/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/async","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","fs","os","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/common/json","vs/base/common/performance","vs/editor/common/core/range","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","path","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","https","http","vs/server/node/server.main"],ve=function(he){for(var e=[],k=0,O=he.length;k<O;k++)e[k]=be[he[k]];return e};define(be[95],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class k{static get(){const r=new Map,I=new Map,D=new Map,S=new Map;function v(h,$){h.has($.detail)||h.set($.detail,-$.timestamp)}function w(h,$){const c=h.get($.detail);c&&(c>=0||h.set($.detail,c+$.timestamp))}let C=[];typeof he=="function"&&typeof he.getStats=="function"&&(C=he.getStats().slice(0).sort((h,$)=>h.timestamp-$.timestamp));for(const h of C)switch(h.type){case 10:v(r,h);break;case 11:case 12:w(r,h);break;case 21:v(I,h);break;case 22:w(I,h);break;case 33:v(D,h);break;case 34:w(D,h);break;case 31:v(S,h);break;case 32:w(S,h);break}let E=0;D.forEach(h=>E+=h);function b(h){const $=[];return h.forEach((c,g)=>$.push([g,c])),$}return{amdLoad:b(r),amdInvoke:b(I),nodeRequire:b(D),nodeEval:b(S),nodeRequireTotal:E}}static toMarkdownTable(r,I){let D="";const S=[];return r.forEach((v,w)=>{S[w]=v.length}),I.forEach(v=>{v.forEach((w,C)=>{typeof w>"u"&&(w=v[C]="-");const E=w.toString().length;S[C]=Math.max(E,S[C])})}),r.forEach((v,w)=>{D+=`| ${v+" ".repeat(S[w]-v.toString().length)} `}),D+=`|
`,r.forEach((v,w)=>{D+=`| ${"-".repeat(S[w])} `}),D+=`|
`,I.forEach(v=>{v.forEach((w,C)=>{typeof w<"u"&&(D+=`| ${w+" ".repeat(S[C]-w.toString().length)} `)}),D+=`|
`}),D}}e.$U=k}),define(be[142],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function k(c,g,d){const m=O(c,g);if(m!==-1)return c[m]}e.$fb=k;function O(c,g,d=c.length-1){for(let m=d;m>=0;m--){const f=c[m];if(g(f))return m}return-1}e.$gb=O;function r(c,g){const d=I(c,g);return d===-1?void 0:c[d]}e.$hb=r;function I(c,g,d=0,m=c.length){let f=d,u=m;for(;f<u;){const l=Math.floor((f+u)/2);g(c[l])?f=l+1:u=l}return f-1}e.$ib=I;function D(c,g){const d=S(c,g);return d===c.length?void 0:c[d]}e.$jb=D;function S(c,g,d=0,m=c.length){let f=d,u=m;for(;f<u;){const l=Math.floor((f+u)/2);g(c[l])?u=l:f=l+1}return f}e.$kb=S;function v(c,g,d=0,m=c.length){const f=S(c,g,d,m);return f===c.length?-1:f}e.$lb=v;class w{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(w.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!g(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const d=I(this.e,g,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$mb=w;function C(c,g){if(c.length===0)return;let d=c[0];for(let m=1;m<c.length;m++){const f=c[m];g(f,d)>0&&(d=f)}return d}e.$nb=C;function E(c,g){if(c.length===0)return;let d=c[0];for(let m=1;m<c.length;m++){const f=c[m];g(f,d)>=0&&(d=f)}return d}e.$ob=E;function b(c,g){return C(c,(d,m)=>-g(d,m))}e.$pb=b;function h(c,g){if(c.length===0)return-1;let d=0;for(let m=1;m<c.length;m++){const f=c[m];g(f,c[d])>0&&(d=m)}return d}e.$qb=h;function $(c,g){for(const d of c){const m=g(d);if(m!==void 0)return m}}e.$rb=$}),define(be[143],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function k(D,S){const v=Object.create(null);for(const w of D){const C=S(w);let E=v[C];E||(E=v[C]=[]),E.push(w)}return v}e.$K=k;function O(D,S){const v=[],w=[];for(const C of D)S.has(C)||v.push(C);for(const C of S)D.has(C)||w.push(C);return{removed:v,added:w}}e.$L=O;function r(D,S){const v=[],w=[];for(const[C,E]of D)S.has(C)||v.push(E);for(const[C,E]of S)D.has(C)||w.push(E);return{removed:v,added:w}}e.$M=r;function I(D,S){const v=new Set;for(const w of S)D.has(w)&&v.add(w);return v}e.$N=I}),define(be[75],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=void 0;function k(D){return(S,v,w)=>{let C=null,E=null;if(typeof w.value=="function"?(C="value",E=w.value):typeof w.get=="function"&&(C="get",E=w.get),!E)throw new Error("not supported");w[C]=D(E,v)}}function O(D,S,v){let w=null,C=null;if(typeof v.value=="function"?(w="value",C=v.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(w="get",C=v.get),!C)throw new Error("not supported");const E=`$memoize$${S}`;v[w]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,b)}),this[E]}}e.$yh=O;function r(D,S,v){return k((w,C)=>{const E=`$debounce$${C}`,b=`$debounce$result$${C}`;return function(...h){this[b]||(this[b]=v?v():void 0),clearTimeout(this[E]),S&&(this[b]=S(this[b],...h),h=[this[b]]),this[E]=setTimeout(()=>{w.apply(this,h),this[b]=v?v():void 0},D)}})}e.$zh=r;function I(D,S,v){return k((w,C)=>{const E=`$throttle$timer$${C}`,b=`$throttle$result$${C}`,h=`$throttle$lastRun$${C}`,$=`$throttle$pending$${C}`;return function(...c){if(this[b]||(this[b]=v?v():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),S&&(this[b]=S(this[b],...c)),this[$])return;const g=this[h]+D;g<=Date.now()?(this[h]=Date.now(),w.apply(this,[this[b]]),this[b]=v?v():void 0):(this[$]=!0,this[E]=setTimeout(()=>{this[$]=!1,this[h]=Date.now(),w.apply(this,[this[b]]),this[b]=v?v():void 0},g-Date.now()))}})}e.$Ah=I}),define(be[10],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class k{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?f.isErrorNoTelemetry(t)?new f(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=k,e.$X=new k;function O(l){e.$X.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=O;function r(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=r;function I(l){w(l)||e.$X.onUnexpectedError(l)}e.$1=I;function D(l){w(l)||e.$X.onUnexpectedExternalError(l)}e.$2=D;function S(l){if(l instanceof Error){const{name:t,message:o}=l,n=l.stacktrace||l.stack;return{$isError:!0,name:t,message:o,stack:n,noTelemetry:f.isErrorNoTelemetry(l)}}return l}e.$3=S;const v="Canceled";function w(l){return l instanceof C?!0:l instanceof Error&&l.name===v&&l.message===v}e.$4=w;class C extends Error{constructor(){super(v),this.name=this.message}}e.$5=C;function E(){const l=new Error(v);return l.name=l.message,l}e.$6=E;function b(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.$7=b;function h(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.$8=h;class $ extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function c(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.$0=c;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class d extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=d;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=m;class f extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof f)return t;const o=new f;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=f;class u extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$cb=u}),define(be[18],ve([1,0,10,142]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function r(J,Y=0){return J[J.length-(1+Y)]}e.$sb=r;function I(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}e.$tb=I;function D(J,Y,B=(T,N)=>T===N){if(J===Y)return!0;if(!J||!Y||J.length!==Y.length)return!1;for(let T=0,N=J.length;T<N;T++)if(!B(J[T],Y[T]))return!1;return!0}e.$ub=D;function S(J,Y){const B=J.length-1;Y<B&&(J[Y]=J[B]),J.pop()}e.$vb=S;function v(J,Y,B){return w(J.length,T=>B(J[T],Y))}e.$wb=v;function w(J,Y){let B=0,T=J-1;for(;B<=T;){const N=(B+T)/2|0,q=Y(N);if(q<0)B=N+1;else if(q>0)T=N-1;else return N}return-(B+1)}e.$xb=w;function C(J,Y,B){if(J=J|0,J>=Y.length)throw new TypeError("invalid index");const T=Y[Math.floor(Y.length*Math.random())],N=[],q=[],ie=[];for(const ae of Y){const ge=B(ae,T);ge<0?N.push(ae):ge>0?q.push(ae):ie.push(ae)}return J<N.length?C(J,N,B):J<N.length+ie.length?ie[0]:C(J-(N.length+ie.length),q,B)}e.$yb=C;function E(J,Y){const B=[];let T;for(const N of J.slice(0).sort(Y))!T||Y(T[0],N)!==0?(T=[N],B.push(T)):T.push(N);return B}e.$zb=E;function*b(J,Y){let B,T;for(const N of J)T!==void 0&&Y(T,N)?B.push(N):(B&&(yield B),B=[N]),T=N;B&&(yield B)}e.$Ab=b;function h(J,Y){for(let B=0;B<=J.length;B++)Y(B===0?void 0:J[B-1],B===J.length?void 0:J[B])}e.$Bb=h;function $(J,Y){for(let B=0;B<J.length;B++)Y(B===0?void 0:J[B-1],J[B],B+1===J.length?void 0:J[B+1])}e.$Cb=$;function c(J,Y,B){const T=[];function N(ae,ge,ce){if(ge===0&&ce.length===0)return;const pe=T[T.length-1];pe&&pe.start+pe.deleteCount===ae?(pe.deleteCount+=ge,pe.toInsert.push(...ce)):T.push({start:ae,deleteCount:ge,toInsert:ce})}let q=0,ie=0;for(;;){if(q===J.length){N(q,0,Y.slice(ie));break}if(ie===Y.length){N(q,J.length-q,[]);break}const ae=J[q],ge=Y[ie],ce=B(ae,ge);ce===0?(q+=1,ie+=1):ce<0?(N(q,1,[]),q+=1):ce>0&&(N(q,0,[ge]),ie+=1)}return T}e.$Db=c;function g(J,Y,B){const T=c(J,Y,B),N=[],q=[];for(const ie of T)N.push(...J.slice(ie.start,ie.start+ie.deleteCount)),q.push(...ie.toInsert);return{removed:N,added:q}}e.$Eb=g;function d(J,Y,B){if(B===0)return[];const T=J.slice(0,B).sort(Y);return f(J,Y,T,B,J.length),T}e.top=d;function m(J,Y,B,T,N){return B===0?Promise.resolve([]):new Promise((q,ie)=>{(async()=>{const ae=J.length,ge=J.slice(0,B).sort(Y);for(let ce=B,pe=Math.min(B+T,ae);ce<ae;ce=pe,pe=Math.min(pe+T,ae)){if(ce>B&&await new Promise(ye=>setTimeout(ye)),N&&N.isCancellationRequested)throw new k.$5;f(J,Y,ge,ce,pe)}return ge})().then(q,ie)})}e.$Gb=m;function f(J,Y,B,T,N){for(const q=B.length;T<N;T++){const ie=J[T];if(Y(ie,B[q-1])<0){B.pop();const ae=(0,O.$kb)(B,ge=>Y(ie,ge)<0);B.splice(ae,0,ie)}}}function u(J){return J.filter(Y=>!!Y)}e.$Hb=u;function l(J){let Y=0;for(let B=0;B<J.length;B++)J[B]&&(J[Y]=J[B],Y+=1);J.length=Y}e.$Ib=l;function t(J,Y,B){J.splice(B,0,J.splice(Y,1)[0])}e.$Jb=t;function o(J){return!Array.isArray(J)||J.length===0}e.$Kb=o;function n(J){return Array.isArray(J)&&J.length>0}e.$Lb=n;function s(J,Y=B=>B){const B=new Set;return J.filter(T=>{const N=Y(T);return B.has(N)?!1:(B.add(N),!0)})}e.$Mb=s;function i(J){const Y=new Set;return B=>{const T=J(B);return Y.has(T)?!1:(Y.add(T),!0)}}e.$Nb=i;function a(J,Y){return J.length>0?J[0]:Y}e.$Ob=a;function p(J,Y){return J.length>0?J[J.length-1]:Y}e.$Pb=p;function L(J,Y,B=(T,N)=>T===N){let T=0;for(let N=0,q=Math.min(J.length,Y.length);N<q&&B(J[N],Y[N]);N++)T++;return T}e.$Qb=L;function P(J){return[].concat(...J)}e.$Rb=P;function y(J,Y){let B=typeof Y=="number"?J:0;typeof Y=="number"?B=J:(B=0,Y=J);const T=[];if(B<=Y)for(let N=B;N<Y;N++)T.push(N);else for(let N=B;N>Y;N--)T.push(N);return T}e.$Sb=y;function A(J,Y,B){return J.reduce((T,N)=>(T[Y(N)]=B?B(N):N,T),Object.create(null))}e.$Tb=A;function M(J,Y){return J.push(Y),()=>_(J,Y)}e.$Ub=M;function _(J,Y){const B=J.indexOf(Y);if(B>-1)return J.splice(B,1),Y}e.$Vb=_;function se(J,Y,B){const T=J.slice(0,Y),N=J.slice(Y);return T.concat(B,N)}e.$Wb=se;function G(J,Y){let B;if(typeof Y=="number"){let T=Y;B=()=>{const N=Math.sin(T++)*179426549;return N-Math.floor(N)}}else B=Math.random;for(let T=J.length-1;T>0;T-=1){const N=Math.floor(B()*(T+1)),q=J[T];J[T]=J[N],J[N]=q}}e.$Xb=G;function oe(J,Y){const B=J.indexOf(Y);B>-1&&(J.splice(B,1),J.unshift(Y))}e.$Yb=oe;function ee(J,Y){const B=J.indexOf(Y);B>-1&&(J.splice(B,1),J.push(Y))}e.$Zb=ee;function K(J,Y){for(const B of Y)J.push(B)}e.$1b=K;function Z(J,Y){return Array.isArray(J)?J.map(Y):Y(J)}e.$2b=Z;function X(J){return Array.isArray(J)?J:[J]}e.$3b=X;function te(J){return J[Math.floor(Math.random()*J.length)]}e.$4b=te;function V(J,Y,B){const T=re(J,Y),N=J.length,q=B.length;J.length=N+q;for(let ie=N-1;ie>=T;ie--)J[ie+q]=J[ie];for(let ie=0;ie<q;ie++)J[ie+T]=B[ie]}e.$5b=V;function W(J,Y,B,T){const N=re(J,Y);let q=J.splice(N,B);return q===void 0&&(q=[]),V(J,N,T),q}e.$6b=W;function re(J,Y){return Y<0?Math.max(Y+J.length,0):Math.min(Y,J.length)}var ue;(function(J){function Y(q){return q<0}J.isLessThan=Y;function B(q){return q<=0}J.isLessThanOrEqual=B;function T(q){return q>0}J.isGreaterThan=T;function N(q){return q===0}J.isNeitherLessOrGreaterThan=N,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function ne(J,Y){return(B,T)=>Y(J(B),J(T))}e.$7b=ne;function me(...J){return(Y,B)=>{for(const T of J){const N=T(Y,B);if(!ue.isNeitherLessOrGreaterThan(N))return N}return ue.neitherLessOrGreaterThan}}e.$8b=me;const z=(J,Y)=>J-Y;e.$9b=z;const H=(J,Y)=>(0,e.$9b)(J?1:0,Y?1:0);e.$0b=H;function R(J){return(Y,B)=>-J(Y,B)}e.$$b=R;class U{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let B=this.c;for(;B<this.g.length&&Y(this.g[B]);)B++;const T=B===this.c?null:this.g.slice(this.c,B);return this.c=B,T}takeFromEndWhile(Y){let B=this.d;for(;B>=0&&Y(this.g[B]);)B--;const T=B===this.d?null:this.g.slice(B+1,this.d+1);return this.d=B,T}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const B=this.g.slice(this.c,this.c+Y);return this.c+=Y,B}}e.$_b=U;class x{static{this.empty=new x(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(B=>(Y(B),!0))}toArray(){const Y=[];return this.iterate(B=>(Y.push(B),!0)),Y}filter(Y){return new x(B=>this.iterate(T=>Y(T)?B(T):!0))}map(Y){return new x(B=>this.iterate(T=>B(Y(T))))}some(Y){let B=!1;return this.iterate(T=>(B=Y(T),!B)),B}findFirst(Y){let B;return this.iterate(T=>Y(T)?(B=T,!1):!0),B}findLast(Y){let B;return this.iterate(T=>(Y(T)&&(B=T),!0)),B}findLastMaxBy(Y){let B,T=!0;return this.iterate(N=>((T||ue.isGreaterThan(Y(N,B)))&&(T=!1,B=N),!0)),B}}e.$ac=x}),define(be[96],ve([1,0,10]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function O(w,C){if(!w)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=O;function r(w,C="Unreachable"){throw new Error(C)}e.$6c=r;function I(w){if(!w)throw new k.$cb("Assertion Failed")}e.$7c=I;function D(w){w||(0,k.$1)(new k.$cb("Assertion Failed"))}e.$8c=D;function S(w){if(!w()){debugger;w(),(0,k.$1)(new k.$cb("Assertion Failed"))}}e.$9c=S;function v(w,C){let E=0;for(;E<w.length-1;){const b=w[E],h=w[E+1];if(!C(b,h))return!1;E++}return!0}e.$0c=v}),define(be[76],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function k(O,r){const I=this;let D=!1,S;return function(){if(D)return S;if(D=!0,r)try{S=O.apply(I,arguments)}finally{r()}else S=O.apply(I,arguments);return S}}e.$db=k}),define(be[49],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(O){function r(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=r;const I=Object.freeze([]);function D(){return I}O.empty=D;function*S(t){yield t}O.single=S;function v(t){return r(t)?t:S(t)}O.wrap=v;function w(t){return t||I}O.from=w;function*C(t){for(let o=t.length-1;o>=0;o--)yield t[o]}O.reverse=C;function E(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=E;function b(t){return t[Symbol.iterator]().next().value}O.first=b;function h(t,o){for(const n of t)if(o(n))return!0;return!1}O.some=h;function $(t,o){for(const n of t)if(o(n))return n}O.find=$;function*c(t,o){for(const n of t)o(n)&&(yield n)}O.filter=c;function*g(t,o){let n=0;for(const s of t)yield o(s,n++)}O.map=g;function*d(...t){for(const o of t)yield*o}O.concat=d;function m(t,o,n){let s=n;for(const i of t)s=o(s,i);return s}O.reduce=m;function*f(t,o,n=t.length){for(o<0&&(o+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);o<n;o++)yield t[o]}O.slice=f;function u(t,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,t];const s=t[Symbol.iterator]();for(let i=0;i<o;i++){const a=s.next();if(a.done)return[n,O.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}O.consume=u;async function l(t){const o=[];for await(const n of t)o.push(n);return Promise.resolve(o)}O.asyncToArray=l})(k||(e.Iterable=k={}))}),define(be[41],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function D(t,o=!1){let n=0;const s=t.length;let i="",a=0,p=16,L=0;function P(oe){let ee=0,K=0;for(;ee<oe;){const Z=t.charCodeAt(n);if(Z>=48&&Z<=57)K=K*16+Z-48;else if(Z>=65&&Z<=70)K=K*16+Z-65+10;else if(Z>=97&&Z<=102)K=K*16+Z-97+10;else break;n++,ee++}return ee<oe&&(K=-1),K}function y(oe){n=oe,i="",a=0,p=16,L=0}function A(){const oe=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&w(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&w(t.charCodeAt(n)))for(n++;n<t.length&&w(t.charCodeAt(n));)n++;else return L=3,t.substring(oe,n);let ee=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&w(t.charCodeAt(n))){for(n++;n<t.length&&w(t.charCodeAt(n));)n++;ee=n}else L=3;return t.substring(oe,ee)}function M(){let oe="",ee=n;for(;;){if(n>=s){oe+=t.substring(ee,n),L=2;break}const K=t.charCodeAt(n);if(K===34){oe+=t.substring(ee,n),n++;break}if(K===92){if(oe+=t.substring(ee,n),n++,n>=s){L=2;break}switch(t.charCodeAt(n++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:{const X=P(4);X>=0?oe+=String.fromCharCode(X):L=4;break}default:L=5}ee=n;continue}if(K>=0&&K<=31)if(v(K)){oe+=t.substring(ee,n),L=2;break}else L=6;n++}return oe}function _(){if(i="",L=0,a=n,n>=s)return a=s,p=17;let oe=t.charCodeAt(n);if(S(oe)){do n++,i+=String.fromCharCode(oe),oe=t.charCodeAt(n);while(S(oe));return p=15}if(v(oe))return n++,i+=String.fromCharCode(oe),oe===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),p=14;switch(oe){case 123:return n++,p=1;case 125:return n++,p=2;case 91:return n++,p=3;case 93:return n++,p=4;case 58:return n++,p=6;case 44:return n++,p=5;case 34:return n++,i=M(),p=10;case 47:{const ee=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!v(t.charCodeAt(n));)n++;return i=t.substring(ee,n),p=12}if(t.charCodeAt(n+1)===42){n+=2;const K=s-1;let Z=!1;for(;n<K;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,Z=!0;break}n++}return Z||(n++,L=1),i=t.substring(ee,n),p=13}return i+=String.fromCharCode(oe),n++,p=16}case 45:if(i+=String.fromCharCode(oe),n++,n===s||!w(t.charCodeAt(n)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=A(),p=11;default:for(;n<s&&se(oe);)n++,oe=t.charCodeAt(n);if(a!==n){switch(i=t.substring(a,n),i){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return i+=String.fromCharCode(oe),n++,p=16}}function se(oe){if(S(oe)||v(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let oe;do oe=_();while(oe>=12&&oe<=15);return oe}return{setPosition:y,getPosition:()=>n,scan:o?G:_,getToken:()=>p,getTokenValue:()=>i,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>L}}e.$bn=D;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function E(t,o){const n=[],s=new Object;let i;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function L(P,y,A,M){a.value=P,a.offset=y,a.length=A,a.type=M,a.colonOffset=void 0,i=a}try{f(t,{onObjectBegin:(P,y)=>{if(o<=P)throw s;i=void 0,p=o>P,n.push("")},onObjectProperty:(P,y,A)=>{if(o<y||(L(P,y,A,"property"),n[n.length-1]=P,o<=y+A))throw s},onObjectEnd:(P,y)=>{if(o<=P)throw s;i=void 0,n.pop()},onArrayBegin:(P,y)=>{if(o<=P)throw s;i=void 0,n.push(0)},onArrayEnd:(P,y)=>{if(o<=P)throw s;i=void 0,n.pop()},onLiteralValue:(P,y,A)=>{if(o<y||(L(P,y,A,l(P)),o<=y+A))throw s},onSeparator:(P,y,A)=>{if(o<=y)throw s;if(P===":"&&i&&i.type==="property")i.colonOffset=y,p=!1,i=void 0;else if(P===","){const M=n[n.length-1];typeof M=="number"?n[n.length-1]=M+1:(p=!0,n[n.length-1]=""),i=void 0}}})}catch(P){if(P!==s)throw P}return{path:n,previousNode:i,isAtPropertyKey:p,matches:P=>{let y=0;for(let A=0;y<P.length&&A<n.length;A++)if(P[y]===n[A]||P[y]==="*")y++;else if(P[y]!=="**")return!1;return y===P.length}}}e.$cn=E;function b(t,o=[],n=I.DEFAULT){let s=null,i=[];const a=[];function p(P){Array.isArray(i)?i.push(P):s!==null&&(i[s]=P)}return f(t,{onObjectBegin:()=>{const P={};p(P),a.push(i),i=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{const P=[];p(P),a.push(i),i=P,s=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:p,onError:(P,y,A)=>{o.push({error:P,offset:y,length:A})}},n),i[0]}e.$dn=b;function h(t,o=[],n=I.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(P){s.type==="property"&&(s.length=P-s.offset,s=s.parent)}function a(P){return s.children.push(P),P}f(t,{onObjectBegin:P=>{s=a({type:"object",offset:P,length:-1,parent:s,children:[]})},onObjectProperty:(P,y,A)=>{s=a({type:"property",offset:y,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:P,offset:y,length:A,parent:s})},onObjectEnd:(P,y)=>{s.length=P+y-s.offset,s=s.parent,i(P+y)},onArrayBegin:(P,y)=>{s=a({type:"array",offset:P,length:-1,parent:s,children:[]})},onArrayEnd:(P,y)=>{s.length=P+y-s.offset,s=s.parent,i(P+y)},onLiteralValue:(P,y,A)=>{a({type:l(P),offset:y,length:A,parent:s,value:P}),i(y+A)},onSeparator:(P,y,A)=>{s.type==="property"&&(P===":"?s.colonOffset=y:P===","&&i(y))},onError:(P,y,A)=>{o.push({error:P,offset:y,length:A})}},n);const L=s.children[0];return L&&delete L.parent,L}e.$en=h;function $(t,o){if(!t)return;let n=t;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===s){n=a.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}e.$fn=$;function c(t){if(!t.parent||!t.parent.children)return[];const o=c(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}e.$gn=c;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const o=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(o[n.children[0].value]=g(s))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$hn=g;function d(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}e.$in=d;function m(t,o,n=!1){if(d(t,o,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=o;i++){const a=m(s[i],o,n);if(a)return a}return t}}e.$jn=m;function f(t,o,n=I.DEFAULT){const s=D(t,!1);function i(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(ne){return ne?me=>ne(me,s.getTokenOffset(),s.getTokenLength()):()=>!0}const p=i(o.onObjectBegin),L=a(o.onObjectProperty),P=i(o.onObjectEnd),y=i(o.onArrayBegin),A=i(o.onArrayEnd),M=a(o.onLiteralValue),_=a(o.onSeparator),se=i(o.onComment),G=a(o.onError),oe=n&&n.disallowComments,ee=n&&n.allowTrailingComma;function K(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:oe||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(ne){case 12:case 13:oe?Z(10):se();break;case 16:Z(1);break;case 15:case 14:break;default:return ne}}}function Z(ne,me=[],z=[]){if(G(ne),me.length+z.length>0){let H=s.getToken();for(;H!==17;){if(me.indexOf(H)!==-1){K();break}else if(z.indexOf(H)!==-1)break;H=K()}}}function X(ne){const me=s.getTokenValue();return ne?M(me):L(me),K(),!0}function te(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(Z(2),ne=0)}catch{Z(2)}M(ne);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return K(),!0}function V(){return s.getToken()!==10?(Z(3,[],[2,5]),!1):(X(!1),s.getToken()===6?(_(":"),K(),ue()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function W(){p(),K();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Z(4,[],[]),_(","),K(),s.getToken()===2&&ee)break}else ne&&Z(6,[],[]);V()||Z(4,[],[2,5]),ne=!0}return P(),s.getToken()!==2?Z(7,[2],[]):K(),!0}function re(){y(),K();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Z(4,[],[]),_(","),K(),s.getToken()===4&&ee)break}else ne&&Z(6,[],[]);ue()||Z(4,[],[4,5]),ne=!0}return A(),s.getToken()!==4?Z(8,[4],[]):K(),!0}function ue(){switch(s.getToken()){case 3:return re();case 1:return W();case 10:return X(!0);default:return te()}}return K(),s.getToken()===17?n.allowEmptyContent?!0:(Z(4,[],[]),!1):ue()?(s.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}e.$kn=f;function u(t,o){const n=D(t),s=[];let i,a=0,p;do switch(p=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:a!==p&&s.push(t.substring(a,p)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(i!==17);return s.join("")}e.$ln=u;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$mn=l}),define(be[144],ve([1,0,41]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=e.$nn=void 0;function O(w,C,E){let b,h,$,c,g;if(C){for(c=C.offset,g=c+C.length,$=c;$>0&&!v(w,$-1);)$--;let p=g;for(;p<w.length&&!v(w,p);)p++;h=w.substring($,p),b=D(h,E)}else h=w,b=0,$=0,c=0,g=w.length;const d=S(E,w);let m=!1,f=0,u;E.insertSpaces?u=I(" ",E.tabSize||4):u="	";const l=(0,k.$bn)(h,!1);let t=!1;function o(){return d+I(u,b+f)}function n(){let p=l.scan();for(m=!1;p===15||p===14;)m=m||p===14,p=l.scan();return t=p===16||l.getTokenError()!==0,p}const s=[];function i(p,L,P){!t&&L<g&&P>c&&w.substring(L,P)!==p&&s.push({offset:L,length:P-L,content:p})}let a=n();if(a!==17){const p=l.getTokenOffset()+$,L=I(u,b);i(L,$,p)}for(;a!==17;){let p=l.getTokenOffset()+l.getTokenLength()+$,L=n(),P="";for(;!m&&(L===12||L===13);){const A=l.getTokenOffset()+$;i(" ",p,A),p=l.getTokenOffset()+l.getTokenLength()+$,P=L===12?o():"",L=n()}if(L===2)a!==1&&(f--,P=o());else if(L===4)a!==3&&(f--,P=o());else{switch(a){case 3:case 1:f++,P=o();break;case 5:case 12:P=o();break;case 13:m?P=o():P=" ";break;case 6:P=" ";break;case 10:if(L===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:L===12||L===13?P=" ":L!==5&&L!==17&&(t=!0);break;case 16:t=!0;break}m&&(L===12||L===13)&&(P=o())}const y=l.getTokenOffset()+$;i(P,p,y),a=L}return s}e.$nn=O;function r(w,C){const E=JSON.stringify(w,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.$on=r;function I(w,C){let E="";for(let b=0;b<C;b++)E+=w;return E}function D(w,C){let E=0,b=0;const h=C.tabSize||4;for(;E<w.length;){const $=w.charAt(E);if($===" ")b++;else if($==="	")b+=h;else break;E++}return Math.floor(b/h)}function S(w,C){for(let E=0;E<C.length;E++){const b=C.charAt(E);if(b==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return w&&w.eol||`
`}e.$pn=S;function v(w,C){return`\r
`.indexOf(w.charAt(C))!==-1}e.$qn=v}),define(be[145],ve([1,0,41,144]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=void 0;function r(w,C,E){return I(w,C,void 0,E)}e.$rn=r;function I(w,C,E,b,h){const $=C.slice(),c=[],g=(0,k.$en)(w,c);let d,m;for(;$.length>0&&(m=$.pop(),d=(0,k.$fn)(g,$),d===void 0&&E!==void 0);)typeof m=="string"?E={[m]:E}:E=[E];if(d)if(d.type==="object"&&typeof m=="string"&&Array.isArray(d.children)){const f=(0,k.$fn)(d,[m]);if(f!==void 0)if(E===void 0){if(!f.parent)throw new Error("Malformed AST");const u=d.children.indexOf(f.parent);let l,t=f.parent.offset+f.parent.length;if(u>0){const o=d.children[u-1];l=o.offset+o.length}else l=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return D(w,{offset:l,length:t-l,content:""},b)}else return D(w,{offset:f.offset,length:f.length,content:JSON.stringify(E)},b);else{if(E===void 0)return[];const u=`${JSON.stringify(m)}: ${JSON.stringify(E)}`,l=h?h(d.children.map(o=>o.children[0].value)):d.children.length;let t;if(l>0){const o=d.children[l-1];t={offset:o.offset+o.length,length:0,content:","+u}}else d.children.length===0?t={offset:d.offset+1,length:0,content:u}:t={offset:d.offset+1,length:0,content:u+","};return D(w,t,b)}}else if(d.type==="array"&&typeof m=="number"&&Array.isArray(d.children))if(E!==void 0){const f=`${JSON.stringify(E)}`;let u;if(d.children.length===0||m===0)u={offset:d.offset+1,length:0,content:d.children.length===0?f:f+","};else{const l=m===-1||m>d.children.length?d.children.length:m,t=d.children[l-1];u={offset:t.offset+t.length,length:0,content:","+f}}return D(w,u,b)}else{const f=m,u=d.children[f];let l;if(d.children.length===1)l={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===f){const t=d.children[f-1],o=t.offset+t.length,n=d.offset+d.length;l={offset:o,length:n-2-o,content:""}}else l={offset:u.offset,length:d.children[f+1].offset-u.offset,content:""};return D(w,l,b)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${d.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return D(w,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(E)},b)}}e.$sn=I;function D(w,C,E){let b=S(w,C),h=C.offset,$=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;h>0&&!(0,O.$qn)(b,h-1);)h--;for(;$<b.length&&!(0,O.$qn)(b,$);)$++}const c=(0,O.$nn)(b,{offset:h,length:$-h},E);for(let d=c.length-1;d>=0;d--){const m=c[d];b=S(b,m),h=Math.min(h,m.offset),$=Math.max($,m.offset+m.length),$+=m.content.length-m.length}const g=w.length-(b.length-$)-h;return[{offset:h,length:g,content:b.substring(h,$)}]}e.$tn=D;function S(w,C){return w.substring(0,C.offset)+C.content+w.substring(C.offset+C.length)}e.$un=S;function v(w,C){const E=C.slice(0).sort((h,$)=>{const c=h.offset-$.offset;return c===0?h.length-$.length:c});let b=w.length;for(let h=E.length-1;h>=0;h--){const $=E[h];if($.offset+$.length<=b)w=S(w,$);else throw new Error("Overlapping edit");b=$.offset}return w}e.$vn=v}),define(be[60],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class k{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=k}),define(be[97],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class k{static{this.Undefined=new k(void 0)}constructor(I){this.element=I,this.next=k.Undefined,this.prev=k.Undefined}}class O{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let I=this.a;for(;I!==k.Undefined;){const D=I.next;I.prev=k.Undefined,I.next=k.Undefined,I=D}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,D){const S=new k(I);if(this.a===k.Undefined)this.a=S,this.b=S;else if(D){const w=this.b;this.b=S,S.prev=w,w.next=S}else{const w=this.a;this.a=S,S.next=w,w.prev=S}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(S))}}shift(){if(this.a!==k.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==k.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==k.Undefined&&I.next!==k.Undefined){const D=I.prev;D.next=I.next,I.next.prev=D}else I.prev===k.Undefined&&I.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):I.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):I.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==k.Undefined;)yield I.element,I=I.next}}e.$4c=O}),define(be[24],ve([1,0]),function(he,e){"use strict";var k,O,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function I(f,u,l){let t=f.get(u);return t===void 0&&(t=l,f.set(u,t)),t}e.$xc=I;function D(f){const u=[];return f.forEach((l,t)=>{u.push(`${t} => ${l}`)}),`Map(${f.size}) {${u.join(", ")}}`}e.$yc=D;function S(f){const u=[];return f.forEach(l=>{u.push(l)}),`Set(${f.size}) {${u.join(", ")}}`}e.$zc=S;class v{constructor(u,l){this.uri=u,this.value=l}}function w(f){return Array.isArray(f)}class C{static{this.c=u=>u.toString()}constructor(u,l){if(this[k]="ResourceMap",u instanceof C)this.d=new Map(u.d),this.e=l??C.c;else if(w(u)){this.d=new Map,this.e=l??C.c;for(const[t,o]of u)this.set(t,o)}else this.d=new Map,this.e=u??C.c}set(u,l){return this.d.set(this.e(u),new v(u,l)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,l){typeof l<"u"&&(u=u.bind(l));for(const[t,o]of this.d)u(o.value,o.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}e.$Ac=C;class E{constructor(u,l){this[O]="ResourceSet",!u||typeof u=="function"?this.c=new C(u):(this.c=new C(l),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,l){this.c.forEach((t,o)=>u.call(l,o,o,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=E;var b;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class h{constructor(){this[r]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,l=0){const t=this.c.get(u);if(t)return l!==0&&this.l(t,l),t.value}set(u,l,t=0){let o=this.c.get(u);if(o)o.value=l,t!==0&&this.l(o,t);else{switch(o={key:u,value:l,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(u,o),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const l=this.c.get(u);if(l)return this.c.delete(u),this.k(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.k(u),this.f--,u.value}forEach(u,l){const t=this.g;let o=this.d;for(;o;){if(l?u.bind(l)(o.value,o.key,this):u(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const u=this,l=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(u.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const n={value:t.key,done:!1};return t=t.next,n}else return{value:void 0,done:!0}}};return o}values(){const u=this,l=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(u.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const n={value:t.value,done:!1};return t=t.next,n}else return{value:void 0,done:!0}}};return o}entries(){const u=this,l=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(u.g!==l)throw new Error("LinkedMap got modified during iteration.");if(t){const n={value:[t.key,t.value],done:!1};return t=t.next,n}else return{value:void 0,done:!0}}};return o}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let l=this.d,t=this.size;for(;l&&t>u;)this.c.delete(l.key),l=l.next,t--;this.d=l,this.f=t,l&&(l.previous=void 0),this.g++}i(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}j(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}k(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const l=u.next,t=u.previous;if(!l||!t)throw new Error("Invalid list");l.previous=t,t.next=l}u.next=void 0,u.previous=void 0,this.g++}l(u,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(u===this.d)return;const t=u.next,o=u.previous;u===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(l===2){if(u===this.e)return;const t=u.next,o=u.previous;u===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((l,t)=>{u.push([t,l])}),u}fromJSON(u){this.clear();for(const[l,t]of u)this.set(l,t)}}e.$Cc=h;class $ extends h{constructor(u,l=1){super(),this.m=u,this.n=Math.min(Math.max(0,l),1)}get limit(){return this.m}set limit(u){this.m=u,this.o()}get ratio(){return this.n}set ratio(u){this.n=Math.min(Math.max(0,u),1),this.o()}get(u,l=2){return super.get(u,l)}peek(u){return super.get(u,0)}set(u,l){return super.set(u,l,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=$;class c{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let l=this.c.get(u)||0;return l===0?!1:(l--,l===0?this.c.delete(u):this.c.set(u,l),!0)}has(u){return this.c.has(u)}}e.$Ec=c;class g{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[l,t]of u)this.set(l,t)}clear(){this.c.clear(),this.d.clear()}set(u,l){this.c.set(u,l),this.d.set(l,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const l=this.c.get(u);return l===void 0?!1:(this.c.delete(u),this.d.delete(l),!0)}forEach(u,l){this.c.forEach((t,o)=>{u.call(l,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=g;class d{constructor(){this.c=new Map}add(u,l){let t=this.c.get(u);t||(t=new Set,this.c.set(u,t)),t.add(l)}delete(u,l){const t=this.c.get(u);t&&(t.delete(l),t.size===0&&this.c.delete(u))}forEach(u,l){const t=this.c.get(u);t&&t.forEach(l)}get(u){const l=this.c.get(u);return l||new Set}}e.$Gc=d;function m(f,u){if(f===u)return!0;if(f.size!==u.size)return!1;for(const[l,t]of f)if(!u.has(l)||u.get(l)!==t)return!1;for(const[l]of u)if(!f.has(l))return!1;return!0}e.$Hc=m}),define(be[2],ve([1,0,18,143,24,76,49]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const S=!1;let v=null;class w{constructor(){this.b=new Map}static{this.a=0}c(M){let _=this.b.get(M);return _||(_={parent:null,source:null,isSingleton:!1,value:M,idx:w.a++},this.b.set(M,_)),_}trackDisposable(M){const _=this.c(M);_.source||(_.source=new Error().stack)}setParent(M,_){const se=this.c(M);se.parent=_}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,_){const se=_.get(M);if(se)return se;const G=M.parent?this.f(this.c(M.parent),_):M;return _.set(M,G),G}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,se])=>se.source!==null&&!this.f(se,M).isSingleton).flatMap(([se])=>se)}computeLeakingDisposables(M=10,_){let se;if(_)se=_;else{const Z=new Map,X=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,Z).isSingleton);if(X.length===0)return;const te=new Set(X.map(V=>V.value));if(se=X.filter(V=>!(V.parent&&te.has(V.parent))),se.length===0)throw new Error("There are cyclic diposable chains!")}if(!se)return;function G(Z){function X(V,W){for(;V.length>0&&W.some(re=>typeof re=="string"?re===V[0]:V[0].match(re));)V.shift()}const te=Z.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return X(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const oe=new r.$Gc;for(const Z of se){const X=G(Z);for(let te=0;te<=X.length;te++)oe.add(X.slice(0,te).join(`
`),Z)}se.sort((0,k.$7b)(Z=>Z.idx,k.$9b));let ee="",K=0;for(const Z of se.slice(0,M)){K++;const X=G(Z),te=[];for(let V=0;V<X.length;V++){let W=X[V];W=`(shared with ${oe.get(X.slice(0,V+1).join(`
`)).size}/${se.length} leaks) at ${W}`;const ue=oe.get(X.slice(0,V).join(`
`)),ne=(0,O.$K)([...ue].map(me=>G(me)[V]),me=>me);delete ne[X[V]];for(const[me,z]of Object.entries(ne))te.unshift(`    - stacktraces of ${z.length} other leaks continue with ${me}`);te.unshift(W)}ee+=`


==================== Leaking disposable ${K}/${se.length}: ${Z.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return se.length>M&&(ee+=`


... and ${se.length-M} more leaking disposables

`),{leaks:se,details:ee}}}e.$Ic=w;function C(A){v=A}if(e.$Jc=C,S){const A="__is_disposable_tracked__";C(new class{trackDisposable(M){const _=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[A]||console.log(_)},3e3)}setParent(M,_){if(M&&M!==t.None)try{M[A]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[A]=!0}catch{}}markAsSingleton(M){}})}function E(A){return v?.trackDisposable(A),A}e.$Kc=E;function b(A){v?.markAsDisposed(A)}e.$Lc=b;function h(A,M){v?.setParent(A,M)}function $(A,M){if(v)for(const _ of A)v.setParent(_,M)}function c(A){return v?.markAsSingleton(A),A}e.$Mc=c;function g(A){return typeof A.dispose=="function"&&A.dispose.length===0}e.$Nc=g;function d(A){if(D.Iterable.is(A)){const M=[];for(const _ of A)if(_)try{_.dispose()}catch(se){M.push(se)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}e.$Oc=d;function m(A){for(const M of A)g(M)&&M.dispose();return[]}e.$Pc=m;function f(...A){const M=u(()=>d(A));return $(A,M),M}e.$Qc=f;function u(A){const M=E({dispose:(0,I.$db)(()=>{b(M),A()})});return M}e.$Rc=u;class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return h(M,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),h(M,null))}}e.$Sc=l;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,E(this),h(this.q,this)}dispose(){b(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Tc=t;class o{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&h(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&h(M,null),M}}e.$Uc=o;class n{constructor(M){this.a=new o,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class s{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(M){let _=M;return this.unset=()=>_=void 0,this.isset=()=>_!==void 0,this.dispose=()=>{_&&(_(),_=void 0,b(this))},this}}e.$Xc=i;class a{constructor(){this.a=new Map}acquire(M,..._){let se=this.a.get(M);se||(se={counter:0,object:this.b(M,..._)},this.a.set(M,se));const{object:G}=se,oe=(0,I.$db)(()=>{--se.counter===0&&(this.c(M,se.object),this.a.delete(M))});return se.counter++,{object:G,dispose:oe}}}e.$Yc=a;class p{constructor(M){this.a=M}async acquire(M,..._){const se=this.a.acquire(M,..._);try{return{object:await se.object,dispose:()=>se.dispose()}}catch(G){throw se.dispose(),G}}}e.$Zc=p;class L{constructor(M){this.object=M}dispose(){}}e.$1c=L;function P(A){const M=new l;try{A(M)}finally{M.dispose()}}e.$2c=P;class y{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,_,se=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),se||this.a.get(M)?.dispose(),this.a.set(M,_)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=y}),function(he,e){typeof define=="function"&&define.amd?define(be[146],ve([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(Y,B){for(var T=0;T<B.length;T++){var N=B[T];N.enumerable=N.enumerable||!1,N.configurable=!0,"value"in N&&(N.writable=!0),Object.defineProperty(Y,N.key,N)}}function k(Y,B,T){return B&&e(Y.prototype,B),T&&e(Y,T),Object.defineProperty(Y,"prototype",{writable:!1}),Y}function O(Y,B){if(Y){if(typeof Y=="string")return r(Y,B);var T=Object.prototype.toString.call(Y).slice(8,-1);if(T==="Object"&&Y.constructor&&(T=Y.constructor.name),T==="Map"||T==="Set")return Array.from(Y);if(T==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(T))return r(Y,B)}}function r(Y,B){(B==null||B>Y.length)&&(B=Y.length);for(var T=0,N=new Array(B);T<B;T++)N[T]=Y[T];return N}function I(Y,B){var T=typeof Symbol<"u"&&Y[Symbol.iterator]||Y["@@iterator"];if(T)return(T=T.call(Y)).next.bind(T);if(Array.isArray(Y)||(T=O(Y))||B&&Y&&typeof Y.length=="number"){T&&(Y=T);var N=0;return function(){return N>=Y.length?{done:!0}:{done:!1,value:Y[N++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=D();function S(Y){he.defaults=Y}var v=/[&<>"']/,w=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(B){return b[B]};function $(Y,B){if(B){if(v.test(Y))return Y.replace(w,h)}else if(C.test(Y))return Y.replace(E,h);return Y}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Y){return Y.replace(c,function(B,T){return T=T.toLowerCase(),T==="colon"?":":T.charAt(0)==="#"?T.charAt(1)==="x"?String.fromCharCode(parseInt(T.substring(2),16)):String.fromCharCode(+T.substring(1)):""})}var d=/(^|[^\[])\^/g;function m(Y,B){Y=typeof Y=="string"?Y:Y.source,B=B||"";var T={replace:function(q,ie){return ie=ie.source||ie,ie=ie.replace(d,"$1"),Y=Y.replace(q,ie),T},getRegex:function(){return new RegExp(Y,B)}};return T}var f=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(Y,B,T){if(Y){var N;try{N=decodeURIComponent(g(T)).replace(f,"").toLowerCase()}catch{return null}if(N.indexOf("javascript:")===0||N.indexOf("vbscript:")===0||N.indexOf("data:")===0)return null}B&&!u.test(T)&&(T=i(B,T));try{T=encodeURI(T).replace(/%25/g,"%")}catch{return null}return T}var t={},o=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Y,B){t[" "+Y]||(o.test(Y)?t[" "+Y]=Y+"/":t[" "+Y]=P(Y,"/",!0)),Y=t[" "+Y];var T=Y.indexOf(":")===-1;return B.substring(0,2)==="//"?T?B:Y.replace(n,"$1")+B:B.charAt(0)==="/"?T?B:Y.replace(s,"$1")+B:Y+B}var a={exec:function(){}};function p(Y){for(var B=1,T,N;B<arguments.length;B++){T=arguments[B];for(N in T)Object.prototype.hasOwnProperty.call(T,N)&&(Y[N]=T[N])}return Y}function L(Y,B){var T=Y.replace(/\|/g,function(ie,ae,ge){for(var ce=!1,pe=ae;--pe>=0&&ge[pe]==="\\";)ce=!ce;return ce?"|":" |"}),N=T.split(/ \|/),q=0;if(N[0].trim()||N.shift(),N.length>0&&!N[N.length-1].trim()&&N.pop(),N.length>B)N.splice(B);else for(;N.length<B;)N.push("");for(;q<N.length;q++)N[q]=N[q].trim().replace(/\\\|/g,"|");return N}function P(Y,B,T){var N=Y.length;if(N===0)return"";for(var q=0;q<N;){var ie=Y.charAt(N-q-1);if(ie===B&&!T)q++;else if(ie!==B&&T)q++;else break}return Y.slice(0,N-q)}function y(Y,B){if(Y.indexOf(B[1])===-1)return-1;for(var T=Y.length,N=0,q=0;q<T;q++)if(Y[q]==="\\")q++;else if(Y[q]===B[0])N++;else if(Y[q]===B[1]&&(N--,N<0))return q;return-1}function A(Y){Y&&Y.sanitize&&!Y.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(Y,B){if(B<1)return"";for(var T="";B>1;)B&1&&(T+=Y),B>>=1,Y+=Y;return T+Y}function _(Y,B,T,N){var q=B.href,ie=B.title?$(B.title):null,ae=Y[1].replace(/\\([\[\]])/g,"$1");if(Y[0].charAt(0)!=="!"){N.state.inLink=!0;var ge={type:"link",raw:T,href:q,title:ie,text:ae,tokens:N.inlineTokens(ae)};return N.state.inLink=!1,ge}return{type:"image",raw:T,href:q,title:ie,text:$(ae)}}function se(Y,B){var T=Y.match(/^(\s+)(?:```)/);if(T===null)return B;var N=T[1];return B.split(`
`).map(function(q){var ie=q.match(/^\s+/);if(ie===null)return q;var ae=ie[0];return ae.length>=N.length?q.slice(N.length):q}).join(`
`)}var G=function(){function Y(T){this.options=T||he.defaults}var B=Y.prototype;return B.space=function(N){var q=this.rules.block.newline.exec(N);if(q&&q[0].length>0)return{type:"space",raw:q[0]}},B.code=function(N){var q=this.rules.block.code.exec(N);if(q){var ie=q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:q[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:P(ie,`
`)}}},B.fences=function(N){var q=this.rules.block.fences.exec(N);if(q){var ie=q[0],ae=se(ie,q[3]||"");return{type:"code",raw:ie,lang:q[2]?q[2].trim():q[2],text:ae}}},B.heading=function(N){var q=this.rules.block.heading.exec(N);if(q){var ie=q[2].trim();if(/#$/.test(ie)){var ae=P(ie,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ie=ae.trim())}return{type:"heading",raw:q[0],depth:q[1].length,text:ie,tokens:this.lexer.inline(ie)}}},B.hr=function(N){var q=this.rules.block.hr.exec(N);if(q)return{type:"hr",raw:q[0]}},B.blockquote=function(N){var q=this.rules.block.blockquote.exec(N);if(q){var ie=q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:q[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},B.list=function(N){var q=this.rules.block.list.exec(N);if(q){var ie,ae,ge,ce,pe,ye,Ce,Re,$e,De,ke,Me,je=q[1].trim(),He=je.length>1,qe={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");N&&(Me=!1,!(!(q=Xe.exec(N))||this.rules.block.hr.test(N)));){if(ie=q[0],N=N.substring(ie.length),Re=q[2].split(`
`,1)[0],$e=N.split(`
`,1)[0],this.options.pedantic?(ce=2,ke=Re.trimLeft()):(ce=q[2].search(/[^ ]/),ce=ce>4?1:ce,ke=Re.slice(ce),ce+=q[1].length),ye=!1,!Re&&/^ *$/.test($e)&&(ie+=$e+`
`,N=N.substring($e.length+1),Me=!0),!Me)for(var Ze=new RegExp("^ {0,"+Math.min(3,ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,ce-1)+"}(?:```|~~~)"),de=new RegExp("^ {0,"+Math.min(3,ce-1)+"}#");N&&(De=N.split(`
`,1)[0],Re=De,this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(Re)||de.test(Re)||Ze.test(Re)||xe.test(N)));){if(Re.search(/[^ ]/)>=ce||!Re.trim())ke+=`
`+Re.slice(ce);else if(!ye)ke+=`
`+Re;else break;!ye&&!Re.trim()&&(ye=!0),ie+=De+`
`,N=N.substring(De.length+1)}qe.loose||(Ce?qe.loose=!0:/\n *\n *$/.test(ie)&&(Ce=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ke),ae&&(ge=ae[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:ie,task:!!ae,checked:ge,loose:!1,text:ke}),qe.raw+=ie}qe.items[qe.items.length-1].raw=ie.trimRight(),qe.items[qe.items.length-1].text=ke.trimRight(),qe.raw=qe.raw.trimRight();var Pe=qe.items.length;for(pe=0;pe<Pe;pe++){this.lexer.state.top=!1,qe.items[pe].tokens=this.lexer.blockTokens(qe.items[pe].text,[]);var Ae=qe.items[pe].tokens.filter(function(Fe){return Fe.type==="space"}),Te=Ae.every(function(Fe){for(var ze=Fe.raw.split(""),Ve=0,Ge=I(ze),Qe;!(Qe=Ge()).done;){var nt=Qe.value;if(nt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!qe.loose&&Ae.length&&Te&&(qe.loose=!0,qe.items[pe].loose=!0)}return qe}},B.html=function(N){var q=this.rules.block.html.exec(N);if(q){var ie={type:"html",raw:q[0],pre:!this.options.sanitizer&&(q[1]==="pre"||q[1]==="script"||q[1]==="style"),text:q[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(q[0]):$(q[0]);ie.type="paragraph",ie.text=ae,ie.tokens=this.lexer.inline(ae)}return ie}},B.def=function(N){var q=this.rules.block.def.exec(N);if(q){q[3]&&(q[3]=q[3].substring(1,q[3].length-1));var ie=q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:q[0],href:q[2],title:q[3]}}},B.table=function(N){var q=this.rules.block.table.exec(N);if(q){var ie={type:"table",header:L(q[1]).map(function(Ce){return{text:Ce}}),align:q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:q[3]&&q[3].trim()?q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=q[0];var ae=ie.align.length,ge,ce,pe,ye;for(ge=0;ge<ae;ge++)/^ *-+: *$/.test(ie.align[ge])?ie.align[ge]="right":/^ *:-+: *$/.test(ie.align[ge])?ie.align[ge]="center":/^ *:-+ *$/.test(ie.align[ge])?ie.align[ge]="left":ie.align[ge]=null;for(ae=ie.rows.length,ge=0;ge<ae;ge++)ie.rows[ge]=L(ie.rows[ge],ie.header.length).map(function(Ce){return{text:Ce}});for(ae=ie.header.length,ce=0;ce<ae;ce++)ie.header[ce].tokens=this.lexer.inline(ie.header[ce].text);for(ae=ie.rows.length,ce=0;ce<ae;ce++)for(ye=ie.rows[ce],pe=0;pe<ye.length;pe++)ye[pe].tokens=this.lexer.inline(ye[pe].text);return ie}}},B.lheading=function(N){var q=this.rules.block.lheading.exec(N);if(q)return{type:"heading",raw:q[0],depth:q[2].charAt(0)==="="?1:2,text:q[1],tokens:this.lexer.inline(q[1])}},B.paragraph=function(N){var q=this.rules.block.paragraph.exec(N);if(q){var ie=q[1].charAt(q[1].length-1)===`
`?q[1].slice(0,-1):q[1];return{type:"paragraph",raw:q[0],text:ie,tokens:this.lexer.inline(ie)}}},B.text=function(N){var q=this.rules.block.text.exec(N);if(q)return{type:"text",raw:q[0],text:q[0],tokens:this.lexer.inline(q[0])}},B.escape=function(N){var q=this.rules.inline.escape.exec(N);if(q)return{type:"escape",raw:q[0],text:$(q[1])}},B.tag=function(N){var q=this.rules.inline.tag.exec(N);if(q)return!this.lexer.state.inLink&&/^<a /i.test(q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(q[0]):$(q[0]):q[0]}},B.link=function(N){var q=this.rules.inline.link.exec(N);if(q){var ie=q[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ae=P(ie.slice(0,-1),"\\");if((ie.length-ae.length)%2===0)return}else{var ge=y(q[2],"()");if(ge>-1){var ce=q[0].indexOf("!")===0?5:4,pe=ce+q[1].length+ge;q[2]=q[2].substring(0,ge),q[0]=q[0].substring(0,pe).trim(),q[3]=""}}var ye=q[2],Ce="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ye);Re&&(ye=Re[1],Ce=Re[3])}else Ce=q[3]?q[3].slice(1,-1):"";return ye=ye.trim(),/^</.test(ye)&&(this.options.pedantic&&!/>$/.test(ie)?ye=ye.slice(1):ye=ye.slice(1,-1)),_(q,{href:ye&&ye.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},q[0],this.lexer)}},B.reflink=function(N,q){var ie;if((ie=this.rules.inline.reflink.exec(N))||(ie=this.rules.inline.nolink.exec(N))){var ae=(ie[2]||ie[1]).replace(/\s+/g," ");if(ae=q[ae.toLowerCase()],!ae||!ae.href){var ge=ie[0].charAt(0);return{type:"text",raw:ge,text:ge}}return _(ie,ae,ie[0],this.lexer)}},B.emStrong=function(N,q,ie){ie===void 0&&(ie="");var ae=this.rules.inline.emStrong.lDelim.exec(N);if(ae&&!(ae[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ge=ae[1]||ae[2]||"";if(!ge||ge&&(ie===""||this.rules.inline.punctuation.exec(ie))){var ce=ae[0].length-1,pe,ye,Ce=ce,Re=0,$e=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,q=q.slice(-1*N.length+ce);(ae=$e.exec(q))!=null;)if(pe=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!pe){if(ye=pe.length,ae[3]||ae[4]){Ce+=ye;continue}else if((ae[5]||ae[6])&&ce%3&&!((ce+ye)%3)){Re+=ye;continue}if(Ce-=ye,!(Ce>0)){if(ye=Math.min(ye,ye+Ce+Re),Math.min(ce,ye)%2){var De=N.slice(1,ce+ae.index+ye);return{type:"em",raw:N.slice(0,ce+ae.index+ye+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ke=N.slice(2,ce+ae.index+ye-1);return{type:"strong",raw:N.slice(0,ce+ae.index+ye+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},B.codespan=function(N){var q=this.rules.inline.code.exec(N);if(q){var ie=q[2].replace(/\n/g," "),ae=/[^ ]/.test(ie),ge=/^ /.test(ie)&&/ $/.test(ie);return ae&&ge&&(ie=ie.substring(1,ie.length-1)),ie=$(ie,!0),{type:"codespan",raw:q[0],text:ie}}},B.br=function(N){var q=this.rules.inline.br.exec(N);if(q)return{type:"br",raw:q[0]}},B.del=function(N){var q=this.rules.inline.del.exec(N);if(q)return{type:"del",raw:q[0],text:q[2],tokens:this.lexer.inlineTokens(q[2])}},B.autolink=function(N,q){var ie=this.rules.inline.autolink.exec(N);if(ie){var ae,ge;return ie[2]==="@"?(ae=$(this.options.mangle?q(ie[1]):ie[1]),ge="mailto:"+ae):(ae=$(ie[1]),ge=ae),{type:"link",raw:ie[0],text:ae,href:ge,tokens:[{type:"text",raw:ae,text:ae}]}}},B.url=function(N,q){var ie;if(ie=this.rules.inline.url.exec(N)){var ae,ge;if(ie[2]==="@")ae=$(this.options.mangle?q(ie[0]):ie[0]),ge="mailto:"+ae;else{var ce;do ce=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(ce!==ie[0]);ae=$(ie[0]),ie[1]==="www."?ge="http://"+ae:ge=ae}return{type:"link",raw:ie[0],text:ae,href:ge,tokens:[{type:"text",raw:ae,text:ae}]}}},B.inlineText=function(N,q){var ie=this.rules.inline.text.exec(N);if(ie){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):$(ie[0]):ie[0]:ae=$(this.options.smartypants?q(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ae}}},Y}(),oe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};oe._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,oe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,oe.def=m(oe.def).replace("label",oe._label).replace("title",oe._title).getRegex(),oe.bullet=/(?:[*+-]|\d{1,9}[.)])/,oe.listItemStart=m(/^( *)(bull) */).replace("bull",oe.bullet).getRegex(),oe.list=m(oe.list).replace(/bull/g,oe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+oe.def.source+")").getRegex(),oe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",oe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,oe.html=m(oe.html,"i").replace("comment",oe._comment).replace("tag",oe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),oe.paragraph=m(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.blockquote=m(oe.blockquote).replace("paragraph",oe.paragraph).getRegex(),oe.normal=p({},oe),oe.gfm=p({},oe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),oe.gfm.table=m(oe.gfm.table).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.gfm.paragraph=m(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",oe.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.pedantic=p({},oe.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",oe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:m(oe.normal._paragraph).replace("hr",oe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",oe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=m(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=m(oe._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=m(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=m(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=m(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=m(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=m(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=m(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=m(ee.reflink).replace("label",ee._label).replace("ref",oe._label).getRegex(),ee.nolink=m(ee.nolink).replace("ref",oe._label).getRegex(),ee.reflinkSearch=m(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=p({},ee),ee.pedantic=p({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=p({},ee.normal,{escape:m(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=m(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=p({},ee.gfm,{br:m(ee.br).replace("{2,}","*").getRegex(),text:m(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(Y){return Y.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Z(Y){var B="",T,N,q=Y.length;for(T=0;T<q;T++)N=Y.charCodeAt(T),Math.random()>.5&&(N="x"+N.toString(16)),B+="&#"+N+";";return B}var X=function(){function Y(T){this.tokens=[],this.tokens.links=Object.create(null),this.options=T||he.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var N={block:oe.normal,inline:ee.normal};this.options.pedantic?(N.block=oe.pedantic,N.inline=ee.pedantic):this.options.gfm&&(N.block=oe.gfm,this.options.breaks?N.inline=ee.breaks:N.inline=ee.gfm),this.tokenizer.rules=N}Y.lex=function(N,q){var ie=new Y(q);return ie.lex(N)},Y.lexInline=function(N,q){var ie=new Y(q);return ie.inlineTokens(N)};var B=Y.prototype;return B.lex=function(N){N=N.replace(/\r\n|\r/g,`
`),this.blockTokens(N,this.tokens);for(var q;q=this.inlineQueue.shift();)this.inlineTokens(q.src,q.tokens);return this.tokens},B.blockTokens=function(N,q){var ie=this;q===void 0&&(q=[]),this.options.pedantic?N=N.replace(/\t/g,"    ").replace(/^ +$/gm,""):N=N.replace(/^( *)(\t+)/gm,function(Ce,Re,$e){return Re+"    ".repeat($e.length)});for(var ae,ge,ce,pe;N;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(ae=Ce.call({lexer:ie},N,q))?(N=N.substring(ae.raw.length),q.push(ae),!0):!1}))){if(ae=this.tokenizer.space(N)){N=N.substring(ae.raw.length),ae.raw.length===1&&q.length>0?q[q.length-1].raw+=`
`:q.push(ae);continue}if(ae=this.tokenizer.code(N)){N=N.substring(ae.raw.length),ge=q[q.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):q.push(ae);continue}if(ae=this.tokenizer.fences(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.heading(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.hr(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.blockquote(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.list(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.html(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.def(N)){N=N.substring(ae.raw.length),ge=q[q.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.lheading(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ce=N,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,Re=N.slice(1),$e=void 0;ie.options.extensions.startBlock.forEach(function(De){$e=De.call({lexer:this},Re),typeof $e=="number"&&$e>=0&&(Ce=Math.min(Ce,$e))}),Ce<1/0&&Ce>=0&&(ce=N.substring(0,Ce+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(ce))){ge=q[q.length-1],pe&&ge.type==="paragraph"?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):q.push(ae),pe=ce.length!==N.length,N=N.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(N)){N=N.substring(ae.raw.length),ge=q[q.length-1],ge&&ge.type==="text"?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):q.push(ae);continue}if(N){var ye="Infinite loop on byte: "+N.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return this.state.top=!0,q},B.inline=function(N,q){return q===void 0&&(q=[]),this.inlineQueue.push({src:N,tokens:q}),q},B.inlineTokens=function(N,q){var ie=this;q===void 0&&(q=[]);var ae,ge,ce,pe=N,ye,Ce,Re;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(ye=this.tokenizer.rules.inline.reflinkSearch.exec(pe))!=null;)$e.includes(ye[0].slice(ye[0].lastIndexOf("[")+1,-1))&&(pe=pe.slice(0,ye.index)+"["+M("a",ye[0].length-2)+"]"+pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ye=this.tokenizer.rules.inline.blockSkip.exec(pe))!=null;)pe=pe.slice(0,ye.index)+"["+M("a",ye[0].length-2)+"]"+pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ye=this.tokenizer.rules.inline.escapedEmSt.exec(pe))!=null;)pe=pe.slice(0,ye.index)+"++"+pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;N;)if(Ce||(Re=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(ae=ke.call({lexer:ie},N,q))?(N=N.substring(ae.raw.length),q.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.tag(N)){N=N.substring(ae.raw.length),ge=q[q.length-1],ge&&ae.type==="text"&&ge.type==="text"?(ge.raw+=ae.raw,ge.text+=ae.text):q.push(ae);continue}if(ae=this.tokenizer.link(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.reflink(N,this.tokens.links)){N=N.substring(ae.raw.length),ge=q[q.length-1],ge&&ae.type==="text"&&ge.type==="text"?(ge.raw+=ae.raw,ge.text+=ae.text):q.push(ae);continue}if(ae=this.tokenizer.emStrong(N,pe,Re)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.codespan(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.br(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.del(N)){N=N.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.autolink(N,Z)){N=N.substring(ae.raw.length),q.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(N,Z))){N=N.substring(ae.raw.length),q.push(ae);continue}if(ce=N,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,Me=N.slice(1),je=void 0;ie.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Me),typeof je=="number"&&je>=0&&(ke=Math.min(ke,je))}),ke<1/0&&ke>=0&&(ce=N.substring(0,ke+1))}(),ae=this.tokenizer.inlineText(ce,K)){N=N.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(Re=ae.raw.slice(-1)),Ce=!0,ge=q[q.length-1],ge&&ge.type==="text"?(ge.raw+=ae.raw,ge.text+=ae.text):q.push(ae);continue}if(N){var De="Infinite loop on byte: "+N.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return q},k(Y,null,[{key:"rules",get:function(){return{block:oe,inline:ee}}}]),Y}(),te=function(){function Y(T){this.options=T||he.defaults}var B=Y.prototype;return B.code=function(N,q,ie){var ae=(q||"").match(/\S*/)[0];if(this.options.highlight){var ge=this.options.highlight(N,ae);ge!=null&&ge!==N&&(ie=!0,N=ge)}return N=N.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+$(ae,!0)+'">'+(ie?N:$(N,!0))+`</code></pre>
`:"<pre><code>"+(ie?N:$(N,!0))+`</code></pre>
`},B.blockquote=function(N){return`<blockquote>
`+N+`</blockquote>
`},B.html=function(N){return N},B.heading=function(N,q,ie,ae){if(this.options.headerIds){var ge=this.options.headerPrefix+ae.slug(ie);return"<h"+q+' id="'+ge+'">'+N+"</h"+q+`>
`}return"<h"+q+">"+N+"</h"+q+`>
`},B.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},B.list=function(N,q,ie){var ae=q?"ol":"ul",ge=q&&ie!==1?' start="'+ie+'"':"";return"<"+ae+ge+`>
`+N+"</"+ae+`>
`},B.listitem=function(N){return"<li>"+N+`</li>
`},B.checkbox=function(N){return"<input "+(N?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},B.paragraph=function(N){return"<p>"+N+`</p>
`},B.table=function(N,q){return q&&(q="<tbody>"+q+"</tbody>"),`<table>
<thead>
`+N+`</thead>
`+q+`</table>
`},B.tablerow=function(N){return`<tr>
`+N+`</tr>
`},B.tablecell=function(N,q){var ie=q.header?"th":"td",ae=q.align?"<"+ie+' align="'+q.align+'">':"<"+ie+">";return ae+N+("</"+ie+`>
`)},B.strong=function(N){return"<strong>"+N+"</strong>"},B.em=function(N){return"<em>"+N+"</em>"},B.codespan=function(N){return"<code>"+N+"</code>"},B.br=function(){return this.options.xhtml?"<br/>":"<br>"},B.del=function(N){return"<del>"+N+"</del>"},B.link=function(N,q,ie){if(N=l(this.options.sanitize,this.options.baseUrl,N),N===null)return ie;var ae='<a href="'+$(N)+'"';return q&&(ae+=' title="'+q+'"'),ae+=">"+ie+"</a>",ae},B.image=function(N,q,ie){if(N=l(this.options.sanitize,this.options.baseUrl,N),N===null)return ie;var ae='<img src="'+N+'" alt="'+ie+'"';return q&&(ae+=' title="'+q+'"'),ae+=this.options.xhtml?"/>":">",ae},B.text=function(N){return N},Y}(),V=function(){function Y(){}var B=Y.prototype;return B.strong=function(N){return N},B.em=function(N){return N},B.codespan=function(N){return N},B.del=function(N){return N},B.html=function(N){return N},B.text=function(N){return N},B.link=function(N,q,ie){return""+ie},B.image=function(N,q,ie){return""+ie},B.br=function(){return""},Y}(),W=function(){function Y(){this.seen={}}var B=Y.prototype;return B.serialize=function(N){return N.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},B.getNextSafeSlug=function(N,q){var ie=N,ae=0;if(this.seen.hasOwnProperty(ie)){ae=this.seen[N];do ae++,ie=N+"-"+ae;while(this.seen.hasOwnProperty(ie))}return q||(this.seen[N]=ae,this.seen[ie]=0),ie},B.slug=function(N,q){q===void 0&&(q={});var ie=this.serialize(N);return this.getNextSafeSlug(ie,q.dryrun)},Y}(),re=function(){function Y(T){this.options=T||he.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new W}Y.parse=function(N,q){var ie=new Y(q);return ie.parse(N)},Y.parseInline=function(N,q){var ie=new Y(q);return ie.parseInline(N)};var B=Y.prototype;return B.parse=function(N,q){q===void 0&&(q=!0);var ie="",ae,ge,ce,pe,ye,Ce,Re,$e,De,ke,Me,je,He,qe,Xe,Ze,xe,tt,de,Pe=N.length;for(ae=0;ae<Pe;ae++){if(ke=N[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(de=this.options.extensions.renderers[ke.type].call({parser:this},ke),de!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ie+=de||"";continue}switch(ke.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,g(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for($e="",Re="",pe=ke.header.length,ge=0;ge<pe;ge++)Re+=this.renderer.tablecell(this.parseInline(ke.header[ge].tokens),{header:!0,align:ke.align[ge]});for($e+=this.renderer.tablerow(Re),De="",pe=ke.rows.length,ge=0;ge<pe;ge++){for(Ce=ke.rows[ge],Re="",ye=Ce.length,ce=0;ce<ye;ce++)Re+=this.renderer.tablecell(this.parseInline(Ce[ce].tokens),{header:!1,align:ke.align[ce]});De+=this.renderer.tablerow(Re)}ie+=this.renderer.table($e,De);continue}case"blockquote":{De=this.parse(ke.tokens),ie+=this.renderer.blockquote(De);continue}case"list":{for(Me=ke.ordered,je=ke.start,He=ke.loose,pe=ke.items.length,De="",ge=0;ge<pe;ge++)Xe=ke.items[ge],Ze=Xe.checked,xe=Xe.task,qe="",Xe.task&&(tt=this.renderer.checkbox(Ze),He?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=tt+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=tt+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:tt}):qe+=tt),qe+=this.parse(Xe.tokens,He),De+=this.renderer.listitem(qe,xe,Ze);ie+=this.renderer.list(De,Me,je);continue}case"html":{ie+=this.renderer.html(ke.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(De=ke.tokens?this.parseInline(ke.tokens):ke.text;ae+1<Pe&&N[ae+1].type==="text";)ke=N[++ae],De+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ie+=q?this.renderer.paragraph(De):De;continue}default:{var Ae='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ie},B.parseInline=function(N,q){q=q||this.renderer;var ie="",ae,ge,ce,pe=N.length;for(ae=0;ae<pe;ae++){if(ge=N[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(ce=this.options.extensions.renderers[ge.type].call({parser:this},ge),ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ge.type))){ie+=ce||"";continue}switch(ge.type){case"escape":{ie+=q.text(ge.text);break}case"html":{ie+=q.html(ge.text);break}case"link":{ie+=q.link(ge.href,ge.title,this.parseInline(ge.tokens,q));break}case"image":{ie+=q.image(ge.href,ge.title,ge.text);break}case"strong":{ie+=q.strong(this.parseInline(ge.tokens,q));break}case"em":{ie+=q.em(this.parseInline(ge.tokens,q));break}case"codespan":{ie+=q.codespan(ge.text);break}case"br":{ie+=q.br();break}case"del":{ie+=q.del(this.parseInline(ge.tokens,q));break}case"text":{ie+=q.text(ge.text);break}default:{var ye='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(ye);return}else throw new Error(ye)}}}return ie},Y}();function ue(Y,B,T){if(typeof Y>"u"||Y===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Y!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Y)+", string expected");if(typeof B=="function"&&(T=B,B=null),B=p({},ue.defaults,B||{}),A(B),T){var N=B.highlight,q;try{q=X.lex(Y,B)}catch(pe){return T(pe)}var ie=function(ye){var Ce;if(!ye)try{B.walkTokens&&ue.walkTokens(q,B.walkTokens),Ce=re.parse(q,B)}catch(Re){ye=Re}return B.highlight=N,ye?T(ye):T(null,Ce)};if(!N||N.length<3||(delete B.highlight,!q.length))return ie();var ae=0;ue.walkTokens(q,function(pe){pe.type==="code"&&(ae++,setTimeout(function(){N(pe.text,pe.lang,function(ye,Ce){if(ye)return ie(ye);Ce!=null&&Ce!==pe.text&&(pe.text=Ce,pe.escaped=!0),ae--,ae===0&&ie()})},0))}),ae===0&&ie();return}function ge(pe){if(pe.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+$(pe.message+"",!0)+"</pre>";throw pe}try{var ce=X.lex(Y,B);if(B.walkTokens){if(B.async)return Promise.all(ue.walkTokens(ce,B.walkTokens)).then(function(){return re.parse(ce,B)}).catch(ge);ue.walkTokens(ce,B.walkTokens)}return re.parse(ce,B)}catch(pe){ge(pe)}}ue.options=ue.setOptions=function(Y){return p(ue.defaults,Y),S(ue.defaults),ue},ue.getDefaults=D,ue.defaults=he.defaults,ue.use=function(){for(var Y=arguments.length,B=new Array(Y),T=0;T<Y;T++)B[T]=arguments[T];var N=p.apply(void 0,[{}].concat(B)),q=ue.defaults.extensions||{renderers:{},childTokens:{}},ie;B.forEach(function(ae){if(ae.extensions&&(ie=!0,ae.extensions.forEach(function(ce){if(!ce.name)throw new Error("extension name required");if(ce.renderer){var pe=q.renderers?q.renderers[ce.name]:null;pe?q.renderers[ce.name]=function(){for(var ye=arguments.length,Ce=new Array(ye),Re=0;Re<ye;Re++)Ce[Re]=arguments[Re];var $e=ce.renderer.apply(this,Ce);return $e===!1&&($e=pe.apply(this,Ce)),$e}:q.renderers[ce.name]=ce.renderer}if(ce.tokenizer){if(!ce.level||ce.level!=="block"&&ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");q[ce.level]?q[ce.level].unshift(ce.tokenizer):q[ce.level]=[ce.tokenizer],ce.start&&(ce.level==="block"?q.startBlock?q.startBlock.push(ce.start):q.startBlock=[ce.start]:ce.level==="inline"&&(q.startInline?q.startInline.push(ce.start):q.startInline=[ce.start]))}ce.childTokens&&(q.childTokens[ce.name]=ce.childTokens)})),ae.renderer&&function(){var ce=ue.defaults.renderer||new te,pe=function(Re){var $e=ce[Re];ce[Re]=function(){for(var De=arguments.length,ke=new Array(De),Me=0;Me<De;Me++)ke[Me]=arguments[Me];var je=ae.renderer[Re].apply(ce,ke);return je===!1&&(je=$e.apply(ce,ke)),je}};for(var ye in ae.renderer)pe(ye);N.renderer=ce}(),ae.tokenizer&&function(){var ce=ue.defaults.tokenizer||new G,pe=function(Re){var $e=ce[Re];ce[Re]=function(){for(var De=arguments.length,ke=new Array(De),Me=0;Me<De;Me++)ke[Me]=arguments[Me];var je=ae.tokenizer[Re].apply(ce,ke);return je===!1&&(je=$e.apply(ce,ke)),je}};for(var ye in ae.tokenizer)pe(ye);N.tokenizer=ce}(),ae.walkTokens){var ge=ue.defaults.walkTokens;N.walkTokens=function(ce){var pe=[];return pe.push(ae.walkTokens.call(this,ce)),ge&&(pe=pe.concat(ge.call(this,ce))),pe}}ie&&(N.extensions=q),ue.setOptions(N)})},ue.walkTokens=function(Y,B){for(var T=[],N=function(){var ge=ie.value;switch(T=T.concat(B.call(ue,ge)),ge.type){case"table":{for(var ce=I(ge.header),pe;!(pe=ce()).done;){var ye=pe.value;T=T.concat(ue.walkTokens(ye.tokens,B))}for(var Ce=I(ge.rows),Re;!(Re=Ce()).done;)for(var $e=Re.value,De=I($e),ke;!(ke=De()).done;){var Me=ke.value;T=T.concat(ue.walkTokens(Me.tokens,B))}break}case"list":{T=T.concat(ue.walkTokens(ge.items,B));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[ge.type]?ue.defaults.extensions.childTokens[ge.type].forEach(function(je){T=T.concat(ue.walkTokens(ge[je],B))}):ge.tokens&&(T=T.concat(ue.walkTokens(ge.tokens,B)))}},q=I(Y),ie;!(ie=q()).done;)N();return T},ue.parseInline=function(Y,B){if(typeof Y>"u"||Y===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Y!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Y)+", string expected");B=p({},ue.defaults,B||{}),A(B);try{var T=X.lexInline(Y,B);return B.walkTokens&&ue.walkTokens(T,B.walkTokens),re.parseInline(T,B)}catch(N){if(N.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+$(N.message+"",!0)+"</pre>";throw N}},ue.Parser=re,ue.parser=re.parse,ue.Renderer=te,ue.TextRenderer=V,ue.Lexer=X,ue.lexer=X.lex,ue.Tokenizer=G,ue.Slugger=W,ue.parse=ue;var ne=ue.options,me=ue.setOptions,z=ue.use,H=ue.walkTokens,R=ue.parseInline,U=ue,x=re.parse,J=X.lex;he.Lexer=X,he.Parser=re,he.Renderer=te,he.Slugger=W,he.TextRenderer=V,he.Tokenizer=G,he.getDefaults=D,he.lexer=J,he.marked=ue,he.options=ne,he.parse=U,he.parseInline=R,he.parser=x,he.setOptions=me,he.use=z,he.walkTokens=H,Object.defineProperty(he,"__esModule",{value:!0})}),define(be[147],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0;function k(c){const g=I(c);if(g&&g.length>0)return new Uint32Array(g)}e.$Sj=k;let O=0;const r=new Uint32Array(10);function I(c){if(O=0,D(c,E,4352),O>0||(D(c,b,4449),O>0)||(D(c,h,4520),O>0)||(D(c,$,12593),O))return r.subarray(0,O);if(c>=44032&&c<=55203){const g=c-44032,d=g%588,m=Math.floor(g/588),f=Math.floor(d/28),u=d%28-1;if(m<E.length?D(m,E,0):4352+m-12593<$.length&&D(4352+m,$,12593),f<b.length?D(f,b,0):4449+f-12593<$.length&&D(4449+f-12593,$,12593),u>=0&&(u<h.length?D(u,h,0):4520+u-12593<$.length&&D(4520+u-12593,$,12593)),O>0)return r.subarray(0,O)}}function D(c,g,d){c>=d&&c<d+g.length&&S(g[c-d])}function S(c){c!==0&&(r[O++]=c&255,c>>8&&(r[O++]=c>>8&255),c>>16&&(r[O++]=c>>16&255))}var v;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var w;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(w||(w={}));var C;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(C||(C={}));const E=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),b=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),h=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),$=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[98],ve([1,0,24]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=void 0;const O=new k.$Dc(1e4);function r(w){return v(w,"NFC",O)}e.$Hl=r;const I=new k.$Dc(1e4);function D(w){return v(w,"NFD",I)}e.$Il=D;const S=/[^\u0000-\u0080]/;function v(w,C,E){if(!w)return w;const b=E.get(w);if(b)return b;let h;return S.test(w)?h=w.normalize(C):h=w,E.set(w,h),h}e.$Jl=function(){const w=/[\u0300-\u036f]/g;return function(C){return D(C).replace(w,"")}}()}),define(be[148],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=e.rot=e.$8l=void 0;function k(S,v,w){return Math.min(Math.max(S,v),w)}e.$8l=k;function O(S,v){return(v+S%v)%v}e.rot=O;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$0l=r;class I{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$$l=I;class D{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const w=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$_l=D}),function(){function he(r){const I=[];typeof r=="number"&&I.push("code/timeOrigin",r);function D(v){I.push(v,Date.now())}function S(){const v=[];for(let w=0;w<I.length;w+=2)v.push({name:I[w],startTime:I[w+1]});return v}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const D of performance.getEntriesByType("mark"))I.push({name:D.name,startTime:Math.round(r+D.startTime)});return I}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function k(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=k(O))}(),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var O in k)(typeof exports=="object"?exports:he)[O]=k[O]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function k(O){if(e[O])return e[O].exports;var r=e[O]={i:O,l:!1,exports:{}};return he[O].call(r.exports,r,r.exports,k),r.l=!0,r.exports}return k.m=he,k.c=e,k.d=function(O,r,I){k.o(O,r)||Object.defineProperty(O,r,{enumerable:!0,get:I})},k.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},k.t=function(O,r){if(1&r&&(O=k(O)),8&r||4&r&&typeof O=="object"&&O&&O.__esModule)return O;var I=Object.create(null);if(k.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:O}),2&r&&typeof O!="string")for(var D in O)k.d(I,D,function(S){return O[S]}.bind(null,D));return I},k.n=function(O){var r=O&&O.__esModule?function(){return O.default}:function(){return O};return k.d(r,"a",r),r},k.o=function(O,r){return Object.prototype.hasOwnProperty.call(O,r)},k.p="",k(k.s=0)}([function(he,e,k){(function(O){var r;e=he.exports=z,r=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var $e=Array.prototype.slice.call(arguments,0);$e.unshift("SEMVER"),console.log.apply(console,$e)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],v=e.src=[],w=0,C=w++;v[C]="0|[1-9]\\d*";var E=w++;v[E]="[0-9]+";var b=w++;v[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=w++;v[h]="("+v[C]+")\\.("+v[C]+")\\.("+v[C]+")";var $=w++;v[$]="("+v[E]+")\\.("+v[E]+")\\.("+v[E]+")";var c=w++;v[c]="(?:"+v[C]+"|"+v[b]+")";var g=w++;v[g]="(?:"+v[E]+"|"+v[b]+")";var d=w++;v[d]="(?:-("+v[c]+"(?:\\."+v[c]+")*))";var m=w++;v[m]="(?:-?("+v[g]+"(?:\\."+v[g]+")*))";var f=w++;v[f]="[0-9A-Za-z-]+";var u=w++;v[u]="(?:\\+("+v[f]+"(?:\\."+v[f]+")*))";var l=w++,t="v?"+v[h]+v[d]+"?"+v[u]+"?";v[l]="^"+t+"$";var o="[v=\\s]*"+v[$]+v[m]+"?"+v[u]+"?",n=w++;v[n]="^"+o+"$";var s=w++;v[s]="((?:<|>)?=?)";var i=w++;v[i]=v[E]+"|x|X|\\*";var a=w++;v[a]=v[C]+"|x|X|\\*";var p=w++;v[p]="[v=\\s]*("+v[a]+")(?:\\.("+v[a]+")(?:\\.("+v[a]+")(?:"+v[d]+")?"+v[u]+"?)?)?";var L=w++;v[L]="[v=\\s]*("+v[i]+")(?:\\.("+v[i]+")(?:\\.("+v[i]+")(?:"+v[m]+")?"+v[u]+"?)?)?";var P=w++;v[P]="^"+v[s]+"\\s*"+v[p]+"$";var y=w++;v[y]="^"+v[s]+"\\s*"+v[L]+"$";var A=w++;v[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=w++;v[M]="(?:~>?)";var _=w++;v[_]="(\\s*)"+v[M]+"\\s+",S[_]=new RegExp(v[_],"g");var se=w++;v[se]="^"+v[M]+v[p]+"$";var G=w++;v[G]="^"+v[M]+v[L]+"$";var oe=w++;v[oe]="(?:\\^)";var ee=w++;v[ee]="(\\s*)"+v[oe]+"\\s+",S[ee]=new RegExp(v[ee],"g");var K=w++;v[K]="^"+v[oe]+v[p]+"$";var Z=w++;v[Z]="^"+v[oe]+v[L]+"$";var X=w++;v[X]="^"+v[s]+"\\s*("+o+")$|^$";var te=w++;v[te]="^"+v[s]+"\\s*("+t+")$|^$";var V=w++;v[V]="(\\s*)"+v[s]+"\\s*("+o+"|"+v[p]+")",S[V]=new RegExp(v[V],"g");var W=w++;v[W]="^\\s*("+v[p]+")\\s+-\\s+("+v[p]+")\\s*$";var re=w++;v[re]="^\\s*("+v[L]+")\\s+-\\s+("+v[L]+")\\s*$";var ue=w++;v[ue]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)r(ne,v[ne]),S[ne]||(S[ne]=new RegExp(v[ne]));function me($e,De){if($e instanceof z)return $e;if(typeof $e!="string"||$e.length>I||!(De?S[n]:S[l]).test($e))return null;try{return new z($e,De)}catch{return null}}function z($e,De){if($e instanceof z){if($e.loose===De)return $e;$e=$e.version}else if(typeof $e!="string")throw new TypeError("Invalid Version: "+$e);if($e.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof z))return new z($e,De);r("SemVer",$e,De),this.loose=De;var ke=$e.trim().match(De?S[n]:S[l]);if(!ke)throw new TypeError("Invalid Version: "+$e);if(this.raw=$e,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var je=+Me;if(je>=0&&je<D)return je}return Me}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=me,e.valid=function($e,De){var ke=me($e,De);return ke?ke.version:null},e.clean=function($e,De){var ke=me($e.trim().replace(/^[=v]+/,""),De);return ke?ke.version:null},e.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function($e){return r("SemVer.compare",this.version,this.loose,$e),$e instanceof z||($e=new z($e,this.loose)),this.compareMain($e)||this.comparePre($e)},z.prototype.compareMain=function($e){return $e instanceof z||($e=new z($e,this.loose)),R(this.major,$e.major)||R(this.minor,$e.minor)||R(this.patch,$e.patch)},z.prototype.comparePre=function($e){if($e instanceof z||($e=new z($e,this.loose)),this.prerelease.length&&!$e.prerelease.length)return-1;if(!this.prerelease.length&&$e.prerelease.length)return 1;if(!this.prerelease.length&&!$e.prerelease.length)return 0;var De=0;do{var ke=this.prerelease[De],Me=$e.prerelease[De];if(r("prerelease compare",De,ke,Me),ke===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ke===void 0)return-1;if(ke!==Me)return R(ke,Me)}while(++De)},z.prototype.inc=function($e,De){switch($e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+$e)}return this.format(),this.raw=this.version,this},e.inc=function($e,De,ke,Me){typeof ke=="string"&&(Me=ke,ke=void 0);try{return new z($e,ke).inc(De,Me).version}catch{return null}},e.diff=function($e,De){if(Y($e,De))return null;var ke=me($e),Me=me(De);if(ke.prerelease.length||Me.prerelease.length){for(var je in ke)if((je==="major"||je==="minor"||je==="patch")&&ke[je]!==Me[je])return"pre"+je;return"prerelease"}for(var je in ke)if((je==="major"||je==="minor"||je==="patch")&&ke[je]!==Me[je])return je},e.compareIdentifiers=R;var H=/^[0-9]+$/;function R($e,De){var ke=H.test($e),Me=H.test(De);return ke&&Me&&($e=+$e,De=+De),ke&&!Me?-1:Me&&!ke?1:$e<De?-1:$e>De?1:0}function U($e,De,ke){return new z($e,ke).compare(new z(De,ke))}function x($e,De,ke){return U($e,De,ke)>0}function J($e,De,ke){return U($e,De,ke)<0}function Y($e,De,ke){return U($e,De,ke)===0}function B($e,De,ke){return U($e,De,ke)!==0}function T($e,De,ke){return U($e,De,ke)>=0}function N($e,De,ke){return U($e,De,ke)<=0}function q($e,De,ke,Me){var je;switch(De){case"===":typeof $e=="object"&&($e=$e.version),typeof ke=="object"&&(ke=ke.version),je=$e===ke;break;case"!==":typeof $e=="object"&&($e=$e.version),typeof ke=="object"&&(ke=ke.version),je=$e!==ke;break;case"":case"=":case"==":je=Y($e,ke,Me);break;case"!=":je=B($e,ke,Me);break;case">":je=x($e,ke,Me);break;case">=":je=T($e,ke,Me);break;case"<":je=J($e,ke,Me);break;case"<=":je=N($e,ke,Me);break;default:throw new TypeError("Invalid operator: "+De)}return je}function ie($e,De){if($e instanceof ie){if($e.loose===De)return $e;$e=$e.value}if(!(this instanceof ie))return new ie($e,De);r("comparator",$e,De),this.loose=De,this.parse($e),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function($e,De){return R(De,$e)},e.major=function($e,De){return new z($e,De).major},e.minor=function($e,De){return new z($e,De).minor},e.patch=function($e,De){return new z($e,De).patch},e.compare=U,e.compareLoose=function($e,De){return U($e,De,!0)},e.rcompare=function($e,De,ke){return U(De,$e,ke)},e.sort=function($e,De){return $e.sort(function(ke,Me){return e.compare(ke,Me,De)})},e.rsort=function($e,De){return $e.sort(function(ke,Me){return e.rcompare(ke,Me,De)})},e.gt=x,e.lt=J,e.eq=Y,e.neq=B,e.gte=T,e.lte=N,e.cmp=q,e.Comparator=ie;var ae={};function ge($e,De){if($e instanceof ge)return $e.loose===De?$e:new ge($e.raw,De);if($e instanceof ie)return new ge($e.value,De);if(!(this instanceof ge))return new ge($e,De);if(this.loose=De,this.raw=$e,this.set=$e.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$e);this.format()}function ce($e){return!$e||$e.toLowerCase()==="x"||$e==="*"}function pe($e,De,ke,Me,je,He,qe,Xe,Ze,xe,tt,de,Pe){return((De=ce(ke)?"":ce(Me)?">="+ke+".0.0":ce(je)?">="+ke+"."+Me+".0":">="+De)+" "+(Xe=ce(Ze)?"":ce(xe)?"<"+(+Ze+1)+".0.0":ce(tt)?"<"+Ze+"."+(+xe+1)+".0":de?"<="+Ze+"."+xe+"."+tt+"-"+de:"<="+Xe)).trim()}function ye($e,De){for(var ke=0;ke<$e.length;ke++)if(!$e[ke].test(De))return!1;if(De.prerelease.length){for(ke=0;ke<$e.length;ke++)if(r($e[ke].semver),$e[ke].semver!==ae&&$e[ke].semver.prerelease.length>0){var Me=$e[ke].semver;if(Me.major===De.major&&Me.minor===De.minor&&Me.patch===De.patch)return!0}return!1}return!0}function Ce($e,De,ke){try{De=new ge(De,ke)}catch{return!1}return De.test($e)}function Re($e,De,ke,Me){var je,He,qe,Xe,Ze;switch($e=new z($e,Me),De=new ge(De,Me),ke){case">":je=x,He=N,qe=J,Xe=">",Ze=">=";break;case"<":je=J,He=T,qe=x,Xe="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce($e,De,Me))return!1;for(var xe=0;xe<De.set.length;++xe){var tt=De.set[xe],de=null,Pe=null;if(tt.forEach(function(Ae){Ae.semver===ae&&(Ae=new ie(">=0.0.0")),de=de||Ae,Pe=Pe||Ae,je(Ae.semver,de.semver,Me)?de=Ae:qe(Ae.semver,Pe.semver,Me)&&(Pe=Ae)}),de.operator===Xe||de.operator===Ze||(!Pe.operator||Pe.operator===Xe)&&He($e,Pe.semver)||Pe.operator===Ze&&qe($e,Pe.semver))return!1}return!0}ie.prototype.parse=function($e){var De=this.loose?S[X]:S[te],ke=$e.match(De);if(!ke)throw new TypeError("Invalid comparator: "+$e);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new z(ke[2],this.loose):this.semver=ae},ie.prototype.toString=function(){return this.value},ie.prototype.test=function($e){return r("Comparator.test",$e,this.loose),this.semver===ae||(typeof $e=="string"&&($e=new z($e,this.loose)),q($e,this.operator,this.semver,this.loose))},ie.prototype.intersects=function($e,De){if(!($e instanceof ie))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new ge($e.value,De),Ce(this.value,ke,De);if($e.operator==="")return ke=new ge(this.value,De),Ce($e.semver,ke,De);var Me=!(this.operator!==">="&&this.operator!==">"||$e.operator!==">="&&$e.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||$e.operator!=="<="&&$e.operator!=="<"),He=this.semver.version===$e.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||$e.operator!==">="&&$e.operator!=="<="),Xe=q(this.semver,"<",$e.semver,De)&&(this.operator===">="||this.operator===">")&&($e.operator==="<="||$e.operator==="<"),Ze=q(this.semver,">",$e.semver,De)&&(this.operator==="<="||this.operator==="<")&&($e.operator===">="||$e.operator===">");return Me||je||He&&qe||Xe||Ze},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function($e){return $e.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function($e){var De=this.loose;$e=$e.trim(),r("range",$e,De);var ke=De?S[re]:S[W];$e=$e.replace(ke,pe),r("hyphen replace",$e),$e=$e.replace(S[V],"$1$2$3"),r("comparator trim",$e,S[V]),$e=($e=($e=$e.replace(S[_],"$1~")).replace(S[ee],"$1^")).split(/\s+/).join(" ");var Me=De?S[X]:S[te],je=$e.split(" ").map(function(He){return function(qe,Xe){return r("comp",qe),qe=function(Ze,xe){return Ze.trim().split(/\s+/).map(function(tt){return function(de,Pe){r("caret",de,Pe);var Ae=Pe?S[Z]:S[K];return de.replace(Ae,function(Te,Fe,ze,Ve,Ge){var Qe;return r("caret",de,Te,Fe,ze,Ve,Ge),ce(Fe)?Qe="":ce(ze)?Qe=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":ce(Ve)?Qe=Fe==="0"?">="+Fe+"."+ze+".0 <"+Fe+"."+(+ze+1)+".0":">="+Fe+"."+ze+".0 <"+(+Fe+1)+".0.0":Ge?(r("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=Fe==="0"?ze==="0"?">="+Fe+"."+ze+"."+Ve+Ge+" <"+Fe+"."+ze+"."+(+Ve+1):">="+Fe+"."+ze+"."+Ve+Ge+" <"+Fe+"."+(+ze+1)+".0":">="+Fe+"."+ze+"."+Ve+Ge+" <"+(+Fe+1)+".0.0"):(r("no pr"),Qe=Fe==="0"?ze==="0"?">="+Fe+"."+ze+"."+Ve+" <"+Fe+"."+ze+"."+(+Ve+1):">="+Fe+"."+ze+"."+Ve+" <"+Fe+"."+(+ze+1)+".0":">="+Fe+"."+ze+"."+Ve+" <"+(+Fe+1)+".0.0"),r("caret return",Qe),Qe})}(tt,xe)}).join(" ")}(qe,Xe),r("caret",qe),qe=function(Ze,xe){return Ze.trim().split(/\s+/).map(function(tt){return function(de,Pe){var Ae=Pe?S[G]:S[se];return de.replace(Ae,function(Te,Fe,ze,Ve,Ge){var Qe;return r("tilde",de,Te,Fe,ze,Ve,Ge),ce(Fe)?Qe="":ce(ze)?Qe=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":ce(Ve)?Qe=">="+Fe+"."+ze+".0 <"+Fe+"."+(+ze+1)+".0":Ge?(r("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=">="+Fe+"."+ze+"."+Ve+Ge+" <"+Fe+"."+(+ze+1)+".0"):Qe=">="+Fe+"."+ze+"."+Ve+" <"+Fe+"."+(+ze+1)+".0",r("tilde return",Qe),Qe})}(tt,xe)}).join(" ")}(qe,Xe),r("tildes",qe),qe=function(Ze,xe){return r("replaceXRanges",Ze,xe),Ze.split(/\s+/).map(function(tt){return function(de,Pe){de=de.trim();var Ae=Pe?S[y]:S[P];return de.replace(Ae,function(Te,Fe,ze,Ve,Ge,Qe){r("xRange",de,Te,Fe,ze,Ve,Ge,Qe);var nt=ce(ze),Ye=nt||ce(Ve),it=Ye||ce(Ge);return Fe==="="&&it&&(Fe=""),nt?Te=Fe===">"||Fe==="<"?"<0.0.0":"*":Fe&&it?(Ye&&(Ve=0),it&&(Ge=0),Fe===">"?(Fe=">=",Ye?(ze=+ze+1,Ve=0,Ge=0):it&&(Ve=+Ve+1,Ge=0)):Fe==="<="&&(Fe="<",Ye?ze=+ze+1:Ve=+Ve+1),Te=Fe+ze+"."+Ve+"."+Ge):Ye?Te=">="+ze+".0.0 <"+(+ze+1)+".0.0":it&&(Te=">="+ze+"."+Ve+".0 <"+ze+"."+(+Ve+1)+".0"),r("xRange return",Te),Te})}(tt,xe)}).join(" ")}(qe,Xe),r("xrange",qe),qe=function(Ze,xe){return r("replaceStars",Ze,xe),Ze.trim().replace(S[ue],"")}(qe,Xe),r("stars",qe),qe}(He,De)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Me)})),je=je.map(function(He){return new ie(He,De)})},ge.prototype.intersects=function($e,De){if(!($e instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(Me){return $e.set.some(function(je){return je.every(function(He){return Me.intersects(He,De)})})})})},e.toComparators=function($e,De){return new ge($e,De).set.map(function(ke){return ke.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},ge.prototype.test=function($e){if(!$e)return!1;typeof $e=="string"&&($e=new z($e,this.loose));for(var De=0;De<this.set.length;De++)if(ye(this.set[De],$e))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function($e,De,ke){var Me=null,je=null;try{var He=new ge(De,ke)}catch{return null}return $e.forEach(function(qe){He.test(qe)&&(Me&&je.compare(qe)!==-1||(je=new z(Me=qe,ke)))}),Me},e.minSatisfying=function($e,De,ke){var Me=null,je=null;try{var He=new ge(De,ke)}catch{return null}return $e.forEach(function(qe){He.test(qe)&&(Me&&je.compare(qe)!==1||(je=new z(Me=qe,ke)))}),Me},e.validRange=function($e,De){try{return new ge($e,De).range||"*"}catch{return null}},e.ltr=function($e,De,ke){return Re($e,De,"<",ke)},e.gtr=function($e,De,ke){return Re($e,De,">",ke)},e.outside=Re,e.prerelease=function($e,De){var ke=me($e,De);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function($e,De,ke){return $e=new ge($e,ke),De=new ge(De,ke),$e.intersects(De)},e.coerce=function($e){if($e instanceof z)return $e;if(typeof $e!="string")return null;var De=$e.match(S[A]);return De==null?null:me((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,k(1))},function(he,e){var k,O,r=he.exports={};function I(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S(g){if(k===setTimeout)return setTimeout(g,0);if((k===I||!k)&&setTimeout)return k=setTimeout,setTimeout(g,0);try{return k(g,0)}catch{try{return k.call(null,g,0)}catch{return k.call(this,g,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:I}catch{k=I}try{O=typeof clearTimeout=="function"?clearTimeout:D}catch{O=D}})();var v,w=[],C=!1,E=-1;function b(){C&&v&&(C=!1,v.length?w=v.concat(w):E=-1,w.length&&h())}function h(){if(!C){var g=S(b);C=!0;for(var d=w.length;d;){for(v=w,w=[];++E<d;)v&&v[E].run();E=-1,d=w.length}v=null,C=!1,function(m){if(O===clearTimeout)return clearTimeout(m);if((O===D||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(m);try{O(m)}catch{try{return O.call(null,m)}catch{return O.call(this,m)}}}(g)}}function $(g,d){this.fun=g,this.array=d}function c(){}r.nextTick=function(g){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];w.push(new $(g,d)),w.length!==1||C||S(h)},$.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=c,r.addListener=c,r.once=c,r.off=c,r.removeListener=c,r.removeAllListeners=c,r.emit=c,r.prependListener=c,r.prependOnceListener=c,r.listeners=function(g){return[]},r.binding=function(g){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(g){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(be[149],ve([1,0]),function(he,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;class O{constructor(S,v,w){this.level=S,this.key=v,this.value=w,this.forward=[]}}const r=void 0;class I{constructor(S,v=2**16){this.comparator=S,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new O(this.c,r,r)}get size(){return this.f}clear(){this.e=new O(this.c,r,r),this.f=0}has(S){return!!I.g(this,S,this.comparator)}get(S){return I.g(this,S,this.comparator)?.value}set(S,v){return I.h(this,S,v,this.comparator)&&(this.f+=1),this}delete(S){const v=I.k(this,S,this.comparator);return v&&(this.f-=1),v}forEach(S,v){let w=this.e.forward[0];for(;w;)S.call(v,w.value,w.key,this),w=w.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",v=this.e.forward[0];for(;v;)S+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return S}static g(S,v,w){let C=S.e;for(let E=S.d-1;E>=0;E--)for(;C.forward[E]&&w(C.forward[E].key,v)<0;)C=C.forward[E];if(C=C.forward[0],C&&w(C.key,v)===0)return C}static h(S,v,w,C){const E=[];let b=S.e;for(let h=S.d-1;h>=0;h--){for(;b.forward[h]&&C(b.forward[h].key,v)<0;)b=b.forward[h];E[h]=b}if(b=b.forward[0],b&&C(b.key,v)===0)return b.value=w,!1;{const h=I.j(S);if(h>S.d){for(let $=S.d;$<h;$++)E[$]=S.e;S.d=h}b=new O(h,v,w);for(let $=0;$<h;$++)b.forward[$]=E[$].forward[$],E[$].forward[$]=b;return!0}}static j(S,v=.5){let w=1;for(;Math.random()<v&&w<S.c;)w+=1;return w}static k(S,v,w){const C=[];let E=S.e;for(let b=S.d-1;b>=0;b--){for(;E.forward[b]&&w(E.forward[b].key,v)<0;)E=E.forward[b];C[b]=E}if(E=E.forward[0],!E||w(E.key,v)!==0)return!1;for(let b=0;b<S.d&&C[b].forward[b]===E;b++)C[b].forward[b]=E.forward[b];for(;S.d>0&&S.e.forward[S.d-1]===r;)S.d-=1;return!0}}e.$2r=I}),define(be[61],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(I){return new O(I)}constructor(I){this.c=k&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=O}),define(be[6],ve([1,0,10,76,2,97,61]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const S=!1,v=!1;var w;(function(P){P.None=()=>r.$Tc.None;function y(N){if(v){const{onDidAddListener:q}=N,ie=$.create();let ae=0;N.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),q?.()}}}function A(N,q){return te(N,()=>{},0,void 0,!0,void 0,q)}P.defer=A;function M(N){return(q,ie=null,ae)=>{let ge=!1,ce;return ce=N(pe=>{if(!ge)return ce?ce.dispose():ge=!0,q.call(ie,pe)},null,ae),ge&&ce.dispose(),ce}}P.once=M;function _(N,q,ie){return Z((ae,ge=null,ce)=>N(pe=>ae.call(ge,q(pe)),null,ce),ie)}P.map=_;function se(N,q,ie){return Z((ae,ge=null,ce)=>N(pe=>{q(pe),ae.call(ge,pe)},null,ce),ie)}P.forEach=se;function G(N,q,ie){return Z((ae,ge=null,ce)=>N(pe=>q(pe)&&ae.call(ge,pe),null,ce),ie)}P.filter=G;function oe(N){return N}P.signal=oe;function ee(...N){return(q,ie=null,ae)=>{const ge=(0,r.$Qc)(...N.map(ce=>ce(pe=>q.call(ie,pe))));return X(ge,ae)}}P.any=ee;function K(N,q,ie,ae){let ge=ie;return _(N,ce=>(ge=q(ge,ce),ge),ae)}P.reduce=K;function Z(N,q){let ie;const ae={onWillAddFirstListener(){ie=N(ge.fire,ge)},onDidRemoveLastListener(){ie?.dispose()}};q||y(ae);const ge=new f(ae);return q?.add(ge),ge.event}function X(N,q){return q instanceof Array?q.push(N):q&&q.add(N),N}function te(N,q,ie=100,ae=!1,ge=!1,ce,pe){let ye,Ce,Re,$e=0,De;const ke={leakWarningThreshold:ce,onWillAddFirstListener(){ye=N(je=>{$e++,Ce=q(Ce,je),ae&&!Re&&(Me.fire(Ce),Ce=void 0),De=()=>{const He=Ce;Ce=void 0,Re=void 0,(!ae||$e>1)&&Me.fire(He),$e=0},typeof ie=="number"?(clearTimeout(Re),Re=setTimeout(De,ie)):Re===void 0&&(Re=0,queueMicrotask(De))})},onWillRemoveListener(){ge&&$e>0&&De?.()},onDidRemoveLastListener(){De=void 0,ye.dispose()}};pe||y(ke);const Me=new f(ke);return pe?.add(Me),Me.event}P.debounce=te;function V(N,q=0,ie){return P.debounce(N,(ae,ge)=>ae?(ae.push(ge),ae):[ge],q,void 0,!0,void 0,ie)}P.accumulate=V;function W(N,q=(ae,ge)=>ae===ge,ie){let ae=!0,ge;return G(N,ce=>{const pe=ae||!q(ce,ge);return ae=!1,ge=ce,pe},ie)}P.latch=W;function re(N,q,ie){return[P.filter(N,q,ie),P.filter(N,ae=>!q(ae),ie)]}P.split=re;function ue(N,q=!1,ie=[],ae){let ge=ie.slice(),ce=N(Ce=>{ge?ge.push(Ce):ye.fire(Ce)});ae&&ae.add(ce);const pe=()=>{ge?.forEach(Ce=>ye.fire(Ce)),ge=null},ye=new f({onWillAddFirstListener(){ce||(ce=N(Ce=>ye.fire(Ce)),ae&&ae.add(ce))},onDidAddFirstListener(){ge&&(q?setTimeout(pe):pe())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return ae&&ae.add(ye),ye.event}P.buffer=ue;function ne(N,q){return(ae,ge,ce)=>{const pe=q(new z);return N(function(ye){const Ce=pe.evaluate(ye);Ce!==me&&ae.call(ge,Ce)},void 0,ce)}}P.chain=ne;const me=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(q){return this.f.push(q),this}forEach(q){return this.f.push(ie=>(q(ie),ie)),this}filter(q){return this.f.push(ie=>q(ie)?ie:me),this}reduce(q,ie){let ae=ie;return this.f.push(ge=>(ae=q(ae,ge),ae)),this}latch(q=(ie,ae)=>ie===ae){let ie=!0,ae;return this.f.push(ge=>{const ce=ie||!q(ge,ae);return ie=!1,ae=ge,ce?ge:me}),this}evaluate(q){for(const ie of this.f)if(q=ie(q),q===me)break;return q}}function H(N,q,ie=ae=>ae){const ae=(...ye)=>pe.fire(ie(...ye)),ge=()=>N.on(q,ae),ce=()=>N.removeListener(q,ae),pe=new f({onWillAddFirstListener:ge,onDidRemoveLastListener:ce});return pe.event}P.fromNodeEventEmitter=H;function R(N,q,ie=ae=>ae){const ae=(...ye)=>pe.fire(ie(...ye)),ge=()=>N.addEventListener(q,ae),ce=()=>N.removeEventListener(q,ae),pe=new f({onWillAddFirstListener:ge,onDidRemoveLastListener:ce});return pe.event}P.fromDOMEventEmitter=R;function U(N){return new Promise(q=>M(N)(q))}P.toPromise=U;function x(N){const q=new f;return N.then(ie=>{q.fire(ie)},()=>{q.fire(void 0)}).finally(()=>{q.dispose()}),q.event}P.fromPromise=x;function J(N,q,ie){return q(ie),N(ae=>q(ae))}P.runAndSubscribe=J;class Y{constructor(q,ie){this._observable=q,this.f=0,this.g=!1;const ae={onWillAddFirstListener:()=>{q.addObserver(this)},onDidRemoveLastListener:()=>{q.removeObserver(this)}};ie||y(ae),this.emitter=new f(ae),ie&&ie.add(this.emitter)}beginUpdate(q){this.f++}handlePossibleChange(q){}handleChange(q,ie){this.g=!0}endUpdate(q){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function B(N,q){return new Y(N,q).emitter.event}P.fromObservable=B;function T(N){return(q,ie,ae)=>{let ge=0,ce=!1;const pe={beginUpdate(){ge++},endUpdate(){ge--,ge===0&&(N.reportChanges(),ce&&(ce=!1,q.call(ie)))},handlePossibleChange(){},handleChange(){ce=!0}};N.addObserver(pe),N.reportChanges();const ye={dispose(){N.removeObserver(pe)}};return ae instanceof r.$Sc?ae.add(ye):Array.isArray(ae)&&ae.push(ye),ye}}P.fromObservableLight=T})(w||(e.Event=w={}));class C{static{this.all=new Set}static{this.f=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${C.f++}`,C.all.add(this)}start(y){this.g=new D.$Sd,this.listenerCount=y}stop(){if(this.g){const y=this.g.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this.g=void 0}}}e.$Ud=C;let E=-1;function b(P){const y=E;return E=P,{dispose(){E=y}}}e.$Vd=b;class h{constructor(y,A=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=A,this.g=0}dispose(){this.f?.clear()}check(y,A){const M=this.threshold;if(M<=0||A<M)return;this.f||(this.f=new Map);const _=this.f.get(y.value)||0;if(this.f.set(y.value,_+1),this.g-=1,this.g<=0){this.g=M*.5;let se,G=0;for(const[oe,ee]of this.f)(!se||G<ee)&&(se=oe,G=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${G}):`),console.warn(se)}return()=>{const se=this.f.get(y.value)||0;this.f.set(y.value,se-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class g{constructor(y){this.value=y,this.id=c++}}const d=2,m=(P,y)=>{if(P instanceof g)y(P);else for(let A=0;A<P.length;A++){const M=P[A];M&&y(M)}};class f{constructor(y){this.w=0,this.f=y,this.g=E>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const y=this.t;queueMicrotask(()=>{m(y,A=>A.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(y,A,M)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Tc.None;if(this.m)return r.$Tc.None;A&&(y=y.bind(A));const _=new g(y);let se,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(_.stack=$.create(),se=this.g.check(_.stack,this.w+1)),S&&(_.stack=G??$.create()),this.t?this.t instanceof g?(this.u??=new l,this.t=[this.t,_]):this.t.push(_):(this.f?.onWillAddFirstListener?.(this),this.t=_,this.f?.onDidAddFirstListener?.(this)),this.w++;const oe=(0,r.$Rc)(()=>{se?.(),this.x(_)});return M instanceof r.$Sc?M.add(oe):Array.isArray(M)&&M.push(oe),oe},this.q}x(y){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const A=this.t,M=A.indexOf(y);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,A[M]=void 0;const _=this.u.current===this;if(this.w*d<=A.length){let se=0;for(let G=0;G<A.length;G++)A[G]?A[se++]=A[G]:_&&(this.u.end--,se<this.u.i&&this.u.i--);A.length=se}}y(y,A){if(!y)return;const M=this.f?.onListenerError||k.$1;if(!M){y.value(A);return}try{y.value(A)}catch(_){M(_)}}z(y){const A=y.current.t;for(;y.i<y.end;)this.y(A[y.i++],y.value);y.reset()}fire(y){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,y);else{const A=this.u;A.enqueue(this,y,this.t.length),this.z(A)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=f;const u=()=>new l;e.$Xd=u;class l{constructor(){this.i=-1,this.end=0}enqueue(y,A,M){this.i=0,this.end=M,this.current=y,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends f{async fireAsync(y,A,M){if(this.t)for(this.h||(this.h=new I.$4c),m(this.t,_=>this.h.push([_.value,y]));this.h.size>0&&!A.isCancellationRequested;){const[_,se]=this.h.shift(),G=[],oe={...se,token:A,waitUntil:ee=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");M&&(ee=M(ee,_)),G.push(ee)}};try{_(oe)}catch(ee){(0,k.$1)(ee);continue}Object.freeze(G),await Promise.allSettled(G).then(ee=>{for(const K of ee)K.status==="rejected"&&(0,k.$1)(K.reason)})}}}e.$Yd=t;class o extends f{get isPaused(){return this.h!==0}constructor(y){super(y),this.h=0,this.s=new I.$4c,this.A=y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const y=Array.from(this.s);this.s.clear(),super.fire(this.A(y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(y){this.w&&(this.h!==0?this.s.push(y):super.fire(y))}}e.$Zd=o;class n extends o{constructor(y){super(y),this.k=y.delay??100}fire(y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(y)}}e.$1d=n;class s extends f{constructor(y){super(y),this.h=[],this.k=y?.merge}fire(y){this.hasListeners()&&(this.h.push(y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(A=>super.fire(A)),this.h=[]}))}}e.$2d=s;class i{constructor(){this.g=!1,this.h=[],this.f=new f({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(y){const A={event:y,listener:null};this.h.push(A),this.g&&this.m(A);const M=()=>{this.g&&this.o(A);const _=this.h.indexOf(A);this.h.splice(_,1)};return(0,r.$Rc)((0,O.$db)(M))}j(){this.g=!0,this.h.forEach(y=>this.m(y))}k(){this.g=!1,this.h.forEach(y=>this.o(y))}m(y){y.listener=y.event(A=>this.f.fire(A))}o(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.f.dispose()}}e.$3d=i;class a{constructor(y,A,M,_){this.f=new r.$Sc;const se=this.f.add(new i),G=this.f.add(new r.$3c);function oe(ee){G.set(ee,se.add(_(ee)))}for(const ee of y)oe(ee);this.f.add(A(ee=>{oe(ee)})),this.f.add(M(ee=>{G.deleteAndDispose(ee)})),this.event=se.event}dispose(){this.f.dispose()}}e.$4d=a;class p{constructor(){this.f=[]}wrapEvent(y){return(A,M,_)=>y(se=>{const G=this.f[this.f.length-1];G?G.push(()=>A.call(M,se)):A.call(M,se)},void 0,_)}bufferEvents(y){const A=[];this.f.push(A);const M=y();return this.f.pop(),A.forEach(_=>_()),M}}e.$5d=p;class L{constructor(){this.f=!1,this.g=w.None,this.h=r.$Tc.None,this.j=new f({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(y){this.g=y,this.f&&(this.h.dispose(),this.h=y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=L}),define(be[20],ve([1,0,6]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const O=Object.freeze(function(S,v){const w=setTimeout(S.bind(v),0);return{dispose(){clearTimeout(w)}}});var r;(function(S){function v(w){return w===S.None||w===S.Cancelled||w instanceof I?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}S.isCancellationToken=v,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(r||(e.CancellationToken=r={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new k.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(v){this.f=void 0,this.g=void 0,this.g=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=r.Cancelled}dispose(v=!1){v&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=r.None}}e.$7d=D}),define(be[150],ve([1,0,20]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class O{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new k.$7d,v=this.b(S.token);return this.a={promise:v,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$Fe=O;class r{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const v=JSON.stringify(S);return this.b!==v&&(this.b=v,this.a=this.c(S)),this.a}}e.$Ge=r;class I{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const v=this.b(S);return this.a.set(S,v),v}}e.$He=I}),define(be[50],ve([1,0,10,2]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function r(u){const l=u;return l?typeof l.read=="function":!1}e.$8d=r;function I(u){const l=u;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}e.$9d=I;function D(u){const l=u;return l?I(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$0d=D;function S(u,l){return new v(u,l)}e.$$d=S;class v{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,k.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let o;switch(l){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(t);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(u,l){const t=[];let o;for(;(o=u.read())!==null;)t.push(o);return l(t)}e.$_d=w;function C(u,l,t){const o=[];let n;for(;(n=u.read())!==null&&o.length<t;)o.push(n);return n===null&&o.length>0?l(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return u.read()}}}e.$ae=C;function E(u,l){return new Promise((t,o)=>{const n=[];b(u,{onData:s=>{l&&n.push(s)},onError:s=>{l?o(s):t(void 0)},onEnd:()=>{t(l?l(n):void 0)}})})}e.$be=E;function b(u,l,t){u.on("error",o=>{t?.isCancellationRequested||l.onError(o)}),u.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),u.on("data",o=>{t?.isCancellationRequested||l.onData(o)})}e.$ce=b;function h(u,l){return new Promise((t,o)=>{const n=new O.$Sc,s=[],i=L=>{if(s.push(L),s.length>l)return n.dispose(),u.pause(),t({stream:u,buffer:s,ended:!1})},a=L=>(n.dispose(),o(L)),p=()=>(n.dispose(),t({stream:u,buffer:s,ended:!0}));n.add((0,O.$Rc)(()=>u.removeListener("error",a))),u.on("error",a),n.add((0,O.$Rc)(()=>u.removeListener("end",p))),u.on("end",p),n.add((0,O.$Rc)(()=>u.removeListener("data",i))),u.on("data",i)})}e.$de=h;function $(u,l){const t=S(l);return t.end(u),t}e.$ee=$;function c(){const u=S(()=>{throw new Error("not supported")});return u.end(),u}e.$fe=c;function g(u){let l=!1;return{read:()=>l?null:(l=!0,u)}}e.$ge=g;function d(u,l,t){const o=S(t);return b(u,{onData:n=>o.write(l.data(n)),onError:n=>o.error(l.error?l.error(n):n),onEnd:()=>o.end()}),o}e.$he=d;function m(u,l,t){let o=!1;return{read:()=>{const n=l.read();return o?n:(o=!0,n!==null?t([u,n]):u)}}}e.$ie=m;function f(u,l,t){let o=!1;const n=S(t);return b(l,{onData:s=>o?n.write(s):(o=!0,n.write(t([u,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(u)),n.end()}}),n}e.$je=f}),define(be[14],ve([1,0,60,50]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const r=typeof Buffer<"u",I=new k.$V(()=>new Uint8Array(256));let D,S;class v{static alloc(A){return r?new v(Buffer.allocUnsafe(A)):new v(new Uint8Array(A))}static wrap(A){return r&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new v(A)}static fromString(A,M){return!(M?.dontUseNodeBuffer||!1)&&r?new v(Buffer.from(A)):(D||(D=new TextEncoder),new v(D.encode(A)))}static fromByteArray(A){const M=v.alloc(A.length);for(let _=0,se=A.length;_<se;_++)M.buffer[_]=A[_];return M}static concat(A,M){if(typeof M>"u"){M=0;for(let G=0,oe=A.length;G<oe;G++)M+=A[G].byteLength}const _=v.alloc(M);let se=0;for(let G=0,oe=A.length;G<oe;G++){const ee=A[G];_.set(ee,se),se+=ee.byteLength}return _}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=v.alloc(this.byteLength);return A.set(this),A}toString(){return r?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(A,M){return new v(this.buffer.subarray(A,M))}set(A,M){if(A instanceof v)this.buffer.set(A.buffer,M);else if(A instanceof Uint8Array)this.buffer.set(A,M);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),M);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return b(this.buffer,A)}writeUInt32BE(A,M){h(this.buffer,A,M)}readUInt32LE(A){return $(this.buffer,A)}writeUInt32LE(A,M){c(this.buffer,A,M)}readUInt8(A){return g(this.buffer,A)}writeUInt8(A,M){d(this.buffer,A,M)}indexOf(A,M=0){return w(this.buffer,A instanceof v?A.buffer:A,M)}}e.$ke=v;function w(y,A,M=0){const _=A.byteLength,se=y.byteLength;if(_===0)return 0;if(_===1)return y.indexOf(A[0]);if(_>se-M)return-1;const G=I.value;G.fill(A.length);for(let Z=0;Z<A.length;Z++)G[A[Z]]=A.length-Z-1;let oe=M+A.length-1,ee=oe,K=-1;for(;oe<se;)if(y[oe]===A[ee]){if(ee===0){K=oe;break}oe--,ee--}else oe+=Math.max(A.length-ee,G[y[oe]]),ee=A.length-1;return K}e.$le=w;function C(y,A){return y[A+0]<<0>>>0|y[A+1]<<8>>>0}e.$me=C;function E(y,A,M){y[M+0]=A&255,A=A>>>8,y[M+1]=A&255}e.$ne=E;function b(y,A){return y[A]*2**24+y[A+1]*2**16+y[A+2]*2**8+y[A+3]}e.$oe=b;function h(y,A,M){y[M+3]=A,A=A>>>8,y[M+2]=A,A=A>>>8,y[M+1]=A,A=A>>>8,y[M]=A}e.$pe=h;function $(y,A){return y[A+0]<<0>>>0|y[A+1]<<8>>>0|y[A+2]<<16>>>0|y[A+3]<<24>>>0}e.$qe=$;function c(y,A,M){y[M+0]=A&255,A=A>>>8,y[M+1]=A&255,A=A>>>8,y[M+2]=A&255,A=A>>>8,y[M+3]=A&255}e.$re=c;function g(y,A){return y[A]}e.$se=g;function d(y,A,M){y[M]=A}e.$te=d;function m(y){return O.$_d(y,A=>v.concat(A))}e.$ue=m;function f(y){return O.$ge(y)}e.$ve=f;function u(y){return O.$be(y,A=>v.concat(A))}e.$we=u;async function l(y){return y.ended?v.concat(y.buffer):v.concat([...y.buffer,await u(y.stream)])}e.$xe=l;function t(y){return O.$ee(y,A=>v.concat(A))}e.$ye=t;function o(y){return O.$he(y,{data:A=>typeof A=="string"?v.fromString(A):v.wrap(A)},A=>v.concat(A))}e.$ze=o;function n(y){return O.$$d(A=>v.concat(A),y)}e.$Ae=n;function s(y,A){return O.$ie(y,A,M=>v.concat(M))}e.$Be=s;function i(y,A){return O.$je(y,A,M=>v.concat(M))}e.$Ce=i;function a(y){let A=0,M=0,_=0;const se=new Uint8Array(Math.floor(y.length/4*3)),G=ee=>{switch(M){case 3:se[_++]=A|ee,M=0;break;case 2:se[_++]=A|ee>>>2,A=ee<<6,M=3;break;case 1:se[_++]=A|ee>>>4,A=ee<<4,M=2;break;default:A=ee<<2,M=1}};for(let ee=0;ee<y.length;ee++){const K=y.charCodeAt(ee);if(K>=65&&K<=90)G(K-65);else if(K>=97&&K<=122)G(K-97+26);else if(K>=48&&K<=57)G(K-48+52);else if(K===43||K===45)G(62);else if(K===47||K===95)G(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${y[ee]}`)}}const oe=_;for(;M>0;)G(0);return v.wrap(se).slice(0,oe)}e.$De=a;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:y},A=!0,M=!1){const _=M?L:p;let se="";const G=y.byteLength%3;let oe=0;for(;oe<y.byteLength-G;oe+=3){const ee=y[oe+0],K=y[oe+1],Z=y[oe+2];se+=_[ee>>>2],se+=_[(ee<<4|K>>>4)&63],se+=_[(K<<2|Z>>>6)&63],se+=_[Z&63]}if(G===1){const ee=y[oe+0];se+=_[ee>>>2],se+=_[ee<<4&63],A&&(se+="==")}else if(G===2){const ee=y[oe+0],K=y[oe+1];se+=_[ee>>>2],se+=_[(ee<<4|K>>>4)&63],se+=_[K<<2&63],A&&(se+="=")}return se}e.$Ee=P}),define(be[17],ve([1,0,150,60]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function r(de){return!de||typeof de!="string"?!0:de.trim().length===0}e.$Ke=r;const I=/{(\d+)}/g;function D(de,...Pe){return Pe.length===0?de:de.replace(I,function(Ae,Te){const Fe=parseInt(Te,10);return isNaN(Fe)||Fe<0||Fe>=Pe.length?Ae:Pe[Fe]})}e.$Le=D;const S=/{([^}]+)}/g;function v(de,Pe){return Object.keys(Pe).length===0?de:de.replace(S,(Ae,Te)=>Pe[Te]??Ae)}e.$Me=v;function w(de){return de.replace(/[<>"'&]/g,Pe=>{switch(Pe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Pe})}e.$Ne=w;function C(de){return de.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}e.$Oe=C;function E(de){return de.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=E;function b(de,Pe){let Ae=0;const Te=Pe.charCodeAt(0);for(let Fe=de.length-1;Fe>=0;Fe--)de.charCodeAt(Fe)===Te&&Ae++;return Ae}e.$Qe=b;function h(de,Pe,Ae="\u2026"){return de.length<=Pe?de:`${de.substr(0,Pe)}${Ae}`}e.$Re=h;function $(de,Pe,Ae="\u2026"){if(de.length<=Pe)return de;const Te=Math.ceil(Pe/2)-Ae.length/2,Fe=Math.floor(Pe/2)-Ae.length/2;return`${de.substr(0,Te)}${Ae}${de.substr(de.length-Fe)}`}e.$Se=$;function c(de,Pe=" "){const Ae=g(de,Pe);return d(Ae,Pe)}e.$Te=c;function g(de,Pe){if(!de||!Pe)return de;const Ae=Pe.length;if(Ae===0||de.length===0)return de;let Te=0;for(;de.indexOf(Pe,Te)===Te;)Te=Te+Ae;return de.substring(Te)}e.$Ue=g;function d(de,Pe){if(!de||!Pe)return de;const Ae=Pe.length,Te=de.length;if(Ae===0||Te===0)return de;let Fe=Te,ze=-1;for(;ze=de.lastIndexOf(Pe,Fe-1),!(ze===-1||ze+Ae!==Fe);){if(ze===0)return"";Fe=ze}return de.substring(0,Fe)}e.$Ve=d;function m(de){return de.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=m;function f(de){return de.replace(/\*/g,"")}e.$Xe=f;function u(de,Pe,Ae={}){if(!de)throw new Error("Cannot create regex from empty string");Pe||(de=E(de)),Ae.wholeWord&&(/\B/.test(de.charAt(0))||(de="\\b"+de),/\B/.test(de.charAt(de.length-1))||(de=de+"\\b"));let Te="";return Ae.global&&(Te+="g"),Ae.matchCase||(Te+="i"),Ae.multiline&&(Te+="m"),Ae.unicode&&(Te+="u"),new RegExp(de,Te)}e.$Ye=u;function l(de){return de.source==="^"||de.source==="^$"||de.source==="$"||de.source==="^\\s*$"?!1:!!(de.exec("")&&de.lastIndex===0)}e.$Ze=l;function t(de){return de.split(/\r\n|\r|\n/)}e.$1e=t;function o(de){for(let Pe=0,Ae=de.length;Pe<Ae;Pe++){const Te=de.charCodeAt(Pe);if(Te!==32&&Te!==9)return Pe}return-1}e.$2e=o;function n(de,Pe=0,Ae=de.length){for(let Te=Pe;Te<Ae;Te++){const Fe=de.charCodeAt(Te);if(Fe!==32&&Fe!==9)return de.substring(Pe,Te)}return de.substring(Pe,Ae)}e.$3e=n;function s(de,Pe=de.length-1){for(let Ae=Pe;Ae>=0;Ae--){const Te=de.charCodeAt(Ae);if(Te!==32&&Te!==9)return Ae}return-1}e.$4e=s;function i(de,Pe,Ae){const Te=[];let Fe=0;for(const ze of de.matchAll(Pe)){if(Te.push(de.slice(Fe,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Fe=ze.index+ze[0].length,Te.push(Ae(ze[0],...ze.slice(1),ze.index,de,ze.groups))}return Te.push(de.slice(Fe)),Promise.all(Te).then(ze=>ze.join(""))}e.$5e=i;function a(de,Pe){return de<Pe?-1:de>Pe?1:0}e.$6e=a;function p(de,Pe,Ae=0,Te=de.length,Fe=0,ze=Pe.length){for(;Ae<Te&&Fe<ze;Ae++,Fe++){const Qe=de.charCodeAt(Ae),nt=Pe.charCodeAt(Fe);if(Qe<nt)return-1;if(Qe>nt)return 1}const Ve=Te-Ae,Ge=ze-Fe;return Ve<Ge?-1:Ve>Ge?1:0}e.$7e=p;function L(de,Pe){return P(de,Pe,0,de.length,0,Pe.length)}e.$8e=L;function P(de,Pe,Ae=0,Te=de.length,Fe=0,ze=Pe.length){for(;Ae<Te&&Fe<ze;Ae++,Fe++){let Qe=de.charCodeAt(Ae),nt=Pe.charCodeAt(Fe);if(Qe===nt)continue;if(Qe>=128||nt>=128)return p(de.toLowerCase(),Pe.toLowerCase(),Ae,Te,Fe,ze);A(Qe)&&(Qe-=32),A(nt)&&(nt-=32);const Ye=Qe-nt;if(Ye!==0)return Ye}const Ve=Te-Ae,Ge=ze-Fe;return Ve<Ge?-1:Ve>Ge?1:0}e.$9e=P;function y(de){return de>=48&&de<=57}e.$0e=y;function A(de){return de>=97&&de<=122}e.$$e=A;function M(de){return de>=65&&de<=90}e.$_e=M;function _(de,Pe){return de.length===Pe.length&&P(de,Pe)===0}e.$af=_;function se(de,Pe){const Ae=Pe.length;return Pe.length>de.length?!1:P(de,Pe,0,Ae)===0}e.$bf=se;function G(de,Pe){const Ae=Math.min(de.length,Pe.length);let Te;for(Te=0;Te<Ae;Te++)if(de.charCodeAt(Te)!==Pe.charCodeAt(Te))return Te;return Ae}e.$cf=G;function oe(de,Pe){const Ae=Math.min(de.length,Pe.length);let Te;const Fe=de.length-1,ze=Pe.length-1;for(Te=0;Te<Ae;Te++)if(de.charCodeAt(Fe-Te)!==Pe.charCodeAt(ze-Te))return Te;return Ae}e.$df=oe;function ee(de){return 55296<=de&&de<=56319}e.$ef=ee;function K(de){return 56320<=de&&de<=57343}e.$ff=K;function Z(de,Pe){return(de-55296<<10)+(Pe-56320)+65536}e.$gf=Z;function X(de,Pe,Ae){const Te=de.charCodeAt(Ae);if(ee(Te)&&Ae+1<Pe){const Fe=de.charCodeAt(Ae+1);if(K(Fe))return Z(Te,Fe)}return Te}e.$hf=X;function te(de,Pe){const Ae=de.charCodeAt(Pe-1);if(K(Ae)&&Pe>1){const Te=de.charCodeAt(Pe-2);if(ee(Te))return Z(Te,Ae)}return Ae}class V{get offset(){return this.e}constructor(Pe,Ae=0){this.c=Pe,this.d=Pe.length,this.e=Ae}setOffset(Pe){this.e=Pe}prevCodePoint(){const Pe=te(this.c,this.e);return this.e-=Pe>=65536?2:1,Pe}nextCodePoint(){const Pe=X(this.c,this.d,this.e);return this.e+=Pe>=65536?2:1,Pe}eol(){return this.e>=this.d}}e.$if=V;class W{get offset(){return this.c.offset}constructor(Pe,Ae=0){this.c=new V(Pe,Ae)}nextGraphemeLength(){const Pe=Me.getInstance(),Ae=this.c,Te=Ae.offset;let Fe=Pe.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const ze=Ae.offset,Ve=Pe.getGraphemeBreakType(Ae.nextCodePoint());if(De(Fe,Ve)){Ae.setOffset(ze);break}Fe=Ve}return Ae.offset-Te}prevGraphemeLength(){const Pe=Me.getInstance(),Ae=this.c,Te=Ae.offset;let Fe=Pe.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const ze=Ae.offset,Ve=Pe.getGraphemeBreakType(Ae.prevCodePoint());if(De(Ve,Fe)){Ae.setOffset(ze);break}Fe=Ve}return Te-Ae.offset}eol(){return this.c.eol()}}e.$jf=W;function re(de,Pe){return new W(de,Pe).nextGraphemeLength()}e.$kf=re;function ue(de,Pe){return new W(de,Pe).prevGraphemeLength()}e.$lf=ue;function ne(de,Pe){Pe>0&&K(de.charCodeAt(Pe))&&Pe--;const Ae=Pe+re(de,Pe);return[Ae-ue(de,Ae),Ae]}e.$mf=ne;function me(de){const Pe=new W(de);let Ae=0;for(;!Pe.eol();)Ae++,Pe.nextGraphemeLength();return Ae}e.$nf=me;let z;function H(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function R(de){return z||(z=H()),z.test(de)}e.$of=R;const U=/^[\t\n\r\x20-\x7E]*$/;function x(de){return U.test(de)}e.$pf=x,e.$qf=/[\u2028\u2029]/;function J(de){return e.$qf.test(de)}e.$rf=J;function Y(de){return de>=11904&&de<=55215||de>=63744&&de<=64255||de>=65281&&de<=65374}e.$sf=Y;function B(de){return de>=127462&&de<=127487||de===8986||de===8987||de===9200||de===9203||de>=9728&&de<=10175||de===11088||de===11093||de>=127744&&de<=128591||de>=128640&&de<=128764||de>=128992&&de<=129008||de>=129280&&de<=129535||de>=129648&&de<=129782}e.$tf=B;function T(de,Pe,Ae=""){const Te=de.trimStart();if(Te.length<Pe)return Te;const Fe=/\b/g;let ze=0;for(;Fe.test(Te)&&!(Te.length-Fe.lastIndex<Pe);)ze=Fe.lastIndex,Fe.lastIndex+=1;return ze===0?Te:Ae+Te.substring(ze).trimStart()}e.$uf=T;const N=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,q=/\x1b\].*?\x07/g;function ie(de){return de&&(de=de.replace(N,"").replace(q,"")),de}e.$vf=ie,e.$wf=String.fromCharCode(65279);function ae(de){return!!(de&&de.length>0&&de.charCodeAt(0)===65279)}e.$xf=ae;function ge(de){return ae(de)?de.substr(1):de}e.$yf=ge;function ce(de,Pe){if(!de||!Pe||de.length<Pe.length)return!1;const Ae=Pe.length,Te=de.toLowerCase();let Fe=0,ze=-1;for(;Fe<Ae;){const Ve=Te.indexOf(Pe[Fe],ze+1);if(Ve<0)return!1;ze=Ve,Fe++}return!0}e.$zf=ce;function pe(de,Pe=!1){return de?(Pe&&(de=de.replace(/\\./g,"")),de.toLowerCase()!==de):!1}e.$Af=pe;function ye(de){return de.charAt(0).toUpperCase()+de.slice(1)}e.$Bf=ye;function Ce(de,Pe=1){if(Pe===0)return"";let Ae=-1;do Ae=de.indexOf(`
`,Ae+1),Pe--;while(Pe>0&&Ae>=0);return Ae===-1?de:(de[Ae-1]==="\r"&&Ae--,de.substr(0,Ae))}e.$Cf=Ce;function Re(de){return de=de%(2*26),de<26?String.fromCharCode(97+de):String.fromCharCode(65+de-26)}e.$Df=Re;function $e(de){return Me.getInstance().getGraphemeBreakType(de)}e.$Ef=$e;function De(de,Pe){return de===0?Pe!==5&&Pe!==7:de===2&&Pe===3?!1:de===4||de===2||de===3||Pe===4||Pe===2||Pe===3?!0:!(de===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(de===11||de===9)&&(Pe===9||Pe===10)||(de===12||de===10)&&Pe===10||Pe===5||Pe===13||Pe===7||de===1||de===13&&Pe===14||de===6&&Pe===6)}var ke;(function(de){de[de.Other=0]="Other",de[de.Prepend=1]="Prepend",de[de.CR=2]="CR",de[de.LF=3]="LF",de[de.Control=4]="Control",de[de.Extend=5]="Extend",de[de.Regional_Indicator=6]="Regional_Indicator",de[de.SpacingMark=7]="SpacingMark",de[de.L=8]="L",de[de.V=9]="V",de[de.T=10]="T",de[de.LV=11]="LV",de[de.LVT=12]="LVT",de[de.ZWJ=13]="ZWJ",de[de.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(e.GraphemeBreakType=ke={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=je()}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const Ae=this.d,Te=Ae.length/3;let Fe=1;for(;Fe<=Te;)if(Pe<Ae[3*Fe])Fe=2*Fe;else if(Pe>Ae[3*Fe+1])Fe=2*Fe+1;else return Ae[3*Fe+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(de,Pe){if(de===0)return 0;const Ae=qe(de,Pe);if(Ae!==void 0)return Ae;const Te=new V(Pe,de);return Te.prevCodePoint(),Te.offset}e.$Ff=He;function qe(de,Pe){const Ae=new V(Pe,de);let Te=Ae.prevCodePoint();for(;Xe(Te)||Te===65039||Te===8419;){if(Ae.offset===0)return;Te=Ae.prevCodePoint()}if(!B(Te))return;let Fe=Ae.offset;return Fe>0&&Ae.prevCodePoint()===8205&&(Fe=Ae.offset),Fe}function Xe(de){return 127995<=de&&de<=127999}var Ze;(function(de){de[de.zwj=8205]="zwj",de[de.emojiVariantSelector=65039]="emojiVariantSelector",de[de.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.$Gf="\xA0";class xe{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$Ge(Pe=>{function Ae(Ye){const it=new Map;for(let rt=0;rt<Ye.length;rt+=2)it.set(Ye[rt],Ye[rt+1]);return it}function Te(Ye,it){const rt=new Map(Ye);for(const[ut,ct]of it)rt.set(ut,ct);return rt}function Fe(Ye,it){if(!Ye)return it;const rt=new Map;for(const[ut,ct]of Ye)it.has(ut)&&rt.set(ut,ct);return rt}const ze=this.c.value;let Ve=Pe.filter(Ye=>!Ye.startsWith("_")&&Ye in ze);Ve.length===0&&(Ve=["_default"]);let Ge;for(const Ye of Ve){const it=Ae(ze[Ye]);Ge=Fe(Ge,it)}const Qe=Ae(ze._common),nt=Te(Qe,Ge);return new xe(nt)})}static getInstance(Pe){return xe.d.get(Array.from(Pe))}static{this.e=new O.$V(()=>Object.keys(xe.c.value).filter(Pe=>!Pe.startsWith("_")))}static getLocales(){return xe.e.value}constructor(Pe){this.f=Pe}isAmbiguous(Pe){return this.f.has(Pe)}getPrimaryConfusable(Pe){return this.f.get(Pe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=xe;class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(Pe){return tt.e().has(Pe)}static get codePoints(){return tt.e()}}e.$If=tt}),define(be[151],ve([1,0,24,147,17]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.FuzzyScore=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.or=void 0;function I(...ce){return function(pe,ye){for(let Ce=0,Re=ce.length;Ce<Re;Ce++){const $e=ce[Ce](pe,ye);if($e)return $e}return null}}e.or=I,e.$Uj=D.bind(void 0,!1),e.$Vj=D.bind(void 0,!0);function D(ce,pe,ye){if(!ye||ye.length<pe.length)return null;let Ce;return ce?Ce=r.$bf(ye,pe):Ce=ye.indexOf(pe)===0,Ce?pe.length>0?[{start:0,end:pe.length}]:[]:null}function S(ce,pe){const ye=pe.toLowerCase().indexOf(ce.toLowerCase());return ye===-1?null:[{start:ye,end:ye+ce.length}]}e.$Wj=S;function v(ce,pe){return w(ce.toLowerCase(),pe.toLowerCase(),0,0)}e.$Xj=v;function w(ce,pe,ye,Ce){if(ye===ce.length)return[];if(Ce===pe.length)return null;if(ce[ye]===pe[Ce]){let Re=null;return(Re=w(ce,pe,ye+1,Ce+1))?u({start:Ce,end:Ce+1},Re):null}return w(ce,pe,ye,Ce+1)}function C(ce){return 97<=ce&&ce<=122}function E(ce){return 65<=ce&&ce<=90}e.$Yj=E;function b(ce){return 48<=ce&&ce<=57}function h(ce){return ce===32||ce===9||ce===10||ce===13}const $=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ce=>$.add(ce.charCodeAt(0)));function c(ce){return h(ce)||$.has(ce)}function g(ce,pe){return ce===pe||c(ce)&&c(pe)}const d=new Map;function m(ce){if(d.has(ce))return d.get(ce);let pe;const ye=(0,O.$Sj)(ce);return ye&&(pe=ye),d.set(ce,pe),pe}function f(ce){return C(ce)||E(ce)||b(ce)}function u(ce,pe){return pe.length===0?pe=[ce]:ce.end===pe[0].start?pe[0].start=ce.start:pe.unshift(ce),pe}function l(ce,pe){for(let ye=pe;ye<ce.length;ye++){const Ce=ce.charCodeAt(ye);if(E(Ce)||b(Ce)||ye>0&&!f(ce.charCodeAt(ye-1)))return ye}return ce.length}function t(ce,pe,ye,Ce){if(ye===ce.length)return[];if(Ce===pe.length)return null;if(ce[ye]!==pe[Ce].toLowerCase())return null;{let Re=null,$e=Ce+1;for(Re=t(ce,pe,ye+1,Ce+1);!Re&&($e=l(pe,$e))<pe.length;)Re=t(ce,pe,ye+1,$e),$e++;return Re===null?null:u({start:Ce,end:Ce+1},Re)}}function o(ce){let pe=0,ye=0,Ce=0,Re=0,$e=0;for(let He=0;He<ce.length;He++)$e=ce.charCodeAt(He),E($e)&&pe++,C($e)&&ye++,f($e)&&Ce++,b($e)&&Re++;const De=pe/ce.length,ke=ye/ce.length,Me=Ce/ce.length,je=Re/ce.length;return{upperPercent:De,lowerPercent:ke,alphaPercent:Me,numericPercent:je}}function n(ce){const{upperPercent:pe,lowerPercent:ye}=ce;return ye===0&&pe>.6}function s(ce){const{upperPercent:pe,lowerPercent:ye,alphaPercent:Ce,numericPercent:Re}=ce;return ye>.2&&pe<.8&&Ce>.6&&Re<.2}function i(ce){let pe=0,ye=0,Ce=0,Re=0;for(let $e=0;$e<ce.length;$e++)Ce=ce.charCodeAt($e),E(Ce)&&pe++,C(Ce)&&ye++,h(Ce)&&Re++;return(pe===0||ye===0)&&Re===0?ce.length<=30:pe<=5}function a(ce,pe){if(!pe||(pe=pe.trim(),pe.length===0)||!i(ce)||pe.length>60)return null;const ye=o(pe);if(!s(ye)){if(!n(ye))return null;pe=pe.toLowerCase()}let Ce=null,Re=0;for(ce=ce.toLowerCase();Re<pe.length&&(Ce=t(ce,pe,0,Re))===null;)Re=l(pe,Re+1);return Ce}e.$Zj=a;function p(ce,pe,ye=!1){if(!pe||pe.length===0)return null;let Ce=null,Re=0;for(ce=ce.toLowerCase(),pe=pe.toLowerCase();Re<pe.length&&(Ce=L(ce,pe,0,Re,ye),Ce===null);)Re=P(pe,Re+1);return Ce}e.$1j=p;function L(ce,pe,ye,Ce,Re){let $e=0;if(ye===ce.length)return[];if(Ce===pe.length)return null;if(!g(ce.charCodeAt(ye),pe.charCodeAt(Ce))){const Me=m(ce.charCodeAt(ye));if(!Me)return null;for(let je=0;je<Me.length;je++)if(!g(Me[je],pe.charCodeAt(Ce+je)))return null;$e+=Me.length-1}let De=null,ke=Ce+$e+1;if(De=L(ce,pe,ye+1,ke,Re),!Re)for(;!De&&(ke=P(pe,ke))<pe.length;)De=L(ce,pe,ye+1,ke,Re),ke++;if(!De)return null;if(ce.charCodeAt(ye)!==pe.charCodeAt(Ce)){const Me=m(ce.charCodeAt(ye));if(!Me)return De;for(let je=0;je<Me.length;je++)if(Me[je]!==pe.charCodeAt(Ce+je))return De}return u({start:Ce,end:Ce+$e+1},De)}function P(ce,pe){for(let ye=pe;ye<ce.length;ye++)if(c(ce.charCodeAt(ye))||ye>0&&c(ce.charCodeAt(ye-1)))return ye;return ce.length}const y=I(e.$Vj,a,S),A=I(e.$Vj,a,v),M=new k.$Dc(1e4);function _(ce,pe,ye=!1){if(typeof ce!="string"||typeof pe!="string")return null;let Ce=M.get(ce);Ce||(Ce=new RegExp(r.$We(ce),"i"),M.set(ce,Ce));const Re=Ce.exec(pe);return Re?[{start:Re.index,end:Re.index+Re[0].length}]:ye?A(ce,pe):y(ce,pe)}e.$2j=_;function se(ce,pe){const ye=B(ce,ce.toLowerCase(),0,pe,pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ye?oe(ye):null}e.$3j=se;function G(ce,pe,ye,Ce,Re,$e){const De=Math.min(13,ce.length);for(;ye<De;ye++){const ke=B(ce,pe,ye,Ce,Re,$e,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ke)return ke}return[0,$e]}e.$4j=G;function oe(ce){if(typeof ce>"u")return[];const pe=[],ye=ce[1];for(let Ce=ce.length-1;Ce>1;Ce--){const Re=ce[Ce]+ye,$e=pe[pe.length-1];$e&&$e.end===Re?$e.end=Re+1:pe.push({start:Re,end:Re+1})}return pe}e.$5j=oe;const ee=128;function K(){const ce=[],pe=[];for(let ye=0;ye<=ee;ye++)pe[ye]=0;for(let ye=0;ye<=ee;ye++)ce.push(pe.slice(0));return ce}function Z(ce){const pe=[];for(let ye=0;ye<=ce;ye++)pe[ye]=0;return pe}const X=Z(2*ee),te=Z(2*ee),V=K(),W=K(),re=K(),ue=!1;function ne(ce,pe,ye,Ce,Re){function $e(ke,Me,je=" "){for(;ke.length<Me;)ke=je+ke;return ke}let De=` |   |${Ce.split("").map(ke=>$e(ke,3)).join("|")}
`;for(let ke=0;ke<=ye;ke++)ke===0?De+=" |":De+=`${pe[ke-1]}|`,De+=ce[ke].slice(0,Re+1).map(Me=>$e(Me.toString(),3)).join("|")+`
`;return De}function me(ce,pe,ye,Ce){ce=ce.substr(pe),ye=ye.substr(Ce),console.log(ne(W,ce,ce.length,ye,ye.length)),console.log(ne(re,ce,ce.length,ye,ye.length)),console.log(ne(V,ce,ce.length,ye,ye.length))}function z(ce,pe){if(pe<0||pe>=ce.length)return!1;const ye=ce.codePointAt(pe);switch(ye){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!r.$tf(ye)}}function H(ce,pe){if(pe<0||pe>=ce.length)return!1;switch(ce.charCodeAt(pe)){case 32:case 9:return!0;default:return!1}}function R(ce,pe,ye){return pe[ce]!==ye[ce]}function U(ce,pe,ye,Ce,Re,$e,De=!1){for(;pe<ye&&Re<$e;)ce[pe]===Ce[Re]&&(De&&(X[pe]=Re),pe+=1),Re+=1;return pe===ye}e.$6j=U;var x;(function(ce){ce[ce.Diag=1]="Diag",ce[ce.Left=2]="Left",ce[ce.LeftLeft=3]="LeftLeft"})(x||(x={}));var J;(function(ce){ce.Default=[-100,0];function pe(ye){return!ye||ye.length===2&&ye[0]===-100&&ye[1]===0}ce.isDefault=pe})(J||(e.FuzzyScore=J={}));class Y{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(pe,ye){this.firstMatchCanBeWeak=pe,this.boostFullMatch=ye}}e.$7j=Y;function B(ce,pe,ye,Ce,Re,$e,De=Y.default){const ke=ce.length>ee?ee:ce.length,Me=Ce.length>ee?ee:Ce.length;if(ye>=ke||$e>=Me||ke-ye>Me-$e||!U(pe,ye,ke,Re,$e,Me,!0))return;T(ke,Me,ye,$e,pe,Re);let je=1,He=1,qe=ye,Xe=$e;const Ze=[!1];for(je=1,qe=ye;qe<ke;je++,qe++){const Ae=X[qe],Te=te[qe],Fe=qe+1<ke?te[qe+1]:Me;for(He=Ae-$e+1,Xe=Ae;Xe<Fe;He++,Xe++){let ze=Number.MIN_SAFE_INTEGER,Ve=!1;Xe<=Te&&(ze=N(ce,pe,qe,ye,Ce,Re,Xe,Me,$e,V[je-1][He-1]===0,Ze));let Ge=0;ze!==Number.MAX_SAFE_INTEGER&&(Ve=!0,Ge=ze+W[je-1][He-1]);const Qe=Xe>Ae,nt=Qe?W[je][He-1]+(V[je][He-1]>0?-5:0):0,Ye=Xe>Ae+1&&V[je][He-1]>0,it=Ye?W[je][He-2]+(V[je][He-2]>0?-5:0):0;if(Ye&&(!Qe||it>=nt)&&(!Ve||it>=Ge))W[je][He]=it,re[je][He]=3,V[je][He]=0;else if(Qe&&(!Ve||nt>=Ge))W[je][He]=nt,re[je][He]=2,V[je][He]=0;else if(Ve)W[je][He]=Ge,re[je][He]=1,V[je][He]=V[je-1][He-1]+1;else throw new Error("not possible")}}if(ue&&me(ce,ye,Ce,$e),!Ze[0]&&!De.firstMatchCanBeWeak)return;je--,He--;const xe=[W[je][He],$e];let tt=0,de=0;for(;je>=1;){let Ae=He;do{const Te=re[je][Ae];if(Te===3)Ae=Ae-2;else if(Te===2)Ae=Ae-1;else break}while(Ae>=1);tt>1&&pe[ye+je-1]===Re[$e+He-1]&&!R(Ae+$e-1,Ce,Re)&&tt+1>V[je][Ae]&&(Ae=He),Ae===He?tt++:tt=1,de||(de=Ae),je--,He=Ae-1,xe.push(He)}Me===ke&&De.boostFullMatch&&(xe[0]+=2);const Pe=de-ke;return xe[0]-=Pe,xe}e.$8j=B;function T(ce,pe,ye,Ce,Re,$e){let De=ce-1,ke=pe-1;for(;De>=ye&&ke>=Ce;)Re[De]===$e[ke]&&(te[De]=ke,De--),ke--}function N(ce,pe,ye,Ce,Re,$e,De,ke,Me,je,He){if(pe[ye]!==$e[De])return Number.MIN_SAFE_INTEGER;let qe=1,Xe=!1;return De===ye-Ce?qe=ce[ye]===Re[De]?7:5:R(De,Re,$e)&&(De===0||!R(De-1,Re,$e))?(qe=ce[ye]===Re[De]?7:5,Xe=!0):z($e,De)&&(De===0||!z($e,De-1))?qe=5:(z($e,De-1)||H($e,De-1))&&(qe=5,Xe=!0),qe>1&&ye===Ce&&(He[0]=!0),Xe||(Xe=R(De,Re,$e)||z($e,De-1)||H($e,De-1)),ye===Ce?De>Me&&(qe-=Xe?3:5):je?qe+=Xe?2:0:qe+=Xe?0:1,De+1===ke&&(qe-=Xe?3:5),qe}function q(ce,pe,ye,Ce,Re,$e,De){return ae(ce,pe,ye,Ce,Re,$e,!0,De)}e.$9j=q;function ie(ce,pe,ye,Ce,Re,$e,De){return ae(ce,pe,ye,Ce,Re,$e,!1,De)}e.$0j=ie;function ae(ce,pe,ye,Ce,Re,$e,De,ke){let Me=B(ce,pe,ye,Ce,Re,$e,ke);if(Me&&!De)return Me;if(ce.length>=3){const je=Math.min(7,ce.length-1);for(let He=ye+1;He<je;He++){const qe=ge(ce,He);if(qe){const Xe=B(qe,qe.toLowerCase(),ye,Ce,Re,$e,ke);Xe&&(Xe[0]-=3,(!Me||Xe[0]>Me[0])&&(Me=Xe))}}}return Me}function ge(ce,pe){if(pe+1>=ce.length)return;const ye=ce[pe],Ce=ce[pe+1];if(ye!==Ce)return ce.slice(0,pe)+Ce+ye+ce.slice(pe+2)}}),define(be[62],ve([1,0,17]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=void 0;function O(d){return r(d,0)}e.$Ui=O;function r(d,m){switch(typeof d){case"object":return d===null?I(349,m):Array.isArray(d)?v(d,m):w(d,m);case"string":return S(d,m);case"boolean":return D(d,m);case"number":return I(d,m);case"undefined":return I(937,m);default:return I(617,m)}}e.$Vi=r;function I(d,m){return(m<<5)-m+d|0}e.$Wi=I;function D(d,m){return I(d?433:863,m)}function S(d,m){m=I(149417,m);for(let f=0,u=d.length;f<u;f++)m=I(d.charCodeAt(f),m);return m}e.$Xi=S;function v(d,m){return m=I(104579,m),d.reduce((f,u)=>r(u,f),m)}function w(d,m){return m=I(181387,m),Object.keys(d).sort().reduce((f,u)=>(f=S(u,f),r(d[u],f)),m)}class C{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=r(m,this.g),this.g}}e.$Yi=C;var E;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(d,m,f=32){const u=f-m,l=~((1<<u)-1);return(d<<m|(l&d)>>>u)>>>0}function h(d,m=0,f=d.byteLength,u=0){for(let l=0;l<f;l++)d[m+l]=u}function $(d,m,f="0"){for(;d.length<m;)d=f+d;return d}function c(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(f=>f.toString(16).padStart(2,"0")).join(""):$((d>>>0).toString(16),m/4)}e.$Zi=c;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const f=m.length;if(f===0)return;const u=this.p;let l=this.r,t=this.u,o,n;for(t!==0?(o=t,n=-1,t=0):(o=m.charCodeAt(0),n=0);;){let s=o;if(k.$ef(o))if(n+1<f){const i=m.charCodeAt(n+1);k.$ff(i)?(n++,s=k.$gf(o,i)):s=65533}else{t=o;break}else k.$ff(o)&&(s=65533);if(l=this.w(u,l,s),n++,n<f)o=m.charCodeAt(n);else break}this.r=l,this.u=t}w(m,f,u){return u<128?m[f++]=u:u<2048?(m[f++]=192|(u&1984)>>>6,m[f++]=128|(u&63)>>>0):u<65536?(m[f++]=224|(u&61440)>>>12,m[f++]=128|(u&4032)>>>6,m[f++]=128|(u&63)>>>0):(m[f++]=240|(u&1835008)>>>18,m[f++]=128|(u&258048)>>>12,m[f++]=128|(u&4032)>>>6,m[f++]=128|(u&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=g.g,f=this.q;for(let p=0;p<64;p+=4)m.setUint32(p,f.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)m.setUint32(p,b(m.getUint32(p-12,!1)^m.getUint32(p-32,!1)^m.getUint32(p-56,!1)^m.getUint32(p-64,!1),1),!1);let u=this.h,l=this.l,t=this.m,o=this.n,n=this.o,s,i,a;for(let p=0;p<80;p++)p<20?(s=l&t|~l&o,i=1518500249):p<40?(s=l^t^o,i=1859775393):p<60?(s=l&t|l&o|t&o,i=2400959708):(s=l^t^o,i=3395469782),a=b(u,5)+s+n+i+m.getUint32(p*4,!1)&4294967295,n=o,o=t,t=b(l,30),l=u,u=a;this.h=this.h+u&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$1i=g}),define(be[63],ve([1,0,17]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(O||(O={})),function(r){const I="error",D="warning",S="warn",v="info",w="ignore";function C(b){return b?k.$af(I,b)?r.Error:k.$af(D,b)||k.$af(S,b)?r.Warning:k.$af(v,b)?r.Info:r.Ignore:r.Ignore}r.fromValue=C;function E(b){switch(b){case r.Error:return I;case r.Warning:return D;case r.Info:return v;default:return w}}r.toString=E}(O||(O={})),e.default=O}),define(be[152],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(be[64],ve([1,0,18,17]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0;class r{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const $=h.charCodeAt(0),c=this.b.charCodeAt(this.c);return $-c}value(){return this.b[this.c]}}e.$9h=r;class I{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,O.$7e)(h,this.b,0,h.length,this.c,this.d):(0,O.$9e)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$0h=I;class D{constructor(h=!0,$=!0){this.f=h,this.g=$}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let $=h.length-1;$>=0;$--,this.c--){const c=this.b.charCodeAt($);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,O.$7e)(h,this.b,0,h.length,this.d,this.e):(0,O.$9e)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$$h=D;var S;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(S||(S={}));class v{constructor(h,$){this.f=h,this.g=$,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,O.$8e)(h,this.c.scheme);if(this.d[this.e]===2)return(0,O.$8e)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,O.$6e)(h,this.c.query);if(this.d[this.e]===5)return(0,O.$6e)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$_h=v;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(C||(C={}));class E{static forUris(h=()=>!1,$=()=>!1){return new E(new v(h,$))}static forPaths(h=!1){return new E(new D(void 0,!h))}static forStrings(){return new E(new r)}static forConfigKeys(){return new E(new I)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,$){if($){const c=$.slice(0);(0,k.$Xb)(c);for(const g of c)this.set(g,h)}else{const c=h.slice(0);(0,k.$Xb)(c);for(const g of c)this.set(g[0],g[1])}}set(h,$){const c=this.b.reset(h);let g;this.c||(this.c=new w,this.c.segment=c.value());const d=[];for(g=this.c;;){const f=c.cmp(g.segment);if(f>0)g.left||(g.left=new w,g.left.segment=c.value()),d.push([-1,g]),g=g.left;else if(f<0)g.right||(g.right=new w,g.right.segment=c.value()),d.push([1,g]),g=g.right;else if(c.hasNext())c.next(),g.mid||(g.mid=new w,g.mid.segment=c.value()),d.push([0,g]),g=g.mid;else break}const m=g.value;g.value=$,g.key=h;for(let f=d.length-1;f>=0;f--){const u=d[f][1];u.updateHeight();const l=u.balanceFactor();if(l<-1||l>1){const t=d[f][0],o=d[f+1][0];if(t===1&&o===1)d[f][1]=u.rotateLeft();else if(t===-1&&o===-1)d[f][1]=u.rotateRight();else if(t===1&&o===-1)u.right=d[f+1][1]=d[f+1][1].rotateRight(),d[f][1]=u.rotateLeft();else if(t===-1&&o===1)u.left=d[f+1][1]=d[f+1][1].rotateLeft(),d[f][1]=u.rotateRight();else throw new Error;if(f>0)switch(d[f-1][0]){case-1:d[f-1][1].left=d[f][1];break;case 1:d[f-1][1].right=d[f][1];break;case 0:d[f-1][1].mid=d[f][1];break}else this.c=d[0][1]}}return m}get(h){return this.d(h)?.value}d(h){const $=this.b.reset(h);let c=this.c;for(;c;){const g=$.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if($.hasNext())$.next(),c=c.mid;else break}return c}has(h){const $=this.d(h);return!($?.value===void 0&&$?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,$){const c=this.b.reset(h),g=[];let d=this.c;for(;d;){const m=c.cmp(d.segment);if(m>0)g.push([-1,d]),d=d.left;else if(m<0)g.push([1,d]),d=d.right;else if(c.hasNext())c.next(),g.push([0,d]),d=d.mid;else break}if(d){if($?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const m=this.f(d.right);if(m.key){const{key:f,value:u,segment:l}=m;this.e(m.key,!1),d.key=f,d.value=u,d.segment=l}}else{const m=d.left??d.right;if(g.length>0){const[f,u]=g[g.length-1];switch(f){case-1:u.left=m;break;case 0:u.mid=m;break;case 1:u.right=m;break}}else this.c=m}for(let m=g.length-1;m>=0;m--){const f=g[m][1];f.updateHeight();const u=f.balanceFactor();if(u>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),g[m][1]=f.rotateLeft()):u<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),g[m][1]=f.rotateRight()),m>0)switch(g[m-1][0]){case-1:g[m-1][1].left=g[m][1];break;case 1:g[m-1][1].right=g[m][1];break;case 0:g[m-1][1].mid=g[m][1];break}else this.c=g[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const $=this.b.reset(h);let c=this.c,g;for(;c;){const d=$.cmp(c.segment);if(d>0)c=c.left;else if(d<0)c=c.right;else if($.hasNext())$.next(),g=c.value||g,c=c.mid;else break}return c&&c.value||g}findSuperstr(h){return this.g(h,!1)}g(h,$){const c=this.b.reset(h);let g=this.c;for(;g;){const d=c.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else return g.mid?this.h(g.mid):$?g.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[$,c]of this)h(c,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const $=[];return this.j(h,$),$[Symbol.iterator]()}j(h,$){h&&(h.left&&this.j(h.left,$),h.value&&$.push([h.key,h.value]),h.mid&&this.j(h.mid,$),h.right&&this.j(h.right,$))}_isBalanced(){const h=$=>{if(!$)return!0;const c=$.balanceFactor();return c<-1||c>1?!1:h($.left)&&h($.right)};return h(this.c)}}e.$ai=E}),define(be[11],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function k(l){return typeof l=="string"}e.$Jf=k;function O(l){return Array.isArray(l)&&l.every(t=>k(t))}e.$Kf=O;function r(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.$Lf=r;function I(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}e.$Mf=I;function D(l){return typeof l=="number"&&!isNaN(l)}e.$Nf=D;function S(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.$Of=S;function v(l){return l===!0||l===!1}e.$Pf=v;function w(l){return typeof l>"u"}e.$Qf=w;function C(l){return!E(l)}e.$Rf=C;function E(l){return w(l)||l===null}e.$Sf=E;function b(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Tf=b;function h(l){if(E(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.$Uf=h;function $(...l){const t=[];for(let o=0;o<l.length;o++){const n=l[o];if(E(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(n)}return t}e.$Vf=$;const c=Object.prototype.hasOwnProperty;function g(l){if(!r(l))return!1;for(const t in l)if(c.call(l,t))return!1;return!0}e.$Wf=g;function d(l){return typeof l=="function"}e.$Xf=d;function m(...l){return l.length>0&&l.every(d)}e.$Yf=m;function f(l,t){const o=Math.min(l.length,t.length);for(let n=0;n<o;n++)u(l[n],t[n])}e.$Zf=f;function u(l,t){if(k(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(d(t)){try{if(l instanceof t)return}catch{}if(!E(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=u}),define(be[51],ve([1,0,11]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=e.$_j=e.$$j=void 0;const O=Object.create(null);function r(S,v){if((0,k.$Jf)(v)){const w=O[v];if(w===void 0)throw new Error(`${S} references an unknown codicon: ${v}`);v=w}return O[S]=v,{id:S}}function I(){return O}e.$$j=I;function D(){return Object.values(e.$ak)}e.$_j=D,e.$ak={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugBreakpointPending:r("debug-breakpoint-pending",60377),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),gitStash:r("git-stash",60454),gitStashApply:r("git-stash-apply",60455),gitStashPop:r("git-stash-pop",60456),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(be[21],ve([1,0,11]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=void 0;function O(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([f,u])=>{m[f]=u&&typeof u=="object"?O(u):u}),m}e.$wn=O;function r(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const f=m.shift();Object.freeze(f);for(const u in f)if(I.call(f,u)){const l=f[u];typeof l=="object"&&!Object.isFrozen(l)&&!(0,k.$Mf)(l)&&m.push(l)}}return d}e.$xn=r;const I=Object.prototype.hasOwnProperty;function D(d,m){return S(d,m,new Set)}e.$yn=D;function S(d,m,f){if((0,k.$Sf)(d))return d;const u=m(d);if(typeof u<"u")return u;if(Array.isArray(d)){const l=[];for(const t of d)l.push(S(t,m,f));return l}if((0,k.$Lf)(d)){if(f.has(d))throw new Error("Cannot clone recursive data-structure");f.add(d);const l={};for(const t in d)I.call(d,t)&&(l[t]=S(d[t],m,f));return f.delete(d),l}return d}function v(d,m,f=!0){return(0,k.$Lf)(d)?((0,k.$Lf)(m)&&Object.keys(m).forEach(u=>{u in d?f&&((0,k.$Lf)(d[u])&&(0,k.$Lf)(m[u])?v(d[u],m[u],f):d[u]=m[u]):d[u]=m[u]}),d):m}e.$zn=v;function w(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let f,u;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(f=0;f<d.length;f++)if(!w(d[f],m[f]))return!1}else{const l=[];for(u in d)l.push(u);l.sort();const t=[];for(u in m)t.push(u);if(t.sort(),!w(l,t))return!1;for(f=0;f<l.length;f++)if(!w(d[l[f]],m[l[f]]))return!1}return!0}e.$An=w;function C(d){const m=new Set;return JSON.stringify(d,(f,u)=>{if((0,k.$Lf)(u)||Array.isArray(u)){if(m.has(u))return"[Circular]";m.add(u)}return u})}e.$Bn=C;function E(d,m){const f=Object.create(null);return!d||!m||Object.keys(m).forEach(l=>{const t=d[l],o=m[l];w(t,o)||(f[l]=o)}),f}e.$Cn=E;function b(d,m){const f=m.toLowerCase(),u=Object.keys(d).find(l=>l.toLowerCase()===f);return u?d[u]:d[m]}e.$Dn=b;function h(d,m){const f=Object.create(null);for(const[u,l]of Object.entries(d))m(u,l)&&(f[u]=l);return f}e.$En=h;function $(d){let m=[];for(;Object.prototype!==d;)m=m.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return m}e.$Fn=$;function c(d){const m=[];for(const f of $(d))typeof d[f]=="function"&&m.push(f);return m}e.$Gn=c;function g(d,m){const f=l=>function(){const t=Array.prototype.slice.call(arguments,0);return m(l,t)},u={};for(const l of d)u[l]=f(l);return u}e.$Hn=g}),define(be[99],ve([1,0,51]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$bk=e.ThemeColor=void 0;var O;(function(D){function S(v){return v&&typeof v=="object"&&typeof v.id=="string"}D.isThemeColor=S})(O||(e.ThemeColor=O={}));function r(D){return{id:D}}e.$bk=r;var I;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function v(m){const f=S.exec(m.id);if(!f)return v(k.$ak.error);const[,u,l]=f,t=["codicon","codicon-"+u];return l&&t.push("codicon-modifier-"+l.substring(1)),t}D.asClassNameArray=v;function w(m){return v(m).join(" ")}D.asClassName=w;function C(m){return"."+v(m).join(".")}D.asCSSSelector=C;function E(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||O.isThemeColor(m.color))}D.isThemeIcon=E;const b=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function h(m){const f=b.exec(m);if(!f)return;const[,u]=f;return{id:u}}D.fromString=h;function $(m){return{id:m}}D.fromId=$;function c(m,f){let u=m.id;const l=u.lastIndexOf("~");return l!==-1&&(u=u.substring(0,l)),f&&(u=`${u}~${f}`),{id:u}}D.modify=c;function g(m){const f=m.id.lastIndexOf("~");if(f!==-1)return m.id.substring(f+1)}D.getModifier=g;function d(m,f){return m.id===f.id&&m.color?.id===f.color?.id}D.isEqual=d})(I||(e.ThemeIcon=I={}))}),define(be[153],ve([1,0,151,17,99]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=void 0;const I="$(",D=new RegExp(`\\$\\(${r.ThemeIcon.iconNameExpression}(?:${r.ThemeIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${D.source}`,"g");function v(d){return d.replace(S,(m,f)=>f?m:`\\${m}`)}e.$ck=v;const w=new RegExp(`\\\\${D.source}`,"g");function C(d){return d.replace(w,m=>`\\${m}`)}e.$dk=C;const E=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function b(d){return d.indexOf(I)===-1?d:d.replace(E,(m,f,u,l)=>u?m:f||l||"")}e.$ek=b;function h(d){return d?d.replace(/\$\((.*?)\)/g,(m,f)=>` ${f} `).trim():""}e.$fk=h;const $=new RegExp(`\\$\\(${r.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(d){$.lastIndex=0;let m="";const f=[];let u=0;for(;;){const l=$.lastIndex,t=$.exec(d),o=d.substring(l,t?.index);if(o.length>0){m+=o;for(let n=0;n<o.length;n++)f.push(u)}if(!t)break;u+=t[0].length}return{text:m,iconOffsets:f}}e.$gk=c;function g(d,m,f=!1){const{text:u,iconOffsets:l}=m;if(!l||l.length===0)return(0,k.$2j)(d,u,f);const t=(0,O.$Ue)(u," "),o=u.length-t.length,n=(0,k.$2j)(d,t,f);if(n)for(const s of n){const i=l[s.start+o]+o;s.start+=i,s.end+=i}return n}e.$hk=g}),define(be[22],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(r){return k.test(r)}e.$qg=O,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(S){for(let v=0;v<S.length;v++)S[v]=Math.floor(Math.random()*256);return S};const I=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){r(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let v=0,w="";return w+=D[I[v++]],w+=D[I[v++]],w+=D[I[v++]],w+=D[I[v++]],w+="-",w+=D[I[v++]],w+=D[I[v++]],w+="-",w+=D[I[v++]],w+=D[I[v++]],w+="-",w+=D[I[v++]],w+=D[I[v++]],w+="-",w+=D[I[v++]],w+=D[I[v++]],w+=D[I[v++]],w+=D[I[v++]],w+=D[I[v++]],w+=D[I[v++]],w}}()}),define(be[154],ve([1,0,18,49,22]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$rt=e.$qt=e.$pt=e.$ot=void 0;function I(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.$ot=I;function D(E,b,h){const $={id:(0,r.$rg)(),name:E,uri:b,data:h};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$pt=D;class S{constructor(){this.a=new Map}get size(){let b=0;for(const h of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const h=[...this.a.keys()];return O.Iterable.some(this,([$,c])=>c.asFile())&&h.push("files"),C(v(b),h)}get(b){return this.a.get(this.b(b))?.[0]}append(b,h){const $=this.a.get(b);$?$.push(h):this.a.set(this.b(b),[h])}replace(b,h){this.a.set(this.b(b),[h])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,h]of this.a)for(const $ of h)yield[b,$]}b(b){return v(b)}}e.$qt=S;function v(E){return E.toLowerCase()}function w(E,b){return C(v(E),b.map(v))}e.$rt=w;function C(E,b){if(E==="*/*")return b.length>0;if(b.includes(E))return!0;const h=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!h)return!1;const[$,c,g]=h;return g==="*"?b.some(d=>d.startsWith(c+"/")):!1}e.$st=Object.freeze({create:E=>(0,k.$Mb)(E.map(b=>b.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$st.split(E).filter(b=>!b.startsWith("#"))})}),function(){"use strict";function he(e,k,O){function r(h){return new Promise($=>k.exists(h,$))}function I(h){return new Promise(($,c)=>{const g=new Date;k.utimes(h,g,g,d=>d?c(d):$())})}function D(h){return new Promise(($,c)=>k.mkdir(h,{recursive:!0},g=>g&&g.code!=="EEXIST"?c(g):$(h)))}function S(h){return new Promise(($,c)=>k.rm(h,{recursive:!0,force:!0,maxRetries:3},g=>g?c(g):$()))}function v(h){return new Promise(($,c)=>k.readFile(h,"utf8",(g,d)=>g?c(g):$(d)))}function w(h,$){return new Promise((c,g)=>k.writeFile(h,$,"utf8",d=>d?g(d):c()))}async function C(h){const $=e.join(h,"languagepacks.json");try{return JSON.parse(await v($))}catch{}}function E(h,$){try{for(;$;){if(h[$])return $;{const c=$.lastIndexOf("-");if(c>0)$=$.substring(0,c);else return}}}catch(c){console.error("Resolving language pack configuration failed.",c)}}function b(h,$,c,g,d){const m=function(u){return O.mark("code/didGenerateNls"),Promise.resolve({locale:u,osLocale:d,availableLanguages:{}})};if(O.mark("code/willGenerateNls"),g==="pseudo")return Promise.resolve({locale:g,osLocale:d,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:g,osLocale:d,availableLanguages:{}});if(g&&(g==="en"||g==="en-us"))return Promise.resolve({locale:g,osLocale:d,availableLanguages:{}});const f=g;try{return h?C($).then(u=>{if(!u)return m(f);const l=E(u,g);if(!l)return m(f);g=l;const t=u[g];let o;return!t||typeof t.hash!="string"||!t.translations||typeof(o=t.translations.vscode)!="string"?m(f):r(o).then(n=>{if(!n)return m(f);const s=t.hash+"."+g,i=e.join($,"clp",s),a=e.join(i,h),p=e.join(i,"tcf.json"),L=e.join(i,"corrupted.info"),P={locale:f,osLocale:d,availableLanguages:{"*":g},_languagePackId:s,_translationsConfigFile:p,_cacheRoot:i,_resolvedLanguagePackCoreLocation:a,_corruptedFile:L};return r(L).then(y=>{let A;return y?A=S(i):A=Promise.resolve(void 0),A.then(()=>r(a).then(M=>M?(I(a).catch(()=>{}),O.mark("code/didGenerateNls"),P):D(a).then(()=>Promise.all([v(c),v(o)])).then(_=>{const se=JSON.parse(_[0]),G=JSON.parse(_[1]).contents,oe=Object.keys(se.bundles),ee=[];for(const K of oe){const Z=se.bundles[K],X=Object.create(null);for(const te of Z){const V=se.keys[te],W=se.messages[te],re=G[te];let ue;if(re){ue=[];for(let ne=0;ne<V.length;ne++){const me=V[ne],z=typeof me=="string"?me:me.key;let H=re[z];H===void 0&&(H=W[ne]),ue.push(H)}}else ue=W;X[te]=ue}ee.push(w(e.join(a,K.replace(/\//g,"!")+".nls.json"),JSON.stringify(X)))}return ee.push(w(p,JSON.stringify(t.translations))),Promise.all(ee)}).then(()=>(O.mark("code/didGenerateNls"),P)).catch(_=>(console.error("Generating translation files failed.",_),m(g)))))})})}):m(f)}catch(u){return console.error("Generating translation files failed.",u),m(g)}}return{getNLSConfiguration:b}}if(typeof define=="function")define(be[155],ve([77,27,42]),function(e,k,O){return he(e,k,O)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("fs"),O=require("../common/performance");module.exports=he(e,k,O)}else throw new Error("Unknown context")}(),define(be[156],ve([1,0,28]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(D){const S=D.replace(/\-/g,":").toLowerCase();return!O.has(S)}function I(){const D=(0,k.networkInterfaces)();for(const S in D){const v=D[S];if(v){for(const{mac:w}of v)if(r(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$0m=I}),define(be[157],ve([1,0,78]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=e.$ug=e.$tg=void 0;function O(S,v,w,C=1){let E=!1;return new Promise(b=>{const h=setTimeout(()=>{if(!E)return E=!0,b(0)},w);r(S,v,C,$=>{if(!E)return E=!0,clearTimeout(h),b($)})})}e.$tg=O;function r(S,v,w,C){if(v===0)return C(0);const E=new k.Socket;E.once("connect",()=>(D(E),r(S+w,v-1,w,C))),E.once("data",()=>{}),E.once("error",b=>(D(E),b.code!=="ECONNREFUSED"?r(S+w,v-1,w,C):C(S))),E.connect(S,"127.0.0.1")}e.$ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(S,v,w,C="127.0.0.1"){let E=!1,b,h=1;const $=k.createServer({pauseOnConnect:!0});function c(g,d){E||(E=!0,$.removeAllListeners(),$.close(),b&&clearTimeout(b),d(g))}return new Promise(g=>{b=setTimeout(()=>{c(0,g)},w),$.on("listening",()=>{c(S,g)}),$.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&h<v?(S++,h++,$.listen(S,C)):c(0,g)}),$.on("close",()=>{c(0,g)}),$.listen(S,C)})}e.$vg=I;function D(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(v){console.error(v)}}}),function(){function he(){function e(){return process.uncHostAllowlist}function k(v){const w=new Set;if(Array.isArray(v))for(const C of v)typeof C=="string"&&w.add(C);return Array.from(w)}function O(){const v=e();return v?Array.from(v):[]}function r(v){if(process.platform!=="win32")return;const w=e();if(w)if(typeof v=="string")w.add(v.toLowerCase());else for(const C of k(v))r(C)}function I(v){if(typeof v!="string")return;const w=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let C;for(const E of w){if(v.indexOf(E)!==0)continue;const h=v.indexOf("\\",E.length);if(h===-1)continue;const $=v.substring(E.length,h);if($){C=$;break}}return C}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:r,getUNCHost:I,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return he()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=he():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(be[79],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class k{constructor(r,I){this.lineNumber=r,this.column=I}with(r=this.lineNumber,I=this.column){return r===this.lineNumber&&I===this.column?this:new k(r,I)}delta(r=0,I=0){return this.with(this.lineNumber+r,this.column+I)}equals(r){return k.equals(this,r)}static equals(r,I){return!r&&!I?!0:!!r&&!!I&&r.lineNumber===I.lineNumber&&r.column===I.column}isBefore(r){return k.isBefore(this,r)}static isBefore(r,I){return r.lineNumber<I.lineNumber?!0:I.lineNumber<r.lineNumber?!1:r.column<I.column}isBeforeOrEqual(r){return k.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,I){return r.lineNumber<I.lineNumber?!0:I.lineNumber<r.lineNumber?!1:r.column<=I.column}static compare(r,I){const D=r.lineNumber|0,S=I.lineNumber|0;if(D===S){const v=r.column|0,w=I.column|0;return v-w}return D-S}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new k(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Us=k}),define(be[43],ve([1,0,79]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class O{constructor(I,D,S,v){I>S||I===S&&D>v?(this.startLineNumber=S,this.startColumn=v,this.endLineNumber=I,this.endColumn=D):(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=S,this.endColumn=v)}isEmpty(){return O.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return O.containsPosition(this,I)}static containsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<I.startColumn||D.lineNumber===I.endLineNumber&&D.column>I.endColumn)}static strictContainsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<=I.startColumn||D.lineNumber===I.endLineNumber&&D.column>=I.endColumn)}containsRange(I){return O.containsRange(this,I)}static containsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>I.endColumn)}strictContainsRange(I){return O.strictContainsRange(this,I)}static strictContainsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<=I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>=I.endColumn)}plusRange(I){return O.plusRange(this,I)}static plusRange(I,D){let S,v,w,C;return D.startLineNumber<I.startLineNumber?(S=D.startLineNumber,v=D.startColumn):D.startLineNumber===I.startLineNumber?(S=D.startLineNumber,v=Math.min(D.startColumn,I.startColumn)):(S=I.startLineNumber,v=I.startColumn),D.endLineNumber>I.endLineNumber?(w=D.endLineNumber,C=D.endColumn):D.endLineNumber===I.endLineNumber?(w=D.endLineNumber,C=Math.max(D.endColumn,I.endColumn)):(w=I.endLineNumber,C=I.endColumn),new O(S,v,w,C)}intersectRanges(I){return O.intersectRanges(this,I)}static intersectRanges(I,D){let S=I.startLineNumber,v=I.startColumn,w=I.endLineNumber,C=I.endColumn;const E=D.startLineNumber,b=D.startColumn,h=D.endLineNumber,$=D.endColumn;return S<E?(S=E,v=b):S===E&&(v=Math.max(v,b)),w>h?(w=h,C=$):w===h&&(C=Math.min(C,$)),S>w||S===w&&v>C?null:new O(S,v,w,C)}equalsRange(I){return O.equalsRange(this,I)}static equalsRange(I,D){return!I&&!D?!0:!!I&&!!D&&I.startLineNumber===D.startLineNumber&&I.startColumn===D.startColumn&&I.endLineNumber===D.endLineNumber&&I.endColumn===D.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(I){return new k.$Us(I.endLineNumber,I.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(I){return new k.$Us(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,D){return new O(this.startLineNumber,this.startColumn,I,D)}setStartPosition(I,D){return new O(I,D,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(I){return new O(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(I){return new O(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new O(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,D=I){return new O(I.lineNumber,I.column,D.lineNumber,D.column)}static lift(I){return I?new O(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn)}static areIntersecting(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,D){if(I&&D){const w=I.startLineNumber|0,C=D.startLineNumber|0;if(w===C){const E=I.startColumn|0,b=D.startColumn|0;if(E===b){const h=I.endLineNumber|0,$=D.endLineNumber|0;if(h===$){const c=I.endColumn|0,g=D.endColumn|0;return c-g}return h-$}return E-b}return w-C}return(I?1:0)-(D?1:0)}static compareRangesUsingEnds(I,D){return I.endLineNumber===D.endLineNumber?I.endColumn===D.endColumn?I.startLineNumber===D.startLineNumber?I.startColumn-D.startColumn:I.startLineNumber-D.startLineNumber:I.endColumn-D.endColumn:I.endLineNumber-D.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Vs=O}),define(be[158],ve([1,0,43]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class O{static insert(I,D){return{range:new k.$Vs(I.lineNumber,I.column,I.lineNumber,I.column),text:D,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,D){return{range:I,text:D}}static replaceMove(I,D){return{range:I,text:D,forceMoveMarkers:!0}}}e.$Ws=O}),define(be[159],ve([1,0,6,2]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new k.$Wd,this.onDidChange=this.c.event,this.d=null}handleChange(S){this.c.fire({changedLanguages:S,changedColorMap:!1})}register(S,v){return this.a.set(S,v),this.handleChange([S]),(0,O.$Rc)(()=>{this.a.get(S)===v&&(this.a.delete(S),this.handleChange([S]))})}get(S){return this.a.get(S)||null}registerFactory(S,v){this.b.get(S)?.dispose();const w=new I(this,S,v);return this.b.set(S,w),(0,O.$Rc)(()=>{const C=this.b.get(S);!C||C!==w||(this.b.delete(S),C.dispose())})}async getOrCreate(S){const v=this.get(S);if(v)return v;const w=this.b.get(S);return!w||w.isResolved?null:(await w.resolve(),this.get(S))}isResolved(S){if(this.get(S))return!0;const w=this.b.get(S);return!!(!w||w.isResolved)}setColorMap(S){this.d=S,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ut=r;class I extends O.$Tc{get isResolved(){return this.c}constructor(S,v,w){super(),this.f=S,this.g=v,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const S=await this.h.tokenizationSupport;this.c=!0,S&&!this.a&&this.B(this.f.register(this.g,S))}}}),define(be[160],ve([8,9]),function(he,e){return he.create("vs/base/common/actions",e)}),define(be[161],ve([1,0,6,2,160]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=void 0;class I extends O.$Tc{constructor(b,h="",$="",c=!0,g){super(),this.h=this.B(new k.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=h,this.u=$,this.w=c,this.C=g}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,h){this.C&&await this.C(b)}}e.$Li=I;class D extends O.$Tc{constructor(){super(...arguments),this.f=this.B(new k.$Wd),this.onWillRun=this.f.event,this.m=this.B(new k.$Wd),this.onDidRun=this.m.event}async run(b,h){if(!b.enabled)return;this.f.fire({action:b});let $;try{await this.u(b,h)}catch(c){$=c}this.m.fire({action:b,error:$})}async u(b,h){await b.run(h)}}e.$Mi=D;class S{constructor(){this.id=S.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let h=[];for(const $ of b)$.length&&(h.length?h=[...h,new S,...$]:h=$);return h}static{this.ID="vs.actions.separator"}async run(){}}e.$Ni=S;class v{get actions(){return this.a}constructor(b,h,$,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=h,this.class=c,this.a=$}async run(){}}e.$Oi=v;class w extends I{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,r.localize(0,null),void 0,!1)}}e.$Pi=w;function C(E){return{id:E.id,label:E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked??!1,run:async(...b)=>E.run(...b),tooltip:E.label}}e.$Qi=C}),define(be[162],ve([8,9]),function(he,e){return he.create("vs/base/common/date",e)}),define(be[163],ve([1,0,162]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=void 0;const O=60,r=O*60,I=r*24,D=I*7,S=I*30,v=I*365;function w(E,b,h,$){typeof E!="number"&&(E=E.getTime());const c=Math.round((new Date().getTime()-E)/1e3);if(c<-30)return(0,k.localize)(0,null,w(new Date().getTime()+c*1e3,!1));if(!$&&c<30)return(0,k.localize)(1,null);let g;return c<O?(g=c,b?g===1?h?(0,k.localize)(2,null,g):(0,k.localize)(3,null,g):h?(0,k.localize)(4,null,g):(0,k.localize)(5,null,g):g===1?h?(0,k.localize)(6,null,g):(0,k.localize)(7,null,g):h?(0,k.localize)(8,null,g):(0,k.localize)(9,null,g)):c<r?(g=Math.floor(c/O),b?g===1?h?(0,k.localize)(10,null,g):(0,k.localize)(11,null,g):h?(0,k.localize)(12,null,g):(0,k.localize)(13,null,g):g===1?h?(0,k.localize)(14,null,g):(0,k.localize)(15,null,g):h?(0,k.localize)(16,null,g):(0,k.localize)(17,null,g)):c<I?(g=Math.floor(c/r),b?g===1?h?(0,k.localize)(18,null,g):(0,k.localize)(19,null,g):h?(0,k.localize)(20,null,g):(0,k.localize)(21,null,g):g===1?h?(0,k.localize)(22,null,g):(0,k.localize)(23,null,g):h?(0,k.localize)(24,null,g):(0,k.localize)(25,null,g)):c<D?(g=Math.floor(c/I),b?g===1?(0,k.localize)(26,null,g):(0,k.localize)(27,null,g):g===1?(0,k.localize)(28,null,g):(0,k.localize)(29,null,g)):c<S?(g=Math.floor(c/D),b?g===1?h?(0,k.localize)(30,null,g):(0,k.localize)(31,null,g):h?(0,k.localize)(32,null,g):(0,k.localize)(33,null,g):g===1?h?(0,k.localize)(34,null,g):(0,k.localize)(35,null,g):h?(0,k.localize)(36,null,g):(0,k.localize)(37,null,g)):c<v?(g=Math.floor(c/S),b?g===1?h?(0,k.localize)(38,null,g):(0,k.localize)(39,null,g):h?(0,k.localize)(40,null,g):(0,k.localize)(41,null,g):g===1?h?(0,k.localize)(42,null,g):(0,k.localize)(43,null,g):h?(0,k.localize)(44,null,g):(0,k.localize)(45,null,g)):(g=Math.floor(c/v),b?g===1?h?(0,k.localize)(46,null,g):(0,k.localize)(47,null,g):h?(0,k.localize)(48,null,g):(0,k.localize)(49,null,g):g===1?h?(0,k.localize)(50,null,g):(0,k.localize)(51,null,g):h?(0,k.localize)(52,null,g):(0,k.localize)(53,null,g))}e.$wm=w;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$xm=C}),define(be[164],ve([8,9]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(be[39],ve([1,0,18,11,164]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Si=e.$Ri=void 0;function I(E,b){return b&&(E.stack||E.stacktrace)?r.localize(0,null,S(E),D(E.stack)||D(E.stacktrace)):S(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function S(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?r.localize(1,null,E.message):E.message||r.localize(2,null)}function v(E=null,b=!1){if(!E)return r.localize(3,null);if(Array.isArray(E)){const h=k.$Hb(E),$=v(h[0],b);return h.length>1?r.localize(4,null,$,h.length):$}if(O.$Jf(E))return E;if(E.detail){const h=E.detail;if(h.error)return I(h.error,b);if(h.exception)return I(h.exception,b)}return E.stack?I(E,b):E.message?E.message:r.localize(5,null)}e.$Ri=v;function w(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.$Si=w;function C(E,b){let h;return typeof E=="string"?h=new Error(E):h=E,h.actions=b,h}e.$Ti=C}),define(be[165],ve([8,9]),function(he,e){return he.create("vs/base/common/jsonErrorMessages",e)}),define(be[166],ve([1,0,165]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;function O(r){switch(r){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.$Yp=O}),define(be[167],ve([8,9]),function(he,e){return he.create("vs/base/common/platform",e)}),define(be[3],ve([1,0,167]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let O=!1,r=!1,I=!1,D=!1,S=!1,v=!1,w=!1,C=!1,E=!1,b=!1,h,$=e.$g,c=e.$g,g,d;const m=globalThis;let f;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?f=m.vscode.process:typeof process<"u"&&(f=process);const u=typeof f?.versions?.electron=="string",l=u&&f?.type==="renderer";if(typeof f=="object"){O=f.platform==="win32",r=f.platform==="darwin",I=f.platform==="linux",D=I&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,w=u,E=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,$=e.$g;const y=f.env.VSCODE_NLS_CONFIG;if(y)try{const A=JSON.parse(y),M=A.availableLanguages["*"];h=A.locale,c=A.osLocale,$=M||e.$g,g=A._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!l?(d=navigator.userAgent,O=d.indexOf("Windows")>=0,r=d.indexOf("Macintosh")>=0,C=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=d.indexOf("Linux")>=0,b=d?.indexOf("Mobi")>=0,v=!0,h=k.getConfiguredDefaultLocale(k.localize(0,null))||e.$g,$=h,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let n=0;r?n=1:O?n=3:I&&(n=2),e.$i=O,e.$j=r,e.$k=I,e.$l=D,e.$m=S,e.$n=w,e.$o=v,e.$p=v&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=C,e.$s=b,e.$t=E,e.$u=n,e.$v=d,e.$w=$;var s;(function(y){function A(){return e.$w}y.value=A;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}y.isDefaultVariant=M;function _(){return e.$w==="en"}y.isDefault=_})(s||(e.Language=s={})),e.$x=h,e.$y=c,e.$z=g,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const y=[];m.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let _=0,se=y.length;_<se;_++){const G=y[_];if(G.id===M.data.vscodeScheduleAsyncWork){y.splice(_,1),G.callback();return}}});let A=0;return M=>{const _=++A;y.push({id:_,callback:M}),m.postMessage({vscodeScheduleAsyncWork:_},"*")}}return y=>setTimeout(y)})();var i;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=r||C?2:O?1:3;let a=!0,p=!1;function L(){if(!p){p=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,a=new Uint16Array(y.buffer)[0]===(2<<8)+1}return a}e.$D=L,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function P(y){return parseFloat(y)>=20}e.$J=P}),define(be[29],ve([1,0,3]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const I=r.process;O={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(be[7],ve([1,0,29]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,r=97,I=90,D=122,S=46,v=47,w=92,C=58,E=63;class b extends Error{constructor(o,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const a=o.indexOf(".")!==-1?"property":"argument";let p=`The "${o}" ${a} ${i} of type ${n}`;p+=`. Received type ${typeof s}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,o){if(t===null||typeof t!="object")throw new b(o,"Object",t)}function $(t,o){if(typeof t!="string")throw new b(o,"string",t)}const c=k.$dc==="win32";function g(t){return t===v||t===w}function d(t){return t===v}function m(t){return t>=O&&t<=I||t>=r&&t<=D}function f(t,o,n,s){let i="",a=0,p=-1,L=0,P=0;for(let y=0;y<=t.length;++y){if(y<t.length)P=t.charCodeAt(y);else{if(s(P))break;P=v}if(s(P)){if(!(p===y-1||L===1))if(L===2){if(i.length<2||a!==2||i.charCodeAt(i.length-1)!==S||i.charCodeAt(i.length-2)!==S){if(i.length>2){const A=i.lastIndexOf(n);A===-1?(i="",a=0):(i=i.slice(0,A),a=i.length-1-i.lastIndexOf(n)),p=y,L=0;continue}else if(i.length!==0){i="",a=0,p=y,L=0;continue}}o&&(i+=i.length>0?`${n}..`:"..",a=2)}else i.length>0?i+=`${n}${t.slice(p+1,y)}`:i=t.slice(p+1,y),a=y-p-1;p=y,L=0}else P===S&&L!==-1?++L:L=-1}return i}function u(t,o){h(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${t}${s}`:s}e.$fc={resolve(...t){let o="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let a;if(i>=0){if(a=t[i],$(a,"path"),a.length===0)continue}else o.length===0?a=k.cwd():(a=k.env[`=${o}`]||k.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===w)&&(a=`${o}\\`));const p=a.length;let L=0,P="",y=!1;const A=a.charCodeAt(0);if(p===1)g(A)&&(L=1,y=!0);else if(g(A))if(y=!0,g(a.charCodeAt(1))){let M=2,_=M;for(;M<p&&!g(a.charCodeAt(M));)M++;if(M<p&&M!==_){const se=a.slice(_,M);for(_=M;M<p&&g(a.charCodeAt(M));)M++;if(M<p&&M!==_){for(_=M;M<p&&!g(a.charCodeAt(M));)M++;(M===p||M!==_)&&(P=`\\\\${se}\\${a.slice(_,M)}`,L=M)}}}else L=1;else m(A)&&a.charCodeAt(1)===C&&(P=a.slice(0,2),L=2,p>2&&g(a.charCodeAt(2))&&(y=!0,L=3));if(P.length>0)if(o.length>0){if(P.toLowerCase()!==o.toLowerCase())continue}else o=P;if(s){if(o.length>0)break}else if(n=`${a.slice(L)}\\${n}`,s=y,y&&o.length>0)break}return n=f(n,!s,"\\",g),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(t){$(t,"path");const o=t.length;if(o===0)return".";let n=0,s,i=!1;const a=t.charCodeAt(0);if(o===1)return d(a)?"\\":t;if(g(a))if(i=!0,g(t.charCodeAt(1))){let L=2,P=L;for(;L<o&&!g(t.charCodeAt(L));)L++;if(L<o&&L!==P){const y=t.slice(P,L);for(P=L;L<o&&g(t.charCodeAt(L));)L++;if(L<o&&L!==P){for(P=L;L<o&&!g(t.charCodeAt(L));)L++;if(L===o)return`\\\\${y}\\${t.slice(P)}\\`;L!==P&&(s=`\\\\${y}\\${t.slice(P,L)}`,n=L)}}}else n=1;else m(a)&&t.charCodeAt(1)===C&&(s=t.slice(0,2),n=2,o>2&&g(t.charCodeAt(2))&&(i=!0,n=3));let p=n<o?f(t.slice(n),!i,"\\",g):"";return p.length===0&&!i&&(p="."),p.length>0&&g(t.charCodeAt(o-1))&&(p+="\\"),s===void 0?i?`\\${p}`:p:i?`${s}\\${p}`:`${s}${p}`},isAbsolute(t){$(t,"path");const o=t.length;if(o===0)return!1;const n=t.charCodeAt(0);return g(n)||o>2&&m(n)&&t.charCodeAt(1)===C&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,n;for(let a=0;a<t.length;++a){const p=t[a];$(p,"path"),p.length>0&&(o===void 0?o=n=p:o+=`\\${p}`)}if(o===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&g(n.charCodeAt(0))){++i;const a=n.length;a>1&&g(n.charCodeAt(1))&&(++i,a>2&&(g(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<o.length&&g(o.charCodeAt(i));)i++;i>=2&&(o=`\\${o.slice(i)}`)}return e.$fc.normalize(o)},relative(t,o){if($(t,"from"),$(o,"to"),t===o)return"";const n=e.$fc.resolve(t),s=e.$fc.resolve(o);if(n===s||(t=n.toLowerCase(),o=s.toLowerCase(),t===o))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===w;)i++;let a=t.length;for(;a-1>i&&t.charCodeAt(a-1)===w;)a--;const p=a-i;let L=0;for(;L<o.length&&o.charCodeAt(L)===w;)L++;let P=o.length;for(;P-1>L&&o.charCodeAt(P-1)===w;)P--;const y=P-L,A=p<y?p:y;let M=-1,_=0;for(;_<A;_++){const G=t.charCodeAt(i+_);if(G!==o.charCodeAt(L+_))break;G===w&&(M=_)}if(_!==A){if(M===-1)return s}else{if(y>A){if(o.charCodeAt(L+_)===w)return s.slice(L+_+1);if(_===2)return s.slice(L+_)}p>A&&(t.charCodeAt(i+_)===w?M=_:_===2&&(M=3)),M===-1&&(M=0)}let se="";for(_=i+M+1;_<=a;++_)(_===a||t.charCodeAt(_)===w)&&(se+=se.length===0?"..":"\\..");return L+=M,se.length>0?`${se}${s.slice(L,P)}`:(s.charCodeAt(L)===w&&++L,s.slice(L,P))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const n=o.charCodeAt(2);if(n!==E&&n!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(m(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return t},dirname(t){$(t,"path");const o=t.length;if(o===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(o===1)return g(i)?t:".";if(g(i)){if(n=s=1,g(t.charCodeAt(1))){let L=2,P=L;for(;L<o&&!g(t.charCodeAt(L));)L++;if(L<o&&L!==P){for(P=L;L<o&&g(t.charCodeAt(L));)L++;if(L<o&&L!==P){for(P=L;L<o&&!g(t.charCodeAt(L));)L++;if(L===o)return t;L!==P&&(n=s=L+1)}}}}else m(i)&&t.charCodeAt(1)===C&&(n=o>2&&g(t.charCodeAt(2))?3:2,s=n);let a=-1,p=!0;for(let L=o-1;L>=s;--L)if(g(t.charCodeAt(L))){if(!p){a=L;break}}else p=!1;if(a===-1){if(n===-1)return".";a=n}return t.slice(0,a)},basename(t,o){o!==void 0&&$(o,"ext"),$(t,"path");let n=0,s=-1,i=!0,a;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,L=-1;for(a=t.length-1;a>=n;--a){const P=t.charCodeAt(a);if(g(P)){if(!i){n=a+1;break}}else L===-1&&(i=!1,L=a+1),p>=0&&(P===o.charCodeAt(p)?--p===-1&&(s=a):(p=-1,s=L))}return n===s?s=L:s===-1&&(s=t.length),t.slice(n,s)}for(a=t.length-1;a>=n;--a)if(g(t.charCodeAt(a))){if(!i){n=a+1;break}}else s===-1&&(i=!1,s=a+1);return s===-1?"":t.slice(n,s)},extname(t){$(t,"path");let o=0,n=-1,s=0,i=-1,a=!0,p=0;t.length>=2&&t.charCodeAt(1)===C&&m(t.charCodeAt(0))&&(o=s=2);for(let L=t.length-1;L>=o;--L){const P=t.charCodeAt(L);if(g(P)){if(!a){s=L+1;break}continue}i===-1&&(a=!1,i=L+1),P===S?n===-1?n=L:p!==1&&(p=1):n!==-1&&(p=-1)}return n===-1||i===-1||p===0||p===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:u.bind(null,"\\"),parse(t){$(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return g(i)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(g(i)){if(s=1,g(t.charCodeAt(1))){let M=2,_=M;for(;M<n&&!g(t.charCodeAt(M));)M++;if(M<n&&M!==_){for(_=M;M<n&&g(t.charCodeAt(M));)M++;if(M<n&&M!==_){for(_=M;M<n&&!g(t.charCodeAt(M));)M++;M===n?s=M:M!==_&&(s=M+1)}}}}else if(m(i)&&t.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=t,o;if(s=2,g(t.charCodeAt(2))){if(n===3)return o.root=o.dir=t,o;s=3}}s>0&&(o.root=t.slice(0,s));let a=-1,p=s,L=-1,P=!0,y=t.length-1,A=0;for(;y>=s;--y){if(i=t.charCodeAt(y),g(i)){if(!P){p=y+1;break}continue}L===-1&&(P=!1,L=y+1),i===S?a===-1?a=y:A!==1&&(A=1):a!==-1&&(A=-1)}return L!==-1&&(a===-1||A===0||A===1&&a===L-1&&a===p+1?o.base=o.name=t.slice(p,L):(o.name=t.slice(p,a),o.base=t.slice(p,L),o.ext=t.slice(a,L))),p>0&&p!==s?o.dir=t.slice(0,p-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(c){const t=/\\/g;return()=>{const o=k.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>k.cwd()})();e.$gc={resolve(...t){let o="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:l();$(i,"path"),i.length!==0&&(o=`${i}/${o}`,n=i.charCodeAt(0)===v)}return o=f(o,!n,"/",d),n?`/${o}`:o.length>0?o:"."},normalize(t){if($(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===v,n=t.charCodeAt(t.length-1)===v;return t=f(t,!o,"/",d),t.length===0?o?"/":n?"./":".":(n&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return $(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let o;for(let n=0;n<t.length;++n){const s=t[n];$(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if($(t,"from"),$(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const n=1,s=t.length,i=s-n,a=1,p=o.length-a,L=i<p?i:p;let P=-1,y=0;for(;y<L;y++){const M=t.charCodeAt(n+y);if(M!==o.charCodeAt(a+y))break;M===v&&(P=y)}if(y===L)if(p>L){if(o.charCodeAt(a+y)===v)return o.slice(a+y+1);if(y===0)return o.slice(a+y)}else i>L&&(t.charCodeAt(n+y)===v?P=y:y===0&&(P=0));let A="";for(y=n+P+1;y<=s;++y)(y===s||t.charCodeAt(y)===v)&&(A+=A.length===0?"..":"/..");return`${A}${o.slice(a+P)}`},toNamespacedPath(t){return t},dirname(t){if($(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===v;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===v){if(!s){n=i;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":t.slice(0,n)},basename(t,o){o!==void 0&&$(o,"ext"),$(t,"path");let n=0,s=-1,i=!0,a;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let p=o.length-1,L=-1;for(a=t.length-1;a>=0;--a){const P=t.charCodeAt(a);if(P===v){if(!i){n=a+1;break}}else L===-1&&(i=!1,L=a+1),p>=0&&(P===o.charCodeAt(p)?--p===-1&&(s=a):(p=-1,s=L))}return n===s?s=L:s===-1&&(s=t.length),t.slice(n,s)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===v){if(!i){n=a+1;break}}else s===-1&&(i=!1,s=a+1);return s===-1?"":t.slice(n,s)},extname(t){$(t,"path");let o=-1,n=0,s=-1,i=!0,a=0;for(let p=t.length-1;p>=0;--p){const L=t.charCodeAt(p);if(L===v){if(!i){n=p+1;break}continue}s===-1&&(i=!1,s=p+1),L===S?o===-1?o=p:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||s===-1||a===0||a===1&&o===s-1&&o===n+1?"":t.slice(o,s)},format:u.bind(null,"/"),parse(t){$(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.charCodeAt(0)===v;let s;n?(o.root="/",s=1):s=0;let i=-1,a=0,p=-1,L=!0,P=t.length-1,y=0;for(;P>=s;--P){const A=t.charCodeAt(P);if(A===v){if(!L){a=P+1;break}continue}p===-1&&(L=!1,p=P+1),A===S?i===-1?i=P:y!==1&&(y=1):i!==-1&&(y=-1)}if(p!==-1){const A=a===0&&n?1:a;i===-1||y===0||y===1&&i===p-1&&i===a+1?o.base=o.name=t.slice(A,p):(o.name=t.slice(A,i),o.base=t.slice(A,p),o.ext=t.slice(i,p))}return a>0?o.dir=t.slice(0,a-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(be[40],ve([1,0,7,3,17,11]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function D(a){return a===47||a===92}e.$2f=D;function S(a){return a.replace(/[\\/]/g,k.$gc.sep)}e.$3f=S;function v(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$4f=v;function w(a,p=k.$gc.sep){if(!a)return"";const L=a.length,P=a.charCodeAt(0);if(D(P)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let A=3;const M=A;for(;A<L&&!D(a.charCodeAt(A));A++);if(M!==A&&!D(a.charCodeAt(A+1))){for(A+=1;A<L;A++)if(D(a.charCodeAt(A)))return a.slice(0,A+1).replace(/[\\/]/g,p)}}return p}else if(d(P)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+p:a.slice(0,2);let y=a.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(D(a.charCodeAt(y)))return a.slice(0,y+1)}return""}e.$5f=w;function C(a){if(!O.$i||!a||a.length<5)return!1;let p=a.charCodeAt(0);if(p!==92||(p=a.charCodeAt(1),p!==92))return!1;let L=2;const P=L;for(;L<a.length&&(p=a.charCodeAt(L),p!==92);L++);return!(P===L||(p=a.charCodeAt(L+1),isNaN(p)||p===92))}e.$6f=C;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(a,p=O.$i){const L=p?E:b;return!(!a||a.length===0||/^\s+$/.test(a)||(L.lastIndex=0,L.test(a))||p&&h.test(a)||a==="."||a===".."||p&&a[a.length-1]==="."||p&&a.length!==a.trim().length||a.length>255)}e.$7f=$;function c(a,p,L){const P=a===p;return!L||P?P:!a||!p?!1:(0,r.$af)(a,p)}e.$8f=c;function g(a,p,L,P=k.sep){if(a===p)return!0;if(!a||!p||p.length>a.length)return!1;if(L){if(!(0,r.$bf)(a,p))return!1;if(p.length===a.length)return!0;let A=p.length;return p.charAt(p.length-1)===P&&A--,a.charAt(A)===P}return p.charAt(p.length-1)!==P&&(p+=P),a.indexOf(p)===0}e.$9f=g;function d(a){return a>=65&&a<=90||a>=97&&a<=122}e.$0f=d;function m(a,p){return O.$i&&a.endsWith(":")&&(a+=k.sep),(0,k.$ic)(a)||(a=(0,k.$jc)(p,a)),a=(0,k.$hc)(a),O.$i?(a=(0,r.$Ve)(a,k.sep),a.endsWith(":")&&(a+=k.sep)):(a=(0,r.$Ve)(a,k.sep),a||(a=k.sep)),a}e.$$f=m;function f(a){const p=(0,k.$hc)(a);return O.$i?a.length>3?!1:u(p)&&(a.length===2||p.charCodeAt(2)===92):p===k.$gc.sep}e.$_f=f;function u(a,p=O.$i){return p?d(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$ag=u;function l(a,p=O.$i){return u(a,p)?a[0]:void 0}e.$bg=l;function t(a,p,L){return p.length>a.length?-1:a===p?0:(L&&(a=a.toLowerCase(),p=p.toLowerCase()),a.indexOf(p))}e.$cg=t;function o(a){const p=a.split(":");let L,P,y;for(const A of p){const M=Number(A);(0,I.$Nf)(M)?P===void 0?P=M:y===void 0&&(y=M):L=L?[L,A].join(":"):A}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:P!==void 0?P:void 0,column:y!==void 0?y:P!==void 0?1:void 0}}e.$dg=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(a,p,L=8){let P="";for(let A=0;A<L;A++){let M;A===0&&O.$i&&!p&&(L===3||L===4)?M=s:M=n,P+=M.charAt(Math.floor(Math.random()*M.length))}let y;return p?y=`${p}-${P}`:y=P,a?(0,k.$jc)(a,y):y}e.$eg=i}),define(be[65],ve([1,0,7]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=e.$js=e.$is=e.$hs=e.$gs=void 0,e.$gs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},r={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(C){const E=(0,k.$oc)(C),b=O[E.toLowerCase()];return b!==void 0?b:D(C)}e.$hs=I;function D(C){const E=(0,k.$oc)(C);return r[E.toLowerCase()]}e.$is=D;function S(C){for(const E in r)if(r[E]===C)return E}e.$js=S;const v=/^(.+)\/(.+?)(;.+)?$/;function w(C,E){const b=v.exec(C);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:C}e.$ks=w}),define(be[66],ve([1,0,3]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.TerminateResponseCode=e.Source=void 0;var O;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(O||(e.Source=O={}));var r;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function I(S,...v){const w=v.reduce((b,h)=>(b[h]=!0,b),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(b=>!w[b]).forEach(b=>{for(let h=0;h<C.length;h++)if(b.search(C[h])!==-1){delete S[b];break}})}e.$Sl=I;function D(S){S&&(delete S.DEBUG,k.$j&&delete S.DYLD_LIBRARY_PATH,k.$k&&delete S.LD_PRELOAD)}e.$Tl=D}),define(be[4],ve([1,0,7,3]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,I=/^\//,D=/^\/\//;function S(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!r.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!I.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(s,i){return!s&&!i?"file":s}function w(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const C="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,a,p,L,P,y=!1){typeof i=="object"?(this.scheme=i.scheme||C,this.authority=i.authority||C,this.path=i.path||C,this.query=i.query||C,this.fragment=i.fragment||C):(this.scheme=v(i,y),this.authority=a||C,this.path=w(this.scheme,p||C),this.query=L||C,this.fragment=P||C,S(this,y))}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:p,path:L,query:P,fragment:y}=i;return a===void 0?a=this.scheme:a===null&&(a=C),p===void 0?p=this.authority:p===null&&(p=C),L===void 0?L=this.path:L===null&&(L=C),P===void 0?P=this.query:P===null&&(P=C),y===void 0?y=this.fragment:y===null&&(y=C),a===this.scheme&&p===this.authority&&L===this.path&&P===this.query&&y===this.fragment?this:new g(a,p,L,P,y)}static parse(i,a=!1){const p=b.exec(i);return p?new g(p[2]||C,n(p[4]||C),n(p[5]||C),n(p[7]||C),n(p[9]||C),a):new g(C,C,C,C,C)}static file(i){let a=C;if(O.$i&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const p=i.indexOf(E,2);p===-1?(a=i.substring(2),i=E):(a=i.substring(2,p),i=i.substring(p)||E)}return new g("file",a,i,C,C)}static from(i,a){return new g(i.scheme,i.authority,i.path,i.query,i.fragment,a)}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return O.$i&&i.scheme==="file"?p=h.file(k.$fc.join(u(i,!0),...a)).path:p=k.$gc.join(i.path,...a),i.with({path:p})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const a=new g(i);return a._formatted=i.external??null,a._fsPath=i._sep===c?i.fsPath??null:null,a}}else return i}}e.URI=h;function $(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=$;const c=O.$i?1:void 0;class g extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=c),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(s,i,a){let p,L=-1;for(let P=0;P<s.length;P++){const y=s.charCodeAt(P);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||i&&y===47||a&&y===91||a&&y===93||a&&y===58)L!==-1&&(p+=encodeURIComponent(s.substring(L,P)),L=-1),p!==void 0&&(p+=s.charAt(P));else{p===void 0&&(p=s.substr(0,P));const A=d[y];A!==void 0?(L!==-1&&(p+=encodeURIComponent(s.substring(L,P)),L=-1),p+=A):L===-1&&(L=P)}}return L!==-1&&(p+=encodeURIComponent(s.substring(L))),p!==void 0?p:s}function f(s){let i;for(let a=0;a<s.length;a++){const p=s.charCodeAt(a);p===35||p===63?(i===void 0&&(i=s.substr(0,a)),i+=d[p]):i!==void 0&&(i+=s[a])}return i!==void 0?i:s}function u(s,i){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,O.$i&&(a=a.replace(/\//g,"\\")),a}e.$wc=u;function l(s,i){const a=i?f:m;let p="",{scheme:L,authority:P,path:y,query:A,fragment:M}=s;if(L&&(p+=L,p+=":"),(P||L==="file")&&(p+=E,p+=E),P){let _=P.indexOf("@");if(_!==-1){const se=P.substr(0,_);P=P.substr(_+1),_=se.lastIndexOf(":"),_===-1?p+=a(se,!1,!1):(p+=a(se.substr(0,_),!1,!1),p+=":",p+=a(se.substr(_+1),!1,!0)),p+="@"}P=P.toLowerCase(),_=P.lastIndexOf(":"),_===-1?p+=a(P,!1,!0):(p+=a(P.substr(0,_),!1,!0),p+=P.substr(_))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const _=y.charCodeAt(1);_>=65&&_<=90&&(y=`/${String.fromCharCode(_+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const _=y.charCodeAt(0);_>=65&&_<=90&&(y=`${String.fromCharCode(_+32)}:${y.substr(2)}`)}p+=a(y,!0,!1)}return A&&(p+="?",p+=a(A,!1,!1)),M&&(p+="#",p+=i?M:m(M,!1,!1)),p}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,i=>t(i)):s}}),define(be[168],ve([1,0,4]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$pq=e.$oq=e.$nq=void 0;function O(w){const C=w;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$nq=O;function r(w){const C=[];let E;try{const b=JSON.parse(w.arguments),h=b[b.length-1];h&&h.__$stack&&(b.pop(),E=h.__$stack),C.push(...b)}catch{C.push("Unable to log remote console arguments",w.arguments)}return{args:C,stack:E}}e.$oq=r;function I(w){if(typeof w!="string")return I(r(w).stack);const C=w;if(C){const E=D(C),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:k.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$pq=I;function D(w){if(!w)return w;const C=w.indexOf(`
`);return C===-1?w:w.substring(0,C)}function S(w,C){const{args:E,stack:b}=r(w),h=typeof E[0]=="string"&&E.length===1;let $=D(b);$&&($=`(${$.trim()})`);let c=[];if(typeof E[0]=="string"?$&&h?c=[`%c[${C}] %c${E[0]} %c${$}`,v("blue"),v(""),v("grey")]:c=[`%c[${C}] %c${E[0]}`,v("blue"),v(""),...E.slice(1)]:c=[`%c[${C}]%`,v("blue"),...E],$&&!h&&c.push($),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,c)}e.log=S;function v(w){return`color: ${w}`}}),define(be[52],ve([1,0,14,4]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=void 0;function r(v){return JSON.stringify(v,D)}e.$Bh=r;function I(v){let w=JSON.parse(v);return w=S(w),w}e.$Ch=I;function D(v,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function S(v,w=0){if(!v||w>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return O.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 17:return new Date(v.source)}if(v instanceof k.$ke||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let C=0;C<v.length;++C)v[C]=S(v[C],w+1);else for(const C in v)Object.hasOwnProperty.call(v,C)&&(v[C]=S(v[C],w+1))}return v}e.$Dh=S}),define(be[12],ve([1,0,10,3,17,4]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var D;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function S(b,h){return I.URI.isUri(b)?(0,r.$af)(b.scheme,h):(0,r.$bf)(b,h+":")}e.$fg=S;function v(b,...h){return h.some($=>S(b,$))}e.$gg=v,e.$hg="vscode-tkn",e.$ig="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${D.vscodeRemoteResource}`}set(h,$,c){this.a[h]=$,this.b[h]=c}setConnectionToken(h,$){this.c[h]=$}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(f){return k.$1(f),h}const $=h.authority;let c=this.a[$];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const g=this.b[$],d=this.c[$];let m=`path=${encodeURIComponent(h.path)}`;return typeof d=="string"&&(m+=`&${e.$ig}=${encodeURIComponent(d)}`),I.URI.from({scheme:O.$o?this.d:D.vscodeRemoteResource,authority:`${c}:${g}`,path:this.f,query:m})}}e.$jg=new w,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class C{static{this.a=e.$og}asBrowserUri(h){const $=this.b(h,he);return this.uriToBrowserUri($)}uriToBrowserUri(h){return h.scheme===D.vscodeRemote?e.$jg.rewrite(h):h.scheme===D.file&&(O.$m||O.$q===`${D.vscodeFileResource}://${C.a}`)?h.with({scheme:D.vscodeFileResource,authority:h.authority||C.a,query:null,fragment:null}):h}asFileUri(h){const $=this.b(h,he);return this.uriToFileUri($)}uriToFileUri(h){return h.scheme===D.vscodeFileResource?h.with({scheme:D.file,authority:h.authority!==C.a?h.authority:null,query:null,fragment:null}):h}b(h,$){return I.URI.isUri(h)?h:I.URI.parse($.toUrl(h))}}e.$pg=new C;var E;(function(b){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(h.get("3"));const $="vscode-coi";function c(d){let m;typeof d=="string"?m=new URL(d).searchParams:d instanceof URL?m=d.searchParams:I.URI.isUri(d)&&(m=new URL(d.toString(!0)).searchParams);const f=m?.get($);if(f)return h.get(f)}b.getHeadersFromQuery=c;function g(d,m,f){if(!globalThis.crossOriginIsolated)return;const u=m&&f?"3":f?"2":"1";d instanceof URLSearchParams?d.set($,u):d[$]=u}b.addSearchParam=g})(E||(e.COI=E={}))}),define(be[169],ve([1,0,95,12,3,4]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=void 0;class D{constructor(b,h,$){this.id=b,this.dependencies=h,this.callback=$}}class S{static{this.INSTANCE=new S}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,h,$)=>{typeof b!="string"&&($=h,h=b,b=null),(typeof h!="object"||!Array.isArray(h))&&($=h,h=null),this.c.push(new D(b,h,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const h=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!h)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(b){return new Promise((h,$)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",d),c.removeEventListener("error",m)},d=f=>{g(),h(this.c.pop())},m=f=>{g(),$(f)};c.addEventListener("load",d),c.addEventListener("error",m),this.f&&(b=this.f.createScriptURL(b)),c.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(b){return new Promise((h,$)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),h(this.c.pop())}catch(c){$(c)}})}async j(b){try{const h=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=I.URI.parse(b).fsPath,d=h.readFileSync(g).toString(),m=c.wrap(d.replace(/^#!.*/,""));return new $.Script(m).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const v=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function C(E,b,h){if(k.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[E]&&(E=w[E]);const $=`${E}/${b}`;if(v.has($))return v.get($);let c;if(/^\w[\w\d+.-]*:\/\//.test($))c=$;else{const f=`${h&&!r.$o?O.$mg:O.$lg}/${$}`;c=O.$pg.asBrowserUri(f).toString(!0)}const g=S.INSTANCE.load(c);return v.set($,g),g}else return await new Promise(($,c)=>{he([E],$,c)})}e.$iD=C}),define(be[19],ve([1,0,40,12,7,3,17,4]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function v(h){return(0,S.$wc)(h,!0)}e.$wg=v;class w{constructor($){this.a=$}compare($,c,g=!1){return $===c?0:(0,D.$6e)(this.getComparisonKey($,g),this.getComparisonKey(c,g))}isEqual($,c,g=!1){return $===c?!0:!$||!c?!1:this.getComparisonKey($,g)===this.getComparisonKey(c,g)}getComparisonKey($,c=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,c,g=!1){if($.scheme===c.scheme){if($.scheme===O.Schemas.file)return k.$9f(v($),v(c),this.a($))&&$.query===c.query&&(g||$.fragment===c.fragment);if((0,e.$Ng)($.authority,c.authority))return k.$9f($.path,c.path,this.a($),"/")&&$.query===c.query&&(g||$.fragment===c.fragment)}return!1}joinPath($,...c){return S.URI.joinPath($,...c)}basenameOrAuthority($){return(0,e.$Fg)($)||$.authority}basename($){return r.$gc.basename($.path)}extname($){return r.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let c;return $.scheme===O.Schemas.file?c=S.URI.file(r.$mc(v($))).path:(c=r.$gc.dirname($.path),$.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),c="/")),$.with({path:c})}normalizePath($){if(!$.path.length)return $;let c;return $.scheme===O.Schemas.file?c=S.URI.file(r.$hc(v($))).path:c=r.$gc.normalize($.path),$.with({path:c})}relativePath($,c){if($.scheme!==c.scheme||!(0,e.$Ng)($.authority,c.authority))return;if($.scheme===O.Schemas.file){const m=r.$lc(v($),v(c));return I.$i?k.$3f(m):m}let g=$.path||"/";const d=c.path||"/";if(this.a($)){let m=0;for(const f=Math.min(g.length,d.length);m<f&&!(g.charCodeAt(m)!==d.charCodeAt(m)&&g.charAt(m).toLowerCase()!==d.charAt(m).toLowerCase());m++);g=d.substr(0,m)+g.substr(m)}return r.$gc.relative(g,d)}resolvePath($,c){if($.scheme===O.Schemas.file){const g=S.URI.file(r.$kc(v($),c));return $.with({authority:g.authority,path:g.path})}return c=k.$4f(c),$.with({path:r.$gc.resolve($.path,c)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,c){return $===c||$!==void 0&&c!==void 0&&(0,D.$af)($,c)}hasTrailingPathSeparator($,c=r.sep){if($.scheme===O.Schemas.file){const g=v($);return g.length>k.$5f(g).length&&g[g.length-1]===c}else{const g=$.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,c=r.sep){return(0,e.$Og)($,c)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,c=r.sep){let g=!1;if($.scheme===O.Schemas.file){const d=v($);g=d!==void 0&&d.length===k.$5f(d).length&&d[d.length-1]===c}else{c="/";const d=$.path;g=d.length===1&&d.charCodeAt(d.length-1)===47}return!g&&!(0,e.$Og)($,c)?$.with({path:$.path+"/"}):$}}e.$xg=w,e.$yg=new w(()=>!1),e.$zg=new w(h=>h.scheme===O.Schemas.file?!I.$k:!0),e.$Ag=new w(h=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function C(h,$){const c=[];for(let g=0;g<h.length;g++){const d=$(h[g]);h.some((m,f)=>f===g?!1:(0,e.$Cg)(d,$(m)))||c.push(h[g])}return c}e.$Rg=C;var E;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function $(c){const g=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(f=>{const[u,l]=f.split(":");u&&l&&g.set(u,l)});const m=c.path.substring(0,c.path.indexOf(";"));return m&&g.set(h.META_DATA_MIME,m),g}h.parseMetaData=$})(E||(e.DataUri=E={}));function b(h,$,c){if($){let g=h.path;return g&&g[0]!==r.$gc.sep&&(g=r.$gc.sep+g),h.with({scheme:c,authority:$,path:g})}return h.with({scheme:c})}e.$Sg=b}),define(be[15],ve([1,0,20,10,6,2,19,3,152,60]),function(he,e,k,O,r,I,D,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.Promises=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function C(B){return!!B&&typeof B.then=="function"}e.$Tg=C;function E(B){const T=new k.$7d,N=B(T.token),q=new Promise((ie,ae)=>{const ge=T.token.onCancellationRequested(()=>{ge.dispose(),ae(new O.$5)});Promise.resolve(N).then(ce=>{ge.dispose(),T.dispose(),ie(ce)},ce=>{ge.dispose(),T.dispose(),ae(ce)})});return new class{cancel(){T.cancel(),T.dispose()}then(ie,ae){return q.then(ie,ae)}catch(ie){return this.then(void 0,ie)}finally(ie){return q.finally(ie)}}}e.$Ug=E;function b(B,T,N){return new Promise((q,ie)=>{const ae=T.onCancellationRequested(()=>{ae.dispose(),q(N)});B.then(q,ie).finally(()=>ae.dispose())})}e.$Vg=b;function h(B,T){return new Promise((N,q)=>{const ie=T.onCancellationRequested(()=>{ie.dispose(),q(new O.$5)});B.then(N,q).finally(()=>ie.dispose())})}e.$Wg=h;async function $(B){let T=-1;const N=B.map((q,ie)=>q.then(ae=>(T=ie,ae)));try{return await Promise.race(N)}finally{B.forEach((q,ie)=>{ie!==T&&q.cancel()})}}e.$Xg=$;function c(B,T,N){let q;const ie=setTimeout(()=>{q?.(void 0),N?.()},T);return Promise.race([B.finally(()=>clearTimeout(ie)),new Promise(ae=>q=ae)])}e.$Yg=c;function g(B){return new Promise((T,N)=>{const q=B();C(q)?q.then(T,N):T(q)})}e.$Zg=g;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const N=()=>{if(this.b=null,this.f)return;const q=this.queue(this.d);return this.d=null,q};this.b=new Promise(q=>{this.a.then(N,N).then(q)})}return new Promise((N,q)=>{this.b.then(N,q)})}return this.a=T(),new Promise((N,q)=>{this.a.then(ie=>{this.a=null,N(ie)},ie=>{this.a=null,q(ie)})})}dispose(){this.f=!0}}e.$1g=d;class m{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$2g=m;class f{constructor(){this.a=new Map}queue(T,N){const ie=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.a.get(T)===ie&&this.a.delete(T)});return this.a.set(T,ie),ie}}e.$3g=f;const u=(B,T)=>{let N=!0;const q=setTimeout(()=>{N=!1,T()},B);return{isTriggered:()=>N,dispose:()=>{clearTimeout(q),N=!1}}},l=B=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,B())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class t{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,N=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((ie,ae)=>{this.d=ie,this.f=ae}).then(()=>{if(this.b=null,this.d=null,this.g){const ie=this.g;return this.g=null,ie()}}));const q=()=>{this.a=null,this.d?.(null)};return this.a=N===v.$Td?l(q):u(N,q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$4g=t;class o{constructor(T){this.a=new t(T),this.b=new d}trigger(T,N){return this.a.trigger(()=>this.b.queue(T),N)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$5g=o;class n{constructor(){this.a=!1,this.b=new Promise((T,N)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$6g=n;class s extends n{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$7g=s;function i(B,T){return T?new Promise((N,q)=>{const ie=setTimeout(()=>{ae.dispose(),N()},B),ae=T.onCancellationRequested(()=>{clearTimeout(ie),ae.dispose(),q(new O.$5)})}):E(N=>i(B,N))}e.$8g=i;function a(B,T=0,N){const q=setTimeout(()=>{B(),N&&ie.dispose()},T),ie=(0,I.$Rc)(()=>{clearTimeout(q),N?.deleteAndLeak(ie)});return N?.add(ie),ie}e.$9g=a;function p(B){const T=[];let N=0;const q=B.length;function ie(){return N<q?B[N++]():null}function ae(ge){ge!=null&&T.push(ge);const ce=ie();return ce?ce.then(ae):Promise.resolve(T)}return Promise.resolve(null).then(ae)}e.$0g=p;function L(B,T=q=>!!q,N=null){let q=0;const ie=B.length,ae=()=>{if(q>=ie)return Promise.resolve(N);const ge=B[q++];return Promise.resolve(ge()).then(pe=>T(pe)?Promise.resolve(pe):ae())};return ae()}e.$$g=L;function P(B,T=q=>!!q,N=null){if(B.length===0)return Promise.resolve(N);let q=B.length;const ie=()=>{q=-1;for(const ae of B)ae.cancel?.()};return new Promise((ae,ge)=>{for(const ce of B)ce.then(pe=>{--q>=0&&T(pe)?(ie(),ae(pe)):q===0&&ae(N)}).catch(pe=>{--q>=0&&(ie(),ge(pe))})})}e.$_g=P;class y{constructor(T){this.a=0,this.b=!1,this.f=T,this.g=[],this.d=0,this.h=new r.$Wd}whenIdle(){return this.size>0?r.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(T){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((N,q)=>{this.g.push({factory:T,c:N,e:q}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const T=this.g.shift();this.d++;const N=T.factory();N.then(T.c,T.e),N.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ah=y;class A extends y{constructor(){super(1)}}e.$bh=A;class M{constructor(){this.a=new W,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$ch=M;class _{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new ne;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueSize(T,N=D.$yg){const q=N.getComparisonKey(T);return this.a.get(q)?.size??0}queueFor(T,N,q=D.$yg){const ie=q.getComparisonKey(T);let ae=this.a.get(ie);if(!ae){ae=new A;const ge=this.f++,ce=r.Event.once(ae.onDrained)(()=>{ae?.dispose(),this.a.delete(ie),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$3c),this.d.set(ge,ce),this.a.set(ie,ae)}return ae.queue(N)}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$dh=_;class se{constructor(T,N){this.a=-1,typeof T=="function"&&typeof N=="number"&&this.setIfNotSet(T,N)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,N){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},N)}setIfNotSet(T,N){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},N))}}e.$eh=se;class G{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(T,N,q=globalThis){this.cancel();const ie=q.setInterval(()=>{T()},N);this.d=(0,I.$Rc)(()=>{q.clearInterval(ie),this.d=void 0})}dispose(){this.cancel()}}e.$fh=G;class oe{constructor(T,N){this.b=-1,this.a=T,this.d=N,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$gh=oe;class ee{constructor(T,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.a=T,this.b=N,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$hh=ee;class K extends oe{constructor(T,N){super(T,N),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$ih=K;class Z extends I.$Tc{constructor(T,N){super(),this.g=T,this.h=N,this.a=[],this.b=this.B(new I.$Uc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const N of T)this.a.push(N);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new oe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$jh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$lh=(B,T)=>{(0,S.$B)(()=>{if(N)return;const q=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.$lh=(B,T,N)=>{const q=B.requestIdleCallback(T,typeof N=="number"?{timeout:N}:void 0);let ie=!1;return{dispose(){ie||(ie=!0,B.cancelIdleCallback(q))}}},e.$kh=B=>(0,e.$lh)(globalThis,B)}();class X{constructor(T,N){this.g=!1,this.d=()=>{try{this.j=N()}catch(q){this.l=q}finally{this.g=!0}},this.f=(0,e.$lh)(T,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$mh=X;class te extends X{constructor(T){super(globalThis,T)}}e.$nh=te;async function V(B,T,N){let q;for(let ie=0;ie<N;ie++)try{return await B()}catch(ae){q=ae,await i(T)}throw q}e.$oh=V;class W{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,N,q){return this.a={taskId:T,cancel:()=>q?.(),promise:N},N.then(()=>this.d(T),()=>this.d(T)),N}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{let N,q;const ie=new Promise((ae,ge)=>{N=ae,q=ge});this.b={run:T,promise:ie,promiseResolve:N,promiseReject:q}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ph=W;class re{constructor(T,N=()=>Date.now()){this.d=T,this.f=N,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$qh=re;var ue;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(ue||(ue={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,N)=>{this.a=T,this.b=N})}complete(T){return new Promise(N=>{this.a(T),this.d={outcome:0,value:T},N()})}error(T){return new Promise(N=>{this.b(T),this.d={outcome:1,value:T},N()})}cancel(){return this.error(new O.$5)}}e.$rh=ne;var me;(function(B){async function T(q){let ie;const ae=await Promise.all(q.map(ge=>ge.then(ce=>ce,ce=>{ie||(ie=ce)})));if(typeof ie<"u")throw ie;return ae}B.settled=T;function N(q){return new Promise(async(ie,ae)=>{try{await q(ie,ae)}catch(ge){ae(ge)}})}B.withAsyncBody=N})(me||(e.Promises=me={}));class z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(T){this.a=void 0,this.b=void 0,this.d=!1,this.promise=T.then(N=>(this.a=N,this.d=!0,N),N=>{throw this.b=N,this.d=!0,N})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$sh=z;class H{constructor(T){this.b=T,this.a=new w.$V(()=>new z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$th=H;var R;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(R||(R={}));class U{static fromArray(T){return new U(N=>{N.emitMany(T)})}static fromPromise(T){return new U(async N=>{N.emitMany(await T)})}static fromPromises(T){return new U(async N=>{await Promise.all(T.map(async q=>N.emitOne(await q)))})}static merge(T){return new U(async N=>{await Promise.all(T.map(async q=>{for await(const ie of q)N.emitOne(ie)}))})}static{this.EMPTY=U.fromArray([])}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new r.$Wd,queueMicrotask(async()=>{const N={emitOne:q=>this.g(q),emitMany:q=>this.h(q),reject:q=>this.k(q)};try{await Promise.resolve(T(N)),this.j()}catch(q){this.k(q)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(T,N){return new U(async q=>{for await(const ie of T)q.emitOne(N(ie))})}map(T){return U.map(this,T)}static filter(T,N){return new U(async q=>{for await(const ie of T)N(ie)&&q.emitOne(ie)})}filter(T){return U.filter(this,T)}static coalesce(T){return U.filter(T,N=>!!N)}coalesce(){return U.coalesce(this)}static async toPromise(T){const N=[];for await(const q of T)N.push(q);return N}toPromise(){return U.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.$uh=U;class x extends U{constructor(T,N){super(N),this.l=T}cancel(){this.l.cancel()}}e.$vh=x;function J(B){const T=new k.$7d,N=B(T.token);return new x(T,async q=>{const ie=T.token.onCancellationRequested(()=>{ie.dispose(),T.dispose(),q.reject(new O.$5)});try{for await(const ae of N){if(T.token.isCancellationRequested)return;q.emitOne(ae)}ie.dispose(),T.dispose()}catch(ae){ie.dispose(),T.dispose(),q.reject(ae)}})}e.$wh=J;class Y{constructor(){this.a=new ne,this.b=new U(q=>{if(T){q.reject(T);return}return N&&q.emitMany(N),this.d=ie=>q.reject(ie),this.f=ie=>q.emitOne(ie),this.a.p});let T,N;this.f=q=>{N||(N=[]),N.push(q)},this.d=q=>{T||(T=q)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(T){this.d(T),this.a.complete()}emitOne(T){this.f(T)}}e.$xh=Y}),define(be[80],ve([1,0,18,15,40,24,7,3,17]),function(he,e,k,O,r,I,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=void 0;function w(){return Object.create(null)}e.$Ij=w,e.$Jj="**",e.$Kj="/";const C="[/\\\\]",E="[^/\\\\]",b=/\//g;function h(te,V){switch(te){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${V?`|${C}${E}+`:""})*?`}}function $(te,V){if(!te)return[];const W=[];let re=!1,ue=!1,ne="";for(const me of te){switch(me){case V:if(!re&&!ue){W.push(ne),ne="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ne+=me}return ne&&W.push(ne),W}e.$Lj=$;function c(te){if(!te)return"";let V="";const W=$(te,e.$Kj);if(W.every(re=>re===e.$Jj))V=".*";else{let re=!1;W.forEach((ue,ne)=>{if(ue===e.$Jj){if(re)return;V+=h(2,ne===W.length-1)}else{let me=!1,z="",H=!1,R="";for(const U of ue){if(U!=="}"&&me){z+=U;continue}if(H&&(U!=="]"||!R)){let x;U==="-"?x=U:(U==="^"||U==="!")&&!R?x="^":U===e.$Kj?x="":x=(0,v.$Pe)(U),R+=x;continue}switch(U){case"{":me=!0;continue;case"[":H=!0;continue;case"}":{const J=`(?:${$(z,",").map(Y=>c(Y)).join("|")})`;V+=J,me=!1,z="";break}case"]":{V+="["+R+"]",H=!1,R="";break}case"?":V+=E;continue;case"*":V+=h(1);continue;default:V+=(0,v.$Pe)(U)}}ne<W.length-1&&(W[ne+1]!==e.$Jj||ne+2<W.length)&&(V+=C)}re=ue===e.$Jj})}return V}const g=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$Dc(1e4),o=function(){return!1},n=function(){return null};function s(te,V){if(!te)return n;let W;typeof te!="string"?W=te.pattern:W=te,W=W.trim();const re=`${W}_${!!V.trimForExclusions}`;let ue=t.get(re);if(ue)return i(ue,te);let ne;return g.test(W)?ue=p(W.substr(4),W):(ne=d.exec(a(W,V)))?ue=L(ne[1],W):(V.trimForExclusions?f:m).test(W)?ue=P(W,V):(ne=u.exec(a(W,V)))?ue=y(ne[1].substr(1),W,!0):(ne=l.exec(a(W,V)))?ue=y(ne[1],W,!1):ue=A(W),t.set(re,ue),i(ue,te)}function i(te,V){if(typeof V=="string")return te;const W=function(re,ue){return(0,r.$9f)(re,V.base,!S.$k)?te((0,v.$Ue)(re.substr(V.base.length),D.sep),ue):null};return W.allBasenames=te.allBasenames,W.allPaths=te.allPaths,W.basenames=te.basenames,W.patterns=te.patterns,W}function a(te,V){return V.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function p(te,V){return function(W,re){return typeof W=="string"&&W.endsWith(te)?V:null}}function L(te,V){const W=`/${te}`,re=`\\${te}`,ue=function(me,z){return typeof me!="string"?null:z?z===te?V:null:me===te||me.endsWith(W)||me.endsWith(re)?V:null},ne=[te];return ue.basenames=ne,ue.patterns=[V],ue.allBasenames=ne,ue}function P(te,V){const W=Z(te.slice(1,-1).split(",").map(z=>s(z,V)).filter(z=>z!==n),te),re=W.length;if(!re)return n;if(re===1)return W[0];const ue=function(z,H){for(let R=0,U=W.length;R<U;R++)if(W[R](z,H))return te;return null},ne=W.find(z=>!!z.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const me=W.reduce((z,H)=>H.allPaths?z.concat(H.allPaths):z,[]);return me.length&&(ue.allPaths=me),ue}function y(te,V,W){const re=D.sep===D.$gc.sep,ue=re?te:te.replace(b,D.sep),ne=D.sep+ue,me=D.$gc.sep+te;let z;return W?z=function(H,R){return typeof H=="string"&&(H===ue||H.endsWith(ne)||!re&&(H===te||H.endsWith(me)))?V:null}:z=function(H,R){return typeof H=="string"&&(H===ue||!re&&H===te)?V:null},z.allPaths=[(W?"*/":"./")+te],z}function A(te){try{const V=new RegExp(`^${c(te)}$`);return function(W){return V.lastIndex=0,typeof W=="string"&&V.test(W)?te:null}}catch{return n}}function M(te,V,W){return!te||typeof V!="string"?!1:_(te)(V,void 0,W)}e.$Mj=M;function _(te,V={}){if(!te)return o;if(typeof te=="string"||se(te)){const W=s(te,V);if(W===n)return o;const re=function(ue,ne){return!!W(ue,ne)};return W.allBasenames&&(re.allBasenames=W.allBasenames),W.allPaths&&(re.allPaths=W.allPaths),re}return ee(te,V)}e.$Nj=_;function se(te){const V=te;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$Oj=se;function G(te){return te.allBasenames||[]}e.$Pj=G;function oe(te){return te.allPaths||[]}e.$Qj=oe;function ee(te,V){const W=Z(Object.getOwnPropertyNames(te).map(z=>K(z,te[z],V)).filter(z=>z!==n)),re=W.length;if(!re)return n;if(!W.some(z=>!!z.requiresSiblings)){if(re===1)return W[0];const z=function(U,x){let J;for(let Y=0,B=W.length;Y<B;Y++){const T=W[Y](U,x);if(typeof T=="string")return T;(0,O.$Tg)(T)&&(J||(J=[]),J.push(T))}return J?(async()=>{for(const Y of J){const B=await Y;if(typeof B=="string")return B}return null})():null},H=W.find(U=>!!U.allBasenames);H&&(z.allBasenames=H.allBasenames);const R=W.reduce((U,x)=>x.allPaths?U.concat(x.allPaths):U,[]);return R.length&&(z.allPaths=R),z}const ue=function(z,H,R){let U,x;for(let J=0,Y=W.length;J<Y;J++){const B=W[J];B.requiresSiblings&&R&&(H||(H=(0,D.$nc)(z)),U||(U=H.substr(0,H.length-(0,D.$oc)(z).length)));const T=B(z,H,U,R);if(typeof T=="string")return T;(0,O.$Tg)(T)&&(x||(x=[]),x.push(T))}return x?(async()=>{for(const J of x){const Y=await J;if(typeof Y=="string")return Y}return null})():null},ne=W.find(z=>!!z.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const me=W.reduce((z,H)=>H.allPaths?z.concat(H.allPaths):z,[]);return me.length&&(ue.allPaths=me),ue}function K(te,V,W){if(V===!1)return n;const re=s(te,W);if(re===n)return n;if(typeof V=="boolean")return re;if(V){const ue=V.when;if(typeof ue=="string"){const ne=(me,z,H,R)=>{if(!R||!re(me,z))return null;const U=ue.replace("$(basename)",()=>H),x=R(U);return(0,O.$Tg)(x)?x.then(J=>J?te:null):x?te:null};return ne.requiresSiblings=!0,ne}}return re}function Z(te,V){const W=te.filter(z=>!!z.basenames);if(W.length<2)return te;const re=W.reduce((z,H)=>{const R=H.basenames;return R?z.concat(R):z},[]);let ue;if(V){ue=[];for(let z=0,H=re.length;z<H;z++)ue.push(V)}else ue=W.reduce((z,H)=>{const R=H.patterns;return R?z.concat(R):z},[]);const ne=function(z,H){if(typeof z!="string")return null;if(!H){let U;for(U=z.length;U>0;U--){const x=z.charCodeAt(U-1);if(x===47||x===92)break}H=z.substr(U)}const R=re.indexOf(H);return R!==-1?ue[R]:null};ne.basenames=re,ne.patterns=ue,ne.allBasenames=re;const me=te.filter(z=>!z.basenames);return me.push(ne),me}function X(te,V){return(0,k.$ub)(te,V,(W,re)=>typeof W=="string"&&typeof re=="string"?W===re:typeof W!="string"&&typeof re!="string"?W.base===re.base&&W.pattern===re.pattern:!1)}e.$Rj=X}),define(be[100],ve([1,0,10,153,19,17,4]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(S||(e.MarkdownStringTextNewlineStyle=S={}));class v{constructor(m="",f=!1){if(this.value=m,typeof this.value!="string")throw(0,k.$7)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(m,f=0){return this.value+=b(this.supportThemeIcons?(0,O.$ck)(m):m).replace(/([ \t]+)/g,(u,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,f){return this.value+=`
${h(f,m)}
`,this}appendLink(m,f,u){return this.value+="[",this.value+=this.c(f,"]"),this.value+="](",this.value+=this.c(String(m),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(m,f){const u=new RegExp((0,I.$Pe)(f),"g");return m.replace(u,(l,t)=>m.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$ik=v;function w(d){return C(d)?!d.value:Array.isArray(d)?d.every(w):!0}e.$jk=w;function C(d){return d instanceof v?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.$kk=C;function E(d,m){return d===m?!0:!d||!m?!1:d.value===m.value&&d.isTrusted===m.isTrusted&&d.supportThemeIcons===m.supportThemeIcons&&d.supportHtml===m.supportHtml&&(d.baseUri===m.baseUri||!!d.baseUri&&!!m.baseUri&&(0,r.$Bg)(D.URI.from(d.baseUri),D.URI.from(m.baseUri)))}e.$lk=E;function b(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$mk=b;function h(d,m){const f=d.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,u=f>=3?f+1:3;return[`${"`".repeat(u)}${m}`,d,`${"`".repeat(u)}`].join(`
`)}e.$nk=h;function $(d){return d.replace(/"/g,"&quot;")}e.$ok=$;function c(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$pk=c;function g(d){const m=[],f=d.split("|").map(l=>l.trim());d=f[0];const u=f[1];if(u){const l=/height=(\d+)/.exec(u),t=/width=(\d+)/.exec(u),o=l?l[1]:"",n=t?t[1]:"",s=isFinite(parseInt(n)),i=isFinite(parseInt(o));s&&m.push(`width="${n}"`),i&&m.push(`height="${o}"`)}return{href:d,dimensions:m}}e.$qk=g}),define(be[170],ve([1,0,18,40,7,3,19,17]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=void 0;function v(s,i){const{os:a,tildify:p,relative:L}=i;if(L){const A=w(s,L,a);if(typeof A=="string")return A}let P=s.fsPath;if(a===1&&!I.$i?P=P.replace(/\//g,"\\"):a!==1&&I.$i&&(P=P.replace(/\\/g,"/")),a!==1&&p?.userHome){const A=p.userHome.fsPath;let M;s.scheme!==p.userHome.scheme&&s.path[0]===r.$gc.sep&&s.path[1]!==r.$gc.sep?M=p.userHome.with({path:s.path}).fsPath:M=P,P=b(M,A,a)}return(a===1?r.$fc:r.$gc).normalize(C(P,a===1))}e.$Wv=v;function w(s,i,a){const p=a===1?r.$fc:r.$gc,L=a===3?D.$yg:D.$Ag,P=i.getWorkspace(),y=(0,k.$Ob)(P.folders);if(!y)return;s.scheme!==y.uri.scheme&&s.path[0]===r.$gc.sep&&s.path[1]!==r.$gc.sep&&(s=y.uri.with({path:s.path}));const A=i.getWorkspaceFolder(s);if(!A)return;let M;if(L.isEqual(A.uri,s)?M="":M=L.relativePath(A.uri,s)??"",M&&(M=p.normalize(M)),P.folders.length>1&&!i.noPrefix){const _=A.name?A.name:L.basenameOrAuthority(A.uri);M=M?`${_} \u2022 ${M}`:_}return M}function C(s,i=I.$i){return(0,O.$ag)(s,i)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$Xv=C;let E=Object.create(null);function b(s,i,a=I.OS){if(a===1||!s||!i)return s;let p=E.original===i?E.normalized:void 0;p||(p=i,I.$i&&(p=(0,O.$3f)(p)),p=`${(0,S.$Ve)(p,r.$gc.sep)}${r.$gc.sep}`,E={original:i,normalized:p});let L=s;return I.$i&&(L=(0,O.$3f)(L)),(a===3?L.startsWith(p):(0,S.$bf)(L,p))?`~/${L.substr(p.length)}`:s}e.$Yv=b;function h(s,i){return s.replace(/^~($|\/|\\)/,`${i}$1`)}e.$Zv=h;const $="\u2026",c="\\\\",g="~";function d(s,i=r.sep){const a=new Array(s.length);let p=!1;for(let L=0;L<s.length;L++){const P=s[L];if(P===""){a[L]=`.${i}`;continue}if(!P){a[L]=P;continue}p=!0;let y="",A=P;A.indexOf(c)===0?(y=A.substr(0,A.indexOf(c)+c.length),A=A.substr(A.indexOf(c)+c.length)):A.indexOf(i)===0?(y=A.substr(0,A.indexOf(i)+i.length),A=A.substr(A.indexOf(i)+i.length)):A.indexOf(g)===0&&(y=A.substr(0,A.indexOf(g)+g.length),A=A.substr(A.indexOf(g)+g.length));const M=A.split(i);for(let _=1;p&&_<=M.length;_++)for(let se=M.length-_;p&&se>=0;se--){p=!1;let G=M.slice(se,se+_).join(i);for(let oe=0;!p&&oe<s.length;oe++)if(oe!==L&&s[oe]&&s[oe].indexOf(G)>-1){const ee=se+_===M.length,K=se>0&&s[oe].indexOf(i)>-1?i+G:G,Z=s[oe].endsWith(K);p=!ee||Z}if(!p){let oe="";(M[0].endsWith(":")||y!=="")&&(se===1&&(se=0,_++,G=M[0]+i+G),se>0&&(oe=M[0]+i),oe=y+oe),se>0&&(oe=oe+$+i),oe=oe+G,se+_<M.length&&(oe=oe+i+$),a[L]=oe}}p&&(a[L]=P)}return a}e.$1v=d;var m;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function f(s,i=Object.create(null)){const a=[];let p=!1,L="";for(const P of s)if(P==="$"||p&&P==="{")L&&a.push({value:L,type:m.TEXT}),L="",p=!0;else if(P==="}"&&p){const y=i[L];if(typeof y=="string")y.length&&a.push({value:y,type:m.VARIABLE});else if(y){const A=a[a.length-1];(!A||A.type!==m.SEPARATOR)&&a.push({value:y.label,type:m.SEPARATOR})}L="",p=!1}else L+=P;return L&&!p&&a.push({value:L,type:m.TEXT}),a.filter((P,y)=>{if(P.type===m.SEPARATOR){const A=a[y-1],M=a[y+1];return[A,M].every(_=>_&&(_.type===m.VARIABLE||_.type===m.TEXT)&&_.value.length>0)}return!0}).map(P=>P.value).join("")}e.$2v=f;function u(s,i){return I.$j||i?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$j?"&":"&&"):s.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$3v=u;function l(s,i){return I.$j||i?s.replace(/\(&&\w\)|&&/g,""):I.$i?s.replace(/&&|&/g,a=>a==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$4v=l;function t(s){return s.replace(/&/g,"&&")}e.$5v=t;function o(s){if(s.endsWith("]")){const i=s.lastIndexOf(" [",s.length-2);if(i!==-1){const a=n(s.substring(0,i)),p=s.substring(i);return{name:a.name+p,parentPath:a.parentPath}}}return n(s)}e.$6v=o;function n(s){const i=s.indexOf("/")!==-1?r.$gc:r.$fc,a=i.basename(s),p=i.dirname(s);return a.length?{name:a,parentPath:p}:{name:p,parentPath:""}}}),define(be[53],ve([1,0,14,4]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=void 0;function r(E){return E.toJSON()}class I{constructor(b){this.a=b}transformIncoming(b){const h=this.a.transformIncoming(b);return h===b?b:r(O.URI.from(h))}transformOutgoing(b){const h=this.a.transformOutgoing(b);return h===b?b:r(O.URI.from(h))}transformOutgoingURI(b){const h=this.a.transformOutgoing(b);return h===b?b:O.URI.from(h)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$5m=I,e.$6m=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function D(E,b,h){if(!E||h>200)return null;if(typeof E=="object"){if(E instanceof O.URI)return b.transformOutgoing(E);for(const $ in E)if(Object.hasOwnProperty.call(E,$)){const c=D(E[$],b,h+1);c!==null&&(E[$]=c)}}return null}function S(E,b){const h=D(E,b,0);return h===null?E:h}e.$7m=S;function v(E,b,h,$){if(!E||$>200)return null;if(typeof E=="object"){if(E.$mid===1)return h?O.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);if(E instanceof k.$ke)return null;for(const c in E)if(Object.hasOwnProperty.call(E,c)){const g=v(E[c],b,h,$+1);g!==null&&(E[c]=g)}}return null}function w(E,b){const h=v(E,b,!1,0);return h===null?E:h}e.$8m=w;function C(E,b){const h=v(E,b,!0,0);return h===null?E:h}e.$9m=C}),define(be[101],ve([1,0,28,64,22,156,3]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=void 0,e.$$m=new class{c(b){return this.a||(this.a=O.$ai.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,h=0;const $=(0,k.networkInterfaces)();for(const c in $){const g=$[c];if(g)for(const{mac:d,internal:m}of g)m||(h+=1,this.c(d.toUpperCase())&&(b+=1))}this.b=h>0?b/h:0}return this.b}};let S;async function v(b){return S||(S=(async()=>await w(b)||r.$rg())()),S}e.$_m=v;async function w(b){try{const h=await new Promise((c,g)=>{he(["crypto"],c,g)}),$=(0,I.$0m)();return h.createHash("sha256").update($,"utf8").digest("hex")}catch(h){b(h);return}}const C="Software\\Microsoft\\SQMClient";async function E(b){if(D.$i){const h=await new Promise(($,c)=>{he(["@vscode/windows-registry"],$,c)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch($){return b($),""}}return""}e.$an=E}),define(be[171],ve([1,0,27,298,299,3]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=void 0;async function D(S){if(I.$j||I.$i)return;let v;for(const w of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{v=await(0,O.open)(w,k.constants.R_OK);break}catch{}if(!v){S("Unable to retrieve release information from known identifier paths.");return}try{const w=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),C={id:"unknown"};for await(const E of(0,r.createInterface)({input:v.createReadStream(),crlfDelay:1/0})){if(!E.includes("="))continue;const b=E.split("=")[0].toUpperCase().trim();if(w.has(b)){const h=E.split("=")[1].replace(/"/g,"").toLowerCase().trim();b==="ID"||b==="DISTRIB_ID"?C.id=h:b==="ID_LIKE"?C.id_like=h:(b==="VERSION_ID"||b==="DISTRIB_RELEASE")&&(C.version_id=h)}}return C}catch(w){S(w)}}e.$sg=D}),define(be[23],ve([1,0,27,28,300,15,40,98,7,3,19,4]),function(he,e,k,O,r,I,D,S,v,w,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function h(K,Z=b.UNLINK,X){if((0,D.$_f)(K))throw new Error("rimraf - will refuse to recursively delete root");return Z===b.UNLINK?c(K):$(K,X)}async function $(K,Z=(0,D.$eg)((0,O.tmpdir)())){try{try{await k.promises.rename(K,Z)}catch(X){return X.code==="ENOENT"?void 0:c(K)}c(Z).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function c(K){return(0,r.promisify)(k.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function g(K){if((0,D.$_f)(K))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function d(K,Z){return u(await(Z?m(K):(0,r.promisify)(k.readdir)(K)))}async function m(K){try{return await(0,r.promisify)(k.readdir)(K,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const Z=[],X=await d(K);for(const te of X){let V=!1,W=!1,re=!1;try{const ue=await e.Promises.lstat((0,v.$jc)(K,te));V=ue.isFile(),W=ue.isDirectory(),re=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}Z.push({name:te,isFile:()=>V,isDirectory:()=>W,isSymbolicLink:()=>re})}return Z}function f(K){return u(k.readdirSync(K))}e.readdirSync=f;function u(K){return K.map(Z=>typeof Z=="string"?w.$j?(0,S.$Hl)(Z):Z:(Z.name=w.$j?(0,S.$Hl)(Z.name):Z.name,Z))}async function l(K){const Z=await d(K),X=[];for(const te of Z)await o.existsDirectory((0,v.$jc)(K,te))&&X.push(te);return X}function t(K,Z=1e3){return new Promise(X=>{let te=!1;const V=setInterval(()=>{te||(te=!0,k.access(K,W=>{te=!1,W&&(clearInterval(V),X(void 0))}))},Z)})}e.whenDeleted=t;var o;(function(K){async function Z(V){let W;try{if(W=await e.Promises.lstat(V),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(re){if(re.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(w.$i&&re.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ue}throw re}}K.stat=Z;async function X(V){try{const{stat:W,symbolicLink:re}=await K.stat(V);return W.isFile()&&re?.dangling!==!0}catch{}return!1}K.existsFile=X;async function te(V){try{const{stat:W,symbolicLink:re}=await K.stat(V);return W.isDirectory()&&re?.dangling!==!0}catch{}return!1}K.existsDirectory=te})(o||(e.SymlinkSupport=o={}));const n=new I.$dh;function s(K,Z,X){return n.queueFor(E.URI.file(K),()=>{const te=P(X);return new Promise((V,W)=>p(K,Z,te,re=>re?W(re):V()))},C.$zg)}let i=!0;function a(K){i=K}e.configureFlushOnWrite=a;function p(K,Z,X,te){if(!i)return k.writeFile(K,Z,{mode:X.mode,flag:X.flag},te);k.open(K,X.flag,X.mode,(V,W)=>{if(V)return te(V);k.writeFile(W,Z,re=>{if(re)return k.close(W,()=>te(re));k.fdatasync(W,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),a(!1)),k.close(W,ne=>te(ne))))})})}function L(K,Z,X){const te=P(X);if(!i)return k.writeFileSync(K,Z,{mode:te.mode,flag:te.flag});const V=k.openSync(K,te.flag,te.mode);try{k.writeFileSync(V,Z);try{k.fdatasyncSync(V)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),a(!1)}}finally{k.closeSync(V)}}e.writeFileSync=L;function P(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function y(K,Z,X=6e4){if(K!==Z)try{w.$i&&typeof X=="number"?await A(K,Z,Date.now(),X):await(0,r.promisify)(k.rename)(K,Z)}catch(te){if(K.toLowerCase()!==Z.toLowerCase()&&te.code==="EXDEV"||K.endsWith("."))await M(K,Z,{preserveSymlinks:!1}),await h(K,b.MOVE);else throw te}}async function A(K,Z,X,te,V=0){try{return await(0,r.promisify)(k.rename)(K,Z)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-X>=te)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${W}`),W;if(V===0){let re=!1;try{const{stat:ue}=await o.stat(Z);ue.isFile()||(re=!0)}catch{}if(re)throw W}return await(0,I.$8g)(Math.min(100,V*10)),A(K,Z,X,te,V+1)}}async function M(K,Z,X){return se(K,Z,{root:{source:K,target:Z},options:X,handledSourcePaths:new Set})}const _=511;async function se(K,Z,X){if(X.handledSourcePaths.has(K))return;X.handledSourcePaths.add(K);const{stat:te,symbolicLink:V}=await o.stat(K);if(V){if(X.options.preserveSymlinks)try{return await ee(K,Z,X)}catch{}if(V.dangling)return}return te.isDirectory()?G(K,Z,te.mode&_,X):oe(K,Z,te.mode&_)}async function G(K,Z,X,te){await e.Promises.mkdir(Z,{recursive:!0,mode:X});const V=await d(K);for(const W of V)await se((0,v.$jc)(K,W),(0,v.$jc)(Z,W),te)}async function oe(K,Z,X){await e.Promises.copyFile(K,Z),await e.Promises.chmod(Z,X)}async function ee(K,Z,X){let te=await e.Promises.readlink(K);(0,D.$9f)(te,X.root.source,!w.$k)&&(te=(0,v.$jc)(X.root.target,te.substr(X.root.source.length+1))),await e.Promises.symlink(te,Z)}e.Promises=new class{get access(){return(0,r.promisify)(k.access)}get stat(){return(0,r.promisify)(k.stat)}get lstat(){return(0,r.promisify)(k.lstat)}get utimes(){return(0,r.promisify)(k.utimes)}get read(){return(K,Z,X,te,V)=>new Promise((W,re)=>{k.read(K,Z,X,te,V,(ue,ne,me)=>ue?re(ue):W({bytesRead:ne,buffer:me}))})}get readFile(){return(0,r.promisify)(k.readFile)}get write(){return(K,Z,X,te,V)=>new Promise((W,re)=>{k.write(K,Z,X,te,V,(ue,ne,me)=>ue?re(ue):W({bytesWritten:ne,buffer:me}))})}get appendFile(){return(0,r.promisify)(k.appendFile)}get fdatasync(){return(0,r.promisify)(k.fdatasync)}get truncate(){return(0,r.promisify)(k.truncate)}get copyFile(){return(0,r.promisify)(k.copyFile)}get open(){return(0,r.promisify)(k.open)}get close(){return(0,r.promisify)(k.close)}get symlink(){return(0,r.promisify)(k.symlink)}get readlink(){return(0,r.promisify)(k.readlink)}get chmod(){return(0,r.promisify)(k.chmod)}get mkdir(){return(0,r.promisify)(k.mkdir)}get unlink(){return(0,r.promisify)(k.unlink)}get rmdir(){return(0,r.promisify)(k.rmdir)}get realpath(){return(0,r.promisify)(k.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return l}get writeFile(){return s}get rm(){return h}get rename(){return y}get copy(){return M}}}),define(be[172],ve([1,0,27,7,3,17,23]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=e.$uq=void 0;function S(b){if(r.$k)return b;const h=(0,O.$mc)(b);if(b===h)return b;const $=((0,O.$nc)(b)||b).toLowerCase();try{const g=(0,D.readdirSync)(h).filter(d=>d.toLowerCase()===$);if(g.length===1){const d=S(h);if(d)return(0,O.$jc)(d,g[0])}else if(g.length>1){const d=g.indexOf($);if(d>=0){const m=S(h);if(m)return(0,O.$jc)(m,g[d])}}}catch{}return null}e.$uq=S;async function v(b){if(r.$k)return b;const h=(0,O.$mc)(b);if(b===h)return b;const $=((0,O.$nc)(b)||b).toLowerCase();try{const g=(await D.Promises.readdir(h)).filter(d=>d.toLowerCase()===$);if(g.length===1){const d=await v(h);if(d)return(0,O.$jc)(d,g[0])}else if(g.length>1){const d=g.indexOf($);if(d>=0){const m=await v(h);if(m)return(0,O.$jc)(m,g[d])}}}catch{}return null}e.$vq=v;async function w(b){try{return await D.Promises.realpath(b)}catch{const $=E(b);return await D.Promises.access($,k.constants.R_OK),$}}e.$wq=w;function C(b){try{return k.realpathSync(b)}catch{const $=E(b);return k.accessSync($,k.constants.R_OK),$}}e.$xq=C;function E(b){return(0,I.$Ve)((0,O.$hc)(b),O.sep)}}),define(be[102],ve([1,0,28,7,23]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0;const I=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var v;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(v||(v={}));let w;switch(process.arch){case"ia32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class E{constructor(l,t,o){this.exePath=l,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:u=!1}={}){return u?w===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:u=!1,findPreview:l=!1}={}){const t=b({useAlternateBitness:u});if(!t)return null;const o=O.$jc(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(o))return null;let n=-1,s=null;for(const p of await r.Promises.readdir(o)){let L=-1;if(l){const y=p.indexOf("-");if(y<0)continue;const A=p.substring(0,y);if(!I.test(A)||p.substring(y+1)!=="preview")continue;L=parseInt(A,10)}else{if(!I.test(p))continue;L=parseInt(p,10)}if(L<=n)continue;const P=O.$jc(o,p,"pwsh.exe");await r.SymlinkSupport.existsFile(P)&&(s=P,n=L)}if(!s)return null;const i=t.includes("x86")?" (x86)":"",a=l?" Preview":"";return new E(s,`PowerShell${a}${i}`,!0)}async function $({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const l=O.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=u?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const n of await r.Promises.readdir(l))if(t.test(n)){const s=O.$jc(l,n,"pwsh.exe");return new E(s,o)}return null}function c(){const u=O.$jc(k.homedir(),".dotnet","tools","pwsh.exe");return new E(u,".NET Core PowerShell Global Tool")}function g(){const u=O.$jc(process.env.windir,w===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(u,"Windows PowerShell",!0)}async function*d(){let u=await h();u&&(yield u),u=await h({useAlternateBitness:!0}),u&&(yield u),u=await $(),u&&(yield u),u=c(),u&&(yield u),u=await h({findPreview:!0}),u&&(yield u),u=await $({findPreview:!0}),u&&(yield u),u=await h({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=g(),u&&(yield u)}async function*m(){for await(const u of d())await u.exists()&&(yield u)}e.$Ql=m;async function f(){for await(const u of m())return u;return null}e.$Rl=f}),define(be[103],ve([1,0,7,3,29,66,11,23]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Vl=e.$Ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function v(E=r.env){return E.comspec||"cmd.exe"}e.$Ul=v;function w(E){let b=[],h=!1;const $=function(c){if(h){b.push(c);return}(!E.send(c,d=>{if(d&&console.error(d),h=!1,b.length>0){const m=b.slice(0);b=[],m.forEach(f=>$(f))}})||O.$i)&&(h=!0)};return{send:$}}e.$Vl=w;var C;(function(E){async function b(h,$,c){if(k.$ic(h))return h;if($===void 0&&($=r.cwd()),k.$mc(h)!=="."||(c===void 0&&D.$Jf(r.env.PATH)&&(c=r.env.PATH.split(k.$tc)),c===void 0||c.length===0))return k.$jc($,h);async function d(m){if(await S.Promises.exists(m)){let f;try{f=await S.Promises.stat(m)}catch(u){u.message.startsWith("EACCES")&&(f=await S.Promises.lstat(m))}return f?!f.isDirectory():!1}return!1}for(const m of c){let f;if(k.$ic(m)?f=k.$jc(m,h):f=k.$jc($,m,h),await d(f))return f;let u=f+".com";if(await d(u)||(u=f+".exe",await d(u)))return u}return k.$jc($,h)}E.findExecutable=b})(C||(e.win32=C={}))}),define(be[104],ve([1,0,54,12]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0;function r(D){return new Promise((S,v)=>{let w;const C=new Map;function E(h,$,c,g,d){const m=C.get($);if(h===D||m){const f={name:b(c),cmd:c,pid:h,ppid:$,load:g,mem:d};C.set(h,f),h===D&&(w=f),m&&(m.children||(m.children=[]),m.children.push(f),m.children.length>1&&(m.children=m.children.sort((u,l)=>u.pid-l.pid)))}}function b(h){const $=/--utility-sub-type=network/i,c=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,m=/--type=([a-zA-Z-]+)/;if(c.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-agent";if(d.exec(h))return"conpty-agent";let f=m.exec(h);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?$.exec(h)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const u=/[a-zA-Z-]+\.js/g;let l="";do f=u.exec(h),f&&(l+=f+" ");while(f);return l&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${l})`:h}if(process.platform==="win32"){const h=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,c)=>{he(["@vscode/windows-process-tree"],$,c)}).then($=>{$.getProcessList(D,c=>{if(!c){v(new Error(`Root process ${D} not found`));return}$.getProcessCpuUsage(c,g=>{const d=new Map;g.forEach(m=>{const f=h(m.commandLine||"");d.set(m.pid,{name:b(f),cmd:f,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),w=d.get(D),w?(d.forEach(m=>{const f=d.get(m.ppid);f&&(f.children||(f.children=[]),f.children.push(m))}),d.forEach(m=>{m.children&&(m.children=m.children.sort((f,u)=>f.pid-u.pid))}),S(w)):v(new Error(`Root process ${D} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let h=function(){let $=[w];const c=[];for(;$.length;){const d=$.shift();d&&(c.push(d.pid),d.children&&($=$.concat(d.children)))}let g=JSON.stringify(O.$pg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+c.join(" "),(0,k.exec)(g,{},(d,m,f)=>{if(d||f)v(d||new Error(f.toString()));else{const u=m.toString().split(`
`);for(let l=0;l<c.length;l++){const t=C.get(c[l]);t.load=parseFloat(u[l])}if(!w){v(new Error(`Root process ${D} not found`));return}S(w)}})};(0,k.exec)("which ps",{},($,c,g)=>{if($||g)if(process.platform!=="linux")v($||new Error(g.toString()));else{const d=JSON.stringify(O.$pg.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(d,{},(m,f,u)=>{m||u?v(m||new Error(u.toString())):(I(f,E),h())})}else{const d=c.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${d} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,u,l)=>{f||l&&!l.includes("screen size is bogus")?v(f||new Error(l.toString())):(I(u,E),process.platform==="linux"?h():w?S(w):v(new Error(`Root process ${D} not found`)))})}})}})}e.$6r=r;function I(D,S){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=D.toString().split(`
`);for(const C of w){const E=v.exec(C.trim());E&&E.length===6&&S(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(be[105],ve([1,0,28,3,102,103]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=void 0;async function D(E,b){return E===1?O.$i?C():I.$Ul(b):v(E,b)}e.$Wl=D;let S=null;function v(E,b){if(O.$k&&E===2||O.$j&&E===3)return"/bin/bash";if(!S){let h;if(O.$i)h="/bin/bash";else{if(h=b.SHELL,!h)try{h=(0,k.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}S=h}return S}let w=null;async function C(){return w||(w=(await(0,r.$Rl)()).exePath),w}});var Ne=this&&this.__decorate||function(he,e,k,O){var r=arguments.length,I=r<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,k):O,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(he,e,k,O);else for(var S=he.length-1;S>=0;S--)(D=he[S])&&(I=(r<3?D(I):r>3?D(e,k,I):D(e,k))||I);return r>3&&I&&Object.defineProperty(e,k,I),I};define(be[44],ve([1,0,18,15,14,20,75,10,6,2,52,17,11]),function(he,e,k,O,r,I,D,S,v,w,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.ProxyChannel=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.RequestInitiator=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;var h;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(h||(h={}));function $(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(c||(c={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(d||(d={}));function m(V){let W=0;for(let re=0;;re+=7){const ue=V.read(1);if(W|=(ue.buffer[0]&127)<<re,!(ue.buffer[0]&128))return W}}const f=n(0);function u(V,W){if(W===0){V.write(f);return}let re=0;for(let ne=W;ne!==0;ne=ne>>>7)re++;const ue=r.$ke.alloc(re);for(let ne=0;W!==0;ne++)ue.buffer[ne]=W&127,W=W>>>7,W>0&&(ue.buffer[ne]|=128);V.write(ue)}class l{constructor(W){this.b=W,this.a=0}read(W){const re=this.b.slice(this.a,this.a+W);return this.a+=re.byteLength,re}}e.$Eh=l;class t{constructor(){this.a=[]}get buffer(){return r.$ke.concat(this.a)}write(W){this.a.push(W)}}e.$Fh=t;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function n(V){const W=r.$ke.alloc(1);return W.writeUInt8(V,0),W}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},i=typeof Buffer<"u";function a(V,W){if(typeof W>"u")V.write(s.Undefined);else if(typeof W=="string"){const re=r.$ke.fromString(W);V.write(s.String),u(V,re.byteLength),V.write(re)}else if(i&&Buffer.isBuffer(W)){const re=r.$ke.wrap(W);V.write(s.Buffer),u(V,re.byteLength),V.write(re)}else if(W instanceof r.$ke)V.write(s.VSBuffer),u(V,W.byteLength),V.write(W);else if(Array.isArray(W)){V.write(s.Array),u(V,W.length);for(const re of W)a(V,re)}else if(typeof W=="number"&&(W|0)===W)V.write(s.Uint),u(V,W);else{const re=r.$ke.fromString(JSON.stringify(W));V.write(s.Object),u(V,re.byteLength),V.write(re)}}e.$Gh=a;function p(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(m(V)).toString();case o.Buffer:return V.read(m(V)).buffer;case o.VSBuffer:return V.read(m(V));case o.Array:{const re=m(V),ue=[];for(let ne=0;ne<re;ne++)ue.push(p(V));return ue}case o.Object:return JSON.parse(V.read(m(V)).toString());case o.Int:return m(V)}}e.$Hh=p;class L{constructor(W,re,ue=null,ne=1e3){this.h=W,this.j=re,this.k=ue,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(me=>this.q(me)),this.m({type:200})}registerChannel(W,re){this.b.set(W,re),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const re=this.o([W.type]);this.k?.logOutgoing(re,0,1,g(W.type));return}case 201:case 202:case 204:case 203:{const re=this.o([W.type,W.id],W.data);this.k?.logOutgoing(re,W.id,1,g(W.type),W.data);return}}}o(W,re=void 0){const ue=new t;return a(ue,W),a(ue,re),this.p(ue.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const re=new l(W),ue=p(re),ne=p(re),me=ue[0];switch(me){case 100:return this.k?.logIncoming(W.byteLength,ue[1],1,`${$(me)}: ${ue[2]}.${ue[3]}`,ne),this.s({type:me,id:ue[1],channelName:ue[2],name:ue[3],arg:ne});case 102:return this.k?.logIncoming(W.byteLength,ue[1],1,`${$(me)}: ${ue[2]}.${ue[3]}`,ne),this.t({type:me,id:ue[1],channelName:ue[2],name:ue[3],arg:ne});case 101:return this.k?.logIncoming(W.byteLength,ue[1],1,`${$(me)}`),this.u({type:me,id:ue[1]});case 103:return this.k?.logIncoming(W.byteLength,ue[1],1,`${$(me)}`),this.u({type:me,id:ue[1]})}}s(W){const re=this.b.get(W.channelName);if(!re){this.v(W);return}const ue=new I.$7d;let ne;try{ne=re.call(this.j,W.name,W.arg,ue.token)}catch(H){ne=Promise.reject(H)}const me=W.id;ne.then(H=>{this.m({id:me,data:H,type:201})},H=>{H instanceof Error?this.m({id:me,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:me,data:H,type:203})}).finally(()=>{z.dispose(),this.d.delete(W.id)});const z=(0,w.$Rc)(()=>ue.cancel());this.d.set(W.id,z)}t(W){const re=this.b.get(W.channelName);if(!re){this.v(W);return}const ue=W.id,me=re.listen(this.j,W.name,W.arg)(z=>this.m({id:ue,data:z,type:204}));this.d.set(W.id,me)}u(W){const re=this.d.get(W.id);re&&(re.dispose(),this.d.delete(W.id))}v(W){let re=this.g.get(W.channelName);re||(re=[],this.g.set(W.channelName,re));const ue=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);re.push({request:W,timeoutTimer:ue})}w(W){const re=this.g.get(W);if(re){for(const ue of re)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.s(ue.request);break;case 102:this.t(ue.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=L;var P;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class y{constructor(W,re=null){this.l=W,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ue=>this.s(ue)),this.j=re}getChannel(W){const re=this;return{call(ue,ne,me){return re.a?Promise.reject(new S.$5):re.m(W,ue,ne,me)},listen(ue,ne){return re.a?v.Event.None:re.o(W,ue,ne)}}}m(W,re,ue,ne=I.CancellationToken.None){const me=this.g++,H={id:me,type:100,channelName:W,name:re,arg:ue};if(ne.isCancellationRequested)return Promise.reject(new S.$5);let R;return new Promise((x,J)=>{if(ne.isCancellationRequested)return J(new S.$5);const Y=()=>{const q=ie=>{switch(ie.type){case 201:this.f.delete(me),x(ie.data);break;case 202:{this.f.delete(me);const ae=new Error(ie.data.message);ae.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,ae.name=ie.data.name,J(ae);break}case 203:this.f.delete(me),J(ie.data);break}};this.f.set(me,q),this.p(H)};let B=null;this.b===d.Idle?Y():(B=(0,O.$Ug)(q=>this.u()),B.then(()=>{B=null,Y()}));const T=()=>{B?(B.cancel(),B=null):this.p({id:me,type:101}),J(new S.$5)},N=ne.onCancellationRequested(T);R=(0,w.$Qc)((0,w.$Rc)(T),N),this.d.add(R)}).finally(()=>{R.dispose(),this.d.delete(R)})}o(W,re,ue){const ne=this.g++,z={id:ne,type:102,channelName:W,name:re,arg:ue};let H=null;const R=new v.$Wd({onWillAddFirstListener:()=>{H=(0,O.$Ug)(x=>this.u()),H.then(()=>{H=null,this.d.add(R),this.p(z)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(R),this.p({id:ne,type:103}))}}),U=x=>R.fire(x.data);return this.f.set(ne,U),R.event}p(W){switch(W.type){case 100:case 102:{const re=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(re,W.id,0,`${$(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const re=this.q([W.type,W.id]);this.j?.logOutgoing(re,W.id,0,$(W.type));return}}}q(W,re=void 0){const ue=new t;return a(ue,W),a(ue,re),this.r(ue.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const re=new l(W),ue=p(re),ne=p(re),me=ue[0];switch(me){case 200:return this.j?.logIncoming(W.byteLength,0,0,g(me)),this.t({type:ue[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ue[1],0,g(me),ne),this.t({type:ue[0],id:ue[1],data:ne})}}t(W){if(W.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=y,Ne([D.$yh],y.prototype,"onDidInitializePromise",null);class A{get connections(){const W=[];return this.f.forEach(re=>W.push(re)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new v.$Wd,this.onDidAddConnection=this.g.event,this.h=new v.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new w.$Sc,this.j.add(W(({protocol:re,onDidClientDisconnect:ue})=>{const ne=v.Event.once(re.onMessage);this.j.add(ne(me=>{const z=new l(me),H=p(z),R=new L(re,H),U=new y(re);this.a.forEach((J,Y)=>R.registerChannel(Y,J));const x={channelServer:R,channelClient:U,ctx:H};this.f.add(x),this.g.fire(x),this.j.add(ue(()=>{R.dispose(),U.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(W,re){const ue=this;return{call(ne,me,z){let H;if((0,b.$Xf)(re)){const U=(0,k.$4b)(ue.connections.filter(re));H=U?Promise.resolve(U):v.Event.toPromise(v.Event.filter(ue.onDidAddConnection,re))}else H=re.routeCall(ue,ne,me);const R=H.then(U=>U.channelClient.getChannel(W));return _(R).call(ne,me,z)},listen(ne,me){if((0,b.$Xf)(re))return ue.k(W,re,ne,me);const z=re.routeEvent(ue,ne,me).then(H=>H.channelClient.getChannel(W));return _(z).listen(ne,me)}}}k(W,re,ue,ne){const me=this;let z;const H=new v.$Wd({onWillAddFirstListener:()=>{z=new w.$Sc;const R=new v.$3d,U=new Map,x=Y=>{const T=Y.channelClient.getChannel(W).listen(ue,ne),N=R.add(T);U.set(Y,N)},J=Y=>{const B=U.get(Y);B&&(B.dispose(),U.delete(Y))};me.connections.filter(re).forEach(x),v.Event.filter(me.onDidAddConnection,re)(x,void 0,z),me.onDidRemoveConnection(J,void 0,z),R.event(H.fire,H,z),z.add(R)},onDidRemoveLastListener:()=>{z?.dispose(),z=void 0}});return H.event}registerChannel(W,re){this.a.set(W,re);for(const ue of this.f)ue.channelServer.registerChannel(W,re)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Kh=A;class M{constructor(W,re,ue=null){const ne=new t;a(ne,re),W.send(ne.buffer),this.a=new y(W,ue),this.d=new L(W,re,ue)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,re){this.d.registerChannel(W,re)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Lh=M;function _(V){return{call(W,re,ue){return V.then(ne=>ne.call(W,re,ue))},listen(W,re){const ue=new v.$6d;return V.then(ne=>ue.input=ne.listen(W,re)),ue.event}}}e.$Mh=_;function se(V){let W=!1;return{call(re,ue,ne){return W?V.call(re,ue,ne):(0,O.$8g)(0).then(()=>W=!0).then(()=>V.call(re,ue,ne))},listen(re,ue){if(W)return V.listen(re,ue);const ne=new v.$6d;return(0,O.$8g)(0).then(()=>W=!0).then(()=>ne.input=V.listen(re,ue)),ne.event}}}e.$Nh=se;class G{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const re of W.connections)if(await Promise.resolve(this.a(re.ctx)))return Promise.resolve(re);return await v.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$Oh=G;var oe;(function(V){function W(me,z,H){const R=me,U=H&&H.disableMarshalling,x=new Map;for(const J in R)ue(J)&&x.set(J,v.Event.buffer(R[J],!0,void 0,z));return new class{listen(J,Y,B){const T=x.get(Y);if(T)return T;if(ne(Y)){const N=R[Y];if(typeof N=="function")return N.call(R,B)}throw new S.$bb(`Event not found: ${Y}`)}call(J,Y,B){const T=R[Y];if(typeof T=="function"){if(!U&&Array.isArray(B))for(let q=0;q<B.length;q++)B[q]=(0,C.$Dh)(B[q]);let N=T.apply(R,B);return N instanceof Promise||(N=Promise.resolve(N)),N}throw new S.$bb(`Method not found: ${Y}`)}}}V.fromService=W;function re(me,z){const H=z&&z.disableMarshalling;return new Proxy({},{get(R,U){if(typeof U=="string")return z?.properties?.has(U)?z.properties.get(U):ne(U)?function(x){return me.listen(U,x)}:ue(U)?me.listen(U):async function(...x){let J;z&&!(0,b.$Sf)(z.context)?J=[z.context,...x]:J=x;const Y=await me.call(U,J);return H?Y:(0,C.$Dh)(Y)};throw new S.$bb(`Property not found: ${String(U)}`)}})}V.toService=re;function ue(me){return me[0]==="o"&&me[1]==="n"&&E.$_e(me.charCodeAt(2))}function ne(me){return/^onDynamic/.test(me)&&E.$_e(me.charCodeAt(9))}})(oe||(e.ProxyChannel=oe={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const W=V.toString();if(W!=="[object Object]")return W}return V}function Z(V){return Array.isArray(V)?V.map(K):K(V)}function X(V,W,re,ue,ne,me,z){z=Z(z);const H=ee[ne],R=H[ue%H.length];let U=[`%c[${V}]%c[${String(W).padStart(7," ")}]%c[len: ${String(re).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${me}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(me)?(U=U.concat(z),U.push(")")):U.push(z),console.log.apply(console,U)}class te{constructor(W,re){this.d=W,this.f=re,this.a=0,this.b=0}logOutgoing(W,re,ue,ne,me){this.b+=W,X(this.d,this.b,W,re,ue,ne,me)}logIncoming(W,re,ue,ne,me){this.a+=W,X(this.f,this.a,W,re,ue,ne,me)}}e.$Ph=te}),define(be[106],ve([1,0,14,6,2,44]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.ProtocolConstants=e.$Qh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var S;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let a=0;function p(P,y){if(!i.has(P)){const A=String(++a);i.set(P,A)}return i.get(P)}function L(P,y,A,M){if(!s.enableDiagnostics)return;const _=p(P,y);if(M instanceof k.$ke||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const se=k.$ke.alloc(M.byteLength);se.set(M),s.records.push({timestamp:Date.now(),id:_,label:y,type:A,buff:se})}else s.records.push({timestamp:Date.now(),id:_,label:y,type:A,data:M})}s.traceSocketEvent=L})(S||(e.SocketDiagnostics=S={}));var v;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let w=null;function C(){return w||(w=k.$ke.alloc(0)),w}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,a){if(i===0)return C();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const y=this.a[0];return a&&(this.a.shift(),this.b-=i),y}if(this.a[0].byteLength>i){const y=this.a[0].slice(0,i);return a&&(this.a[0]=this.a[0].slice(i),this.b-=i),y}const p=k.$ke.alloc(i);let L=0,P=0;for(;i>0;){const y=this.a[P];if(y.byteLength>i){const A=y.slice(0,i);p.set(A,L),L+=i,a&&(this.a[P]=y.slice(i),this.b-=i),i-=i}else p.set(y,L),L+=y.byteLength,a?(this.a.shift(),this.b-=y.byteLength):P++,i-=y.byteLength}return p}}e.$Qh=E;var b;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(b||(b={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class c{constructor(i,a,p,L){this.type=i,this.id=a,this.ack=p,this.data=L,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends r.$Tc{constructor(i){super(),this.f=this.B(new O.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new E,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,L=this.g.id,P=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new c(p,L,P,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=k.$ke.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(a,i.data)}g(i,a){const p=this.f===0;return this.d.push(i,a),this.f+=i.byteLength+a.byteLength,p}h(){const i=k.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,a){this.g(i,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class m extends r.$Tc{constructor(i){super(),this.f=new O.$Wd,this.onMessage=this.f.event,this.g=new O.$Wd,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new d(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new c(1,0,0,i))}}e.$Rh=m;class f extends I.$Lh{static fromSocket(i,a){return new f(new m(i),a)}get onDidDispose(){return this.b.onDidDispose}constructor(i,a,p=null){super(i,a,p),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$Sh=f;class u{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$Th=u;class l{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,a=this.a;for(;a;)a=a.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let a=0,p=this.a;for(;p;)i[a++]=p.data,p=p.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const a=new l(i);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const i=Date.now();for(let a=0;a<o.a;a++)this.c[a]=i-1e3*a;setInterval(()=>{for(let a=o.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),a=(1+o.a)*1e3;let p=0;for(let L=0;L<o.a;L++)i-this.c[L]<=a&&p++;return 1-p/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new u,this.onControlMessage=this.u.event,this.v=new u,this.onMessage=this.v.event,this.w=new u,this.onDidDispose=this.w.event,this.x=new u,this.onSocketClose=this.x.event,this.y=new u,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??o.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$Sc,this.o=i.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new c(5,0,0,C());this.p.write(i),this.p.flush()}sendPause(){const i=new c(7,0,0,C());this.p.write(i)}sendResume(){const i=new c(8,0,0,C());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,a){this.a=!0,this.r.dispose(),this.r=new r.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new c(3,0,this.h,C());this.p.write(i);const a=this.b.toArray();for(let p=0,L=a.length;p<L;p++)this.p.write(a[p]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const a=this.b.peek();if(a&&a.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new c(6,0,0,C())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let p=0,L=a.length;p<L;p++)this.p.write(a[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const a=++this.c;this.h=this.g;const p=new c(1,a,this.h,i);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(i){const a=new c(2,0,0,i);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),a=Date.now()-i.writtenTime,p=Date.now()-this.q.lastReadTime,L=Date.now()-this.n;if(a>=2e4&&p>=2e4&&L>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:p});return}const P=Math.max(2e4-a,2e4-p,2e4-L,500);this.f=setTimeout(()=>{this.f=null,this.B()},P)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new c(3,0,this.h,C());this.p.write(i)}D(){this.h=this.g;const i=new c(9,0,this.h,C());this.p.write(i)}}e.$Uh=n}),define(be[107],ve([1,0,54,15,14,20,168,10,6,2,21,103,66,44]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;class $ extends h.$Ih{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",m=>r.$ke.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$rq=$;class c{constructor(d,m){this.i=d,this.j=m,this.c=new Set,this.g=new Map,this.h=new v.$Wd,this.onDidProcessExit=this.h.event;const f=m&&m.timeout?m.timeout:6e4;this.b=new O.$4g(f),this.d=null,this.f=null}getChannel(d){const m=this;return{call(f,u,l){return m.k(d,f,u,l)},listen(f,u){return m.l(d,f,u)}}}k(d,m,f,u=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const l=this.n(d),t=(0,O.$Ug)(s=>l.call(m,f,s)),o=u.onCancellationRequested(()=>t.cancel()),n=(0,w.$Rc)(()=>t.cancel());return this.c.add(n),t.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,m,f){if(!this.b)return v.Event.None;this.b.cancel();let u;const l=new v.$Wd({onWillAddFirstListener:()=>{u=this.n(d).listen(m,f)(l.fire,l),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,C.$wn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,b.$Tl)(m.env),this.d=(0,k.fork)(this.i,d,m);const f=new v.$Wd;v.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,D.$nq)(i)){(0,D.log)(i,`IPC Library: ${this.j.serverName}`);return}f.fire(r.$ke.wrap(Buffer.from(i,"base64")))});const l=this.j.useQueue?(0,E.$Vl)(this.d):this.d,t=i=>this.d&&this.d.connected&&l.send(i.buffer.toString("base64")),o=f.event,n={send:t,onMessage:o};this.f=new h.$Jh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,a)=>{process.removeListener("exit",s),this.c.forEach(p=>(0,w.$Oc)(p)),this.c.clear(),i!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:a})})}return this.f}n(d){let m=this.g.get(d);return m||(m=this.m.getChannel(d),this.g.set(d,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$sq=c}),define(be[173],ve([1,0,15,6,2,52,11]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.StorageState=e.$qp=e.StorageHint=void 0;var S;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function v(b){const h=b;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$qp=v;var w;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(w||(e.StorageState=w={}));class C extends r.$Tc{static{this.a=100}constructor(h,$=Object.create(null)){super(),this.r=h,this.s=$,this.b=this.B(new O.$Zd),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new k.$5g(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach(($,c)=>this.w(c,$)),h.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(h,$){if(this.c===w.Closed)return;let c=!1;(0,D.$Sf)($)?c=this.f.delete(h):this.f.get(h)!==$&&(this.f.set(h,$),c=!0),c&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,$){const c=this.f.get(h);return(0,D.$Sf)(c)?$:c}getBoolean(h,$){const c=this.get(h);return(0,D.$Sf)(c)?$:c==="true"}getNumber(h,$){const c=this.get(h);return(0,D.$Sf)(c)?$:parseInt(c,10)}getObject(h,$){const c=this.get(h);return(0,D.$Sf)(c)?$:(0,I.$Ch)(c)}async set(h,$,c=!1){if(this.c===w.Closed)return;if((0,D.$Sf)($))return this.delete(h,c);const g=(0,D.$Lf)($)||Array.isArray($)?(0,I.$Bh)($):String($);if(this.f.get(h)!==g)return this.f.set(h,g),this.j.set(h,g),this.h.delete(h),this.b.fire({key:h,external:c}),this.D()}async delete(h,$=!1){if(!(this.c===w.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:$}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$rp=C;class E{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach(($,c)=>this.a.set(c,$)),h.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$sp=E}),define(be[174],ve([8,9]),function(he,e){return he.create("vs/base/node/zip",e)}),define(be[81],ve([1,0,27,15,7,11,23,174]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=e.zip=e.$Np=e.$Mp=void 0,e.$Mp="end of central directory record signature not found";const v=new RegExp(e.$Mp);class w extends Error{constructor(l,t){let o=t.message;switch(l){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=l,this.cause=t}}e.$Np=w;function C(u){const l=u.externalFileAttributes>>16||33188;return[448,56,7].map(t=>l&t).reduce((t,o)=>t+o,l&61440)}function E(u){if(u instanceof w)return u;let l;return v.test(u.message)&&(l="CorruptZip"),new w(l,u)}function b(u,l,t,o,n,s){const i=r.$mc(l),a=r.$jc(o,i);if(!a.startsWith(o))return Promise.reject(new Error(S.localize(0,null,l)));const p=r.$jc(o,l);let L;return s.onCancellationRequested(()=>{L?.destroy()}),Promise.resolve(D.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((P,y)=>{if(!s.isCancellationRequested)try{L=(0,k.createWriteStream)(p,{mode:t}),L.once("close",()=>P()),L.once("error",y),u.once("error",y),u.pipe(L)}catch(A){y(A)}}))}function h(u,l,t,o){let n=(0,O.$Ug)(()=>Promise.resolve()),s=0;const i=o.onCancellationRequested(()=>{n.cancel(),u.close()});return new Promise((a,p)=>{const L=new O.$2g,P=y=>{y.isCancellationRequested||(s++,u.readEntry())};u.once("error",p),u.once("close",()=>n.then(()=>{o.isCancellationRequested||u.entryCount===s?a():p(new w("Incomplete",new Error(S.localize(1,null,s,u.entryCount))))},p)),u.readEntry(),u.on("entry",y=>{if(o.isCancellationRequested)return;if(!t.sourcePathRegex.test(y.fileName)){P(o);return}const A=y.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(A)){const se=r.$jc(l,A);n=(0,O.$Ug)(G=>D.Promises.mkdir(se,{recursive:!0}).then(()=>P(G)).then(void 0,p));return}const M=c(u,y),_=C(y);n=(0,O.$Ug)(se=>L.queue(()=>M.then(G=>b(G,A,_,l,t,se).then(()=>P(se)))).then(null,p))})}).finally(()=>i.dispose())}async function $(u,l=!1){const{open:t}=await new Promise((o,n)=>{he(["yauzl"],o,n)});return new Promise((o,n)=>{t(u,l?{lazyEntries:!0}:void 0,(s,i)=>{s?n(E(s)):o((0,I.$Uf)(i))})})}function c(u,l){return new Promise((t,o)=>{u.openReadStream(l,(n,s)=>{n?o(E(n)):t((0,I.$Uf)(s))})})}async function g(u,l){const{ZipFile:t}=await new Promise((o,n)=>{he(["yazl"],o,n)});return new Promise((o,n)=>{const s=new t;l.forEach(a=>{a.contents?s.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&s.addFile(a.localPath,a.path)}),s.end();const i=(0,k.createWriteStream)(u);s.outputStream.pipe(i),s.outputStream.once("error",n),i.once("error",n),i.once("finish",()=>o(u))})}e.zip=g;function d(u,l,t={},o){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let s=$(u,!0);return t.overwrite&&(s=s.then(i=>D.Promises.rm(l).then(()=>i))),s.then(i=>h(i,l,{sourcePathRegex:n},o))}e.$Pp=d;function m(u,l){return $(u).then(t=>new Promise((o,n)=>{t.on("entry",s=>{s.fileName===l&&c(t,s).then(i=>o(i),i=>n(i))}),t.once("close",()=>n(new Error(S.localize(2,null,l))))}))}function f(u,l){return m(u,l).then(t=>new Promise((o,n)=>{const s=[];t.once("error",n),t.on("data",i=>s.push(i)),t.on("end",()=>o(Buffer.concat(s)))}))}e.$Qp=f}),define(be[175],ve([8,9]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(be[176],ve([1,0,51,4,158,43,159,175]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Nt=e.$Mt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Lt=e.$Kt=e.SymbolKinds=e.SymbolTag=e.$Jt=e.$It=e.SymbolKind=e.$Ht=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Gt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Ft=e.$Et=e.$Dt=void 0;class v{constructor(oe,ee,K){this.offset=oe,this.type=ee,this.language=K,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Dt=v;class w{constructor(oe,ee){this.tokens=oe,this.endState=ee,this._tokenizationResultBrand=void 0}}e.$Et=w;class C{constructor(oe,ee){this.tokens=oe,this.endState=ee,this._encodedTokenizationResultBrand=void 0}}e.$Ft=C;var E;(function(G){G[G.Method=0]="Method",G[G.Function=1]="Function",G[G.Constructor=2]="Constructor",G[G.Field=3]="Field",G[G.Variable=4]="Variable",G[G.Class=5]="Class",G[G.Struct=6]="Struct",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Event=10]="Event",G[G.Operator=11]="Operator",G[G.Unit=12]="Unit",G[G.Value=13]="Value",G[G.Constant=14]="Constant",G[G.Enum=15]="Enum",G[G.EnumMember=16]="EnumMember",G[G.Keyword=17]="Keyword",G[G.Text=18]="Text",G[G.Color=19]="Color",G[G.File=20]="File",G[G.Reference=21]="Reference",G[G.Customcolor=22]="Customcolor",G[G.Folder=23]="Folder",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue",G[G.Snippet=27]="Snippet"})(E||(e.CompletionItemKind=E={}));var b;(function(G){const oe=new Map;oe.set(0,k.$ak.symbolMethod),oe.set(1,k.$ak.symbolFunction),oe.set(2,k.$ak.symbolConstructor),oe.set(3,k.$ak.symbolField),oe.set(4,k.$ak.symbolVariable),oe.set(5,k.$ak.symbolClass),oe.set(6,k.$ak.symbolStruct),oe.set(7,k.$ak.symbolInterface),oe.set(8,k.$ak.symbolModule),oe.set(9,k.$ak.symbolProperty),oe.set(10,k.$ak.symbolEvent),oe.set(11,k.$ak.symbolOperator),oe.set(12,k.$ak.symbolUnit),oe.set(13,k.$ak.symbolValue),oe.set(15,k.$ak.symbolEnum),oe.set(14,k.$ak.symbolConstant),oe.set(15,k.$ak.symbolEnum),oe.set(16,k.$ak.symbolEnumMember),oe.set(17,k.$ak.symbolKeyword),oe.set(27,k.$ak.symbolSnippet),oe.set(18,k.$ak.symbolText),oe.set(19,k.$ak.symbolColor),oe.set(20,k.$ak.symbolFile),oe.set(21,k.$ak.symbolReference),oe.set(22,k.$ak.symbolCustomColor),oe.set(23,k.$ak.symbolFolder),oe.set(24,k.$ak.symbolTypeParameter),oe.set(25,k.$ak.account),oe.set(26,k.$ak.issues);function ee(X){let te=oe.get(X);return te||(console.info("No codicon found for CompletionItemKind "+X),te=k.$ak.symbolProperty),te}G.toIcon=ee;const K=new Map;K.set("method",0),K.set("function",1),K.set("constructor",2),K.set("field",3),K.set("variable",4),K.set("class",5),K.set("struct",6),K.set("interface",7),K.set("module",8),K.set("property",9),K.set("event",10),K.set("operator",11),K.set("unit",12),K.set("value",13),K.set("constant",14),K.set("enum",15),K.set("enum-member",16),K.set("enumMember",16),K.set("keyword",17),K.set("snippet",27),K.set("text",18),K.set("color",19),K.set("file",20),K.set("reference",21),K.set("customcolor",22),K.set("folder",23),K.set("type-parameter",24),K.set("typeParameter",24),K.set("account",25),K.set("issue",26);function Z(X,te){let V=K.get(X);return typeof V>"u"&&!te&&(V=9),V}G.fromString=Z})(b||(e.CompletionItemKinds=b={}));var h;(function(G){G[G.Deprecated=1]="Deprecated"})(h||(e.CompletionItemTag=h={}));var $;(function(G){G[G.None=0]="None",G[G.KeepWhitespace=1]="KeepWhitespace",G[G.InsertAsSnippet=4]="InsertAsSnippet"})($||(e.CompletionItemInsertTextRule=$={}));var c;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var g;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class d{constructor(oe,ee,K,Z){this.range=oe,this.text=ee,this.completionKind=K,this.isSnippetText=Z}equals(oe){return I.$Vs.lift(this.range).equalsRange(oe.range)&&this.text===oe.text&&this.completionKind===oe.completionKind&&this.isSnippetText===oe.isSnippetText}}e.$Gt=d;var m;(function(G){G[G.Invoke=1]="Invoke",G[G.Auto=2]="Auto"})(m||(e.CodeActionTriggerType=m={}));var f;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(f||(e.SignatureHelpTriggerKind=f={}));var u;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(u||(e.DocumentHighlightKind=u={}));function l(G){return G&&O.URI.isUri(G.uri)&&I.$Vs.isIRange(G.range)&&(I.$Vs.isIRange(G.originSelectionRange)||I.$Vs.isIRange(G.targetSelectionRange))}e.$Ht=l;var t;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$It={[17]:(0,S.localize)(0,null),[16]:(0,S.localize)(1,null),[4]:(0,S.localize)(2,null),[13]:(0,S.localize)(3,null),[8]:(0,S.localize)(4,null),[9]:(0,S.localize)(5,null),[21]:(0,S.localize)(6,null),[23]:(0,S.localize)(7,null),[7]:(0,S.localize)(8,null),[0]:(0,S.localize)(9,null),[11]:(0,S.localize)(10,null),[10]:(0,S.localize)(11,null),[19]:(0,S.localize)(12,null),[5]:(0,S.localize)(13,null),[1]:(0,S.localize)(14,null),[2]:(0,S.localize)(15,null),[20]:(0,S.localize)(16,null),[15]:(0,S.localize)(17,null),[18]:(0,S.localize)(18,null),[24]:(0,S.localize)(19,null),[3]:(0,S.localize)(20,null),[6]:(0,S.localize)(21,null),[14]:(0,S.localize)(22,null),[22]:(0,S.localize)(23,null),[25]:(0,S.localize)(24,null),[12]:(0,S.localize)(25,null)};function o(G,oe){return(0,S.localize)(26,null,G,e.$It[oe])}e.$Jt=o;var n;(function(G){G[G.Deprecated=1]="Deprecated"})(n||(e.SymbolTag=n={}));var s;(function(G){const oe=new Map;oe.set(0,k.$ak.symbolFile),oe.set(1,k.$ak.symbolModule),oe.set(2,k.$ak.symbolNamespace),oe.set(3,k.$ak.symbolPackage),oe.set(4,k.$ak.symbolClass),oe.set(5,k.$ak.symbolMethod),oe.set(6,k.$ak.symbolProperty),oe.set(7,k.$ak.symbolField),oe.set(8,k.$ak.symbolConstructor),oe.set(9,k.$ak.symbolEnum),oe.set(10,k.$ak.symbolInterface),oe.set(11,k.$ak.symbolFunction),oe.set(12,k.$ak.symbolVariable),oe.set(13,k.$ak.symbolConstant),oe.set(14,k.$ak.symbolString),oe.set(15,k.$ak.symbolNumber),oe.set(16,k.$ak.symbolBoolean),oe.set(17,k.$ak.symbolArray),oe.set(18,k.$ak.symbolObject),oe.set(19,k.$ak.symbolKey),oe.set(20,k.$ak.symbolNull),oe.set(21,k.$ak.symbolEnumMember),oe.set(22,k.$ak.symbolStruct),oe.set(23,k.$ak.symbolEvent),oe.set(24,k.$ak.symbolOperator),oe.set(25,k.$ak.symbolTypeParameter);function ee(K){let Z=oe.get(K);return Z||(console.info("No codicon found for SymbolKind "+K),Z=k.$ak.symbolProperty),Z}G.toIcon=ee})(s||(e.SymbolKinds=s={}));class i{static asEditOperation(oe){return r.$Ws.replace(I.$Vs.lift(oe.range),oe.text)}}e.$Kt=i;class a{static{this.Comment=new a("comment")}static{this.Imports=new a("imports")}static{this.Region=new a("region")}static fromValue(oe){switch(oe){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(oe)}constructor(oe){this.value=oe}}e.$Lt=a;var p;(function(G){function oe(ee){return!ee||typeof ee!="object"?!1:typeof ee.id=="string"&&typeof ee.title=="string"}G.is=oe})(p||(e.Command=p={}));var L;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(L||(e.CommentThreadCollapsibleState=L={}));var P;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(P||(e.CommentThreadState=P={}));var y;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(y||(e.CommentMode=y={}));var A;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(A||(e.CommentState=A={}));var M;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class _{constructor(oe){this.b=oe,this.a=null}dispose(){this.a&&this.a.then(oe=>{oe&&oe.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Mt=_,e.$Nt=new D.$ut;var se;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(se||(e.ExternalUriOpenerPriority=se={}))}),define(be[177],ve([8,9]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[178],ve([8,9]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(be[179],ve([8,9]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(be[180],ve([8,9]),function(he,e){return he.create("vs/platform/environment/node/argv",e)}),define(be[181],ve([8,9]),function(he,e){return he.create("vs/platform/environment/node/argvHelper",e)}),define(be[182],ve([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(be[183],ve([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(be[184],ve([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(be[185],ve([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(be[186],ve([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(be[187],ve([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(be[188],ve([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(be[189],ve([8,9]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[190],ve([8,9]),function(he,e){return he.create("vs/platform/files/common/fileService",e)}),define(be[191],ve([8,9]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(be[192],ve([8,9]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(be[193],ve([8,9]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(be[194],ve([8,9]),function(he,e){return he.create("vs/platform/languagePacks/common/languagePacks",e)}),define(be[195],ve([8,9]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(be[196],ve([8,9]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(be[197],ve([8,9]),function(he,e){return he.create("vs/platform/shell/node/shellEnv",e)}),define(be[198],ve([8,9]),function(he,e){return he.create("vs/platform/telemetry/common/telemetryService",e)}),define(be[199],ve([8,9]),function(he,e){return he.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(be[200],ve([8,9]),function(he,e){return he.create("vs/platform/terminal/common/terminalProfiles",e)}),define(be[201],ve([8,9]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(be[202],ve([8,9]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(be[203],ve([8,9]),function(he,e){return he.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(be[204],ve([8,9]),function(he,e){return he.create("vs/server/node/serverEnvironmentService",e)}),define(be[205],ve([8,9]),function(he,e){return he.create("vs/server/node/serverServices",e)}),define(be[206],ve([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(be[207],ve([8,9]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(be[208],ve([8,9]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[209],ve([8,9]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(be[210],ve([1,0,10,179]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.TokenType=void 0;var r;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(r||(e.TokenType=r={}));function I(...w){switch(w.length){case 1:return(0,O.localize)(0,null,w[0]);case 2:return(0,O.localize)(1,null,w[0],w[1]);case 3:return(0,O.localize)(2,null,w[0],w[1],w[2]);default:return}}const D=(0,O.localize)(3,null),S=(0,O.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,k.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const E=this.d,b=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:b};this.g.push({offset:E,lexeme:b,additionalInfo:C}),this.f.push(h)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const E=this.c.substring(this.d,this.e),b=v.b.get(E);b?this.k(b):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,E=!1,b=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(S);return}const $=this.c.charCodeAt(C);if(E)E=!1;else if($===47&&!b){C++;break}else $===91?b=!0:$===92?E=!0:$===93&&(b=!1);C++}for(;C<this.c.length&&v.a.has(this.c.charCodeAt(C));)C++;this.e=C;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$2i=v}),define(be[211],ve([1,0,6,2]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=void 0;class r{constructor(){this.a=new k.$Wd,this.b=new k.$Wd,this.c=new k.$Wd,this.d=new k.$Wd}static{this.ChannelName="extensionhostdebugservice"}call(S,v,w){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(S,v,w){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$co=r;class I extends O.$Tc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,v,w){this.b.call("attach",[S,v,w])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,v){this.b.call("terminate",[S,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,v){return this.b.call("openExtensionDevelopmentHostWindow",[S,v])}}e.$do=I}),define(be[212],ve([1,0,4]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=void 0;class O{constructor(D){this.a=D}listen(D,S,v){throw new Error("Invalid listen")}call(D,S,v){switch(S){case"download":return this.a.download(k.URI.revive(v[0]),k.URI.revive(v[1]))}throw new Error("Invalid call")}}e.$fo=O;class r{constructor(D,S){this.a=D,this.b=S}async download(D,S){const v=this.b();v&&(D=v.transformOutgoingURI(D),S=v.transformOutgoingURI(S)),await this.a.call("download",[D,S])}}e.$go=r}),define(be[213],ve([1,0,163,75,12,7,29,19,4]),function(he,e,k,O,r,I,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=e.$ym=void 0,e.$ym=/^([^.]+\..+)[:=](.+)$/;class w{get appRoot(){return(0,I.$mc)(r.$pg.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,I.$jc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,k.$xm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.$jc)(this.userDataPath,"logs",h)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Ig)(v.URI.file((0,I.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=D.env.VSCODE_PORTABLE;return h?v.URI.file((0,I.$jc)(h,"argv.json")):(0,S.$Ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,I.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,I.$kc)(h):(0,I.$hc)((0,I.$jc)(r.$pg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?v.URI.file((0,I.$kc)(h)):v.URI.file((0,I.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,I.$kc)(h);const $=D.env.VSCODE_EXTENSIONS;if($)return $;const c=D.env.VSCODE_PORTABLE;return c?(0,I.$jc)(c,"extensions"):(0,S.$Ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map($=>/^[^:/?#]+?:\/\//.test($)?v.URI.parse($):v.URI.file((0,I.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?v.URI.parse(h):v.URI.file((0,I.$hc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$ym.test(h))}get extensionLogLevel(){const h=[];for(const $ of this.args.log||[]){const c=e.$ym.exec($);c&&c[1]&&c[2]&&h.push([c[1],c[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,S.$Ig)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=D.env.VSCODE_PORTABLE;return h?v.URI.file((0,I.$jc)(h,"policy.json")):(0,S.$Ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,$,c){this.a=h,this.b=$,this.c=c,this.editSessionId=this.args.editSessionId}}e.$zm=w,Ne([O.$yh],w.prototype,"appRoot",null),Ne([O.$yh],w.prototype,"userHome",null),Ne([O.$yh],w.prototype,"userDataPath",null),Ne([O.$yh],w.prototype,"appSettingsHome",null),Ne([O.$yh],w.prototype,"tmpDir",null),Ne([O.$yh],w.prototype,"cacheHome",null),Ne([O.$yh],w.prototype,"stateResource",null),Ne([O.$yh],w.prototype,"userRoamingDataHome",null),Ne([O.$yh],w.prototype,"userDataSyncHome",null),Ne([O.$yh],w.prototype,"sync",null),Ne([O.$yh],w.prototype,"machineSettingsResource",null),Ne([O.$yh],w.prototype,"workspaceStorageHome",null),Ne([O.$yh],w.prototype,"localHistoryHome",null),Ne([O.$yh],w.prototype,"keyboardLayoutResource",null),Ne([O.$yh],w.prototype,"argvResource",null),Ne([O.$yh],w.prototype,"isExtensionDevelopment",null),Ne([O.$yh],w.prototype,"untitledWorkspacesHome",null),Ne([O.$yh],w.prototype,"builtinExtensionsPath",null),Ne([O.$yh],w.prototype,"extensionsPath",null),Ne([O.$yh],w.prototype,"extensionDevelopmentLocationURI",null),Ne([O.$yh],w.prototype,"extensionDevelopmentKind",null),Ne([O.$yh],w.prototype,"extensionTestsLocationURI",null),Ne([O.$yh],w.prototype,"debugExtensionHost",null),Ne([O.$yh],w.prototype,"logLevel",null),Ne([O.$yh],w.prototype,"extensionLogLevel",null),Ne([O.$yh],w.prototype,"serviceMachineIdResource",null),Ne([O.$yh],w.prototype,"disableTelemetry",null),Ne([O.$yh],w.prototype,"disableWorkspaceTrust",null),Ne([O.$yh],w.prototype,"useInMemorySecretStorage",null),Ne([O.$yh],w.prototype,"policyFile",null);function C(b,h){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,h,b.debugId,b.extensionEnvironment)}e.$Am=C;function E(b,h,$,c,g,d){const f=Number(h||b)||(c?null:$),u=f?!!h:!1;let l;if(d)try{l=JSON.parse(d)}catch{}return{port:f,break:u,debugId:g,env:l}}e.$Bm=E}),define(be[67],ve([1,0,301,3,180]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=void 0;const I={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$Xl=["tunnel","serve-web"],e.$Yl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(c,g,d=D){const m=c.find(a=>a.length>0&&a[0]!=="-"),f={},u=["_"],l=[],t={};let o;for(const a in g){const p=g[a];p.type==="subcommand"?a===m&&(o=p):(p.alias&&(f[a]=p.alias),p.type==="string"||p.type==="string[]"?(u.push(a),p.deprecates&&u.push(...p.deprecates)):p.type==="boolean"&&(l.push(a),p.deprecates&&l.push(...p.deprecates)),p.global&&(t[a]=p))}if(o&&m){const a=t;for(const y in o.options)a[y]=o.options[y];const p=c.filter(y=>y!==m),L=d.getSubcommandReporter?d.getSubcommandReporter(m):void 0,P=S(p,a,L);return{[m]:P,_:[]}}const n=k(c,{string:u,boolean:l,alias:f}),s={},i=n;s._=n._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(const a in g){const p=g[a];if(p.type==="subcommand")continue;p.alias&&delete i[p.alias];let L=i[a];if(p.deprecates)for(const P of p.deprecates)i.hasOwnProperty(P)&&(L||(L=i[P],L&&d.onDeprecatedOption(P,p.deprecationMessage||(0,r.localize)(38,null,a))),delete i[P]);if(typeof L<"u"){if(p.type==="string[]"){if(Array.isArray(L)||(L=[L]),!p.allowEmptyValue){const P=L.filter(y=>y.length>0);P.length!==L.length&&(d.onEmptyValue(a),L=P.length>0?P:void 0)}}else p.type==="string"&&(Array.isArray(L)?(L=L.pop(),d.onMultipleValues(a,L)):!L&&!p.allowEmptyValue&&(d.onEmptyValue(a),L=void 0));s[a]=L,p.deprecationMessage&&d.onDeprecatedOption(a,p.deprecationMessage)}delete i[a]}for(const a in i)d.onUnknownOption(a);return s}e.$Zl=S;function v(c,g){let d="";return g.args&&(Array.isArray(g.args)?d=` <${g.args.join("> <")}>`:d=` <${g.args}>`),g.alias?`-${g.alias} --${c}${d}`:`--${c}${d}`}function w(c,g){const d=[];for(const m in c){const f=c[m],u=v(m,f);d.push([u,f.description])}return C(d,g)}e.$1l=w;function C(c,g){const m=c.reduce((l,t)=>Math.max(l,t[0].length),12)+2+1;if(g-m<25)return c.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=g-m-1,u=[];for(const l of c){const t=l[0],o=b(l[1],f),n=E(m-t.length-2);u.push("  "+t+n+o[0]);for(let s=1;s<o.length;s++)u.push(E(m)+o[s])}return u}function E(c){return" ".repeat(c)}function b(c,g){const d=[];for(;c.length;){const m=c.length<g?c.length:c.lastIndexOf(" ",g),f=c.slice(0,m).trim();c=c.slice(m),d.push(f)}return d}function h(c,g,d,m,f){const u=process.stdout.isTTY&&process.stdout.columns||80,l=f?.noInputFiles!==!0?`[${(0,r.localize)(39,null)}...]`:"",t=[`${c} ${d}`];t.push(""),t.push(`${(0,r.localize)(40,null)}: ${g} [${(0,r.localize)(41,null)}]${l}`),t.push(""),f?.noPipe!==!0&&(O.$i?t.push((0,r.localize)(42,null,g)):t.push((0,r.localize)(43,null,g)),t.push(""));const o={},n=[];for(const s in m){const i=m[s];if(i.type==="subcommand")i.description&&n.push({command:s,description:i.description});else if(i.description&&i.cat){let a=o[i.cat];a||(o[i.cat]=a={}),a[s]=i}}for(const s in o){const i=s,a=o[i];a&&(t.push(I[i]),t.push(...w(a,u)),t.push(""))}return n.length&&(t.push((0,r.localize)(44,null)),t.push(...C(n.map(s=>[s.command,s.description]),u)),t.push("")),t.join(`
`)}e.$2l=h;function $(c,g){return`${c||(0,r.localize)(45,null)}
${g||(0,r.localize)(46,null)}
${process.arch}`}e.$3l=$}),define(be[214],ve([1,0,302,181,67]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.$4l=void 0;function I(E,b){const h=(f,u)=>{console.warn((0,O.localize)(0,null,f,u))},$=f=>{console.warn((0,O.localize)(1,null,f))},c=(f,u)=>{console.warn((0,O.localize)(2,null,f,u))},g=f=>({onUnknownOption:u=>{r.$Xl.includes(f)||console.warn((0,O.localize)(3,null,u,f))},onMultipleValues:h,onEmptyValue:$,onDeprecatedOption:c,getSubcommandReporter:r.$Xl.includes(f)?g:void 0}),d={onUnknownOption:f=>{console.warn((0,O.localize)(4,null,f))},onMultipleValues:h,onEmptyValue:$,onDeprecatedOption:c,getSubcommandReporter:g},m=(0,r.$Zl)(E,r.$Yl,b?d:void 0);return m.goto&&m._.forEach(f=>k(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(f),(0,O.localize)(5,null))),m}function D(E){const b=E.findIndex(h=>!/^-/.test(h));if(b>-1)return[...E.slice(0,b),...E.slice(b+1)]}function S(E){let[,...b]=E;process.env.VSCODE_DEV&&(b=D(b)||[]);const h=!C(process.env);return I(b,h)}e.$4l=S;function v(E){let[,,...b]=E;return process.env.VSCODE_DEV&&(b=D(b)||[]),I(b,!0)}e.$5l=v;function w(E,...b){const h=E.indexOf("--");return h===-1?E.push(...b):E.splice(h,0,...b),E}e.$6l=w;function C(E){return E.VSCODE_CLI==="1"}e.$7l=C}),function(){"use strict";function he(e,k,O){function r(D,S){const v=I(D,S),w=[v];return e.isAbsolute(v)||w.unshift(O),e.resolve(...w)}function I(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,S);const C=D["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(E,"AppData","Roaming")}break;case"darwin":w=e.join(k.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,S)}return{getUserDataPath:r}}if(typeof define=="function")define(be[215],ve([77,28,29]),function(e,k,O){return he(e,k,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=he(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(be[108],ve([1,0,28,213,215]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=void 0;class I extends O.$zm{constructor(w,C){super(w,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,r.getUserDataPath)(w,C.nameShort)},C)}}e.$Cm=I;function D(v,w){return(0,O.$Bm)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,w,v.extensionEnvironment)}e.$Dm=D;function S(v,w){return(0,O.$Bm)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,w,v.extensionEnvironment)}e.$Em=S}),define(be[216],ve([1,0,11,185]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;function r(D,S,v,w){try{I(D,S,v,w)}catch(C){D.error(C?.message??C)}return S}e.$Zp=r;function I(D,S,v,w){const C=(E,b,h)=>{const $=E[b];if((0,k.$Jf)($)){const c=$,g=c.length;if(g>1&&c[0]==="%"&&c[g-1]==="%"){const d=c.substr(1,g-2);let m=v[d];m===void 0&&w&&(m=w[d]);const f=typeof m=="string"?m:m?.message,u=w?.[d],l=typeof u=="string"?u:u?.message;if(!f){l||D.warn(`[${S.name}]: ${(0,O.localize)(0,null,d)}`);return}if(h&&(b==="title"||b==="category")&&l&&l!==f){const t={value:f,original:l};E[b]=t}else E[b]=f}}else if((0,k.$Lf)($))for(const c in $)$.hasOwnProperty(c)&&(c==="commands"?C($,c,!0):C($,c,h));else if(Array.isArray($))for(let c=0;c<$.length;c++)C($,c,h)};for(const E in S)S.hasOwnProperty(E)&&C(S,E)}}),define(be[217],ve([1,0,81,188]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;function r(I){return(0,k.$Qp)(I,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.$8p=r}),define(be[82],ve([1,0,19,63,189,55]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function v(d){return d=d.trim(),d==="*"||D.test(d)}e.$bp=v;function w(d){if(!v(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=d.match(D);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.$cp=w;function C(d){if(!d)return null;const m=d.majorBase,f=d.majorMustEqual,u=d.minorBase;let l=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(m===0||(l=!1),o=!1);let n=0;if(d.preRelease){const s=S.exec(d.preRelease);if(s){const[,i,a,p]=s;n=Date.UTC(Number(i),Number(a)-1,Number(p))}}return{majorBase:m,majorMustEqual:f,minorBase:u,minorMustEqual:l,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:n}}e.$dp=C;function E(d,m,f){let u;typeof d=="string"?u=C(w(d)):u=d;let l;m instanceof Date?l=m.getTime():typeof m=="string"&&(l=new Date(m).getTime());let t;if(typeof f=="string"?t=C(w(f)):t=f,!u||!t)return!1;const o=u.majorBase,n=u.minorBase,s=u.patchBase;let i=t.majorBase,a=t.minorBase,p=t.patchBase;const L=t.notBefore;let P=t.majorMustEqual,y=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?o>i?!0:o<i?!1:n>a?!0:n<a||l&&l<L?!1:s>=p:(o===1&&i===0&&(!P||!y||!A)&&(i=1,a=0,p=0,P=!0,y=!1,A=!1),o<i?!1:o>i?!P:n<a?!1:n>a?!y:s<p?!1:s>p?!A:!(l&&l<L))}e.$ep=E;function b(d,m,f,u,l){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([O.default.Error,r.localize(0,null)]),t;if(typeof u.name!="string")return t.push([O.default.Error,r.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([O.default.Error,r.localize(2,null,"version")]),t;if(!u.engines)return t.push([O.default.Error,r.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([O.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!g(u.extensionDependencies))return t.push([O.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!g(u.activationEvents))return t.push([O.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([O.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([O.default.Warning,r.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([O.default.Error,r.localize(9,null,"main")]),t;{const s=(0,k.$Ig)(f,u.main);(0,k.$Cg)(s,f)||t.push([O.default.Warning,r.localize(10,null,s.path,f.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([O.default.Error,r.localize(11,null,"browser")]),t;{const s=(0,k.$Ig)(f,u.browser);(0,k.$Cg)(s,f)||t.push([O.default.Warning,r.localize(12,null,s.path,f.path)])}}if(!I.valid(u.version))return t.push([O.default.Error,r.localize(13,null)]),t;const o=[];if(!h(d,m,u,l,o))for(const s of o)t.push([O.default.Error,s]);return t}e.$fp=b;function h(d,m,f,u,l){return u||typeof f.main>"u"&&typeof f.browser>"u"?!0:c(d,m,f.engines.vscode,l)}e.$gp=h;function $(d,m,f){return d==="*"||c(m,f,d)}e.$hp=$;function c(d,m,f,u=[]){const l=C(w(f));if(!l)return u.push(r.localize(14,null,f)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return u.push(r.localize(15,null,f)),!1}else if(!l.majorMustEqual)return u.push(r.localize(16,null,f)),!1;return E(d,m,l)?!0:(u.push(r.localize(17,null,d,f)),!1)}function g(d){if(!Array.isArray(d))return!1;for(let m=0,f=d.length;m<f;m++)if(typeof d[m]!="string")return!1;return!0}}),define(be[218],ve([1,0,14,22]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;async function r(I,D,S){let v=S&&S.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const C=(await D.readFile(I.serviceMachineIdResource)).value.toString();v=(0,O.$qg)(C)?C:null}catch{v=null}if(!v){v=(0,O.$rg)();try{await D.writeFile(I.serviceMachineIdResource,k.$ke.fromString(v))}catch{}}return S?.store("storage.serviceMachineId",v,-1,1),v}e.$Bp=r}),define(be[68],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class k{constructor(r,I=[],D=!1){this.ctor=r,this.staticArguments=I,this.supportsDelayedInstantiation=D}}e.$4h=k}),define(be[109],ve([1,0,68]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=e.InstantiationType=void 0;const O=[];var r;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function I(S,v,w){v instanceof k.$4h||(v=new k.$4h(v,[],!!w)),O.push([S,v])}e.$Zr=I;function D(){return O}e.$1r=D}),define(be[219],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;class k{constructor(I,D){this.key=I,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Dq=k;class O{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const D of this.a.values())D.outgoing.size===0&&I.push(D);return I}insertEdge(I,D){const S=this.lookupOrInsertNode(I),v=this.lookupOrInsertNode(D);S.outgoing.set(v.key,v),v.incoming.set(S.key,S)}removeNode(I){const D=this.b(I);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(I){const D=this.b(I);let S=this.a.get(D);return S||(S=new k(D,I),this.a.set(D,S)),S}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[D,S]of this.a)I.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,D]of this.a){const S=new Set([I]),v=this.c(D,S);if(v)return v}}c(I,D){for(const[S,v]of I.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const w=this.c(v,D);if(w)return w;D.delete(S)}}}e.$Eq=O}),define(be[5],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e._util=void 0;var k;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(v){return v[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(k||(e._util=k={})),e.$6h=r("instantiationService");function O(D,S,v){S[k.DI_TARGET]===S?S[k.DI_DEPENDENCIES].push({id:D,index:v}):(S[k.DI_DEPENDENCIES]=[{id:D,index:v}],S[k.DI_TARGET]=S)}function r(D){if(k.serviceIds.has(D))return k.serviceIds.get(D);const S=function(v,w,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(S,v,C)};return S.toString=()=>D,k.serviceIds.set(D,S),S}e.$7h=r;function I(D){return D}e.$8h=I}),define(be[25],ve([1,0,11,4,5]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.ConfigurationTarget=e.$Ci=e.$Bi=e.$Ai=void 0,e.$Ai=(0,r.$7h)("configurationService");function I(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof O.URI)}e.$Bi=I;function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof O.URI)}e.$Ci=D;var S;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function v(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Di=v;function w(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}e.$Ei=w;function C(d,m){const f=Object.create(null);for(const u in d)E(f,u,d[u],m);return f}e.$Fi=C;function E(d,m,f,u){const l=m.split("."),t=l.pop();let o=d;for(let n=0;n<l.length;n++){const s=l[n];let i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:u(`Ignoring ${m} as ${l.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[t]=f}catch{u(`Ignoring ${m} as ${l.join(".")} is ${JSON.stringify(o)}`)}else u(`Ignoring ${m} as ${l.join(".")} is ${JSON.stringify(o)}`)}e.$Gi=E;function b(d,m){const f=m.split(".");h(d,f)}e.$Hi=b;function h(d,m){const f=m.shift();if(m.length===0){delete d[f];return}if(Object.keys(d).indexOf(f)!==-1){const u=d[f];typeof u=="object"&&!Array.isArray(u)&&(h(u,m),Object.keys(u).length===0&&delete d[f])}}function $(d,m,f){function u(o,n){let s=o;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const l=m.split("."),t=u(d,l);return typeof t>"u"?f:t}e.$Ii=$;function c(d,m,f){Object.keys(m).forEach(u=>{u!=="__proto__"&&(u in d?k.$Lf(d[u])&&k.$Lf(m[u])?c(d[u],m[u],f):f&&(d[u]=m[u]):d[u]=m[u])})}e.$Ji=c;function g(d){return d.replace(/[\[\]]/g,"")}e.$Ki=g}),define(be[69],ve([1,0,3,17,210,5,178,10]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.ContextKeyExprType=e.$3i=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",k.$j),v.set("isLinux",k.$k),v.set("isWindows",k.$i),v.set("isWeb",k.$o),v.set("isMacNative",k.$j&&!k.$o),v.set("isEdge",k.$H),v.set("isFirefox",k.$F),v.set("isChrome",k.$E),v.set("isSafari",k.$G);function w(H,R){if(v.get(H)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(H,R)}e.$3i=w;const C=Object.prototype.hasOwnProperty;var E;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const b={regexParsingWithErrorRecovery:!0},h=(0,D.localize)(0,null),$=(0,D.localize)(1,null),c=(0,D.localize)(2,null),g=(0,D.localize)(3,null),d=(0,D.localize)(4,null),m=(0,D.localize)(5,null),f=(0,D.localize)(6,null),u=(0,D.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=b){this.k=R,this.d=new r.$2i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const x=this.D(),J=x.type===17?m:void 0;throw this.h.push({message:d,offset:x.offset,lexeme:r.$2i.getLexeme(x),additionalInfo:J}),l.c}return U}catch(U){if(U!==l.c)throw U;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const U=this.o();R.push(U)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const U=this.s();R.push(U)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,g),U?.negate()}case 17:return this.z(),M.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const U=this.l();return this.A(1,g),U}case 17:{const U=R.lexeme;if(this.z(),this.y(9)){const J=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),J.type!==10)throw this.B("REGEX",J);const Y=J.lexeme,B=Y.lastIndexOf("/"),T=B===Y.length-1?void 0:this.w(Y.substring(B+1));let N;try{N=new RegExp(Y.substring(1,B),T)}catch{throw this.B("REGEX",J)}return K.create(U,N)}switch(J.type){case 10:case 19:{const Y=[J.lexeme];this.z();let B=this.D(),T=0;for(let ge=0;ge<J.lexeme.length;ge++)J.lexeme.charCodeAt(ge)===40?T++:J.lexeme.charCodeAt(ge)===41&&T--;for(;!this.E()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:T++;break;case 1:T--;break;case 10:case 18:for(let ge=0;ge<B.lexeme.length;ge++)B.lexeme.charCodeAt(ge)===40?T++:J.lexeme.charCodeAt(ge)===41&&T--}if(T<0)break;Y.push(r.$2i.getLexeme(B)),this.z(),B=this.D()}const N=Y.join(""),q=N.lastIndexOf("/"),ie=q===N.length-1?void 0:this.w(N.substring(q+1));let ae;try{ae=new RegExp(N.substring(1,q),ie)}catch{throw this.B("REGEX",J)}return t.regex(U,ae)}case 18:{const Y=J.lexeme;this.z();let B=null;if(!(0,O.$Ke)(Y)){const T=Y.indexOf("/"),N=Y.lastIndexOf("/");if(T!==N&&T>=0){const q=Y.slice(T+1,N),ie=Y[N+1]==="i"?"i":"";try{B=new RegExp(q,ie)}catch{throw this.B("REGEX",J)}}}if(B===null)throw this.B("REGEX",J);return K.create(U,B)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const J=this.u();return t.notIn(U,J)}switch(this.D().type){case 3:{this.z();const J=this.u();if(this.x().type===18)return t.equals(U,J);switch(J){case"true":return t.has(U);case"false":return t.not(U);default:return t.equals(U,J)}}case 4:{this.z();const J=this.u();if(this.x().type===18)return t.notEquals(U,J);switch(J){case"true":return t.not(U);case"false":return t.has(U);default:return t.notEquals(U,J)}}case 5:return this.z(),oe.create(U,this.u());case 6:return this.z(),ee.create(U,this.u());case 7:return this.z(),se.create(U,this.u());case 8:return this.z(),G.create(U,this.u());case 13:return this.z(),t.in(U,this.u());default:return t.has(U)}}case 20:throw this.h.push({message:f,offset:R.offset,lexeme:"",additionalInfo:u}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,U){if(this.C(R))return this.z();throw this.B(U,this.D())}B(R,U,x){const J=(0,D.localize)(8,null,R,r.$2i.getLexeme(U)),Y=U.offset,B=r.$2i.getLexeme(U);return this.h.push({message:J,offset:Y,lexeme:B,additionalInfo:x}),l.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$4i=l;class t{static false(){return i.INSTANCE}static true(){return a.INSTANCE}static has(R){return p.create(R)}static equals(R,U){return L.create(R,U)}static notEquals(R,U){return A.create(R,U)}static regex(R,U){return K.create(R,U)}static in(R,U){return P.create(R,U)}static notIn(R,U){return y.create(R,U)}static not(R){return M.create(R)}static and(...R){return te.create(R,null,!0)}static or(...R){return V.create(R,null,!0)}static greater(R,U){return se.create(R,U)}static greaterEquals(R,U){return G.create(R,U)}static smaller(R,U){return oe.create(R,U)}static smallerEquals(R,U){return ee.create(R,U)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$5i=t;function o(H){const R=new l({regexParsingWithErrorRecovery:!1});return H.map(U=>(R.parse(U),R.lexingErrors.length>0?R.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,D.localize)(9,null,x.additionalInfo):(0,D.localize)(10,null),offset:x.offset,length:x.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$6i=o;function n(H,R){const U=H?H.substituteConstants():void 0,x=R?R.substituteConstants():void 0;return!U&&!x?!0:!U||!x?!1:U.equals(x)}e.$7i=n;function s(H,R){return H.cmp(R)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return a.INSTANCE}}e.$8i=i;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return i.INSTANCE}}e.$9i=a;class p{static create(R,U=null){const x=v.get(R);return typeof x=="boolean"?x?a.INSTANCE:i.INSTANCE:new p(R,U)}constructor(R,U){this.key=R,this.c=U,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:re(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=v.get(this.key);return typeof R=="boolean"?R?a.INSTANCE:i.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$0i=p;class L{static create(R,U,x=null){if(typeof U=="boolean")return U?p.create(R,x):M.create(R,x);const J=v.get(R);return typeof J=="boolean"?U===(J?"true":"false")?a.INSTANCE:i.INSTANCE:new L(R,U,x)}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=v.get(this.c);if(typeof R=="boolean"){const U=R?"true":"false";return this.d===U?a.INSTANCE:i.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$$i=L;class P{static create(R,U){return new P(R,U)}constructor(R,U){this.d=R,this.f=U,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const U=R.getValue(this.f),x=R.getValue(this.d);return Array.isArray(U)?U.includes(x):typeof x=="string"&&typeof U=="object"&&U!==null?C.call(U,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$_i=P;class y{static create(R,U){return new y(R,U)}constructor(R,U){this.d=R,this.f=U,this.type=11,this.c=P.create(R,U)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$aj=y;class A{static create(R,U,x=null){if(typeof U=="boolean")return U?M.create(R,x):p.create(R,x);const J=v.get(R);return typeof J=="boolean"?U===(J?"true":"false")?i.INSTANCE:a.INSTANCE:new A(R,U,x)}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=v.get(this.c);if(typeof R=="boolean"){const U=R?"true":"false";return this.d===U?i.INSTANCE:a.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$bj=A;class M{static create(R,U=null){const x=v.get(R);return typeof x=="boolean"?x?i.INSTANCE:a.INSTANCE:new M(R,U)}constructor(R,U){this.c=R,this.d=U,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:re(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=v.get(this.c);return typeof R=="boolean"?R?i.INSTANCE:a.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$cj=M;function _(H,R){if(typeof H=="string"){const U=parseFloat(H);isNaN(U)||(H=U)}return typeof H=="string"||typeof H=="number"?R(H):i.INSTANCE}class se{static create(R,U,x=null){return _(U,J=>new se(R,J,x))}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$dj=se;class G{static create(R,U,x=null){return _(U,J=>new G(R,J,x))}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$ej=G;class oe{static create(R,U,x=null){return _(U,J=>new oe(R,J,x))}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$fj=oe;class ee{static create(R,U,x=null){return _(U,J=>new ee(R,J,x))}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:ue(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$gj=ee;class K{static create(R,U){return new K(R,U)}constructor(R,U){this.d=R,this.f=U,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const U=this.f?this.f.source:"",x=R.f?R.f.source:"";return U<x?-1:U>x?1:0}equals(R){if(R.type===this.type){const U=this.f?this.f.source:"",x=R.f?R.f.source:"";return this.d===R.d&&U===x}return!1}substituteConstants(){return this}evaluate(R){const U=R.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$hj=K;class Z{static create(R){return new Z(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new Z(this.c.map(R))}negate(){return this.c}}e.$ij=Z;function X(H){let R=null;for(let U=0,x=H.length;U<x;U++){const J=H[U].substituteConstants();if(H[U]!==J&&R===null){R=[];for(let Y=0;Y<U;Y++)R[Y]=H[Y]}R!==null&&(R[U]=J)}return R===null?H:R}class te{static create(R,U,x){return te.d(R,U,x)}constructor(R,U){this.expr=R,this.c=U,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let U=0,x=this.expr.length;U<x;U++){const J=s(this.expr[U],R.expr[U]);if(J!==0)return J}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].equals(R.expr[U]))return!1;return!0}return!1}substituteConstants(){const R=X(this.expr);return R===this.expr?this:te.create(R,this.c,!1)}evaluate(R){for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].evaluate(R))return!1;return!0}static d(R,U,x){const J=[];let Y=!1;for(const B of R)if(B){if(B.type===1){Y=!0;continue}if(B.type===0)return i.INSTANCE;if(B.type===6){J.push(...B.expr);continue}J.push(B)}if(J.length===0&&Y)return a.INSTANCE;if(J.length!==0){if(J.length===1)return J[0];J.sort(s);for(let B=1;B<J.length;B++)J[B-1].equals(J[B])&&(J.splice(B,1),B--);if(J.length===1)return J[0];for(;J.length>1;){const B=J[J.length-1];if(B.type!==9)break;J.pop();const T=J.pop(),N=J.length===0,q=V.create(B.expr.map(ie=>te.create([ie,T],null,x)),null,N);q&&(J.push(q),J.sort(s))}if(J.length===1)return J[0];if(x){for(let B=0;B<J.length;B++)for(let T=B+1;T<J.length;T++)if(J[B].negate().equals(J[T]))return i.INSTANCE;if(J.length===1)return J[0]}return new te(J,U)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const U of this.expr)R.push(...U.keys());return R}map(R){return new te(this.expr.map(U=>U.map(R)),null)}negate(){if(!this.c){const R=[];for(const U of this.expr)R.push(U.negate());this.c=V.create(R,this,!0)}return this.c}}e.$jj=te;class V{static create(R,U,x){return V.d(R,U,x)}constructor(R,U){this.expr=R,this.c=U,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let U=0,x=this.expr.length;U<x;U++){const J=s(this.expr[U],R.expr[U]);if(J!==0)return J}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].equals(R.expr[U]))return!1;return!0}return!1}substituteConstants(){const R=X(this.expr);return R===this.expr?this:V.create(R,this.c,!1)}evaluate(R){for(let U=0,x=this.expr.length;U<x;U++)if(this.expr[U].evaluate(R))return!0;return!1}static d(R,U,x){let J=[],Y=!1;if(R){for(let B=0,T=R.length;B<T;B++){const N=R[B];if(N){if(N.type===0){Y=!0;continue}if(N.type===1)return a.INSTANCE;if(N.type===9){J=J.concat(N.expr);continue}J.push(N)}}if(J.length===0&&Y)return i.INSTANCE;J.sort(s)}if(J.length!==0){if(J.length===1)return J[0];for(let B=1;B<J.length;B++)J[B-1].equals(J[B])&&(J.splice(B,1),B--);if(J.length===1)return J[0];if(x){for(let B=0;B<J.length;B++)for(let T=B+1;T<J.length;T++)if(J[B].negate().equals(J[T]))return a.INSTANCE;if(J.length===1)return J[0]}return new V(J,U)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const U of this.expr)R.push(...U.keys());return R}map(R){return new V(this.expr.map(U=>U.map(R)),null)}negate(){if(!this.c){const R=[];for(const U of this.expr)R.push(U.negate());for(;R.length>1;){const U=R.shift(),x=R.shift(),J=[];for(const Y of z(U))for(const B of z(x))J.push(te.create([Y,B],null,!1));R.unshift(V.create(J,null,!1))}this.c=V.create(R,this,!0)}return this.c}}e.$kj=V;class W extends p{static{this.d=[]}static all(){return W.d.values()}constructor(R,U,x){super(R,null),this.f=U,typeof x=="object"?W.d.push({...x,key:R}):x!==!0&&W.d.push({key:R,description:x,type:U!=null?typeof U:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return L.create(this.key,R)}notEqualsTo(R){return A.create(this.key,R)}}e.$lj=W,e.$mj=(0,I.$7h)("contextKeyService");function re(H,R){return H<R?-1:H>R?1:0}function ue(H,R,U,x){return H<U?-1:H>U?1:R<x?-1:R>x?1:0}function ne(H,R){if(H.type===0||R.type===1)return!0;if(H.type===9)return R.type===9?me(H.expr,R.expr):!1;if(R.type===9){for(const U of R.expr)if(ne(H,U))return!0;return!1}if(H.type===6){if(R.type===6)return me(R.expr,H.expr);for(const U of H.expr)if(ne(U,R))return!0;return!1}return H.equals(R)}e.$nj=ne;function me(H,R){let U=0,x=0;for(;U<H.length&&x<R.length;){const J=H[U].cmp(R[x]);if(J<0)return!1;J===0&&U++,x++}return U===H.length}function z(H){return H.type===9?H.expr:[H]}}),define(be[220],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=e.ID=void 0,e.ID="diagnosticsService",e.$Jm=(0,k.$7h)(e.ID);function O(I){return!!I.hostName&&!!I.errorMessage}e.$Km=O;class r{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Lm=r}),define(be[83],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=void 0,e.$eo=(0,k.$7h)("downloadService")}),define(be[26],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=void 0,e.$bi=(0,k.$7h)("environmentService"),e.$ci=(0,k.$8h)(e.$bi)}),define(be[30],ve([1,0,183,5]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.ExtensionGalleryErrorCode=e.$Ao=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0,e.$no="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$oo=new RegExp(e.$no),e.$po="__web_extension",e.$qo="skipWalkthrough",e.$ro="extensionsSync",e.$so="dependecyOrPackExtensionInstall";function r(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$to=r;function I(f){switch(f){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$uo=I;function D(f,u){switch(f){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$vo=D;function S(f,u){return u==="web"&&!f.includes("web")}e.$wo=S;function v(f,u,l){return S(u,l)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===l}e.$xo=v;function w(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$yo=w;var C;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var E;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var b;(function(f){f.Install="install",f.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var h;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$zo=(0,O.$7h)("extensionGalleryService");var $;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.DownloadSignature="DownloadSignature",f.UpdateMetadata="UpdateMetadata",f.Extract="Extract",f.Scanning="Scanning",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.NotAllowed="NotAllowed",f.Gallery="Gallery",f.Unknown="Unknown",f.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var c;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class g extends Error{constructor(u,l){super(u),this.code=l,this.name=l}}e.$Ao=g;var d;(function(f){f.Timeout="Timeout",f.Cancelled="Cancelled",f.Failed="Failed"})(d||(e.ExtensionGalleryErrorCode=d={}));class m extends Error{constructor(u,l){super(u),this.code=l,this.name=l}}e.$Bo=m,e.$Co=(0,O.$7h)("extensionManagementService"),e.$Do="extensionsIdentifiers/disabled",e.$Eo="extensionsIdentifiers/enabled",e.$Fo=(0,O.$7h)("IGlobalExtensionEnablementService"),e.$Go=(0,O.$7h)("IExtensionTipsService"),e.$Ho=(0,k.localize)(0,null),e.$Io={value:e.$Ho,original:"Extensions"},e.$Jo=(0,k.localize2)(1,"Preferences")}),define(be[221],ve([1,0,6,2,21,4,53,30]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=void 0;function v(g,d){return g?I.URI.revive(d?d.transformIncoming(g):g):void 0}function w(g,d){return d?d.transformOutgoingURI(g):g}function C(g,d){d=d||D.$6m;const m=g.manifest;return{...(0,D.$9m)({...g,manifest:void 0},d),manifest:m}}function E(g,d){return g?.profileLocation?(0,D.$9m)(g,d??D.$6m):g}function b(g,d){return d?(0,r.$yn)(g,m=>m instanceof I.URI?d.transformOutgoingURI(m):void 0):g}class h{constructor(d,m){this.a=d,this.b=m,this.onInstallExtension=k.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(d.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(d.onDidUpdateExtensionMetadata,!0)}listen(d,m){const f=this.b(d);switch(m){case"onInstallExtension":return k.Event.map(this.onInstallExtension,u=>({...u,profileLocation:u.profileLocation?w(u.profileLocation,f):u.profileLocation}));case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,u=>u.map(l=>({...l,local:l.local?b(l.local,f):l.local,profileLocation:l.profileLocation?w(l.profileLocation,f):l.profileLocation})));case"onUninstallExtension":return k.Event.map(this.onUninstallExtension,u=>({...u,profileLocation:u.profileLocation?w(u.profileLocation,f):u.profileLocation}));case"onDidUninstallExtension":return k.Event.map(this.onDidUninstallExtension,u=>({...u,profileLocation:u.profileLocation?w(u.profileLocation,f):u.profileLocation}));case"onDidUpdateExtensionMetadata":return k.Event.map(this.onDidUpdateExtensionMetadata,u=>b(u,f))}throw new Error("Invalid listen")}async call(d,m,f){const u=this.b(d);switch(m){case"zip":{const l=C(f[0],u),t=await this.a.zip(l);return w(t,u)}case"unzip":return this.a.unzip(v(f[0],u));case"install":return this.a.install(v(f[0],u),E(f[1],u));case"installFromLocation":return this.a.installFromLocation(v(f[0],u),v(f[1],u));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],v(f[1],u),v(f[2],u));case"getManifest":return this.a.getManifest(v(f[0],u));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],E(f[1],u));case"installGalleryExtensions":{const l=f[0];return this.a.installGalleryExtensions(l.map(({extension:t,options:o})=>({extension:t,options:E(o,u)??{}})))}case"uninstall":return this.a.uninstall(C(f[0],u),E(f[1],u));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(f[0],u));case"getInstalled":return(await this.a.getInstalled(f[0],v(f[1],u))).map(t=>b(t,u));case"toggleAppliationScope":{const l=await this.a.toggleAppliationScope(C(f[0],u),v(f[1],u));return b(l,u)}case"copyExtensions":return this.a.copyExtensions(v(f[0],u),v(f[1],u));case"updateMetadata":{const l=await this.a.updateMetadata(C(f[0],u),f[1],v(f[2],u));return b(l,u)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1],f[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Jp=h;class $ extends O.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(d){super(),this.m=d,this.c=this.B(new k.$Wd),this.f=this.B(new k.$Wd),this.g=this.B(new k.$Wd),this.h=this.B(new k.$Wd),this.j=this.B(new k.$Wd),this.B(this.m.listen("onInstallExtension")(m=>this.n(this.c,{...m,source:this.r(m.source)?I.URI.revive(m.source):m.source,profileLocation:I.URI.revive(m.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(m=>this.n(this.f,m.map(f=>({...f,local:f.local?C(f.local,null):f.local,source:this.r(f.source)?I.URI.revive(f.source):f.source,profileLocation:I.URI.revive(f.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(m=>this.n(this.g,{...m,profileLocation:I.URI.revive(m.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(m=>this.n(this.h,{...m,profileLocation:I.URI.revive(m.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(m=>this.j.fire(C(m,null))))}n(d,m){d.fire(m)}r(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(d){const m=await this.getTargetPlatform();return d.allTargetPlatforms.some(f=>(0,S.$xo)(f,d.allTargetPlatforms,m))}zip(d){return Promise.resolve(this.m.call("zip",[d]).then(m=>I.URI.revive(m)))}unzip(d){return Promise.resolve(this.m.call("unzip",[d]))}install(d,m){return Promise.resolve(this.m.call("install",[d,m])).then(f=>C(f,null))}installFromLocation(d,m){return Promise.resolve(this.m.call("installFromLocation",[d,m])).then(f=>C(f,null))}async installExtensionsFromProfile(d,m,f){return(await this.m.call("installExtensionsFromProfile",[d,m,f])).map(l=>C(l,null))}getManifest(d){return Promise.resolve(this.m.call("getManifest",[d]))}installFromGallery(d,m){return Promise.resolve(this.m.call("installFromGallery",[d,m])).then(f=>C(f,null))}async installGalleryExtensions(d){return(await this.m.call("installGalleryExtensions",[d])).map(f=>({...f,local:f.local?C(f.local,null):f.local,source:this.r(f.source)?I.URI.revive(f.source):f.source,profileLocation:I.URI.revive(f.profileLocation)}))}uninstall(d,m){return Promise.resolve(this.m.call("uninstall",[d,m]))}reinstallFromGallery(d){return Promise.resolve(this.m.call("reinstallFromGallery",[d])).then(m=>C(m,null))}getInstalled(d=null,m){return Promise.resolve(this.m.call("getInstalled",[d,m])).then(f=>f.map(u=>C(u,null)))}updateMetadata(d,m,f){return Promise.resolve(this.m.call("updateMetadata",[d,m,f])).then(u=>C(u,null))}toggleAppliationScope(d,m){return this.m.call("toggleAppliationScope",[d,m]).then(f=>C(f,null))}copyExtensions(d,m){return this.m.call("copyExtensions",[d,m])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(d,m,f){const u=await this.m.call("download",[d,m,f]);return I.URI.revive(u)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Kp=$;class c{constructor(d){this.a=d}listen(d,m){throw new Error("Invalid listen")}call(d,m,f){switch(m){case"getConfigBasedTips":return this.a.getConfigBasedTips(I.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Lp=c}),define(be[16],ve([1,0,64,7,17,11,4,191,5,3,12,60]),function(he,e,k,O,r,I,D,S,v,w,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.FileKind=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.FileOperationResult=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.FileChangeType=e.$Jk=e.FileOperation=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileSystemProviderErrorCode=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderCapabilities=e.$tk=e.FilePermission=e.FileType=e.$sk=e.$rk=void 0,e.$rk=(0,v.$7h)("fileService");function b(ne){return ne.create===!0}e.$sk=b;var h;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var $;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})($||(e.FilePermission=$={}));function c(ne){const me=ne;return!!me&&typeof me.onDidChange=="function"}e.$tk=c;var g;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function d(ne){return!!(ne.capabilities&2)}e.$uk=d;function m(ne){return!!(ne.capabilities&8)}e.$vk=m;function f(ne){return!!(ne.capabilities&131072)}e.$wk=f;function u(ne){return!!(ne.capabilities&4)}e.$xk=u;function l(ne){return!!(ne.capabilities&16)}e.$yk=l;function t(ne){return d(ne)?!!(ne.capabilities&16384):!1}e.$zk=t;function o(ne){return d(ne)?!!(ne.capabilities&32768):!1}e.$Ak=o;function n(ne){return!!(ne.capabilities&65536)}e.$Bk=n;function s(ne){return!!(ne.capabilities&2048)}e.$Ck=s;var i;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class a extends Error{static create(me,z){const H=new a(me.toString(),z);return P(H,z),H}constructor(me,z){super(me),this.code=z}}e.$Dk=a;function p(ne,me){return a.create(ne,me)}e.$Ek=p;function L(ne){return ne||p((0,S.localize)(0,null),i.Unknown)}e.$Fk=L;function P(ne,me){return ne.name=me?`${me} (FileSystemError)`:"FileSystemError",ne}e.$Gk=P;function y(ne){if(!ne)return i.Unknown;if(ne instanceof a)return ne.code;const me=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!me)return i.Unknown;switch(me[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.$Hk=y;function A(ne){if(ne instanceof ee)return ne.fileOperationResult;switch(y(ne)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.$Ik=A;var M;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class _{constructor(me,z,H){this.resource=me,this.operation=z,this.target=H}isOperation(me){return this.operation===me}}e.$Jk=_;var se;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(se||(e.FileChangeType=se={}));class G{static{this.a=null}constructor(me,z){this.c=z,this.b=void 0,this.d=new E.$V(()=>{const H=k.$ai.forUris(()=>this.c);return H.fill(this.rawAdded.map(R=>[R,!0])),H}),this.f=new E.$V(()=>{const H=k.$ai.forUris(()=>this.c);return H.fill(this.rawUpdated.map(R=>[R,!0])),H}),this.g=new E.$V(()=>{const H=k.$ai.forUris(()=>this.c);return H.fill(this.rawDeleted.map(R=>[R,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of me){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==G.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(me,...z){return this.h(me,{includeChildren:!1},...z)}affects(me,...z){return this.h(me,{includeChildren:!0},...z)}h(me,z,...H){if(!me)return!1;const R=H.length>0;return!!((!R||H.includes(1))&&(this.d.value.get(me)||z.includeChildren&&this.d.value.findSuperstr(me))||(!R||H.includes(0))&&(this.f.value.get(me)||z.includeChildren&&this.f.value.findSuperstr(me))||(!R||H.includes(2))&&(this.g.value.findSubstr(me)||z.includeChildren&&this.g.value.findSuperstr(me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(me){return this.b===me}hasCorrelation(){return typeof this.b=="number"}}e.$Kk=G;function oe(ne,me,z){return!ne||!me||ne===me||me.length>ne.length?!1:(me.charAt(me.length-1)!==O.sep&&(me+=O.sep),z?(0,r.$bf)(ne,me):ne.indexOf(me)===0)}e.$Lk=oe;class ee extends Error{constructor(me,z,H){super(me),this.fileOperationResult=z,this.options=H}}e.$Mk=ee;class K extends ee{constructor(me,z,H,R){super(me,z,R),this.fileOperationResult=z,this.size=H}}e.$Nk=K;class Z extends ee{constructor(me,z,H){super(me,2,H),this.stat=z}}e.$Ok=Z;var X;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$Pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Rk="files.associations",e.$Sk="files.exclude",e.$Tk="files.readonlyInclude",e.$Uk="files.readonlyExclude",e.$Vk="files.readonlyFromPermissions";var te;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$Wk="";function V(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}e.$Xk=V;async function W(ne,me){if(!me.hasProvider(D.URI.from({scheme:ne.scheme})))return new Promise(z=>{const H=me.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===ne.scheme&&R.added&&(H.dispose(),z())})})}e.$Yk=W;class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(me){return(0,I.$Nf)(me)||(me=0),me<re.KB?(0,S.localize)(1,null,me.toFixed(0)):me<re.MB?(0,S.localize)(2,null,(me/re.KB).toFixed(2)):me<re.GB?(0,S.localize)(3,null,(me/re.MB).toFixed(2)):me<re.TB?(0,S.localize)(4,null,(me/re.GB).toFixed(2)):(0,S.localize)(5,null,(me/re.TB).toFixed(2))}}e.$Zk=re;function ue(ne){const me=typeof ne=="string"||ne?.scheme===C.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===C.Schemas.file?1024*re.MB:me?10*re.MB:w.$o?50*re.MB:1024*re.MB}e.$1k=ue}),define(be[110],ve([1,0,14,10,192,16]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;async function D(C,E,b,h,$,c){let g;try{await S(C,E,b,h,$,c)}catch(d){g=d}finally{g&&$.errorTransformer&&(g=$.errorTransformer(g)),typeof g<"u"&&b.error(g),b.end()}}e.$cq=D;async function S(C,E,b,h,$,c){v(c);const g=await C.open(E,{create:!1});try{v(c);let d=0,m=0,f=$&&typeof $.length=="number"?$.length:void 0,u=k.$ke.alloc(Math.min($.bufferSize,typeof f=="number"?f:$.bufferSize)),l=$&&typeof $.position=="number"?$.position:0,t=0;do m=await C.read(g,l,u.buffer,t,u.byteLength-t),l+=m,t+=m,d+=m,typeof f=="number"&&(f-=m),t===u.byteLength&&(await b.write(h(u)),u=k.$ke.alloc(Math.min($.bufferSize,typeof f=="number"?f:$.bufferSize)),t=0);while(m>0&&(typeof f!="number"||f>0)&&v(c)&&w(d,$));if(t>0){let o=t;typeof f=="number"&&(o=Math.min(t,f)),b.write(h(u.slice(0,o)))}}catch(d){throw(0,I.$Fk)(d)}finally{await C.close(g)}}function v(C){if(C.isCancellationRequested)throw(0,O.$6)();return!0}function w(C,E){if(typeof E?.limits?.size=="number"&&C>E.limits.size)throw(0,I.$Ek)((0,r.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(be[56],ve([1,0,80,2,7,3,4,16]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=void 0;function v(d){return d.recursive===!0}e.$eq=v;class w extends O.$Tc{static{this.a=5}constructor(m,f,u,l){super(),this.h=m,this.j=f,this.m=u,this.n=l,this.c=this.B(new O.$Uc),this.f=void 0,this.g=0}s(){const m=new O.$Sc;this.c.value=m,this.b=this.r(m),this.b.setVerboseLogging(this.m),m.add(this.b.onDidChangeFile(f=>this.h(f))),m.add(this.b.onDidLogMessage(f=>this.j(f))),m.add(this.b.onDidError(f=>this.t(f)))}t(m){this.n.restartOnError?this.g<w.a&&this.f?(this.w(`restarting watcher after error: ${m}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${m}`):this.w(m)}u(m){this.g++,this.s(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.m=m,await this.b?.setVerboseLogging(m)}w(m){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${m}`})}y(m){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}e.$fq=w;class C extends w{constructor(m,f,u){super(m,f,u,{type:"node.js",restartOnError:!1})}}e.$gq=C;class E extends w{constructor(m,f,u){super(m,f,u,{type:"universal",restartOnError:!0})}}e.$hq=E;function b(d){return d.map(m=>({type:m.type,resource:D.URI.revive(m.resource),cId:m.cId}))}e.$iq=b;function h(d){const m=new g;for(const f of d)m.processEvent(f);return m.coalesce()}e.$jq=h;function $(d,m){return typeof m=="string"&&!m.startsWith(k.$Jj)&&!(0,r.$ic)(m)?{base:d,pattern:m}:m}e.$kq=$;function c(d,m){const f=[];for(const u of m)f.push((0,k.$Nj)($(d,u)));return f}e.$lq=c;class g{constructor(){this.a=new Set,this.b=new Map}c(m){return I.$k?m.resource.fsPath:m.resource.fsPath.toLowerCase()}processEvent(m){const f=this.b.get(this.c(m));let u=!1;if(f){const l=f.type,t=m.type;f.resource.fsPath!==m.resource.fsPath&&(m.type===2||m.type===1)?u=!0:l===1&&t===2?(this.b.delete(this.c(m)),this.a.delete(f)):l===2&&t===1?f.type=0:l===1&&t===0||(f.type=t)}else u=!0;u&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],f=[];return Array.from(this.a).filter(u=>u.type!==2?(m.push(u),!1):!0).sort((u,l)=>u.resource.fsPath.length-l.resource.fsPath.length).filter(u=>f.some(l=>(0,S.$Lk)(u.resource.fsPath,l,!I.$k))?!1:(f.push(u.resource.fsPath),!0)).concat(m)}}}),define(be[222],ve([1,0,14,39,10,6,2,50,22,16,56]),function(he,e,k,O,r,I,D,S,v,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=e.$pO=void 0,e.$pO="localFilesystem";class E extends D.$Tc{constructor(h,$){super(),this.a=h,this.b=$,this.onDidChangeCapabilities=I.Event.None,this.f=this.B(new I.$Wd),this.onDidChangeFile=this.f.event,this.g=this.B(new I.$Wd),this.onDidWatchError=this.g.event,this.h=(0,v.$rg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,$){const{buffer:c}=await this.a.call("readFile",[h,$]);return c}readFileStream(h,$,c){const g=(0,S.$$d)(m=>k.$ke.concat(m.map(f=>k.$ke.wrap(f))).buffer),d=new D.$Sc;return d.add(this.a.listen("readFileStream",[h,$])(m=>{if(m instanceof k.$ke)g.write(m.buffer);else{if(m==="end")g.end();else{let f;if(m instanceof Error)f=m;else{const u=m;f=(0,w.$Ek)(u.message??(0,O.$Ri)(u),u.code??w.FileSystemProviderErrorCode.Unknown)}g.error(f),g.end()}d.dispose()}})),d.add(c.onCancellationRequested(()=>{g.error((0,r.$6)()),g.end(),d.dispose()})),g}writeFile(h,$,c){return this.a.call("writeFile",[h,k.$ke.wrap($),c])}open(h,$){return this.a.call("open",[h,$])}close(h){return this.a.call("close",[h])}async read(h,$,c,g,d){const[m,f]=await this.a.call("read",[h,$,d]);return c.set(m.buffer.slice(0,f),g),f}write(h,$,c,g,d){return this.a.call("write",[h,$,k.$ke.wrap(c),g,d])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,$){return this.a.call("delete",[h,$])}rename(h,$,c){return this.a.call("rename",[h,$,c])}copy(h,$,c){return this.a.call("copy",[h,$,c])}cloneFile(h,$){return this.a.call("cloneFile",[h,$])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const $=h;this.f.fire((0,C.$iq)($))}else{const $=h;this.g.fire($)}}))}watch(h,$){const c=(0,v.$rg)();return this.a.call("watch",[this.h,c,h,$]),(0,D.$Rc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$qO=E}),define(be[223],ve([1,0,27,15,20,40,2,98,7,3,19,4,172,23,56]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=void 0;class c extends D.$Tc{static{this.a=100}static{this.b=75}constructor(m,f,u,l){super(),this.m=m,this.n=f,this.r=u,this.s=l,this.c=this.B(new O.$jh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new O.$ih(t=>this.z(t),c.b)),this.g=(0,$.$lq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$lq)(this.m.path,this.m.includes):void 0,this.j=new r.$7d,this.ready=this.t()}async t(){try{const m=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const f=await h.Promises.stat(m);this.B(await this.w(m,f.isDirectory()))}catch(m){m.code!=="ENOENT"?this.D(m):this.G(m)}}async u(m){let f=m.path;try{f=await h.Promises.realpath(m.path),m.path===f&&(f=await(0,b.$vq)(m.path)??m.path),m.path!==f&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${f})`)}catch{}return f}async w(m,f){if(w.$j&&(0,I.$9f)(m,"/Volumes/",!0))return this.D(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Tc.None;const u=new r.$7d(this.j.token),l=new D.$Sc;try{const t=E.URI.file(this.m.path),o=(0,v.$nc)(m),n=(0,k.watch)(m);l.add((0,D.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${m}'`);const s=new Set;if(f)try{for(const a of await h.Promises.readdir(m))s.add(a)}catch(a){this.D(a)}const i=new Map;l.add((0,D.$Rc)(()=>{for(const[,a]of i)a.dispose();i.clear()})),n.on("error",(a,p)=>{this.D(`Failed to watch ${m} for changes using fs.watch() (${a}, ${p})`),this.dispose()}),n.on("change",(a,p)=>{if(u.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${p}`);let L="";if(p&&(L=p.toString(),w.$j&&(L=(0,S.$Hl)(L))),!(!L||a!=="change"&&a!=="rename"))if(f)if(a==="rename"){i.get(L)?.dispose();const P=setTimeout(async()=>{if(i.delete(L),L===o&&!await h.Promises.exists(m)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const y=await this.C((0,v.$jc)(m,L));if(u.token.isCancellationRequested)return;let A;y?s.has(L)?A=0:(A=1,s.add(L)):(s.delete(L),A=2),this.y({resource:(0,C.$Ig)(t,L),type:A,cId:this.m.correlationId})},c.a);i.set(L,(0,D.$Rc)(()=>clearTimeout(P)))}else{let P;s.has(L)?P=0:(P=1,s.add(L)),this.y({resource:(0,C.$Ig)(t,L),type:P,cId:this.m.correlationId})}else if(a==="rename"||L!==o){const P=setTimeout(async()=>{const y=await h.Promises.exists(m);u.token.isCancellationRequested||(y?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),l.add(await this.w(m,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);l.clear(),l.add((0,D.$Rc)(()=>clearTimeout(P)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await h.Promises.exists(m)&&!u.token.isCancellationRequested&&this.D(`Failed to watch ${m} for changes using fs.watch() (${t.toString()})`)}return(0,D.$Rc)(()=>{u.dispose(!0),l.dispose()})}y(m,f=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`),!f&&this.g.some(u=>u(m.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${m.resource.fsPath}`):!f&&this.h&&this.h.length>0&&!this.h.some(u=>u(m.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${m.resource.fsPath}`):this.f.work(m))}z(m){const f=(0,$.$jq)(m);if(f.length>0){if(this.s)for(const l of f)this.G(` >> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`);this.c.work(f)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(m){if(w.$k)return h.Promises.exists(m);try{const f=(0,v.$nc)(m);return(await h.Promises.readdir((0,v.$mc)(m))).some(l=>l===f)}catch(f){return this.G(f),!1}}setVerboseLogging(m){this.s=m}D(m){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}F(m){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}G(m){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$yq=c;async function g(d,m,f,u,l=512){const t=await h.Promises.open(d,"r"),o=Buffer.allocUnsafe(l),n=new r.$7d(u);let s,i=!1;const a={path:d,excludes:[],recursive:!1},p=new c(a,L=>{(async()=>{for(const{type:P}of L)if(P===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await h.Promises.read(t,o,0,l,null);if(!y||n.token.isCancellationRequested)break;m(o.slice(0,y))}}catch(y){s=new Error(y),n.dispose(!0)}finally{i=!1}}})()});return await p.ready,f(),new Promise((L,P)=>{n.token.onCancellationRequested(async()=>{p.dispose();try{await h.Promises.close(t)}catch(y){s=new Error(y)}s?P(s):L()})})}e.$zq=g}),define(be[224],ve([1,0,6,80,2,3,223]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class S extends r.$Tc{constructor(){super(...arguments),this.a=this.B(new k.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(w){const C=this.j(w),E=C.filter(h=>{const $=this.c.get(h.path);return $?!(0,O.$Rj)($.request.excludes,h.excludes)||!(0,O.$Rj)($.request.includes,h.includes):!0}),b=Array.from(this.c.values()).filter(({request:h})=>!C.find($=>$.path===h.path&&(0,O.$Rj)($.excludes,h.excludes)&&(0,O.$Rj)($.includes,h.includes))).map(({request:h})=>h.path);E.length&&this.m(`Request to start watching: ${E.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const h of b)this.h(h);for(const h of E)this.g(h)}g(w){const C=new D.$yq(w,b=>this.a.fire(b),b=>this.b.fire(b),this.f),E={request:w,instance:C};this.c.set(w.path,E)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const C=this.c.get(w);C&&(this.c.delete(w),C.instance.dispose())}j(w){const C=new Map;for(const E of w){const b=I.$k?E.path:E.path.toLowerCase();let h=C.get(E.correlationId);h||(h=new Map,C.set(E.correlationId,h)),h.set(b,E)}return Array.from(C.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(w){this.f=w;for(const[,C]of this.c)C.instance.setVerboseLogging(w)}m(w){this.f&&this.b.fire({type:"trace",message:this.n(w)})}n(w,C){return C?`[File Watcher (node.js)] ${w} (path: ${C.request.path})`:`[File Watcher (node.js)] ${w}`}}e.$Aq=S}),define(be[225],ve([1,0,56,224]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class r extends k.$gq{constructor(D,S,v){super(D,S,v),this.s()}r(D){return D.add(new O.$Aq)}}e.$Bq=r}),define(be[226],ve([1,0,12,44,107,56]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;class D extends I.$hq{constructor(v,w,C){super(v,w,C),this.s()}r(v){const w=v.add(new r.$sq(k.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(w.onDidProcessExit(({code:C,signal:E})=>this.t(`terminated by itself with code ${C}, signal: ${E}`))),O.ProxyChannel.toService((0,O.$Nh)(w.getChannel("watcher")))}}e.$tq=D}),define(be[84],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class k{constructor(...r){this.a=new Map;for(const[I,D]of r)this.set(I,D)}set(r,I){const D=this.a.get(r);return this.a.set(r,I),D}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$5h=k}),define(be[111],ve([1,0,15,10,2,68,219,5,84,97]),function(he,e,k,O,r,I,D,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;const C=!1;class E extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class b{constructor(g=new v.$5h,d=!1,m,f=C){this.f=g,this.g=d,this.h=m,this.i=f,this.o=new Set,this.f.set(S.$6h,this),this._globalGraph=f?m?._globalGraph??new D.$Eq(u=>u):void 0}createChild(g){return new b(g,this.g,this,this.i)}invokeFunction(g,...d){const m=$.traceInvocation(this.i,g);let f=!1;try{return g({get:l=>{if(f)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(l,m);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...d)}finally{f=!0,m.stop()}}createInstance(g,...d){let m,f;return g instanceof I.$4h?(m=$.traceCreation(this.i,g.ctor),f=this.j(g.ctor,g.staticArguments.concat(d),m)):(m=$.traceCreation(this.i,g),f=this.j(g,d,m)),m.stop(),f}j(g,d=[],m){const f=S._util.getServiceDependencies(g).sort((t,o)=>t.index-o.index),u=[];for(const t of f){const o=this.m(t.id,m);o||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(o)}const l=f.length>0?f[0].index:d.length;if(d.length!==l){console.trace(`[createInstance] First service dependency of ${g.name} at position ${l+1} conflicts with ${d.length} static arguments`);const t=l-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,l)}return Reflect.construct(g,d.concat(u))}k(g,d){if(this.f.get(g)instanceof I.$4h)this.f.set(g,d);else if(this.h)this.h.k(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const d=this.f.get(g);return!d&&this.h?this.h.l(g):d}m(g,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const m=this.l(g);return m instanceof I.$4h?this.q(g,m,d.branch(g,!0)):(d.branch(g,!1),m)}q(g,d,m){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,d,m)}finally{this.o.delete(g)}}r(g,d,m){const f=new D.$Eq(t=>t.id.toString());let u=0;const l=[{id:g,desc:d,_trace:m}];for(;l.length;){const t=l.pop();if(f.lookupOrInsertNode(t),u++>1e3)throw new E(f);for(const o of S._util.getServiceDependencies(t.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${g} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof I.$4h){const s={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};f.insertEdge(t,s),l.push(s)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new E(f);break}for(const{data:o}of t){if(this.l(o.id)instanceof I.$4h){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}f.removeNode(o)}}return this.l(g)}s(g,d,m=[],f,u){if(this.f.get(g)instanceof I.$4h)return this.t(g,d,m,f,u);if(this.h)return this.h.s(g,d,m,f,u);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(g,d,m=[],f,u){if(f){const l=new b(void 0,this.g,this,this.i);l.c=String(g);const t=new Map,o=new k.$nh(()=>{const n=l.j(d,m,u);for(const[s,i]of t){const a=n[s];if(typeof a=="function")for(const p of i)p.disposable=a.apply(n,p.listener)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let p=t.get(s);return p||(p=new w.$4c,t.set(s,p)),(P,y,A)=>{if(o.isInitialized)return o.value[s](P,y,A);{const M={listener:[P,y,A],disposable:void 0},_=p.push(M);return(0,r.$Rc)(()=>{_(),M.disposable?.dispose()})}}}if(s in n)return n[s];const i=o.value;let a=i[s];return typeof a!="function"||(a=a.bind(i),n[s]=a),a},set(n,s,i){return o.value[s]=i,!0},getPrototypeOf(n){return d.prototype}})}else return this.j(d,m,u)}u(g,d){if(d&&console.warn(g),this.g)throw new Error(g)}}e.$Fq=b;var h;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(h||(h={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,d){return g?new $(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(g,d){return g?new $(1,d.name):$.c}static{this.f=0}constructor(g,d){this.type=g,this.name=d,this.g=Date.now(),this.h=[]}branch(g,d){const m=new $(3,g.toString());return this.h.push([g,d,m]),m}stop(){const g=Date.now()-this.g;$.f+=g;let d=!1;function m(u,l){const t=[],o=new Array(u+1).join("	");for(const[n,s,i]of l.h)if(s&&i){d=!0,t.push(`${o}CREATES -> ${n}`);const a=m(u+1,i);a&&t.push(a)}else t.push(`${o}uses -> ${n}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(g>2||d)&&$.all.add(f.join(`
`))}}e.$Gq=$}),define(be[227],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$pv=void 0,e.$pv=(0,k.$7h)("labelService");var O;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(O||(e.Verbosity=O={}))});var Oe=this&&this.__param||function(he,e){return function(k,O){e(k,O,he)}};define(be[85],ve([1,0,20,2,3,194,30,5]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=void 0;function v(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$hr=v,e.$ir=(0,S.$7h)("languagePackService");let w=class extends O.$Tc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new k.$7d;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const $=b.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(g=>g.startsWith("lp-"))).map(c=>{const g=c.properties.localizedLanguages?.[0],d=v(c);return{...this.f(d,g,c),extensionId:c.identifier.id,galleryExtension:c}});return $.push(this.f("en","English")),$}f(E,b,h){const $=b??E;let c;if($!==E&&(c=`(${E})`),E.toLowerCase()===r.$w.toLowerCase()&&(c??="",c+=(0,I.localize)(0,null)),h?.installCount){c??="";const g=h.installCount;let d;g>1e6?d=`${Math.floor(g/1e5)/10}M`:g>1e3?d=`${Math.floor(g/1e3)}K`:d=String(g),c+=` $(cloud-download) ${d}`}return{id:E,label:$,description:c}}};e.$jr=w,e.$jr=w=Ne([Oe(0,D.$zo)],w)}),define(be[13],ve([1,0,39,6,62,2,24,3,19,11,4,69,5]),function(he,e,k,O,r,I,D,S,v,w,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.log=e.$rj=e.LogLevel=e.$qj=e.$pj=e.$oj=void 0,e.$oj=(0,b.$7h)("logService"),e.$pj=(0,b.$7h)("loggerService");function h(){return new Date().toISOString()}function $(P){return(0,w.$Nf)(P)}e.$qj=$;var c;(function(P){P[P.Off=0]="Off",P[P.Trace=1]="Trace",P[P.Debug=2]="Debug",P[P.Info=3]="Info",P[P.Warning=4]="Warning",P[P.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$rj=c.Info;function g(P,y,A){switch(y){case c.Trace:P.trace(A);break;case c.Debug:P.debug(A);break;case c.Info:P.info(A);break;case c.Warning:P.warn(A);break;case c.Error:P.error(A);break;case c.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=g;function d(P,y=!1){let A="";for(let M=0;M<P.length;M++){let _=P[M];if(_ instanceof Error&&(_=(0,k.$Ri)(_,y)),typeof _=="object")try{_=JSON.stringify(_)}catch{}A+=(M>0?" ":"")+_}return A}class m extends I.$Tc{constructor(){super(...arguments),this.b=e.$rj,this.c=this.B(new O.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==c.Off&&this.b<=y}}e.$tj=m;class f extends m{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...A){this.f(c.Trace)&&this.g(c.Trace,d([y,...A],!0))}debug(y,...A){this.f(c.Debug)&&this.g(c.Debug,d([y,...A]))}info(y,...A){this.f(c.Info)&&this.g(c.Info,d([y,...A]))}warn(y,...A){this.f(c.Warning)&&this.g(c.Warning,d([y,...A]))}error(y,...A){if(this.f(c.Error))if(y instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=y.stack,this.g(c.Error,d(M))}else this.g(c.Error,d([y,...A]))}flush(){}}e.$uj=f;class u extends m{constructor(y=e.$rj){super(),this.setLevel(y),this.g=!S.$i}trace(y,...A){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,y,...A):console.log(`[main ${h()}]`,y,...A))}debug(y,...A){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,y,...A):console.log(`[main ${h()}]`,y,...A))}info(y,...A){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,y,...A):console.log(`[main ${h()}]`,y,...A))}warn(y,...A){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,y,...A):console.warn(`[main ${h()}]`,y,...A))}error(y,...A){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,y,...A):console.error(`[main ${h()}]`,y,...A))}flush(){}}e.$vj=u;class l extends m{constructor(y=e.$rj,A=!0){super(),this.g=A,this.setLevel(y)}trace(y,...A){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...A):console.log(y,...A))}debug(y,...A){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...A):console.log(y,...A))}info(y,...A){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...A):console.log(y,...A))}warn(y,...A){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...A):console.log(y,...A))}error(y,...A){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...A):console.error(y,...A))}flush(){}}e.$wj=l;class t extends m{constructor(y,A=e.$rj){super(),this.g=y,this.setLevel(A)}trace(y,...A){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(y),...A])}debug(y,...A){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(y),...A])}info(y,...A){this.f(c.Info)&&this.g.log(c.Info,[this.h(y),...A])}warn(y,...A){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(y),...A])}error(y,...A){this.f(c.Error)&&this.g.log(c.Error,[this.h(y),...A])}h(y){return typeof y=="string"?y:(0,k.$Ri)(y,this.f(c.Trace))}flush(){}}e.$xj=t;class o extends m{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const A of this.g)A.setLevel(y);super.setLevel(y)}trace(y,...A){for(const M of this.g)M.trace(y,...A)}debug(y,...A){for(const M of this.g)M.debug(y,...A)}info(y,...A){for(const M of this.g)M.info(y,...A)}warn(y,...A){for(const M of this.g)M.warn(y,...A)}error(y,...A){for(const M of this.g)M.error(y,...A)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$yj=o;class n extends I.$Tc{constructor(y,A,M){if(super(),this.h=y,this.j=A,this.b=new D.$Ac,this.c=this.B(new O.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$Wd),this.onDidChangeVisibility=this.g.event,M)for(const _ of M)this.b.set(_.resource,{logger:void 0,info:_})}m(y){return(0,w.$Jf)(y)?[...this.b.values()].find(A=>A.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,A){const M=this.n(y),_=(0,w.$Jf)(y)?y:A?.id??(0,r.$Ui)(M.toString()).toString(16);let se=this.b.get(M)?.logger;const G=A?.logLevel==="always"?c.Trace:A?.logLevel;se||(se=this.s(M,G??this.getLogLevel(M)??this.h,{...A,id:_}));const oe={logger:se,info:{resource:M,id:_,logLevel:G,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(oe.info),this.b.set(M,oe),se}n(y){return(0,w.$Jf)(y)?(0,v.$Ig)(this.j,`${y}.log`):y}setLogLevel(y,A){if(C.URI.isUri(y)){const M=y,_=A,se=this.b.get(M);se&&_!==se.info.logLevel&&(se.info.logLevel=_===this.h?void 0:_,se.logger?.setLevel(_),this.b.set(se.info.resource,se),this.f.fire([M,_]))}else{this.h=y;for(const[M,_]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,A){const M=this.m(y);M&&A!==!M.info.hidden&&(M.info.hidden=!A,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,A]))}getLogLevel(y){let A;return y&&(A=this.b.get(y)?.info.logLevel),A??this.h}registerLogger(y){const A=this.b.get(y.resource);A?A.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const A=this.b.get(y);A&&(A.logger&&A.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$zj=n;class s{constructor(){this.onDidChangeLogLevel=new O.$Wd().event}setLevel(y){}getLevel(){return c.Info}trace(y,...A){}debug(y,...A){}info(y,...A){}warn(y,...A){}error(y,...A){}critical(y,...A){}dispose(){}flush(){}}e.$Aj=s;class i extends s{}e.$Bj=i;function a(P){if(P.verbose)return c.Trace;if(typeof P.logLevel=="string"){const y=L(P.logLevel.toLowerCase());if(y!==void 0)return y}return e.$rj}e.$Cj=a;function p(P){switch(P){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$Dj=p;function L(P){switch(P){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$Ej=L,e.$Fj=new E.$lj("logLevel",p(c.Info))}),define(be[86],ve([1,0,10,5,13]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=void 0,e.$Gp=(0,O.$7h)("IExtensionSignatureVerificationService");let I=class{constructor(S){this.b=S}c(){return this.a||(this.a=new Promise((S,v)=>he(["node-vsce-sign"],async w=>S(w),v))),this.a}async verify(S,v,w){let C;try{C=await this.c()}catch(E){return this.b.error("Could not load vsce-sign module",(0,k.$0)(E)),!1}return C.verify(S,v,w)}};e.$Hp=I,e.$Hp=I=Ne([Oe(0,r.$oj)],I)}),define(be[228],ve([1,0,18,15,10,6,2,7,56,13]),function(he,e,k,O,r,I,D,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class C extends D.$Tc{constructor(b,h){super(),this.a=b,this.b=h,this.c=this.B(new I.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$5g(0)),this.w=[],this.y=this.B(new O.$5g(0))}watch(b,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(b,h):this.z(b,h)}n(b,h){const $={path:this.H(b),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},c=(0,k.$Ub)(this.j,$);return this.r(),(0,D.$Rc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,r.$1)(b))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,v.$iq)(h)),h=>this.G(h),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const h of this.j)(0,v.$eq)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const h of this.j)(0,v.$eq)(h)&&b.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,h){const $={path:this.H(b),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},c=(0,k.$Ub)(this.w,$);return this.C(),(0,D.$Rc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,r.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,v.$iq)(b)),b=>this.G(b),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,S.$hc)(b.fsPath)}}e.$mq=C}),define(be[112],ve([1,0,18,15,14,20,6,62,49,2,64,12,42,19,50,190,16,110,13,10]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;let l=class extends w.$Tc{static{u=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$Wd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Wd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Wd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Wd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Wd),this.Y=this.B(new D.$Wd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Wd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new O.$dh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${o}`);const s=new w.$Sc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(i=>{const a=new g.$Kk(i,!this.S(n));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this.Z.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,w.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,w.$Oc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await O.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return v.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,h.$Mg)(o))throw new g.$Mk((0,c.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new f.$bb;throw s.message=(0,c.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,g.$xk)(n)||(0,g.$uk)(n)||(0,g.$yk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,g.$xk)(n)||(0,g.$uk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,g.$Hk)(s)===g.FileSystemProviderErrorCode.FileNotFound?new g.$Mk((0,c.localize)(2,null,this.sb(o)),1):(0,g.$Fk)(s)}}async s(o,n){const s=await this.j(o),i=this.S(s),a=n?.resolveTo,p=n?.resolveSingleChildDescendants,L=n?.resolveMetadata,P=await s.stat(o);let y;return this.t(s,o,P,void 0,!!L,(A,M)=>(y||(y=C.$ai.forUris(()=>!i),y.set(o,!0),a&&y.fill(!0,a)),y.get(A.resource)||y.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&p?M===1:!1))}async t(o,n,s,i,a,p){const{providerExtUri:L}=this.R(o),P={resource:n,name:L.basename(n),isFile:(s.type&g.FileType.File)!==0,isDirectory:(s.type&g.FileType.Directory)!==0,isSymbolicLink:(s.type&g.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&g.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&g.FilePermission.Locked),etag:(0,g.$Xk)({mtime:s.mtime,size:s.size}),children:void 0};if(P.isDirectory&&p(P,i)){try{const y=await o.readdir(n),A=await O.Promises.settled(y.map(async([M,_])=>{try{const se=L.joinPath(n,M),G=a?await o.stat(se):{type:_};return await this.t(o,se,G,y.length,a,p)}catch(se){return this.b.trace(se),null}}));P.children=(0,k.$Hb)(A)}catch(y){this.b.trace(y),P.children=[]}return P}return P}async resolveAll(o){return O.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new g.$Mk((0,c.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=r.$ke.fromString(""),s){await this.u(o,s);const i=await this.writeFile(o,n);return this.r.fire(new g.$Jk(o,0,i)),i}async writeFile(o,n,s){const i=this.qb(await this.n(o),o),{providerExtUri:a}=this.R(i);let p=s;if((0,g.$Ak)(i)&&!p?.atomic){const L=i.enforceAtomicWriteFile?.(o);L&&(p={...s,atomic:L})}try{await this.w(i,o,p)||await this.U(i,a.dirname(o));let P;if((0,g.$uk)(i)&&!(n instanceof r.$ke))if((0,$.$9d)(n)){const y=await(0,$.$de)(n,3);y.ended?P=r.$ke.concat(y.buffer):P=y}else P=(0,$.$ae)(n,y=>r.$ke.concat(y),3);else P=n;!(0,g.$xk)(i)||(0,g.$uk)(i)&&P instanceof r.$ke||(0,g.$uk)(i)&&(0,g.$Ak)(i)&&p?.atomic?await this.hb(i,o,p,P):await this.db(i,o,p,P instanceof r.$ke?(0,r.$ve)(P):P),this.r.fire(new g.$Jk(o,4))}catch(L){throw new g.$Mk((0,c.localize)(4,null,this.sb(o),(0,g.$Fk)(L).toString()),(0,g.$Ik)(L),p)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const i=!!s?.unlock;if(i&&!(o.capabilities&8192))throw new Error((0,c.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,c.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,c.localize)(7,null,this.sb(n)));if(i)throw new Error((0,c.localize)(8,null,this.sb(n)))}let p;try{p=await o.stat(n)}catch{return}if(p.type&g.FileType.Directory)throw new g.$Mk((0,c.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,p),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==g.$Wk&&typeof p.mtime=="number"&&typeof p.size=="number"&&s.mtime<p.mtime&&s.etag!==(0,g.$Xk)({mtime:s.mtime,size:p.size}))throw new g.$Mk((0,c.localize)(10,null),3,s);return p}async readFile(o,n,s){const i=await this.m(o);return n?.atomic?this.z(i,o,n,s):this.C(i,o,n,s)}async z(o,n,s,i){return new Promise((a,p)=>{this.cb.queueFor(n,async()=>{try{const L=await this.C(o,n,s,i);a(L)}catch(L){p(L)}},this.R(o).providerExtUri)})}async C(o,n,s,i){const a=await this.D(o,n,{...s,preferUnbuffered:!0},i);return{...a,value:await(0,r.$we)(a.value)}}async readFileStream(o,n,s){const i=await this.m(o);return this.D(i,o,n,s)}async D(o,n,s,i){const a=new I.$7d(i);let p=s;(0,g.$zk)(o)&&o.enforceAtomicReadFile?.(n)&&(p={...s,atomic:!0});const L=this.J(n,p).then(y=>y,y=>{throw a.dispose(!0),y});let P;try{return typeof p?.etag=="string"&&p.etag!==g.$Wk&&await L,p?.atomic&&(0,g.$zk)(o)||!((0,g.$xk)(o)||(0,g.$yk)(o))||(0,g.$uk)(o)&&p?.preferUnbuffered?P=this.I(o,n,p):(0,g.$yk)(o)?P=this.G(o,n,a.token,p):P=this.H(o,n,a.token,p),P.on("end",()=>a.dispose()),P.on("error",()=>a.dispose()),{...await L,value:P}}catch(y){throw P&&await(0,$.$be)(P),this.F(y,n,p)}}F(o,n,s){const i=(0,c.localize)(11,null,this.sb(n),(0,g.$Fk)(o).toString());return o instanceof g.$Ok?new g.$Ok(i,o.stat,s):o instanceof g.$Nk?new g.$Nk(i,o.fileOperationResult,o.size,o.options):new g.$Mk(i,(0,g.$Ik)(o),s)}G(o,n,s,i=Object.create(null)){const a=o.readFileStream(n,i,s);return(0,$.$he)(a,{data:p=>p instanceof r.$ke?p:r.$ke.wrap(p),error:p=>this.F(p,n,i)},p=>r.$ke.concat(p))}H(o,n,s,i=Object.create(null)){const a=(0,r.$Ae)();return(0,d.$cq)(o,n,a,p=>p,{...i,bufferSize:this.a,errorTransformer:p=>this.F(p,n,i)},s),a}I(o,n,s){const i=(0,$.$$d)(a=>r.$ke.concat(a));return(async()=>{try{let a;s?.atomic&&(0,g.$zk)(o)?a=await o.readFile(n,{atomic:!0}):a=await o.readFile(n),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.L(n,a.byteLength,s),i.end(r.$ke.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new g.$Mk((0,c.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==g.$Wk&&n.etag===s.etag)throw new g.$Ok((0,c.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new g.$Nk((0,c.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,i){if(o.toString()!==n.toString())try{const a=s==="move"?this.qb(await this.n(o),o):await this.m(o),p=this.qb(await this.n(n),n);await this.Q(a,o,p,n,s,i)}catch(a){return a}return!0}async move(o,n,s){const i=this.qb(await this.n(o),o),a=this.qb(await this.n(n),n),p=await this.N(i,o,a,n,"move",!!s),L=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$Jk(o,p==="move"?2:3,L)),L}async copy(o,n,s){const i=await this.m(o),a=this.qb(await this.n(n),n),p=await this.N(i,o,a,n,"copy",!!s),L=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$Jk(o,p==="copy"?3:2,L)),L}async N(o,n,s,i,a,p){if(n.toString()===i.toString())return a;const{exists:L,isSameResourceWithDifferentPathCase:P}=await this.Q(o,n,s,i,a,p);if(L&&!P&&p&&await this.del(i,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(i)),a==="copy"){if(o===s&&(0,g.$vk)(o))await o.copy(n,i,{overwrite:p});else{const y=await this.resolve(n);y.isDirectory?await this.P(o,y,s,i):await this.O(o,n,s,i)}return a}else return o===s?(await o.rename(n,i,{overwrite:p}),a):(await this.N(o,n,s,i,"copy",p),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,i){if((0,g.$xk)(o)&&(0,g.$xk)(s))return this.jb(o,n,s,i);if((0,g.$xk)(o)&&(0,g.$uk)(s))return this.pb(o,n,s,i);if((0,g.$uk)(o)&&(0,g.$xk)(s))return this.nb(o,n,s,i);if((0,g.$uk)(o)&&(0,g.$uk)(s))return this.lb(o,n,s,i)}async P(o,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await O.Promises.settled(n.children.map(async a=>{const p=this.R(s).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.P(o,await this.resolve(a.resource),s,p):this.O(o,a.resource,s,p)}))}async Q(o,n,s,i,a,p){let L=!1;if(o===s){const{providerExtUri:y,isPathCaseSensitive:A}=this.R(o);if(A||(L=y.isEqual(n,i)),L&&a==="copy")throw new Error((0,c.localize)(15,null,this.sb(n),this.sb(i)));if(!L&&y.isEqualOrParent(i,n))throw new Error((0,c.localize)(16,null,this.sb(n),this.sb(i)))}const P=await this.exists(i);if(P&&!L){if(!p)throw new g.$Mk((0,c.localize)(17,null,this.sb(n),this.sb(i)),4);if(o===s){const{providerExtUri:y}=this.R(o);if(y.isEqualOrParent(n,i))throw new Error((0,c.localize)(18,null,this.sb(n),this.sb(i)))}}return{exists:P,isSameResourceWithDifferentPathCase:L}}R(o){const n=this.S(o);return{providerExtUri:n?h.$yg:h.$Ag,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new g.$Jk(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:i}=this.R(o);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await o.stat(n)).type&g.FileType.Directory))throw new Error((0,c.localize)(19,null,this.sb(n)));break}catch(a){if((0,g.$Hk)(a)!==g.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(i.basename(n)),n=i.dirname(n)}for(let a=s.length-1;a>=0;a--){n=i.joinPath(n,s[a]);try{await o.mkdir(n)}catch(p){if((0,g.$Hk)(p)!==g.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),i=!!n?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,c.localize)(20,null,this.sb(o)));const a=n?.atomic;if(a&&!(s.capabilities&65536))throw new Error((0,c.localize)(21,null,this.sb(o)));if(i&&a)throw new Error((0,c.localize)(22,null,this.sb(o)));let p;try{p=await s.stat(o)}catch{}if(p)this.rb(o,p);else throw new g.$Mk((0,c.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const P=await this.resolve(o);if(P.isDirectory&&Array.isArray(P.children)&&P.children.length>0)throw new Error((0,c.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let i=n;if((0,g.$Bk)(s)&&!i?.atomic){const P=s.enforceAtomicDelete?.(o);P&&(i={...n,atomic:P})}const a=!!i?.useTrash,p=!!i?.recursive,L=i?.atomic??!1;await s.delete(o,{recursive:p,useTrash:a,atomic:L}),this.r.fire(new g.$Jk(o,1))}async cloneFile(o,n){const s=await this.j(o),i=this.qb(await this.n(n),n);if(!(s===i&&this.R(s).providerExtUri.isEqual(o,n)))return s===i&&(0,g.$wk)(s)?s.cloneFile(o,n):(await this.U(i,this.R(i).providerExtUri.dirname(n)),s===i&&(0,g.$vk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,i,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:u.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new w.$Sc;let i=!1,a=()=>{i=!0};s.add((0,w.$Rc)(()=>a())),(async()=>{try{const L=await this.bb(o,n);i?(0,w.$Oc)(L):a=()=>(0,w.$Oc)(L)}catch(L){this.b.error(L)}})();const p=n.correlationId;if(typeof p=="number"){const L=s.add(new D.$Wd);return s.add(this.X.event(y=>{y.correlates(p)&&L.fire(y)})),{onDidChange:L.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),i=(0,S.$Ui)([this.R(s).providerExtUri.getComparisonKey(o),n]);let a=this.$.get(i);return a||(a={count:0,disposable:s.watch(o,n)},this.$.set(i,a)),a.count+=1,(0,w.$Rc)(()=>{a&&(a.count--,a.count===0&&((0,w.$Oc)(a.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,w.$Oc)(o.disposable);this.$.clear()}async db(o,n,s,i){return this.cb.queueFor(n,async()=>{const a=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,$.$9d)(i)||(0,$.$0d)(i)?await this.eb(o,a,i):await this.fb(o,a,i)}catch(p){throw(0,g.$Fk)(p)}finally{await o.close(a)}},this.R(o).providerExtUri)}async eb(o,n,s){let i=0,a;if((0,$.$0d)(s)){if(s.buffer.length>0){const p=r.$ke.concat(s.buffer);await this.gb(o,n,p,p.byteLength,i,0),i+=p.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise((p,L)=>{(0,$.$ce)(a,{onData:async P=>{a.pause();try{await this.gb(o,n,P,P.byteLength,i,0)}catch(y){return L(y)}i+=P.byteLength,setTimeout(()=>a.resume())},onError:P=>L(P),onEnd:()=>p()})})}async fb(o,n,s){let i=0,a;for(;(a=s.read())!==null;)await this.gb(o,n,a,a.byteLength,i,0),i+=a.byteLength}async gb(o,n,s,i,a,p){let L=0;for(;L<i;){const P=await o.write(n,a+L,s.buffer,p+L,i-L);L+=P}}async hb(o,n,s,i){return this.cb.queueFor(n,()=>this.ib(o,n,s,i),this.R(o).providerExtUri)}async ib(o,n,s,i){let a;i instanceof r.$ke?a=i:(0,$.$9d)(i)?a=await(0,r.$we)(i):(0,$.$0d)(i)?a=await(0,r.$xe)(i):a=(0,r.$ue)(i),await o.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,i){return this.cb.queueFor(i,()=>this.kb(o,n,s,i),this.R(s).providerExtUri)}async kb(o,n,s,i){let a,p;try{a=await o.open(n,{create:!1}),p=await s.open(i,{create:!0,unlock:!1});const L=r.$ke.alloc(this.a);let P=0,y=0,A=0;do A=await o.read(a,P,L.buffer,y,L.byteLength-y),await this.gb(s,p,L,A,P,y),P+=A,y+=A,y===L.byteLength&&(y=0);while(A>0)}catch(L){throw(0,g.$Fk)(L)}finally{await O.Promises.settled([typeof a=="number"?o.close(a):Promise.resolve(),typeof p=="number"?s.close(p):Promise.resolve()])}}async lb(o,n,s,i){return this.cb.queueFor(i,()=>this.mb(o,n,s,i),this.R(s).providerExtUri)}async mb(o,n,s,i){return s.writeFile(i,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,i){return this.cb.queueFor(i,()=>this.ob(o,n,s,i),this.R(s).providerExtUri)}async ob(o,n,s,i){const a=await s.open(i,{create:!0,unlock:!1});try{const p=await o.readFile(n);await this.gb(s,a,r.$ke.wrap(p),p.byteLength,0,0)}catch(p){throw(0,g.$Fk)(p)}finally{await s.close(a)}}async pb(o,n,s,i){const a=await(0,r.$we)(this.H(o,n,I.CancellationToken.None));await this.hb(s,i,void 0,a)}qb(o,n){if(o.capabilities&2048)throw new g.$Mk((0,c.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&g.FilePermission.Readonly)throw new g.$Mk((0,c.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===E.Schemas.file?o.fsPath:o.toString(!0)}};e.$dq=l,e.$dq=l=u=Ne([Oe(0,m.$oj)],l)}),define(be[70],ve([1,0,27,303,15,24,14,6,40,2,7,3,19,50,23,193,16,110,228,39,226,225]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0,(()=>{try{(0,O.gracefulify)(k)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.$Ri)(o)}`)}})();class t extends m.$mq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=S.Event.None,this.N=new I.$Ac(i=>b.$zg.getComparisonKey(i)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:i}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:g.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async a=>{try{let p;a.isSymbolicLink()?p=(await this.stat((0,b.$Ig)(n,a.name))).type:p=this.M(a),i.push([a.name,p])}catch(p){this.a.trace(p)}})),i}catch(s){throw this.fb(s)}}M(n,s){let i;return s?.dangling?i=g.FileType.Unknown:n.isFile()?i=g.FileType.File:n.isDirectory()?i=g.FileType.Directory:i=g.FileType.Unknown,s&&(i|=g.FileType.SymbolicLink),i}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const a=new r.$6g;return this.N.set(n,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,w.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),a.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),i=await this.O(n));const a=this.H(n);return await $.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{i?.dispose()}}P(n){t.I&&this.a.trace(n)}readFileStream(n,s,i){const a=(0,h.$$d)(p=>D.$ke.concat(p.map(L=>D.$ke.wrap(L))).buffer);return(0,d.$cq)(this,n,a,p=>p.buffer,{...s,bufferSize:256*1024},i),a}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,b.$Ig)((0,b.$Hg)(n),`${(0,b.$Fg)(n)}${i.atomic.postfix}`),s,i):this.S(n,s,i)}async Q(n){try{const s=this.H(n),{symbolicLink:i}=await $.SymlinkSupport.stat(s);if(i)return!1}catch{}return!0}async R(n,s,i,a){const p=new w.$Sc;try{p.add(await this.O(n)),p.add(await this.O(s)),await this.S(s,i,a,!0);try{await this.rename(s,n,{overwrite:!0})}catch(L){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw L}}finally{p.dispose()}}async S(n,s,i,a){let p;try{const L=this.H(n);if(!i.create||!i.overwrite){if(await $.Promises.exists(L)){if(!i.overwrite)throw(0,g.$Ek)((0,c.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,g.$Ek)((0,c.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(n,{create:!0,unlock:i.unlock},a),await this.write(p,0,s,0,s.byteLength)}catch(L){throw await this.gb(n,L)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(n){t.Y=n}async open(n,s,i){const a=this.H(n);let p;(0,g.$sk)(s)&&!i&&(p=await this.O(n));let L;try{if((0,g.$sk)(s)&&s.unlock)try{const{stat:y}=await $.SymlinkSupport.stat(a);y.mode&128||await $.Promises.chmod(a,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let P;if((0,g.$sk)(s)){if(E.$i)try{await $.Promises.truncate(a,0),P="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}P||(P="w")}else P="r";L=await $.Promises.open(a,P)}catch(P){throw p?.dispose(),(0,g.$sk)(s)?await this.gb(n,P):this.fb(P)}if(this.U.set(L,0),(0,g.$sk)(s)&&this.X.set(L,n),p){const P=this.W.get(L);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${L} (${a})`),this.W.set(L,p),P&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${L} (${a})`),P.dispose())}return L}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&t.Y)try{await $.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await $.Promises.close(n)}catch(i){throw this.fb(i)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,a,p){const L=this.Z(n,s);let P=null;try{P=(await $.Promises.read(n,i,a,p,L)).bytesRead}catch(y){throw this.fb(y)}finally{this.$(n,L,P)}return P}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,i){const a=this.U.get(n);typeof a=="number"&&(typeof s=="number"||(typeof i=="number"?this.U.set(n,a+i):this.U.delete(n)))}async write(n,s,i,a,p){return(0,r.$oh)(()=>this.ab(n,s,i,a,p),100,3)}async ab(n,s,i,a,p){const L=this.Z(n,s);let P=null;try{P=(await $.Promises.write(n,i,a,p,L)).bytesWritten}catch(y){throw await this.gb(this.X.get(n),y)}finally{this.$(n,L,P)}return P}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const i=this.H(n);if(s.recursive){let a;s?.atomic!==!1&&s.atomic.postfix&&(a=(0,C.$jc)((0,C.$mc)(i),`${(0,C.$nc)(i)}${s.atomic.postfix}`)),await $.Promises.rm(i,$.RimRafMode.MOVE,a)}else try{await $.Promises.unlink(i)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let p=!1;try{const{stat:L,symbolicLink:P}=await $.SymlinkSupport.stat(i);p=L.isDirectory()&&!P}catch{}if(p)await $.Promises.rmdir(i);else throw a}else throw a}}catch(i){throw this.fb(i)}}async rename(n,s,i){const a=this.H(n),p=this.H(s);if(a!==p)try{await this.bb(n,s,"move",i.overwrite),await $.Promises.rename(a,p)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,c.localize)(2,null,(0,C.$nc)(a),(0,C.$nc)((0,C.$mc)(p)),L.toString()))),this.fb(L)}}async copy(n,s,i){const a=this.H(n),p=this.H(s);if(a!==p)try{await this.bb(n,s,"copy",i.overwrite),await $.Promises.copy(a,p,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,c.localize)(3,null,(0,C.$nc)(a),(0,C.$nc)((0,C.$mc)(p)),L.toString()))),this.fb(L)}}async bb(n,s,i,a){const p=this.H(n),L=this.H(s);let P=!1;if(!!(this.capabilities&1024)||(P=(0,v.$8f)(p,L,!0)),P){if(i==="copy")throw(0,g.$Ek)((0,c.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const A=await this.L(n);if(!A)throw(0,g.$Ek)((0,c.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const M=await this.L(s);if(M){if(!a)throw(0,g.$Ek)((0,c.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);A.type&g.FileType.File&&M.type&g.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,i){const a=this.H(n),p=this.H(s),L=!!(this.capabilities&1024);if((0,v.$8f)(a,p,!L))return;const P=new w.$Sc;try{P.add(await this.O(n)),P.add(await this.O(s)),i&&await $.Promises.mkdir((0,C.$mc)(p),{recursive:!0}),await $.Promises.copyFile(a,p)}catch(y){if(y.code==="ENOENT"&&!i)return this.cb(n,s,!0);throw this.fb(y)}finally{P.dispose()}}t(n,s,i){return new u.$tq(a=>n(a),a=>s(a),i)}F(n,s,i){return new l.$Bq(a=>n(a),a=>s(a),i)}fb(n){if(n instanceof g.$Dk)return n;let s=n,i;switch(n.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=g.FileSystemProviderErrorCode.Unknown;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.$Ek)(s,i)}async gb(n,s){let i=this.fb(s);if(n&&i.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await $.SymlinkSupport.stat(this.H(n));a.mode&128||(i=(0,g.$Ek)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return i}}e.$Cq=t}),define(be[229],ve([1,0,6,70,2,14,50,20]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0;class v extends r.$Tc{constructor(E,b){super(),this.a=E,this.b=b,this.F=new Map,this.G=new Map}call(E,b,h){const $=this.c(E);switch(b){case"stat":return this.g($,h[0]);case"readdir":return this.h($,h[0]);case"open":return this.r($,h[0],h[1]);case"close":return this.s(h[0]);case"read":return this.t(h[0],h[1],h[2]);case"readFile":return this.j($,h[0],h[1]);case"write":return this.u(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.n($,h[0],h[1],h[2]);case"rename":return this.z($,h[0],h[1],h[2]);case"copy":return this.C($,h[0],h[1],h[2]);case"cloneFile":return this.D($,h[0],h[1]);case"mkdir":return this.w($,h[0]);case"delete":return this.y($,h[0],h[1]);case"watch":return this.I($,h[0],h[1],h[2],h[3]);case"unwatch":return this.J(h[0],h[1])}throw new Error(`IPC Command ${b} not found`)}listen(E,b,h){const $=this.c(E);switch(b){case"fileChange":return this.H($,h[0]);case"readFileStream":return this.m($,h[0],h[1])}throw new Error(`Unknown event ${b}`)}g(E,b){const h=this.f(E,b,!0);return this.a.stat(h)}h(E,b){const h=this.f(E,b);return this.a.readdir(h)}async j(E,b,h){const $=this.f(E,b,!0),c=await this.a.readFile($,h);return I.$ke.wrap(c)}m(E,b,h){const $=this.f(E,b,!0),c=new S.$7d,g=new k.$Wd({onDidRemoveLastListener:()=>{c.cancel()}}),d=this.a.readFileStream($,h,c.token);return(0,D.$ce)(d,{onData:m=>g.fire(I.$ke.wrap(m)),onError:m=>g.fire(m),onEnd:()=>{g.fire("end"),g.dispose(),c.dispose()}}),g.event}n(E,b,h,$){const c=this.f(E,b);return this.a.writeFile(c,h.buffer,$)}r(E,b,h){const $=this.f(E,b,!0);return this.a.open($,h)}s(E){return this.a.close(E)}async t(E,b,h){const $=I.$ke.alloc(h),c=0,g=await this.a.read(E,b,$.buffer,c,h);return[$,g]}u(E,b,h,$,c){return this.a.write(E,b,h.buffer,$,c)}w(E,b){const h=this.f(E,b);return this.a.mkdir(h)}y(E,b,h){const $=this.f(E,b);return this.a.delete($,h)}z(E,b,h,$){const c=this.f(E,b),g=this.f(E,h);return this.a.rename(c,g,$)}C(E,b,h,$){const c=this.f(E,b),g=this.f(E,h);return this.a.copy(c,g,$)}D(E,b,h){const $=this.f(E,b),c=this.f(E,h);return this.a.cloneFile($,c)}H(E,b){const h=new k.$Wd({onWillAddFirstListener:()=>{this.F.set(b,this.L(E,h))},onDidRemoveLastListener:()=>{(0,r.$Oc)(this.F.get(b)),this.F.delete(b)}});return h.event}async I(E,b,h,$,c){const g=this.F.get(b);if(g){const d=this.f(E,$),m=g.watch(h,d,c);this.G.set(b+h,m)}}async J(E,b){const h=E+b,$=this.G.get(h);$&&((0,r.$Oc)($),this.G.delete(h))}dispose(){super.dispose();for(const[,E]of this.G)E.dispose();this.G.clear();for(const[,E]of this.F)E.dispose();this.F.clear()}}e.$_r=v;class w extends r.$Tc{constructor(E,b,h,$){super(),this.c=E,this.f=h,this.g=$,this.a=new Map,this.b=this.B(new O.$Cq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(b)}h(E){const b=this.B(new k.$Wd);this.B(b.event(h=>{E.fire(h.map($=>({resource:this.c.transformOutgoingURI($.resource),type:$.type,cId:$.cId})))})),this.B(this.b.onDidChangeFile(h=>b.fire(h))),this.B(this.b.onDidWatchError(h=>E.fire(h)))}j(E){}m(E){}watch(E,b,h){const $=this.m(this.g);return Array.isArray($)&&(h.excludes=[...h.excludes,...$]),this.a.set(E,this.b.watch(b,h)),(0,r.$Rc)(()=>{(0,r.$Oc)(this.a.get(E)),this.a.delete(E)})}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),super.dispose()}}e.$as=w}),define(be[113],ve([1,0,4,6,13,2]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=void 0;class D extends r.$zj{constructor(E,b,h,$,c){super(b,h,$),this.r=E,this.t=c,this.B(c.listen("onDidChangeLogLevel",E)(g=>{(0,r.$qj)(g)?super.setLogLevel(g):super.setLogLevel(k.URI.revive(g[0]),g[1])})),this.B(c.listen("onDidChangeVisibility",E)(([g,d])=>super.setVisibility(k.URI.revive(g),d))),this.B(c.listen("onDidChangeLoggers",E)(({added:g,removed:d})=>{for(const m of g)super.registerLogger({...m,resource:k.URI.revive(m.resource)});for(const m of d)super.deregisterLogger(m.resource)}))}createConsoleMainLogger(){return new r.$xj({log:(E,b)=>{this.t.call("consoleLog",[E,b])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,b){super.setLogLevel(E,b),this.t.call("setLogLevel",[E,b])}setVisibility(E,b){super.setVisibility(E,b),this.t.call("setVisibility",[this.n(E),b])}s(E,b,h){return new S(this.t,E,b,h,this.r)}static setLogLevel(E,b,h){return E.call("setLogLevel",[b,h])}}e.$Br=D;class S extends r.$uj{constructor(E,b,h,$,c){super($?.logLevel==="always"),this.r=E,this.s=b,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[b,$,c]).then(()=>{this.u(this.n),this.m=!0})}g(E,b){const h=[[E,b]];this.m?this.u(h):this.n.push(...h)}u(E){this.r.call("log",[this.s,E])}}class v{constructor(E,b){this.a=E,this.b=b}listen(E,b){const h=this.b(E);switch(b){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(c=>this.c(c,h)),removed:[...$.removed].map(c=>this.c(c,h))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,$=>[h.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,$=>(0,r.$qj)($)?$:[h.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${b}`)}async call(E,b,h){const $=this.b(E);switch(b){case"setLogLevel":return(0,r.$qj)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(k.URI.revive($.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,$)))}throw new Error(`Call not found: ${b}`)}c(E,b){return{...E,resource:b.transformOutgoingURI(E.resource)}}}e.$Cr=v;class w extends I.$Tc{constructor(E,b){super(),b.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(h=>b.call("setLogLevel",[h]))),b.call("getRegisteredLoggers").then(h=>{for(const $ of h)E.registerLogger({...$,resource:k.URI.revive($.resource)})}),this.B(b.listen("onDidChangeVisibility")(([h,$])=>E.setVisibility(k.URI.revive(h),$))),this.B(b.listen("onDidChangeLoggers")(({added:h,removed:$})=>{for(const c of h)E.registerLogger({...c,resource:k.URI.revive(c.resource)});for(const c of $)E.deregisterLogger(c.resource)}))}}e.$Dr=w}),define(be[114],ve([1,0,2,13]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=void 0;class r extends k.$Tc{constructor(D,S=[]){super(),this.a=new O.$yj([D,...S]),this.B(D.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.$HO=r}),define(be[230],ve([1,0,16,13]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=void 0;var r;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(r||(r={}));async function I(w,C,E,b,h){try{const $=await new Promise((g,d)=>{he(["@vscode/spdlog"],g,d)});$.setFlushOn(r.Trace);const c=await $.createAsyncRotatingLogger(w,C,E,b);return h?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch($){console.error($)}return null}function D(w,C,E){switch(C){case O.LogLevel.Trace:w.trace(E);break;case O.LogLevel.Debug:w.debug(E);break;case O.LogLevel.Info:w.info(E);break;case O.LogLevel.Warning:w.warn(E);break;case O.LogLevel.Error:w.error(E);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function S(w,C){switch(C){case O.LogLevel.Trace:w.setLevel(r.Trace);break;case O.LogLevel.Debug:w.setLevel(r.Debug);break;case O.LogLevel.Info:w.setLevel(r.Info);break;case O.LogLevel.Warning:w.setLevel(r.Warning);break;case O.LogLevel.Error:w.setLevel(r.Error);break;case O.LogLevel.Off:w.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${C}`)}}class v extends O.$uj{constructor(C,E,b,h,$){super(),this.m=[],this.setLevel($),this.n=this.s(C,E,b,h),this.B(this.onDidChangeLogLevel(c=>{this.r&&S(this.r,c)}))}async s(C,E,b,h){const $=b?6:1,c=30/$*k.$Zk.MB,g=await I(C,E,c,$,h);if(g){this.r=g,S(this.r,this.getLevel());for(const{level:d,message:m}of this.m)D(this.r,d,m);this.m=[]}}g(C,E){this.r?D(this.r,C,E):this.getLevel()<=C&&this.m.push({level:C,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$wO=v}),define(be[115],ve([1,0,22,13,230]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xO=void 0;class I extends O.$zj{s(S,v,w){return new r.$wO((0,k.$rg)(),S.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,v)}}e.$xO=I}),define(be[231],ve([1,0,63,195,5]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var D;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(D||(e.MarkerSeverity=D={})),function(v){function w($,c){return c-$}v.compare=w;const C=Object.create(null);C[v.Error]=(0,O.localize)(0,null),C[v.Warning]=(0,O.localize)(1,null),C[v.Info]=(0,O.localize)(2,null);function E($){return C[$]||""}v.toString=E;function b($){switch($){case k.default.Error:return v.Error;case k.default.Warning:return v.Warning;case k.default.Info:return v.Info;case k.default.Ignore:return v.Hint}}v.fromSeverity=b;function h($){switch($){case v.Error:return k.default.Error;case v.Warning:return k.default.Warning;case v.Info:return k.default.Info;case v.Hint:return k.default.Ignore}}v.toSeverity=h}(D||(e.MarkerSeverity=D={}));var S;(function(v){const w="";function C(b){return E(b,!0)}v.makeKey=C;function E(b,h){const $=[w];return b.source?$.push(b.source.replace("\xA6","\\\xA6")):$.push(w),b.code?typeof b.code=="string"?$.push(b.code.replace("\xA6","\\\xA6")):$.push(b.code.value.replace("\xA6","\\\xA6")):$.push(w),b.severity!==void 0&&b.severity!==null?$.push(D.toString(b.severity)):$.push(w),b.message&&h?$.push(b.message.replace("\xA6","\\\xA6")):$.push(w),b.startLineNumber!==void 0&&b.startLineNumber!==null?$.push(b.startLineNumber.toString()):$.push(w),b.startColumn!==void 0&&b.startColumn!==null?$.push(b.startColumn.toString()):$.push(w),b.endLineNumber!==void 0&&b.endLineNumber!==null?$.push(b.endLineNumber.toString()):$.push(w),b.endColumn!==void 0&&b.endColumn!==null?$.push(b.endColumn.toString()):$.push(w),$.push(w),$.join("\xA6")}v.makeKeyOptionalMessage=E})(S||(e.IMarkerData=S={})),e.$Bt=(0,r.$7h)("markerService")}),define(be[71],ve([1,0,6,49,2,5]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=void 0,e.$Kn=(0,I.$7h)("policy");class D extends r.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.$Wd),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const C=Object.keys(this.f).length;return this.f={...w,...this.f},C!==Object.keys(this.f).length&&await this.j(w),O.Iterable.reduce(this.g.entries(),(E,[b,h])=>({...E,[b]:h}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(w,[C,E])=>({...w,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.$Ln=D;class S{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Mn=S}),define(be[57],ve([1,0,29]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.context<"u"){const I=r.context.configuration();if(I)O=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,k.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:I.version})}}else O={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testCoverage"],"ms-vscode.extension-test-runner":["testCoverage"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"vscjava.vscode-java-test":["testCoverage"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","handleIssueUri","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","commentReactor","contribShareMenu","fileComments","contribCommentPeekContext","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","treeViewMarkdownMessage","tabInputTextMerge","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatAgents2","chatAgents2Additions","defaultChatAgent","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"apidev.azure-api-center":["chatAgents2","chatRequestAccess"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot","github.copilot-chat","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.86.1",sha256:"e382de75b63a57d3419bbb110e17551d40d88b4bb0a49452dab2c7278b815e72",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.86.1",commit:"31c37ee8f63491495ac49e43b8544550fbae4533",date:"2024-02-07T08:35:21.863Z"},Object.keys(O).length===0&&Object.assign(O,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(be[31],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Gj=(0,k.$7h)("productService"),e.$Hj="vscode://schemas/vscode-product"}),define(be[37],ve([1,0,96,11]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0;class r{constructor(){this.a=new Map}add(D,S){k.ok(O.$Jf(D)),k.ok(O.$Lf(S)),k.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$In=new r}),define(be[232],ve([1,0,6,37]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0,e.$Jn={JSONContribution:"base.contributions.json"};function r(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class I{constructor(){this.b=new k.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,w){this.a[r(v)]=w,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const D=new I;O.$In.add(e.$Jn.JSONContribution,D)}),define(be[45],ve([1,0,18,6,11,177,25,232,37]),function(he,e,k,O,r,I,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.ConfigurationScope=e.$Nn=e.EditPresentationTypes=void 0;var w;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$Nn={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un="vscode://schemas/settings/resourceLanguage",e.$Vn="vscode://schemas/settings/configurationDefaults";const E=v.$In.as(S.$Jn.JSONContribution);class b{constructor(){this.h=new Set,this.i=new O.$Wd,this.onDidSchemaChange=this.i.event,this.j=new O.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Un,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const n=new Set;this.n(t,o,n),E.registerSchema(e.$Un,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const o=new Set;this.o(t,o),E.registerSchema(e.$Un,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const n=new Set;this.o(o,n),this.n(t,!1,n),E.registerSchema(e.$Un,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const n=[];for(const{overrides:s,source:i}of t)for(const a in s)if(o.add(a),e.$Xn.test(a)){const p=this.a.get(a),L=p?.valuesSources??new Map;if(i)for(const M of Object.keys(s[a]))L.set(M,i);const P={...p?.value||{},...s[a]};this.a.set(a,{source:i,value:P,valuesSources:L});const y=(0,D.$Ki)(a),A={type:"object",default:P,description:I.localize(1,null,y),$ref:e.$Un,defaultDefaultValue:P,source:r.$Jf(i)?void 0:i,defaultValueSource:i};n.push(...c(a)),this.d[a]=A,this.b.properties[a]=A}else{this.a.set(a,{value:s[a],source:i});const p=this.d[a];p&&(this.w(a,p),this.r(a,p))}this.m(n)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:n,source:s}of t)for(const i in n){const a=this.a.get(i),p=r.$Jf(s)?s:s?.id,L=r.$Jf(a?.source)?a?.source:a?.source?.id;if(p===L)if(o.add(i),this.a.delete(i),e.$Xn.test(i))delete this.d[i],delete this.b.properties[i];else{const P=this.d[i];P&&(this.w(i,P),this.r(i,P))}}this.u()}deltaConfiguration(t){let o=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,n){t.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(t,o){const n=s=>{if(s.properties)for(const i in s.properties){o.add(i);const a=this.d[i];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[i],this.s(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.c.indexOf(s);i!==-1&&this.c.splice(i,1)}}p(t,o=!0,n,s,i=3,a){i=r.$Sf(t.scope)?i:t.scope;const p=t.properties;if(p)for(const P in p){const y=p[P];if(o&&f(P,y)){delete p[P];continue}if(y.source=n,y.defaultDefaultValue=p[P].default,this.w(P,y),e.$Xn.test(P)?y.scope=void 0:(y.scope=r.$Sf(y.scope)?i:y.scope,y.restricted=r.$Sf(y.restricted)?!!s?.includes(P):y.restricted),p[P].hasOwnProperty("included")&&!p[P].included){this.f[P]=p[P],delete p[P];continue}else this.d[P]=p[P],p[P].policy?.name&&this.e.set(p[P].policy.name,P);!p[P].deprecationMessage&&p[P].markdownDeprecationMessage&&(p[P].deprecationMessage=p[P].markdownDeprecationMessage),a.add(P)}const L=t.allOf;if(L)for(const P of L)this.p(P,o,n,s,i,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=n=>{const s=n.properties;if(s)for(const a in s)this.r(a,s[a]);n.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$On.properties[t]=o,o.scope){case 1:e.$Pn.properties[t]=o;break;case 2:e.$Qn.properties[t]=o;break;case 6:e.$Rn.properties[t]=o;break;case 3:e.$Sn.properties[t]=o;break;case 4:e.$Tn.properties[t]=o;break;case 5:e.$Tn.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$On.properties[t],o.scope){case 1:delete e.$Pn.properties[t];break;case 2:delete e.$Qn.properties[t];break;case 6:delete e.$Rn.properties[t];break;case 3:delete e.$Sn.properties[t];break;case 4:case 5:delete e.$Tn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,n={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$Un};this.w(o,n),e.$On.properties[o]=n,e.$Pn.properties[o]=n,e.$Qn.properties[o]=n,e.$Rn.properties[o]=n,e.$Sn.properties[o]=n,e.$Tn.properties[o]=n}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$Un};e.$On.patternProperties[e.$Wn]=t,e.$Pn.patternProperties[e.$Wn]=t,e.$Qn.patternProperties[e.$Wn]=t,e.$Rn.patternProperties[e.$Wn]=t,e.$Sn.patternProperties[e.$Wn]=t,e.$Tn.patternProperties[e.$Wn]=t,this.i.fire()}w(t,o){const n=this.a.get(t);let s=n?.value,i=n?.source;r.$Qf(s)&&(s=o.defaultDefaultValue,i=void 0),r.$Qf(s)&&(s=d(o.type)),o.default=s,o.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",$=new RegExp(h,"g");e.$Wn=`^(${h})+$`,e.$Xn=new RegExp(e.$Wn);function c(l){const t=[];if(e.$Xn.test(l)){let o=$.exec(l);for(;o?.length;){const n=o[1].trim();n&&t.push(n),o=$.exec(l)}}return(0,k.$Mb)(t)}e.$Yn=c;function g(l){return l.reduce((t,o)=>`${t}[${o}]`,"")}e.$Zn=g;function d(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$1n=d;const m=new b;v.$In.add(e.$Nn.Configuration,m);function f(l,t){return l.trim()?e.$Xn.test(l)?I.localize(7,null,l):m.getConfigurationProperties()[l]!==void 0?I.localize(8,null,l):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,l,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$2n=f;function u(){const l=[],t=m.getConfigurationProperties();for(const o of Object.keys(t))l.push([o,t[o].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$3n=u}),define(be[116],ve([1,0,18,6,41,2,24,21,11,4,25,45,37]),function(he,e,k,O,r,I,D,S,v,w,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0;function h(o){return Object.isFrozen(o)?o:S.$xn(o)}class ${constructor(n={},s=[],i=[],a){this.b=n,this.c=s,this.d=i,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof $)return s;const i=new c("");return i.parseRaw(s),i.configurationModel});this.f=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Ii)(this.contents,n):this.contents}inspect(n,s){const i=this.rawConfiguration.getValue(n),a=s?this.rawConfiguration.getOverrideValue(n,s):void 0,p=s?this.rawConfiguration.override(s).getValue(n):i;return{value:i,override:a,merged:p}}getOverrideValue(n,s){const i=this.i(s);return i?n?(0,C.$Ii)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return k.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return k.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=S.$wn(this.contents),i=S.$wn(this.overrides),a=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const L of n)if(p.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(s,L.contents);for(const P of L.overrides){const[y]=i.filter(A=>k.$ub(A.identifiers,P.identifiers));y?(this.h(y.contents,P.contents),y.keys.push(...P.keys),y.keys=k.$Mb(y.keys)):i.push(S.$wn(P))}for(const P of L.keys)a.indexOf(P)===-1&&a.push(P)}return new $(s,a,i,p.every(L=>L instanceof $)?void 0:p)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const a of k.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let p=this.contents[a];const L=s[a];L&&(typeof p=="object"&&typeof L=="object"?(p=S.$wn(p),this.h(p,L)):p=L),i[a]=p}return new $(i,this.keys,this.overrides)}h(n,s){for(const i of Object.keys(s)){if(i in n&&v.$Lf(n[i])&&v.$Lf(s[i])){this.h(n[i],s[i]);continue}n[i]=S.$wn(s[i])}}i(n){let s=null,i=null;const a=p=>{p&&(i?this.h(i,p):i=S.$wn(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===n?s=p.contents:p.identifiers.includes(n)&&a(p.contents);return a(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$Hi)(this.contents,n),E.$Xn.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>k.$ub(i.identifiers,(0,E.$Yn)(n))),1))}j(n,s,i){(0,C.$Gi)(this.contents,n,s,a=>console.error(a)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),E.$Xn.test(n)&&this.overrides.push({identifiers:(0,E.$Yn)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Fi)(this.contents[n],a=>console.error(a))})}}e.$4n=$;class c{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!v.$Sf(n)){const i=this.g(n);this.parseRaw(i,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:i,keys:a,overrides:p,restricted:L,hasExcludedProperties:P}=this.h(n,s);this.b=new $(i,a,p,P?[n]:void 0),this.c=L||[]}g(n){let s={},i=null,a=[];const p=[],L=[];function P(A){Array.isArray(a)?a.push(A):i!==null&&(a[i]=A)}const y={onObjectBegin:()=>{const A={};P(A),p.push(a),a=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{a=p.pop()},onArrayBegin:()=>{const A=[];P(A),p.push(a),a=A,i=null},onArrayEnd:()=>{a=p.pop()},onLiteralValue:P,onError:(A,M,_)=>{L.push({error:A,offset:M,length:_})}};if(n)try{r.$kn(n,y),s=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return s}h(n,s){const i=b.$In.as(E.$Nn.Configuration).getConfigurationProperties(),a=this.i(n,i,!0,s);n=a.raw;const p=(0,C.$Fi)(n,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),L=Object.keys(n),P=this.j(n,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:p,keys:L,overrides:P,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(n,s,i,a){let p=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:p};const L={},P=[];for(const y in n)if(E.$Xn.test(y)&&i){const A=this.i(n[y],s,!1,a);L[y]=A.raw,p=p||A.hasExcludedProperties,P.push(...A.restricted)}else{const A=s[y],M=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&P.push(y),!a.exclude?.includes(y)&&(a.include?.includes(y)||(M===void 0||a.scopes===void 0||a.scopes.includes(M))&&!(a.skipRestricted&&A?.restricted))?L[y]=n[y]:p=!0}return{raw:L,restricted:P,hasExcludedProperties:p}}j(n,s){const i=[];for(const a of Object.keys(n))if(E.$Xn.test(a)){const p={};for(const L in n[a])p[L]=n[a][L];i.push({identifiers:(0,E.$Yn)(a),keys:Object.keys(p),contents:(0,C.$Fi)(p,s)})}return i}}e.$5n=c;class g extends I.$Tc{constructor(n,s,i,a){super(),this.c=n,this.f=s,this.g=a,this.b=this.B(new O.$Wd),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&i.isEqual(p.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$6n=g;class d{constructor(n,s,i,a,p,L,P,y,A,M,_,se,G){this.a=n,this.b=s,this.c=i,this.overrideIdentifiers=a,this.d=p,this.f=L,this.g=P,this.h=y,this.i=A,this.j=M,this.k=_,this.l=se,this.m=G}get value(){return h(this.c)}n(n,s,i){const a=n.inspect(s,i);return{get value(){return h(a.value)},get override(){return h(a.override)},get merged(){return h(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(n,s,i,a,p=new $,L=new $,P=new D.$Ac,y=new $,A=new D.$Ac){this.c=n,this.d=s,this.f=i,this.g=a,this.h=p,this.i=L,this.j=P,this.l=y,this.m=A,this.a=null,this.b=new D.$Ac,this.n=null}getValue(n,s,i){return this.p(n,s,i).getValue(n)}updateValue(n,s,i={}){let a;i.resource?(a=this.m.get(i.resource),a||(a=new $,this.m.set(i.resource,a))):a=this.l,s===void 0?a.removeValue(n):a.setValue(n,s),i.resource||(this.a=null)}inspect(n,s,i){const a=this.p(n,s,i),p=this.t(s.resource,i),L=s.resource?this.m.get(s.resource)||this.l:this.l,P=new Set;for(const y of a.overrides)for(const A of y.identifiers)a.getOverrideValue(n,A)!==void 0&&P.add(A);return new d(n,s,a.getValue(n),P.size?[...P]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,p||void 0,L)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:a,updated:p,removed:L}=l(this.c,n);s=[...a,...p,...L]}for(const a of s)for(const p of(0,E.$Yn)(a)){const L=this.c.getKeysForOverrideIdentifier(p),P=n.getKeysForOverrideIdentifier(p),y=[...P.filter(A=>L.indexOf(A)===-1),...L.filter(A=>P.indexOf(A)===-1),...L.filter(A=>!S.$An(this.c.override(p).getValue(A),n.override(p).getValue(A)))];i.push([p,y])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:a}=l(this.d,n),p=[...s,...i,...a];return p.length&&this.updatePolicyConfiguration(n),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:a,overrides:p}=l(this.applicationConfiguration,n),L=[...s,...i,...a];return L.length&&this.updateApplicationConfiguration(n),{keys:L,overrides:p}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:a,overrides:p}=l(this.localUserConfiguration,n),L=[...s,...i,...a];return L.length&&this.updateLocalUserConfiguration(n),{keys:L,overrides:p}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:a,overrides:p}=l(this.remoteUserConfiguration,n),L=[...s,...i,...a];return L.length&&this.updateRemoteUserConfiguration(n),{keys:L,overrides:p}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:a,overrides:p}=l(this.workspaceConfiguration,n),L=[...s,...i,...a];return L.length&&this.updateWorkspaceConfiguration(n),{keys:L,overrides:p}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:a,updated:p,removed:L,overrides:P}=l(i,s),y=[...a,...p,...L];return(y.length||!i)&&this.updateFolderConfiguration(n,s),{keys:y,overrides:P}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:a,removed:p,overrides:L}=l(s,void 0);return{keys:[...i,...a,...p],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,i){let a=this.q(s,i);return s.overrideIdentifier&&(a=a.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(a=a.merge(this.d)),a}q({resource:n},s){let i=this.r();if(s&&n){const a=s.getFolder(n);a&&(i=this.s(a.uri)||i);const p=this.m.get(n);p&&(i=i.merge(p))}return i}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const i=this.r(),a=this.j.get(n);a?(s=i.merge(a),this.b.set(n,s)):s=i}return s}t(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:i,overrides:a,keys:p}=this.j.get(s);return n.push([s,{contents:i,overrides:a,keys:p}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.i.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(a=>s.add(a))),[...s.values()]}static parse(n){const s=this.w(n.defaults),i=this.w(n.policy),a=this.w(n.application),p=this.w(n.user),L=this.w(n.workspace),P=n.folders.reduce((y,A)=>(y.set(w.URI.revive(A[0]),this.w(A[1])),y),new D.$Ac);return new m(s,i,a,p,new $,L,P,new $,new D.$Ac)}static w(n){return new $(n.contents,n.keys,n.overrides)}}e.$7n=m;function f(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const a of o)a.keys.forEach(p=>n.add(p)),a.overrides.forEach(([p,L])=>{const P=(0,D.$xc)(s,p,new Set);L.forEach(y=>P.add(y))});const i=[];return s.forEach((a,p)=>i.push([p,[...a.values()]])),{keys:[...n.values()],overrides:i}}e.$8n=f;class u{constructor(n,s,i,a){this.change=n,this.f=s,this.g=i,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of n.keys)this.affectedKeys.add(p);for(const[,p]of n.overrides)for(const L of p)this.affectedKeys.add(L);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(n,s){const i=this.a+n,a=this.d.indexOf(i);if(a<0)return!1;const p=a+i.length;if(p>=this.d.length)return!1;const L=this.d.charCodeAt(p);if(L!==this.b&&L!==this.c)return!1;if(s){const P=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,y=this.g.getValue(n,s,this.h);return!S.$An(P,y)}return!0}}e.$9n=u;function l(o,n){const{added:s,removed:i,updated:a}=t(n?.rawConfiguration,o?.rawConfiguration),p=[],L=o?.getAllOverrideIdentifiers()||[],P=n?.getAllOverrideIdentifiers()||[];if(n){const y=P.filter(A=>!L.includes(A));for(const A of y)p.push([A,n.getKeysForOverrideIdentifier(A)])}if(o){const y=L.filter(A=>!P.includes(A));for(const A of y)p.push([A,o.getKeysForOverrideIdentifier(A)])}if(n&&o){for(const y of L)if(P.includes(y)){const A=t({contents:o.getOverrideValue(void 0,y)||{},keys:o.getKeysForOverrideIdentifier(y)},{contents:n.getOverrideValue(void 0,y)||{},keys:n.getKeysForOverrideIdentifier(y)});p.push([y,[...A.added,...A.removed,...A.updated]])}}return{added:s,removed:i,updated:a,overrides:p}}function t(o,n){const s=o?n?o.keys.filter(p=>n.keys.indexOf(p)===-1):[...o.keys]:[],i=n?o?n.keys.filter(p=>o.keys.indexOf(p)===-1):[...n.keys]:[],a=[];if(o&&n){for(const p of n.keys)if(o.keys.indexOf(p)!==-1){const L=(0,C.$Ii)(n.contents,p),P=(0,C.$Ii)(o.contents,p);S.$An(L,P)||a.push(p)}}return{added:s,removed:i,updated:a}}}),define(be[233],ve([1,0,18,6,2,21,11,116,45,13,71,37]),function(he,e,k,O,r,I,D,S,v,w,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=e.$0n=void 0;class b extends r.$Tc{constructor(){super(...arguments),this.a=this.B(new O.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$4n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$In.as(v.$Nn.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:d})=>this.c(Array.from(g),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,d){this.h(g,E.$In.as(v.$Nn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new S.$4n;const g=E.$In.as(v.$Nn.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,d){const m=this.f();for(const f of g){const u=m[f],l=d[f];u!==void 0?this.b.addValue(f,u):l?this.b.addValue(f,l.default):this.b.removeValue(f)}}}e.$0n=b;class h{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new S.$4n}async initialize(){return this.configurationModel}}e.$$n=h;let $=class extends r.$Tc{get configurationModel(){return this.b}constructor(g,d,m){super(),this.c=g,this.f=d,this.g=m,this.a=this.B(new O.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$4n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const d={},m=[],f=E.$In.as(v.$Nn.Configuration).getConfigurationProperties();for(const u of g){const l=f[u];if(!l){m.push(u);continue}if(l.policy){if(l.type!=="string"&&l.type!=="number"){this.g.warn(`Policy ${l.policy.name} has unsupported type ${l.type}`);continue}m.push(u),d[l.policy.name]={type:l.type}}}return(0,D.$Wf)(d)||await this.f.updatePolicyDefinitions(d),m}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const d=E.$In.as(v.$Nn.Configuration).getPolicyConfigurations(),m=(0,k.$Hb)(g.map(f=>d.get(f)));this.m(m,!0)}m(g,d){this.g.trace("PolicyConfiguration#update",g);const m=E.$In.as(v.$Nn.Configuration).getConfigurationProperties(),f=[],u=this.b.isEmpty();for(const l of g){const t=m[l]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(u?o!==void 0:!(0,I.$An)(this.b.getValue(l),o))&&f.push([l,o])}else this.b.getValue(l)!==void 0&&f.push([l,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const l=this.b;this.b=new S.$4n;for(const t of l.keys)this.b.setValue(t,l.getValue(t));for(const[t,o]of f)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);d&&this.a.fire(this.b)}}};e.$_n=$,e.$_n=$=Ne([Oe(1,C.$Kn),Oe(2,w.$oj)],$)}),define(be[117],ve([1,0,18,15,14,6,41,145,2,21,3,19,25,116,45,233,71]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=void 0;class d extends v.$Tc{constructor(u,l,t,o){super(),this.m=u,this.h=this.B(new I.$Wd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new c.$0n),this.c=t instanceof g.$Mn?new c.$$n:this.B(new c.$_n(this.b,t,o)),this.f=this.B(new h.$6n(this.m,{},E.$zg,l)),this.a=new h.$7n(this.b.configurationModel,this.c.configurationModel,new h.$4n,new h.$4n),this.j=new m(u,l,this),this.g=this.B(new O.$gh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,l,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$7n(u,l,new h.$4n,t)}getConfigurationData(){return this.a.toData()}getValue(u,l){const t=typeof u=="string"?u:void 0,o=(0,b.$Bi)(u)?u:(0,b.$Bi)(l)?l:{};return this.a.getValue(t,o,void 0)}async updateValue(u,l,t,o,n){const s=(0,b.$Ci)(t)?t:(0,b.$Bi)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,i=s?o:t;if(i!==void 0&&i!==3&&i!==2)throw new Error(`Unable to write ${u} to target ${i}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,k.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const a=this.inspect(u,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,w.$An)(l,a.defaultValue)&&(l=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const L=s.overrideIdentifiers.sort(),P=this.a.localUserConfiguration.overrides.find(y=>(0,k.$ub)([...y.identifiers].sort(),L));P&&(s.overrideIdentifiers=P.identifiers)}const p=s?.overrideIdentifiers?.length?[(0,$.$Zn)(s.overrideIdentifiers),u]:[u];await this.j.write(p,l),await this.reloadConfiguration()}inspect(u,l={}){return this.a.inspect(u,l,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.n(u)}n(u){const l=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(u);this.t(t,l,2)}r(u,l){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(u,l);this.t(o,t,7)}s(u){const l=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(u);this.t(t,l,7)}t(u,l,t){const o=new h.$9n(u,{data:l},this.a);o.source=t,this.h.fire(o)}}e.$ao=d;class m{constructor(u,l,t){this.b=u,this.c=l,this.d=t,this.a=new O.$bh}write(u,l){return this.a.queue(()=>this.e(u,l))}async e(u,l){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)t="{}";else throw s}const o=[];if((0,D.$dn)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(t,u,l);t=(0,S.$vn)(t,n),await this.c.writeFile(this.b,r.$ke.fromString(t))}f(u,l,t){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!l.length){const i=JSON.stringify(t,null,n?" ".repeat(o):"	");return[{content:i,length:i.length,offset:0}]}return(0,S.$sn)(u,l,t,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let u=C.OS===3||C.OS===2?`
`:`\r
`;const l=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});l&&typeof l=="string"&&l!=="auto"&&(u=l),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(be[118],ve([1,0,10,5]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.RemoteAuthorityResolverErrorCode=e.$$k=e.$0k=e.RemoteConnectionType=e.$9k=void 0,e.$9k=(0,O.$7h)("remoteAuthorityResolverService");var r;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class I{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$0k=I;class D{constructor(E,b){this.host=E,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$$k=D;var S;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class v extends k.$bb{static isNotAvailable(E){return E instanceof v&&E._code===S.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof v&&E._code===S.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof v&&E._code===S.NoResolverFound}static isInvalidAuthority(E){return E instanceof v&&E._code===S.InvalidAuthority}static isHandled(E){return E instanceof v&&E.isHandled}constructor(E,b=S.Unknown,h){super(E),this._message=E,this._code=b,this._detail=h,this.isHandled=b===S.NotAvailable&&h===!0,Object.setPrototypeOf(this,v.prototype)}}e.$_k=v;function w(C){const E=C.indexOf("+");return E===-1?C:C.substring(0,E)}e.$al=w}),define(be[234],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0,e.$JO=(0,k.$7h)("IRemoteExtensionsScannerService"),e.$KO="remoteExtensionsScanner"}),define(be[58],ve([1,0,12]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=void 0;function O(w){return w.scheme===k.Schemas.vscodeRemote?w.authority:void 0}e.$bl=O;function r(w){if(!w)return;const C=w.indexOf("+");return C<0?w:w.substr(0,C)}e.$cl=r;function I(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$dl=I;function D(w){const{host:C,port:E}=v(w);if(typeof E>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:C,port:E}}e.$el=D;function S(w,C){let{host:E,port:b}=v(w);return typeof b>"u"&&(b=C),{host:E,port:b}}e.$fl=S;function v(w){const C=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=w.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=w.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:w,port:void 0}}}),define(be[35],ve([1,0,17,5,58]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.TargetPlatform=e.ExtensionType=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=void 0,e.$gm="extensions.user.cache",e.$hm="extensions.builtin.cache",e.$im="undefined_publisher",e.$jm=["ui","workspace","web"];function I(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$km=I,e.$lm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(D||(e.ExtensionType=D={}));var S;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class v{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g>"u"||g===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){const m=typeof g=="string"?g:g.value,f=typeof d=="string"?d:d.value;return k.$af(m,f)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$mm=v;class w{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const d of g)this.add(d)}add(g){this.c.add(v.toKey(g))}delete(g){return this.c.delete(v.toKey(g))}has(g){return this.c.has(v.toKey(g))}}e.$nm=w;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(v.toKey(g))}get(g){return this.c.get(v.toKey(g))}has(g){return this.c.has(v.toKey(g))}set(g,d){this.c.set(v.toKey(g),d)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$om=C;function E(c){return b(c)}e.$pm=E;function b(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$qm=b;function h(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$rm=h;function $(c,g){if(g){const d=`onResolveRemoteAuthority:${(0,r.$cl)(g)}`;return!!c.activationEvents?.includes(d)}return!1}e.$sm=$,e.$tm=(0,O.$7h)("IBuiltinExtensionsScannerService")}),define(be[235],ve([1,0,10,35]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=void 0;class r{constructor(){this.a=new Map,this.b=new WeakMap}register(D,S){this.a.set(D,S)}readActivationEvents(D){return this.b.has(D)||this.b.set(D,this.c(D)),this.b.get(D)}createActivationEventsMap(D){const S=Object.create(null);for(const v of D){const w=this.readActivationEvents(v);w.length>0&&(S[O.$mm.toKey(v.identifier)]=w)}return S}c(D){if(typeof D.main>"u"&&typeof D.browser>"u")return[];const S=Array.isArray(D.activationEvents)?D.activationEvents.slice(0):[];for(let v=0;v<S.length;v++)S[v]==="onUri"&&(S[v]=`onUri:${O.$mm.toKey(D.identifier)}`);if(!D.contributes)return S;for(const v in D.contributes){const w=this.a.get(v);if(!w)continue;const C=D.contributes[v],E=Array.isArray(C)?C:[C];try{w(E,S)}catch(b){(0,k.$1)(b)}}return S}}e.$oF=r,e.$pF=new r}),define(be[236],ve([1,0,2,35,16]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class I extends k.$Tc{constructor(S,v,w,C,E){super(),this.a=S,this.b=v,this.c=w,this.f=E,this.B(C.onDidInstallExtensions(b=>this.g(b))),this.B(C.onDidUninstallExtension(b=>this.h(b)))}g(S){for(const v of S)v.local&&this.invalidate(v.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,S)&&await this.j(v);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,O.$gm))}catch(v){(0,r.$Ik)(v)!==1&&this.f.error(v)}}}e.$9p=I}),define(be[46],ve([1,0,14,10,2,196,45,5,13,37]),function(he,e,k,O,r,I,D,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=void 0,e.$ip=(0,S.$7h)("requestService");class C{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?l[t]="*****":l[t]=this.b[t];this.a=l}return this.a}}class E extends r.$Tc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,I.localize)(0,null),when:v.$Fj.isEqualTo((0,v.$Dj)(v.LogLevel.Trace)).serialize()})}async c(l,t,o){const n=`${l} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new C(t.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,t.type,(0,O.$0)(s)),s}}}e.$jp=E;function b(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.$kp=b;function h(u){return u.res.statusCode===204}e.$lp=h;async function $(u){return h(u)?null:(await(0,k.$we)(u.stream)).toString()}e.$mp=$;async function c(u){if(!b(u))throw new Error("Server returned "+u.res.statusCode);return $(u)}e.$np=c;async function g(u){if(!b(u))throw new Error("Server returned "+u.res.statusCode);if(h(u))return null;const t=(await(0,k.$we)(u.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$op=g;function d(u){f(u)}e.$pp=d;let m;function f(u){const l=w.$In.as(D.$Nn.Configuration),t=m;m={id:"http",order:15,title:(0,I.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,I.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(6,null),(0,I.localize)(7,null),(0,I.localize)(8,null),(0,I.localize)(9,null)],default:"override",description:(0,I.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,I.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[m],remove:t?[t]:[]})}f(1)}),define(be[237],ve([1,0,20,12,16,46]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=void 0;let D=class{constructor(v,w){this.a=v,this.b=w}async download(v,w,C=k.CancellationToken.None){if(v.scheme===O.Schemas.file||v.scheme===O.Schemas.vscodeRemote){await this.b.copy(v,w);return}const E={type:"GET",url:v.toString(!0)},b=await this.a.request(E,C);if(b.res.statusCode===200)await this.b.writeFile(w,b.stream);else{const h=await(0,I.$np)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${h}`)}}};e.$WO=D,e.$WO=D=Ne([Oe(0,I.$ip),Oe(1,r.$rk)],D)}),define(be[238],ve([1,0,14,20]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;class r{constructor(S){this.a=S}listen(S,v){throw new Error("Invalid listen")}call(S,v,w,C=O.CancellationToken.None){switch(v){case"request":return this.a.request(w[0],C).then(async({res:E,stream:b})=>{const h=await(0,k.$we)(b);return[{statusCode:E.statusCode,headers:E.headers},h]});case"resolveProxy":return this.a.resolveProxy(w[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$lr=r;class I{constructor(S){this.a=S}async request(S,v){const[w,C]=await this.a.call("request",[S],v);return{res:w,stream:(0,k.$ye)(C)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$mr=I}),define(be[239],ve([1,0,87,11]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;function r(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function I(D,S,v={}){const w=(0,k.parse)(D),C=v.proxyUrl||r(w,S);if(!C)return null;const E=(0,k.parse)(C);if(!/^https?:$/.test(E.protocol||""))return null;const b={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,O.$Pf)(v.strictSSL)?v.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((h,$)=>{he(["http-proxy-agent"],h,$)})).HttpProxyAgent(C,b):new(await new Promise((h,$)=>{he(["https-proxy-agent"],h,$)})).HttpsProxyAgent(C,b)}e.$nr=I}),define(be[88],ve([1,0,54,7,197,20,39,10,3,22,105,214,15,148]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=void 0;let $;async function c(d,m,f,u){return f["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$i?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$7l)(u)&&!f["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$7l)(u)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),$||($=b.Promises.withAsyncBody(async(l,t)=>{const o=new I.$7d;let n=1e4;const s=d.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(n=(0,h.$8l)(s,1,120)*1e3);const i=setTimeout(()=>{o.dispose(!0),t(new Error((0,r.localize)(0,null)))},n);try{l(await g(m,o.token))}catch(a){!(0,S.$4)(a)&&!o.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,D.$Ri)(a)))):l({})}finally{clearTimeout(i),o.dispose()}})),$)}e.$am=c;async function g(d,m){const f=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",f);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",u);const l=(0,w.$rg)().replace(/-/g,"").substr(0,12),t=new RegExp(l+"({.*})"+l),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",o);const n=await(0,C.$Wl)(v.OS,o);return d.trace("getUnixShellEnvironment#shell",n),new Promise((s,i)=>{if(m.isCancellationRequested)return i(new S.$5);const a=(0,O.$nc)(n);let p,L;const P="";/^pwsh(-preview)?$/.test(a)?(p=`& '${process.execPath}' ${P} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,L=["-Login","-Command"]):a==="nu"?(p=`^'${process.execPath}' ${P} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,L=["-i","-l","-c"]):a==="xonsh"?(p=`import os, json; print("${l}", json.dumps(dict(os.environ)), "${l}")`,L=["-i","-l","-c"]):(p=`'${process.execPath}' ${P} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"||a==="csh"?L=["-ic"]:L=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),p);const y=(0,k.spawn)(n,[...L,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});m.onCancellationRequested(()=>(y.kill(),i(new S.$5))),y.on("error",_=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Ri)(_)),i(_)});const A=[];y.stdout.on("data",_=>A.push(_));const M=[];y.stderr.on("data",_=>M.push(_)),y.on("close",(_,se)=>{const G=Buffer.concat(A).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const oe=Buffer.concat(M).toString("utf8");if(oe.trim()&&d.trace("getUnixShellEnvironment#stderr",oe),_||se)return i(new Error((0,r.localize)(2,null,_,se)));const ee=t.exec(G),K=ee?ee[1]:"{}";try{const Z=JSON.parse(K);f?Z.ELECTRON_RUN_AS_NODE=f:delete Z.ELECTRON_RUN_AS_NODE,u?Z.ELECTRON_NO_ATTACH_CONSOLE=u:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.VSCODE_RESOLVING_ENVIRONMENT,delete Z.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",Z),s(Z)}catch(Z){d.error("getUnixShellEnvironment#errorCaught",(0,D.$Ri)(Z)),i(Z)}})})}}),define(be[240],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=e.$yO=void 0,e.$yO=(0,k.$7h)("stateReadService"),e.$zO=(0,k.$7h)("stateService")}),define(be[241],ve([1,0,15,14,2,11,26,16,13]),function(he,e,k,O,r,I,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=e.$BO=e.$AO=e.SaveStrategy=void 0;var w;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(w||(e.SaveStrategy=w={}));class C extends r.$Tc{constructor($,c,g,d){super(),this.h=$,this.j=c,this.m=g,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new k.$5g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch($){$.fileOperationResult!==1&&this.m.error($)}}getItem($,c){const g=this.a[$];return(0,I.$Sf)(g)?c:g}setItem($,c){this.setItems([{key:$,data:c}])}setItems($){let c=!1;for(const{key:g,data:d}of $)this.a[g]!==d&&((0,I.$Sf)(d)?(0,I.$Qf)(this.a[g])||(this.a[g]=void 0,c=!0):(this.a[g]=d,c=!0));c&&this.s()}removeItem($){(0,I.$Qf)(this.a[$])||(this.a[$]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const $=JSON.stringify(this.a,null,4);if($!==this.b)try{await this.n.writeFile(this.h,O.$ke.fromString($),{atomic:{postfix:".vsctmp"}}),this.b=$}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$AO=C;let E=class extends r.$Tc{constructor($,c,g,d){super(),this.a=this.B(new C(c.stateResource,$,g,d))}async init(){await this.a.init()}getItem($,c){return this.a.getItem($,c)}};e.$BO=E,e.$BO=E=Ne([Oe(1,D.$bi),Oe(2,v.$oj),Oe(3,S.$rk)],E);class b extends E{setItem($,c){this.a.setItem($,c)}setItems($){this.a.setItems($)}removeItem($){this.a.removeItem($)}close(){return this.a.close()}}e.$CO=b}),define(be[119],ve([1,0,3,29,22]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=void 0;function I(v){if(k.$u===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function D(v,w,C,E,b,h,$,c,g){const d=Object.create(null);d["common.machineId"]=h,d["common.sqmId"]=$,d.sessionID=(0,r.$rg)()+Date.now(),d.commitHash=E,d.version=b,d["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,k.$h)(k.$u),d["common.nodePlatform"]=O.$dc,d["common.nodeArch"]=C,d["common.product"]=g||"desktop",c&&(d["common.msftInternal"]=c);let m=0;const f=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),k.$l&&(d["common.snap"]="true");const u=I(w);return u&&(d["common.platformDetail"]=u),d}e.$Ko=D;function S(v){const w=O.env.USERDNSDOMAIN;if(!w)return!1;const C=w.toLowerCase();return v.some(E=>C===E)}e.$Lo=S}),define(be[242],ve([1,0,18,10,2,21,16]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var S;(function(w){function C(E,b){return E.callstack<b.callstack?-1:E.callstack>b.callstack?1:0}w.compare=C})(S||(e.ErrorEvent=S={}));class v{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(C,E=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new r.$Sc,this.c=C,this.d=E;const b=O.$X.addListener(h=>this.j(h));this.h.add((0,r.$Rc)(b)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(C){if(!C||C.code||(C.detail&&C.detail.stack&&(C=C.detail),O.$bb.isErrorNoTelemetry(C)||C instanceof D.$Mk||typeof C?.message=="string"&&C.message.includes("Unable to read file")))return;const E=Array.isArray(C.stack)?C.stack.join(`
`):C.stack,b=C.message?C.message:(0,I.$Bn)(C);E&&this.k({msg:b,callstack:E})}k(C){const E=(0,k.$wb)(this.g,C,S.compare);E<0?(C.count=1,this.g.splice(~E,0,C)):(this.g[E].count||(this.g[E].count=0),this.g[E].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const C of this.g)this.c.publicLogError2("UnhandledError",C);this.g.length=0}}e.default=v}),define(be[243],ve([1,0,2]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;class O extends k.$Tc{constructor(I,D){super(),this.a=I,this.b=D}async call(I,D,S){switch(D){case"updateTelemetryLevel":{const{telemetryLevel:v}=S;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:w}=S;return this.b?this.b.log(v,w):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${D} not found`)}listen(I,D,S){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$fs=O}),define(be[32],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=void 0,e.$vl=(0,k.$7h)("telemetryService"),e.$wl=(0,k.$7h)("customEndpointTelemetryService"),e.$xl="telemetry.currentSessionDate",e.$yl="telemetry.firstSessionDate",e.$zl="telemetry.lastSessionDate",e.$Al="telemetry.machineId",e.$Bl="telemetry.sqmId",e.$Cl="telemetry",e.$Dl="telemetry.telemetryLevel",e.$El="telemetry.enableCrashReporter",e.$Fl="telemetry.enableTelemetry";var O;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var r;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(be[244],ve([1,0,28,15,41,12,7,3,4,101,23,104,220,16,31,32]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=e.$8r=e.$7r=void 0;const g=new Map;async function d(t,o){const n=`${t}::${o.join(":")}`,s=g.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,p=new Map,L=2e4;function P(A,M,_,se){const G=M.substring(A.length+1);return O.Promises.withAsyncBody(async oe=>{let ee;try{ee=await C.Promises.readdir(M,{withFileTypes:!0})}catch{oe();return}if(se.count>=L){se.count+=ee.length,se.maxReached=!0,oe();return}let K=ee.length;if(K===0){oe();return}let Z=ee;se.count+ee.length>L&&(se.maxReached=!0,K=L-se.count,Z=ee.slice(0,K)),se.count+=ee.length;for(const X of Z)if(X.isDirectory()){if(_.includes(X.name)||await P(A,(0,D.$jc)(M,X.name),_,se),--K===0){oe();return}}else{const te=X.name.lastIndexOf(".");if(te>=0){const V=X.name.substring(te+1);V&&a.set(V,(a.get(V)??0)+1)}for(const V of i)V.relativePathPattern?.test(G)!==!1&&V.filePattern.test(X.name)&&p.set(V.tag,(p.get(V.tag)??0)+1);if(--K===0){oe();return}}})}const y=O.Promises.withAsyncBody(async A=>{const M={count:0,maxReached:!1};await P(t,t,o,M);const _=await u(t);A({configFiles:m(p),fileTypes:m(a),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:_})});return g.set(n,y),y}e.$7r=d;function m(t){return Array.from(t.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function f(){const t={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/h.$Zk.GB).toFixed(2)}GB (${(k.freemem()/h.$Zk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.$$m.value()*100)}%`},o=k.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$8r=f;async function u(t){try{const o=new Map,n=(0,D.$jc)(t,".vscode","launch.json"),s=await C.Promises.readFile(n),i=[],a=(0,r.$dn)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,r.$mn)(a)==="object"&&a.configurations)for(const p of a.configurations){const L=p.type;L&&(o.has(L)?o.set(L,o.get(L)+1):o.set(L,1))}return m(o)}catch{return[]}}e.$9r=u;let l=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const s=k.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(k.totalmem()/h.$Zk.GB).toFixed(2)}GB (${(k.freemem()/h.$Zk.GB).toFixed(2)}GB free)`),S.$i||n.push(`Load (avg):       ${k.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(w.$$m.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,E.$6r)(o.mainPID),this.k(o)]).then(async s=>{let[i,a]=s,p=this.m(o,i);return n.forEach(L=>{if((0,b.$Km)(L))p+=`
${L.errorMessage}`,a+=`
${L.errorMessage}`;else if(p+=`

Remote: ${L.hostName}`,L.processes&&(p+=`
${this.m(o,L.processes)}`),L.workspaceMetadata){a+=`
|  Remote: ${L.hostName}`;for(const P of Object.keys(L.workspaceMetadata)){const y=L.workspaceMetadata[P];let A=`${y.fileCount} files`;y.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${P}): ${A}`,a+=this.h(y)}}}),{processInfo:p,workspaceInfo:a}})}async getSystemInfo(o,n){const{memory:s,vmHint:i,os:a,cpus:p}=f(),L={os:a,memory:s,cpus:p,vmHint:i,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return S.$i||(L.load=`${k.loadavg().map(P=>Math.round(P)).join(", ")}`),S.$k&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(o,n){const s=[];return(0,E.$6r)(o.mainPID).then(async i=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,i)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(a=>{if((0,b.$Km)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.f(a.machineInfo)),a.processes&&s.push(this.m(o,a.processes)),a.workspaceMetadata)for(const p of Object.keys(a.workspaceMetadata)){const L=a.workspaceMetadata[p];let P=`${L.fileCount} files`;L.maxFilesReached&&(P=`more than ${P}`),s.push(`Folder (${p}): ${P}`),s.push(this.h(L))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let i=0;const a=(y,A)=>{const M=` ${y}(${A})`;i+M.length>60?(n.push(p),p="|                 ",i=p.length):i+=M.length,p+=M};let p="|      File types:";const L=10,P=o.fileTypes.length>L?L:o.fileTypes.length;for(let y=0;y<P;y++){const A=o.fileTypes[y];a(A.name,A.count)}if(n.push(p),o.configFiles.length>=0&&(p="|      Conf files:",i=0,o.configFiles.forEach(y=>{a(y.name,y.count)}),n.push(p)),o.launchConfigFiles.length>0){let y="|      Launch Configs:";o.launchConfigFiles.forEach(A=>{const M=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;y+=M}),n.push(y)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(a=>{const p=v.URI.revive(a);if(p.scheme===I.Schemas.file){const L=p.fsPath;s.push(d(L,["node_modules",".git"]).then(P=>{let y=`${P.fileCount} files`;P.maxFilesReached&&(y=`more than ${y}`),n.push(`|    Folder (${(0,D.$nc)(L)}): ${y}`),n.push(this.h(P))}).catch(P=>{n.push(`|      Error: Unable to collect workspace stats for folder ${L} (${P.toString()})`)}))}else n.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(o,n){const s=new Map;o.windows.forEach(a=>s.set(a.pid,`window [${a.id}] (${a.title})`)),o.pidToNames.forEach(({pid:a,name:p})=>s.set(a,p));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,i,n,0),i.join(`
`)}n(o,n,s,i,a){const p=a===0;let L;p?L=i.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?L=n.get(i.pid):L=`${"  ".repeat(a)} ${i.name}`;const P=process.platform==="win32"?i.mem:k.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(P/h.$Zk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(i.children)&&i.children.forEach(y=>this.n(o,n,s,y,a+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const i=v.URI.revive(s);if(i.scheme!==I.Schemas.file)continue;const a=i.fsPath;try{(await d(a,["node_modules",".git"])).fileTypes.forEach(L=>n.add(L.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=v.URI.revive(n);if(s.scheme!==I.Schemas.file)continue;const i=s.fsPath;try{const a=await d(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),a.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),a.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$0r=l,e.$0r=l=Ne([Oe(0,c.$vl),Oe(1,$.$Gj)],l)}),define(be[38],ve([1,0,21,11,58,119,32]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;class S{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$Mo=S;class v{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$No=v,e.$Oo=new v;class w{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$Po=w,e.$Qo="telemetry",e.$Ro="extensionTelemetryLog",e.$So={log:()=>null,flush:()=>Promise.resolve(null)};function C(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.$To=C;function E(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Uo=E;function b(t){const o=t.getValue(D.$Dl),n=t.getValue(D.$El);if(t.getValue(D.$Fl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Vo=b;function h(t){const o={},n={},s={};g(t,s);for(let i in s){i=i.length>150?i.substr(i.length-149):i;const a=s[i];typeof a=="number"?n[i]=a:typeof a=="boolean"?n[i]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${a.length}`),o[i]=a.substring(0,8191)):typeof a<"u"&&a!==null&&(o[i]=a)}return{properties:o,measurements:n}}e.$Wo=h;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const o=(0,r.$cl)(t);return $.has(o)?o:"other"}e.$Xo=c;function g(t,o,n=0,s){if(t)for(const i of Object.getOwnPropertyNames(t)){const a=t[i],p=s?s+i:i;Array.isArray(a)?o[p]=(0,k.$Bn)(a):a instanceof Date?o[p]=a.toISOString():(0,O.$Lf)(a)?n<2?g(a,o,n+1,p+"."):o[p]=(0,k.$Bn)(a):o[p]=a}}function d(t,o){const n=t.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,I.$Lo)(n)||s}e.$Yo=d;function m(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Zo=m;function f(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const s=[];for(const L of o)for(;;){const P=L.exec(t);if(!P)break;s.push([P.index,L.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(n="";;){const L=a.exec(t);if(!L)break;const P=s.some(([y,A])=>L.index<A&&y<a.lastIndex);!i.test(L[0])&&!P&&(n+=t.substring(p,L.index)+"<REDACTED: user-file-path>",p=a.lastIndex)}return p<t.length&&(n+=t.substr(p)),n}function u(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function l(t,o){return(0,k.$yn)(t,n=>{if(n instanceof S||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=f(s,o);for(const i of o)s=s.replace(i,"");return s=u(s),s}})}e.$1o=l}),define(be[36],ve([1,0,17,30,35,3,4,10,29,38]),function(he,e,k,O,r,I,D,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,k.$8e)(n.id,s.id)===0}e.$2o=C;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(s){const i=s.manifest?s.manifest.version:s.version,a=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new b(s.identifier,i,a)}static parse(s){const i=E.exec(s);return i&&i[1]&&i[2]?new b({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,a="undefined"){this.version=i,this.targetPlatform=a,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof b?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$3o=b;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const s=h.exec(n);return s&&s[1]?[g(s[1]),s[2]]:[g(n),void 0]}e.$4o=$;function c(n,s){return`${n}.${s}`}e.$5o=c;function g(n){return n.toLowerCase()}e.$6o=g;function d(n,s){return g(c(n??r.$im,s))}e.$7o=d;function m(n,s){const i=[],a=p=>{for(const L of i)if(L.some(P=>C(s(P),s(p))))return L;return null};for(const p of n){const L=a(p);L?L.push(p):i.push([p])}return i}e.$8o=m;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$9o=f;function u(n){return{id:new w.$Mo(n.identifier.id),name:new w.$Mo(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$0o=u,e.$$o=new r.$mm("pprice.better-merge");function l(n,s){const i=[],a=s.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const p=a.shift();if(p&&i.every(L=>!C(L.identifier,{id:p}))){const L=n.filter(P=>C(P.identifier,{id:p}));L.length===1&&(i.push(L[0]),a.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$_o=l;async function t(n,s){if(!I.$k)return!1;let i;try{i=(await n.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){s.debug("Error while getting the os-release file.",(0,S.$0)(p))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const i=await t(n,s),a=(0,O.$vo)(i?"alpine":I.$u,v.$ec);return s.debug("ComputeTargetPlatform:",a),a}e.$ap=o}),define(be[120],ve([1,0,20,10,12,19,55,4,184,30,36,35]),function(he,e,k,O,r,I,D,S,v,w,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;const b=c=>(0,v.localize)(0,null,c),h=(0,v.localize)(1,null,"ms-dotnettools.csharp");let $=class{constructor(g,d,m){this.a=g,this.b=d,this.d=m}get f(){}async listExtensions(g,d,m){let f=await this.b.getInstalled(1,m);const u=E.$lm.map(t=>t.toLowerCase());if(d&&d!==""){if(u.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}f=f.filter(t=>t.manifest.categories?t.manifest.categories.map(n=>n.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),u.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),f=f.sort((t,o)=>t.identifier.id.localeCompare(o.identifier.id));let l;for(const t of f)l!==t.identifier.id&&(l=t.identifier.id,this.a.info(g?`${l}@${t.manifest.version}`:l))}async installExtensions(g,d,m,f){const u=[];try{const l=[];g.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const t=[];let o=[];const n=(i,a,p)=>{o.push({id:i,version:a!=="prerelease"?a:void 0,installOptions:{...m,isBuiltin:p,installPreReleaseVersion:a==="prerelease"||m.installPreReleaseVersion}})};for(const i of g)if(i instanceof S.URI)t.push({vsix:i,installOptions:m});else{const[a,p]=(0,C.$4o)(i);n(a,p,!1)}for(const i of d)if(i instanceof S.URI)t.push({vsix:i,installOptions:{...m,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[a,p]=(0,C.$4o)(i);n(a,p,!0)}const s=await this.b.getInstalled(1,m.profileLocation);if(t.length&&await Promise.all(t.map(async({vsix:i,installOptions:a})=>{try{const p=await this.g(i,a,f,s);p&&l.push(p)}catch(p){this.a.error(p),u.push(i.toString())}})),o.length&&(o=o.filter(({id:i,version:a})=>{const p=s.find(L=>(0,C.$2o)(L.identifier,{id:i}));if(p){if(!f&&(!a||a==="prerelease"&&p.preRelease))return this.a.info((0,v.localize)(5,null,i,p.manifest.version,i)),!1;if(a&&p.manifest.version===a)return this.a.info((0,v.localize)(6,null,`${i}@${a}`)),!1}return!0}),o.length)){const i=await this.h(o);await Promise.all(o.map(async a=>{const p=i.get(a.id.toLowerCase());if(p)try{const L=await this.j(a,p,s);L&&l.push(L)}catch(L){this.a.error(L.message||L.stack||L),u.push(a.id)}else this.a.error(`${b(a.version?`${a.id}@${a.version}`:a.id)}
${h}`),u.push(a.id)}))}}catch(l){throw this.a.error((0,v.localize)(7,null,(0,O.$0)(l))),l}if(u.length)throw new Error((0,v.localize)(8,null,u.join(", ")))}async updateExtensions(g){const d=await this.b.getInstalled(1,g),m=[];for(const t of d)t.identifier.uuid&&m.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,v.localize)(9,null,m.length));const f=await this.d.getExtensions(m,{compatible:!0},k.CancellationToken.None),u=[];for(const t of f)for(const o of d)(0,C.$2o)(o.identifier,t.identifier)&&(0,D.gt)(t.version,o.manifest.version)&&u.push({extension:t,options:{operation:3,installPreReleaseVersion:o.isPreReleaseVersion}});if(!u.length){this.a.info((0,v.localize)(10,null));return}this.a.info((0,v.localize)(11,null,u.map(t=>t.extension.identifier.id).join(", ")));const l=await this.b.installGalleryExtensions(u);for(const t of l)t.error?this.a.error((0,v.localize)(12,null,t.identifier.id,(0,O.$0)(t.error))):this.a.info((0,v.localize)(13,null,t.identifier.id,t.local?.manifest.version))}async g(g,d,m,f){const u=await this.b.getManifest(g);if(!u)throw new Error("Invalid vsix");if(await this.l(u,m,d.profileLocation,f))try{return await this.b.install(g,d),this.a.info((0,v.localize)(14,null,(0,I.$Fg)(g))),u}catch(t){if((0,O.$4)(t))return this.a.info((0,v.localize)(15,null,(0,I.$Fg)(g))),null;throw t}return null}async h(g){const d=new Map,m=g.some(l=>l.installOptions.installPreReleaseVersion),f=await this.b.getTargetPlatform(),u=[];for(const l of g)w.$oo.test(l.id)&&u.push({...l,preRelease:m});if(u.length){const l=await this.d.getExtensions(u,{targetPlatform:f},k.CancellationToken.None);for(const t of l)d.set(t.identifier.id.toLowerCase(),t)}return d}async j({id:g,version:d,installOptions:m},f,u){const l=await this.d.getManifest(f,k.CancellationToken.None);if(l&&!this.k(l))return null;const t=u.find(o=>(0,C.$2o)(o.identifier,f.identifier));if(t){if(f.version===t.manifest.version)return this.a.info((0,v.localize)(16,null,d?`${g}@${d}`:g)),null;this.a.info((0,v.localize)(17,null,g,f.version))}try{m.isBuiltin?this.a.info(d?(0,v.localize)(18,null,g,d):(0,v.localize)(19,null,g)):this.a.info(d?(0,v.localize)(20,null,g,d):(0,v.localize)(21,null,g));const o=await this.b.installFromGallery(f,{...m,installGivenVersion:!!d});return this.a.info((0,v.localize)(22,null,g,o.manifest.version)),l}catch(o){if((0,O.$4)(o))return this.a.info((0,v.localize)(23,null,g)),null;throw o}}k(g){return!0}async l(g,d,m,f){if(!d){const u={id:(0,C.$7o)(g.publisher,g.name)},l=f.find(t=>(0,C.$2o)(u,t.identifier)&&(0,D.gt)(t.manifest.version,g.version));if(l)return this.a.info((0,v.localize)(24,null,l.identifier.id,l.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,d,m){const f=async l=>{if(l instanceof S.URI){const t=await this.b.getManifest(l);return(0,C.$5o)(t.publisher,t.name)}return l},u=[];for(const l of g){const t=await f(l),n=(await this.b.getInstalled(void 0,m)).filter(s=>(0,C.$2o)(s.identifier,{id:t}));if(!n.length)throw new Error(`${this.m(t)}
${h}`);if(n.some(s=>s.type===0)){this.a.info((0,v.localize)(25,null,t));return}if(!d&&n.some(s=>s.isBuiltin)){this.a.info((0,v.localize)(26,null,t));return}this.a.info((0,v.localize)(27,null,t));for(const s of n)await this.b.uninstall(s,{profileLocation:m}),u.push(s);this.f?this.a.info((0,v.localize)(28,null,t,this.f)):this.a.info((0,v.localize)(29,null,t))}}async locateExtension(g){const d=await this.b.getInstalled();g.forEach(m=>{d.forEach(f=>{if(f.identifier.id===m&&f.location.scheme===r.Schemas.file){this.a.info(f.location.fsPath);return}})})}m(g){return this.f?(0,v.localize)(30,null,g,this.f):(0,v.localize)(31,null,g)}};e.$Ip=$,e.$Ip=$=Ne([Oe(1,w.$Co),Oe(2,w.$zo)],$)}),define(be[245],ve([1,0,15,10,2,12,19,55,11,22,23,81,25,26,30,36,86,16,13]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=void 0;let u=class extends r.$Tc{static{f=this}static{this.c=".sigzip"}constructor(t,o,n,s,i,a){super(),this.h=o,this.j=n,this.m=s,this.n=i,this.r=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,o,n){await this.g;const s=(0,D.$Ig)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,s,a=>this.j.download(t,a,o))}catch(a){throw new $.$Ao(a.message,$.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.t(t)){const a=await this.u(t);try{i=await this.n.verify(s.fsPath,a.fsPath,this.r.getLevel()===m.LogLevel.Trace)}catch(p){const L=p;if(i=L.code,L.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${L.output}`),i===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(P){this.r.error(P)}throw new $.$Ao(E.$Mp,$.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(a)}catch(p){this.r.error(p)}}}return i===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:s,verificationStatus:i}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,v.$Pf)(o)?o:!0}async u(t){await this.g;const o=(0,D.$Ig)(this.extensionsDownloadDir,`${this.z(t)}${f.c}`);try{await this.w(t,o,n=>this.j.downloadSignatureArchive(t,n))}catch(n){throw new $.$Ao(n.message,$.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(t,o,n){if(await this.h.exists(o))return;if(o.scheme!==I.Schemas.file){await n(o);return}const s=(0,D.$Ig)(this.extensionsDownloadDir,`.${(0,w.$rg)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(i){try{await this.h.del(s)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,O.$0)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],n=[],s=[];for(const p of t.children)if(p.name.endsWith(f.c))s.push(p.resource);else{const L=c.$3o.parse(p.name);L&&n.push([L,p])}const i=(0,c.$8o)(n,([p])=>p),a=[];for(const p of i)p.sort((L,P)=>S.rcompare(L[0].version,P[0].version)),o.push(...p.slice(1).map(L=>L[1].resource)),a.push(p[0][1]);a.sort((p,L)=>p.mtime-L.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.f)).map(p=>p.resource)),o.push(...s),await k.Promises.settled(o.map(p=>(this.r.trace("Deleting from cache",p.path),this.h.del(p))))}}catch(t){this.r.error(t)}}z(t){return this.f?c.$3o.create(t).toString().toLowerCase():(0,w.$rg)()}};e.$6p=u,e.$6p=u=f=Ne([Oe(0,h.$ci),Oe(1,d.$rk),Oe(2,$.$zo),Oe(3,b.$Ai),Oe(4,g.$Gp),Oe(5,m.$oj)],u)}),define(be[246],ve([1,0,6,2,24,36,35]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class S extends O.$Tc{constructor(w,C,E,b,h,$,c){super(),this.f=w,this.g=C,this.h=E,this.j=b,this.m=h,this.n=$,this.r=c,this.a=this.B(new k.$Wd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.$3c),this.s().then(null,g=>c.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(w=>this.u(w.added))),this.B(this.j.onAddExtensions(w=>this.w(w))),this.B(this.j.onDidAddExtensions(w=>this.y(w))),this.B(this.j.onRemoveExtensions(w=>this.z(w))),this.B(this.j.onDidRemoveExtensions(w=>this.C(w))),this.B(this.n.onDidFilesChange(w=>this.D(w)))}async u(w){try{w.length&&await Promise.all(w.map(C=>(this.c.set(C.id,(0,O.$Qc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(w){for(const C of w.extensions)this.I(this.L(C.identifier,C.version),w.profileLocation)}async y(w){for(const C of w.extensions){const E=this.L(C.identifier,C.version);w.error?this.J(E,w.profileLocation):this.I(E,w.profileLocation)}}async z(w){for(const C of w.extensions)this.J(this.L(C.identifier,C.version),w.profileLocation)}async C(w){const C=[],E=[];for(const b of w.extensions){const h=this.L(b.identifier,b.version);w.error?this.I(h,w.profileLocation):(this.J(h,w.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),E.push(this.f.scanInstalledExtensionAtLocation(b.location).then($=>{$?C.push($):this.r.info("Extension not found at the location",b.location.toString())},$=>this.r.error($)))))}try{await Promise.all(E),C.length&&await this.H(C)}catch(b){this.r.error(b)}}D(w){for(const C of this.h.profiles)w.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(w){const C=[],E=[],b=await this.j.scanProfileExtensions(w),h=new Set,$=new Set;for(const[c,g]of this.b)g.has(w)&&$.add(c);for(const c of b){const g=this.L(c.identifier,c.version);h.add(g),$.has(g)||(C.push(c.identifier),this.I(g,w))}for(const c of $)if(!h.has(c)){const g=this.M(c);g&&(E.push(g.identifier),this.J(c,w))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:w}:void 0,removed:E.length?{extensions:E,profileLocation:w}:void 0})}async G(w){const C=await this.j.scanProfileExtensions(w);for(const E of C)this.I(this.L(E.identifier,E.version),w)}async H(w){w||(w=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),w.length&&await this.f.markAsUninstalled(...w)}I(w,C){let E=this.b.get(w);E||this.b.set(w,E=new r.$Bc(b=>this.m.extUri.getComparisonKey(b))),E.add(C)}J(w,C){const E=this.b.get(w);E&&E.delete(C),E?.size||this.b.delete(w)}L(w,C){return`${D.$mm.toKey(w.id)}@${C}`}M(w){const[C,E]=(0,I.$4o)(w);return E?{identifier:{id:C},version:E}:void 0}}e.$0p=S}),define(be[247],ve([1,0,218,38]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function r(I,D,S,v,w,C,E){const b={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${D.nameShort})`};if((0,O.$To)(D,S)&&(0,O.$Vo)(v)===3){const h=await(0,k.$Bp)(S,w,C);b["X-Market-User-Id"]=h,b["VSCode-SessionId"]=E.machineId||h}return b}e.$Cp=r}),define(be[121],ve([1,0,89,18,15,2,12,7,23,26,30,36,13,85,4]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;let c=class extends h.$jr{constructor(f,u,l,t){super(l),this.h=f,this.j=t,this.g=this.B(new g(u,t)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(f,u){const t=(await this.g.getLanguagePacks())[u];if(!t){this.j.warn(`No language pack found for ${u}`);return}const o=t.translations[f];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),u=Object.keys(f).map(l=>{const t=f[l];return{...this.f(l,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return u.push(this.f("en","English")),u.sort((l,t)=>l.label.localeCompare(t.label)),u}async m(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",f.identifier.id),await this.update())}async n(f){const u=await this.g.getLanguagePacks();Object.keys(u).some(l=>u[l]&&u[l].extensions.some(t=>(0,E.$2o)(t.extensionIdentifier,f.identifier)))&&(this.j.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,u]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(u);return!(0,O.$ub)(Object.keys(f),Object.keys(l))}};e.$kr=c,e.$kr=c=Ne([Oe(0,C.$Co),Oe(1,w.$ci),Oe(2,C.$zo),Oe(3,b.$oj)],c);let g=class extends I.$Tc{constructor(f,u){super(),this.j=u,this.c={},this.f=(0,S.$jc)(f.userDataPath,"languagepacks.json"),this.g=new r.$bh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.s(u=>{Object.keys(u).forEach(l=>delete u[l]),this.m(u,...f)}).then(()=>this.c)}m(f,...u){for(const l of u)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(f,l);Object.keys(f).forEach(l=>this.r(f[l]))}n(f,u){const l=u.identifier,t=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const o of t)if(u.location.scheme===D.Schemas.file&&d(o)){let n=f[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},f[o.languageId]=n);const s=n.extensions.filter(i=>(0,E.$2o)(i.extensionIdentifier,l))[0];s?s.version=u.manifest.version:n.extensions.push({extensionIdentifier:l,version:u.manifest.version});for(const i of o.translations)n.translations[i.id]=(0,S.$jc)(u.location.fsPath,i.path)}}r(f){if(f){const u=(0,k.createHash)("md5");for(const l of f.extensions)u.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);f.hash=u.digest("hex")}}s(f=()=>null){return this.g.queue(()=>{let u=null;return v.Promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(u=f(l),l)).then(l=>{for(const o of Object.keys(l))l[o]||delete l[o];this.c=l,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>u,l=>this.j.error(l))})}};g=Ne([Oe(0,w.$ci),Oe(1,b.$oj)],g);function d(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const f of m.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(be[248],ve([1,0,169,10,21,38]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function v(C,E,b){const h=await(0,k.$iD)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,k.$iD)("@microsoft/1ds-post-js","dist/ms.post.js"),c=new h.AppInsightsCore,g=new $.PostChannel,d={instrumentationKey:C,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(b){d.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:b};d.extensionConfig[g.identifier]=m}return c.initialize(d,[]),c.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),c}class w{constructor(E,b,h,$,c){this.e=E,this.f=b,this.g=h,this.h=c,this.c=D,this.d=S,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=v(this.a,this.e,this.h)),this.b.then(b=>{E(b)},b=>{(0,O.$1)(b),console.error(b)})}}log(E,b){if(!this.a)return;b=(0,r.$zn)(b,this.g),b=(0,I.$Wo)(b);const h=this.f+"/"+E;try{this.i($=>{$.pluginVersionString=b?.properties.version??"Unknown",$.track({name:h,baseData:{name:h,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$uO=w}),define(be[249],ve([1,0,2,21,3,17,198,25,45,57,31,37,32,38]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,m,f){this.k=m,this.l=f,this.d={},this.i=new k.$Sc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const u of this.f)this.j.push(new RegExp((0,I.$Pe)(u),"gi")),u.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.$Pe)(u.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(u=>{(u.affectsConfiguration(b.$Dl)||u.affectsConfiguration(b.$Fl)||u.affectsConfiguration(b.$El))&&this.m()}))}setExperimentProperty(d,m){this.d[d]=m}m(){let d=(0,h.$Vo)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const f=m.usage?3:m.error?2:0;d=Math.min(d,f)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,m,f){this.g<m||(f=(0,O.$zn)(f,this.d),f=(0,h.$1o)(f,this.j),f=(0,O.$zn)(f,this.c),this.b.forEach(u=>u.log(d,f)))}publicLog(d,m){this.n(d,3,m)}publicLog2(d,m){this.publicLog(d,m)}publicLogError(d,m){this.h&&this.n(d,2,m)}publicLogError2(d,m){this.publicLogError(d,m)}};e.$qr=$,e.$qr=$=Ne([Oe(1,S.$Ai),Oe(2,C.$Gj)],$);function c(){const g=(0,D.localize)(0,null,w.default.nameLong),d=w.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=r.$o?"":(0,D.localize)(3,null),f=(0,D.localize)(4,null),u=(0,D.localize)(5,null),l=(0,D.localize)(6,null),t=(0,D.localize)(7,null),o=`
|       | ${f} | ${u} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,D.localize)(8,null);return`
${g} ${d} ${m}

&nbsp;

${t}
${o}

&nbsp;

${n}
`}E.$In.as(v.$Nn.Configuration).registerConfiguration({id:b.$Cl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[b.$Dl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$In.as(v.$Nn.Configuration).registerConfiguration({id:b.$Cl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[b.$Fl]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,D.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,D.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${b.$Dl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(be[250],ve([1,0,25,5,31,32,249,38]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=e.$ds=e.$cs=void 0;let v=class extends D.$qr{constructor(C,E,b,h){super(C,b,h),this.o=E}publicLog(C,E){if(!(this.o<3))return super.publicLog(C,E)}publicLog2(C,E){return this.publicLog(C,E)}publicLogError(C,E){return this.o<2?Promise.resolve(void 0):super.publicLogError(C,E)}publicLogError2(C,E){return this.publicLogError(C,E)}async updateInjectedTelemetryLevel(C){if(C===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,C):C,this.o===0&&this.dispose()}};e.$cs=v,e.$cs=v=Ne([Oe(2,k.$Ai),Oe(3,r.$Gj)],v),e.$ds=new class extends S.$No{async updateInjectedTelemetryLevel(){}},e.$es=(0,O.$8h)(I.$vl)}),define(be[251],ve([1,0,14,20,304,248]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=void 0;async function D(C,E){const b=await E.request(C,O.CancellationToken.None),h=(await(0,k.$we)(b.stream)).toString(),$=b.res.statusCode??200;return{headers:b.res.headers,statusCode:$,responseData:h}}async function S(C){const E={method:C.type,headers:C.headers};return new Promise((h,$)=>{const c=r.request(C.url??"",E,g=>{g.on("data",function(d){h({headers:g.headers,statusCode:g.statusCode??200,responseData:d.toString()})}),g.on("error",function(d){$(d)})});c.write(C.data,g=>{g&&$(g)}),c.end()})}async function v(C,E,b){const h=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),$={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:h};try{const c=C?await D($,C):await S($);b(c.statusCode,c.headers,c.responseData)}catch{b(0,{})}}class w extends I.$uO{constructor(E,b,h,$,c){const g={sendPOST:(d,m)=>{v(E,d,m)}};super(b,h,$,c,g)}}e.$vO=w}),define(be[252],ve([1,0,10,242]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class r extends O.default{i(){(0,k.setUnexpectedErrorHandler)(S=>console.error(S));const D=[];process.on("unhandledRejection",(S,v)=>{D.push(v),setTimeout(()=>{const w=D.indexOf(v);w>=0&&v.catch(C=>{D.splice(w,1),(0,k.$4)(C)||(console.warn(`rejected promise not handled within 1 second: ${C}`),C.stack&&console.warn(`stack trace: ${C.stack}`),S&&(0,k.$1)(S))})},1e3)}),process.on("rejectionHandled",S=>{const v=D.indexOf(S);v>=0&&D.splice(v,1)}),process.on("uncaughtException",S=>{(0,k.$Z)(S)||(0,k.$1)(S)})}}e.default=r}),define(be[122],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var k;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(k||(e.EnvironmentVariableMutatorType=k={}))}),define(be[123],ve([1,0,3,122]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;const r=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class I{constructor(C){this.collections=C,this.a=new Map,this.b=new Map,C.forEach((E,b)=>{this.d(E,b);const h=E.map.entries();let $=h.next();for(;!$.done;){const c=$.value[1],g=$.value[0];let d=this.a.get(g);if(d||(d=[],this.a.set(g,d)),d.length>0&&d[0].type===O.EnvironmentVariableMutatorType.Replace){$=h.next();continue}const m={extensionIdentifier:b,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};m.scope||delete m.scope,d.unshift(m),$=h.next()}})}async applyToProcessEnvironment(C,E,b){let h;k.$i&&(h={},Object.keys(C).forEach($=>h[$.toLowerCase()]=$));for(const[$,c]of this.getVariableMap(E)){const g=k.$i&&h[$.toLowerCase()]||$;for(const d of c){const m=b?await b(d.value):d.value;if(d.options?.applyAtProcessCreation??!0)switch(d.type){case O.EnvironmentVariableMutatorType.Append:C[g]=(C[g]||"")+m;break;case O.EnvironmentVariableMutatorType.Prepend:C[g]=m+(C[g]||"");break;case O.EnvironmentVariableMutatorType.Replace:C[g]=m;break}if(d.options?.applyAtShellIntegration??!1){const f=`VSCODE_ENV_${r.get(d.type)}`;C[f]=(C[f]?C[f]+":":"")+$+"="+this.c(m)}}}}c(C){return C.replaceAll(":","\\x3a")}diff(C,E){const b=new Map,h=new Map,$=new Map;if(C.getVariableMap(E).forEach((c,g)=>{const d=this.getVariableMap(E).get(g),m=S(c,d);m&&b.set(g,m)}),this.getVariableMap(E).forEach((c,g)=>{const d=C.getVariableMap(E).get(g),m=S(c,d);m&&$.set(g,m)}),this.getVariableMap(E).forEach((c,g)=>{const d=C.getVariableMap(E).get(g),m=v(c,d);m&&h.set(g,m)}),!(b.size===0&&h.size===0&&$.size===0))return{added:b,changed:h,removed:$}}getVariableMap(C){const E=new Map;for(const b of this.a.values()){const h=b.filter($=>D($,C));h.length>0&&E.set(h[0].variable,h)}return E}getDescriptionMap(C){const E=new Map;for(const b of this.b.values()){const h=b.filter($=>D($,C,!0));for(const $ of h)E.set($.extensionIdentifier,$.description)}return E}d(C,E){if(!C.descriptionMap)return;const b=C.descriptionMap.entries();let h=b.next();for(;!h.done;){const $=h.value[1],c=h.value[0];let g=this.b.get(c);g||(g=[],this.b.set(c,g));const d={extensionIdentifier:E,scope:$.scope,description:$.description};d.scope||delete d.scope,g.push(d),h=b.next()}}}e.$Tr=I;function D(w,C,E=!1){return w.scope?!!(w.scope.workspaceFolder&&C?.workspaceFolder&&w.scope.workspaceFolder.index===C.workspaceFolder.index):E?C===w.scope:!0}function S(w,C){if(!C)return w;const E=new Set;C.forEach(h=>E.add(h.extensionIdentifier));const b=[];return w.forEach(h=>{E.has(h.extensionIdentifier)||b.push(h)}),b.length===0?void 0:b}function v(w,C){if(!C)return;const E=new Map;C.forEach(h=>E.set(h.extensionIdentifier,h));const b=[];return w.forEach(h=>{const $=E.get(h.extensionIdentifier);$&&(h.type!==$.type||h.value!==$.value||h.scope?.workspaceFolder?.index!==$.scope?.workspaceFolder?.index)&&b.push($)}),b.length===0?void 0:b}}),define(be[90],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=void 0;function k(v){return[...v.entries()]}e.$Nr=k;function O(v){return v?[...v.entries()]:[]}e.$Or=O;function r(v){return new Map(v)}e.$Pr=r;function I(v){return new Map(v??[])}e.$Qr=I;function D(v){return Array.from(v.entries()).map(w=>[w[0],k(w[1].map),O(w[1].descriptionMap)])}e.$Rr=D;function S(v){return new Map(v.map(w=>[w[0],{map:r(w[1]),descriptionMap:I(w[2])}]))}e.$Sr=S}),define(be[253],ve([1,0,15,20,6,2,13]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;let S=class extends I.$Tc{constructor(w,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$Wd),this.onCreateRequest=this.g.event,this.b=w===void 0?15e3:w,this.B((0,I.$Rc)(()=>{for(const E of this.f.values())(0,I.$Oc)(E)}))}createRequest(w){return new Promise((C,E)=>{const b=++this.a;this.c.set(b,C),this.g.fire({requestId:b,...w});const h=new O.$7d;(0,k.$8g)(this.b,h.token).then(()=>E(`Request ${b} timed out (${this.b}ms)`)),this.f.set(b,[(0,I.$Rc)(()=>h.cancel())])})}acceptReply(w,C){const E=this.c.get(w);E?(this.c.delete(w),(0,I.$Oc)(this.f.get(w)||[]),this.f.delete(w),E(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};e.$Er=S,e.$Er=S=Ne([Oe(1,D.$oj)],S)}),define(be[91],ve([1,0,5,69,37]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.$yr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$xr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$wr=void 0,e.$wr=new O.$lj("terminalTabFocusMode",!1,!0);var I;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(I||(e.TerminalSettingPrefix=I={}));var D;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",l.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",l.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",l.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",l.MouseWheelZoom="terminal.integrated.mouseWheelZoom",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var S;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh"})(S||(e.PosixShellType=S={}));var v;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash"})(v||(e.WindowsShellType=v={}));var w;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(w||(e.TitleEventSource=w={}));var C;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(C||(e.TerminalIpcChannels=C={}));var E;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$xr=(0,k.$7h)("ptyService");var b;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b||(e.HeartbeatConstants=b={}));var h;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var $;(function(l){l.TerminalView="view",l.Editor="editor"})($||(e.TerminalLocationString=$={}));var c;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var g;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var d;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var m;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var f;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(f||(e.TerminalExitReason=f={})),e.$yr={Backend:"workbench.contributions.terminal.processBackend"};class u{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}r.$In.add(e.$yr.Backend,new u),e.$zr=(0,k.$7h)("localPtyService"),e.$Ar=(0,k.$7h)("terminalLogService")}),define(be[254],ve([1,0,3]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=e.$_N=e.$$N=void 0;function O(D){let S=D;S.includes("\\")&&(S=S.replace(/\\/g,"\\\\"));const v=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return S=S.replace(v,""),`'${S}'`}e.$$N=O;function r(D,S,v){if(!D)return"";if(!S)return D;S.match(/[\/\\]$/)&&(S=S.slice(0,S.length-1));const w=D.replace(/\\/g,"/").toLowerCase(),C=S.replace(/\\/g,"/").toLowerCase();return w.includes(C)?`~${v}${D.slice(S.length+1)}`:D}e.$_N=r;function I(D){return D.match(/^['"].*['"]$/)&&(D=D.substring(1,D.length-1)),k.OS===1&&D&&D[1]===":"?D[0].toUpperCase()+D.substring(1):D}e.$aO=I}),define(be[255],ve([1,0,51,4,200,99]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.$Gr=e.$Fr=void 0;function D(b,h){const $=[{name:null,description:(0,r.localize)(0,null)}];return $.push(...b.map(c=>({name:c.profileName,description:S(c)}))),h&&$.push(...h.map(c=>({name:c.title,description:v(c)}))),{values:$.map(c=>c.name),markdownDescriptions:$.map(c=>c.description)}}e.$Fr=D;function S(b){let h=`$(${I.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:k.$ak.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?h+=`
- args: "${b.args}"`:h+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(h+=`
- overrideName: ${b.overrideName}`),b.color&&(h+=`
- color: ${b.color}`),b.env&&(h+=`
- env: ${JSON.stringify(b.env)}`),h}function v(b){return`$(${I.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:k.$ak.terminal.id}) ${b.title}
- extensionIdentifier: ${b.extensionIdentifier}`}function w(b,h){if(!b&&!h)return!0;if(typeof b=="string"&&typeof h=="string")return b===h;if(Array.isArray(b)&&Array.isArray(h)){if(b.length!==h.length)return!1;for(let $=0;$<b.length;$++)if(b[$]!==h[$])return!1;return!0}return!1}e.$Gr=w;function C(b,h){if(!b&&!h)return!0;if(!b||!h)return!1;if(I.ThemeIcon.isThemeIcon(b)&&I.ThemeIcon.isThemeIcon(h))return b.id===h.id&&b.color===h.color;if(typeof b=="object"&&"light"in b&&"dark"in b&&typeof h=="object"&&"light"in h&&"dark"in h){const $=b,c=h;if((O.URI.isUri($.light)||E($.light))&&(O.URI.isUri($.dark)||E($.dark))&&(O.URI.isUri(c.light)||E(c.light))&&(O.URI.isUri(c.dark)||E(c.dark)))return $.light.path===c.light.path&&$.dark.path===c.dark.path}if(O.URI.isUri(b)&&O.URI.isUri(h)||E(b)||E(h)){const $=b,c=h;return $.path===c.path&&$.scheme===c.scheme}return!1}e.$Hr=C;function E(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.$Ir=E}),define(be[256],ve([1,0,51,3,199,45,37,255]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.$Kr=e.$Jr=void 0,e.$Jr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Kr={type:"string",enum:Array.from((0,k.$_j)(),g=>g.id),markdownEnumDescriptions:Array.from((0,k.$_j)(),g=>`$(${g.id})`)};const v={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$Kr},color:{description:(0,r.localize)(3,null),...e.$Jr},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...v}},C={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...v}};function E(g){const d=g===2?"linux":g===1?"osx":"windows";return(0,r.localize)(7,null,(0,O.$h)(g),'```json\n"terminal.integrated.profile.'+d+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:E(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...v}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...v}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:E(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...v}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:E(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...v}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){D.$In.as(I.$Nn.Configuration).registerConfiguration(b),c()}e.$Lr=h;let $;function c(g,d){const m=D.$In.as(I.$Nn.Configuration);let f;g&&(f=(0,S.$Fr)(g?.profiles,d));const u=$;$={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:g?.os===3?f?.values:void 0,markdownEnumDescriptions:g?.os===3?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:g?.os===2?f?.values:void 0,markdownEnumDescriptions:g?.os===2?f?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:g?.os===1?f?.values:void 0,markdownEnumDescriptions:g?.os===1?f?.markdownDescriptions:void 0}}},m.updateConfigurations({add:[$],remove:u?[u]:[]})}e.$Mr=c}),define(be[257],ve([1,0,2,12,107,26,108]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=void 0;let S=class extends k.$Tc{constructor(w,C){super(),this.a=w,this.b=C}start(){const w={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:O.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},C=(0,D.$Dm)(this.b.args,this.b.isBuilt);C&&(C.break&&C.port?w.debugBrk=C.port:!C.break&&C.port&&(w.debug=C.port));const E=new r.$sq(O.$pg.asFileUri("bootstrap-fork").fsPath,w),b=new k.$Sc;return b.add(E),{client:E,store:b,onDidProcessExit:E.onDidProcessExit}}};e.$PO=S,e.$PO=S=Ne([Oe(1,I.$bi)],S)}),define(be[258],ve([1,0,28,12,21,7,3,29,17,11,23,122,90,123]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=void 0;function $(){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let i=0;return s&&s.length===4&&(i=parseInt(s[3])),i}e.$Ur=$;async function c(s,i,a,p=S.env,L=C.Promises.exists){if(I.$ic(s))return await L(s)?s:void 0;if(i===void 0&&(i=S.cwd()),I.$mc(s)!=="."){const M=I.$jc(i,s);return await L(M)?M:void 0}const y=(0,r.$Dn)(p,"PATH");if(a===void 0&&(0,w.$Jf)(y)&&(a=y.split(I.$tc)),a===void 0||a.length===0){const M=I.$jc(i,s);return await L(M)?M:void 0}for(const M of a){let _;if(I.$ic(M)?_=I.$jc(M,s):_=I.$jc(i,M,s),await L(_))return _;if(D.$i){let se=_+".com";if(await L(se)||(se=_+".exe",await L(se)))return se}}const A=I.$jc(i,s);return await L(A)?A:void 0}e.$Vr=c;function g(s,i,a,p,L){const P=D.$i&&(!i.windowsEnableConpty||$()<18309);if(!i.shellIntegration.enabled||!s.executable||s.isFeatureTerminal||s.hideFromUser||s.ignoreShellIntegration||P)return;const y=s.args,A=S.$dc==="win32"?I.$nc(s.executable).toLowerCase():I.$nc(s.executable),M=I.$mc(O.$pg.asFileUri("").fsPath);let _;const se={VSCODE_INJECTION:"1"};if(i.shellIntegration.nonce&&(se.VSCODE_NONCE=i.shellIntegration.nonce),D.$i){if(A==="pwsh.exe"||A==="powershell.exe")return!y||o(y)?_=f.get(m.WindowsPwsh):t(y)&&(_=f.get(m.WindowsPwshLogin)),_?(_=[..._],_[_.length-1]=(0,v.$Le)(_[_.length-1],M,""),i.shellIntegration.suggestEnabled&&(se.VSCODE_SUGGEST="1"),{newArgs:_,envMixin:se}):void 0;p.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args);return}switch(A){case"bash":return!y||y.length===0?_=f.get(m.Bash):n(y)&&(se.VSCODE_SHELL_LOGIN="1",d(i,se),_=f.get(m.Bash)),_?(_=[..._],_[_.length-1]=(0,v.$Le)(_[_.length-1],M),{newArgs:_,envMixin:se}):void 0;case"fish":{const G=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",oe=I.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return se.XDG_DATA_DIRS=`${G}:${oe}`,d(i,se),{newArgs:void 0,envMixin:se}}case"pwsh":return!y||o(y)?_=f.get(m.Pwsh):t(y)&&(_=f.get(m.PwshLogin)),_?(i.shellIntegration.suggestEnabled&&(se.VSCODE_SUGGEST="1"),_=[..._],_[_.length-1]=(0,v.$Le)(_[_.length-1],M,""),{newArgs:_,envMixin:se}):void 0;case"zsh":{if(!y||y.length===0?_=f.get(m.Zsh):n(y)?(_=f.get(m.ZshLogin),d(i,se)):(y===f.get(m.Zsh)||y===f.get(m.ZshLogin))&&(_=y),!_)return;_=[..._],_[_.length-1]=(0,v.$Le)(_[_.length-1],M);let G;try{G=k.userInfo().username}catch{G="unknown"}const oe=I.$jc(k.tmpdir(),`${G}-${L.applicationName}-zsh`);se.ZDOTDIR=oe;const ee=a?.ZDOTDIR??k.homedir()??"~";se.USER_ZDOTDIR=ee;const K=[];return K.push({source:I.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.$jc(oe,".zshrc")}),K.push({source:I.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.$jc(oe,".zprofile")}),K.push({source:I.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.$jc(oe,".zshenv")}),K.push({source:I.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.$jc(oe,".zlogin")}),{newArgs:_,envMixin:se,filesToCopy:K}}}p.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args)}e.$Wr=g;function d(s,i){if(D.$j&&s.environmentVariableCollections){const a=(0,b.$Sr)(s.environmentVariableCollections),L=new h.$Tr(a).getVariableMap({workspaceFolder:s.workspaceFolder}).get("PATH"),P=[];if(L)for(const y of L)y.type===E.EnvironmentVariableMutatorType.Prepend&&P.push(y.value);P.length>0&&(i.VSCODE_PATH_PREFIX=P.join(""))}}var m;(function(s){s.WindowsPwsh="windows-pwsh",s.WindowsPwshLogin="windows-pwsh-login",s.Pwsh="pwsh",s.PwshLogin="pwsh-login",s.Zsh="zsh",s.ZshLogin="zsh-login",s.Bash="bash"})(m||(m={}));const f=new Map;f.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(m.Zsh,["-i"]),f.set(m.ZshLogin,["-il"]),f.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const u=["-login","-l"],l=["-nol","-nologo"];function t(s){return typeof s=="string"?u.includes(s.toLowerCase()):s.length===1&&u.includes(s[0].toLowerCase())||s.length===2&&(u.includes(s[0].toLowerCase())||u.includes(s[1].toLowerCase()))&&(l.includes(s[0].toLowerCase())||l.includes(s[1].toLowerCase()))}function o(s){return typeof s=="string"?l.includes(s.toLowerCase()):s.length===0||s?.length===1&&l.includes(s[0].toLowerCase())}function n(s){return s==="string"&&u.includes(s.toLowerCase())||typeof s!="string"&&s.length===1&&u.includes(s[0].toLowerCase())}}),define(be[259],ve([1,0,54,51,7,3,11,23,102,258,77]),function(he,e,k,O,r,I,D,S,v,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0;var E;(function(a){a.UnixShellsPath="/etc/shells"})(E||(E={}));let b,h=!0;function $(a,p,L,P,y=process.env,A,M,_,se){return A=A||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},I.$i?c(L,A,y,M,P.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:P.getValue("terminal.integrated.profiles.windows"),typeof p=="string"?p:P.getValue("terminal.integrated.defaultProfile.windows"),se,_):n(A,M,L,a&&typeof a=="object"?{...a}:P.getValue(I.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof p=="string"?p:P.getValue(I.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),se,_,y)}e.$Xr=$;async function c(a,p,L,P,y,A,M,_,se){const G=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),oe=`${process.env.windir}\\${G?"Sysnative":"System32"}`;let ee=!1;(0,w.$Ur)()>=16299&&(ee=!0),await f(_);const K=new Map;if(a){K.set("PowerShell",{source:"PowerShell",icon:O.$ak.terminalPowershell,isAutoDetected:!0}),K.set("Windows PowerShell",{path:`${oe}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$ak.terminalPowershell,isAutoDetected:!0}),K.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),K.set("Command Prompt",{path:`${oe}\\cmd.exe`,icon:O.$ak.terminalCmd,isAutoDetected:!0}),K.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),K.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.$ak.terminalBash,isAutoDetected:!0});const X=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;K.set("Cmder",{path:`${oe}\\cmd.exe`,args:["/K",X],requiresPath:process.env.CMDER_ROOT?X:{path:X,isUnsafe:!0},isAutoDetected:!0})}s(A,K);const Z=await g(K.entries(),M,p,L,P,se);if(a&&y)try{const X=await t(`${oe}\\${ee?"wsl":"bash"}.exe`,M);for(const te of X)(!A||!(te.profileName in A))&&Z.push(te)}catch{h&&(P?.info("WSL is not installed, so could not detect WSL profiles"),h=!1)}return Z}async function g(a,p,L,P=process.env,y,A){const M=[];for(const[_,se]of a)M.push(d(_,se,p,L,P,y,A));return(await Promise.all(M)).filter(_=>!!_)}async function d(a,p,L,P,y=process.env,A,M){if(p===null)return;let _,se,G;if("source"in p&&!("path"in p)){const Z=b?.get(p.source);if(!Z)return;_=Z.paths,se=p.args||Z.args,p.icon?G=m(p.icon):Z.icon&&(G=Z.icon)}else _=Array.isArray(p.path)?p.path:[p.path],se=I.$i||Array.isArray(p.args)?p.args:void 0,G=m(p.icon);let oe;if(M){const Z=_.map(te=>typeof te=="string"?te:te.path),X=await M(Z);oe=new Array(_.length);for(let te=0;te<_.length;te++)typeof _[te]=="string"?oe[te]=X[te]:oe[te]={path:X[te],isUnsafe:!0}}else oe=_.slice();let ee;if(p.requiresPath){let Z;if((0,D.$Jf)(p.requiresPath)?Z=p.requiresPath:(Z=p.requiresPath.path,p.requiresPath.isUnsafe&&(ee=Z)),!await P.existsFile(Z))return}const K=await i(a,L,oe,P,y,se,p.env,p.overrideName,p.isAutoDetected,ee);if(!K){A?.debug("Terminal profile not validated",a,_);return}return K.isAutoDetected=p.isAutoDetected,K.icon=G,K.color=p.color,K}function m(a){return typeof a=="string"?{id:a}:a}async function f(a){if(b&&!a)return;const[p,L]=await Promise.all([u(),a||l()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:p,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:L,icon:O.$ak.terminalPowershell})}async function u(){const a=new Set,p=await(0,w.$Vr)("git.exe");if(p){const y=(0,C.dirname)(p);a.add((0,C.resolve)(y,"../.."))}function L(y,A){A&&y.add(A)}L(a,process.env.ProgramW6432),L(a,process.env.ProgramFiles),L(a,process.env["ProgramFiles(X86)"]),L(a,`${process.env.LocalAppData}\\Program`);const P=[];for(const y of a)P.push(`${y}\\Git\\bin\\bash.exe`,`${y}\\Git\\usr\\bin\\bash.exe`,`${y}\\usr\\bin\\bash.exe`);return P.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),P.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),P}async function l(){const a=[];for await(const p of(0,v.$Ql)())a.push(p.exePath);return a}async function t(a,p){const L=[],P=await new Promise((M,_)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(se,G)=>{if(se)return _("Problem occurred when getting wsl distros");M(G)})});if(!P)return[];const y=new RegExp(/[\r?\n]/),A=P.split(y).filter(M=>M.trim().length>0&&M!=="");for(const M of A){if(M===""||M.startsWith("docker-desktop"))continue;const _=`${M} (WSL)`,se={profileName:_,path:a,args:["-d",`${M}`],isDefault:_===p,icon:o(M),isAutoDetected:!1};L.push(se)}return L}function o(a){return a.includes("Ubuntu")?O.$ak.terminalUbuntu:a.includes("Debian")?O.$ak.terminalDebian:O.$ak.terminalLinux}async function n(a,p,L,P,y,A,M,_){const se=new Map;if(L&&await a.existsFile("/etc/shells")){const G=(await a.readFile("/etc/shells")).toString(),oe=(A||G.split(`
`)).map(K=>{const Z=K.indexOf("#");return Z===-1?K:K.substring(0,Z)}).filter(K=>K.trim().length>0),ee=new Map;for(const K of oe){let Z=(0,r.$nc)(K),X=ee.get(Z)||0;X++,X>1&&(Z=`${Z} (${X})`),ee.set(Z,X),se.set(Z,{path:K,isAutoDetected:!0})}}return s(P,se),await g(se.entries(),y,a,_,p,M)}function s(a,p){if(a)for(const[L,P]of Object.entries(a))P===null||typeof P!="object"||!("path"in P)&&!("source"in P)?p.delete(L):(P.icon=P.icon||p.get(L)?.icon,p.set(L,P))}async function i(a,p,L,P,y,A,M,_,se,G){if(L.length===0)return Promise.resolve(void 0);const oe=L.shift();if(oe==="")return i(a,p,L,P,y,A,M,_,se);const ee=typeof oe!="string"&&oe.isUnsafe,K=typeof oe=="string"?oe:oe.path,Z={profileName:a,path:K,args:A,env:M,overrideName:_,isAutoDetected:se,isDefault:a===p,isUnsafePath:ee,requiresUnsafePath:G};if((0,r.$nc)(K)===K){const te=y.PATH?y.PATH.split(r.$tc):void 0,V=await(0,w.$Vr)(K,void 0,te,void 0,P.existsFile);return V?(Z.path=V,Z.isFromPath=!0,Z):i(a,p,L,P,y,A)}return await P.existsFile((0,r.$hc)(K))?Z:i(a,p,L,P,y,A,M,_,se)}}),define(be[260],ve([1,0,6,2,3,44,25,13,113,88,253,91,256,259,105,61]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0;var g;(function(m){m[m.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let d=class extends O.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(f,u,l,t){super(),this.M=f,this.N=u,this.O=l,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new k.$Wd),this.onPtyHostExit=this.u.event,this.w=this.B(new k.$Wd),this.onPtyHostStart=this.w.event,this.y=this.B(new k.$Wd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new k.$Wd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new k.$Wd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new k.$Wd),this.onProcessData=this.D.event,this.F=this.B(new k.$Wd),this.onProcessReady=this.F.event,this.G=this.B(new k.$Wd),this.onProcessReplay=this.G.event,this.H=this.B(new k.$Wd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new k.$Wd),this.onDidRequestDetach=this.I.event,this.J=this.B(new k.$Wd),this.onDidChangeProperty=this.J.event,this.L=this.B(new k.$Wd),this.onProcessExit=this.L.event,(0,b.$Lr)(),this.B(this.M),this.B((0,O.$Rc)(()=>this.W())),this.j=this.B(new C.$Er(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&k.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(r.$i)return process.env;try{return await(0,w.$am)(this.N,this.O,{_:[]},process.env)}catch(f){return this.O.error("ptyHost was unable to resolve shell environment",f),{}}}U(){const f=this.M.start(),u=f.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),I.ProxyChannel.toService(u.getChannel(E.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(f.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=g.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=I.ProxyChannel.toService(u.getChannel(E.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new v.$Dr(this.P,u.getChannel(E.TerminalIpcChannels.Logger))),this.a=f,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[f,t]}async createProcess(f,u,l,t,o,n,s,i,a,p,L){const P=setTimeout(()=>this.$(),E.HeartbeatConstants.CreateProcessTimeout),y=await this.f.createProcess(f,u,l,t,o,n,s,i,a,p,L);return clearTimeout(P),y}updateTitle(f,u,l){return this.f.updateTitle(f,u,l)}updateIcon(f,u,l,t){return this.f.updateIcon(f,u,l,t)}attachToProcess(f){return this.f.attachToProcess(f)}detachFromProcess(f,u){return this.f.detachFromProcess(f,u)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(f){return this.f.start(f)}shutdown(f,u){return this.f.shutdown(f,u)}input(f,u){return this.f.input(f,u)}processBinary(f,u){return this.f.processBinary(f,u)}resize(f,u,l){return this.f.resize(f,u,l)}clearBuffer(f){return this.f.clearBuffer(f)}acknowledgeDataEvent(f,u){return this.f.acknowledgeDataEvent(f,u)}setUnicodeVersion(f,u){return this.f.setUnicodeVersion(f,u)}getInitialCwd(f){return this.f.getInitialCwd(f)}getCwd(f){return this.f.getCwd(f)}async getLatency(){const f=new c.$Sd,u=await this.f.getLatency();return f.stop(),[{label:"ptyhostservice<->ptyhost",latency:f.elapsed()},...u]}orphanQuestionReply(f){return this.f.orphanQuestionReply(f)}installAutoReply(f,u){return this.f.installAutoReply(f,u)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(f){return this.f.uninstallAutoReply(f)}getDefaultSystemShell(f){return this.g?.getDefaultSystemShell(f)??(0,$.$Wl)(f??r.OS,process.env)}async getProfiles(f,u,l,t=!1){const o=await this.S();return(0,h.$Xr)(u,l,t,this.N,o,void 0,this.O,this.bb.bind(this,f))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(f,u){return this.f.getWslPath(f,u)}getRevivedPtyNewId(f,u){return this.f.getRevivedPtyNewId(f,u)}setTerminalLayoutInfo(f){return this.f.setTerminalLayoutInfo(f)}async getTerminalLayoutInfo(f){return this.g?.getTerminalLayoutInfo(f)}async requestDetachInstance(f,u){return this.f.requestDetachInstance(f,u)}async acceptDetachInstanceReply(f,u){return this.f.acceptDetachInstanceReply(f,u)}async freePortKillProcess(f){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(f)}async serializeTerminalState(f){return this.f.serializeTerminalState(f)}async reviveTerminalProcesses(f,u,l){return this.f.reviveTerminalProcesses(f,u,l)}async refreshProperty(f,u){return this.f.refreshProperty(f,u)}async updateProperty(f,u,l){return this.f.updateProperty(f,u,l)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(f){this.ab(),this.s=setTimeout(()=>this.Y(),f?E.HeartbeatConstants.ConnectingBeatInterval:E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier+E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${E.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(f,u){return this.j.createRequest({workspaceId:f,originalText:u})}async acceptPtyHostResolvedVariables(f,u){this.j.acceptReply(f,u)}};e.$Yr=d,e.$Yr=d=Ne([Oe(1,D.$Ai),Oe(2,S.$oj),Oe(3,S.$pj)],d)}),define(be[34],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=void 0,e.$2k=(0,k.$7h)("IUriIdentityService")}),define(be[124],ve([1,0,34,109,16,19,149,6,2]),function(he,e,k,O,r,I,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;class w{static{this._clock=0}constructor(b){this.uri=b,this.time=w._clock++}touch(){return this.time=w._clock++,this}}let C=class{constructor(b){this.g=b,this.c=new v.$Sc,this.f=2**16;const h=new Map,$=c=>{let g=h.get(c.scheme);return g===void 0&&(g=b.hasProvider(c)&&!this.g.hasCapability(c,1024),h.set(c.scheme,g)),g};this.c.add(S.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(c=>{h.delete(c.scheme)})),this.extUri=new I.$xg($),this.d=new D.$2r((c,g)=>this.extUri.compare(c,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,I.$Jg)(b));const h=this.d.get(b);return h?h.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new w(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort(($,c)=>$[1].time<c[1].time?1:$[1].time>c[1].time?-1:0);w._clock=0,this.d.clear();const h=this.f*.5;for(let $=0;$<h;$++)this.d.set(b[$][0],b[$][1].touch())}};e.$3r=C,e.$3r=C=Ne([Oe(0,r.$rk)],C),(0,O.$Zr)(k.$2k,C,1)}),define(be[92],ve([1,0,202,7,64,19,4,5,12]),function(he,e,k,O,r,I,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.WorkbenchState=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0,e.$di=(0,S.$7h)("contextService");function w(s){const i=s;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.$ei=w;function C(s){return typeof s?.id=="string"&&!w(s)&&!b(s)}e.$fi=C,e.$gi={id:"ext-dev"},e.$hi={id:"empty-window"};function E(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,O.$nc)(s)}:i?e.$gi:e.$hi;const a=s;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$ii=E;function b(s){const i=s;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.$ji=b;function h(s){const i=s;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const a=s;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(s?.id)return{id:s.id}}e.$ki=h;var $;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function c(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$li=c;function g(s){const i=s;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$mi=g;class d{constructor(i,a,p,L,P){this.h=i,this.j=p,this.k=L,this.l=P,this.c=r.$ai.forUris(this.l,()=>!0),this.folders=a}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=r.$ai.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ni=d;class m{constructor(i,a){this.raw=a,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,I.$Ig)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$oi=m;function f(s){return new m({uri:s,index:0,name:(0,I.$Eg)(s)},{uri:s.toString()})}e.$pi=f,e.$qi="code-workspace",e.$ri=`.${e.$qi}`,e.$si=[{name:(0,k.localize)(0,null),extensions:[e.$qi]}],e.$ti="workspace.json";function u(s,i){return I.$zg.isEqualOrParent(s,i.untitledWorkspacesHome)}e.$ui=u;function l(s){let i;return D.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===v.Schemas.tmp}e.$vi=l,e.$wi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$wi}e.$xi=t;function o(s,i){return!u(s,i)&&!l(s)}e.$yi=o;function n(s){return(typeof s=="string"?(0,O.$oc)(s):(0,I.$Gg)(s))===e.$ri}e.$zi=n}),define(be[33],ve([1,0,62,6,2,19,4,201,26,16,5,13,92,24,34,15,22,17,11]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.ProfileResourceType=void 0;var f;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(f||(e.ProfileResourceType=f={}));function u(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&D.URI.isUri(i.location)&&D.URI.isUri(i.globalStorageHome)&&D.URI.isUri(i.settingsResource)&&D.URI.isUri(i.keybindingsResource)&&D.URI.isUri(i.tasksResource)&&D.URI.isUri(i.snippetsHome)&&D.URI.isUri(i.extensionsResource))}e.$3k=u,e.$4k=(0,C.$7h)("IUserDataProfilesService");function l(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:D.URI.revive(s.location).with({scheme:i}),globalStorageHome:D.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:D.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:D.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:D.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:D.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:D.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:D.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$5k=l;function t(s,i,a,p,L,P){return{id:s,name:i,location:a,isDefault:!1,shortName:L?.shortName,icon:L?.icon,globalStorageHome:P&&L?.useDefaultFlags?.globalState?P.globalStorageHome:(0,I.$Ig)(a,"globalStorage"),settingsResource:P&&L?.useDefaultFlags?.settings?P.settingsResource:(0,I.$Ig)(a,"settings.json"),keybindingsResource:P&&L?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,I.$Ig)(a,"keybindings.json"),tasksResource:P&&L?.useDefaultFlags?.tasks?P.tasksResource:(0,I.$Ig)(a,"tasks.json"),snippetsHome:P&&L?.useDefaultFlags?.snippets?P.snippetsHome:(0,I.$Ig)(a,"snippets"),extensionsResource:P&&L?.useDefaultFlags?.extensions?P.extensionsResource:(0,I.$Ig)(a,"extensions.json"),cacheHome:(0,I.$Ig)(p,s),useDefaultFlags:L?.useDefaultFlags,isTransient:L?.transient}}e.$6k=t;let o=class extends r.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,a,p,L){super(),this.t=i,this.u=a,this.w=p,this.y=L,this.f=!0,this.h=this.B(new O.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),a=[i];if(this.f)try{for(const P of this.O()){if(!P.name||!(0,m.$Jf)(P.name)||!P.location){this.y.warn("Skipping the invalid stored profile",P.location||P.name);continue}a.push(t((0,I.$Fg)(P.location),P.name,P.location,this.g,{shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags},i))}}catch(P){this.y.error(P)}const p=new h.$Ac,L=new Map;if(a.length)try{const P=this.Q();if(P.workspaces)for(const[y,A]of Object.entries(P.workspaces)){const M=D.URI.parse(y),_=a.find(se=>se.id===A);_&&p.set(M,_)}if(P.emptyWindows)for(const[y,A]of Object.entries(P.emptyWindows)){const M=a.find(_=>_.id===A);M&&L.set(y,M)}}catch(P){this.y.error(P)}this.z={profiles:a,workspaces:p,emptyWindows:L}}return this.z}D(){const i=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const a="Temp",p=new RegExp(`${(0,d.$Pe)(a)}\\s(\\d+)`);let L=0;for(const y of this.profiles){const A=p.exec(y.name),M=A?parseInt(A[1]):0;L=M>L?M:L}const P=`${a} ${L+1}`;return this.createProfile((0,k.$Ui)((0,g.$rg)()).toString(16),P,{transient:!0},i)}async createNamedProfile(i,a,p){return this.createProfile((0,k.$Ui)((0,g.$rg)()).toString(16),i,a,p)}async createProfile(i,a,p,L){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=await this.F(i,a,p);return L&&await this.setProfileForWorkspace(L,P),P}async F(i,a,p){if(!(0,m.$Jf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let L=this.r.get(a);return L||(L=(async()=>{try{const P=this.profiles.find(M=>M.name===a||M.id===i);if(P)return P;const y=t(i,a,(0,I.$Ig)(this.profilesHome,i),this.g,p,this.defaultProfile);await this.u.createFolder(y.location);const A=[];return this.j.fire({profile:y,join(M){A.push(M)}}),await c.Promises.settled(A),this.I([y],[],[]),y}finally{this.r.delete(a)}})(),this.r.set(a,L)),L}async updateProfile(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(L=>L.id===i.id);if(!p)throw new Error(`Profile '${i.name}' does not exist`);return p=t(p.id,a.name??p.name,p.location,this.g,{shortName:a.shortName??p.shortName,icon:a.icon===null?void 0:a.icon??p.icon,transient:a.transient??p.isTransient,useDefaultFlags:a.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(L=>L.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const p=[];this.m.fire({profile:a,join(L){p.push(L)}});try{await Promise.allSettled(p)}catch(L){this.y.error(L)}for(const L of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(L)?.id&&this.C.emptyWindows.delete(L);for(const L of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(L)?.id&&this.C.workspaces.delete(L);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(L){(0,w.$Ik)(L)!==1&&this.y.error(L)}}async setProfileForWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(L=>L.id===a.id);if(!p)throw new Error(`Profile '${a.name}' does not exist`);this.L(i,p)}unsetWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.G(i);return D.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(i){return(0,b.$ei)(i)?i.uri:(0,b.$ji)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,i.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,i.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,i.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,i.location)))}I(i,a,p){const L=[...this.profiles,...i],P=[];this.s.profiles=[];for(let y of L)y.isDefault||a.some(A=>y.id===A.id)||(y=p.find(A=>y.id===A.id)??y,y.isTransient?this.s.profiles.push(y):P.push({location:y.location,name:y.name,shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags}));this.P(P),this.z=void 0,this.J(i,a,p)}J(i,a,p){this.h.fire({added:i,removed:a,updated:p,all:this.profiles})}L(i,a,p){p=a?.isTransient?!0:p,p||this.L(i,void 0,!0);const L=this.G(i),P=p?this.s:this.C;D.URI.isUri(L)?(P.workspaces.delete(L),a&&P.workspaces.set(L,a)):(P.emptyWindows.delete(L),a&&P.emptyWindows.set(L,a)),p||this.M()}M(){const i={};for(const[p,L]of this.C.workspaces.entries())i[p.toString()]=L.id;const a={};for(const[p,L]of this.C.emptyWindows.entries())a[p.toString()]=L.id;this.R({workspaces:i,emptyWindows:a}),this.z=void 0}N(i){const a={},p=this.D();if(i.workspaces)for(const[P,y]of Object.entries(i.workspaces)){const A=D.URI.parse(y);a[P]=this.w.extUri.isEqual(A,p.location)?p.id:this.w.extUri.basename(A)}const L={};if(i.emptyWindows)for(const[P,y]of Object.entries(i.emptyWindows)){const A=D.URI.parse(y);L[P]=this.w.extUri.isEqual(A,p.location)?p.id:this.w.extUri.basename(A)}return{workspaces:a,emptyWindows:L}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$7k=o,e.$7k=o=Ne([Oe(0,v.$bi),Oe(1,w.$rk),Oe(2,$.$2k),Oe(3,E.$oj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$8k=n}),define(be[261],ve([1,0,18,15,20,10,6,2,3,11,4,182,30,36,35,13,31,32,34,33]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;let u=class extends S.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,a,p,L,P,y){super(),this.z=i,this.C=a,this.D=p,this.F=L,this.G=P,this.H=y,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$Wd),this.s=this.B(new D.$Wd),this.t=this.B(new D.$Wd),this.u=this.B(new D.$Wd),this.w=this.B(new D.$Wd),this.y=[],this.B((0,S.$Rc)(()=>{this.j.forEach(({task:A})=>A.cancel()),this.m.forEach(A=>A.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const a=await this.getTargetPlatform();return i.allTargetPlatforms.some(p=>(0,b.$xo)(p,i.allTargetPlatforms,a))}async installFromGallery(i,a={}){try{const L=(await this.installGalleryExtensions([{extension:i,options:a}])).find(({identifier:P})=>(0,h.$2o)(P,i.identifier));if(L?.local)return L?.local;throw L?.error?L.error:new b.$Ao(`Unknown error while installing extension ${i.identifier.id}`,b.ExtensionManagementErrorCode.Unknown)}catch(p){throw t(p)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new b.$Ao(E.localize(0,null),b.ExtensionManagementErrorCode.NotAllowed);const a=[],p=[];await Promise.allSettled(i.map(async({extension:L,options:P})=>{try{const y=await this.O(L,!!P?.installGivenVersion,!!P?.installPreReleaseVersion);p.push({...y,options:P})}catch(y){a.push({identifier:L.identifier,operation:2,source:L,error:y})}})),p.length&&a.push(...await this.I(p));for(const L of a)L.error&&(this.F.error("Failed to install extension.",L.identifier.id),this.F.error(L.error),L.source&&!C.URI.isUri(L.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,h.$0o)(L.source),error:L.error}));return a}async uninstall(i,a={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.Q(i,a)}async toggleAppliationScope(i,a){if((0,$.$pm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let p=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||(p=await this.ab(i,this.H.defaultProfile.extensionsResource,a));for(const L of this.H.profiles){const P=(await this.getInstalled(1,L.extensionsResource)).find(y=>(0,h.$2o)(y.identifier,i.identifier));P?this.w.fire(P):this.u.fire({identifier:i.identifier,profileLocation:L.extensionsResource})}return p}else{const p=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(i,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:p.identifier,operation:2,local:p,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),p}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.X(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const a=[];return await Promise.allSettled(i.map(async p=>{try{const L=await this.J(p,(P,y)=>i.some(A=>(0,h.$6o)(y.identifier.id)===(0,h.$7o)(A.manifest.publisher,A.manifest.name))?!1:this.L(P,y));a.push(...L)}catch(L){a.push({identifier:{id:(0,h.$7o)(p.manifest.publisher,p.manifest.name)},operation:2,source:p.extension,error:L})}})),this.s.fire(a),a}async J({manifest:i,extension:a,options:p},L){const P=p.isApplicationScoped||p.isBuiltin||(0,$.$pm)(i),y={...p,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(a)?p.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:P,profileLocation:P?this.H.defaultProfile.extensionsResource:p.profileLocation??this.Y()},A=ee=>`${h.$3o.create(ee).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!C.URI.isUri(a)){const ee=this.j.get(A(a));if(ee)return this.F.info("Extensions is already requested to install",a.identifier.id),await ee.task.waitUntilTaskIsFinished(),[]}const M=[],_=[],se=[],G=this.Z(i,a,y);C.URI.isUri(a)||this.j.set(A(a),{task:G,waitingTasks:[]}),this.n.fire({identifier:G.identifier,source:a,profileLocation:y.profileLocation}),this.F.info("Installing extension:",G.identifier.id),M.push({task:G,manifest:i});let oe=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",G.identifier.id);else try{const K=await this.N(G.identifier,i,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),Z=await this.getInstalled(void 0,y.profileLocation),X={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[b.$so]:!0}};for(const{gallery:te,manifest:V}of(0,k.$Mb)(K,({gallery:W})=>W.identifier.id)){oe=oe||!!V.extensionDependencies?.some(ue=>(0,h.$2o)({id:ue},G.identifier));const W=A(te),re=this.j.get(W);if(re){if(L(G,re.task)){const ue=re.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,G.identifier.id),re.waitingTasks.push(G),_.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,ne=>ne.some(me=>(0,h.$2o)(me.identifier,ue)))).then(ne=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,G.identifier.id),!ne.find(z=>(0,h.$2o)(z.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else if(!Z.some(({identifier:ue})=>(0,h.$2o)(ue,te.identifier))){const ue=this.Z(V,te,X);this.j.set(W,{task:ue,waitingTasks:[G]}),this.n.fire({identifier:ue.identifier,source:te,profileLocation:y.profileLocation}),this.F.info("Installing extension:",ue.identifier.id,G.identifier.id),M.push({task:ue,manifest:V})}}}catch(K){if(C.URI.isUri(G.source))(0,k.$Lb)(i.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",G.identifier.id,K.message),(0,k.$Lb)(i.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",G.identifier.id,K.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",G.identifier.id),K}const ee=M.reduce((K,{task:Z,manifest:X})=>(K.set(Z.identifier.id.toLowerCase(),{task:Z,manifest:X}),K),new Map);for(;ee.size;){let K;const Z=[...ee.values()].filter(({manifest:X})=>!X.extensionDependencies?.some(te=>ee.has(te.toLowerCase())));Z.length?K=ee.size===1?Z:Z.filter(({task:X})=>!(X===G&&!oe)):(this.F.info("Found extensions with circular dependencies",Z.map(({task:X})=>X.identifier.id)),K=[...ee.values()]),await this.M(K.map(async({task:X})=>{const te=new Date().getTime();try{const V=await X.run();if(await this.M(this.y.map(W=>W.postInstall(V,X.source,y,r.CancellationToken.None))),!C.URI.isUri(X.source)){const W=X.operation===3,re=W?void 0:(new Date().getTime()-X.source.lastUpdated)/1e3;if(o(this.C,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$0o)(X.source),verificationStatus:X.verificationStatus,duration:new Date().getTime()-te,durationSinceUpdate:re}),v.$o&&X.operation!==3)try{await this.z.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}se.push({local:V,identifier:X.identifier,operation:X.operation,source:X.source,context:X.options.context,profileLocation:X.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw this.F.error("Error while installing the extension",X.identifier.id,(0,I.$0)(V)),V}finally{ee.delete(X.identifier.id.toLowerCase())}}))}return _.length&&await this.M(_),se.forEach(({identifier:K})=>this.F.info("Extension installed successfully:",K.id)),se}catch(ee){if(M.forEach(({task:K})=>K.cancel()),se.length)try{const K=await Promise.allSettled(se.map(({local:Z})=>this.$(Z,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let Z=0;Z<K.length;Z++){const X=K[Z],{identifier:te}=se[Z];X.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",te.id):this.F.warn("Rollback: Error while uninstalling extension",te.id,(0,I.$0)(X.reason))}}catch(K){this.F.warn("Error while rolling back extensions",(0,I.$0)(K),se.map(({identifier:Z})=>Z.id))}return M.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:y.context,profileLocation:y.profileLocation,error:ee}))}finally{for(const{task:ee}of M)ee.source&&!C.URI.isUri(ee.source)&&this.j.delete(A(ee.source))}}L(i,a){for(const[,{task:p,waitingTasks:L}]of this.j.entries())if(p===i&&(L.includes(a)||L.some(P=>this.L(P,a)))||p===a&&L[0]&&!this.L(i,L[0]))return!1;return!0}async M(i){const a=[],p=[],L=await Promise.allSettled(i);for(const P of L)P.status==="fulfilled"?a.push(P.value):p.push(P.reason);if(p.length)throw l(p);return a}async N(i,a,p,L,P){if(!this.z.isEnabled())return[];const y=await this.getInstalled(void 0,P),A=[],M=[],_=async(se,G)=>{A.push(se);const oe=G.extensionDependencies||[],ee=[...oe];if(G.extensionPack){const K=p?y.find(Z=>(0,h.$2o)(Z.identifier,se)):void 0;for(const Z of G.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(X=>(0,h.$2o)({id:X},{id:Z}))||ee.every(X=>!(0,h.$2o)({id:X},{id:Z}))&&ee.push(Z)}if(ee.length){const K=ee.filter(Z=>A.every(X=>!(0,h.$2o)(X,{id:Z})));if(K.length){const Z=await this.z.getExtensions(K.map(X=>({id:X,preRelease:L})),r.CancellationToken.None);for(const X of Z){if(A.find(W=>(0,h.$2o)(W,X.identifier)))continue;const te=oe.some(W=>(0,h.$2o)({id:W},X.identifier));let V;try{V=await this.O(X,!1,L)}catch(W){if(te)throw W;this.F.info("Skipping the packed extension as it cannot be installed",X.identifier.id,(0,I.$0)(W));continue}M.push({gallery:V.extension,manifest:V.manifest}),await _(V.extension.identifier,V.manifest)}}}};return await _(i,a),M}async O(i,a,p){let L;const P=await this.getExtensionsControlManifest();if(P.malicious.some(M=>(0,h.$2o)(i.identifier,M)))throw new b.$Ao(E.localize(1,null,i.identifier.id),b.ExtensionManagementErrorCode.Malicious);const y=P.deprecated[i.identifier.id.toLowerCase()];if(y?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${y.extension.id}' extension instead.`),L=(await this.z.getExtensions([{id:y.extension.id,preRelease:y.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},r.CancellationToken.None))[0],!L)throw new b.$Ao(E.localize(2,null,i.identifier.id,y.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const M=await this.getTargetPlatform();throw new b.$Ao(E.localize(3,null,i.identifier.id,this.G.nameLong,(0,b.$to)(M)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(L=await this.P(i,a,p),!L)throw!p&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],r.CancellationToken.None))[0]?new b.$Ao(E.localize(4,null,i.displayName??i.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$Ao(E.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",L.identifier.id);const A=await this.z.getManifest(L,r.CancellationToken.None);if(A===null)throw new b.$Ao(`Missing manifest for extension ${L.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(A.version!==L.version)throw new b.$Ao(`Cannot install '${L.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:L,manifest:A}}async P(i,a,p){const L=await this.getTargetPlatform();let P=null;return!a&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==p&&(P=(await this.z.getExtensions([{...i.identifier,preRelease:p}],{targetPlatform:L,compatible:!0},r.CancellationToken.None))[0]||null),!P&&await this.z.isExtensionCompatible(i,p,L)&&(P=i),P||(a?P=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:L,compatible:!0},r.CancellationToken.None))[0]||null:P=await this.z.getCompatibleExtension(i,p,L)),P}async Q(i,a){const p={...a,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},L=se=>`${se.id.toLowerCase()}${p.versionOnly?`-${i.manifest.version}`:""}${p.profileLocation?`@${p.profileLocation.toString()}`:""}`,P=this.m.get(L(i.identifier));if(P)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),P.waitUntilTaskIsFinished();const y=se=>{const G=this.$(se,p);return this.m.set(L(G.extension.identifier),G),p.profileLocation?this.F.info("Uninstalling extension from the profile:",`${se.identifier.id}@${se.manifest.version}`,p.profileLocation.toString()):this.F.info("Uninstalling extension:",`${se.identifier.id}@${se.manifest.version}`),this.t.fire({identifier:se.identifier,profileLocation:p.profileLocation,applicationScoped:se.isApplicationScoped}),G},A=(se,G)=>{G?p.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${se.identifier.id}@${se.manifest.version}`,p.profileLocation.toString(),G.message):this.F.error("Failed to uninstall extension:",`${se.identifier.id}@${se.manifest.version}`,G.message):p.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${se.identifier.id}@${se.manifest.version}`,p.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${se.identifier.id}@${se.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$9o)(se),error:G}),this.u.fire({identifier:se.identifier,error:G?.code,profileLocation:p.profileLocation,applicationScoped:se.isApplicationScoped})},M=[],_=[];try{M.push(y(i));const se=await this.getInstalled(1,p.profileLocation);if(p.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const G=this.U(i,se);for(const oe of G)this.m.has(L(oe.identifier))?this.F.info("Extensions is already requested to uninstall",oe.identifier.id):M.push(y(oe))}p.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.R(M.map(G=>G.extension),se,i),await this.M(M.map(async G=>{try{if(await G.run(),await this.M(this.y.map(oe=>oe.postUninstall(G.extension,p,r.CancellationToken.None))),G.extension.identifier.uuid)try{await this.z.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,"uninstall")}catch{}A(G.extension)}catch(oe){const ee=oe instanceof b.$Ao?oe:new b.$Ao((0,I.$0)(oe),b.ExtensionManagementErrorCode.Internal);throw A(G.extension,ee),ee}finally{_.push(G)}}))}catch(se){const G=se instanceof b.$Ao?se:new b.$Ao((0,I.$0)(se),b.ExtensionManagementErrorCode.Internal);for(const oe of M){try{oe.cancel()}catch{}_.includes(oe)||A(oe.extension,G)}throw G}finally{for(const se of M)this.m.delete(L(se.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",se.extension.identifier.id)}}R(i,a,p){for(const L of i){const P=this.W(L,a);if(P.length){const y=P.filter(A=>!i.some(M=>(0,h.$2o)(M.identifier,A.identifier)));if(y.length)throw new Error(this.S(L,y,p))}}}S(i,a,p){return p===i?a.length===1?E.localize(6,null,p.manifest.displayName||p.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(7,null,p.manifest.displayName||p.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(8,null,p.manifest.displayName||p.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?E.localize(9,null,p.manifest.displayName||p.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(10,null,p.manifest.displayName||p.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(11,null,p.manifest.displayName||p.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}U(i,a,p=[]){if(p.indexOf(i)!==-1)return[];p.push(i);const L=i.manifest.extensionPack?i.manifest.extensionPack:[];if(L.length){const P=a.filter(A=>!A.isBuiltin&&L.some(M=>(0,h.$2o)({id:M},A.identifier))),y=[];for(const A of P)y.push(...this.U(A,a,p));return[...P,...y]}return[]}W(i,a){return a.filter(p=>p.manifest.extensionDependencies&&p.manifest.extensionDependencies.some(L=>(0,h.$2o)({id:L},i.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const i=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Rp=u,e.$Rp=u=Ne([Oe(0,b.$zo),Oe(1,d.$vl),Oe(2,m.$2k),Oe(3,c.$oj),Oe(4,g.$Gj),Oe(5,f.$4k)],u);function l(s){const i=Array.isArray(s)?s:[s];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((a,p)=>new Error(`${a.message}${a.message?",":""}${p instanceof Error?p.message:p}`),new Error(""))}e.$Sp=l;function t(s){if(s instanceof b.$Ao)return s;if(s instanceof b.$Bo){const a=new b.$Ao(s.message,b.ExtensionManagementErrorCode.Gallery);return a.stack=s.stack,a}const i=new b.$Ao(s.message,b.ExtensionManagementErrorCode.Internal);return i.stack=s.stack,i}e.$Tp=t;function o(s,i,{extensionData:a,verificationStatus:p,duration:L,error:P,durationSinceUpdate:y}){let A,M;(0,w.$Rf)(p)&&(p===!0?p="Verified":(p===!1||(A=b.ExtensionManagementErrorCode.Signature,M=p),p="Unverified")),P&&(P instanceof b.$Ao||P instanceof b.$Bo?(A=P.code,P.code===b.ExtensionManagementErrorCode.Signature&&(M=P.message)):A=b.ExtensionManagementErrorCode.Internal),s.publicLog(i,{...a,verificationStatus:p,success:!P,duration:L,errorcode:A,errorcodeDetail:M,durationSinceUpdate:y})}class n{constructor(){this.d=new O.$6g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.$Ug)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.$Ug)(i=>new Promise((a,p)=>{const L=i.onCancellationRequested(()=>{L.dispose(),p(new I.$5)})})),this.d.open()),this.g.cancel()}}e.$Up=n}),define(be[47],ve([1,0,15,14,2,6,24,4,30,36,16,5,13,33,34,11,10,32]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.$Vp=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(e.ExtensionsProfileScanningErrorCode=m={}));class f extends Error{constructor(n,s){super(n),this.code=s}}e.$Vp=f,e.$Wp=(0,E.$7h)("IExtensionsProfileScannerService");let u=class extends r.$Tc{constructor(n,s,i,a,p,L){super(),this.j=n,this.m=s,this.n=i,this.r=a,this.s=p,this.t=L,this.b=this.B(new I.$Wd),this.onAddExtensions=this.b.event,this.c=this.B(new I.$Wd),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.$Wd),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.$Wd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s){const i=[],a=[];try{return await this.u(s,p=>{const L=[];for(const P of p)n.some(([y])=>(0,w.$2o)(y.identifier,P.identifier)&&y.manifest.version!==P.version)?i.push(P):L.push(P);for(const[P,y]of n){const A=L.findIndex(_=>(0,w.$2o)(_.identifier,P.identifier)&&_.version===P.manifest.version),M={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:y};A===-1?(a.push(M),L.push(M)):L.splice(A,1,M)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),i.length&&this.f.fire({extensions:i,profileLocation:s}),L}),a.length&&this.c.fire({extensions:a,profileLocation:s}),i.length&&this.g.fire({extensions:i,profileLocation:s}),a}catch(p){throw a.length&&this.c.fire({extensions:a,error:p,profileLocation:s}),i.length&&this.g.fire({extensions:i,error:p,profileLocation:s}),p}}async updateMetadata(n,s){const i=[];return await this.u(s,a=>{const p=[];for(const L of a){const P=n.find(([y])=>(0,w.$2o)(y.identifier,L.identifier)&&y.manifest.version===L.version);P&&(L.metadata={...L.metadata,...P[1]},i.push(L)),p.push(L)}return p}),i}async removeExtensionFromProfile(n,s){const i=[];try{await this.u(s,a=>{const p=[];for(const L of a)(0,w.$2o)(L.identifier,n.identifier)?i.push(L):p.push(L);return i.length&&this.f.fire({extensions:i,profileLocation:s}),p}),i.length&&this.g.fire({extensions:i,profileLocation:s})}catch(a){throw i.length&&this.g.fire({extensions:i,error:a,profileLocation:s}),a}}async u(n,s,i){return this.F(n).queue(async()=>{let a=[],p;try{const L=await this.m.readFile(n);p=JSON.parse(L.value.toString().trim()||"[]")}catch(L){if((0,C.$Ik)(L)!==1)throw L;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&i?.bailOutWhenFileNotFound)throw new f((0,g.$0)(L),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(n);let L=!1;for(const P of p){l(P)||this.w(n);let y;if((0,c.$Jf)(P.relativeLocation)&&P.relativeLocation)y=this.z(P.relativeLocation);else if((0,c.$Jf)(P.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${P.location}`);continue}else{y=S.URI.revive(P.location);const A=this.y(y);A&&(L=!0,P.relativeLocation=A)}(0,c.$Qf)(P.metadata?.hasPreReleaseVersion)&&P.metadata?.preRelease&&(L=!0,P.metadata.hasPreReleaseVersion=!0),a.push({identifier:P.identifier,location:y,version:P.version,metadata:P.metadata})}L&&await this.m.writeFile(n,O.$ke.fromString(JSON.stringify(p)))}if(s){a=s(a);const L=a.map(P=>({identifier:P.identifier,version:P.version,location:P.location.toJSON(),relativeLocation:this.y(P.location),metadata:P.metadata}));await this.m.writeFile(n,O.$ke.fromString(JSON.stringify(L)))}return a})}w(n){const s=new f(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(n)).value.toString()}catch(p){if((0,C.$Ik)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",n.toString());let a;try{const p=JSON.parse(i);Array.isArray(p)&&p.every(L=>l(L))?a=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$ke.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,C.$Ik)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(n)}catch(p){(0,C.$Ik)(p)!==1&&this.t.error(p)}try{await this.m.del(s)}catch(p){(0,C.$Ik)(p)!==1&&this.t.error(p)}return a})()),this.C}F(n){let s=this.h.get(n);return s||(s=new k.$bh,this.h.set(n,s)),s}};e.$Xp=u,e.$Xp=u=Ne([Oe(1,C.$rk),Oe(2,h.$4k),Oe(3,$.$2k),Oe(4,d.$vl),Oe(5,b.$oj)],u);function l(o){return(0,c.$Lf)(o)&&(0,v.$yo)(o.identifier)&&(t(o.location)||(0,c.$Jf)(o.location)&&o.location)&&((0,c.$Qf)(o.relativeLocation)||(0,c.$Jf)(o.relativeLocation))&&o.version&&(0,c.$Jf)(o.version)}function t(o){return o?(0,c.$Jf)(o.path)&&(0,c.$Jf)(o.scheme):!1}}),define(be[59],ve([1,0,18,15,21,14,10,41,166,2,12,7,3,19,55,63,11,4,186,26,36,35,82,16,5,13,31,6,52,47,33,34,216]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l,t,o,n,s,i,a,p,L,P,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.Translations=void 0;var M;(function(Z){function X(te,V){if(te===V)return!0;const W=Object.keys(te),re=new Set;for(const ue of Object.keys(V))re.add(ue);if(W.length!==re.size)return!1;for(const ue of W){if(te[ue]!==V[ue])return!1;re.delete(ue)}return re.size===0}Z.equals=X})(M||(e.Translations=M={})),e.$1p=(0,n.$7h)("IExtensionsScannerService");let _=class extends w.$Tc{constructor(X,te,V,W,re,ue,ne,me,z,H,R,U){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=te,this.r=V,this.s=W,this.t=re,this.u=ue,this.w=ne,this.y=me,this.z=z,this.C=H,this.D=R,this.F=U,this.g=this.B(new a.$Wd),this.onDidChangeCache=this.g.event,this.h=(0,h.$Ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(oe,this.s,this.h)),this.m=this.B(this.F.createInstance(oe,this.s,this.h)),this.n=this.B(this.F.createInstance(G,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,u.$ap)(this.w,this.y)),this.G}async scanAllExtensions(X,te,V){const[W,re]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(te)]),ue=V?await this.scanExtensionsUnderDevelopment(X,[...W,...re]):[];return this.L(W,re,ue,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const te=[];te.push(this.M(!!X.useCache,X.language)),te.push(this.N(X.language,!!X.checkControlFile));const[V,W]=await Promise.all(te);return this.J([...V,...W],0,X,!1)}async scanUserExtensions(X){const te=X.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const V=this.D.extUri.isEqual(X.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(te,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,V),re=X.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ue;try{ue=await re.scanExtensions(W)}catch(ne){if(ne instanceof L.$Vp&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ue=await re.scanExtensions(W);else throw ne}return ue=await this.J(ue,1,X,!0),this.y.trace("Scanned user extensions:",ue.length),ue}async scanExtensionsUnderDevelopment(X,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===C.Schemas.file).map(async W=>{const re=await this.P(W,!1,1,!0,X.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(re)).map(ne=>(ne.type=te.find(me=>(0,u.$2o)(me.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,re)))}))).flat();return this.J(V,"development",X,!0)}return[]}async scanExistingExtension(X,te,V){const W=await this.P(X,!1,te,!0,V.language,!0,void 0),re=await this.n.scanExtension(W);return!re||!V.includeInvalid&&!re.isValid?null:re}async scanOneOrMultipleExtensions(X,te,V){const W=await this.P(X,!1,te,!0,V.language,!0,void 0),re=await this.n.scanOneOrMultipleExtensions(W);return this.J(re,te,V,!0)}async scanMetadata(X){const te=(0,h.$Ig)(X,"package.json"),V=(await this.w.readFile(te)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(X,te){const V=(0,h.$Ig)(X,"package.json"),W=(await this.w.readFile(V)).value.toString(),re=JSON.parse(W);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,re.__metadata={...re.__metadata,...te},await this.w.writeFile((0,h.$Ig)(X,"package.json"),I.$ke.fromString(JSON.stringify(re,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof L.$Vp&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw X}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.u.addExtensionsToProfile(X.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,I.$ke.fromString(JSON.stringify([])))}catch(te){(0,o.$Ik)(te)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.y.error(X)}finally{this.H=void 0}})()),this.H}async J(X,te,V,W){return V.includeAllVersions||(X=this.L(te===0?X:void 0,te===1?X:void 0,te==="development"?X:void 0,await this.getTargetPlatform(),W)),V.includeInvalid||(X=X.filter(re=>re.isValid)),X.sort((re,ue)=>{const ne=E.$nc(re.location.fsPath),me=E.$nc(ue.location.fsPath);return ne<me?-1:ne>me?1:0})}L(X,te,V,W,re){const ue=(me,z,H)=>{if(me.isValid&&!z.isValid)return!1;if(me.isValid===z.isValid){if(re&&$.gt(me.manifest.version,z.manifest.version))return this.y.debug(`Skipping extension ${z.location.path} with lower version ${z.manifest.version} in favour of ${me.location.path} with version ${me.manifest.version}`),!1;if($.eq(me.manifest.version,z.manifest.version)){if(me.type===0)return this.y.debug(`Skipping extension ${z.location.path} in favour of system extension ${me.location.path} with same version`),!1;if(me.targetPlatform===W)return this.y.debug(`Skipping extension ${z.location.path} from different target platform ${z.targetPlatform}`),!1}}return H?this.y.warn(`Overwriting user extension ${me.location.path} with ${z.location.path}.`):this.y.debug(`Overwriting user extension ${me.location.path} with ${z.location.path}.`),!0},ne=new l.$om;return X?.forEach(me=>{const z=ne.get(me.identifier.id);(!z||ue(z,me,!1))&&ne.set(me.identifier.id,me)}),te?.forEach(me=>{const z=ne.get(me.identifier.id);if(!z&&X&&me.type===0){this.y.debug(`Skipping obsolete system extension ${me.location.path}.`);return}(!z||ue(z,me,!1))&&ne.set(me.identifier.id,me)}),V?.forEach(me=>{const z=ne.get(me.identifier.id);(!z||ue(z,me,!0))&&ne.set(me.identifier.id,me),ne.set(me.identifier.id,me)}),[...ne.values()]}async M(X,te){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,te,!0,void 0),re=await(X&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",re.length),re}async N(X,te){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const W=te?await this.O():{},re=[],ue=d.URI.file(E.$hc(E.$jc(C.$pg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const me of V){const z=W[me.name]||"marketplace";switch(z){case"disabled":break;case"marketplace":re.push((0,h.$Ig)(ue,me.name));break;default:re.push(d.URI.file(z));break}}const ne=await Promise.all(re.map(async me=>this.n.scanExtension(await this.P(me,!1,0,!0,X,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,k.$Hb)(ne)}async O(){try{const X=await this.w.readFile(this.r);return JSON.parse(X.value.toString())}catch{return{}}}async P(X,te,V,W,re,ue,ne){const me=await this.f(re??b.$w),z=await this.Q(X),H=te&&!this.D.extUri.isEqual(X,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,R=H?await this.Q(H):void 0;return new se(X,z,H,R,te,ne,V,W,ue,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,re,me)}async Q(X){try{const te=await this.w.stat(X);if(typeof te.mtime=="number")return te.mtime}catch{}}};e.$2p=_,e.$2p=_=Ne([Oe(4,P.$4k),Oe(5,L.$Wp),Oe(6,o.$rk),Oe(7,s.$oj),Oe(8,f.$bi),Oe(9,i.$Gj),Oe(10,y.$2k),Oe(11,n.$6h)],_);class se{constructor(X,te,V,W,re,ue,ne,me,z,H,R,U,x,J,Y){this.location=X,this.mtime=te,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=W,this.profile=re,this.profileScanOptions=ue,this.type=ne,this.excludeObsolete=me,this.validate=z,this.productVersion=H,this.productDate=R,this.productCommit=U,this.devMode=x,this.language=J,this.translations=Y}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,te){return(0,h.$Bg)(X.location,te.location)&&X.mtime===te.mtime&&(0,h.$Bg)(X.applicationExtensionslocation,te.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&X.profile===te.profile&&r.$An(X.profileScanOptions,te.profileScanOptions)&&X.type===te.type&&X.excludeObsolete===te.excludeObsolete&&X.validate===te.validate&&X.productVersion===te.productVersion&&X.productDate===te.productDate&&X.productCommit===te.productCommit&&X.devMode===te.devMode&&X.language===te.language&&M.equals(X.translations,te.translations)}}e.$3p=se;let G=class extends w.$Tc{constructor(X,te,V,W,re){super(),this.f=X,this.g=te,this.h=V,this.j=W,this.m=re}async scanExtensions(X){const te=X.profile?await this.r(X):await this.n(X);let V={};if(X.excludeObsolete&&X.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(W)}catch{}return(0,g.$Wf)(V)?te:te.filter(W=>!V[u.$3o.create(W).toString()])}async n(X){const te=await this.j.resolve(X.location);if(!te.children?.length)return[];const V=await Promise.all(te.children.map(async W=>{if(!W.isDirectory||X.type===1&&(0,h.$Fg)(W.resource).indexOf(".")===0)return null;const re=new se(W.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(re)}));return(0,k.$Hb)(V).sort((W,re)=>W.location.path<re.location.path?-1:1)}async r(X){let te=await this.s(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){te=te.filter(W=>!W.metadata?.isApplicationScoped);const V=await this.s(X.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,X);te.push(...V)}return te}async s(X,te,V){const W=await this.g.scanProfileExtensions(X,V.profileScanOptions);if(!W.length)return[];const re=await Promise.all(W.map(async ue=>{if(te(ue)){const ne=new se(ue.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ne,ue.metadata)}return null}));return(0,k.$Hb)(re)}async scanOneOrMultipleExtensions(X){try{if(await this.j.exists((0,h.$Ig)(X.location,"package.json"))){const te=await this.scanExtension(X);return te?[te]:[]}else return await this.scanExtensions(X)}catch(te){return this.m.error(`Error scanning extensions at ${X.location.path}:`,(0,D.$0)(te)),[]}}async scanExtension(X,te){try{let V=await this.scanExtensionManifest(X.location);if(V){V.publisher||(V.publisher=l.$im),te=te??V.__metadata,delete V.__metadata;const W=(0,u.$7o)(V.publisher,V.name),re=te?.id?{id:W,uuid:te.id}:{id:W},ue=te?.isSystem?0:X.type,ne=ue===0||!!te?.isBuiltin;V=await this.t(X.location,V,se.createNlsConfiguration(X));const me={type:ue,identifier:re,manifest:V,location:X.location,isBuiltin:ne,targetPlatform:te?.targetPlatform??"undefined",metadata:te,isValid:!0,validations:[]};return X.validate?this.validate(me,X):me}}catch(V){X.type!==0&&this.m.error(V)}return null}validate(X,te){let V=!0;const W=(0,t.$fp)(te.productVersion,te.productDate,te.location,X.manifest,X.isBuiltin);for(const[re,ue]of W)re===c.default.Error&&(V=!1,this.m.error(this.z(te.location,ue)));return X.isValid=V,X.validations=W,X}async scanExtensionManifest(X){const te=(0,h.$Ig)(X,"package.json");let V;try{V=(await this.j.readFile(te)).value.toString()}catch(re){return(0,o.$Ik)(re)!==1&&this.m.error(this.z(X,(0,m.localize)(0,null,te.path,re.message))),null}let W;try{W=JSON.parse(V)}catch{const ue=[];(0,S.$dn)(V,ue);for(const ne of ue)this.m.error(this.z(X,(0,m.localize)(1,null,te.path,ne.offset,ne.length,(0,v.$Yp)(ne.error))));return null}return(0,S.$mn)(W)!=="object"?(this.m.error(this.z(X,(0,m.localize)(2,null,te.path))),null):W}async t(X,te,V){const W=await this.u(X,te,V);if(W)try{const re=[],ue=await this.w(W.default,re);if(re.length>0)return re.forEach(me=>{this.m.error(this.z(X,(0,m.localize)(3,null,W.default?.path,(0,v.$Yp)(me.error))))}),te;if((0,S.$mn)(W)!=="object")return this.m.error(this.z(X,(0,m.localize)(4,null,W.default?.path))),te;const ne=W.values||Object.create(null);return(0,A.$Zp)(this.m,te,ne,ue)}catch{}return te}async u(X,te,V){const W=(0,h.$Ig)(X,"package.nls.json"),re=(z,H)=>{H.forEach(R=>{this.m.error(this.z(X,(0,m.localize)(5,null,z?.path,(0,v.$Yp)(R.error))))})},ue=z=>{this.m.error(this.z(X,(0,m.localize)(6,null,z?.path)))},ne=`${te.publisher}.${te.name}`,me=V.translations[ne];if(me)try{const z=d.URI.file(me),H=(await this.j.readFile(z)).value.toString(),R=[],U=(0,S.$dn)(H,R);return R.length>0?(re(z,R),{values:void 0,default:W}):(0,S.$mn)(U)!=="object"?(ue(z),{values:void 0,default:W}):{values:U.contents?U.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let H;try{H=await this.y(X,V)}catch{return}if(!H.localized)return{values:void 0,default:H.original};try{const R=(await this.j.readFile(H.localized)).value.toString(),U=[],x=(0,S.$dn)(R,U);return U.length>0?(re(H.localized,U),{values:void 0,default:H.original}):(0,S.$mn)(x)!=="object"?(ue(H.localized),{values:void 0,default:H.original}):{values:x,default:H.original}}catch{return{values:void 0,default:H.original}}}}async w(X,te){if(X)try{const V=(await this.j.readFile(X)).value.toString();return(0,S.$dn)(V,te)}catch{}}y(X,te){return new Promise((V,W)=>{const re=ue=>{const ne=(0,h.$Ig)(X,`package.nls.${ue}.json`);this.j.exists(ne).then(me=>{me&&V({localized:ne,original:(0,h.$Ig)(X,"package.nls.json")});const z=ue.lastIndexOf("-");z===-1?V({localized:(0,h.$Ig)(X,"package.nls.json"),original:null}):(ue=ue.substring(0,z),re(ue))})};if(te.devMode||te.pseudo||!te.language)return V({localized:(0,h.$Ig)(X,"package.nls.json"),original:null});re(te.language)})}z(X,te){return`[${X.path}]: ${te}`}};G=Ne([Oe(1,L.$Wp),Oe(2,y.$2k),Oe(3,o.$rk),Oe(4,s.$oj)],G);let oe=class extends G{constructor(X,te,V,W,re,ue,ne){super(te,W,re,ue,ne),this.G=X,this.H=V,this.D=this.B(new O.$5g(3e3)),this.F=this.B(new a.$Wd),this.onDidChangeCache=this.F.event}async scanExtensions(X){const te=this.M(X),V=await this.I(te);if(this.C=X,V&&V.input&&se.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",X.location.toString()),this.D.trigger(()=>this.L()),V.result.map(re=>(re.location=d.URI.revive(re.location),re));const W=await super.scanExtensions(X);return await this.J(te,{input:X,result:W}),W}async I(X){try{const te=await this.j.readFile(X),V=JSON.parse(te.value.toString());return{result:V.result,input:(0,p.$Dh)(V.input)}}catch(te){this.m.debug("Error while reading the extension cache file:",X.path,(0,D.$0)(te))}return null}async J(X,te){try{await this.j.writeFile(X,I.$ke.fromString(JSON.stringify(te)))}catch(V){this.m.debug("Error while writing the extension cache file:",X.path,(0,D.$0)(V))}}async L(){if(!this.C)return;const X=this.M(this.C),te=await this.I(X);if(!te)return;const V=te.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!r.$An(W,V))try{this.m.info("Invalidating Cache",V,W),await this.j.del(X),this.F.fire()}catch(re){this.m.error(re)}}M(X){const te=this.N(X);return this.h.extUri.joinPath(te.cacheHome,X.type===0?l.$hm:l.$gm)}N(X){return X.type===0?this.H.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.G.extensionsResource)?this.G:this.H.profiles.find(te=>this.h.extUri.isEqual(X.location,te.extensionsResource))??this.G:this.H.defaultProfile}};oe=Ne([Oe(2,P.$4k),Oe(3,L.$Wp),Oe(4,y.$2k),Oe(5,o.$rk),Oe(6,s.$oj)],oe);function ee(Z,X){const te=(0,u.$5o)(Z.manifest.publisher,Z.manifest.name);return{id:te,identifier:new l.$mm(te),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:X,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,...Z.manifest}}e.$4p=ee;class K extends _{constructor(X,te,V,W,re,ue,ne,me,z,H,R,U){super(X,te,(0,h.$Ig)(V,".vscode-oss-dev","extensions","control.json"),W,re,ue,ne,me,z,H,R,U),this.R=(async()=>{if(b.$z)try{const x=await this.w.readFile(d.URI.file(b.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(X){return this.R}}e.$5p=K}),define(be[262],ve([1,0,54,15,39,6,2,12,7,23,13,33]),function(he,e,k,O,r,I,D,S,v,w,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;let b=class extends D.$Tc{constructor($,c){super(),this.b=$,this.f=c,this.a=new O.$ah(5)}async postUninstall($){const c=this.g($,"uninstall");c&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(g)}}));try{await w.Promises.rm(this.m($))}catch(g){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(g)}}g($,c){const g=`vscode:${c}`;if($.location.scheme===S.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[g]=="string"){const d=$.manifest.scripts[g].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn($.identifier.id,$.manifest.version,`${g} should be a node script`),null):{script:(0,v.$jc)($.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h($,c,g,d,m){return new Promise((f,u)=>{const l=this.j($,c,g,m);let t;const o=n=>{t&&(clearTimeout(t),t=null),n?u(n):f(void 0)};l.on("error",n=>{o((0,r.$Ri)(n)||"Unknown")}),l.on("exit",(n,s)=>{o(n?`post-${c} process exited with code ${n}`:void 0)}),d&&(t=setTimeout(()=>{t=null,l.kill(),u("timed out")},5e3))})}j($,c,g,d){const m={silent:!0,execArgv:void 0},f=(0,k.fork)($,[`--type=extension-post-${c}`,...g],m);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const u=I.Event.fromNodeEventEmitter(f.stdout,"data"),l=I.Event.fromNodeEventEmitter(f.stderr,"data");u(n=>this.f.info(d.identifier.id,d.manifest.version,`post-${c}`,n)),l(n=>this.f.error(d.identifier.id,d.manifest.version,`post-${c}`,n));const t=I.Event.any(I.Event.map(u,n=>({data:`%c${n}`,format:[""]})),I.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return I.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}m($){return(0,v.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$7p=b,e.$7p=b=Ne([Oe(0,E.$4k),Oe(1,C.$oj)],b)}),define(be[125],ve([1,0,15,14,20,39,10,6,62,2,24,12,7,19,55,11,4,22,23,81,187,83,26,261,30,36,47,59,245,262,217,236,246,82,16,5,13,31,32,34,33]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l,t,o,n,s,i,a,p,L,P,y,A,M,_,se,G,oe,ee,K,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.$$p=void 0,e.$$p=(0,se.$8h)(n.$Co);const X=".vsctmp";let te=class extends o.$Rp{constructor(z,H,R,U,x,J,Y,B,T,N,q,ie){super(z,H,q,R,N,ie),this.fb=x,this.gb=J,this.hb=Y,this.ib=T,this.eb=new Map,this.rb=new C.$Bc;const ae=this.B(B.createInstance(L.$7p));this.bb=this.B(B.createInstance(V,ce=>ae.postUninstall(ce))),this.cb=this.B(new y.$9p(ie,T,q,this,this.F)),this.db=this.B(B.createInstance(p.$6p));const ge=this.B(new A.$0p(this,this.fb,ie,J,q,T,R));this.B(ge.onDidChangeExtensionsByAnotherSource(ce=>this.qb(ce))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$ap)(this.ib,this.F)),this.jb}async zip(z){this.F.trace("ExtensionManagementService#zip",z.identifier.id);const H=await this.pb(z),R=await(0,f.zip)((0,h.$Ig)(this.db.extensionsDownloadDir,(0,d.$rg)()).fsPath,H);return g.URI.file(R)}async unzip(z){return this.F.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:H,cleanup:R}=await this.lb(z),U=b.$kc(H.fsPath);try{return await(0,P.$8p)(U)}finally{await R()}}getInstalled(z,H=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(z??null,H)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(z){return this.bb.scanUserExtensionAtLocation(z)}async install(z,H={}){this.F.trace("ExtensionManagementService#install",z.toString());const{location:R,cleanup:U}=await this.lb(z);try{const x=await(0,P.$8p)(b.$kc(R.fsPath)),J=(0,s.$7o)(x.publisher,x.name);if(x.engines&&x.engines.vscode&&!(0,M.$hp)(x.engines.vscode,this.G.version,this.G.date))throw new Error(u.localize(0,null,J,this.G.version));const B=(await this.I([{manifest:x,extension:R,options:H}])).find(({identifier:T})=>(0,s.$2o)(T,{id:J}));if(B?.local)return B.local;throw B?.error?B.error:(0,o.$Tp)(new Error(`Unknown error while installing extension ${J}`))}finally{await U()}}async installFromLocation(z,H){this.F.trace("ExtensionManagementService#installFromLocation",z.toString());const R=await this.bb.scanUserExtensionAtLocation(z);if(!R)throw new Error(`Cannot find a valid extension from the location ${z.toString()}`);return await this.ub([[R,void 0]],H),this.F.info("Successfully installed extension",R.identifier.id,H.toString()),R}async installExtensionsFromProfile(z,H,R){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",z,H.toString(),R.toString());const U=(await this.bb.scanExtensions(1,H)).filter(x=>z.some(J=>(0,s.$2o)(J,x.identifier)));if(U.length){const x=await Promise.all(U.map(J=>this.bb.scanMetadata(J,H)));await this.ub(U.map((J,Y)=>[J,x[Y]]),R),this.F.info("Successfully installed extensions",U.map(J=>J.identifier.id),R.toString())}return U}async updateMetadata(z,H,R=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",z.identifier.id),H.isPreReleaseVersion&&(H.preRelease=!0,H.hasPreReleaseVersion=!0),H.isMachineScoped===!1&&(H.isMachineScoped=void 0),H.isBuiltin===!1&&(H.isBuiltin=void 0),H.pinned===!1&&(H.pinned=void 0),z=await this.bb.updateMetadata(z,H,R),this.cb.invalidate(R),this.w.fire(z),z}async reinstallFromGallery(z){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",z.identifier.id),!this.z.isEnabled())throw new Error(u.localize(1,null));const H=await this.getTargetPlatform(),[R]=await this.z.getExtensions([{...z.identifier,preRelease:z.preRelease}],{targetPlatform:H,compatible:!0},r.CancellationToken.None);if(!R)throw new Error(u.localize(2,null));await this.bb.setUninstalled(z);try{await this.bb.removeUninstalledExtension(z)}catch(U){throw new Error(u.localize(3,null,(0,I.$Ri)(U)))}return this.installFromGallery(R)}ab(z,H,R,U){return this.bb.copyExtension(z,H,R,U)}copyExtensions(z,H){return this.bb.copyExtensions(z,H)}markAsUninstalled(...z){return this.bb.setUninstalled(...z)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(z){this.F.error(z)}}async download(z,H,R){const{location:U}=await this.db.download(z,H,!R);return U}async lb(z){if(z.scheme===E.Schemas.file)return{location:z,async cleanup(){}};this.F.trace("Downloading extension from",z.toString());const H=(0,h.$Ig)(this.db.extensionsDownloadDir,(0,d.$rg)());return await this.hb.download(z,H),this.F.info("Downloaded extension to",H.toString()),{location:H,cleanup:async()=>{try{await this.ib.del(H)}catch(U){this.F.error(U)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(z,H,R){if(g.URI.isUri(H))return new ue(z,H,R,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const U=s.$3o.create(H).toString();let x=this.eb.get(U);return x||(this.eb.set(U,x=new re(z,H,R,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),x.waitUntilTaskIsFinished().finally(()=>this.eb.delete(U))),x}$(z,H){return new ne(z,H.profileLocation,this.gb)}async pb(z){const H=async U=>{let x=await m.Promises.readdir(U);x=x.map(B=>b.$jc(U,B));const J=await Promise.all(x.map(B=>m.Promises.stat(B)));let Y=Promise.resolve([]);return J.forEach((B,T)=>{const N=x[T];B.isFile()&&(Y=Y.then(q=>[...q,N])),B.isDirectory()&&(Y=Y.then(q=>H(N).then(ie=>[...q,...ie])))}),Y};return(await H(z.location.fsPath)).map(U=>({path:`extension/${b.$lc(z.location.fsPath,U)}`,localPath:U}))}async qb({added:z,removed:H}){if(H){const R=z&&this.D.extUri.isEqual(H.profileLocation,z.profileLocation)?H.extensions.filter(U=>z.extensions.every(x=>!(0,s.$2o)(x,U))):H.extensions;for(const U of R)this.F.info("Extensions removed from another source",U.id,H.profileLocation.toString()),this.u.fire({identifier:U,profileLocation:H.profileLocation})}if(z){const U=(await this.bb.scanExtensions(1,z.profileLocation)).filter(x=>z.extensions.some(J=>(0,s.$2o)(J,x.identifier)));this.s.fire(U.map(x=>(this.F.info("Extensions added from another source",x.identifier.id,z.profileLocation.toString()),{identifier:x.identifier,local:x,profileLocation:z.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(H=>this.rb.add(H)));const z=await this.ib.resolve(this.fb.userExtensionsLocation);for(const H of z.children??[])H.isDirectory&&this.rb.add(H.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(H=>this.tb(H)))}async tb(z){if(!z.affects(this.fb.userExtensionsLocation,1))return;const H=[];for(const R of z.rawAdded){if(this.rb.has(R)||!this.D.extUri.isEqual(this.D.extUri.dirname(R),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(R,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(R).startsWith(".")||!(await this.ib.stat(R)).isDirectory)continue;const U=await this.bb.scanUserExtensionAtLocation(R);U&&U.installedTimestamp===void 0&&(this.rb.add(R),H.push(U))}H.length&&(await this.ub(H.map(R=>[R,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",H.map(R=>R.identifier.id)))}async ub(z,H){const R=z.map(U=>U[0]);await this.vb(R),await this.gb.addExtensionsToProfile(z,H),this.s.fire(R.map(U=>({local:U,identifier:U.identifier,operation:1,profileLocation:H})))}async vb(z){const H=await this.bb.getUninstalledExtensions();for(const R of z){const U=s.$3o.create(R);H[U.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",U.id),await this.bb.setInstalled(U),this.F.info("Removed the extension from uninstalled list:",U.id))}}};e.$_p=te,e.$_p=te=Ne([Oe(0,n.$zo),Oe(1,ee.$vl),Oe(2,G.$oj),Oe(3,t.$ci),Oe(4,a.$1p),Oe(5,i.$Wp),Oe(6,l.$eo),Oe(7,se.$6h),Oe(8,_.$rk),Oe(9,oe.$Gj),Oe(10,K.$2k),Oe(11,Z.$4k)],te);let V=class extends w.$Tc{constructor(z,H,R,U,x,J){super(),this.j=z,this.m=H,this.n=R,this.s=U,this.t=x,this.u=J,this.h=this.B(new S.$Wd),this.onExtract=this.h.event,this.c=(0,h.$Ig)(this.n.userExtensionsLocation,".obsolete"),this.g=new k.$bh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(z,H){const R={includeInvalid:!0,profileLocation:H};let U=[];return z===null||z===0?U.push(...await this.n.scanAllExtensions({includeInvalid:!0},R,!1)):z===1&&U.push(...await this.n.scanUserExtensions(R)),U=z!==null?U.filter(x=>x.type===z):U,Promise.all(U.map(x=>this.F(x)))}async scanAllUserExtensions(z){const H=await this.n.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(H.map(R=>this.F(R)))}async scanUserExtensionAtLocation(z){try{const H=await this.n.scanExistingExtension(z,1,{includeInvalid:!0});if(H)return await this.F(H)}catch(H){this.u.error(H)}return null}async extractUserExtension(z,H,R,U,x){const J=z.toString(),Y=g.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,d.$rg)()}`)),B=g.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,J));let T=await this.m.exists(B);if(T&&U){try{await this.y(z.id,B,"removeExisting")}catch{throw new n.$Ao(u.localize(4,null,B.fsPath,z.id),n.ExtensionManagementErrorCode.Delete)}T=!1}if(T)await this.n.updateMetadata(B,R);else try{try{this.u.trace(`Started extracting the extension from ${H} to ${B.fsPath}`),await(0,f.$Pp)(H,Y.fsPath,{sourcePath:"extension",overwrite:!0},x),this.u.info(`Extracted extension to ${B}:`,z.id)}catch(N){let q=n.ExtensionManagementErrorCode.Extract;throw N instanceof f.$Np&&(N.type==="CorruptZip"?q=n.ExtensionManagementErrorCode.CorruptZip:N.type==="Incomplete"&&(q=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Ao(N.message,q)}await this.n.updateMetadata(Y,R);try{this.u.trace(`Started renaming the extension from ${Y.fsPath} to ${B.fsPath}`),await this.C(Y.fsPath,B.fsPath),this.u.info("Renamed to",B.fsPath)}catch(N){if(N.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(N)}. Deleted from extracted location`,Y),N}this.h.fire(B)}catch(N){try{await this.m.del(Y,{recursive:!0})}catch{}throw N}return this.D(B,1)}async scanMetadata(z,H){return H?(await this.w(z,H))?.metadata:this.n.scanMetadata(z.location)}async w(z,H){return(await this.s.scanProfileExtensions(H)).find(U=>(0,s.$2o)(U.identifier,z.identifier))}async updateMetadata(z,H,R){return R?await this.s.updateMetadata([[z,H]],R):await this.n.updateMetadata(z.location,H),this.D(z.location,z.type,R)}getUninstalledExtensions(){return this.z()}async setUninstalled(...z){const H=z.map(R=>s.$3o.create(R));await this.z(R=>H.forEach(U=>{R[U.toString()]=!0,this.u.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(z){await this.z(H=>delete H[z.toString()])}async removeExtension(z,H){if(this.t.extUri.isEqualOrParent(z.location,this.n.userExtensionsLocation))return this.y(z.identifier.id,z.location,H)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.z(H=>delete H[s.$3o.create(z).toString()])}async copyExtension(z,H,R,U){const x=await this.w(z,H),J=await this.w(z,R);return U={...x?.metadata,...U},J?await this.s.updateMetadata([[z,{...J.metadata,...U}]],R):await this.s.addExtensionsToProfile([[z,U]],R),this.D(z.location,z.type,R)}async copyExtensions(z,H){const R=await this.scanExtensions(1,z),U=await Promise.all(R.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,z)]));await this.s.addExtensionsToProfile(U,H)}async y(z,H,R){this.u.trace(`Deleting ${R} extension from disk`,z,H.fsPath);const U=this.t.extUri.joinPath(this.t.extUri.dirname(H),`${this.t.extUri.basename(H)}.${(0,v.$Ui)((0,d.$rg)()).toString(16)}${X}`);await this.C(H.fsPath,U.fsPath),await this.m.del(U,{recursive:!0}),this.u.info(`Deleted ${R} extension from disk`,z,H.fsPath)}async z(z){return this.g.queue(async()=>{let H;try{H=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(U){if((0,_.$Ik)(U)!==1)throw U}let R={};if(H)try{R=JSON.parse(H)}catch{}return z&&(z(R),Object.keys(R).length?await this.m.writeFile(this.c,O.$ke.fromString(JSON.stringify(R))):await this.m.del(this.c)),R})}async C(z,H){try{await m.Promises.rename(z,H,2*60*1e3)}catch(R){throw new n.$Ao(R.message||u.localize(5,null,z,H),R.code||n.ExtensionManagementErrorCode.Rename)}}async D(z,H,R){if(R){const x=(await this.n.scanUserExtensions({profileLocation:R})).find(J=>this.t.extUri.isEqual(J.location,z));if(x)return this.F(x)}else{const U=await this.n.scanExistingExtension(z,H,{includeInvalid:!0});if(U)return this.F(U)}throw new Error(u.localize(6,null,z.path))}async F(z){const H=await this.m.resolve(z.location);let R,U;return H.children&&(R=H.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,U=H.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:R,changelogUrl:U,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!z.metadata?.hasPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated,pinned:!!z.metadata?.pinned}}async G(){const z=await this.getUninstalledExtensions();if(Object.keys(z).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(z));const H=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const x of H)z[s.$3o.create(x).toString()]||R.add(x.identifier.id.toLowerCase());try{const x=(0,s.$8o)(H,J=>J.identifier);await k.Promises.settled(x.map(async J=>{const Y=J.sort((B,T)=>$.rcompare(B.manifest.version,T.manifest.version))[0];R.has(Y.identifier.id.toLowerCase())||await this.j(await this.F(Y))}))}catch(x){this.u.error(x)}const U=H.filter(x=>x.metadata&&z[s.$3o.create(x).toString()]);await Promise.allSettled(U.map(x=>this.removeUninstalledExtension(x)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let z;try{z=await this.m.resolve(this.n.userExtensionsLocation)}catch(H){(0,_.$Ik)(H)!==1&&this.u.error(H);return}if(z?.children)try{await Promise.allSettled(z.children.map(async H=>{if(!(!H.isDirectory||!H.name.endsWith(X))){this.u.trace("Deleting the temporarily deleted folder",H.resource.toString());try{await this.m.del(H.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",H.resource.toString())}catch(R){(0,_.$Ik)(R)!==1&&this.u.error(R)}}}))}catch{}}};e.$aq=V,e.$aq=V=Ne([Oe(1,_.$rk),Oe(2,a.$1p),Oe(3,i.$Wp),Oe(4,K.$2k),Oe(5,G.$oj)],V);class W extends o.$Up{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,c.$Qf)(this.options.operation)?this.l:this.options.operation}constructor(z,H,R,U,x,J,Y,B,T){super(),this.identifier=z,this.source=H,this.options=R,this.m=U,this.n=x,this.o=J,this.p=Y,this.q=B,this.s=T,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(z){const[H,R]=await this.x(z);return this.j=H.isBuiltin||H.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[H,R]],this.j),H}async u({zipPath:z,key:H,metadata:R},U,x){let J=await this.v(H);return J?J=await this.m.updateMetadata(J,R):(this.s.trace("Extracting extension...",H.id),J=await this.m.extractUserExtension(H,z,R,U,x),this.s.info("Extracting extension completed.",H.id)),J}async v(z){return await this.w(z)?(this.s.trace("Removing the extension from uninstalled list:",z.id),await this.m.setInstalled(z),this.s.info("Removed the extension from uninstalled list:",z.id),(await this.m.scanAllUserExtensions(!0)).find(U=>s.$3o.create(U).equals(z))):void 0}async w(z){return!!(await this.m.getUninstalledExtensions())[z.toString()]}}class re extends W{constructor(z,H,R,U,x,J,Y,B,T,N){super(H.identifier,H,R,x,J,Y,B,T,N),this.y=H,this.z=U}async x(z){let H;try{H=await this.m.scanExtensions(null,this.options.profileLocation)}catch(Y){throw new n.$Ao(Y,n.ExtensionManagementErrorCode.Scanning)}const R=H.find(Y=>(0,s.$2o)(Y.identifier,this.y.identifier));R&&(this.l=3);const U={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:R?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??R?.pinned,preRelease:(0,c.$Pf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||R?.preRelease};if(R?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(R,U),U]}catch(Y){throw new n.$Ao((0,D.$0)(Y),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:x,verificationStatus:J}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=J,this.B(x.fsPath),[await this.u({zipPath:x.fsPath,key:s.$3o.create(this.y),metadata:U},!1,z),U]}catch(Y){try{await this.z.delete(x)}catch(B){this.s.warn("Error while deleting the downloaded file",x.toString(),(0,D.$0)(B))}throw Y}}async B(z){try{await(0,P.$8p)(z)}catch(H){throw new n.$Ao((0,o.$Sp)(H).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$bq=re;class ue extends W{constructor(z,H,R,U,x,J,Y,B,T,N){super({id:(0,s.$7o)(z.publisher,z.name)},H,R,x,J,Y,B,T,N),this.y=z,this.z=H,this.A=U}async h(z){const H=await super.h(z);return this.D(H,z),H}async x(z){const H=new s.$3o(this.identifier,this.y.version),U=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Y=>(0,s.$2o)(this.identifier,Y.identifier)),x={isApplicationScoped:this.options.isApplicationScoped||U?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||U?.isMachineScoped,isBuiltin:this.options.isBuiltin||U?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??U?.pinned};if(U)if(this.l=3,H.equals(new s.$3o(U.identifier,U.manifest.version)))try{await this.m.removeExtension(U,"existing")}catch{throw new Error(u.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(U.manifest.version,this.y.version)&&await this.m.setUninstalled(U);else{const Y=await this.v(H);if(Y)try{await this.m.removeExtension(Y,"existing")}catch{throw new Error(u.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$kc(this.z.fsPath),key:H,metadata:x},!0,z),x]}async D(z,H){try{let[R]=await this.A.getExtensions([{id:z.identifier.id,version:z.manifest.version}],H);if(R||([R]=await this.A.getExtensions([{id:z.identifier.id}],H)),R){const U={id:R.identifier.uuid,publisherDisplayName:R.publisherDisplayName,publisherId:R.publisherId,isPreReleaseVersion:R.properties.isPreReleaseVersion,hasPreReleaseVersion:z.hasPreReleaseVersion||R.properties.isPreReleaseVersion,preRelease:R.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(z,U,this.options.profileLocation)}}catch{}}}class ne extends o.$Up{constructor(z,H,R){super(),this.extension=z,this.j=H,this.k=R}async h(z){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(be[126],ve([1,0,13,33,34,32,47,16,26,4]),function(he,e,k,O,r,I,D,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=void 0;let C=class extends D.$Xp{constructor(b,h,$,c,g,d){super(w.URI.file(b.extensionsPath),h,$,c,g,d)}};e.$GO=C,e.$GO=C=Ne([Oe(0,v.$ci),Oe(1,S.$rk),Oe(2,O.$4k),Oe(3,r.$2k),Oe(4,I.$vl),Oe(5,k.$oj)],C)}),define(be[263],ve([1,0,15,6,2,42,11,173,5,33]),function(he,e,k,O,r,I,D,S,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$vp=e.$up=e.$tp=void 0,e.$tp="__$__isNewStorageMarker",e.$up="__$__targetStorageMarker",e.$vp=(0,v.$7h)("storageService");var C;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var E;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var b;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function h(m){const f=m.get(e.$up);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.$wp=h;class $ extends r.$Tc{static{this.a=60*1e3}constructor(f={flushInterval:$.a}){super(),this.m=f,this.b=this.B(new O.$Zd),this.c=this.B(new O.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new k.$gh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new r.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(f,u,l){return O.Event.filter(this.b.event,t=>t.scope===f&&(u===void 0||t.key===u),l)}n(){this.j.value=(0,k.$kh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,r.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(f,u){const{key:l,external:t}=u;if(l===e.$up){switch(f){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:l,target:this.J(f)[l],external:t})}w(f){this.f.fire({reason:f})}get(f,u,l){return this.P(u)?.get(f,l)}getBoolean(f,u,l){return this.P(u)?.getBoolean(f,l)}getNumber(f,u,l){return this.P(u)?.getNumber(f,l)}getObject(f,u,l){return this.P(u)?.getObject(f,l)}storeAll(f,u){this.y(()=>{for(const l of f)this.store(l.key,l.value,l.scope,l.target,u)})}store(f,u,l,t,o=!1){if((0,D.$Sf)(u)){this.remove(f,l,o);return}this.y(()=>{this.z(f,l,t),this.P(l)?.set(f,u,o)})}remove(f,u,l=!1){this.y(()=>{this.z(f,u,void 0),this.P(u)?.delete(f,l)})}y(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,u){const l=[],t=this.J(f);for(const o of Object.keys(t))t[o]===u&&l.push(o);return l}z(f,u,l,t=!1){const o=this.J(u);typeof l=="number"?o[f]!==l&&(o[f]=l,this.P(u)?.set(e.$up,JSON.stringify(o),t)):typeof o[f]=="number"&&(delete o[f],this.P(u)?.set(e.$up,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(f){switch(f){case-1:return this.I;case 0:return this.G;default:return this.D}}L(f){const u=this.P(f);return u?h(u):Object.create(null)}isNew(f){return this.getBoolean(e.$tp,f)===!0}async flush(f=C.NONE){this.f.fire({reason:f});const u=this.P(-1),l=this.P(0),t=this.P(1);switch(f){case C.NONE:await k.Promises.settled([u?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await k.Promises.settled([u?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return d(f,u,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(f){return await this.flush(),this.P(f)?.optimize()}async switch(f,u){return this.w(C.NONE),(0,w.$3k)(f)?this.R(f,u):this.S(f,u)}M(f,u){return!(f.id===u.id||c(u)&&c(f))}N(f,u,l){this.y(()=>{const t=new Set;for(const[o,n]of f)t.add(o),u.get(o)!==n&&this.u(l,{key:o,external:!0});for(const[o]of u.items)t.has(o)||this.u(l,{key:o,external:!0})})}}e.$xp=$;function c(m){return m.isDefault||!!m.useDefaultFlags?.globalState}e.$yp=c;class g extends ${constructor(){super(),this.U=this.B(new S.$rp(new S.$sp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$rp(new S.$sp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$rp(new S.$sp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(f=>this.u(1,f))),this.B(this.W.onDidChangeStorage(f=>this.u(0,f))),this.B(this.U.onDidChangeStorage(f=>this.u(-1,f)))}P(f){switch(f){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(f){return!1}}e.$zp=g;async function d(m,f,u,l,t,o){const n=M=>{try{return JSON.parse(M)}catch{return M}},s=new Map,i=new Map;m.forEach((M,_)=>{s.set(_,M),i.set(_,n(M))});const a=new Map,p=new Map;f.forEach((M,_)=>{a.set(_,M),p.set(_,n(M))});const L=new Map,P=new Map;u.forEach((M,_)=>{L.set(_,M),P.set(_,n(M))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const y=[];if(s.forEach((M,_)=>{y.push({key:_,value:M})}),console.table(y),console.groupEnd(),console.log(i),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];a.forEach((_,se)=>{M.push({key:se,value:_})}),console.table(M),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${o})`);const A=[];L.forEach((M,_)=>{A.push({key:_,value:M})}),console.table(A),console.groupEnd(),console.log(P)}e.$Ap=d}),define(be[127],ve([1,0,18,20,10,3,29,11,4,25,26,30,36,82,16,13,31,46,247,263,32,61]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.$Dp=void 0;const t=I.$o?"web":(0,E.$vo)(I.$u,D.$ec),o="X-Market-Search-Activity-Id";var n;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...U){return String(U.reduce((x,J)=>x|J,0))}var i;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},p={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class y{constructor(x=P){this.d=x}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(x,J=this.d.pageSize){return new y({...this.d,pageNumber:x,pageSize:J})}withFilter(x,...J){const Y=[...this.d.criteria,...J.length?J.map(B=>({filterType:x,value:B})):[{filterType:x}]];return new y({...this.d,criteria:Y})}withSortBy(x){return new y({...this.d,sortBy:x})}withSortOrder(x){return new y({...this.d,sortOrder:x})}withFlags(...x){return new y({...this.d,flags:x.reduce((J,Y)=>J|Y,0)})}withAssetTypes(...x){return new y({...this.d,assetTypes:x})}withSource(x){return new y({...this.d,source:x})}get raw(){const{criteria:x,pageNumber:J,pageSize:Y,sortBy:B,sortOrder:T,flags:N,assetTypes:q}=this.d;return{filters:[{criteria:x,pageNumber:J,pageSize:Y,sortBy:B,sortOrder:T}],assetTypes:q,flags:N}}get searchText(){const x=this.d.criteria.filter(J=>J.filterType===i.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(x=>String(x.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function A(U,x){const J=(U||[]).filter(Y=>Y.statisticName===x)[0];return J?J.value:0}function M(U){const x="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(Y=>Y.assetType.indexOf(x)===0).reduce((Y,B)=>{const T=G(U,B.assetType);return T&&Y.push([B.assetType.substring(x.length),T]),Y},[])}function _(U){if(U.properties){const x=U.properties.filter(B=>B.key===a.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Y=x.filter(B=>J.test(B.value))[0];return Y?{uri:Y.value,fallbackUri:Y.value}:null}return G(U,a.Repository)}function se(U){return{uri:`${U.fallbackAssetUri}/${a.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${a.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function G(U,x){return U.files.filter(Y=>Y.assetType===x)[0]?{uri:`${U.assetUri}/${x}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${x}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function oe(U,x){const J=U.properties?U.properties.filter(B=>B.key===x):[],Y=J.length>0&&J[0].value;return Y?Y.split(",").map(B=>(0,b.$6o)(B)):[]}function ee(U){const x=U.properties?U.properties.filter(J=>J.key===p.Engine):[];return x.length>0&&x[0].value||""}function K(U){const x=U.properties?U.properties.filter(J=>J.key===p.PreRelease):[];return x.length>0&&x[0].value==="true"}function Z(U){const x=U.properties?U.properties.filter(Y=>Y.key===p.LocalizedLanguages):[],J=x.length>0&&x[0].value||"";return J?J.split(","):[]}function X(U){return U.properties?.find(x=>x.key===p.SponsorLink)?.value}function te(U){return U.properties?.find(x=>x.key===p.SupportLink)?.value}function V(U){return U.indexOf("preview")!==-1}function W(U){return U.targetPlatform?(0,E.$uo)(U.targetPlatform):"undefined"}function re(U){const x=(0,k.$Mb)(U.versions.map(W)),J=!!U.tags?.includes(E.$po),Y=x.indexOf("web");return J?Y===-1&&x.push("web"):Y!==-1&&x.splice(Y,1),x}function ue(U,x){for(let J=0;J<U.length;J++){const Y=U[J];if(Y.version===U[J-1]?.version){let B=J;if(W(Y)===x)for(;B>0&&U[B-1].version===Y.version;)B--;B!==J&&(U.splice(J,1),U.splice(B,0,Y))}}return U}e.$Dp=ue;function ne(U,x,J){U.telemetryData={index:x,querySource:J,queryActivityId:U.queryContext?.[o]}}function me(U,x,J,Y){const B=U.versions[0],T={manifest:G(x,a.Manifest),readme:G(x,a.Details),changelog:G(x,a.Changelog),license:G(x,a.License),repository:_(x),download:se(x),icon:G(x,a.Icon),signature:G(x,a.Signature),coreTranslations:M(x)};return{identifier:{id:(0,b.$7o)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:x.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:X(B),description:U.shortDescription||"",installCount:A(U.statistics,"install"),rating:A(U.statistics,"averagerating"),ratingCount:A(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:J,assets:T,properties:{dependencies:oe(x,p.Dependency),extensionPack:oe(x,p.ExtensionPack),engine:ee(x),localizedLanguages:Z(x),targetPlatform:W(x),isPreReleaseVersion:K(x)},hasPreReleaseVersion:K(B),hasReleaseVersion:!0,preview:V(U.flags),isSigned:!!T.signature,queryContext:Y,supportLink:te(B)}}let z=class{constructor(x,J,Y,B,T,N,q,ie){this.k=J,this.l=Y,this.n=B,this.o=T,this.q=N,this.u=q,this.w=ie;const ae=q.extensionsGallery,ge=ae?.servicePPEUrl&&ie.getValue("_extensionsGallery.enablePPE");this.d=ge?ae.servicePPEUrl:ae?.serviceUrl,this.g=ge?void 0:ae?.searchUrl,this.h=ae?.controlUrl,this.j=(0,m.$Cp)(q.version,q,this.n,this.w,this.q,x,this.o)}x(x=""){return`${this.d}${x}`}isEnabled(){return!!this.d}async getExtensions(x,J,Y){const B=O.CancellationToken.isCancellationToken(J)?{}:J,T=O.CancellationToken.isCancellationToken(J)?J:Y,N=[],q=[],ie=[],ae=[];let ge=!0;for(const ye of x){ye.uuid?q.push(ye.uuid):N.push(ye.id);const Ce=!!(ye.version||ye.preRelease);ie.push({id:ye.id,uuid:ye.uuid,includePreRelease:Ce}),ye.version&&ae.push({id:ye.id,uuid:ye.uuid,version:ye.version}),ge=ge&&!!ye.hasPreRelease&&!Ce}if(!q.length&&!N.length)return[];let ce=new y().withPage(1,x.length);q.length&&(ce=ce.withFilter(i.ExtensionId,...q)),N.length&&(ce=ce.withFilter(i.ExtensionName,...N)),(B.queryAllVersions||ge)&&(ce=ce.withFlags(ce.flags,n.IncludeVersions)),B.source&&(ce=ce.withSource(B.source));const{extensions:pe}=await this.z(ce,{targetPlatform:B.targetPlatform??t,includePreRelease:ie,versions:ae,compatible:!!B.compatible},T);return B.source&&pe.forEach((ye,Ce)=>ne(ye,Ce,B.source)),pe}async getCompatibleExtension(x,J,Y){if((0,E.$wo)(x.allTargetPlatforms,Y))return null;if(await this.isExtensionCompatible(x,J,Y))return x;const B=new y().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,x.identifier.uuid),{extensions:T}=await this.z(B,{targetPlatform:Y,compatible:!0,includePreRelease:J},O.CancellationToken.None);return T[0]||null}async isExtensionCompatible(x,J,Y){if(!(0,E.$xo)(x.properties.targetPlatform,x.allTargetPlatforms,Y)||!J&&x.properties.isPreReleaseVersion)return!1;let B=x.properties.engine;if(!B){const T=await this.getManifest(x,O.CancellationToken.None);if(!T)throw new Error("Manifest was not found");B=T.engines.vscode}return(0,h.$hp)(B,this.u.version,this.u.date)}async y(x,J,Y,B,T){if(!(0,E.$xo)(W(x),B,T)||J!=="any"&&K(x)!==(J==="prerelease"))return!1;if(Y)try{const N=await this.E(x);if(!(0,h.$hp)(N,this.u.version,this.u.date))return!1}catch(N){return this.l.error(`Error while getting the engine for the version ${x.version}.`,(0,r.$0)(N)),!1}return!0}async query(x,J){let Y=x.text||"";const B=x.pageSize??50;let T=new y().withPage(1,B);Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,ce,pe)=>(T=T.withFilter(i.Category,pe||ce),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,ce,pe)=>(T=T.withFilter(i.Tag,pe||ce),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(T=T.withFilter(i.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),T=T.withFilter(i.SearchText,Y)),T=T.withSortBy(0)):x.ids?T=T.withFilter(i.ExtensionId,...x.ids):x.names?T=T.withFilter(i.ExtensionName,...x.names):T=T.withSortBy(4),typeof x.sortBy=="number"&&(T=T.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(T=T.withSortOrder(x.sortOrder)),x.source&&(T=T.withSource(x.source));const N=async(ge,ce)=>{const{extensions:pe,total:ye}=await this.z(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!x.includePreRelease},ce);return pe.forEach((Ce,Re)=>ne(Ce,(ge.pageNumber-1)*ge.pageSize+Re,x.source)),{extensions:pe,total:ye}},{extensions:q,total:ie}=await N(T,J),ae=async(ge,ce)=>{if(ce.isCancellationRequested)throw new r.$5;const{extensions:pe}=await N(T.withPage(ge+1),ce);return pe};return{firstPage:q,total:ie,pageSize:T.pageSize,getPage:ae}}async z(x,J,Y){const B=x.flags;x.flags&n.IncludeLatestVersionOnly&&x.flags&n.IncludeVersions&&(x=x.withFlags(x.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(x.flags&n.IncludeLatestVersionOnly)&&!(x.flags&n.IncludeVersions)&&(x=x.withFlags(x.flags,n.IncludeLatestVersionOnly)),J.versions?.length&&(x=x.withFlags(x.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),x=x.withFlags(x.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:T,total:N,context:q}=await this.B(x,Y);if(!(x.flags&n.IncludeLatestVersionOnly)){const ce=[];for(const pe of T){const ye=await this.A(pe,J,q);ye&&ce.push(ye)}return{extensions:ce,total:N}}const ae=[],ge=new Map;for(let ce=0;ce<T.length;ce++){const pe=T[ce],ye={id:(0,b.$7o)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ce=(0,S.$Pf)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find($e=>(0,b.$2o)($e,ye))?.includePreRelease;if(J.compatible&&(0,E.$wo)(re(pe),J.targetPlatform))continue;const Re=await this.A(pe,J,q);!Re||Re.properties.isPreReleaseVersion&&(!Ce||!Re.hasReleaseVersion)||!Re.properties.isPreReleaseVersion&&Re.properties.targetPlatform!==J.targetPlatform&&Re.hasPreReleaseVersion?ge.set(pe.extensionId,ce):ae.push([ce,Re])}if(ge.size){const ce=new l.$Sd,pe=new y().withFlags(B&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ge.size).withFilter(i.ExtensionId,...ge.keys()),{extensions:ye}=await this.z(pe,J,Y);this.o.publicLog2("galleryService:additionalQuery",{duration:ce.elapsed(),count:ge.size});for(const Ce of ye){const Re=ge.get(Ce.identifier.uuid);ae.push([Re,Ce])}}return{extensions:ae.sort((ce,pe)=>ce[0]-pe[0]).map(([,ce])=>ce),total:N}}async A(x,J,Y){const B={id:(0,b.$7o)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},T=J.versions?.find(ae=>(0,b.$2o)(ae,B))?.version,N=(0,S.$Pf)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find(ae=>(0,b.$2o)(ae,B))?.includePreRelease,q=re(x),ie=ue(x.versions,J.targetPlatform);if(J.compatible&&(0,E.$wo)(q,J.targetPlatform))return null;for(let ae=0;ae<ie.length;ae++){const ge=ie[ae];if(!(T&&ge.version!==T)){if(await this.y(ge,N?"any":"release",J.compatible,q,J.targetPlatform))return me(x,ge,q,Y);if(T&&ge.version===T)return null}}return T||J.compatible?null:me(x,x.versions[0],q)}async B(x,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const Y=await this.j,B=JSON.stringify(x.raw),T={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},N=new l.$Sd;let q,ie,ae=0;try{if(q=await this.k.request({type:"POST",url:this.g&&x.criteria.some(ce=>ce.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:B,headers:T},J),q.res.statusCode&&q.res.statusCode>=400&&q.res.statusCode<500)return{galleryExtensions:[],total:ae};const ge=await(0,d.$op)(q);if(ge){const ce=ge.results[0],pe=ce.extensions,ye=ce.resultMetadata&&ce.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ae=ye&&ye.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:ae,context:{[o]:q.res.headers.activityid}}}return{galleryExtensions:[],total:ae}}catch(ge){const ce=(0,r.$4)(ge)?E.ExtensionGalleryErrorCode.Cancelled:(0,r.$0)(ge).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw ie=new E.$Bo((0,r.$0)(ge),ce),ie}finally{this.o.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(B.length),duration:N.elapsed(),success:!!q&&(0,d.$kp)(q),responseBodySize:q?.res.headers["Content-Length"],statusCode:q?String(q.res.statusCode):void 0,errorCode:ie?.code,count:String(ae)})}}async reportStatistic(x,J,Y,B){if(!this.isEnabled())return;const T=I.$o?this.x(`/itemName/${x}.${J}/version/${Y}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${x}/extensions/${J}/${Y}/stats?statType=${B}`),N=I.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ie={...await this.j,Accept:N};try{await this.k.request({type:"POST",url:T,headers:ie},O.CancellationToken.None)}catch{}}async download(x,J,Y){this.l.trace("ExtensionGalleryService#download",x.identifier.id);const B=(0,b.$0o)(x),T=new Date().getTime(),N=ce=>this.o.publicLog("galleryService:downloadVSIX",{...B,duration:ce}),q=Y===2?"install":Y===3?"update":"",ie=q?{uri:`${x.assets.download.uri}${v.URI.parse(x.assets.download.uri).query?"&":"?"}${q}=true`,fallbackUri:`${x.assets.download.fallbackUri}${v.URI.parse(x.assets.download.fallbackUri).query?"&":"?"}${q}=true`}:x.assets.download,ae=x.queryContext?.[o]?{[o]:x.queryContext[o]}:void 0,ge=await this.D(ie,ae?{headers:ae}:void 0);await this.q.writeFile(J,ge.stream),N(new Date().getTime()-T)}async downloadSignatureArchive(x,J){if(!x.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",x.identifier.id);const Y=await this.D(x.assets.signature);await this.q.writeFile(J,Y.stream)}async getReadme(x,J){if(x.assets.readme){const Y=await this.D(x.assets.readme,{},J);return await(0,d.$np)(Y)||""}return""}async getManifest(x,J){if(x.assets.manifest){const Y=await this.D(x.assets.manifest,{},J),B=await(0,d.$np)(Y);return B?JSON.parse(B):null}return null}async C(x,J){const Y=G(x,a.Manifest);if(!Y)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},T=await this.D(Y,{headers:B});return await(0,d.$op)(T)}async getCoreTranslation(x,J){const Y=x.assets.coreTranslations.filter(B=>B[0]===J.toUpperCase())[0];if(Y){const B=await this.D(Y[1]),T=await(0,d.$np)(B);return T?JSON.parse(T):null}return null}async getChangelog(x,J){if(x.assets.changelog){const Y=await this.D(x.assets.changelog,{},J);return await(0,d.$np)(Y)||""}return""}async getAllCompatibleVersions(x,J,Y){let B=new y().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);x.identifier.uuid?B=B.withFilter(i.ExtensionId,x.identifier.uuid):B=B.withFilter(i.ExtensionName,x.identifier.id);const{galleryExtensions:T}=await this.B(B,O.CancellationToken.None);if(!T.length)return[];const N=re(T[0]);if((0,E.$wo)(N,Y))return[];const q=[];await Promise.all(T[0].versions.map(async ge=>{try{await this.y(ge,J?"any":"release",!0,N,Y)&&q.push(ge)}catch{}}));const ie=[],ae=new Set;for(const ge of ue(q,Y))ae.has(ge.version)||(ae.add(ge.version),ie.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:K(ge)}));return ie}async D(x,J={},Y=O.CancellationToken.None){const B=await this.j,T={type:"GET"},N={...B,...J.headers||{}};J={...J,...T,headers:N};const q=x.uri,ie=x.fallbackUri,ae={...J,url:q};try{const ge=await this.k.request(ae,Y);if(ge.res.statusCode===200)return ge;const ce=await(0,d.$np)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${ce}`)}catch(ge){if((0,r.$4)(ge))throw ge;const ce=(0,r.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:q,message:ce});const pe={...J,url:ie};return this.k.request(pe,Y)}}async E(x){let J=ee(x);if(!J){const Y=await this.C(x,O.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");J=Y.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const x=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,d.$op)(x),Y=[],B={},T=[];if(J){for(const N of J.malicious)Y.push({id:N});if(J.migrateToPreRelease)for(const[N,q]of Object.entries(J.migrateToPreRelease))(!q.engine||(0,h.$hp)(q.engine,this.u.version,this.u.date))&&(B[N.toLowerCase()]={disallowInstall:!0,extension:{id:q.id,displayName:q.displayName,autoMigrate:{storage:!!q.migrateStorage},preRelease:!0}});if(J.deprecated)for(const[N,q]of Object.entries(J.deprecated))q&&(B[N.toLowerCase()]=(0,S.$Pf)(q)?{}:q);if(J.search)for(const N of J.search)T.push(N)}return{malicious:Y,deprecated:B,search:T}}};z=Ne([Oe(1,d.$ip),Oe(2,c.$oj),Oe(3,C.$bi),Oe(4,u.$vl),Oe(5,$.$rk),Oe(6,g.$Gj),Oe(7,w.$Ai)],z);let H=class extends z{constructor(x,J,Y,B,T,N,q,ie){super(x,J,Y,B,T,N,q,ie)}};e.$Ep=H,e.$Ep=H=Ne([Oe(0,f.$vp),Oe(1,d.$ip),Oe(2,c.$oj),Oe(3,C.$bi),Oe(4,u.$vl),Oe(5,$.$rk),Oe(6,g.$Gj),Oe(7,w.$Ai)],H);let R=class extends z{constructor(x,J,Y,B,T,N,q){super(void 0,x,J,Y,B,T,N,q)}};e.$Fp=R,e.$Fp=R=Ne([Oe(0,d.$ip),Oe(1,c.$oj),Oe(2,C.$bi),Oe(3,u.$vl),Oe(4,$.$rk),Oe(5,g.$Gj),Oe(6,w.$Ai)],R)}),define(be[264],ve([1,0,6,2,33,53]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=e.$NO=void 0;class D{constructor(w,C){this.a=w,this.b=C}listen(w,C){const E=this.b(w);switch(C){case"onDidChangeProfiles":return k.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(h=>(0,I.$7m)({...h},E)),added:b.added.map(h=>(0,I.$7m)({...h},E)),removed:b.removed.map(h=>(0,I.$7m)({...h},E)),updated:b.updated.map(h=>(0,I.$7m)({...h},E))}))}throw new Error(`Invalid listen ${C}`)}async call(w,C,E){const b=this.b(w);switch(C){case"createProfile":{const h=await this.a.createProfile(E[0],E[1],E[2]);return(0,I.$7m)({...h},b)}case"updateProfile":{let h=(0,r.$5k)((0,I.$8m)(E[0],b),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,E[1]),(0,I.$7m)({...h},b)}case"removeProfile":{const h=(0,r.$5k)((0,I.$8m)(E[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${C}`)}}e.$NO=D;class S extends O.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,C,E){super(),this.profilesHome=C,this.f=E,this.a=[],this.b=this.B(new k.$Wd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(b=>(0,r.$5k)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const h=b.added.map(g=>(0,r.$5k)(g,this.profilesHome.scheme)),$=b.removed.map(g=>(0,r.$5k)(g,this.profilesHome.scheme)),c=b.updated.map(g=>(0,r.$5k)(g,this.profilesHome.scheme));this.a=b.all.map(g=>(0,r.$5k)(g,this.profilesHome.scheme)),this.b.fire({added:h,removed:$,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,C,E){const b=await this.f.call("createNamedProfile",[w,C,E]);return(0,r.$5k)(b,this.profilesHome.scheme)}async createProfile(w,C,E,b){const h=await this.f.call("createProfile",[w,C,E,b]);return(0,r.$5k)(h,this.profilesHome.scheme)}async createTransientProfile(w){const C=await this.f.call("createTransientProfile",[w]);return(0,r.$5k)(C,this.profilesHome.scheme)}async setProfileForWorkspace(w,C){await this.f.call("setProfileForWorkspace",[w,C])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,C){const E=await this.f.call("updateProfile",[w,C]);return(0,r.$5k)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$OO=S}),define(be[128],ve([1,0,4,26,16,13,240,34,33,11,241]),function(he,e,k,O,r,I,D,S,v,w,C){"use strict";var E,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=e.$DO=void 0;let h=class extends v.$7k{static{E=this}static{this.a="profileAssociationsMigration"}constructor(d,m,f,u,l){super(f,u,m,l),this.U=d,this.W=f}O(){return this.U.getItem(E.b,[]).map(m=>({...m,location:(0,w.$Jf)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):k.URI.revive(m.location)}))}Q(){const d=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(k.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$DO=h,e.$DO=h=E=Ne([Oe(0,D.$yO),Oe(1,S.$2k),Oe(2,O.$ci),Oe(3,r.$rk),Oe(4,I.$oj)],h);let $=b=class extends h{constructor(d,m,f,u,l){super(d,m,f,u,l),this.$=d}P(d){d.length?this.$.setItem(b.b,d.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(b.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(b.c,d):this.$.removeItem(b.c)}Q(){const d="workspaceAndProfileInfo",m=this.$.getItem(d,void 0);if(m){this.$.removeItem(d);const u=m.reduce((l,{workspace:t,profile:o})=>(l[k.URI.revive(t).toString()]=k.URI.revive(o).toString(),l),{});this.$.setItem(b.c,{workspaces:u})}const f=super.Q();return this.$.getItem(b.a,!1)||(this.R(f),this.$.setItem(b.a,!0)),f}};e.$EO=$,e.$EO=$=b=Ne([Oe(0,D.$zO),Oe(1,S.$2k),Oe(2,O.$ci),Oe(3,r.$rk),Oe(4,I.$oj)],$);let c=class extends ${constructor(d,m,f,u){super(new C.$CO(0,m,u,f),d,m,f,u)}async init(){return await this.$.init(),super.init()}};e.$FO=c,e.$FO=c=Ne([Oe(0,S.$2k),Oe(1,O.$ci),Oe(2,r.$rk),Oe(3,I.$oj)],c)}),define(be[129],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=(0,k.$7h)("extensionHostStatusService");class O{constructor(){this.a=new Map}setExitInfo(I,D){this.a.set(I,D)}getExitInfo(I){return this.a.get(I)||null}}e.$Pm=O}),define(be[265],ve([1,0,6,15]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=void 0;function r(D){let S=0,v=0,w=0;D>=1e3&&(w=Math.floor(D/1e3),D-=w*1e3),w>=60&&(v=Math.floor(w/60),w-=v*60),v>=60&&(S=Math.floor(v/60),v-=S*60);const C=S?`${S}h`:"",E=v?`${v}m`:"",b=w?`${w}s`:"",h=D?`${D}ms`:"";return`${C}${E}${b}${h}`}class I{constructor(S,v,w,C){this.i=S,this.j=v,this.a=new k.$Wd,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=w,this.protocol=C,this.e=!1,this.f=new O.$hh(()=>{this.k(`The reconnection grace time of ${r(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new O.$hh(()=>{this.k(`The reconnection short grace time of ${r(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${r(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(S){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${S}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${r(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const S=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),S.end(),this.a.fire(void 0)}acceptReconnection(S,v,w){this.d=S,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,w),this.protocol.endAcceptReconnection()}}e.$Xm=I}),define(be[130],ve([1,0,27,12,7,155,57]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.$Gl=void 0;const S=r.$jc(O.$pg.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function w(b){return new Promise(h=>k.exists(b,h))}function C(b,h){return w(S).then($=>{if(!$||!D.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const c=`${b}||${h}`;let g=v.get(c);return g||(g=I.getNLSConfiguration(D.default.commit,h,S,b,b).then(d=>(E.is(d)&&(d._languagePackSupport=!0),d)),v.set(c,g)),g})}e.$Gl=C;var E;(function(b){function h($){const c=$;return c&&typeof c._languagePackId=="string"}b.is=h})(E||(e.InternalNLSConfiguration=E={}))}),define(be[131],ve([1,0,19,4,26,47,59,16,5,13,31,34,33,130]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=void 0;let $=class extends D.$2p{constructor(g,d,m,f,u,l,t,o){super(O.URI.file(u.builtinExtensionsPath),O.URI.file(u.extensionsPath),(0,k.$Ig)(u.userHome,".vscode-oss-dev","extensions","control.json"),g.defaultProfile,g,d,m,f,u,l,t,o),this.R=u}async f(g){const d=await(0,h.$Gl)(g,this.R.userDataPath);if(h.InternalNLSConfiguration.is(d))try{const m=await this.w.readFile(O.URI.file(d._translationsConfigFile));return JSON.parse(m.value.toString())}catch{}return Object.create(null)}};e.$tO=$,e.$tO=$=Ne([Oe(0,b.$4k),Oe(1,I.$Wp),Oe(2,S.$rk),Oe(3,w.$oj),Oe(4,r.$ci),Oe(5,C.$Gj),Oe(6,E.$2k),Oe(7,v.$6h)],$)}),define(be[266],ve([1,0,267,27,7,22,12,23]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z_-]+$/;var w;(function(g){g[g.None=0]="None",g[g.Optional=1]="Optional",g[g.Mandatory=2]="Mandatory"})(w||(e.ServerConnectionTokenType=w={}));class C{constructor(){this.type=0}validate(d){return!0}}e.$Ym=C;class E{constructor(d){this.value=d,this.type=2}validate(d){return d===this.value}}e.$Zm=E;class b{constructor(d){this.message=d}}e.$1m=b;async function h(g,d){const m=g["without-connection-token"],f=g["connection-token"],u=g["connection-token-file"];if(m)return typeof f<"u"||typeof u<"u"?new b("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new C;if(typeof u<"u"){if(typeof f<"u")return new b("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=O.readFileSync(u).toString().replace(/\r?\n$/,"")}catch{return new b(`Unable to read the connection token file at '${u}'.`)}return v.test(l)?new E(l):new b(`The connection token defined in '${u} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof f<"u"?v.test(f)?new E(f):new b(`The connection token '${f} does not adhere to the characters 0-9, a-z, A-Z or -.`):new E(await d())}e.$2m=h;async function $(g){return h(g,async()=>{if(!g["user-data-dir"])return(0,I.$rg)();const m=r.$jc(g["user-data-dir"],"token");try{const l=(await S.Promises.readFile(m)).toString().replace(/\r?\n$/,"");if(v.test(l))return l}catch{}const f=(0,I.$rg)();try{await S.Promises.writeFile(m,f,{mode:384})}catch{}return f})}e.$3m=$;function c(g,d,m){if(g.validate(m.query[D.$ig]))return!0;const f=k.parse(d.headers.cookie||"");return g.validate(f[D.$hg])}e.$4m=c}),define(be[48],ve([1,0,204,108,67,5,26,75]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Fm={host:{type:"string",cat:"o",args:"ip-address",description:k.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:k.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:k.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:k.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:k.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:k.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:k.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:k.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:k.localize(8,null)},"user-data-dir":r.$Yl["user-data-dir"],"enable-smoke-test-driver":r.$Yl["enable-smoke-test-driver"],"disable-telemetry":r.$Yl["disable-telemetry"],"disable-workspace-trust":r.$Yl["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:r.$Yl.log,logsPath:r.$Yl.logsPath,"force-disable-user-env":r.$Yl["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:k.localize(9,null)},"default-workspace":{type:"string",description:k.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":r.$Yl["extensions-dir"],"extensions-download-dir":r.$Yl["extensions-download-dir"],"builtin-extensions-dir":r.$Yl["builtin-extensions-dir"],"install-extension":r.$Yl["install-extension"],"install-builtin-extension":r.$Yl["install-builtin-extension"],"update-extensions":r.$Yl["update-extensions"],"uninstall-extension":r.$Yl["uninstall-extension"],"list-extensions":r.$Yl["list-extensions"],"locate-extension":r.$Yl["locate-extension"],"show-versions":r.$Yl["show-versions"],category:r.$Yl.category,force:r.$Yl.force,"do-not-sync":r.$Yl["do-not-sync"],"pre-release":r.$Yl["pre-release"],"start-server":{type:"boolean",cat:"e",description:k.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:r.$Yl.help,version:r.$Yl.version,"locate-shell-integration-path":r.$Yl["locate-shell-integration-path"],compatibility:{type:"string"},_:r.$Yl._},e.$Gm=(0,I.$8h)(D.$bi);class v extends O.$Cm{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$Hm=v,Ne([S.$yh],v.prototype,"userRoamingDataHome",null)}),define(be[268],ve([1,0,27,23,77,87,267,89,40,65,3,13,48,7,12,22,31,46,20,4,14,11,58]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=e.CacheControl=e.$SO=void 0;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(L,P,y,A){P.writeHead(y,{"Content-Type":"text/plain"}),P.end(A)}e.$SO=n;var s;(function(L){L[L.NO_CACHING=0]="NO_CACHING",L[L.ETAG=1]="ETAG",L[L.NO_EXPIRY=2]="NO_EXPIRY"})(s||(e.CacheControl=s={}));async function i(L,P,y,A,M,_){try{const se=await O.Promises.stat(L);if(P===1){const G=`W/"${[se.ino,se.size,se.mtime.getTime()].join("-")}"`;if(A.headers["if-none-match"]===G)return M.writeHead(304),void M.end();_.Etag=G}else P===2?_["Cache-Control"]="public, max-age=31536000":P===0&&(_["Cache-Control"]="no-store");_["Content-Type"]=o[(0,h.$oc)(L)]||(0,w.$is)(L)||"text/plain",M.writeHead(200,_),(0,k.createReadStream)(L).pipe(M)}catch(se){return se.code!=="ENOENT"?(y.error(se),console.error(se.toString())):console.error(`File not found: ${L}`),M.writeHead(404,{"Content-Type":"text/plain"}),void M.end("Not found")}}e.$TO=i;const a=(0,h.$mc)($.$pg.asFileUri("").fsPath);let p=class{constructor(P,y,A,M,_){this.f=P,this.g=y,this.h=A,this.i=M,this.j=_,this.a=this.j.extensionsGallery?.resourceUrlTemplate?f.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const se=(0,t.$dl)(_);this.b=`${se}/static`,this.c=`${se}/callback`,this.d=`${se}/web-extension-resource`}async handle(P,y,A){try{const M=A.pathname;return M.startsWith(this.b)&&M.charCodeAt(this.b.length)===47?this.k(P,y,A):M==="/"?this.n(P,y,A):M===this.c?this.p(y):M.startsWith(this.d)&&M.charCodeAt(this.d.length)===47?this.m(P,y,A):n(P,y,404,"Not found.")}catch(M){return this.h.error(M),console.error(M.toString()),n(P,y,500,"Internal Server Error.")}}async k(P,y,A){const M=Object.create(null),se=decodeURIComponent(A.pathname).substring(this.b.length+1),G=(0,h.$jc)(a,se);return(0,v.$9f)(G,a,!C.$k)?i(G,this.g.isBuilt?2:1,this.h,P,y,M):n(P,y,400,"Bad request.")}l(P){const y=P.authority.indexOf(".");return y!==-1?P.authority.substring(y+1):void 0}async m(P,y,A){if(!this.a)return n(P,y,500,"No extension gallery service configured.");const M=decodeURIComponent(A.pathname),_=(0,h.$hc)(M.substring(this.d.length+1)),se=f.URI.parse(_).with({scheme:this.a.scheme,authority:_.substring(0,_.indexOf("/")),path:_.substring(_.indexOf("/")+1)});if(this.l(this.a)!==this.l(se))return n(P,y,403,"Request Forbidden");const G={},oe=V=>{const W=P.headers[V];W&&((0,l.$Jf)(W)||W[0])?G[V]=(0,l.$Jf)(W)?W:W[0]:V!==V.toLowerCase()&&oe(V.toLowerCase())};oe("X-Client-Name"),oe("X-Client-Version"),oe("X-Machine-Id"),oe("X-Client-Commit");const ee=await this.i.request({type:"GET",url:se.toString(!0),headers:G},m.CancellationToken.None),K=ee.res.statusCode||500;if(K!==200){let V=null;try{V=await(0,d.$np)(ee)}catch{}return n(P,y,K,V||`Request failed with status ${K}`)}const Z=Object.create(null),X=V=>{const W=ee.res.headers[V];W?Z[V]=W:V!==V.toLowerCase()&&X(V.toLowerCase())};X("Cache-Control"),X("Content-Type"),y.writeHead(200,Z);const te=await(0,u.$we)(ee.stream);return void y.end(te.buffer)}async n(P,y,A){const M=A.query[$.$ig];if(typeof M=="string"){const H=Object.create(null);H["Set-Cookie"]=D.serialize($.$hg,M,{sameSite:"lax",maxAge:60*60*24*7});const R=Object.create(null);for(const x in A.query)x!==$.$ig&&(R[x]=A.query[x]);const U=I.format({pathname:"/",query:R});return H.Location=U,y.writeHead(302,H),void y.end()}const _=H=>{const R=P.headers[H];return Array.isArray(R)?R[0]:R},se=!this.g.isBuilt&&this.g.args["use-test-resolver"],G=se?"test+test":_("x-original-host")||_("x-forwarded-host")||P.headers.host;if(!G)return n(P,y,400,"Bad request.");function oe(H){return JSON.stringify(H).replace(/"/g,"&quot;")}let ee;this.g.args["enable-smoke-test-driver"]&&(ee=!1);const K=H=>H&&f.URI.file(r.resolve(H)).with({scheme:$.Schemas.vscodeRemote,authority:G}),Z=$.$pg.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,X=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,c.$rg)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,te={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:G,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.g.isBuilt)try{const H=JSON.parse((await O.Promises.readFile((0,h.$jc)(a,"product.overrides.json"))).toString());Object.assign(te,H)}catch{}const V={remoteAuthority:G,_wrapWebWorkerExtHostInIframe:ee,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:K(this.g.args["default-folder"]),workspaceUri:K(this.g.args["default-workspace"]),productConfiguration:te,callbackRoute:this.c},W=this.j.extensionsGallery?.nlsBaseUrl,re={WORKBENCH_WEB_CONFIGURATION:oe(V),WORKBENCH_AUTH_SESSION:X?oe(X):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:W?`${W}${W.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};if(se){const H=[];for(const R of["vscode-test-resolver","github-authentication"]){const U=JSON.parse((await O.Promises.readFile($.$pg.asFileUri(`${$.$kg}/${R}/package.json`).fsPath)).toString());H.push({extensionPath:R,packageJSON:U})}re.WORKBENCH_BUILTIN_EXTENSIONS=oe(H)}let ue;try{ue=(await O.Promises.readFile(Z)).toString().replace(/\{\{([^}]+)\}\}/g,(R,U)=>re[U]??"undefined")}catch{return y.writeHead(404,{"Content-Type":"text/plain"}),void y.end("Not found")}const ne="sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=",z={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(ue).join(" ")} '${ne}' ${se?"":`http://${G}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(z["Set-Cookie"]=D.serialize($.$hg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),y.writeHead(200,z),void y.end(ue)}o(P){const y=/<script>([\s\S]+?)<\/script>/img,A=[];let M;for(;M=y.exec(P);){const _=S.createHash("sha256"),se=M[1].replace(/\r\n/g,`
`),G=_.update(Buffer.from(se)).digest().toString("base64");A.push(`'sha256-${G}'`)}return A}async p(P){const y=$.$pg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,A=(await O.Promises.readFile(y)).toString(),M=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(A).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return P.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":M}),void P.end(A)}};e.$UO=p,e.$UO=p=Ne([Oe(1,b.$Gm),Oe(2,E.$oj),Oe(3,d.$ip),Oe(4,g.$Gj)],p)}),define(be[269],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0,e.$AN=(0,k.$7h)("IExtHostInitDataService")}),define(be[270],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=e.$kN=void 0,e.$kN=(0,k.$7h)("IExtHostRpcService");class O{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$lN=O}),define(be[72],ve([1,0,53]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;function O(I){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:I,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function r(I){return new k.$5m(O(I))}e.$4r=r}),define(be[271],ve([1,0,3,42,4,72,53,104,244,7,19]),function(he,e,k,O,r,I,D,S,v,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0;class E{static{this.a=1}constructor(h,$,c,g){this.b=h,this.c=$,this.d=c,this.e=g}async call(h,$,c){switch($){case"getEnvironmentData":{const g=c,d=(0,I.$4r)(g.remoteAuthority);let m=await this.f(g.profile);return m=(0,D.$7m)(m,d),m}case"getExtensionHostExitInfo":{const g=c;return this.e.getExitInfo(g.reconnectionToken)}case"getDiagnosticInfo":{const g=c,d={machineInfo:(0,v.$8r)()},m=g.includeProcesses?(0,S.$6r)(process.pid):Promise.resolve();let f=[];const u={};if(g.folders){const l=(0,I.$4r)("");f=g.folders.map(o=>r.URI.revive(l.transformIncoming(o))).filter(o=>o.scheme==="file").map(o=>(0,v.$7r)(o.fsPath,["node_modules",".git"]).then(n=>{u[(0,w.$nc)(o.fsPath)]=n}))}return Promise.all([m,...f]).then(([l,t])=>(d.processes=l||void 0,d.workspaceMetadata=g.folders?u:void 0,d))}}throw new Error(`IPC Command ${$} not found`)}listen(h,$,c){throw new Error("Not supported")}async f(h){h&&!this.d.profiles.some(c=>c.id===h)&&await this.d.createProfile(h,h);let $=!1;if(process.platform==="linux"){const c=process.glibcVersion;$=(c?parseInt(c.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:r.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,C.$Ig)(this.c.logsHome,`exthost${E.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:k.OS,arch:process.arch,marks:O.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(c=>({...c}))},isUnsupportedGlibc:$}}}e.$$r=E}),define(be[272],ve([1,0,4,72,70,7,229]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0;class S extends D.$_r{constructor(C,E){super(new r.$Cq(C),C),this.N=E,this.M=new Map,this.B(this.a)}c(C){let E=this.M.get(C.remoteAuthority);return E||(E=(0,O.$4r)(C.remoteAuthority),this.M.set(C.remoteAuthority,E)),E}f(C,E,b=!1){if(b&&E.path==="/vscode-resource"&&E.query){const h=JSON.parse(E.query).requestResourcePath;return k.URI.from({scheme:"file",path:h})}return k.URI.revive(C.transformIncoming(E))}L(C,E){return new v(C,E,this.b,this.N)}}e.$bs=S;class v extends D.$as{constructor(C,E,b,h){super(C,E,b,h)}j(C){const E=C.args["file-watcher-polling"];if(E){const b=E.split(I.$tc),h=Number(b[0]);if(h>0)return{usePolling:b.length>1?b.slice(1):!0,pollingInterval:h}}}m(C){if(C.extensionsPath)return[I.$gc.join(C.extensionsPath,"**")]}}}),define(be[93],ve([1,0,207,11,4,2,5,37,16,12,39,161,63]),function(he,e,k,O,r,I,D,S,v,w,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8E=e.$7E=e.$6E=e.EditorsOrder=e.$5E=e.CloseDirection=e.$4E=e.$3E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.EditorInputCapabilities=e.$TE=e.SaveReason=e.Verbosity=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=void 0,e.$GE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$HE={id:"default",displayName:(0,k.localize)(0,null),providerDisplayName:(0,k.localize)(1,null)},e.$IE="workbench.editor.sidebysideEditor",e.$JE="workbench.editors.textDiffEditor",e.$KE="workbench.editors.binaryResourceDiffEditor";var h;(function(z){z[z.PROGRAMMATIC=1]="PROGRAMMATIC",z[z.USER=2]="USER",z[z.EDIT=3]="EDIT",z[z.NAVIGATION=4]="NAVIGATION",z[z.JUMP=5]="JUMP"})(h||(e.EditorPaneSelectionChangeReason=h={}));var $;(function(z){z[z.IDENTICAL=1]="IDENTICAL",z[z.SIMILAR=2]="SIMILAR",z[z.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function c(z){const H=z;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.$LE=c;function g(z,H,R){for(const U of R.visibleEditorPanes)if(U.group.id===H&&z.matches(U.input))return U.getViewState()}e.$ME=g;function d(z){if(p(z))return!1;const H=z;return r.URI.isUri(H?.resource)}e.$NE=d;function m(z){if(p(z))return!1;const H=z;return H?.original!==void 0&&H.modified!==void 0}e.$OE=m;function f(z){if(p(z))return!1;const H=z;return!H||H.resources&&!Array.isArray(H.resources)?!1:!!H.resources||!!H.multiDiffSource}e.$PE=f;function u(z){if(p(z)||m(z))return!1;const H=z;return H?.primary!==void 0&&H.secondary!==void 0}e.$QE=u;function l(z){if(p(z))return!1;const H=z;return H?H.resource===void 0||H.resource.scheme===w.Schemas.untitled||H.forceUntitled===!0:!1}e.$RE=l;function t(z){if(p(z))return!1;const H=z;return r.URI.isUri(H?.base?.resource)&&r.URI.isUri(H?.input1?.resource)&&r.URI.isUri(H?.input2?.resource)&&r.URI.isUri(H?.result?.resource)}e.$SE=t;var o;(function(z){z[z.SHORT=0]="SHORT",z[z.MEDIUM=1]="MEDIUM",z[z.LONG=2]="LONG"})(o||(e.Verbosity=o={}));var n;(function(z){z[z.EXPLICIT=1]="EXPLICIT",z[z.AUTO=2]="AUTO",z[z.FOCUS_CHANGE=3]="FOCUS_CHANGE",z[z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class s{constructor(){this.a=new Map}registerSource(H,R){let U=this.a.get(H);return U||(U={source:H,label:R},this.a.set(H,U)),U.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.$TE=new s;var i;(function(z){z[z.None=0]="None",z[z.Readonly=2]="Readonly",z[z.Untitled=4]="Untitled",z[z.Singleton=8]="Singleton",z[z.RequiresTrust=16]="RequiresTrust",z[z.CanSplitInGroup=32]="CanSplitInGroup",z[z.ForceDescription=64]="ForceDescription",z[z.CanDropIntoEditor=128]="CanDropIntoEditor",z[z.MultipleEditors=256]="MultipleEditors",z[z.Scratchpad=512]="Scratchpad",z[z.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(i||(e.EditorInputCapabilities=i={}));class a extends I.$Tc{}e.$UE=a;function p(z){return z instanceof a}e.$VE=p;function L(z){const H=z;return r.URI.isUri(H?.preferredResource)}function P(z){const H=z;return p(H?.primary)&&p(H?.secondary)}e.$WE=P;function y(z){const H=z;return p(H?.modified)&&p(H?.original)}e.$XE=y;function A(z,H,R,U,x){return me(U,[(0,E.$Qi)({id:"workbench.action.openLargeFile",label:(0,k.localize)(2,null),run:()=>{const J={...R,limits:{size:Number.MAX_VALUE}};z.openEditor(H,J)}}),(0,E.$Qi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,k.localize)(3,null),run:()=>x.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}e.$YE=A;function M(z){return p(z?.editor)}e.$ZE=M;function _(z){const H=z;return M(z)&&H?.group!==void 0}e.$1E=_;function se(z){const H=z;return typeof H?.groupId=="number"&&p(H.editor)}e.$2E=se;var G;(function(z){z[z.UNKNOWN=0]="UNKNOWN",z[z.REPLACE=1]="REPLACE",z[z.MOVE=2]="MOVE",z[z.UNPIN=3]="UNPIN"})(G||(e.EditorCloseContext=G={}));var oe;(function(z){z[z.GROUP_ACTIVE=0]="GROUP_ACTIVE",z[z.GROUP_INDEX=1]="GROUP_INDEX",z[z.GROUP_LABEL=2]="GROUP_LABEL",z[z.GROUP_LOCKED=3]="GROUP_LOCKED",z[z.EDITOR_OPEN=4]="EDITOR_OPEN",z[z.EDITOR_CLOSE=5]="EDITOR_CLOSE",z[z.EDITOR_MOVE=6]="EDITOR_MOVE",z[z.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",z[z.EDITOR_LABEL=8]="EDITOR_LABEL",z[z.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",z[z.EDITOR_PIN=10]="EDITOR_PIN",z[z.EDITOR_STICKY=11]="EDITOR_STICKY",z[z.EDITOR_DIRTY=12]="EDITOR_DIRTY",z[z.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(oe||(e.GroupModelChangeKind=oe={}));var ee;(function(z){z[z.PRIMARY=1]="PRIMARY",z[z.SECONDARY=2]="SECONDARY",z[z.BOTH=3]="BOTH",z[z.ANY=4]="ANY"})(ee||(e.SideBySideEditor=ee={}));class K{getOriginalUri(H,R){if(!H)return;if(t(H))return e.$4E.getOriginalUri(H.result,R);if(R?.supportSideBySide){const{primary:x,secondary:J}=this.a(H);if(x&&J){if(R?.supportSideBySide===ee.BOTH)return{primary:this.getOriginalUri(x,{filterByScheme:R.filterByScheme}),secondary:this.getOriginalUri(J,{filterByScheme:R.filterByScheme})};if(R?.supportSideBySide===ee.ANY)return this.getOriginalUri(x,{filterByScheme:R.filterByScheme})??this.getOriginalUri(J,{filterByScheme:R.filterByScheme});H=R.supportSideBySide===ee.PRIMARY?x:J}}if(m(H)||f(H)||u(H)||t(H))return;const U=L(H)?H.preferredResource:H.resource;return!U||!R||!R.filterByScheme?U:this.b(U,R.filterByScheme)}a(H){return P(H)||u(H)?{primary:H.primary,secondary:H.secondary}:y(H)||m(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,R){if(!H)return;if(t(H))return e.$4E.getCanonicalUri(H.result,R);if(R?.supportSideBySide){const{primary:x,secondary:J}=this.a(H);if(x&&J){if(R?.supportSideBySide===ee.BOTH)return{primary:this.getCanonicalUri(x,{filterByScheme:R.filterByScheme}),secondary:this.getCanonicalUri(J,{filterByScheme:R.filterByScheme})};if(R?.supportSideBySide===ee.ANY)return this.getCanonicalUri(x,{filterByScheme:R.filterByScheme})??this.getCanonicalUri(J,{filterByScheme:R.filterByScheme});H=R.supportSideBySide===ee.PRIMARY?x:J}}if(m(H)||f(H)||u(H)||t(H))return;const U=H.resource;return!U||!R||!R.filterByScheme?U:this.b(U,R.filterByScheme)}b(H,R){if(Array.isArray(R)){if(R.some(U=>H.scheme===U))return H}else if(R===H.scheme)return H}}var Z;(function(z){z[z.UNKNOWN=0]="UNKNOWN",z[z.KEYBOARD=1]="KEYBOARD",z[z.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function X(z,H,R,U){if(!z.isSticky(H))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return R===Z.MOUSE||R===Z.KEYBOARD;case"mouse":return R===Z.MOUSE;case"keyboard":return R===Z.KEYBOARD}return!1}e.$3E=X,e.$4E=new K;var te;(function(z){z[z.LEFT=0]="LEFT",z[z.RIGHT=1]="RIGHT"})(te||(e.CloseDirection=te={}));class V{constructor(){this.c=new Map,this.d=new Map}start(H){const R=this.a=H.get(D.$6h);for(const[U,x]of this.c)this.e(U,x,R);this.c.clear()}e(H,R,U){const x=U.createInstance(R);this.d.set(H,x)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,O.$Uf)(this.b)}registerEditorSerializer(H,R){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,R,this.a):this.c.set(H,R),(0,I.$Rc)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}S.$In.add(e.$GE.EditorFactory,new V);async function W(z,H,R){return!z||!z.length?[]:await Promise.all(z.map(async U=>{const x=r.URI.revive(U.fileUri);if(!x){R.info("Cannot resolve the path because it is not valid.",U);return}if(!await H.canHandleResource(x)){R.info("Cannot resolve the path because it cannot be handled",U);return}let Y=U.exists,B=U.type;if(typeof Y!="boolean"||typeof B!="number")try{B=(await H.stat(x)).isDirectory?v.FileType.Directory:v.FileType.Unknown,Y=!0}catch(N){R.error(N),Y=!1}if(!Y&&U.openOnlyIfExists){R.info("Cannot resolve the path because it does not exist",U);return}if(B===v.FileType.Directory){R.info("Cannot resolve the path because it is a directory",U);return}const T={...U.options,pinned:!0};return Y?{resource:x,options:T}:{resource:x,options:T,forceUntitled:!0}}))}e.$5E=W;var re;(function(z){z[z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",z[z.SEQUENTIAL=1]="SEQUENTIAL"})(re||(e.EditorsOrder=re={}));function ue(z){const H=z;if(!H)return!1;const R=H;if(R.modified)return ue(R.modified);const U=H;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$6E=ue;function ne(z){return(0,C.$Si)(z)}e.$7E=ne;function me(z,H,R){const U=(0,C.$Ti)(z,H);return U.forceMessage=R?.forceMessage,U.forceSeverity=R?.forceSeverity,U.allowDialog=R?.allowDialog,U}e.$8E=me}),define(be[273],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0,e.$NN=(0,k.$7h)("environmentVariableService")}),define(be[274],ve([1,0,7,4,66,3,254,11]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=void 0;function v(l,t){if(t)if(I.$i)for(const o in t){let n=o;for(const i in l)if(o.toLowerCase()===i.toLowerCase()){n=i;break}const s=t[o];s!==void 0&&w(l,n,s)}else Object.keys(t).forEach(o=>{const n=t[o];n!==void 0&&w(l,o,n)})}e.$cO=v;function w(l,t,o){typeof o=="string"?l[t]=o:delete l[t]}function C(l,t,o,n){l.TERM_PROGRAM="vscode",t&&(l.TERM_PROGRAM_VERSION=t),h(l,n)&&(l.LANG=$(o)),l.COLORTERM="truecolor"}e.$dO=C;function E(l,t){if(t)for(const o of Object.keys(t)){const n=t[o];n!=null&&(l[o]=n)}}async function b(l,t){return await Promise.all(Object.entries(t).map(async([o,n])=>{if(typeof n=="string")try{t[o]=await l(n)}catch{t[o]=n}})),t}function h(l,t){if(t==="on")return!0;if(t==="auto"){const o=l.LANG;return!o||o.search(/\.UTF\-8$/)===-1&&o.search(/\.utf8$/)===-1&&o.search(/\.euc.+/)===-1}return!1}e.$eO=h;function $(l){const t=l?l.split("-"):[],o=t.length;if(o===0)return"en_US.UTF-8";if(o===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in n&&t.push(n[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.$fO=$;async function c(l,t,o,n,s,i){if(l.cwd){const p=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,L=await g(p,o);return(0,D.$aO)(L||p)}let a;return!l.ignoreConfigurationCwd&&s&&(o&&(s=await g(s,o,i)),s&&(k.$ic(s)?a=s:n&&(a=k.$jc(n.fsPath,s)))),a||(a=n?n.fsPath:t||""),(0,D.$aO)(a)}e.$gO=c;async function g(l,t,o){if(t)try{return await t(l)}catch(n){o?.error("Could not resolve terminal cwd",n);return}return l}function d(l,t,o){if(o)return n=>o.resolveWithEnvironment(t,l,n)}e.$hO=d;async function m(l,t,o,n,s,i){const a={};if(l.strictEnv)E(a,l.env);else{E(a,i);const p={...t};o&&(p&&await b(o,p),l.env&&await b(o,l.env)),(0,r.$Sl)(a,"VSCODE_IPC_HOOK_CLI"),v(a,p),v(a,l.env),C(a,n,I.$w,s)}return a}e.$iO=m;async function f(l,t,o,n,s,i,a=I.$i){let p;if((0,S.$Jf)(l)?p=l:(p=l.fsPath,a&&i!==1?p=p.replace(/\\/g,"/"):!a&&i===1&&(p=p.replace(/\//g,"\\"))),!t)return p;const L=p.includes(" "),P=p.includes("(")||p.includes(")"),y=k.$nc(t,".exe"),A=y==="pwsh"||o==="pwsh"||y==="powershell"||o==="powershell";if(A&&(L||p.includes("'")))return`& '${p.replace(/'/g,"''")}'`;if(P&&A)return`& '${p}'`;if(i===1){if(n!==void 0)return n==="gitbash"?(0,D.$$N)(p.replace(/\\/g,"/")):n==="wsl"?s?.getWslPath(p,"win-to-unix")||p:L?`"${p}"`:p;const M=t.toLowerCase();return M.includes("wsl")||M.includes("bash.exe")&&!M.toLowerCase().includes("git")?s?.getWslPath(p,"win-to-unix")||p:L?`"${p}"`:p}return(0,D.$$N)(p)}e.$jO=f;function u(l,t,o){const n=typeof l=="string"?O.URI.parse(l):l;let s=n?t.getWorkspaceFolder(n)??void 0:void 0;if(!s){const i=o.getLastActiveWorkspaceRoot();s=i?t.getWorkspaceFolder(i)??void 0:void 0}return s}e.$kO=u}),define(be[73],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.TestPosition=e.TestIdPathParts=void 0;var k;(function(I){I.Delimiter="\0"})(k||(e.TestIdPathParts=k={}));var O;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class r{static fromExtHostTestItem(D,S,v=D.parent){if(D._isRoot)return new r([S]);const w=[D.id];for(let C=v;C&&C.id!==S;C=C.parent)w.push(C.id);return w.push(S),new r(w.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const S=D.indexOf("\0");return S===-1?D:D.slice(0,S)}static fromString(D){return new r(D.split("\0"))}static join(D,S){return new r([...D.path,S])}static joinToString(D,S){return D.toString()+"\0"+S}static parentId(D){const S=D.lastIndexOf("\0");return S===-1?void 0:D.slice(0,S)}static localId(D){const S=D.lastIndexOf("\0");return S===-1?D:D.slice(S+1)}static isChild(D,S){return S.startsWith(D)&&S[D.length]==="\0"}static compare(D,S){return D===S?0:r.isChild(D,S)?2:r.isChild(S,D)?3:1}constructor(D,S=D.length){if(this.path=D,this.d=S,D.length===0||S<1)throw new Error("cannot create test with empty path")}get rootId(){return new r(this.path,1)}get parentId(){return this.d>1?new r(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new r(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new r(this.path,D)}compare(D){if(typeof D=="string")return r.compare(this.toString(),D);for(let S=0;S<D.d&&S<this.d;S++)if(D.path[S]!==this.path[S])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.$0J=r}),define(be[94],ve([1,0,4,79,43,73]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$eK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$dK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$cK=e.$bK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$aK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$_J=e.$$J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var D;(function(ee){ee[ee.Unset=0]="Unset",ee[ee.Queued=1]="Queued",ee[ee.Running=2]="Running",ee[ee.Passed=3]="Passed",ee[ee.Failed=4]="Failed",ee[ee.Skipped=5]="Skipped",ee[ee.Errored=6]="Errored"})(D||(e.TestResultState=D={}));var S;(function(ee){ee[ee.Run=1]="Run",ee[ee.Debug=2]="Debug",ee[ee.Coverage=3]="Coverage"})(S||(e.ExtTestRunProfileKind=S={}));var v;(function(ee){ee[ee.Run=2]="Run",ee[ee.Debug=4]="Debug",ee[ee.Coverage=8]="Coverage",ee[ee.HasNonDefaultProfile=16]="HasNonDefaultProfile",ee[ee.HasConfigurable=32]="HasConfigurable",ee[ee.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.$$J=[2,4,8,16,32,64];const w=ee=>"runId"in ee;e.$_J=w;var C;(function(ee){ee.serialize=K=>({range:K.range.toJSON(),uri:K.uri.toJSON()}),ee.deserialize=(K,Z)=>({range:r.$Vs.lift(Z.range),uri:K.asCanonicalUri(k.URI.revive(Z.uri))})})(C||(e.IRichLocation=C={}));var E;(function(ee){ee[ee.Error=0]="Error",ee[ee.Output=1]="Output"})(E||(e.TestMessageType=E={}));var b;(function(ee){ee.serialize=K=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&C.serialize(K.location)}),ee.deserialize=(K,Z)=>({message:Z.message,type:0,expected:Z.expected,actual:Z.actual,contextValue:Z.contextValue,location:Z.location&&C.deserialize(K,Z.location)})})(b||(e.ITestErrorMessage=b={}));const h=(ee,K)=>`${K?"s":"e"}${ee}`;e.$aK=h;var $;(function(ee){ee.serialize=K=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&C.serialize(K.location)}),ee.deserialize=(K,Z)=>({message:Z.message,type:1,offset:Z.offset,length:Z.length,location:Z.location&&C.deserialize(K,Z.location)})})($||(e.ITestOutputMessage=$={}));var c;(function(ee){ee.serialize=K=>K.type===0?b.serialize(K):$.serialize(K),ee.deserialize=(K,Z)=>Z.type===0?b.deserialize(K,Z):$.deserialize(K,Z)})(c||(e.ITestMessage=c={}));var g;(function(ee){ee.serializeWithoutMessages=K=>({state:K.state,duration:K.duration,messages:[]}),ee.serialize=K=>({state:K.state,duration:K.duration,messages:K.messages.map(c.serialize)}),ee.deserialize=(K,Z)=>({state:Z.state,duration:Z.duration,messages:Z.messages.map(X=>c.deserialize(K,X))})})(g||(e.ITestTaskState=g={}));const d="\0",m=(ee,K)=>ee+d+K;e.$bK=m;const f=ee=>{const K=ee.indexOf(d);return{ctrlId:ee.slice(0,K),tagId:ee.slice(K+1)}};e.$cK=f;var u;(function(ee){ee.serialize=K=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?.toJSON(),range:K.range?.toJSON()||null,description:K.description,error:K.error,sortText:K.sortText}),ee.deserialize=(K,Z)=>({extId:Z.extId,label:Z.label,tags:Z.tags,busy:Z.busy,children:void 0,uri:Z.uri?K.asCanonicalUri(k.URI.revive(Z.uri)):void 0,range:Z.range?r.$Vs.lift(Z.range):null,description:Z.description,error:Z.error,sortText:Z.sortText})})(u||(e.ITestItem=u={}));var l;(function(ee){ee[ee.NotExpandable=0]="NotExpandable",ee[ee.Expandable=1]="Expandable",ee[ee.BusyExpanding=2]="BusyExpanding",ee[ee.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(ee){ee.serialize=K=>({expand:K.expand,item:u.serialize(K.item)}),ee.deserialize=(K,Z)=>({controllerId:I.$0J.root(Z.item.extId),expand:Z.expand,item:u.deserialize(K,Z.item)})})(t||(e.InternalTestItem=t={}));var o;(function(ee){ee.serialize=K=>{let Z;return K.item&&(Z={},K.item.label!==void 0&&(Z.label=K.item.label),K.item.tags!==void 0&&(Z.tags=K.item.tags),K.item.busy!==void 0&&(Z.busy=K.item.busy),K.item.uri!==void 0&&(Z.uri=K.item.uri?.toJSON()),K.item.range!==void 0&&(Z.range=K.item.range?.toJSON()),K.item.description!==void 0&&(Z.description=K.item.description),K.item.error!==void 0&&(Z.error=K.item.error),K.item.sortText!==void 0&&(Z.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:Z}},ee.deserialize=K=>{let Z;return K.item&&(Z={},K.item.label!==void 0&&(Z.label=K.item.label),K.item.tags!==void 0&&(Z.tags=K.item.tags),K.item.busy!==void 0&&(Z.busy=K.item.busy),K.item.range!==void 0&&(Z.range=K.item.range?r.$Vs.lift(K.item.range):null),K.item.description!==void 0&&(Z.description=K.item.description),K.item.error!==void 0&&(Z.error=K.item.error),K.item.sortText!==void 0&&(Z.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:Z}}})(o||(e.ITestItemUpdate=o={}));const n=(ee,K)=>{K.expand!==void 0&&(ee.expand=K.expand),K.item!==void 0&&(ee.item=ee.item?Object.assign(ee.item,K.item):K.item)};e.$dK=n;var s;(function(ee){ee.serializeWithoutMessages=K=>({...t.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(g.serializeWithoutMessages)}),ee.serialize=K=>({...t.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(g.serialize)}),ee.deserialize=(K,Z)=>({...t.deserialize(K,Z),ownComputedState:Z.ownComputedState,computedState:Z.computedState,tasks:Z.tasks.map(X=>g.deserialize(K,X)),retired:!0})})(s||(e.TestResultItem=s={}));var i;(function(ee){ee.empty=()=>({covered:0,total:0}),ee.sum=(K,Z)=>{K.covered+=Z.covered,K.total+=Z.total}})(i||(e.ICoveredCount=i={}));var a;(function(ee){ee.serialize=K=>({statement:K.statement,branch:K.branch,function:K.function,details:K.details?.map(y.serialize),uri:K.uri.toJSON()}),ee.deserialize=(K,Z)=>({statement:Z.statement,branch:Z.branch,function:Z.function,details:Z.details?.map(y.deserialize),uri:K.asCanonicalUri(k.URI.revive(Z.uri))})})(a||(e.IFileCoverage=a={}));function p(ee){return{...ee,location:ee.location?.toJSON()}}function L(ee){return ee.location=ee.location?O.$Us.isIPosition(ee.location)?O.$Us.lift(ee.location):r.$Vs.lift(ee.location):void 0,ee}e.$eK=3;var P;(function(ee){ee[ee.Function=0]="Function",ee[ee.Statement=1]="Statement",ee[ee.Branch=2]="Branch"})(P||(e.DetailType=P={}));var y;(function(ee){ee.serialize=K=>K.type===0?M.serialize(K):_.serialize(K),ee.deserialize=K=>K.type===0?M.deserialize(K):_.deserialize(K)})(y||(e.CoverageDetails=y={}));var A;(function(ee){ee.serialize=p,ee.deserialize=L})(A||(e.IBranchCoverage=A={}));var M;(function(ee){ee.serialize=p,ee.deserialize=L})(M||(e.IFunctionCoverage=M={}));var _;(function(ee){ee.serialize=K=>({...p(K),branches:K.branches?.map(A.serialize)}),ee.deserialize=K=>({...L(K),branches:K.branches?.map(A.deserialize)})})(_||(e.IStatementCoverage=_={}));var se;(function(ee){ee[ee.Add=0]="Add",ee[ee.Update=1]="Update",ee[ee.DocumentSynced=2]="DocumentSynced",ee[ee.Remove=3]="Remove",ee[ee.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",ee[ee.Retire=5]="Retire",ee[ee.AddTag=6]="AddTag",ee[ee.RemoveTag=7]="RemoveTag"})(se||(e.TestDiffOpType=se={}));var G;(function(ee){ee.deserialize=(K,Z)=>Z.op===0?{op:Z.op,item:t.deserialize(K,Z.item)}:Z.op===1?{op:Z.op,item:o.deserialize(Z.item)}:Z.op===2?{op:Z.op,uri:K.asCanonicalUri(k.URI.revive(Z.uri)),docv:Z.docv}:Z,ee.serialize=K=>K.op===0?{op:K.op,item:t.serialize(K.item)}:K.op===1?{op:K.op,item:o.serialize(K.item)}:K})(G||(e.TestsDiffOp=G={}));class oe{constructor(K){this.k=K,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(K){const Z=this.v();for(const X of K)switch(X.op){case 0:this.l(t.deserialize(this.k,X.item),Z);break;case 1:this.o(o.deserialize(X.item),Z);break;case 3:this.p(X.itemId,Z);break;case 5:this.q(X.itemId);break;case 4:this.updatePendingRoots(X.amount);break;case 6:this.c.set(X.tag.id,X.tag);break;case 7:this.c.delete(X.id);break}Z.complete?.()}l(K,Z){const X=I.$0J.parentId(K.item.extId)?.toString();let te;if(!X)te=this.w(K),this.g.add(te),this.f.set(K.item.extId,te);else if(this.f.has(X)){const V=this.f.get(X);V.children.add(K.item.extId),te=this.w(K,V),this.f.set(K.item.extId,te)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(K)}`);return}return Z.add?.(te),K.expand===2&&this.h++,te}o(K,Z){const X=this.f.get(K.extId);if(X)return K.expand!==void 0&&(X.expand===2&&this.h--,K.expand===2&&this.h++),(0,e.$dK)(X,K),Z.update?.(X),X}p(K,Z){const X=this.f.get(K);if(!X)return;const te=I.$0J.parentId(X.item.extId)?.toString();te?this.f.get(te).children.delete(X.item.extId):this.g.delete(X);const V=[[K]];for(;V.length;)for(const W of V.pop()){const re=this.f.get(W);re&&(V.push(re.children),this.f.delete(W),Z.remove?.(re,re!==X),re.expand===2&&this.h--)}}q(K){}updatePendingRoots(K){this.j+=K}v(){return{}}}e.$fK=oe}),define(be[132],ve([1,0,15,6,2,96,94,73]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.TestItemEventOp=void 0;var v;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const w=(m,f)=>m===f,E=Object.entries({range:(m,f)=>m===f?!0:!m||!f?!1:m.equalsRange(f),busy:w,label:w,description:w,error:w,sortText:w,tags:(m,f)=>!(m.length!==f.length||m.some(u=>!f.includes(u)))}),b=(m,f)=>{let u;for(const[l,t]of E)t(m[l],f[l])||(u?u[l]=f[l]:u={[l]:f[l]});return u};class h extends r.$Tc{get root(){return this.s.root}constructor(f){super(),this.s=f,this.f=this.B(new k.$gh(()=>this.flushDiff(),200)),this.g=this.B(new O.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(f){this.h=f;for(const u of this.tree.values())this.J(u)}get resolveHandler(){return this.h}collectDiff(){const f=this.m;return this.m=[],f}pushDiff(f){switch(f.op){case 2:{for(const u of this.m)if(u.op===2&&u.uri===f.uri){u.docv=f.docv;return}break}case 1:{const u=this.m[this.m.length-1];if(u){if(u.op===1&&u.item.extId===f.item.extId){(0,D.$dK)(u.item,f.item);return}if(u.op===0&&u.item.item.extId===f.item.extId){(0,D.$dK)(u.item,f.item);return}}break}}this.m.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,u){const l=this.tree.get(f);if(l){if((l.expandLevels===void 0||u>l.expandLevels)&&(l.expandLevels=u),l.expand===1){const t=this.M(l);return t.isOpen()?this.L(l,u-1):t.wait().then(()=>this.L(l,u-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,u-1)):this.L(l,u-1)}}dispose(){for(const f of this.tree.values())this.s.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(f,u){switch(u.op){case 3:this.O(S.$0J.joinToString(f.fullId,u.id));break;case 0:this.z(u.item,f);break;case 5:for(const l of u.ops)this.w(f,l);break;case 1:this.C(u.new,u.old,f.fullId.toString());break;case 2:this.J(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:u.update}});break;case 6:this.y(f.actual.uri);break;default:(0,I.$6c)(u)}}y(f){f&&this.pushDiff({op:2,uri:f,docv:this.s.getDocumentVersion(f)})}z(f,u){const l=S.$0J.fromExtHostTestItem(f,this.root.id,u?.actual),t=this.s.getApiFor(f);t.parent&&t.parent!==u?.actual&&this.s.getChildren(t.parent).delete(f.id);let o=this.tree.get(l.toString());if(!o){o={fullId:l,actual:f,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},f.tags.forEach(this.D,this),this.tree.set(o.fullId.toString(),o),this.G(f,u),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:o.expand,item:this.s.toITestItem(f)}}),this.I(f,o,u);return}if(o.actual===f){this.H(f,o,u);return}if(o.actual.uri?.toString()!==f.uri?.toString())return this.O(l.toString()),this.z(f,u);const n=this.s.getChildren(o.actual),s=o.actual,i=b(this.s.toITestItem(s),this.s.toITestItem(f));this.s.getApiFor(s).listener=void 0,o.actual=f,o.expand=0,i&&(i.hasOwnProperty("tags")&&(this.C(f.tags,s.tags,l.toString()),delete i.tags),this.w(o,{op:4,update:i})),this.I(f,o,u);for(const[a,p]of n)this.s.getChildren(f).get(p.id)||this.O(S.$0J.joinToString(l,p.id));this.y(o.actual.uri)}C(f,u,l){const t=new Set(u.map(o=>o.id));for(const o of f)t.delete(o.id)||this.D(o);this.pushDiff({op:1,item:{extId:l,item:{tags:f.map(o=>(0,D.$bK)(this.s.controllerId,o.id))}}}),t.forEach(this.F,this)}D(f){const u=this.j.get(f.id);u?u.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.$bK)(this.s.controllerId,f.id)}}))}F(f){const u=this.j.get(f);u&&!--u.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,D.$bK)(this.s.controllerId,f)}))}G(f,u){this.s.getApiFor(f).parent=u&&u.actual!==this.root?u.actual:void 0}H(f,u,l){this.G(f,l);const t=this.s.getApiFor(f);t.parent=l?.actual,t.listener=o=>this.w(u,o),this.J(u)}I(f,u,l){this.H(f,u,l);for(const[t,o]of this.s.getChildren(f))this.z(o,u)}J(f){let u;this.h?f.resolveBarrier?u=f.resolveBarrier.isOpen()?3:2:u=f.actual.canResolveChildren?1:0:u=0,u!==f.expand&&(f.expand=u,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:u}}),u===1&&f.expandLevels!==void 0&&this.M(f))}L(f,u){if(u<0)return;const l=[];for(const[t,o]of this.s.getChildren(f.actual)){const n=this.expand(S.$0J.joinToString(f.fullId,o.id),u);(0,k.$Tg)(n)&&l.push(n)}if(l.length)return Promise.all(l).then(()=>{})}M(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const o=new k.$6g;return o.open(),o}f.expand=2,this.N(f);const u=f.resolveBarrier=new k.$6g,l=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,o)};let t;try{t=this.h(f.actual===this.root?void 0:f.actual)}catch(o){l(o)}return(0,k.$Tg)(t)?t.catch(l).then(()=>{u.open(),this.J(f)}):(u.open(),this.J(f)),f.resolveBarrier}N(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}O(f){const u=this.tree.get(f);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const l=[u];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.F(o.id);this.tree.delete(t.fullId.toString());for(const[o,n]of this.s.getChildren(t.actual))l.push(this.tree.get(S.$0J.joinToString(t.fullId,n.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.$aN=h;class $ extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.$bN=$;class c extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$cN=c;class g extends Error{constructor(f,u,l){super(`TestItem with ID "${f}" is from controller "${u}" and cannot be added as a child of an item from controller "${l}".`)}}e.$dN=g;const d=(m,f,u)=>{let l=new Map;return{get size(){return l.size},forEach(t,o){for(const n of l.values())t.call(o,n,this)},[Symbol.iterator](){return l.entries()},replace(t){const o=new Map,n=new Set(l.keys()),s={op:5,ops:[]};for(const i of t){if(!(i instanceof u))throw new c(i.id);const a=f(i).controllerId;if(a!==m.controllerId)throw new g(i.id,a,m.controllerId);if(o.has(i.id))throw new $(i.id);o.set(i.id,i),n.delete(i.id),s.ops.push({op:0,item:i})}for(const i of n.keys())s.ops.push({op:3,id:i});m.listener?.(s),l=o},add(t){if(!(t instanceof u))throw new c(t.id);l.set(t.id,t),m.listener?.({op:0,item:t})},delete(t){l.delete(t)&&m.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$eN=d}),define(be[133],ve([1,0,132]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=void 0;const O=new WeakMap,r=(D,S)=>{const v={controllerId:S};return O.set(D,v),v};e.$fN=r;const I=D=>{const S=O.get(D);if(!S)throw new k.$cN(D?.id||"<unknown>");return S};e.$gN=I}),define(be[275],ve([1,0,25,5]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=void 0,e.$3D=".vscode",e.$4D="settings",e.$5D=`${e.$3D}/${e.$4D}.json`,e.$6D="vscode://schemas/settings/default",e.$7D="vscode://schemas/settings/user",e.$8D="vscode://schemas/settings/profile",e.$9D="vscode://schemas/settings/machine",e.$0D="vscode://schemas/settings/workspace",e.$$D="vscode://schemas/settings/folder",e.$_D="vscode://schemas/launch",e.$aE="vscode://schemas/tasks",e.$bE=[1],e.$cE=[2,3,4,5,6],e.$dE=[3,4,5],e.$eE=[1,...e.$dE],e.$fE=[2,3,4,5,6],e.$gE=[3,4,5,6],e.$hE=[4,5,6],e.$iE="tasks",e.$jE="launch",e.$kE=Object.create(null),e.$kE[e.$iE]=`${e.$3D}/${e.$iE}.json`,e.$kE[e.$jE]=`${e.$3D}/${e.$jE}.json`,e.$lE=Object.create(null),e.$lE[e.$iE]=`${e.$iE}.json`,e.$mE=(0,O.$8h)(k.$Ai),e.$nE=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$oE="workbench.settings.applyToAllProfiles"}),define(be[134],ve([1,0,5]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=e.VariableKind=e.$9N=void 0,e.$9N=(0,k.$7h)("configurationResolverService");var O;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator",I.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class r extends Error{constructor(D,S){super(S),this.variable=D}}e.$0N=r}),define(be[276],ve([1,0,7,29,11,21,3,170,208,134,17]),function(he,e,k,O,r,I,D,S,v,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=void 0;class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(h,$,c,g){this.h=new Map,this.a=h,this.b=$,this.g=c,g&&(this.c=g.then(d=>this.i(d)))}i(h){if(D.$i){const $=Object.create(null);return Object.keys(h).forEach(c=>{$[c.toLowerCase()]=h[c]}),$}return h}resolveWithEnvironment(h,$,c){return this.l({env:this.i(h),userHome:void 0},$?$.uri:void 0,c)}async resolveAsync(h,$){const c={env:await this.c,userHome:await this.g};return this.l(c,h?h.uri:void 0,$)}async j(h,$,c,g){const d=I.$wn($);D.$i&&d.windows?Object.keys(d.windows).forEach(f=>d[f]=d.windows[f]):D.$j&&d.osx?Object.keys(d.osx).forEach(f=>d[f]=d.osx[f]):D.$k&&d.linux&&Object.keys(d.linux).forEach(f=>d[f]=d.linux[f]),delete d.windows,delete d.osx,delete d.linux;const m={env:await this.c,userHome:await this.g};return this.l(m,h?h.uri:void 0,d,c,g)}async resolveAnyAsync(h,$,c){return this.j(h,$,c)}async resolveAnyMap(h,$,c){const g=new Map;return{newConfig:await this.j(h,$,c,g),resolvedVariables:g}}resolveWithInteractionReplace(h,$,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(h,$,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(h,$){if(this.h.has(h))throw new Error("Variable "+h+" is contributed twice.");this.h.set(h,$)}async l(h,$,c,g,d){if(r.$Jf(c))return this.m(h,$,c,g,d);if(Array.isArray(c))return Promise.all(c.map(m=>this.l(h,$,m,g,d)));if(r.$Lf(c)){const m=Object.create(null),f=await Promise.all(Object.keys(c).map(async u=>[await this.m(h,$,u,g,d),await this.l(h,$,c[u],g,d)]));for(const[u,l]of f)m[u]=l;return m}return c}m(h,$,c,g,d){return(0,C.$5e)(c,E.VARIABLE_REGEXP,async(m,f)=>{if(f.includes(E.VARIABLE_LHS))return m;let u=await this.o(h,m,f,$,g);return d?.set(f,u),u!==m&&r.$Jf(u)&&u.match(E.VARIABLE_REGEXP)&&(u=await this.m(h,$,u,g,d)),u})}n(h){return this.b?this.b.getUriLabel(h,{noPrefix:!0}):h.fsPath}async o(h,$,c,g,d){let m;const f=c.split(":");f.length>1&&(c=f[0],m=f[1]);const u=o=>{const n=this.a.getFilePath();if(n)return(0,S.$Xv)(n);throw new w.$0N(o,(0,v.localize)(0,null,$))},l=o=>{const n=u(o);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,S.$Xv)(s)}throw new w.$0N(o,(0,v.localize)(1,null,$,k.$nc(n)))},t=o=>{if(m){const n=this.a.getFolderUri(m);if(n)return n;throw new w.$0N(o,(0,v.localize)(2,null,$,m))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new w.$0N(o,(0,v.localize)(3,null,$)):new w.$0N(o,(0,v.localize)(4,null,$))};switch(c){case"env":if(m){if(h.env){const o=h.env[D.$i?m.toLowerCase():m];if(r.$Jf(o))return o}return""}throw new w.$0N(w.VariableKind.Env,(0,v.localize)(5,null,$));case"config":if(m){const o=this.a.getConfigurationValue(g,m);if(r.$Sf(o))throw new w.$0N(w.VariableKind.Config,(0,v.localize)(6,null,$,m));if(r.$Lf(o))throw new w.$0N(w.VariableKind.Config,(0,v.localize)(7,null,$,m));return o}throw new w.$0N(w.VariableKind.Config,(0,v.localize)(8,null,$));case"command":return this.p(w.VariableKind.Command,$,m,d,"command");case"input":return this.p(w.VariableKind.Input,$,m,d,"input");case"extensionInstallFolder":if(m){const o=await this.a.getExtension(m);if(!o)throw new w.$0N(w.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,$,m));return this.n(o.extensionLocation)}throw new w.$0N(w.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,$));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,S.$Xv)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return g||m?(0,S.$Xv)(this.n(t(w.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,S.$Xv)(k.$nc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(h.userHome)return h.userHome;throw new w.$0N(w.VariableKind.UserHome,(0,v.localize)(11,null,$))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new w.$0N(w.VariableKind.LineNumber,(0,v.localize)(12,null,$))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new w.$0N(w.VariableKind.SelectedText,(0,v.localize)(13,null,$))}case"file":return u(w.VariableKind.File);case"fileWorkspaceFolder":return l(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return k.$nc(l(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||m?k.$lc(this.n(t(w.VariableKind.RelativeFile)),u(w.VariableKind.RelativeFile)):u(w.VariableKind.RelativeFile);case"relativeFileDirname":{const o=k.$mc(u(w.VariableKind.RelativeFileDirname));if(g||m){const n=k.$lc(this.n(t(w.VariableKind.RelativeFileDirname)),o);return n.length===0?".":n}return o}case"fileDirname":return k.$mc(u(w.VariableKind.FileDirname));case"fileExtname":return k.$oc(u(w.VariableKind.FileExtname));case"fileBasename":return k.$nc(u(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=k.$nc(u(w.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-k.$oc(o).length)}case"fileDirnameBasename":return k.$nc(k.$mc(u(w.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||$}case"execInstallFolder":{const o=this.a.getAppRoot();return o||$}case"pathSeparator":case"/":return k.sep;default:try{const o=m?`${c}:${m}`:c;return this.p(w.VariableKind.Unknown,$,o,d,void 0)}catch{return $}}}}p(h,$,c,g,d){if(c&&g){const m=d===void 0?g[c]:g[d+":"+c];if(typeof m=="string")return m;throw new w.$0N(h,(0,v.localize)(14,null,$))}return $}}e.$lO=E}),define(be[277],ve([1,0,5,93]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cD=e.$bD=e.OpenEditorContext=e.GroupsOrder=e.$aD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$_C=void 0,e.$_C=(0,k.$7h)("editorGroupsService");var r;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(r||(e.GroupDirection=r={}));var I;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var D;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(D||(e.GroupLocation=D={}));var S;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EXPAND=1]="EXPAND",$[$.EVEN=2]="EVEN"})(S||(e.GroupsArrangement=S={}));var v;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function w($){const c=$;return(0,O.$VE)(c?.editor)&&(0,O.$VE)(c?.replacement)}e.$aD=w;var C;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var E;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function b($){const c=$;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$bD=b;function h($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$cD=h}),define(be[135],ve([1,0,5,277]),function(he,e,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=e.$gD=e.$fD=e.$eD=e.$dD=void 0,e.$dD=(0,k.$7h)("editorService"),e.$eD=-1,e.$fD=-2,e.$gD=-3;function r(I){const D=I;return typeof I=="number"||(0,O.$bD)(D)}e.$hD=r}),define(be[278],ve([1,0,275,118,92,90,134,93,135,12,227,273,91]),function(he,e,k,O,r,I,D,S,v,w,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oO=e.$nO=void 0,e.$nO="remoteterminal";let h=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(c,g,d,m,f,u,l,t,o,n){this.a=c,this.b=g,this.c=d,this.d=m,this.e=f,this.f=u,this.g=l,this.h=t,this.i=o,this.j=n}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(c,g,d,m,f,u,l,t){await this.c.whenRemoteConfigurationLoaded();const o=Object.create(null),n=d?this.d.getWorkspaceFolder(d)??void 0:void 0;let s;try{s=(await this.e.resolveAnyMap(n,{shellLaunchConfig:c,configuration:g})).resolvedVariables}catch(_){this.h.error(_)}if(s)for(const[_,se]of s.entries())(/^config:/.test(_)||_==="selectedText"||_==="lineNumber")&&(o[_]=se);const i=[];for(const[_,se]of this.f.collections.entries())i.push([_,(0,I.$Nr)(se.map),(0,I.$Or)(se.descriptionMap)]);const a=await this.g.resolveAuthority(this.a),p=a.options&&a.options.extensionHostEnv,L=this.d.getWorkspace(),P=L.folders,y=d?this.d.getWorkspaceFolder(d):null,A=S.$4E.getOriginalUri(this.i.activeEditor,{supportSideBySide:S.SideBySideEditor.PRIMARY,filterByScheme:[w.Schemas.file,w.Schemas.vscodeUserData,w.Schemas.vscodeRemote]}),M={configuration:g,resolvedVariables:o,envVariableCollections:i,shellLaunchConfig:c,workspaceId:L.id,workspaceName:this.j.getWorkspaceLabel(L),workspaceFolders:P,activeWorkspaceFolder:y,activeFileResource:A,shouldPersistTerminal:f,options:m,cols:u,rows:l,unicodeVersion:t,resolverEnv:p};return await this.b.call("$createProcess",M)}requestDetachInstance(c,g){return this.b.call("$requestDetachInstance",[c,g])}acceptDetachInstanceReply(c,g){return this.b.call("$acceptDetachInstanceReply",[c,g])}attachToProcess(c){return this.b.call("$attachToProcess",[c])}detachFromProcess(c,g){return this.b.call("$detachFromProcess",[c,g])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(c,g){return this.b.call("$processBinary",[c,g])}start(c){return this.b.call("$start",[c])}input(c,g){return this.b.call("$input",[c,g])}acknowledgeDataEvent(c,g){return this.b.call("$acknowledgeDataEvent",[c,g])}setUnicodeVersion(c,g){return this.b.call("$setUnicodeVersion",[c,g])}shutdown(c,g){return this.b.call("$shutdown",[c,g])}resize(c,g,d){return this.b.call("$resize",[c,g,d])}clearBuffer(c){return this.b.call("$clearBuffer",[c])}getInitialCwd(c){return this.b.call("$getInitialCwd",[c])}getCwd(c){return this.b.call("$getCwd",[c])}orphanQuestionReply(c){return this.b.call("$orphanQuestionReply",[c])}sendCommandResult(c,g,d){return this.b.call("$sendCommandResult",[c,g,d])}freePortKillProcess(c){return this.b.call("$freePortKillProcess",[c])}installAutoReply(c,g){return this.b.call("$installAutoReply",[c,g])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(c){return this.b.call("$getDefaultSystemShell",[c])}getProfiles(c,g,d){return this.b.call("$getProfiles",[this.d.getWorkspace().id,c,g,d])}acceptPtyHostResolvedVariables(c,g){return this.b.call("$acceptPtyHostResolvedVariables",[c,g])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(c,g){return this.b.call("$getWslPath",[c,g])}setTerminalLayoutInfo(c){const d={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call("$setTerminalLayoutInfo",d)}updateTitle(c,g,d){return this.b.call("$updateTitle",[c,g,d])}updateIcon(c,g,d,m){return this.b.call("$updateIcon",[c,g,d,m])}refreshProperty(c,g){return this.b.call("$refreshProperty",[c,g])}updateProperty(c,g,d){return this.b.call("$updateProperty",[c,g,d])}getTerminalLayoutInfo(){const g={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",g)}reviveTerminalProcesses(c,g,d){return this.b.call("$reviveTerminalProcesses",[c,g,d])}getRevivedPtyNewId(c){return this.b.call("$getRevivedPtyNewId",[c])}serializeTerminalState(c){return this.b.call("$serializeTerminalState",[c])}};e.$oO=h,e.$oO=h=Ne([Oe(2,k.$mE),Oe(3,r.$di),Oe(4,D.$9N),Oe(5,E.$NN),Oe(6,O.$9k),Oe(7,b.$Ar),Oe(8,v.$dD),Oe(9,C.$pv)],h)}),define(be[279],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.ExtHostConnectionType=void 0;var k;(function(C){C[C.IPC=1]="IPC",C[C.Socket=2]="Socket",C[C.MessagePort=3]="MessagePort"})(k||(e.ExtHostConnectionType=k={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(E){this.pipeName=E,this.type=1}serialize(E){E[O.ENV_KEY]=this.pipeName}}e.$Qm=O;class r{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(E){E[r.ENV_KEY]="1"}}e.$Rm=r;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(E){E[I.ENV_KEY]="1"}}e.$Sm=I;function D(C){delete C[O.ENV_KEY],delete C[r.ENV_KEY],delete C[I.ENV_KEY]}function S(C,E){D(E),C.serialize(E)}e.$Tm=S;function v(C){if(C[O.ENV_KEY])return w(C,new O(C[O.ENV_KEY]));if(C[r.ENV_KEY])return w(C,new r);if(C[I.ENV_KEY])return w(C,new I);throw new Error("No connection information defined in environment!")}e.$Um=v;function w(C,E){return D(C),E}}),define(be[280],ve([1,0,14]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$vm=e.$um=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(O||(e.UIKind=O={}));var r;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(r||(e.ExtensionHostExitCode=r={}));var I;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function D(w){const C=k.$ke.alloc(1);switch(w){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.$um=D;function S(w,C){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.$vm=S;var v;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(be[281],ve([1,0,5,6,13,269,280,58,38,21,4,2,206]),function(he,e,k,O,r,I,D,S,v,w,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=e.$CN=e.$BN=void 0;let h=class extends E.$Tc{constructor(d,m){super(),this.s=d,this.t=m,this.a=this.B(new O.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=C.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=m.createLogger(this.m,{id:v.$Ro,name:(0,b.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(m.onDidChangeLogLevel(f=>{(0,r.$qj)(f)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===r.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,m,f){const u=this.getTelemetryDetails(),l=new $(m,f,d,this.n,this.j,this.getBuiltInCommonProperties(d),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}),t=this.r.get(d.identifier.value)??[];return this.r.set(d.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(d,m,f){this.f=d,this.g=m,this.c=f??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(d){const m=Object.create(null);switch(m["common.extname"]=`${d.publisher}.${d.name}`,m["common.extversion"]=d.version,m["common.vscodemachineid"]=this.s.telemetryInfo.machineId,m["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,m["common.sqmid"]=this.s.telemetryInfo.sqmId,m["common.vscodeversion"]=this.s.version,m["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),m["common.product"]=this.s.environment.appHost,this.s.uiKind){case D.UIKind.Web:m["common.uikind"]="web";break;case D.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,S.$cl)((0,v.$Xo)(this.s.remote.authority)),m}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const m=this.getTelemetryDetails();this.r.forEach((f,u)=>{const l=f.filter(t=>!t.isDisposed);l.length===0?this.r.delete(u):this.r.set(u,l)}),this.r.forEach(f=>{for(const u of f)u.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(d,m){const u=this.r.get(d.value)?.filter(t=>!t.isDisposed);if(!u)return this.r.delete(d.value),!1;let l=!1;for(const t of u)t.ignoreUnhandledExtHostErrors||(t.logError(m),l=!0);return l}};e.$BN=h,e.$BN=h=Ne([Oe(0,I.$AN),Oe(1,r.$pj)],h);class ${static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,m,f,u,l,t,o){this.g=f,this.h=u,this.i=l,this.j=t,this.a=new O.$Wd,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.b=m?.ignoreBuiltInCommonProperties??!1,this.c=m?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(d,m){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:m},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let m="properties"in d?d.properties??{}:d;return m=(0,v.$1o)(m,[]),this.c&&(m=(0,w.$zn)(m,this.c)),this.b||(m=(0,w.$zn)(m,this.j)),"properties"in d?d.properties=m:d=m,d}k(d,m){this.f&&(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f?.sendEventData(d,m),this.h.trace(d,m))}logUsage(d,m){this.d.isUsageEnabled&&this.k(d,m)}logError(d,m){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof d=="string")this.k(d,m);else{const f={name:d.name,message:d.message,stack:d.stack,cause:d.cause},u=(0,v.$1o)(f,[]),l=new Error(u.message,{cause:u.cause});l.stack=u.stack,l.name=u.name,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f.sendErrorData(l,m),this.h.trace("exception",m)}}get apiTelemetryLogger(){if(!this.e){const d=this,m={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(m)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let d=this.f;this.f=void 0,Promise.resolve(d.flush()).then(d=void 0),this.e=void 0}else this.f=void 0}}e.$CN=$;function c(g){const d=Date.now()-new Date(g).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.$DN=c,e.$EN=(0,k.$7h)("IExtHostTelemetry")}),define(be[282],ve([1,0,6,4,36,235,35,5]),function(he,e,k,O,r,I,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PF=e.$OF=e.$NF=e.ActivationKind=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.ExtensionHostStartup=e.$HF=e.$GF=e.$FF=e.$EF=void 0,e.$EF=Object.freeze({identifier:new D.$mm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$FF="extensions.webWorker",e.$GF=(0,S.$7h)("extensionService");class v{constructor(l){this.dependency=l}}e.$HF=v;var w;(function(u){u[u.EagerAutoStart=1]="EagerAutoStart",u[u.EagerManualStart=2]="EagerManualStart",u[u.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class C{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,o){this.c=l,this.d=t.slice(0),this.e=o.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$pF.createActivationEventsMap(this.d)}}set(l,t,o){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const n=[],s=[],i=[],a=[],p=E(this.d),L=E(t),P=(se,G)=>se.extensionLocation.toString()===G.extensionLocation.toString()||se.isBuiltin===G.isBuiltin||se.isUserBuiltin===G.isUserBuiltin||se.isUnderDevelopment===G.isUnderDevelopment;for(const se of this.d){const G=L.get(se.identifier);if(!G){n.push(se.identifier),p.delete(se.identifier);continue}if(!P(se,G)){n.push(se.identifier),p.delete(se.identifier);continue}}for(const se of t){const G=p.get(se.identifier);if(!G){s.push(se);continue}if(!P(G,se)){n.push(G.identifier),p.delete(G.identifier);continue}}const y=new D.$nm(this.e),A=new D.$nm(o);for(const se of this.e)A.has(se)||i.push(se);for(const se of o)y.has(se)||a.push(se);const M=I.$pF.createActivationEventsMap(s),_={versionId:l,toRemove:n,toAdd:s,addActivationEvents:M,myToRemove:i,myToAdd:a};return this.delta(_),_}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:o,myToRemove:n,myToAdd:s}=l,i=new D.$nm(t),a=new D.$nm(n);for(let p=0;p<this.d.length;p++)i.has(this.d[p].identifier)&&(this.d.splice(p,1),p--);for(let p=0;p<this.e.length;p++)a.has(this.e[p])&&(this.e.splice(p,1),p--);for(const p of o)this.d.push(p);for(const p of s)this.e.push(p);return this.f=null,l}containsExtension(l){for(const t of this.e)if(D.$mm.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const o=I.$pF.readActivationEvents(t);for(const n of o)l.add(n)}return l}}e.$IF=C;function E(u){const l=new D.$om;for(const t of u)l.set(t.identifier,t);return l}function b(u,l){return u.enabledApiProposals?u.enabledApiProposals.includes(l):!1}e.$JF=b;function h(u,l){if(!b(u,l))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.$KF=h;class ${constructor(l,t,o,n){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=n}}e.$LF=$;class c{constructor(l,t){this.description=l,this.value=t}}e.$MF=c;var g;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function d(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,r.$7o)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}e.$NF=d;function m(u,l){return{identifier:new D.$mm((0,r.$5o)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!l,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform}}e.$OF=m;class f{constructor(){this.onDidRegisterExtensions=k.Event.None,this.onDidChangeExtensionsStatus=k.Event.None,this.onDidChangeExtensions=k.Event.None,this.onWillActivateByEvent=k.Event.None,this.onDidChangeResponsiveChange=k.Event.None,this.onWillStop=k.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$PF=f}),define(be[283],ve([1,0,35,209,55]),function(he,e,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IO=void 0;function I(D,S,v,w){const C=new k.$om;return D.forEach(E=>{const b=C.get(E.identifier);b&&w.warn((0,O.localize)(0,null,b.extensionLocation.fsPath,E.extensionLocation.fsPath)),C.set(E.identifier,E)}),S.forEach(E=>{const b=C.get(E.identifier);if(b)if(b.isBuiltin){if(r.gte(b.version,E.version)){w.warn(`Skipping extension ${E.extensionLocation.path} in favour of the builtin extension ${b.extensionLocation.path}.`);return}E.isBuiltin=!0}else w.warn((0,O.localize)(1,null,b.extensionLocation.fsPath,E.extensionLocation.fsPath));else if(E.isBuiltin){w.warn(`Skipping obsolete builtin extension ${E.extensionLocation.path}`);return}C.set(E.identifier,E)}),v.forEach(E=>{w.info((0,O.localize)(2,null,E.extensionLocation.fsPath));const b=C.get(E.identifier);b&&b.isBuiltin&&(E.isBuiltin=!0),C.set(E.identifier,E)}),Array.from(C.values())}e.$IO=I}),define(be[284],ve([1,0,7,3,29,4,42,53,69,59,283,12]),function(he,e,k,O,r,I,D,S,v,w,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=e.$LO=void 0;class b{constructor(c,g,d,m,f,u,l){this.c=c,this.d=d,this.f=m,this.g=f,this.h=u,this.i=l,this.a=Promise.resolve(),this.b=Promise.resolve();const t=g.args["install-builtin-extension"];if(t){f.trace("Installing builtin extensions passed via args...");const n={isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]};D.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=c.installExtensions([],this.j(t),n,!!g.args.force).then(()=>{D.mark("code/server/didInstallBuiltinExtensions"),f.trace("Finished installing builtin extensions")},s=>{f.error(s)})}const o=g.args["install-extension"];o&&(f.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>c.installExtensions(this.j(o),[],{isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"],isApplicationScoped:!0},!!g.args.force)).then(()=>{f.trace("Finished installing extensions")},n=>{f.error(n)}))}j(c){return c.map(g=>/\.vsix$/i.test(g)?I.URI.file((0,k.$ic)(g)?g:(0,k.$jc)((0,r.cwd)(),g)):g)}whenExtensionsReady(){return this.b}async scanExtensions(c,g,d,m){D.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${c}`),await this.a;const f=d?d.filter(l=>l.scheme===E.Schemas.file).map(l=>l.fsPath):void 0;g=g??this.d.defaultProfile.extensionsResource;const u=await this.k(g,c??O.$w,f,m);return this.g.trace("Scanned Extensions",u),this.r(u),D.mark("code/server/didScanExtensions"),u}async scanSingleExtension(c,g,d){await this.a;const m=c.scheme===E.Schemas.file?c.fsPath:null;if(!m)return null;const f=await this.o(m,g,d??O.$w);return f?(this.r([f]),f):null}async k(c,g,d,m){await this.q(g,m);const[f,u,l]=await Promise.all([this.m(g),this.n(c,g),this.l(g,d)]);return(0,C.$IO)(f,u,l,this.g)}async l(c,g){return g?(await Promise.all(g.map(d=>this.f.scanOneOrMultipleExtensions(I.URI.file((0,k.$kc)(d)),1,{language:c})))).flat().map(d=>(0,w.$4p)(d,!0)):[]}async m(c){return(await this.f.scanSystemExtensions({language:c,useCache:!0})).map(d=>(0,w.$4p)(d,!1))}async n(c,g){return(await this.f.scanUserExtensions({profileLocation:c,language:g,useCache:!0})).map(m=>(0,w.$4p)(m,!1))}async o(c,g,d){const m=I.URI.file((0,k.$kc)(c)),f=g?0:1,u=await this.f.scanExistingExtension(m,f,{language:d});return u?(0,w.$4p)(u,!1):null}async q(c,g){if(!(c===O.$g||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(m=>m.id===c)){this.g.trace(`Language Pack ${c} is already installed. Skipping language pack installation.`);return}}catch(d){this.g.error(d)}if(!g){this.g.trace(`No language pack id provided for language ${c}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${g} for language ${c} is not installed. It will be installed now.`);try{await this.c.installExtensions([g],[],{isMachineScoped:!0},!0)}catch(d){this.g.error(d)}}}r(c){const g=(t,o)=>t.replace(/file/g,"vscode-remote"),d=t=>{let o="";return o+=t.global?"g":"",o+=t.ignoreCase?"i":"",o+=t.multiline?"m":"",new RegExp(g(t.source,!0),o)},m=new class{mapDefined(t){return v.$0i.create(t)}mapNot(t){return v.$cj.create(t)}mapEquals(t,o){return t==="resourceScheme"&&typeof o=="string"?v.$$i.create(t,g(o,!1)):v.$$i.create(t,o)}mapNotEquals(t,o){return t==="resourceScheme"&&typeof o=="string"?v.$bj.create(t,g(o,!1)):v.$bj.create(t,o)}mapGreater(t,o){return v.$dj.create(t,o)}mapGreaterEquals(t,o){return v.$ej.create(t,o)}mapSmaller(t,o){return v.$fj.create(t,o)}mapSmallerEquals(t,o){return v.$gj.create(t,o)}mapRegex(t,o){return t==="resourceScheme"&&o?v.$hj.create(t,d(o)):v.$hj.create(t,o)}mapIn(t,o){return v.$_i.create(t,o)}mapNotIn(t,o){return v.$aj.create(t,o)}},f=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const o=v.$5i.deserialize(t.when);if(!o)return;const n=o.map(m);t.when=n.serialize()},u=t=>{if(Array.isArray(t))for(const o of t)f(o);else f(t)},l=t=>{for(const o in t)u(t[o])};c.forEach(t=>{t.contributes&&(t.contributes.menus&&l(t.contributes.menus),t.contributes.keybindings&&u(t.contributes.keybindings),t.contributes.views&&l(t.contributes.views))})}}e.$LO=b;class h{constructor(c,g){this.a=c,this.b=g}listen(c,g){throw new Error("Invalid listen")}async call(c,g,d){const m=this.b(c);switch(g){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const f=d[0],u=d[1]?I.URI.revive(m.transformIncoming(d[1])):void 0,l=Array.isArray(d[2])?d[2].map(n=>I.URI.revive(m.transformIncoming(n))):void 0,t=d[3];return(await this.a.scanExtensions(f,u,l,t)).map(n=>(0,S.$7m)(n,m))}case"scanSingleExtension":{const f=await this.a.scanSingleExtension(I.URI.revive(m.transformIncoming(d[0])),d[1],d[2]);return f?(0,S.$7m)(f,m):null}}throw new Error("Invalid call")}}e.$MO=h}),define(be[136],ve([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uv=e.$Tv=e.$Sv=e.$Rv=void 0;class k{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++k.count}}e.$Rv=k;const O=[];function r(S){const v=new k(S);return O[v.nid]=v,v}e.$Sv=r;function I(S){return O[S].sid}e.$Tv=I;class D{constructor(v){this.value=v}}e.$Uv=D}),define(be[285],ve([1,0,136]),function(he,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.$fL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$eL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var r;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(r||(e.TabInputKind=r={}));var I;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var D;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(D||(e.WebviewEditorCapabilities=D={}));var S;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(S||(e.WebviewMessageArrayBufferViewType=S={}));var v;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var w;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var C;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(C||(e.CandidatePortSource=C={}));class E{static{this.a=0}static mixin(g){return g._id=E.a++,g}}e.$eL=E;var b;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var h;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(h||(e.ISuggestResultDtoField=h={}));var $;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$fL={MainThreadAuthentication:(0,k.$Sv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.$Sv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,k.$Sv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,k.$Sv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,k.$Sv)("MainThreadChatVariables"),MainThreadClipboard:(0,k.$Sv)("MainThreadClipboard"),MainThreadCommands:(0,k.$Sv)("MainThreadCommands"),MainThreadComments:(0,k.$Sv)("MainThreadComments"),MainThreadConfiguration:(0,k.$Sv)("MainThreadConfiguration"),MainThreadConsole:(0,k.$Sv)("MainThreadConsole"),MainThreadDebugService:(0,k.$Sv)("MainThreadDebugService"),MainThreadDecorations:(0,k.$Sv)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.$Sv)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.$Sv)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.$Sv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.$Sv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.$Sv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.$Sv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.$Sv)("MainThreadEditorTabs"),MainThreadErrors:(0,k.$Sv)("MainThreadErrors"),MainThreadTreeViews:(0,k.$Sv)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.$Sv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,k.$Sv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.$Sv)("MainThreadLanguages"),MainThreadLogger:(0,k.$Sv)("MainThreadLogger"),MainThreadMessageService:(0,k.$Sv)("MainThreadMessageService"),MainThreadOutputService:(0,k.$Sv)("MainThreadOutputService"),MainThreadProgress:(0,k.$Sv)("MainThreadProgress"),MainThreadQuickDiff:(0,k.$Sv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,k.$Sv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.$Sv)("MainThreadStatusBar"),MainThreadSecretState:(0,k.$Sv)("MainThreadSecretState"),MainThreadStorage:(0,k.$Sv)("MainThreadStorage"),MainThreadSpeech:(0,k.$Sv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,k.$Sv)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.$Sv)("MainThreadTerminalService"),MainThreadWebviews:(0,k.$Sv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.$Sv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.$Sv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.$Sv)("MainThreadCustomEditors"),MainThreadUrls:(0,k.$Sv)("MainThreadUrls"),MainThreadUriOpeners:(0,k.$Sv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,k.$Sv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,k.$Sv)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.$Sv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,k.$Sv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,k.$Sv)("MainThreadExtensionService"),MainThreadSCM:(0,k.$Sv)("MainThreadSCM"),MainThreadSearch:(0,k.$Sv)("MainThreadSearch"),MainThreadShare:(0,k.$Sv)("MainThreadShare"),MainThreadTask:(0,k.$Sv)("MainThreadTask"),MainThreadWindow:(0,k.$Sv)("MainThreadWindow"),MainThreadLabelService:(0,k.$Sv)("MainThreadLabelService"),MainThreadNotebook:(0,k.$Sv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.$Sv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.$Sv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.$Sv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.$Sv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.$Sv)("MainThreadInteractive"),MainThreadChat:(0,k.$Sv)("MainThreadChat"),MainThreadInlineChat:(0,k.$Sv)("MainThreadInlineChatShape"),MainThreadTheming:(0,k.$Sv)("MainThreadTheming"),MainThreadTunnelService:(0,k.$Sv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,k.$Sv)("MainThreadManagedSockets"),MainThreadTimeline:(0,k.$Sv)("MainThreadTimeline"),MainThreadTesting:(0,k.$Sv)("MainThreadTesting"),MainThreadLocalization:(0,k.$Sv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,k.$Sv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,k.$Sv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,k.$Sv)("MainThreadIssueReporter")},e.$gL={ExtHostCommands:(0,k.$Sv)("ExtHostCommands"),ExtHostConfiguration:(0,k.$Sv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.$Sv)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.$Sv)("ExtHostDebugService"),ExtHostDecorations:(0,k.$Sv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.$Sv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.$Sv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.$Sv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.$Sv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.$Sv)("ExtHostEditors"),ExtHostTreeViews:(0,k.$Sv)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.$Sv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.$Sv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.$Sv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.$Sv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.$Sv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.$Sv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,k.$Sv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,k.$Sv)("ExtHostStatusBar"),ExtHostShare:(0,k.$Sv)("ExtHostShare"),ExtHostExtensionService:(0,k.$Sv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.$Sv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.$Sv)("ExtHostTerminalService"),ExtHostSCM:(0,k.$Sv)("ExtHostSCM"),ExtHostSearch:(0,k.$Sv)("ExtHostSearch"),ExtHostTask:(0,k.$Sv)("ExtHostTask"),ExtHostWorkspace:(0,k.$Sv)("ExtHostWorkspace"),ExtHostWindow:(0,k.$Sv)("ExtHostWindow"),ExtHostWebviews:(0,k.$Sv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.$Sv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.$Sv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.$Sv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.$Sv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.$Sv)("ExtHostEditorTabs"),ExtHostProgress:(0,k.$Sv)("ExtHostProgress"),ExtHostComments:(0,k.$Sv)("ExtHostComments"),ExtHostSecretState:(0,k.$Sv)("ExtHostSecretState"),ExtHostStorage:(0,k.$Sv)("ExtHostStorage"),ExtHostUrls:(0,k.$Sv)("ExtHostUrls"),ExtHostUriOpeners:(0,k.$Sv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,k.$Sv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,k.$Sv)("ExtHostOutputService"),ExtHostLabelService:(0,k.$Sv)("ExtHostLabelService"),ExtHostNotebook:(0,k.$Sv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.$Sv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.$Sv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.$Sv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.$Sv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,k.$Sv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,k.$Sv)("ExtHostInteractive"),ExtHostInlineChat:(0,k.$Sv)("ExtHostInlineChatShape"),ExtHostChat:(0,k.$Sv)("ExtHostChat"),ExtHostChatAgents2:(0,k.$Sv)("ExtHostChatAgents"),ExtHostChatVariables:(0,k.$Sv)("ExtHostChatVariables"),ExtHostChatProvider:(0,k.$Sv)("ExtHostChatProvider"),ExtHostSpeech:(0,k.$Sv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,k.$Sv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,k.$Sv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,k.$Sv)("ExtHostTheming"),ExtHostTunnelService:(0,k.$Sv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,k.$Sv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,k.$Sv)("ExtHostAuthentication"),ExtHostTimeline:(0,k.$Sv)("ExtHostTimeline"),ExtHostTesting:(0,k.$Sv)("ExtHostTesting"),ExtHostTelemetry:(0,k.$Sv)("ExtHostTelemetry"),ExtHostLocalization:(0,k.$Sv)("ExtHostLocalization"),ExtHostIssueReporter:(0,k.$Sv)("ExtHostIssueReporter")}}),define(be[286],ve([1,0,14,24,12,109,5]),function(he,e,k,O,r,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5I=e.$4I=e.$3I=e.$2I=void 0,e.$2I=(0,D.$7h)("notebookDocumentService");const S=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${S.join("")}]+`),w=7;function C(h){if(h.scheme!==r.Schemas.vscodeNotebookCell)return;const $=h.fragment.indexOf("s");if($<0)return;const c=parseInt(h.fragment.substring(0,$).replace(v,""),w),g=(0,k.$De)(h.fragment.substring($+1)).toString();if(!isNaN(c))return{handle:c,notebook:h.with({scheme:g,fragment:null})}}e.$3I=C;function E(h,$){const c=$.toString(w),d=`${c.length<S.length?S[c.length-1]:"z"}${c}s${(0,k.$Ee)(k.$ke.fromString(h.scheme),!0,!0)}`;return h.with({scheme:r.Schemas.vscodeNotebookCell,fragment:d})}e.$4I=E;class b{constructor(){this.a=new O.$Ac}getNotebook($){if($.scheme===r.Schemas.vscodeNotebookCell){const c=C($);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get($)}addNotebookDocument($){this.a.set($.uri,$)}removeNotebookDocument($){this.a.delete($.uri)}}e.$5I=b,(0,I.$Zr)(e.$2I,b,1)}),define(be[137],ve([1,0,14,80,49,65,12,7,3,69,286]),function(he,e,k,O,r,I,D,S,v,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.CellStatusbarAlignment=e.$gJ=e.$fJ=e.$eJ=e.NotebookEditorPriority=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_I=e.$$I=e.$0I=e.$9I=e.CellKind=e.$8I=e.$7I=e.$6I=void 0,e.$6I="workbench.editor.notebook",e.$7I="workbench.editor.notebookTextDiffEditor",e.$8I="workbench.editor.interactive";var E;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(E||(e.CellKind=E={})),e.$9I=["application/json","application/javascript","text/html","image/svg+xml",I.$gs.latex,I.$gs.markdown,"image/png","image/jpeg",I.$gs.text],e.$0I=[I.$gs.latex,I.$gs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$gs.text],e.$$I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_I="_notAvailable";var b;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(b||(e.NotebookRunState=b={}));var h;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(h||(e.NotebookCellExecutionState=h={}));var $;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var c;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var d;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var m;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(m||(e.SelectionStateType=m={}));var f;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(f||(e.CellEditType=f={}));var u;(function(Z){Z.scheme=D.Schemas.vscodeNotebookCell;function X(ne,me){return(0,C.$4I)(ne,me)}Z.generate=X;function te(ne){return(0,C.$3I)(ne)}Z.parse=te;function V(ne,me){return ne.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${ne.scheme!==D.Schemas.file?ne.scheme:""}`})}Z.generateCellOutputUri=V;function W(ne){if(ne.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!me)return;const z=me[1]&&me[1]!==""?me[1]:void 0,H=me[2];return{outputId:z,notebook:ne.with({scheme:H||D.Schemas.file,fragment:null})}}Z.parseCellOutputUri=W;function re(ne,me,z){return Z.generate(ne,me).with({scheme:z})}Z.generateCellPropertyUri=re;function ue(ne,me){if(ne.scheme===me)return Z.parse(ne.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=ue})(u||(e.CellUri=u={}));const l=Z=>v.$i?Z.replace(/\//g,"\\"):Z;class t{constructor(X=[],te=e.$9I){this.e=te,this.d=[...new Set(X)].map(V=>({pattern:V,matches:O.$Nj(l(V))}))}sort(X){const te=new Map(r.Iterable.map(X,W=>[W,l(W)]));let V=[];for(const{matches:W}of this.d)for(const[re,ue]of te)if(W(ue)){V.push(re),te.delete(re);break}return te.size&&(V=V.concat([...te.keys()].sort((W,re)=>this.e.indexOf(W)-this.e.indexOf(re)))),V}prioritize(X,te){const V=this.f(X);if(V===-1){this.d.unshift({pattern:X,matches:O.$Nj(l(X))});return}const W=new Set(te.map(ue=>this.f(ue,V)));W.delete(-1);const re=Array.from(W).sort();this.d.splice(V+1,0,...re.map(ue=>this.d[ue]));for(let ue=re.length-1;ue>=0;ue--)this.d.splice(re[ue],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,te=this.d.length){const V=l(X);for(let W=0;W<te;W++)if(this.d[W].matches(V))return W;return-1}}e.$aJ=t;function o(Z,X,te,V=(W,re)=>W===re){const W=[];function re(me,z,H){if(z===0&&H.length===0)return;const R=W[W.length-1];R&&R.start+R.deleteCount===me?(R.deleteCount+=z,R.toInsert.push(...H)):W.push({start:me,deleteCount:z,toInsert:H})}let ue=0,ne=0;for(;;){if(ue===Z.length){re(ue,0,X.slice(ne));break}if(ne===X.length){re(ue,Z.length-ue,[]);break}const me=Z[ue],z=X[ne];if(V(me,z)){ue+=1,ne+=1;continue}te(z)?(re(ue,1,[]),ue+=1):(re(ue,0,[z]),ne+=1)}return W}e.$bJ=o,e.$cJ=new w.$lj("notebookEditorCursorAtBoundary","none"),e.$dJ=new w.$lj("notebookEditorCursorAtLineBoundary","none");var n;(function(Z){Z.default="default",Z.option="option"})(n||(e.NotebookEditorPriority=n={}));function s(Z){const X=Z;return!!((typeof X.include=="string"||O.$Oj(X.include))&&(typeof X.exclude=="string"||O.$Oj(X.exclude)))}e.$eJ=s;function i(Z,X,te){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(X)>=0||Z.viewType===X)return!0;if(Z.filenamePattern){const V=s(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,W=s(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(O.$Mj(V,(0,S.$nc)(te.fsPath).toLowerCase()))return!(W&&O.$Mj(W,(0,S.$nc)(te.fsPath).toLowerCase()))}return!1}e.$fJ=i,e.$gJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var a;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class p{static{this.d="notebook/"}static create(X){return`${p.d}${X}`}static parse(X){if(X.startsWith(p.d))return X.substring(p.d.length)}}e.$hJ=p;function L(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}e.$iJ=L;const P=new TextDecoder;function y(Z){const X=[];let te=!1;for(const ue of Z)(X.length===0||te)&&(X.push(ue),te=!0);let V=_(X);const W=k.$ke.concat(X.map(ue=>k.$ke.wrap(ue))),re=K(W);return V=V||re.byteLength!==W.byteLength,{data:re,didCompression:V}}e.$jJ=y,e.$kJ=`${String.fromCharCode(27)}[A`;const A=e.$kJ.split("").map(Z=>Z.charCodeAt(0)),M=10;function _(Z){let X=!1;return Z.forEach((te,V)=>{if(V===0||te.length<e.$kJ.length)return;const W=Z[V-1],re=te.subarray(0,e.$kJ.length);if(re[0]===A[0]&&re[1]===A[1]&&re[2]===A[2]){const ue=W.lastIndexOf(M);if(ue===-1)return;X=!0,Z[V-1]=W.subarray(0,ue),Z[V]=te.subarray(e.$kJ.length)}}),X}function se(Z){let X=Z;do Z=X,X=Z.replace(/[^\n]\x08/gm,"");while(X.length<Z.length);return Z}function G(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const X=Z.match(/^(.*)\r+/m)[1];let te=Z.match(/\r+(.*)$/m)[1];te=te+X.slice(te.length,X.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,te)}return Z}const oe="\b".charCodeAt(0),ee="\r".charCodeAt(0);function K(Z){return!Z.buffer.includes(oe)&&!Z.buffer.includes(ee)?Z:k.$ke.fromString(G(se(P.decode(Z.buffer))))}}),define(be[138],ve([1,0,18,10,100,24,65,17,11,4,22,35,16,118,137]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$){"use strict";var c,g,d,m,f,u,l,t,o,n,s,i,a,p,L,P,y;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$_M=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$$M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TestRunProfileKind=e.TestResultState=e.$QM=e.$PM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$OM=e.NotebookVariablesRequestKind=e.$NM=e.$MM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$LM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.ColorThemeKind=e.$FM=e.$EM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$DM=e.$CM=e.DebugConsoleMode=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$wM=e.$vM=e.FileChangeType=e.$uM=e.$tM=e.$sM=e.$rM=e.InlineCompletionTriggerKind=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.ConfigurationTarget=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$7L=e.ViewBadge=e.ProgressLocation=e.$6L=e.$5L=e.TaskScope=e.ShellQuoting=e.$4L=e.$3L=e.$2L=e.TaskPanelKind=e.TaskRevealKind=e.$1L=e.TerminalLocation=e.$ZL=e.$YL=e.$XL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$WL=e.$VL=e.$UL=e.$TL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$SL=e.StatusBarAlignment=e.ViewColumn=e.$RL=e.$QL=e.$PL=e.$OL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$NL=e.$ML=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.LanguageStatusSeverity=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.CodeActionTriggerKind=e.$AL=e.$zL=e.SymbolTag=e.SymbolKind=e.$yL=e.$xL=e.DocumentHighlightKind=e.$wL=e.$vL=e.$uL=e.$tL=e.DiagnosticSeverity=e.DiagnosticTag=e.$sL=e.$rL=e.FileEditType=e.$qL=e.$pL=e.$oL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function A(j){return Object.assign(j,{apply:function(...le){if(le.length===0)return Reflect.construct(j,[]);{const we=le.length===1?[]:le[1];return Reflect.construct(j,we,le[0].constructor)}},call:function(...le){if(le.length===0)return Reflect.construct(j,[]);{const[we,...Ue]=le;return Reflect.construct(j,Ue,we.constructor)}}})}var M;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(M||(e.TerminalOutputAnchor=M={}));var _;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(_||(e.TerminalQuickFixType=_={}));let se=c=class{static from(...F){let le=F;return new c(function(){if(le){for(const we of le)we&&typeof we.dispose=="function"&&we.dispose();le=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$hL=se,e.$hL=se=c=Ne([A],se);let G=g=class{static Min(...F){if(F.length===0)throw new TypeError;let le=F[0];for(let we=1;we<F.length;we++){const Ue=F[we];Ue.isBefore(le)&&(le=Ue)}return le}static Max(...F){if(F.length===0)throw new TypeError;let le=F[0];for(let we=1;we<F.length;we++){const Ue=F[we];Ue.isAfter(le)&&(le=Ue)}return le}static isPosition(F){if(!F)return!1;if(F instanceof g)return!0;const{line:le,character:we}=F;return typeof le=="number"&&typeof we=="number"}static of(F){if(F instanceof g)return F;if(this.isPosition(F))return new g(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,le){if(F<0)throw(0,O.$7)("line must be non-negative");if(le<0)throw(0,O.$7)("character must be non-negative");this.c=F,this.e=le}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,le=0){if(F===null||le===null)throw(0,O.$7)();let we;return typeof F>"u"?we=0:typeof F=="number"?we=F:(we=typeof F.lineDelta=="number"?F.lineDelta:0,le=typeof F.characterDelta=="number"?F.characterDelta:0),we===0&&le===0?this:new g(this.line+we,this.character+le)}with(F,le=this.character){if(F===null||le===null)throw(0,O.$7)();let we;return typeof F>"u"?we=this.line:typeof F=="number"?we=F:(we=typeof F.line=="number"?F.line:this.line,le=typeof F.character=="number"?F.character:this.character),we===this.line&&le===this.character?this:new g(we,le)}toJSON(){return{line:this.line,character:this.character}}};e.$iL=G,e.$iL=G=g=Ne([A],G);let oe=d=class{static isRange(F){return F instanceof d?!0:F?G.isPosition(F.start)&&G.isPosition(F.end):!1}static of(F){if(F instanceof d)return F;if(this.isRange(F))return new d(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,le,we,Ue){let Je,_e;if(typeof F=="number"&&typeof le=="number"&&typeof we=="number"&&typeof Ue=="number"?(Je=new G(F,le),_e=new G(we,Ue)):G.isPosition(F)&&G.isPosition(le)&&(Je=G.of(F),_e=G.of(le)),!Je||!_e)throw new Error("Invalid arguments");Je.isBefore(_e)?(this.c=Je,this.e=_e):(this.c=_e,this.e=Je)}contains(F){return d.isRange(F)?this.contains(F.start)&&this.contains(F.end):G.isPosition(F)?!(G.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const le=G.Max(F.start,this.c),we=G.Min(F.end,this.e);if(!le.isAfter(we))return new d(le,we)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const le=G.Min(F.start,this.c),we=G.Max(F.end,this.end);return new d(le,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,le=this.end){if(F===null||le===null)throw(0,O.$7)();let we;return F?G.isPosition(F)?we=F:(we=F.start||this.start,le=F.end||this.end):we=this.start,we.isEqual(this.c)&&le.isEqual(this.end)?this:new d(we,le)}toJSON(){return[this.start,this.end]}};e.$jL=oe,e.$jL=oe=d=Ne([A],oe);let ee=m=class extends oe{static isSelection(F){return F instanceof m?!0:F?oe.isRange(F)&&G.isPosition(F.anchor)&&G.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,le,we,Ue){let Je,_e;if(typeof F=="number"&&typeof le=="number"&&typeof we=="number"&&typeof Ue=="number"?(Je=new G(F,le),_e=new G(we,Ue)):G.isPosition(F)&&G.isPosition(le)&&(Je=G.of(F),_e=G.of(le)),!Je||!_e)throw new Error("Invalid arguments");super(Je,_e),this.f=Je,this.g=_e}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$kL=ee,e.$kL=ee=m=Ne([A],ee);const K=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,O.$7)("connectionToken")};class Z{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,le,we){if(typeof F!="string"||F.length===0)throw(0,O.$7)("host");if(typeof le!="number"||le===0||Math.round(le)!==le)throw(0,O.$7)("port");typeof we<"u"&&K(we),this.host=F,this.port=Math.round(le),this.connectionToken=we}}e.$lL=Z;class X{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,le){this.makeConnection=F,this.connectionToken=le,typeof le<"u"&&K(le)}}e.$mL=X;class te extends Error{static NotAvailable(F,le){return new te(F,h.RemoteAuthorityResolverErrorCode.NotAvailable,le)}static TemporarilyNotAvailable(F){return new te(F,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,le=h.RemoteAuthorityResolverErrorCode.Unknown,we){super(F),this._message=F,this._code=le,this._detail=we,Object.setPrototypeOf(this,te.prototype)}}e.$nL=te;var V;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(V||(e.EndOfLine=V={}));var W;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(W||(e.EnvironmentVariableMutatorType=W={}));let re=f=class{static isTextEdit(F){return F instanceof f?!0:F?oe.isRange(F)&&typeof F.newText=="string":!1}static replace(F,le){return new f(F,le)}static insert(F,le){return f.replace(new oe(F,F),le)}static delete(F){return f.replace(F,"")}static setEndOfLine(F){const le=new f(new oe(new G(0,0),new G(0,0)),"");return le.newEol=F,le}get range(){return this.c}set range(F){if(F&&!oe.isRange(F))throw(0,O.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,O.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,O.$7)("newEol");this.f=F}constructor(F,le){this.c=F,this.e=le}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$oL=re,e.$oL=re=f=Ne([A],re);let ue=u=class{static isNotebookCellEdit(F){return F instanceof u?!0:F?Mt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,le){return new u(F,le)}static insertCells(F,le){return new u(new Mt(F,F),le)}static deleteCells(F){return new u(F,[])}static updateCellMetadata(F,le){const we=new u(new Mt(F,F),[]);return we.newCellMetadata=le,we}static updateNotebookMetadata(F){const le=new u(new Mt(0,0),[]);return le.newNotebookMetadata=F,le}constructor(F,le){this.range=F,this.newCells=le}};e.$pL=ue,e.$pL=ue=u=Ne([A],ue);class ne{static isSnippetTextEdit(F){return F instanceof ne?!0:F?oe.isRange(F.range)&&H.isSnippetString(F.snippet):!1}static replace(F,le){return new ne(F,le)}static insert(F,le){return ne.replace(new oe(F,F),le)}constructor(F,le){this.range=F,this.snippet=le}}e.$qL=ne;var me;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(me||(e.FileEditType=me={}));let z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,le,we,Ue){this.c.push({_type:1,from:F,to:le,options:we,metadata:Ue})}createFile(F,le,we){this.c.push({_type:1,from:void 0,to:F,options:le,metadata:we})}deleteFile(F,le,we){this.c.push({_type:1,from:F,to:void 0,options:le,metadata:we})}e(F,le,we){this.c.push({_type:3,metadata:we,uri:F,edit:{editType:5,metadata:le},notebookMetadata:le})}f(F,le,we,Ue){const Je=le.start,_e=le.end;(Je!==_e||we.length>0)&&this.c.push({_type:5,uri:F,index:Je,count:_e-Je,cells:we,metadata:Ue})}g(F,le,we,Ue){this.c.push({_type:3,metadata:Ue,uri:F,edit:{editType:3,index:le,metadata:we}})}replace(F,le,we,Ue){this.c.push({_type:2,uri:F,edit:new re(le,we),metadata:Ue})}insert(F,le,we,Ue){this.replace(F,new oe(le,le),we,Ue)}delete(F,le,we){this.replace(F,le,"",we)}has(F){return this.c.some(le=>le._type===2&&le.uri.toString()===F.toString())}set(F,le){if(le)for(const we of le){if(!we)continue;let Ue,Je;Array.isArray(we)?(Ue=we[0],Je=we[1]):Ue=we,ue.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(F,Ue.range.start,Ue.newCellMetadata,Je):Ue.newNotebookMetadata?this.e(F,Ue.newNotebookMetadata,Je):this.f(F,Ue.range,Ue.newCells,Je):ne.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:F,range:Ue.range,edit:Ue.snippet,metadata:Je}):this.c.push({_type:2,uri:F,edit:Ue,metadata:Je})}else{for(let we=0;we<this.c.length;we++){const Ue=this.c[we];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===F.toString()&&(this.c[we]=void 0);break}}(0,k.$Ib)(this.c)}}get(F){const le=[];for(const we of this.c)we._type===2&&we.uri.toString()===F.toString()&&le.push(we.edit);return le}entries(){const F=new I.$Ac;for(const le of this.c)if(le._type===2){let we=F.get(le.uri);we||(we=[le.uri,[]],F.set(le.uri,we)),we[1].push(le.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$rL=z,e.$rL=z=Ne([A],z);let H=l=class{static isSnippetString(F){return F instanceof l?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=l.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,le=this.e++){if(typeof F=="function"){const we=new l;we.e=this.e,F(we),this.e=we.e,F=we.value}else F=l.c(F);return this.value+="${",this.value+=le,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,le=this.e++){const we=F.map(Ue=>Ue.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=le,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(F,le){if(typeof le=="function"){const we=new l;we.e=this.e,le(we),this.e=we.e,le=we.value}else typeof le=="string"&&(le=le.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,le&&(this.value+=":",this.value+=le),this.value+="}",this}};e.$sL=H,e.$sL=H=l=Ne([A],H);var R;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(R||(e.DiagnosticTag=R={}));var U;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(U||(e.DiagnosticSeverity=U={}));let x=t=class{static isLocation(F){return F instanceof t?!0:F?oe.isRange(F.range)&&w.URI.isUri(F.uri):!1}constructor(F,le){if(this.uri=F,le)if(oe.isRange(le))this.range=oe.of(le);else if(G.isPosition(le))this.range=new oe(le,le);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$tL=x,e.$tL=x=t=Ne([A],x);let J=class{static is(F){return F?typeof F.message=="string"&&F.location&&oe.isRange(F.location.range)&&w.URI.isUri(F.location.uri):!1}constructor(F,le){this.location=F,this.message=le}static isEqual(F,le){return F===le?!0:!F||!le?!1:F.message===le.message&&F.location.range.isEqual(le.location.range)&&F.location.uri.toString()===le.location.uri.toString()}};e.$uL=J,e.$uL=J=Ne([A],J);let Y=class{constructor(F,le,we=U.Error){if(!oe.isRange(F))throw new TypeError("range must be set");if(!le)throw new TypeError("message must be set");this.range=F,this.message=le,this.severity=we}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,le){return F===le?!0:!F||!le?!1:F.message===le.message&&F.severity===le.severity&&F.code===le.code&&F.severity===le.severity&&F.source===le.source&&F.range.isEqual(le.range)&&(0,k.$ub)(F.tags,le.tags)&&(0,k.$ub)(F.relatedInformation,le.relatedInformation,J.isEqual)}};e.$vL=Y,e.$vL=Y=Ne([A],Y);let B=class{constructor(F,le){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=le}};e.$wL=B,e.$wL=B=Ne([A],B);var T;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(T||(e.DocumentHighlightKind=T={}));let N=class{constructor(F,le=T.Text){this.range=F,this.kind=le}toJSON(){return{range:this.range,kind:T[this.kind]}}};e.$xL=N,e.$xL=N=Ne([A],N);let q=class{constructor(F,le){this.uri=F,this.highlights=le}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$yL=q,e.$yL=q=Ne([A],q);var ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var ae;(function(j){j[j.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let ge=o=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,le,we,Ue,Je){this.name=F,this.kind=le,this.containerName=Je,typeof we=="string"&&(this.containerName=we),Ue instanceof x?this.location=Ue:we instanceof oe&&(this.location=new x(Ue,we)),o.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$zL=ge,e.$zL=ge=o=Ne([A],ge);let ce=n=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(n.validate)}constructor(F,le,we,Ue,Je){this.name=F,this.detail=le,this.kind=we,this.range=Ue,this.selectionRange=Je,this.children=[],n.validate(this)}};e.$AL=ce,e.$AL=ce=n=Ne([A],ce);var pe;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(pe||(e.CodeActionTriggerKind=pe={}));let ye=class{constructor(F,le){this.title=F,this.kind=le}};e.$BL=ye,e.$BL=ye=Ne([A],ye);let Ce=class{static{s=this}static{this.c="."}constructor(F){this.value=F}append(F){return new s(this.value?this.value+s.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+s.c)}};e.$CL=Ce,e.$CL=Ce=s=Ne([A],Ce),Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll"),Ce.Notebook=Ce.Empty.append("notebook");let Re=class{constructor(F,le){if(this.range=F,this.parent=le,le&&!le.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$DL=Re,e.$DL=Re=Ne([A],Re);class $e{constructor(F,le,we,Ue,Je,_e){this.kind=F,this.name=le,this.detail=we,this.uri=Ue,this.range=Je,this.selectionRange=_e}}e.$EL=$e;class De{constructor(F,le){this.fromRanges=le,this.from=F}}e.$FL=De;class ke{constructor(F,le){this.fromRanges=le,this.to=F}}e.$GL=ke;var Me;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Me||(e.LanguageStatusSeverity=Me={}));let je=class{constructor(F,le){this.range=F,this.command=le}get isResolved(){return!!this.command}};e.$HL=je,e.$HL=je=Ne([A],je);let He=i=class{#e;static isMarkdownString(F){return F instanceof i?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,le=!1){this.#e=new r.$ik(F,{supportThemeIcons:le})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,le){return this.#e.appendCodeblock(le??"",F),this}};e.$IL=He,e.$IL=He=i=Ne([A],He);let qe=class{constructor(F,le){this.label=F,this.documentation=le}};e.$JL=qe,e.$JL=qe=Ne([A],qe);let Xe=class{constructor(F,le){this.label=F,this.documentation=le,this.parameters=[]}};e.$KL=Xe,e.$KL=Xe=Ne([A],Xe);let Ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$LL=Ze,e.$LL=Ze=Ne([A],Ze);var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var tt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let de=class{constructor(F){this.value=F}};e.$ML=de,e.$ML=de=Ne([A],de);let Pe=class{constructor(F,le,we){this.position=F,this.label=le,this.kind=we}};e.$NL=Pe,e.$NL=Pe=Ne([A],Pe);var Ae;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae||(e.CompletionTriggerKind=Ae={}));var Te;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Te||(e.CompletionItemKind=Te={}));var Fe;(function(j){j[j.Deprecated=1]="Deprecated"})(Fe||(e.CompletionItemTag=Fe={}));let ze=class{constructor(F,le){this.label=F,this.kind=le}toJSON(){return{label:this.label,kind:this.kind&&Te[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$OL=ze,e.$OL=ze=Ne([A],ze);let Ve=class{constructor(F=[],le=!1){this.items=F,this.isIncomplete=le}};e.$PL=Ve,e.$PL=Ve=Ne([A],Ve);let Ge=class{constructor(F,le,we){this.insertText=F,this.range=le,this.command=we}};e.$QL=Ge,e.$QL=Ge=Ne([A],Ge);let Qe=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$RL=Qe,e.$RL=Qe=Ne([A],Qe);var nt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var Ye;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ye||(e.StatusBarAlignment=Ye={}));function it(j,F){return`${E.$mm.toKey(j)}.${F}`}e.$SL=it;var rt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(rt||(e.TextEditorLineNumbersStyle=rt={}));var ut;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(ut||(e.TextDocumentSaveReason=ut={}));var ct;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ct||(e.TextEditorRevealType=ct={}));var ht;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ht||(e.TextEditorSelectionChangeKind=ht={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Tt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Tt||(e.DecorationRangeBehavior=Tt={})),function(j){function F(le){switch(le){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=F}(ht||(e.TextEditorSelectionChangeKind=ht={}));var Dt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Dt||(e.SyntaxTokenType=Dt={})),function(j){function F(le){switch(le){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=F}(Dt||(e.SyntaxTokenType=Dt={}));let Ct=class{constructor(F,le){if(le&&!w.URI.isUri(le))throw(0,O.$7)("target");if(!oe.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.target=le}};e.$TL=Ct,e.$TL=Ct=Ne([A],Ct);let pt=class{constructor(F,le,we,Ue){this.red=F,this.green=le,this.blue=we,this.alpha=Ue}};e.$UL=pt,e.$UL=pt=Ne([A],pt);let St=class{constructor(F,le){if(le&&!(le instanceof pt))throw(0,O.$7)("color");if(!oe.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.color=le}};e.$VL=St,e.$VL=St=Ne([A],St);let bt=class{constructor(F){if(!F||typeof F!="string")throw(0,O.$7)("label");this.label=F}};e.$WL=bt,e.$WL=bt=Ne([A],bt);var dt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(dt||(e.ColorFormat=dt={}));var Ut;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ut||(e.SourceControlInputBoxValidationType=Ut={}));var Ft;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));class st{constructor(F,le,we){if(this.startIndex=F,this.length=le,this.tooltip=we,typeof F!="number"||F<0)throw(0,O.$7)("startIndex");if(typeof le!="number"||le<1)throw(0,O.$7)("length");if(we!==void 0&&typeof we!="string")throw(0,O.$7)("tooltip")}}e.$XL=st;class mt{constructor(F){this.uri=F}}e.$YL=mt;class wt{constructor(F){this.terminalCommand=F}}e.$ZL=wt;var At;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class qt{constructor(F){if(this.options=F,typeof F!="object")throw(0,O.$7)("options")}}e.$1L=qt;var Nt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Nt||(e.TaskRevealKind=Nt={}));var zt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(zt||(e.TaskPanelKind=zt={}));let Lt=class{static{a=this}static{this.Clean=new a("clean","Clean")}static{this.Build=new a("build","Build")}static{this.Rebuild=new a("rebuild","Rebuild")}static{this.Test=new a("test","Test")}static from(F){switch(F){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}constructor(F,le){if(this.label=le,typeof F!="string"||typeof le!="string")throw(0,O.$7)("name");this.c=F}get id(){return this.c}};e.$2L=Lt,e.$2L=Lt=a=Ne([A],Lt);function Ot(j){let F="";for(let le=0;le<j.length;le++)F+=j[le].replace(/,/g,",,")+",";return F}let Et=class{constructor(F,le,we){if(typeof F!="string")throw(0,O.$7)("process");this.e=[],this.c=F,le!==void 0&&(Array.isArray(le)?(this.e=le,this.f=we):this.f=le)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,O.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const le of this.e)F.push(le);return Ot(F)}};e.$3L=Et,e.$3L=Et=Ne([A],Et);let gt=class{constructor(F,le,we){if(this.f=[],Array.isArray(le)){if(!F)throw(0,O.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F,this.f=le,this.g=we}else{if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F,this.g=le}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const le of this.f)F.push(typeof le=="string"?le:le.value);return Ot(F)}};e.$4L=gt,e.$4L=gt=Ne([A],gt);var Vt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Vt||(e.ShellQuoting=Vt={}));var Bt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Bt||(e.TaskScope=Bt={}));class Gt{constructor(F){this.c=F}computeId(){return"customExecution"+(0,C.$rg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$5L=Gt;let Ht=class{static{p=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,le,we,Ue,Je,_e){this.k=!1,this.l=this.definition=F;let et;typeof le=="string"?(this.n=this.name=le,this.u=this.source=we,this.execution=Ue,et=Je,this.k=!0):le===Bt.Global||le===Bt.Workspace?(this.target=le,this.n=this.name=we,this.u=this.source=Ue,this.execution=Je,et=_e):(this.target=le,this.n=this.name=we,this.u=this.source=Ue,this.execution=Je,et=_e),typeof et=="string"?(this.q=[et],this.r=!0):Array.isArray(et)?(this.q=et,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Et?this.l={type:p.e,id:this.o.computeId()}:this.o instanceof gt?this.l={type:p.f,id:this.o.computeId()}:this.o instanceof Gt?this.l={type:p.c,id:this.o.computeId()}:this.l={type:p.g,id:(0,C.$rg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,O.$7)("Kind can't be undefined or null");this.A(),this.l=F}get scope(){return this.m}set target(F){this.A(),this.m=F}get name(){return this.n}set name(F){if(typeof F!="string")throw(0,O.$7)("name");this.A(),this.n=F}get execution(){return this.o}set execution(F){F===null&&(F=void 0),this.A(),this.o=F;const le=this.l.type;(p.g===le||p.e===le||p.f===le||p.c===le)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(F){if(Array.isArray(F))this.A(),this.q=F,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.A(),this.t=F}get source(){return this.u}set source(F){if(typeof F!="string"||F.length===0)throw(0,O.$7)("source must be a string of length > 0");this.A(),this.u=F}get group(){return this.w}set group(F){F===null&&(F=void 0),this.A(),this.w=F}get detail(){return this.z}set detail(F){F===null&&(F=void 0),this.z=F}get presentationOptions(){return this.x}set presentationOptions(F){F==null&&(F=Object.create(null)),this.A(),this.x=F}get runOptions(){return this.y}set runOptions(F){F==null&&(F=Object.create(null)),this.A(),this.y=F}};e.$6L=Ht,e.$6L=Ht=p=Ne([A],Ht);var Jt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Jt||(e.ProgressLocation=Jt={}));var Ee;(function(j){function F(le){const we=le;return(0,v.$Nf)(we.value)?we.tooltip&&!(0,v.$Jf)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}j.isViewBadge=F})(Ee||(e.ViewBadge=Ee={}));let Ie=L=class{static isTreeItem(F,le){const we=F;if(we.checkboxState!==void 0){const Ue=(0,v.$Nf)(we.checkboxState)?we.checkboxState:(0,v.$Lf)(we.checkboxState)&&(0,v.$Nf)(we.checkboxState.state)?we.checkboxState.state:void 0,Je=!(0,v.$Nf)(we.checkboxState)&&(0,v.$Lf)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==Q.Checked&&Ue!==Q.Unchecked||Je!==void 0&&!(0,v.$Jf)(Je))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}if(F instanceof L)return!0;if(we.label!==void 0&&!(0,v.$Jf)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,v.$Jf)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,v.$Jf)(we.iconPath)&&!w.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,v.$Jf)(we.iconPath.id))){const Ue=we.iconPath;if(!Ue||!(0,v.$Jf)(Ue.light)&&!w.URI.isUri(Ue.light)&&!(0,v.$Jf)(Ue.dark)&&!w.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}return we.description!==void 0&&!(0,v.$Jf)(we.description)&&typeof we.description!="boolean"?(console.log("INVALID tree item, invalid description",we.description),!1):we.resourceUri!==void 0&&!w.URI.isUri(we.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1):we.tooltip!==void 0&&!(0,v.$Jf)(we.tooltip)&&!(we.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",we.tooltip),!1):we.command!==void 0&&!we.command.command?(console.log("INVALID tree item, invalid command",we.command),!1):we.collapsibleState!==void 0&&we.collapsibleState<fe.None&&we.collapsibleState>fe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1):we.contextValue!==void 0&&!(0,v.$Jf)(we.contextValue)?(console.log("INVALID tree item, invalid contextValue",we.contextValue),!1):we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1):!0}constructor(F,le=fe.None){this.collapsibleState=le,w.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$7L=Ie,e.$7L=Ie=L=Ne([A],Ie);var fe;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(fe||(e.TreeItemCollapsibleState=fe={}));var Q;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Q||(e.TreeItemCheckboxState=Q={}));let Se=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$8L=Se,e.$8L=Se=Ne([A],Se);class Le extends Se{}e.$9L=Le;class We extends Le{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$0L=We;class Be{constructor(F,le,we,Ue){this.name=F,this.uri=le,this._itemId=we,this.c=Ue}data(){return this.c()}}e.$$L=Be;let Ke=class{#e=new Map;constructor(F){for(const[le,we]of F??[]){const Ue=this.#e.get(this.#t(le));Ue?Ue.push(we):this.#e.set(this.#t(le),[we])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,le){this.#e.set(this.#t(F),[le])}forEach(F,le){for(const[we,Ue]of this.#e)for(const Je of Ue)F.call(le,Je,we,this)}*[Symbol.iterator](){for(const[F,le]of this.#e)for(const we of le)yield[F,we]}#t(F){return F.toLowerCase()}};e.$_L=Ke,e.$_L=Ke=Ne([A],Ke);let lt=class{constructor(F){this.insertText=F}};e.$aM=lt,e.$aM=lt=Ne([A],lt);let vt=class{constructor(F,le){this.label=le,this.insertText=F}};e.$bM=vt,e.$bM=vt=Ne([A],vt);let ot=class{constructor(F,le){this.id=F,this.color=le}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$cM=ot,e.$cM=ot=Ne([A],ot),ot.File=new ot("file"),ot.Folder=new ot("folder");let at=class{constructor(F){this.id=F}};e.$dM=at,e.$dM=at=Ne([A],at);var $t;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})($t||(e.ConfigurationTarget=$t={}));let xt=class{get base(){return this.c}set base(F){this.c=F,this.e=w.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,le){if(typeof F!="string"&&(!F||!w.URI.isUri(F)&&!w.URI.isUri(F.uri)))throw(0,O.$7)("base");if(typeof le!="string")throw(0,O.$7)("pattern");typeof F=="string"?this.baseUri=w.URI.file(F):w.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=le}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eM=xt,e.$eM=xt=Ne([A],xt);const Pn=new WeakMap;function ui(j,F){Pn.set(j,F)}e.$fM=ui;let Wt=class{constructor(F,le,we,Ue){this.enabled=typeof F=="boolean"?F:!0,typeof le=="string"&&(this.condition=le),typeof we=="string"&&(this.hitCondition=we),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this.c||(this.c=Pn.get(this)??(0,C.$rg)()),this.c}};e.$gM=Wt,e.$gM=Wt=Ne([A],Wt);let _t=class extends Wt{constructor(F,le,we,Ue,Je){if(super(le,we,Ue,Je),F===null)throw(0,O.$7)("location");this.location=F}};e.$hM=_t,e.$hM=_t=Ne([A],_t);let en=class extends Wt{constructor(F,le,we,Ue,Je){super(le,we,Ue,Je),this.functionName=F}};e.$iM=en,e.$iM=en=Ne([A],en);let tn=class extends Wt{constructor(F,le,we,Ue,Je,_e,et){if(super(Ue,Je,_e,et),!le)throw(0,O.$7)("dataId");this.label=F,this.dataId=le,this.canPersist=we}};e.$jM=tn,e.$jM=tn=Ne([A],tn);let nn=class{constructor(F,le,we){this.command=F,this.args=le||[],this.options=we}};e.$kM=nn,e.$kM=nn=Ne([A],nn);let sn=class{constructor(F,le){this.port=F,this.host=le}};e.$lM=sn,e.$lM=sn=Ne([A],sn);let rn=class{constructor(F){this.path=F}};e.$mM=rn,e.$mM=rn=Ne([A],rn);let on=class{constructor(F){this.implementation=F}};e.$nM=on,e.$nM=on=Ne([A],on);let an=class{constructor(F,le,we){this.session=F,this.threadId=le,this.frameId=we}};e.$oM=an,e.$oM=an=Ne([A],an);let cn=class{constructor(F,le){this.session=F,this.threadId=le}};e.$pM=cn,e.$pM=cn=Ne([A],cn);let ln=class{constructor(F,le){this.range=F,this.expression=le}};e.$qM=ln,e.$qM=ln=Ne([A],ln);var In;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(In||(e.InlineCompletionTriggerKind=In={}));let un=class{constructor(F,le){this.range=F,this.text=le}};e.$rM=un,e.$rM=un=Ne([A],un);let hn=class{constructor(F,le,we=!0){this.range=F,this.variableName=le,this.caseSensitiveLookup=we}};e.$sM=hn,e.$sM=hn=Ne([A],hn);let fn=class{constructor(F,le){this.range=F,this.expression=le}};e.$tM=fn,e.$tM=fn=Ne([A],fn);let dn=class{constructor(F,le){this.frameId=F,this.stoppedLocation=le}};e.$uM=dn,e.$uM=dn=Ne([A],dn);var Cn;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Cn||(e.FileChangeType=Cn={}));let mn=P=class extends Error{static FileExists(F){return new P(F,b.FileSystemProviderErrorCode.FileExists,P.FileExists)}static FileNotFound(F){return new P(F,b.FileSystemProviderErrorCode.FileNotFound,P.FileNotFound)}static FileNotADirectory(F){return new P(F,b.FileSystemProviderErrorCode.FileNotADirectory,P.FileNotADirectory)}static FileIsADirectory(F){return new P(F,b.FileSystemProviderErrorCode.FileIsADirectory,P.FileIsADirectory)}static NoPermissions(F){return new P(F,b.FileSystemProviderErrorCode.NoPermissions,P.NoPermissions)}static Unavailable(F){return new P(F,b.FileSystemProviderErrorCode.Unavailable,P.Unavailable)}constructor(F,le=b.FileSystemProviderErrorCode.Unknown,we){super(w.URI.isUri(F)?F.toString(!0):F),this.code=we?.name??"Unknown",(0,b.$Gk)(this,le),Object.setPrototypeOf(this,P.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};e.$vM=mn,e.$vM=mn=P=Ne([A],mn);let gn=class{constructor(F,le,we){this.start=F,this.end=le,this.kind=we}};e.$wM=gn,e.$wM=gn=Ne([A],gn);var An;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(An||(e.FoldingRangeKind=An={}));var Ln;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ln||(e.CommentThreadCollapsibleState=Ln={}));var On;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(On||(e.CommentMode=On={}));var Rn;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Rn||(e.CommentState=Rn={}));var Fn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Fn||(e.CommentThreadState=Fn={}));class hi{constructor(F,le=[]){this.tokenTypes=F,this.tokenModifiers=le}}e.$xM=hi;function fi(j){return typeof j>"u"||(0,v.$Kf)(j)}class $n{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let le=0,we=F.tokenTypes.length;le<we;le++)this.k.set(F.tokenTypes[le],le);for(let le=0,we=F.tokenModifiers.length;le<we;le++)this.l.set(F.tokenModifiers[le],le)}}push(F,le,we,Ue,Je){if(typeof F=="number"&&typeof le=="number"&&typeof we=="number"&&typeof Ue=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.o(F,le,we,Ue,Je);if(oe.isRange(F)&&typeof le=="string"&&fi(we))return this.n(F,le,we);throw(0,O.$7)()}n(F,le,we){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(le))throw new Error("`tokenType` is not in the provided legend");const Ue=F.start.line,Je=F.start.character,_e=F.end.character-F.start.character,et=this.k.get(le);let ft=0;if(we)for(const yt of we){if(!this.l.has(yt))throw new Error("`tokenModifier` is not in the provided legend");const kt=this.l.get(yt);ft|=1<<kt>>>0}this.o(Ue,Je,_e,et,ft)}o(F,le,we,Ue,Je){if(this.f&&(F<this.c||F===this.c&&le<this.e)){this.f=!1;const ft=this.g.length/5|0;let yt=0,kt=0;for(let It=0;It<ft;It++){let Rt=this.g[5*It],Xt=this.g[5*It+1];Rt===0?(Rt=yt,Xt+=kt):Rt+=yt,this.g[5*It]=Rt,this.g[5*It+1]=Xt,yt=Rt,kt=Xt}}let _e=F,et=le;this.f&&this.j>0&&(_e-=this.c,_e===0&&(et-=this.e)),this.g[this.j++]=_e,this.g[this.j++]=et,this.g[this.j++]=we,this.g[this.j++]=Ue,this.g[this.j++]=Je,this.c=F,this.e=le}static q(F){const le=[],we=F.length/5|0;for(let et=0;et<we;et++)le[et]=et;le.sort((et,ft)=>{const yt=F[5*et],kt=F[5*ft];if(yt===kt){const It=F[5*et+1],Rt=F[5*ft+1];return It-Rt}return yt-kt});const Ue=new Uint32Array(F.length);let Je=0,_e=0;for(let et=0;et<we;et++){const ft=5*le[et],yt=F[ft+0],kt=F[ft+1],It=F[ft+2],Rt=F[ft+3],Xt=F[ft+4],li=yt-Je,zi=li===0?kt-_e:kt,Yt=5*et;Ue[Yt+0]=li,Ue[Yt+1]=zi,Ue[Yt+2]=It,Ue[Yt+3]=Rt,Ue[Yt+4]=Xt,Je=yt,_e=kt}return Ue}build(F){return this.f?new pn(new Uint32Array(this.g),F):new pn($n.q(this.g),F)}}e.$yM=$n;class pn{constructor(F,le){this.resultId=le,this.data=F}}e.$zM=pn;class di{constructor(F,le,we){this.start=F,this.deleteCount=le,this.data=we}}e.$AM=di;class mi{constructor(F,le){this.resultId=le,this.edits=F}}e.$BM=mi;var Nn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Nn||(e.DebugConsoleMode=Nn={}));class gi{constructor(F){this.name=F}}e.$CM=gi;let bn=class{static{this.Back={iconPath:new ot("arrow-left")}}constructor(){}};e.$DM=bn,e.$DM=bn=Ne([A],bn);var Mn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Mn||(e.QuickPickItemKind=Mn={}));var jn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(jn||(e.InputBoxValidationSeverity=jn={}));var Tn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Tn||(e.ExtensionKind=Tn={}));class $i{static validate(F){if(typeof F.badge=="string"){let le=(0,S.$kf)(F.badge,0);if(le<F.badge.length&&(le+=(0,S.$kf)(F.badge,le)),F.badge.length>le)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!ot.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,le,we){this.badge=F,this.tooltip=le,this.color=we}}e.$EM=$i;let wn=class{constructor(F){this.kind=F}};e.$FM=wn,e.$FM=wn=Ne([A],wn);var Un;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Un||(e.ColorThemeKind=Un={}));class Mt{static isNotebookRange(F){return F instanceof Mt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,le){if(F<0)throw(0,O.$7)("start must be positive");if(le<0)throw(0,O.$7)("end must be positive");F<=le?(this.c=F,this.e=le):(this.c=le,this.e=F)}with(F){let le=this.c,we=this.e;return F.start!==void 0&&(le=F.start),F.end!==void 0&&(we=F.end),le===this.c&&we===this.e?this:new Mt(le,we)}}e.$GM=Mt;class Zt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(le=>Zt.isNotebookCellData(le))}static isNotebookCellData(F){return!0}constructor(F,le,we,Ue,Je,_e,et){this.kind=F,this.value=le,this.languageId=we,this.mime=Ue,this.outputs=Je??[],this.metadata=_e,this.executionSummary=et,Zt.validate(this)}}e.$HM=Zt;class pi{constructor(F){this.cells=F}}e.$IM=pi;class Pt{static isNotebookCellOutputItem(F){return F instanceof Pt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const le={name:F.name,message:F.message,stack:F.stack};return Pt.json(le,"application/vnd.code.notebook.error")}static stdout(F){return Pt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Pt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,le="application/octet-stream"){return new Pt(F,le)}static#e=new TextEncoder;static text(F,le=D.$gs.text){const we=Pt.#e.encode(String(F));return new Pt(we,le)}static json(F,le="text/x-json"){const we=JSON.stringify(F,void 0,"	");return Pt.text(we,le)}constructor(F,le){this.data=F,this.mime=le;const we=(0,D.$ks)(le,!0);if(!we)throw new Error(`INVALID mime type: ${le}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.$JM=Pt;class Qt{static isNotebookCellOutput(F){return F instanceof Qt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,le=!1){const we=new Set,Ue=new Set;for(let Je=0;Je<F.length;Je++){const _e=F[Je],et=(0,D.$ks)(_e.mime);if(!we.has(et)||(0,$.$iJ)(et)){we.add(et);continue}Ue.add(Je),le&&console.warn(`DUPLICATED mime type '${_e.mime}' will be dropped`)}return Ue.size===0?F:F.filter((Je,_e)=>!Ue.has(_e))}constructor(F,le,we){this.items=Qt.ensureUniqueMimeTypes(F,!0),typeof le=="string"?(this.id=le,this.metadata=we):(this.id=(0,C.$rg)(),this.metadata=le??we)}}e.$KM=Qt;var zn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(zn||(e.NotebookCellKind=zn={}));var Bn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Bn||(e.NotebookCellExecutionState=Bn={}));var qn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(qn||(e.NotebookCellStatusBarAlignment=qn={}));var Hn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Hn||(e.NotebookEditorRevealType=Hn={}));class bi{constructor(F,le){this.text=F,this.alignment=le}}e.$LM=bi;var Wn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Wn||(e.NotebookControllerAffinity=Wn={}));var Vn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(Vn||(e.NotebookControllerAffinity2=Vn={}));class wi{constructor(F,le=[]){this.uri=F,this.provides=(0,k.$3b)(le)}}e.$MM=wi;class vi{constructor(F){this.label=F}}e.$NM=vi;var Gn;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(Gn||(e.NotebookVariablesRequestKind=Gn={}));let vn=class{constructor(F,le){this.label=F,this.timestamp=le}};e.$OM=vn,e.$OM=vn=Ne([A],vn);var Jn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Jn||(e.ExtensionMode=Jn={}));var Xn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Xn||(e.ExtensionRuntime=Xn={}));var Yn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Yn||(e.StandardTokenType=Yn={}));class yi{constructor(F,le){this.ranges=F,this.wordPattern=le}}e.$PM=yi;class Ei{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$QM=Ei;var Zn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Zn||(e.TestResultState=Zn={}));var Qn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Qn||(e.TestRunProfileKind=Qn={}));let yn=class{constructor(F=void 0,le=void 0,we=void 0,Ue=!1){this.include=F,this.exclude=le,this.profile=we,this.continuous=Ue}};e.$RM=yn,e.$RM=yn=Ne([A],yn);let En=y=class{static diff(F,le,we){const Ue=new y(F);return Ue.expectedOutput=le,Ue.actualOutput=we,Ue}constructor(F){this.message=F}};e.$SM=En,e.$SM=En=y=Ne([A],En);let kn=class{constructor(F){this.id=F}};e.$TM=kn,e.$TM=kn=Ne([A],kn);class Kt{constructor(F,le){this.covered=F,this.total=le}}e.$UM=Kt;const Dn=j=>{if(j&&j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`)};class Sn{static fromDetails(F,le){const we=new Kt(0,0),Ue=new Kt(0,0),Je=new Kt(0,0);for(const et of le)if("branches"in et){we.total+=1,we.covered+=et.executionCount>0?1:0;for(const ft of et.branches)Ue.total+=1,Ue.covered+=ft.executionCount>0?1:0}else Je.total+=1,Je.covered+=et.executionCount>0?1:0;const _e=new Sn(F,we,Ue.total>0?Ue:void 0,Je.total>0?Je:void 0);return _e.detailedCoverage=le,_e}constructor(F,le,we,Ue){this.uri=F,this.statementCoverage=le,this.branchCoverage=we,this.functionCoverage=Ue,Dn(le),Dn(we),Dn(Ue)}}e.$VM=Sn;class ki{constructor(F,le,we=[]){this.executionCount=F,this.location=le,this.branches=we}}e.$WM=ki;class Di{constructor(F,le,we){this.executionCount=F,this.location=le,this.label=we}}e.$XM=Di;class Si{constructor(F,le,we){this.name=F,this.executionCount=le,this.location=we}}e.$YM=Si;var Kn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Kn||(e.ExternalUriOpenerPriority=Kn={}));var xn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(xn||(e.WorkspaceTrustState=xn={}));var _n;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(_n||(e.PortAutoForwardAction=_n={}));class Pi{constructor(F,le,we,Ue,Je,_e){this.kind=F,this.name=le,this.detail=we,this.uri=Ue,this.range=Je,this.selectionRange=_e}}e.$ZM=Pi;class Ii{constructor(F){this.uri=F}}e.$1M=Ii;class Ci{constructor(F,le){this.original=F,this.modified=le}}e.$2M=Ci;class Ai{constructor(F,le,we,Ue){this.base=F,this.input1=le,this.input2=we,this.result=Ue}}e.$3M=Ai;class Li{constructor(F,le){this.uri=F,this.viewType=le}}e.$4M=Li;class Oi{constructor(F){this.viewType=F}}e.$5M=Oi;class Ri{constructor(F,le){this.uri=F,this.notebookType=le}}e.$6M=Ri;class Fi{constructor(F,le,we){this.original=F,this.modified=le,this.notebookType=we}}e.$7M=Fi;class Ni{constructor(){}}e.$8M=Ni;class Mi{constructor(F,le){this.uri=F,this.inputBoxUri=le}}e.$9M=Mi;class ji{constructor(F){this.providerId=F}}e.$0M=ji;var ei;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(ei||(e.InteractiveSessionVoteDirection=ei={}));var ti;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(ti||(e.ChatAgentCopyKind=ti={}));var ni;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(ni||(e.ChatVariableLevel=ni={}));class Ti{constructor(F,le){this.label=F,this.values=le}}e.$$M=Ti;var ii;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(ii||(e.InteractiveEditorResponseFeedbackKind=ii={}));var si;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(si||(e.ChatMessageRole=si={}));class Ui{constructor(F,le){this.role=F,this.content=le}}e.$_M=Ui;var ri;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(ri||(e.ChatAgentResultFeedbackKind=ri={}));var oi;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(oi||(e.RelatedInformationType=oi={}));var ai;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(ai||(e.SpeechToTextStatus=ai={}));var ci;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(ci||(e.KeywordRecognitionStatus=ci={}))}),define(be[139],ve([1,0,18,14,154,76,100,24,146,52,65,21,11,4,43,176,231,133,93,137,73,94,135,282,138]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$jN=e.$iN=e.MarkdownString=e.$hN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var s;(function(Ee){function Ie(Q){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:We,positionColumn:Be}=Q,Ke=new n.$iL(Se-1,Le-1),lt=new n.$iL(We-1,Be-1);return new n.$kL(Ke,lt)}Ee.to=Ie;function fe(Q){const{anchor:Se,active:Le}=Q;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Ee.from=fe})(s||(e.Selection=s={}));var i;(function(Ee){function Ie(Q){if(!Q)return;const{start:Se,end:Le}=Q;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Ee.from=Ie;function fe(Q){if(!Q)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:We,endColumn:Be}=Q;return new n.$jL(Se-1,Le-1,We-1,Be-1)}Ee.to=fe})(i||(e.Range=i={}));var a;(function(Ee){function Ie(fe){return new n.$tL(h.URI.revive(fe.uri),i.to(fe.range))}Ee.to=Ie})(a||(e.Location=a={}));var p;(function(Ee){function Ie(fe){switch(fe){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Ee.to=Ie})(p||(e.TokenType=p={}));var L;(function(Ee){function Ie(Q){return new n.$iL(Q.lineNumber-1,Q.column-1)}Ee.to=Ie;function fe(Q){return{lineNumber:Q.line+1,column:Q.character+1}}Ee.from=fe})(L||(e.Position=L={}));var P;(function(Ee){function Ie(Se,Le,We){return(0,k.$Hb)((0,k.$3b)(Se).map(Be=>fe(Be,Le,We)))}Ee.from=Ie;function fe(Se,Le,We){if(typeof Se=="string")return{$serialized:!0,language:Se,isBuiltin:We?.isBuiltin};if(Se)return{$serialized:!0,language:Se.language,scheme:Q(Se.scheme,Le),pattern:ze.from(Se.pattern)??void 0,exclusive:Se.exclusive,notebookType:Se.notebookType,isBuiltin:We?.isBuiltin}}function Q(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(P||(e.DocumentSelector=P={}));var y;(function(Ee){function Ie(Q){switch(Q){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Ee.from=Ie;function fe(Q){switch(Q){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Ee.to=fe})(y||(e.DiagnosticTag=y={}));var A;(function(Ee){function Ie(Q){let Se;return Q.code&&((0,b.$Jf)(Q.code)||(0,b.$Nf)(Q.code)?Se=String(Q.code):Se={value:String(Q.code.value),target:Q.code.target}),{...i.from(Q.range),message:Q.message,source:Q.source,code:Se,severity:_.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(M.from),tags:Array.isArray(Q.tags)?(0,k.$Hb)(Q.tags.map(y.from)):void 0}}Ee.from=Ie;function fe(Q){const Se=new n.$vL(i.to(Q),Q.message,_.to(Q.severity));return Se.source=Q.source,Se.code=(0,b.$Jf)(Q.code)?Q.code:Q.code?.value,Se.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(M.to),Se.tags=Q.tags&&(0,k.$Hb)(Q.tags.map(y.to)),Se}Ee.to=fe})(A||(e.Diagnostic=A={}));var M;(function(Ee){function Ie(Q){return{...i.from(Q.location.range),message:Q.message,resource:Q.location.uri}}Ee.from=Ie;function fe(Q){return new n.$uL(new n.$tL(Q.resource,i.to(Q)),Q.message)}Ee.to=fe})(M||(e.DiagnosticRelatedInformation=M={}));var _;(function(Ee){function Ie(Q){switch(Q){case n.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ee.from=Ie;function fe(Q){switch(Q){case g.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Ee.to=fe})(_||(e.DiagnosticSeverity=_={}));var se;(function(Ee){function Ie(Q){return typeof Q=="number"&&Q>=n.ViewColumn.One?Q-1:Q===n.ViewColumn.Beside?t.$fD:t.$eD}Ee.from=Ie;function fe(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=fe})(se||(e.ViewColumn=se={}));function G(Ee){return typeof Ee.range<"u"}function oe(Ee){return Ee.length===0?!0:!!G(Ee[0])}e.$hN=oe;var ee;(function(Ee){function Ie(Be){return Be.map(Ee.from)}Ee.fromMany=Ie;function fe(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function Q(Be){let Ke;if(fe(Be)){const{language:at,value:$t}=Be;Ke={value:"```"+at+`
`+$t+"\n```\n"}}else n.$IL.isMarkdownString(Be)?Ke={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ke={value:Be}:Ke={value:""};const lt=Object.create(null);Ke.uris=lt;const vt=at=>{try{let $t=h.URI.parse(at,!0);$t=$t.with({query:Se($t.query,lt)}),lt[at]=$t}catch{}return""},ot=new v.marked.Renderer;return ot.link=vt,ot.image=at=>typeof at=="string"?vt(D.$qk(at).href):"",(0,v.marked)(Ke.value,{renderer:ot}),Ke}Ee.from=Q;function Se(Be,Ke){if(!Be)return Be;let lt;try{lt=(0,w.$Ch)(Be)}catch{}if(!lt)return Be;let vt=!1;return lt=(0,E.$yn)(lt,ot=>{if(h.URI.isUri(ot)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ke[at]=ot,vt=!0,at}else return}),vt?JSON.stringify(lt):Be}function Le(Be){const Ke=new n.$IL(Be.value,Be.supportThemeIcons);return Ke.isTrusted=Be.isTrusted,Ke.supportHtml=Be.supportHtml,Ke.baseUri=Be.baseUri?h.URI.from(Be.baseUri):void 0,Ke}Ee.to=Le;function We(Be){if(Be)return typeof Be=="string"?Be:Ee.from(Be)}Ee.fromStrict=We})(ee||(e.MarkdownString=ee={}));function K(Ee){return oe(Ee)?Ee.map(Ie=>({range:i.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?ee.fromMany(Ie.hoverMessage):Ie.hoverMessage?ee.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Ee.map(Ie=>({range:i.from(Ie)}))}e.$iN=K;function Z(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?h.URI.file(Ee):Ee}e.$jN=Z;var X;(function(Ee){function Ie(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?Z(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Ee.from=Ie})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var te;(function(Ee){function Ie(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?Z(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?X.from(fe.before):void 0,after:fe.after?X.from(fe.after):void 0}}Ee.from=Ie})(te||(e.ThemableDecorationRenderOptions=te={}));var V;(function(Ee){function Ie(fe){if(typeof fe>"u")return fe;switch(fe){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ie})(V||(e.DecorationRangeBehavior=V={}));var W;(function(Ee){function Ie(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?V.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?te.from(fe.light):void 0,dark:fe.dark?te.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?Z(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?X.from(fe.before):void 0,after:fe.after?X.from(fe.after):void 0}}Ee.from=Ie})(W||(e.DecorationRenderOptions=W={}));var re;(function(Ee){function Ie(Q){return{text:Q.newText,eol:Q.newEol&&de.from(Q.newEol),range:i.from(Q.range)}}Ee.from=Ie;function fe(Q){const Se=new n.$oL(i.to(Q.range),Q.text);return Se.newEol=typeof Q.eol>"u"?void 0:de.to(Q.eol),Se}Ee.to=fe})(re||(e.TextEdit=re={}));var ue;(function(Ee){function Ie(Q,Se){const Le={edits:[]};if(Q instanceof n.$rL){const We=new S.$Bc;for(const Be of Q._allEntries())Be._type===1&&h.URI.isUri(Be.to)&&Be.from===void 0&&We.add(Be.to);for(const Be of Q._allEntries())if(Be._type===1){let Ke;Be.options?.contents&&(ArrayBuffer.isView(Be.options.contents)?Ke={type:"base64",value:(0,O.$Ee)(O.$ke.wrap(Be.options.contents))}:Ke={type:"dataTransferItem",id:Be.options.contents._itemId}),Le.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contents:Ke},metadata:Be.metadata})}else Be._type===2?Le.edits.push({resource:Be.uri,textEdit:re.from(Be.edit),versionId:We.has(Be.uri)?void 0:Se?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Le.edits.push({resource:Be.uri,textEdit:{range:i.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:We.has(Be.uri)?void 0:Se?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Le.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Se?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Le.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Se?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(ut.from)}})}return Le}Ee.from=Ie;function fe(Q){const Se=new n.$rL,Le=new S.$Ac;for(const We of Q.edits)if(We.textEdit){const Be=We,Ke=h.URI.revive(Be.resource),lt=i.to(Be.textEdit.range),vt=Be.textEdit.text,ot=Be.textEdit.insertAsSnippet;let at;ot?at=n.$qL.replace(lt,new n.$sL(vt)):at=n.$oL.replace(lt,vt);const $t=Le.get(Ke);$t?$t.push(at):Le.set(Ke,[at])}else Se.renameFile(h.URI.revive(We.oldResource),h.URI.revive(We.newResource),We.options);for(const[We,Be]of Le)Se.set(We,Be);return Se}Ee.to=fe})(ue||(e.WorkspaceEdit=ue={}));var ne;(function(Ee){const Ie=Object.create(null);Ie[n.SymbolKind.File]=0,Ie[n.SymbolKind.Module]=1,Ie[n.SymbolKind.Namespace]=2,Ie[n.SymbolKind.Package]=3,Ie[n.SymbolKind.Class]=4,Ie[n.SymbolKind.Method]=5,Ie[n.SymbolKind.Property]=6,Ie[n.SymbolKind.Field]=7,Ie[n.SymbolKind.Constructor]=8,Ie[n.SymbolKind.Enum]=9,Ie[n.SymbolKind.Interface]=10,Ie[n.SymbolKind.Function]=11,Ie[n.SymbolKind.Variable]=12,Ie[n.SymbolKind.Constant]=13,Ie[n.SymbolKind.String]=14,Ie[n.SymbolKind.Number]=15,Ie[n.SymbolKind.Boolean]=16,Ie[n.SymbolKind.Array]=17,Ie[n.SymbolKind.Object]=18,Ie[n.SymbolKind.Key]=19,Ie[n.SymbolKind.Null]=20,Ie[n.SymbolKind.EnumMember]=21,Ie[n.SymbolKind.Struct]=22,Ie[n.SymbolKind.Event]=23,Ie[n.SymbolKind.Operator]=24,Ie[n.SymbolKind.TypeParameter]=25;function fe(Se){return typeof Ie[Se]=="number"?Ie[Se]:6}Ee.from=fe;function Q(Se){for(const Le in Ie)if(Ie[Le]===Se)return Number(Le);return n.SymbolKind.Property}Ee.to=Q})(ne||(e.SymbolKind=ne={}));var me;(function(Ee){function Ie(Q){switch(Q){case n.SymbolTag.Deprecated:return 1}}Ee.from=Ie;function fe(Q){switch(Q){case 1:return n.SymbolTag.Deprecated}}Ee.to=fe})(me||(e.SymbolTag=me={}));var z;(function(Ee){function Ie(Q){return{name:Q.name,kind:ne.from(Q.kind),tags:Q.tags&&Q.tags.map(me.from),containerName:Q.containerName,location:J.from(Q.location)}}Ee.from=Ie;function fe(Q){const Se=new n.$zL(Q.name,ne.to(Q.kind),Q.containerName,J.to(Q.location));return Se.tags=Q.tags&&Q.tags.map(me.to),Se}Ee.to=fe})(z||(e.WorkspaceSymbol=z={}));var H;(function(Ee){function Ie(Q){const Se={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:i.from(Q.range),selectionRange:i.from(Q.selectionRange),kind:ne.from(Q.kind),tags:Q.tags?.map(me.from)??[]};return Q.children&&(Se.children=Q.children.map(Ie)),Se}Ee.from=Ie;function fe(Q){const Se=new n.$AL(Q.name,Q.detail,ne.to(Q.kind),i.to(Q.range),i.to(Q.selectionRange));return(0,k.$Lb)(Q.tags)&&(Se.tags=Q.tags.map(me.to)),Q.children&&(Se.children=Q.children.map(fe)),Se}Ee.to=fe})(H||(e.DocumentSymbol=H={}));var R;(function(Ee){function Ie(Q){const Se=new n.$EL(ne.to(Q.kind),Q.name,Q.detail||"",h.URI.revive(Q.uri),i.to(Q.range),i.to(Q.selectionRange));return Se._sessionId=Q._sessionId,Se._itemId=Q._itemId,Se}Ee.to=Ie;function fe(Q,Se,Le){if(Se=Se??Q._sessionId,Le=Le??Q._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:Q.name,detail:Q.detail,kind:ne.from(Q.kind),uri:Q.uri,range:i.from(Q.range),selectionRange:i.from(Q.selectionRange),tags:Q.tags?.map(me.from)}}Ee.from=fe})(R||(e.CallHierarchyItem=R={}));var U;(function(Ee){function Ie(fe){return new n.$FL(R.to(fe.from),fe.fromRanges.map(Q=>i.to(Q)))}Ee.to=Ie})(U||(e.CallHierarchyIncomingCall=U={}));var x;(function(Ee){function Ie(fe){return new n.$GL(R.to(fe.to),fe.fromRanges.map(Q=>i.to(Q)))}Ee.to=Ie})(x||(e.CallHierarchyOutgoingCall=x={}));var J;(function(Ee){function Ie(Q){return{range:Q.range&&i.from(Q.range),uri:Q.uri}}Ee.from=Ie;function fe(Q){return new n.$tL(h.URI.revive(Q.uri),i.to(Q.range))}Ee.to=fe})(J||(e.location=J={}));var Y;(function(Ee){function Ie(Q){const Se=Q,Le=Q;return{originSelectionRange:Se.originSelectionRange?i.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:i.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?i.from(Se.targetSelectionRange):void 0}}Ee.from=Ie;function fe(Q){return{targetUri:h.URI.revive(Q.uri),targetRange:i.to(Q.range),targetSelectionRange:Q.targetSelectionRange?i.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?i.to(Q.originSelectionRange):void 0}}Ee.to=fe})(Y||(e.DefinitionLink=Y={}));var B;(function(Ee){function Ie(Q){return{range:i.from(Q.range),contents:ee.fromMany(Q.contents)}}Ee.from=Ie;function fe(Q){return new n.$wL(Q.contents.map(ee.to),i.to(Q.range))}Ee.to=fe})(B||(e.Hover=B={}));var T;(function(Ee){function Ie(Q){return{range:i.from(Q.range),expression:Q.expression}}Ee.from=Ie;function fe(Q){return new n.$qM(i.to(Q.range),Q.expression)}Ee.to=fe})(T||(e.EvaluatableExpression=T={}));var N;(function(Ee){function Ie(Q){if(Q instanceof n.$rM)return{type:"text",range:i.from(Q.range),text:Q.text};if(Q instanceof n.$sM)return{type:"variable",range:i.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof n.$tM)return{type:"expression",range:i.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ie;function fe(Q){switch(Q.type){case"text":return{range:i.to(Q.range),text:Q.text};case"variable":return{range:i.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:i.to(Q.range),expression:Q.expression}}}Ee.to=fe})(N||(e.InlineValue=N={}));var q;(function(Ee){function Ie(Q){return{frameId:Q.frameId,stoppedLocation:i.from(Q.stoppedLocation)}}Ee.from=Ie;function fe(Q){return new n.$uM(Q.frameId,i.to(Q.stoppedLocation))}Ee.to=fe})(q||(e.InlineValueContext=q={}));var ie;(function(Ee){function Ie(Q){return{range:i.from(Q.range),kind:Q.kind}}Ee.from=Ie;function fe(Q){return new n.$xL(i.to(Q.range),Q.kind)}Ee.to=fe})(ie||(e.DocumentHighlight=ie={}));var ae;(function(Ee){function Ie(Q){return{uri:Q.uri,highlights:Q.highlights.map(ie.from)}}Ee.from=Ie;function fe(Q){return new n.$yL(h.URI.revive(Q.uri),Q.highlights.map(ie.to))}Ee.to=fe})(ae||(e.MultiDocumentHighlight=ae={}));var ge;(function(Ee){function Ie(fe){switch(fe){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Ee.to=Ie})(ge||(e.CompletionTriggerKind=ge={}));var ce;(function(Ee){function Ie(fe){return{triggerKind:ge.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Ee.to=Ie})(ce||(e.CompletionContext=ce={}));var pe;(function(Ee){function Ie(Q){switch(Q){case n.CompletionItemTag.Deprecated:return 1}}Ee.from=Ie;function fe(Q){switch(Q){case 1:return n.CompletionItemTag.Deprecated}}Ee.to=fe})(pe||(e.CompletionItemTag=pe={}));var ye;(function(Ee){const Ie=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function fe(Le){return Ie.get(Le)??9}Ee.from=fe;const Q=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Se(Le){return Q.get(Le)??n.CompletionItemKind.Property}Ee.to=Se})(ye||(e.CompletionItemKind=ye={}));var Ce;(function(Ee){function Ie(fe,Q){const Se=new n.$OL(fe.label);return Se.insertText=fe.insertText,Se.kind=ye.to(fe.kind),Se.tags=fe.tags?.map(pe.to),Se.detail=fe.detail,Se.documentation=D.$kk(fe.documentation)?ee.to(fe.documentation):fe.documentation,Se.sortText=fe.sortText,Se.filterText=fe.filterText,Se.preselect=fe.preselect,Se.commitCharacters=fe.commitCharacters,$.$Vs.isIRange(fe.range)?Se.range=i.to(fe.range):typeof fe.range=="object"&&(Se.range={inserting:i.to(fe.range.insert),replacing:i.to(fe.range.replace)}),Se.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Se.insertText=new n.$sL(fe.insertText):(Se.insertText=fe.insertText,Se.textEdit=Se.range instanceof n.$jL?new n.$oL(Se.range,Se.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Se.additionalTextEdits=fe.additionalTextEdits.map(Le=>re.to(Le))),Se.command=Q&&fe.command?Q.fromInternal(fe.command):void 0,Se}Ee.to=Ie})(Ce||(e.CompletionItem=Ce={}));var Re;(function(Ee){function Ie(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:ee.fromStrict(Q.documentation)}}Ee.from=Ie;function fe(Q){return{label:Q.label,documentation:D.$kk(Q.documentation)?ee.to(Q.documentation):Q.documentation}}Ee.to=fe})(Re||(e.ParameterInformation=Re={}));var $e;(function(Ee){function Ie(Q){return{label:Q.label,documentation:ee.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(Re.from):[],activeParameter:Q.activeParameter}}Ee.from=Ie;function fe(Q){return{label:Q.label,documentation:D.$kk(Q.documentation)?ee.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Re.to):[],activeParameter:Q.activeParameter}}Ee.to=fe})($e||(e.SignatureInformation=$e={}));var De;(function(Ee){function Ie(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map($e.from):[]}}Ee.from=Ie;function fe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map($e.to):[]}}Ee.to=fe})(De||(e.SignatureHelp=De={}));var ke;(function(Ee){function Ie(fe,Q){const Se=new n.$NL(L.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(Me.to.bind(void 0,fe)),Q.kind&&je.to(Q.kind));return Se.textEdits=Q.textEdits&&Q.textEdits.map(re.to),Se.tooltip=D.$kk(Q.tooltip)?ee.to(Q.tooltip):Q.tooltip,Se.paddingLeft=Q.paddingLeft,Se.paddingRight=Q.paddingRight,Se}Ee.to=Ie})(ke||(e.InlayHint=ke={}));var Me;(function(Ee){function Ie(fe,Q){const Se=new n.$ML(Q.label);return Se.tooltip=D.$kk(Q.tooltip)?ee.to(Q.tooltip):Q.tooltip,c.Command.is(Q.command)&&(Se.command=fe.fromInternal(Q.command)),Q.location&&(Se.location=J.to(Q.location)),Se}Ee.to=Ie})(Me||(e.InlayHintLabelPart=Me={}));var je;(function(Ee){function Ie(Q){return Q}Ee.from=Ie;function fe(Q){return Q}Ee.to=fe})(je||(e.InlayHintKind=je={}));var He;(function(Ee){function Ie(Q){return{range:i.from(Q.range),url:Q.target,tooltip:Q.tooltip}}Ee.from=Ie;function fe(Q){let Se;if(Q.url)try{Se=typeof Q.url=="string"?h.URI.parse(Q.url,!0):h.URI.revive(Q.url)}catch{}return new n.$TL(i.to(Q.range),Se)}Ee.to=fe})(He||(e.DocumentLink=He={}));var qe;(function(Ee){function Ie(Q){const Se=new n.$WL(Q.label);return Q.textEdit&&(Se.textEdit=re.to(Q.textEdit)),Q.additionalTextEdits&&(Se.additionalTextEdits=Q.additionalTextEdits.map(Le=>re.to(Le))),Se}Ee.to=Ie;function fe(Q){return{label:Q.label,textEdit:Q.textEdit?re.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Se=>re.from(Se)):void 0}}Ee.from=fe})(qe||(e.ColorPresentation=qe={}));var Xe;(function(Ee){function Ie(Q){return new n.$UL(Q[0],Q[1],Q[2],Q[3])}Ee.to=Ie;function fe(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}Ee.from=fe})(Xe||(e.Color=Xe={}));var Ze;(function(Ee){function Ie(Q){return{range:i.from(Q.range)}}Ee.from=Ie;function fe(Q){return new n.$DL(i.to(Q.range))}Ee.to=fe})(Ze||(e.SelectionRange=Ze={}));var xe;(function(Ee){function Ie(fe){switch(fe){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Ee.to=Ie})(xe||(e.TextDocumentSaveReason=xe={}));var tt;(function(Ee){function Ie(Q){switch(Q){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ie;function fe(Q){switch(Q){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Ee.to=fe})(tt||(e.TextEditorLineNumbersStyle=tt={}));var de;(function(Ee){function Ie(Q){if(Q===n.EndOfLine.CRLF)return 1;if(Q===n.EndOfLine.LF)return 0}Ee.from=Ie;function fe(Q){if(Q===1)return n.EndOfLine.CRLF;if(Q===0)return n.EndOfLine.LF}Ee.to=fe})(de||(e.EndOfLine=de={}));var Pe;(function(Ee){function Ie(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ie})(Pe||(e.ProgressLocation=Pe={}));var Ae;(function(Ee){function Ie(Q){const Se={start:Q.start+1,end:Q.end+1};return Q.kind&&(Se.kind=Te.from(Q.kind)),Se}Ee.from=Ie;function fe(Q){const Se={start:Q.start-1,end:Q.end-1};return Q.kind&&(Se.kind=Te.to(Q.kind)),Se}Ee.to=fe})(Ae||(e.FoldingRange=Ae={}));var Te;(function(Ee){function Ie(Q){if(Q)switch(Q){case n.FoldingRangeKind.Comment:return c.$Lt.Comment;case n.FoldingRangeKind.Imports:return c.$Lt.Imports;case n.FoldingRangeKind.Region:return c.$Lt.Region}}Ee.from=Ie;function fe(Q){if(Q)switch(Q.value){case c.$Lt.Comment.value:return n.FoldingRangeKind.Comment;case c.$Lt.Imports.value:return n.FoldingRangeKind.Imports;case c.$Lt.Region.value:return n.FoldingRangeKind.Region}}Ee.to=fe})(Te||(e.FoldingRangeKind=Te={}));var Fe;(function(Ee){function Ie(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?i.from(fe.selection):void 0,override:typeof fe.override=="boolean"?m.$HE.id:void 0}}Ee.from=Ie})(Fe||(e.TextEditorOpenOptions=Fe={}));var ze;(function(Ee){function Ie(Le){return Le instanceof n.$eM?Le.toJSON():typeof Le=="string"?Le:fe(Le)||Q(Le)?new n.$eM(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Ee.from=Ie;function fe(Le){const We=Le;return We?h.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function Q(Le){const We=Le;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function Se(Le){return typeof Le=="string"?Le:new n.$eM(h.URI.revive(Le.baseUri),Le.pattern)}Ee.to=Se})(ze||(e.GlobPattern=ze={}));var Ve;(function(Ee){function Ie(fe){if(fe){if(Array.isArray(fe))return fe.map(Ie);if(typeof fe=="string")return fe;{const Q=fe;return{language:Q.language,scheme:Q.scheme,pattern:ze.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}Ee.from=Ie})(Ve||(e.LanguageSelector=Ve={}));var Ge;(function(Ee){function Ie(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Se=>Array.isArray(Se)&&Se.every(Le=>Le&&typeof Le=="object"&&"uri"in Le&&h.URI.isUri(Le.uri)&&"version"in Le&&typeof Le.version=="number"&&"ranges"in Le&&Array.isArray(Le.ranges)&&Le.ranges.every(We=>We instanceof n.$jL)))}Ee.is=Ie;function fe(Q){return{documents:Q.documents.map(Se=>Se.map(Le=>({uri:h.URI.from(Le.uri),version:Le.version,ranges:Le.ranges.map(We=>i.from(We))})))}}Ee.from=fe})(Ge||(e.MappedEditsContext=Ge={}));var Qe;(function(Ee){function Ie(Q){return{start:Q.start,end:Q.end}}Ee.from=Ie;function fe(Q){return new n.$GM(Q.start,Q.end)}Ee.to=fe})(Qe||(e.NotebookRange=Qe={}));var nt;(function(Ee){function Ie(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}Ee.to=Ie;function fe(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}Ee.from=fe})(nt||(e.NotebookCellExecutionSummary=nt={}));var Ye;(function(Ee){function Ie(fe){if(fe===f.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(fe===f.NotebookCellExecutionState.Pending)return;if(fe===f.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Ee.to=Ie})(Ye||(e.NotebookCellExecutionState=Ye={}));var it;(function(Ee){function Ie(Q){switch(Q){case n.NotebookCellKind.Markup:return f.CellKind.Markup;case n.NotebookCellKind.Code:default:return f.CellKind.Code}}Ee.from=Ie;function fe(Q){switch(Q){case f.CellKind.Markup:return n.NotebookCellKind.Markup;case f.CellKind.Code:default:return n.NotebookCellKind.Code}}Ee.to=fe})(it||(e.NotebookCellKind=it={}));var rt;(function(Ee){function Ie(Q){const Se={metadata:Q.metadata??Object.create(null),cells:[]};for(const Le of Q.cells)n.$HM.validate(Le),Se.cells.push(ut.from(Le));return Se}Ee.from=Ie;function fe(Q){const Se=new n.$IM(Q.cells.map(ut.to));return(0,b.$Wf)(Q.metadata)||(Se.metadata=Q.metadata),Se}Ee.to=fe})(rt||(e.NotebookData=rt={}));var ut;(function(Ee){function Ie(Q){return{cellKind:it.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:nt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(ht.from):[]}}Ee.from=Ie;function fe(Q){return new n.$HM(it.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(ht.to):void 0,Q.metadata,Q.internalMetadata?nt.to(Q.internalMetadata):void 0)}Ee.to=fe})(ut||(e.NotebookCellData=ut={}));var ct;(function(Ee){function Ie(Q){return{mime:Q.mime,valueBytes:O.$ke.wrap(Q.data)}}Ee.from=Ie;function fe(Q){return new n.$JM(Q.valueBytes.buffer,Q.mime)}Ee.to=fe})(ct||(e.NotebookCellOutputItem=ct={}));var ht;(function(Ee){function Ie(Q){return{outputId:Q.id,items:Q.items.map(ct.from),metadata:Q.metadata}}Ee.from=Ie;function fe(Q){const Se=Q.items.map(ct.to);return new n.$KM(Se,Q.outputId,Q.metadata)}Ee.to=fe})(ht||(e.NotebookCellOutput=ht={}));var jt;(function(Ee){function Ie(Se){return Q(Se)?{include:ze.from(Se.include)??void 0,exclude:ze.from(Se.exclude)??void 0}:ze.from(Se)??void 0}Ee.from=Ie;function fe(Se){return Q(Se)?{include:ze.to(Se.include),exclude:ze.to(Se.exclude)}:ze.to(Se)}Ee.to=fe;function Q(Se){const Le=Se;return Le?!(0,b.$Sf)(Le.include)&&!(0,b.$Sf)(Le.exclude):!1}})(jt||(e.NotebookExclusiveDocumentPattern=jt={}));var Tt;(function(Ee){function Ie(fe,Q,Se){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Le,Se),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Ee.from=Ie})(Tt||(e.NotebookStatusBarItem=Tt={}));var Dt;(function(Ee){function Ie(fe,Q,Se){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:Q.toInternal(Le,Se),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Ee.from=Ie})(Dt||(e.NotebookKernelSourceAction=Dt={}));var Ct;(function(Ee){function Ie(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Ee.from=Ie})(Ct||(e.NotebookDocumentContentOptions=Ct={}));var pt;(function(Ee){function Ie(Q){return{uri:Q.uri,provides:Q.provides}}Ee.from=Ie;function fe(Q){return new n.$MM(h.URI.revive(Q.uri),Q.provides)}Ee.to=fe})(pt||(e.NotebookRendererScript=pt={}));var St;(function(Ee){function Ie(Q){return{message:ee.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:i.from(Q.location.range),uri:Q.location.uri}}}Ee.from=Ie;function fe(Q){const Se=new n.$SM(typeof Q.message=="string"?Q.message:ee.to(Q.message));return Se.actualOutput=Q.actual,Se.expectedOutput=Q.expected,Se.contextValue=Q.contextValue,Se.location=Q.location?J.to(Q.location):void 0,Se}Ee.to=fe})(St||(e.TestMessage=St={}));var bt;(function(Ee){Ee.namespace=l.$bK,Ee.denamespace=l.$cK})(bt||(e.TestTag=bt={}));var dt;(function(Ee){function Ie(Q){const Se=(0,d.$gN)(Q).controllerId;return{extId:u.$0J.fromExtHostTestItem(Q,Se).toString(),label:Q.label,uri:h.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Le=>bt.namespace(Se,Le.id)),range:$.$Vs.lift(i.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&ee.fromStrict(Q.error)||null}}Ee.from=Ie;function fe(Q){return{parent:void 0,error:void 0,id:u.$0J.fromString(Q.extId).localId,label:Q.label,uri:h.URI.revive(Q.uri),tags:(Q.tags||[]).map(Se=>{const{tagId:Le}=bt.denamespace(Se);return new n.$TM(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}Ee.toPlain=fe})(dt||(e.TestItem=dt={})),function(Ee){function Ie(Q){return{id:Q.id}}Ee.from=Ie;function fe(Q){return new n.$TM(Q.id)}Ee.to=fe}(bt||(e.TestTag=bt={}));var Ut;(function(Ee){const Ie=(Q,Se)=>{const Le=[];for(const[Be,Ke]of Se)u.$0J.compare(Ke.item.extId,Be)===2&&(Se.delete(Be),Le.push(Ke));const We={...dt.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ke=>Ke.type===0).map(St.to)})),children:Le.map(Be=>Ie(Be,Se))};for(const Be of We.children)Be.parent=We;return We};function fe(Q){const Se=[],Le=new Map;for(const We of Q.items){Le.set(We.item.extId,We);const Be=u.$0J.root(We.item.extId);Q.request.targets.some(Ke=>Ke.controllerId===Be&&Ke.testIds.includes(We.item.extId))&&Se.push(We)}return{completedAt:Q.completedAt,results:Se.map(We=>Ie(We,Le))}}Ee.to=fe})(Ut||(e.TestResults=Ut={}));var Ft;(function(Ee){function Ie(Le){return{covered:Le.covered,total:Le.total}}function fe(Le){return"line"in Le?L.from(Le):i.from(Le)}function Q(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(We=>({count:We.executionCount,location:We.location&&fe(We.location),label:We.label})):void 0}:{type:0,name:Le.name,count:Le.executionCount,location:fe(Le.location)}}Ee.fromDetailed=Q;function Se(Le){return{uri:Le.uri,statement:Ie(Le.statementCoverage),branch:Le.branchCoverage&&Ie(Le.branchCoverage),function:Le.functionCoverage&&Ie(Le.functionCoverage),details:Le.detailedCoverage?.map(Q)}}Ee.fromFile=Se})(Ft||(e.TestCoverage=Ft={}));var st;(function(Ee){function Ie(fe){switch(fe){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Ee.to=Ie})(st||(e.CodeActionTriggerKind=st={}));var mt;(function(Ee){function Ie(Q){const Se=new n.$ZM(ne.to(Q.kind),Q.name,Q.detail||"",h.URI.revive(Q.uri),i.to(Q.range),i.to(Q.selectionRange));return Se._sessionId=Q._sessionId,Se._itemId=Q._itemId,Se}Ee.to=Ie;function fe(Q,Se,Le){if(Se=Se??Q._sessionId,Le=Le??Q._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:ne.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:i.from(Q.range),selectionRange:i.from(Q.selectionRange),tags:Q.tags?.map(me.from)}}Ee.from=fe})(mt||(e.TypeHierarchyItem=mt={}));var wt;(function(Ee){function Ie(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Ee.from=Ie})(wt||(e.ViewBadge=wt={}));var At;(function(Ee){function Ie(Le,We,Be){const Ke=We.fileData;return Ke?new n.$0L(new n.$$L(Ke.name,h.URI.revive(Ke.uri),Ke.id,(0,I.$db)(()=>Be(Ke.id)))):Le===C.$gs.uriList&&We.uriListData?new n.$9L(Se(We.uriListData)):new n.$9L(We.asString)}Ee.to=Ie;async function fe(Le,We){const Be=await We.asString();if(Le===C.$gs.uriList)return{asString:Be,fileData:void 0,uriListData:Q(Be)};const Ke=We.asFile();return{asString:Be,fileData:Ke?{name:Ke.name,uri:Ke.uri,id:Ke._itemId??Ke.id}:void 0}}Ee.from=fe;function Q(Le){return r.$st.split(Le).map(We=>{if(We.startsWith("#"))return We;try{return h.URI.parse(We)}catch{}return We})}function Se(Le){return r.$st.create(Le.map(We=>typeof We=="string"?We:h.URI.revive(We)))}})(At||(e.DataTransferItem=At={}));var qt;(function(Ee){function Ie(Q,Se){const Le=Q.items.map(([We,Be])=>[We,At.to(We,Be,Se)]);return new n.$_L(Le)}Ee.toDataTransfer=Ie;async function fe(Q){const Se={items:[]},Le=[];for(const[We,Be]of Q)Le.push((async()=>{Se.items.push([We,await At.from(We,Be)])})());return await Promise.all(Le),Se}Ee.from=fe})(qt||(e.DataTransfer=qt={}));var Nt;(function(Ee){function Ie(fe){return{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}Ee.from=Ie})(Nt||(e.ChatReplyFollowup=Nt={}));var zt;(function(Ee){function Ie(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:Nt.from(fe)}Ee.from=Ie})(zt||(e.ChatFollowup=zt={}));var Lt;(function(Ee){function Ie(Q){const Se=new n.$_M(Ot.to(Q.role),Q.content);return Se.name=Q.name,Se}Ee.to=Ie;function fe(Q){return{role:Ot.from(Q.role),content:Q.content,name:Q.name}}Ee.from=fe})(Lt||(e.ChatMessage=Lt={}));var Ot;(function(Ee){function Ie(Q){switch(Q){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Ee.to=Ie;function fe(Q){switch(Q){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Ee.from=fe})(Ot||(e.ChatMessageRole=Ot={}));var Et;(function(Ee){function Ie(Se){const Le={};for(const We of Object.keys(Se))Le[We]=Se[We].map(Ee.to);return Le}Ee.objectTo=Ie;function fe(Se){return{level:gt.to(Se.level),kind:Se.kind,value:(0,h.$vc)(Se.value)?h.URI.revive(Se.value):Se.value,description:Se.description}}Ee.to=fe;function Q(Se){return{level:gt.from(Se.level),kind:Se.kind,value:Se.value,description:Se.description}}Ee.from=Q})(Et||(e.ChatVariable=Et={}));var gt;(function(Ee){function Ie(Q){switch(Q){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Ee.to=Ie;function fe(Q){switch(Q){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Ee.from=fe})(gt||(e.ChatVariableLevel=gt={}));var Vt;(function(Ee){function Ie(fe){switch(fe){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return n.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Ie})(Vt||(e.InteractiveEditorResponseFeedbackKind=Vt={}));var Bt;(function(Ee){function Ie(Se,Le){return"markdownContent"in Le?((0,o.$KF)(Se,"chatAgents2Additions"),{content:ee.from(Le.markdownContent),kind:"markdownContent"}):"content"in Le?"vulnerabilities"in Le&&Le.vulnerabilities?((0,o.$KF)(Se,"chatAgents2Additions"),{content:Le.content,vulnerabilities:Le.vulnerabilities,kind:"vulnerability"}):typeof Le.content=="string"?{content:Le.content,kind:"content"}:((0,o.$KF)(Se,"chatAgents2Additions"),{content:ee.from(Le.content),kind:"markdownContent"}):"documents"in Le?{documents:Le.documents.map(We=>({uri:We.uri,version:We.version,ranges:We.ranges.map(Be=>i.from(Be))})),kind:"usedContext"}:"reference"in Le?{reference:"uri"in Le.reference?{uri:Le.reference.uri,range:i.from(Le.reference.range)}:Le.reference,kind:"reference"}:"inlineReference"in Le?{inlineReference:"uri"in Le.inlineReference?{uri:Le.inlineReference.uri,range:i.from(Le.inlineReference.range)}:Le.inlineReference,name:Le.title,kind:"inlineReference"}:"agentName"in Le?((0,o.$KF)(Se,"chatAgents2Additions"),{agentName:Le.agentName,command:Le.command,kind:"agentDetection"}):"treeData"in Le?{treeData:Le.treeData,kind:"treeData"}:"message"in Le?{content:ee.from(Le.message),kind:"progressMessage"}:void 0}Ee.from=Ie;function fe(Se){switch(Se.kind){case"markdownContent":case"inlineReference":case"treeData":return Ee.to(Se);case"content":return{content:Se.content};case"usedContext":return{documents:Se.documents.map(Le=>({uri:h.URI.revive(Le.uri),version:Le.version,ranges:Le.ranges.map(We=>i.to(We))}))};case"reference":return{reference:(0,h.$vc)(Se.reference)?h.URI.revive(Se.reference):a.to(Se.reference)};case"agentDetection":return;case"progressMessage":return{message:Se.content.value};case"vulnerability":return{content:Se.content,vulnerabilities:Se.vulnerabilities};default:return}}Ee.to=fe;function Q(Se){switch(Se.kind){case"markdownContent":return{content:Se.content.value};case"inlineReference":return{inlineReference:(0,h.$vc)(Se.inlineReference)?h.URI.revive(Se.inlineReference):a.to(Se.inlineReference),title:Se.name};case"treeData":return{treeData:(0,w.$Dh)(Se.treeData)};default:return}}Ee.toProgressContent=Q})(Bt||(e.ChatResponseProgress=Bt={}));var Gt;(function(Ee){function Ie(fe,Q){return{prompt:fe.message,variables:Et.objectTo(fe.variables),slashCommand:Q,subCommand:fe.command,agentId:fe.agentId}}Ee.to=Ie})(Gt||(e.ChatAgentRequest=Gt={}));var Ht;(function(Ee){function Ie(fe){return{label:fe.label,values:fe.values.map(Et.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation}}Ee.from=Ie})(Ht||(e.ChatAgentCompletionItem=Ht={}));var Jt;(function(Ee){function Ie(fe,Q,Se){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:Q.toInternal(fe,Se)}Ee.from=Ie})(Jt||(e.TerminalQuickFix=Jt={}))}),define(be[287],ve([1,0,43,133,73,132,94,139,4]),function(he,e,k,O,r,I,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=e.$xN=e.$wN=void 0;const w=(f,u,l,t)=>{let o=u;return{enumerable:!0,configurable:!1,get(){return o},set(n){if(!l(o,n)){const s=o;o=n,f.listener?.(t(n,s))}}}},C=(f,u)=>f===u,E={range:(f,u)=>f===u?!0:!f||!u?!1:f.isEqual(u),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(f,u)=>!(f.length!==u.length||f.some(l=>!u.find(t=>l.id===t.id)))},b=f=>u=>({op:4,update:f(u)}),h=(f,u)=>({range:(()=>{let l;const t=b(o=>({range:k.$Vs.lift(S.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return l},set(o){f.listener?.({op:6}),E.range(l,o)||(l=o,f.listener?.(t(o)))}}})(),label:w(f,u,E.label,b(l=>({label:l}))),description:w(f,void 0,E.description,b(l=>({description:l}))),sortText:w(f,void 0,E.sortText,b(l=>({sortText:l}))),canResolveChildren:w(f,!1,E.canResolveChildren,l=>({op:2,state:l})),busy:w(f,!1,E.busy,b(l=>({busy:l}))),error:w(f,void 0,E.error,b(l=>({error:S.MarkdownString.fromStrict(l)||null}))),tags:w(f,[],E.tags,(l,t)=>({op:1,new:l.map(S.TestTag.from),old:t.map(S.TestTag.from)}))}),$=f=>{const u=r.$0J.fromString(f.extId),l=new g(u.controllerId,u.localId,f.label,v.URI.revive(f.uri)||void 0);return l.range=S.Range.to(f.range||void 0),l.description=f.description||void 0,l.sortText=f.sortText||void 0,l.tags=f.tags.map(t=>S.TestTag.to({id:(0,D.$cK)(t).tagId})),l},c=f=>{let u;for(const l of f.tests){const t=$(l.item);(0,O.$gN)(t).parent=u,u=t}return u};e.$wN=c;class g{constructor(u,l,t,o){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const n=(0,O.$fN)(this,u);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof d?void 0:n.parent}},children:{value:(0,I.$eN)(n,O.$gN,g),enumerable:!0,writable:!1},...h(n,t)})}}e.$xN=g;class d extends g{constructor(u,l){super(u,u,l,void 0),this._isRoot=!0}}e.$yN=d;class m extends I.$aN{constructor(u,l,t){super({controllerId:u,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:O.$gN,getChildren:o=>o.children,root:new d(u,l),toITestItem:S.TestItem.from})}}e.$zN=m}),define(be[288],ve([1,0,11,138,139,21,285,18,13,52,43,79,4,2,5,270,287,14,136,39,61,38,281,22]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=void 0;let n=class{#e;#t;#n;constructor(P,y,A){this.b=new Map,this.c=new Map,this.#e=P.getProxy(D.$fL.MainThreadCommands),this.d=y,this.#n=A,this.#t=P.getProxy(D.$fL.MainThreadTelemetry),this.converter=new s(this,M=>{const _=this.c.get(M);return _?.result===a.Void?_:void 0},y),this.f=[{processArgument(M){return(0,w.$Dh)(M)}},{processArgument(M){return(0,I.$yn)(M,function(_){if(C.$Vs.isIRange(_))return r.Range.to(_);if(E.$Us.isIPosition(_))return r.Position.to(_);if(C.$Vs.isIRange(_.range)&&b.URI.isUri(_.uri))return r.location.to(_);if(_ instanceof d.$ke)return _.buffer.buffer;if(!Array.isArray(_))return _})}}]}registerArgumentProcessor(P){this.f.push(P)}registerApiCommand(P){const y=this.registerCommand(!1,P.id,async(...A)=>{const M=P.args.map((se,G)=>{if(!se.validate(A[G]))throw new Error(`Invalid argument '${se.name}' when running '${P.id}', received: ${typeof A[G]=="object"?JSON.stringify(A[G],null,"	"):A[G]} `);return se.convert(A[G])}),_=await this.executeCommand(P.internalId,...M);return P.result.convert(_,A,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this.c.set(P.id,P),new O.$hL(()=>{y.dispose(),this.c.delete(P.id)})}registerCommand(P,y,A,M,_,se){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:A,thisArg:M,metadata:_,extension:se}),P&&this.#e.$registerCommand(y),new O.$hL(()=>{this.b.delete(y)&&P&&this.#e.$unregisterCommand(y)})}executeCommand(P,...y){return this.d.trace("ExtHostCommands#executeCommand",P),this.g(P,y,!0)}async g(P,y,A){if(this.b.has(P))return this.#e.$fireCommandActivationEvent(P),this.h(P,y,!1);{let M=!1;const _=(0,I.$yn)(y,function(se){if(se instanceof O.$iL)return r.Position.from(se);if(se instanceof O.$jL)return r.Range.from(se);if(se instanceof O.$tL)return r.location.from(se);if(O.$GM.isNotebookRange(se))return r.NotebookRange.from(se);if(se instanceof ArrayBuffer)return M=!0,d.$ke.wrap(new Uint8Array(se));if(se instanceof Uint8Array)return M=!0,d.$ke.wrap(se);if(se instanceof d.$ke)return M=!0,se;if(!Array.isArray(se))return se});try{const se=await this.#e.$executeCommand(P,M?new m.$Uv(_):_,A);return(0,w.$Dh)(se)}catch(se){if(se instanceof Error&&se.message==="$executeCommand:retry")return this.g(P,y,!1);throw se}}}async h(P,y,A){const M=this.b.get(P);if(!M)throw new Error("Unknown command");const{callback:_,thisArg:se,metadata:G}=M;if(G?.args)for(let ee=0;ee<G.args.length;ee++)try{(0,k.$1f)(y[ee],G.args[ee].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${G.args[ee].name}' - ${G.args[ee].description}`)}const oe=u.$Sd.create();try{return await _.apply(se,y)}catch(ee){if(P===this.converter.delegatingCommandId){const K=this.converter.getActualCommand(...y);K&&(P=K.command)}if(this.d.error(ee,P,M.extension?.identifier),!A)throw ee;if(M.extension?.identifier){const K=this.#n.onExtensionError(M.extension.identifier,ee);this.d.trace("forwarded error to extension?",K,M.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.$Ri)(ee)),this.id=P,this.source=M.extension?.displayName??M.extension?.name}}}finally{this.j(M,P,oe.elapsed())}}j(P,y,A){P.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new l.$Mo(y),duration:A})}$executeContributedCommand(P,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",P);const A=this.b.get(P);return A?(y=y.map(M=>this.f.reduce((_,se)=>se.processArgument(_,A.extension?.identifier),M)),this.h(P,y,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this.d.trace("ExtHostCommands#getCommands",P),this.#e.$getCommands().then(y=>(P&&(y=y.filter(A=>A[0]!=="_")),y))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[y,A]of this.b){const{metadata:M}=A;M&&(P[y]=M)}return Promise.resolve(P)}};e.$FN=n,e.$FN=n=Ne([Oe(0,c.$kN),Oe(1,v.$oj),Oe(2,t.$EN)],n),e.$GN=(0,$.$7h)("IExtHostCommands");class s{constructor(P,y,A){this.d=P,this.f=y,this.g=A,this.delegatingCommandId=`__vsc${(0,o.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(P,y){if(!P)return;const A={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return A;const M=this.f(P.command);if(M)A.id=M.internalId,A.arguments=M.args.map((_,se)=>_.convert(P.arguments&&P.arguments[se]));else if((0,S.$Lb)(P.arguments)){const _=`${P.command} /${++this.c}`;this.b.set(_,P),y.add((0,h.$Rc)(()=>{this.b.delete(_),this.g.trace("CommandsConverter#DISPOSE",_)})),A.$ident=_,A.id=this.delegatingCommandId,A.arguments=[_],this.g.trace("CommandsConverter#CREATE",P.command,_)}return A}fromInternal(P){return typeof P.$ident=="string"?this.b.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this.b.get(P[0])}h(...P){const y=this.getActualCommand(...P);return this.g.trace("CommandsConverter#EXECUTE",P[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.$HN=s;class i{static{this.Uri=new i("uri","Uri of a text document",P=>b.URI.isUri(P),P=>P)}static{this.Position=new i("position","A position in a text document",P=>O.$iL.isPosition(P),r.Position.from)}static{this.Range=new i("range","A range in a text document",P=>O.$jL.isRange(P),r.Range.from)}static{this.Selection=new i("selection","A selection in a text document",P=>O.$kL.isSelection(P),r.Selection.from)}static{this.Number=new i("number","",P=>typeof P=="number",P=>P)}static{this.String=new i("string","",P=>typeof P=="string",P=>P)}static{this.StringArray=i.Arr(i.String)}static Arr(P){return new i(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,y=>Array.isArray(y)&&y.every(A=>P.validate(A)),y=>y.map(A=>P.convert(A)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",P=>P instanceof O.$EL,r.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",P=>P instanceof O.$ZM,r.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",P=>P instanceof g.$xN,r.TestItem.from)}constructor(P,y,A,M){this.name=P,this.description=y,this.validate=A,this.convert=M}optional(){return new i(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,y){return new i(P??this.name,y??this.description,this.validate,this.convert)}}e.$IN=i;class a{static{this.Void=new a("no result",P=>P)}constructor(P,y){this.description=P,this.convert=y}}e.$JN=a;class p{constructor(P,y,A,M,_){this.id=P,this.internalId=y,this.description=A,this.args=M,this.result=_}}e.$KN=p}),define(be[289],ve([1,0,10,2,12,222]),function(he,e,k,O,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sO=e.$rO=void 0,e.$rO="remoteFilesystem";class D extends I.$qO{static register(v,w,C){const E=v.getConnection();if(!E)return O.$Tc.None;const b=new O.$Sc,h=(async()=>{try{const $=await v.getRawEnvironment();$?w.registerProvider(r.Schemas.vscodeRemote,b.add(new D($,E))):C.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch($){C.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,k.$0)($))}})();return b.add(w.onWillActivateFileSystemProvider($=>{$.scheme===r.Schemas.vscodeRemote&&$.join(h)})),b}constructor(v,w){super(w.getChannel(e.$rO),{pathCaseSensitive:v.os===3})}}e.$sO=D}),define(be[74],ve([1,0,89,78,28,290,14,10,6,2,7,3,22,44,106]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0;class c{traceSocketEvent(y,A){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,y,A)}constructor(y,A=""){this.f=!0,this.debugLabel=A,this.socket=y,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,S.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(y){const A=M=>{this.traceSocketEvent("read",M),y(D.$ke.wrap(M))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(y){const A=M=>{y({type:0,hadError:M,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(y){const A=()=>{y()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(y){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",y),this.socket.write(y.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,S.$1)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,S.$1)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((y,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),y();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),y()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$Vh=c;var g;(function(P){P[P.MinHeaderByteSize=2]="MinHeaderByteSize",P[P.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var d;(function(P){P[P.PeekHeader=1]="PeekHeader",P[P.ReadHeader=2]="ReadHeader",P[P.ReadBody=3]="ReadBody",P[P.Fin=4]="Fin"})(d||(d={}));class m extends w.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(y,A){this.socket.traceSocketEvent(y,A)}constructor(y,A,M,_){super(),this.f=this.B(new v.$Wd),this.g=this.B(new v.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=y,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:M?.byteLength||0,recordInflateBytes:_}),this.a=this.B(new f(this,A,M,_,this.f,(se,G)=>this.m(se,G))),this.B(this.a.onError(se=>{console.error(se),(0,S.$1)(se),this.g.fire({type:0,hadError:!0,error:se})})),this.b=new $.$Qh,this.B(this.socket.onData(se=>this.n(se))),this.B(this.socket.onClose(async se=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(se)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this.f.event(y)}onClose(y){return this.g.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){let A=0;for(;A<y.byteLength;)this.a.writeMessage(y.slice(A,Math.min(A+262144,y.byteLength)),{compressed:!0,opcode:2}),A+=262144}m(y,{compressed:A,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",y);let _=2;y.byteLength<126?_+=0:y.byteLength<2**16?_+=2:_+=8;const se=D.$ke.alloc(_),G=A?64:0,oe=M&15;if(se.writeUInt8(128|G|oe,0),y.byteLength<126)se.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){se.writeUInt8(126,1);let ee=1;se.writeUInt8(y.byteLength>>>8&255,++ee),se.writeUInt8(y.byteLength>>>0&255,++ee)}else{se.writeUInt8(127,1);let ee=1;se.writeUInt8(0,++ee),se.writeUInt8(0,++ee),se.writeUInt8(0,++ee),se.writeUInt8(0,++ee),se.writeUInt8(y.byteLength>>>24&255,++ee),se.writeUInt8(y.byteLength>>>16&255,++ee),se.writeUInt8(y.byteLength>>>8&255,++ee),se.writeUInt8(y.byteLength>>>0&255,++ee)}this.socket.write(D.$ke.concat([se,y]))}end(){this.h=!0,this.socket.end()}n(y){if(y.byteLength!==0){for(this.b.acceptChunk(y);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const A=this.b.peek(this.j.readLen),M=A.readUInt8(0),_=(M&128)>>>7,se=(M&64)>>>6,G=M&15,oe=A.readUInt8(1),ee=(oe&128)>>>7,K=oe&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=_,this.j.firstFrameOfMessage&&(this.j.compressed=!!se),this.j.firstFrameOfMessage=!!_,this.j.mask=0,this.j.opcode=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const A=this.b.read(this.j.readLen),M=A.readUInt8(1),_=(M&128)>>>7;let se=M&127,G=1;se===126?se=A.readUInt8(++G)*2**8+A.readUInt8(++G):se===127&&(se=A.readUInt8(++G)*0+A.readUInt8(++G)*0+A.readUInt8(++G)*0+A.readUInt8(++G)*0+A.readUInt8(++G)*2**24+A.readUInt8(++G)*2**16+A.readUInt8(++G)*2**8+A.readUInt8(++G));let oe=0;_&&(oe=A.readUInt8(++G)*2**24+A.readUInt8(++G)*2**16+A.readUInt8(++G)*2**8+A.readUInt8(++G)),this.j.state=3,this.j.readLen=se,this.j.mask=oe,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const A=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(A,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(A,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Wh=m;class f extends w.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$ke.alloc(0)}constructor(y,A,M,_,se,G){super(),this.n=y,this.r=se,this.s=G,this.a=this.B(new v.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new u(this.n,_,M,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(oe=>this.a.fire(oe))),this.B(this.f.onError(oe=>this.a.fire(oe)))):(this.b=null,this.f=null)}writeMessage(y,A){this.g.push({data:y,options:A}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:y,options:A}=this.g.shift();if(this.f&&A.compressed){const M=await this.w(this.f,y);this.s(M,A)}else this.s(y,{...A,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(y,A){return new Promise((M,_)=>{y.write(A),y.flush(se=>M(se))})}acceptFrame(y,A,M){this.h.push({data:y,isCompressed:A,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const y=this.h.shift();if(this.b&&y.isCompressed){const A=await this.C(this.b,y.data,y.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(y.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(y,A,M){return new Promise((_,se)=>{y.write(A),M&&y.write(D.$ke.fromByteArray([0,0,255,255])),y.flush(G=>_(G))})}}class u extends w.$Tc{get recordedInflateBytes(){return this.j?D.$ke.concat(this.f):D.$ke.alloc(0)}constructor(y,A,M,_){super(),this.h=y,this.j=A,this.a=this.B(new v.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(_),this.b.on("error",se=>{this.h.traceSocketEvent("zlibInflateError",{message:se?.message,code:se?.code}),this.a.fire(se)}),this.b.on("data",se=>{this.h.traceSocketEvent("zlibInflateData",se),this.g.push(D.$ke.wrap(se))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(y){this.j&&this.f.push(y.clone()),this.h.traceSocketEvent("zlibInflateWrite",y),this.b.write(y.buffer)}flush(y){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const A=D.$ke.concat(this.g);this.g.length=0,y(A)})}}class l extends w.$Tc{constructor(y,A){super(),this.g=y,this.a=this.B(new v.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(D.$ke.wrap(M))})}write(y){this.g.traceSocketEvent("zlibDeflateWrite",y.buffer),this.b.write(y.buffer)}flush(y){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let A=D.$ke.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),y(A)})}}function t(P,y){if(y===0)return;const A=P.byteLength>>>2;for(let ee=0;ee<A;ee++){const K=P.readUInt32BE(ee*4);P.writeUInt32BE(K^y,ee*4)}const M=A*4,_=P.byteLength-M,se=y>>>24&255,G=y>>>16&255,oe=y>>>8&255;_>=1&&P.writeUInt8(P.readUInt8(M)^se,M),_>=2&&P.writeUInt8(P.readUInt8(M+1)^G,M+1),_>=3&&P.writeUInt8(P.readUInt8(M+2)^oe,M+2)}e.$Xh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const P=(0,b.$rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${P}-sock`;const y=process.platform!=="darwin"&&e.$Xh?e.$Xh:(0,r.tmpdir)(),A=(0,C.$jc)(y,`vscode-ipc-${P}.sock`);return i(A),A}e.$Yh=n;function s(P,y,A){const _=(0,k.createHash)("sha256").update(P).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${A}-${y}-sock`;const se=A.substr(0,4),G=y.substr(0,6);let oe;return process.platform!=="darwin"&&e.$Xh&&!process.env.VSCODE_PORTABLE?oe=(0,C.$jc)(e.$Xh,`vscode-${_}-${se}-${G}.sock`):oe=(0,C.$jc)(P,`${se}-${G}.sock`),i(oe),oe}e.$Zh=s;function i(P){const y=o[E.$u];typeof y=="number"&&P.length>=y&&console.warn(`WARNING: IPC handle "${P}" is longer than ${y} chars, try a shorter --user-data-dir`)}class a extends h.$Kh{static b(y){const A=v.Event.fromNodeEventEmitter(y,"connection");return v.Event.map(A,M=>({protocol:new $.$Rh(new c(M,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(M,"close"))}))}constructor(y){super(a.b(y)),this.d=y}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$1h=a;function p(P){return new Promise((y,A)=>{const M=(0,O.createServer)();M.on("error",A),M.listen(P,()=>{M.removeListener("error",A),y(new a(M))})})}e.$2h=p;function L(P,y){return new Promise((A,M)=>{const _=(0,O.createConnection)(P,()=>{_.removeListener("error",M),A($.$Sh.fromSocket(new c(_,`ipc-client${y}`),y))});_.once("error",M)})}e.$3h=L}),define(be[140],ve([1,0,87,15,14,10,11,25,26,88,13,46,239,290]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=void 0;let $=class extends E.$jp{constructor(m,f,u,l){super(l),this.m=m,this.n=f,this.r=u,this.s(),this.B(m.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const m=this.m.getValue("http");this.f=m?.proxy,this.g=!!m?.proxyStrictSSL,this.h=m?.proxyAuthorization}async request(m,f){const{f:u,g:l}=this;let t;try{t=await(0,w.$am)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,I.$0)(s)))}const o={...process.env,...t},n=m.agent?m.agent:await(0,b.$nr)(m.url||"",o,{proxyUrl:u,strictSSL:l});return m.agent=n,m.strictSSL=l,this.h&&(m.headers={...m.headers||{},"Proxy-Authorization":this.h}),this.c(m.isChromiumNetwork?"electron":"node",m,()=>g(m,f))}async resolveProxy(m){}async loadCertificates(){return(await new Promise((f,u)=>{he(["@vscode/proxy-agent"],f,u)})).loadSystemCertificates({log:this.r})}};e.$or=$,e.$or=$=Ne([Oe(0,S.$Ai),Oe(1,v.$ci),Oe(2,C.$oj),Oe(3,C.$pj)],$);async function c(d){return((0,k.parse)(d.url).protocol==="https:"?await new Promise((u,l)=>{he(["https"],u,l)}):await new Promise((u,l)=>{he(["http"],u,l)})).request}async function g(d,m){return O.Promises.withAsyncBody(async(f,u)=>{const l=(0,k.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await c(d),o={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,D.$Pf)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(o.auth=d.user+":"+d.password);const n=t(o,s=>{const i=(0,D.$Nf)(d.followRedirects)?d.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&i>0&&s.headers.location)g({...d,url:s.headers.location,followRedirects:i-1},m).then(f,u);else{let a=s;!d.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(a=s.pipe((0,h.createGunzip)())),f({res:s,stream:(0,r.$ze)(a)})}});n.on("error",u),d.timeout&&n.setTimeout(d.timeout),d.isChromiumNetwork&&n.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&n.write(d.data),n.end(),m.onCancellationRequested(()=>{n.abort(),u(new I.$5)})})}e.$pr=g}),define(be[141],ve([1,0,54,78,130,12,7,14,6,74,88,13,48,3,66,129,2,279,25]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0;async function f(s={},i,a,p,L,P){const y=await(0,r.$Gl)(a,p.userDataPath);let A={};if(i)try{A=await(0,C.$am)(P,L,p.args,process.env)}catch(ee){L.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ee)}const _={...process.env,...A,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(y,void 0,0),...s},se=p.isBuilt?(0,D.$jc)(p.appRoot,"bin"):(0,D.$jc)(p.appRoot,"resources","server","bin-dev"),G=(0,D.$jc)(se,"remote-cli");let oe=t(_,"PATH");return oe?oe=G+D.$tc+oe:oe=G,o(_,"PATH",oe),p.args["without-browser-env-var"]||(_.BROWSER=(0,D.$jc)(se,"helpers",h.$i?"browser.cmd":"browser.sh")),n(_),_}e.$Vm=f;class u{constructor(i,a){this.socket=i,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let i,a,p;return this.socket instanceof w.$Vh?(i=!0,a=!1,p=S.$ke.alloc(0)):(i=!1,a=this.socket.permessageDeflate,p=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:i,permessageDeflate:a,inflateBytes:p.buffer.toString("base64")}}}let l=class{constructor(i,a,p,L,P,y,A,M){this.i=i,this.j=P,this.l=y,this.m=A,this.n=M,this.b=new v.$Wd,this.onClose=this.b.event,this.c=!h.$i||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new u(p,L),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(i){this.l.info(`${this.o}${i}`)}q(i){this.l.error(`${this.o}${i}`)}async r(i,a){const p=new g.$Sc;p.add(a.socket),p.add((0,g.$Rc)(()=>{i.destroy()}));const L=()=>{p.dispose()};p.add(a.socket.onEnd(L)),p.add(a.socket.onClose(L)),p.add(v.Event.fromNodeEventEmitter(i,"end")(L)),p.add(v.Event.fromNodeEventEmitter(i,"close")(L)),p.add(v.Event.fromNodeEventEmitter(i,"error")(L)),p.add(a.socket.onData(P=>i.write(P.buffer))),p.add(v.Event.fromNodeEventEmitter(i,"data")(P=>{a.socket.write(S.$ke.wrap(P))})),a.initialDataChunk.byteLength>0&&i.write(a.initialDataChunk.buffer)}async s(i,a){await a.socketDrain();const p=a.toIExtHostSocketMessage();let L;a.socket instanceof w.$Vh?L=a.socket.socket:L=a.socket.socket.socket,i.send(p,L)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const i={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(i)}acceptReconnection(i,a,p){this.f=i,this.p("The client has reconnected.");const L=new u(a,p);if(!this.g){this.h=L;return}this.s(this.g,L)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(i){try{let a=process.execArgv?process.execArgv.filter(G=>!/^--inspect(-brk)?=/.test(G)):[];i.port&&!process.pkg&&(a=[`--inspect${i.break?"-brk":""}=${i.port}`]);const p=await f(i.env,!0,i.language,this.j,this.l,this.n);(0,$.$Tl)(p);let L;if(this.c)(0,d.$Tm)(new d.$Rm,p),L=null;else{const{namedPipeServer:G,pipeName:oe}=await this.u();(0,d.$Tm)(new d.$Qm(oe),p),L=G}const P={env:p,execArgv:a,silent:!0};P.execArgv.unshift("--dns-result-order=ipv4first");const y=["--type=extensionHost","--transformURIs"],A=this.j.args["use-host-proxy"];y.push(`--useHostProxy=${A?"true":"false"}`),this.g=k.fork(I.$pg.asFileUri("bootstrap-fork").fsPath,y,P);const M=this.g.pid;this.p(`<${M}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const _=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),se=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(_(G=>this.p(`<${M}> ${G}`)),se(G=>this.p(`<${M}><stderr> ${G}`)),this.g.on("error",G=>{this.q(`<${M}> Extension Host Process had an error`),this.l.error(G),this.t()}),this.g.on("exit",(G,oe)=>{this.m.setExitInfo(this.i,{code:G,signal:oe}),this.p(`<${M}> Extension Host Process exited with code: ${G}, signal: ${oe}.`),this.t()}),L)L.on("connection",G=>{L.close(),this.r(G,this.h)});else{const G=oe=>{oe.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",G),this.s(this.g,this.h),this.h=null)};this.g.on("message",G)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}u(){return new Promise((i,a)=>{const p=(0,w.$Yh)(),L=O.createServer();L.on("error",a),L.listen(p,()=>{L?.removeListener("error",a),i({pipeName:p,namedPipeServer:L})})})}};e.$Wm=l,e.$Wm=l=Ne([Oe(4,b.$Gm),Oe(5,E.$oj),Oe(6,c.$Om),Oe(7,m.$Ai)],l);function t(s,i){const a=Object.keys(s).filter(L=>L.toLowerCase()===i.toLowerCase()),p=a.length>0?a[0]:i;return s[p]}function o(s,i,a){const p=Object.keys(s).filter(P=>P.toLowerCase()===i.toLowerCase()),L=p.length>0?p[0]:i;s[L]=a}function n(s){for(const i of Object.keys(s))s[i]===null&&delete s[i]}}),define(be[291],ve([1,0,84,13,68,117,25,46,140,38,32,30,127,125,86,111,57,2,112,70,12,16,31,48,120,85,121,10,4,7,29,237,83,34,124,67,3,59,131,33,47,71,128,126,114,115,203,292]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l,t,o,n,s,i,a,p,L,P,y,A,M,_,se,G,oe,ee,K,Z,X,te,V,W,re,ue,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class me extends d.$Tc{constructor(U,x){super(),this.a=U,this.b=x,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const U=await this.f();await U.invokeFunction(async x=>{const J=x.get(D.$Ai),Y=x.get(O.$oj);G.$i&&(J.getValue("security.restrictUNCAccess")===!1?(0,ne.disableUNCAccessRestrictions)():(0,ne.addUNCHostToAllowlist)(J.getValue("security.allowedUNCHosts")));try{await this.g(U.createInstance(n.$Ip,new O.$wj(Y.getLevel(),!1)))}catch(B){throw Y.error(B),console.error((0,a.$0)(B)),B}})}async f(){const U=new k.$5h,x={_serviceBrand:void 0,...g.default};U.set(t.$Gj,x);const J=new o.$Hm(this.a,x);U.set(o.$Gm,J);const Y=new re.$xO((0,O.$Cj)(J),J.logsHome);U.set(O.$pj,Y);const B=new W.$HO(this.B(Y.createLogger("remoteCLI",{name:(0,ue.localize)(0,null)})));U.set(O.$oj,B),B.trace(`Remote configuration data at ${this.b}`),B.trace("process arguments:",this.a);const T=this.B(new m.$dq(B));U.set(l.$rk,T),T.registerProvider(u.Schemas.file,this.B(new f.$Cq(B)));const N=new _.$3r(T);U.set(M.$2k,N);const q=this.B(new te.$FO(N,J,T,B));U.set(K.$4k,q);const ie=this.B(new I.$ao(q.defaultProfile.settingsResource,T,new X.$Mn,B));return U.set(D.$Ai,ie),await Promise.all([ie.initialize(),q.init()]),U.set(S.$ip,new r.$4h(v.$or)),U.set(A.$eo,new r.$4h(y.$WO)),U.set(C.$vl,w.$Oo),U.set(E.$zo,new r.$4h(b.$Fp)),U.set(Z.$Wp,new r.$4h(V.$GO)),U.set(oe.$1p,new r.$4h(ee.$tO)),U.set($.$Gp,new r.$4h($.$Hp)),U.set(h.$$p,new r.$4h(h.$_p)),U.set(s.$ir,new r.$4h(i.$kr)),new c.$Fq(U)}async g(U){if(this.a["list-extensions"])return U.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const x={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return U.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),x,!!this.a.force)}else{if(this.a["uninstall-extension"])return U.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return U.updateExtensions();if(this.a["locate-extension"])return U.locateExtension(this.a["locate-extension"])}}h(U){return U.map(x=>/\.vsix$/i.test(x)?p.URI.file((0,L.$ic)(x)?x:(0,L.$jc)((0,P.cwd)(),x)):x)}}function z(R){setTimeout(()=>process.exit(R),0)}async function H(R,U,x){if(R.help){const Y=g.default.serverApplicationName+(G.$i?".cmd":"");console.log((0,se.$2l)(g.default.nameLong,Y,g.default.version,x,{noInputFiles:!0,noPipe:!0}));return}if(R.version){console.log((0,se.$3l)(g.default.version,g.default.commit));return}const J=new me(R,U);try{await J.run(),z(0)}catch{z(1)}finally{J.dispose()}}e.run=H}),define(be[293],ve([1,0,74,305,27,288,4,13,92]),function(he,e,k,O,r,I,D,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=e.$LN=void 0;class w{constructor(b,h,$){this.b=b,this.c=h,this.f=$,this.a=O.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(h.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,h){const $=(g,d)=>{h.writeHead(g,{"content-type":"application/json"}),h.end(JSON.stringify(d||null),m=>m&&this.c.error(m))},c=[];b.setEncoding("utf8"),b.on("data",g=>c.push(g)),b.on("end",async()=>{try{const g=JSON.parse(c.join(""));let d;switch(g.type){case"open":d=await this.i(g);break;case"openExternal":d=await this.j(g);break;case"status":d=await this.l(g);break;case"extensionManagement":d=await this.k(g);break;default:$(404,`Unknown message type: ${g.type}`);break}$(200,d)}catch(g){const d=g instanceof Error?g.message:JSON.stringify(g);$(500,d),this.c.error("Error while processing pipe request",g)}})}async i(b){const{fileURIs:h,folderURIs:$,forceNewWindow:c,diffMode:g,mergeMode:d,addMode:m,forceReuseWindow:f,gotoLineMode:u,waitMarkerFilePath:l,remoteAuthority:t}=b,o=[];if(Array.isArray($))for(const a of $)try{o.push({folderUri:D.URI.parse(a)})}catch{}if(Array.isArray(h))for(const a of h)try{(0,v.$zi)(a)?o.push({workspaceUri:D.URI.parse(a)}):o.push({fileUri:D.URI.parse(a)})}catch{}const n=l?D.URI.file(l):void 0,i={forceNewWindow:c,diffMode:g,mergeMode:d,addMode:m,gotoLineMode:u,forceReuseWindow:f,preferNewWindow:!f&&!n&&!m,waitMarkerFileURI:n,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",o,i)}async j(b){for(const h of b.uris){const $=D.URI.parse(h),c=$.scheme==="file"?$:h;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(b){const h=c=>c?.map(g=>/\.vsix$/i.test(g)?D.URI.parse(g):g),$={list:b.list,install:h(b.install),uninstall:h(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",$)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&r.existsSync(this.f)&&r.unlinkSync(this.f)}}e.$LN=w;let C=class extends w{constructor(b,h){super(b,h,(0,k.$Yh)())}};e.$MN=C,e.$MN=C=Ne([Oe(0,I.$GN),Oe(1,S.$oj)],C)}),define(be[294],ve([1,0,28,6,21,2,7,3,4,74,72,293,123,90,274,276,141]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mO=void 0;class d extends c.$lO{constructor(u,l,t,o,n){super({getFolderUri:s=>{const i=l.filter(a=>a.name===s);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(s,i)=>o[`config:${i}`],getExecPath:()=>u.VSCODE_EXEC_PATH,getAppRoot:()=>u.VSCODE_CWD,getFilePath:()=>{if(t)return D.$hc(t.fsPath)},getSelectedText:()=>o.selectedText,getLineNumber:()=>o.lineNumber,getExtension:async s=>{const a=(await n.getInstalled()).find(p=>p.identifier.id===s);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(k.homedir()),Promise.resolve(u))}}class m extends I.$Tc{constructor(u,l,t,o,n,s){super(),this.g=u,this.h=l,this.j=t,this.m=o,this.n=n,this.r=s,this.a=0,this.b=new Map,this.c=this.B(new O.$Wd),this.onExecuteCommand=this.c.event}async call(u,l,t){switch(l){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,t);case"$createProcess":{const o=(0,C.$4r)(u.remoteAuthority);return this.s(o,t)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,t);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,t);case"$listProcesses":return this.j.listProcesses.apply(this.j,t);case"$getLatency":return this.j.getLatency.apply(this.j,t);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,t);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,t);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,t);case"$start":return this.j.start.apply(this.j,t);case"$input":return this.j.input.apply(this.j,t);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,t);case"$shutdown":return this.j.shutdown.apply(this.j,t);case"$resize":return this.j.resize.apply(this.j,t);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,t);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,t);case"$getCwd":return this.j.getCwd.apply(this.j,t);case"$processBinary":return this.j.processBinary.apply(this.j,t);case"$sendCommandResult":return this.u(t[0],t[1],t[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,t);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,t);case"$getDefaultSystemShell":return this.w.apply(this,t);case"$getProfiles":return this.y.apply(this,t);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(t[0],t[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,t);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,t);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,t);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,t);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,t);case"$updateTitle":return this.j.updateTitle.apply(this.j,t);case"$updateProperty":return this.j.updateProperty.apply(this.j,t);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,t);case"$requestDetachInstance":return this.j.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,t);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,t)}throw new Error(`IPC Command ${l} not found`)}listen(u,l,t){switch(l){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||O.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||O.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||O.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||O.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||O.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||O.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${l} not found`)}async s(u,l){const t={name:l.shellLaunchConfig.name,executable:l.shellLaunchConfig.executable,args:l.shellLaunchConfig.args,cwd:typeof l.shellLaunchConfig.cwd=="string"||typeof l.shellLaunchConfig.cwd>"u"?l.shellLaunchConfig.cwd:v.URI.revive(u.transformIncoming(l.shellLaunchConfig.cwd)),env:l.shellLaunchConfig.env,useShellEnvironment:l.shellLaunchConfig.useShellEnvironment,reconnectionProperties:l.shellLaunchConfig.reconnectionProperties,type:l.shellLaunchConfig.type,isFeatureTerminal:l.shellLaunchConfig.isFeatureTerminal},o=await(0,g.$Vm)(l.resolverEnv,!!l.shellLaunchConfig.useShellEnvironment,S.$w,this.g,this.h,this.r);this.h.trace("baseEnv",o);const n=ee=>({uri:v.URI.revive(u.transformIncoming(ee.uri)),name:ee.name,index:ee.index,toResource:()=>{throw new Error("Not implemented")}}),s=l.workspaceFolders.map(n),i=l.activeWorkspaceFolder?n(l.activeWorkspaceFolder):void 0,a=l.activeFileResource?v.URI.revive(u.transformIncoming(l.activeFileResource)):void 0,p=new d(o,s,a,l.resolvedVariables,this.n),L=$.$hO(i,process.env,p),P=await $.$gO(t,k.homedir(),L,i?.uri,l.configuration["terminal.integrated.cwd"],this.h);t.cwd=P;const y=S.$i?"terminal.integrated.env.windows":S.$j?"terminal.integrated.env.osx":"terminal.integrated.env.linux",A=l.configuration[y],M=await $.$iO(t,A,L,this.m.version,l.configuration["terminal.integrated.detectLocale"],o);if(!t.strictEnv){const ee=[];for(const[te,V,W]of l.envVariableCollections)ee.push([te,{map:(0,h.$Pr)(V),descriptionMap:(0,h.$Qr)(W)}]);const K=new Map(ee),Z=new b.$Tr(K),X=i?i??void 0:void 0;await Z.applyToProcessEnvironment(M,{workspaceFolder:X},L)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:P,cols:l.cols,rows:l.rows,env:M});const _=(0,w.$Yh)();M.VSCODE_IPC_HOOK_CLI=_;const se=await this.j.createProcess(t,P,l.cols,l.rows,l.unicodeVersion,M,o,l.options,l.shouldPersistTerminal,l.workspaceId,l.workspaceName),G={executeCommand:(ee,...K)=>this.t(se,ee,K,u)},oe=new E.$LN(G,this.h,_);return this.j.onProcessExit(ee=>ee.id===se&&oe.dispose()),{persistentTerminalId:se,resolvedShellLaunchConfig:t}}t(u,l,t,o){let n,s;const i=new Promise((L,P)=>{n=L,s=P}),a=++this.a;this.b.set(a,{resolve:n,reject:s,uriTransformer:o});const p=(0,r.$yn)(t,L=>{if(L&&L.$mid===1)return o.transformOutgoing(L);if(L&&L instanceof v.URI)return o.transformOutgoingURI(L)});return this.c.fire({reqId:a,persistentProcessId:u,commandId:l,commandArgs:p}),i}u(u,l,t){const o=this.b.get(u);if(!o)return;this.b.delete(u);const n=(0,r.$yn)(t,s=>{if(s&&s.$mid===1)return o.uriTransformer.transformIncoming(s)});l?o.reject(n):o.resolve(n)}w(u){return this.j.getDefaultSystemShell(u)}async y(u,l,t,o){return this.j.getProfiles(u,l,t,o)||[]}z(){return{...process.env}}C(u,l){return this.j.getWslPath(u,l)}D(){return this.j.reduceConnectionGraceTime()}}e.$mO=m}),define(be[295],ve([1,0,28,6,2,12,7,101,23,44,25,117,211,83,212,26,127,30,86,120,221,125,16,112,70,68,111,84,85,121,13,57,31,46,238,140,119,32,38,252,91,260,34,124,271,272,243,250,294,72,48,278,289,129,59,131,47,33,71,251,115,128,126,114,113,205,284,234,264,257]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l,t,o,n,s,i,a,p,L,P,y,A,M,_,se,G,oe,ee,K,Z,X,te,V,W,re,ue,ne,me,z,H,R,U,x,J,Y,B,T,N,q,ie,ae,ge,ce,pe,ye,Ce,Re,$e,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=void 0;const ke="monacoworkbench";async function Me(de,Pe,Ae,Te){const Fe=new a.$5h,ze=new qe,Ve={_serviceBrand:void 0,...y.default};Fe.set(A.$Gj,Ve);const Ge=new H.$Hm(Pe,Ve);Fe.set(c.$bi,Ge),Fe.set(c.$ci,Ge);const Qe=new ie.$xO((0,P.$Cj)(Ge),Ge.logsHome);Fe.set(P.$pj,Qe),ze.registerChannel("logger",new pe.$Cr(Qe,st=>He(st.remoteAuthority)));const nt=Qe.createLogger("remoteagent",{name:(0,ye.localize)(0,null)}),Ye=new ce.$HO(nt,[new Xe((0,P.$Cj)(Ge))]);Fe.set(P.$oj,Ye),setTimeout(()=>tt(Ge.logsHome.with({scheme:I.Schemas.file}).fsPath).then(null,st=>Ye.error(st)),1e4),Ye.onDidChangeLogLevel(st=>(0,P.log)(Ye,st,`Log level changed to ${(0,P.$Dj)(Ye.getLevel())}`)),Ye.trace(`Remote configuration data at ${Ae}`),Ye.trace("process arguments:",Ge.args),Array.isArray(Ve.serverGreeting)&&Ye.info(`

${Ve.serverGreeting.join(`
`)}

`),ze.registerChannel(b.$co.ChannelName,new b.$co);const it=new w.$Oh(st=>st.clientId==="renderer"),rt=Te.add(new o.$dq(Ye));Fe.set(t.$rk,rt),rt.registerProvider(I.Schemas.file,Te.add(new n.$Cq(Ye)));const ut=new V.$3r(rt);Fe.set(te.$2k,ut);const ct=new E.$ao(Ge.machineSettingsResource,rt,new N.$Mn,Ye);Fe.set(C.$Ai,ct);const ht=new ae.$FO(ut,Ge,rt,Ye);Fe.set(T.$4k,ht),ze.registerChannel("userDataProfiles",new $e.$NO(ht,st=>He(st.remoteAuthority)));const[,,jt,Tt]=await Promise.all([ct.initialize(),ht.init(),(0,S.$_m)(Ye.error.bind(Ye)),(0,S.$an)(Ye.error.bind(Ye))]),Dt=new x.$Pm;Fe.set(x.$Om,Dt);const Ct=new se.$or(ct,Ge,Ye,Qe);Fe.set(M.$ip,Ct);let pt=ee.$So;const St=(0,ee.$Yo)(Ve,ct);if((0,ee.$To)(Ve,Ge)){!(0,ee.$Uo)(Ve,Ge)&&Ve.aiConfig?.ariaKey&&(pt=new q.$vO(Ct,St,ke,null,Ve.aiConfig.ariaKey),Te.add((0,r.$Rc)(()=>pt?.flush())));const st={appenders:[pt],commonProperties:(0,G.$Ko)((0,k.release)(),(0,k.hostname)(),process.arch,Ve.commit,Ve.version+"-remote",jt,Tt,St,"remoteAgent"),piiPaths:(0,ee.$Zo)(Ge)},mt=Ge.args["telemetry-level"];let wt=3;mt==="all"?wt=3:mt==="error"?wt=2:mt==="crash"?wt=1:mt!==void 0&&(wt=0),Fe.set(ne.$es,new s.$4h(ne.$cs,[st,wt]))}else Fe.set(ne.$es,ne.$ds);Fe.set(d.$zo,new s.$4h(g.$Fp));const bt=ze.getChannel("download",it);Fe.set(h.$eo,new $.$go(bt,()=>He("renderer"))),Fe.set(B.$Wp,new s.$4h(ge.$GO)),Fe.set(J.$1p,new s.$4h(Y.$tO)),Fe.set(m.$Gp,new s.$4h(m.$Hp)),Fe.set(l.$$p,new s.$4h(l.$_p));const dt=new i.$Fq(Fe);Fe.set(p.$ir,dt.createInstance(L.$kr));const Ut=dt.createInstance(De.$PO,{graceTime:108e5,shortGraceTime:3e5,scrollback:ct.getValue("terminal.integrated.persistentSessionScrollback")??100}),Ft=dt.createInstance(X.$Yr,Ut);return Fe.set(Z.$xr,Ft),dt.invokeFunction(st=>{const mt=st.get(l.$$p),wt=st.get(J.$1p),At=st.get(d.$zo),qt=st.get(p.$ir),Nt=new W.$$r(de,Ge,ht,Dt);ze.registerChannel("remoteextensionsenvironment",Nt);const zt=new ue.$fs(st.get(ne.$es),pt);ze.registerChannel("telemetry",zt),ze.registerChannel(R.$nO,new me.$mO(Ge,Ye,Ft,Ve,mt,ct));const Lt=new Ce.$LO(dt.createInstance(f.$Ip,Ye),Ge,ht,wt,Ye,At,qt);ze.registerChannel(Re.$KO,new Ce.$MO(Lt,gt=>He(gt.remoteAuthority)));const Ot=new re.$bs(Ye,Ge);ze.registerChannel(U.$rO,Ot),ze.registerChannel("request",new _.$lr(st.get(M.$ip)));const Et=new u.$Jp(mt,gt=>He(gt.remoteAuthority));return ze.registerChannel("extensions",Et),Lt.whenExtensionsReady().then(()=>mt.cleanUp()),Te.add(new K.default(st.get(oe.$vl))),{telemetryService:st.get(oe.$vl)}}),{socketServer:ze,instantiationService:dt}}e.$QO=Me;const je=Object.create(null);function He(de){return je[de]||(je[de]=(0,z.$4r)(de)),je[de]}class qe extends w.$Kh{constructor(){const Pe=new O.$Wd;super(Pe.event),this.b=Pe}acceptConnection(Pe,Ae){this.b.fire({protocol:Pe,onDidClientDisconnect:Ae})}}e.$RO=qe;class Xe extends P.$tj{constructor(Pe=P.$rj){super(),this.setLevel(Pe),this.g=!!process.stdout.isTTY}trace(Pe,...Ae){this.f(P.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,Pe,...Ae):console.log(`[${Ze()}]`,Pe,...Ae))}debug(Pe,...Ae){this.f(P.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,Pe,...Ae):console.log(`[${Ze()}]`,Pe,...Ae))}info(Pe,...Ae){this.f(P.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,Pe,...Ae):console.log(`[${Ze()}]`,Pe,...Ae))}warn(Pe,...Ae){this.f(P.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ze()}]\x1B[0m`,Pe,...Ae):console.warn(`[${Ze()}]`,Pe,...Ae))}error(Pe,...Ae){this.f(P.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ze()}]\x1B[0m`,Pe,...Ae):console.error(`[${Ze()}]`,Pe,...Ae))}flush(){}}function Ze(){const de=new Date;return`${xe(de.getHours())}:${xe(de.getMinutes())}:${xe(de.getSeconds())}`}function xe(de){return de<10?`0${de}`:String(de)}async function tt(de){const Pe=D.$nc(de),Ae=D.$mc(de),ze=(await v.Promises.readdir(Ae)).filter(Ge=>/^\d{8}T\d{6}$/.test(Ge)).sort().filter(Ge=>Ge!==Pe),Ve=ze.slice(0,Math.max(0,ze.length-9));await Promise.all(Ve.map(Ge=>v.Promises.rm(D.$jc(Ae,Ge))))}}),define(be[296],ve([1,0,89,27,78,297,87,95,14,10,40,2,12,7,42,3,17,4,22,171,157,292,106,74,25,5,13,31,58,32,141,265,266,48,295,268]),function(he,e,k,O,r,I,D,S,v,w,C,E,b,h,$,c,g,d,m,f,u,l,t,o,n,s,i,a,p,L,P,y,A,M,_,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=void 0;const G=5*60*1e3;let oe=class extends E.$Tc{constructor(X,te,V,W,re,ue,ne,me){super(),this.n=X,this.r=te,this.s=V,this.t=re,this.u=ue,this.w=ne,this.y=me,this.h=K.create(this.u),this.j=(0,p.$dl)(ue),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=W?this.y.createInstance(se.$UO,this.r):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(X,te){if(X.method!=="GET")return(0,se.$SO)(X,te,405,`Unsupported method ${X.method}`);if(!X.url)return(0,se.$SO)(X,te,400,"Bad request.");const V=D.parse(X.url,!0);let W=V.pathname;if(!W)return(0,se.$SO)(X,te,400,"Bad request.");if(W.startsWith(this.j)&&W.charCodeAt(this.j.length)===47&&(W=W.substring(this.j.length)),W==="/version")return te.writeHead(200,{"Content-Type":"text/plain"}),void te.end(this.u.commit||"");if(W==="/delay-shutdown")return this.N(),te.writeHead(200),void te.end("OK");if(!(0,A.$4m)(this.r,X,V))return(0,se.$SO)(X,te,403,"Forbidden.");if(W==="/vscode-remote-resource"){const re=V.query.path;if(typeof re!="string")return(0,se.$SO)(X,te,400,"Bad request.");let ue;try{ue=d.URI.from({scheme:b.Schemas.file,path:re}).fsPath}catch{return(0,se.$SO)(X,te,400,"Bad request.")}const ne=Object.create(null);this.t.isBuilt&&((0,C.$9f)(ue,this.t.builtinExtensionsPath,!c.$k)||(0,C.$9f)(ue,this.t.extensionsPath,!c.$k))&&(ne["Cache-Control"]="public, max-age=31536000"),ne.Vary="Origin";const me=X.headers.origin;return me&&this.h.matches(me)&&(ne["Access-Control-Allow-Origin"]=me),(0,se.$TO)(ue,1,this.w,X,te,ne)}if(this.g){this.g.handle(X,te,V);return}return te.writeHead(404,{"Content-Type":"text/plain"}),void te.end("Not found")}handleUpgrade(X,te){let V=(0,m.$rg)(),W=!1,re=!1;if(X.url){const R=D.parse(X.url,!0).query;typeof R.reconnectionToken=="string"&&(V=R.reconnectionToken),R.reconnection==="true"&&(W=!0),R.skipWebSocketFrames==="true"&&(re=!0)}if(X.headers.upgrade===void 0||X.headers.upgrade.toLowerCase()!=="websocket"){te.end("HTTP/1.1 400 Bad Request");return}const ue=X.headers["sec-websocket-key"],ne=k.createHash("sha1");ne.update(ue+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const z=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ne.digest("base64")}`];let H=!1;if(!re&&!this.t.args["disable-websocket-compression"]&&X.headers["sec-websocket-extensions"]){const R=Array.isArray(X.headers["sec-websocket-extensions"])?X.headers["sec-websocket-extensions"]:[X.headers["sec-websocket-extensions"]];for(const U of R)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(U)){if(/\b(permessage-deflate)\b/.test(U)){H=!0,z.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(U)){H=!0,z.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}te.write(z.join(`\r
`)+`\r
\r
`),te.setTimeout(0),te.setNoDelay(!0),re?this.D(new o.$Vh(te,`server-connection-${V}`),W,V):this.D(new o.$Wh(new o.$Vh(te,`server-connection-${V}`),H,null,!0),W,V)}handleServerError(X){this.w.error("Error occurred in server"),this.w.error(X)}z(X){let te;return X instanceof o.$Vh?te=X.socket:te=X.socket.socket,te.remoteAddress||"<unknown>"}async C(X,te,V){const W=te.getSocket();this.w.error(`${X} ${V}.`);const re={type:"error",reason:V};te.sendControl(v.$ke.fromString(JSON.stringify(re))),te.dispose(),await W.drain(),W.dispose()}D(X,te,V){const W=this.z(X),re=`[${W}][${V.substr(0,8)}]`,ue=new t.$Uh({socket:X}),ne=this.s?new this.s.validator:null,me=this.s?new this.s.signer:null;let z;(function(x){x[x.WaitingForAuth=0]="WaitingForAuth",x[x.WaitingForConnectionType=1]="WaitingForConnectionType",x[x.Done=2]="Done",x[x.Error=3]="Error"})(z||(z={}));let H=0;const R=x=>{H=3,U.dispose(),this.C(re,ue,x)},U=ue.onControlMessage(x=>{if(H===0){let J;try{J=JSON.parse(x.toString())}catch{return R("Malformed first message")}if(J.type!=="auth")return R("Invalid first message");if(this.r.type===2&&!this.r.validate(J.auth))return R("Unauthorized client refused: auth mismatch");let Y=(0,m.$rg)();if(me)try{Y=me.sign(J.data)}catch{}let B=(0,m.$rg)();if(ne)try{B=ne.createNewMessage(B)}catch{}const T={type:"sign",data:B,signedData:Y};ue.sendControl(v.$ke.fromString(JSON.stringify(T))),H=1}else if(H===1){let J;try{J=JSON.parse(x.toString())}catch{return R("Malformed second message")}if(J.type!=="connectionType")return R("Invalid second message");if(typeof J.signedData!="string")return R("Invalid second message field type");const Y=J.commit,B=this.u.commit;if(Y&&B&&Y!==B)return R("Client refused: version mismatch");let T=!1;if(!ne)T=!0;else if(this.r.validate(J.signedData))T=!0;else try{T=ne.validate(J.signedData)==="ok"}catch{}if(!T){if(this.t.isBuilt)return R("Unauthorized client refused");this.w.error(`${re} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const N in this.b)this.b[N].shortenReconnectionGraceTimeIfNecessary();for(const N in this.a)this.a[N].shortenReconnectionGraceTimeIfNecessary();H=2,U.dispose(),this.F(W,re,ue,X,te,V,J)}})}async F(X,te,V,W,re,ue,ne){const me=ne.desiredConnectionType===1?`${te}[ManagementConnection]`:ne.desiredConnectionType===2?`${te}[ExtensionHostConnection]`:te;if(ne.desiredConnectionType===1)if(re){if(!this.b[ue])return this.f.has(ue)?this.C(me,V,"Unknown reconnection token (seen before)"):this.C(me,V,"Unknown reconnection token (never seen)");V.sendControl(v.$ke.fromString(JSON.stringify({type:"ok"})));const z=V.readEntireBuffer();V.dispose(),this.b[ue].acceptReconnection(X,W,z)}else{if(this.b[ue])return this.C(me,V,"Duplicate reconnection token");V.sendControl(v.$ke.fromString(JSON.stringify({type:"ok"})));const z=new y.$Xm(this.w,ue,X,V);this.n.acceptConnection(z.protocol,z.onClose),this.b[ue]=z,this.f.add(ue),z.onClose(()=>{delete this.b[ue]})}else if(ne.desiredConnectionType===2){const z=ne.args||{language:"en"},H=await this.I(z);if(H.port&&this.w.trace(`${me} - startParams debug port ${H.port}`),this.w.trace(`${me} - startParams language: ${H.language}`),this.w.trace(`${me} - startParams env: ${JSON.stringify(H.env)}`),re){if(!this.a[ue])return this.f.has(ue)?this.C(me,V,"Unknown reconnection token (seen before)"):this.C(me,V,"Unknown reconnection token (never seen)");V.sendPause(),V.sendControl(v.$ke.fromString(JSON.stringify(H.port?{debugPort:H.port}:{})));const R=V.readEntireBuffer();V.dispose(),this.a[ue].acceptReconnection(X,W,R)}else{if(this.a[ue])return this.C(me,V,"Duplicate reconnection token");V.sendPause(),V.sendControl(v.$ke.fromString(JSON.stringify(H.port?{debugPort:H.port}:{})));const R=V.readEntireBuffer();V.dispose();const U=this.y.createInstance(P.$Wm,ue,X,W,R);this.a[ue]=U,this.f.add(ue),U.onClose(()=>{delete this.a[ue],this.J()}),U.start(H)}}else if(ne.desiredConnectionType===3){const z=ne.args;this.G(V,z)}else return this.C(me,V,"Unknown initial data received")}async G(X,te){const V=X.getSocket().socket,W=X.readEntireBuffer();X.dispose(),V.pause();const re=await this.H(te.host,te.port);W.byteLength>0&&re.write(W.buffer),re.on("end",()=>V.end()),re.on("close",()=>V.end()),re.on("error",()=>V.destroy()),V.on("end",()=>re.end()),V.on("close",()=>re.end()),V.on("error",()=>re.destroy()),re.pipe(V),V.pipe(re)}H(X,te){return new Promise((V,W)=>{const re=r.createConnection({host:X,port:te,autoSelectFamily:!0},()=>{re.removeListener("error",W),re.pause(),V(re)});re.once("error",W)})}I(X){return typeof X.port=="number"?(0,u.$tg)(X.port,10,5e3).then(te=>(X.port=te,X)):(X.debugId=void 0,X.port=void 0,X.break=void 0,Promise.resolve(X))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(X=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!X?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},G))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};oe=Ne([Oe(4,M.$Gm),Oe(5,a.$Gj),Oe(6,i.$oj),Oe(7,s.$6h)],oe);async function ee(Z,X,te){const V=await(0,A.$3m)(X);V instanceof A.$1m&&(console.warn(V.message),process.exit(1));function W(T){(0,w.setUnexpectedErrorHandler)(N=>{(0,w.$Z)(N)&&N.stack&&/unexpectedErrorHandler/.test(N.stack)||T(N)})}const re=[];W(T=>{re.push(T),console.error(T)});let ue=!1;process.on("SIGPIPE",()=>{ue||(ue=!0,(0,w.$1)(new Error("Unexpected SIGPIPE")))});const ne=new E.$Sc,{socketServer:me,instantiationService:z}=await(0,_.$QO)(V,X,te,ne);z.invokeFunction(T=>{const N=T.get(i.$oj);re.forEach(q=>N.error(q)),re.length=0,W(q=>N.error(q))}),z.invokeFunction(T=>{const N=T.get(n.$Ai);c.$i&&(N.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(N.getValue("security.allowedUNCHosts")))}),z.invokeFunction(T=>{const N=T.get(i.$oj);if(c.$i&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const q=(0,h.$jc)(process.env.HOMEDRIVE,"node_modules"),ie=(0,h.$mc)((0,h.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),ae=(0,h.$jc)(ie,"node_modules");if(O.existsSync(q)||O.existsSync(ae)){const ge=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${q}
* ${ae}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;N.warn(ge),console.warn(ge),process.exit(0)}}});const H=z.invokeFunction(T=>{const N=T.get(i.$oj);if(O.existsSync((0,h.$jc)(b.$pg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(ie){N.error(ie)}return null}),R=O.existsSync(b.$pg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(R&&Z&&typeof Z!="string"){const T=V.type!==0?`?${b.$ig}=${V.value}`:"";console.log(`Web UI available at http://localhost${Z.port===80?"":`:${Z.port}`}/${T}`)}const U=z.createInstance(oe,me,V,H,R);$.mark("code/server/ready");const x=I.performance.now(),J=global.vscodeServerStartTime,Y=global.vscodeServerListenTime,B=global.vscodeServerCodeLoadedTime;if(z.invokeFunction(async T=>{const N=T.get(L.$vl);if(N.publicLog2("serverStart",{startTime:J,startedTime:Y,codeLoadedTime:B,readyTime:x}),c.$k){const q=T.get(i.$oj),ie=await(0,f.$sg)(q.error.bind(q));ie&&N.publicLog2("serverPlatformInfo",{platformId:ie.id,platformVersionId:ie.version_id,platformIdLike:ie.id_like})}}),X["print-startup-performance"]){const T=S.$U.get();let N="";N+=`

### Load AMD-module
`,N+=S.$U.toMarkdownTable(["Module","Duration"],T.amdLoad),N+=`

### Load commonjs-module
`,N+=S.$U.toMarkdownTable(["Module","Duration"],T.nodeRequire),N+=`

### Invoke AMD-module factory
`,N+=S.$U.toMarkdownTable(["Module","Duration"],T.amdInvoke),N+=`

### Invoke commonjs-module
`,N+=S.$U.toMarkdownTable(["Module","Duration"],T.nodeEval),N+=`Start-up time: ${Y-J}
`,N+=`Code loading time: ${B-J}
`,N+=`Initialized time: ${x-J}
`,N+=`
`,console.log(N)}return U}e.$VO=ee;class K{static create(X){const te=X.webEndpointUrlTemplate,V=X.commit,W=X.quality;if(!te||!V||!W)return new K(null);const re=(0,m.$rg)(),ne=new URL(te.replace("{{uuid}}",re).replace("{{commit}}",V).replace("{{quality}}",W)).origin,me=(0,g.$Pe)(ne).replace(re,"[a-zA-Z0-9\\-]+");try{const z=(0,g.$Ye)(`^${me}$`,!0,{matchCase:!1});return new K(z)}catch{return new K(null)}}constructor(X){this.a=X}matches(X){return this.a?this.a.test(X):!1}}}),define(be[306],ve([1,0,28,27,12,291,296,67,7,297,48,57,42]),function(he,e,k,O,r,I,D,S,v,w,C,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,b.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=w.performance.now();const h={onMultipleValues:(s,i)=>{console.error(`Option '${s}' can only be defined once. Using value ${i}.`)},onEmptyValue:s=>{console.error(`Ignoring option '${s}': Value must not be empty.`)},onUnknownOption:s=>{console.error(`Ignoring option '${s}': not supported for server.`)},onDeprecatedOption:(s,i)=>{console.warn(`Option '${s}' is deprecated: ${i}`)}},$=(0,S.$Zl)(process.argv.slice(2),C.$Fm,h),c=$["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.$jc)(k.homedir(),E.default.serverDataFolderName||".vscode-remote"),g=(0,v.$jc)(c,"data"),d=(0,v.$jc)(g,"User"),m=(0,v.$jc)(d,"globalStorage"),f=(0,v.$jc)(d,"History"),u=(0,v.$jc)(g,"Machine");$["user-data-dir"]=g;const l=(0,v.$mc)(r.$pg.asFileUri("").fsPath),t=(0,v.$jc)(l,"extensions");$["builtin-extensions-dir"]=t,$["extensions-dir"]=$["extensions-dir"]||(0,v.$jc)(c,"extensions"),[c,$["extensions-dir"],g,d,u,m,f].forEach(s=>{try{O.existsSync(s)||O.mkdirSync(s,{mode:448})}catch(i){console.error(i)}});function o(){(0,I.run)($,c,C.$Fm)}e.spawnCli=o;function n(s){return(0,D.$VO)(s,$,c)}e.createServer=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/31c37ee8f63491495ac49e43b8544550fbae4533/core/vs/server/node/server.main.js.map
