/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(ge){for(var e=[],C=0,F=ge.length;C<F;C++)e[C]=Ee[ge[C]];return e};define(Ee[157],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class C{static get(){const f=new Map,P=new Map,A=new Map,v=new Map;function $(k,S){k.has(S.detail)||k.set(S.detail,-S.timestamp)}function E(k,S){const c=k.get(S.detail);c&&(c>=0||k.set(S.detail,c+S.timestamp))}let R=[];typeof ge=="function"&&typeof ge.getStats=="function"&&(R=ge.getStats().slice(0).sort((k,S)=>k.timestamp-S.timestamp));for(const k of R)switch(k.type){case 10:$(f,k);break;case 11:case 12:E(f,k);break;case 21:$(P,k);break;case 22:E(P,k);break;case 33:$(A,k);break;case 34:E(A,k);break;case 31:$(v,k);break;case 32:E(v,k);break}let D=0;A.forEach(k=>D+=k);function p(k){const S=[];return k.forEach((c,g)=>S.push([g,c])),S}return{amdLoad:p(f),amdInvoke:p(P),nodeRequire:p(A),nodeEval:p(v),nodeRequireTotal:D}}static toMarkdownTable(f,P){let A="";const v=[];return f.forEach(($,E)=>{v[E]=$.length}),P.forEach($=>{$.forEach((E,R)=>{typeof E>"u"&&(E=$[R]="-");const D=E.toString().length;v[R]=Math.max(D,v[R])})}),f.forEach(($,E)=>{A+=`| ${$+" ".repeat(v[E]-$.toString().length)} `}),A+=`|
`,f.forEach(($,E)=>{A+=`| ${"-".repeat(v[E])} `}),A+=`|
`,P.forEach($=>{$.forEach((E,R)=>{typeof E<"u"&&(A+=`| ${E+" ".repeat(v[R]-E.toString().length)} `)}),A+=`|
`}),A}}e.$U=C}),define(Ee[158],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function C(c,g,o){const i=F(c,g);if(i!==-1)return c[i]}e.$fb=C;function F(c,g,o=c.length-1){for(let i=o;i>=0;i--){const r=c[i];if(g(r))return i}return-1}e.$gb=F;function f(c,g){const o=P(c,g);return o===-1?void 0:c[o]}e.$hb=f;function P(c,g,o=0,i=c.length){let r=o,n=i;for(;r<n;){const a=Math.floor((r+n)/2);g(c[a])?r=a+1:n=a}return r-1}e.$ib=P;function A(c,g){const o=v(c,g);return o===c.length?void 0:c[o]}e.$jb=A;function v(c,g,o=0,i=c.length){let r=o,n=i;for(;r<n;){const a=Math.floor((r+n)/2);g(c[a])?n=a:r=a+1}return r}e.$kb=v;function $(c,g,o=0,i=c.length){const r=v(c,g,o,i);return r===c.length?-1:r}e.$lb=$;class E{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(E.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!g(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const o=P(this.e,g,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=E;function R(c,g){if(c.length===0)return;let o=c[0];for(let i=1;i<c.length;i++){const r=c[i];g(r,o)>0&&(o=r)}return o}e.$nb=R;function D(c,g){if(c.length===0)return;let o=c[0];for(let i=1;i<c.length;i++){const r=c[i];g(r,o)>=0&&(o=r)}return o}e.$ob=D;function p(c,g){return R(c,(o,i)=>-g(o,i))}e.$pb=p;function k(c,g){if(c.length===0)return-1;let o=0;for(let i=1;i<c.length;i++){const r=c[i];g(r,c[o])>0&&(o=i)}return o}e.$qb=k;function S(c,g){for(const o of c){const i=g(o);if(i!==void 0)return i}}e.$rb=S}),define(Ee[73],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function C(A,v){const $=Object.create(null);for(const E of A){const R=v(E);let D=$[R];D||(D=$[R]=[]),D.push(E)}return $}e.$K=C;function F(A,v){const $=[],E=[];for(const R of A)v.has(R)||$.push(R);for(const R of v)A.has(R)||E.push(R);return{removed:$,added:E}}e.$L=F;function f(A,v){const $=[],E=[];for(const[R,D]of A)v.has(R)||$.push(D);for(const[R,D]of v)A.has(R)||E.push(D);return{removed:$,added:E}}e.$M=f;function P(A,v){const $=new Set;for(const E of v)A.has(E)&&$.add(E);return $}e.$N=P}),define(Ee[52],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=void 0;function C(A){return(v,$,E)=>{let R=null,D=null;if(typeof E.value=="function"?(R="value",D=E.value):typeof E.get=="function"&&(R="get",D=E.get),!D)throw new Error("not supported");E[R]=A(D,$)}}function F(A,v,$){let E=null,R=null;if(typeof $.value=="function"?(E="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(E="get",R=$.get),!R)throw new Error("not supported");const D=`$memoize$${v}`;$[E]=function(...p){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[D]}}e.$yh=F;function f(A,v,$){return C((E,R)=>{const D=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...k){this[p]||(this[p]=$?$():void 0),clearTimeout(this[D]),v&&(this[p]=v(this[p],...k),k=[this[p]]),this[D]=setTimeout(()=>{E.apply(this,k),this[p]=$?$():void 0},A)}})}e.$zh=f;function P(A,v,$){return C((E,R)=>{const D=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,k=`$throttle$lastRun$${R}`,S=`$throttle$pending$${R}`;return function(...c){if(this[p]||(this[p]=$?$():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),v&&(this[p]=v(this[p],...c)),this[S])return;const g=this[k]+A;g<=Date.now()?(this[k]=Date.now(),E.apply(this,[this[p]]),this[p]=$?$():void 0):(this[S]=!0,this[D]=setTimeout(()=>{this[S]=!1,this[k]=Date.now(),E.apply(this,[this[p]]),this[p]=$?$():void 0},g-Date.now()))}})}e.$Ah=P}),define(Ee[14],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?r.isErrorNoTelemetry(t)?new r(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(h=>{h(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=C,e.$X=new C;function F(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=f;function P(a){E(a)||e.$X.onUnexpectedError(a)}e.$1=P;function A(a){E(a)||e.$X.onUnexpectedExternalError(a)}e.$2=A;function v(a){if(a instanceof Error){const{name:t,message:h}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:h,stack:s,noTelemetry:r.isErrorNoTelemetry(a)}}return a}e.$3=v;const $="Canceled";function E(a){return a instanceof R?!0:a instanceof Error&&a.name===$&&a.message===$}e.$4=E;class R extends Error{constructor(){super($),this.name=this.message}}e.$5=R;function D(){const a=new Error($);return a.name=a.message,a}e.$6=D;function p(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=p;function k(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=k;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function c(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=c;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class r extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof r)return t;const h=new r;return h.message=t.message,h.stack=t.stack,h}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=r;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(Ee[19],Se([1,0,14,158]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function f(de,fe=0){return de[de.length-(1+fe)]}e.$sb=f;function P(de){if(de.length===0)throw new Error("Invalid tail call");return[de.slice(0,de.length-1),de[de.length-1]]}e.$tb=P;function A(de,fe,_=(ee,G)=>ee===G){if(de===fe)return!0;if(!de||!fe||de.length!==fe.length)return!1;for(let ee=0,G=de.length;ee<G;ee++)if(!_(de[ee],fe[ee]))return!1;return!0}e.$ub=A;function v(de,fe){const _=de.length-1;fe<_&&(de[fe]=de[_]),de.pop()}e.$vb=v;function $(de,fe,_){return E(de.length,ee=>_(de[ee],fe))}e.$wb=$;function E(de,fe){let _=0,ee=de-1;for(;_<=ee;){const G=(_+ee)/2|0,x=fe(G);if(x<0)_=G+1;else if(x>0)ee=G-1;else return G}return-(_+1)}e.$xb=E;function R(de,fe,_){if(de=de|0,de>=fe.length)throw new TypeError("invalid index");const ee=fe[Math.floor(fe.length*Math.random())],G=[],x=[],me=[];for(const we of fe){const Ae=_(we,ee);Ae<0?G.push(we):Ae>0?x.push(we):me.push(we)}return de<G.length?R(de,G,_):de<G.length+me.length?me[0]:R(de-(G.length+me.length),x,_)}e.$yb=R;function D(de,fe){const _=[];let ee;for(const G of de.slice(0).sort(fe))!ee||fe(ee[0],G)!==0?(ee=[G],_.push(ee)):ee.push(G);return _}e.$zb=D;function*p(de,fe){let _,ee;for(const G of de)ee!==void 0&&fe(ee,G)?_.push(G):(_&&(yield _),_=[G]),ee=G;_&&(yield _)}e.$Ab=p;function k(de,fe){for(let _=0;_<=de.length;_++)fe(_===0?void 0:de[_-1],_===de.length?void 0:de[_])}e.$Bb=k;function S(de,fe){for(let _=0;_<de.length;_++)fe(_===0?void 0:de[_-1],de[_],_+1===de.length?void 0:de[_+1])}e.$Cb=S;function c(de,fe,_){const ee=[];function G(we,Ae,ve){if(Ae===0&&ve.length===0)return;const Ie=ee[ee.length-1];Ie&&Ie.start+Ie.deleteCount===we?(Ie.deleteCount+=Ae,Ie.toInsert.push(...ve)):ee.push({start:we,deleteCount:Ae,toInsert:ve})}let x=0,me=0;for(;;){if(x===de.length){G(x,0,fe.slice(me));break}if(me===fe.length){G(x,de.length-x,[]);break}const we=de[x],Ae=fe[me],ve=_(we,Ae);ve===0?(x+=1,me+=1):ve<0?(G(x,1,[]),x+=1):ve>0&&(G(x,0,[Ae]),me+=1)}return ee}e.$Db=c;function g(de,fe,_){const ee=c(de,fe,_),G=[],x=[];for(const me of ee)G.push(...de.slice(me.start,me.start+me.deleteCount)),x.push(...me.toInsert);return{removed:G,added:x}}e.$Eb=g;function o(de,fe,_){if(_===0)return[];const ee=de.slice(0,_).sort(fe);return r(de,fe,ee,_,de.length),ee}e.top=o;function i(de,fe,_,ee,G){return _===0?Promise.resolve([]):new Promise((x,me)=>{(async()=>{const we=de.length,Ae=de.slice(0,_).sort(fe);for(let ve=_,Ie=Math.min(_+ee,we);ve<we;ve=Ie,Ie=Math.min(Ie+ee,we)){if(ve>_&&await new Promise(B=>setTimeout(B)),G&&G.isCancellationRequested)throw new C.$5;r(de,fe,Ae,ve,Ie)}return Ae})().then(x,me)})}e.$Gb=i;function r(de,fe,_,ee,G){for(const x=_.length;ee<G;ee++){const me=de[ee];if(fe(me,_[x-1])<0){_.pop();const we=(0,F.$kb)(_,Ae=>fe(me,Ae)<0);_.splice(we,0,me)}}}function n(de){return de.filter(fe=>!!fe)}e.$Hb=n;function a(de){let fe=0;for(let _=0;_<de.length;_++)de[_]&&(de[fe]=de[_],fe+=1);de.length=fe}e.$Ib=a;function t(de,fe,_){de.splice(_,0,de.splice(fe,1)[0])}e.$Jb=t;function h(de){return!Array.isArray(de)||de.length===0}e.$Kb=h;function s(de){return Array.isArray(de)&&de.length>0}e.$Lb=s;function d(de,fe=_=>_){const _=new Set;return de.filter(ee=>{const G=fe(ee);return _.has(G)?!1:(_.add(G),!0)})}e.$Mb=d;function l(de){const fe=new Set;return _=>{const ee=de(_);return fe.has(ee)?!1:(fe.add(ee),!0)}}e.$Nb=l;function u(de,fe){return de.length>0?de[0]:fe}e.$Ob=u;function w(de,fe){return de.length>0?de[de.length-1]:fe}e.$Pb=w;function I(de,fe,_=(ee,G)=>ee===G){let ee=0;for(let G=0,x=Math.min(de.length,fe.length);G<x&&_(de[G],fe[G]);G++)ee++;return ee}e.$Qb=I;function b(de){return[].concat(...de)}e.$Rb=b;function m(de,fe){let _=typeof fe=="number"?de:0;typeof fe=="number"?_=de:(_=0,fe=de);const ee=[];if(_<=fe)for(let G=_;G<fe;G++)ee.push(G);else for(let G=_;G>fe;G--)ee.push(G);return ee}e.$Sb=m;function y(de,fe,_){return de.reduce((ee,G)=>(ee[fe(G)]=_?_(G):G,ee),Object.create(null))}e.$Tb=y;function L(de,fe){return de.push(fe),()=>N(de,fe)}e.$Ub=L;function N(de,fe){const _=de.indexOf(fe);if(_>-1)return de.splice(_,1),fe}e.$Vb=N;function U(de,fe,_){const ee=de.slice(0,fe),G=de.slice(fe);return ee.concat(_,G)}e.$Wb=U;function T(de,fe){let _;if(typeof fe=="number"){let ee=fe;_=()=>{const G=Math.sin(ee++)*179426549;return G-Math.floor(G)}}else _=Math.random;for(let ee=de.length-1;ee>0;ee-=1){const G=Math.floor(_()*(ee+1)),x=de[ee];de[ee]=de[G],de[G]=x}}e.$Xb=T;function O(de,fe){const _=de.indexOf(fe);_>-1&&(de.splice(_,1),de.unshift(fe))}e.$Yb=O;function M(de,fe){const _=de.indexOf(fe);_>-1&&(de.splice(_,1),de.push(fe))}e.$Zb=M;function j(de,fe){for(const _ of fe)de.push(_)}e.$1b=j;function z(de,fe){return Array.isArray(de)?de.map(fe):fe(de)}e.$2b=z;function J(de){return Array.isArray(de)?de:[de]}e.$3b=J;function le(de){return de[Math.floor(Math.random()*de.length)]}e.$4b=le;function Y(de,fe,_){const ee=X(de,fe),G=de.length,x=_.length;de.length=G+x;for(let me=G-1;me>=ee;me--)de[me+x]=de[me];for(let me=0;me<x;me++)de[me+ee]=_[me]}e.$5b=Y;function Q(de,fe,_,ee){const G=X(de,fe);let x=de.splice(G,_);return x===void 0&&(x=[]),Y(de,G,ee),x}e.$6b=Q;function X(de,fe){return fe<0?Math.max(fe+de.length,0):Math.min(fe,de.length)}var ue;(function(de){function fe(x){return x<0}de.isLessThan=fe;function _(x){return x<=0}de.isLessThanOrEqual=_;function ee(x){return x>0}de.isGreaterThan=ee;function G(x){return x===0}de.isNeitherLessOrGreaterThan=G,de.greaterThan=1,de.lessThan=-1,de.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function ne(de,fe){return(_,ee)=>fe(de(_),de(ee))}e.$7b=ne;function $e(...de){return(fe,_)=>{for(const ee of de){const G=ee(fe,_);if(!ue.isNeitherLessOrGreaterThan(G))return G}return ue.neitherLessOrGreaterThan}}e.$8b=$e;const oe=(de,fe)=>de-fe;e.$9b=oe;const K=(de,fe)=>(0,e.$9b)(de?1:0,fe?1:0);e.$0b=K;function W(de){return(fe,_)=>-de(fe,_)}e.$$b=W;class ie{constructor(fe){this.g=fe,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(fe){let _=this.c;for(;_<this.g.length&&fe(this.g[_]);)_++;const ee=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ee}takeFromEndWhile(fe){let _=this.d;for(;_>=0&&fe(this.g[_]);)_--;const ee=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const fe=this.g[this.c];return this.c++,fe}removeLast(){const fe=this.g[this.d];return this.d--,fe}takeCount(fe){const _=this.g.slice(this.c,this.c+fe);return this.c+=fe,_}}e.$_b=ie;class ye{static{this.empty=new ye(fe=>{})}constructor(fe){this.iterate=fe}forEach(fe){this.iterate(_=>(fe(_),!0))}toArray(){const fe=[];return this.iterate(_=>(fe.push(_),!0)),fe}filter(fe){return new ye(_=>this.iterate(ee=>fe(ee)?_(ee):!0))}map(fe){return new ye(_=>this.iterate(ee=>_(fe(ee))))}some(fe){let _=!1;return this.iterate(ee=>(_=fe(ee),!_)),_}findFirst(fe){let _;return this.iterate(ee=>fe(ee)?(_=ee,!1):!0),_}findLast(fe){let _;return this.iterate(ee=>(fe(ee)&&(_=ee),!0)),_}findLastMaxBy(fe){let _,ee=!0;return this.iterate(G=>((ee||ue.isGreaterThan(fe(G,_)))&&(ee=!1,_=G),!0)),_}}e.$ac=ye}),define(Ee[61],Se([1,0,14]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function F(E,R){if(!E)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=F;function f(E,R="Unreachable"){throw new Error(R)}e.$6c=f;function P(E){if(!E)throw new C.$cb("Assertion Failed")}e.$7c=P;function A(E){E||(0,C.$1)(new C.$cb("Assertion Failed"))}e.$8c=A;function v(E){if(!E()){debugger;E(),(0,C.$1)(new C.$cb("Assertion Failed"))}}e.$9c=v;function $(E,R){let D=0;for(;D<E.length-1;){const p=E[D],k=E[D+1];if(!R(p,k))return!1;D++}return!0}e.$0c=$}),define(Ee[74],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function C(F,f){const P=this;let A=!1,v;return function(){if(A)return v;if(A=!0,f)try{v=F.apply(P,arguments)}finally{f()}else v=F.apply(P,arguments);return v}}e.$db=C}),define(Ee[121],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=void 0;class C{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$pN=C,e.$qN=new C("id#")}),define(Ee[53],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(F){function f(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}F.is=f;const P=Object.freeze([]);function A(){return P}F.empty=A;function*v(t){yield t}F.single=v;function $(t){return f(t)?t:v(t)}F.wrap=$;function E(t){return t||P}F.from=E;function*R(t){for(let h=t.length-1;h>=0;h--)yield t[h]}F.reverse=R;function D(t){return!t||t[Symbol.iterator]().next().done===!0}F.isEmpty=D;function p(t){return t[Symbol.iterator]().next().value}F.first=p;function k(t,h){for(const s of t)if(h(s))return!0;return!1}F.some=k;function S(t,h){for(const s of t)if(h(s))return s}F.find=S;function*c(t,h){for(const s of t)h(s)&&(yield s)}F.filter=c;function*g(t,h){let s=0;for(const d of t)yield h(d,s++)}F.map=g;function*o(...t){for(const h of t)yield*h}F.concat=o;function i(t,h,s){let d=s;for(const l of t)d=h(d,l);return d}F.reduce=i;function*r(t,h,s=t.length){for(h<0&&(h+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);h<s;h++)yield t[h]}F.slice=r;function n(t,h=Number.POSITIVE_INFINITY){const s=[];if(h===0)return[s,t];const d=t[Symbol.iterator]();for(let l=0;l<h;l++){const u=d.next();if(u.done)return[s,F.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return d}}]}F.consume=n;async function a(t){const h=[];for await(const s of t)h.push(s);return Promise.resolve(h)}F.asyncToArray=a})(C||(e.Iterable=C={}))}),define(Ee[159],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function A(t,h=!1){let s=0;const d=t.length;let l="",u=0,w=16,I=0;function b(O){let M=0,j=0;for(;M<O;){const z=t.charCodeAt(s);if(z>=48&&z<=57)j=j*16+z-48;else if(z>=65&&z<=70)j=j*16+z-65+10;else if(z>=97&&z<=102)j=j*16+z-97+10;else break;s++,M++}return M<O&&(j=-1),j}function m(O){s=O,l="",u=0,w=16,I=0}function y(){const O=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&E(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&E(t.charCodeAt(s)))for(s++;s<t.length&&E(t.charCodeAt(s));)s++;else return I=3,t.substring(O,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&E(t.charCodeAt(s))){for(s++;s<t.length&&E(t.charCodeAt(s));)s++;M=s}else I=3;return t.substring(O,M)}function L(){let O="",M=s;for(;;){if(s>=d){O+=t.substring(M,s),I=2;break}const j=t.charCodeAt(s);if(j===34){O+=t.substring(M,s),s++;break}if(j===92){if(O+=t.substring(M,s),s++,s>=d){I=2;break}switch(t.charCodeAt(s++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const J=b(4);J>=0?O+=String.fromCharCode(J):I=4;break}default:I=5}M=s;continue}if(j>=0&&j<=31)if($(j)){O+=t.substring(M,s),I=2;break}else I=6;s++}return O}function N(){if(l="",I=0,u=s,s>=d)return u=d,w=17;let O=t.charCodeAt(s);if(v(O)){do s++,l+=String.fromCharCode(O),O=t.charCodeAt(s);while(v(O));return w=15}if($(O))return s++,l+=String.fromCharCode(O),O===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),w=14;switch(O){case 123:return s++,w=1;case 125:return s++,w=2;case 91:return s++,w=3;case 93:return s++,w=4;case 58:return s++,w=6;case 44:return s++,w=5;case 34:return s++,l=L(),w=10;case 47:{const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<d&&!$(t.charCodeAt(s));)s++;return l=t.substring(M,s),w=12}if(t.charCodeAt(s+1)===42){s+=2;const j=d-1;let z=!1;for(;s<j;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,I=1),l=t.substring(M,s),w=13}return l+=String.fromCharCode(O),s++,w=16}case 45:if(l+=String.fromCharCode(O),s++,s===d||!E(t.charCodeAt(s)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=y(),w=11;default:for(;s<d&&U(O);)s++,O=t.charCodeAt(s);if(u!==s){switch(l=t.substring(u,s),l){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return l+=String.fromCharCode(O),s++,w=16}}function U(O){if(v(O)||$(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:m,getPosition:()=>s,scan:h?T:N,getToken:()=>w,getTokenValue:()=>l,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>I}}e.$bn=A;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function D(t,h){const s=[],d=new Object;let l;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function I(b,m,y,L){u.value=b,u.offset=m,u.length=y,u.type=L,u.colonOffset=void 0,l=u}try{r(t,{onObjectBegin:(b,m)=>{if(h<=b)throw d;l=void 0,w=h>b,s.push("")},onObjectProperty:(b,m,y)=>{if(h<m||(I(b,m,y,"property"),s[s.length-1]=b,h<=m+y))throw d},onObjectEnd:(b,m)=>{if(h<=b)throw d;l=void 0,s.pop()},onArrayBegin:(b,m)=>{if(h<=b)throw d;l=void 0,s.push(0)},onArrayEnd:(b,m)=>{if(h<=b)throw d;l=void 0,s.pop()},onLiteralValue:(b,m,y)=>{if(h<m||(I(b,m,y,a(b)),h<=m+y))throw d},onSeparator:(b,m,y)=>{if(h<=m)throw d;if(b===":"&&l&&l.type==="property")l.colonOffset=m,w=!1,l=void 0;else if(b===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(w=!0,s[s.length-1]=""),l=void 0}}})}catch(b){if(b!==d)throw b}return{path:s,previousNode:l,isAtPropertyKey:w,matches:b=>{let m=0;for(let y=0;m<b.length&&y<s.length;y++)if(b[m]===s[y]||b[m]==="*")m++;else if(b[m]!=="**")return!1;return m===b.length}}}e.$cn=D;function p(t,h=[],s=P.DEFAULT){let d=null,l=[];const u=[];function w(b){Array.isArray(l)?l.push(b):d!==null&&(l[d]=b)}return r(t,{onObjectBegin:()=>{const b={};w(b),u.push(l),l=b,d=null},onObjectProperty:b=>{d=b},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{const b=[];w(b),u.push(l),l=b,d=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:w,onError:(b,m,y)=>{h.push({error:b,offset:m,length:y})}},s),l[0]}e.$dn=p;function k(t,h=[],s=P.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(b){d.type==="property"&&(d.length=b-d.offset,d=d.parent)}function u(b){return d.children.push(b),b}r(t,{onObjectBegin:b=>{d=u({type:"object",offset:b,length:-1,parent:d,children:[]})},onObjectProperty:(b,m,y)=>{d=u({type:"property",offset:m,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:b,offset:m,length:y,parent:d})},onObjectEnd:(b,m)=>{d.length=b+m-d.offset,d=d.parent,l(b+m)},onArrayBegin:(b,m)=>{d=u({type:"array",offset:b,length:-1,parent:d,children:[]})},onArrayEnd:(b,m)=>{d.length=b+m-d.offset,d=d.parent,l(b+m)},onLiteralValue:(b,m,y)=>{u({type:a(b),offset:m,length:y,parent:d,value:b}),l(m+y)},onSeparator:(b,m,y)=>{d.type==="property"&&(b===":"?d.colonOffset=m:b===","&&l(m))},onError:(b,m,y)=>{h.push({error:b,offset:m,length:y})}},s);const I=d.children[0];return I&&delete I.parent,I}e.$en=k;function S(t,h){if(!t)return;let s=t;for(const d of h)if(typeof d=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===d){s=u.children[1],l=!0;break}if(!l)return}else{const l=d;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.$fn=S;function c(t){if(!t.parent||!t.parent.children)return[];const h=c(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;h.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&h.push(s)}return h}e.$gn=c;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const h=Object.create(null);for(const s of t.children){const d=s.children[1];d&&(h[s.children[0].value]=g(d))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$hn=g;function o(t,h,s=!1){return h>=t.offset&&h<t.offset+t.length||s&&h===t.offset+t.length}e.$in=o;function i(t,h,s=!1){if(o(t,h,s)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=h;l++){const u=i(d[l],h,s);if(u)return u}return t}}e.$jn=i;function r(t,h,s=P.DEFAULT){const d=A(t,!1);function l(ne){return ne?()=>ne(d.getTokenOffset(),d.getTokenLength()):()=>!0}function u(ne){return ne?$e=>ne($e,d.getTokenOffset(),d.getTokenLength()):()=>!0}const w=l(h.onObjectBegin),I=u(h.onObjectProperty),b=l(h.onObjectEnd),m=l(h.onArrayBegin),y=l(h.onArrayEnd),L=u(h.onLiteralValue),N=u(h.onSeparator),U=l(h.onComment),T=u(h.onError),O=s&&s.disallowComments,M=s&&s.allowTrailingComma;function j(){for(;;){const ne=d.scan();switch(d.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:O||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ne){case 12:case 13:O?z(10):U();break;case 16:z(1);break;case 15:case 14:break;default:return ne}}}function z(ne,$e=[],oe=[]){if(T(ne),$e.length+oe.length>0){let K=d.getToken();for(;K!==17;){if($e.indexOf(K)!==-1){j();break}else if(oe.indexOf(K)!==-1)break;K=j()}}}function J(ne){const $e=d.getTokenValue();return ne?L($e):I($e),j(),!0}function le(){switch(d.getToken()){case 11:{let ne=0;try{ne=JSON.parse(d.getTokenValue()),typeof ne!="number"&&(z(2),ne=0)}catch{z(2)}L(ne);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return j(),!0}function Y(){return d.getToken()!==10?(z(3,[],[2,5]),!1):(J(!1),d.getToken()===6?(N(":"),j(),ue()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function Q(){w(),j();let ne=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ne||z(4,[],[]),N(","),j(),d.getToken()===2&&M)break}else ne&&z(6,[],[]);Y()||z(4,[],[2,5]),ne=!0}return b(),d.getToken()!==2?z(7,[2],[]):j(),!0}function X(){m(),j();let ne=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ne||z(4,[],[]),N(","),j(),d.getToken()===4&&M)break}else ne&&z(6,[],[]);ue()||z(4,[],[4,5]),ne=!0}return y(),d.getToken()!==4?z(8,[4],[]):j(),!0}function ue(){switch(d.getToken()){case 3:return X();case 1:return Q();case 10:return J(!0);default:return le()}}return j(),d.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):ue()?(d.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.$kn=r;function n(t,h){const s=A(t),d=[];let l,u=0,w;do switch(w=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:u!==w&&d.push(t.substring(u,w)),h!==void 0&&d.push(s.getTokenValue().replace(/[^\r\n]/g,h)),u=s.getPosition();break}while(l!==17);return d.join("")}e.$ln=n;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$mn=a}),define(Ee[43],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class C{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=C}),define(Ee[75],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(P){this.element=P,this.next=C.Undefined,this.prev=C.Undefined}}class F{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let P=this.a;for(;P!==C.Undefined;){const A=P.next;P.prev=C.Undefined,P.next=C.Undefined,P=A}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,A){const v=new C(P);if(this.a===C.Undefined)this.a=v,this.b=v;else if(A){const E=this.b;this.b=v,v.prev=E,E.next=v}else{const E=this.a;this.a=v,v.next=E,E.prev=v}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(v))}}shift(){if(this.a!==C.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==C.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==C.Undefined&&P.next!==C.Undefined){const A=P.prev;A.next=P.next,P.next.prev=A}else P.prev===C.Undefined&&P.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):P.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):P.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==C.Undefined;)yield P.element,P=P.next}}e.$4c=F}),define(Ee[28],Se([1,0]),function(ge,e){"use strict";var C,F,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function P(r,n,a){let t=r.get(n);return t===void 0&&(t=a,r.set(n,t)),t}e.$xc=P;function A(r){const n=[];return r.forEach((a,t)=>{n.push(`${t} => ${a}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.$yc=A;function v(r){const n=[];return r.forEach(a=>{n.push(a)}),`Set(${r.size}) {${n.join(", ")}}`}e.$zc=v;class ${constructor(n,a){this.uri=n,this.value=a}}function E(r){return Array.isArray(r)}class R{static{this.c=n=>n.toString()}constructor(n,a){if(this[C]="ResourceMap",n instanceof R)this.d=new Map(n.d),this.e=a??R.c;else if(E(n)){this.d=new Map,this.e=a??R.c;for(const[t,h]of n)this.set(t,h)}else this.d=new Map,this.e=n??R.c}set(n,a){return this.d.set(this.e(n),new $(n,a)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,a){typeof a<"u"&&(n=n.bind(a));for(const[t,h]of this.d)n(h.value,h.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=R;class D{constructor(n,a){this[F]="ResourceSet",!n||typeof n=="function"?this.c=new R(n):(this.c=new R(a),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,a){this.c.forEach((t,h)=>n.call(a,h,h,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=D;var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class k{constructor(){this[f]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,a=0){const t=this.c.get(n);if(t)return a!==0&&this.l(t,a),t.value}set(n,a,t=0){let h=this.c.get(n);if(h)h.value=a,t!==0&&this.l(h,t);else{switch(h={key:n,value:a,next:void 0,previous:void 0},t){case 0:this.j(h);break;case 1:this.i(h);break;case 2:this.j(h);break;default:this.j(h);break}this.c.set(n,h),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const a=this.c.get(n);if(a)return this.c.delete(n),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,a){const t=this.g;let h=this.d;for(;h;){if(a?n.bind(a)(h.value,h.key,this):n(h.value,h.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const n=this,a=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}values(){const n=this,a=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}entries(){const n=this,a=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>n;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const a=n.next,t=n.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}n.next=void 0,n.previous=void 0,this.g++}l(n,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(n===this.d)return;const t=n.next,h=n.previous;n===this.e?(h.next=void 0,this.e=h):(t.previous=h,h.next=t),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(a===2){if(n===this.e)return;const t=n.next,h=n.previous;n===this.d?(t.previous=void 0,this.d=t):(t.previous=h,h.next=t),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((a,t)=>{n.push([t,a])}),n}fromJSON(n){this.clear();for(const[a,t]of n)this.set(a,t)}}e.$Cc=k;class S extends k{constructor(n,a=1){super(),this.m=n,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,a=2){return super.get(n,a)}peek(n){return super.get(n,0)}set(n,a){return super.set(n,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class c{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let a=this.c.get(n)||0;return a===0?!1:(a--,a===0?this.c.delete(n):this.c.set(n,a),!0)}has(n){return this.c.has(n)}}e.$Ec=c;class g{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[a,t]of n)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(n,a){this.c.set(n,a),this.d.set(a,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const a=this.c.get(n);return a===void 0?!1:(this.c.delete(n),this.d.delete(a),!0)}forEach(n,a){this.c.forEach((t,h)=>{n.call(a,t,h,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=g;class o{constructor(){this.c=new Map}add(n,a){let t=this.c.get(n);t||(t=new Set,this.c.set(n,t)),t.add(a)}delete(n,a){const t=this.c.get(n);t&&(t.delete(a),t.size===0&&this.c.delete(n))}forEach(n,a){const t=this.c.get(n);t&&t.forEach(a)}get(n){const a=this.c.get(n);return a||new Set}}e.$Gc=o;function i(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[a,t]of r)if(!n.has(a)||n.get(a)!==t)return!1;for(const[a]of n)if(!r.has(a))return!1;return!0}e.$Hc=i}),define(Ee[3],Se([1,0,19,73,28,74,53]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const v=!1;let $=null;class E{constructor(){this.b=new Map}static{this.a=0}c(L){let N=this.b.get(L);return N||(N={parent:null,source:null,isSingleton:!1,value:L,idx:E.a++},this.b.set(L,N)),N}trackDisposable(L){const N=this.c(L);N.source||(N.source=new Error().stack)}setParent(L,N){const U=this.c(L);U.parent=N}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,N){const U=N.get(L);if(U)return U;const T=L.parent?this.f(this.c(L.parent),N):L;return N.set(L,T),T}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,L).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(L=10,N){let U;if(N)U=N;else{const z=new Map,J=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,z).isSingleton);if(J.length===0)return;const le=new Set(J.map(Y=>Y.value));if(U=J.filter(Y=>!(Y.parent&&le.has(Y.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function T(z){function J(Y,Q){for(;Y.length>0&&Q.some(X=>typeof X=="string"?X===Y[0]:Y[0].match(X));)Y.shift()}const le=z.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return J(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const O=new f.$Gc;for(const z of U){const J=T(z);for(let le=0;le<=J.length;le++)O.add(J.slice(0,le).join(`
`),z)}U.sort((0,C.$7b)(z=>z.idx,C.$9b));let M="",j=0;for(const z of U.slice(0,L)){j++;const J=T(z),le=[];for(let Y=0;Y<J.length;Y++){let Q=J[Y];Q=`(shared with ${O.get(J.slice(0,Y+1).join(`
`)).size}/${U.length} leaks) at ${Q}`;const ue=O.get(J.slice(0,Y).join(`
`)),ne=(0,F.$K)([...ue].map($e=>T($e)[Y]),$e=>$e);delete ne[J[Y]];for(const[$e,oe]of Object.entries(ne))le.unshift(`    - stacktraces of ${oe.length} other leaks continue with ${$e}`);le.unshift(Q)}M+=`


==================== Leaking disposable ${j}/${U.length}: ${z.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return U.length>L&&(M+=`


... and ${U.length-L} more leaking disposables

`),{leaks:U,details:M}}}e.$Ic=E;function R(y){$=y}if(e.$Jc=R,v){const y="__is_disposable_tracked__";R(new class{trackDisposable(L){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[y]||console.log(N)},3e3)}setParent(L,N){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsDisposed(L){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsSingleton(L){}})}function D(y){return $?.trackDisposable(y),y}e.$Kc=D;function p(y){$?.markAsDisposed(y)}e.$Lc=p;function k(y,L){$?.setParent(y,L)}function S(y,L){if($)for(const N of y)$.setParent(N,L)}function c(y){return $?.markAsSingleton(y),y}e.$Mc=c;function g(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Nc=g;function o(y){if(A.Iterable.is(y)){const L=[];for(const N of y)if(N)try{N.dispose()}catch(U){L.push(U)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Oc=o;function i(y){for(const L of y)g(L)&&L.dispose();return[]}e.$Pc=i;function r(...y){const L=n(()=>o(y));return S(y,L),L}e.$Qc=r;function n(y){const L=D({dispose:(0,P.$db)(()=>{p(L),y()})});return L}e.$Rc=n;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,D(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return k(L,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),k(L,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,D(this),k(this.q,this)}dispose(){p(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Tc=t;class h{constructor(){this.b=!1,D(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&k(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&k(L,null),L}}e.$Uc=h;class s{constructor(L){this.a=new h,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class d{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=d;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(L){let N=L;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,p(this))},this}}e.$Xc=l;class u{constructor(){this.a=new Map}acquire(L,...N){let U=this.a.get(L);U||(U={counter:0,object:this.b(L,...N)},this.a.set(L,U));const{object:T}=U,O=(0,P.$db)(()=>{--U.counter===0&&(this.c(L,U.object),this.a.delete(L))});return U.counter++,{object:T,dispose:O}}}e.$Yc=u;class w{constructor(L){this.a=L}async acquire(L,...N){const U=this.a.acquire(L,...N);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(T){throw U.dispose(),T}}}e.$Zc=w;class I{constructor(L){this.object=L}dispose(){}}e.$1c=I;function b(y){const L=new a;try{y(L)}finally{L.dispose()}}e.$2c=b;class m{constructor(){this.a=new Map,this.b=!1,D(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,N,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(L)?.dispose(),this.a.set(L,N)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=m}),function(ge,e){typeof define=="function"&&define.amd?define(Ee[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(fe,_){for(var ee=0;ee<_.length;ee++){var G=_[ee];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(fe,G.key,G)}}function C(fe,_,ee){return _&&e(fe.prototype,_),ee&&e(fe,ee),Object.defineProperty(fe,"prototype",{writable:!1}),fe}function F(fe,_){if(fe){if(typeof fe=="string")return f(fe,_);var ee=Object.prototype.toString.call(fe).slice(8,-1);if(ee==="Object"&&fe.constructor&&(ee=fe.constructor.name),ee==="Map"||ee==="Set")return Array.from(fe);if(ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ee))return f(fe,_)}}function f(fe,_){(_==null||_>fe.length)&&(_=fe.length);for(var ee=0,G=new Array(_);ee<_;ee++)G[ee]=fe[ee];return G}function P(fe,_){var ee=typeof Symbol<"u"&&fe[Symbol.iterator]||fe["@@iterator"];if(ee)return(ee=ee.call(fe)).next.bind(ee);if(Array.isArray(fe)||(ee=F(fe))||_&&fe&&typeof fe.length=="number"){ee&&(fe=ee);var G=0;return function(){return G>=fe.length?{done:!0}:{done:!1,value:fe[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=A();function v(fe){ge.defaults=fe}var $=/[&<>"']/,E=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(_){return p[_]};function S(fe,_){if(_){if($.test(fe))return fe.replace(E,k)}else if(R.test(fe))return fe.replace(D,k);return fe}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(fe){return fe.replace(c,function(_,ee){return ee=ee.toLowerCase(),ee==="colon"?":":ee.charAt(0)==="#"?ee.charAt(1)==="x"?String.fromCharCode(parseInt(ee.substring(2),16)):String.fromCharCode(+ee.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(fe,_){fe=typeof fe=="string"?fe:fe.source,_=_||"";var ee={replace:function(x,me){return me=me.source||me,me=me.replace(o,"$1"),fe=fe.replace(x,me),ee},getRegex:function(){return new RegExp(fe,_)}};return ee}var r=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(fe,_,ee){if(fe){var G;try{G=decodeURIComponent(g(ee)).replace(r,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}_&&!n.test(ee)&&(ee=l(_,ee));try{ee=encodeURI(ee).replace(/%25/g,"%")}catch{return null}return ee}var t={},h=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(fe,_){t[" "+fe]||(h.test(fe)?t[" "+fe]=fe+"/":t[" "+fe]=b(fe,"/",!0)),fe=t[" "+fe];var ee=fe.indexOf(":")===-1;return _.substring(0,2)==="//"?ee?_:fe.replace(s,"$1")+_:_.charAt(0)==="/"?ee?_:fe.replace(d,"$1")+_:fe+_}var u={exec:function(){}};function w(fe){for(var _=1,ee,G;_<arguments.length;_++){ee=arguments[_];for(G in ee)Object.prototype.hasOwnProperty.call(ee,G)&&(fe[G]=ee[G])}return fe}function I(fe,_){var ee=fe.replace(/\|/g,function(me,we,Ae){for(var ve=!1,Ie=we;--Ie>=0&&Ae[Ie]==="\\";)ve=!ve;return ve?"|":" |"}),G=ee.split(/ \|/),x=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>_)G.splice(_);else for(;G.length<_;)G.push("");for(;x<G.length;x++)G[x]=G[x].trim().replace(/\\\|/g,"|");return G}function b(fe,_,ee){var G=fe.length;if(G===0)return"";for(var x=0;x<G;){var me=fe.charAt(G-x-1);if(me===_&&!ee)x++;else if(me!==_&&ee)x++;else break}return fe.slice(0,G-x)}function m(fe,_){if(fe.indexOf(_[1])===-1)return-1;for(var ee=fe.length,G=0,x=0;x<ee;x++)if(fe[x]==="\\")x++;else if(fe[x]===_[0])G++;else if(fe[x]===_[1]&&(G--,G<0))return x;return-1}function y(fe){fe&&fe.sanitize&&!fe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(fe,_){if(_<1)return"";for(var ee="";_>1;)_&1&&(ee+=fe),_>>=1,fe+=fe;return ee+fe}function N(fe,_,ee,G){var x=_.href,me=_.title?S(_.title):null,we=fe[1].replace(/\\([\[\]])/g,"$1");if(fe[0].charAt(0)!=="!"){G.state.inLink=!0;var Ae={type:"link",raw:ee,href:x,title:me,text:we,tokens:G.inlineTokens(we)};return G.state.inLink=!1,Ae}return{type:"image",raw:ee,href:x,title:me,text:S(we)}}function U(fe,_){var ee=fe.match(/^(\s+)(?:```)/);if(ee===null)return _;var G=ee[1];return _.split(`
`).map(function(x){var me=x.match(/^\s+/);if(me===null)return x;var we=me[0];return we.length>=G.length?x.slice(G.length):x}).join(`
`)}var T=function(){function fe(ee){this.options=ee||ge.defaults}var _=fe.prototype;return _.space=function(G){var x=this.rules.block.newline.exec(G);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},_.code=function(G){var x=this.rules.block.code.exec(G);if(x){var me=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?me:b(me,`
`)}}},_.fences=function(G){var x=this.rules.block.fences.exec(G);if(x){var me=x[0],we=U(me,x[3]||"");return{type:"code",raw:me,lang:x[2]?x[2].trim():x[2],text:we}}},_.heading=function(G){var x=this.rules.block.heading.exec(G);if(x){var me=x[2].trim();if(/#$/.test(me)){var we=b(me,"#");(this.options.pedantic||!we||/ $/.test(we))&&(me=we.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:me,tokens:this.lexer.inline(me)}}},_.hr=function(G){var x=this.rules.block.hr.exec(G);if(x)return{type:"hr",raw:x[0]}},_.blockquote=function(G){var x=this.rules.block.blockquote.exec(G);if(x){var me=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},_.list=function(G){var x=this.rules.block.list.exec(G);if(x){var me,we,Ae,ve,Ie,B,Z,te,V,ae,he,Re,je=x[1].trim(),He=je.length>1,Qe={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Re=!1,!(!(x=_e.exec(G))||this.rules.block.hr.test(G)));){if(me=x[0],G=G.substring(me.length),te=x[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(ve=2,he=te.trimLeft()):(ve=x[2].search(/[^ ]/),ve=ve>4?1:ve,he=te.slice(ve),ve+=x[1].length),B=!1,!te&&/^ *$/.test(V)&&(me+=V+`
`,G=G.substring(V.length+1),Re=!0),!Re)for(var at=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:```|~~~)"),Pe=new RegExp("^ {0,"+Math.min(3,ve-1)+"}#");G&&(ae=G.split(`
`,1)[0],te=ae,this.options.pedantic&&(te=te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(te)||Pe.test(te)||at.test(te)||st.test(G)));){if(te.search(/[^ ]/)>=ve||!te.trim())he+=`
`+te.slice(ve);else if(!B)he+=`
`+te;else break;!B&&!te.trim()&&(B=!0),me+=ae+`
`,G=G.substring(ae.length+1)}Qe.loose||(Z?Qe.loose=!0:/\n *\n *$/.test(me)&&(Z=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(he),we&&(Ae=we[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:me,task:!!we,checked:Ae,loose:!1,text:he}),Qe.raw+=me}Qe.items[Qe.items.length-1].raw=me.trimRight(),Qe.items[Qe.items.length-1].text=he.trimRight(),Qe.raw=Qe.raw.trimRight();var Ue=Qe.items.length;for(Ie=0;Ie<Ue;Ie++){this.lexer.state.top=!1,Qe.items[Ie].tokens=this.lexer.blockTokens(Qe.items[Ie].text,[]);var Le=Qe.items[Ie].tokens.filter(function(re){return re.type==="space"}),Ze=Le.every(function(re){for(var se=re.raw.split(""),Ce=0,Ve=P(se),Xe;!(Xe=Ve()).done;){var it=Xe.value;if(it===`
`&&(Ce+=1),Ce>1)return!0}return!1});!Qe.loose&&Le.length&&Ze&&(Qe.loose=!0,Qe.items[Ie].loose=!0)}return Qe}},_.html=function(G){var x=this.rules.block.html.exec(G);if(x){var me={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(x[0]):S(x[0]);me.type="paragraph",me.text=we,me.tokens=this.lexer.inline(we)}return me}},_.def=function(G){var x=this.rules.block.def.exec(G);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var me=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:x[0],href:x[2],title:x[3]}}},_.table=function(G){var x=this.rules.block.table.exec(G);if(x){var me={type:"table",header:I(x[1]).map(function(Z){return{text:Z}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=x[0];var we=me.align.length,Ae,ve,Ie,B;for(Ae=0;Ae<we;Ae++)/^ *-+: *$/.test(me.align[Ae])?me.align[Ae]="right":/^ *:-+: *$/.test(me.align[Ae])?me.align[Ae]="center":/^ *:-+ *$/.test(me.align[Ae])?me.align[Ae]="left":me.align[Ae]=null;for(we=me.rows.length,Ae=0;Ae<we;Ae++)me.rows[Ae]=I(me.rows[Ae],me.header.length).map(function(Z){return{text:Z}});for(we=me.header.length,ve=0;ve<we;ve++)me.header[ve].tokens=this.lexer.inline(me.header[ve].text);for(we=me.rows.length,ve=0;ve<we;ve++)for(B=me.rows[ve],Ie=0;Ie<B.length;Ie++)B[Ie].tokens=this.lexer.inline(B[Ie].text);return me}}},_.lheading=function(G){var x=this.rules.block.lheading.exec(G);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},_.paragraph=function(G){var x=this.rules.block.paragraph.exec(G);if(x){var me=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:me,tokens:this.lexer.inline(me)}}},_.text=function(G){var x=this.rules.block.text.exec(G);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},_.escape=function(G){var x=this.rules.inline.escape.exec(G);if(x)return{type:"escape",raw:x[0],text:S(x[1])}},_.tag=function(G){var x=this.rules.inline.tag.exec(G);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):S(x[0]):x[0]}},_.link=function(G){var x=this.rules.inline.link.exec(G);if(x){var me=x[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var we=b(me.slice(0,-1),"\\");if((me.length-we.length)%2===0)return}else{var Ae=m(x[2],"()");if(Ae>-1){var ve=x[0].indexOf("!")===0?5:4,Ie=ve+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,Ie).trim(),x[3]=""}}var B=x[2],Z="";if(this.options.pedantic){var te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);te&&(B=te[1],Z=te[3])}else Z=x[3]?x[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(me)?B=B.slice(1):B=B.slice(1,-1)),N(x,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},_.reflink=function(G,x){var me;if((me=this.rules.inline.reflink.exec(G))||(me=this.rules.inline.nolink.exec(G))){var we=(me[2]||me[1]).replace(/\s+/g," ");if(we=x[we.toLowerCase()],!we||!we.href){var Ae=me[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return N(me,we,me[0],this.lexer)}},_.emStrong=function(G,x,me){me===void 0&&(me="");var we=this.rules.inline.emStrong.lDelim.exec(G);if(we&&!(we[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=we[1]||we[2]||"";if(!Ae||Ae&&(me===""||this.rules.inline.punctuation.exec(me))){var ve=we[0].length-1,Ie,B,Z=ve,te=0,V=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,x=x.slice(-1*G.length+ve);(we=V.exec(x))!=null;)if(Ie=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Ie){if(B=Ie.length,we[3]||we[4]){Z+=B;continue}else if((we[5]||we[6])&&ve%3&&!((ve+B)%3)){te+=B;continue}if(Z-=B,!(Z>0)){if(B=Math.min(B,B+Z+te),Math.min(ve,B)%2){var ae=G.slice(1,ve+we.index+B);return{type:"em",raw:G.slice(0,ve+we.index+B+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var he=G.slice(2,ve+we.index+B-1);return{type:"strong",raw:G.slice(0,ve+we.index+B+1),text:he,tokens:this.lexer.inlineTokens(he)}}}}}},_.codespan=function(G){var x=this.rules.inline.code.exec(G);if(x){var me=x[2].replace(/\n/g," "),we=/[^ ]/.test(me),Ae=/^ /.test(me)&&/ $/.test(me);return we&&Ae&&(me=me.substring(1,me.length-1)),me=S(me,!0),{type:"codespan",raw:x[0],text:me}}},_.br=function(G){var x=this.rules.inline.br.exec(G);if(x)return{type:"br",raw:x[0]}},_.del=function(G){var x=this.rules.inline.del.exec(G);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},_.autolink=function(G,x){var me=this.rules.inline.autolink.exec(G);if(me){var we,Ae;return me[2]==="@"?(we=S(this.options.mangle?x(me[1]):me[1]),Ae="mailto:"+we):(we=S(me[1]),Ae=we),{type:"link",raw:me[0],text:we,href:Ae,tokens:[{type:"text",raw:we,text:we}]}}},_.url=function(G,x){var me;if(me=this.rules.inline.url.exec(G)){var we,Ae;if(me[2]==="@")we=S(this.options.mangle?x(me[0]):me[0]),Ae="mailto:"+we;else{var ve;do ve=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ve!==me[0]);we=S(me[0]),me[1]==="www."?Ae="http://"+we:Ae=we}return{type:"link",raw:me[0],text:we,href:Ae,tokens:[{type:"text",raw:we,text:we}]}}},_.inlineText=function(G,x){var me=this.rules.inline.text.exec(G);if(me){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):S(me[0]):me[0]:we=S(this.options.smartypants?x(me[0]):me[0]),{type:"text",raw:me[0],text:we}}},fe}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=i(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=i(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=i(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=i(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=i(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=w({},O),O.gfm=w({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=i(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=w({},O.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:i(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=i(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=i(O._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=i(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=i(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=i(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=i(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=i(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=i(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=i(M.reflink).replace("label",M._label).replace("ref",O._label).getRegex(),M.nolink=i(M.nolink).replace("ref",O._label).getRegex(),M.reflinkSearch=i(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=w({},M),M.pedantic=w({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=w({},M.normal,{escape:i(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=i(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=w({},M.gfm,{br:i(M.br).replace("{2,}","*").getRegex(),text:i(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(fe){return fe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(fe){var _="",ee,G,x=fe.length;for(ee=0;ee<x;ee++)G=fe.charCodeAt(ee),Math.random()>.5&&(G="x"+G.toString(16)),_+="&#"+G+";";return _}var J=function(){function fe(ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=ee||ge.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:O.normal,inline:M.normal};this.options.pedantic?(G.block=O.pedantic,G.inline=M.pedantic):this.options.gfm&&(G.block=O.gfm,this.options.breaks?G.inline=M.breaks:G.inline=M.gfm),this.tokenizer.rules=G}fe.lex=function(G,x){var me=new fe(x);return me.lex(G)},fe.lexInline=function(G,x){var me=new fe(x);return me.inlineTokens(G)};var _=fe.prototype;return _.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},_.blockTokens=function(G,x){var me=this;x===void 0&&(x=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Z,te,V){return te+"    ".repeat(V.length)});for(var we,Ae,ve,Ie;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(we=Z.call({lexer:me},G,x))?(G=G.substring(we.raw.length),x.push(we),!0):!1}))){if(we=this.tokenizer.space(G)){G=G.substring(we.raw.length),we.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(we);continue}if(we=this.tokenizer.code(G)){G=G.substring(we.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(we);continue}if(we=this.tokenizer.fences(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.heading(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.hr(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.blockquote(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.list(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.html(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.def(G)){G=G.substring(we.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.lheading(G)){G=G.substring(we.raw.length),x.push(we);continue}if(ve=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,te=G.slice(1),V=void 0;me.options.extensions.startBlock.forEach(function(ae){V=ae.call({lexer:this},te),typeof V=="number"&&V>=0&&(Z=Math.min(Z,V))}),Z<1/0&&Z>=0&&(ve=G.substring(0,Z+1))}(),this.state.top&&(we=this.tokenizer.paragraph(ve))){Ae=x[x.length-1],Ie&&Ae.type==="paragraph"?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(we),Ie=ve.length!==G.length,G=G.substring(we.raw.length);continue}if(we=this.tokenizer.text(G)){G=G.substring(we.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+we.raw,Ae.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(we);continue}if(G){var B="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,x},_.inline=function(G,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:G,tokens:x}),x},_.inlineTokens=function(G,x){var me=this;x===void 0&&(x=[]);var we,Ae,ve,Ie=G,B,Z,te;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)V.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,B.index)+"["+L("a",B[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,B.index)+"["+L("a",B[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,B.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Z||(te=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(we=he.call({lexer:me},G,x))?(G=G.substring(we.raw.length),x.push(we),!0):!1}))){if(we=this.tokenizer.escape(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.tag(G)){G=G.substring(we.raw.length),Ae=x[x.length-1],Ae&&we.type==="text"&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):x.push(we);continue}if(we=this.tokenizer.link(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(we.raw.length),Ae=x[x.length-1],Ae&&we.type==="text"&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):x.push(we);continue}if(we=this.tokenizer.emStrong(G,Ie,te)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.codespan(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.br(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.del(G)){G=G.substring(we.raw.length),x.push(we);continue}if(we=this.tokenizer.autolink(G,z)){G=G.substring(we.raw.length),x.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(G,z))){G=G.substring(we.raw.length),x.push(we);continue}if(ve=G,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,Re=G.slice(1),je=void 0;me.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Re),typeof je=="number"&&je>=0&&(he=Math.min(he,je))}),he<1/0&&he>=0&&(ve=G.substring(0,he+1))}(),we=this.tokenizer.inlineText(ve,j)){G=G.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(te=we.raw.slice(-1)),Z=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=we.raw,Ae.text+=we.text):x.push(we);continue}if(G){var ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return x},C(fe,null,[{key:"rules",get:function(){return{block:O,inline:M}}}]),fe}(),le=function(){function fe(ee){this.options=ee||ge.defaults}var _=fe.prototype;return _.code=function(G,x,me){var we=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(G,we);Ae!=null&&Ae!==G&&(me=!0,G=Ae)}return G=G.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+S(we,!0)+'">'+(me?G:S(G,!0))+`</code></pre>
`:"<pre><code>"+(me?G:S(G,!0))+`</code></pre>
`},_.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},_.html=function(G){return G},_.heading=function(G,x,me,we){if(this.options.headerIds){var Ae=this.options.headerPrefix+we.slug(me);return"<h"+x+' id="'+Ae+'">'+G+"</h"+x+`>
`}return"<h"+x+">"+G+"</h"+x+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(G,x,me){var we=x?"ol":"ul",Ae=x&&me!==1?' start="'+me+'"':"";return"<"+we+Ae+`>
`+G+"</"+we+`>
`},_.listitem=function(G){return"<li>"+G+`</li>
`},_.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(G){return"<p>"+G+`</p>
`},_.table=function(G,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+x+`</table>
`},_.tablerow=function(G){return`<tr>
`+G+`</tr>
`},_.tablecell=function(G,x){var me=x.header?"th":"td",we=x.align?"<"+me+' align="'+x.align+'">':"<"+me+">";return we+G+("</"+me+`>
`)},_.strong=function(G){return"<strong>"+G+"</strong>"},_.em=function(G){return"<em>"+G+"</em>"},_.codespan=function(G){return"<code>"+G+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(G){return"<del>"+G+"</del>"},_.link=function(G,x,me){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var we='<a href="'+S(G)+'"';return x&&(we+=' title="'+x+'"'),we+=">"+me+"</a>",we},_.image=function(G,x,me){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var we='<img src="'+G+'" alt="'+me+'"';return x&&(we+=' title="'+x+'"'),we+=this.options.xhtml?"/>":">",we},_.text=function(G){return G},fe}(),Y=function(){function fe(){}var _=fe.prototype;return _.strong=function(G){return G},_.em=function(G){return G},_.codespan=function(G){return G},_.del=function(G){return G},_.html=function(G){return G},_.text=function(G){return G},_.link=function(G,x,me){return""+me},_.image=function(G,x,me){return""+me},_.br=function(){return""},fe}(),Q=function(){function fe(){this.seen={}}var _=fe.prototype;return _.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(G,x){var me=G,we=0;if(this.seen.hasOwnProperty(me)){we=this.seen[G];do we++,me=G+"-"+we;while(this.seen.hasOwnProperty(me))}return x||(this.seen[G]=we,this.seen[me]=0),me},_.slug=function(G,x){x===void 0&&(x={});var me=this.serialize(G);return this.getNextSafeSlug(me,x.dryrun)},fe}(),X=function(){function fe(ee){this.options=ee||ge.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new Q}fe.parse=function(G,x){var me=new fe(x);return me.parse(G)},fe.parseInline=function(G,x){var me=new fe(x);return me.parseInline(G)};var _=fe.prototype;return _.parse=function(G,x){x===void 0&&(x=!0);var me="",we,Ae,ve,Ie,B,Z,te,V,ae,he,Re,je,He,Qe,_e,at,st,rt,Pe,Ue=G.length;for(we=0;we<Ue;we++){if(he=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(Pe=this.options.extensions.renderers[he.type].call({parser:this},he),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){me+=Pe||"";continue}switch(he.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(he.tokens),he.depth,g(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(V="",te="",Ie=he.header.length,Ae=0;Ae<Ie;Ae++)te+=this.renderer.tablecell(this.parseInline(he.header[Ae].tokens),{header:!0,align:he.align[Ae]});for(V+=this.renderer.tablerow(te),ae="",Ie=he.rows.length,Ae=0;Ae<Ie;Ae++){for(Z=he.rows[Ae],te="",B=Z.length,ve=0;ve<B;ve++)te+=this.renderer.tablecell(this.parseInline(Z[ve].tokens),{header:!1,align:he.align[ve]});ae+=this.renderer.tablerow(te)}me+=this.renderer.table(V,ae);continue}case"blockquote":{ae=this.parse(he.tokens),me+=this.renderer.blockquote(ae);continue}case"list":{for(Re=he.ordered,je=he.start,He=he.loose,Ie=he.items.length,ae="",Ae=0;Ae<Ie;Ae++)_e=he.items[Ae],at=_e.checked,st=_e.task,Qe="",_e.task&&(rt=this.renderer.checkbox(at),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=rt+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=rt+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:rt}):Qe+=rt),Qe+=this.parse(_e.tokens,He),ae+=this.renderer.listitem(Qe,st,at);me+=this.renderer.list(ae,Re,je);continue}case"html":{me+=this.renderer.html(he.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(ae=he.tokens?this.parseInline(he.tokens):he.text;we+1<Ue&&G[we+1].type==="text";)he=G[++we],ae+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);me+=x?this.renderer.paragraph(ae):ae;continue}default:{var Le='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}}return me},_.parseInline=function(G,x){x=x||this.renderer;var me="",we,Ae,ve,Ie=G.length;for(we=0;we<Ie;we++){if(Ae=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(ve=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){me+=ve||"";continue}switch(Ae.type){case"escape":{me+=x.text(Ae.text);break}case"html":{me+=x.html(Ae.text);break}case"link":{me+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{me+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{me+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{me+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{me+=x.codespan(Ae.text);break}case"br":{me+=x.br();break}case"del":{me+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{me+=x.text(Ae.text);break}default:{var B='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return me},fe}();function ue(fe,_,ee){if(typeof fe>"u"||fe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");if(typeof _=="function"&&(ee=_,_=null),_=w({},ue.defaults,_||{}),y(_),ee){var G=_.highlight,x;try{x=J.lex(fe,_)}catch(Ie){return ee(Ie)}var me=function(B){var Z;if(!B)try{_.walkTokens&&ue.walkTokens(x,_.walkTokens),Z=X.parse(x,_)}catch(te){B=te}return _.highlight=G,B?ee(B):ee(null,Z)};if(!G||G.length<3||(delete _.highlight,!x.length))return me();var we=0;ue.walkTokens(x,function(Ie){Ie.type==="code"&&(we++,setTimeout(function(){G(Ie.text,Ie.lang,function(B,Z){if(B)return me(B);Z!=null&&Z!==Ie.text&&(Ie.text=Z,Ie.escaped=!0),we--,we===0&&me()})},0))}),we===0&&me();return}function Ae(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(Ie.message+"",!0)+"</pre>";throw Ie}try{var ve=J.lex(fe,_);if(_.walkTokens){if(_.async)return Promise.all(ue.walkTokens(ve,_.walkTokens)).then(function(){return X.parse(ve,_)}).catch(Ae);ue.walkTokens(ve,_.walkTokens)}return X.parse(ve,_)}catch(Ie){Ae(Ie)}}ue.options=ue.setOptions=function(fe){return w(ue.defaults,fe),v(ue.defaults),ue},ue.getDefaults=A,ue.defaults=ge.defaults,ue.use=function(){for(var fe=arguments.length,_=new Array(fe),ee=0;ee<fe;ee++)_[ee]=arguments[ee];var G=w.apply(void 0,[{}].concat(_)),x=ue.defaults.extensions||{renderers:{},childTokens:{}},me;_.forEach(function(we){if(we.extensions&&(me=!0,we.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var Ie=x.renderers?x.renderers[ve.name]:null;Ie?x.renderers[ve.name]=function(){for(var B=arguments.length,Z=new Array(B),te=0;te<B;te++)Z[te]=arguments[te];var V=ve.renderer.apply(this,Z);return V===!1&&(V=Ie.apply(this,Z)),V}:x.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ve.level]?x[ve.level].unshift(ve.tokenizer):x[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?x.startBlock?x.startBlock.push(ve.start):x.startBlock=[ve.start]:ve.level==="inline"&&(x.startInline?x.startInline.push(ve.start):x.startInline=[ve.start]))}ve.childTokens&&(x.childTokens[ve.name]=ve.childTokens)})),we.renderer&&function(){var ve=ue.defaults.renderer||new le,Ie=function(te){var V=ve[te];ve[te]=function(){for(var ae=arguments.length,he=new Array(ae),Re=0;Re<ae;Re++)he[Re]=arguments[Re];var je=we.renderer[te].apply(ve,he);return je===!1&&(je=V.apply(ve,he)),je}};for(var B in we.renderer)Ie(B);G.renderer=ve}(),we.tokenizer&&function(){var ve=ue.defaults.tokenizer||new T,Ie=function(te){var V=ve[te];ve[te]=function(){for(var ae=arguments.length,he=new Array(ae),Re=0;Re<ae;Re++)he[Re]=arguments[Re];var je=we.tokenizer[te].apply(ve,he);return je===!1&&(je=V.apply(ve,he)),je}};for(var B in we.tokenizer)Ie(B);G.tokenizer=ve}(),we.walkTokens){var Ae=ue.defaults.walkTokens;G.walkTokens=function(ve){var Ie=[];return Ie.push(we.walkTokens.call(this,ve)),Ae&&(Ie=Ie.concat(Ae.call(this,ve))),Ie}}me&&(G.extensions=x),ue.setOptions(G)})},ue.walkTokens=function(fe,_){for(var ee=[],G=function(){var Ae=me.value;switch(ee=ee.concat(_.call(ue,Ae)),Ae.type){case"table":{for(var ve=P(Ae.header),Ie;!(Ie=ve()).done;){var B=Ie.value;ee=ee.concat(ue.walkTokens(B.tokens,_))}for(var Z=P(Ae.rows),te;!(te=Z()).done;)for(var V=te.value,ae=P(V),he;!(he=ae()).done;){var Re=he.value;ee=ee.concat(ue.walkTokens(Re.tokens,_))}break}case"list":{ee=ee.concat(ue.walkTokens(Ae.items,_));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Ae.type]?ue.defaults.extensions.childTokens[Ae.type].forEach(function(je){ee=ee.concat(ue.walkTokens(Ae[je],_))}):Ae.tokens&&(ee=ee.concat(ue.walkTokens(Ae.tokens,_)))}},x=P(fe),me;!(me=x()).done;)G();return ee},ue.parseInline=function(fe,_){if(typeof fe>"u"||fe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");_=w({},ue.defaults,_||{}),y(_);try{var ee=J.lexInline(fe,_);return _.walkTokens&&ue.walkTokens(ee,_.walkTokens),X.parseInline(ee,_)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}},ue.Parser=X,ue.parser=X.parse,ue.Renderer=le,ue.TextRenderer=Y,ue.Lexer=J,ue.lexer=J.lex,ue.Tokenizer=T,ue.Slugger=Q,ue.parse=ue;var ne=ue.options,$e=ue.setOptions,oe=ue.use,K=ue.walkTokens,W=ue.parseInline,ie=ue,ye=X.parse,de=J.lex;ge.Lexer=J,ge.Parser=X,ge.Renderer=le,ge.Slugger=Q,ge.TextRenderer=Y,ge.Tokenizer=T,ge.getDefaults=A,ge.lexer=de,ge.marked=ue,ge.options=ne,ge.parse=ie,ge.parseInline=W,ge.parser=ye,ge.setOptions=$e,ge.use=oe,ge.walkTokens=K,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Ee[161],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0;function C(c){const g=P(c);if(g&&g.length>0)return new Uint32Array(g)}e.$Sj=C;let F=0;const f=new Uint32Array(10);function P(c){if(F=0,A(c,D,4352),F>0||(A(c,p,4449),F>0)||(A(c,k,4520),F>0)||(A(c,S,12593),F))return f.subarray(0,F);if(c>=44032&&c<=55203){const g=c-44032,o=g%588,i=Math.floor(g/588),r=Math.floor(o/28),n=o%28-1;if(i<D.length?A(i,D,0):4352+i-12593<S.length&&A(4352+i,S,12593),r<p.length?A(r,p,0):4449+r-12593<S.length&&A(4449+r-12593,S,12593),n>=0&&(n<k.length?A(n,k,0):4520+n-12593<S.length&&A(4520+n-12593,S,12593)),F>0)return f.subarray(0,F)}}function A(c,g,o){c>=o&&c<o+g.length&&v(g[c-o])}function v(c){c!==0&&(f[F++]=c&255,c>>8&&(f[F++]=c>>8&255),c>>16&&(f[F++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var E;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(E||(E={}));var R;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(R||(R={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),k=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ee[76],Se([1,0,28]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=void 0;const F=new C.$Dc(1e4);function f(E){return $(E,"NFC",F)}e.$Hl=f;const P=new C.$Dc(1e4);function A(E){return $(E,"NFD",P)}e.$Il=A;const v=/[^\u0000-\u0080]/;function $(E,R,D){if(!E)return E;const p=D.get(E);if(p)return p;let k;return v.test(E)?k=E.normalize(R):k=E,D.set(E,k),k}e.$Jl=function(){const E=/[\u0300-\u036f]/g;return function(R){return A(R).replace(E,"")}}()}),define(Ee[122],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=e.rot=e.$8l=void 0;function C(v,$,E){return Math.min(Math.max(v,$),E)}e.$8l=C;function F(v,$){return($+v%$)%$}e.rot=F;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$0l=f;class P{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$$l=P;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const E=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$_l=A}),function(){function ge(f){const P=[];typeof f=="number"&&P.push("code/timeOrigin",f);function A($){P.push($,Date.now())}function v(){const $=[];for(let E=0;E<P.length;E+=2)$.push({name:P[E],startTime:P[E+1]});return $}return{mark:A,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(f+A.startTime)});return P}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function C(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=C(F))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var F in C)(typeof exports=="object"?exports:ge)[F]=C[F]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function C(F){if(e[F])return e[F].exports;var f=e[F]={i:F,l:!1,exports:{}};return ge[F].call(f.exports,f,f.exports,C),f.l=!0,f.exports}return C.m=ge,C.c=e,C.d=function(F,f,P){C.o(F,f)||Object.defineProperty(F,f,{enumerable:!0,get:P})},C.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},C.t=function(F,f){if(1&f&&(F=C(F)),8&f||4&f&&typeof F=="object"&&F&&F.__esModule)return F;var P=Object.create(null);if(C.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:F}),2&f&&typeof F!="string")for(var A in F)C.d(P,A,function(v){return F[v]}.bind(null,A));return P},C.n=function(F){var f=F&&F.__esModule?function(){return F.default}:function(){return F};return C.d(f,"a",f),f},C.o=function(F,f){return Object.prototype.hasOwnProperty.call(F,f)},C.p="",C(C.s=0)}([function(ge,e,C){(function(F){var f;e=ge.exports=oe,f=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],$=e.src=[],E=0,R=E++;$[R]="0|[1-9]\\d*";var D=E++;$[D]="[0-9]+";var p=E++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=E++;$[k]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var S=E++;$[S]="("+$[D]+")\\.("+$[D]+")\\.("+$[D]+")";var c=E++;$[c]="(?:"+$[R]+"|"+$[p]+")";var g=E++;$[g]="(?:"+$[D]+"|"+$[p]+")";var o=E++;$[o]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var i=E++;$[i]="(?:-?("+$[g]+"(?:\\."+$[g]+")*))";var r=E++;$[r]="[0-9A-Za-z-]+";var n=E++;$[n]="(?:\\+("+$[r]+"(?:\\."+$[r]+")*))";var a=E++,t="v?"+$[k]+$[o]+"?"+$[n]+"?";$[a]="^"+t+"$";var h="[v=\\s]*"+$[S]+$[i]+"?"+$[n]+"?",s=E++;$[s]="^"+h+"$";var d=E++;$[d]="((?:<|>)?=?)";var l=E++;$[l]=$[D]+"|x|X|\\*";var u=E++;$[u]=$[R]+"|x|X|\\*";var w=E++;$[w]="[v=\\s]*("+$[u]+")(?:\\.("+$[u]+")(?:\\.("+$[u]+")(?:"+$[o]+")?"+$[n]+"?)?)?";var I=E++;$[I]="[v=\\s]*("+$[l]+")(?:\\.("+$[l]+")(?:\\.("+$[l]+")(?:"+$[i]+")?"+$[n]+"?)?)?";var b=E++;$[b]="^"+$[d]+"\\s*"+$[w]+"$";var m=E++;$[m]="^"+$[d]+"\\s*"+$[I]+"$";var y=E++;$[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=E++;$[L]="(?:~>?)";var N=E++;$[N]="(\\s*)"+$[L]+"\\s+",v[N]=new RegExp($[N],"g");var U=E++;$[U]="^"+$[L]+$[w]+"$";var T=E++;$[T]="^"+$[L]+$[I]+"$";var O=E++;$[O]="(?:\\^)";var M=E++;$[M]="(\\s*)"+$[O]+"\\s+",v[M]=new RegExp($[M],"g");var j=E++;$[j]="^"+$[O]+$[w]+"$";var z=E++;$[z]="^"+$[O]+$[I]+"$";var J=E++;$[J]="^"+$[d]+"\\s*("+h+")$|^$";var le=E++;$[le]="^"+$[d]+"\\s*("+t+")$|^$";var Y=E++;$[Y]="(\\s*)"+$[d]+"\\s*("+h+"|"+$[w]+")",v[Y]=new RegExp($[Y],"g");var Q=E++;$[Q]="^\\s*("+$[w]+")\\s+-\\s+("+$[w]+")\\s*$";var X=E++;$[X]="^\\s*("+$[I]+")\\s+-\\s+("+$[I]+")\\s*$";var ue=E++;$[ue]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)f(ne,$[ne]),v[ne]||(v[ne]=new RegExp($[ne]));function $e(V,ae){if(V instanceof oe)return V;if(typeof V!="string"||V.length>P||!(ae?v[s]:v[a]).test(V))return null;try{return new oe(V,ae)}catch{return null}}function oe(V,ae){if(V instanceof oe){if(V.loose===ae)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof oe))return new oe(V,ae);f("SemVer",V,ae),this.loose=ae;var he=V.trim().match(ae?v[s]:v[a]);if(!he)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var je=+Re;if(je>=0&&je<A)return je}return Re}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=$e,e.valid=function(V,ae){var he=$e(V,ae);return he?he.version:null},e.clean=function(V,ae){var he=$e(V.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(V){return f("SemVer.compare",this.version,this.loose,V),V instanceof oe||(V=new oe(V,this.loose)),this.compareMain(V)||this.comparePre(V)},oe.prototype.compareMain=function(V){return V instanceof oe||(V=new oe(V,this.loose)),W(this.major,V.major)||W(this.minor,V.minor)||W(this.patch,V.patch)},oe.prototype.comparePre=function(V){if(V instanceof oe||(V=new oe(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],Re=V.prerelease[ae];if(f("prerelease compare",ae,he,Re),he===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(he===void 0)return-1;if(he!==Re)return W(he,Re)}while(++ae)},oe.prototype.inc=function(V,ae){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,ae,he,Re){typeof he=="string"&&(Re=he,he=void 0);try{return new oe(V,he).inc(ae,Re).version}catch{return null}},e.diff=function(V,ae){if(fe(V,ae))return null;var he=$e(V),Re=$e(ae);if(he.prerelease.length||Re.prerelease.length){for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Re[je])return"pre"+je;return"prerelease"}for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Re[je])return je},e.compareIdentifiers=W;var K=/^[0-9]+$/;function W(V,ae){var he=K.test(V),Re=K.test(ae);return he&&Re&&(V=+V,ae=+ae),he&&!Re?-1:Re&&!he?1:V<ae?-1:V>ae?1:0}function ie(V,ae,he){return new oe(V,he).compare(new oe(ae,he))}function ye(V,ae,he){return ie(V,ae,he)>0}function de(V,ae,he){return ie(V,ae,he)<0}function fe(V,ae,he){return ie(V,ae,he)===0}function _(V,ae,he){return ie(V,ae,he)!==0}function ee(V,ae,he){return ie(V,ae,he)>=0}function G(V,ae,he){return ie(V,ae,he)<=0}function x(V,ae,he,Re){var je;switch(ae){case"===":typeof V=="object"&&(V=V.version),typeof he=="object"&&(he=he.version),je=V===he;break;case"!==":typeof V=="object"&&(V=V.version),typeof he=="object"&&(he=he.version),je=V!==he;break;case"":case"=":case"==":je=fe(V,he,Re);break;case"!=":je=_(V,he,Re);break;case">":je=ye(V,he,Re);break;case">=":je=ee(V,he,Re);break;case"<":je=de(V,he,Re);break;case"<=":je=G(V,he,Re);break;default:throw new TypeError("Invalid operator: "+ae)}return je}function me(V,ae){if(V instanceof me){if(V.loose===ae)return V;V=V.value}if(!(this instanceof me))return new me(V,ae);f("comparator",V,ae),this.loose=ae,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(V,ae){return W(ae,V)},e.major=function(V,ae){return new oe(V,ae).major},e.minor=function(V,ae){return new oe(V,ae).minor},e.patch=function(V,ae){return new oe(V,ae).patch},e.compare=ie,e.compareLoose=function(V,ae){return ie(V,ae,!0)},e.rcompare=function(V,ae,he){return ie(ae,V,he)},e.sort=function(V,ae){return V.sort(function(he,Re){return e.compare(he,Re,ae)})},e.rsort=function(V,ae){return V.sort(function(he,Re){return e.rcompare(he,Re,ae)})},e.gt=ye,e.lt=de,e.eq=fe,e.neq=_,e.gte=ee,e.lte=G,e.cmp=x,e.Comparator=me;var we={};function Ae(V,ae){if(V instanceof Ae)return V.loose===ae?V:new Ae(V.raw,ae);if(V instanceof me)return new Ae(V.value,ae);if(!(this instanceof Ae))return new Ae(V,ae);if(this.loose=ae,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ve(V){return!V||V.toLowerCase()==="x"||V==="*"}function Ie(V,ae,he,Re,je,He,Qe,_e,at,st,rt,Pe,Ue){return((ae=ve(he)?"":ve(Re)?">="+he+".0.0":ve(je)?">="+he+"."+Re+".0":">="+ae)+" "+(_e=ve(at)?"":ve(st)?"<"+(+at+1)+".0.0":ve(rt)?"<"+at+"."+(+st+1)+".0":Pe?"<="+at+"."+st+"."+rt+"-"+Pe:"<="+_e)).trim()}function B(V,ae){for(var he=0;he<V.length;he++)if(!V[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<V.length;he++)if(f(V[he].semver),V[he].semver!==we&&V[he].semver.prerelease.length>0){var Re=V[he].semver;if(Re.major===ae.major&&Re.minor===ae.minor&&Re.patch===ae.patch)return!0}return!1}return!0}function Z(V,ae,he){try{ae=new Ae(ae,he)}catch{return!1}return ae.test(V)}function te(V,ae,he,Re){var je,He,Qe,_e,at;switch(V=new oe(V,Re),ae=new Ae(ae,Re),he){case">":je=ye,He=G,Qe=de,_e=">",at=">=";break;case"<":je=de,He=ee,Qe=ye,_e="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Z(V,ae,Re))return!1;for(var st=0;st<ae.set.length;++st){var rt=ae.set[st],Pe=null,Ue=null;if(rt.forEach(function(Le){Le.semver===we&&(Le=new me(">=0.0.0")),Pe=Pe||Le,Ue=Ue||Le,je(Le.semver,Pe.semver,Re)?Pe=Le:Qe(Le.semver,Ue.semver,Re)&&(Ue=Le)}),Pe.operator===_e||Pe.operator===at||(!Ue.operator||Ue.operator===_e)&&He(V,Ue.semver)||Ue.operator===at&&Qe(V,Ue.semver))return!1}return!0}me.prototype.parse=function(V){var ae=this.loose?v[J]:v[le],he=V.match(ae);if(!he)throw new TypeError("Invalid comparator: "+V);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new oe(he[2],this.loose):this.semver=we},me.prototype.toString=function(){return this.value},me.prototype.test=function(V){return f("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new oe(V,this.loose)),x(V,this.operator,this.semver,this.loose))},me.prototype.intersects=function(V,ae){if(!(V instanceof me))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Ae(V.value,ae),Z(this.value,he,ae);if(V.operator==="")return he=new Ae(this.value,ae),Z(V.semver,he,ae);var Re=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),He=this.semver.version===V.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),_e=x(this.semver,"<",V.semver,ae)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),at=x(this.semver,">",V.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return Re||je||He&&Qe||_e||at},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var ae=this.loose;V=V.trim(),f("range",V,ae);var he=ae?v[X]:v[Q];V=V.replace(he,Ie),f("hyphen replace",V),V=V.replace(v[Y],"$1$2$3"),f("comparator trim",V,v[Y]),V=(V=(V=V.replace(v[N],"$1~")).replace(v[M],"$1^")).split(/\s+/).join(" ");var Re=ae?v[J]:v[le],je=V.split(" ").map(function(He){return function(Qe,_e){return f("comp",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Pe,Ue){f("caret",Pe,Ue);var Le=Ue?v[z]:v[j];return Pe.replace(Le,function(Ze,re,se,Ce,Ve){var Xe;return f("caret",Pe,Ze,re,se,Ce,Ve),ve(re)?Xe="":ve(se)?Xe=">="+re+".0.0 <"+(+re+1)+".0.0":ve(Ce)?Xe=re==="0"?">="+re+"."+se+".0 <"+re+"."+(+se+1)+".0":">="+re+"."+se+".0 <"+(+re+1)+".0.0":Ve?(f("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Xe=re==="0"?se==="0"?">="+re+"."+se+"."+Ce+Ve+" <"+re+"."+se+"."+(+Ce+1):">="+re+"."+se+"."+Ce+Ve+" <"+re+"."+(+se+1)+".0":">="+re+"."+se+"."+Ce+Ve+" <"+(+re+1)+".0.0"):(f("no pr"),Xe=re==="0"?se==="0"?">="+re+"."+se+"."+Ce+" <"+re+"."+se+"."+(+Ce+1):">="+re+"."+se+"."+Ce+" <"+re+"."+(+se+1)+".0":">="+re+"."+se+"."+Ce+" <"+(+re+1)+".0.0"),f("caret return",Xe),Xe})}(rt,st)}).join(" ")}(Qe,_e),f("caret",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Pe,Ue){var Le=Ue?v[T]:v[U];return Pe.replace(Le,function(Ze,re,se,Ce,Ve){var Xe;return f("tilde",Pe,Ze,re,se,Ce,Ve),ve(re)?Xe="":ve(se)?Xe=">="+re+".0.0 <"+(+re+1)+".0.0":ve(Ce)?Xe=">="+re+"."+se+".0 <"+re+"."+(+se+1)+".0":Ve?(f("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Xe=">="+re+"."+se+"."+Ce+Ve+" <"+re+"."+(+se+1)+".0"):Xe=">="+re+"."+se+"."+Ce+" <"+re+"."+(+se+1)+".0",f("tilde return",Xe),Xe})}(rt,st)}).join(" ")}(Qe,_e),f("tildes",Qe),Qe=function(at,st){return f("replaceXRanges",at,st),at.split(/\s+/).map(function(rt){return function(Pe,Ue){Pe=Pe.trim();var Le=Ue?v[m]:v[b];return Pe.replace(Le,function(Ze,re,se,Ce,Ve,Xe){f("xRange",Pe,Ze,re,se,Ce,Ve,Xe);var it=ve(se),nt=it||ve(Ce),Oe=nt||ve(Ve);return re==="="&&Oe&&(re=""),it?Ze=re===">"||re==="<"?"<0.0.0":"*":re&&Oe?(nt&&(Ce=0),Oe&&(Ve=0),re===">"?(re=">=",nt?(se=+se+1,Ce=0,Ve=0):Oe&&(Ce=+Ce+1,Ve=0)):re==="<="&&(re="<",nt?se=+se+1:Ce=+Ce+1),Ze=re+se+"."+Ce+"."+Ve):nt?Ze=">="+se+".0.0 <"+(+se+1)+".0.0":Oe&&(Ze=">="+se+"."+Ce+".0 <"+se+"."+(+Ce+1)+".0"),f("xRange return",Ze),Ze})}(rt,st)}).join(" ")}(Qe,_e),f("xrange",Qe),Qe=function(at,st){return f("replaceStars",at,st),at.trim().replace(v[ue],"")}(Qe,_e),f("stars",Qe),Qe}(He,ae)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Re)})),je=je.map(function(He){return new me(He,ae)})},Ae.prototype.intersects=function(V,ae){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Re){return V.set.some(function(je){return je.every(function(He){return Re.intersects(He,ae)})})})})},e.toComparators=function(V,ae){return new Ae(V,ae).set.map(function(he){return he.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new oe(V,this.loose));for(var ae=0;ae<this.set.length;ae++)if(B(this.set[ae],V))return!0;return!1},e.satisfies=Z,e.maxSatisfying=function(V,ae,he){var Re=null,je=null;try{var He=new Ae(ae,he)}catch{return null}return V.forEach(function(Qe){He.test(Qe)&&(Re&&je.compare(Qe)!==-1||(je=new oe(Re=Qe,he)))}),Re},e.minSatisfying=function(V,ae,he){var Re=null,je=null;try{var He=new Ae(ae,he)}catch{return null}return V.forEach(function(Qe){He.test(Qe)&&(Re&&je.compare(Qe)!==1||(je=new oe(Re=Qe,he)))}),Re},e.validRange=function(V,ae){try{return new Ae(V,ae).range||"*"}catch{return null}},e.ltr=function(V,ae,he){return te(V,ae,"<",he)},e.gtr=function(V,ae,he){return te(V,ae,">",he)},e.outside=te,e.prerelease=function(V,ae){var he=$e(V,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(V,ae,he){return V=new Ae(V,he),ae=new Ae(ae,he),V.intersects(ae)},e.coerce=function(V){if(V instanceof oe)return V;if(typeof V!="string")return null;var ae=V.match(v[y]);return ae==null?null:$e((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,C(1))},function(ge,e){var C,F,f=ge.exports={};function P(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function v(g){if(C===setTimeout)return setTimeout(g,0);if((C===P||!C)&&setTimeout)return C=setTimeout,setTimeout(g,0);try{return C(g,0)}catch{try{return C.call(null,g,0)}catch{return C.call(this,g,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:P}catch{C=P}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var $,E=[],R=!1,D=-1;function p(){R&&$&&(R=!1,$.length?E=$.concat(E):D=-1,E.length&&k())}function k(){if(!R){var g=v(p);R=!0;for(var o=E.length;o;){for($=E,E=[];++D<o;)$&&$[D].run();D=-1,o=E.length}$=null,R=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(g)}}function S(g,o){this.fun=g,this.array=o}function c(){}f.nextTick=function(g){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];E.push(new S(g,o)),E.length!==1||R||v(k)},S.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=c,f.addListener=c,f.once=c,f.off=c,f.removeListener=c,f.removeAllListeners=c,f.emit=c,f.prependListener=c,f.prependOnceListener=c,f.listeners=function(g){return[]},f.binding=function(g){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(g){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(Ee[38],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(P){return new F(P)}constructor(P){this.c=C&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=F}),define(Ee[4],Se([1,0,14,74,3,75,38]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const v=!1,$=!1;var E;(function(b){b.None=()=>f.$Tc.None;function m(G){if($){const{onDidAddListener:x}=G,me=S.create();let we=0;G.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),x?.()}}}function y(G,x){return le(G,()=>{},0,void 0,!0,void 0,x)}b.defer=y;function L(G){return(x,me=null,we)=>{let Ae=!1,ve;return ve=G(Ie=>{if(!Ae)return ve?ve.dispose():Ae=!0,x.call(me,Ie)},null,we),Ae&&ve.dispose(),ve}}b.once=L;function N(G,x,me){return z((we,Ae=null,ve)=>G(Ie=>we.call(Ae,x(Ie)),null,ve),me)}b.map=N;function U(G,x,me){return z((we,Ae=null,ve)=>G(Ie=>{x(Ie),we.call(Ae,Ie)},null,ve),me)}b.forEach=U;function T(G,x,me){return z((we,Ae=null,ve)=>G(Ie=>x(Ie)&&we.call(Ae,Ie),null,ve),me)}b.filter=T;function O(G){return G}b.signal=O;function M(...G){return(x,me=null,we)=>{const Ae=(0,f.$Qc)(...G.map(ve=>ve(Ie=>x.call(me,Ie))));return J(Ae,we)}}b.any=M;function j(G,x,me,we){let Ae=me;return N(G,ve=>(Ae=x(Ae,ve),Ae),we)}b.reduce=j;function z(G,x){let me;const we={onWillAddFirstListener(){me=G(Ae.fire,Ae)},onDidRemoveLastListener(){me?.dispose()}};x||m(we);const Ae=new r(we);return x?.add(Ae),Ae.event}function J(G,x){return x instanceof Array?x.push(G):x&&x.add(G),G}function le(G,x,me=100,we=!1,Ae=!1,ve,Ie){let B,Z,te,V=0,ae;const he={leakWarningThreshold:ve,onWillAddFirstListener(){B=G(je=>{V++,Z=x(Z,je),we&&!te&&(Re.fire(Z),Z=void 0),ae=()=>{const He=Z;Z=void 0,te=void 0,(!we||V>1)&&Re.fire(He),V=0},typeof me=="number"?(clearTimeout(te),te=setTimeout(ae,me)):te===void 0&&(te=0,queueMicrotask(ae))})},onWillRemoveListener(){Ae&&V>0&&ae?.()},onDidRemoveLastListener(){ae=void 0,B.dispose()}};Ie||m(he);const Re=new r(he);return Ie?.add(Re),Re.event}b.debounce=le;function Y(G,x=0,me){return b.debounce(G,(we,Ae)=>we?(we.push(Ae),we):[Ae],x,void 0,!0,void 0,me)}b.accumulate=Y;function Q(G,x=(we,Ae)=>we===Ae,me){let we=!0,Ae;return T(G,ve=>{const Ie=we||!x(ve,Ae);return we=!1,Ae=ve,Ie},me)}b.latch=Q;function X(G,x,me){return[b.filter(G,x,me),b.filter(G,we=>!x(we),me)]}b.split=X;function ue(G,x=!1,me=[],we){let Ae=me.slice(),ve=G(Z=>{Ae?Ae.push(Z):B.fire(Z)});we&&we.add(ve);const Ie=()=>{Ae?.forEach(Z=>B.fire(Z)),Ae=null},B=new r({onWillAddFirstListener(){ve||(ve=G(Z=>B.fire(Z)),we&&we.add(ve))},onDidAddFirstListener(){Ae&&(x?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return we&&we.add(B),B.event}b.buffer=ue;function ne(G,x){return(we,Ae,ve)=>{const Ie=x(new oe);return G(function(B){const Z=Ie.evaluate(B);Z!==$e&&we.call(Ae,Z)},void 0,ve)}}b.chain=ne;const $e=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(x){return this.f.push(x),this}forEach(x){return this.f.push(me=>(x(me),me)),this}filter(x){return this.f.push(me=>x(me)?me:$e),this}reduce(x,me){let we=me;return this.f.push(Ae=>(we=x(we,Ae),we)),this}latch(x=(me,we)=>me===we){let me=!0,we;return this.f.push(Ae=>{const ve=me||!x(Ae,we);return me=!1,we=Ae,ve?Ae:$e}),this}evaluate(x){for(const me of this.f)if(x=me(x),x===$e)break;return x}}function K(G,x,me=we=>we){const we=(...B)=>Ie.fire(me(...B)),Ae=()=>G.on(x,we),ve=()=>G.removeListener(x,we),Ie=new r({onWillAddFirstListener:Ae,onDidRemoveLastListener:ve});return Ie.event}b.fromNodeEventEmitter=K;function W(G,x,me=we=>we){const we=(...B)=>Ie.fire(me(...B)),Ae=()=>G.addEventListener(x,we),ve=()=>G.removeEventListener(x,we),Ie=new r({onWillAddFirstListener:Ae,onDidRemoveLastListener:ve});return Ie.event}b.fromDOMEventEmitter=W;function ie(G){return new Promise(x=>L(G)(x))}b.toPromise=ie;function ye(G){const x=new r;return G.then(me=>{x.fire(me)},()=>{x.fire(void 0)}).finally(()=>{x.dispose()}),x.event}b.fromPromise=ye;function de(G,x,me){return x(me),G(we=>x(we))}b.runAndSubscribe=de;class fe{constructor(x,me){this._observable=x,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{x.addObserver(this)},onDidRemoveLastListener:()=>{x.removeObserver(this)}};me||m(we),this.emitter=new r(we),me&&me.add(this.emitter)}beginUpdate(x){this.f++}handlePossibleChange(x){}handleChange(x,me){this.g=!0}endUpdate(x){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(G,x){return new fe(G,x).emitter.event}b.fromObservable=_;function ee(G){return(x,me,we)=>{let Ae=0,ve=!1;const Ie={beginUpdate(){Ae++},endUpdate(){Ae--,Ae===0&&(G.reportChanges(),ve&&(ve=!1,x.call(me)))},handlePossibleChange(){},handleChange(){ve=!0}};G.addObserver(Ie),G.reportChanges();const B={dispose(){G.removeObserver(Ie)}};return we instanceof f.$Sc?we.add(B):Array.isArray(we)&&we.push(B),B}}b.fromObservableLight=ee})(E||(e.Event=E={}));class R{static{this.all=new Set}static{this.f=0}constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${R.f++}`,R.all.add(this)}start(m){this.g=new A.$Sd,this.listenerCount=m}stop(){if(this.g){const m=this.g.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.g=void 0}}}e.$Ud=R;let D=-1;function p(b){const m=D;return D=b,{dispose(){D=m}}}e.$Vd=p;class k{constructor(m,y=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=y,this.g=0}dispose(){this.f?.clear()}check(m,y){const L=this.threshold;if(L<=0||y<L)return;this.f||(this.f=new Map);const N=this.f.get(m.value)||0;if(this.f.set(m.value,N+1),this.g-=1,this.g<=0){this.g=L*.5;let U,T=0;for(const[O,M]of this.f)(!U||T<M)&&(U=O,T=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${T}):`),console.warn(U)}return()=>{const U=this.f.get(m.value)||0;this.f.set(m.value,U-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class g{constructor(m){this.value=m,this.id=c++}}const o=2,i=(b,m)=>{if(b instanceof g)m(b);else for(let y=0;y<b.length;y++){const L=b[y];L&&m(L)}};class r{constructor(m){this.w=0,this.f=m,this.g=D>0||this.f?.leakWarningThreshold?new k(this.f?.leakWarningThreshold??D):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const m=this.t;queueMicrotask(()=>{i(m,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(m,y,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Tc.None;if(this.m)return f.$Tc.None;y&&(m=m.bind(y));const N=new g(m);let U,T;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=S.create(),U=this.g.check(N.stack,this.w+1)),v&&(N.stack=T??S.create()),this.t?this.t instanceof g?(this.u??=new a,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const O=(0,f.$Rc)(()=>{U?.(),this.x(N)});return L instanceof f.$Sc?L.add(O):Array.isArray(L)&&L.push(O),O},this.q}x(m){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,L=y.indexOf(m);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[L]=void 0;const N=this.u.current===this;if(this.w*o<=y.length){let U=0;for(let T=0;T<y.length;T++)y[T]?y[U++]=y[T]:N&&(this.u.end--,U<this.u.i&&this.u.i--);y.length=U}}y(m,y){if(!m)return;const L=this.f?.onListenerError||C.$1;if(!L){m.value(y);return}try{m.value(y)}catch(N){L(N)}}z(m){const y=m.current.t;for(;m.i<m.end;)this.y(y[m.i++],m.value);m.reset()}fire(m){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,m);else{const y=this.u;y.enqueue(this,m,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=r;const n=()=>new a;e.$Xd=n;class a{constructor(){this.i=-1,this.end=0}enqueue(m,y,L){this.i=0,this.end=L,this.current=m,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends r{async fireAsync(m,y,L){if(this.t)for(this.h||(this.h=new P.$4c),i(this.t,N=>this.h.push([N.value,m]));this.h.size>0&&!y.isCancellationRequested;){const[N,U]=this.h.shift(),T=[],O={...U,token:y,waitUntil:M=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");L&&(M=L(M,N)),T.push(M)}};try{N(O)}catch(M){(0,C.$1)(M);continue}Object.freeze(T),await Promise.allSettled(T).then(M=>{for(const j of M)j.status==="rejected"&&(0,C.$1)(j.reason)})}}}e.$Yd=t;class h extends r{get isPaused(){return this.h!==0}constructor(m){super(m),this.h=0,this.s=new P.$4c,this.A=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.A(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.w&&(this.h!==0?this.s.push(m):super.fire(m))}}e.$Zd=h;class s extends h{constructor(m){super(m),this.k=m.delay??100}fire(m){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(m)}}e.$1d=s;class d extends r{constructor(m){super(m),this.h=[],this.k=m?.merge}fire(m){this.hasListeners()&&(this.h.push(m),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$2d=d;class l{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(m){const y={event:m,listener:null};this.h.push(y),this.g&&this.m(y);const L=()=>{this.g&&this.o(y);const N=this.h.indexOf(y);this.h.splice(N,1)};return(0,f.$Rc)((0,F.$db)(L))}j(){this.g=!0,this.h.forEach(m=>this.m(m))}k(){this.g=!1,this.h.forEach(m=>this.o(m))}m(m){m.listener=m.event(y=>this.f.fire(y))}o(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.f.dispose()}}e.$3d=l;class u{constructor(m,y,L,N){this.f=new f.$Sc;const U=this.f.add(new l),T=this.f.add(new f.$3c);function O(M){T.set(M,U.add(N(M)))}for(const M of m)O(M);this.f.add(y(M=>{O(M)})),this.f.add(L(M=>{T.deleteAndDispose(M)})),this.event=U.event}dispose(){this.f.dispose()}}e.$4d=u;class w{constructor(){this.f=[]}wrapEvent(m){return(y,L,N)=>m(U=>{const T=this.f[this.f.length-1];T?T.push(()=>y.call(L,U)):y.call(L,U)},void 0,N)}bufferEvents(m){const y=[];this.f.push(y);const L=m();return this.f.pop(),y.forEach(N=>N()),L}}e.$5d=w;class I{constructor(){this.f=!1,this.g=E.None,this.h=f.$Tc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(m){this.g=m,this.f&&(this.h.dispose(),this.h=m(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=I}),define(Ee[21],Se([1,0,4]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const F=Object.freeze(function(v,$){const E=setTimeout(v.bind($),0);return{dispose(){clearTimeout(E)}}});var f;(function(v){function $(E){return E===v.None||E===v.Cancelled||E instanceof P?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}v.isCancellationToken=$,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(f||(e.CancellationToken=f={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new C.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=f.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=f.None}}e.$7d=A}),define(Ee[162],Se([1,0,21]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class F{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new C.$7d,$=this.b(v.token);return this.a={promise:$,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$Fe=F;class f{constructor(v){this.c=v,this.a=void 0,this.b=void 0}get(v){const $=JSON.stringify(v);return this.b!==$&&(this.b=$,this.a=this.c(v)),this.a}}e.$Ge=f;class P{get cachedValues(){return this.a}constructor(v){this.b=v,this.a=new Map}get(v){if(this.a.has(v))return this.a.get(v);const $=this.b(v);return this.a.set(v,$),$}}e.$He=P}),define(Ee[99],Se([1,0,14,3]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function f(n){const a=n;return a?typeof a.read=="function":!1}e.$8d=f;function P(n){const a=n;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$9d=P;function A(n){const a=n;return a?P(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$0d=A;function v(n,a){return new $(n,a)}e.$$d=v;class ${constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,C.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let h;switch(a){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const s=h.indexOf(t);s>=0&&h.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(n,a){const t=[];let h;for(;(h=n.read())!==null;)t.push(h);return a(t)}e.$_d=E;function R(n,a,t){const h=[];let s;for(;(s=n.read())!==null&&h.length<t;)h.push(s);return s===null&&h.length>0?a(h):{read:()=>{if(h.length>0)return h.shift();if(typeof s<"u"){const d=s;return s=void 0,d}return n.read()}}}e.$ae=R;function D(n,a){return new Promise((t,h)=>{const s=[];p(n,{onData:d=>{a&&s.push(d)},onError:d=>{a?h(d):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}e.$be=D;function p(n,a,t){n.on("error",h=>{t?.isCancellationRequested||a.onError(h)}),n.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),n.on("data",h=>{t?.isCancellationRequested||a.onData(h)})}e.$ce=p;function k(n,a){return new Promise((t,h)=>{const s=new F.$Sc,d=[],l=I=>{if(d.push(I),d.length>a)return s.dispose(),n.pause(),t({stream:n,buffer:d,ended:!1})},u=I=>(s.dispose(),h(I)),w=()=>(s.dispose(),t({stream:n,buffer:d,ended:!0}));s.add((0,F.$Rc)(()=>n.removeListener("error",u))),n.on("error",u),s.add((0,F.$Rc)(()=>n.removeListener("end",w))),n.on("end",w),s.add((0,F.$Rc)(()=>n.removeListener("data",l))),n.on("data",l)})}e.$de=k;function S(n,a){const t=v(a);return t.end(n),t}e.$ee=S;function c(){const n=v(()=>{throw new Error("not supported")});return n.end(),n}e.$fe=c;function g(n){let a=!1;return{read:()=>a?null:(a=!0,n)}}e.$ge=g;function o(n,a,t){const h=v(t);return p(n,{onData:s=>h.write(a.data(s)),onError:s=>h.error(a.error?a.error(s):s),onEnd:()=>h.end()}),h}e.$he=o;function i(n,a,t){let h=!1;return{read:()=>{const s=a.read();return h?s:(h=!0,s!==null?t([n,s]):n)}}}e.$ie=i;function r(n,a,t){let h=!1;const s=v(t);return p(a,{onData:d=>h?s.write(d):(h=!0,s.write(t([n,d]))),onError:d=>s.error(d),onEnd:()=>{h||(h=!0,s.write(n)),s.end()}}),s}e.$je=r}),define(Ee[22],Se([1,0,43,99]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const f=typeof Buffer<"u",P=new C.$V(()=>new Uint8Array(256));let A,v;class ${static alloc(y){return f?new $(Buffer.allocUnsafe(y)):new $(new Uint8Array(y))}static wrap(y){return f&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new $(y)}static fromString(y,L){return!(L?.dontUseNodeBuffer||!1)&&f?new $(Buffer.from(y)):(A||(A=new TextEncoder),new $(A.encode(y)))}static fromByteArray(y){const L=$.alloc(y.length);for(let N=0,U=y.length;N<U;N++)L.buffer[N]=y[N];return L}static concat(y,L){if(typeof L>"u"){L=0;for(let T=0,O=y.length;T<O;T++)L+=y[T].byteLength}const N=$.alloc(L);let U=0;for(let T=0,O=y.length;T<O;T++){const M=y[T];N.set(M,U),U+=M.byteLength}return N}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=$.alloc(this.byteLength);return y.set(this),y}toString(){return f?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(y,L){return new $(this.buffer.subarray(y,L))}set(y,L){if(y instanceof $)this.buffer.set(y.buffer,L);else if(y instanceof Uint8Array)this.buffer.set(y,L);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),L);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return p(this.buffer,y)}writeUInt32BE(y,L){k(this.buffer,y,L)}readUInt32LE(y){return S(this.buffer,y)}writeUInt32LE(y,L){c(this.buffer,y,L)}readUInt8(y){return g(this.buffer,y)}writeUInt8(y,L){o(this.buffer,y,L)}indexOf(y,L=0){return E(this.buffer,y instanceof $?y.buffer:y,L)}}e.$ke=$;function E(m,y,L=0){const N=y.byteLength,U=m.byteLength;if(N===0)return 0;if(N===1)return m.indexOf(y[0]);if(N>U-L)return-1;const T=P.value;T.fill(y.length);for(let z=0;z<y.length;z++)T[y[z]]=y.length-z-1;let O=L+y.length-1,M=O,j=-1;for(;O<U;)if(m[O]===y[M]){if(M===0){j=O;break}O--,M--}else O+=Math.max(y.length-M,T[m[O]]),M=y.length-1;return j}e.$le=E;function R(m,y){return m[y+0]<<0>>>0|m[y+1]<<8>>>0}e.$me=R;function D(m,y,L){m[L+0]=y&255,y=y>>>8,m[L+1]=y&255}e.$ne=D;function p(m,y){return m[y]*2**24+m[y+1]*2**16+m[y+2]*2**8+m[y+3]}e.$oe=p;function k(m,y,L){m[L+3]=y,y=y>>>8,m[L+2]=y,y=y>>>8,m[L+1]=y,y=y>>>8,m[L]=y}e.$pe=k;function S(m,y){return m[y+0]<<0>>>0|m[y+1]<<8>>>0|m[y+2]<<16>>>0|m[y+3]<<24>>>0}e.$qe=S;function c(m,y,L){m[L+0]=y&255,y=y>>>8,m[L+1]=y&255,y=y>>>8,m[L+2]=y&255,y=y>>>8,m[L+3]=y&255}e.$re=c;function g(m,y){return m[y]}e.$se=g;function o(m,y,L){m[L]=y}e.$te=o;function i(m){return F.$_d(m,y=>$.concat(y))}e.$ue=i;function r(m){return F.$ge(m)}e.$ve=r;function n(m){return F.$be(m,y=>$.concat(y))}e.$we=n;async function a(m){return m.ended?$.concat(m.buffer):$.concat([...m.buffer,await n(m.stream)])}e.$xe=a;function t(m){return F.$ee(m,y=>$.concat(y))}e.$ye=t;function h(m){return F.$he(m,{data:y=>typeof y=="string"?$.fromString(y):$.wrap(y)},y=>$.concat(y))}e.$ze=h;function s(m){return F.$$d(y=>$.concat(y),m)}e.$Ae=s;function d(m,y){return F.$ie(m,y,L=>$.concat(L))}e.$Be=d;function l(m,y){return F.$je(m,y,L=>$.concat(L))}e.$Ce=l;function u(m){let y=0,L=0,N=0;const U=new Uint8Array(Math.floor(m.length/4*3)),T=M=>{switch(L){case 3:U[N++]=y|M,L=0;break;case 2:U[N++]=y|M>>>2,y=M<<6,L=3;break;case 1:U[N++]=y|M>>>4,y=M<<4,L=2;break;default:y=M<<2,L=1}};for(let M=0;M<m.length;M++){const j=m.charCodeAt(M);if(j>=65&&j<=90)T(j-65);else if(j>=97&&j<=122)T(j-97+26);else if(j>=48&&j<=57)T(j-48+52);else if(j===43||j===45)T(62);else if(j===47||j===95)T(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${m[M]}`)}}const O=N;for(;L>0;)T(0);return $.wrap(U).slice(0,O)}e.$De=u;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:m},y=!0,L=!1){const N=L?I:w;let U="";const T=m.byteLength%3;let O=0;for(;O<m.byteLength-T;O+=3){const M=m[O+0],j=m[O+1],z=m[O+2];U+=N[M>>>2],U+=N[(M<<4|j>>>4)&63],U+=N[(j<<2|z>>>6)&63],U+=N[z&63]}if(T===1){const M=m[O+0];U+=N[M>>>2],U+=N[M<<4&63],y&&(U+="==")}else if(T===2){const M=m[O+0],j=m[O+1];U+=N[M>>>2],U+=N[(M<<4|j>>>4)&63],U+=N[j<<2&63],y&&(U+="=")}return U}e.$Ee=b}),define(Ee[12],Se([1,0,162,43]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$If=e.$Hf=e.$Gf=e.$Ff=e.GraphemeBreakType=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function f(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$Ke=f;const P=/{(\d+)}/g;function A(Pe,...Ue){return Ue.length===0?Pe:Pe.replace(P,function(Le,Ze){const re=parseInt(Ze,10);return isNaN(re)||re<0||re>=Ue.length?Le:Ue[re]})}e.$Le=A;const v=/{([^}]+)}/g;function $(Pe,Ue){return Object.keys(Ue).length===0?Pe:Pe.replace(v,(Le,Ze)=>Ue[Ze]??Le)}e.$Me=$;function E(Pe){return Pe.replace(/[<>"'&]/g,Ue=>{switch(Ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ue})}e.$Ne=E;function R(Pe){return Pe.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}e.$Oe=R;function D(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=D;function p(Pe,Ue){let Le=0;const Ze=Ue.charCodeAt(0);for(let re=Pe.length-1;re>=0;re--)Pe.charCodeAt(re)===Ze&&Le++;return Le}e.$Qe=p;function k(Pe,Ue,Le="\u2026"){return Pe.length<=Ue?Pe:`${Pe.substr(0,Ue)}${Le}`}e.$Re=k;function S(Pe,Ue,Le="\u2026"){if(Pe.length<=Ue)return Pe;const Ze=Math.ceil(Ue/2)-Le.length/2,re=Math.floor(Ue/2)-Le.length/2;return`${Pe.substr(0,Ze)}${Le}${Pe.substr(Pe.length-re)}`}e.$Se=S;function c(Pe,Ue=" "){const Le=g(Pe,Ue);return o(Le,Ue)}e.$Te=c;function g(Pe,Ue){if(!Pe||!Ue)return Pe;const Le=Ue.length;if(Le===0||Pe.length===0)return Pe;let Ze=0;for(;Pe.indexOf(Ue,Ze)===Ze;)Ze=Ze+Le;return Pe.substring(Ze)}e.$Ue=g;function o(Pe,Ue){if(!Pe||!Ue)return Pe;const Le=Ue.length,Ze=Pe.length;if(Le===0||Ze===0)return Pe;let re=Ze,se=-1;for(;se=Pe.lastIndexOf(Ue,re-1),!(se===-1||se+Le!==re);){if(se===0)return"";re=se}return Pe.substring(0,re)}e.$Ve=o;function i(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=i;function r(Pe){return Pe.replace(/\*/g,"")}e.$Xe=r;function n(Pe,Ue,Le={}){if(!Pe)throw new Error("Cannot create regex from empty string");Ue||(Pe=D(Pe)),Le.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Ze="";return Le.global&&(Ze+="g"),Le.matchCase||(Ze+="i"),Le.multiline&&(Ze+="m"),Le.unicode&&(Ze+="u"),new RegExp(Pe,Ze)}e.$Ye=n;function a(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$Ze=a;function t(Pe){return Pe.split(/\r\n|\r|\n/)}e.$1e=t;function h(Pe){for(let Ue=0,Le=Pe.length;Ue<Le;Ue++){const Ze=Pe.charCodeAt(Ue);if(Ze!==32&&Ze!==9)return Ue}return-1}e.$2e=h;function s(Pe,Ue=0,Le=Pe.length){for(let Ze=Ue;Ze<Le;Ze++){const re=Pe.charCodeAt(Ze);if(re!==32&&re!==9)return Pe.substring(Ue,Ze)}return Pe.substring(Ue,Le)}e.$3e=s;function d(Pe,Ue=Pe.length-1){for(let Le=Ue;Le>=0;Le--){const Ze=Pe.charCodeAt(Le);if(Ze!==32&&Ze!==9)return Le}return-1}e.$4e=d;function l(Pe,Ue,Le){const Ze=[];let re=0;for(const se of Pe.matchAll(Ue)){if(Ze.push(Pe.slice(re,se.index)),se.index===void 0)throw new Error("match.index should be defined");re=se.index+se[0].length,Ze.push(Le(se[0],...se.slice(1),se.index,Pe,se.groups))}return Ze.push(Pe.slice(re)),Promise.all(Ze).then(se=>se.join(""))}e.$5e=l;function u(Pe,Ue){return Pe<Ue?-1:Pe>Ue?1:0}e.$6e=u;function w(Pe,Ue,Le=0,Ze=Pe.length,re=0,se=Ue.length){for(;Le<Ze&&re<se;Le++,re++){const Xe=Pe.charCodeAt(Le),it=Ue.charCodeAt(re);if(Xe<it)return-1;if(Xe>it)return 1}const Ce=Ze-Le,Ve=se-re;return Ce<Ve?-1:Ce>Ve?1:0}e.$7e=w;function I(Pe,Ue){return b(Pe,Ue,0,Pe.length,0,Ue.length)}e.$8e=I;function b(Pe,Ue,Le=0,Ze=Pe.length,re=0,se=Ue.length){for(;Le<Ze&&re<se;Le++,re++){let Xe=Pe.charCodeAt(Le),it=Ue.charCodeAt(re);if(Xe===it)continue;if(Xe>=128||it>=128)return w(Pe.toLowerCase(),Ue.toLowerCase(),Le,Ze,re,se);y(Xe)&&(Xe-=32),y(it)&&(it-=32);const nt=Xe-it;if(nt!==0)return nt}const Ce=Ze-Le,Ve=se-re;return Ce<Ve?-1:Ce>Ve?1:0}e.$9e=b;function m(Pe){return Pe>=48&&Pe<=57}e.$0e=m;function y(Pe){return Pe>=97&&Pe<=122}e.$$e=y;function L(Pe){return Pe>=65&&Pe<=90}e.$_e=L;function N(Pe,Ue){return Pe.length===Ue.length&&b(Pe,Ue)===0}e.$af=N;function U(Pe,Ue){const Le=Ue.length;return Ue.length>Pe.length?!1:b(Pe,Ue,0,Le)===0}e.$bf=U;function T(Pe,Ue){const Le=Math.min(Pe.length,Ue.length);let Ze;for(Ze=0;Ze<Le;Ze++)if(Pe.charCodeAt(Ze)!==Ue.charCodeAt(Ze))return Ze;return Le}e.$cf=T;function O(Pe,Ue){const Le=Math.min(Pe.length,Ue.length);let Ze;const re=Pe.length-1,se=Ue.length-1;for(Ze=0;Ze<Le;Ze++)if(Pe.charCodeAt(re-Ze)!==Ue.charCodeAt(se-Ze))return Ze;return Le}e.$df=O;function M(Pe){return 55296<=Pe&&Pe<=56319}e.$ef=M;function j(Pe){return 56320<=Pe&&Pe<=57343}e.$ff=j;function z(Pe,Ue){return(Pe-55296<<10)+(Ue-56320)+65536}e.$gf=z;function J(Pe,Ue,Le){const Ze=Pe.charCodeAt(Le);if(M(Ze)&&Le+1<Ue){const re=Pe.charCodeAt(Le+1);if(j(re))return z(Ze,re)}return Ze}e.$hf=J;function le(Pe,Ue){const Le=Pe.charCodeAt(Ue-1);if(j(Le)&&Ue>1){const Ze=Pe.charCodeAt(Ue-2);if(M(Ze))return z(Ze,Le)}return Le}class Y{get offset(){return this.e}constructor(Ue,Le=0){this.c=Ue,this.d=Ue.length,this.e=Le}setOffset(Ue){this.e=Ue}prevCodePoint(){const Ue=le(this.c,this.e);return this.e-=Ue>=65536?2:1,Ue}nextCodePoint(){const Ue=J(this.c,this.d,this.e);return this.e+=Ue>=65536?2:1,Ue}eol(){return this.e>=this.d}}e.$if=Y;class Q{get offset(){return this.c.offset}constructor(Ue,Le=0){this.c=new Y(Ue,Le)}nextGraphemeLength(){const Ue=Re.getInstance(),Le=this.c,Ze=Le.offset;let re=Ue.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const se=Le.offset,Ce=Ue.getGraphemeBreakType(Le.nextCodePoint());if(ae(re,Ce)){Le.setOffset(se);break}re=Ce}return Le.offset-Ze}prevGraphemeLength(){const Ue=Re.getInstance(),Le=this.c,Ze=Le.offset;let re=Ue.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const se=Le.offset,Ce=Ue.getGraphemeBreakType(Le.prevCodePoint());if(ae(Ce,re)){Le.setOffset(se);break}re=Ce}return Ze-Le.offset}eol(){return this.c.eol()}}e.$jf=Q;function X(Pe,Ue){return new Q(Pe,Ue).nextGraphemeLength()}e.$kf=X;function ue(Pe,Ue){return new Q(Pe,Ue).prevGraphemeLength()}e.$lf=ue;function ne(Pe,Ue){Ue>0&&j(Pe.charCodeAt(Ue))&&Ue--;const Le=Ue+X(Pe,Ue);return[Le-ue(Pe,Le),Le]}e.$mf=ne;function $e(Pe){const Ue=new Q(Pe);let Le=0;for(;!Ue.eol();)Le++,Ue.nextGraphemeLength();return Le}e.$nf=$e;let oe;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Pe){return oe||(oe=K()),oe.test(Pe)}e.$of=W;const ie=/^[\t\n\r\x20-\x7E]*$/;function ye(Pe){return ie.test(Pe)}e.$pf=ye,e.$qf=/[\u2028\u2029]/;function de(Pe){return e.$qf.test(Pe)}e.$rf=de;function fe(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$sf=fe;function _(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$tf=_;function ee(Pe,Ue,Le=""){const Ze=Pe.trimStart();if(Ze.length<Ue)return Ze;const re=/\b/g;let se=0;for(;re.test(Ze)&&!(Ze.length-re.lastIndex<Ue);)se=re.lastIndex,re.lastIndex+=1;return se===0?Ze:Le+Ze.substring(se).trimStart()}e.$uf=ee;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,x=/\x1b\].*?\x07/g;function me(Pe){return Pe&&(Pe=Pe.replace(G,"").replace(x,"")),Pe}e.$vf=me,e.$wf=String.fromCharCode(65279);function we(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$xf=we;function Ae(Pe){return we(Pe)?Pe.substr(1):Pe}e.$yf=Ae;function ve(Pe,Ue){if(!Pe||!Ue||Pe.length<Ue.length)return!1;const Le=Ue.length,Ze=Pe.toLowerCase();let re=0,se=-1;for(;re<Le;){const Ce=Ze.indexOf(Ue[re],se+1);if(Ce<0)return!1;se=Ce,re++}return!0}e.$zf=ve;function Ie(Pe,Ue=!1){return Pe?(Ue&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$Af=Ie;function B(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$Bf=B;function Z(Pe,Ue=1){if(Ue===0)return"";let Le=-1;do Le=Pe.indexOf(`
`,Le+1),Ue--;while(Ue>0&&Le>=0);return Le===-1?Pe:(Pe[Le-1]==="\r"&&Le--,Pe.substr(0,Le))}e.$Cf=Z;function te(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$Df=te;function V(Pe){return Re.getInstance().getGraphemeBreakType(Pe)}e.$Ef=V;function ae(Pe,Ue){return Pe===0?Ue!==5&&Ue!==7:Pe===2&&Ue===3?!1:Pe===4||Pe===2||Pe===3||Ue===4||Ue===2||Ue===3?!0:!(Pe===8&&(Ue===8||Ue===9||Ue===11||Ue===12)||(Pe===11||Pe===9)&&(Ue===9||Ue===10)||(Pe===12||Pe===10)&&Ue===10||Ue===5||Ue===13||Ue===7||Pe===1||Pe===13&&Ue===14||Pe===6&&Ue===6)}var he;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=je()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===10?3:Ue===13?2:4;if(Ue<127)return 0;const Le=this.d,Ze=Le.length/3;let re=1;for(;re<=Ze;)if(Ue<Le[3*re])re=2*re;else if(Ue>Le[3*re+1])re=2*re+1;else return Le[3*re+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Pe,Ue){if(Pe===0)return 0;const Le=Qe(Pe,Ue);if(Le!==void 0)return Le;const Ze=new Y(Ue,Pe);return Ze.prevCodePoint(),Ze.offset}e.$Ff=He;function Qe(Pe,Ue){const Le=new Y(Ue,Pe);let Ze=Le.prevCodePoint();for(;_e(Ze)||Ze===65039||Ze===8419;){if(Le.offset===0)return;Ze=Le.prevCodePoint()}if(!_(Ze))return;let re=Le.offset;return re>0&&Le.prevCodePoint()===8205&&(re=Le.offset),re}function _e(Pe){return 127995<=Pe&&Pe<=127999}var at;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.$Gf="\xA0";class st{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$Ge(Ue=>{function Le(nt){const Oe=new Map;for(let yt=0;yt<nt.length;yt+=2)Oe.set(nt[yt],nt[yt+1]);return Oe}function Ze(nt,Oe){const yt=new Map(nt);for(const[Dt,Ft]of Oe)yt.set(Dt,Ft);return yt}function re(nt,Oe){if(!nt)return Oe;const yt=new Map;for(const[Dt,Ft]of nt)Oe.has(Dt)&&yt.set(Dt,Ft);return yt}const se=this.c.value;let Ce=Ue.filter(nt=>!nt.startsWith("_")&&nt in se);Ce.length===0&&(Ce=["_default"]);let Ve;for(const nt of Ce){const Oe=Le(se[nt]);Ve=re(Ve,Oe)}const Xe=Le(se._common),it=Ze(Xe,Ve);return new st(it)})}static getInstance(Ue){return st.d.get(Array.from(Ue))}static{this.e=new F.$V(()=>Object.keys(st.c.value).filter(Ue=>!Ue.startsWith("_")))}static getLocales(){return st.e.value}constructor(Ue){this.f=Ue}isAmbiguous(Ue){return this.f.has(Ue)}getPrimaryConfusable(Ue){return this.f.get(Ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Hf=st;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Ue){return rt.e().has(Ue)}static get codePoints(){return rt.e()}}e.$If=rt}),define(Ee[123],Se([1,0,28,161,12]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.FuzzyScore=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.or=void 0;function P(...ve){return function(Ie,B){for(let Z=0,te=ve.length;Z<te;Z++){const V=ve[Z](Ie,B);if(V)return V}return null}}e.or=P,e.$Uj=A.bind(void 0,!1),e.$Vj=A.bind(void 0,!0);function A(ve,Ie,B){if(!B||B.length<Ie.length)return null;let Z;return ve?Z=f.$bf(B,Ie):Z=B.indexOf(Ie)===0,Z?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function v(ve,Ie){const B=Ie.toLowerCase().indexOf(ve.toLowerCase());return B===-1?null:[{start:B,end:B+ve.length}]}e.$Wj=v;function $(ve,Ie){return E(ve.toLowerCase(),Ie.toLowerCase(),0,0)}e.$Xj=$;function E(ve,Ie,B,Z){if(B===ve.length)return[];if(Z===Ie.length)return null;if(ve[B]===Ie[Z]){let te=null;return(te=E(ve,Ie,B+1,Z+1))?n({start:Z,end:Z+1},te):null}return E(ve,Ie,B,Z+1)}function R(ve){return 97<=ve&&ve<=122}function D(ve){return 65<=ve&&ve<=90}e.$Yj=D;function p(ve){return 48<=ve&&ve<=57}function k(ve){return ve===32||ve===9||ve===10||ve===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ve=>S.add(ve.charCodeAt(0)));function c(ve){return k(ve)||S.has(ve)}function g(ve,Ie){return ve===Ie||c(ve)&&c(Ie)}const o=new Map;function i(ve){if(o.has(ve))return o.get(ve);let Ie;const B=(0,F.$Sj)(ve);return B&&(Ie=B),o.set(ve,Ie),Ie}function r(ve){return R(ve)||D(ve)||p(ve)}function n(ve,Ie){return Ie.length===0?Ie=[ve]:ve.end===Ie[0].start?Ie[0].start=ve.start:Ie.unshift(ve),Ie}function a(ve,Ie){for(let B=Ie;B<ve.length;B++){const Z=ve.charCodeAt(B);if(D(Z)||p(Z)||B>0&&!r(ve.charCodeAt(B-1)))return B}return ve.length}function t(ve,Ie,B,Z){if(B===ve.length)return[];if(Z===Ie.length)return null;if(ve[B]!==Ie[Z].toLowerCase())return null;{let te=null,V=Z+1;for(te=t(ve,Ie,B+1,Z+1);!te&&(V=a(Ie,V))<Ie.length;)te=t(ve,Ie,B+1,V),V++;return te===null?null:n({start:Z,end:Z+1},te)}}function h(ve){let Ie=0,B=0,Z=0,te=0,V=0;for(let He=0;He<ve.length;He++)V=ve.charCodeAt(He),D(V)&&Ie++,R(V)&&B++,r(V)&&Z++,p(V)&&te++;const ae=Ie/ve.length,he=B/ve.length,Re=Z/ve.length,je=te/ve.length;return{upperPercent:ae,lowerPercent:he,alphaPercent:Re,numericPercent:je}}function s(ve){const{upperPercent:Ie,lowerPercent:B}=ve;return B===0&&Ie>.6}function d(ve){const{upperPercent:Ie,lowerPercent:B,alphaPercent:Z,numericPercent:te}=ve;return B>.2&&Ie<.8&&Z>.6&&te<.2}function l(ve){let Ie=0,B=0,Z=0,te=0;for(let V=0;V<ve.length;V++)Z=ve.charCodeAt(V),D(Z)&&Ie++,R(Z)&&B++,k(Z)&&te++;return(Ie===0||B===0)&&te===0?ve.length<=30:Ie<=5}function u(ve,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!l(ve)||Ie.length>60)return null;const B=h(Ie);if(!d(B)){if(!s(B))return null;Ie=Ie.toLowerCase()}let Z=null,te=0;for(ve=ve.toLowerCase();te<Ie.length&&(Z=t(ve,Ie,0,te))===null;)te=a(Ie,te+1);return Z}e.$Zj=u;function w(ve,Ie,B=!1){if(!Ie||Ie.length===0)return null;let Z=null,te=0;for(ve=ve.toLowerCase(),Ie=Ie.toLowerCase();te<Ie.length&&(Z=I(ve,Ie,0,te,B),Z===null);)te=b(Ie,te+1);return Z}e.$1j=w;function I(ve,Ie,B,Z,te){let V=0;if(B===ve.length)return[];if(Z===Ie.length)return null;if(!g(ve.charCodeAt(B),Ie.charCodeAt(Z))){const Re=i(ve.charCodeAt(B));if(!Re)return null;for(let je=0;je<Re.length;je++)if(!g(Re[je],Ie.charCodeAt(Z+je)))return null;V+=Re.length-1}let ae=null,he=Z+V+1;if(ae=I(ve,Ie,B+1,he,te),!te)for(;!ae&&(he=b(Ie,he))<Ie.length;)ae=I(ve,Ie,B+1,he,te),he++;if(!ae)return null;if(ve.charCodeAt(B)!==Ie.charCodeAt(Z)){const Re=i(ve.charCodeAt(B));if(!Re)return ae;for(let je=0;je<Re.length;je++)if(Re[je]!==Ie.charCodeAt(Z+je))return ae}return n({start:Z,end:Z+V+1},ae)}function b(ve,Ie){for(let B=Ie;B<ve.length;B++)if(c(ve.charCodeAt(B))||B>0&&c(ve.charCodeAt(B-1)))return B;return ve.length}const m=P(e.$Vj,u,v),y=P(e.$Vj,u,$),L=new C.$Dc(1e4);function N(ve,Ie,B=!1){if(typeof ve!="string"||typeof Ie!="string")return null;let Z=L.get(ve);Z||(Z=new RegExp(f.$We(ve),"i"),L.set(ve,Z));const te=Z.exec(Ie);return te?[{start:te.index,end:te.index+te[0].length}]:B?y(ve,Ie):m(ve,Ie)}e.$2j=N;function U(ve,Ie){const B=_(ve,ve.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?O(B):null}e.$3j=U;function T(ve,Ie,B,Z,te,V){const ae=Math.min(13,ve.length);for(;B<ae;B++){const he=_(ve,Ie,B,Z,te,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(he)return he}return[0,V]}e.$4j=T;function O(ve){if(typeof ve>"u")return[];const Ie=[],B=ve[1];for(let Z=ve.length-1;Z>1;Z--){const te=ve[Z]+B,V=Ie[Ie.length-1];V&&V.end===te?V.end=te+1:Ie.push({start:te,end:te+1})}return Ie}e.$5j=O;const M=128;function j(){const ve=[],Ie=[];for(let B=0;B<=M;B++)Ie[B]=0;for(let B=0;B<=M;B++)ve.push(Ie.slice(0));return ve}function z(ve){const Ie=[];for(let B=0;B<=ve;B++)Ie[B]=0;return Ie}const J=z(2*M),le=z(2*M),Y=j(),Q=j(),X=j(),ue=!1;function ne(ve,Ie,B,Z,te){function V(he,Re,je=" "){for(;he.length<Re;)he=je+he;return he}let ae=` |   |${Z.split("").map(he=>V(he,3)).join("|")}
`;for(let he=0;he<=B;he++)he===0?ae+=" |":ae+=`${Ie[he-1]}|`,ae+=ve[he].slice(0,te+1).map(Re=>V(Re.toString(),3)).join("|")+`
`;return ae}function $e(ve,Ie,B,Z){ve=ve.substr(Ie),B=B.substr(Z),console.log(ne(Q,ve,ve.length,B,B.length)),console.log(ne(X,ve,ve.length,B,B.length)),console.log(ne(Y,ve,ve.length,B,B.length))}function oe(ve,Ie){if(Ie<0||Ie>=ve.length)return!1;const B=ve.codePointAt(Ie);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!f.$tf(B)}}function K(ve,Ie){if(Ie<0||Ie>=ve.length)return!1;switch(ve.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function W(ve,Ie,B){return Ie[ve]!==B[ve]}function ie(ve,Ie,B,Z,te,V,ae=!1){for(;Ie<B&&te<V;)ve[Ie]===Z[te]&&(ae&&(J[Ie]=te),Ie+=1),te+=1;return Ie===B}e.$6j=ie;var ye;(function(ve){ve[ve.Diag=1]="Diag",ve[ve.Left=2]="Left",ve[ve.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var de;(function(ve){ve.Default=[-100,0];function Ie(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}ve.isDefault=Ie})(de||(e.FuzzyScore=de={}));class fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,B){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=B}}e.$7j=fe;function _(ve,Ie,B,Z,te,V,ae=fe.default){const he=ve.length>M?M:ve.length,Re=Z.length>M?M:Z.length;if(B>=he||V>=Re||he-B>Re-V||!ie(Ie,B,he,te,V,Re,!0))return;ee(he,Re,B,V,Ie,te);let je=1,He=1,Qe=B,_e=V;const at=[!1];for(je=1,Qe=B;Qe<he;je++,Qe++){const Le=J[Qe],Ze=le[Qe],re=Qe+1<he?le[Qe+1]:Re;for(He=Le-V+1,_e=Le;_e<re;He++,_e++){let se=Number.MIN_SAFE_INTEGER,Ce=!1;_e<=Ze&&(se=G(ve,Ie,Qe,B,Z,te,_e,Re,V,Y[je-1][He-1]===0,at));let Ve=0;se!==Number.MAX_SAFE_INTEGER&&(Ce=!0,Ve=se+Q[je-1][He-1]);const Xe=_e>Le,it=Xe?Q[je][He-1]+(Y[je][He-1]>0?-5:0):0,nt=_e>Le+1&&Y[je][He-1]>0,Oe=nt?Q[je][He-2]+(Y[je][He-2]>0?-5:0):0;if(nt&&(!Xe||Oe>=it)&&(!Ce||Oe>=Ve))Q[je][He]=Oe,X[je][He]=3,Y[je][He]=0;else if(Xe&&(!Ce||it>=Ve))Q[je][He]=it,X[je][He]=2,Y[je][He]=0;else if(Ce)Q[je][He]=Ve,X[je][He]=1,Y[je][He]=Y[je-1][He-1]+1;else throw new Error("not possible")}}if(ue&&$e(ve,B,Z,V),!at[0]&&!ae.firstMatchCanBeWeak)return;je--,He--;const st=[Q[je][He],V];let rt=0,Pe=0;for(;je>=1;){let Le=He;do{const Ze=X[je][Le];if(Ze===3)Le=Le-2;else if(Ze===2)Le=Le-1;else break}while(Le>=1);rt>1&&Ie[B+je-1]===te[V+He-1]&&!W(Le+V-1,Z,te)&&rt+1>Y[je][Le]&&(Le=He),Le===He?rt++:rt=1,Pe||(Pe=Le),je--,He=Le-1,st.push(He)}Re===he&&ae.boostFullMatch&&(st[0]+=2);const Ue=Pe-he;return st[0]-=Ue,st}e.$8j=_;function ee(ve,Ie,B,Z,te,V){let ae=ve-1,he=Ie-1;for(;ae>=B&&he>=Z;)te[ae]===V[he]&&(le[ae]=he,ae--),he--}function G(ve,Ie,B,Z,te,V,ae,he,Re,je,He){if(Ie[B]!==V[ae])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return ae===B-Z?Qe=ve[B]===te[ae]?7:5:W(ae,te,V)&&(ae===0||!W(ae-1,te,V))?(Qe=ve[B]===te[ae]?7:5,_e=!0):oe(V,ae)&&(ae===0||!oe(V,ae-1))?Qe=5:(oe(V,ae-1)||K(V,ae-1))&&(Qe=5,_e=!0),Qe>1&&B===Z&&(He[0]=!0),_e||(_e=W(ae,te,V)||oe(V,ae-1)||K(V,ae-1)),B===Z?ae>Re&&(Qe-=_e?3:5):je?Qe+=_e?2:0:Qe+=_e?0:1,ae+1===he&&(Qe-=_e?3:5),Qe}function x(ve,Ie,B,Z,te,V,ae){return we(ve,Ie,B,Z,te,V,!0,ae)}e.$9j=x;function me(ve,Ie,B,Z,te,V,ae){return we(ve,Ie,B,Z,te,V,!1,ae)}e.$0j=me;function we(ve,Ie,B,Z,te,V,ae,he){let Re=_(ve,Ie,B,Z,te,V,he);if(Re&&!ae)return Re;if(ve.length>=3){const je=Math.min(7,ve.length-1);for(let He=B+1;He<je;He++){const Qe=Ae(ve,He);if(Qe){const _e=_(Qe,Qe.toLowerCase(),B,Z,te,V,he);_e&&(_e[0]-=3,(!Re||_e[0]>Re[0])&&(Re=_e))}}}return Re}function Ae(ve,Ie){if(Ie+1>=ve.length)return;const B=ve[Ie],Z=ve[Ie+1];if(B!==Z)return ve.slice(0,Ie)+Z+B+ve.slice(Ie+2)}}),define(Ee[54],Se([1,0,12]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=void 0;function F(o){return f(o,0)}e.$Ui=F;function f(o,i){switch(typeof o){case"object":return o===null?P(349,i):Array.isArray(o)?$(o,i):E(o,i);case"string":return v(o,i);case"boolean":return A(o,i);case"number":return P(o,i);case"undefined":return P(937,i);default:return P(617,i)}}e.$Vi=f;function P(o,i){return(i<<5)-i+o|0}e.$Wi=P;function A(o,i){return P(o?433:863,i)}function v(o,i){i=P(149417,i);for(let r=0,n=o.length;r<n;r++)i=P(o.charCodeAt(r),i);return i}e.$Xi=v;function $(o,i){return i=P(104579,i),o.reduce((r,n)=>f(n,r),i)}function E(o,i){return i=P(181387,i),Object.keys(o).sort().reduce((r,n)=>(r=v(n,r),f(o[n],r)),i)}class R{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=f(i,this.g),this.g}}e.$Yi=R;var D;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function p(o,i,r=32){const n=r-i,a=~((1<<n)-1);return(o<<i|(a&o)>>>n)>>>0}function k(o,i=0,r=o.byteLength,n=0){for(let a=0;a<r;a++)o[i+a]=n}function S(o,i,r="0"){for(;o.length<i;)o=r+o;return o}function c(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(r=>r.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),i/4)}e.$Zi=c;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const r=i.length;if(r===0)return;const n=this.p;let a=this.r,t=this.u,h,s;for(t!==0?(h=t,s=-1,t=0):(h=i.charCodeAt(0),s=0);;){let d=h;if(C.$ef(h))if(s+1<r){const l=i.charCodeAt(s+1);C.$ff(l)?(s++,d=C.$gf(h,l)):d=65533}else{t=h;break}else C.$ff(h)&&(d=65533);if(a=this.w(n,a,d),s++,s<r)h=i.charCodeAt(s);else break}this.r=a,this.u=t}w(i,r,n){return n<128?i[r++]=n:n<2048?(i[r++]=192|(n&1984)>>>6,i[r++]=128|(n&63)>>>0):n<65536?(i[r++]=224|(n&61440)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0):(i[r++]=240|(n&1835008)>>>18,i[r++]=128|(n&258048)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=g.g,r=this.q;for(let w=0;w<64;w+=4)i.setUint32(w,r.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)i.setUint32(w,p(i.getUint32(w-12,!1)^i.getUint32(w-32,!1)^i.getUint32(w-56,!1)^i.getUint32(w-64,!1),1),!1);let n=this.h,a=this.l,t=this.m,h=this.n,s=this.o,d,l,u;for(let w=0;w<80;w++)w<20?(d=a&t|~a&h,l=1518500249):w<40?(d=a^t^h,l=1859775393):w<60?(d=a&t|a&h|t&h,l=2400959708):(d=a^t^h,l=3395469782),u=p(n,5)+d+s+l+i.getUint32(w*4,!1)&4294967295,s=h,h=t,t=p(a,30),a=n,n=u;this.h=this.h+n&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+h&4294967295,this.o=this.o+s&4294967295}}e.$1i=g}),define(Ee[39],Se([1,0,12]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(F||(F={})),function(f){const P="error",A="warning",v="warn",$="info",E="ignore";function R(p){return p?C.$af(P,p)?f.Error:C.$af(A,p)||C.$af(v,p)?f.Warning:C.$af($,p)?f.Info:f.Ignore:f.Ignore}f.fromValue=R;function D(p){switch(p){case f.Error:return P;case f.Warning:return A;case f.Info:return $;default:return E}}f.toString=D}(F||(F={})),e.default=F}),define(Ee[163],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(Ee[77],Se([1,0,19,12]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0;class f{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const S=k.charCodeAt(0),c=this.b.charCodeAt(this.c);return S-c}value(){return this.b[this.c]}}e.$9h=f;class P{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,F.$7e)(k,this.b,0,k.length,this.c,this.d):(0,F.$9e)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$0h=P;class A{constructor(k=!0,S=!0){this.f=k,this.g=S}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let S=k.length-1;S>=0;S--,this.c--){const c=this.b.charCodeAt(S);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,F.$7e)(k,this.b,0,k.length,this.d,this.e):(0,F.$9e)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$$h=A;var v;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(v||(v={}));class ${constructor(k,S){this.f=k,this.g=S,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,F.$8e)(k,this.c.scheme);if(this.d[this.e]===2)return(0,F.$8e)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,F.$6e)(k,this.c.query);if(this.d[this.e]===5)return(0,F.$6e)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$_h=$;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(R||(R={}));class D{static forUris(k=()=>!1,S=()=>!1){return new D(new $(k,S))}static forPaths(k=!1){return new D(new A(void 0,!k))}static forStrings(){return new D(new f)}static forConfigKeys(){return new D(new P)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,S){if(S){const c=S.slice(0);(0,C.$Xb)(c);for(const g of c)this.set(g,k)}else{const c=k.slice(0);(0,C.$Xb)(c);for(const g of c)this.set(g[0],g[1])}}set(k,S){const c=this.b.reset(k);let g;this.c||(this.c=new E,this.c.segment=c.value());const o=[];for(g=this.c;;){const r=c.cmp(g.segment);if(r>0)g.left||(g.left=new E,g.left.segment=c.value()),o.push([-1,g]),g=g.left;else if(r<0)g.right||(g.right=new E,g.right.segment=c.value()),o.push([1,g]),g=g.right;else if(c.hasNext())c.next(),g.mid||(g.mid=new E,g.mid.segment=c.value()),o.push([0,g]),g=g.mid;else break}const i=g.value;g.value=S,g.key=k;for(let r=o.length-1;r>=0;r--){const n=o[r][1];n.updateHeight();const a=n.balanceFactor();if(a<-1||a>1){const t=o[r][0],h=o[r+1][0];if(t===1&&h===1)o[r][1]=n.rotateLeft();else if(t===-1&&h===-1)o[r][1]=n.rotateRight();else if(t===1&&h===-1)n.right=o[r+1][1]=o[r+1][1].rotateRight(),o[r][1]=n.rotateLeft();else if(t===-1&&h===1)n.left=o[r+1][1]=o[r+1][1].rotateLeft(),o[r][1]=n.rotateRight();else throw new Error;if(r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}return i}get(k){return this.d(k)?.value}d(k){const S=this.b.reset(k);let c=this.c;for(;c;){const g=S.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(S.hasNext())S.next(),c=c.mid;else break}return c}has(k){const S=this.d(k);return!(S?.value===void 0&&S?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,S){const c=this.b.reset(k),g=[];let o=this.c;for(;o;){const i=c.cmp(o.segment);if(i>0)g.push([-1,o]),o=o.left;else if(i<0)g.push([1,o]),o=o.right;else if(c.hasNext())c.next(),g.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:r,value:n,segment:a}=i;this.e(i.key,!1),o.key=r,o.value=n,o.segment=a}}else{const i=o.left??o.right;if(g.length>0){const[r,n]=g[g.length-1];switch(r){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this.c=i}for(let i=g.length-1;i>=0;i--){const r=g[i][1];r.updateHeight();const n=r.balanceFactor();if(n>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),g[i][1]=r.rotateLeft()):n<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),g[i][1]=r.rotateRight()),i>0)switch(g[i-1][0]){case-1:g[i-1][1].left=g[i][1];break;case 1:g[i-1][1].right=g[i][1];break;case 0:g[i-1][1].mid=g[i][1];break}else this.c=g[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const S=this.b.reset(k);let c=this.c,g;for(;c;){const o=S.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(S.hasNext())S.next(),g=c.value||g,c=c.mid;else break}return c&&c.value||g}findSuperstr(k){return this.g(k,!1)}g(k,S){const c=this.b.reset(k);let g=this.c;for(;g;){const o=c.cmp(g.segment);if(o>0)g=g.left;else if(o<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else return g.mid?this.h(g.mid):S?g.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[S,c]of this)k(c,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const S=[];return this.j(k,S),S[Symbol.iterator]()}j(k,S){k&&(k.left&&this.j(k.left,S),k.value&&S.push([k.key,k.value]),k.mid&&this.j(k.mid,S),k.right&&this.j(k.right,S))}_isBalanced(){const k=S=>{if(!S)return!0;const c=S.balanceFactor();return c<-1||c>1?!1:k(S.left)&&k(S.right)};return k(this.c)}}e.$ai=D}),define(Ee[18],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=void 0;function C(a){return typeof a=="string"}e.$Jf=C;function F(a){return Array.isArray(a)&&a.every(t=>C(t))}e.$Kf=F;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Lf=f;function P(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Mf=P;function A(a){return typeof a=="number"&&!isNaN(a)}e.$Nf=A;function v(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Of=v;function $(a){return a===!0||a===!1}e.$Pf=$;function E(a){return typeof a>"u"}e.$Qf=E;function R(a){return!D(a)}e.$Rf=R;function D(a){return E(a)||a===null}e.$Sf=D;function p(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Tf=p;function k(a){if(D(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Uf=k;function S(...a){const t=[];for(let h=0;h<a.length;h++){const s=a[h];if(D(s))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);t.push(s)}return t}e.$Vf=S;const c=Object.prototype.hasOwnProperty;function g(a){if(!f(a))return!1;for(const t in a)if(c.call(a,t))return!1;return!0}e.$Wf=g;function o(a){return typeof a=="function"}e.$Xf=o;function i(...a){return a.length>0&&a.every(o)}e.$Yf=i;function r(a,t){const h=Math.min(a.length,t.length);for(let s=0;s<h;s++)n(a[s],t[s])}e.$Zf=r;function n(a,t){if(C(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!D(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$1f=n}),define(Ee[78],Se([1,0,18]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=e.$_j=e.$$j=void 0;const F=Object.create(null);function f(v,$){if((0,C.$Jf)($)){const E=F[$];if(E===void 0)throw new Error(`${v} references an unknown codicon: ${$}`);$=E}return F[v]=$,{id:v}}function P(){return F}e.$$j=P;function A(){return Object.values(e.$ak)}e.$_j=A,e.$ak={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugBreakpointPending:f("debug-breakpoint-pending",60377),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),lightbulbSparkle:f("lightbulb-sparkle",60447),lightbulbSparkleAutofix:f("lightbulb-sparkle-autofix",60447),robot:f("robot",60448),sparkleFilled:f("sparkle-filled",60449),diffSingle:f("diff-single",60450),diffMultiple:f("diff-multiple",60451),surroundWith:f("surround-with",60452),gitStash:f("git-stash",60454),gitStashApply:f("git-stash-apply",60455),gitStashPop:f("git-stash-pop",60456),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(Ee[24],Se([1,0,18]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([r,n])=>{i[r]=n&&typeof n=="object"?F(n):n}),i}e.$wn=F;function f(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const r=i.shift();Object.freeze(r);for(const n in r)if(P.call(r,n)){const a=r[n];typeof a=="object"&&!Object.isFrozen(a)&&!(0,C.$Mf)(a)&&i.push(a)}}return o}e.$xn=f;const P=Object.prototype.hasOwnProperty;function A(o,i){return v(o,i,new Set)}e.$yn=A;function v(o,i,r){if((0,C.$Sf)(o))return o;const n=i(o);if(typeof n<"u")return n;if(Array.isArray(o)){const a=[];for(const t of o)a.push(v(t,i,r));return a}if((0,C.$Lf)(o)){if(r.has(o))throw new Error("Cannot clone recursive data-structure");r.add(o);const a={};for(const t in o)P.call(o,t)&&(a[t]=v(o[t],i,r));return r.delete(o),a}return o}function $(o,i,r=!0){return(0,C.$Lf)(o)?((0,C.$Lf)(i)&&Object.keys(i).forEach(n=>{n in o?r&&((0,C.$Lf)(o[n])&&(0,C.$Lf)(i[n])?$(o[n],i[n],r):o[n]=i[n]):o[n]=i[n]}),o):i}e.$zn=$;function E(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let r,n;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(r=0;r<o.length;r++)if(!E(o[r],i[r]))return!1}else{const a=[];for(n in o)a.push(n);a.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!E(a,t))return!1;for(r=0;r<a.length;r++)if(!E(o[a[r]],i[a[r]]))return!1}return!0}e.$An=E;function R(o){const i=new Set;return JSON.stringify(o,(r,n)=>{if((0,C.$Lf)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.$Bn=R;function D(o,i){const r=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],h=i[a];E(t,h)||(r[a]=h)}),r}e.$Cn=D;function p(o,i){const r=i.toLowerCase(),n=Object.keys(o).find(a=>a.toLowerCase()===r);return n?o[n]:o[i]}e.$Dn=p;function k(o,i){const r=Object.create(null);for(const[n,a]of Object.entries(o))i(n,a)&&(r[n]=a);return r}e.$En=k;function S(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$Fn=S;function c(o){const i=[];for(const r of S(o))typeof o[r]=="function"&&i.push(r);return i}e.$Gn=c;function g(o,i){const r=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},n={};for(const a of o)n[a]=r(a);return n}e.$Hn=g}),define(Ee[55],Se([1,0,78]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$bk=e.ThemeColor=void 0;var F;(function(A){function v($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=v})(F||(e.ThemeColor=F={}));function f(A){return{id:A}}e.$bk=f;var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(i){const r=v.exec(i.id);if(!r)return $(C.$ak.error);const[,n,a]=r,t=["codicon","codicon-"+n];return a&&t.push("codicon-modifier-"+a.substring(1)),t}A.asClassNameArray=$;function E(i){return $(i).join(" ")}A.asClassName=E;function R(i){return"."+$(i).join(".")}A.asCSSSelector=R;function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}A.isThemeIcon=D;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function k(i){const r=p.exec(i);if(!r)return;const[,n]=r;return{id:n}}A.fromString=k;function S(i){return{id:i}}A.fromId=S;function c(i,r){let n=i.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),r&&(n=`${n}~${r}`),{id:n}}A.modify=c;function g(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}A.getModifier=g;function o(i,r){return i.id===r.id&&i.color?.id===r.color?.id}A.isEqual=o})(P||(e.ThemeIcon=P={}))}),define(Ee[164],Se([1,0,123,12,55]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=void 0;const P="$(",A=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${A.source}`,"g");function $(o){return o.replace(v,(i,r)=>r?i:`\\${i}`)}e.$ck=$;const E=new RegExp(`\\\\${A.source}`,"g");function R(o){return o.replace(E,i=>`\\${i}`)}e.$dk=R;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function p(o){return o.indexOf(P)===-1?o:o.replace(D,(i,r,n,a)=>n?i:r||a||"")}e.$ek=p;function k(o){return o?o.replace(/\$\((.*?)\)/g,(i,r)=>` ${r} `).trim():""}e.$fk=k;const S=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(o){S.lastIndex=0;let i="";const r=[];let n=0;for(;;){const a=S.lastIndex,t=S.exec(o),h=o.substring(a,t?.index);if(h.length>0){i+=h;for(let s=0;s<h.length;s++)r.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:r}}e.$gk=c;function g(o,i,r=!1){const{text:n,iconOffsets:a}=i;if(!a||a.length===0)return(0,C.$2j)(o,n,r);const t=(0,F.$Ue)(n," "),h=n.length-t.length,s=(0,C.$2j)(o,t,r);if(s)for(const d of s){const l=a[d.start+h]+h;d.start+=l,d.end+=l}return s}e.$hk=g}),define(Ee[124],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=e.$Ie=e.Constants=void 0;var C;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function F(P){return P<0?0:P>255?255:P|0}e.$Ie=F;function f(P){return P<0?0:P>4294967295?4294967295:P|0}e.$Je=f}),define(Ee[30],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(f){return C.test(f)}e.$qg=F,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(v){for(let $=0;$<v.length;$++)v[$]=Math.floor(Math.random()*256);return v};const P=new Uint8Array(16),A=[];for(let v=0;v<256;v++)A.push(v.toString(16).padStart(2,"0"));return function(){f(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let $=0,E="";return E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E}}()}),define(Ee[165],Se([1,0,19,53,30]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$rt=e.$qt=e.$pt=e.$ot=void 0;function P(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$ot=P;function A(D,p,k){const S={id:(0,f.$rg)(),name:D,uri:p,data:k};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$pt=A;class v{constructor(){this.a=new Map}get size(){let p=0;for(const k of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const k=[...this.a.keys()];return F.Iterable.some(this,([S,c])=>c.asFile())&&k.push("files"),R($(p),k)}get(p){return this.a.get(this.b(p))?.[0]}append(p,k){const S=this.a.get(p);S?S.push(k):this.a.set(this.b(p),[k])}replace(p,k){this.a.set(this.b(p),[k])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,k]of this.a)for(const S of k)yield[p,S]}b(p){return $(p)}}e.$qt=v;function $(D){return D.toLowerCase()}function E(D,p){return R($(D),p.map($))}e.$rt=E;function R(D,p){if(D==="*/*")return p.length>0;if(p.includes(D))return!0;const k=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[S,c,g]=k;return g==="*"?p.some(o=>o.startsWith(c+"/")):!1}e.$st=Object.freeze({create:D=>(0,C.$Mb)(D.map(p=>p.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$st.split(D).filter(p=>!p.startsWith("#"))})}),define(Ee[166],Se([1,0,62]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vg=e.$ug=e.$tg=void 0;function F(v,$,E,R=1){let D=!1;return new Promise(p=>{const k=setTimeout(()=>{if(!D)return D=!0,p(0)},E);f(v,$,R,S=>{if(!D)return D=!0,clearTimeout(k),p(S)})})}e.$tg=F;function f(v,$,E,R){if($===0)return R(0);const D=new C.Socket;D.once("connect",()=>(A(D),f(v+E,$-1,E,R))),D.once("data",()=>{}),D.once("error",p=>(A(D),p.code!=="ECONNREFUSED"?f(v+E,$-1,E,R):R(v))),D.connect(v,"127.0.0.1")}e.$ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(v,$,E,R="127.0.0.1"){let D=!1,p,k=1;const S=C.createServer({pauseOnConnect:!0});function c(g,o){D||(D=!0,S.removeAllListeners(),S.close(),p&&clearTimeout(p),o(g))}return new Promise(g=>{p=setTimeout(()=>{c(0,g)},E),S.on("listening",()=>{c(v,g)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&k<$?(v++,k++,S.listen(v,R)):c(0,g)}),S.on("close",()=>{c(0,g)}),S.listen(v,R)})}e.$vg=P;function A(v){try{v.removeAllListeners("connect"),v.removeAllListeners("error"),v.end(),v.destroy(),v.unref()}catch($){console.error($)}}}),define(Ee[125],Se([1,0,124]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=void 0;class F{constructor(v){const $=(0,C.$Ie)(v);this.c=$,this.a=F.d($),this.b=new Map}static d(v){const $=new Uint8Array(256);return $.fill(v),$}set(v,$){const E=(0,C.$Ie)($);v>=0&&v<256?this.a[v]=E:this.b.set(v,E)}get(v){return v>=0&&v<256?this.a[v]:this.b.get(v)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$gt=F;var f;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(f||(f={}));class P{constructor(){this.a=new F(0)}add(v){this.a.set(v,1)}has(v){return this.a.get(v)===1}clear(){return this.a.clear()}}e.$ht=P}),define(Ee[167],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=e.StringEOL=void 0;var C;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function F(f){let P=0,A=0,v=0,$=0;for(let E=0,R=f.length;E<R;E++){const D=f.charCodeAt(E);D===13?(P===0&&(A=E),P++,E+1<R&&f.charCodeAt(E+1)===10?($|=2,E++):$|=3,v=E+1):D===10&&($|=1,P===0&&(A=E),P++,v=E+1)}return P===0&&(A=f.length),[P,A,f.length-v,$]}e.$vt=F}),define(Ee[48],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class C{constructor(f,P){this.lineNumber=f,this.column=P}with(f=this.lineNumber,P=this.column){return f===this.lineNumber&&P===this.column?this:new C(f,P)}delta(f=0,P=0){return this.with(this.lineNumber+f,this.column+P)}equals(f){return C.equals(this,f)}static equals(f,P){return!f&&!P?!0:!!f&&!!P&&f.lineNumber===P.lineNumber&&f.column===P.column}isBefore(f){return C.isBefore(this,f)}static isBefore(f,P){return f.lineNumber<P.lineNumber?!0:P.lineNumber<f.lineNumber?!1:f.column<P.column}isBeforeOrEqual(f){return C.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,P){return f.lineNumber<P.lineNumber?!0:P.lineNumber<f.lineNumber?!1:f.column<=P.column}static compare(f,P){const A=f.lineNumber|0,v=P.lineNumber|0;if(A===v){const $=f.column|0,E=P.column|0;return $-E}return A-v}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new C(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Us=C}),define(Ee[29],Se([1,0,48]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class F{constructor(P,A,v,$){P>v||P===v&&A>$?(this.startLineNumber=v,this.startColumn=$,this.endLineNumber=P,this.endColumn=A):(this.startLineNumber=P,this.startColumn=A,this.endLineNumber=v,this.endColumn=$)}isEmpty(){return F.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return F.containsPosition(this,P)}static containsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<P.startColumn||A.lineNumber===P.endLineNumber&&A.column>P.endColumn)}static strictContainsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<=P.startColumn||A.lineNumber===P.endLineNumber&&A.column>=P.endColumn)}containsRange(P){return F.containsRange(this,P)}static containsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>P.endColumn)}strictContainsRange(P){return F.strictContainsRange(this,P)}static strictContainsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<=P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>=P.endColumn)}plusRange(P){return F.plusRange(this,P)}static plusRange(P,A){let v,$,E,R;return A.startLineNumber<P.startLineNumber?(v=A.startLineNumber,$=A.startColumn):A.startLineNumber===P.startLineNumber?(v=A.startLineNumber,$=Math.min(A.startColumn,P.startColumn)):(v=P.startLineNumber,$=P.startColumn),A.endLineNumber>P.endLineNumber?(E=A.endLineNumber,R=A.endColumn):A.endLineNumber===P.endLineNumber?(E=A.endLineNumber,R=Math.max(A.endColumn,P.endColumn)):(E=P.endLineNumber,R=P.endColumn),new F(v,$,E,R)}intersectRanges(P){return F.intersectRanges(this,P)}static intersectRanges(P,A){let v=P.startLineNumber,$=P.startColumn,E=P.endLineNumber,R=P.endColumn;const D=A.startLineNumber,p=A.startColumn,k=A.endLineNumber,S=A.endColumn;return v<D?(v=D,$=p):v===D&&($=Math.max($,p)),E>k?(E=k,R=S):E===k&&(R=Math.min(R,S)),v>E||v===E&&$>R?null:new F(v,$,E,R)}equalsRange(P){return F.equalsRange(this,P)}static equalsRange(P,A){return!P&&!A?!0:!!P&&!!A&&P.startLineNumber===A.startLineNumber&&P.startColumn===A.startColumn&&P.endLineNumber===A.endLineNumber&&P.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(P){return new C.$Us(P.endLineNumber,P.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(P){return new C.$Us(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,A){return new F(this.startLineNumber,this.startColumn,P,A)}setStartPosition(P,A){return new F(P,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(P){return new F(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(P){return new F(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new F(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,A=P){return new F(P.lineNumber,P.column,A.lineNumber,A.column)}static lift(P){return P?new F(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn)}static areIntersecting(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,A){if(P&&A){const E=P.startLineNumber|0,R=A.startLineNumber|0;if(E===R){const D=P.startColumn|0,p=A.startColumn|0;if(D===p){const k=P.endLineNumber|0,S=A.endLineNumber|0;if(k===S){const c=P.endColumn|0,g=A.endColumn|0;return c-g}return k-S}return D-p}return E-R}return(P?1:0)-(A?1:0)}static compareRangesUsingEnds(P,A){return P.endLineNumber===A.endLineNumber?P.endColumn===A.endColumn?P.startLineNumber===A.startLineNumber?P.startColumn-A.startColumn:P.startLineNumber-A.startLineNumber:P.endColumn-A.endColumn:P.endLineNumber-A.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Vs=F}),define(Ee[168],Se([1,0,29]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class F{static insert(P,A){return{range:new C.$Vs(P.lineNumber,P.column,P.lineNumber,P.column),text:A,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,A){return{range:P,text:A}}static replaceMove(P,A){return{range:P,text:A,forceMoveMarkers:!0}}}e.$Ws=F}),define(Ee[169],Se([1,0,48,29]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.SelectionDirection=void 0;var f;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class P extends F.$Vs{constructor(v,$,E,R){super(v,$,E,R),this.selectionStartLineNumber=v,this.selectionStartColumn=$,this.positionLineNumber=E,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return P.selectionsEqual(this,v)}static selectionsEqual(v,$){return v.selectionStartLineNumber===$.selectionStartLineNumber&&v.selectionStartColumn===$.selectionStartColumn&&v.positionLineNumber===$.positionLineNumber&&v.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,$){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,v,$):new P(v,$,this.startLineNumber,this.startColumn)}getPosition(){return new C.$Us(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$Us(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,$){return this.getDirection()===0?new P(v,$,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,v,$)}static fromPositions(v,$=v){return new P(v.lineNumber,v.column,$.lineNumber,$.column)}static fromRange(v,$){return $===0?new P(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new P(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new P(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,$){if(v&&!$||!v&&$)return!1;if(!v&&!$)return!0;if(v.length!==$.length)return!1;for(let E=0,R=v.length;E<R;E++)if(!this.selectionsEqual(v[E],$[E]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,$,E,R,D){return D===0?new P(v,$,E,R):new P(E,R,v,$)}}e.$Xs=P}),define(Ee[170],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0,e.$ts={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[171],Se([1,0,125]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class f extends C.$gt{constructor(v){super(0);for(let $=0,E=v.length;$<E;$++)this.set(v.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$it=f;function P(A){const v={};return $=>(v.hasOwnProperty($)||(v[$]=A($)),v[$])}e.$jt=P(A=>new f(A))}),define(Ee[126],Se([1,0,53,3,75]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.$vs=e.$us=void 0,e.$us="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(D=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$us)D.indexOf(k)>=0||(p+="\\"+k);return p+="\\s]+)",new RegExp(p,"g")}e.$vs=P();function A(D){let p=e.$vs;if(D&&D instanceof RegExp)if(D.global)p=D;else{let k="g";D.ignoreCase&&(k+="i"),D.multiline&&(k+="m"),D.unicode&&(k+="u"),p=new RegExp(D.source,k)}return p.lastIndex=0,p}e.$ws=A;const v=new f.$4c;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(D){const p=v.unshift(D);return(0,F.$Rc)(p)}e.$xs=$;function E(D,p,k,S,c){if(p=A(p),c||(c=C.Iterable.first(v)),k.length>c.maxLen){let n=D-c.maxLen/2;return n<0?n=0:S+=n,k=k.substring(n,D+c.maxLen/2),E(D,p,k,S,c)}const g=Date.now(),o=D-1-S;let i=-1,r=null;for(let n=1;!(Date.now()-g>=c.timeBudget);n++){const a=o-c.windowSize*n;p.lastIndex=Math.max(0,a);const t=R(p,k,o,i);if(!t&&r||(r=t,a<=0))break;i=a}if(r){const n={word:r[0],startColumn:S+1+r.index,endColumn:S+1+r.index+r[0].length};return p.lastIndex=0,n}return null}e.$ys=E;function R(D,p,k,S){let c;for(;c=D.exec(p);){const g=c.index||0;if(g<=k&&D.lastIndex>=k)return c;if(S>0&&g>S)return null}return null}}),define(Ee[172],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.$St=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class F{constructor(v){if(this.e=null,this.f=!1,this.open=v.open,this.close=v.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(v.notIn))for(let $=0,E=v.notIn.length;$<E;$++)switch(v.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(v){switch(v){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(v,$){if(v.getTokenCount()===0)return!0;const E=v.findTokenIndexAtOffset($-2),R=v.getStandardTokenType(E);return this.isOK(R)}g(v,$){for(let E=v;E<=$;E++){const R=String.fromCharCode(E);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$St=F;class f{constructor(v){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of v)P(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),P(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),P(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),P(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&P(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Tt=f;function P(A,v,$){A.has(v)?A.get(v).push($):A.set(v,[$])}}),define(Ee[173],Se([1,0,125]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KZ=e.$JZ=e.$IZ=e.State=void 0;var F;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class f{constructor(S,c,g){const o=new Uint8Array(S*c);for(let i=0,r=S*c;i<r;i++)o[i]=g;this.a=o,this.rows=S,this.cols=c}get(S,c){return this.a[S*this.cols+c]}set(S,c,g){this.a[S*this.cols+c]=g}}class P{constructor(S){let c=0,g=0;for(let i=0,r=S.length;i<r;i++){const[n,a,t]=S[i];a>c&&(c=a),n>g&&(g=n),t>g&&(g=t)}c++,g++;const o=new f(g,c,0);for(let i=0,r=S.length;i<r;i++){const[n,a,t]=S[i];o.set(n,a,t)}this.a=o,this.b=c}nextState(S,c){return c<0||c>=this.b?0:this.a.get(S,c)}}e.$IZ=P;let A=null;function v(){return A===null&&(A=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var $;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})($||($={}));let E=null;function R(){if(E===null){E=new C.$gt(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<k.length;c++)E.set(k.charCodeAt(c),1);const S=".,;:";for(let c=0;c<S.length;c++)E.set(S.charCodeAt(c),2)}return E}class D{static a(S,c,g,o,i){let r=i-1;do{const n=c.charCodeAt(r);if(S.get(n)!==2)break;r--}while(r>o);if(o>0){const n=c.charCodeAt(o-1),a=c.charCodeAt(r);(n===40&&a===41||n===91&&a===93||n===123&&a===125)&&r--}return{range:{startLineNumber:g,startColumn:o+1,endLineNumber:g,endColumn:r+2},url:c.substring(o,r+1)}}static computeLinks(S,c=v()){const g=R(),o=[];for(let i=1,r=S.getLineCount();i<=r;i++){const n=S.getLineContent(i),a=n.length;let t=0,h=0,s=0,d=1,l=!1,u=!1,w=!1,I=!1;for(;t<a;){let b=!1;const m=n.charCodeAt(t);if(d===13){let y;switch(m){case 40:l=!0,y=0;break;case 41:y=l?0:1;break;case 91:w=!0,u=!0,y=0;break;case 93:w=!1,y=u?0:1;break;case 123:I=!0,y=0;break;case 125:y=I?0:1;break;case 39:case 34:case 96:s===m?y=1:s===39||s===34||s===96?y=0:y=1;break;case 42:y=s===42?1:0;break;case 124:y=s===124?1:0;break;case 32:y=w?0:1;break;default:y=g.get(m)}y===1&&(o.push(D.a(g,n,i,h,t)),b=!0)}else if(d===12){let y;m===91?(u=!0,y=0):y=g.get(m),y===1?b=!0:d=13}else d=c.nextState(d,m),d===0&&(b=!0);b&&(d=1,l=!1,u=!1,I=!1,h=t+1,s=m),t++}d===13&&o.push(D.a(g,n,i,h,a))}return o}}e.$JZ=D;function p(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:D.computeLinks(k)}e.$KZ=p}),define(Ee[79],Se([1,0,24]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gv=e.$fv=e.$ev=e.$dv=e.ModelConstants=e.PositionAffinity=e.$cv=e.TrackedRangeStickiness=e.$bv=e.$av=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var f;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(f||(e.GlyphMarginLane=f={}));var P;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var A;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var v;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var $;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E||(e.EndOfLineSequence=E={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,C.$An)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$av=R;class D{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$bv=D;var p;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function k(n){return n&&typeof n.read=="function"}e.$cv=k;var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var c;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c||(e.ModelConstants=c={}));class g{constructor(a,t,h,s,d,l){this.identifier=a,this.range=t,this.text=h,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=d,this._isTracked=l}}e.$dv=g;class o{constructor(a,t,h){this.regex=a,this.wordSeparators=t,this.simpleSearch=h}}e.$ev=o;class i{constructor(a,t,h){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=h}}e.$fv=i;function r(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.$gv=r}),define(Ee[174],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.NodeColor=e.$TB=void 0;class C{constructor(g,o){this.piece=g,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$UB)return f(this.right);let g=this;for(;g.parent!==e.$UB&&g.parent.left!==g;)g=g.parent;return g.parent===e.$UB?e.$UB:g.parent}prev(){if(this.left!==e.$UB)return P(this.left);let g=this;for(;g.parent!==e.$UB&&g.parent.right!==g;)g=g.parent;return g.parent===e.$UB?e.$UB:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$TB=C;var F;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$UB=new C(null,0),e.$UB.parent=e.$UB,e.$UB.left=e.$UB,e.$UB.right=e.$UB,e.$UB.color=0;function f(c){for(;c.left!==e.$UB;)c=c.left;return c}e.$VB=f;function P(c){for(;c.right!==e.$UB;)c=c.right;return c}e.$WB=P;function A(c){return c===e.$UB?0:c.size_left+c.piece.length+A(c.right)}function v(c){return c===e.$UB?0:c.lf_left+c.piece.lineFeedCnt+v(c.right)}function $(){e.$UB.parent=e.$UB}function E(c,g){const o=g.right;o.size_left+=g.size_left+(g.piece?g.piece.length:0),o.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=o.left,o.left!==e.$UB&&(o.left.parent=g),o.parent=g.parent,g.parent===e.$UB?c.root=o:g.parent.left===g?g.parent.left=o:g.parent.right=o,o.left=g,g.parent=o}e.$XB=E;function R(c,g){const o=g.left;g.left=o.right,o.right!==e.$UB&&(o.right.parent=g),o.parent=g.parent,g.size_left-=o.size_left+(o.piece?o.piece.length:0),g.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),g.parent===e.$UB?c.root=o:g===g.parent.right?g.parent.right=o:g.parent.left=o,o.right=g,g.parent=o}e.$YB=R;function D(c,g){let o,i;if(g.left===e.$UB?(i=g,o=i.right):g.right===e.$UB?(i=g,o=i.left):(i=f(g.right),o=i.right),i===c.root){c.root=o,o.color=0,g.detach(),$(),c.root.parent=e.$UB;return}const r=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===g?(o.parent=i.parent,S(c,o)):(i.parent===g?o.parent=i:o.parent=i.parent,S(c,o),i.left=g.left,i.right=g.right,i.parent=g.parent,i.color=g.color,g===c.root?c.root=i:g===g.parent.left?g.parent.left=i:g.parent.right=i,i.left!==e.$UB&&(i.left.parent=i),i.right!==e.$UB&&(i.right.parent=i),i.size_left=g.size_left,i.lf_left=g.lf_left,S(c,i)),g.detach(),o.parent.left===o){const a=A(o),t=v(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const h=a-o.parent.size_left,s=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,k(c,o.parent,h,s)}}if(S(c,o.parent),r){$();return}let n;for(;o!==c.root&&o.color===0;)o===o.parent.left?(n=o.parent.right,n.color===1&&(n.color=0,o.parent.color=1,E(c,o.parent),n=o.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.right.color===0&&(n.left.color=0,n.color=1,R(c,n),n=o.parent.right),n.color=o.parent.color,o.parent.color=0,n.right.color=0,E(c,o.parent),o=c.root)):(n=o.parent.left,n.color===1&&(n.color=0,o.parent.color=1,R(c,o.parent),n=o.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.left.color===0&&(n.right.color=0,n.color=1,E(c,n),n=o.parent.left),n.color=o.parent.color,o.parent.color=0,n.left.color=0,R(c,o.parent),o=c.root));o.color=0,$()}e.$ZB=D;function p(c,g){for(S(c,g);g!==c.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const o=g.parent.parent.right;o.color===1?(g.parent.color=0,o.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,E(c,g)),g.parent.color=0,g.parent.parent.color=1,R(c,g.parent.parent))}else{const o=g.parent.parent.left;o.color===1?(g.parent.color=0,o.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,R(c,g)),g.parent.color=0,g.parent.parent.color=1,E(c,g.parent.parent))}c.root.color=0}e.$1B=p;function k(c,g,o,i){for(;g!==c.root&&g!==e.$UB;)g.parent.left===g&&(g.parent.size_left+=o,g.parent.lf_left+=i),g=g.parent}e.$2B=k;function S(c,g){let o=0,i=0;if(g!==c.root){for(;g!==c.root&&g===g.parent.right;)g=g.parent;if(g!==c.root)for(g=g.parent,o=A(g.left)-g.size_left,i=v(g.left)-g.lf_left,g.size_left+=o,g.lf_left+=i;g!==c.root&&(o!==0||i!==0);)g.parent.left===g&&(g.parent.size_left+=o,g.parent.lf_left+=i),g=g.parent}}e.$3B=S}),define(Ee[175],Se([1,0,19,124]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=void 0;class f{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,E){$=(0,F.$Je)($);const R=this.a,D=this.b,p=E.length;return p===0?!1:(this.a=new Uint32Array(R.length+p),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($),$+p),this.a.set(E,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}setValue($,E){return $=(0,F.$Je)($),E=(0,F.$Je)(E),this.a[$]===E?!1:(this.a[$]=E,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,E){$=(0,F.$Je)($),E=(0,F.$Je)(E);const R=this.a,D=this.b;if($>=R.length)return!1;const p=R.length-$;return E>=p&&(E=p),E===0?!1:(this.a=new Uint32Array(R.length-E),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($+E),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,F.$Je)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),$>=this.a.length&&($=this.a.length-1);for(let R=E;R<=$;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let E=0,R=this.a.length-1,D=0,p=0,k=0;for(;E<=R;)if(D=E+(R-E)/2|0,p=this.b[D],k=p-this.a[D],$<k)R=D-1;else if($>=p)E=D+1;else break;return new A(D,$-k)}}e.$jv=f;class P{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const E=this.e[$],R=E>0?this.d[E-1]:0;return new A(E,$-R)}removeValues($,E){this.a.splice($,E),this.f($)}insertValues($,E){this.a=(0,C.$Wb)(this.a,$,E),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,E=this.a.length;$<E;$++){const R=this.a[$],D=$>0?this.d[$-1]:0;this.d[$]=D+R;for(let p=0;p<R;p++)this.e[D+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,E){this.a[$]!==E&&(this.a[$]=E,this.f($))}}e.$kv=P;class A{constructor($,E){this.index=$,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=E}}e.$lv=A}),define(Ee[176],Se([1,0,12,48,175]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=void 0;class P{constructor(v,$,E,R){this.d=v,this.f=$,this.g=E,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(v){v.eol&&v.eol!==this.g&&(this.g=v.eol,this.j=null);const $=v.changes;for(const E of $)this.o(E.range),this.p(new F.$Us(E.range.startLineNumber,E.range.startColumn),E.text);this.h=v.versionId,this.k=null}l(){if(!this.j){const v=this.g.length,$=this.f.length,E=new Uint32Array($);for(let R=0;R<$;R++)E[R]=this.f[R].length+v;this.j=new f.$jv(E)}}n(v,$){this.f[v]=$,this.j&&this.j.setValue(v,this.f[v].length+this.g.length)}o(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.startLineNumber-1].substring(v.endColumn-1));return}this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.endLineNumber-1].substring(v.endColumn-1)),this.f.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this.j&&this.j.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}p(v,$){if($.length===0)return;const E=(0,C.$1e)($);if(E.length===1){this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+E[0]+this.f[v.lineNumber-1].substring(v.column-1));return}E[E.length-1]+=this.f[v.lineNumber-1].substring(v.column-1),this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+E[0]);const R=new Uint32Array(E.length-1);for(let D=1;D<E.length;D++)this.f.splice(v.lineNumber+D-1,0,E[D]),R[D-1]=E[D].length+this.g.length;this.j&&this.j.insertValues(v.lineNumber,R)}}e.$mv=P}),define(Ee[100],Se([1,0,12,171,48,29,79]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9B=e.$8B=e.$7B=e.$6B=e.$5B=e.$4B=void 0;const v=999;class ${constructor(i,r,n,a){this.searchString=i,this.isRegex=r,this.matchCase=n,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=E(this.searchString):i=this.searchString.indexOf(`
`)>=0;let r=null;try{r=C.$Ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!r)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new A.$ev(r,this.wordSeparators?(0,F.$jt)(this.wordSeparators):null,n?this.searchString:null)}}e.$4B=$;function E(o){if(!o||o.length===0)return!1;for(let i=0,r=o.length;i<r;i++){const n=o.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=r)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$5B=E;function R(o,i,r){if(!r)return new A.$bv(o,null);const n=[];for(let a=0,t=i.length;a<t;a++)n[a]=i[a];return new A.$bv(o,n)}e.$6B=R;class D{constructor(i){const r=[];let n=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(r[n++]=a);this.a=r}findLineFeedCountBeforeOffset(i){const r=this.a;let n=0,a=r.length-1;if(a===-1||i<=r[0])return 0;for(;n<a;){const t=n+((a-n)/2>>0);r[t]>=i?a=t-1:r[t+1]>=i?(n=t,a=t):n=t+1}return n+1}}class p{static findMatches(i,r,n,a,t){const h=r.parseSearchRequest();return h?h.regex.multiline?this.b(i,n,new g(h.wordSeparators,h.regex),a,t):this.c(i,n,h,a,t):[]}static a(i,r,n,a,t,h){let s,d=0;a?(d=a.findLineFeedCountBeforeOffset(t),s=r+t+d):s=r+t;let l;if(a){const b=a.findLineFeedCountBeforeOffset(t+h.length)-d;l=s+h.length+b}else l=s+h.length;const u=i.getPositionAt(s),w=i.getPositionAt(l);return new P.$Vs(u.lineNumber,u.column,w.lineNumber,w.column)}static b(i,r,n,a,t){const h=i.getOffsetAt(r.getStartPosition()),s=i.getValueInRange(r,1),d=i.getEOL()===`\r
`?new D(s):null,l=[];let u=0,w;for(n.reset(0);w=n.next(s);)if(l[u++]=R(this.a(i,h,s,d,w.index,w[0]),w,a),u>=t)return l;return l}static c(i,r,n,a,t){const h=[];let s=0;if(r.startLineNumber===r.endLineNumber){const l=i.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return s=this.d(n,l,r.startLineNumber,r.startColumn-1,s,h,a,t),h}const d=i.getLineContent(r.startLineNumber).substring(r.startColumn-1);s=this.d(n,d,r.startLineNumber,r.startColumn-1,s,h,a,t);for(let l=r.startLineNumber+1;l<r.endLineNumber&&s<t;l++)s=this.d(n,i.getLineContent(l),l,0,s,h,a,t);if(s<t){const l=i.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);s=this.d(n,l,r.endLineNumber,0,s,h,a,t)}return h}static d(i,r,n,a,t,h,s,d){const l=i.wordSeparators;if(!s&&i.simpleSearch){const I=i.simpleSearch,b=I.length,m=r.length;let y=-b;for(;(y=r.indexOf(I,y+b))!==-1;)if((!l||c(l,r,m,y,b))&&(h[t++]=new A.$bv(new P.$Vs(n,y+1+a,n,y+1+b+a),null),t>=d))return t;return t}const u=new g(i.wordSeparators,i.regex);let w;u.reset(0);do if(w=u.next(r),w&&(h[t++]=R(new P.$Vs(n,w.index+1+a,n,w.index+1+w[0].length+a),w,s),t>=d))return t;while(w);return t}static findNextMatch(i,r,n,a){const t=r.parseSearchRequest();if(!t)return null;const h=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,n,h,a):this.f(i,n,h,a)}static e(i,r,n,a){const t=new f.$Us(r.lineNumber,1),h=i.getOffsetAt(t),s=i.getLineCount(),d=i.getValueInRange(new P.$Vs(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),l=i.getEOL()===`\r
`?new D(d):null;n.reset(r.column-1);const u=n.next(d);return u?R(this.a(i,h,d,l,u.index,u[0]),u,a):r.lineNumber!==1||r.column!==1?this.e(i,new f.$Us(1,1),n,a):null}static f(i,r,n,a){const t=i.getLineCount(),h=r.lineNumber,s=i.getLineContent(h),d=this.g(n,s,h,r.column,a);if(d)return d;for(let l=1;l<=t;l++){const u=(h+l-1)%t,w=i.getLineContent(u+1),I=this.g(n,w,u+1,1,a);if(I)return I}return null}static g(i,r,n,a,t){i.reset(a-1);const h=i.next(r);return h?R(new P.$Vs(n,h.index+1,n,h.index+1+h[0].length),h,t):null}static findPreviousMatch(i,r,n,a){const t=r.parseSearchRequest();if(!t)return null;const h=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,n,h,a):this.j(i,n,h,a)}static h(i,r,n,a){const t=this.b(i,new P.$Vs(1,1,r.lineNumber,r.column),n,a,10*v);if(t.length>0)return t[t.length-1];const h=i.getLineCount();return r.lineNumber!==h||r.column!==i.getLineMaxColumn(h)?this.h(i,new f.$Us(h,i.getLineMaxColumn(h)),n,a):null}static j(i,r,n,a){const t=i.getLineCount(),h=r.lineNumber,s=i.getLineContent(h).substring(0,r.column-1),d=this.k(n,s,h,a);if(d)return d;for(let l=1;l<=t;l++){const u=(t+h-l-1)%t,w=i.getLineContent(u+1),I=this.k(n,w,u+1,a);if(I)return I}return null}static k(i,r,n,a){let t=null,h;for(i.reset(0);h=i.next(r);)t=R(new P.$Vs(n,h.index+1,n,h.index+1+h[0].length),h,a);return t}}e.$7B=p;function k(o,i,r,n,a){if(n===0)return!0;const t=i.charCodeAt(n-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const h=i.charCodeAt(n);if(o.get(h)!==0)return!0}return!1}function S(o,i,r,n,a){if(n+a===r)return!0;const t=i.charCodeAt(n+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const h=i.charCodeAt(n+a-1);if(o.get(h)!==0)return!0}return!1}function c(o,i,r,n,a){return k(o,i,r,n,a)&&S(o,i,r,n,a)}e.$8B=c;class g{constructor(i,r){this._wordSeparators=i,this.a=r,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const r=i.length;let n;do{if(this.b+this.c===r||(n=this.a.exec(i),!n))return null;const a=n.index,t=n[0].length;if(a===this.b&&t===this.c){if(t===0){C.$hf(i,r,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||c(this._wordSeparators,i,r,a,t))return n}while(n);return null}}e.$9B=g}),define(Ee[127],Se([1,0,48,29,79,174,100]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=void 0;const v=65535;function $(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class E{constructor(i,r,n,a,t){this.lineStarts=i,this.cr=r,this.lf=n,this.crlf=a,this.isBasicASCII=t}}function R(o,i=!0){const r=[0];let n=1;for(let a=0,t=o.length;a<t;a++){const h=o.charCodeAt(a);h===13?a+1<t&&o.charCodeAt(a+1)===10?(r[n++]=a+2,a++):r[n++]=a+1:h===10&&(r[n++]=a+1)}return i?$(r):r}e.$0B=R;function D(o,i){o.length=0,o[0]=0;let r=1,n=0,a=0,t=0,h=!0;for(let d=0,l=i.length;d<l;d++){const u=i.charCodeAt(d);u===13?d+1<l&&i.charCodeAt(d+1)===10?(t++,o[r++]=d+2,d++):(n++,o[r++]=d+1):u===10?(a++,o[r++]=d+1):h&&u!==9&&(u<32||u>126)&&(h=!1)}const s=new E($(o),n,a,t,h);return o.length=0,s}e.$$B=D;class p{constructor(i,r,n,a,t){this.bufferIndex=i,this.start=r,this.end=n,this.lineFeedCnt=a,this.length=t}}e.$_B=p;class k{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$aC=k;class S{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==P.$UB&&i.iterate(i.root,n=>(n!==P.$UB&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const n=this.b;for(let a=0;a<n.length;a++){const t=n[a];if(t.node.parent===null||t.nodeStartOffset>=i){n[a]=null,r=!0;continue}}if(r){const a=[];for(const t of n)t!==null&&a.push(t);this.b=a}}}class g{constructor(i,r,n){this.create(i,r,n)}create(i,r,n){this.a=[new k("",[0])],this.g={line:0,column:0},this.root=P.$UB,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=n;let a=null;for(let t=0,h=i.length;t<h;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const s=new p(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,s)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=v,n=r-Math.floor(r/3),a=n*2;let t="",h=0;const s=[];if(this.iterate(this.root,d=>{const l=this.R(d),u=l.length;if(h<=n||h+u<a)return t+=l,h+=u,!0;const w=t.replace(/\r\n|\r|\n/g,i);return s.push(new k(w,R(w))),t=l,h=u,!0}),h>0){const d=t.replace(/\r\n|\r|\n/g,i);s.push(new k(d,R(d)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,a=>{if(a===P.$UB)return!0;const t=this.R(a),h=t.length,s=i.G(r),d=i.G(r+h),l=i.getValueInRange2(s,d);return r+=h,t===l})}getOffsetAt(i,r){let n=0,a=this.root;for(;a!==P.$UB;)if(a.left!==P.$UB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){n+=a.size_left;const t=this.B(a,i-a.lf_left-2);return n+=t+r-1}else i-=a.lf_left+a.piece.lineFeedCnt,n+=a.size_left+a.piece.length,a=a.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,n=0;const a=i;for(;r!==P.$UB;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const t=this.A(r,i-r.size_left);if(n+=r.lf_left+t.index,t.index===0){const h=this.getOffsetAt(n+1,1),s=a-h;return new C.$Us(n+1,s+1)}return new C.$Us(n+1,t.remainder+1)}else if(i-=r.size_left+r.piece.length,n+=r.lf_left+r.piece.lineFeedCnt,r.right===P.$UB){const t=this.getOffsetAt(n+1,1),h=a-i-t;return new C.$Us(n+1,h+1)}else r=r.right;return new C.$Us(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,a);return r?r!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(i,r){if(i.node===r.node){const s=i.node,d=this.a[s.piece.bufferIndex].buffer,l=this.u(s.piece.bufferIndex,s.piece.start);return d.substring(l+i.remainder,l+r.remainder)}let n=i.node;const a=this.a[n.piece.bufferIndex].buffer,t=this.u(n.piece.bufferIndex,n.piece.start);let h=a.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==P.$UB;){const s=this.a[n.piece.bufferIndex].buffer,d=this.u(n.piece.bufferIndex,n.piece.start);if(n===r.node){h+=s.substring(d,d+r.remainder);break}else h+=s.substr(d,n.piece.length);n=n.next()}return h}getLinesContent(){const i=[];let r=0,n="",a=!1;return this.iterate(this.root,t=>{if(t===P.$UB)return!0;const h=t.piece;let s=h.length;if(s===0)return!0;const d=this.a[h.bufferIndex].buffer,l=this.a[h.bufferIndex].lineStarts,u=h.start.line,w=h.end.line;let I=l[u]+h.start.column;if(a&&(d.charCodeAt(I)===10&&(I++,s--),i[r++]=n,n="",a=!1,s===0))return!0;if(u===w)return!this.f&&d.charCodeAt(I+s-1)===13?(a=!0,n+=d.substr(I,s-1)):n+=d.substr(I,s),!0;n+=this.f?d.substring(I,Math.max(I,l[u+1]-this.e)):d.substring(I,l[u+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;for(let b=u+1;b<w;b++)n=this.f?d.substring(l[b],l[b+1]-this.e):d.substring(l[b],l[b+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;return!this.f&&d.charCodeAt(l[w]+h.end.column-1)===13?(a=!0,h.end.column===0?r--:n=d.substr(l[w],h.end.column-1)):n=d.substr(l[w],h.end.column),!0}),a&&(i[r++]=n,n=""),i[r++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const n=this.a[r.piece.bufferIndex],a=this.u(r.piece.bufferIndex,r.piece.start);return n.buffer.charCodeAt(a)}else{const r=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(a)}}getLineCharCode(i,r){const n=this.H(i,r+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}findMatchesInNode(i,r,n,a,t,h,s,d,l,u,w){const I=this.a[i.piece.bufferIndex],b=this.u(i.piece.bufferIndex,i.piece.start),m=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,h);let L;const N={line:0,column:0};let U,T;r._wordSeparators?(U=I.buffer.substring(m,y),T=O=>O+m,r.reset(0)):(U=I.buffer,T=O=>O,r.reset(m));do if(L=r.next(U),L){if(T(L.index)>=y)return u;this.s(i,T(L.index)-b,N);const O=this.t(i.piece.bufferIndex,t,N),M=N.line===t.line?N.column-t.column+a:N.column+1,j=M+L[0].length;if(w[u++]=(0,A.$6B)(new F.$Vs(n+O,M,n+O,j),L,d),T(L.index)+L[0].length>=y||u>=l)return u}while(L);return u}findMatchesLineByLine(i,r,n,a){const t=[];let h=0;const s=new A.$9B(r.wordSeparators,r.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let u=this.s(d.node,d.remainder);const w=this.s(l.node,l.remainder);if(d.node===l.node)return this.findMatchesInNode(d.node,s,i.startLineNumber,i.startColumn,u,w,r,n,a,h,t),t;let I=i.startLineNumber,b=d.node;for(;b!==l.node;){const y=this.t(b.piece.bufferIndex,u,b.piece.end);if(y>=1){const N=this.a[b.piece.bufferIndex].lineStarts,U=this.u(b.piece.bufferIndex,b.piece.start),T=N[u.line+y],O=I===i.startLineNumber?i.startColumn:1;if(h=this.findMatchesInNode(b,s,I,O,u,this.s(b,T-U),r,n,a,h,t),h>=a)return t;I+=y}const L=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const N=this.getLineContent(I).substring(L,i.endColumn-1);return h=this.n(r,s,N,i.endLineNumber,L,h,t,n,a),t}if(h=this.n(r,s,this.getLineContent(I).substr(L),I,L,h,t,n,a),h>=a)return t;I++,d=this.H(I,1),b=d.node,u=this.s(d.node,d.remainder)}if(I===i.endLineNumber){const y=I===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(I).substring(y,i.endColumn-1);return h=this.n(r,s,L,i.endLineNumber,y,h,t,n,a),t}const m=I===i.startLineNumber?i.startColumn:1;return h=this.findMatchesInNode(l.node,s,I,m,u,w,r,n,a,h,t),t}n(i,r,n,a,t,h,s,d,l){const u=i.wordSeparators;if(!d&&i.simpleSearch){const I=i.simpleSearch,b=I.length,m=n.length;let y=-b;for(;(y=n.indexOf(I,y+b))!==-1;)if((!u||(0,A.$8B)(u,n,m,y,b))&&(s[h++]=new f.$bv(new F.$Vs(a,y+1+t,a,y+1+b+t),null),h>=l))return h;return h}let w;r.reset(0);do if(w=r.next(n),w&&(s[h++]=(0,A.$6B)(new F.$Vs(a,w.index+1+t,a,w.index+1+w[0].length+t),w,d),h>=l))return h;while(w);return h}insert(i,r,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==P.$UB){const{node:a,remainder:t,nodeStartOffset:h}=this.G(i),s=a.piece,d=s.bufferIndex,l=this.s(a,t);if(a.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&h+s.length===i&&r.length<v){this.F(a,r),this.y();return}if(h===i)this.o(r,a),this.h.validate(i);else if(h+a.piece.length>i){const u=[];let w=new p(s.bufferIndex,l,s.end,this.t(s.bufferIndex,l,s.end),this.u(d,s.end)-this.u(d,l));if(this.K()&&this.M(r)&&this.I(a,t)===10){const y={line:w.start.line+1,column:0};w=new p(w.bufferIndex,y,w.end,this.t(w.bufferIndex,y,w.end),w.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(a,t-1)===13){const y=this.s(a,t-1);this.C(a,y),r="\r"+r,a.piece.length===0&&u.push(a)}else this.C(a,l);else this.C(a,l);const I=this.w(r);w.length>0&&this.S(a,w);let b=a;for(let m=0;m<I.length;m++)b=this.S(b,I[m]);this.v(u)}else this.q(r,a)}else{const a=this.w(r);let t=this.T(null,a[0]);for(let h=1;h<a.length;h++)t=this.S(t,a[h])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===P.$UB)return;const n=this.G(i),a=this.G(i+r),t=n.node,h=a.node;if(t===h){const I=this.s(t,n.remainder),b=this.s(t,a.remainder);if(n.nodeStartOffset===i){if(r===t.piece.length){const m=t.next();(0,P.$ZB)(this,t),this.N(m),this.y();return}this.D(t,b),this.h.validate(i),this.N(t),this.y();return}if(n.nodeStartOffset+t.piece.length===i+r){this.C(t,I),this.O(t),this.y();return}this.E(t,I,b),this.y();return}const s=[],d=this.s(t,n.remainder);this.C(t,d),this.h.validate(i),t.piece.length===0&&s.push(t);const l=this.s(h,a.remainder);this.D(h,l),h.piece.length===0&&s.push(h);const u=t.next();for(let I=u;I!==P.$UB&&I!==h;I=I.next())s.push(I);const w=t.piece.length===0?t.prev():t;this.v(s),this.O(w),this.y()}o(i,r){const n=[];if(this.K()&&this.M(i)&&this.L(r)){const h=r.piece,s={line:h.start.line+1,column:0},d=new p(h.bufferIndex,s,h.end,this.t(h.bufferIndex,s,h.end),h.length-1);r.piece=d,i+=`
`,(0,P.$2B)(this,r,-1,-1),r.piece.length===0&&n.push(r)}const a=this.w(i);let t=this.T(r,a[a.length-1]);for(let h=a.length-2;h>=0;h--)t=this.T(t,a[h]);this.N(t),this.v(n)}q(i,r){this.Q(i,r)&&(i+=`
`);const n=this.w(i),a=this.S(r,n[0]);let t=a;for(let h=1;h<n.length;h++)t=this.S(t,n[h]);this.N(a)}s(i,r,n){const a=i.piece,t=i.piece.bufferIndex,h=this.a[t].lineStarts,d=h[a.start.line]+a.start.column+r;let l=a.start.line,u=a.end.line,w=0,I=0,b=0;for(;l<=u&&(w=l+(u-l)/2|0,b=h[w],w!==u);)if(I=h[w+1],d<b)u=w-1;else if(d>=I)l=w+1;else break;return n?(n.line=w,n.column=d-b,null):{line:w,column:d-b}}t(i,r,n){if(n.column===0)return n.line-r.line;const a=this.a[i].lineStarts;if(n.line===a.length-1)return n.line-r.line;const t=a[n.line+1],h=a[n.line]+n.column;if(t>h+1)return n.line-r.line;const s=h-1;return this.a[i].buffer.charCodeAt(s)===13?n.line-r.line+1:n.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,P.$ZB)(this,i[r])}w(i){if(i.length>v){const u=[];for(;i.length>v;){const I=i.charCodeAt(v-1);let b;I===13||I>=55296&&I<=56319?(b=i.substring(0,v-1),i=i.substring(v-1)):(b=i.substring(0,v),i=i.substring(v));const m=R(b);u.push(new p(this.a.length,{line:0,column:0},{line:m.length-1,column:b.length-m[m.length-1]},m.length-1,b.length)),this.a.push(new k(b,m))}const w=R(i);return u.push(new p(this.a.length,{line:0,column:0},{line:w.length-1,column:i.length-w[w.length-1]},w.length-1,i.length)),this.a.push(new k(i,w)),u}let r=this.a[0].buffer.length;const n=R(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let u=0;u<n.length;u++)n[u]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let u=0;u<n.length;u++)n[u]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,h=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[h],d={line:h,column:s},l=new p(0,a,d,this.t(0,a,d),t-r);return this.g=d,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let n=this.root,a="";const t=this.h.get2(i);if(t){n=t.node;const h=this.B(n,i-t.nodeStartLineNumber-1),s=this.a[n.piece.bufferIndex].buffer,d=this.u(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)a=s.substring(d+h,d+n.piece.length);else{const l=this.B(n,i-t.nodeStartLineNumber);return s.substring(d+h,d+l-r)}}else{let h=0;const s=i;for(;n!==P.$UB;)if(n.left!==P.$UB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const d=this.B(n,i-n.lf_left-2),l=this.B(n,i-n.lf_left-1),u=this.a[n.piece.bufferIndex].buffer,w=this.u(n.piece.bufferIndex,n.piece.start);return h+=n.size_left,this.h.set({node:n,nodeStartOffset:h,nodeStartLineNumber:s-(i-1-n.lf_left)}),u.substring(w+d,w+l-r)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const d=this.B(n,i-n.lf_left-2),l=this.a[n.piece.bufferIndex].buffer,u=this.u(n.piece.bufferIndex,n.piece.start);a=l.substring(u+d,u+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,h+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==P.$UB;){const h=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.B(n,0),d=this.u(n.piece.bufferIndex,n.piece.start);return a+=h.substring(d,d+s-r),a}else{const s=this.u(n.piece.bufferIndex,n.piece.start);a+=h.substr(s,n.piece.length)}n=n.next()}return a}y(){let i=this.root,r=1,n=0;for(;i!==P.$UB;)r+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=n,this.h.validate(this.c)}A(i,r){const n=i.piece,a=this.s(i,r),t=a.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===r){const h=this.t(i.piece.bufferIndex,n.start,a);if(h!==t)return{index:h,remainder:0}}return{index:t,remainder:a.column}}B(i,r){if(r<0)return 0;const n=i.piece,a=this.a[n.bufferIndex].lineStarts,t=n.start.line+r+1;return t>n.end.line?a[n.end.line]+n.end.column-a[n.start.line]-n.start.column:a[t]-a[n.start.line]-n.start.column}C(i,r){const n=i.piece,a=n.lineFeedCnt,t=this.u(n.bufferIndex,n.end),h=r,s=this.u(n.bufferIndex,h),d=this.t(n.bufferIndex,n.start,h),l=d-a,u=s-t,w=n.length+u;i.piece=new p(n.bufferIndex,n.start,h,d,w),(0,P.$2B)(this,i,u,l)}D(i,r){const n=i.piece,a=n.lineFeedCnt,t=this.u(n.bufferIndex,n.start),h=r,s=this.t(n.bufferIndex,h,n.end),d=this.u(n.bufferIndex,h),l=s-a,u=t-d,w=n.length+u;i.piece=new p(n.bufferIndex,h,n.end,s,w),(0,P.$2B)(this,i,u,l)}E(i,r,n){const a=i.piece,t=a.start,h=a.end,s=a.length,d=a.lineFeedCnt,l=r,u=this.t(a.bufferIndex,a.start,l),w=this.u(a.bufferIndex,r)-this.u(a.bufferIndex,t);i.piece=new p(a.bufferIndex,a.start,l,u,w),(0,P.$2B)(this,i,w-s,u-d);const I=new p(a.bufferIndex,n,h,this.t(a.bufferIndex,n,h),this.u(a.bufferIndex,h)-this.u(a.bufferIndex,n)),b=this.S(i,I);this.N(b)}F(i,r){this.Q(r,i)&&(r+=`
`);const n=this.K()&&this.L(r)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=r;const t=R(r,!1);for(let b=0;b<t.length;b++)t[b]+=a;if(n){const b=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-b}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const h=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[h],d={line:h,column:s},l=i.piece.length+r.length,u=i.piece.lineFeedCnt,w=this.t(0,i.piece.start,d),I=w-u;i.piece=new p(i.piece.bufferIndex,i.piece.start,d,w,l),this.g=d,(0,P.$2B)(this,i,r.length,I)}G(i){let r=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let a=0;for(;r!==P.$UB;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){a+=r.size_left;const t={node:r,remainder:i-r.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=r.size_left+r.piece.length,a+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let n=this.root,a=0;for(;n!==P.$UB;)if(n.left!==P.$UB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.B(n,i-n.lf_left-2),h=this.B(n,i-n.lf_left-1);return a+=n.size_left,{node:n,remainder:Math.min(t+r-1,h),nodeStartOffset:a}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.B(n,i-n.lf_left-2);if(t+r-1<=n.piece.length)return{node:n,remainder:t+r-1,nodeStartOffset:a};r-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==P.$UB;){if(n.piece.lineFeedCnt>0){const t=this.B(n,0),h=this.J(n);return{node:n,remainder:Math.min(r-1,t),nodeStartOffset:h}}else if(n.piece.length>=r-1){const t=this.J(n);return{node:n,remainder:r-1,nodeStartOffset:t}}else r-=n.piece.length;n=n.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+r;return n.buffer.charCodeAt(a)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===P.$UB||i.piece.lineFeedCnt===0)return!1;const r=i.piece,n=this.a[r.bufferIndex].lineStarts,a=r.start.line,t=n[a]+r.start.column;return a===n.length-1||n[a+1]>t+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===P.$UB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const n=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const h=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new p(i.piece.bufferIndex,i.piece.start,t,s,h),(0,P.$2B)(this,i,-1,-1),i.piece.length===0&&n.push(i);const d={line:r.piece.start.line+1,column:0},l=r.piece.length-1,u=this.t(r.piece.bufferIndex,d,r.piece.end);r.piece=new p(r.piece.bufferIndex,d,r.piece.end,u,l),(0,P.$2B)(this,r,-1,-1),r.piece.length===0&&n.push(r);const w=this.w(`\r
`);this.S(i,w[0]);for(let I=0;I<n.length;I++)(0,P.$ZB)(this,n[I])}Q(i,r){if(this.K()&&this.M(i)){const n=r.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,P.$ZB)(this,n);else{const a=n.piece,t={line:a.start.line+1,column:0},h=a.length-1,s=this.t(a.bufferIndex,t,a.end);n.piece=new p(a.bufferIndex,t,a.end,s,h),(0,P.$2B)(this,n,-1,-1)}return!0}}return!1}iterate(i,r){if(i===P.$UB)return r(P.$UB);const n=this.iterate(i.left,r);return n&&r(i)&&this.iterate(i.right,r)}R(i){if(i===P.$UB)return"";const r=this.a[i.piece.bufferIndex],n=i.piece,a=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return r.buffer.substring(a,t)}getPieceContent(i){const r=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return r.buffer.substring(n,a)}S(i,r){const n=new P.$TB(r,1);if(n.left=P.$UB,n.right=P.$UB,n.parent=P.$UB,n.size_left=0,n.lf_left=0,this.root===P.$UB)this.root=n,n.color=0;else if(i.right===P.$UB)i.right=n,n.parent=i;else{const t=(0,P.$VB)(i.right);t.left=n,n.parent=t}return(0,P.$1B)(this,n),n}T(i,r){const n=new P.$TB(r,1);if(n.left=P.$UB,n.right=P.$UB,n.parent=P.$UB,n.size_left=0,n.lf_left=0,this.root===P.$UB)this.root=n,n.color=0;else if(i.left===P.$UB)i.left=n,n.parent=i;else{const a=(0,P.$WB)(i.left);a.right=n,n.parent=a}return(0,P.$1B)(this,n),n}U(i){let r="";return this.iterate(i,n=>(r+=this.R(n),!0)),r}}e.$bC=g}),define(Ee[177],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y8=e.$x8=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const A=this.a.get(P);return this.a.delete(P),A}}addDragOperationTransfer(P,A){this.a.set(P,A)}}e.$x8=C;class F{constructor(P){this.identifier=P}}e.$y8=F}),define(Ee[178],Se([1,0,4,3]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Wd,this.onDidChange=this.c.event,this.d=null}handleChange(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,$){return this.a.set(v,$),this.handleChange([v]),(0,F.$Rc)(()=>{this.a.get(v)===$&&(this.a.delete(v),this.handleChange([v]))})}get(v){return this.a.get(v)||null}registerFactory(v,$){this.b.get(v)?.dispose();const E=new P(this,v,$);return this.b.set(v,E),(0,F.$Rc)(()=>{const R=this.b.get(v);!R||R!==E||(this.b.delete(v),R.dispose())})}async getOrCreate(v){const $=this.get(v);if($)return $;const E=this.b.get(v);return!E||E.isResolved?null:(await E.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const E=this.b.get(v);return!!(!E||E.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ut=f;class P extends F.$Tc{get isResolved(){return this.c}constructor(v,$,E){super(),this.f=v,this.g=$,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const v=await this.h.tokenizationSupport;this.c=!0,v&&!this.a&&this.B(this.f.register(this.g,v))}}}),define(Ee[179],Se([8,9]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Ee[180],Se([1,0,4,3,179]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=void 0;class P extends F.$Tc{constructor(p,k="",S="",c=!0,g){super(),this.h=this.B(new C.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=k,this.u=S,this.w=c,this.C=g}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,k){this.C&&await this.C(p)}}e.$Li=P;class A extends F.$Tc{constructor(){super(...arguments),this.f=this.B(new C.$Wd),this.onWillRun=this.f.event,this.m=this.B(new C.$Wd),this.onDidRun=this.m.event}async run(p,k){if(!p.enabled)return;this.f.fire({action:p});let S;try{await this.u(p,k)}catch(c){S=c}this.m.fire({action:p,error:S})}async u(p,k){await p.run(k)}}e.$Mi=A;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let k=[];for(const S of p)S.length&&(k.length?k=[...k,new v,...S]:k=S);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$Ni=v;class ${get actions(){return this.a}constructor(p,k,S,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=k,this.class=c,this.a=S}async run(){}}e.$Oi=$;class E extends P{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,f.localize(0,null),void 0,!1)}}e.$Pi=E;function R(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...p)=>D.run(...p),tooltip:D.label}}e.$Qi=R}),define(Ee[181],Se([8,9]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Ee[182],Se([1,0,181]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=void 0;const F=60,f=F*60,P=f*24,A=P*7,v=P*30,$=P*365;function E(D,p,k,S){typeof D!="number"&&(D=D.getTime());const c=Math.round((new Date().getTime()-D)/1e3);if(c<-30)return(0,C.localize)(0,null,E(new Date().getTime()+c*1e3,!1));if(!S&&c<30)return(0,C.localize)(1,null);let g;return c<F?(g=c,p?g===1?k?(0,C.localize)(2,null,g):(0,C.localize)(3,null,g):k?(0,C.localize)(4,null,g):(0,C.localize)(5,null,g):g===1?k?(0,C.localize)(6,null,g):(0,C.localize)(7,null,g):k?(0,C.localize)(8,null,g):(0,C.localize)(9,null,g)):c<f?(g=Math.floor(c/F),p?g===1?k?(0,C.localize)(10,null,g):(0,C.localize)(11,null,g):k?(0,C.localize)(12,null,g):(0,C.localize)(13,null,g):g===1?k?(0,C.localize)(14,null,g):(0,C.localize)(15,null,g):k?(0,C.localize)(16,null,g):(0,C.localize)(17,null,g)):c<P?(g=Math.floor(c/f),p?g===1?k?(0,C.localize)(18,null,g):(0,C.localize)(19,null,g):k?(0,C.localize)(20,null,g):(0,C.localize)(21,null,g):g===1?k?(0,C.localize)(22,null,g):(0,C.localize)(23,null,g):k?(0,C.localize)(24,null,g):(0,C.localize)(25,null,g)):c<A?(g=Math.floor(c/P),p?g===1?(0,C.localize)(26,null,g):(0,C.localize)(27,null,g):g===1?(0,C.localize)(28,null,g):(0,C.localize)(29,null,g)):c<v?(g=Math.floor(c/A),p?g===1?k?(0,C.localize)(30,null,g):(0,C.localize)(31,null,g):k?(0,C.localize)(32,null,g):(0,C.localize)(33,null,g):g===1?k?(0,C.localize)(34,null,g):(0,C.localize)(35,null,g):k?(0,C.localize)(36,null,g):(0,C.localize)(37,null,g)):c<$?(g=Math.floor(c/v),p?g===1?k?(0,C.localize)(38,null,g):(0,C.localize)(39,null,g):k?(0,C.localize)(40,null,g):(0,C.localize)(41,null,g):g===1?k?(0,C.localize)(42,null,g):(0,C.localize)(43,null,g):k?(0,C.localize)(44,null,g):(0,C.localize)(45,null,g)):(g=Math.floor(c/$),p?g===1?k?(0,C.localize)(46,null,g):(0,C.localize)(47,null,g):k?(0,C.localize)(48,null,g):(0,C.localize)(49,null,g):g===1?k?(0,C.localize)(50,null,g):(0,C.localize)(51,null,g):k?(0,C.localize)(52,null,g):(0,C.localize)(53,null,g))}e.$wm=E;function R(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$xm=R}),define(Ee[183],Se([8,9]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Ee[44],Se([1,0,19,18,183]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Si=e.$Ri=void 0;function P(D,p){return p&&(D.stack||D.stacktrace)?f.localize(0,null,v(D),A(D.stack)||A(D.stacktrace)):v(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function v(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?f.localize(1,null,D.message):D.message||f.localize(2,null)}function $(D=null,p=!1){if(!D)return f.localize(3,null);if(Array.isArray(D)){const k=C.$Hb(D),S=$(k[0],p);return k.length>1?f.localize(4,null,S,k.length):S}if(F.$Jf(D))return D;if(D.detail){const k=D.detail;if(k.error)return P(k.error,p);if(k.exception)return P(k.exception,p)}return D.stack?P(D,p):D.message?D.message:f.localize(5,null)}e.$Ri=$;function E(D){const p=D;return p instanceof Error&&Array.isArray(p.actions)}e.$Si=E;function R(D,p){let k;return typeof D=="string"?k=new Error(D):k=D,k.actions=p,k}e.$Ti=R}),define(Ee[184],Se([8,9]),function(ge,e){return ge.create("vs/base/common/platform",e)}),define(Ee[10],Se([1,0,184]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let F=!1,f=!1,P=!1,A=!1,v=!1,$=!1,E=!1,R=!1,D=!1,p=!1,k,S=e.$g,c=e.$g,g,o;const i=globalThis;let r;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?r=i.vscode.process:typeof process<"u"&&(r=process);const n=typeof r?.versions?.electron=="string",a=n&&r?.type==="renderer";if(typeof r=="object"){F=r.platform==="win32",f=r.platform==="darwin",P=r.platform==="linux",A=P&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,E=n,D=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$g,S=e.$g;const m=r.env.VSCODE_NLS_CONFIG;if(m)try{const y=JSON.parse(m),L=y.availableLanguages["*"];k=y.locale,c=y.osLocale,S=L||e.$g,g=y._translationsConfigFile}catch{}v=!0}else typeof navigator=="object"&&!a?(o=navigator.userAgent,F=o.indexOf("Windows")>=0,f=o.indexOf("Macintosh")>=0,R=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=o.indexOf("Linux")>=0,p=o?.indexOf("Mobi")>=0,$=!0,k=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,S=k,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(t||(e.Platform=t={}));function h(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=h;let s=0;f?s=1:F?s=3:P&&(s=2),e.$i=F,e.$j=f,e.$k=P,e.$l=A,e.$m=v,e.$n=E,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=R,e.$s=p,e.$t=D,e.$u=s,e.$v=o,e.$w=S;var d;(function(m){function y(){return e.$w}m.value=y;function L(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}m.isDefaultVariant=L;function N(){return e.$w==="en"}m.isDefault=N})(d||(e.Language=d={})),e.$x=k,e.$y=c,e.$z=g,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const m=[];i.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let N=0,U=m.length;N<U;N++){const T=m[N];if(T.id===L.data.vscodeScheduleAsyncWork){m.splice(N,1),T.callback();return}}});let y=0;return L=>{const N=++y;m.push({id:N,callback:L}),i.postMessage({vscodeScheduleAsyncWork:N},"*")}}return m=>setTimeout(m)})();var l;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=f||R?2:F?1:3;let u=!0,w=!1;function I(){if(!w){w=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,u=new Uint16Array(m.buffer)[0]===(2<<8)+1}return u}e.$D=I,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function b(m){return parseFloat(m)>=20}e.$J=b}),define(Ee[49],Se([1,0,10]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.process<"u"){const P=f.process;F={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return C.$i?"win32":C.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$dc=F.platform,e.$ec=F.arch}),define(Ee[17],Se([1,0,49]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const F=65,f=97,P=90,A=122,v=46,$=47,E=92,R=58,D=63;class p extends Error{constructor(h,s,d){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const u=h.indexOf(".")!==-1?"property":"argument";let w=`The "${h}" ${u} ${l} of type ${s}`;w+=`. Received type ${typeof d}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,h){if(t===null||typeof t!="object")throw new p(h,"Object",t)}function S(t,h){if(typeof t!="string")throw new p(h,"string",t)}const c=C.$dc==="win32";function g(t){return t===$||t===E}function o(t){return t===$}function i(t){return t>=F&&t<=P||t>=f&&t<=A}function r(t,h,s,d){let l="",u=0,w=-1,I=0,b=0;for(let m=0;m<=t.length;++m){if(m<t.length)b=t.charCodeAt(m);else{if(d(b))break;b=$}if(d(b)){if(!(w===m-1||I===1))if(I===2){if(l.length<2||u!==2||l.charCodeAt(l.length-1)!==v||l.charCodeAt(l.length-2)!==v){if(l.length>2){const y=l.lastIndexOf(s);y===-1?(l="",u=0):(l=l.slice(0,y),u=l.length-1-l.lastIndexOf(s)),w=m,I=0;continue}else if(l.length!==0){l="",u=0,w=m,I=0;continue}}h&&(l+=l.length>0?`${s}..`:"..",u=2)}else l.length>0?l+=`${s}${t.slice(w+1,m)}`:l=t.slice(w+1,m),u=m-w-1;w=m,I=0}else b===v&&I!==-1?++I:I=-1}return l}function n(t,h){k(h,"pathObject");const s=h.dir||h.root,d=h.base||`${h.name||""}${h.ext||""}`;return s?s===h.root?`${s}${d}`:`${s}${t}${d}`:d}e.$fc={resolve(...t){let h="",s="",d=!1;for(let l=t.length-1;l>=-1;l--){let u;if(l>=0){if(u=t[l],S(u,"path"),u.length===0)continue}else h.length===0?u=C.cwd():(u=C.env[`=${h}`]||C.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==h.toLowerCase()&&u.charCodeAt(2)===E)&&(u=`${h}\\`));const w=u.length;let I=0,b="",m=!1;const y=u.charCodeAt(0);if(w===1)g(y)&&(I=1,m=!0);else if(g(y))if(m=!0,g(u.charCodeAt(1))){let L=2,N=L;for(;L<w&&!g(u.charCodeAt(L));)L++;if(L<w&&L!==N){const U=u.slice(N,L);for(N=L;L<w&&g(u.charCodeAt(L));)L++;if(L<w&&L!==N){for(N=L;L<w&&!g(u.charCodeAt(L));)L++;(L===w||L!==N)&&(b=`\\\\${U}\\${u.slice(N,L)}`,I=L)}}}else I=1;else i(y)&&u.charCodeAt(1)===R&&(b=u.slice(0,2),I=2,w>2&&g(u.charCodeAt(2))&&(m=!0,I=3));if(b.length>0)if(h.length>0){if(b.toLowerCase()!==h.toLowerCase())continue}else h=b;if(d){if(h.length>0)break}else if(s=`${u.slice(I)}\\${s}`,d=m,m&&h.length>0)break}return s=r(s,!d,"\\",g),d?`${h}\\${s}`:`${h}${s}`||"."},normalize(t){S(t,"path");const h=t.length;if(h===0)return".";let s=0,d,l=!1;const u=t.charCodeAt(0);if(h===1)return o(u)?"\\":t;if(g(u))if(l=!0,g(t.charCodeAt(1))){let I=2,b=I;for(;I<h&&!g(t.charCodeAt(I));)I++;if(I<h&&I!==b){const m=t.slice(b,I);for(b=I;I<h&&g(t.charCodeAt(I));)I++;if(I<h&&I!==b){for(b=I;I<h&&!g(t.charCodeAt(I));)I++;if(I===h)return`\\\\${m}\\${t.slice(b)}\\`;I!==b&&(d=`\\\\${m}\\${t.slice(b,I)}`,s=I)}}}else s=1;else i(u)&&t.charCodeAt(1)===R&&(d=t.slice(0,2),s=2,h>2&&g(t.charCodeAt(2))&&(l=!0,s=3));let w=s<h?r(t.slice(s),!l,"\\",g):"";return w.length===0&&!l&&(w="."),w.length>0&&g(t.charCodeAt(h-1))&&(w+="\\"),d===void 0?l?`\\${w}`:w:l?`${d}\\${w}`:`${d}${w}`},isAbsolute(t){S(t,"path");const h=t.length;if(h===0)return!1;const s=t.charCodeAt(0);return g(s)||h>2&&i(s)&&t.charCodeAt(1)===R&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let h,s;for(let u=0;u<t.length;++u){const w=t[u];S(w,"path"),w.length>0&&(h===void 0?h=s=w:h+=`\\${w}`)}if(h===void 0)return".";let d=!0,l=0;if(typeof s=="string"&&g(s.charCodeAt(0))){++l;const u=s.length;u>1&&g(s.charCodeAt(1))&&(++l,u>2&&(g(s.charCodeAt(2))?++l:d=!1))}if(d){for(;l<h.length&&g(h.charCodeAt(l));)l++;l>=2&&(h=`\\${h.slice(l)}`)}return e.$fc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h)return"";const s=e.$fc.resolve(t),d=e.$fc.resolve(h);if(s===d||(t=s.toLowerCase(),h=d.toLowerCase(),t===h))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===E;)l++;let u=t.length;for(;u-1>l&&t.charCodeAt(u-1)===E;)u--;const w=u-l;let I=0;for(;I<h.length&&h.charCodeAt(I)===E;)I++;let b=h.length;for(;b-1>I&&h.charCodeAt(b-1)===E;)b--;const m=b-I,y=w<m?w:m;let L=-1,N=0;for(;N<y;N++){const T=t.charCodeAt(l+N);if(T!==h.charCodeAt(I+N))break;T===E&&(L=N)}if(N!==y){if(L===-1)return d}else{if(m>y){if(h.charCodeAt(I+N)===E)return d.slice(I+N+1);if(N===2)return d.slice(I+N)}w>y&&(t.charCodeAt(l+N)===E?L=N:N===2&&(L=3)),L===-1&&(L=0)}let U="";for(N=l+L+1;N<=u;++N)(N===u||t.charCodeAt(N)===E)&&(U+=U.length===0?"..":"\\..");return I+=L,U.length>0?`${U}${d.slice(I,b)}`:(d.charCodeAt(I)===E&&++I,d.slice(I,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const h=e.$fc.resolve(t);if(h.length<=2)return t;if(h.charCodeAt(0)===E){if(h.charCodeAt(1)===E){const s=h.charCodeAt(2);if(s!==D&&s!==v)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(i(h.charCodeAt(0))&&h.charCodeAt(1)===R&&h.charCodeAt(2)===E)return`\\\\?\\${h}`;return t},dirname(t){S(t,"path");const h=t.length;if(h===0)return".";let s=-1,d=0;const l=t.charCodeAt(0);if(h===1)return g(l)?t:".";if(g(l)){if(s=d=1,g(t.charCodeAt(1))){let I=2,b=I;for(;I<h&&!g(t.charCodeAt(I));)I++;if(I<h&&I!==b){for(b=I;I<h&&g(t.charCodeAt(I));)I++;if(I<h&&I!==b){for(b=I;I<h&&!g(t.charCodeAt(I));)I++;if(I===h)return t;I!==b&&(s=d=I+1)}}}}else i(l)&&t.charCodeAt(1)===R&&(s=h>2&&g(t.charCodeAt(2))?3:2,d=s);let u=-1,w=!0;for(let I=h-1;I>=d;--I)if(g(t.charCodeAt(I))){if(!w){u=I;break}}else w=!1;if(u===-1){if(s===-1)return".";u=s}return t.slice(0,u)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let s=0,d=-1,l=!0,u;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(s=2),h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let w=h.length-1,I=-1;for(u=t.length-1;u>=s;--u){const b=t.charCodeAt(u);if(g(b)){if(!l){s=u+1;break}}else I===-1&&(l=!1,I=u+1),w>=0&&(b===h.charCodeAt(w)?--w===-1&&(d=u):(w=-1,d=I))}return s===d?d=I:d===-1&&(d=t.length),t.slice(s,d)}for(u=t.length-1;u>=s;--u)if(g(t.charCodeAt(u))){if(!l){s=u+1;break}}else d===-1&&(l=!1,d=u+1);return d===-1?"":t.slice(s,d)},extname(t){S(t,"path");let h=0,s=-1,d=0,l=-1,u=!0,w=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(h=d=2);for(let I=t.length-1;I>=h;--I){const b=t.charCodeAt(I);if(g(b)){if(!u){d=I+1;break}continue}l===-1&&(u=!1,l=I+1),b===v?s===-1?s=I:w!==1&&(w=1):s!==-1&&(w=-1)}return s===-1||l===-1||w===0||w===1&&s===l-1&&s===d+1?"":t.slice(s,l)},format:n.bind(null,"\\"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.length;let d=0,l=t.charCodeAt(0);if(s===1)return g(l)?(h.root=h.dir=t,h):(h.base=h.name=t,h);if(g(l)){if(d=1,g(t.charCodeAt(1))){let L=2,N=L;for(;L<s&&!g(t.charCodeAt(L));)L++;if(L<s&&L!==N){for(N=L;L<s&&g(t.charCodeAt(L));)L++;if(L<s&&L!==N){for(N=L;L<s&&!g(t.charCodeAt(L));)L++;L===s?d=L:L!==N&&(d=L+1)}}}}else if(i(l)&&t.charCodeAt(1)===R){if(s<=2)return h.root=h.dir=t,h;if(d=2,g(t.charCodeAt(2))){if(s===3)return h.root=h.dir=t,h;d=3}}d>0&&(h.root=t.slice(0,d));let u=-1,w=d,I=-1,b=!0,m=t.length-1,y=0;for(;m>=d;--m){if(l=t.charCodeAt(m),g(l)){if(!b){w=m+1;break}continue}I===-1&&(b=!1,I=m+1),l===v?u===-1?u=m:y!==1&&(y=1):u!==-1&&(y=-1)}return I!==-1&&(u===-1||y===0||y===1&&u===I-1&&u===w+1?h.base=h.name=t.slice(w,I):(h.name=t.slice(w,u),h.base=t.slice(w,I),h.ext=t.slice(u,I))),w>0&&w!==d?h.dir=t.slice(0,w-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(c){const t=/\\/g;return()=>{const h=C.cwd().replace(t,"/");return h.slice(h.indexOf("/"))}}return()=>C.cwd()})();e.$gc={resolve(...t){let h="",s=!1;for(let d=t.length-1;d>=-1&&!s;d--){const l=d>=0?t[d]:a();S(l,"path"),l.length!==0&&(h=`${l}/${h}`,s=l.charCodeAt(0)===$)}return h=r(h,!s,"/",o),s?`/${h}`:h.length>0?h:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$,s=t.charCodeAt(t.length-1)===$;return t=r(t,!h,"/",o),t.length===0?h?"/":s?"./":".":(s&&(t+="/"),h?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let h;for(let s=0;s<t.length;++s){const d=t[s];S(d,"path"),d.length>0&&(h===void 0?h=d:h+=`/${d}`)}return h===void 0?".":e.$gc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h||(t=e.$gc.resolve(t),h=e.$gc.resolve(h),t===h))return"";const s=1,d=t.length,l=d-s,u=1,w=h.length-u,I=l<w?l:w;let b=-1,m=0;for(;m<I;m++){const L=t.charCodeAt(s+m);if(L!==h.charCodeAt(u+m))break;L===$&&(b=m)}if(m===I)if(w>I){if(h.charCodeAt(u+m)===$)return h.slice(u+m+1);if(m===0)return h.slice(u+m)}else l>I&&(t.charCodeAt(s+m)===$?b=m:m===0&&(b=0));let y="";for(m=s+b+1;m<=d;++m)(m===d||t.charCodeAt(m)===$)&&(y+=y.length===0?"..":"/..");return`${y}${h.slice(u+b)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$;let s=-1,d=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===$){if(!d){s=l;break}}else d=!1;return s===-1?h?"/":".":h&&s===1?"//":t.slice(0,s)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let s=0,d=-1,l=!0,u;if(h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let w=h.length-1,I=-1;for(u=t.length-1;u>=0;--u){const b=t.charCodeAt(u);if(b===$){if(!l){s=u+1;break}}else I===-1&&(l=!1,I=u+1),w>=0&&(b===h.charCodeAt(w)?--w===-1&&(d=u):(w=-1,d=I))}return s===d?d=I:d===-1&&(d=t.length),t.slice(s,d)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===$){if(!l){s=u+1;break}}else d===-1&&(l=!1,d=u+1);return d===-1?"":t.slice(s,d)},extname(t){S(t,"path");let h=-1,s=0,d=-1,l=!0,u=0;for(let w=t.length-1;w>=0;--w){const I=t.charCodeAt(w);if(I===$){if(!l){s=w+1;break}continue}d===-1&&(l=!1,d=w+1),I===v?h===-1?h=w:u!==1&&(u=1):h!==-1&&(u=-1)}return h===-1||d===-1||u===0||u===1&&h===d-1&&h===s+1?"":t.slice(h,d)},format:n.bind(null,"/"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.charCodeAt(0)===$;let d;s?(h.root="/",d=1):d=0;let l=-1,u=0,w=-1,I=!0,b=t.length-1,m=0;for(;b>=d;--b){const y=t.charCodeAt(b);if(y===$){if(!I){u=b+1;break}continue}w===-1&&(I=!1,w=b+1),y===v?l===-1?l=b:m!==1&&(m=1):l!==-1&&(m=-1)}if(w!==-1){const y=u===0&&s?1:u;l===-1||m===0||m===1&&l===w-1&&l===u+1?h.base=h.name=t.slice(y,w):(h.name=t.slice(y,l),h.base=t.slice(y,w),h.ext=t.slice(l,w))}return u>0?h.dir=t.slice(0,u-1):s&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(Ee[128],Se([1,0,43,17]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=void 0;const f=new C.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),P=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function v(I,b,m=!1){const y=I||"",L=b||"",N=f.value.collator.compare(y,L);return f.value.collatorIsNumeric&&N===0&&y!==L?y<L?-1:1:N}e.$Jq=v;function $(I,b){const m=P.value.collator;return I=I||"",b=b||"",n(m,I,b)}e.$Kq=$;function E(I,b){const m=P.value.collator;return I=I||"",b=b||"",s(I,b)||n(m,I,b)}e.$Lq=E;function R(I,b){const m=P.value.collator;return I=I||"",b=b||"",h(I,b)||n(m,I,b)}e.$Mq=R;function D(I,b){return I=I||"",b=b||"",I===b?0:I<b?-1:1}e.$Nq=D;function p(I,b){const[m,y]=i(I),[L,N]=i(b);let U=f.value.collator.compare(y,N);if(U===0){if(f.value.collatorIsNumeric&&y!==N)return y<N?-1:1;if(U=f.value.collator.compare(m,L),f.value.collatorIsNumeric&&U===0&&m!==L)return m<L?-1:1}return U}e.$Oq=p;function k(I,b){I=I||"",b=b||"";const m=r(I),y=r(b),L=P.value.collator,N=A.value.collator;return n(N,m,y)||n(L,I,b)}e.$Pq=k;function S(I,b){I=I||"",b=b||"";const m=r(I),y=r(b),L=P.value.collator,N=A.value.collator;return n(N,m,y)||s(I,b)||n(L,I,b)}e.$Qq=S;function c(I,b){I=I||"",b=b||"";const m=r(I),y=r(b),L=P.value.collator,N=A.value.collator;return n(N,m,y)||h(I,b)||n(L,I,b)}e.$Rq=c;function g(I,b){I=I||"",b=b||"";const m=r(I).toLowerCase(),y=r(b).toLowerCase();return m!==y?m<y?-1:1:I!==b?I<b?-1:1:0}e.$Sq=g;const o=/^(.*?)(\.([^.]*))?$/;function i(I,b=!1){const m=I?o.exec(I):[];let y=[m&&m[1]||"",m&&m[3]||""];return b&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function r(I){const b=I?o.exec(I):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function n(I,b,m){const y=I.compare(b,m);return y!==0?y:b.length!==m.length?b.length<m.length?-1:1:0}function a(I){const b=I.charAt(0);return b.toLocaleUpperCase()!==b}function t(I){const b=I.charAt(0);return b.toLocaleLowerCase()!==b}function h(I,b){return a(I)&&t(b)?-1:t(I)&&a(b)?1:0}function s(I,b){return t(I)&&a(b)?-1:a(I)&&t(b)?1:0}function d(I,b,m=!1){return m||(I=I&&I.toLowerCase(),b=b&&b.toLowerCase()),I===b?0:I<b?-1:1}function l(I,b,m=!1){const y=I.split(F.sep),L=b.split(F.sep),N=y.length-1,U=L.length-1;let T,O;for(let M=0;;M++){if(T=N===M,O=U===M,T&&O)return v(y[M],L[M],m);if(T)return-1;if(O)return 1;const j=d(y[M],L[M],m);if(j!==0)return j}}e.$Tq=l;function u(I,b,m){const y=I.toLowerCase(),L=b.toLowerCase(),N=w(I,b,m);if(N)return N;const U=y.endsWith(m),T=L.endsWith(m);if(U!==T)return U?-1:1;const O=v(y,L);return O!==0?O:y.localeCompare(L)}e.$Uq=u;function w(I,b,m){const y=I.toLowerCase(),L=b.toLowerCase(),N=y.startsWith(m),U=L.startsWith(m);if(N!==U)return N?-1:1;if(N&&U){if(y.length<L.length)return-1;if(y.length>L.length)return 1}return 0}e.$Vq=w}),define(Ee[34],Se([1,0,17,10,12,18]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function A(u){return u===47||u===92}e.$2f=A;function v(u){return u.replace(/[\\/]/g,C.$gc.sep)}e.$3f=v;function $(u){return u.indexOf("/")===-1&&(u=v(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.$4f=$;function E(u,w=C.$gc.sep){if(!u)return"";const I=u.length,b=u.charCodeAt(0);if(A(b)){if(A(u.charCodeAt(1))&&!A(u.charCodeAt(2))){let y=3;const L=y;for(;y<I&&!A(u.charCodeAt(y));y++);if(L!==y&&!A(u.charCodeAt(y+1))){for(y+=1;y<I;y++)if(A(u.charCodeAt(y)))return u.slice(0,y+1).replace(/[\\/]/g,w)}}return w}else if(o(b)&&u.charCodeAt(1)===58)return A(u.charCodeAt(2))?u.slice(0,2)+w:u.slice(0,2);let m=u.indexOf("://");if(m!==-1){for(m+=3;m<I;m++)if(A(u.charCodeAt(m)))return u.slice(0,m+1)}return""}e.$5f=E;function R(u){if(!F.$i||!u||u.length<5)return!1;let w=u.charCodeAt(0);if(w!==92||(w=u.charCodeAt(1),w!==92))return!1;let I=2;const b=I;for(;I<u.length&&(w=u.charCodeAt(I),w!==92);I++);return!(b===I||(w=u.charCodeAt(I+1),isNaN(w)||w===92))}e.$6f=R;const D=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(u,w=F.$i){const I=w?D:p;return!(!u||u.length===0||/^\s+$/.test(u)||(I.lastIndex=0,I.test(u))||w&&k.test(u)||u==="."||u===".."||w&&u[u.length-1]==="."||w&&u.length!==u.trim().length||u.length>255)}e.$7f=S;function c(u,w,I){const b=u===w;return!I||b?b:!u||!w?!1:(0,f.$af)(u,w)}e.$8f=c;function g(u,w,I,b=C.sep){if(u===w)return!0;if(!u||!w||w.length>u.length)return!1;if(I){if(!(0,f.$bf)(u,w))return!1;if(w.length===u.length)return!0;let y=w.length;return w.charAt(w.length-1)===b&&y--,u.charAt(y)===b}return w.charAt(w.length-1)!==b&&(w+=b),u.indexOf(w)===0}e.$9f=g;function o(u){return u>=65&&u<=90||u>=97&&u<=122}e.$0f=o;function i(u,w){return F.$i&&u.endsWith(":")&&(u+=C.sep),(0,C.$ic)(u)||(u=(0,C.$jc)(w,u)),u=(0,C.$hc)(u),F.$i?(u=(0,f.$Ve)(u,C.sep),u.endsWith(":")&&(u+=C.sep)):(u=(0,f.$Ve)(u,C.sep),u||(u=C.sep)),u}e.$$f=i;function r(u){const w=(0,C.$hc)(u);return F.$i?u.length>3?!1:n(w)&&(u.length===2||w.charCodeAt(2)===92):w===C.$gc.sep}e.$_f=r;function n(u,w=F.$i){return w?o(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.$ag=n;function a(u,w=F.$i){return n(u,w)?u[0]:void 0}e.$bg=a;function t(u,w,I){return w.length>u.length?-1:u===w?0:(I&&(u=u.toLowerCase(),w=w.toLowerCase()),u.indexOf(w))}e.$cg=t;function h(u){const w=u.split(":");let I,b,m;for(const y of w){const L=Number(y);(0,P.$Nf)(L)?b===void 0?b=L:m===void 0&&(m=L):I=I?[I,y].join(":"):y}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:b!==void 0?b:void 0,column:m!==void 0?m:b!==void 0?1:void 0}}e.$dg=h;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(u,w,I=8){let b="";for(let y=0;y<I;y++){let L;y===0&&F.$i&&!w&&(I===3||I===4)?L=d:L=s,b+=L.charAt(Math.floor(Math.random()*L.length))}let m;return w?m=`${w}-${b}`:m=b,u?(0,C.$jc)(u,m):m}e.$eg=l}),define(Ee[129],Se([1,0,128,123,54,17,10,12]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=void 0;const $=0,E=[$,[]];function R(z,J,le,Y){if(!z||!J)return E;const Q=z.length,X=J.length;if(Q<X)return E;const ue=z.toLowerCase();return D(J,le,X,z,ue,Q,Y)}e.$Wq=R;function D(z,J,le,Y,Q,X,ue){const ne=[],$e=[];for(let ie=0;ie<le;ie++){const ye=ie*X,de=ye-X,fe=ie>0,_=z[ie],ee=J[ie];for(let G=0;G<X;G++){const x=G>0,me=ye+G,we=me-1,Ae=de+G-1,ve=x?ne[we]:0,Ie=fe&&x?ne[Ae]:0,B=fe&&x?$e[Ae]:0;let Z;!Ie&&fe?Z=0:Z=p(_,ee,Y,Q,G,B),Z&&Ie+Z>=ve&&(ue||fe||Q.startsWith(J,G))?($e[me]=B+1,ne[me]=Ie+Z):($e[me]=$,ne[me]=ve)}}const oe=[];let K=le-1,W=X-1;for(;K>=0&&W>=0;){const ie=K*X+W;$e[ie]===$||(oe.push(W),K--),W--}return[ne[le*X-1],oe.reverse()]}function p(z,J,le,Y,Q,X){let ue=0;if(!k(J,Y[Q]))return ue;if(ue+=1,X>0&&(ue+=X*5),z===le[Q]&&(ue+=1),Q===0)ue+=8;else{const ne=S(le.charCodeAt(Q-1));ne?ue+=ne:(0,F.$Yj)(le.charCodeAt(Q))&&X===0&&(ue+=2)}return ue}function k(z,J){return z===J?!0:z==="/"||z==="\\"?J==="/"||J==="\\":!1}function S(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function g(z,J,le=0,Y=0){const Q=J;return Q.values&&Q.values.length>1?o(z,Q.values,le,Y):i(z,J,le,Y)}e.$Xq=g;function o(z,J,le,Y){let Q=0;const X=[];for(const ue of J){const[ne,$e]=i(z,ue,le,Y);if(typeof ne!="number")return c;Q+=ne,X.push(...$e)}return[Q,I(X)]}function i(z,J,le,Y){const Q=(0,F.$8j)(J.original,J.originalLowercase,le,z,z.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,F.$5j)(Q)]:c}const r=Object.freeze({score:0}),n=1<<18,a=1<<17,t=1<<16;function h(z,J,le,Y){const Q=Y.values?Y.values:[Y];return(0,f.$Ui)({[Y.normalized]:{values:Q.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:z,description:J,allowNonContiguousMatches:le}})}function s(z,J,le,Y,Q){if(!z||!J.normalized)return r;const X=Y.getItemLabel(z);if(!X)return r;const ue=Y.getItemDescription(z),ne=h(X,ue,le,J),$e=Q[ne];if($e)return $e;const oe=d(X,ue,Y.getItemPath(z),J,le);return Q[ne]=oe,oe}e.$Yq=s;function d(z,J,le,Y,Q){const X=!le||!Y.containsPathSeparator;return le&&(A.$k?Y.pathNormalized===le:(0,v.$af)(Y.pathNormalized,le))?{score:n,labelMatch:[{start:0,end:z.length}],descriptionMatch:J?[{start:0,end:J.length}]:void 0}:Y.values&&Y.values.length>1?l(z,J,le,Y.values,X,Q):u(z,J,le,Y,X,Q)}function l(z,J,le,Y,Q,X){let ue=0;const ne=[],$e=[];for(const oe of Y){const{score:K,labelMatch:W,descriptionMatch:ie}=u(z,J,le,oe,Q,X);if(K===$)return r;ue+=K,W&&ne.push(...W),ie&&$e.push(...ie)}return{score:ue,labelMatch:I(ne),descriptionMatch:I($e)}}function u(z,J,le,Y,Q,X){if(Q||!J){const[ue,ne]=R(z,Y.normalized,Y.normalizedLowercase,X&&!Y.expectContiguousMatch);if(ue){const $e=(0,F.$Vj)(Y.normalized,z);let oe;if($e){oe=a;const K=Math.round(Y.normalized.length/z.length*100);oe+=K}else oe=t;return{score:oe+ue,labelMatch:$e||w(ne)}}}if(J){let ue=J;le&&(ue=`${J}${P.sep}`);const ne=ue.length,$e=`${ue}${z}`,[oe,K]=R($e,Y.normalized,Y.normalizedLowercase,X&&!Y.expectContiguousMatch);if(oe){const W=w(K),ie=[],ye=[];return W.forEach(de=>{de.start<ne&&de.end>ne?(ie.push({start:0,end:de.end-ne}),ye.push({start:de.start,end:ne})):de.start>=ne?ie.push({start:de.start-ne,end:de.end-ne}):ye.push(de)}),{score:oe,labelMatch:ie,descriptionMatch:ye}}}return r}function w(z){const J=[];if(!z)return J;let le;for(const Y of z)le&&le.end===Y?le.end+=1:(le={start:Y,end:Y+1},J.push(le));return J}function I(z){const J=z.sort((Q,X)=>Q.start-X.start),le=[];let Y;for(const Q of J)!Y||!b(Y,Q)?(Y=Q,le.push(Q)):(Y.start=Math.min(Y.start,Q.start),Y.end=Math.max(Y.end,Q.end));return le}function b(z,J){return!(z.end<J.start||J.end<z.start)}function m(z,J,le,Y,Q,X){const ue=s(z,le,Y,Q,X),ne=s(J,le,Y,Q,X),$e=ue.score,oe=ne.score;if(($e===n||oe===n)&&$e!==oe)return $e===n?-1:1;if($e>t||oe>t){if($e!==oe)return $e>oe?-1:1;if($e<a&&oe<a){const _=L(ue.labelMatch,ne.labelMatch);if(_!==0)return _}const de=Q.getItemLabel(z)||"",fe=Q.getItemLabel(J)||"";if(de.length!==fe.length)return de.length-fe.length}if($e!==oe)return $e>oe?-1:1;const K=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,W=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(K&&!W)return-1;if(W&&!K)return 1;const ie=y(z,ue,Q),ye=y(J,ne,Q);return ie&&ye&&ie!==ye?ye>ie?-1:1:N(z,J,le,Q)}e.$Zq=m;function y(z,J,le){let Y=-1,Q=-1;if(J.descriptionMatch&&J.descriptionMatch.length?Y=J.descriptionMatch[0].start:J.labelMatch&&J.labelMatch.length&&(Y=J.labelMatch[0].start),J.labelMatch&&J.labelMatch.length){if(Q=J.labelMatch[J.labelMatch.length-1].end,J.descriptionMatch&&J.descriptionMatch.length){const X=le.getItemDescription(z);X&&(Q+=X.length)}}else J.descriptionMatch&&J.descriptionMatch.length&&(Q=J.descriptionMatch[J.descriptionMatch.length-1].end);return Q-Y}function L(z,J){if(!z&&!J||(!z||!z.length)&&(!J||!J.length))return 0;if(!J||!J.length)return-1;if(!z||!z.length)return 1;const le=z[0].start,Q=z[z.length-1].end-le,X=J[0].start,ne=J[J.length-1].end-X;return Q===ne?0:ne<Q?1:-1}function N(z,J,le,Y){const Q=Y.getItemLabel(z)||"",X=Y.getItemLabel(J)||"",ue=Y.getItemDescription(z),ne=Y.getItemDescription(J),$e=Q.length+(ue?ue.length:0),oe=X.length+(ne?ne.length:0);if($e!==oe)return $e-oe;const K=Y.getItemPath(z),W=Y.getItemPath(J);return K&&W&&K.length!==W.length?K.length-W.length:Q!==X?(0,C.$Uq)(Q,X,le.normalized):ue&&ne&&ue!==ne?(0,C.$Uq)(ue,ne,le.normalized):K&&W&&K!==W?(0,C.$Uq)(K,W,le.normalized):0}function U(z){return z.startsWith('"')&&z.endsWith('"')}const T=" ";function O(z){typeof z!="string"&&(z="");const J=z.toLowerCase(),{pathNormalized:le,normalized:Y,normalizedLowercase:Q}=M(z),X=le.indexOf(P.sep)>=0,ue=U(z);let ne;const $e=z.split(T);if($e.length>1)for(const oe of $e){const K=U(oe),{pathNormalized:W,normalized:ie,normalizedLowercase:ye}=M(oe);ie&&(ne||(ne=[]),ne.push({original:oe,originalLowercase:oe.toLowerCase(),pathNormalized:W,normalized:ie,normalizedLowercase:ye,expectContiguousMatch:K}))}return{original:z,originalLowercase:J,pathNormalized:le,normalized:Y,normalizedLowercase:Q,values:ne,containsPathSeparator:X,expectContiguousMatch:ue}}e.$1q=O;function M(z){let J;A.$i?J=z.replace(/\//g,P.sep):J=z.replace(/\\/g,P.sep);const le=(0,v.$Xe)(J).replace(/\s|"/g,"");return{pathNormalized:J,normalized:le,normalizedLowercase:le.toLowerCase()}}function j(z){return Array.isArray(z)?O(z.map(J=>J.original).join(T)):O(z.original)}e.$2q=j}),define(Ee[101],Se([1,0,17]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=e.$js=e.$is=e.$hs=e.$gs=void 0,e.$gs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const D=(0,C.$oc)(R),p=F[D.toLowerCase()];return p!==void 0?p:A(R)}e.$hs=P;function A(R){const D=(0,C.$oc)(R);return f[D.toLowerCase()]}e.$is=A;function v(R){for(const D in f)if(f[D]===R)return D}e.$js=v;const $=/^(.+)\/(.+?)(;.+)?$/;function E(R,D){const p=$.exec(R);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:D?void 0:R}e.$ks=E}),define(Ee[102],Se([1,0,10]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.TerminateResponseCode=e.Source=void 0;var F;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(F||(e.Source=F={}));var f;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function P(v,...$){const E=$.reduce((p,k)=>(p[k]=!0,p),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(p=>!E[p]).forEach(p=>{for(let k=0;k<R.length;k++)if(p.search(R[k])!==-1){delete v[p];break}})}e.$Sl=P;function A(v){v&&(delete v.DEBUG,C.$j&&delete v.DYLD_LIBRARY_PATH,C.$k&&delete v.LD_PRELOAD)}e.$Tl=A}),define(Ee[2],Se([1,0,17,10]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,P=/^\//,A=/^\/\//;function v(d,l){if(!d.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!f.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!P.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(d,l){return!d&&!l?"file":d}function E(d,l){switch(d){case"https":case"http":case"file":l?l[0]!==D&&(l=D+l):l=D;break}return l}const R="",D="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(l){return l instanceof k?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,u,w,I,b,m=!1){typeof l=="object"?(this.scheme=l.scheme||R,this.authority=l.authority||R,this.path=l.path||R,this.query=l.query||R,this.fragment=l.fragment||R):(this.scheme=$(l,m),this.authority=u||R,this.path=E(this.scheme,w||R),this.query=I||R,this.fragment=b||R,v(this,m))}get fsPath(){return n(this,!1)}with(l){if(!l)return this;let{scheme:u,authority:w,path:I,query:b,fragment:m}=l;return u===void 0?u=this.scheme:u===null&&(u=R),w===void 0?w=this.authority:w===null&&(w=R),I===void 0?I=this.path:I===null&&(I=R),b===void 0?b=this.query:b===null&&(b=R),m===void 0?m=this.fragment:m===null&&(m=R),u===this.scheme&&w===this.authority&&I===this.path&&b===this.query&&m===this.fragment?this:new g(u,w,I,b,m)}static parse(l,u=!1){const w=p.exec(l);return w?new g(w[2]||R,s(w[4]||R),s(w[5]||R),s(w[7]||R),s(w[9]||R),u):new g(R,R,R,R,R)}static file(l){let u=R;if(F.$i&&(l=l.replace(/\\/g,D)),l[0]===D&&l[1]===D){const w=l.indexOf(D,2);w===-1?(u=l.substring(2),l=D):(u=l.substring(2,w),l=l.substring(w)||D)}return new g("file",u,l,R,R)}static from(l,u){return new g(l.scheme,l.authority,l.path,l.query,l.fragment,u)}static joinPath(l,...u){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return F.$i&&l.scheme==="file"?w=k.file(C.$fc.join(n(l,!0),...u)).path:w=C.$gc.join(l.path,...u),l.with({path:w})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof k)return l;{const u=new g(l);return u._formatted=l.external??null,u._fsPath=l._sep===c?l.fsPath??null:null,u}}else return l}}e.URI=k;function S(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}e.$vc=S;const c=F.$i?1:void 0;class g extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=c),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(d,l,u){let w,I=-1;for(let b=0;b<d.length;b++){const m=d.charCodeAt(b);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||l&&m===47||u&&m===91||u&&m===93||u&&m===58)I!==-1&&(w+=encodeURIComponent(d.substring(I,b)),I=-1),w!==void 0&&(w+=d.charAt(b));else{w===void 0&&(w=d.substr(0,b));const y=o[m];y!==void 0?(I!==-1&&(w+=encodeURIComponent(d.substring(I,b)),I=-1),w+=y):I===-1&&(I=b)}}return I!==-1&&(w+=encodeURIComponent(d.substring(I))),w!==void 0?w:d}function r(d){let l;for(let u=0;u<d.length;u++){const w=d.charCodeAt(u);w===35||w===63?(l===void 0&&(l=d.substr(0,u)),l+=o[w]):l!==void 0&&(l+=d[u])}return l!==void 0?l:d}function n(d,l){let u;return d.authority&&d.path.length>1&&d.scheme==="file"?u=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?l?u=d.path.substr(1):u=d.path[1].toLowerCase()+d.path.substr(2):u=d.path,F.$i&&(u=u.replace(/\//g,"\\")),u}e.$wc=n;function a(d,l){const u=l?r:i;let w="",{scheme:I,authority:b,path:m,query:y,fragment:L}=d;if(I&&(w+=I,w+=":"),(b||I==="file")&&(w+=D,w+=D),b){let N=b.indexOf("@");if(N!==-1){const U=b.substr(0,N);b=b.substr(N+1),N=U.lastIndexOf(":"),N===-1?w+=u(U,!1,!1):(w+=u(U.substr(0,N),!1,!1),w+=":",w+=u(U.substr(N+1),!1,!0)),w+="@"}b=b.toLowerCase(),N=b.lastIndexOf(":"),N===-1?w+=u(b,!1,!0):(w+=u(b.substr(0,N),!1,!0),w+=b.substr(N))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const N=m.charCodeAt(1);N>=65&&N<=90&&(m=`/${String.fromCharCode(N+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const N=m.charCodeAt(0);N>=65&&N<=90&&(m=`${String.fromCharCode(N+32)}:${m.substr(2)}`)}w+=u(m,!0,!1)}return y&&(w+="?",w+=u(y,!1,!1)),L&&(w+="#",w+=l?L:i(L,!1,!1)),w}function t(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+t(d.substr(3)):d}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(d){return d.match(h)?d.replace(h,l=>t(l)):d}}),define(Ee[185],Se([1,0,2]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$pq=e.$oq=e.$nq=void 0;function F(E){const R=E;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$nq=F;function f(E){const R=[];let D;try{const p=JSON.parse(E.arguments),k=p[p.length-1];k&&k.__$stack&&(p.pop(),D=k.__$stack),R.push(...p)}catch{R.push("Unable to log remote console arguments",E.arguments)}return{args:R,stack:D}}e.$oq=f;function P(E){if(typeof E!="string")return P(f(E).stack);const R=E;if(R){const D=A(R),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(p&&p.length===4)return{uri:C.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$pq=P;function A(E){if(!E)return E;const R=E.indexOf(`
`);return R===-1?E:E.substring(0,R)}function v(E,R){const{args:D,stack:p}=f(E),k=typeof D[0]=="string"&&D.length===1;let S=A(p);S&&(S=`(${S.trim()})`);let c=[];if(typeof D[0]=="string"?S&&k?c=[`%c[${R}] %c${D[0]} %c${S}`,$("blue"),$(""),$("grey")]:c=[`%c[${R}] %c${D[0]}`,$("blue"),$(""),...D.slice(1)]:c=[`%c[${R}]%`,$("blue"),...D],S&&!k&&c.push(S),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,c)}e.log=v;function $(E){return`color: ${E}`}}),define(Ee[56],Se([1,0,22,2]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=void 0;function f($){return JSON.stringify($,A)}e.$Bh=f;function P($){let E=JSON.parse($);return E=v(E),E}e.$Ch=P;function A($,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function v($,E=0){if(!$||E>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return F.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof C.$ke||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let R=0;R<$.length;++R)$[R]=v($[R],E+1);else for(const R in $)Object.hasOwnProperty.call($,R)&&($[R]=v($[R],E+1))}return $}e.$Dh=v}),define(Ee[16],Se([1,0,14,10,12,2]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var A;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function v(p,k){return P.URI.isUri(p)?(0,f.$af)(p.scheme,k):(0,f.$bf)(p,k+":")}e.$fg=v;function $(p,...k){return k.some(S=>v(p,S))}e.$gg=$,e.$hg="vscode-tkn",e.$ig="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${A.vscodeRemoteResource}`}set(k,S,c){this.a[k]=S,this.b[k]=c}setConnectionToken(k,S){this.c[k]=S}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)try{return this.e(k)}catch(r){return C.$1(r),k}const S=k.authority;let c=this.a[S];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const g=this.b[S],o=this.c[S];let i=`path=${encodeURIComponent(k.path)}`;return typeof o=="string"&&(i+=`&${e.$ig}=${encodeURIComponent(o)}`),P.URI.from({scheme:F.$o?this.d:A.vscodeRemoteResource,authority:`${c}:${g}`,path:this.f,query:i})}}e.$jg=new E,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class R{static{this.a=e.$og}asBrowserUri(k){const S=this.b(k,ge);return this.uriToBrowserUri(S)}uriToBrowserUri(k){return k.scheme===A.vscodeRemote?e.$jg.rewrite(k):k.scheme===A.file&&(F.$m||F.$q===`${A.vscodeFileResource}://${R.a}`)?k.with({scheme:A.vscodeFileResource,authority:k.authority||R.a,query:null,fragment:null}):k}asFileUri(k){const S=this.b(k,ge);return this.uriToFileUri(S)}uriToFileUri(k){return k.scheme===A.vscodeFileResource?k.with({scheme:A.file,authority:k.authority!==R.a?k.authority:null,query:null,fragment:null}):k}b(k,S){return P.URI.isUri(k)?k:P.URI.parse(S.toUrl(k))}}e.$pg=new R;var D;(function(p){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(k.get("3"));const S="vscode-coi";function c(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:P.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const r=i?.get(S);if(r)return k.get(r)}p.getHeadersFromQuery=c;function g(o,i,r){if(!globalThis.crossOriginIsolated)return;const n=i&&r?"3":r?"2":"1";o instanceof URLSearchParams?o.set(S,n):o[S]=n}p.addSearchParam=g})(D||(e.COI=D={}))}),define(Ee[186],Se([1,0,157,16,10,2]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=void 0;class A{constructor(p,k,S){this.id=p,this.dependencies=k,this.callback=S}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,k,S)=>{typeof p!="string"&&(S=k,k=p,p=null),(typeof k!="object"||!Array.isArray(k))&&(S=k,k=null),this.c.push(new A(p,k,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const k=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!k)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(p){return new Promise((k,S)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",o),c.removeEventListener("error",i)},o=r=>{g(),k(this.c.pop())},i=r=>{g(),S(r)};c.addEventListener("load",o),c.addEventListener("error",i),this.f&&(p=this.f.createScriptURL(p)),c.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(p){return new Promise((k,S)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),k(this.c.pop())}catch(c){S(c)}})}async j(p){try{const k=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=P.URI.parse(p).fsPath,o=k.readFileSync(g).toString(),i=c.wrap(o.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const $=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function R(D,p,k){if(C.$T){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[D]&&(D=E[D]);const S=`${D}/${p}`;if($.has(S))return $.get(S);let c;if(/^\w[\w\d+.-]*:\/\//.test(S))c=S;else{const r=`${k&&!f.$o?F.$mg:F.$lg}/${S}`;c=F.$pg.asBrowserUri(r).toString(!0)}const g=v.INSTANCE.load(c);return $.set(S,g),g}else return await new Promise((S,c)=>{ge([D],S,c)})}e.$iD=R}),define(Ee[23],Se([1,0,34,16,17,10,12,2]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function $(k){return(0,v.$wc)(k,!0)}e.$wg=$;class E{constructor(S){this.a=S}compare(S,c,g=!1){return S===c?0:(0,A.$6e)(this.getComparisonKey(S,g),this.getComparisonKey(c,g))}isEqual(S,c,g=!1){return S===c?!0:!S||!c?!1:this.getComparisonKey(S,g)===this.getComparisonKey(c,g)}getComparisonKey(S,c=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,c,g=!1){if(S.scheme===c.scheme){if(S.scheme===F.Schemas.file)return C.$9f($(S),$(c),this.a(S))&&S.query===c.query&&(g||S.fragment===c.fragment);if((0,e.$Ng)(S.authority,c.authority))return C.$9f(S.path,c.path,this.a(S),"/")&&S.query===c.query&&(g||S.fragment===c.fragment)}return!1}joinPath(S,...c){return v.URI.joinPath(S,...c)}basenameOrAuthority(S){return(0,e.$Fg)(S)||S.authority}basename(S){return f.$gc.basename(S.path)}extname(S){return f.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let c;return S.scheme===F.Schemas.file?c=v.URI.file(f.$mc($(S))).path:(c=f.$gc.dirname(S.path),S.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),c="/")),S.with({path:c})}normalizePath(S){if(!S.path.length)return S;let c;return S.scheme===F.Schemas.file?c=v.URI.file(f.$hc($(S))).path:c=f.$gc.normalize(S.path),S.with({path:c})}relativePath(S,c){if(S.scheme!==c.scheme||!(0,e.$Ng)(S.authority,c.authority))return;if(S.scheme===F.Schemas.file){const i=f.$lc($(S),$(c));return P.$i?C.$3f(i):i}let g=S.path||"/";const o=c.path||"/";if(this.a(S)){let i=0;for(const r=Math.min(g.length,o.length);i<r&&!(g.charCodeAt(i)!==o.charCodeAt(i)&&g.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);g=o.substr(0,i)+g.substr(i)}return f.$gc.relative(g,o)}resolvePath(S,c){if(S.scheme===F.Schemas.file){const g=v.URI.file(f.$kc($(S),c));return S.with({authority:g.authority,path:g.path})}return c=C.$4f(c),S.with({path:f.$gc.resolve(S.path,c)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,c){return S===c||S!==void 0&&c!==void 0&&(0,A.$af)(S,c)}hasTrailingPathSeparator(S,c=f.sep){if(S.scheme===F.Schemas.file){const g=$(S);return g.length>C.$5f(g).length&&g[g.length-1]===c}else{const g=S.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,c=f.sep){return(0,e.$Og)(S,c)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,c=f.sep){let g=!1;if(S.scheme===F.Schemas.file){const o=$(S);g=o!==void 0&&o.length===C.$5f(o).length&&o[o.length-1]===c}else{c="/";const o=S.path;g=o.length===1&&o.charCodeAt(o.length-1)===47}return!g&&!(0,e.$Og)(S,c)?S.with({path:S.path+"/"}):S}}e.$xg=E,e.$yg=new E(()=>!1),e.$zg=new E(k=>k.scheme===F.Schemas.file?!P.$k:!0),e.$Ag=new E(k=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function R(k,S){const c=[];for(let g=0;g<k.length;g++){const o=S(k[g]);k.some((i,r)=>r===g?!1:(0,e.$Cg)(o,S(i)))||c.push(k[g])}return c}e.$Rg=R;var D;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function S(c){const g=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(r=>{const[n,a]=r.split(":");n&&a&&g.set(n,a)});const i=c.path.substring(0,c.path.indexOf(";"));return i&&g.set(k.META_DATA_MIME,i),g}k.parseMetaData=S})(D||(e.DataUri=D={}));function p(k,S,c){if(S){let g=k.path;return g&&g[0]!==f.$gc.sep&&(g=f.$gc.sep+g),k.with({scheme:c,authority:S,path:g})}return k.with({scheme:c})}e.$Sg=p}),define(Ee[11],Se([1,0,21,14,4,3,23,10,163,43]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.Promises=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function R(_){return!!_&&typeof _.then=="function"}e.$Tg=R;function D(_){const ee=new C.$7d,G=_(ee.token),x=new Promise((me,we)=>{const Ae=ee.token.onCancellationRequested(()=>{Ae.dispose(),we(new F.$5)});Promise.resolve(G).then(ve=>{Ae.dispose(),ee.dispose(),me(ve)},ve=>{Ae.dispose(),ee.dispose(),we(ve)})});return new class{cancel(){ee.cancel(),ee.dispose()}then(me,we){return x.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return x.finally(me)}}}e.$Ug=D;function p(_,ee,G){return new Promise((x,me)=>{const we=ee.onCancellationRequested(()=>{we.dispose(),x(G)});_.then(x,me).finally(()=>we.dispose())})}e.$Vg=p;function k(_,ee){return new Promise((G,x)=>{const me=ee.onCancellationRequested(()=>{me.dispose(),x(new F.$5)});_.then(G,x).finally(()=>me.dispose())})}e.$Wg=k;async function S(_){let ee=-1;const G=_.map((x,me)=>x.then(we=>(ee=me,we)));try{return await Promise.race(G)}finally{_.forEach((x,me)=>{me!==ee&&x.cancel()})}}e.$Xg=S;function c(_,ee,G){let x;const me=setTimeout(()=>{x?.(void 0),G?.()},ee);return Promise.race([_.finally(()=>clearTimeout(me)),new Promise(we=>x=we)])}e.$Yg=c;function g(_){return new Promise((ee,G)=>{const x=_();R(x)?x.then(ee,G):ee(x)})}e.$Zg=g;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ee){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ee,!this.b){const G=()=>{if(this.b=null,this.f)return;const x=this.queue(this.d);return this.d=null,x};this.b=new Promise(x=>{this.a.then(G,G).then(x)})}return new Promise((G,x)=>{this.b.then(G,x)})}return this.a=ee(),new Promise((G,x)=>{this.a.then(me=>{this.a=null,G(me)},me=>{this.a=null,x(me)})})}dispose(){this.f=!0}}e.$1g=o;class i{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.$2g=i;class r{constructor(){this.a=new Map}queue(ee,G){const me=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ee)===me&&this.a.delete(ee)});return this.a.set(ee,me),me}}e.$3g=r;const n=(_,ee)=>{let G=!0;const x=setTimeout(()=>{G=!1,ee()},_);return{isTriggered:()=>G,dispose:()=>{clearTimeout(x),G=!1}}},a=_=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,_())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class t{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,G=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const x=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Td?a(x):n(G,x),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$4g=t;class h{constructor(ee){this.a=new t(ee),this.b=new o}trigger(ee,G){return this.a.trigger(()=>this.b.queue(ee),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$5g=h;class s{constructor(){this.a=!1,this.b=new Promise((ee,G)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$6g=s;class d extends s{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.$7g=d;function l(_,ee){return ee?new Promise((G,x)=>{const me=setTimeout(()=>{we.dispose(),G()},_),we=ee.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),x(new F.$5)})}):D(G=>l(_,G))}e.$8g=l;function u(_,ee=0,G){const x=setTimeout(()=>{_(),G&&me.dispose()},ee),me=(0,P.$Rc)(()=>{clearTimeout(x),G?.deleteAndLeak(me)});return G?.add(me),me}e.$9g=u;function w(_){const ee=[];let G=0;const x=_.length;function me(){return G<x?_[G++]():null}function we(Ae){Ae!=null&&ee.push(Ae);const ve=me();return ve?ve.then(we):Promise.resolve(ee)}return Promise.resolve(null).then(we)}e.$0g=w;function I(_,ee=x=>!!x,G=null){let x=0;const me=_.length,we=()=>{if(x>=me)return Promise.resolve(G);const Ae=_[x++];return Promise.resolve(Ae()).then(Ie=>ee(Ie)?Promise.resolve(Ie):we())};return we()}e.$$g=I;function b(_,ee=x=>!!x,G=null){if(_.length===0)return Promise.resolve(G);let x=_.length;const me=()=>{x=-1;for(const we of _)we.cancel?.()};return new Promise((we,Ae)=>{for(const ve of _)ve.then(Ie=>{--x>=0&&ee(Ie)?(me(),we(Ie)):x===0&&we(G)}).catch(Ie=>{--x>=0&&(me(),Ae(Ie))})})}e.$_g=b;class m{constructor(ee){this.a=0,this.b=!1,this.f=ee,this.g=[],this.d=0,this.h=new f.$Wd}whenIdle(){return this.size>0?f.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(ee){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,x)=>{this.g.push({factory:ee,c:G,e:x}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const ee=this.g.shift();this.d++;const G=ee.factory();G.then(ee.c,ee.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ah=m;class y extends m{constructor(){super(1)}}e.$bh=y;class L{constructor(){this.a=new Q,this.b=0}queue(ee){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ee())):this.a.run(this.b++,ee())}}e.$ch=L;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ee=new ne;return this.b.add(ee),ee.p}g(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueSize(ee,G=A.$yg){const x=G.getComparisonKey(ee);return this.a.get(x)?.size??0}queueFor(ee,G,x=A.$yg){const me=x.getComparisonKey(ee);let we=this.a.get(me);if(!we){we=new y;const Ae=this.f++,ve=f.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ae),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$3c),this.d.set(Ae,ve),this.a.set(me,we)}return we.queue(G)}h(){this.g()&&this.j()}j(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$dh=N;class U{constructor(ee,G){this.a=-1,typeof ee=="function"&&typeof G=="number"&&this.setIfNotSet(ee,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},G)}setIfNotSet(ee,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},G))}}e.$eh=U;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ee,G,x=globalThis){this.cancel();const me=x.setInterval(()=>{ee()},G);this.d=(0,P.$Rc)(()=>{x.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$fh=T;class O{constructor(ee,G){this.b=-1,this.a=ee,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$gh=O;class M{constructor(ee,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ee,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$hh=M;class j extends O{constructor(ee,G){super(ee,G),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.$ih=j;class z extends P.$Tc{constructor(ee,G){super(),this.g=ee,this.h=G,this.a=[],this.b=this.B(new P.$Uc),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ee)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$jh=z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$lh=(_,ee)=>{(0,v.$B)(()=>{if(G)return;const x=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,x-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$lh=(_,ee,G)=>{const x=_.requestIdleCallback(ee,typeof G=="number"?{timeout:G}:void 0);let me=!1;return{dispose(){me||(me=!0,_.cancelIdleCallback(x))}}},e.$kh=_=>(0,e.$lh)(globalThis,_)}();class J{constructor(ee,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(x){this.l=x}finally{this.g=!0}},this.f=(0,e.$lh)(ee,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$mh=J;class le extends J{constructor(ee){super(globalThis,ee)}}e.$nh=le;async function Y(_,ee,G){let x;for(let me=0;me<G;me++)try{return await _()}catch(we){x=we,await l(ee)}throw x}e.$oh=Y;class Q{isRunning(ee){return typeof ee=="number"?this.a?.taskId===ee:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ee,G,x){return this.a={taskId:ee,cancel:()=>x?.(),promise:G},G.then(()=>this.d(ee),()=>this.d(ee)),G}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}queue(ee){if(this.b)this.b.run=ee;else{let G,x;const me=new Promise((we,Ae)=>{G=we,x=Ae});this.b={run:ee,promise:me,promiseResolve:G,promiseReject:x}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ph=Q;class X{constructor(ee,G=()=>Date.now()){this.d=ee,this.f=G,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.$qh=X;var ue;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(ue||(ue={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ee,G)=>{this.a=ee,this.b=G})}complete(ee){return new Promise(G=>{this.a(ee),this.d={outcome:0,value:ee},G()})}error(ee){return new Promise(G=>{this.b(ee),this.d={outcome:1,value:ee},G()})}cancel(){return this.error(new F.$5)}}e.$rh=ne;var $e;(function(_){async function ee(x){let me;const we=await Promise.all(x.map(Ae=>Ae.then(ve=>ve,ve=>{me||(me=ve)})));if(typeof me<"u")throw me;return we}_.settled=ee;function G(x){return new Promise(async(me,we)=>{try{await x(me,we)}catch(Ae){we(Ae)}})}_.withAsyncBody=G})($e||(e.Promises=$e={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ee){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ee.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$sh=oe;class K{constructor(ee){this.b=ee,this.a=new E.$V(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$th=K;var W;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(W||(W={}));class ie{static fromArray(ee){return new ie(G=>{G.emitMany(ee)})}static fromPromise(ee){return new ie(async G=>{G.emitMany(await ee)})}static fromPromises(ee){return new ie(async G=>{await Promise.all(ee.map(async x=>G.emitOne(await x)))})}static merge(ee){return new ie(async G=>{await Promise.all(ee.map(async x=>{for await(const me of x)G.emitOne(me)}))})}static{this.EMPTY=ie.fromArray([])}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new f.$Wd,queueMicrotask(async()=>{const G={emitOne:x=>this.g(x),emitMany:x=>this.h(x),reject:x=>this.k(x)};try{await Promise.resolve(ee(G)),this.j()}catch(x){this.k(x)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,G){return new ie(async x=>{for await(const me of ee)x.emitOne(G(me))})}map(ee){return ie.map(this,ee)}static filter(ee,G){return new ie(async x=>{for await(const me of ee)G(me)&&x.emitOne(me)})}filter(ee){return ie.filter(this,ee)}static coalesce(ee){return ie.filter(ee,G=>!!G)}coalesce(){return ie.coalesce(this)}static async toPromise(ee){const G=[];for await(const x of ee)G.push(x);return G}toPromise(){return ie.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}e.$uh=ie;class ye extends ie{constructor(ee,G){super(G),this.l=ee}cancel(){this.l.cancel()}}e.$vh=ye;function de(_){const ee=new C.$7d,G=_(ee.token);return new ye(ee,async x=>{const me=ee.token.onCancellationRequested(()=>{me.dispose(),ee.dispose(),x.reject(new F.$5)});try{for await(const we of G){if(ee.token.isCancellationRequested)return;x.emitOne(we)}me.dispose(),ee.dispose()}catch(we){me.dispose(),ee.dispose(),x.reject(we)}})}e.$wh=de;class fe{constructor(){this.a=new ne,this.b=new ie(x=>{if(ee){x.reject(ee);return}return G&&x.emitMany(G),this.d=me=>x.reject(me),this.f=me=>x.emitOne(me),this.a.p});let ee,G;this.f=x=>{G||(G=[]),G.push(x)},this.d=x=>{ee||(ee=x)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ee){this.d(ee),this.a.complete()}emitOne(ee){this.f(ee)}}e.$xh=fe}),define(Ee[35],Se([1,0,19,11,34,28,17,10,12]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=void 0;function E(){return Object.create(null)}e.$Ij=E,e.$Jj="**",e.$Kj="/";const R="[/\\\\]",D="[^/\\\\]",p=/\//g;function k(le,Y){switch(le){case 0:return"";case 1:return`${D}*?`;default:return`(?:${R}|${D}+${R}${Y?`|${R}${D}+`:""})*?`}}function S(le,Y){if(!le)return[];const Q=[];let X=!1,ue=!1,ne="";for(const $e of le){switch($e){case Y:if(!X&&!ue){Q.push(ne),ne="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ne+=$e}return ne&&Q.push(ne),Q}e.$Lj=S;function c(le){if(!le)return"";let Y="";const Q=S(le,e.$Kj);if(Q.every(X=>X===e.$Jj))Y=".*";else{let X=!1;Q.forEach((ue,ne)=>{if(ue===e.$Jj){if(X)return;Y+=k(2,ne===Q.length-1)}else{let $e=!1,oe="",K=!1,W="";for(const ie of ue){if(ie!=="}"&&$e){oe+=ie;continue}if(K&&(ie!=="]"||!W)){let ye;ie==="-"?ye=ie:(ie==="^"||ie==="!")&&!W?ye="^":ie===e.$Kj?ye="":ye=(0,$.$Pe)(ie),W+=ye;continue}switch(ie){case"{":$e=!0;continue;case"[":K=!0;continue;case"}":{const de=`(?:${S(oe,",").map(fe=>c(fe)).join("|")})`;Y+=de,$e=!1,oe="";break}case"]":{Y+="["+W+"]",K=!1,W="";break}case"?":Y+=D;continue;case"*":Y+=k(1);continue;default:Y+=(0,$.$Pe)(ie)}}ne<Q.length-1&&(Q[ne+1]!==e.$Jj||ne+2<Q.length)&&(Y+=R)}X=ue===e.$Jj})}return Y}const g=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Dc(1e4),h=function(){return!1},s=function(){return null};function d(le,Y){if(!le)return s;let Q;typeof le!="string"?Q=le.pattern:Q=le,Q=Q.trim();const X=`${Q}_${!!Y.trimForExclusions}`;let ue=t.get(X);if(ue)return l(ue,le);let ne;return g.test(Q)?ue=w(Q.substr(4),Q):(ne=o.exec(u(Q,Y)))?ue=I(ne[1],Q):(Y.trimForExclusions?r:i).test(Q)?ue=b(Q,Y):(ne=n.exec(u(Q,Y)))?ue=m(ne[1].substr(1),Q,!0):(ne=a.exec(u(Q,Y)))?ue=m(ne[1],Q,!1):ue=y(Q),t.set(X,ue),l(ue,le)}function l(le,Y){if(typeof Y=="string")return le;const Q=function(X,ue){return(0,f.$9f)(X,Y.base,!v.$k)?le((0,$.$Ue)(X.substr(Y.base.length),A.sep),ue):null};return Q.allBasenames=le.allBasenames,Q.allPaths=le.allPaths,Q.basenames=le.basenames,Q.patterns=le.patterns,Q}function u(le,Y){return Y.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function w(le,Y){return function(Q,X){return typeof Q=="string"&&Q.endsWith(le)?Y:null}}function I(le,Y){const Q=`/${le}`,X=`\\${le}`,ue=function($e,oe){return typeof $e!="string"?null:oe?oe===le?Y:null:$e===le||$e.endsWith(Q)||$e.endsWith(X)?Y:null},ne=[le];return ue.basenames=ne,ue.patterns=[Y],ue.allBasenames=ne,ue}function b(le,Y){const Q=z(le.slice(1,-1).split(",").map(oe=>d(oe,Y)).filter(oe=>oe!==s),le),X=Q.length;if(!X)return s;if(X===1)return Q[0];const ue=function(oe,K){for(let W=0,ie=Q.length;W<ie;W++)if(Q[W](oe,K))return le;return null},ne=Q.find(oe=>!!oe.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const $e=Q.reduce((oe,K)=>K.allPaths?oe.concat(K.allPaths):oe,[]);return $e.length&&(ue.allPaths=$e),ue}function m(le,Y,Q){const X=A.sep===A.$gc.sep,ue=X?le:le.replace(p,A.sep),ne=A.sep+ue,$e=A.$gc.sep+le;let oe;return Q?oe=function(K,W){return typeof K=="string"&&(K===ue||K.endsWith(ne)||!X&&(K===le||K.endsWith($e)))?Y:null}:oe=function(K,W){return typeof K=="string"&&(K===ue||!X&&K===le)?Y:null},oe.allPaths=[(Q?"*/":"./")+le],oe}function y(le){try{const Y=new RegExp(`^${c(le)}$`);return function(Q){return Y.lastIndex=0,typeof Q=="string"&&Y.test(Q)?le:null}}catch{return s}}function L(le,Y,Q){return!le||typeof Y!="string"?!1:N(le)(Y,void 0,Q)}e.$Mj=L;function N(le,Y={}){if(!le)return h;if(typeof le=="string"||U(le)){const Q=d(le,Y);if(Q===s)return h;const X=function(ue,ne){return!!Q(ue,ne)};return Q.allBasenames&&(X.allBasenames=Q.allBasenames),Q.allPaths&&(X.allPaths=Q.allPaths),X}return M(le,Y)}e.$Nj=N;function U(le){const Y=le;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.$Oj=U;function T(le){return le.allBasenames||[]}e.$Pj=T;function O(le){return le.allPaths||[]}e.$Qj=O;function M(le,Y){const Q=z(Object.getOwnPropertyNames(le).map(oe=>j(oe,le[oe],Y)).filter(oe=>oe!==s)),X=Q.length;if(!X)return s;if(!Q.some(oe=>!!oe.requiresSiblings)){if(X===1)return Q[0];const oe=function(ie,ye){let de;for(let fe=0,_=Q.length;fe<_;fe++){const ee=Q[fe](ie,ye);if(typeof ee=="string")return ee;(0,F.$Tg)(ee)&&(de||(de=[]),de.push(ee))}return de?(async()=>{for(const fe of de){const _=await fe;if(typeof _=="string")return _}return null})():null},K=Q.find(ie=>!!ie.allBasenames);K&&(oe.allBasenames=K.allBasenames);const W=Q.reduce((ie,ye)=>ye.allPaths?ie.concat(ye.allPaths):ie,[]);return W.length&&(oe.allPaths=W),oe}const ue=function(oe,K,W){let ie,ye;for(let de=0,fe=Q.length;de<fe;de++){const _=Q[de];_.requiresSiblings&&W&&(K||(K=(0,A.$nc)(oe)),ie||(ie=K.substr(0,K.length-(0,A.$oc)(oe).length)));const ee=_(oe,K,ie,W);if(typeof ee=="string")return ee;(0,F.$Tg)(ee)&&(ye||(ye=[]),ye.push(ee))}return ye?(async()=>{for(const de of ye){const fe=await de;if(typeof fe=="string")return fe}return null})():null},ne=Q.find(oe=>!!oe.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const $e=Q.reduce((oe,K)=>K.allPaths?oe.concat(K.allPaths):oe,[]);return $e.length&&(ue.allPaths=$e),ue}function j(le,Y,Q){if(Y===!1)return s;const X=d(le,Q);if(X===s)return s;if(typeof Y=="boolean")return X;if(Y){const ue=Y.when;if(typeof ue=="string"){const ne=($e,oe,K,W)=>{if(!W||!X($e,oe))return null;const ie=ue.replace("$(basename)",()=>K),ye=W(ie);return(0,F.$Tg)(ye)?ye.then(de=>de?le:null):ye?le:null};return ne.requiresSiblings=!0,ne}}return X}function z(le,Y){const Q=le.filter(oe=>!!oe.basenames);if(Q.length<2)return le;const X=Q.reduce((oe,K)=>{const W=K.basenames;return W?oe.concat(W):oe},[]);let ue;if(Y){ue=[];for(let oe=0,K=X.length;oe<K;oe++)ue.push(Y)}else ue=Q.reduce((oe,K)=>{const W=K.patterns;return W?oe.concat(W):oe},[]);const ne=function(oe,K){if(typeof oe!="string")return null;if(!K){let ie;for(ie=oe.length;ie>0;ie--){const ye=oe.charCodeAt(ie-1);if(ye===47||ye===92)break}K=oe.substr(ie)}const W=X.indexOf(K);return W!==-1?ue[W]:null};ne.basenames=X,ne.patterns=ue,ne.allBasenames=X;const $e=le.filter(oe=>!oe.basenames);return $e.push(ne),$e}function J(le,Y){return(0,C.$ub)(le,Y,(Q,X)=>typeof Q=="string"&&typeof X=="string"?Q===X:typeof Q!="string"&&typeof X!="string"?Q.base===X.base&&Q.pattern===X.pattern:!1)}e.$Rj=J}),define(Ee[80],Se([1,0,14,164,23,12,2]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.MarkdownStringTextNewlineStyle=void 0;var v;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(v||(e.MarkdownStringTextNewlineStyle=v={}));class ${constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,C.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=p(this.supportThemeIcons?(0,F.$ck)(i):i).replace(/([ \t]+)/g,(n,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+=`
${k(r,i)}
`,this}appendLink(i,r,n){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(i,r){const n=new RegExp((0,P.$Pe)(r),"g");return i.replace(n,(a,t)=>i.charAt(t-1)!=="\\"?`\\${a}`:a)}}e.$ik=$;function E(o){return R(o)?!o.value:Array.isArray(o)?o.every(E):!0}e.$jk=E;function R(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$kk=R;function D(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,f.$Bg)(A.URI.from(o.baseUri),A.URI.from(i.baseUri)))}e.$lk=D;function p(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$mk=p;function k(o,i){const r=o.match(/^`+/gm)?.reduce((a,t)=>a.length>t.length?a:t).length??0,n=r>=3?r+1:3;return[`${"`".repeat(n)}${i}`,o,`${"`".repeat(n)}`].join(`
`)}e.$nk=k;function S(o){return o.replace(/"/g,"&quot;")}e.$ok=S;function c(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$pk=c;function g(o){const i=[],r=o.split("|").map(a=>a.trim());o=r[0];const n=r[1];if(n){const a=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),h=a?a[1]:"",s=t?t[1]:"",d=isFinite(parseInt(s)),l=isFinite(parseInt(h));d&&i.push(`width="${s}"`),l&&i.push(`height="${h}"`)}return{href:o,dimensions:i}}e.$qk=g}),define(Ee[103],Se([1,0,19,34,17,10,23,12]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=void 0;function $(d,l){const{os:u,tildify:w,relative:I}=l;if(I){const y=E(d,I,u);if(typeof y=="string")return y}let b=d.fsPath;if(u===1&&!P.$i?b=b.replace(/\//g,"\\"):u!==1&&P.$i&&(b=b.replace(/\\/g,"/")),u!==1&&w?.userHome){const y=w.userHome.fsPath;let L;d.scheme!==w.userHome.scheme&&d.path[0]===f.$gc.sep&&d.path[1]!==f.$gc.sep?L=w.userHome.with({path:d.path}).fsPath:L=b,b=p(L,y,u)}return(u===1?f.$fc:f.$gc).normalize(R(b,u===1))}e.$Wv=$;function E(d,l,u){const w=u===1?f.$fc:f.$gc,I=u===3?A.$yg:A.$Ag,b=l.getWorkspace(),m=(0,C.$Ob)(b.folders);if(!m)return;d.scheme!==m.uri.scheme&&d.path[0]===f.$gc.sep&&d.path[1]!==f.$gc.sep&&(d=m.uri.with({path:d.path}));const y=l.getWorkspaceFolder(d);if(!y)return;let L;if(I.isEqual(y.uri,d)?L="":L=I.relativePath(y.uri,d)??"",L&&(L=w.normalize(L)),b.folders.length>1&&!l.noPrefix){const N=y.name?y.name:I.basenameOrAuthority(y.uri);L=L?`${N} \u2022 ${L}`:N}return L}function R(d,l=P.$i){return(0,F.$ag)(d,l)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Xv=R;let D=Object.create(null);function p(d,l,u=P.OS){if(u===1||!d||!l)return d;let w=D.original===l?D.normalized:void 0;w||(w=l,P.$i&&(w=(0,F.$3f)(w)),w=`${(0,v.$Ve)(w,f.$gc.sep)}${f.$gc.sep}`,D={original:l,normalized:w});let I=d;return P.$i&&(I=(0,F.$3f)(I)),(u===3?I.startsWith(w):(0,v.$bf)(I,w))?`~/${I.substr(w.length)}`:d}e.$Yv=p;function k(d,l){return d.replace(/^~($|\/|\\)/,`${l}$1`)}e.$Zv=k;const S="\u2026",c="\\\\",g="~";function o(d,l=f.sep){const u=new Array(d.length);let w=!1;for(let I=0;I<d.length;I++){const b=d[I];if(b===""){u[I]=`.${l}`;continue}if(!b){u[I]=b;continue}w=!0;let m="",y=b;y.indexOf(c)===0?(m=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(l)===0?(m=y.substr(0,y.indexOf(l)+l.length),y=y.substr(y.indexOf(l)+l.length)):y.indexOf(g)===0&&(m=y.substr(0,y.indexOf(g)+g.length),y=y.substr(y.indexOf(g)+g.length));const L=y.split(l);for(let N=1;w&&N<=L.length;N++)for(let U=L.length-N;w&&U>=0;U--){w=!1;let T=L.slice(U,U+N).join(l);for(let O=0;!w&&O<d.length;O++)if(O!==I&&d[O]&&d[O].indexOf(T)>-1){const M=U+N===L.length,j=U>0&&d[O].indexOf(l)>-1?l+T:T,z=d[O].endsWith(j);w=!M||z}if(!w){let O="";(L[0].endsWith(":")||m!=="")&&(U===1&&(U=0,N++,T=L[0]+l+T),U>0&&(O=L[0]+l),O=m+O),U>0&&(O=O+S+l),O=O+T,U+N<L.length&&(O=O+l+S),u[I]=O}}w&&(u[I]=b)}return u}e.$1v=o;var i;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function r(d,l=Object.create(null)){const u=[];let w=!1,I="";for(const b of d)if(b==="$"||w&&b==="{")I&&u.push({value:I,type:i.TEXT}),I="",w=!0;else if(b==="}"&&w){const m=l[I];if(typeof m=="string")m.length&&u.push({value:m,type:i.VARIABLE});else if(m){const y=u[u.length-1];(!y||y.type!==i.SEPARATOR)&&u.push({value:m.label,type:i.SEPARATOR})}I="",w=!1}else I+=b;return I&&!w&&u.push({value:I,type:i.TEXT}),u.filter((b,m)=>{if(b.type===i.SEPARATOR){const y=u[m-1],L=u[m+1];return[y,L].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(b=>b.value).join("")}e.$2v=r;function n(d,l){return P.$j||l?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):d.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.$3v=n;function a(d,l){return P.$j||l?d.replace(/\(&&\w\)|&&/g,""):P.$i?d.replace(/&&|&/g,u=>u==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$4v=a;function t(d){return d.replace(/&/g,"&&")}e.$5v=t;function h(d){if(d.endsWith("]")){const l=d.lastIndexOf(" [",d.length-2);if(l!==-1){const u=s(d.substring(0,l)),w=d.substring(l);return{name:u.name+w,parentPath:u.parentPath}}}return s(d)}e.$6v=h;function s(d){const l=d.indexOf("/")!==-1?f.$gc:f.$fc,u=l.basename(d),w=l.dirname(d);return u.length?{name:u,parentPath:w}:{name:w,parentPath:""}}}),define(Ee[130],Se([1,0,22,2]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=void 0;function f(D){return D.toJSON()}class P{constructor(p){this.a=p}transformIncoming(p){const k=this.a.transformIncoming(p);return k===p?p:f(F.URI.from(k))}transformOutgoing(p){const k=this.a.transformOutgoing(p);return k===p?p:f(F.URI.from(k))}transformOutgoingURI(p){const k=this.a.transformOutgoing(p);return k===p?p:F.URI.from(k)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$5m=P,e.$6m=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,p,k){if(!D||k>200)return null;if(typeof D=="object"){if(D instanceof F.URI)return p.transformOutgoing(D);for(const S in D)if(Object.hasOwnProperty.call(D,S)){const c=A(D[S],p,k+1);c!==null&&(D[S]=c)}}return null}function v(D,p){const k=A(D,p,0);return k===null?D:k}e.$7m=v;function $(D,p,k,S){if(!D||S>200)return null;if(typeof D=="object"){if(D.$mid===1)return k?F.URI.revive(p.transformIncoming(D)):p.transformIncoming(D);if(D instanceof C.$ke)return null;for(const c in D)if(Object.hasOwnProperty.call(D,c)){const g=$(D[c],p,k,S+1);g!==null&&(D[c]=g)}}return null}function E(D,p){const k=$(D,p,!1,0);return k===null?D:k}e.$8m=E;function R(D,p){const k=$(D,p,!0,0);return k===null?D:k}e.$9m=R}),define(Ee[31],Se([1,0,57,63,386,11,34,76,17,10,23,2]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function k(j,z=p.UNLINK,J){if((0,A.$_f)(j))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?c(j):S(j,J)}async function S(j,z=(0,A.$eg)((0,F.tmpdir)())){try{try{await C.promises.rename(j,z)}catch(J){return J.code==="ENOENT"?void 0:c(j)}c(z).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function c(j){return(0,f.promisify)(C.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function g(j){if((0,A.$_f)(j))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function o(j,z){return n(await(z?i(j):(0,f.promisify)(C.readdir)(j)))}async function i(j){try{return await(0,f.promisify)(C.readdir)(j,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const z=[],J=await o(j);for(const le of J){let Y=!1,Q=!1,X=!1;try{const ue=await e.Promises.lstat((0,$.$jc)(j,le));Y=ue.isFile(),Q=ue.isDirectory(),X=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}z.push({name:le,isFile:()=>Y,isDirectory:()=>Q,isSymbolicLink:()=>X})}return z}function r(j){return n(C.readdirSync(j))}e.readdirSync=r;function n(j){return j.map(z=>typeof z=="string"?E.$j?(0,v.$Hl)(z):z:(z.name=E.$j?(0,v.$Hl)(z.name):z.name,z))}async function a(j){const z=await o(j),J=[];for(const le of z)await h.existsDirectory((0,$.$jc)(j,le))&&J.push(le);return J}function t(j,z=1e3){return new Promise(J=>{let le=!1;const Y=setInterval(()=>{le||(le=!0,C.access(j,Q=>{le=!1,Q&&(clearInterval(Y),J(void 0))}))},z)})}e.whenDeleted=t;var h;(function(j){async function z(Y){let Q;try{if(Q=await e.Promises.lstat(Y),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(E.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ue}throw X}}j.stat=z;async function J(Y){try{const{stat:Q,symbolicLink:X}=await j.stat(Y);return Q.isFile()&&X?.dangling!==!0}catch{}return!1}j.existsFile=J;async function le(Y){try{const{stat:Q,symbolicLink:X}=await j.stat(Y);return Q.isDirectory()&&X?.dangling!==!0}catch{}return!1}j.existsDirectory=le})(h||(e.SymlinkSupport=h={}));const s=new P.$dh;function d(j,z,J){return s.queueFor(D.URI.file(j),()=>{const le=b(J);return new Promise((Y,Q)=>w(j,z,le,X=>X?Q(X):Y()))},R.$zg)}let l=!0;function u(j){l=j}e.configureFlushOnWrite=u;function w(j,z,J,le){if(!l)return C.writeFile(j,z,{mode:J.mode,flag:J.flag},le);C.open(j,J.flag,J.mode,(Y,Q)=>{if(Y)return le(Y);C.writeFile(Q,z,X=>{if(X)return C.close(Q,()=>le(X));C.fdatasync(Q,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),u(!1)),C.close(Q,ne=>le(ne))))})})}function I(j,z,J){const le=b(J);if(!l)return C.writeFileSync(j,z,{mode:le.mode,flag:le.flag});const Y=C.openSync(j,le.flag,le.mode);try{C.writeFileSync(Y,z);try{C.fdatasyncSync(Y)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),u(!1)}}finally{C.closeSync(Y)}}e.writeFileSync=I;function b(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function m(j,z,J=6e4){if(j!==z)try{E.$i&&typeof J=="number"?await y(j,z,Date.now(),J):await(0,f.promisify)(C.rename)(j,z)}catch(le){if(j.toLowerCase()!==z.toLowerCase()&&le.code==="EXDEV"||j.endsWith("."))await L(j,z,{preserveSymlinks:!1}),await k(j,p.MOVE);else throw le}}async function y(j,z,J,le,Y=0){try{return await(0,f.promisify)(C.rename)(j,z)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-J>=le)throw console.error(`[node.js fs] rename failed after ${Y} retries with error: ${Q}`),Q;if(Y===0){let X=!1;try{const{stat:ue}=await h.stat(z);ue.isFile()||(X=!0)}catch{}if(X)throw Q}return await(0,P.$8g)(Math.min(100,Y*10)),y(j,z,J,le,Y+1)}}async function L(j,z,J){return U(j,z,{root:{source:j,target:z},options:J,handledSourcePaths:new Set})}const N=511;async function U(j,z,J){if(J.handledSourcePaths.has(j))return;J.handledSourcePaths.add(j);const{stat:le,symbolicLink:Y}=await h.stat(j);if(Y){if(J.options.preserveSymlinks)try{return await M(j,z,J)}catch{}if(Y.dangling)return}return le.isDirectory()?T(j,z,le.mode&N,J):O(j,z,le.mode&N)}async function T(j,z,J,le){await e.Promises.mkdir(z,{recursive:!0,mode:J});const Y=await o(j);for(const Q of Y)await U((0,$.$jc)(j,Q),(0,$.$jc)(z,Q),le)}async function O(j,z,J){await e.Promises.copyFile(j,z),await e.Promises.chmod(z,J)}async function M(j,z,J){let le=await e.Promises.readlink(j);(0,A.$9f)(le,J.root.source,!E.$k)&&(le=(0,$.$jc)(J.root.target,le.substr(J.root.source.length+1))),await e.Promises.symlink(le,z)}e.Promises=new class{get access(){return(0,f.promisify)(C.access)}get stat(){return(0,f.promisify)(C.stat)}get lstat(){return(0,f.promisify)(C.lstat)}get utimes(){return(0,f.promisify)(C.utimes)}get read(){return(j,z,J,le,Y)=>new Promise((Q,X)=>{C.read(j,z,J,le,Y,(ue,ne,$e)=>ue?X(ue):Q({bytesRead:ne,buffer:$e}))})}get readFile(){return(0,f.promisify)(C.readFile)}get write(){return(j,z,J,le,Y)=>new Promise((Q,X)=>{C.write(j,z,J,le,Y,(ue,ne,$e)=>ue?X(ue):Q({bytesWritten:ne,buffer:$e}))})}get appendFile(){return(0,f.promisify)(C.appendFile)}get fdatasync(){return(0,f.promisify)(C.fdatasync)}get truncate(){return(0,f.promisify)(C.truncate)}get copyFile(){return(0,f.promisify)(C.copyFile)}get open(){return(0,f.promisify)(C.open)}get close(){return(0,f.promisify)(C.close)}get symlink(){return(0,f.promisify)(C.symlink)}get readlink(){return(0,f.promisify)(C.readlink)}get chmod(){return(0,f.promisify)(C.chmod)}get mkdir(){return(0,f.promisify)(C.mkdir)}get unlink(){return(0,f.promisify)(C.unlink)}get rmdir(){return(0,f.promisify)(C.rmdir)}get realpath(){return(0,f.promisify)(C.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return d}get rm(){return k}get rename(){return m}get copy(){return L}}}),define(Ee[104],Se([1,0,57,17,10,12,31]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=e.$uq=void 0;function v(p){if(f.$k)return p;const k=(0,F.$mc)(p);if(p===k)return p;const S=((0,F.$nc)(p)||p).toLowerCase();try{const g=(0,A.readdirSync)(k).filter(o=>o.toLowerCase()===S);if(g.length===1){const o=v(k);if(o)return(0,F.$jc)(o,g[0])}else if(g.length>1){const o=g.indexOf(S);if(o>=0){const i=v(k);if(i)return(0,F.$jc)(i,g[o])}}}catch{}return null}e.$uq=v;async function $(p){if(f.$k)return p;const k=(0,F.$mc)(p);if(p===k)return p;const S=((0,F.$nc)(p)||p).toLowerCase();try{const g=(await A.Promises.readdir(k)).filter(o=>o.toLowerCase()===S);if(g.length===1){const o=await $(k);if(o)return(0,F.$jc)(o,g[0])}else if(g.length>1){const o=g.indexOf(S);if(o>=0){const i=await $(k);if(i)return(0,F.$jc)(i,g[o])}}}catch{}return null}e.$vq=$;async function E(p){try{return await A.Promises.realpath(p)}catch{const S=D(p);return await A.Promises.access(S,C.constants.R_OK),S}}e.$wq=E;function R(p){try{return C.realpathSync(p)}catch{const S=D(p);return C.accessSync(S,C.constants.R_OK),S}}e.$xq=R;function D(p){return(0,P.$Ve)((0,F.$hc)(p),F.sep)}}),define(Ee[105],Se([1,0,17,10,49,102,18,31]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Vl=e.$Ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function $(D=f.env){return D.comspec||"cmd.exe"}e.$Ul=$;function E(D){let p=[],k=!1;const S=function(c){if(k){p.push(c);return}(!D.send(c,o=>{if(o&&console.error(o),k=!1,p.length>0){const i=p.slice(0);p=[],i.forEach(r=>S(r))}})||F.$i)&&(k=!0)};return{send:S}}e.$Vl=E;var R;(function(D){async function p(k,S,c){if(C.$ic(k))return k;if(S===void 0&&(S=f.cwd()),C.$mc(k)!=="."||(c===void 0&&A.$Jf(f.env.PATH)&&(c=f.env.PATH.split(C.$tc)),c===void 0||c.length===0))return C.$jc(S,k);async function o(i){if(await v.Promises.exists(i)){let r;try{r=await v.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(r=await v.Promises.lstat(i))}return r?!r.isDirectory():!1}return!1}for(const i of c){let r;if(C.$ic(i)?r=C.$jc(i,k):r=C.$jc(S,i,k),await o(r))return r;let n=r+".com";if(await o(n)||(n=r+".exe",await o(n)))return n}return C.$jc(S,k)}D.findExecutable=p})(R||(e.win32=R={}))});var Ge=this&&this.__decorate||function(ge,e,C,F){var f=arguments.length,P=f<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,C):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(ge,e,C,F);else for(var v=ge.length-1;v>=0;v--)(A=ge[v])&&(P=(f<3?A(P):f>3?A(e,C,P):A(e,C))||P);return f>3&&P&&Object.defineProperty(e,C,P),P};define(Ee[81],Se([1,0,19,11,22,21,52,14,4,3,56,12,18]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.ProxyChannel=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.RequestInitiator=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;var k;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(k||(k={}));function S(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(c||(c={}));function g(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(o||(o={}));function i(Y){let Q=0;for(let X=0;;X+=7){const ue=Y.read(1);if(Q|=(ue.buffer[0]&127)<<X,!(ue.buffer[0]&128))return Q}}const r=s(0);function n(Y,Q){if(Q===0){Y.write(r);return}let X=0;for(let ne=Q;ne!==0;ne=ne>>>7)X++;const ue=f.$ke.alloc(X);for(let ne=0;Q!==0;ne++)ue.buffer[ne]=Q&127,Q=Q>>>7,Q>0&&(ue.buffer[ne]|=128);Y.write(ue)}class a{constructor(Q){this.b=Q,this.a=0}read(Q){const X=this.b.slice(this.a,this.a+Q);return this.a+=X.byteLength,X}}e.$Eh=a;class t{constructor(){this.a=[]}get buffer(){return f.$ke.concat(this.a)}write(Q){this.a.push(Q)}}e.$Fh=t;var h;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(h||(h={}));function s(Y){const Q=f.$ke.alloc(1);return Q.writeUInt8(Y,0),Q}const d={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object),Uint:s(h.Int)},l=typeof Buffer<"u";function u(Y,Q){if(typeof Q>"u")Y.write(d.Undefined);else if(typeof Q=="string"){const X=f.$ke.fromString(Q);Y.write(d.String),n(Y,X.byteLength),Y.write(X)}else if(l&&Buffer.isBuffer(Q)){const X=f.$ke.wrap(Q);Y.write(d.Buffer),n(Y,X.byteLength),Y.write(X)}else if(Q instanceof f.$ke)Y.write(d.VSBuffer),n(Y,Q.byteLength),Y.write(Q);else if(Array.isArray(Q)){Y.write(d.Array),n(Y,Q.length);for(const X of Q)u(Y,X)}else if(typeof Q=="number"&&(Q|0)===Q)Y.write(d.Uint),n(Y,Q);else{const X=f.$ke.fromString(JSON.stringify(Q));Y.write(d.Object),n(Y,X.byteLength),Y.write(X)}}e.$Gh=u;function w(Y){switch(Y.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return Y.read(i(Y)).toString();case h.Buffer:return Y.read(i(Y)).buffer;case h.VSBuffer:return Y.read(i(Y));case h.Array:{const X=i(Y),ue=[];for(let ne=0;ne<X;ne++)ue.push(w(Y));return ue}case h.Object:return JSON.parse(Y.read(i(Y)).toString());case h.Int:return i(Y)}}e.$Hh=w;class I{constructor(Q,X,ue=null,ne=1e3){this.h=Q,this.j=X,this.k=ue,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($e=>this.q($e)),this.m({type:200})}registerChannel(Q,X){this.b.set(Q,X),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const X=this.o([Q.type]);this.k?.logOutgoing(X,0,1,g(Q.type));return}case 201:case 202:case 204:case 203:{const X=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(X,Q.id,1,g(Q.type),Q.data);return}}}o(Q,X=void 0){const ue=new t;return u(ue,Q),u(ue,X),this.p(ue.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const X=new a(Q),ue=w(X),ne=w(X),$e=ue[0];switch($e){case 100:return this.k?.logIncoming(Q.byteLength,ue[1],1,`${S($e)}: ${ue[2]}.${ue[3]}`,ne),this.s({type:$e,id:ue[1],channelName:ue[2],name:ue[3],arg:ne});case 102:return this.k?.logIncoming(Q.byteLength,ue[1],1,`${S($e)}: ${ue[2]}.${ue[3]}`,ne),this.t({type:$e,id:ue[1],channelName:ue[2],name:ue[3],arg:ne});case 101:return this.k?.logIncoming(Q.byteLength,ue[1],1,`${S($e)}`),this.u({type:$e,id:ue[1]});case 103:return this.k?.logIncoming(Q.byteLength,ue[1],1,`${S($e)}`),this.u({type:$e,id:ue[1]})}}s(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const ue=new P.$7d;let ne;try{ne=X.call(this.j,Q.name,Q.arg,ue.token)}catch(K){ne=Promise.reject(K)}const $e=Q.id;ne.then(K=>{this.m({id:$e,data:K,type:201})},K=>{K instanceof Error?this.m({id:$e,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:$e,data:K,type:203})}).finally(()=>{oe.dispose(),this.d.delete(Q.id)});const oe=(0,E.$Rc)(()=>ue.cancel());this.d.set(Q.id,oe)}t(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const ue=Q.id,$e=X.listen(this.j,Q.name,Q.arg)(oe=>this.m({id:ue,data:oe,type:204}));this.d.set(Q.id,$e)}u(Q){const X=this.d.get(Q.id);X&&(X.dispose(),this.d.delete(Q.id))}v(Q){let X=this.g.get(Q.channelName);X||(X=[],this.g.set(Q.channelName,X));const ue=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:Q,timeoutTimer:ue})}w(Q){const X=this.g.get(Q);if(X){for(const ue of X)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.s(ue.request);break;case 102:this.t(ue.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=I;var b;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class m{constructor(Q,X=null){this.l=Q,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ue=>this.s(ue)),this.j=X}getChannel(Q){const X=this;return{call(ue,ne,$e){return X.a?Promise.reject(new v.$5):X.m(Q,ue,ne,$e)},listen(ue,ne){return X.a?$.Event.None:X.o(Q,ue,ne)}}}m(Q,X,ue,ne=P.CancellationToken.None){const $e=this.g++,K={id:$e,type:100,channelName:Q,name:X,arg:ue};if(ne.isCancellationRequested)return Promise.reject(new v.$5);let W;return new Promise((ye,de)=>{if(ne.isCancellationRequested)return de(new v.$5);const fe=()=>{const x=me=>{switch(me.type){case 201:this.f.delete($e),ye(me.data);break;case 202:{this.f.delete($e);const we=new Error(me.data.message);we.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,we.name=me.data.name,de(we);break}case 203:this.f.delete($e),de(me.data);break}};this.f.set($e,x),this.p(K)};let _=null;this.b===o.Idle?fe():(_=(0,F.$Ug)(x=>this.u()),_.then(()=>{_=null,fe()}));const ee=()=>{_?(_.cancel(),_=null):this.p({id:$e,type:101}),de(new v.$5)},G=ne.onCancellationRequested(ee);W=(0,E.$Qc)((0,E.$Rc)(ee),G),this.d.add(W)}).finally(()=>{W.dispose(),this.d.delete(W)})}o(Q,X,ue){const ne=this.g++,oe={id:ne,type:102,channelName:Q,name:X,arg:ue};let K=null;const W=new $.$Wd({onWillAddFirstListener:()=>{K=(0,F.$Ug)(ye=>this.u()),K.then(()=>{K=null,this.d.add(W),this.p(oe)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(W),this.p({id:ne,type:103}))}}),ie=ye=>W.fire(ye.data);return this.f.set(ne,ie),W.event}p(Q){switch(Q.type){case 100:case 102:{const X=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(X,Q.id,0,`${S(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const X=this.q([Q.type,Q.id]);this.j?.logOutgoing(X,Q.id,0,S(Q.type));return}}}q(Q,X=void 0){const ue=new t;return u(ue,Q),u(ue,X),this.r(ue.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const X=new a(Q),ue=w(X),ne=w(X),$e=ue[0];switch($e){case 200:return this.j?.logIncoming(Q.byteLength,0,0,g($e)),this.t({type:ue[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ue[1],0,g($e),ne),this.t({type:ue[0],id:ue[1],data:ne})}}t(Q){if(Q.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=m,Ge([A.$yh],m.prototype,"onDidInitializePromise",null);class y{get connections(){const Q=[];return this.f.forEach(X=>Q.push(X)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new $.$Wd,this.onDidAddConnection=this.g.event,this.h=new $.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new E.$Sc,this.j.add(Q(({protocol:X,onDidClientDisconnect:ue})=>{const ne=$.Event.once(X.onMessage);this.j.add(ne($e=>{const oe=new a($e),K=w(oe),W=new I(X,K),ie=new m(X);this.a.forEach((de,fe)=>W.registerChannel(fe,de));const ye={channelServer:W,channelClient:ie,ctx:K};this.f.add(ye),this.g.fire(ye),this.j.add(ue(()=>{W.dispose(),ie.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(Q,X){const ue=this;return{call(ne,$e,oe){let K;if((0,p.$Xf)(X)){const ie=(0,C.$4b)(ue.connections.filter(X));K=ie?Promise.resolve(ie):$.Event.toPromise($.Event.filter(ue.onDidAddConnection,X))}else K=X.routeCall(ue,ne,$e);const W=K.then(ie=>ie.channelClient.getChannel(Q));return N(W).call(ne,$e,oe)},listen(ne,$e){if((0,p.$Xf)(X))return ue.k(Q,X,ne,$e);const oe=X.routeEvent(ue,ne,$e).then(K=>K.channelClient.getChannel(Q));return N(oe).listen(ne,$e)}}}k(Q,X,ue,ne){const $e=this;let oe;const K=new $.$Wd({onWillAddFirstListener:()=>{oe=new E.$Sc;const W=new $.$3d,ie=new Map,ye=fe=>{const ee=fe.channelClient.getChannel(Q).listen(ue,ne),G=W.add(ee);ie.set(fe,G)},de=fe=>{const _=ie.get(fe);_&&(_.dispose(),ie.delete(fe))};$e.connections.filter(X).forEach(ye),$.Event.filter($e.onDidAddConnection,X)(ye,void 0,oe),$e.onDidRemoveConnection(de,void 0,oe),W.event(K.fire,K,oe),oe.add(W)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return K.event}registerChannel(Q,X){this.a.set(Q,X);for(const ue of this.f)ue.channelServer.registerChannel(Q,X)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Kh=y;class L{constructor(Q,X,ue=null){const ne=new t;u(ne,X),Q.send(ne.buffer),this.a=new m(Q,ue),this.d=new I(Q,X,ue)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,X){this.d.registerChannel(Q,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Lh=L;function N(Y){return{call(Q,X,ue){return Y.then(ne=>ne.call(Q,X,ue))},listen(Q,X){const ue=new $.$6d;return Y.then(ne=>ue.input=ne.listen(Q,X)),ue.event}}}e.$Mh=N;function U(Y){let Q=!1;return{call(X,ue,ne){return Q?Y.call(X,ue,ne):(0,F.$8g)(0).then(()=>Q=!0).then(()=>Y.call(X,ue,ne))},listen(X,ue){if(Q)return Y.listen(X,ue);const ne=new $.$6d;return(0,F.$8g)(0).then(()=>Q=!0).then(()=>ne.input=Y.listen(X,ue)),ne.event}}}e.$Nh=U;class T{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const X of Q.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await $.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$Oh=T;var O;(function(Y){function Q($e,oe,K){const W=$e,ie=K&&K.disableMarshalling,ye=new Map;for(const de in W)ue(de)&&ye.set(de,$.Event.buffer(W[de],!0,void 0,oe));return new class{listen(de,fe,_){const ee=ye.get(fe);if(ee)return ee;if(ne(fe)){const G=W[fe];if(typeof G=="function")return G.call(W,_)}throw new v.$bb(`Event not found: ${fe}`)}call(de,fe,_){const ee=W[fe];if(typeof ee=="function"){if(!ie&&Array.isArray(_))for(let x=0;x<_.length;x++)_[x]=(0,R.$Dh)(_[x]);let G=ee.apply(W,_);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new v.$bb(`Method not found: ${fe}`)}}}Y.fromService=Q;function X($e,oe){const K=oe&&oe.disableMarshalling;return new Proxy({},{get(W,ie){if(typeof ie=="string")return oe?.properties?.has(ie)?oe.properties.get(ie):ne(ie)?function(ye){return $e.listen(ie,ye)}:ue(ie)?$e.listen(ie):async function(...ye){let de;oe&&!(0,p.$Sf)(oe.context)?de=[oe.context,...ye]:de=ye;const fe=await $e.call(ie,de);return K?fe:(0,R.$Dh)(fe)};throw new v.$bb(`Property not found: ${String(ie)}`)}})}Y.toService=X;function ue($e){return $e[0]==="o"&&$e[1]==="n"&&D.$_e($e.charCodeAt(2))}function ne($e){return/^onDynamic/.test($e)&&D.$_e($e.charCodeAt(9))}})(O||(e.ProxyChannel=O={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const Q=Y.toString();if(Q!=="[object Object]")return Q}return Y}function z(Y){return Array.isArray(Y)?Y.map(j):j(Y)}function J(Y,Q,X,ue,ne,$e,oe){oe=z(oe);const K=M[ne],W=K[ue%K.length];let ie=[`%c[${Y}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${$e}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test($e)?(ie=ie.concat(oe),ie.push(")")):ie.push(oe),console.log.apply(console,ie)}class le{constructor(Q,X){this.d=Q,this.f=X,this.a=0,this.b=0}logOutgoing(Q,X,ue,ne,$e){this.b+=Q,J(this.d,this.b,Q,X,ue,ne,$e)}logIncoming(Q,X,ue,ne,$e){this.a+=Q,J(this.f,this.a,Q,X,ue,ne,$e)}}e.$Ph=le}),define(Ee[82],Se([1,0,22,4,3,81]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.ProtocolConstants=e.$Qh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(d){d.Created="created",d.Read="read",d.Write="write",d.Open="open",d.Error="error",d.Close="close",d.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",d.NodeEndReceived="nodeEndReceived",d.NodeEndSent="nodeEndSent",d.NodeDrainBegin="nodeDrainBegin",d.NodeDrainEnd="nodeDrainEnd",d.zlibInflateError="zlibInflateError",d.zlibInflateData="zlibInflateData",d.zlibInflateInitialWrite="zlibInflateInitialWrite",d.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",d.zlibInflateWrite="zlibInflateWrite",d.zlibInflateFlushFired="zlibInflateFlushFired",d.zlibDeflateError="zlibDeflateError",d.zlibDeflateData="zlibDeflateData",d.zlibDeflateWrite="zlibDeflateWrite",d.zlibDeflateFlushFired="zlibDeflateFlushFired",d.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",d.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",d.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",d.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",d.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",d.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",d.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",d.ProtocolHeaderRead="protocolHeaderRead",d.ProtocolMessageRead="protocolMessageRead",d.ProtocolHeaderWrite="protocolHeaderWrite",d.ProtocolMessageWrite="protocolMessageWrite",d.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var v;(function(d){d.enableDiagnostics=!1,d.records=[];const l=new WeakMap;let u=0;function w(b,m){if(!l.has(b)){const y=String(++u);l.set(b,y)}return l.get(b)}function I(b,m,y,L){if(!d.enableDiagnostics)return;const N=w(b,m);if(L instanceof C.$ke||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const U=C.$ke.alloc(L.byteLength);U.set(L),d.records.push({timestamp:Date.now(),id:N,label:m,type:y,buff:U})}else d.records.push({timestamp:Date.now(),id:N,label:m,type:y,data:L})}d.traceSocketEvent=I})(v||(e.SocketDiagnostics=v={}));var $;(function(d){d[d.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",d[d.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let E=null;function R(){return E||(E=C.$ke.alloc(0)),E}class D{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,u){if(l===0)return R();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const m=this.a[0];return u&&(this.a.shift(),this.b-=l),m}if(this.a[0].byteLength>l){const m=this.a[0].slice(0,l);return u&&(this.a[0]=this.a[0].slice(l),this.b-=l),m}const w=C.$ke.alloc(l);let I=0,b=0;for(;l>0;){const m=this.a[b];if(m.byteLength>l){const y=m.slice(0,l);w.set(y,I),I+=l,u&&(this.a[b]=m.slice(l),this.b-=l),l-=l}else w.set(m,I),I+=m.byteLength,u?(this.a.shift(),this.b-=m.byteLength):b++,l-=m.byteLength}return w}}e.$Qh=D;var p;(function(d){d[d.None=0]="None",d[d.Regular=1]="Regular",d[d.Control=2]="Control",d[d.Ack=3]="Ack",d[d.Disconnect=5]="Disconnect",d[d.ReplayRequest=6]="ReplayRequest",d[d.Pause=7]="Pause",d[d.Resume=8]="Resume",d[d.KeepAlive=9]="KeepAlive"})(p||(p={}));function k(d){switch(d){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(d){d[d.HeaderLength=13]="HeaderLength",d[d.AcknowledgeTime=2e3]="AcknowledgeTime",d[d.TimeoutTime=2e4]="TimeoutTime",d[d.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",d[d.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",d[d.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class c{constructor(l,u,w,I){this.type=l,this.id=u,this.ack=w,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends f.$Tc{constructor(l){super(),this.f=this.B(new F.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new D,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const w=this.g.messageType,I=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new c(w,I,b,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=C.$ke.alloc(13);u.writeUInt8(l.type,0),u.writeUInt32BE(l.id,1),u.writeUInt32BE(l.ack,5),u.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:k(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(u,l.data)}g(l,u){const w=this.f===0;return this.d.push(l,u),this.f+=l.byteLength+u.byteLength,w}h(){const l=C.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,u){this.g(l,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends f.$Tc{constructor(l){super(),this.f=new F.$Wd,this.onMessage=this.f.event,this.g=new F.$Wd,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new o(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new c(1,0,0,l))}}e.$Rh=i;class r extends P.$Lh{static fromSocket(l,u){return new r(new i(l),u)}get onDidDispose(){return this.b.onDidDispose}constructor(l,u,w=null){super(l,u,w),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$Sh=r;class n{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$Th=n;class a{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,u=this.a;for(;u;)u=u.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let u=0,w=this.a;for(;w;)l[u++]=w.data,w=w.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const u=new a(l);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class h{static{this.a=10}static{this.b=null}static getInstance(){return h.b||(h.b=new h),h.b}constructor(){this.c=[];const l=Date.now();for(let u=0;u<h.a;u++)this.c[u]=l-1e3*u;setInterval(()=>{for(let u=h.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),u=(1+h.a)*1e3;let w=0;for(let I=0;I<h.a;I++)l-this.c[I]<=u&&w++;return 1-w/h.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new n,this.onControlMessage=this.u.event,this.v=new n,this.onMessage=this.v.event,this.w=new n,this.onDidDispose=this.w.event,this.x=new n,this.onSocketClose=this.x.event,this.y=new n,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??h.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Sc,this.o=l.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new c(5,0,0,R());this.p.write(l),this.p.flush()}sendPause(){const l=new c(7,0,0,R());this.p.write(l)}sendResume(){const l=new c(8,0,0,R());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,u){this.a=!0,this.r.dispose(),this.r=new f.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new c(3,0,this.h,R());this.p.write(l);const u=this.b.toArray();for(let w=0,I=u.length;w<I;w++)this.p.write(u[w]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const u=this.b.peek();if(u&&u.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new c(6,0,0,R())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let w=0,I=u.length;w<I;w++)this.p.write(u[w]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const u=++this.c;this.h=this.g;const w=new c(1,u,this.h,l);this.b.push(w),this.a||(this.p.write(w),this.B())}sendControl(l){const u=new c(2,0,0,l);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),u=Date.now()-l.writtenTime,w=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(u>=2e4&&w>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:w});return}const b=Math.max(2e4-u,2e4-w,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new c(3,0,this.h,R());this.p.write(l)}D(){this.h=this.g;const l=new c(9,0,this.h,R());this.p.write(l)}}e.$Uh=s}),define(Ee[187],Se([1,0,50,11,22,21,185,14,4,3,24,105,102,81]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;class S extends k.$Ih{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>f.$ke.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$rq=S;class c{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Wd,this.onDidProcessExit=this.h.event;const r=i&&i.timeout?i.timeout:6e4;this.b=new F.$4g(r),this.d=null,this.f=null}getChannel(o){const i=this;return{call(r,n,a){return i.k(o,r,n,a)},listen(r,n){return i.l(o,r,n)}}}k(o,i,r,n=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(v.$6());this.b.cancel();const a=this.n(o),t=(0,F.$Ug)(d=>a.call(i,r,d)),h=n.onCancellationRequested(()=>t.cancel()),s=(0,E.$Rc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{h.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,r){if(!this.b)return $.Event.None;this.b.cancel();let n;const a=new $.$Wd({onWillAddFirstListener:()=>{n=this.n(o).listen(i,r)(a.fire,a),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,R.$wn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,p.$Tl)(i.env),this.d=(0,C.fork)(this.i,o,i);const r=new $.$Wd;$.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,A.$nq)(l)){(0,A.log)(l,`IPC Library: ${this.j.serverName}`);return}r.fire(f.$ke.wrap(Buffer.from(l,"base64")))});const a=this.j.useQueue?(0,D.$Vl)(this.d):this.d,t=l=>this.d&&this.d.connected&&a.send(l.buffer.toString("base64")),h=r.event,s={send:t,onMessage:h};this.f=new k.$Jh(s);const d=()=>this.o();process.once("exit",d),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,u)=>{process.removeListener("exit",d),this.c.forEach(w=>(0,E.$Oc)(w)),this.c.clear(),l!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:u})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$sq=c}),define(Ee[188],Se([1,0,11,4,3,56,18]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.StorageState=e.$qp=e.StorageHint=void 0;var v;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function $(p){const k=p;return k?.changed instanceof Map||k?.deleted instanceof Set}e.$qp=$;var E;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(E||(e.StorageState=E={}));class R extends f.$Tc{static{this.a=100}constructor(k,S=Object.create(null)){super(),this.r=k,this.s=S,this.b=this.B(new F.$Zd),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new C.$5g(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((S,c)=>this.w(c,S)),k.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(k,S){if(this.c===E.Closed)return;let c=!1;(0,A.$Sf)(S)?c=this.f.delete(k):this.f.get(k)!==S&&(this.f.set(k,S),c=!0),c&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,S){const c=this.f.get(k);return(0,A.$Sf)(c)?S:c}getBoolean(k,S){const c=this.get(k);return(0,A.$Sf)(c)?S:c==="true"}getNumber(k,S){const c=this.get(k);return(0,A.$Sf)(c)?S:parseInt(c,10)}getObject(k,S){const c=this.get(k);return(0,A.$Sf)(c)?S:(0,P.$Ch)(c)}async set(k,S,c=!1){if(this.c===E.Closed)return;if((0,A.$Sf)(S))return this.delete(k,c);const g=(0,A.$Lf)(S)||Array.isArray(S)?(0,P.$Bh)(S):String(S);if(this.f.get(k)!==g)return this.f.set(k,g),this.j.set(k,g),this.h.delete(k),this.b.fire({key:k,external:c}),this.D()}async delete(k,S=!1){if(!(this.c===E.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:S}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(this.z)return this.D(k)}async D(k){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$rp=R;class D{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((S,c)=>this.a.set(c,S)),k.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$sp=D}),define(Ee[189],Se([1,0,12,10,22]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=void 0;let P;function A(){return P||(P=new TextDecoder("UTF-16LE")),P}let v;function $(){return v||(v=new TextDecoder("UTF-16BE")),v}let E;function R(){return E||(E=F.$D()?A():$()),E}e.$bt=R;function D(S,c,g){const o=new Uint16Array(S.buffer,c,g);return g>0&&(o[0]===65279||o[0]===65534)?p(S,c,g):A().decode(o)}e.$ct=D;function p(S,c,g){const o=[];let i=0;for(let r=0;r<g;r++){const n=f.$me(S,c);c+=2,o[i++]=String.fromCharCode(n)}return o.join("")}class k{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return R().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const g=this.a-this.d;g<=1&&(g===0||C.$ef(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const g=c.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=c;return}for(let o=0;o<g;o++)this.b[this.d++]=c.charCodeAt(o)}}e.$dt=k}),define(Ee[190],Se([1,0,22,189]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=void 0;function f($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,R,D,p){this.oldPosition=E,this.oldText=R,this.newPosition=D,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,R,D){const p=R.length;C.$pe(E,p,D),D+=4;for(let k=0;k<p;k++)C.$ne(E,R.charCodeAt(k),D),D+=2;return D}static d(E,R){const D=C.$oe(E,R);return R+=4,(0,F.$ct)(E,R,D)}writeSize(){return 4+4+P.a(this.oldText)+P.a(this.newText)}write(E,R){return C.$pe(E,this.oldPosition,R),R+=4,C.$pe(E,this.newPosition,R),R+=4,R=P.c(E,this.oldText,R),R=P.c(E,this.newText,R),R}static read(E,R,D){const p=C.$oe(E,R);R+=4;const k=C.$oe(E,R);R+=4;const S=P.d(E,R);R+=P.a(S);const c=P.d(E,R);return R+=P.a(c),D.push(new P(p,S,k,c)),R}}e.$et=P;function A($,E){return $===null||$.length===0?E:new v($,E).compress()}e.$ft=A;class v{constructor(E,R){this.a=E,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,R=0,D=this.n(E),p=this.l(R);for(;E<this.f||R<this.h;){if(D===null){this.k(p),p=this.l(++R);continue}if(p===null){this.m(D),D=this.n(++E);continue}if(p.oldEnd<=D.newPosition){this.k(p),p=this.l(++R);continue}if(D.newEnd<=p.oldPosition){this.m(D),D=this.n(++E);continue}if(p.oldPosition<D.newPosition){const[o,i]=v.r(p,D.newPosition-p.oldPosition);this.k(o),p=i;continue}if(D.newPosition<p.oldPosition){const[o,i]=v.q(D,p.oldPosition-D.newPosition);this.m(o),D=i;continue}let c,g;if(p.oldEnd===D.newEnd)c=D,g=p,D=this.n(++E),p=this.l(++R);else if(p.oldEnd<D.newEnd){const[o,i]=v.q(D,p.oldLength);c=o,g=p,D=i,p=this.l(++R)}else{const[o,i]=v.r(p,D.newLength);c=D,g=o,D=this.n(++E),p=i}this.d[this.e++]=new P(c.oldPosition,c.oldText,g.newPosition,g.newText),this.g+=c.newLength-c.oldLength,this.j+=g.newLength-g.oldLength}const k=v.s(this.d);return v.t(k)}k(E){this.d[this.e++]=v.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=v.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,R){return new P(R.oldPosition-E,R.oldText,R.newPosition,R.newText)}static p(E,R){return new P(R.oldPosition,R.oldText,R.newPosition+E,R.newText)}static q(E,R){const D=E.newText.substr(0,R),p=E.newText.substr(R);return[new P(E.oldPosition,E.oldText,E.newPosition,D),new P(E.oldEnd,"",E.newPosition+R,p)]}static r(E,R){const D=E.oldText.substr(0,R),p=E.oldText.substr(R);return[new P(E.oldPosition,D,E.newPosition,E.newText),new P(E.oldPosition+R,p,E.newEnd,"")]}static s(E){if(E.length===0)return E;const R=[];let D=0,p=E[0];for(let k=1;k<E.length;k++){const S=E[k];p.oldEnd===S.oldPosition?p=new P(p.oldPosition,p.oldText+S.oldText,p.newPosition,p.newText+S.newText):(R[D++]=p,p=S)}return R[D++]=p,R}static t(E){if(E.length===0)return E;const R=[];let D=0;for(let p=0;p<E.length;p++){const k=E[p];k.oldText!==k.newText&&(R[D++]=k)}return R}}}),define(Ee[191],Se([1,0,35,17]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=void 0;function f(P,A,v,$,E,R){if(Array.isArray(P)){let D=0;for(const p of P){const k=f(p,A,v,$,E,R);if(k===10)return k;k>D&&(D=k)}return D}else{if(typeof P=="string")return $?P==="*"?5:P===v?10:0:0;if(P){const{language:D,pattern:p,scheme:k,hasAccessToAllModels:S,notebookType:c}=P;if(!$&&!S)return 0;c&&E&&(A=E);let g=0;if(k)if(k===A.scheme)g=10;else if(k==="*")g=5;else return 0;if(D)if(D===v)g=10;else if(D==="*")g=Math.max(g,5);else return 0;if(c)if(c===R)g=10;else if(c==="*"&&R!==void 0)g=Math.max(g,5);else return 0;if(p){let o;if(typeof p=="string"?o=p:o={...p,base:(0,F.$hc)(p.base)},o===A.fsPath||(0,C.$Mj)(o,A.fsPath))g=10;else return 0}return g}else return 0}}e.$Ct=f}),define(Ee[192],Se([1,0,4,12,29,79,127,167,190,3]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class R extends E.$Tc{constructor(p,k,S,c,g,o,i){super(),this.m=this.B(new C.$Wd),this.onDidChangeContent=this.m.event,this.f=k,this.j=!o,this.g=c,this.h=g,this.c=new A.$bC(p,S,i)}equals(p){return!(p instanceof R)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,k){return this.c.getOffsetAt(p,k)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,k){const S=p+k,c=this.getPositionAt(p),g=this.getPositionAt(S);return new f.$Vs(c.lineNumber,c.column,g.lineNumber,g.column)}getValueInRange(p,k=0){if(p.isEmpty())return"";const S=this.n(k);return this.c.getValueInRange(p,S)}getValueLengthInRange(p,k=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const S=this.getOffsetAt(p.startLineNumber,p.startColumn),c=this.getOffsetAt(p.endLineNumber,p.endColumn);let g=0;const o=this.n(k),i=this.getEOL();if(o.length!==i.length){const r=o.length-i.length,n=p.endLineNumber-p.startLineNumber;g=r*n}return c-S+g}getCharacterCountInRange(p,k=0){if(this.j){let S=0;const c=p.startLineNumber,g=p.endLineNumber;for(let o=c;o<=g;o++){const i=this.getLineContent(o),r=o===c?p.startColumn-1:0,n=o===g?p.endColumn-1:i.length;for(let a=r;a<n;a++)F.$ef(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(k).length*(g-c),S}return this.getValueLengthInRange(p,k)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,k){return this.c.getLineCharCode(p,k)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const k=F.$2e(this.getLineContent(p));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(p){const k=F.$4e(this.getLineContent(p));return k===-1?0:k+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,k,S){let c=this.g,g=this.h,o=this.j,i=!0,r=[];for(let l=0;l<p.length;l++){const u=p[l];i&&u._isTracked&&(i=!1);const w=u.range;if(u.text){let L=!0;o||(L=!F.$pf(u.text),o=L),!c&&L&&(c=F.$of(u.text)),!g&&L&&(g=F.$rf(u.text))}let I="",b=0,m=0,y=0;if(u.text){let L;[b,m,y,L]=(0,v.$vt)(u.text);const N=this.getEOL();L===0||L===(N===`\r
`?2:1)?I=u.text:I=u.text.replace(/\r\n|\r|\n/g,N)}r[l]={sortIndex:l,identifier:u.identifier||null,range:w,rangeOffset:this.getOffsetAt(w.startLineNumber,w.startColumn),rangeLength:this.getValueLengthInRange(w),text:I,eolCount:b,firstLineLength:m,lastLineLength:y,forceMoveMarkers:!!u.forceMoveMarkers,isAutoWhitespaceEdit:u.isAutoWhitespaceEdit||!1}}r.sort(R.u);let n=!1;for(let l=0,u=r.length-1;l<u;l++){const w=r[l].range.getEndPosition(),I=r[l+1].range.getStartPosition();if(I.isBeforeOrEqual(w)){if(I.isBefore(w))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(r=this.s(r));const a=S||k?R._getInverseEditRanges(r):[],t=[];if(k)for(let l=0;l<r.length;l++){const u=r[l],w=a[l];if(u.isAutoWhitespaceEdit&&u.range.isEmpty())for(let I=w.startLineNumber;I<=w.endLineNumber;I++){let b="";I===w.startLineNumber&&(b=this.getLineContent(u.range.startLineNumber),F.$2e(b)!==-1)||t.push({lineNumber:I,oldContent:b})}}let h=null;if(S){let l=0;h=[];for(let u=0;u<r.length;u++){const w=r[u],I=a[u],b=this.getValueInRange(w.range),m=w.rangeOffset+l;l+=w.text.length-b.length,h[u]={sortIndex:w.sortIndex,identifier:w.identifier,range:I,text:b,textChange:new $.$et(w.rangeOffset,b,m,w.text)}}n||h.sort((u,w)=>u.sortIndex-w.sortIndex)}this.g=c,this.h=g,this.j=o;const s=this.t(r);let d=null;if(k&&t.length>0){t.sort((l,u)=>u.lineNumber-l.lineNumber),d=[];for(let l=0,u=t.length;l<u;l++){const w=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===w)continue;const I=t[l].oldContent,b=this.getLineContent(w);b.length===0||b===I||F.$2e(b)!==-1||d.push(w)}}return this.m.fire(),new P.$fv(h,s,d)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let k=!1;const S=p[0].range,c=p[p.length-1].range,g=new f.$Vs(S.startLineNumber,S.startColumn,c.endLineNumber,c.endColumn);let o=S.startLineNumber,i=S.startColumn;const r=[];for(let s=0,d=p.length;s<d;s++){const l=p[s],u=l.range;k=k||l.forceMoveMarkers,r.push(this.getValueInRange(new f.$Vs(o,i,u.startLineNumber,u.startColumn))),l.text.length>0&&r.push(l.text),o=u.endLineNumber,i=u.endColumn}const n=r.join(""),[a,t,h]=(0,v.$vt)(n);return{sortIndex:0,identifier:p[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:n,eolCount:a,firstLineLength:t,lastLineLength:h,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(p){p.sort(R.w);const k=[];for(let S=0;S<p.length;S++){const c=p[S],g=c.range.startLineNumber,o=c.range.startColumn,i=c.range.endLineNumber,r=c.range.endColumn;if(g===i&&o===r&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const n=new f.$Vs(g,o,i,r);k.push({range:n,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return k}findMatchesLineByLine(p,k,S,c){return this.c.findMatchesLineByLine(p,k,S,c)}getPieceTree(){return this.c}static _getInverseEditRange(p,k){const S=p.startLineNumber,c=p.startColumn,[g,o,i]=(0,v.$vt)(k);let r;if(k.length>0){const n=g+1;n===1?r=new f.$Vs(S,c,S,c+o):r=new f.$Vs(S,c,S+n-1,i+1)}else r=new f.$Vs(S,c,S,c);return r}static _getInverseEditRanges(p){const k=[];let S=0,c=0,g=null;for(let o=0,i=p.length;o<i;o++){const r=p[o];let n,a;g?g.range.endLineNumber===r.range.startLineNumber?(n=S,a=c+(r.range.startColumn-g.range.endColumn)):(n=S+(r.range.startLineNumber-g.range.endLineNumber),a=r.range.startColumn):(n=r.range.startLineNumber,a=r.range.startColumn);let t;if(r.text.length>0){const h=r.eolCount+1;h===1?t=new f.$Vs(n,a,n,a+r.firstLineLength):t=new f.$Vs(n,a,n+h-1,r.lastLineLength+1)}else t=new f.$Vs(n,a,n,a);S=t.endLineNumber,c=t.endColumn,k.push(t),g=r}return k}static u(p,k){const S=f.$Vs.compareRangesUsingEnds(p.range,k.range);return S===0?p.sortIndex-k.sortIndex:S}static w(p,k){const S=f.$Vs.compareRangesUsingEnds(p.range,k.range);return S===0?k.sortIndex-p.sortIndex:-S}}e.$cC=R}),define(Ee[193],Se([1,0,12,127,192]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class P{constructor($,E,R,D,p,k,S,c,g){this.a=$,this.b=E,this.c=R,this.d=D,this.e=p,this.f=k,this.g=S,this.h=c,this.j=g}k($){const E=this.c+this.d+this.e,R=this.c+this.e;return E===0?$===1?`
`:`\r
`:R>E/2?`\r
`:`
`}create($){const E=this.k($),R=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let p=0,k=R.length;p<k;p++){const S=R[p].buffer.replace(/\r\n|\r|\n/g,E),c=(0,F.$0B)(S);R[p]=new F.$aC(S,c)}const D=new f.$cC(R,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&C.$xf($)&&(this.b=C.$wf,$=$.substr(1));const E=$.charCodeAt($.length-1);E===13||E>=55296&&E<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=E):(this.m($,!1),this.c=!1,this.d=E)}m($,E){!E&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const E=(0,F.$$B)(this.e,$);this.a.push(new F.$aC($,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=C.$of($)),this.k||(this.k=C.$rf($)))}finish($=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const E=(0,F.$0B)($.buffer);$.lineStarts=E,this.d===13&&this.f++}}}e.$dC=A}),define(Ee[131],Se([1,0,22,10]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$=e.$G$=void 0;var f;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(f||(f={}));function P(D){for(let p=0,k=D.length;p<k;p+=4){const S=D[p+0],c=D[p+1],g=D[p+2],o=D[p+3];D[p+0]=o,D[p+1]=g,D[p+2]=c,D[p+3]=S}}function A(D){const p=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return F.$D()||P(p),C.$ke.wrap(p)}function v(D){const p=D.buffer;if(F.$D()||P(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const k=new Uint8Array(p.byteLength);return k.set(p),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function $(D){const p=new Uint32Array(E(D));let k=0;if(p[k++]=D.id,D.type==="full")p[k++]=1,p[k++]=D.data.length,p.set(D.data,k),k+=D.data.length;else{p[k++]=2,p[k++]=D.deltas.length;for(const S of D.deltas)p[k++]=S.start,p[k++]=S.deleteCount,S.data?(p[k++]=S.data.length,p.set(S.data,k),k+=S.data.length):p[k++]=0}return A(p)}e.$G$=$;function E(D){let p=0;if(p+=1+1,D.type==="full")p+=1+D.data.length;else{p+=1,p+=(1+1+1)*D.deltas.length;for(const k of D.deltas)k.data&&(p+=k.data.length)}return p}function R(D){const p=v(D);let k=0;const S=p[k++];if(p[k++]===1){const i=p[k++],r=p.subarray(k,k+i);return k+=i,{id:S,type:"full",data:r}}const g=p[k++],o=[];for(let i=0;i<g;i++){const r=p[k++],n=p[k++],a=p[k++];let t;a>0&&(t=p.subarray(k,k+a),k+=a),o[i]={start:r,deleteCount:n,data:t}}return{id:S,type:"delta",deltas:o}}e.$H$=R}),define(Ee[194],Se([8,9]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Ee[132],Se([1,0,19,24,10,170,126,194]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=E;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class D{constructor(se,Ce,Ve,Xe){this.id=se,this.name=Ce,this.defaultValue=Ve,this.schema=Xe}applyUpdate(se,Ce){return k(se,Ce)}compute(se,Ce,Ve){return Ve}}class p{constructor(se,Ce){this.newValue=se,this.didChange=Ce}}e.ApplyUpdateResult=p;function k(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new p(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const Ve=Array.isArray(re)&&Array.isArray(se)&&C.$ub(re,se);return new p(se,!Ve)}let Ce=!1;for(const Ve in se)if(se.hasOwnProperty(Ve)){const Xe=k(re[Ve],se[Ve]);Xe.didChange&&(re[Ve]=Xe.newValue,Ce=!0)}return new p(re,Ce)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ce){return k(se,Ce)}validate(se){return this.defaultValue}}class c{constructor(se,Ce,Ve,Xe){this.id=se,this.name=Ce,this.defaultValue=Ve,this.schema=Xe}applyUpdate(se,Ce){return k(se,Ce)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ce,Ve){return Ve}}function g(re,se){return typeof re>"u"?se:re==="false"?!1:!!re}e.boolean=g;class o extends c{constructor(se,Ce,Ve,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=Ve),super(se,Ce,Ve,Xe)}validate(se){return g(se,this.defaultValue)}}function i(re,se,Ce,Ve){if(typeof re>"u")return se;let Xe=parseInt(re,10);return isNaN(Xe)?se:(Xe=Math.max(Ce,Xe),Xe=Math.min(Ve,Xe),Xe|0)}e.clampedInt=i;class r extends c{static clampedInt(se,Ce,Ve,Xe){return i(se,Ce,Ve,Xe)}constructor(se,Ce,Ve,Xe,it,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ve,nt.minimum=Xe,nt.maximum=it),super(se,Ce,Ve,nt),this.minimum=Xe,this.maximum=it}validate(se){return r.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function n(re,se,Ce,Ve){if(typeof re>"u")return se;const Xe=a.float(re,se);return a.clamp(Xe,Ce,Ve)}e.clampedFloat=n;class a extends c{static clamp(se,Ce,Ve){return se<Ce?Ce:se>Ve?Ve:se}static float(se,Ce){if(typeof se=="number")return se;if(typeof se>"u")return Ce;const Ve=parseFloat(se);return isNaN(Ve)?Ce:Ve}constructor(se,Ce,Ve,Xe,it){typeof it<"u"&&(it.type="number",it.default=Ve),super(se,Ce,Ve,it),this.validationFn=Xe}validate(se){return this.validationFn(a.float(se,this.defaultValue))}}class t extends c{static string(se,Ce){return typeof se!="string"?Ce:se}constructor(se,Ce,Ve,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=Ve),super(se,Ce,Ve,Xe)}validate(se){return t.string(se,this.defaultValue)}}function h(re,se,Ce,Ve){return typeof re!="string"?se:Ve&&re in Ve?Ve[re]:Ce.indexOf(re)===-1?se:re}e.stringSet=h;class s extends c{constructor(se,Ce,Ve,Xe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Xe,it.default=Ve),super(se,Ce,Ve,it),this.c=Xe}validate(se){return h(se,this.defaultValue,this.c)}}class d extends D{constructor(se,Ce,Ve,Xe,it,nt,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=it,Oe.default=Xe),super(se,Ce,Ve,Oe),this.c=it,this.d=nt}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function l(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",tags:["accessibility"],description:v.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ce,Ve){return Ve===0?se.accessibilitySupport:Ve}}class w extends D{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:v.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{insertSpace:g(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function b(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function y(re){switch(re){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function L(re){switch(re){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class N extends S{constructor(){super(140)}compute(se,Ce,Ve){const Xe=["monaco-editor"];return Ce.get(39)&&Xe.push(Ce.get(39)),se.extraEditorClassName&&Xe.push(se.extraEditorClassName),Ce.get(73)==="default"?Xe.push("mouse-default"):Ce.get(73)==="copy"&&Xe.push("mouse-copy"),Ce.get(110)&&Xe.push("showUnused"),Ce.get(138)&&Xe.push("showDeprecated"),Xe.join(" ")}}class U extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(se,Ce,Ve){return Ve&&se.emptySelectionClipboard}}class T extends D{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[v.localize(8,null),v.localize(9,null),v.localize(10,null)],description:v.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[v.localize(12,null),v.localize(13,null),v.localize(14,null)],description:v.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:v.localize(16,null),included:f.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:v.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:v.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{cursorMoveOnType:g(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":h(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":h(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ce.loop,this.defaultValue.loop)}}}class O extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:v.localize(19,null)},{type:"string",description:v.localize(20,null)}],description:v.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?O.OFF:se==="true"?O.ON:se:se?O.ON:O.OFF}}e.EditorFontLigatures=O;class M extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:v.localize(22,null)},{type:"string",description:v.localize(23,null)}],description:v.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?M.OFF:se==="true"?M.TRANSLATE:se:se?M.TRANSLATE:M.OFF}compute(se,Ce,Ve){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class j extends S{constructor(){super(50)}compute(se,Ce,Ve){return se.fontInfo}}class z extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(25,null)})}validate(se){const Ce=a.float(se,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ce,6,100)}compute(se,Ce,Ve){return se.fontInfo.fontSize}}class J extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:J.d,maximum:J.e,errorMessage:v.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:J.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(r.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,J.d,J.e))}}class le extends D{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[v.localize(28,null),v.localize(29,null),v.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:v.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:v.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:v.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:v.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:v.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ve,description:v.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ve,description:v.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ve,description:v.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ve,description:v.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ve,description:v.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{multiple:h(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??h(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??h(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??h(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??h(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??h(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Y extends D{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:v.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:v.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:v.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:v.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:v.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),delay:r.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:g(Ce.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Ce.above,this.defaultValue.above)}}}var Q;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class X extends S{constructor(){super(143)}compute(se,Ce,Ve){return X.computeLayout(Ce,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const Ce=se.height/se.lineHeight,Ve=Math.floor(se.paddingTop/se.lineHeight);let Xe=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Xe=Math.max(Xe,Ce-1));const it=(Ve+se.viewLineCount+Xe)/(se.pixelRatio*se.height),nt=Math.floor(se.viewLineCount/it);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Xe,desiredRatio:it,minimapLineCount:nt}}static c(se,Ce){const Ve=se.outerWidth,Xe=se.outerHeight,it=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const nt=Ce.stableMinimapLayoutInput,Oe=nt&&se.outerHeight===nt.outerHeight&&se.lineHeight===nt.lineHeight&&se.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&se.pixelRatio===nt.pixelRatio&&se.scrollBeyondLastLine===nt.scrollBeyondLastLine&&se.paddingTop===nt.paddingTop&&se.paddingBottom===nt.paddingBottom&&se.minimap.enabled===nt.minimap.enabled&&se.minimap.side===nt.minimap.side&&se.minimap.size===nt.minimap.size&&se.minimap.showSlider===nt.minimap.showSlider&&se.minimap.renderCharacters===nt.minimap.renderCharacters&&se.minimap.maxColumn===nt.minimap.maxColumn&&se.minimap.scale===nt.minimap.scale&&se.verticalScrollbarWidth===nt.verticalScrollbarWidth&&se.isViewportWrapping===nt.isViewportWrapping,yt=se.lineHeight,Dt=se.typicalHalfwidthCharacterWidth,Ft=se.scrollBeyondLastLine,Tt=se.minimap.renderCharacters;let kt=it>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Ht=se.minimap.maxColumn,Ot=se.minimap.size,Xt=se.minimap.side,qt=se.verticalScrollbarWidth,zt=se.viewLineCount,et=se.remainingWidth,Gt=se.isViewportWrapping,Jt=Tt?2:3;let ht=Math.floor(it*Xe);const $t=ht/it;let Bt=!1,Qt=!1,Et=Jt*kt,ft=kt/it,It=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Nt,extraLinesBeyondLastLine:At,desiredRatio:Wt,minimapLineCount:Me}=X.computeContainedMinimapLineCount({viewLineCount:zt,scrollBeyondLastLine:Ft,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Xe,lineHeight:yt,pixelRatio:it});if(zt/Me>1)Bt=!0,Qt=!0,kt=1,Et=1,ft=kt/it;else{let De=!1,ce=kt+1;if(Ot==="fit"){const Fe=Math.ceil((Nt+zt+At)*Et);Gt&&Oe&&et<=Ce.stableFitRemainingWidth?(De=!0,ce=Ce.stableFitMaxMinimapScale):De=Fe>ht}if(Ot==="fill"||De){Bt=!0;const Fe=kt;Et=Math.min(yt*it,Math.max(1,Math.floor(1/Wt))),Gt&&Oe&&et<=Ce.stableFitRemainingWidth&&(ce=Ce.stableFitMaxMinimapScale),kt=Math.min(ce,Math.max(1,Math.floor(Et/Jt))),kt>Fe&&(It=Math.min(2,kt/Fe)),ft=kt/it/It,ht=Math.ceil(Math.max(gt,Nt+zt+At)*Et),Gt?(Ce.stableMinimapLayoutInput=se,Ce.stableFitRemainingWidth=et,Ce.stableFitMaxMinimapScale=kt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const _t=Math.floor(Ht*ft),Lt=Math.min(_t,Math.max(0,Math.floor((et-qt-2)*ft/(Dt+ft)))+e.MINIMAP_GUTTER_WIDTH);let Je=Math.floor(it*Lt);const Mt=Je/it;Je=Math.floor(Je*It);const jt=Tt?1:2,Zt=Xt==="left"?0:Ve-Lt-qt;return{renderMinimap:jt,minimapLeft:Zt,minimapWidth:Lt,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Qt,minimapScale:kt,minimapLineHeight:Et,minimapCanvasInnerWidth:Je,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:$t}}static computeLayout(se,Ce){const Ve=Ce.outerWidth|0,Xe=Ce.outerHeight|0,it=Ce.lineHeight|0,nt=Ce.lineNumbersDigitCount|0,Oe=Ce.typicalHalfwidthCharacterWidth,yt=Ce.maxDigitWidth,Dt=Ce.pixelRatio,Ft=Ce.viewLineCount,Tt=se.get(135),kt=Tt==="inherit"?se.get(134):Tt,Ht=kt==="inherit"?se.get(130):kt,Ot=se.get(133),Xt=Ce.isDominatedByLongLines,qt=se.get(57),zt=se.get(67).renderType!==0,et=se.get(68),Gt=se.get(104),Jt=se.get(83),ht=se.get(72),$t=se.get(102),Bt=$t.verticalScrollbarSize,Qt=$t.verticalHasArrows,Et=$t.arrowSize,ft=$t.horizontalScrollbarSize,It=se.get(43),_t=se.get(109)!=="never";let Lt=se.get(65);It&&_t&&(Lt+=16);let Je=0;if(zt){const xe=Math.max(nt,et);Je=Math.round(xe*yt)}let Mt=0;qt&&(Mt=it*Ce.glyphMarginDecorationLaneCount);let jt=0,Zt=jt+Mt,gt=Zt+Je,Nt=gt+Lt;const At=Ve-Mt-Je-Lt;let Wt=!1,Me=!1,Te=-1;kt==="inherit"&&Xt?(Wt=!0,Me=!0):Ht==="on"||Ht==="bounded"?Me=!0:Ht==="wordWrapColumn"&&(Te=Ot);const De=X.c({outerWidth:Ve,outerHeight:Xe,lineHeight:it,typicalHalfwidthCharacterWidth:Oe,pixelRatio:Dt,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:ht,verticalScrollbarWidth:Bt,viewLineCount:Ft,remainingWidth:At,isViewportWrapping:Me},Ce.memory||new R);De.renderMinimap!==0&&De.minimapLeft===0&&(jt+=De.minimapWidth,Zt+=De.minimapWidth,gt+=De.minimapWidth,Nt+=De.minimapWidth);const ce=At-De.minimapWidth,Fe=Math.max(1,Math.floor((ce-Bt-2)/Oe)),Be=Qt?Et:0;return Me&&(Te=Math.max(1,Fe),Ht==="bounded"&&(Te=Math.min(Te,Ot))),{width:Ve,height:Xe,glyphMarginLeft:jt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Zt,lineNumbersWidth:Je,decorationsLeft:gt,decorationsWidth:Lt,contentLeft:Nt,contentWidth:ce,minimap:De,viewportColumn:Fe,isWordWrapMinified:Wt,isViewportWrapping:Me,wrappingColumn:Te,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:ft,overviewRuler:{top:Be,width:Bt,height:Xe-2*Be,right:0}}}}e.EditorLayoutInfoComputer=X;class ue extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[v.localize(47,null),v.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:v.localize(49,null)}})}validate(se){return h(se,"simple",["simple","advanced"])}compute(se,Ce,Ve){return Ce.get(2)===2?"advanced":Ve}}var ne;(function(re){re.Off="off",re.OnCode="onCode",re.On="on"})(ne||(e.ShowLightbulbIconMode=ne={}));class $e extends D{constructor(){const se={enabled:ne.OnCode};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ne.Off,ne.OnCode,ne.On],default:se.enabled,enumDescriptions:[v.localize(50,null),v.localize(51,null),v.localize(52,null)],description:v.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:h(se.enabled,this.defaultValue.enabled,[ne.Off,ne.OnCode,ne.On])}}}class oe extends D{constructor(){const se={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:v.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:v.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:v.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:v.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:h(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends D{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:v.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[v.localize(59,null),v.localize(60,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(61,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:v.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:v.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:v.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:h(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:g(Ce.padding,this.defaultValue.padding)}}}class W extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):r.clampedInt(se,this.defaultValue,0,1e3)}compute(se,Ce,Ve){return Ve<0?r.clampedInt(-Ve*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class ie extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>a.clamp(se,0,150),{markdownDescription:v.localize(66,null)})}compute(se,Ce,Ve){return se.fontInfo.lineHeight}}class ye extends D{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:v.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:v.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(69,null),v.localize(70,null),v.localize(71,null)],default:se.size,description:v.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:v.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:v.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:v.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:v.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),autohide:g(Ce.autohide,this.defaultValue.autohide),size:h(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Ce.side,this.defaultValue.side,["right","left"]),showSlider:h(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(Ce.scale,1,1,3),maxColumn:r.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(re){return re==="ctrlCmd"?f.$j?"metaKey":"ctrlKey":"altKey"}class fe extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{top:r.clampedInt(Ce.top,0,0,1e3),bottom:r.clampedInt(Ce.bottom,0,0,1e3)}}}class _ extends D{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:v.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:v.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),cycle:g(Ce.cycle,this.defaultValue.cycle)}}}class ee extends S{constructor(){super(141)}compute(se,Ce,Ve){return se.pixelRatio}}class G extends D{constructor(){const se={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[v.localize(82,null),v.localize(83,null),v.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:se.strings,description:v.localize(85,null)},comments:{anyOf:Ce,default:se.comments,description:v.localize(86,null)},other:{anyOf:Ce,default:se.other,description:v.localize(87,null)}},default:se,markdownDescription:v.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Dt=se?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ce,comments:Ve,strings:Xe}=se,it=["on","inline","off"];let nt,Oe,yt;return typeof Ce=="boolean"?nt=Ce?"on":"off":nt=h(Ce,this.defaultValue.other,it),typeof Ve=="boolean"?Oe=Ve?"on":"off":Oe=h(Ve,this.defaultValue.comments,it),typeof Xe=="boolean"?yt=Xe?"on":"off":yt=h(Xe,this.defaultValue.strings,it),{other:nt,comments:Oe,strings:yt}}}var x;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(x||(e.RenderLineNumbersType=x={}));class me extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(89,null),v.localize(90,null),v.localize(91,null),v.localize(92,null)],default:"on",description:v.localize(93,null)})}validate(se){let Ce=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ce=4,Ve=se):se==="interval"?Ce=3:se==="relative"?Ce=2:se==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ve}}}function we(re){const se=re.get(97);return se==="editable"?re.get(90):se!=="on"}e.filterValidationDecorations=we;class Ae extends D{constructor(){const se=[],Ce={type:"number",description:v.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:v.localize(95,null),format:"color-hex"}}}]},default:se,description:v.localize(96,null)})}validate(se){if(Array.isArray(se)){const Ce=[];for(const Ve of se)if(typeof Ve=="number")Ce.push({column:r.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Xe=Ve;Ce.push({column:r.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return Ce.sort((Ve,Xe)=>Ve.column-Xe.column),Ce}return this.defaultValue}}class ve extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Ie(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends D{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(97,null),v.localize(98,null),v.localize(99,null)],default:"auto",description:v.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(101,null),v.localize(102,null),v.localize(103,null)],default:"auto",description:v.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:v.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:v.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:v.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:v.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se,Ve=r.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=r.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:g(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:r.clampedInt(Ce.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:r.clampedInt(Ce.verticalSliderSize,Xe,0,1e3),scrollByPage:g(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends D{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:v.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:v.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:v.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:v.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:v.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:v.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:v.localize(115,null)}})}applyUpdate(se,Ce){let Ve=!1;Ce.allowedCharacters&&se&&(F.$An(se.allowedCharacters,Ce.allowedCharacters)||(se={...se,allowedCharacters:Ce.allowedCharacters},Ve=!0)),Ce.allowedLocales&&se&&(F.$An(se.allowedLocales,Ce.allowedLocales)||(se={...se,allowedLocales:Ce.allowedLocales},Ve=!0));const Xe=super.applyUpdate(se,Ce);return Ve?new p(Xe.newValue,!0):Xe}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{nonBasicASCII:he(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,Ce){if(typeof se!="object"||!se)return Ce;const Ve={};for(const[Xe,it]of Object.entries(se))it===!0&&(Ve[Xe]=!0);return Ve}}class te extends D{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:v.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[v.localize(117,null),v.localize(118,null),v.localize(119,null)],description:v.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:v.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:v.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),mode:h(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class V extends D{constructor(){const se={enabled:P.$ts.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$ts.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:v.localize(124,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ae extends D{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(125,null),v.localize(126,null),v.localize(127,null)],default:se.bracketPairs,description:v.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null)],default:se.bracketPairsHorizontal,description:v.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:v.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:v.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null)],default:se.highlightActiveIndentation,description:v.localize(138,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{bracketPairs:he(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(re,se,Ce){const Ve=Ce.indexOf(re);return Ve===-1?se:Ce[Ve]}class Re extends D{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(139,null),v.localize(140,null)],default:se.insertMode,description:v.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:v.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:v.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:v.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[v.localize(145,null),v.localize(146,null),v.localize(147,null),v.localize(148,null)],default:se.selectionMode,markdownDescription:v.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:v.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:v.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:v.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:v.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:v.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:v.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(186,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{insertMode:h(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ce.preview,this.defaultValue.preview),previewMode:h(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ce.showMethods,this.defaultValue.showMethods),showFunctions:g(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ce.showFields,this.defaultValue.showFields),showVariables:g(Ce.showVariables,this.defaultValue.showVariables),showClasses:g(Ce.showClasses,this.defaultValue.showClasses),showStructs:g(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ce.showModules,this.defaultValue.showModules),showProperties:g(Ce.showProperties,this.defaultValue.showProperties),showEvents:g(Ce.showEvents,this.defaultValue.showEvents),showOperators:g(Ce.showOperators,this.defaultValue.showOperators),showUnits:g(Ce.showUnits,this.defaultValue.showUnits),showValues:g(Ce.showValues,this.defaultValue.showValues),showConstants:g(Ce.showConstants,this.defaultValue.showConstants),showEnums:g(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ce.showKeywords,this.defaultValue.showKeywords),showWords:g(Ce.showWords,this.defaultValue.showWords),showColors:g(Ce.showColors,this.defaultValue.showColors),showFiles:g(Ce.showFiles,this.defaultValue.showFiles),showReferences:g(Ce.showReferences,this.defaultValue.showReferences),showFolders:g(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ce.showUsers,this.defaultValue.showUsers),showIssues:g(Ce.showIssues,this.defaultValue.showIssues)}}}class je extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:v.localize(188,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(se.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Qe extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[v.localize(189,null),v.localize(190,null),v.localize(191,null),v.localize(192,null)],description:v.localize(193,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,Ce,Ve){return Ce.get(2)===2?0:Ve}}class _e extends S{constructor(){super(144)}compute(se,Ce,Ve){const Xe=Ce.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class at extends D{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:v.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[v.localize(196,null),v.localize(197,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),showDropSelector:h(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends D{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:v.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[v.localize(200,null),v.localize(201,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),showPasteSelector:h(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$j?Pe:f.$k?Ue:rt,fontWeight:"normal",fontSize:f.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(re){return e.editorOptionsRegistry[re.id]=re,re}var Ze;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.ariaRequired=5]="ariaRequired",re[re.autoClosingBrackets=6]="autoClosingBrackets",re[re.autoClosingComments=7]="autoClosingComments",re[re.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",re[re.autoClosingDelete=9]="autoClosingDelete",re[re.autoClosingOvertype=10]="autoClosingOvertype",re[re.autoClosingQuotes=11]="autoClosingQuotes",re[re.autoIndent=12]="autoIndent",re[re.automaticLayout=13]="automaticLayout",re[re.autoSurround=14]="autoSurround",re[re.bracketPairColorization=15]="bracketPairColorization",re[re.guides=16]="guides",re[re.codeLens=17]="codeLens",re[re.codeLensFontFamily=18]="codeLensFontFamily",re[re.codeLensFontSize=19]="codeLensFontSize",re[re.colorDecorators=20]="colorDecorators",re[re.colorDecoratorsLimit=21]="colorDecoratorsLimit",re[re.columnSelection=22]="columnSelection",re[re.comments=23]="comments",re[re.contextmenu=24]="contextmenu",re[re.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",re[re.cursorBlinking=26]="cursorBlinking",re[re.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",re[re.cursorStyle=28]="cursorStyle",re[re.cursorSurroundingLines=29]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",re[re.cursorWidth=31]="cursorWidth",re[re.disableLayerHinting=32]="disableLayerHinting",re[re.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",re[re.domReadOnly=34]="domReadOnly",re[re.dragAndDrop=35]="dragAndDrop",re[re.dropIntoEditor=36]="dropIntoEditor",re[re.emptySelectionClipboard=37]="emptySelectionClipboard",re[re.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",re[re.extraEditorClassName=39]="extraEditorClassName",re[re.fastScrollSensitivity=40]="fastScrollSensitivity",re[re.find=41]="find",re[re.fixedOverflowWidgets=42]="fixedOverflowWidgets",re[re.folding=43]="folding",re[re.foldingStrategy=44]="foldingStrategy",re[re.foldingHighlight=45]="foldingHighlight",re[re.foldingImportsByDefault=46]="foldingImportsByDefault",re[re.foldingMaximumRegions=47]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=49]="fontFamily",re[re.fontInfo=50]="fontInfo",re[re.fontLigatures=51]="fontLigatures",re[re.fontSize=52]="fontSize",re[re.fontWeight=53]="fontWeight",re[re.fontVariations=54]="fontVariations",re[re.formatOnPaste=55]="formatOnPaste",re[re.formatOnType=56]="formatOnType",re[re.glyphMargin=57]="glyphMargin",re[re.gotoLocation=58]="gotoLocation",re[re.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",re[re.hover=60]="hover",re[re.inDiffEditor=61]="inDiffEditor",re[re.inlineSuggest=62]="inlineSuggest",re[re.letterSpacing=63]="letterSpacing",re[re.lightbulb=64]="lightbulb",re[re.lineDecorationsWidth=65]="lineDecorationsWidth",re[re.lineHeight=66]="lineHeight",re[re.lineNumbers=67]="lineNumbers",re[re.lineNumbersMinChars=68]="lineNumbersMinChars",re[re.linkedEditing=69]="linkedEditing",re[re.links=70]="links",re[re.matchBrackets=71]="matchBrackets",re[re.minimap=72]="minimap",re[re.mouseStyle=73]="mouseStyle",re[re.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=75]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",re[re.multiCursorModifier=77]="multiCursorModifier",re[re.multiCursorPaste=78]="multiCursorPaste",re[re.multiCursorLimit=79]="multiCursorLimit",re[re.occurrencesHighlight=80]="occurrencesHighlight",re[re.overviewRulerBorder=81]="overviewRulerBorder",re[re.overviewRulerLanes=82]="overviewRulerLanes",re[re.padding=83]="padding",re[re.pasteAs=84]="pasteAs",re[re.parameterHints=85]="parameterHints",re[re.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",re[re.quickSuggestions=88]="quickSuggestions",re[re.quickSuggestionsDelay=89]="quickSuggestionsDelay",re[re.readOnly=90]="readOnly",re[re.readOnlyMessage=91]="readOnlyMessage",re[re.renameOnType=92]="renameOnType",re[re.renderControlCharacters=93]="renderControlCharacters",re[re.renderFinalNewline=94]="renderFinalNewline",re[re.renderLineHighlight=95]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=97]="renderValidationDecorations",re[re.renderWhitespace=98]="renderWhitespace",re[re.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",re[re.roundedSelection=100]="roundedSelection",re[re.rulers=101]="rulers",re[re.scrollbar=102]="scrollbar",re[re.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=104]="scrollBeyondLastLine",re[re.scrollPredominantAxis=105]="scrollPredominantAxis",re[re.selectionClipboard=106]="selectionClipboard",re[re.selectionHighlight=107]="selectionHighlight",re[re.selectOnLineNumbers=108]="selectOnLineNumbers",re[re.showFoldingControls=109]="showFoldingControls",re[re.showUnused=110]="showUnused",re[re.snippetSuggestions=111]="snippetSuggestions",re[re.smartSelect=112]="smartSelect",re[re.smoothScrolling=113]="smoothScrolling",re[re.stickyScroll=114]="stickyScroll",re[re.stickyTabStops=115]="stickyTabStops",re[re.stopRenderingLineAfter=116]="stopRenderingLineAfter",re[re.suggest=117]="suggest",re[re.suggestFontSize=118]="suggestFontSize",re[re.suggestLineHeight=119]="suggestLineHeight",re[re.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",re[re.suggestSelection=121]="suggestSelection",re[re.tabCompletion=122]="tabCompletion",re[re.tabIndex=123]="tabIndex",re[re.unicodeHighlighting=124]="unicodeHighlighting",re[re.unusualLineTerminators=125]="unusualLineTerminators",re[re.useShadowDOM=126]="useShadowDOM",re[re.useTabStops=127]="useTabStops",re[re.wordBreak=128]="wordBreak",re[re.wordSeparators=129]="wordSeparators",re[re.wordWrap=130]="wordWrap",re[re.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=133]="wordWrapColumn",re[re.wordWrapOverride1=134]="wordWrapOverride1",re[re.wordWrapOverride2=135]="wordWrapOverride2",re[re.wrappingIndent=136]="wrappingIndent",re[re.wrappingStrategy=137]="wrappingStrategy",re[re.showDeprecated=138]="showDeprecated",re[re.inlayHints=139]="inlayHints",re[re.editorClassName=140]="editorClassName",re[re.pixelRatio=141]="pixelRatio",re[re.tabFocusMode=142]="tabFocusMode",re[re.layoutInfo=143]="layoutInfo",re[re.wrappingInfo=144]="wrappingInfo",re[re.defaultColorDecorators=145]="defaultColorDecorators",re[re.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",re[re.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(202,null)})),acceptSuggestionOnEnter:Le(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(203,null),""],markdownDescription:v.localize(204,null)})),accessibilitySupport:Le(new u),accessibilityPageSize:Le(new r(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(205,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",v.localize(206,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:v.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Le(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(208,null),v.localize(209,null),""],description:v.localize(210,null)})),autoClosingComments:Le(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(211,null),v.localize(212,null),""],description:v.localize(213,null)})),autoClosingDelete:Le(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(214,null),""],description:v.localize(215,null)})),autoClosingOvertype:Le(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(216,null),""],description:v.localize(217,null)})),autoClosingQuotes:Le(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(218,null),v.localize(219,null),""],description:v.localize(220,null)})),autoIndent:Le(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null),v.localize(224,null),v.localize(225,null)],description:v.localize(226,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(227,null),v.localize(228,null),v.localize(229,null),""],description:v.localize(230,null)})),bracketPairColorization:Le(new V),bracketPairGuides:Le(new ae),stickyTabStops:Le(new o(115,"stickyTabStops",!1,{description:v.localize(231,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:v.localize(232,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:v.localize(233,null)})),codeLensFontSize:Le(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:v.localize(234,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:v.localize(235,null)})),colorDecoratorActivatedOn:Le(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[v.localize(236,null),v.localize(237,null),v.localize(238,null)],description:v.localize(239,null)})),colorDecoratorsLimit:Le(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:v.localize(240,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:v.localize(241,null)})),comments:Le(new w),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:v.localize(242,null)})),cursorBlinking:Le(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:v.localize(243,null)})),cursorSmoothCaretAnimation:Le(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[v.localize(244,null),v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),cursorStyle:Le(new d(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:v.localize(248,null)})),cursorSurroundingLines:Le(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(249,null)})),cursorSurroundingLinesStyle:Le(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(250,null),v.localize(251,null)],markdownDescription:v.localize(252,null)})),cursorWidth:Le(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(253,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:v.localize(254,null)})),emptySelectionClipboard:Le(new U),dropIntoEditor:Le(new at),stickyScroll:Le(new oe),experimentalWhitespaceRendering:Le(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[v.localize(255,null),v.localize(256,null),v.localize(257,null)],description:v.localize(258,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new a(40,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:v.localize(259,null)})),find:Le(new T),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:v.localize(260,null)})),foldingStrategy:Le(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(261,null),v.localize(262,null)],description:v.localize(263,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:v.localize(264,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:v.localize(265,null)})),foldingMaximumRegions:Le(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:v.localize(266,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(267,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(268,null)})),fontInfo:Le(new j),fontLigatures2:Le(new O),fontSize:Le(new z),fontWeight:Le(new J),fontVariations:Le(new M),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:v.localize(269,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:v.localize(270,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:v.localize(271,null)})),gotoLocation:Le(new le),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:v.localize(272,null)})),hover:Le(new Y),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>a.clamp(re,-5,20),{description:v.localize(273,null)})),lightbulb:Le(new $e),lineDecorationsWidth:Le(new W),lineHeight:Le(new ie),lineNumbers:Le(new me),lineNumbersMinChars:Le(new r(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(69,"linkedEditing",!1,{description:v.localize(274,null)})),links:Le(new o(70,"links",!0,{description:v.localize(275,null)})),matchBrackets:Le(new s(71,"matchBrackets","always",["always","near","never"],{description:v.localize(276,null)})),minimap:Le(new ye),mouseStyle:Le(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new a(74,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:v.localize(277,null)})),mouseWheelZoom:Le(new o(75,"mouseWheelZoom",!1,{markdownDescription:f.$j?v.localize(278,null):v.localize(279,null)})),multiCursorMergeOverlapping:Le(new o(76,"multiCursorMergeOverlapping",!0,{description:v.localize(280,null)})),multiCursorModifier:Le(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[v.localize(281,null),v.localize(282,null)],markdownDescription:v.localize(283,null)})),multiCursorPaste:Le(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(284,null),v.localize(285,null)],markdownDescription:v.localize(286,null)})),multiCursorLimit:Le(new r(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:v.localize(287,null)})),occurrencesHighlight:Le(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[v.localize(288,null),v.localize(289,null),v.localize(290,null)],markdownDescription:v.localize(291,null)})),overviewRulerBorder:Le(new o(81,"overviewRulerBorder",!0,{description:v.localize(292,null)})),overviewRulerLanes:Le(new r(82,"overviewRulerLanes",3,0,3)),padding:Le(new fe),pasteAs:Le(new st),parameterHints:Le(new _),peekWidgetDefaultFocus:Le(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(293,null),v.localize(294,null)],description:v.localize(295,null)})),definitionLinkOpensInPeek:Le(new o(87,"definitionLinkOpensInPeek",!1,{description:v.localize(296,null)})),quickSuggestions:Le(new G),quickSuggestionsDelay:Le(new r(89,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(297,null)})),readOnly:Le(new o(90,"readOnly",!1)),readOnlyMessage:Le(new ve),renameOnType:Le(new o(92,"renameOnType",!1,{description:v.localize(298,null),markdownDeprecationMessage:v.localize(299,null)})),renderControlCharacters:Le(new o(93,"renderControlCharacters",!0,{description:v.localize(300,null),restricted:!0})),renderFinalNewline:Le(new s(94,"renderFinalNewline",f.$k?"dimmed":"on",["off","on","dimmed"],{description:v.localize(301,null)})),renderLineHighlight:Le(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(302,null)],description:v.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(304,null)})),renderValidationDecorations:Le(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(305,null),v.localize(306,null),v.localize(307,null),""],description:v.localize(308,null)})),revealHorizontalRightPadding:Le(new r(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(100,"roundedSelection",!0,{description:v.localize(309,null)})),rulers:Le(new Ae),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new r(103,"scrollBeyondLastColumn",4,0,1073741824,{description:v.localize(310,null)})),scrollBeyondLastLine:Le(new o(104,"scrollBeyondLastLine",!0,{description:v.localize(311,null)})),scrollPredominantAxis:Le(new o(105,"scrollPredominantAxis",!0,{description:v.localize(312,null)})),selectionClipboard:Le(new o(106,"selectionClipboard",!0,{description:v.localize(313,null),included:f.$k})),selectionHighlight:Le(new o(107,"selectionHighlight",!0,{description:v.localize(314,null)})),selectOnLineNumbers:Le(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[v.localize(315,null),v.localize(316,null),v.localize(317,null)],description:v.localize(318,null)})),showUnused:Le(new o(110,"showUnused",!0,{description:v.localize(319,null)})),showDeprecated:Le(new o(138,"showDeprecated",!0,{description:v.localize(320,null)})),inlayHints:Le(new K),snippetSuggestions:Le(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(321,null),v.localize(322,null),v.localize(323,null),v.localize(324,null)],description:v.localize(325,null)})),smartSelect:Le(new je),smoothScrolling:Le(new o(113,"smoothScrolling",!1,{description:v.localize(326,null)})),stopRenderingLineAfter:Le(new r(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Re),inlineSuggest:Le(new te),inlineCompletionsAccessibilityVerbose:Le(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:v.localize(327,null)})),suggestFontSize:Le(new r(118,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new r(119,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(120,"suggestOnTriggerCharacters",!0,{description:v.localize(330,null)})),suggestSelection:Le(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(331,null),v.localize(332,null),v.localize(333,null)],description:v.localize(334,null)})),tabCompletion:Le(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(335,null),v.localize(336,null),v.localize(337,null)],description:v.localize(338,null)})),tabIndex:Le(new r(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Z),unusualLineTerminators:Le(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(339,null),v.localize(340,null),v.localize(341,null)],description:v.localize(342,null)})),useShadowDOM:Le(new o(126,"useShadowDOM",!0)),useTabStops:Le(new o(127,"useTabStops",!0,{description:v.localize(343,null)})),wordBreak:Le(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[v.localize(344,null),v.localize(345,null)],description:v.localize(346,null)})),wordSeparators:Le(new t(129,"wordSeparators",A.$us,{description:v.localize(347,null)})),wordWrap:Le(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(348,null),v.localize(349,null),v.localize(350,null),v.localize(351,null)],description:v.localize(352,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new r(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(353,null)})),wordWrapOverride1:Le(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new o(145,"defaultColorDecorators",!1,{markdownDescription:v.localize(354,null)})),pixelRatio:Le(new ee),tabFocusMode:Le(new o(142,"tabFocusMode",!1,{markdownDescription:v.localize(355,null)})),layoutInfo:Le(new X),wrappingInfo:Le(new _e),wrappingIndent:Le(new Qe),wrappingStrategy:Le(new ue)}}),define(Ee[195],Se([8,9]),function(ge,e){return ge.create("vs/editor/common/languages",e)}),define(Ee[83],Se([1,0,78,2,168,29,178,195]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Nt=e.$Mt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Lt=e.$Kt=e.SymbolKinds=e.SymbolTag=e.$Jt=e.$It=e.SymbolKind=e.$Ht=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Gt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Ft=e.$Et=e.$Dt=void 0;class ${constructor(O,M,j){this.offset=O,this.type=M,this.language=j,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Dt=$;class E{constructor(O,M){this.tokens=O,this.endState=M,this._tokenizationResultBrand=void 0}}e.$Et=E;class R{constructor(O,M){this.tokens=O,this.endState=M,this._encodedTokenizationResultBrand=void 0}}e.$Ft=R;var D;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(D||(e.CompletionItemKind=D={}));var p;(function(T){const O=new Map;O.set(0,C.$ak.symbolMethod),O.set(1,C.$ak.symbolFunction),O.set(2,C.$ak.symbolConstructor),O.set(3,C.$ak.symbolField),O.set(4,C.$ak.symbolVariable),O.set(5,C.$ak.symbolClass),O.set(6,C.$ak.symbolStruct),O.set(7,C.$ak.symbolInterface),O.set(8,C.$ak.symbolModule),O.set(9,C.$ak.symbolProperty),O.set(10,C.$ak.symbolEvent),O.set(11,C.$ak.symbolOperator),O.set(12,C.$ak.symbolUnit),O.set(13,C.$ak.symbolValue),O.set(15,C.$ak.symbolEnum),O.set(14,C.$ak.symbolConstant),O.set(15,C.$ak.symbolEnum),O.set(16,C.$ak.symbolEnumMember),O.set(17,C.$ak.symbolKeyword),O.set(27,C.$ak.symbolSnippet),O.set(18,C.$ak.symbolText),O.set(19,C.$ak.symbolColor),O.set(20,C.$ak.symbolFile),O.set(21,C.$ak.symbolReference),O.set(22,C.$ak.symbolCustomColor),O.set(23,C.$ak.symbolFolder),O.set(24,C.$ak.symbolTypeParameter),O.set(25,C.$ak.account),O.set(26,C.$ak.issues);function M(J){let le=O.get(J);return le||(console.info("No codicon found for CompletionItemKind "+J),le=C.$ak.symbolProperty),le}T.toIcon=M;const j=new Map;j.set("method",0),j.set("function",1),j.set("constructor",2),j.set("field",3),j.set("variable",4),j.set("class",5),j.set("struct",6),j.set("interface",7),j.set("module",8),j.set("property",9),j.set("event",10),j.set("operator",11),j.set("unit",12),j.set("value",13),j.set("constant",14),j.set("enum",15),j.set("enum-member",16),j.set("enumMember",16),j.set("keyword",17),j.set("snippet",27),j.set("text",18),j.set("color",19),j.set("file",20),j.set("reference",21),j.set("customcolor",22),j.set("folder",23),j.set("type-parameter",24),j.set("typeParameter",24),j.set("account",25),j.set("issue",26);function z(J,le){let Y=j.get(J);return typeof Y>"u"&&!le&&(Y=9),Y}T.fromString=z})(p||(e.CompletionItemKinds=p={}));var k;(function(T){T[T.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var S;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var c;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var g;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class o{constructor(O,M,j,z){this.range=O,this.text=M,this.completionKind=j,this.isSnippetText=z}equals(O){return P.$Vs.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$Gt=o;var i;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function a(T){return T&&F.URI.isUri(T.uri)&&P.$Vs.isIRange(T.range)&&(P.$Vs.isIRange(T.originSelectionRange)||P.$Vs.isIRange(T.targetSelectionRange))}e.$Ht=a;var t;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$It={[17]:(0,v.localize)(0,null),[16]:(0,v.localize)(1,null),[4]:(0,v.localize)(2,null),[13]:(0,v.localize)(3,null),[8]:(0,v.localize)(4,null),[9]:(0,v.localize)(5,null),[21]:(0,v.localize)(6,null),[23]:(0,v.localize)(7,null),[7]:(0,v.localize)(8,null),[0]:(0,v.localize)(9,null),[11]:(0,v.localize)(10,null),[10]:(0,v.localize)(11,null),[19]:(0,v.localize)(12,null),[5]:(0,v.localize)(13,null),[1]:(0,v.localize)(14,null),[2]:(0,v.localize)(15,null),[20]:(0,v.localize)(16,null),[15]:(0,v.localize)(17,null),[18]:(0,v.localize)(18,null),[24]:(0,v.localize)(19,null),[3]:(0,v.localize)(20,null),[6]:(0,v.localize)(21,null),[14]:(0,v.localize)(22,null),[22]:(0,v.localize)(23,null),[25]:(0,v.localize)(24,null),[12]:(0,v.localize)(25,null)};function h(T,O){return(0,v.localize)(26,null,T,e.$It[O])}e.$Jt=h;var s;(function(T){T[T.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var d;(function(T){const O=new Map;O.set(0,C.$ak.symbolFile),O.set(1,C.$ak.symbolModule),O.set(2,C.$ak.symbolNamespace),O.set(3,C.$ak.symbolPackage),O.set(4,C.$ak.symbolClass),O.set(5,C.$ak.symbolMethod),O.set(6,C.$ak.symbolProperty),O.set(7,C.$ak.symbolField),O.set(8,C.$ak.symbolConstructor),O.set(9,C.$ak.symbolEnum),O.set(10,C.$ak.symbolInterface),O.set(11,C.$ak.symbolFunction),O.set(12,C.$ak.symbolVariable),O.set(13,C.$ak.symbolConstant),O.set(14,C.$ak.symbolString),O.set(15,C.$ak.symbolNumber),O.set(16,C.$ak.symbolBoolean),O.set(17,C.$ak.symbolArray),O.set(18,C.$ak.symbolObject),O.set(19,C.$ak.symbolKey),O.set(20,C.$ak.symbolNull),O.set(21,C.$ak.symbolEnumMember),O.set(22,C.$ak.symbolStruct),O.set(23,C.$ak.symbolEvent),O.set(24,C.$ak.symbolOperator),O.set(25,C.$ak.symbolTypeParameter);function M(j){let z=O.get(j);return z||(console.info("No codicon found for SymbolKind "+j),z=C.$ak.symbolProperty),z}T.toIcon=M})(d||(e.SymbolKinds=d={}));class l{static asEditOperation(O){return f.$Ws.replace(P.$Vs.lift(O.range),O.text)}}e.$Kt=l;class u{static{this.Comment=new u("comment")}static{this.Imports=new u("imports")}static{this.Region=new u("region")}static fromValue(O){switch(O){case"comment":return u.Comment;case"imports":return u.Imports;case"region":return u.Region}return new u(O)}constructor(O){this.value=O}}e.$Lt=u;var w;(function(T){function O(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}T.is=O})(w||(e.Command=w={}));var I;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var b;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(b||(e.CommentThreadState=b={}));var m;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(m||(e.CommentMode=m={}));var y;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(y||(e.CommentState=y={}));var L;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class N{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Mt=N,e.$Nt=new A.$ut;var U;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(U||(e.ExternalUriOpenerPriority=U={}))}),define(Ee[196],Se([8,9]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[197],Se([8,9]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[198],Se([8,9]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[199],Se([8,9]),function(ge,e){return ge.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[200],Se([8,9]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[201],Se([8,9]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[202],Se([8,9]),function(ge,e){return ge.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[203],Se([8,9]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Ee[204],Se([8,9]),function(ge,e){return ge.create("vs/platform/files/common/io",e)}),define(Ee[205],Se([8,9]),function(ge,e){return ge.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[206],Se([8,9]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Ee[207],Se([8,9]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[208],Se([8,9]),function(ge,e){return ge.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[209],Se([8,9]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Ee[210],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ee[211],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[212],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[213],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[214],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[215],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[216],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[217],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[218],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[219],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[220],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[221],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[222],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[223],Se([8,9]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Ee[224],Se([8,9]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Ee[225],Se([8,9]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Ee[226],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[227],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[228],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[229],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[230],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[231],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[232],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[233],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[234],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[235],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[236],Se([1,0,14,198]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.TokenType=void 0;var f;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(f||(e.TokenType=f={}));function P(...E){switch(E.length){case 1:return(0,F.localize)(0,null,E[0]);case 2:return(0,F.localize)(1,null,E[0],E[1]);case 3:return(0,F.localize)(2,null,E[0],E[1],E[2]);default:return}}const A=(0,F.localize)(3,null),v=(0,F.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const D=this.d,p=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:p};this.g.push({offset:D,lexeme:p,additionalInfo:R}),this.f.push(k)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const D=this.c.substring(this.d,this.e),p=$.b.get(D);p?this.k(p):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,D=!1,p=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(v);return}const S=this.c.charCodeAt(R);if(D)D=!1;else if(S===47&&!p){R++;break}else S===91?p=!0:S===92?D=!0:S===93&&(p=!1);R++}for(;R<this.c.length&&$.a.has(this.c.charCodeAt(R));)R++;this.e=R;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$2i=$}),define(Ee[237],Se([1,0,23,39,201,387]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||A.test(o)}e.$bp=$;function E(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$cp=E;function R(o){if(!o)return null;const i=o.majorBase,r=o.majorMustEqual,n=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let h=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),h=!1);let s=0;if(o.preRelease){const d=v.exec(o.preRelease);if(d){const[,l,u,w]=d;s=Date.UTC(Number(l),Number(u)-1,Number(w))}}return{majorBase:i,majorMustEqual:r,minorBase:n,minorMustEqual:a,patchBase:t,patchMustEqual:h,isMinimum:o.hasGreaterEquals,notBefore:s}}e.$dp=R;function D(o,i,r){let n;typeof o=="string"?n=R(E(o)):n=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof r=="string"?t=R(E(r)):t=r,!n||!t)return!1;const h=n.majorBase,s=n.minorBase,d=n.patchBase;let l=t.majorBase,u=t.minorBase,w=t.patchBase;const I=t.notBefore;let b=t.majorMustEqual,m=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?h>l?!0:h<l?!1:s>u?!0:s<u||a&&a<I?!1:d>=w:(h===1&&l===0&&(!b||!m||!y)&&(l=1,u=0,w=0,b=!0,m=!1,y=!1),h<l?!1:h>l?!b:s<u?!1:s>u?!m:d<w?!1:d>w?!y:!(a&&a<I))}e.$ep=D;function p(o,i,r,n,a){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([F.default.Error,f.localize(0,null)]),t;if(typeof n.name!="string")return t.push([F.default.Error,f.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([F.default.Error,f.localize(2,null,"version")]),t;if(!n.engines)return t.push([F.default.Error,f.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([F.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!g(n.extensionDependencies))return t.push([F.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!g(n.activationEvents))return t.push([F.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([F.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([F.default.Warning,f.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([F.default.Error,f.localize(9,null,"main")]),t;{const d=(0,C.$Ig)(r,n.main);(0,C.$Cg)(d,r)||t.push([F.default.Warning,f.localize(10,null,d.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([F.default.Error,f.localize(11,null,"browser")]),t;{const d=(0,C.$Ig)(r,n.browser);(0,C.$Cg)(d,r)||t.push([F.default.Warning,f.localize(12,null,d.path,r.path)])}}if(!P.valid(n.version))return t.push([F.default.Error,f.localize(13,null)]),t;const h=[];if(!k(o,i,n,a,h))for(const d of h)t.push([F.default.Error,d]);return t}e.$fp=p;function k(o,i,r,n,a){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:c(o,i,r.engines.vscode,a)}e.$gp=k;function S(o,i,r){return o==="*"||c(i,r,o)}e.$hp=S;function c(o,i,r,n=[]){const a=R(E(r));if(!a)return n.push(f.localize(14,null,r)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return n.push(f.localize(15,null,r)),!1}else if(!a.majorMustEqual)return n.push(f.localize(16,null,r)),!1;return D(o,i,a)?!0:(n.push(f.localize(17,null,o,r)),!1)}function g(o){if(!Array.isArray(o))return!1;for(let i=0,r=o.length;i<r;i++)if(typeof o[i]!="string")return!1;return!0}}),define(Ee[106],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class C{constructor(f,P=[],A=!1){this.ctor=f,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.$4h=C}),define(Ee[84],Se([1,0,106]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=e.InstantiationType=void 0;const F=[];var f;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function P(v,$,E){$ instanceof C.$4h||($=new C.$4h($,[],!!E)),F.push([v,$])}e.$Zr=P;function A(){return F}e.$1r=A}),define(Ee[238],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;class C{constructor(P,A){this.key=P,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Dq=C;class F{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const A of this.a.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const v=this.lookupOrInsertNode(P),$=this.lookupOrInsertNode(A);v.outgoing.set($.key,$),$.incoming.set(v.key,v)}removeNode(P){const A=this.b(P);this.a.delete(A);for(const v of this.a.values())v.outgoing.delete(A),v.incoming.delete(A)}lookupOrInsertNode(P){const A=this.b(P);let v=this.a.get(A);return v||(v=new C(A,P),this.a.set(A,v)),v}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[A,v]of this.a)P.push(`${A}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,A]of this.a){const v=new Set([P]),$=this.c(A,v);if($)return $}}c(P,A){for(const[v,$]of P.outgoing){if(A.has(v))return[...A,v].join(" -> ");A.add(v);const E=this.c($,A);if(E)return E;A.delete(v)}}}e.$Eq=F}),define(Ee[5],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e._util=void 0;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function v($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=v})(C||(e._util=C={})),e.$6h=f("instantiationService");function F(A,v,$){v[C.DI_TARGET]===v?v[C.DI_DEPENDENCIES].push({id:A,index:$}):(v[C.DI_DEPENDENCIES]=[{id:A,index:$}],v[C.DI_TARGET]=v)}function f(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const v=function($,E,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(v,$,R)};return v.toString=()=>A,C.serviceIds.set(A,v),v}e.$7h=f;function P(A){return A}e.$8h=P}),define(Ee[51],Se([1,0,18,2,5]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.ConfigurationTarget=e.$Ci=e.$Bi=e.$Ai=void 0,e.$Ai=(0,f.$7h)("configurationService");function P(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof F.URI)}e.$Bi=P;function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof F.URI)}e.$Ci=A;var v;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Di=$;function E(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Ei=E;function R(o,i){const r=Object.create(null);for(const n in o)D(r,n,o[n],i);return r}e.$Fi=R;function D(o,i,r,n){const a=i.split("."),t=a.pop();let h=o;for(let s=0;s<a.length;s++){const d=a[s];let l=h[d];switch(typeof l){case"undefined":l=h[d]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(l)}`);return}h=l}if(typeof h=="object"&&h!==null)try{h[t]=r}catch{n(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(h)}`)}else n(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(h)}`)}e.$Gi=D;function p(o,i){const r=i.split(".");k(o,r)}e.$Hi=p;function k(o,i){const r=i.shift();if(i.length===0){delete o[r];return}if(Object.keys(o).indexOf(r)!==-1){const n=o[r];typeof n=="object"&&!Array.isArray(n)&&(k(n,i),Object.keys(n).length===0&&delete o[r])}}function S(o,i,r){function n(h,s){let d=h;for(const l of s){if(typeof d!="object"||d===null)return;d=d[l]}return d}const a=i.split("."),t=n(o,a);return typeof t>"u"?r:t}e.$Ii=S;function c(o,i,r){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in o?C.$Lf(o[n])&&C.$Lf(i[n])?c(o[n],i[n],r):r&&(o[n]=i[n]):o[n]=i[n])})}e.$Ji=c;function g(o){return o.replace(/[\[\]]/g,"")}e.$Ki=g}),define(Ee[45],Se([1,0,10,12,236,5,197,14]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.ContextKeyExprType=e.$3i=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",C.$j),$.set("isLinux",C.$k),$.set("isWindows",C.$i),$.set("isWeb",C.$o),$.set("isMacNative",C.$j&&!C.$o),$.set("isEdge",C.$H),$.set("isFirefox",C.$F),$.set("isChrome",C.$E),$.set("isSafari",C.$G);function E(K,W){if($.get(K)!==void 0)throw(0,v.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(K,W)}e.$3i=E;const R=Object.prototype.hasOwnProperty;var D;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const p={regexParsingWithErrorRecovery:!0},k=(0,A.localize)(0,null),S=(0,A.localize)(1,null),c=(0,A.localize)(2,null),g=(0,A.localize)(3,null),o=(0,A.localize)(4,null),i=(0,A.localize)(5,null),r=(0,A.localize)(6,null),n=(0,A.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=p){this.k=W,this.d=new f.$2i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const ye=this.D(),de=ye.type===17?i:void 0;throw this.h.push({message:o,offset:ye.offset,lexeme:f.$2i.getLexeme(ye),additionalInfo:de}),a.c}return ie}catch(ie){if(ie!==a.c)throw ie;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const ie=this.o();W.push(ie)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const ie=this.s();W.push(ie)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,g),ie?.negate()}case 17:return this.z(),L.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,g),ie}case 17:{const ie=W.lexeme;if(this.z(),this.y(9)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==10)throw this.B("REGEX",de);const fe=de.lexeme,_=fe.lastIndexOf("/"),ee=_===fe.length-1?void 0:this.w(fe.substring(_+1));let G;try{G=new RegExp(fe.substring(1,_),ee)}catch{throw this.B("REGEX",de)}return j.create(ie,G)}switch(de.type){case 10:case 19:{const fe=[de.lexeme];this.z();let _=this.D(),ee=0;for(let Ae=0;Ae<de.lexeme.length;Ae++)de.lexeme.charCodeAt(Ae)===40?ee++:de.lexeme.charCodeAt(Ae)===41&&ee--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let Ae=0;Ae<_.lexeme.length;Ae++)_.lexeme.charCodeAt(Ae)===40?ee++:de.lexeme.charCodeAt(Ae)===41&&ee--}if(ee<0)break;fe.push(f.$2i.getLexeme(_)),this.z(),_=this.D()}const G=fe.join(""),x=G.lastIndexOf("/"),me=x===G.length-1?void 0:this.w(G.substring(x+1));let we;try{we=new RegExp(G.substring(1,x),me)}catch{throw this.B("REGEX",de)}return t.regex(ie,we)}case 18:{const fe=de.lexeme;this.z();let _=null;if(!(0,F.$Ke)(fe)){const ee=fe.indexOf("/"),G=fe.lastIndexOf("/");if(ee!==G&&ee>=0){const x=fe.slice(ee+1,G),me=fe[G+1]==="i"?"i":"";try{_=new RegExp(x,me)}catch{throw this.B("REGEX",de)}}}if(_===null)throw this.B("REGEX",de);return j.create(ie,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const de=this.u();return t.notIn(ie,de)}switch(this.D().type){case 3:{this.z();const de=this.u();if(this.x().type===18)return t.equals(ie,de);switch(de){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,de)}}case 4:{this.z();const de=this.u();if(this.x().type===18)return t.notEquals(ie,de);switch(de){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,de)}}case 5:return this.z(),O.create(ie,this.u());case 6:return this.z(),M.create(ie,this.u());case 7:return this.z(),U.create(ie,this.u());case 8:return this.z(),T.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:r,offset:W.offset,lexeme:"",additionalInfo:n}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ie){if(this.C(W))return this.z();throw this.B(ie,this.D())}B(W,ie,ye){const de=(0,A.localize)(8,null,W,f.$2i.getLexeme(ie)),fe=ie.offset,_=f.$2i.getLexeme(ie);return this.h.push({message:de,offset:fe,lexeme:_,additionalInfo:ye}),a.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$4i=a;class t{static false(){return l.INSTANCE}static true(){return u.INSTANCE}static has(W){return w.create(W)}static equals(W,ie){return I.create(W,ie)}static notEquals(W,ie){return y.create(W,ie)}static regex(W,ie){return j.create(W,ie)}static in(W,ie){return b.create(W,ie)}static notIn(W,ie){return m.create(W,ie)}static not(W){return L.create(W)}static and(...W){return le.create(W,null,!0)}static or(...W){return Y.create(W,null,!0)}static greater(W,ie){return U.create(W,ie)}static greaterEquals(W,ie){return T.create(W,ie)}static smaller(W,ie){return O.create(W,ie)}static smallerEquals(W,ie){return M.create(W,ie)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$5i=t;function h(K){const W=new a({regexParsingWithErrorRecovery:!1});return K.map(ie=>(W.parse(ie),W.lexingErrors.length>0?W.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,A.localize)(9,null,ye.additionalInfo):(0,A.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$6i=h;function s(K,W){const ie=K?K.substituteConstants():void 0,ye=W?W.substituteConstants():void 0;return!ie&&!ye?!0:!ie||!ye?!1:ie.equals(ye)}e.$7i=s;function d(K,W){return K.cmp(W)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return u.INSTANCE}}e.$8i=l;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return l.INSTANCE}}e.$9i=u;class w{static create(W,ie=null){const ye=$.get(W);return typeof ye=="boolean"?ye?u.INSTANCE:l.INSTANCE:new w(W,ie)}constructor(W,ie){this.key=W,this.c=ie,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:X(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=$.get(this.key);return typeof W=="boolean"?W?u.INSTANCE:l.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$0i=w;class I{static create(W,ie,ye=null){if(typeof ie=="boolean")return ie?w.create(W,ye):L.create(W,ye);const de=$.get(W);return typeof de=="boolean"?ie===(de?"true":"false")?u.INSTANCE:l.INSTANCE:new I(W,ie,ye)}constructor(W,ie,ye){this.c=W,this.d=ie,this.f=ye,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const ie=W?"true":"false";return this.d===ie?u.INSTANCE:l.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$$i=I;class b{static create(W,ie){return new b(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.f),ye=W.getValue(this.d);return Array.isArray(ie)?ie.includes(ye):typeof ye=="string"&&typeof ie=="object"&&ie!==null?R.call(ie,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$_i=b;class m{static create(W,ie){return new m(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=11,this.c=b.create(W,ie)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$aj=m;class y{static create(W,ie,ye=null){if(typeof ie=="boolean")return ie?L.create(W,ye):w.create(W,ye);const de=$.get(W);return typeof de=="boolean"?ie===(de?"true":"false")?l.INSTANCE:u.INSTANCE:new y(W,ie,ye)}constructor(W,ie,ye){this.c=W,this.d=ie,this.f=ye,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const ie=W?"true":"false";return this.d===ie?l.INSTANCE:u.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$bj=y;class L{static create(W,ie=null){const ye=$.get(W);return typeof ye=="boolean"?ye?l.INSTANCE:u.INSTANCE:new L(W,ie)}constructor(W,ie){this.c=W,this.d=ie,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:X(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=$.get(this.c);return typeof W=="boolean"?W?l.INSTANCE:u.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$cj=L;function N(K,W){if(typeof K=="string"){const ie=parseFloat(K);isNaN(ie)||(K=ie)}return typeof K=="string"||typeof K=="number"?W(K):l.INSTANCE}class U{static create(W,ie,ye=null){return N(ie,de=>new U(W,de,ye))}constructor(W,ie,ye){this.c=W,this.d=ie,this.f=ye,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$dj=U;class T{static create(W,ie,ye=null){return N(ie,de=>new T(W,de,ye))}constructor(W,ie,ye){this.c=W,this.d=ie,this.f=ye,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$ej=T;class O{static create(W,ie,ye=null){return N(ie,de=>new O(W,de,ye))}constructor(W,ie,ye){this.c=W,this.d=ie,this.f=ye,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$fj=O;class M{static create(W,ie,ye=null){return N(ie,de=>new M(W,de,ye))}constructor(W,ie,ye){this.c=W,this.d=ie,this.f=ye,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$gj=M;class j{static create(W,ie){return new j(W,ie)}constructor(W,ie){this.d=W,this.f=ie,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ie=this.f?this.f.source:"",ye=W.f?W.f.source:"";return ie<ye?-1:ie>ye?1:0}equals(W){if(W.type===this.type){const ie=this.f?this.f.source:"",ye=W.f?W.f.source:"";return this.d===W.d&&ie===ye}return!1}substituteConstants(){return this}evaluate(W){const ie=W.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.$hj=j;class z{static create(W){return new z(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new z(this.c.map(W))}negate(){return this.c}}e.$ij=z;function J(K){let W=null;for(let ie=0,ye=K.length;ie<ye;ie++){const de=K[ie].substituteConstants();if(K[ie]!==de&&W===null){W=[];for(let fe=0;fe<ie;fe++)W[fe]=K[fe]}W!==null&&(W[ie]=de)}return W===null?K:W}class le{static create(W,ie,ye){return le.d(W,ie,ye)}constructor(W,ie){this.expr=W,this.c=ie,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,ye=this.expr.length;ie<ye;ie++){const de=d(this.expr[ie],W.expr[ie]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=J(this.expr);return W===this.expr?this:le.create(W,this.c,!1)}evaluate(W){for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].evaluate(W))return!1;return!0}static d(W,ie,ye){const de=[];let fe=!1;for(const _ of W)if(_){if(_.type===1){fe=!0;continue}if(_.type===0)return l.INSTANCE;if(_.type===6){de.push(..._.expr);continue}de.push(_)}if(de.length===0&&fe)return u.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(d);for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];for(;de.length>1;){const _=de[de.length-1];if(_.type!==9)break;de.pop();const ee=de.pop(),G=de.length===0,x=Y.create(_.expr.map(me=>le.create([me,ee],null,ye)),null,G);x&&(de.push(x),de.sort(d))}if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let ee=_+1;ee<de.length;ee++)if(de[_].negate().equals(de[ee]))return l.INSTANCE;if(de.length===1)return de[0]}return new le(de,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new le(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.c){const W=[];for(const ie of this.expr)W.push(ie.negate());this.c=Y.create(W,this,!0)}return this.c}}e.$jj=le;class Y{static create(W,ie,ye){return Y.d(W,ie,ye)}constructor(W,ie){this.expr=W,this.c=ie,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ie=0,ye=this.expr.length;ie<ye;ie++){const de=d(this.expr[ie],W.expr[ie]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].equals(W.expr[ie]))return!1;return!0}return!1}substituteConstants(){const W=J(this.expr);return W===this.expr?this:Y.create(W,this.c,!1)}evaluate(W){for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(this.expr[ie].evaluate(W))return!0;return!1}static d(W,ie,ye){let de=[],fe=!1;if(W){for(let _=0,ee=W.length;_<ee;_++){const G=W[_];if(G){if(G.type===0){fe=!0;continue}if(G.type===1)return u.INSTANCE;if(G.type===9){de=de.concat(G.expr);continue}de.push(G)}}if(de.length===0&&fe)return l.INSTANCE;de.sort(d)}if(de.length!==0){if(de.length===1)return de[0];for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let ee=_+1;ee<de.length;ee++)if(de[_].negate().equals(de[ee]))return u.INSTANCE;if(de.length===1)return de[0]}return new Y(de,ie)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ie of this.expr)W.push(...ie.keys());return W}map(W){return new Y(this.expr.map(ie=>ie.map(W)),null)}negate(){if(!this.c){const W=[];for(const ie of this.expr)W.push(ie.negate());for(;W.length>1;){const ie=W.shift(),ye=W.shift(),de=[];for(const fe of oe(ie))for(const _ of oe(ye))de.push(le.create([fe,_],null,!1));W.unshift(Y.create(de,null,!1))}this.c=Y.create(W,this,!0)}return this.c}}e.$kj=Y;class Q extends w{static{this.d=[]}static all(){return Q.d.values()}constructor(W,ie,ye){super(W,null),this.f=ie,typeof ye=="object"?Q.d.push({...ye,key:W}):ye!==!0&&Q.d.push({key:W,description:ye,type:ie!=null?typeof ie:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return I.create(this.key,W)}notEqualsTo(W){return y.create(this.key,W)}}e.$lj=Q,e.$mj=(0,P.$7h)("contextKeyService");function X(K,W){return K<W?-1:K>W?1:0}function ue(K,W,ie,ye){return K<ie?-1:K>ie?1:W<ye?-1:W>ye?1:0}function ne(K,W){if(K.type===0||W.type===1)return!0;if(K.type===9)return W.type===9?$e(K.expr,W.expr):!1;if(W.type===9){for(const ie of W.expr)if(ne(K,ie))return!0;return!1}if(K.type===6){if(W.type===6)return $e(W.expr,K.expr);for(const ie of K.expr)if(ne(ie,W))return!0;return!1}return K.equals(W)}e.$nj=ne;function $e(K,W){let ie=0,ye=0;for(;ie<K.length&&ye<W.length;){const de=K[ie].cmp(W[ye]);if(de<0)return!1;de===0&&ie++,ye++}return ie===K.length}function oe(K){return K.type===9?K.expr:[K]}}),define(Ee[239],Se([1,0,23,39,199,5,103,10,24]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$v=e.$0v=e.ConfirmResult=e.$9v=e.$8v=e.$7v=void 0,e.$7v=(0,P.$7h)("dialogService");var E;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(E||(E={}));class R{a(g){return this.d(g,E.Confirmation)}b(g){return this.d(g,E.Prompt)}c(g){return this.d(g,E.Input)}d(g,o){const i=[];switch(o){case E.Confirmation:{const r=g;r.primaryButton?i.push(r.primaryButton):i.push((0,f.localize)(0,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,f.localize)(1,null));break}case E.Prompt:{const r=g;Array.isArray(r.buttons)&&r.buttons.length>0&&i.push(...r.buttons.map(n=>n.label)),r.cancelButton&&(r.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof r.cancelButton=="string"?i.push(r.cancelButton):r.cancelButton.label?i.push(r.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case E.Input:{const r=g;r.primaryButton?i.push(r.primaryButton):i.push((0,f.localize)(5,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,f.localize)(6,null));break}}return i}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===F.default.Info?"info":g===F.default.Error?"error":g===F.default.Warning?"warning":"none"}f(g,o,i){const r=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&r.push(g.cancelButton);let n=r[o]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.$8v=R,e.$9v=(0,P.$7h)("fileDialogService");var D;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(D||(e.ConfirmResult=D={}));const p=10;function k(c){const g=[];return g.push(...c.slice(0,p).map(o=>typeof o=="string"?o:(0,C.$Fg)(o))),c.length>p&&(c.length-p===1?g.push((0,f.localize)(7,null)):g.push((0,f.localize)(8,null,c.length-p))),g.push(""),g.join(`
`)}e.$0v=k;function S(c,g){const o=(0,$.$wn)(c);let i=(o.buttons??[]).map(t=>(0,A.$4v)(t)),r=(c.buttons||[]).map((t,h)=>h),n=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(v.$k||v.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const h=r[a];r.splice(a,1),r.splice(1,0,h),a=1}v.$k&&i.length>1&&(i=i.reverse(),r=r.reverse(),n=i.length-1,typeof t=="string"&&(a=n-1))}else if(v.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const h=r[a];r.splice(a,1),r.push(h),a=i.length-1}}return o.buttons=i,o.defaultId=n,o.cancelId=a,o.noLink=!0,o.title=o.title||g.nameLong,{options:o,buttonIndeces:r}}e.$$v=S}),define(Ee[133],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=void 0,e.$bi=(0,C.$7h)("environmentService"),e.$ci=(0,C.$8h)(e.$bi)}),define(Ee[134],Se([1,0,200,5]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.ExtensionGalleryErrorCode=e.$Ao=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0,e.$no="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$oo=new RegExp(e.$no),e.$po="__web_extension",e.$qo="skipWalkthrough",e.$ro="extensionsSync",e.$so="dependecyOrPackExtensionInstall";function f(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$to=f;function P(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$uo=P;function A(r,n){switch(r){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$vo=A;function v(r,n){return n==="web"&&!r.includes("web")}e.$wo=v;function $(r,n,a){return v(n,a)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===a}e.$xo=$;function E(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$yo=E;var R;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var D;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var p;(function(r){r.Install="install",r.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var k;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(k||(e.InstallOperation=k={})),e.$zo=(0,F.$7h)("extensionGalleryService");var S;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var c;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class g extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.$Ao=g;var o;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.$Bo=i,e.$Co=(0,F.$7h)("extensionManagementService"),e.$Do="extensionsIdentifiers/disabled",e.$Eo="extensionsIdentifiers/enabled",e.$Fo=(0,F.$7h)("IGlobalExtensionEnablementService"),e.$Go=(0,F.$7h)("IExtensionTipsService"),e.$Ho=(0,C.localize)(0,null),e.$Io={value:e.$Ho,original:"Extensions"},e.$Jo=(0,C.localize2)(1,"Preferences")}),define(Ee[240],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B3b=e.$A3b=void 0,e.$A3b=(0,C.$7h)("externalTerminal"),e.$B3b="Terminal.app"}),define(Ee[241],Se([1,0,50,52,16,17,10,102,31,105,202,240]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=e.$D$b=e.$C$b=void 0;const p=R.localize(0,null);class k{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends k{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(C,a,E.$Ul(),t)}spawnTerminal(a,t,h,s){const d=t.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const l=P.$nc(d,".exe").toLowerCase();if(l==="cmder")return a.spawn(d,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return d.indexOf(" ")>=0&&u.push('""'),u.push(d),l==="wt"&&u.push("-d ."),new Promise((w,I)=>{const b=o(process),m=a.spawn(h,u,{cwd:s,env:b,detached:!0});m.on("error",I),m.on("exit",()=>w())})}async runInTerminal(a,t,h,s,d){const l="windowsExec"in d&&d.windowsExec?d.windowsExec:S.getDefaultTerminalWindows(),u=await S.f();return new Promise((w,I)=>{const b=`"${t} - ${p}"`,m=`""${h.join('" "')}" & pause"`,y=Object.assign({},o(process),s);Object.keys(y).filter(O=>y[O]===null).forEach(O=>delete y[O]);const L={cwd:t,env:y,windowsVerbatimArguments:!0};let N,U;P.$nc(l,".exe")==="wt"?(N=l,U=["-d",".",S.b,"/c",m]):u?(N=u,U=["-d",t,l,"/c",m]):(N=S.b,U=["/c","start",b,"/wait",l,"/c",m]),C.spawn(N,U,L).on("error",O=>{I(i(O))}),w(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const a=await E.win32.findExecutable("wt");return await $.Promises.exists(a)?a:void 0}catch{return}}}e.$C$b=S,Ge([F.$yh],S,"f",null);class c extends k{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(C,a,t)}runInTerminal(a,t,h,s,d){const l=d.osxExec||D.$B3b;return new Promise((u,w)=>{if(l===D.$B3b||l==="iTerm.app"){const I=l===D.$B3b?"TerminalHelper":"iTermHelper",m=[f.$pg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",a||p,"-w",t];for(const N of h)m.push("-a"),m.push(N);if(s){const N=Object.assign({},o(process),s);for(const U in N){const T=N[U];T===null?(m.push("-u"),m.push(U)):(m.push("-e"),m.push(`${U}=${T}`))}}let y="";const L=C.spawn(c.b,m);L.on("error",N=>{w(i(N))}),L.stderr.on("data",N=>{y+=N.toString()}),L.on("exit",N=>{if(N===0)u(void 0);else if(y){const U=y.split(`
`,1);w(new Error(U[0]))}else w(new Error(R.localize(1,null,I,N)))})}else w(new Error(R.localize(2,null,l)))})}spawnTerminal(a,t,h){const s=t.osxExec||D.$B3b;return new Promise((d,l)=>{const u=["-a",s];h&&u.push(h);const w=o(process),I=a.spawn("/usr/bin/open",u,{cwd:h,env:w});I.on("error",l),I.on("exit",()=>d())})}}e.$D$b=c;class g extends k{static{this.b=R.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(C,a,t)}runInTerminal(a,t,h,s,d){const l=d.linuxExec?Promise.resolve(d.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((u,w)=>{const I=[];l.then(b=>{b.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const m=`${r(h)}; echo; read -p "${g.b}" -n1;`;I.push(`''${m}''`);const y=Object.assign({},o(process),s);Object.keys(y).filter(T=>y[T]===null).forEach(T=>delete y[T]);const L={cwd:t,env:y};let N="";const U=C.spawn(b,I,L);U.on("error",T=>{w(i(T))}),U.stderr.on("data",T=>{N+=T.toString()}),U.on("exit",T=>{if(T===0)u(void 0);else if(N){const O=N.split(`
`,1);w(new Error(O[0]))}else w(new Error(R.localize(4,null,b,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!A.$k)g.d=Promise.resolve("xterm");else{const a=await $.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(a,t,h){const s=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((d,l)=>{s.then(u=>{const w=o(process),I=a.spawn(u,[],{cwd:h,env:w});I.on("error",l),I.on("exit",()=>d())})})}}e.$E$b=g;function o(n){const a={...n.env};return(0,v.$Sl)(a),a}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(R.localize(5,null,n.path)):n}function r(n){let a="";for(const t of n)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(Ee[32],Se([1,0,77,17,12,18,2,203,5,10,16,43]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.FileKind=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.FileOperationResult=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.FileChangeType=e.$Jk=e.FileOperation=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileSystemProviderErrorCode=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderCapabilities=e.$tk=e.FilePermission=e.FileType=e.$sk=e.$rk=void 0,e.$rk=(0,$.$7h)("fileService");function p(ne){return ne.create===!0}e.$sk=p;var k;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var S;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function c(ne){const $e=ne;return!!$e&&typeof $e.onDidChange=="function"}e.$tk=c;var g;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function o(ne){return!!(ne.capabilities&2)}e.$uk=o;function i(ne){return!!(ne.capabilities&8)}e.$vk=i;function r(ne){return!!(ne.capabilities&131072)}e.$wk=r;function n(ne){return!!(ne.capabilities&4)}e.$xk=n;function a(ne){return!!(ne.capabilities&16)}e.$yk=a;function t(ne){return o(ne)?!!(ne.capabilities&16384):!1}e.$zk=t;function h(ne){return o(ne)?!!(ne.capabilities&32768):!1}e.$Ak=h;function s(ne){return!!(ne.capabilities&65536)}e.$Bk=s;function d(ne){return!!(ne.capabilities&2048)}e.$Ck=d;var l;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class u extends Error{static create($e,oe){const K=new u($e.toString(),oe);return b(K,oe),K}constructor($e,oe){super($e),this.code=oe}}e.$Dk=u;function w(ne,$e){return u.create(ne,$e)}e.$Ek=w;function I(ne){return ne||w((0,v.localize)(0,null),l.Unknown)}e.$Fk=I;function b(ne,$e){return ne.name=$e?`${$e} (FileSystemError)`:"FileSystemError",ne}e.$Gk=b;function m(ne){if(!ne)return l.Unknown;if(ne instanceof u)return ne.code;const $e=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!$e)return l.Unknown;switch($e[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$Hk=m;function y(ne){if(ne instanceof M)return ne.fileOperationResult;switch(m(ne)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$Ik=y;var L;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class N{constructor($e,oe,K){this.resource=$e,this.operation=oe,this.target=K}isOperation($e){return this.operation===$e}}e.$Jk=N;var U;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class T{static{this.a=null}constructor($e,oe){this.c=oe,this.b=void 0,this.d=new D.$V(()=>{const K=C.$ai.forUris(()=>this.c);return K.fill(this.rawAdded.map(W=>[W,!0])),K}),this.f=new D.$V(()=>{const K=C.$ai.forUris(()=>this.c);return K.fill(this.rawUpdated.map(W=>[W,!0])),K}),this.g=new D.$V(()=>{const K=C.$ai.forUris(()=>this.c);return K.fill(this.rawDeleted.map(W=>[W,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of $e){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==T.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains($e,...oe){return this.h($e,{includeChildren:!1},...oe)}affects($e,...oe){return this.h($e,{includeChildren:!0},...oe)}h($e,oe,...K){if(!$e)return!1;const W=K.length>0;return!!((!W||K.includes(1))&&(this.d.value.get($e)||oe.includeChildren&&this.d.value.findSuperstr($e))||(!W||K.includes(0))&&(this.f.value.get($e)||oe.includeChildren&&this.f.value.findSuperstr($e))||(!W||K.includes(2))&&(this.g.value.findSubstr($e)||oe.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Kk=T;function O(ne,$e,oe){return!ne||!$e||ne===$e||$e.length>ne.length?!1:($e.charAt($e.length-1)!==F.sep&&($e+=F.sep),oe?(0,f.$bf)(ne,$e):ne.indexOf($e)===0)}e.$Lk=O;class M extends Error{constructor($e,oe,K){super($e),this.fileOperationResult=oe,this.options=K}}e.$Mk=M;class j extends M{constructor($e,oe,K,W){super($e,oe,W),this.fileOperationResult=oe,this.size=K}}e.$Nk=j;class z extends M{constructor($e,oe,K){super($e,2,K),this.stat=oe}}e.$Ok=z;var J;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$Pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Rk="files.associations",e.$Sk="files.exclude",e.$Tk="files.readonlyInclude",e.$Uk="files.readonlyExclude",e.$Vk="files.readonlyFromPermissions";var le;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$Wk="";function Y(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}e.$Xk=Y;async function Q(ne,$e){if(!$e.hasProvider(A.URI.from({scheme:ne.scheme})))return new Promise(oe=>{const K=$e.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(K.dispose(),oe())})})}e.$Yk=Q;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize($e){return(0,P.$Nf)($e)||($e=0),$e<X.KB?(0,v.localize)(1,null,$e.toFixed(0)):$e<X.MB?(0,v.localize)(2,null,($e/X.KB).toFixed(2)):$e<X.GB?(0,v.localize)(3,null,($e/X.MB).toFixed(2)):$e<X.TB?(0,v.localize)(4,null,($e/X.GB).toFixed(2)):(0,v.localize)(5,null,($e/X.TB).toFixed(2))}}e.$Zk=X;function ue(ne){const $e=typeof ne=="string"||ne?.scheme===R.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===R.Schemas.file?1024*X.MB:$e?10*X.MB:E.$o?50*X.MB:1024*X.MB}e.$1k=ue}),define(Ee[242],Se([1,0,22,14,204,32]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;async function A(R,D,p,k,S,c){let g;try{await v(R,D,p,k,S,c)}catch(o){g=o}finally{g&&S.errorTransformer&&(g=S.errorTransformer(g)),typeof g<"u"&&p.error(g),p.end()}}e.$cq=A;async function v(R,D,p,k,S,c){$(c);const g=await R.open(D,{create:!1});try{$(c);let o=0,i=0,r=S&&typeof S.length=="number"?S.length:void 0,n=C.$ke.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await R.read(g,a,n.buffer,t,n.byteLength-t),a+=i,t+=i,o+=i,typeof r=="number"&&(r-=i),t===n.byteLength&&(await p.write(k(n)),n=C.$ke.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),t=0);while(i>0&&(typeof r!="number"||r>0)&&$(c)&&E(o,S));if(t>0){let h=t;typeof r=="number"&&(h=Math.min(t,r)),p.write(k(n.slice(0,h)))}}catch(o){throw(0,P.$Fk)(o)}finally{await R.close(g)}}function $(R){if(R.isCancellationRequested)throw(0,F.$6)();return!0}function E(R,D){if(typeof D?.limits?.size=="number"&&R>D.limits.size)throw(0,P.$Ek)((0,f.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[85],Se([1,0,35,3,17,10,2,32]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=void 0;function $(o){return o.recursive===!0}e.$eq=$;class E extends F.$Tc{static{this.a=5}constructor(i,r,n,a){super(),this.h=i,this.j=r,this.m=n,this.n=a,this.c=this.B(new F.$Uc),this.f=void 0,this.g=0}s(){const i=new F.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$fq=E;class R extends E{constructor(i,r,n){super(i,r,n,{type:"node.js",restartOnError:!1})}}e.$gq=R;class D extends E{constructor(i,r,n){super(i,r,n,{type:"universal",restartOnError:!0})}}e.$hq=D;function p(o){return o.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}e.$iq=p;function k(o){const i=new g;for(const r of o)i.processEvent(r);return i.coalesce()}e.$jq=k;function S(o,i){return typeof i=="string"&&!i.startsWith(C.$Jj)&&!(0,f.$ic)(i)?{base:o,pattern:i}:i}e.$kq=S;function c(o,i){const r=[];for(const n of i)r.push((0,C.$Nj)(S(o,n)));return r}e.$lq=c;class g{constructor(){this.a=new Set,this.b=new Map}c(i){return P.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let n=!1;if(r){const a=r.type,t=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(r)):a===2&&t===1?r.type=0:a===1&&t===0||(r.type=t)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,a)=>n.resource.fsPath.length-a.resource.fsPath.length).filter(n=>r.some(a=>(0,v.$Lk)(n.resource.fsPath,a,!P.$k))?!1:(r.push(n.resource.fsPath),!0)).concat(i)}}}),define(Ee[243],Se([1,0,57,11,21,34,3,76,17,10,23,2,104,31,85]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=void 0;class c extends A.$Tc{static{this.a=100}static{this.b=75}constructor(i,r,n,a){super(),this.m=i,this.n=r,this.r=n,this.s=a,this.c=this.B(new F.$jh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$ih(t=>this.z(t),c.b)),this.g=(0,S.$lq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$lq)(this.m.path,this.m.includes):void 0,this.j=new f.$7d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const r=await k.Promises.stat(i);this.B(await this.w(i,r.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let r=i.path;try{r=await k.Promises.realpath(i.path),i.path===r&&(r=await(0,p.$vq)(i.path)??i.path),i.path!==r&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${r})`)}catch{}return r}async w(i,r){if(E.$j&&(0,P.$9f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Tc.None;const n=new f.$7d(this.j.token),a=new A.$Sc;try{const t=D.URI.file(this.m.path),h=(0,$.$nc)(i),s=(0,C.watch)(i);a.add((0,A.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${i}'`);const d=new Set;if(r)try{for(const u of await k.Promises.readdir(i))d.add(u)}catch(u){this.D(u)}const l=new Map;a.add((0,A.$Rc)(()=>{for(const[,u]of l)u.dispose();l.clear()})),s.on("error",(u,w)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${u}, ${w})`),this.dispose()}),s.on("change",(u,w)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${u}"] ${w}`);let I="";if(w&&(I=w.toString(),E.$j&&(I=(0,v.$Hl)(I))),!(!I||u!=="change"&&u!=="rename"))if(r)if(u==="rename"){l.get(I)?.dispose();const b=setTimeout(async()=>{if(l.delete(I),I===h&&!await k.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.C((0,$.$jc)(i,I));if(n.token.isCancellationRequested)return;let y;m?d.has(I)?y=0:(y=1,d.add(I)):(d.delete(I),y=2),this.y({resource:(0,R.$Ig)(t,I),type:y,cId:this.m.correlationId})},c.a);l.set(I,(0,A.$Rc)(()=>clearTimeout(b)))}else{let b;d.has(I)?b=0:(b=1,d.add(I)),this.y({resource:(0,R.$Ig)(t,I),type:b,cId:this.m.correlationId})}else if(u==="rename"||I!==h){const b=setTimeout(async()=>{const m=await k.Promises.exists(i);n.token.isCancellationRequested||(m?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);a.clear(),a.add((0,A.$Rc)(()=>clearTimeout(b)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await k.Promises.exists(i)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Rc)(()=>{n.dispose(!0),a.dispose()})}y(i,r=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!r&&this.g.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!r&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const r=(0,S.$jq)(i);if(r.length>0){if(this.s)for(const a of r)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(E.$k)return k.Promises.exists(i);try{const r=(0,$.$nc)(i);return(await k.Promises.readdir((0,$.$mc)(i))).some(a=>a===r)}catch(r){return this.G(r),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$yq=c;async function g(o,i,r,n,a=512){const t=await k.Promises.open(o,"r"),h=Buffer.allocUnsafe(a),s=new f.$7d(n);let d,l=!1;const u={path:o,excludes:[],recursive:!1},w=new c(u,I=>{(async()=>{for(const{type:b}of I)if(b===0){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:m}=await k.Promises.read(t,h,0,a,null);if(!m||s.token.isCancellationRequested)break;i(h.slice(0,m))}}catch(m){d=new Error(m),s.dispose(!0)}finally{l=!1}}})()});return await w.ready,r(),new Promise((I,b)=>{s.token.onCancellationRequested(async()=>{w.dispose();try{await k.Promises.close(t)}catch(m){d=new Error(m)}d?b(d):I()})})}e.$zq=g}),define(Ee[244],Se([1,0,4,35,3,10,243]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class v extends f.$Tc{constructor(){super(...arguments),this.a=this.B(new C.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(E){const R=this.j(E),D=R.filter(k=>{const S=this.c.get(k.path);return S?!(0,F.$Rj)(S.request.excludes,k.excludes)||!(0,F.$Rj)(S.request.includes,k.includes):!0}),p=Array.from(this.c.values()).filter(({request:k})=>!R.find(S=>S.path===k.path&&(0,F.$Rj)(S.excludes,k.excludes)&&(0,F.$Rj)(S.includes,k.includes))).map(({request:k})=>k.path);D.length&&this.m(`Request to start watching: ${D.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"}, correlationId: ${typeof k.correlationId=="number"?k.correlationId:"<none>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const k of p)this.h(k);for(const k of D)this.g(k)}g(E){const R=new A.$yq(E,p=>this.a.fire(p),p=>this.b.fire(p),this.f),D={request:E,instance:R};this.c.set(E.path,D)}async stop(){for(const[E]of this.c)this.h(E);this.c.clear()}h(E){const R=this.c.get(E);R&&(this.c.delete(E),R.instance.dispose())}j(E){const R=new Map;for(const D of E){const p=P.$k?D.path:D.path.toLowerCase();let k=R.get(D.correlationId);k||(k=new Map,R.set(D.correlationId,k)),k.set(p,D)}return Array.from(R.values()).map(D=>Array.from(D.values())).flat()}async setVerboseLogging(E){this.f=E;for(const[,R]of this.c)R.instance.setVerboseLogging(E)}m(E){this.f&&this.b.fire({type:"trace",message:this.n(E)})}n(E,R){return R?`[File Watcher (node.js)] ${E} (path: ${R.request.path})`:`[File Watcher (node.js)] ${E}`}}e.$Aq=v}),define(Ee[245],Se([1,0,85,244]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class f extends C.$gq{constructor(A,v,$){super(A,v,$),this.s()}r(A){return A.add(new F.$Aq)}}e.$Bq=f}),define(Ee[246],Se([1,0,16,81,187,85]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;class A extends P.$hq{constructor($,E,R){super($,E,R),this.s()}r($){const E=$.add(new f.$sq(C.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(E.onDidProcessExit(({code:R,signal:D})=>this.t(`terminated by itself with code ${R}, signal: ${D}`))),F.ProxyChannel.toService((0,F.$Nh)(E.getChannel("watcher")))}}e.$tq=A}),define(Ee[107],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class C{constructor(...f){this.a=new Map;for(const[P,A]of f)this.set(P,A)}set(f,P){const A=this.a.get(f);return this.a.set(f,P),A}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$5h=C}),define(Ee[247],Se([1,0,11,14,3,106,238,5,107,75]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;const R=!1;class D extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class p{constructor(g=new $.$5h,o=!1,i,r=R){this.f=g,this.g=o,this.h=i,this.i=r,this.o=new Set,this.f.set(v.$6h,this),this._globalGraph=r?i?._globalGraph??new A.$Eq(n=>n):void 0}createChild(g){return new p(g,this.g,this,this.i)}invokeFunction(g,...o){const i=S.traceInvocation(this.i,g);let r=!1;try{return g({get:a=>{if(r)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{r=!0,i.stop()}}createInstance(g,...o){let i,r;return g instanceof P.$4h?(i=S.traceCreation(this.i,g.ctor),r=this.j(g.ctor,g.staticArguments.concat(o),i)):(i=S.traceCreation(this.i,g),r=this.j(g,o,i)),i.stop(),r}j(g,o=[],i){const r=v._util.getServiceDependencies(g).sort((t,h)=>t.index-h.index),n=[];for(const t of r){const h=this.m(t.id,i);h||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(h)}const a=r.length>0?r[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${g.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(g,o.concat(n))}k(g,o){if(this.f.get(g)instanceof P.$4h)this.f.set(g,o);else if(this.h)this.h.k(g,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const o=this.f.get(g);return!o&&this.h?this.h.l(g):o}m(g,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const i=this.l(g);return i instanceof P.$4h?this.q(g,i,o.branch(g,!0)):(o.branch(g,!1),i)}q(g,o,i){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,o,i)}finally{this.o.delete(g)}}r(g,o,i){const r=new A.$Eq(t=>t.id.toString());let n=0;const a=[{id:g,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(r.lookupOrInsertNode(t),n++>1e3)throw new D(r);for(const h of v._util.getServiceDependencies(t.desc.ctor)){const s=this.l(h.id);if(s||this.u(`[createInstance] ${g} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),s instanceof P.$4h){const d={id:h.id,desc:s,_trace:t._trace.branch(h.id,!0)};r.insertEdge(t,d),a.push(d)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new D(r);break}for(const{data:h}of t){if(this.l(h.id)instanceof P.$4h){const d=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,d)}r.removeNode(h)}}return this.l(g)}s(g,o,i=[],r,n){if(this.f.get(g)instanceof P.$4h)return this.t(g,o,i,r,n);if(this.h)return this.h.s(g,o,i,r,n);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(g,o,i=[],r,n){if(r){const a=new p(void 0,this.g,this,this.i);a.c=String(g);const t=new Map,h=new C.$nh(()=>{const s=a.j(o,i,n);for(const[d,l]of t){const u=s[d];if(typeof u=="function")for(const w of l)w.disposable=u.apply(s,w.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,d){if(!h.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let w=t.get(d);return w||(w=new E.$4c,t.set(d,w)),(b,m,y)=>{if(h.isInitialized)return h.value[d](b,m,y);{const L={listener:[b,m,y],disposable:void 0},N=w.push(L);return(0,f.$Rc)(()=>{N(),L.disposable?.dispose()})}}}if(d in s)return s[d];const l=h.value;let u=l[d];return typeof u!="function"||(u=u.bind(l),s[d]=u),u},set(s,d,l){return h.value[d]=l,!0},getPrototypeOf(s){return o.prototype}})}else return this.j(o,i,n)}u(g,o){if(o&&console.warn(g),this.g)throw new Error(g)}}e.$Fq=p;var k;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(k||(k={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,o){return g?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(g,o){return g?new S(1,o.name):S.c}static{this.f=0}constructor(g,o){this.type=g,this.name=o,this.g=Date.now(),this.h=[]}branch(g,o){const i=new S(3,g.toString());return this.h.push([g,o,i]),i}stop(){const g=Date.now()-this.g;S.f+=g;let o=!1;function i(n,a){const t=[],h=new Array(n+1).join("	");for(const[s,d,l]of a.h)if(d&&l){o=!0,t.push(`${h}CREATES -> ${s}`);const u=i(n+1,l);u&&t.push(u)}else t.push(`${h}uses -> ${s}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(g>2||o)&&S.all.add(r.join(`
`))}}e.$Gq=S}),define(Ee[13],Se([1,0,44,4,54,3,28,10,23,18,2,45,5]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.log=e.$rj=e.LogLevel=e.$qj=e.$pj=e.$oj=void 0,e.$oj=(0,p.$7h)("logService"),e.$pj=(0,p.$7h)("loggerService");function k(){return new Date().toISOString()}function S(b){return(0,E.$Nf)(b)}e.$qj=S;var c;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$rj=c.Info;function g(b,m,y){switch(m){case c.Trace:b.trace(y);break;case c.Debug:b.debug(y);break;case c.Info:b.info(y);break;case c.Warning:b.warn(y);break;case c.Error:b.error(y);break;case c.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=g;function o(b,m=!1){let y="";for(let L=0;L<b.length;L++){let N=b[L];if(N instanceof Error&&(N=(0,C.$Ri)(N,m)),typeof N=="object")try{N=JSON.stringify(N)}catch{}y+=(L>0?" ":"")+N}return y}class i extends P.$Tc{constructor(){super(...arguments),this.b=e.$rj,this.c=this.B(new F.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==c.Off&&this.b<=m}}e.$tj=i;class r extends i{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...y){this.f(c.Trace)&&this.g(c.Trace,o([m,...y],!0))}debug(m,...y){this.f(c.Debug)&&this.g(c.Debug,o([m,...y]))}info(m,...y){this.f(c.Info)&&this.g(c.Info,o([m,...y]))}warn(m,...y){this.f(c.Warning)&&this.g(c.Warning,o([m,...y]))}error(m,...y){if(this.f(c.Error))if(m instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=m.stack,this.g(c.Error,o(L))}else this.g(c.Error,o([m,...y]))}flush(){}}e.$uj=r;class n extends i{constructor(m=e.$rj){super(),this.setLevel(m),this.g=!v.$i}trace(m,...y){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,m,...y):console.log(`[main ${k()}]`,m,...y))}debug(m,...y){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,m,...y):console.log(`[main ${k()}]`,m,...y))}info(m,...y){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,m,...y):console.log(`[main ${k()}]`,m,...y))}warn(m,...y){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,m,...y):console.warn(`[main ${k()}]`,m,...y))}error(m,...y){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,m,...y):console.error(`[main ${k()}]`,m,...y))}flush(){}}e.$vj=n;class a extends i{constructor(m=e.$rj,y=!0){super(),this.g=y,this.setLevel(m)}trace(m,...y){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...y):console.log(m,...y))}debug(m,...y){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...y):console.log(m,...y))}info(m,...y){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...y):console.log(m,...y))}warn(m,...y){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...y):console.log(m,...y))}error(m,...y){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...y):console.error(m,...y))}flush(){}}e.$wj=a;class t extends i{constructor(m,y=e.$rj){super(),this.g=m,this.setLevel(y)}trace(m,...y){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(m),...y])}debug(m,...y){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(m),...y])}info(m,...y){this.f(c.Info)&&this.g.log(c.Info,[this.h(m),...y])}warn(m,...y){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(m),...y])}error(m,...y){this.f(c.Error)&&this.g.log(c.Error,[this.h(m),...y])}h(m){return typeof m=="string"?m:(0,C.$Ri)(m,this.f(c.Trace))}flush(){}}e.$xj=t;class h extends i{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const y of this.g)y.setLevel(m);super.setLevel(m)}trace(m,...y){for(const L of this.g)L.trace(m,...y)}debug(m,...y){for(const L of this.g)L.debug(m,...y)}info(m,...y){for(const L of this.g)L.info(m,...y)}warn(m,...y){for(const L of this.g)L.warn(m,...y)}error(m,...y){for(const L of this.g)L.error(m,...y)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose();super.dispose()}}e.$yj=h;class s extends P.$Tc{constructor(m,y,L){if(super(),this.h=m,this.j=y,this.b=new A.$Ac,this.c=this.B(new F.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Wd),this.onDidChangeVisibility=this.g.event,L)for(const N of L)this.b.set(N.resource,{logger:void 0,info:N})}m(m){return(0,E.$Jf)(m)?[...this.b.values()].find(y=>y.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,y){const L=this.n(m),N=(0,E.$Jf)(m)?m:y?.id??(0,f.$Ui)(L.toString()).toString(16);let U=this.b.get(L)?.logger;const T=y?.logLevel==="always"?c.Trace:y?.logLevel;U||(U=this.s(L,T??this.getLogLevel(L)??this.h,{...y,id:N}));const O={logger:U,info:{resource:L,id:N,logLevel:T,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(O.info),this.b.set(L,O),U}n(m){return(0,E.$Jf)(m)?(0,$.$Ig)(this.j,`${m}.log`):m}setLogLevel(m,y){if(R.URI.isUri(m)){const L=m,N=y,U=this.b.get(L);U&&N!==U.info.logLevel&&(U.info.logLevel=N===this.h?void 0:N,U.logger?.setLevel(N),this.b.set(U.info.resource,U),this.f.fire([L,N]))}else{this.h=m;for(const[L,N]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,y){const L=this.m(m);L&&y!==!L.info.hidden&&(L.info.hidden=!y,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,y]))}getLogLevel(m){let y;return m&&(y=this.b.get(m)?.info.logLevel),y??this.h}registerLogger(m){const y=this.b.get(m.resource);y?y.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const y=this.b.get(m);y&&(y.logger&&y.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$zj=s;class d{constructor(){this.onDidChangeLogLevel=new F.$Wd().event}setLevel(m){}getLevel(){return c.Info}trace(m,...y){}debug(m,...y){}info(m,...y){}warn(m,...y){}error(m,...y){}critical(m,...y){}dispose(){}flush(){}}e.$Aj=d;class l extends d{}e.$Bj=l;function u(b){if(b.verbose)return c.Trace;if(typeof b.logLevel=="string"){const m=I(b.logLevel.toLowerCase());if(m!==void 0)return m}return e.$rj}e.$Cj=u;function w(b){switch(b){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$Dj=w;function I(b){switch(b){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$Ej=I,e.$Fj=new D.$lj("logLevel",w(c.Info))}),define(Ee[248],Se([1,0,19,11,14,4,3,17,85,13]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class R extends A.$Tc{constructor(p,k){super(),this.a=p,this.b=k,this.c=this.B(new P.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$5g(0)),this.w=[],this.y=this.B(new F.$5g(0))}watch(p,k){return k.recursive||this.b?.watcher?.forceUniversal?this.n(p,k):this.z(p,k)}n(p,k){const S={path:this.H(p),excludes:k.excludes,includes:k.includes,recursive:k.recursive,correlationId:k.correlationId},c=(0,C.$Ub)(this.j,S);return this.r(),(0,A.$Rc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,f.$1)(p))}s(){this.h||(this.h=this.B(this.t(k=>this.c.fire((0,$.$iq)(k)),k=>this.G(k),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const k of this.j)(0,$.$eq)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const k of this.j)(0,$.$eq)(k)&&p.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,k){const S={path:this.H(p),excludes:k.excludes,includes:k.includes,recursive:!1,correlationId:k.correlationId},c=(0,C.$Ub)(this.w,S);return this.C(),(0,A.$Rc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,f.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,$.$iq)(p)),p=>this.G(p),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,v.$hc)(p.fsPath)}}e.$mq=R}),define(Ee[249],Se([1,0,57,388,11,28,22,4,34,3,17,10,23,99,31,205,32,242,248,44,246,245]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0,(()=>{try{(0,F.gracefulify)(C)}catch(h){console.error(`Error enabling graceful-fs: ${(0,r.$Ri)(h)}`)}})();class t extends i.$mq{static{this.I=!1}constructor(s,d){super(s,d),this.onDidChangeCapabilities=v.Event.None,this.N=new P.$Ac(l=>p.$zg.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,D.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:d,symbolicLink:l}=await S.SymlinkSupport.stat(this.H(s));return{type:this.M(d,l),ctime:d.birthtime.getTime(),mtime:d.mtime.getTime(),size:d.size,permissions:d.mode&128?void 0:g.FilePermission.Locked}}catch(d){throw this.fb(d)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const d=await S.Promises.readdir(this.H(s),{withFileTypes:!0}),l=[];return await Promise.all(d.map(async u=>{try{let w;u.isSymbolicLink()?w=(await this.stat((0,p.$Ig)(s,u.name))).type:w=this.M(u),l.push([u.name,w])}catch(w){this.a.trace(w)}})),l}catch(d){throw this.fb(d)}}M(s,d){let l;return d?.dangling?l=g.FileType.Unknown:s.isFile()?l=g.FileType.File:s.isDirectory()?l=g.FileType.Directory:l=g.FileType.Unknown,d&&(l|=g.FileType.SymbolicLink),l}async O(s){const d=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${d})`);let l;for(;l=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${d})`),await l.wait();const u=new f.$6g;return this.N.set(s,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${d})`),(0,E.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${d})`),this.N.get(s)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${d})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${d})`),u.open()})}async readFile(s,d){let l;try{d?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),l=await this.O(s));const u=this.H(s);return await S.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{l?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,d,l){const u=(0,k.$$d)(w=>A.$ke.concat(w.map(I=>A.$ke.wrap(I))).buffer);return(0,o.$cq)(this,s,u,w=>w.buffer,{...d,bufferSize:256*1024},l),u}async writeFile(s,d,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,p.$Ig)((0,p.$Hg)(s),`${(0,p.$Fg)(s)}${l.atomic.postfix}`),d,l):this.S(s,d,l)}async Q(s){try{const d=this.H(s),{symbolicLink:l}=await S.SymlinkSupport.stat(d);if(l)return!1}catch{}return!0}async R(s,d,l,u){const w=new E.$Sc;try{w.add(await this.O(s)),w.add(await this.O(d)),await this.S(d,l,u,!0);try{await this.rename(d,s,{overwrite:!0})}catch(I){try{await this.delete(d,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{w.dispose()}}async S(s,d,l,u){let w;try{const I=this.H(s);if(!l.create||!l.overwrite){if(await S.Promises.exists(I)){if(!l.overwrite)throw(0,g.$Ek)((0,c.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,g.$Ek)((0,c.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(s,{create:!0,unlock:l.unlock},u),await this.write(w,0,d,0,d.byteLength)}catch(I){throw await this.gb(s,I)}finally{typeof w=="number"&&await this.close(w)}}static{this.Y=!0}static configureFlushOnWrite(s){t.Y=s}async open(s,d,l){const u=this.H(s);let w;(0,g.$sk)(d)&&!l&&(w=await this.O(s));let I;try{if((0,g.$sk)(d)&&d.unlock)try{const{stat:m}=await S.SymlinkSupport.stat(u);m.mode&128||await S.Promises.chmod(u,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}let b;if((0,g.$sk)(d)){if(D.$i)try{await S.Promises.truncate(u,0),b="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}b||(b="w")}else b="r";I=await S.Promises.open(u,b)}catch(b){throw w?.dispose(),(0,g.$sk)(d)?await this.gb(s,b):this.fb(b)}if(this.U.set(I,0),(0,g.$sk)(d)&&this.X.set(I,s),w){const b=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${u})`),this.W.set(I,w),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${u})`),b.dispose())}return I}async close(s){const d=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await S.Promises.fdatasync(s)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await S.Promises.close(s)}catch(l){throw this.fb(l)}finally{d&&(this.W.get(s)===d&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),d.dispose())}}async read(s,d,l,u,w){const I=this.Z(s,d);let b=null;try{b=(await S.Promises.read(s,l,u,w,I)).bytesRead}catch(m){throw this.fb(m)}finally{this.$(s,I,b)}return b}Z(s,d){return d===this.U.get(s)?null:d}$(s,d,l){const u=this.U.get(s);typeof u=="number"&&(typeof d=="number"||(typeof l=="number"?this.U.set(s,u+l):this.U.delete(s)))}async write(s,d,l,u,w){return(0,f.$oh)(()=>this.ab(s,d,l,u,w),100,3)}async ab(s,d,l,u,w){const I=this.Z(s,d);let b=null;try{b=(await S.Promises.write(s,l,u,w,I)).bytesWritten}catch(m){throw await this.gb(this.X.get(s),m)}finally{this.$(s,I,b)}return b}async mkdir(s){try{await S.Promises.mkdir(this.H(s))}catch(d){throw this.fb(d)}}async delete(s,d){try{const l=this.H(s);if(d.recursive){let u;d?.atomic!==!1&&d.atomic.postfix&&(u=(0,R.$jc)((0,R.$mc)(l),`${(0,R.$nc)(l)}${d.atomic.postfix}`)),await S.Promises.rm(l,S.RimRafMode.MOVE,u)}else try{await S.Promises.unlink(l)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let w=!1;try{const{stat:I,symbolicLink:b}=await S.SymlinkSupport.stat(l);w=I.isDirectory()&&!b}catch{}if(w)await S.Promises.rmdir(l);else throw u}else throw u}}catch(l){throw this.fb(l)}}async rename(s,d,l){const u=this.H(s),w=this.H(d);if(u!==w)try{await this.bb(s,d,"move",l.overwrite),await S.Promises.rename(u,w)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,c.localize)(2,null,(0,R.$nc)(u),(0,R.$nc)((0,R.$mc)(w)),I.toString()))),this.fb(I)}}async copy(s,d,l){const u=this.H(s),w=this.H(d);if(u!==w)try{await this.bb(s,d,"copy",l.overwrite),await S.Promises.copy(u,w,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,c.localize)(3,null,(0,R.$nc)(u),(0,R.$nc)((0,R.$mc)(w)),I.toString()))),this.fb(I)}}async bb(s,d,l,u){const w=this.H(s),I=this.H(d);let b=!1;if(!!(this.capabilities&1024)||(b=(0,$.$8f)(w,I,!0)),b){if(l==="copy")throw(0,g.$Ek)((0,c.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const y=await this.L(s);if(!y)throw(0,g.$Ek)((0,c.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(d);if(L){if(!u)throw(0,g.$Ek)((0,c.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);y.type&g.FileType.File&&L.type&g.FileType.File||await this.delete(d,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,d){return this.cb(s,d,!1)}async cb(s,d,l){const u=this.H(s),w=this.H(d),I=!!(this.capabilities&1024);if((0,$.$8f)(u,w,!I))return;const b=new E.$Sc;try{b.add(await this.O(s)),b.add(await this.O(d)),l&&await S.Promises.mkdir((0,R.$mc)(w),{recursive:!0}),await S.Promises.copyFile(u,w)}catch(m){if(m.code==="ENOENT"&&!l)return this.cb(s,d,!0);throw this.fb(m)}finally{b.dispose()}}t(s,d,l){return new n.$tq(u=>s(u),u=>d(u),l)}F(s,d,l){return new a.$Bq(u=>s(u),u=>d(u),l)}fb(s){if(s instanceof g.$Dk)return s;let d=s,l;switch(s.code){case"ENOENT":l=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":d=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=g.FileSystemProviderErrorCode.Unknown;break;default:l=g.FileSystemProviderErrorCode.Unknown}return(0,g.$Ek)(d,l)}async gb(s,d){let l=this.fb(d);if(s&&l.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await S.SymlinkSupport.stat(this.H(s));u.mode&128||(l=(0,g.$Ek)(d,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return l}}e.$Cq=t}),define(Ee[250],Se([1,0,3,13]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=void 0;class f extends C.$Tc{constructor(A,v=[]){super(),this.a=new F.$yj([A,...v]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...v){this.a.trace(A,...v)}debug(A,...v){this.a.debug(A,...v)}info(A,...v){this.a.info(A,...v)}warn(A,...v){this.a.warn(A,...v)}error(A,...v){this.a.error(A,...v)}flush(){this.a.flush()}}e.$HO=f}),define(Ee[251],Se([1,0,32,13]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=void 0;var f;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(f||(f={}));async function P(E,R,D,p,k){try{const S=await new Promise((g,o)=>{ge(["@vscode/spdlog"],g,o)});S.setFlushOn(f.Trace);const c=await S.createAsyncRotatingLogger(E,R,D,p);return k?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(S){console.error(S)}return null}function A(E,R,D){switch(R){case F.LogLevel.Trace:E.trace(D);break;case F.LogLevel.Debug:E.debug(D);break;case F.LogLevel.Info:E.info(D);break;case F.LogLevel.Warning:E.warn(D);break;case F.LogLevel.Error:E.error(D);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function v(E,R){switch(R){case F.LogLevel.Trace:E.setLevel(f.Trace);break;case F.LogLevel.Debug:E.setLevel(f.Debug);break;case F.LogLevel.Info:E.setLevel(f.Info);break;case F.LogLevel.Warning:E.setLevel(f.Warning);break;case F.LogLevel.Error:E.setLevel(f.Error);break;case F.LogLevel.Off:E.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class $ extends F.$uj{constructor(R,D,p,k,S){super(),this.m=[],this.setLevel(S),this.n=this.s(R,D,p,k),this.B(this.onDidChangeLogLevel(c=>{this.r&&v(this.r,c)}))}async s(R,D,p,k){const S=p?6:1,c=30/S*C.$Zk.MB,g=await P(R,D,c,S,k);if(g){this.r=g,v(this.r,this.getLevel());for(const{level:o,message:i}of this.m)A(this.r,o,i);this.m=[]}}g(R,D){this.r?A(this.r,R,D):this.getLevel()<=R&&this.m.push({level:R,message:D})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$wO=$}),define(Ee[135],Se([1,0,39,206,5]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function E(S,c){return c-S}$.compare=E;const R=Object.create(null);R[$.Error]=(0,F.localize)(0,null),R[$.Warning]=(0,F.localize)(1,null),R[$.Info]=(0,F.localize)(2,null);function D(S){return R[S]||""}$.toString=D;function p(S){switch(S){case C.default.Error:return $.Error;case C.default.Warning:return $.Warning;case C.default.Info:return $.Info;case C.default.Ignore:return $.Hint}}$.fromSeverity=p;function k(S){switch(S){case $.Error:return C.default.Error;case $.Warning:return C.default.Warning;case $.Info:return C.default.Info;case $.Hint:return C.default.Ignore}}$.toSeverity=k}(A||(e.MarkerSeverity=A={}));var v;(function($){const E="";function R(p){return D(p,!0)}$.makeKey=R;function D(p,k){const S=[E];return p.source?S.push(p.source.replace("\xA6","\\\xA6")):S.push(E),p.code?typeof p.code=="string"?S.push(p.code.replace("\xA6","\\\xA6")):S.push(p.code.value.replace("\xA6","\\\xA6")):S.push(E),p.severity!==void 0&&p.severity!==null?S.push(A.toString(p.severity)):S.push(E),p.message&&k?S.push(p.message.replace("\xA6","\\\xA6")):S.push(E),p.startLineNumber!==void 0&&p.startLineNumber!==null?S.push(p.startLineNumber.toString()):S.push(E),p.startColumn!==void 0&&p.startColumn!==null?S.push(p.startColumn.toString()):S.push(E),p.endLineNumber!==void 0&&p.endLineNumber!==null?S.push(p.endLineNumber.toString()):S.push(E),p.endColumn!==void 0&&p.endColumn!==null?S.push(p.endColumn.toString()):S.push(E),S.push(E),S.join("\xA6")}$.makeKeyOptionalMessage=D})(v||(e.IMarkerData=v={})),e.$Bt=(0,f.$7h)("markerService")}),define(Ee[252],Se([1,0,4,39,5]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.NotificationsFilter=e.$rv=e.NeverShowAgainScope=e.NotificationPriority=e.$qv=e.Severity=void 0,e.Severity=F.default,e.$qv=(0,f.$7h)("notificationService");var P;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var A;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function v(D){if(D){const p=D;return typeof p.id=="string"&&typeof p.label=="string"}return!1}e.$rv=v;var $;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new R,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$sv=E;class R{infinite(){}done(){}total(p){}worked(p){}}e.$tv=R}),define(Ee[253],Se([1,0,49]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.context<"u"){const P=f.context.configuration();if(P)F=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(F=globalThis._VSCODE_PRODUCT_JSON,C.env.VSCODE_DEV&&Object.assign(F,{nameShort:`${F.nameShort} Dev`,nameLong:`${F.nameLong} Dev`,dataFolderName:`${F.dataFolderName}-dev`,serverDataFolderName:F.serverDataFolderName?`${F.serverDataFolderName}-dev`:void 0}),!F.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(F,{version:P.version})}}else F={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testCoverage"],"ms-vscode.extension-test-runner":["testCoverage"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"vscjava.vscode-java-test":["testCoverage"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","handleIssueUri","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","commentReactor","contribShareMenu","fileComments","contribCommentPeekContext","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","treeViewMarkdownMessage","tabInputTextMerge","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatAgents2","chatAgents2Additions","defaultChatAgent","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"apidev.azure-api-center":["chatAgents2","chatRequestAccess"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot","github.copilot-chat","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.86.1",sha256:"e382de75b63a57d3419bbb110e17551d40d88b4bb0a49452dab2c7278b815e72",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.86.1",commit:"31c37ee8f63491495ac49e43b8544550fbae4533",date:"2024-02-07T08:35:21.863Z"},Object.keys(F).length===0&&Object.assign(F,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=F}),define(Ee[136],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Gj=(0,C.$7h)("productService"),e.$Hj="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(ge,e){return function(C,F){e(C,F,ge)}};define(Ee[86],Se([1,0,11,21,3,5]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.ProgressLocation=e.$uv=void 0,e.$uv=(0,P.$7h)("progressService");var A;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$vv=Object.freeze({total(){},worked(){},done(){}});class v{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$wv=v;class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const k=this.d;this.d=()=>{k?.(),p()}}):Promise.resolve()}}e.$xv=$;let E=class extends f.$Tc{constructor(p,k){super(),this.a=new C.$rh,k.withProgress(p,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,f.$Rc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$yv=E,e.$yv=E=Ge([qe(1,e.$uv)],E);class R extends f.$Tc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new f.$Sc)}start(p){this.stop();const k=++this.a,S=new F.$7d;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,f.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Rc)(()=>S.cancel())),this.b.add((0,f.$Rc)(()=>this.c?this.c.done():void 0)),{id:k,token:S.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$zv=R,e.$Av=(0,P.$7h)("editorProgressService")}),define(Ee[37],Se([1,0,61,18]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0;class f{constructor(){this.a=new Map}add(A,v){C.ok(F.$Jf(A)),C.ok(F.$Lf(v)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,v)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$In=new f}),define(Ee[108],Se([1,0,4,37]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0,e.$Jn={JSONContribution:"base.contributions.json"};function f(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class P{constructor(){this.b=new C.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,E){this.a[f($)]=E,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new P;F.$In.add(e.$Jn.JSONContribution,A)}),define(Ee[87],Se([1,0,19,4,18,196,51,108,37]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.ConfigurationScope=e.$Nn=e.EditPresentationTypes=void 0;var E;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$Nn={Configuration:"base.contributions.configuration"};var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un="vscode://schemas/settings/resourceLanguage",e.$Vn="vscode://schemas/settings/configurationDefaults";const D=$.$In.as(v.$Jn.JSONContribution);class p{constructor(){this.h=new Set,this.i=new F.$Wd,this.onDidSchemaChange=this.i.event,this.j=new F.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$Un,this.g),this.v()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const s=new Set;this.n(t,h,s),D.registerSchema(e.$Un,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const h=new Set;this.o(t,h),D.registerSchema(e.$Un,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:t,remove:h}){const s=new Set;this.o(h,s),this.n(t,!1,s),D.registerSchema(e.$Un,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const h=new Set;this.k(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(t,h){const s=[];for(const{overrides:d,source:l}of t)for(const u in d)if(h.add(u),e.$Xn.test(u)){const w=this.a.get(u),I=w?.valuesSources??new Map;if(l)for(const L of Object.keys(d[u]))I.set(L,l);const b={...w?.value||{},...d[u]};this.a.set(u,{source:l,value:b,valuesSources:I});const m=(0,A.$Ki)(u),y={type:"object",default:b,description:P.localize(1,null,m),$ref:e.$Un,defaultDefaultValue:b,source:f.$Jf(l)?void 0:l,defaultValueSource:l};s.push(...c(u)),this.d[u]=y,this.b.properties[u]=y}else{this.a.set(u,{value:d[u],source:l});const w=this.d[u];w&&(this.w(u,w),this.r(u,w))}this.m(s)}deregisterDefaultConfigurations(t){const h=new Set;this.l(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(t,h){for(const{overrides:s,source:d}of t)for(const l in s){const u=this.a.get(l),w=f.$Jf(d)?d:d?.id,I=f.$Jf(u?.source)?u?.source:u?.source?.id;if(w===I)if(h.add(l),this.a.delete(l),e.$Xn.test(l))delete this.d[l],delete this.b.properties[l];else{const b=this.d[l];b&&(this.w(l,b),this.r(l,b))}}this.u()}deltaConfiguration(t){let h=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),h=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),h=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const h of t)this.h.add(h);this.u()}n(t,h,s){t.forEach(d=>{this.p(d,h,d.extensionInfo,d.restrictedProperties,void 0,s),this.c.push(d),this.q(d)})}o(t,h){const s=d=>{if(d.properties)for(const l in d.properties){h.add(l);const u=this.d[l];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[l],this.s(l,d.properties[l])}d.allOf?.forEach(l=>s(l))};for(const d of t){s(d);const l=this.c.indexOf(d);l!==-1&&this.c.splice(l,1)}}p(t,h=!0,s,d,l=3,u){l=f.$Sf(t.scope)?l:t.scope;const w=t.properties;if(w)for(const b in w){const m=w[b];if(h&&r(b,m)){delete w[b];continue}if(m.source=s,m.defaultDefaultValue=w[b].default,this.w(b,m),e.$Xn.test(b)?m.scope=void 0:(m.scope=f.$Sf(m.scope)?l:m.scope,m.restricted=f.$Sf(m.restricted)?!!d?.includes(b):m.restricted),w[b].hasOwnProperty("included")&&!w[b].included){this.f[b]=w[b],delete w[b];continue}else this.d[b]=w[b],w[b].policy?.name&&this.e.set(w[b].policy.name,b);!w[b].deprecationMessage&&w[b].markdownDeprecationMessage&&(w[b].deprecationMessage=w[b].markdownDeprecationMessage),u.add(b)}const I=t.allOf;if(I)for(const b of I)this.p(b,h,s,d,l,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const h=s=>{const d=s.properties;if(d)for(const u in d)this.r(u,d[u]);s.allOf?.forEach(h)};h(t)}r(t,h){switch(e.$On.properties[t]=h,h.scope){case 1:e.$Pn.properties[t]=h;break;case 2:e.$Qn.properties[t]=h;break;case 6:e.$Rn.properties[t]=h;break;case 3:e.$Sn.properties[t]=h;break;case 4:e.$Tn.properties[t]=h;break;case 5:e.$Tn.properties[t]=h,this.g.properties[t]=h;break}}s(t,h){switch(delete e.$On.properties[t],h.scope){case 1:delete e.$Pn.properties[t];break;case 2:delete e.$Qn.properties[t];break;case 6:delete e.$Rn.properties[t];break;case 3:delete e.$Sn.properties[t];break;case 4:case 5:delete e.$Tn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const h=`[${t}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$Un};this.w(h,s),e.$On.properties[h]=s,e.$Pn.properties[h]=s,e.$Qn.properties[h]=s,e.$Rn.properties[h]=s,e.$Sn.properties[h]=s,e.$Tn.properties[h]=s}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$Un};e.$On.patternProperties[e.$Wn]=t,e.$Pn.patternProperties[e.$Wn]=t,e.$Qn.patternProperties[e.$Wn]=t,e.$Rn.patternProperties[e.$Wn]=t,e.$Sn.patternProperties[e.$Wn]=t,e.$Tn.patternProperties[e.$Wn]=t,this.i.fire()}w(t,h){const s=this.a.get(t);let d=s?.value,l=s?.source;f.$Qf(d)&&(d=h.defaultDefaultValue,l=void 0),f.$Qf(d)&&(d=o(h.type)),h.default=d,h.defaultValueSource=l}}const k="\\[([^\\]]+)\\]",S=new RegExp(k,"g");e.$Wn=`^(${k})+$`,e.$Xn=new RegExp(e.$Wn);function c(a){const t=[];if(e.$Xn.test(a)){let h=S.exec(a);for(;h?.length;){const s=h[1].trim();s&&t.push(s),h=S.exec(a)}}return(0,C.$Mb)(t)}e.$Yn=c;function g(a){return a.reduce((t,h)=>`${t}[${h}]`,"")}e.$Zn=g;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$1n=o;const i=new p;$.$In.add(e.$Nn.Configuration,i);function r(a,t){return a.trim()?e.$Xn.test(a)?P.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?P.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$2n=r;function n(){const a=[],t=i.getConfigurationProperties();for(const h of Object.keys(t))a.push([h,t[h].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$3n=n}),define(Ee[254],Se([1,0,19,4,159,3,28,24,18,2,51,87,37]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0;function k(h){return Object.isFrozen(h)?h:v.$xn(h)}class S{constructor(s={},d=[],l=[],u){this.b=s,this.c=d,this.d=l,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(d=>{if(d instanceof S)return d;const l=new c("");return l.parseRaw(d),l.configurationModel});this.f=s.reduce((d,l)=>l===d?l:d.merge(l),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$Ii)(this.contents,s):this.contents}inspect(s,d){const l=this.rawConfiguration.getValue(s),u=d?this.rawConfiguration.getOverrideValue(s,d):void 0,w=d?this.rawConfiguration.override(d).getValue(s):l;return{value:l,override:u,merged:w}}getOverrideValue(s,d){const l=this.i(d);return l?s?(0,R.$Ii)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const d=[];for(const l of this.overrides)l.identifiers.includes(s)&&d.push(...l.keys);return C.$Mb(d)}getAllOverrideIdentifiers(){const s=[];for(const d of this.overrides)s.push(...d.identifiers);return C.$Mb(s)}override(s){let d=this.a.get(s);return d||(d=this.g(s),this.a.set(s,d)),d}merge(...s){const d=v.$wn(this.contents),l=v.$wn(this.overrides),u=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const I of s)if(w.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(d,I.contents);for(const b of I.overrides){const[m]=l.filter(y=>C.$ub(y.identifiers,b.identifiers));m?(this.h(m.contents,b.contents),m.keys.push(...b.keys),m.keys=C.$Mb(m.keys)):l.push(v.$wn(b))}for(const b of I.keys)u.indexOf(b)===-1&&u.push(b)}return new S(d,u,l,w.every(I=>I instanceof S)?void 0:w)}g(s){const d=this.i(s);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const l={};for(const u of C.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let w=this.contents[u];const I=d[u];I&&(typeof w=="object"&&typeof I=="object"?(w=v.$wn(w),this.h(w,I)):w=I),l[u]=w}return new S(l,this.keys,this.overrides)}h(s,d){for(const l of Object.keys(d)){if(l in s&&$.$Lf(s[l])&&$.$Lf(d[l])){this.h(s[l],d[l]);continue}s[l]=v.$wn(d[l])}}i(s){let d=null,l=null;const u=w=>{w&&(l?this.h(l,w):l=v.$wn(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===s?d=w.contents:w.identifiers.includes(s)&&u(w.contents);return u(d),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,d){this.j(s,d,!0)}setValue(s,d){this.j(s,d,!1)}removeValue(s){const d=this.keys.indexOf(s);d!==-1&&(this.keys.splice(d,1),(0,R.$Hi)(this.contents,s),D.$Xn.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>C.$ub(l.identifiers,(0,D.$Yn)(s))),1))}j(s,d,l){(0,R.$Gi)(this.contents,s,d,u=>console.error(u)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),D.$Xn.test(s)&&this.overrides.push({identifiers:(0,D.$Yn)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$Fi)(this.contents[s],u=>console.error(u))})}}e.$4n=S;class c{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,d){if(!$.$Sf(s)){const l=this.g(s);this.parseRaw(l,d)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,d){this.a=s;const{contents:l,keys:u,overrides:w,restricted:I,hasExcludedProperties:b}=this.h(s,d);this.b=new S(l,u,w,b?[s]:void 0),this.c=I||[]}g(s){let d={},l=null,u=[];const w=[],I=[];function b(y){Array.isArray(u)?u.push(y):l!==null&&(u[l]=y)}const m={onObjectBegin:()=>{const y={};b(y),w.push(u),u=y,l=null},onObjectProperty:y=>{l=y},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const y=[];b(y),w.push(u),u=y,l=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:b,onError:(y,L,N)=>{I.push({error:y,offset:L,length:N})}};if(s)try{f.$kn(s,m),d=u[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return d}h(s,d){const l=p.$In.as(D.$Nn.Configuration).getConfigurationProperties(),u=this.i(s,l,!0,d);s=u.raw;const w=(0,R.$Fi)(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),I=Object.keys(s),b=this.j(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:w,keys:I,overrides:b,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(s,d,l,u){let w=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:w};const I={},b=[];for(const m in s)if(D.$Xn.test(m)&&l){const y=this.i(s[m],d,!1,u);I[m]=y.raw,w=w||y.hasExcludedProperties,b.push(...y.restricted)}else{const y=d[m],L=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&b.push(m),!u.exclude?.includes(m)&&(u.include?.includes(m)||(L===void 0||u.scopes===void 0||u.scopes.includes(L))&&!(u.skipRestricted&&y?.restricted))?I[m]=s[m]:w=!0}return{raw:I,restricted:b,hasExcludedProperties:w}}j(s,d){const l=[];for(const u of Object.keys(s))if(D.$Xn.test(u)){const w={};for(const I in s[u])w[I]=s[u][I];l.push({identifiers:(0,D.$Yn)(u),keys:Object.keys(w),contents:(0,R.$Fi)(w,d)})}return l}}e.$5n=c;class g extends P.$Tc{constructor(s,d,l,u){super(),this.c=s,this.f=d,this.g=u,this.b=this.B(new F.$Wd),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,w=>w.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&l.isEqual(w.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$6n=g;class o{constructor(s,d,l,u,w,I,b,m,y,L,N,U,T){this.a=s,this.b=d,this.c=l,this.overrideIdentifiers=u,this.d=w,this.f=I,this.g=b,this.h=m,this.i=y,this.j=L,this.k=N,this.l=U,this.m=T}get value(){return k(this.c)}n(s,d,l){const u=s.inspect(d,l);return{get value(){return k(u.value)},get override(){return k(u.override)},get merged(){return k(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(s,d,l,u,w=new S,I=new S,b=new A.$Ac,m=new S,y=new A.$Ac){this.c=s,this.d=d,this.f=l,this.g=u,this.h=w,this.i=I,this.j=b,this.l=m,this.m=y,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,d,l){return this.p(s,d,l).getValue(s)}updateValue(s,d,l={}){let u;l.resource?(u=this.m.get(l.resource),u||(u=new S,this.m.set(l.resource,u))):u=this.l,d===void 0?u.removeValue(s):u.setValue(s,d),l.resource||(this.a=null)}inspect(s,d,l){const u=this.p(s,d,l),w=this.t(d.resource,l),I=d.resource?this.m.get(d.resource)||this.l:this.l,b=new Set;for(const m of u.overrides)for(const y of m.identifiers)u.getOverrideValue(s,y)!==void 0&&b.add(y);return new o(s,d,u.getValue(s),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,w||void 0,I)}keys(s){const d=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,d){this.j.set(s,d),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,d){const l=[];if(!d){const{added:u,updated:w,removed:I}=a(this.c,s);d=[...u,...w,...I]}for(const u of d)for(const w of(0,D.$Yn)(u)){const I=this.c.getKeysForOverrideIdentifier(w),b=s.getKeysForOverrideIdentifier(w),m=[...b.filter(y=>I.indexOf(y)===-1),...I.filter(y=>b.indexOf(y)===-1),...I.filter(y=>!v.$An(this.c.override(w).getValue(y),s.override(w).getValue(y)))];l.push([w,m])}return this.updateDefaultConfiguration(s),{keys:d,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:d,updated:l,removed:u}=a(this.d,s),w=[...d,...l,...u];return w.length&&this.updatePolicyConfiguration(s),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:d,updated:l,removed:u,overrides:w}=a(this.applicationConfiguration,s),I=[...d,...l,...u];return I.length&&this.updateApplicationConfiguration(s),{keys:I,overrides:w}}compareAndUpdateLocalUserConfiguration(s){const{added:d,updated:l,removed:u,overrides:w}=a(this.localUserConfiguration,s),I=[...d,...l,...u];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:w}}compareAndUpdateRemoteUserConfiguration(s){const{added:d,updated:l,removed:u,overrides:w}=a(this.remoteUserConfiguration,s),I=[...d,...l,...u];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:w}}compareAndUpdateWorkspaceConfiguration(s){const{added:d,updated:l,removed:u,overrides:w}=a(this.workspaceConfiguration,s),I=[...d,...l,...u];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:w}}compareAndUpdateFolderConfiguration(s,d){const l=this.folderConfigurations.get(s),{added:u,updated:w,removed:I,overrides:b}=a(l,d),m=[...u,...w,...I];return(m.length||!l)&&this.updateFolderConfiguration(s,d),{keys:m,overrides:b}}compareAndDeleteFolderConfiguration(s){const d=this.folderConfigurations.get(s);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:u,removed:w,overrides:I}=a(d,void 0);return{keys:[...l,...u,...w],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,d,l){let u=this.q(d,l);return d.overrideIdentifier&&(u=u.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(u=u.merge(this.d)),u}q({resource:s},d){let l=this.r();if(d&&s){const u=d.getFolder(s);u&&(l=this.s(u.uri)||l);const w=this.m.get(s);w&&(l=l.merge(w))}return l}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let d=this.b.get(s);if(!d){const l=this.r(),u=this.j.get(s);u?(d=l.merge(u),this.b.set(s,d)):d=l}return d}t(s,d){if(d&&s){const l=d.getFolder(s);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,d)=>{const{contents:l,overrides:u,keys:w}=this.j.get(d);return s.push([d,{contents:l,overrides:u,keys:w}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(d=>s.add(d)),this.userConfiguration.keys.forEach(d=>s.add(d)),this.i.keys.forEach(d=>s.add(d)),this.j.forEach(d=>d.keys.forEach(l=>s.add(l))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>s.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>s.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>s.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}v(s){const d=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(l=>d.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>d.add(l)),this.i.getKeysForOverrideIdentifier(s).forEach(l=>d.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(u=>d.add(u))),[...d.values()]}static parse(s){const d=this.w(s.defaults),l=this.w(s.policy),u=this.w(s.application),w=this.w(s.user),I=this.w(s.workspace),b=s.folders.reduce((m,y)=>(m.set(E.URI.revive(y[0]),this.w(y[1])),m),new A.$Ac);return new i(d,l,u,w,new S,I,b,new S,new A.$Ac)}static w(s){return new S(s.contents,s.keys,s.overrides)}}e.$7n=i;function r(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const s=new Set,d=new Map;for(const u of h)u.keys.forEach(w=>s.add(w)),u.overrides.forEach(([w,I])=>{const b=(0,A.$xc)(d,w,new Set);I.forEach(m=>b.add(m))});const l=[];return d.forEach((u,w)=>l.push([w,[...u.values()]])),{keys:[...s.values()],overrides:l}}e.$8n=r;class n{constructor(s,d,l,u){this.change=s,this.f=d,this.g=l,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const w of s.keys)this.affectedKeys.add(w);for(const[,w]of s.overrides)for(const I of w)this.affectedKeys.add(I);this.d=this.a;for(const w of this.affectedKeys)this.d+=w+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(s,d){const l=this.a+s,u=this.d.indexOf(l);if(u<0)return!1;const w=u+l.length;if(w>=this.d.length)return!1;const I=this.d.charCodeAt(w);if(I!==this.b&&I!==this.c)return!1;if(d){const b=this.previousConfiguration?this.previousConfiguration.getValue(s,d,this.f?.workspace):void 0,m=this.g.getValue(s,d,this.h);return!v.$An(b,m)}return!0}}e.$9n=n;function a(h,s){const{added:d,removed:l,updated:u}=t(s?.rawConfiguration,h?.rawConfiguration),w=[],I=h?.getAllOverrideIdentifiers()||[],b=s?.getAllOverrideIdentifiers()||[];if(s){const m=b.filter(y=>!I.includes(y));for(const y of m)w.push([y,s.getKeysForOverrideIdentifier(y)])}if(h){const m=I.filter(y=>!b.includes(y));for(const y of m)w.push([y,h.getKeysForOverrideIdentifier(y)])}if(s&&h){for(const m of I)if(b.includes(m)){const y=t({contents:h.getOverrideValue(void 0,m)||{},keys:h.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});w.push([m,[...y.added,...y.removed,...y.updated]])}}return{added:d,removed:l,updated:u,overrides:w}}function t(h,s){const d=h?s?h.keys.filter(w=>s.keys.indexOf(w)===-1):[...h.keys]:[],l=s?h?s.keys.filter(w=>h.keys.indexOf(w)===-1):[...s.keys]:[],u=[];if(h&&s){for(const w of s.keys)if(h.keys.indexOf(w)!==-1){const I=(0,R.$Ii)(s.contents,w),b=(0,R.$Ii)(h.contents,w);v.$An(I,b)||u.push(w)}}return{added:d,removed:l,updated:u}}}),define(Ee[255],Se([1,0,22,4,3,82]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$asb=e.$_rb=e.$$rb=e.$0rb=void 0;const A=(E,R,D)=>{const p=new Uint8Array(16);for(let c=0;c<16;c++)p[c]=Math.round(Math.random()*256);const k=(0,C.$Ee)(C.$ke.wrap(p));return[`GET ws://localhost${E}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$0rb=A,e.$$rb=C.$ke.fromString(`\r
\r
`);async function v(E,R,D,p,k){E.write(C.$ke.fromString((0,e.$0rb)(R,D,p)));const S=new f.$Sc;try{return await new Promise((c,g)=>{let o;S.add(E.onData(i=>{o?o=C.$ke.concat([o,i],o.byteLength+i.byteLength):o=i;const r=o.indexOf(e.$$rb);if(r===-1)return;c(E),E.pauseData();const n=o.slice(r+e.$$rb.byteLength);n.byteLength&&k.onData.fire(n)})),S.add(E.onClose(i=>g(i??new Error("socket closed")))),S.add(E.onEnd(()=>g(new Error("socket ended"))))})}catch(c){throw E.dispose(),c}finally{S.dispose()}}e.$_rb=v;class $ extends f.$Tc{constructor(R,D){super(),this.g=R,this.a=this.B(new F.$Zd),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new F.$Wd),this.onDidDispose=this.b.event,this.f=!1,this.B(D.onData),this.B(D.onData.event(p=>this.a.fire(p))),this.onClose=this.B(D.onClose).event,this.onEnd=this.B(D.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,D){P.SocketDiagnostics.traceSocketEvent(this,this.g,R,D)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$asb=$}),define(Ee[64],Se([1,0,14,5]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.RemoteAuthorityResolverErrorCode=e.$$k=e.$0k=e.RemoteConnectionType=e.$9k=void 0,e.$9k=(0,F.$7h)("remoteAuthorityResolverService");var f;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class P{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$0k=P;class A{constructor(D,p){this.host=D,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$$k=A;var v;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(v||(e.RemoteAuthorityResolverErrorCode=v={}));class $ extends C.$bb{static isNotAvailable(D){return D instanceof $&&D._code===v.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof $&&D._code===v.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof $&&D._code===v.NoResolverFound}static isInvalidAuthority(D){return D instanceof $&&D._code===v.InvalidAuthority}static isHandled(D){return D instanceof $&&D.isHandled}constructor(D,p=v.Unknown,k){super(D),this._message=D,this._code=p,this._detail=k,this.isHandled=p===v.NotAvailable&&k===!0,Object.setPrototypeOf(this,$.prototype)}}e.$_k=$;function E(R){const D=R.indexOf("+");return D===-1?R:R.substring(0,D)}e.$al=E}),define(Ee[65],Se([1,0,16]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=void 0;function F(E){return E.scheme===C.Schemas.vscodeRemote?E.authority:void 0}e.$bl=F;function f(E){if(!E)return;const R=E.indexOf("+");return R<0?E:E.substr(0,R)}e.$cl=f;function P(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.$dl=P;function A(E){const{host:R,port:D}=$(E);if(typeof D>"u")throw new Error(`Invalid remote authority: ${E}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:D}}e.$el=A;function v(E,R){let{host:D,port:p}=$(E);return typeof p>"u"&&(p=R),{host:D,port:p}}e.$fl=v;function $(E){const R=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const D=E.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const p=E.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:E,port:void 0}}}),define(Ee[25],Se([1,0,12,5,65]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.TargetPlatform=e.ExtensionType=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=void 0,e.$gm="extensions.user.cache",e.$hm="extensions.builtin.cache",e.$im="undefined_publisher",e.$jm=["ui","workspace","web"];function P(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$km=P,e.$lm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var v;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,o){if(typeof g>"u"||g===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof g=="string"||typeof o=="string"){const i=typeof g=="string"?g:g.value,r=typeof o=="string"?o:o.value;return C.$af(i,r)}return g._lower===o._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$mm=$;class E{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const o of g)this.add(o)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$nm=E;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,o){this.c.set($.toKey(g),o)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$om=R;function D(c){return p(c)}e.$pm=D;function p(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$qm=p;function k(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$rm=k;function S(c,g){if(g){const o=`onResolveRemoteAuthority:${(0,f.$cl)(g)}`;return!!c.activationEvents?.includes(o)}return!1}e.$sm=S,e.$tm=(0,F.$7h)("IBuiltinExtensionsScannerService")}),define(Ee[137],Se([1,0,14,25]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(A,v){this.a.set(A,v)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const v=Object.create(null);for(const $ of A){const E=this.readActivationEvents($);E.length>0&&(v[F.$mm.toKey($.identifier)]=E)}return v}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const v=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<v.length;$++)v[$]==="onUri"&&(v[$]=`onUri:${F.$mm.toKey(A.identifier)}`);if(!A.contributes)return v;for(const $ in A.contributes){const E=this.a.get($);if(!E)continue;const R=A.contributes[$],D=Array.isArray(R)?R:[R];try{E(D,v)}catch(p){(0,C.$1)(p)}}return v}}e.$oF=f,e.$pF=new f}),define(Ee[256],Se([1,0,11,22,21,14,4,3,58,38,30,82,64,65]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.PersistentConnectionEventType=e.$ml=e.$ll=e.$kl=e.ConnectionType=void 0;const S=30*1e3;var c;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function g(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(K){const W=new f.$7d;return setTimeout(()=>W.cancel(),K),W.token}function i(K,W){if(K.isCancellationRequested||W.isCancellationRequested)return f.CancellationToken.Cancelled;const ie=new f.$7d;return K.onCancellationRequested(()=>ie.cancel()),W.onCancellationRequested(()=>ie.cancel()),ie.token}class r{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new v.$Sc,this.promise=new Promise((ie,ye)=>{this.f=ie,this.g=ye}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function n(K,W){const ie=new r(W);return ie.registerDisposable(K.onControlMessage(ye=>{const de=JSON.parse(ye.toString()),fe=Q(de);fe?ie.reject(fe):ie.resolve(de)})),ie.promise}function a(K,W,ie,ye,de,fe,_,ee){const G=new r(ee),x=E.$Sd.create(!1);return K.info(`Creating a socket (${_})...`),$.mark(`code/willCreateSocket/${fe}`),W.connect(ie,ye,de,_).then(me=>{G.didTimeout?($.mark(`code/didCreateSocketError/${fe}`),K.info(`Creating a socket (${_}) finished after ${x.elapsed()} ms, but this is too late and has timed out already.`),me?.dispose()):($.mark(`code/didCreateSocketOK/${fe}`),K.info(`Creating a socket (${_}) was successful after ${x.elapsed()} ms.`),G.resolve(me))},me=>{$.mark(`code/didCreateSocketError/${fe}`),K.info(`Creating a socket (${_}) returned an error after ${x.elapsed()} ms.`),K.error(me),G.reject(me)}),G.promise}function t(K,W){const ie=new r(W);return K.then(ye=>{ie.didTimeout||ie.resolve(ye)},ye=>{ie.didTimeout||ie.reject(ye)}),ie.promise}async function h(K,W,ie,ye){const de=$e(K,W);K.logService.trace(`${de} 1/6. invoking socketFactory.connect().`);let fe;try{fe=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,k.$dl)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,g(W),`renderer-${g(W)}-${K.reconnectionToken}`,ye)}catch(me){throw K.logService.error(`${de} socketFactory.connect() failed or timed out. Error:`),K.logService.error(me),me}K.logService.trace(`${de} 2/6. socketFactory.connect() was successful.`);let _,ee;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(fe,null),_=K.reconnectionProtocol,ee=!1):(_=new D.$Uh({socket:fe}),ee=!0),K.logService.trace(`${de} 3/6. sending AuthRequest control message.`);const G=await t(K.signService.createNewMessage((0,R.$rg)()),ye),x={type:"auth",auth:K.connectionToken||"00000000000000000000",data:G.data};_.sendControl(F.$ke.fromString(JSON.stringify(x)));try{const me=await n(_,i(ye,o(1e4)));if(me.type!=="sign"||typeof me.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(K.logService.trace(`${de} 4/6. received SignRequest control message.`),!await t(K.signService.validate(G,me.signedData),ye)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const Ae=await t(K.signService.sign(me.data),ye),ve={type:"connectionType",commit:K.commit,signedData:Ae,desiredConnectionType:W};return ie&&(ve.args=ie),K.logService.trace(`${de} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(F.$ke.fromString(JSON.stringify(ve))),{protocol:_,ownsProtocol:ee}}catch(me){throw me&&me.code==="ETIMEDOUT"&&(K.logService.error(`${de} the handshake timed out. Error:`),K.logService.error(me)),me&&me.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${de} received error control message when negotiating connection. Error:`),K.logService.error(me)),ee&&Y(_),me}}async function s(K,W,ie,ye){const de=Date.now(),fe=$e(K,W),{protocol:_,ownsProtocol:ee}=await h(K,W,ie,ye),G=new r(ye);return G.registerDisposable(_.onControlMessage(x=>{const me=JSON.parse(x.toString()),we=Q(me);we?(K.logService.error(`${fe} received error control message when negotiating connection. Error:`),K.logService.error(we),ee&&Y(_),G.reject(we)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${fe} 6/6. handshake finished, connection is up and running after ${oe(de)}!`),G.resolve({protocol:_,firstMessage:me}))})),G.promise}async function d(K,W){const{protocol:ie}=await s(K,1,void 0,W);return{protocol:ie}}async function l(K,W,ie){const{protocol:ye,firstMessage:de}=await s(K,2,W,ie),fe=de&&de.debugPort;return{protocol:ye,debugPort:fe}}async function u(K,W,ie){const ye=Date.now(),de=$e(K,3),{protocol:fe}=await h(K,3,W,ie);return K.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${oe(ye)}!`),fe}async function w(K,W,ie){const{connectTo:ye,connectionToken:de}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:ye,connectionToken:de,reconnectionToken:W,reconnectionProtocol:ie,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function I(K,W,ie){return m(K,async ye=>{const{protocol:de}=await d(ye,f.CancellationToken.None);return new J(K,W,ie,ye.reconnectionToken,de)})}e.$kl=I;async function b(K,W){return m(K,async ie=>{const{protocol:ye,debugPort:de}=await l(ie,W,f.CancellationToken.None);return new le(K,W,ie.reconnectionToken,ye,de)})}e.$ll=b;async function m(K,W){for(let ye=1;;ye++)try{const de=(0,R.$rg)(),fe=await w(K,de,null);return await W(fe)}catch(de){if(ye<5)K.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(de);else throw K.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(de),z.triggerPermanentFailure(0,0,p.$_k.isHandled(de)),de}}async function y(K,W,ie){const ye=await w(K,(0,R.$rg)(),null);return await u(ye,{host:W,port:ie},f.CancellationToken.None)}e.$ml=y;function L(K){return(0,C.$Ug)(W=>new Promise((ie,ye)=>{const de=setTimeout(ie,K*1e3);W.onCancellationRequested(()=>{clearTimeout(de),ie()})}))}var N;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class U{constructor(W,ie){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.type=0}}e.$nl=U;class T{constructor(W,ie,ye,de){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.durationSeconds=ye,this.c=de,this.type=1}skipWait(){this.c.cancel()}}e.$ol=T;class O{constructor(W,ie,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.type=2}}e.$pl=O;class M{constructor(W,ie,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.type=4}}e.$ql=M;class j{constructor(W,ie,ye,de){this.reconnectionToken=W,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.handled=de,this.type=3}}e.$rl=j;class z extends v.$Tc{static triggerPermanentFailure(W,ie,ye){this._permanentFailure=!0,this.f=W,this.g=ie,this.h=ye,this.j.forEach(de=>de.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(W=>W.y())}static debugPauseSocketWriting(){this.j.forEach(W=>W.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||z._permanentFailure}constructor(W,ie,ye,de,fe){super(),this.t=W,this.u=ie,this.reconnectionToken=ye,this.protocol=de,this.w=fe,this.m=this.B(new A.$Wd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(de.onSocketClose(_=>{const ee=ne(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ee} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(de.onSocketTimeout(_=>{const ee=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),z.j.push(this),this.B((0,v.$Rc)(()=>{const _=z.j.indexOf(this);_>=0&&z.j.splice(_,1)})),this.n&&this.D(z.f,z.g,z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const W=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const de=ye<ie.length?ie[ye]:ie[ie.length-1];try{if(de>0){const _=L(de);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de,_)),this.u.logService.info(`${W} waiting for ${de} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${W} resolving connection...`);const fe=await w(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${W} connecting to ${fe.connectTo}...`),await this.G(fe,o(S)),this.u.logService.info(`${W} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(fe){if(fe.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(p.$_k.isTemporarilyNotAvailable(fe)){this.u.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if((fe.code==="ETIMEDOUT"||fe.code==="ENETUNREACH"||fe.code==="ECONNREFUSED"||fe.code==="ECONNRESET")&&fe.syscall==="connect"){this.u.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if((0,P.$4)(fe)){this.u.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if(fe instanceof p.$_k){this.u.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,p.$_k.isHandled(fe));break}this.u.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(W,ie,ye){this.w?z.triggerPermanentFailure(W,ie,ye):this.D(W,ie,ye)}D(W,ie,ye){this.m.fire(new j(this.reconnectionToken,W,ie,ye)),Y(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$sl=z;class J extends z{constructor(W,ie,ye,de,fe){super(1,W,de,fe,!0),this.client=this.B(new D.$Sh(fe,{remoteAuthority:ie,clientId:ye},W.ipcLogger))}async G(W,ie){await d(W,ie)}}e.$tl=J;class le extends z{constructor(W,ie,ye,de,fe){super(2,W,ye,de,!1),this.H=ie,this.debugPort=fe}async G(W,ie){await l(W,this.H,ie)}}e.$ul=le;function Y(K){try{K.acceptDisconnect();const W=K.getSocket();K.dispose(),W.dispose()}catch(W){(0,P.$1)(W)}}function Q(K){if(K&&K.type==="error"){const W=new Error(`Connection error: ${K.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function X(K,W){for(;K.length<W;)K+=" ";return K}function ue(K,W){return`[remote-connection][${X(g(K),13)}][${W.substr(0,5)}\u2026]`}function ne(K,W,ie){return`${ue(K,W)}[${ie?"reconnect":"initial"}]`}function $e(K,W){return`${ne(W,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function oe(K){return`${Date.now()-K} ms`}}),define(Ee[257],Se([1,0,3,5]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=void 0,e.$gl=(0,F.$7h)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(A,v){return this.a[A]??=[],this.a[A].push(v),(0,C.$Rc)(()=>{const $=this.a[A]?.indexOf(v);typeof $=="number"&&$>=0&&this.a[A]?.splice($,1)})}b(A){return(this.a[A.type]||[]).find($=>$.supports(A))}connect(A,v,$,E){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,v,$,E)}}e.$hl=f}),define(Ee[258],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V7b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const P=await this.c();if(P){const A=String(C.a++);return this.b.set(A,P),{id:A,data:P.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,P){if(!f.id)return!0;const A=this.b.get(f.id);if(!A)return!1;this.b.delete(f.id);try{return A.validate(P)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$V7b=C}),define(Ee[109],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=void 0,e.$il="signService",e.$jl=(0,C.$7h)(e.$il)}),define(Ee[138],Se([1,0,258]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;class F extends C.$V7b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(A=>new A.signer().sign(P))}h(){return new Promise((P,A)=>ge(["vsda"],P,A))}}e.$Q_b=F}),define(Ee[259],Se([1,0,10,49,30]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=void 0;function P($){if(C.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,E,R,D,p,k,S,c,g){const o=Object.create(null);o["common.machineId"]=k,o["common.sqmId"]=S,o.sessionID=(0,f.$rg)()+Date.now(),o.commitHash=D,o.version=p,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$u),o["common.nodePlatform"]=F.$dc,o["common.nodeArch"]=R,o["common.product"]=g||"desktop",c&&(o["common.msftInternal"]=c);let i=0;const r=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const n=P(E);return n&&(o["common.platformDetail"]=n),o}e.$Ko=A;function v($){const E=F.env.USERDNSDOMAIN;if(!E)return!1;const R=E.toLowerCase();return $.some(D=>R===D)}e.$Lo=v}),define(Ee[260],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=void 0,e.$vl=(0,C.$7h)("telemetryService"),e.$wl=(0,C.$7h)("customEndpointTelemetryService"),e.$xl="telemetry.currentSessionDate",e.$yl="telemetry.firstSessionDate",e.$zl="telemetry.lastSessionDate",e.$Al="telemetry.machineId",e.$Bl="telemetry.sqmId",e.$Cl="telemetry",e.$Dl="telemetry.telemetryLevel",e.$El="telemetry.enableCrashReporter",e.$Fl="telemetry.enableTelemetry";var F;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var f;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(Ee[88],Se([1,0,24,18,65,259,260]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;class v{constructor(h){this.value=h,this.isTrustedTelemetryValue=!0}}e.$Mo=v;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$No=$,e.$Oo=new $;class E{async publicLog(h,s,d){}async publicLogError(h,s,d){}}e.$Po=E,e.$Qo="telemetry",e.$Ro="extensionTelemetryLog",e.$So={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,h){return!h.isBuilt&&!h.disableTelemetry?!0:!(h.disableTelemetry||!t.enableTelemetry)}e.$To=R;function D(t,h){return h.extensionTestsLocationURI?!0:!(h.isBuilt||h.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Uo=D;function p(t){const h=t.getValue(A.$Dl),s=t.getValue(A.$El);if(t.getValue(A.$Fl)===!1||s===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Vo=p;function k(t){const h={},s={},d={};g(t,d);for(let l in d){l=l.length>150?l.substr(l.length-149):l;const u=d[l];typeof u=="number"?s[l]=u:typeof u=="boolean"?s[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),h[l]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(h[l]=u)}return{properties:h,measurements:s}}e.$Wo=k;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const h=(0,f.$cl)(t);return S.has(h)?h:"other"}e.$Xo=c;function g(t,h,s=0,d){if(t)for(const l of Object.getOwnPropertyNames(t)){const u=t[l],w=d?d+l:l;Array.isArray(u)?h[w]=(0,C.$Bn)(u):u instanceof Date?h[w]=u.toISOString():(0,F.$Lf)(u)?s<2?g(u,h,s+1,w+"."):h[w]=(0,C.$Bn)(u):h[w]=u}}function o(t,h){const s=t.msftInternalDomains||[],d=h.getValue("telemetry.internalTesting");return(0,P.$Lo)(s)||d}e.$Yo=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Zo=i;function r(t,h){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const d=[];for(const I of h)for(;;){const b=I.exec(t);if(!b)break;d.push([b.index,I.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(s="";;){const I=u.exec(t);if(!I)break;const b=d.some(([m,y])=>I.index<y&&m<u.lastIndex);!l.test(I[0])&&!b&&(s+=t.substring(w,I.index)+"<REDACTED: user-file-path>",w=u.lastIndex)}return w<t.length&&(s+=t.substr(w)),s}function n(t){if(!t)return t;const h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of h)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,h){return(0,C.$yn)(t,s=>{if(s instanceof v||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let d=s.replaceAll("%20"," ");d=r(d,h);for(const l of h)d=d.replace(l,"");return d=n(d),d}})}e.$1o=a}),define(Ee[261],Se([1,0,12,134,25,10,2,14,49,88]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0;function R(s,d){return s.uuid&&d.uuid?s.uuid===d.uuid:s.id===d.id?!0:(0,C.$8e)(s.id,d.id)===0}e.$2o=R;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(d){const l=d.manifest?d.manifest.version:d.version,u=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new p(d.identifier,l,u)}static parse(d){const l=D.exec(d);return l&&l[1]&&l[2]?new p({id:l[1]},l[2],l[4]||void 0):null}constructor(d,l,u="undefined"){this.version=l,this.targetPlatform=u,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof p?R(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$3o=p;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const d=k.exec(s);return d&&d[1]?[g(d[1]),d[2]]:[g(s),void 0]}e.$4o=S;function c(s,d){return`${s}.${d}`}e.$5o=c;function g(s){return s.toLowerCase()}e.$6o=g;function o(s,d){return g(c(s??f.$im,d))}e.$7o=o;function i(s,d){const l=[],u=w=>{for(const I of l)if(I.some(b=>R(d(b),d(w))))return I;return null};for(const w of s){const I=u(w);I?I.push(w):l.push([w])}return l}e.$8o=i;function r(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$9o=r;function n(s){return{id:new E.$Mo(s.identifier.id),name:new E.$Mo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$0o=n,e.$$o=new f.$mm("pprice.better-merge");function a(s,d){const l=[],u=d.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const w=u.shift();if(w&&l.every(I=>!R(I.identifier,{id:w}))){const I=s.filter(b=>R(b.identifier,{id:w}));I.length===1&&(l.push(I[0]),u.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$_o=a;async function t(s,d){if(!P.$k)return!1;let l;try{l=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){d.debug("Error while getting the os-release file.",(0,v.$0)(w))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(s,d){const l=await t(s,d),u=(0,F.$vo)(l?"alpine":P.$u,$.$ec);return d.debug("ComputeTargetPlatform:",u),u}e.$ap=h}),define(Ee[262],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=void 0;function C($){return[...$.entries()]}e.$Nr=C;function F($){return $?[...$.entries()]:[]}e.$Or=F;function f($){return new Map($)}e.$Pr=f;function P($){return new Map($??[])}e.$Qr=P;function A($){return Array.from($.entries()).map(E=>[E[0],C(E[1].map),F(E[1].descriptionMap)])}e.$Rr=A;function v($){return new Map($.map(E=>[E[0],{map:f(E[1]),descriptionMap:P(E[2])}]))}e.$Sr=v}),define(Ee[263],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsb=void 0;class C{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,P,A=5){const v=P($=>{const E=typeof $=="string"?$:$.data;let R=this.a.get(f);if(R){R.data.push(E);return}const D=setTimeout(()=>this.flushBuffer(f),A);R={data:[E],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(f),v.dispose()}},this.a.set(f,R)});return v}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const P=this.a.get(f);P&&(this.a.delete(f),this.b(f,P.data.join("")))}}e.$rsb=C}),define(Ee[264],Se([1,0,11,78,55,4,18,2,207,108,37]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.IconFontDefinition=e.IconContribution=e.$xw=void 0,e.$xw={IconContribution:"base.contributions.icons"};var D;(function(n){function a(t,h){let s=t.defaults;for(;f.ThemeIcon.isThemeIcon(s);){const d=S.getIcon(s.id);if(!d)return;s=d.defaults}return s}n.getDefinition=a})(D||(e.IconContribution=D={}));var p;(function(n){function a(h){return{weight:h.weight,style:h.style,src:h.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=a;function t(h){const s=d=>(0,A.$Jf)(d)?d:void 0;if(h&&Array.isArray(h.src)&&h.src.every(d=>(0,A.$Jf)(d.format)&&(0,A.$Jf)(d.location)))return{weight:s(h.weight),style:s(h.style),src:h.src.map(d=>({format:d.format,location:v.URI.parse(d.location)}))}}n.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class k{constructor(){this.a=new P.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,h,s){const d=this.b[a];if(d){if(h&&!d.description){d.description=h,this.d.properties[a].markdownDescription=`${h} $(${a})`;const w=this.e.enum.indexOf(a);w!==-1&&(this.e.enumDescriptions[w]=h),this.a.fire()}return d}const l={id:a,description:h,defaults:t,deprecationMessage:s};this.b[a]=l;const u={$ref:"#/definitions/icons"};return s&&(u.deprecationMessage=s),h&&(u.markdownDescription=`${h}: $(${a})`),this.d.properties[a]=u,this.e.enum.push(a),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const h=this.f[a];return h||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(d,l)=>d.id.localeCompare(l.id),t=d=>{for(;f.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(d=>this.b[d]);for(const d of s.filter(l=>!!l.description).sort(a))h.push(`|<i class="${t(d)}"></i>|${d.id}|${f.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const d of s.filter(l=>!f.ThemeIcon.isThemeIcon(l.defaults)).sort(a))h.push(`|<i class="${t(d)}"></i>|${d.id}|`);return h.join(`
`)}}const S=new k;R.$In.add(e.$xw.IconContribution,S);function c(n,a,t,h){return S.registerIcon(n,a,t,h)}e.$yw=c;function g(){return S}e.$zw=g;function o(){const n=(0,F.$$j)();for(const a in n){const t="\\"+n[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}o(),e.$Aw="vscode://schemas/icons";const i=R.$In.as(E.$Jn.JSONContribution);i.registerSchema(e.$Aw,S.getIconSchema());const r=new C.$gh(()=>i.notifySchemaChanged(e.$Aw),200);S.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Bw=c("widget-close",F.$ak.close,(0,$.localize)(2,null)),e.$Cw=c("goto-previous-location",F.$ak.arrowUp,(0,$.localize)(3,null)),e.$Dw=c("goto-next-location",F.$ak.arrowDown,(0,$.localize)(4,null)),e.$Ew=f.ThemeIcon.modify(F.$ak.sync,"spin"),e.$Fw=f.ThemeIcon.modify(F.$ak.loading,"spin")}),define(Ee[89],Se([1,0,4,51,5,13]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.ProvidedOnAutoForward=e.$Dv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cv=e.$Bv=void 0,e.$Bv=(0,f.$7h)("tunnelService"),e.$Cv=(0,f.$7h)("sharedTunnelsService");var A;(function(g){g.Http="http",g.Https="https"})(A||(e.TunnelProtocol=A={}));var v;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(v||(e.TunnelPrivacyId=v={}));function $(g){return!!g.forwardPort}e.$Dv=$;var E;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function R(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(o)return{address:o[1],port:+o[2]}}e.$Ev=R,e.$Fv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(g){return e.$Fv.indexOf(g)>=0}e.$Gv=D,e.$Hv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(g){return e.$Hv.indexOf(g)>=0}e.$Iv=p;function k(g,o,i,r){if(i===1)return!1;if(i===2&&p(o)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(n?.length===4&&parseInt(n[1])>=18)return!1}return g<1024}e.$Jv=k;class S{constructor(o,i,r){this.remoteAddress=o,this.localAddress=i,this.b=r,this.a=new C.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Kv=S;let c=class{constructor(o,i){this.k=o,this.l=i,this.a=new C.$Wd,this.onTunnelOpened=this.a.event,this.b=new C.$Wd,this.onTunnelClosed=this.b.event,this.c=new C.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],i=Array.from(this.e.values());for(const r of i){const n=Array.from(r.values());for(const a of n){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,r,n,a){this.q(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:r,privacy:n,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(p(o)||D(o))&&(o=e.$Fv[0]);const r=this.s(o,i);if(r)return++r.refcount,r.value}openTunnel(o,i,r,n,a,t=!1,h,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${a}.`);const d=this.f??o;if(!d)return;if(i||(i="localhost"),n||(n=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(d,i,r,n,a,t,h,s);return l?l.then(u=>{if(u){if(typeof u=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,r),u}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.o(u);return(u.tunnelRemoteHost!==i||u.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&u.privacy!==h&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const r=i.get(o.tunnelRemotePort);r&&(r.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,r))}}}}async p(o,i,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const n=r.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),n}}async closeTunnel(o,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const r=this.e.get(o);if(r&&r.has(i)){const n=r.get(i);n.refcount=0,await this.p(o,i,n)}}q(o,i,r){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:r})}async r(o,i){const r=this.e.get(o);if(r){const n=r.get(i),a=n?await n.value:void 0;(!a||typeof a=="string")&&r.delete(i),r.size===0&&this.e.delete(o)}}s(o,i){const r=[o];D(o)?(r.push(...e.$Fv),r.push(...e.$Hv)):p(o)&&r.push(...e.$Hv);const n=r.map(a=>this.e.get(a));for(const a of n){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!R(o)}u(o,i,r,n,a,t,h){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${n}.`);const s=r;this.j.add(s);const d=n===void 0?r:n,l={elevationRequired:a?this.isPortPrivileged(d):!1},u={remoteAddress:{host:i,port:r},localAddressPort:n,privacy:t,public:t?t!==v.Private:void 0,protocol:h},w=o.forwardPort(u,l);return w?(this.q(i,r,w),w.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),w}};e.$Lv=c,e.$Lv=c=Ge([qe(0,P.$oj),qe(1,F.$Ai)],c)}),define(Ee[265],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=void 0,e.$2k=(0,C.$7h)("IUriIdentityService")}),define(Ee[266],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Mv=void 0,e.$Mv=(0,C.$7h)("editSessionIdentityService");var F;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Ee[267],Se([1,0,16]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=void 0;function F($){return $.scheme!==C.Schemas.file&&$.scheme!==C.Schemas.vscodeRemote}e.$OK=F;function f($){if($.folders.length)return $.folders.every(E=>F(E.uri))?$.folders[0].uri:void 0;if($.configuration&&F($.configuration))return $.configuration}e.$PK=f;function P($){return f($)?.scheme}e.$QK=P;function A($){return f($)?.authority}e.$RK=A;function v($){return f($)!==void 0}e.$SK=v}),define(Ee[40],Se([1,0,209,17,77,23,2,5,16]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.WorkbenchState=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0,e.$di=(0,v.$7h)("contextService");function E(d){const l=d;return typeof l?.id=="string"&&A.URI.isUri(l.uri)}e.$ei=E;function R(d){return typeof d?.id=="string"&&!E(d)&&!p(d)}e.$fi=R,e.$gi={id:"ext-dev"},e.$hi={id:"empty-window"};function D(d,l){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,F.$nc)(d)}:l?e.$gi:e.$hi;const u=d;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.$ii=D;function p(d){const l=d;return typeof l?.id=="string"&&A.URI.isUri(l.configPath)}e.$ji=p;function k(d){const l=d;if(l?.uri)return{id:l.id,uri:A.URI.revive(l.uri)};const u=d;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(d?.id)return{id:d.id}}e.$ki=k;var S;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function c(d){const l=d;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$li=c;function g(d){const l=d;return!!(l&&typeof l=="object"&&A.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$mi=g;class o{constructor(l,u,w,I,b){this.h=l,this.j=w,this.k=I,this.l=b,this.c=f.$ai.forUris(this.l,()=>!0),this.folders=u}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=f.$ai.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ni=o;class i{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,P.$Ig)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$oi=i;function r(d){return new i({uri:d,index:0,name:(0,P.$Eg)(d)},{uri:d.toString()})}e.$pi=r,e.$qi="code-workspace",e.$ri=`.${e.$qi}`,e.$si=[{name:(0,C.localize)(0,null),extensions:[e.$qi]}],e.$ti="workspace.json";function n(d,l){return P.$zg.isEqualOrParent(d,l.untitledWorkspacesHome)}e.$ui=n;function a(d){let l;return A.URI.isUri(d)?l=d:l=d.configuration,l?.scheme===$.Schemas.tmp}e.$vi=a,e.$wi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(d){return d.id===e.$wi}e.$xi=t;function h(d,l){return!n(d,l)&&!a(d)}e.$yi=h;function s(d){return(typeof d=="string"?(0,F.$oc)(d):(0,P.$Gg)(d))===e.$ri}e.$zi=s}),define(Ee[268],Se([1,0,54,4,3,23,2,208,133,32,5,13,40,28,265,11,30,12,18]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.ProfileResourceType=void 0;var r;(function(d){d.Settings="settings",d.Keybindings="keybindings",d.Snippets="snippets",d.Tasks="tasks",d.Extensions="extensions",d.GlobalState="globalState"})(r||(e.ProfileResourceType=r={}));function n(d){const l=d;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&A.URI.isUri(l.location)&&A.URI.isUri(l.globalStorageHome)&&A.URI.isUri(l.settingsResource)&&A.URI.isUri(l.keybindingsResource)&&A.URI.isUri(l.tasksResource)&&A.URI.isUri(l.snippetsHome)&&A.URI.isUri(l.extensionsResource))}e.$3k=n,e.$4k=(0,R.$7h)("IUserDataProfilesService");function a(d,l){return{id:d.id,isDefault:d.isDefault,name:d.name,shortName:d.shortName,icon:d.icon,location:A.URI.revive(d.location).with({scheme:l}),globalStorageHome:A.URI.revive(d.globalStorageHome).with({scheme:l}),settingsResource:A.URI.revive(d.settingsResource).with({scheme:l}),keybindingsResource:A.URI.revive(d.keybindingsResource).with({scheme:l}),tasksResource:A.URI.revive(d.tasksResource).with({scheme:l}),snippetsHome:A.URI.revive(d.snippetsHome).with({scheme:l}),extensionsResource:A.URI.revive(d.extensionsResource).with({scheme:l}),cacheHome:A.URI.revive(d.cacheHome).with({scheme:l}),useDefaultFlags:d.useDefaultFlags,isTransient:d.isTransient}}e.$5k=a;function t(d,l,u,w,I,b){return{id:d,name:l,location:u,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:b&&I?.useDefaultFlags?.globalState?b.globalStorageHome:(0,P.$Ig)(u,"globalStorage"),settingsResource:b&&I?.useDefaultFlags?.settings?b.settingsResource:(0,P.$Ig)(u,"settings.json"),keybindingsResource:b&&I?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,P.$Ig)(u,"keybindings.json"),tasksResource:b&&I?.useDefaultFlags?.tasks?b.tasksResource:(0,P.$Ig)(u,"tasks.json"),snippetsHome:b&&I?.useDefaultFlags?.snippets?b.snippetsHome:(0,P.$Ig)(u,"snippets"),extensionsResource:b&&I?.useDefaultFlags?.extensions?b.extensionsResource:(0,P.$Ig)(u,"extensions.json"),cacheHome:(0,P.$Ig)(w,d),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$6k=t;let h=class extends f.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,u,w,I){super(),this.t=l,this.u=u,this.w=w,this.y=I,this.f=!0,this.h=this.B(new F.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new k.$Ac,emptyWindows:new Map},this.profilesHome=(0,P.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),u=[l];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,i.$Jf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}u.push(t((0,P.$Fg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},l))}}catch(b){this.y.error(b)}const w=new k.$Ac,I=new Map;if(u.length)try{const b=this.Q();if(b.workspaces)for(const[m,y]of Object.entries(b.workspaces)){const L=A.URI.parse(m),N=u.find(U=>U.id===y);N&&w.set(L,N)}if(b.emptyWindows)for(const[m,y]of Object.entries(b.emptyWindows)){const L=u.find(N=>N.id===y);L&&I.set(m,L)}}catch(b){this.y.error(b)}this.z={profiles:u,workspaces:w,emptyWindows:I}}return this.z}D(){const l=t("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const u="Temp",w=new RegExp(`${(0,o.$Pe)(u)}\\s(\\d+)`);let I=0;for(const m of this.profiles){const y=w.exec(m.name),L=y?parseInt(y[1]):0;I=L>I?L:I}const b=`${u} ${I+1}`;return this.createProfile((0,C.$Ui)((0,g.$rg)()).toString(16),b,{transient:!0},l)}async createNamedProfile(l,u,w){return this.createProfile((0,C.$Ui)((0,g.$rg)()).toString(16),l,u,w)}async createProfile(l,u,w,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(l,u,w);return I&&await this.setProfileForWorkspace(I,b),b}async F(l,u,w){if(!(0,i.$Jf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(u);return I||(I=(async()=>{try{const b=this.profiles.find(L=>L.name===u||L.id===l);if(b)return b;const m=t(l,u,(0,P.$Ig)(this.profilesHome,l),this.g,w,this.defaultProfile);await this.u.createFolder(m.location);const y=[];return this.j.fire({profile:m,join(L){y.push(L)}}),await c.Promises.settled(y),this.I([m],[],[]),m}finally{this.r.delete(u)}})(),this.r.set(u,I)),I}async updateProfile(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(I=>I.id===l.id);if(!w)throw new Error(`Profile '${l.name}' does not exist`);return w=t(w.id,u.name??w.name,w.location,this.g,{shortName:u.shortName??w.shortName,icon:u.icon===null?void 0:u.icon??w.icon,transient:u.transient??w.isTransient,useDefaultFlags:u.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.I([],[],[w]),w}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(I=>I.id===l.id);if(!u)throw new Error(`Profile '${l.name}' does not exist`);const w=[];this.m.fire({profile:u,join(I){w.push(I)}});try{await Promise.allSettled(w)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(I){(0,E.$Ik)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(I=>I.id===u.id);if(!w)throw new Error(`Profile '${u.name}' does not exist`);this.L(l,w)}unsetWorkspace(l,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(u=>u.isDirectory&&this.profiles.every(w=>!this.w.extUri.isEqual(w.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(l.map(u=>this.removeProfile(u)))}getProfileForWorkspace(l){const u=this.G(l);return A.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(l){return(0,p.$ei)(l)?l.uri:(0,p.$ji)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,l.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,l.location)))}I(l,u,w){const I=[...this.profiles,...l],b=[];this.s.profiles=[];for(let m of I)m.isDefault||u.some(y=>m.id===y.id)||(m=w.find(y=>m.id===y.id)??m,m.isTransient?this.s.profiles.push(m):b.push({location:m.location,name:m.name,shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags}));this.P(b),this.z=void 0,this.J(l,u,w)}J(l,u,w){this.h.fire({added:l,removed:u,updated:w,all:this.profiles})}L(l,u,w){w=u?.isTransient?!0:w,w||this.L(l,void 0,!0);const I=this.G(l),b=w?this.s:this.C;A.URI.isUri(I)?(b.workspaces.delete(I),u&&b.workspaces.set(I,u)):(b.emptyWindows.delete(I),u&&b.emptyWindows.set(I,u)),w||this.M()}M(){const l={};for(const[w,I]of this.C.workspaces.entries())l[w.toString()]=I.id;const u={};for(const[w,I]of this.C.emptyWindows.entries())u[w.toString()]=I.id;this.R({workspaces:l,emptyWindows:u}),this.z=void 0}N(l){const u={},w=this.D();if(l.workspaces)for(const[b,m]of Object.entries(l.workspaces)){const y=A.URI.parse(m);u[b]=this.w.extUri.isEqual(y,w.location)?w.id:this.w.extUri.basename(y)}const I={};if(l.emptyWindows)for(const[b,m]of Object.entries(l.emptyWindows)){const y=A.URI.parse(m);I[b]=this.w.extUri.isEqual(y,w.location)?w.id:this.w.extUri.basename(y)}return{workspaces:u,emptyWindows:I}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$7k=h,e.$7k=h=Ge([qe(0,$.$bi),qe(1,E.$rk),qe(2,S.$2k),qe(3,D.$oj)],h);class s extends h{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$8k=s}),define(Ee[269],Se([1,0,11,4,3,58,18,188,5,268]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$vp=e.$up=e.$tp=void 0,e.$tp="__$__isNewStorageMarker",e.$up="__$__targetStorageMarker",e.$vp=(0,$.$7h)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var D;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(D||(e.StorageScope=D={}));var p;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function k(i){const r=i.get(e.$up);if(r)try{return JSON.parse(r)}catch{}return Object.create(null)}e.$wp=k;class S extends f.$Tc{static{this.a=60*1e3}constructor(r={flushInterval:S.a}){super(),this.m=r,this.b=this.B(new F.$Zd),this.c=this.B(new F.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new C.$gh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(r,n,a){return F.Event.filter(this.b.event,t=>t.scope===r&&(n===void 0||t.key===n),a)}n(){this.j.value=(0,C.$kh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(r,n){const{key:a,external:t}=n;if(a===e.$up){switch(r){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:r})}else this.b.fire({scope:r,key:a,target:this.J(r)[a],external:t})}w(r){this.f.fire({reason:r})}get(r,n,a){return this.P(n)?.get(r,a)}getBoolean(r,n,a){return this.P(n)?.getBoolean(r,a)}getNumber(r,n,a){return this.P(n)?.getNumber(r,a)}getObject(r,n,a){return this.P(n)?.getObject(r,a)}storeAll(r,n){this.y(()=>{for(const a of r)this.store(a.key,a.value,a.scope,a.target,n)})}store(r,n,a,t,h=!1){if((0,A.$Sf)(n)){this.remove(r,a,h);return}this.y(()=>{this.z(r,a,t),this.P(a)?.set(r,n,h)})}remove(r,n,a=!1){this.y(()=>{this.z(r,n,void 0),this.P(n)?.delete(r,a)})}y(r){this.b.pause(),this.c.pause();try{r()}finally{this.b.resume(),this.c.resume()}}keys(r,n){const a=[],t=this.J(r);for(const h of Object.keys(t))t[h]===n&&a.push(h);return a}z(r,n,a,t=!1){const h=this.J(n);typeof a=="number"?h[r]!==a&&(h[r]=a,this.P(n)?.set(e.$up,JSON.stringify(h),t)):typeof h[r]=="number"&&(delete h[r],this.P(n)?.set(e.$up,JSON.stringify(h),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(r){switch(r){case-1:return this.I;case 0:return this.G;default:return this.D}}L(r){const n=this.P(r);return n?k(n):Object.create(null)}isNew(r){return this.getBoolean(e.$tp,r)===!0}async flush(r=R.NONE){this.f.fire({reason:r});const n=this.P(-1),a=this.P(0),t=this.P(1);switch(r){case R.NONE:await C.Promises.settled([n?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await C.Promises.settled([n?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const r=this.P(-1)?.items??new Map,n=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(r,n,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(r){return await this.flush(),this.P(r)?.optimize()}async switch(r,n){return this.w(R.NONE),(0,E.$3k)(r)?this.R(r,n):this.S(r,n)}M(r,n){return!(r.id===n.id||c(n)&&c(r))}N(r,n,a){this.y(()=>{const t=new Set;for(const[h,s]of r)t.add(h),n.get(h)!==s&&this.u(a,{key:h,external:!0});for(const[h]of n.items)t.has(h)||this.u(a,{key:h,external:!0})})}}e.$xp=S;function c(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$yp=c;class g extends S{constructor(){super(),this.U=this.B(new v.$rp(new v.$sp,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$rp(new v.$sp,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$rp(new v.$sp,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(r=>this.u(1,r))),this.B(this.W.onDidChangeStorage(r=>this.u(0,r))),this.B(this.U.onDidChangeStorage(r=>this.u(-1,r)))}P(r){switch(r){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(r){switch(r){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(r){return!1}}e.$zp=g;async function o(i,r,n,a,t,h){const s=L=>{try{return JSON.parse(L)}catch{return L}},d=new Map,l=new Map;i.forEach((L,N)=>{d.set(N,L),l.set(N,s(L))});const u=new Map,w=new Map;r.forEach((L,N)=>{u.set(N,L),w.set(N,s(L))});const I=new Map,b=new Map;n.forEach((L,N)=>{I.set(N,L),b.set(N,s(L))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const m=[];if(d.forEach((L,N)=>{m.push({key:N,value:L})}),console.table(m),console.groupEnd(),console.log(l),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];u.forEach((N,U)=>{L.push({key:U,value:N})}),console.table(L),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${h})`);const y=[];I.forEach((L,N)=>{y.push({key:N,value:L})}),console.table(y),console.groupEnd(),console.log(b)}e.$Ap=o}),define(Ee[110],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class C{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const P=this.c++;return this.b.set(P,f),this.e(),P}get(f,P){return this.b.has(f)?this.b.get(f)[P]:void 0}delete(f){this.b.delete(f),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Mgc=C}),define(Ee[59],Se([1,0,16,23,5]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;class P{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new F.$xg(v=>{const $=this.b.get(v.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(v,$){$===null?this.b.delete(v.scheme):this.b.set(v.scheme,$)}isFreeScheme(v){return!this.b.has(v)&&!this.a.has(v)}getCapabilities(v){return this.b.get(v)}}e.$Pgc=P,e.$Qgc=(0,f.$7h)("IExtHostFileSystemInfo")}),define(Ee[27],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0,e.$AN=(0,C.$7h)("IExtHostInitDataService")}),define(Ee[270],Se([1,0,214,13,250,27]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;let A=class extends f.$HO{constructor($,E,R){const D=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=R.remote.isRemote?(0,C.localize)(0,null):$?(0,C.localize)(1,null):(0,C.localize)(2,null);super(E.createLogger(D,{name:p}))}};e.$Wic=A,e.$Wic=A=Ge([qe(1,F.$pj),qe(2,P.$AN)],A)}),define(Ee[271],Se([1,0,11]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=e.$yhc=void 0;class F{constructor(A,v,$){this.h=new Map,this.a=A,this.b=v,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new C.$gh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of E.values())R.complete()}catch(R){for(const D of E.values())D.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,v){let $=this.f[A];return typeof $>"u"&&($=v),$}update(A,v){this.f[A]=v;const $=this.h.get(A);if($!==void 0)return $.p;const E=new C.$rh;return this.h.set(A,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$yhc=F;class f extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,v){super(A.identifier.value,!0,v),this.j=A}}e.$zhc=f}),define(Ee[272],Se([1,0,4,2]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;class f{constructor(A){this.c=A,this.a=new C.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,v,$,E){const D=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(v.value,$,E);this.b.fire(D)}$acceptDirtyStateChanged(A,v){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty(v)}$acceptModelSaved(A){const v=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire(v.apiNotebook)}}e.$mic=f}),define(Ee[20],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=e.$kN=void 0,e.$kN=(0,C.$7h)("IExtHostRpcService");class F{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$lN=F}),define(Ee[273],Se([1,0,25,4]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class f{#e;constructor(A,v){this.b=new F.$Wd,this.onDidChange=this.b.event,this.a=C.$mm.toKey(A.identifier),this.#e=v,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(A){return this.#e.get(this.a,A)}store(A,v){return this.#e.store(this.a,A,v)}delete(A){return this.#e.delete(this.a,A)}}e.$Ghc=f}),define(Ee[66],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=void 0,e.$9gc=(0,C.$7h)("IURITransformerService");class F{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$0gc=F}),define(Ee[274],Se([1,0,22]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlb=e.$ylb=void 0;class F{constructor(){this.buffers=[]}add($){let E=this.buffers.indexOf($);return E<0&&(E=this.buffers.length,this.buffers.push($)),E}}function f(v,$){if($.serializeBuffersForPostMessage){const E=new F,D=JSON.stringify(v,(k,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(S)};if(ArrayBuffer.isView(S)){const c=P(S);if(c)return{$$vscode_array_buffer_reference$$:!0,index:E.add(S.buffer),view:{type:c,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),p=E.buffers.map(k=>{const S=new Uint8Array(k);return C.$ke.wrap(S)});return{message:D,buffers:p}}else return{message:JSON.stringify(v),buffers:[]}}e.$ylb=f;function P(v){switch(v.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(v,$){const E=$.map(p=>{const k=new ArrayBuffer(p.byteLength);return new Uint8Array(k).set(p.buffer),k}),R=$.length?(p,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const S=k,{index:c}=S,g=E[c];if(S.view)switch(S.view.type){case 1:return new Int8Array(g,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return k}:void 0;return{message:JSON.parse(v,R),arrayBuffers:E}}e.$zlb=A}),define(Ee[275],Se([1,0,276,389,390,62,2,13,391]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;const E=!1;function R(r,n,a,t,h,s){const d=s.environment.useHostProxy,l=typeof d=="boolean"?d:!s.remote.isRemote,u={resolveProxy:b=>r.resolveProxy(b),lookupProxyAuthorization:g.bind(void 0,t,h,n,{},s.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(n),addCertificatesV2:()=>k(n),log:t,getLogLevel:()=>{const b=t.getLevel();switch(b){case v.LogLevel.Trace:return $.LogLevel.Trace;case v.LogLevel.Debug:return $.LogLevel.Debug;case v.LogLevel.Info:return $.LogLevel.Info;case v.LogLevel.Warning:return $.LogLevel.Warning;case v.LogLevel.Error:return $.LogLevel.Error;case v.LogLevel.Off:return $.LogLevel.Off;default:return m(b)}function m(y){return t.error("Unknown log level",y),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,loadAdditionalCertificates:async()=>{const b=[];if(s.remote.isRemote&&b.push((0,$.loadSystemCertificates)({log:t})),l){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const m=r.loadCertificates();m.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),b.push(m)}return(await Promise.all(b)).flat()},env:process.env},w=(0,$.createProxyResolver)(u),I=D(u,w);return c(a,I)}e.$sjc=R;function D(r,n){return{http:Object.assign(C,(0,$.createHttpPatch)(r,C,n)),https:Object.assign(F,(0,$.createHttpPatch)(r,F,n)),net:Object.assign(P,(0,$.createNetPatch)(r,P)),tls:Object.assign(f,(0,$.createTlsPatch)(r,f))}}function p(r){const n=r.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",E)&&!!n.get("systemCertificates")}function k(r){const n=r.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",E)&&!!n.get("systemCertificates")}const S=new Map;function c(r,n){return r.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,h=t._load;t._load=function(d,l,u){if(d==="net")return n.net;if(d==="tls")return n.tls;if(d!=="http"&&d!=="https")return h.apply(this,arguments);const w=a.findSubstr(A.URI.file(l.filename));let I=S.get(w);if(I||S.set(w,I={}),!I[d]){const b=n[d];I[d]={...b}}return I[d]}})}async function g(r,n,a,t,h,s,d,l){const u=t[s];d&&(t[s]=d),r.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${d}`,`proxyAuthenticateCache:${u}`);const w=d||u,I=Array.isArray(w)?w:typeof w=="string"?[w]:[];if(i(n,I,h),I.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const b=await new Promise((U,T)=>{ge(["kerberos"],U,T)}),m=new URL(s),y=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${m.hostname}`:`HTTP@${m.hostname}`);return r.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${y}`),"Negotiate "+await(await b.initializeClient(y)).step("")}catch(b){r.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let o=!1;function i(r,n,a){o||!n.length||(o=!0,r.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Ee[277],Se([1,0,130]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;function F(P){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:P,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function f(P){return new C.$5m(F(P))}e.$4r=f}),define(Ee[139],Se([1,0,224,18,2,3,5,37,32,16,44,180,39]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8E=e.$7E=e.$6E=e.EditorsOrder=e.$5E=e.CloseDirection=e.$4E=e.$3E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.EditorInputCapabilities=e.$TE=e.SaveReason=e.Verbosity=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$KE=e.$JE=e.$IE=e.$HE=e.$GE=void 0,e.$GE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$HE={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$IE="workbench.editor.sidebysideEditor",e.$JE="workbench.editors.textDiffEditor",e.$KE="workbench.editors.binaryResourceDiffEditor";var k;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var S;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function c(oe){const K=oe;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$LE=c;function g(oe,K,W){for(const ie of W.visibleEditorPanes)if(ie.group.id===K&&oe.matches(ie.input))return ie.getViewState()}e.$ME=g;function o(oe){if(w(oe))return!1;const K=oe;return f.URI.isUri(K?.resource)}e.$NE=o;function i(oe){if(w(oe))return!1;const K=oe;return K?.original!==void 0&&K.modified!==void 0}e.$OE=i;function r(oe){if(w(oe))return!1;const K=oe;return!K||K.resources&&!Array.isArray(K.resources)?!1:!!K.resources||!!K.multiDiffSource}e.$PE=r;function n(oe){if(w(oe)||i(oe))return!1;const K=oe;return K?.primary!==void 0&&K.secondary!==void 0}e.$QE=n;function a(oe){if(w(oe))return!1;const K=oe;return K?K.resource===void 0||K.resource.scheme===E.Schemas.untitled||K.forceUntitled===!0:!1}e.$RE=a;function t(oe){if(w(oe))return!1;const K=oe;return f.URI.isUri(K?.base?.resource)&&f.URI.isUri(K?.input1?.resource)&&f.URI.isUri(K?.input2?.resource)&&f.URI.isUri(K?.result?.resource)}e.$SE=t;var h;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var s;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class d{constructor(){this.a=new Map}registerSource(K,W){let ie=this.a.get(K);return ie||(ie={source:K,label:W},this.a.set(K,ie)),ie.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$TE=new d;var l;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class u extends P.$Tc{}e.$UE=u;function w(oe){return oe instanceof u}e.$VE=w;function I(oe){const K=oe;return f.URI.isUri(K?.preferredResource)}function b(oe){const K=oe;return w(K?.primary)&&w(K?.secondary)}e.$WE=b;function m(oe){const K=oe;return w(K?.modified)&&w(K?.original)}e.$XE=m;function y(oe,K,W,ie,ye){return $e(ie,[(0,D.$Qi)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const de={...W,limits:{size:Number.MAX_VALUE}};oe.openEditor(K,de)}}),(0,D.$Qi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$YE=y;function L(oe){return w(oe?.editor)}e.$ZE=L;function N(oe){const K=oe;return L(oe)&&K?.group!==void 0}e.$1E=N;function U(oe){const K=oe;return typeof K?.groupId=="number"&&w(K.editor)}e.$2E=U;var T;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var O;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var M;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class j{getOriginalUri(K,W){if(!K)return;if(t(K))return e.$4E.getOriginalUri(K.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(W?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===M.ANY)return this.getOriginalUri(ye,{filterByScheme:W.filterByScheme})??this.getOriginalUri(de,{filterByScheme:W.filterByScheme});K=W.supportSideBySide===M.PRIMARY?ye:de}}if(i(K)||r(K)||n(K)||t(K))return;const ie=I(K)?K.preferredResource:K.resource;return!ie||!W||!W.filterByScheme?ie:this.b(ie,W.filterByScheme)}a(K){return b(K)||n(K)?{primary:K.primary,secondary:K.secondary}:m(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,W){if(!K)return;if(t(K))return e.$4E.getCanonicalUri(K.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(W?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===M.ANY)return this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:W.filterByScheme});K=W.supportSideBySide===M.PRIMARY?ye:de}}if(i(K)||r(K)||n(K)||t(K))return;const ie=K.resource;return!ie||!W||!W.filterByScheme?ie:this.b(ie,W.filterByScheme)}b(K,W){if(Array.isArray(W)){if(W.some(ie=>K.scheme===ie))return K}else if(W===K.scheme)return K}}var z;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function J(oe,K,W,ie){if(!oe.isSticky(K))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return W===z.MOUSE||W===z.KEYBOARD;case"mouse":return W===z.MOUSE;case"keyboard":return W===z.KEYBOARD}return!1}e.$3E=J,e.$4E=new j;var le;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(K){const W=this.a=K.get(A.$6h);for(const[ie,ye]of this.c)this.e(ie,ye,W);this.c.clear()}e(K,W,ie){const ye=ie.createInstance(W);this.d.set(K,ye)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,F.$Uf)(this.b)}registerEditorSerializer(K,W){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,W,this.a):this.c.set(K,W),(0,P.$Rc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}v.$In.add(e.$GE.EditorFactory,new Y);async function Q(oe,K,W){return!oe||!oe.length?[]:await Promise.all(oe.map(async ie=>{const ye=f.URI.revive(ie.fileUri);if(!ye){W.info("Cannot resolve the path because it is not valid.",ie);return}if(!await K.canHandleResource(ye)){W.info("Cannot resolve the path because it cannot be handled",ie);return}let fe=ie.exists,_=ie.type;if(typeof fe!="boolean"||typeof _!="number")try{_=(await K.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,fe=!0}catch(G){W.error(G),fe=!1}if(!fe&&ie.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",ie);return}if(_===$.FileType.Directory){W.info("Cannot resolve the path because it is a directory",ie);return}const ee={...ie.options,pinned:!0};return fe?{resource:ye,options:ee}:{resource:ye,options:ee,forceUntitled:!0}}))}e.$5E=Q;var X;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function ue(oe){const K=oe;if(!K)return!1;const W=K;if(W.modified)return ue(W.modified);const ie=K;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$6E=ue;function ne(oe){return(0,R.$Si)(oe)}e.$7E=ne;function $e(oe,K,W){const ie=(0,R.$Ti)(oe,K);return ie.forceMessage=W?.forceMessage,ie.forceSeverity=W?.forceSeverity,ie.allowDialog=W?.allowDialog,ie}e.$8E=$e}),define(Ee[278],Se([1,0,4,225,5,3,28,37,19,24,78,264]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$bF=e.ViewContentGroups=e.$aF=e.$_E=e.ViewContainerLocation=e.Extensions=e.$$E=e.$0E=e.$9E=void 0,e.$9E="views",e.$0E=(0,F.localize)(0,null),e.$$E=(0,D.$yw)("default-view-icon",R.$ak.window,(0,F.localize)(1,null));var p;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var k;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel",h[h.AuxiliaryBar=2]="AuxiliaryBar"})(k||(e.ViewContainerLocation=k={})),e.$_E=[0,1,2];function S(h){switch(h){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$aF=S;class c extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new C.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new C.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(s,d,l){const u=this.get(s.id);if(u)return u;const w=s;return w.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:w.openCommandActionDescriptor??{id:w.id},(0,A.$xc)(this.g,d,[]).push(w),l?.isDefault&&this.h.push(w),this.c.fire({viewContainer:w,viewContainerLocation:d}),w}deregisterViewContainer(s){for(const d of this.g.keys()){const l=this.g.get(d),u=l?.indexOf(s);if(u!==-1){l?.splice(u,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:s,viewContainerLocation:d});return}}}get(s){return this.all.filter(d=>d.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(d=>this.getViewContainerLocation(d)===s)}}v.$In.add(p.ViewContainersRegistry,new c);var g;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(g||(e.ViewContentGroups=g={}));function o(h,s){const d=h.group??g.More,l=s.group??g.More;return d!==l?d.localeCompare(l):(h.order??5)-(s.order??5)}class i extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new C.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,d){this.registerViews2([{views:s,viewContainer:d}])}registerViews2(s){s.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(s)}deregisterViews(s,d){const l=this.s(s,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(s,d){for(const l of this.m.keys())if(l!==d){const u=this.s(s,l);u.length&&(this.r(u,d),this.g.fire({views:u,from:l,to:d}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const d of this.j){const l=(this.m.get(d)||[]).filter(u=>u.id===s)[0];if(l)return l}return null}getViewContainer(s){for(const d of this.j)if((this.m.get(d)||[]).filter(u=>u.id===s)[0])return d;return null}registerViewWelcomeContent(s,d){return this.n.add(s,d),this.h.fire(s),(0,P.$Rc)(()=>{this.n.delete(s,d),this.h.fire(s)})}registerViewWelcomeContent2(s,d){const l=new Map;for(const[u,w]of d)this.n.add(s,w),l.set(u,(0,P.$Rc)(()=>{this.n.delete(s,w),this.h.fire(s)}));return this.h.fire(s),l}getViewWelcomeContent(s){const d=[];return this.n.forEach(s,l=>d.push(l)),d.sort(o)}r(s,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const u of s){if(this.getView(u.id)!==null)throw new Error((0,F.localize)(2,null,u.id));l.push(u)}}s(s,d){const l=this.m.get(d);if(!l)return[];const u=[],w=[];for(const I of l)s.includes(I)?u.push(I):w.push(I);return u.length&&(w.length?this.m.set(d,w):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),u}}v.$In.add(p.ViewsRegistry,new i),e.$bF=(0,f.$7h)("viewDescriptorService");var r;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var n;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class a{constructor(s,d){this.c=!1,this.d=!1,(0,E.$zn)(this,s),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const u=await d(l);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$cF=a;class t extends Error{constructor(s){super((0,F.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$dF=t}),define(Ee[279],Se([1,0,2,29,5]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nF=e.$mF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$lF=e.$kF=void 0;function P(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof C.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(F.$Vs.isIRange)}e.$kF=P;function A(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(P)}e.$lF=A;var v;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(v||(e.InteractiveSessionVoteDirection=v={}));var $;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$mF=(0,f.$7h)("IChatService"),e.$nF="accessibility.voice.keywordActivation"}),define(Ee[140],Se([1,0,4,11,226]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lb=void 0;class P{constructor(){this.f=new Map,this.k=[],this.m=new C.$Wd,this.n=new C.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(v){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=v}onEvent(v){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=v}onRequest(v){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=v}sendResponse(v){v.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${v.command}`)):this.s("response",v)}sendRequest(v,$,E,R){const D={command:v};if($&&Object.keys($).length>0&&(D.arguments=$),this.s("request",D),typeof R=="number"){const p=setTimeout(()=>{clearTimeout(p);const k=this.f.get(D.seq);if(k){this.f.delete(D.seq);const S={type:"response",seq:0,request_seq:D.seq,success:!1,command:v,message:(0,f.localize)(0,null,R,v)};k(S)}},R)}return E&&this.f.set(D.seq,E),D.seq}acceptMessage(v){this.j?this.j(v):(this.k.push(v),this.k.length===1&&this.q())}o(v,$){return v.type!=="event"||$.type!=="event"}async q(){let v;for(;this.k.length;){if((!v||this.o(this.k[0],v))&&await(0,F.$8g)(0),v=this.k.shift(),!v)return;switch(v.type){case"event":this.i?.(v);break;case"request":this.g?.(v);break;case"response":{const $=v,E=this.f.get($.request_seq);E&&(this.f.delete($.request_seq),E($));break}}}}s(v,$){$.type=v,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const v=new Map;this.f.forEach(($,E)=>v.set(E,$)),await(0,F.$8g)(500),v.forEach(($,E)=>{$({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$5lb=P}),define(Ee[280],Se([1,0,2,227,45,5]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$UH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$TH=e.MemoryRangeType=e.$SH=e.State=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=void 0,e.$MG="workbench.view.debug",e.$NG="workbench.debug.variablesView",e.$OG="workbench.debug.watchExpressionsView",e.$PG="workbench.debug.callStackView",e.$QG="workbench.debug.loadedScriptsView",e.$RG="workbench.debug.breakPointsView",e.$SG="workbench.debug.disassemblyView",e.$TG="workbench.panel.repl",e.$UG="workbench.panel.repl.view",e.$VG=new f.$lj("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.$WG=new f.$lj("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.$XG=new f.$lj("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.$YG="debugUx",e.$ZG=new f.$lj(e.$YG,"default",{type:"string",description:F.localize(3,null)}),e.$1G=new f.$lj("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.$2G=new f.$lj("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.$3G=new f.$lj("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.$4G=new f.$lj("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.$5G=new f.$lj("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.$6G=new f.$lj("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.$7G=new f.$lj("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.$8G=new f.$lj("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.$9G=new f.$lj("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.$0G=new f.$lj("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.$$G=new f.$lj("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.$_G=new f.$lj("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.$aH=new f.$lj("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.$bH=new f.$lj("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.$cH=new f.$lj("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.$dH=new f.$lj("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.$eH=new f.$lj("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.$fH=new f.$lj("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.$gH=new f.$lj("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(22,null)}),e.$hH=new f.$lj("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(23,null)}),e.$iH=new f.$lj("loadedScriptsItemType",void 0,{type:"string",description:F.localize(24,null)}),e.$jH=new f.$lj("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(25,null)}),e.$kH=new f.$lj("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(26,null)}),e.$lH=new f.$lj("stepBackSupported",!1,{type:"boolean",description:F.localize(27,null)}),e.$mH=new f.$lj("restartFrameSupported",!1,{type:"boolean",description:F.localize(28,null)}),e.$nH=new f.$lj("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(29,null)}),e.$oH=new f.$lj("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(30,null)}),e.$pH=new f.$lj("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(31,null)}),e.$qH=new f.$lj("breakpointsExist",!1,{type:"boolean",description:F.localize(32,null)}),e.$rH=new f.$lj("debuggersAvailable",!1,{type:"boolean",description:F.localize(33,null)}),e.$sH=new f.$lj("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(34,null)}),e.$tH=new f.$lj("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(35,null)}),e.$uH=new f.$lj("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(36,null)}),e.$vH=new f.$lj("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(37,null)}),e.$wH=new f.$lj("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.$xH=new f.$lj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.$yH=new f.$lj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.$zH=new f.$lj("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.$AH=new f.$lj("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.$BH=new f.$lj("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(43,null)}),e.$CH=new f.$lj("variableIsReadonly",!1,{type:"boolean",description:F.localize(44,null)}),e.$DH=new f.$lj("variableValue",!1,{type:"string",description:F.localize(45,null)}),e.$EH=new f.$lj("variableType",!1,{type:"string",description:F.localize(46,null)}),e.$FH=new f.$lj("variableName",!1,{type:"string",description:F.localize(47,null)}),e.$GH=new f.$lj("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(48,null)}),e.$HH=new f.$lj("multiSessionRepl",!1,{type:"boolean",description:F.localize(49,null)}),e.$IH=new f.$lj("multiSessionDebug",!1,{type:"boolean",description:F.localize(50,null)}),e.$JH=new f.$lj("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(51,null)}),e.$KH=new f.$lj("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(52,null)}),e.$LH=new f.$lj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(53,null)}),e.$MH=new f.$lj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(54,null)});const A=c=>F.localize(55,null,c);e.$NH=A,e.$OH="editor.contrib.debug",e.$PH="editor.contrib.breakpoint",e.$QH="debug",e.$RH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(56,null)};var v;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(v||(e.State=v={}));function $(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$SH=$;var E;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$TH="vscode-debug-memory";var R;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(R||(e.DebugConfigurationProviderTriggerKind=R={}));var D;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$UH=(0,P.$7h)("debugService");var p;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE",c[c.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var k;(function(c){c[c.Command=0]="Command",c[c.Tree=1]="Tree"})(k||(e.DebugVisualizationType=k={}));var S;(function(c){c.deserialize=g=>({id:g.id,name:g.name,iconPath:g.iconPath&&{light:C.URI.revive(g.iconPath.light),dark:C.URI.revive(g.iconPath.dark)},iconClass:g.iconClass,visualization:g.visualization}),c.serialize=g=>g})(S||(e.IDebugVisualization=S={}))}),define(Ee[281],Se([1,0,12,2,17,24,16,29,21,19]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=void 0;const R=/{([^}]+)}/g;function D(I,b,m){return I.replace(R,function(y,L){return b&&L.length>0&&L[0]!=="_"?y:m&&m.hasOwnProperty(L)?m[L]:y})}e.$bG=D;function p(I){const b={};for(const m of Object.keys(I))m.startsWith("!")||(b[m]=I[m]);return b}e.$cG=p;function k(I){return I.configuration.request==="attach"&&!S(I)&&(!I.parentSession||k(I.parentSession))}e.$dG=k;function S(I){let b=I.configuration.type;if(b)return b==="vslsShare"&&(b=I.configuration.adapterProxy.configuration.type),(0,C.$af)(b,"extensionhost")||(0,C.$af)(b,"pwa-extensionhost")?I:I.parentSession?S(I.parentSession):void 0}e.$eG=S;function c(I){return I.type&&(I.label||I.program||I.runtime)}e.$fG=c;function g(I,b,m){let y,L=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=N.exec(I);){const T=U.index+1,O=T+U[0].length;if(T<=b&&O>=m){y=U[0],L=T;break}}if(y){const T=/\w+/g;let O=null;for(;(O=T.exec(y))&&!(O.index+1+L+O[0].length>=m););O&&(y=y.substring(0,T.lastIndex))}return y?{start:L,end:L+y.length-1}:{start:0,end:0}}e.$gG=g;async function o(I,b,m,y){if(I.evaluatableExpressionProvider.has(b)){const L=I.evaluatableExpressionProvider.ordered(b),N=(0,E.$Hb)(await Promise.all(L.map(async U=>{try{return await U.provideEvaluatableExpression(b,m,y??$.CancellationToken.None)}catch{return}})));if(N.length>0){let U=N[0].expression;const T=N[0].range;return U||(U=b.getLineContent(m.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:U}}}else{const L=b.getLineContent(m.lineNumber),{start:N,end:U}=g(L,m.column,m.column),T=L.substring(N-1,U);return{matchingExpression:T,range:new v.$Vs(m.lineNumber,N,m.lineNumber,N+T.length)}}return null}e.$hG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(I){return!!(I&&I.match(i))}e.$iG=r;function n(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(r(I.path))return F.URI.parse(I.path);if((0,f.$ic)(I.path))return F.URI.file(I.path)}return I.path}function a(I){if(typeof I.path=="object"){const b=F.URI.revive(I.path);if(b)return b.scheme===A.Schemas.file?b.fsPath:b.toString()}return I.path}function t(I,b){const m=b?n:a,y=(0,P.$wn)(I);return s(y,(L,N)=>{L&&N&&(N.path=m(N))}),y}e.$jG=t;function h(I,b){const m=b?n:a,y=(0,P.$wn)(I);return s(y,(L,N)=>{!L&&N&&(N.path=m(N))}),y}e.$kG=h;function s(I,b){switch(I.type){case"event":{const m=I;switch(m.event){case"output":b(!1,m.body.source);break;case"loadedSource":b(!1,m.body.source);break;case"breakpoint":b(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=I;switch(m.command){case"setBreakpoints":b(!0,m.arguments.source);break;case"breakpointLocations":b(!0,m.arguments.source);break;case"source":b(!0,m.arguments.source);break;case"gotoTargets":b(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(y=>b(!1,y));break;default:break}break}case"response":{const m=I;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(y=>b(!1,y.source));break;case"loadedSources":m.body.sources.forEach(y=>b(!1,y));break;case"scopes":m.body.scopes.forEach(y=>b(!1,y.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(y=>b(!1,y.source));break;case"setBreakpoints":m.body.breakpoints.forEach(y=>b(!1,y.source));break;case"disassemble":m.body?.instructions.forEach(L=>b(!1,L.location));break;default:break}break}}}function d(I){return I.filter(b=>!b.presentation?.hidden).sort((b,m)=>b.presentation?m.presentation?b.presentation.group?m.presentation.group?b.presentation.group!==m.presentation.group?b.presentation.group.localeCompare(m.presentation.group):l(b.presentation.order,m.presentation.order):-1:m.presentation.group?1:l(b.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$lG=d;function l(I,b){return typeof I!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:I-b}async function u(I,b){const m=I.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(m!=="none"&&(await b.saveAll(),m==="allEditorsInActiveGroup")){const y=b.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await b.save({editor:y.input,groupId:y.group.id})}await I.reloadConfiguration()}e.$mG=u;const w=(I,b)=>!I||!b?I===b:I.name===b.name&&I.path===b.path&&I.sourceReference===b.sourceReference;e.$nG=w}),define(Ee[282],Se([1,0,50,62,24,17,10,12,31,228,140]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=e.$6ic=e.$5ic=e.$4ic=e.$3ic=void 0;class D extends R.$5lb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",r=>this.w(r))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${D.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(r){this.m.fire(new Error((r.message||r)+`
`+i))}continue}}else{const i=this.r.indexOf(D.a);if(i!==-1){const n=this.r.toString("utf8",0,i).split(D.b);for(const a of n){const t=a.split(D.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+D.a.length);continue}}break}}}e.$3ic=D;class p extends D{startSession(){return new Promise((o,i)=>{let r=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),r=!0}),this.x.on("close",()=>{r?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",n=>{r?this.m.fire(n):i(n)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$4ic=p;class k extends p{constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$5ic=k;class S extends p{constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.path,o)}}e.$6ic=S;class c extends D{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,r=this.y.options||{};try{if(o)if(P.$ic(o)){if(!await $.Promises.exists(o))throw new Error(E.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let n=process.env;if(r.env&&Object.keys(r.env).length>0&&(n=f.$zn(f.$wn(process.env),r.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(t.cwd=r.cwd);const h=C.fork(i[0],i.slice(1),t);if(!h.pid)throw new Error(E.localize(2,null,i[0]));this.x=h}else throw new Error(E.localize(3,null));else{const a={env:n};r.cwd&&(a.cwd=r.cwd),this.x=C.spawn(o,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(n){this.m.fire(n)}}async stopSession(){return this.x?(await this.u(),A.$i?new Promise((o,i)=>{const r=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(n,a,t){if(n)return i(n)});r.on("exit",o),r.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const r=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?r.runtime=P.$jc(i,o.runtime):r.runtime=o.runtime),o.runtimeArgs&&(r.runtimeArgs=o.runtimeArgs),o.program&&(P.$ic(o.program)?r.program=o.program:r.program=P.$jc(i,o.program)),o.args&&(r.args=o.args);const n=o;return n.win&&(r.win=c.A(n.win,i)),n.winx86&&(r.winx86=c.A(n.winx86,i)),n.windows&&(r.windows=c.A(n.windows,i)),n.osx&&(r.osx=c.A(n.osx,i)),n.linux&&(r.linux=c.A(n.linux,i)),r}static platformAdapterExecutable(o,i){let r=Object.create(null);i=i.toLowerCase();for(const d of o)if(d.contributes){const l=d.contributes.debuggers;l&&l.length>0&&l.filter(u=>typeof u.type=="string"&&v.$af(u.type,i)).forEach(u=>{const w=c.A(u,d.extensionLocation.fsPath);r=f.$zn(r,w,d.isBuiltin)})}let n;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=r.winx86||r.win||r.windows:A.$i?n=r.win||r.windows:A.$j?n=r.osx:A.$k&&(n=r.linux),n=n||r;const a=n.program||r.program,t=n.args||r.args,h=n.runtime||r.runtime,s=n.runtimeArgs||r.runtimeArgs;if(h)return{type:"executable",command:h,args:(s||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$7ic=c}),define(Ee[283],Se([1,0,50,34,10]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=e.$8ic=void 0;function P(E,R){return new Promise((D,p)=>{let k="";const S=C.spawn(E,R);S.pid&&S.stdout.on("data",c=>{k+=c.toString()}),S.on("error",c=>{p(c)}),S.on("close",c=>{D(k)})})}async function A(E){if(E)if(f.$i){const R=await new Promise((D,p)=>{ge(["@vscode/windows-process-tree"],D,p)});return new Promise(D=>{R.getProcessTree(E,p=>{D(!!p&&p.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(E)]).then(R=>{const D=R.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$8ic=A;var v;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(v||(v={}));function $(E,R,D,p,k){E=E.trim().toLowerCase();let S;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?S=1:E.indexOf("cmd.exe")>=0?S=0:E.indexOf("bash")>=0?S=2:f.$i?S=0:S=2;let c,g=" ";switch(S){case 1:if(c=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),p){const o=(0,F.$bg)(p);o&&(g+=`${o}:; `),g+=`cd ${c(p)}; `}if(k)for(const o in k){const i=k[o];i===null?g+=`Remove-Item env:${o}; `:g+=`\${env:${o}}='${i}'; `}if(R.length>0){const o=R.shift(),i=D?o:c(o);g+=i[0]==="'"?`& ${i} `:`${i} `;for(const r of R)g+=r==="<"||r===">"||D?r:c(r),g+=" "}break;case 0:if(c=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),p){const o=(0,F.$bg)(p);o&&(g+=`${o}: && `),g+=`cd ${c(p)} && `}if(k){g+='cmd /C "';for(const o in k){let i=k[o];i===null?g+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,r=>`^${r}`),g+=`set "${o}=${i}" && `)}}for(const o of R)g+=o==="<"||o===">"||D?o:c(o),g+=" ";k&&(g+='"');break;case 2:{c=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(p&&(g+=`cd ${c(p)} ; `),k){g+="/usr/bin/env";for(const i in k){const r=k[i];r===null?g+=` -u ${o(i)}`:g+=` ${o(`${i}=${r}`)}`}g+=" "}for(const i of R)g+=i==="<"||i===">"||D?i:c(i),g+=" ";break}}return g}e.$9ic=$}),define(Ee[284],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mJ=e.CellExecutionUpdateType=void 0;var F;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$mJ=(0,C.$7h)("INotebookExecutionService")}),define(Ee[285],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfb=e.$ufb=e.ProxyKernelState=e.$tfb=void 0,e.$tfb=100;var F;(function(f){f[f.Disconnected=1]="Disconnected",f[f.Connected=2]="Connected",f[f.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.$ufb=(0,C.$7h)("INotebookKernelService"),e.$vfb=(0,C.$7h)("INotebookKernelHistoryService")}),define(Ee[286],Se([1,0,3,29,193,100]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vRb=void 0;class A extends C.$Tc{constructor($,E,R){super(),this._source=$,this.b=E,this.c=R,this.a=void 0}f($){const E=$.getLineCount();return new F.$Vs(1,1,E,this.g($,E))}g($,E){if(E<1||E>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const $=new f.$dC;$.acceptChunk(this._source);const E=$.finish(!0),{textBuffer:R,disposable:D}=E.create(1);this.b=R,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const E=new f.$dC;E.acceptChunk($);const R=E.finish(!0),{textBuffer:D,disposable:p}=R.create(1);return this.B(p),D})),this.a}findInInputs($){const R=new P.$4B($,!1,!1,null).parseSearchRequest();if(!R)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,R,!0,5e3)}findInOutputs($){const R=new P.$4B($,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(D=>{const p=D.findMatchesLineByLine(this.f(D),R,!0,5e3);if(p.length!==0)return{textBuffer:D,matches:p}}).filter(D=>!!D):[]}}e.$vRb=A}),define(Ee[67],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(P){P.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var F;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class f{static fromExtHostTestItem(A,v,$=A.parent){if(A._isRoot)return new f([v]);const E=[A.id];for(let R=$;R&&R.id!==v;R=R.parent)E.push(R.id);return E.push(v),new f(E.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const v=A.indexOf("\0");return v===-1?A:A.slice(0,v)}static fromString(A){return new f(A.split("\0"))}static join(A,v){return new f([...A.path,v])}static joinToString(A,v){return A.toString()+"\0"+v}static parentId(A){const v=A.lastIndexOf("\0");return v===-1?void 0:A.slice(0,v)}static localId(A){const v=A.lastIndexOf("\0");return v===-1?A:A.slice(v+1)}static isChild(A,v){return v.startsWith(A)&&v[A.length]==="\0"}static compare(A,v){return A===v?0:f.isChild(A,v)?2:f.isChild(v,A)?3:1}constructor(A,v=A.length){if(this.path=A,this.d=v,A.length===0||v<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new f(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new f(this.path,A)}compare(A){if(typeof A=="string")return f.compare(this.toString(),A);for(let v=0;v<A.d&&v<this.d;v++)if(A.path[v]!==this.path[v])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$0J=f}),define(Ee[90],Se([1,0,2,48,29,67]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$eK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$dK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$cK=e.$bK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$aK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$_J=e.$$J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var v;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(v||(e.ExtTestRunProfileKind=v={}));var $;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$$J=[2,4,8,16,32,64];const E=M=>"runId"in M;e.$_J=E;var R;(function(M){M.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),M.deserialize=(j,z)=>({range:f.$Vs.lift(z.range),uri:j.asCanonicalUri(C.URI.revive(z.uri))})})(R||(e.IRichLocation=R={}));var D;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(D||(e.TestMessageType=D={}));var p;(function(M){M.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&R.serialize(j.location)}),M.deserialize=(j,z)=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&R.deserialize(j,z.location)})})(p||(e.ITestErrorMessage=p={}));const k=(M,j)=>`${j?"s":"e"}${M}`;e.$aK=k;var S;(function(M){M.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&R.serialize(j.location)}),M.deserialize=(j,z)=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&R.deserialize(j,z.location)})})(S||(e.ITestOutputMessage=S={}));var c;(function(M){M.serialize=j=>j.type===0?p.serialize(j):S.serialize(j),M.deserialize=(j,z)=>z.type===0?p.deserialize(j,z):S.deserialize(j,z)})(c||(e.ITestMessage=c={}));var g;(function(M){M.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),M.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(c.serialize)}),M.deserialize=(j,z)=>({state:z.state,duration:z.duration,messages:z.messages.map(J=>c.deserialize(j,J))})})(g||(e.ITestTaskState=g={}));const o="\0",i=(M,j)=>M+o+j;e.$bK=i;const r=M=>{const j=M.indexOf(o);return{ctrlId:M.slice(0,j),tagId:M.slice(j+1)}};e.$cK=r;var n;(function(M){M.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),M.deserialize=(j,z)=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?j.asCanonicalUri(C.URI.revive(z.uri)):void 0,range:z.range?f.$Vs.lift(z.range):null,description:z.description,error:z.error,sortText:z.sortText})})(n||(e.ITestItem=n={}));var a;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(M){M.serialize=j=>({expand:j.expand,item:n.serialize(j.item)}),M.deserialize=(j,z)=>({controllerId:P.$0J.root(z.item.extId),expand:z.expand,item:n.deserialize(j,z.item)})})(t||(e.InternalTestItem=t={}));var h;(function(M){M.serialize=j=>{let z;return j.item&&(z={},j.item.label!==void 0&&(z.label=j.item.label),j.item.tags!==void 0&&(z.tags=j.item.tags),j.item.busy!==void 0&&(z.busy=j.item.busy),j.item.uri!==void 0&&(z.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(z.range=j.item.range?.toJSON()),j.item.description!==void 0&&(z.description=j.item.description),j.item.error!==void 0&&(z.error=j.item.error),j.item.sortText!==void 0&&(z.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:z}},M.deserialize=j=>{let z;return j.item&&(z={},j.item.label!==void 0&&(z.label=j.item.label),j.item.tags!==void 0&&(z.tags=j.item.tags),j.item.busy!==void 0&&(z.busy=j.item.busy),j.item.range!==void 0&&(z.range=j.item.range?f.$Vs.lift(j.item.range):null),j.item.description!==void 0&&(z.description=j.item.description),j.item.error!==void 0&&(z.error=j.item.error),j.item.sortText!==void 0&&(z.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:z}}})(h||(e.ITestItemUpdate=h={}));const s=(M,j)=>{j.expand!==void 0&&(M.expand=j.expand),j.item!==void 0&&(M.item=M.item?Object.assign(M.item,j.item):j.item)};e.$dK=s;var d;(function(M){M.serializeWithoutMessages=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(g.serializeWithoutMessages)}),M.serialize=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(g.serialize)}),M.deserialize=(j,z)=>({...t.deserialize(j,z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(J=>g.deserialize(j,J)),retired:!0})})(d||(e.TestResultItem=d={}));var l;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(j,z)=>{j.covered+=z.covered,j.total+=z.total}})(l||(e.ICoveredCount=l={}));var u;(function(M){M.serialize=j=>({statement:j.statement,branch:j.branch,function:j.function,details:j.details?.map(m.serialize),uri:j.uri.toJSON()}),M.deserialize=(j,z)=>({statement:z.statement,branch:z.branch,function:z.function,details:z.details?.map(m.deserialize),uri:j.asCanonicalUri(C.URI.revive(z.uri))})})(u||(e.IFileCoverage=u={}));function w(M){return{...M,location:M.location?.toJSON()}}function I(M){return M.location=M.location?F.$Us.isIPosition(M.location)?F.$Us.lift(M.location):f.$Vs.lift(M.location):void 0,M}e.$eK=3;var b;(function(M){M[M.Function=0]="Function",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(b||(e.DetailType=b={}));var m;(function(M){M.serialize=j=>j.type===0?L.serialize(j):N.serialize(j),M.deserialize=j=>j.type===0?L.deserialize(j):N.deserialize(j)})(m||(e.CoverageDetails=m={}));var y;(function(M){M.serialize=w,M.deserialize=I})(y||(e.IBranchCoverage=y={}));var L;(function(M){M.serialize=w,M.deserialize=I})(L||(e.IFunctionCoverage=L={}));var N;(function(M){M.serialize=j=>({...w(j),branches:j.branches?.map(y.serialize)}),M.deserialize=j=>({...I(j),branches:j.branches?.map(y.deserialize)})})(N||(e.IStatementCoverage=N={}));var U;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var T;(function(M){M.deserialize=(j,z)=>z.op===0?{op:z.op,item:t.deserialize(j,z.item)}:z.op===1?{op:z.op,item:h.deserialize(z.item)}:z.op===2?{op:z.op,uri:j.asCanonicalUri(C.URI.revive(z.uri)),docv:z.docv}:z,M.serialize=j=>j.op===0?{op:j.op,item:t.serialize(j.item)}:j.op===1?{op:j.op,item:h.serialize(j.item)}:j})(T||(e.TestsDiffOp=T={}));class O{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const z=this.v();for(const J of j)switch(J.op){case 0:this.l(t.deserialize(this.k,J.item),z);break;case 1:this.o(h.deserialize(J.item),z);break;case 3:this.p(J.itemId,z);break;case 5:this.q(J.itemId);break;case 4:this.updatePendingRoots(J.amount);break;case 6:this.c.set(J.tag.id,J.tag);break;case 7:this.c.delete(J.id);break}z.complete?.()}l(j,z){const J=P.$0J.parentId(j.item.extId)?.toString();let le;if(!J)le=this.w(j),this.g.add(le),this.f.set(j.item.extId,le);else if(this.f.has(J)){const Y=this.f.get(J);Y.children.add(j.item.extId),le=this.w(j,Y),this.f.set(j.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return z.add?.(le),j.expand===2&&this.h++,le}o(j,z){const J=this.f.get(j.extId);if(J)return j.expand!==void 0&&(J.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$dK)(J,j),z.update?.(J),J}p(j,z){const J=this.f.get(j);if(!J)return;const le=P.$0J.parentId(J.item.extId)?.toString();le?this.f.get(le).children.delete(J.item.extId):this.g.delete(J);const Y=[[j]];for(;Y.length;)for(const Q of Y.pop()){const X=this.f.get(Q);X&&(Y.push(X.children),this.f.delete(Q),z.remove?.(X,X!==J),X.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$fK=O}),define(Ee[111],Se([1,0,11,4,3,61,90,67]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const E=(i,r)=>i===r,D=Object.entries({range:(i,r)=>i===r?!0:!i||!r?!1:i.equalsRange(r),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,r)=>!(i.length!==r.length||i.some(n=>!r.includes(n)))}),p=(i,r)=>{let n;for(const[a,t]of D)t(i[a],r[a])||(n?n[a]=r[a]:n={[a]:r[a]});return n};class k extends f.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new C.$gh(()=>this.flushDiff(),200)),this.g=this.B(new F.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const n of this.m)if(n.op===2&&n.uri===r.uri){n.docv=r.docv;return}break}case 1:{const n=this.m[this.m.length-1];if(n){if(n.op===1&&n.item.extId===r.item.extId){(0,A.$dK)(n.item,r.item);return}if(n.op===0&&n.item.item.extId===r.item.extId){(0,A.$dK)(n.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,n){const a=this.tree.get(r);if(a){if((a.expandLevels===void 0||n>a.expandLevels)&&(a.expandLevels=n),a.expand===1){const t=this.M(a);return t.isOpen()?this.L(a,n-1):t.wait().then(()=>this.L(a,n-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.L(a,n-1)):this.L(a,n-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,n){switch(n.op){case 3:this.O(v.$0J.joinToString(r.fullId,n.id));break;case 0:this.z(n.item,r);break;case 5:for(const a of n.ops)this.w(r,a);break;case 1:this.C(n.new,n.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:n.update}});break;case 6:this.y(r.actual.uri);break;default:(0,P.$6c)(n)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,n){const a=v.$0J.fromExtHostTestItem(r,this.root.id,n?.actual),t=this.s.getApiFor(r);t.parent&&t.parent!==n?.actual&&this.s.getChildren(t.parent).delete(r.id);let h=this.tree.get(a.toString());if(!h){h={fullId:a,actual:r,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(h.fullId.toString(),h),this.G(r,n),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:h.expand,item:this.s.toITestItem(r)}}),this.I(r,h,n);return}if(h.actual===r){this.H(r,h,n);return}if(h.actual.uri?.toString()!==r.uri?.toString())return this.O(a.toString()),this.z(r,n);const s=this.s.getChildren(h.actual),d=h.actual,l=p(this.s.toITestItem(d),this.s.toITestItem(r));this.s.getApiFor(d).listener=void 0,h.actual=r,h.expand=0,l&&(l.hasOwnProperty("tags")&&(this.C(r.tags,d.tags,a.toString()),delete l.tags),this.w(h,{op:4,update:l})),this.I(r,h,n);for(const[u,w]of s)this.s.getChildren(r).get(w.id)||this.O(v.$0J.joinToString(a,w.id));this.y(h.actual.uri)}C(r,n,a){const t=new Set(n.map(h=>h.id));for(const h of r)t.delete(h.id)||this.D(h);this.pushDiff({op:1,item:{extId:a,item:{tags:r.map(h=>(0,A.$bK)(this.s.controllerId,h.id))}}}),t.forEach(this.F,this)}D(r){const n=this.j.get(r.id);n?n.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$bK)(this.s.controllerId,r.id)}}))}F(r){const n=this.j.get(r);n&&!--n.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,A.$bK)(this.s.controllerId,r)}))}G(r,n){this.s.getApiFor(r).parent=n&&n.actual!==this.root?n.actual:void 0}H(r,n,a){this.G(r,a);const t=this.s.getApiFor(r);t.parent=a?.actual,t.listener=h=>this.w(n,h),this.J(n)}I(r,n,a){this.H(r,n,a);for(const[t,h]of this.s.getChildren(r))this.z(h,n)}J(r){let n;this.h?r.resolveBarrier?n=r.resolveBarrier.isOpen()?3:2:n=r.actual.canResolveChildren?1:0:n=0,n!==r.expand&&(r.expand=n,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:n}}),n===1&&r.expandLevels!==void 0&&this.M(r))}L(r,n){if(n<0)return;const a=[];for(const[t,h]of this.s.getChildren(r.actual)){const s=this.expand(v.$0J.joinToString(r.fullId,h.id),n);(0,C.$Tg)(s)&&a.push(s)}if(a.length)return Promise.all(a).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const h=new C.$6g;return h.open(),h}r.expand=2,this.N(r);const n=r.resolveBarrier=new C.$6g,a=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,h)};let t;try{t=this.h(r.actual===this.root?void 0:r.actual)}catch(h){a(h)}return(0,C.$Tg)(t)?t.catch(a).then(()=>{n.open(),this.J(r)}):(n.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const n=this.tree.get(r);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const a=[n];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.F(h.id);this.tree.delete(t.fullId.toString());for(const[h,s]of this.s.getChildren(t.actual))a.push(this.tree.get(v.$0J.joinToString(t.fullId,s.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$aN=k;class S extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$bN=S;class c extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$cN=c;class g extends Error{constructor(r,n,a){super(`TestItem with ID "${r}" is from controller "${n}" and cannot be added as a child of an item from controller "${a}".`)}}e.$dN=g;const o=(i,r,n)=>{let a=new Map;return{get size(){return a.size},forEach(t,h){for(const s of a.values())t.call(h,s,this)},[Symbol.iterator](){return a.entries()},replace(t){const h=new Map,s=new Set(a.keys()),d={op:5,ops:[]};for(const l of t){if(!(l instanceof n))throw new c(l.id);const u=r(l).controllerId;if(u!==i.controllerId)throw new g(l.id,u,i.controllerId);if(h.has(l.id))throw new S(l.id);h.set(l.id,l),s.delete(l.id),d.ops.push({op:0,item:l})}for(const l of s.keys())d.ops.push({op:3,id:l});i.listener?.(d),a=h},add(t){if(!(t instanceof n))throw new c(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$eN=o}),define(Ee[141],Se([1,0,111]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=void 0;const F=new WeakMap,f=(A,v)=>{const $={controllerId:v};return F.set(A,$),$};e.$fN=f;const P=A=>{const v=F.get(A);if(!v)throw new C.$cN(A?.id||"<unknown>");return v};e.$gN=P}),define(Ee[112],Se([1,0,16,2]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gwb=e.$fwb=e.$ewb=e.$dwb=e.$cwb=void 0,e.$cwb="vscode-cdn.net",e.$dwb=`vscode-resource.${e.$cwb}`,e.$ewb=`'self' https://*.${e.$cwb}`;function f(v,$){return v.scheme===C.Schemas.http||v.scheme===C.Schemas.https?v:($&&$.authority&&$.isRemote&&v.scheme===C.Schemas.file&&(v=F.URI.from({scheme:C.Schemas.vscodeRemote,authority:$.authority,path:v.path})),F.URI.from({scheme:C.Schemas.https,authority:`${v.scheme}+${P(v.authority)}.${e.$dwb}`,path:v.path,fragment:v.fragment,query:v.query}))}e.$fwb=f;function P(v){return v.replace(/./g,$=>{const E=$.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?$:"-"+E.toString(16).padStart(4,"0")})}function A(v){return v.replace(/-([0-9a-f]{4})/g,($,E)=>String.fromCharCode(parseInt(E,16)))}e.$gwb=A}),define(Ee[287],Se([1,0,4,3,112]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class P{constructor(v,$,E){this.d=v,this.e=$,this.f=E,this.a=0,this.b=new F.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const D of this.c.values())R.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(v=>v.inset.dispose()),this.b.dispose()}createWebviewEditorInset(v,$,E,R,D){let p;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===v){p=r;break}if(!p)throw new Error("not a visible editor");const k=this,S=this.a++,c=new C.$Wd,g=new C.$Wd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,f.$fwb)(r,k.f)}get cspSource(){return f.$ewb}set options(r){this.b=r,k.d.$setOptions(S,r)}get options(){return this.b}set html(r){this.a=r,k.d.$setHtml(S,r)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(r){return k.d.$postMessage(S,r)}},i=new class{constructor(){this.editor=v,this.line=$,this.height=E,this.webview=o,this.onDidDispose=g.event}dispose(){k.c.has(S)&&(k.c.delete(S),k.d.$disposeEditorInset(S),g.fire(),g.dispose(),c.dispose())}};return this.d.$createEditorInset(S,p.id,p.value.document.uri,$+1,E,R||{},D.identifier,D.extensionLocation),this.c.set(S,{editor:v,inset:i,onDidReceiveMessage:c}),i}$onDidDispose(v){const $=this.c.get(v);$&&$.inset.dispose()}$onDidReceiveMessage(v,$){this.c.get(v)?.onDidReceiveMessage.fire($)}}e.$7gc=P}),define(Ee[288],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=e.VariableKind=e.$9N=void 0,e.$9N=(0,C.$7h)("configurationResolverService");var F;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class f extends Error{constructor(A,v){super(v),this.variable=A}}e.$0N=f}),define(Ee[289],Se([1,0,17,49,18,24,10,103,231,288,12]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,S,c,g){this.h=new Map,this.a=k,this.b=S,this.g=c,g&&(this.c=g.then(o=>this.i(o)))}i(k){if(A.$i){const S=Object.create(null);return Object.keys(k).forEach(c=>{S[c.toLowerCase()]=k[c]}),S}return k}resolveWithEnvironment(k,S,c){return this.l({env:this.i(k),userHome:void 0},S?S.uri:void 0,c)}async resolveAsync(k,S){const c={env:await this.c,userHome:await this.g};return this.l(c,k?k.uri:void 0,S)}async j(k,S,c,g){const o=P.$wn(S);A.$i&&o.windows?Object.keys(o.windows).forEach(r=>o[r]=o.windows[r]):A.$j&&o.osx?Object.keys(o.osx).forEach(r=>o[r]=o.osx[r]):A.$k&&o.linux&&Object.keys(o.linux).forEach(r=>o[r]=o.linux[r]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,k?k.uri:void 0,o,c,g)}async resolveAnyAsync(k,S,c){return this.j(k,S,c)}async resolveAnyMap(k,S,c){const g=new Map;return{newConfig:await this.j(k,S,c,g),resolvedVariables:g}}resolveWithInteractionReplace(k,S,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,S,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,S){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,S)}async l(k,S,c,g,o){if(f.$Jf(c))return this.m(k,S,c,g,o);if(Array.isArray(c))return Promise.all(c.map(i=>this.l(k,S,i,g,o)));if(f.$Lf(c)){const i=Object.create(null),r=await Promise.all(Object.keys(c).map(async n=>[await this.m(k,S,n,g,o),await this.l(k,S,c[n],g,o)]));for(const[n,a]of r)i[n]=a;return i}return c}m(k,S,c,g,o){return(0,R.$5e)(c,D.VARIABLE_REGEXP,async(i,r)=>{if(r.includes(D.VARIABLE_LHS))return i;let n=await this.o(k,i,r,S,g);return o?.set(r,n),n!==i&&f.$Jf(n)&&n.match(D.VARIABLE_REGEXP)&&(n=await this.m(k,S,n,g,o)),n})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,S,c,g,o){let i;const r=c.split(":");r.length>1&&(c=r[0],i=r[1]);const n=h=>{const s=this.a.getFilePath();if(s)return(0,v.$Xv)(s);throw new E.$0N(h,(0,$.localize)(0,null,S))},a=h=>{const s=n(h);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,v.$Xv)(d)}throw new E.$0N(h,(0,$.localize)(1,null,S,C.$nc(s)))},t=h=>{if(i){const s=this.a.getFolderUri(i);if(s)return s;throw new E.$0N(h,(0,$.localize)(2,null,S,i))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new E.$0N(h,(0,$.localize)(3,null,S)):new E.$0N(h,(0,$.localize)(4,null,S))};switch(c){case"env":if(i){if(k.env){const h=k.env[A.$i?i.toLowerCase():i];if(f.$Jf(h))return h}return""}throw new E.$0N(E.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const h=this.a.getConfigurationValue(g,i);if(f.$Sf(h))throw new E.$0N(E.VariableKind.Config,(0,$.localize)(6,null,S,i));if(f.$Lf(h))throw new E.$0N(E.VariableKind.Config,(0,$.localize)(7,null,S,i));return h}throw new E.$0N(E.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(E.VariableKind.Command,S,i,o,"command");case"input":return this.p(E.VariableKind.Input,S,i,o,"input");case"extensionInstallFolder":if(i){const h=await this.a.getExtension(i);if(!h)throw new E.$0N(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(h.extensionLocation)}throw new E.$0N(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,v.$Xv)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return g||i?(0,v.$Xv)(this.n(t(E.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,v.$Xv)(C.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new E.$0N(E.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new E.$0N(E.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new E.$0N(E.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return n(E.VariableKind.File);case"fileWorkspaceFolder":return a(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$nc(a(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||i?C.$lc(this.n(t(E.VariableKind.RelativeFile)),n(E.VariableKind.RelativeFile)):n(E.VariableKind.RelativeFile);case"relativeFileDirname":{const h=C.$mc(n(E.VariableKind.RelativeFileDirname));if(g||i){const s=C.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),h);return s.length===0?".":s}return h}case"fileDirname":return C.$mc(n(E.VariableKind.FileDirname));case"fileExtname":return C.$oc(n(E.VariableKind.FileExtname));case"fileBasename":return C.$nc(n(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=C.$nc(n(E.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-C.$oc(h).length)}case"fileDirnameBasename":return C.$nc(C.$mc(n(E.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||S}case"execInstallFolder":{const h=this.a.getAppRoot();return h||S}case"pathSeparator":case"/":return C.sep;default:try{const h=i?`${c}:${i}`:c;return this.p(E.VariableKind.Unknown,S,h,o,void 0)}catch{return S}}}}p(k,S,c,g,o){if(c&&g){const i=o===void 0?g[c]:g[o+":"+c];if(typeof i=="string")return i;throw new E.$0N(k,(0,$.localize)(14,null,S))}return S}}e.$lO=D}),define(Ee[142],Se([1,0,5,139]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cD=e.$bD=e.OpenEditorContext=e.GroupsOrder=e.$aD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$_C=void 0,e.$_C=(0,C.$7h)("editorGroupsService");var f;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var P;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var A;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var v;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(v||(e.GroupsArrangement=v={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function E(S){const c=S;return(0,F.$VE)(c?.editor)&&(0,F.$VE)(c?.replacement)}e.$aD=E;var R;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var D;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function p(S){const c=S;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$bD=p;function k(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$cD=k}),define(Ee[290],Se([1,0,5,142]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=e.$gD=e.$fD=e.$eD=e.$dD=void 0,e.$dD=(0,C.$7h)("editorService"),e.$eD=-1,e.$fD=-2,e.$gD=-3;function f(P){const A=P;return typeof P=="number"||(0,F.$bD)(A)}e.$hD=f}),define(Ee[143],Se([1,0,5,133]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CK=void 0,e.$CK=(0,C.$8h)(F.$bi)}),define(Ee[144],Se([1,0,25,4,17,3]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y8b=e.$X8b=e.$W8b=e.$V8b=e.$U8b=void 0;class A{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$U8b=A;class v{static isHostExtension(o,i,r){if(i.getExtensionDescription(o))return!1;const n=r.getExtensionDescription(o);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(o,i){this.j=o,this.c=new F.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new C.$om,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=c(this.e,i),this.e=this.e.concat(o);const r=v.l(this.e);return this.e=c(this.e,r.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,r)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,s){this.addNode(h),this.addNode(s),this.c.has(h)?this.c.get(h).push(s):this.c.set(h,[s])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,s){const d=i.getArcs(h);for(let l=0;l<d.length;l++)if(!s.has(d[l]))return!1;return!0}getNodes(){return this.e}},r=new C.$om;for(const h of o)if(r.set(h.identifier,h),h.extensionDependencies)for(const s of h.extensionDependencies)i.addArc(C.$mm.toKey(h.identifier),C.$mm.toKey(s));const n=new Set;i.getNodes().filter(h=>i.getArcs(h).length===0).forEach(h=>n.add(h));const a=i.getNodes().filter(h=>!n.has(h));let t;do{t=!1;for(let h=0;h<a.length;h++){const s=a[h];i.hasOnlyGoodArcs(s,n)&&(a.splice(h,1),h--,n.add(s),t=!0)}}while(t);return a.map(h=>r.get(h))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$V8b=v;class ${constructor(o,i){this.versionId=o,this.extensions=i}}e.$W8b=$;class E{constructor(o){this.d=new p,this.c=new v(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new R(this,i)}deltaExtensions(o,i,r){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$X8b=E;class R extends P.$Tc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$Y8b=R;class D{constructor(o){this.name=o,this.promise=new Promise((i,r)=>{this.c=i})}resolve(o){this.c(o)}}class p{constructor(){this.c=[],this.d=!1}async acquire(o){const i=new D(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};o.resolve((0,P.$Rc)(n))}}var k;(function(g){g[g.Builtin=0]="Builtin",g[g.User=1]="User",g[g.Dev=2]="Dev"})(k||(k={}));function S(g,o){const i=g.isBuiltin?0:g.isUnderDevelopment?2:1,r=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==r)return i-r;const n=f.$gc.basename(g.extensionLocation.path),a=f.$gc.basename(o.extensionLocation.path);return n<a?-1:n>a?1:0}function c(g,o){const i=new C.$nm(o);return g.filter(r=>!i.has(r.identifier))}}),define(Ee[291],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.ExtHostConnectionType=void 0;var C;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(D){this.pipeName=D,this.type=1}serialize(D){D[F.ENV_KEY]=this.pipeName}}e.$Qm=F;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(D){D[f.ENV_KEY]="1"}}e.$Rm=f;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(D){D[P.ENV_KEY]="1"}}e.$Sm=P;function A(R){delete R[F.ENV_KEY],delete R[f.ENV_KEY],delete R[P.ENV_KEY]}function v(R,D){A(D),R.serialize(D)}e.$Tm=v;function $(R){if(R[F.ENV_KEY])return E(R,new F(R[F.ENV_KEY]));if(R[f.ENV_KEY])return E(R,new f);if(R[P.ENV_KEY])return E(R,new P);throw new Error("No connection information defined in environment!")}e.$Um=$;function E(R,D){return A(R),D}}),define(Ee[113],Se([1,0,22]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$vm=e.$um=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(F||(e.UIKind=F={}));var f;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var P;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function A(E){const R=C.$ke.alloc(1);switch(E){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$um=A;function v(E,R){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$vm=v;var $;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[91],Se([1,0,5,4,13,27,113,65,88,24,2,3,217]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=e.$CN=e.$BN=void 0;let k=class extends D.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new F.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Ro,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,f.$qj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,r){const n=this.getTelemetryDetails(),a=new S(i,r,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,r){this.f=o,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.$cl)((0,$.$Xo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((r,n)=>{const a=r.filter(t=>!t.isDisposed);a.length===0?this.r.delete(n):this.r.set(n,a)}),this.r.forEach(r=>{for(const n of r)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const n=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!n)return this.r.delete(o.value),!1;let a=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$BN=k,e.$BN=k=Ge([qe(0,P.$AN),qe(1,f.$pj)],k);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,r,n,a,t,h){this.g=r,this.h=n,this.i=a,this.j=t,this.a=new F.$Wd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,$.$1o)(i,[]),this.c&&(i=(0,E.$zn)(i,this.c)),this.b||(i=(0,E.$zn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const r={name:o.name,message:o.message,stack:o.stack,cause:o.cause},n=(0,$.$1o)(r,[]),a=new Error(n.message,{cause:n.cause});a.stack=n.stack,a.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$CN=S;function c(g){const o=Date.now()-new Date(g).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$DN=c,e.$EN=(0,C.$7h)("IExtHostTelemetry")}),define(Ee[26],Se([1,0,4,2,261,137,25,5]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PF=e.$OF=e.$NF=e.ActivationKind=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.ExtensionHostStartup=e.$HF=e.$GF=e.$FF=e.$EF=void 0,e.$EF=Object.freeze({identifier:new A.$mm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$FF="extensions.webWorker",e.$GF=(0,v.$7h)("extensionService");class ${constructor(a){this.dependency=a}}e.$HF=$;var E;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,h){this.c=a,this.d=t.slice(0),this.e=h.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$pF.createActivationEventsMap(this.d)}}set(a,t,h){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const s=[],d=[],l=[],u=[],w=D(this.d),I=D(t),b=(U,T)=>U.extensionLocation.toString()===T.extensionLocation.toString()||U.isBuiltin===T.isBuiltin||U.isUserBuiltin===T.isUserBuiltin||U.isUnderDevelopment===T.isUnderDevelopment;for(const U of this.d){const T=I.get(U.identifier);if(!T){s.push(U.identifier),w.delete(U.identifier);continue}if(!b(U,T)){s.push(U.identifier),w.delete(U.identifier);continue}}for(const U of t){const T=w.get(U.identifier);if(!T){d.push(U);continue}if(!b(T,U)){s.push(T.identifier),w.delete(T.identifier);continue}}const m=new A.$nm(this.e),y=new A.$nm(h);for(const U of this.e)y.has(U)||l.push(U);for(const U of h)m.has(U)||u.push(U);const L=P.$pF.createActivationEventsMap(d),N={versionId:a,toRemove:s,toAdd:d,addActivationEvents:L,myToRemove:l,myToAdd:u};return this.delta(N),N}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:h,myToRemove:s,myToAdd:d}=a,l=new A.$nm(t),u=new A.$nm(s);for(let w=0;w<this.d.length;w++)l.has(this.d[w].identifier)&&(this.d.splice(w,1),w--);for(let w=0;w<this.e.length;w++)u.has(this.e[w])&&(this.e.splice(w,1),w--);for(const w of h)this.d.push(w);for(const w of d)this.e.push(w);return this.f=null,a}containsExtension(a){for(const t of this.e)if(A.$mm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const h=P.$pF.readActivationEvents(t);for(const s of h)a.add(s)}return a}}e.$IF=R;function D(n){const a=new A.$om;for(const t of n)a.set(t.identifier,t);return a}function p(n,a){return n.enabledApiProposals?n.enabledApiProposals.includes(a):!1}e.$JF=p;function k(n,a){if(!p(n,a))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.$KF=k;class S{constructor(a,t,h,s){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=s}}e.$LF=S;class c{constructor(a,t){this.description=a,this.value=t}}e.$MF=c;var g;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function o(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,f.$7o)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.$NF=o;function i(n,a){return{identifier:new A.$mm((0,f.$5o)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!a,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.$OF=i;class r{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$PF=r}),define(Ee[292],Se([1,0,14,144,25,26,13,11]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=e.$thc=e.$shc=e.$rhc=e.$qhc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,i,r,n){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=n}}e.$qhc=$;class E{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$rhc=E;class R{constructor(o,i,r,n,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=r,this.module=n,this.exports=a,this.subscriptions=t}}e.$shc=R;class D extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$thc=D;class p extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$uhc=p;class k extends R{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,i,r,n){this.g=n,this.a=o,this.b=i,this.c=r,this.d=new f.$om,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,r]of this.d)o.push(r.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const r=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(r.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const r=this.a.getExtensionDescription(o);if(!r)throw new Error(`Extension '${o}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(o){const i=o.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new k(a));return this.c.onExtensionActivationError(o.id,a,new P.$HF(o.id.value)),t}const r=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of n){if(this.m(a))continue;const t=this.d.get(a);if(t){r.push(t);continue}if(this.l(a)){r.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const h=this.a.getExtensionDescription(a);if(h){if(!h.main&&!h.browser)continue;r.push(this.j({id:h.identifier,reason:o.reason}));continue}const s=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${a}'`),l=this.k(o,i.displayName,[],new k(d));return this.c.onExtensionActivationError(i.identifier,d,new P.$HF(a)),l}return this.k(o,i.displayName,r,null)}k(o,i,r,n){const a=new c(o.id,i,o.reason,r,n,this.c,this.g);return this.d.set(o.id,a),a}l(o){return F.$V8b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$vhc=S,e.$vhc=S=Ge([qe(3,A.$oj)],S);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,r,n,a,t,h){this.c=o,this.d=i,this.f=r,this.g=n,this.h=a,this.j=t,this.k=h,this.a=new v.$6g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new k(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new k(i),this.b&&C.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};c=Ge([qe(6,A.$oj)],c)}),define(Ee[293],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ee[294],Se([1,0,233,14,39,134,108,37,25,293,136,137]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=void 0;const p=v.$In.as(A.$Jn.JSONContribution);class k{constructor(a,t,h){this.a=a,this.b=t,this.c=h}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(f.default.Error,a)}warn(a){this.d(f.default.Warning,a)}info(a){this.d(f.default.Info,a)}}e.$yF=k;class S{static a(a){const t=new $.$nm;for(let h=0,s=a.length;h<s;h++)t.add(a[h].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const h=this.a(a),s=this.a(t),d=t.filter(u=>!h.has(u.description.identifier)),l=a.filter(u=>!s.has(u.description.identifier));return new S(d,l)}constructor(a,t){this.added=a,this.removed=t}}e.$zF=S;class c{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,F.$1)(a)}}}e.$AF=c;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$BF={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$lm},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$no}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$no}},extensionKind:{description:C.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new c(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&D.$pF.register(a.extensionPoint,a.activationEventsGenerator),e.$BF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,p.registerSchema(o,e.$BF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$CF=i;const r={ExtensionsRegistry:"ExtensionsRegistry"};v.$In.add(r.ExtensionsRegistry,new i),e.$DF=v.$In.as(r.ExtensionsRegistry),p.registerSchema(o,e.$BF),p.registerSchema(R.$Hj,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Ee[295],Se([1,0,229,18,24,294,45,4]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var E;(function(p){function k(S,c,g){if(!S)return;const o=F.$Jf(S.type)?S.type:void 0;if(!o||o.length===0){g.error(C.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const r of S.required)F.$Jf(r)&&i.push(r);return{extensionId:c.value,taskType:o,required:i,properties:S.properties?f.$wn(S.properties):{},when:S.when?A.$5i.deserialize(S.when):void 0}}p.from=k})(E||(E={}));const R=P.$DF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,k)=>{for(const S of p)S.type&&k.push(`onTaskType:${S.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:$}});class D{constructor(){this.d=new v.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,S)=>{R.setHandler((c,g)=>{this.c=void 0;try{for(const o of g.removed){const i=o.value;for(const r of i)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const o of g.added){const i=o.value;for(const r of i){const n=E.from(r,o.description.identifier,o.collector);n&&(this.a[n.taskType]=n)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const S of this.all()){const c={type:"object",additionalProperties:!1};S.required.length>0&&(c.required=S.required.slice(0)),S.properties!==void 0?c.properties=f.$wn(S.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[S.taskType]},k.push(c)}this.c={oneOf:k}}return this.c}}e.$BG=new D}),define(Ee[296],Se([1,0,230,18,23,24,45,295]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$LG=e.JsonSchemaVersion=e.ExecutionEngine=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$FG=e.ShellQuoting=e.$EG=e.$DG=e.$CG=void 0,e.$CG="settings",e.$DG=new A.$lj("taskRunning",!1,C.localize(0,null)),e.$EG={value:C.localize(1,null),original:"Tasks"};var $;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$FG="$customized",function(M){function j(z){if(!z)return M.Strong;switch(z.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=j}($||(e.ShellQuoting=$={}));var E;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var R;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(R||(e.RevealKind=R={})),function(M){function j(z){switch(z.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=j}(R||(e.RevealKind=R={}));var D;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(M){function j(z){switch(z.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=j}(D||(e.RevealProblemKind=D={}));var p;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(p||(e.PanelKind=p={})),function(M){function j(z){switch(z.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=j}(p||(e.PanelKind=p={}));var k;(function(M){M.defaults={echo:!0,reveal:R.Always,revealProblems:D.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var S;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(M){function j(J){switch(J.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=j;function z(J){switch(J){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=z}(S||(e.RuntimeType=S={}));var c;(function(M){function j(z){return F.$Jf(z)?z:z.value}M.value=j})(c||(e.CommandString=c={}));var g;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function j(J){return J===M.Clean._id||J===M.Build._id||J===M.Rebuild._id||J===M.Test._id}M.is=j;function z(J){if(J!==void 0)return F.$Jf(J)?j(J)?{_id:J,isDefault:!1}:void 0:J}M.from=z})(g||(e.TaskGroup=g={}));var o;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function j(z){switch(z){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=j})(i||(e.TaskSourceKind=i={}));var r;(function(M){M.parallel="parallel",M.sequence="sequence"})(r||(e.DependsOrder=r={}));var n;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var a;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(j,z,J,le,Y,Q){this._label="",this._id=j,z&&(this._label=z),J&&(this.type=J),this.runOptions=le,this.configurationProperties=Y,this._source=Q}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,z=!1){if(j===void 0)return!1;if(F.$Jf(j))return j===this._label||j===this.configurationProperties.identifier||z&&j===this._id;const J=this.getDefinition(!0);return J!==void 0&&J._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$GG=t;class h extends t{constructor(j,z,J,le,Y,Q,X,ue){super(j,J,void 0,X,ue,z),this.command={},this._source=z,this.hasDefinedMatchers=Q,Y&&(this.command=Y)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case S.Shell:z="shell";break;case S.Process:z="process";break;case S.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(j){return j instanceof h}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$CG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const J={type:e.$FG,folder:j,id:z};return JSON.stringify(J)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new h(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$HG=h;class s extends t{constructor(j,z,J,le,Y,Q,X){super(j,J,le,Q,X,z),this._source=z,this.configures=Y}static is(j){return j instanceof s}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$CG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(z+=this._source.kind);const J={type:e.$FG,folder:j,id:z};return JSON.stringify(J)}}e.$IG=s;class d extends t{constructor(j,z,J,le,Y,Q,X,ue,ne){super(j,J,le,ue,ne,z),this.defines=Y,this.hasDefinedMatchers=X,this.command=Q,this.icon=ne.icon,this.hide=ne.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof d}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new d(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$JG=d;class l extends t{constructor(j,z,J,le,Y,Q){super(j,J,le,Y,Q,z),this._source=z}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new l(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$KG=l;var u;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function(M){M._default=M.Terminal}(u||(e.ExecutionEngine=u={}));var w;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class I{constructor(j){this.c=new Map;for(let z=0;z<j.length;z++)this.c.set(j[z].uri.toString(),z)}compare(j,z){const J=j.getWorkspaceFolder(),le=z.getWorkspaceFolder();if(J&&le){let Y=this.c.get(J.uri.toString());Y=Y===void 0?0:Y+1;let Q=this.c.get(le.uri.toString());return Q=Q===void 0?0:Q+1,Y===Q?j._label.localeCompare(z._label):Y-Q}else return!J&&le?-1:J&&!le?1:0}}e.$LG=I;var b;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(b||(e.TaskEventKind=b={}));var m;(function(M){M.SingleRun="singleRun",M.Background="background"})(m||(e.TaskRunType=m={}));var y;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var L;(function(M){function j(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function z(ue,ne,$e){return{...j(ue),kind:"start",terminalId:ne,resolvedVariables:$e}}M.start=z;function J(ue,ne,$e){return{...j(ue),kind:"processStarted",terminalId:ne,processId:$e}}M.processStarted=J;function le(ue,ne,$e){return{...j(ue),kind:"processEnded",terminalId:ne,exitCode:$e}}M.processEnded=le;function Y(ue,ne,$e){return{...j(ue),kind:"terminated",exitReason:$e,terminalId:ne}}M.terminated=Y;function Q(ue,ne,$e){return{...j(ne),kind:ue,terminalId:$e}}M.general=Q;function X(){return{kind:"changed"}}M.changed=X})(L||(e.TaskEvent=L={}));var N;(function(M){function j(J){const le=Object.keys(J).sort();let Y="";for(const Q of le){let X=J[Q];X instanceof Object?X=j(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Y+=Q+","+X+","}return Y}function z(J){const Y={_key:j(J),type:J.taskType};return Object.assign(Y,J),Y}M.create=z})(N||(e.KeyedTaskIdentifier=N={}));var U;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var T;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var O;(function(M){function j(z,J){const le=v.$BG.get(z.type);if(le===void 0){const ue=P.$wn(z);return delete ue._key,N.create(ue)}const Y=Object.create(null);Y.type=le.taskType;const Q=new Set;le.required.forEach(ue=>Q.add(ue));const X=le.properties;for(const ue of Object.keys(X)){const ne=z[ue];if(ne!=null)Y[ue]=ne;else if(Q.has(ue)){const $e=X[ue];if($e.default!==void 0)Y[ue]=P.$wn($e.default);else switch($e.type){case"boolean":Y[ue]=!1;break;case"number":case"integer":Y[ue]=0;break;case"string":Y[ue]="";break;default:J.error(C.localize(2,null,JSON.stringify(z,void 0,0),ue));return}}}return N.create(Y)}M.createTaskIdentifier=j})(O||(e.TaskDefinition=O={}))}),define(Ee[297],Se([1,0,14]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$18b=e.$Z8b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,v)=>{this.b=A,this.d=v,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$1)(A))}then(A,v){return this.j().then(A,v)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Z8b=F;class f extends F{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$18b=f}),define(Ee[68],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uv=e.$Tv=e.$Sv=e.$Rv=void 0;class C{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++C.count}}e.$Rv=C;const F=[];function f(v){const $=new C(v);return F[$.nid]=$,$}e.$Sv=f;function P(v){return F[v].sid}e.$Tv=P;class A{constructor($){this.value=$}}e.$Uv=A}),define(Ee[6],Se([1,0,68]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.$fL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$eL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var f;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var A;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var v;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(v||(e.WebviewMessageArrayBufferViewType=v={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var E;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var R;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class D{static{this.a=0}static mixin(g){return g._id=D.a++,g}}e.$eL=D;var p;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var k;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var S;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$fL={MainThreadAuthentication:(0,C.$Sv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$Sv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$Sv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,C.$Sv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$Sv)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$Sv)("MainThreadClipboard"),MainThreadCommands:(0,C.$Sv)("MainThreadCommands"),MainThreadComments:(0,C.$Sv)("MainThreadComments"),MainThreadConfiguration:(0,C.$Sv)("MainThreadConfiguration"),MainThreadConsole:(0,C.$Sv)("MainThreadConsole"),MainThreadDebugService:(0,C.$Sv)("MainThreadDebugService"),MainThreadDecorations:(0,C.$Sv)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$Sv)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$Sv)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$Sv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$Sv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$Sv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$Sv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$Sv)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$Sv)("MainThreadErrors"),MainThreadTreeViews:(0,C.$Sv)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$Sv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$Sv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$Sv)("MainThreadLanguages"),MainThreadLogger:(0,C.$Sv)("MainThreadLogger"),MainThreadMessageService:(0,C.$Sv)("MainThreadMessageService"),MainThreadOutputService:(0,C.$Sv)("MainThreadOutputService"),MainThreadProgress:(0,C.$Sv)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$Sv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$Sv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$Sv)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$Sv)("MainThreadSecretState"),MainThreadStorage:(0,C.$Sv)("MainThreadStorage"),MainThreadSpeech:(0,C.$Sv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$Sv)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$Sv)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$Sv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$Sv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$Sv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$Sv)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$Sv)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$Sv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$Sv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$Sv)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$Sv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$Sv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$Sv)("MainThreadExtensionService"),MainThreadSCM:(0,C.$Sv)("MainThreadSCM"),MainThreadSearch:(0,C.$Sv)("MainThreadSearch"),MainThreadShare:(0,C.$Sv)("MainThreadShare"),MainThreadTask:(0,C.$Sv)("MainThreadTask"),MainThreadWindow:(0,C.$Sv)("MainThreadWindow"),MainThreadLabelService:(0,C.$Sv)("MainThreadLabelService"),MainThreadNotebook:(0,C.$Sv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$Sv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$Sv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$Sv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$Sv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$Sv)("MainThreadInteractive"),MainThreadChat:(0,C.$Sv)("MainThreadChat"),MainThreadInlineChat:(0,C.$Sv)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$Sv)("MainThreadTheming"),MainThreadTunnelService:(0,C.$Sv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$Sv)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$Sv)("MainThreadTimeline"),MainThreadTesting:(0,C.$Sv)("MainThreadTesting"),MainThreadLocalization:(0,C.$Sv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$Sv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$Sv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$Sv)("MainThreadIssueReporter")},e.$gL={ExtHostCommands:(0,C.$Sv)("ExtHostCommands"),ExtHostConfiguration:(0,C.$Sv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$Sv)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$Sv)("ExtHostDebugService"),ExtHostDecorations:(0,C.$Sv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$Sv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$Sv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$Sv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$Sv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$Sv)("ExtHostEditors"),ExtHostTreeViews:(0,C.$Sv)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$Sv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$Sv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$Sv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$Sv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$Sv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$Sv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$Sv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$Sv)("ExtHostStatusBar"),ExtHostShare:(0,C.$Sv)("ExtHostShare"),ExtHostExtensionService:(0,C.$Sv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$Sv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$Sv)("ExtHostTerminalService"),ExtHostSCM:(0,C.$Sv)("ExtHostSCM"),ExtHostSearch:(0,C.$Sv)("ExtHostSearch"),ExtHostTask:(0,C.$Sv)("ExtHostTask"),ExtHostWorkspace:(0,C.$Sv)("ExtHostWorkspace"),ExtHostWindow:(0,C.$Sv)("ExtHostWindow"),ExtHostWebviews:(0,C.$Sv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$Sv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$Sv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$Sv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$Sv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$Sv)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$Sv)("ExtHostProgress"),ExtHostComments:(0,C.$Sv)("ExtHostComments"),ExtHostSecretState:(0,C.$Sv)("ExtHostSecretState"),ExtHostStorage:(0,C.$Sv)("ExtHostStorage"),ExtHostUrls:(0,C.$Sv)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$Sv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$Sv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$Sv)("ExtHostOutputService"),ExtHostLabelService:(0,C.$Sv)("ExtHostLabelService"),ExtHostNotebook:(0,C.$Sv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$Sv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$Sv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$Sv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$Sv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$Sv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$Sv)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$Sv)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$Sv)("ExtHostChat"),ExtHostChatAgents2:(0,C.$Sv)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$Sv)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$Sv)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$Sv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,C.$Sv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$Sv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$Sv)("ExtHostTheming"),ExtHostTunnelService:(0,C.$Sv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$Sv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$Sv)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$Sv)("ExtHostTimeline"),ExtHostTesting:(0,C.$Sv)("ExtHostTesting"),ExtHostTelemetry:(0,C.$Sv)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$Sv)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$Sv)("ExtHostIssueReporter")}}),define(Ee[92],Se([1,0,5,13,6,20]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=void 0,e.$Tgc=(0,C.$7h)("IExtHostApiDeprecationService");let A=class{constructor($,E){this.c=E,this.a=new Set,this.b=$.getProxy(f.$fL.MainThreadTelemetry)}report($,E,R){const D=this.d($,E);this.a.has(D)||(this.a.add(D),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:$}))}d($,E){return`${$}-${E.identifier.value}`}};e.$Ugc=A,e.$Ugc=A=Ge([qe(0,P.$kN),qe(1,F.$oj)],A),e.$Vgc=Object.freeze(new class{report(v,$,E){}})}),define(Ee[298],Se([1,0,6]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;class F{constructor(P){const A=P.getProxy(C.$fL.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(v){return A.$writeText(v)}})}}e.$5gc=F}),define(Ee[299],Se([1,0,24,6,27,20]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;let A=class{constructor(R,D){this.a=R.getProxy(F.$fL.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,D){const p=this,k=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){p.e(R,D,k,arguments)}})}e(R,D,p,k){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:$(k,this.b)}),this.c&&this.f(R,p,k)}};e.$Vic=A,e.$Vic=A=Ge([qe(0,P.$kN),qe(1,f.$AN)],A);const v=1e5;function $(E,R){const D=[];if(E.length)for(let p=0;p<E.length;p++){let k=E[p];if(typeof k>"u")k="undefined";else if(k instanceof Error){const S=k;S.stack?k=S.stack:k=S.toString()}D.push(k)}if(R){const p=new Error().stack;p&&D.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,C.$Bn)(D);return p.length>v?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(Ee[300],Se([1,0,2,6,26]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class P{constructor(v){this.a=v.getProxy(F.$fL.MainThreadDialogs)}showOpenDialog(v,$){return $?.allowUIResources&&(0,f.$KF)(v,"showLocal"),this.a.$showOpenDialog($).then(E=>E?E.map(R=>C.URI.revive(R)):void 0)}showSaveDialog(v){return this.a.$showSaveDialog(v).then($=>$?C.URI.revive($):void 0)}}e.$Zhc=P}),define(Ee[301],Se([1,0,3,6]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;class f{constructor(A){this.b=0,this.a=A.getProxy(F.$fL.MainThreadLabelService)}$registerResourceLabelFormatter(A){const v=this.b++;return this.a.$registerResourceLabelFormatter(v,A),(0,C.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(v)})}}e.$iic=f}),define(Ee[114],Se([1,0,10,12,2,5,13,6,27,20]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=e.$Hhc=void 0;let R=class{constructor(p,k,S){this.f=S,this.d=new Map,this.a=k.getProxy(v.$fL.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===C.$g}getMessage(p,k){const{message:S,args:c,comment:g}=k;if(this.c)return(0,F.$Me)(S,c??{});let o=S;g&&g.length>0&&(o+=`/${Array.isArray(g)?g.join(""):g}`);const i=this.d.get(p)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,F.$Me)(i??S,c??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let k;const S=await this.g(p);if(!S){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(S),g=JSON.parse(c);k=p.isBuiltin?g.contents?.bundle:g}catch(c){this.f.error(`Failed to load translations for ${p.identifier.value} from ${S}: ${c.message}`);return}k&&this.d.set(p.identifier.value,{contents:k,uri:S})}async g(p){if(p.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return f.URI.revive(k)}return p.l10n?f.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Hhc=R,e.$Hhc=R=Ge([qe(0,$.$AN),qe(1,E.$kN),qe(2,A.$oj)],R),e.$Ihc=(0,P.$7h)("IExtHostLocalizationService")}),define(Ee[145],Se([1,0,13,6,27,20,2,56]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;let $=class extends C.$zj{constructor(D,p){super(p.logLevel,p.logsLocation,p.loggers.map(k=>(0,v.$Dh)(k))),this.r=D.getProxy(F.$fL.MainThreadLogger)}$setLogLevel(D,p){p?this.setLogLevel(A.URI.revive(p),D):this.setLogLevel(D)}setVisibility(D,p){super.setVisibility(D,p),this.r.$setVisibility(D,p)}s(D,p,k){return new E(this.r,D,p,k)}};e.$Uic=$,e.$Uic=$=Ge([qe(0,P.$kN),qe(1,f.$AN)],$);class E extends C.$uj{constructor(D,p,k,S){super(S?.logLevel==="always"),this.r=D,this.s=p,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(p,S).then(()=>{this.u(this.n),this.m=!0})}g(D,p){const k=[[D,p]];this.m?this.u(k):this.n.push(...k)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ee[115],Se([1,0,6,5,3,20,22]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=e.$Jhc=void 0,e.$Jhc=(0,F.$7h)("IExtHostManagedSockets");let v=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(C.$fL.MainThreadManagedSockets)}setFactory(D,p){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(D,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const p=++this.b,k=await this.c.makeConnection(),S=new f.$Sc;return this.d.set(p,new E(p,k,S)),S.add((0,f.$Rc)(()=>this.d.delete(p))),S.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),S.dispose()})),S.add(k.onDidClose(c=>{this.a.$onDidManagedSocketClose(p,c?.stack??c?.message),S.dispose()})),S.add(k.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(p,A.$ke.wrap(c)))),p}$remoteSocketWrite(D,p){this.d.get(D)?.actual.send(p.buffer)}$remoteSocketEnd(D){const p=this.d.get(D);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Khc=v,e.$Khc=v=Ge([qe(0,P.$kN)],v);class ${constructor(D,p){this.socketFactoryId=D,this.makeConnection=p}}class E extends f.$Tc{constructor(D,p,k){super(),this.socketId=D,this.actual=p,this.B(k)}}}),define(Ee[302],Se([1,0,6,13,26]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;function P(v){return v&&v.title}let A=class{constructor($,E){this.b=E,this.a=$.getProxy(C.$fL.MainThreadMessageService)}showMessage($,E,R,D,p){const k={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof D=="string"||P(D)?S=[D,...p]:(k.modal=D?.modal,k.useCustom=D?.useCustom,k.detail=D?.detail,S=p),k.useCustom&&(0,f.$KF)($,"resolvers");const c=[];let g=!1;for(let o=0;o<S.length;o++){const i=S[o];if(typeof i=="string")c.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:n}=i;c.push({title:r,isCloseAffordance:!!n,handle:o}),n&&(g?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):g=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,R,k,c).then(o=>{if(typeof o=="number")return S[o]})}};e.$kic=A,e.$kic=A=Ge([qe(1,F.$oj)],A)}),define(Ee[303],Se([1,0,3,18,2,26,6]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;class v{constructor(E){this.b=new Map,this.a=E.getProxy(A.$fL.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,R,D){if((0,P.$KF)(E,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,D),this.a.$registerProfileContentHandler(R,D.name,D.description,E.identifier.value),(0,C.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(E,R,D,p){const k=this.b.get(E);if(!k)throw new Error(`Unknown handler with id: ${E}`);return k.saveProfile(R,D,p)}async $readProfile(E,R,D){const p=this.b.get(E);if(!p)throw new Error(`Unknown handler with id: ${E}`);return p.readProfile((0,F.$Jf)(R)?R:f.URI.revive(R),D)}}e.$tic=v}),define(Ee[116],Se([1,0,6,4,5]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;class P{constructor(v){this.b=new F.$Wd,this.onDidChangePassword=this.b.event,this.a=v.getProxy(C.$fL.MainThreadSecretState)}async $onDidChangePassword(v){this.b.fire(v)}get(v,$){return this.a.$getPassword(v,$)}store(v,$,E){return this.a.$setPassword(v,$,E)}delete(v,$){return this.a.$deletePassword(v,$)}}e.$Ehc=P,e.$Fhc=(0,f.$7h)("IExtHostSecretState")}),define(Ee[304],Se([1,0,21,3,6]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;class P{static{this.a=1}constructor(v){this.c=new Map,this.d=new Map,this.b=v.getProxy(f.$fL.MainThreadSpeech)}async $createSpeechToTextSession(v,$){const E=this.c.get(v);if(!E)return;const R=new F.$Sc,D=new C.$7d;this.d.set($,D);const p=R.add(E.provideSpeechToTextSession(D.token));R.add(p.onDidChange(k=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,k)})),R.add(D.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}async $createKeywordRecognitionSession(v,$){const E=this.c.get(v);if(!E)return;const R=new F.$Sc,D=new C.$7d;this.d.set($,D);const p=R.add(E.provideKeywordRecognitionSession(D.token));R.add(p.onDidChange(k=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,k)})),R.add(D.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}registerProvider(v,$,E){const R=P.a++;return this.c.set(R,E),this.b.$registerProvider(R,$,{extension:v,displayName:v.value}),(0,F.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Aic=P}),define(Ee[117],Se([1,0,6,4,5]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0;class P{constructor(v,$){this.c=$,this.b=new F.$Wd,this.onDidChangeStorage=this.b.event,this.a=v.getProxy(C.$fL.MainThreadStorage)}registerExtensionStorageKeysToSync(v,$){this.a.$registerExtensionStorageKeysToSync(v,$)}async initializeExtensionStorage(v,$,E){const R=await this.a.$initializeExtensionStorage(v,$);let D;return R&&(D=this.d(v,$,R)),D||E}setValue(v,$,E){return this.a.$setValue(v,$,E)}$acceptValue(v,$,E){const R=this.d(v,$,E);R&&this.b.fire({shared:v,key:$,value:R})}d(v,$,E){try{return JSON.parse(E)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${v}): ${R}`)}}}e.$whc=P,e.$xhc=(0,f.$7h)("IExtHostStorage")}),define(Ee[305],Se([1,0,3,16,2,6]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(P.$fL.MainThreadUriOpeners)}registerExternalUriOpener($,E,R,D){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const p=D.schemes.find(k=>!A.a.has(k));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(E,R),this.b.$registerUriOpener(E,D.schemes,$,D.label),(0,C.$Rc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri($,E,R){const D=this.c.get($);if(!D)throw new Error(`Unknown opener with id: ${$}`);const p=f.URI.revive(E);return D.canOpenExternalUri(p,R)}async $openUri($,E,R){const D=this.c.get($);if(!D)throw new Error(`Unknown opener id: '${$}'`);return D.openExternalUri(f.URI.revive(E.resolvedUri),{sourceUri:f.URI.revive(E.sourceUri)},R)}}e.$Oic=A}),define(Ee[306],Se([1,0,6,2,3,14,25]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;class v{static{this.a=0}constructor(E){this.c=new A.$nm,this.d=new Map,this.b=E.getProxy(C.$fL.MainThreadUrls)}registerUriHandler(E,R){const D=E.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const p=v.a++;return this.c.add(D),this.d.set(p,R),this.b.$registerUriHandler(p,D,E.displayName||E.name),(0,f.$Rc)(()=>{this.c.delete(D),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(E,R){const D=this.d.get(E);if(!D)return Promise.resolve(void 0);try{D.handleUri(F.URI.revive(R))}catch(p){(0,P.$1)(p)}return Promise.resolve(void 0)}async createAppUri(E){return F.URI.revive(await this.b.$createAppUri(E))}}e.$Pic=v}),define(Ee[93],Se([1,0,4,3,16,24,2,237,274,112,6]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=e.$khc=e.$jhc=e.$ihc=e.$hhc=void 0;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,a,t,h,s,d,l){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new C.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Wd,this._onDidDispose=this.#h.event,this.#e=n,this.#t=a,this.#o=t,this.#n=h,this.#s=s,this.#r=d,this.#u=p(d),this.#d=k(d),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,E.$fwb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===f.Schemas.https||n.scheme===f.Schemas.http){let a=n.toString();return a.endsWith("/")||(a+="/"),a+" "+E.$ewb}return E.$ewb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),P.$An(this.#o,n)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const a=(0,$.$ylb)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const a=this.#r.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,d,l,u,w)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(u)}),b=(0,E.$fwb)(I,{isRemote:a,authority:t}).toString();return`${s}${b}${w}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,d,l,u,w)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(u)}),b=(0,E.$fwb)(I,{isRemote:a,authority:t}).toString();return`${s}${b}${w}`})}}e.$hhc=D;function p(r){try{const n=(0,v.$dp)((0,v.$cp)(r.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.$ihc=p;function k(r){try{const n=(0,v.$dp)((0,v.$cp)(r.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class S extends F.$Tc{constructor(n,a,t,h,s){super(),this.c=a,this.f=t,this.g=h,this.h=s,this.b=new Map,this.a=n.getProxy(R.$fL.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,a,t){const h=this.j(n);if(h){const{message:s}=(0,$.$zlb)(a,t.value);h._onMessageEmitter.fire(s)}}$onMissingCsp(n,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,a,t){const h=new D(n,this.a,o(a),this.c,this.f,t,this.h);this.b.set(n,h);const s=h._onDidDispose(()=>{s.dispose(),this.deleteWebview(n)});return h}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$jhc=S;function c(r){return{id:r.identifier,location:r.extensionLocation}}e.$khc=c;function g(r,n,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(r,n)}}e.$lhc=g;function o(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(n=>A.URI.from(n))}}function i(r,n){return[...(n?.getWorkspaceFolders()||[]).map(a=>a.uri),r.extensionLocation]}}),define(Ee[146],Se([1,0,4,6,2,16,12,5,20,26]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=void 0;let D=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(k){const S=this.d;return{get focused(){return S.focused},get active(){return(0,E.$KF)(k,"windowActivity"),S.active}}}constructor(k){this.c=new C.$Wd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=k.getProxy(F.$fL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:c})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(k){this.onDidChangeWindowProperty("focused",k)}$onDidChangeWindowActive(k){this.onDidChangeWindowProperty("active",k)}onDidChangeWindowProperty(k,S){S!==this.d[k]&&(this.d={...this.d,[k]:S},this.c.fire(this.d))}openUri(k,S){let c;if(typeof k=="string"){c=k;try{k=f.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,A.$Ke)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,c,S)}async asExternalUri(k,S){if((0,A.$Ke)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this.b.$asExternalUri(k,S);return f.URI.from(c)}};e.$Ric=D,e.$Ric=D=R=Ge([qe(0,$.$kN)],D),e.$Sic=(0,v.$7h)("IExtHostWindow")}),define(Ee[307],Se([1,0,299,27,20]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=void 0;const P=1024*1024;let A=class extends C.$Vic{constructor($,E){super($,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,E,R){const D=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,D.write(`
START_NATIVE_LOG
`),E.apply(console,R),D.write(`
END_NATIVE_LOG
`),this.g=!1}j($,E){const R=process[$],D=R.write;let p="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(k,S,c)=>{if(!this.g){p+=k.toString(S);const g=p.length>P?p.length:p.lastIndexOf(`
`);g!==-1&&(console[E](p.slice(0,g)),p=p.slice(g+1))}D.call(R,k,S,c)}})}};e.$ujc=A,e.$ujc=A=Ge([qe(0,f.$kN),qe(1,F.$AN)],A)}),define(Ee[308],Se([1,0,145,16,251,30]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;class A extends C.$Uic{s($,E,R){return $.scheme===F.Schemas.file?new f.$wO(R?.name||(0,P.$rg)(),$.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,E):super.s($,E,R)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Gjc=A}),define(Ee[309],Se([1,0,11,22,21,14,4,3,130,297,68]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$48b=e.ResponsiveState=e.RequestInitiator=e.$38b=e.$28b=void 0;function p(y,L){try{return JSON.stringify(y,L)}catch{return"null"}}const k="$$ref$$",S={[k]:-1};class c{constructor(L,N){this.jsonString=L,this.referencedBuffers=N}}function g(y,L=null,N=!1){const U=[];return{jsonString:(N?p:JSON.stringify)(y,(O,M)=>{if(typeof M>"u")return S;if(typeof M=="object"){if(M instanceof F.$ke){const j=U.push(M)-1;return{[k]:j}}if(L)return L(O,M)}return M}),referencedBuffers:U}}e.$28b=g;function o(y,L,N){return JSON.parse(y,(U,T)=>{if(T){const O=T[k];if(typeof O=="number")return L[O];if(N&&T.$mid===1)return N.transformIncoming(T)}return T})}e.$38b=o;function i(y,L){return JSON.stringify(y,L)}function r(y){return y?(L,N)=>N&&N.$mid===1?y.transformOutgoing(N):N:null}var n;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var a;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},h=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class d extends v.$Tc{static{D=h}static{this.a=3*1e3}constructor(L,N=null,U=null){super(),this[D]=!0,this.b=this.B(new A.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=N,this.g=U,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,O=R.$Rv.count;T<O;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$gh(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const N=this.w[L];delete this.w[L],N.resolveErr(P.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,$.$8m)(L,this.g):L}getProxy(L){const{nid:N,sid:U}=L;return this.s[N]||(this.s[N]=this.J(N,U)),this.s[N]}J(L,N){const U={get:(T,O)=>(typeof O=="string"&&!T[O]&&O.charCodeAt(0)===36&&(T[O]=(...M)=>this.U(L,O,M)),O===s?N:T[O])};return new Proxy(Object.create(null),U)}set(L,N){return this.m[L.nid]=N,N}assertRegistered(L){for(let N=0,U=L.length;N<U;N++){const T=L[N];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(L){if(this.j)return;const N=L.byteLength,U=u.read(L,0),T=U.readUInt8(),O=U.readUInt32();switch(T){case 1:case 2:{let{rpcId:M,method:j,args:z}=I.deserializeRequestJSONArgs(U);this.g&&(z=(0,$.$8m)(z,this.g)),this.M(N,O,M,j,z,T===2);break}case 3:case 4:{let{rpcId:M,method:j,args:z}=I.deserializeRequestMixedArgs(U);this.g&&(z=(0,$.$8m)(z,this.g)),this.M(N,O,M,j,z,T===4);break}case 5:{this.f?.logIncoming(N,O,0,"ack"),this.G(O);break}case 6:{this.N(N,O);break}case 7:{this.O(N,O,void 0);break}case 9:{let M=I.deserializeReplyOKJSON(U);this.g&&(M=(0,$.$8m)(M,this.g)),this.O(N,O,M);break}case 10:{const M=I.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(N,O,M);break}case 8:{const M=I.deserializeReplyOKVSBuffer(U);this.O(N,O,M);break}case 11:{let M=I.deserializeReplyErrError(U);this.g&&(M=(0,$.$8m)(M,this.g)),this.P(N,O,M);break}case 12:{this.P(N,O,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,N,U,T,O,M){this.f?.logIncoming(L,N,1,`receiveRequest ${(0,R.$Tv)(U)}.${T}(`,O);const j=String(N);let z,J;if(M){const Y=new f.$7d;O.push(Y.token),z=this.Q(U,T,O),J=()=>Y.cancel()}else z=this.Q(U,T,O),J=t;this.u[j]=J;const le=I.serializeAcknowledged(N);this.f?.logOutgoing(le.byteLength,N,1,"ack"),this.c.send(le),z.then(Y=>{delete this.u[j];const Q=I.serializeReplyOK(N,Y,this.h);this.f?.logOutgoing(Q.byteLength,N,1,"reply:",Y),this.c.send(Q)},Y=>{delete this.u[j];const Q=I.serializeReplyErr(N,Y);this.f?.logOutgoing(Q.byteLength,N,1,"replyErr:",Y),this.c.send(Q)})}N(L,N){this.f?.logIncoming(L,N,1,"receiveCancel");const U=String(N);this.u[U]?.()}O(L,N,U){this.f?.logIncoming(L,N,0,"receiveReply:",U);const T=String(N);if(!this.w.hasOwnProperty(T))return;const O=this.w[T];delete this.w[T],O.resolveOk(U)}P(L,N,U){this.f?.logIncoming(L,N,0,"receiveReplyErr:",U);const T=String(N);if(!this.w.hasOwnProperty(T))return;const O=this.w[T];delete this.w[T];let M;U&&(U.$isError?(M=new Error,M.name=U.name,M.message=U.message,M.stack=U.stack):M=U),O.resolveErr(M)}Q(L,N,U){try{return Promise.resolve(this.S(L,N,U))}catch(T){return Promise.reject(T)}}S(L,N,U){const T=this.m[L];if(!T)throw new Error("Unknown actor "+(0,R.$Tv)(L));const O=T[N];if(typeof O!="function")throw new Error("Unknown method "+N+" on actor "+(0,R.$Tv)(L));return O.apply(T,U)}U(L,N,U){if(this.j)return new E.$18b;let T=null;if(U.length>0&&f.CancellationToken.isCancellationToken(U[U.length-1])&&(T=U.pop()),T&&T.isCancellationRequested)return Promise.reject(P.$6());const O=I.serializeRequestArguments(U,this.h),M=++this.t,j=String(M),z=new E.$Z8b,J=new v.$Sc;T&&J.add(T.onCancellationRequested(()=>{const Y=I.serializeCancel(M);this.f?.logOutgoing(Y.byteLength,M,0,"cancel"),this.c.send(I.serializeCancel(M))})),this.w[j]=new l(z,J),this.F(M);const le=I.serializeRequest(M,L,N,O,!!T);return this.f?.logOutgoing(le.byteLength,M,0,`request: ${(0,R.$Tv)(L)}.${N}(`,U),this.c.send(le),z}}e.$48b=d;class l{constructor(L,N){this.a=L,this.b=N}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class u{static alloc(L,N,U){const T=new u(F.$ke.alloc(U+1+4),0);return T.writeUInt8(L),T.writeUInt32(N),T}static read(L,N){return new u(L,N)}get buffer(){return this.a}constructor(L,N){this.a=L,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+L).toString();return this.b+=L,U}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+L).toString();return this.b+=L,U}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+L);return this.b+=L,N}static sizeMixedArray(L){let N=0;N+=1;for(let U=0,T=L.length;U<T;U++){const O=L[U];switch(N+=1,O.type){case 1:N+=this.sizeLongString(O.value);break;case 2:N+=this.sizeVSBuffer(O.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(O.value);for(let M=0;M<O.buffers.length;++M)N+=this.sizeVSBuffer(O.buffers[M]);break;case 4:break}}return N}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let N=0,U=L.length;N<U;N++){const T=L[N];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let O=0;O<T.buffers.length;++O)this.writeBuffer(T.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const N=new Array(L);for(let U=0;U<L;U++)switch(this.readUInt8()){case 1:N[U]=this.readLongString();break;case 2:N[U]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),M=this.readLongString(),j=[];for(let z=0;z<O;++z)j.push(this.readVSBuffer());N[U]=new R.$Uv(o(M,j,null));break}case 4:N[U]=void 0;break}return N}}var w;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(w||(w={}));class I{static a(L){for(let N=0,U=L.length;N<U;N++)if(L[N]instanceof F.$ke||L[N]instanceof R.$Uv||typeof L[N]>"u")return!0;return!1}static serializeRequestArguments(L,N){if(this.a(L)){const U=[];for(let T=0,O=L.length;T<O;T++){const M=L[T];if(M instanceof F.$ke)U[T]={type:2,value:M};else if(typeof M>"u")U[T]={type:4};else if(M instanceof R.$Uv){const{jsonString:j,referencedBuffers:z}=g(M.value,N);U[T]={type:3,value:F.$ke.fromString(j),buffers:z}}else U[T]={type:1,value:F.$ke.fromString(i(M,N))}}return{type:1,args:U}}return{type:0,args:i(L,N)}}static serializeRequest(L,N,U,T,O){switch(T.type){case 0:return this.b(L,N,U,T.args,O);case 1:return this.c(L,N,U,T.args,O)}}static b(L,N,U,T,O){const M=F.$ke.fromString(U),j=F.$ke.fromString(T);let z=0;z+=u.sizeUInt8(),z+=u.sizeShortString(M),z+=u.sizeLongString(j);const J=u.alloc(O?2:1,L,z);return J.writeUInt8(N),J.writeShortString(M),J.writeLongString(j),J.buffer}static deserializeRequestJSONArgs(L){const N=L.readUInt8(),U=L.readShortString(),T=L.readLongString();return{rpcId:N,method:U,args:JSON.parse(T)}}static c(L,N,U,T,O){const M=F.$ke.fromString(U);let j=0;j+=u.sizeUInt8(),j+=u.sizeShortString(M),j+=u.sizeMixedArray(T);const z=u.alloc(O?4:3,L,j);return z.writeUInt8(N),z.writeShortString(M),z.writeMixedArray(T),z.buffer}static deserializeRequestMixedArgs(L){const N=L.readUInt8(),U=L.readShortString(),T=L.readMixedArray(),O=new Array(T.length);for(let M=0,j=T.length;M<j;M++){const z=T[M];typeof z=="string"?O[M]=JSON.parse(z):O[M]=z}return{rpcId:N,method:U,args:O}}static serializeAcknowledged(L){return u.alloc(5,L,0).buffer}static serializeCancel(L){return u.alloc(6,L,0).buffer}static serializeReplyOK(L,N,U){if(typeof N>"u")return this.d(L);if(N instanceof F.$ke)return this.e(L,N);if(N instanceof R.$Uv){const{jsonString:T,referencedBuffers:O}=g(N.value,U,!0);return this.g(L,T,O)}else return this.f(L,p(N,U))}static d(L){return u.alloc(7,L,0).buffer}static e(L,N){let U=0;U+=u.sizeVSBuffer(N);const T=u.alloc(8,L,U);return T.writeVSBuffer(N),T.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,N){const U=F.$ke.fromString(N);let T=0;T+=u.sizeLongString(U);const O=u.alloc(9,L,T);return O.writeLongString(U),O.buffer}static g(L,N,U){const T=F.$ke.fromString(N);let O=0;O+=u.sizeUInt32,O+=u.sizeLongString(T);for(const j of U)O+=u.sizeVSBuffer(j);const M=u.alloc(10,L,O);M.writeUInt32(U.length),M.writeLongString(T);for(const j of U)M.writeBuffer(j);return M.buffer}static deserializeReplyOKJSON(L){const N=L.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(L,N){const U=L.readUInt32(),T=L.readLongString(),O=[];for(let M=0;M<U;++M)O.push(L.readVSBuffer());return new R.$Uv(o(T,O,N))}static serializeReplyErr(L,N){const U=N?p(P.$3(N),null):void 0;if(typeof U!="string")return this.h(L);const T=F.$ke.fromString(U);let O=0;O+=u.sizeLongString(T);const M=u.alloc(11,L,O);return M.writeLongString(T),M.buffer}static deserializeReplyErrError(L){const N=L.readLongString();return JSON.parse(N)}static h(L){return u.alloc(12,L,0).buffer}}var b;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var m;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(m||(m={}))}),define(Ee[310],Se([1,0,22,28,16,84,5]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5I=e.$4I=e.$3I=e.$2I=void 0,e.$2I=(0,A.$7h)("notebookDocumentService");const v=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${v.join("")}]+`),E=7;function R(k){if(k.scheme!==f.Schemas.vscodeNotebookCell)return;const S=k.fragment.indexOf("s");if(S<0)return;const c=parseInt(k.fragment.substring(0,S).replace($,""),E),g=(0,C.$De)(k.fragment.substring(S+1)).toString();if(!isNaN(c))return{handle:c,notebook:k.with({scheme:g,fragment:null})}}e.$3I=R;function D(k,S){const c=S.toString(E),o=`${c.length<v.length?v[c.length-1]:"z"}${c}s${(0,C.$Ee)(C.$ke.fromString(k.scheme),!0,!0)}`;return k.with({scheme:f.Schemas.vscodeNotebookCell,fragment:o})}e.$4I=D;class p{constructor(){this.a=new F.$Ac}getNotebook(S){if(S.scheme===f.Schemas.vscodeNotebookCell){const c=R(S);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get(S)}addNotebookDocument(S){this.a.set(S.uri,S)}removeNotebookDocument(S){this.a.delete(S.uri)}}e.$5I=p,(0,P.$Zr)(e.$2I,p,1)}),define(Ee[118],Se([1,0,22,35,53,101,16,17,10,45,310]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.CellStatusbarAlignment=e.$gJ=e.$fJ=e.$eJ=e.NotebookEditorPriority=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_I=e.$$I=e.$0I=e.$9I=e.CellKind=e.$8I=e.$7I=e.$6I=void 0,e.$6I="workbench.editor.notebook",e.$7I="workbench.editor.notebookTextDiffEditor",e.$8I="workbench.editor.interactive";var D;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(D||(e.CellKind=D={})),e.$9I=["application/json","application/javascript","text/html","image/svg+xml",P.$gs.latex,P.$gs.markdown,"image/png","image/jpeg",P.$gs.text],e.$0I=[P.$gs.latex,P.$gs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$gs.text],e.$$I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_I="_notAvailable";var p;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var k;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var S;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var c;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var o;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var n;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;function J(ne,$e){return(0,R.$4I)(ne,$e)}z.generate=J;function le(ne){return(0,R.$3I)(ne)}z.parse=le;function Y(ne,$e){return ne.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${ne.scheme!==A.Schemas.file?ne.scheme:""}`})}z.generateCellOutputUri=Y;function Q(ne){if(ne.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!$e)return;const oe=$e[1]&&$e[1]!==""?$e[1]:void 0,K=$e[2];return{outputId:oe,notebook:ne.with({scheme:K||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=Q;function X(ne,$e,oe){return z.generate(ne,$e).with({scheme:oe})}z.generateCellPropertyUri=X;function ue(ne,$e){if(ne.scheme===$e)return z.parse(ne.with({scheme:z.scheme}))}z.parseCellPropertyUri=ue})(n||(e.CellUri=n={}));const a=z=>$.$i?z.replace(/\//g,"\\"):z;class t{constructor(J=[],le=e.$9I){this.e=le,this.d=[...new Set(J)].map(Y=>({pattern:Y,matches:F.$Nj(a(Y))}))}sort(J){const le=new Map(f.Iterable.map(J,Q=>[Q,a(Q)]));let Y=[];for(const{matches:Q}of this.d)for(const[X,ue]of le)if(Q(ue)){Y.push(X),le.delete(X);break}return le.size&&(Y=Y.concat([...le.keys()].sort((Q,X)=>this.e.indexOf(Q)-this.e.indexOf(X)))),Y}prioritize(J,le){const Y=this.f(J);if(Y===-1){this.d.unshift({pattern:J,matches:F.$Nj(a(J))});return}const Q=new Set(le.map(ue=>this.f(ue,Y)));Q.delete(-1);const X=Array.from(Q).sort();this.d.splice(Y+1,0,...X.map(ue=>this.d[ue]));for(let ue=X.length-1;ue>=0;ue--)this.d.splice(X[ue],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,le=this.d.length){const Y=a(J);for(let Q=0;Q<le;Q++)if(this.d[Q].matches(Y))return Q;return-1}}e.$aJ=t;function h(z,J,le,Y=(Q,X)=>Q===X){const Q=[];function X($e,oe,K){if(oe===0&&K.length===0)return;const W=Q[Q.length-1];W&&W.start+W.deleteCount===$e?(W.deleteCount+=oe,W.toInsert.push(...K)):Q.push({start:$e,deleteCount:oe,toInsert:K})}let ue=0,ne=0;for(;;){if(ue===z.length){X(ue,0,J.slice(ne));break}if(ne===J.length){X(ue,z.length-ue,[]);break}const $e=z[ue],oe=J[ne];if(Y($e,oe)){ue+=1,ne+=1;continue}le(oe)?(X(ue,1,[]),ue+=1):(X(ue,0,[oe]),ne+=1)}return Q}e.$bJ=h,e.$cJ=new E.$lj("notebookEditorCursorAtBoundary","none"),e.$dJ=new E.$lj("notebookEditorCursorAtLineBoundary","none");var s;(function(z){z.default="default",z.option="option"})(s||(e.NotebookEditorPriority=s={}));function d(z){const J=z;return!!((typeof J.include=="string"||F.$Oj(J.include))&&(typeof J.exclude=="string"||F.$Oj(J.exclude)))}e.$eJ=d;function l(z,J,le){if(Array.isArray(z.viewType)&&z.viewType.indexOf(J)>=0||z.viewType===J)return!0;if(z.filenamePattern){const Y=d(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,Q=d(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(F.$Mj(Y,(0,v.$nc)(le.fsPath).toLowerCase()))return!(Q&&F.$Mj(Q,(0,v.$nc)(le.fsPath).toLowerCase()))}return!1}e.$fJ=l,e.$gJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var u;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class w{static{this.d="notebook/"}static create(J){return`${w.d}${J}`}static parse(J){if(J.startsWith(w.d))return J.substring(w.d.length)}}e.$hJ=w;function I(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$iJ=I;const b=new TextDecoder;function m(z){const J=[];let le=!1;for(const ue of z)(J.length===0||le)&&(J.push(ue),le=!0);let Y=N(J);const Q=C.$ke.concat(J.map(ue=>C.$ke.wrap(ue))),X=j(Q);return Y=Y||X.byteLength!==Q.byteLength,{data:X,didCompression:Y}}e.$jJ=m,e.$kJ=`${String.fromCharCode(27)}[A`;const y=e.$kJ.split("").map(z=>z.charCodeAt(0)),L=10;function N(z){let J=!1;return z.forEach((le,Y)=>{if(Y===0||le.length<e.$kJ.length)return;const Q=z[Y-1],X=le.subarray(0,e.$kJ.length);if(X[0]===y[0]&&X[1]===y[1]&&X[2]===y[2]){const ue=Q.lastIndexOf(L);if(ue===-1)return;J=!0,z[Y-1]=Q.subarray(0,ue),z[Y]=le.subarray(e.$kJ.length)}}),J}function U(z){let J=z;do z=J,J=z.replace(/[^\n]\x08/gm,"");while(J.length<z.length);return z}function T(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const J=z.match(/^(.*)\r+/m)[1];let le=z.match(/\r+(.*)$/m)[1];le=le+J.slice(le.length,J.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return z}const O="\b".charCodeAt(0),M="\r".charCodeAt(0);function j(z){return!z.buffer.includes(O)&&!z.buffer.includes(M)?z:C.$ke.fromString(T(U(b.decode(z.buffer))))}}),define(Ee[7],Se([1,0,19,14,80,28,101,12,18,2,30,25,32,64,118]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S){"use strict";var c,g,o,i,r,n,a,t,h,s,d,l,u,w,I,b,m;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$_M=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$$M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TestRunProfileKind=e.TestResultState=e.$QM=e.$PM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$OM=e.NotebookVariablesRequestKind=e.$NM=e.$MM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$LM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.ColorThemeKind=e.$FM=e.$EM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$DM=e.$CM=e.DebugConsoleMode=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$wM=e.$vM=e.FileChangeType=e.$uM=e.$tM=e.$sM=e.$rM=e.InlineCompletionTriggerKind=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.ConfigurationTarget=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$7L=e.ViewBadge=e.ProgressLocation=e.$6L=e.$5L=e.TaskScope=e.ShellQuoting=e.$4L=e.$3L=e.$2L=e.TaskPanelKind=e.TaskRevealKind=e.$1L=e.TerminalLocation=e.$ZL=e.$YL=e.$XL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$WL=e.$VL=e.$UL=e.$TL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$SL=e.StatusBarAlignment=e.ViewColumn=e.$RL=e.$QL=e.$PL=e.$OL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$NL=e.$ML=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.LanguageStatusSeverity=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.CodeActionTriggerKind=e.$AL=e.$zL=e.SymbolTag=e.SymbolKind=e.$yL=e.$xL=e.DocumentHighlightKind=e.$wL=e.$vL=e.$uL=e.$tL=e.DiagnosticSeverity=e.DiagnosticTag=e.$sL=e.$rL=e.FileEditType=e.$qL=e.$pL=e.$oL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(H){return Object.assign(H,{apply:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const Ne=pe.length===1?[]:pe[1];return Reflect.construct(H,Ne,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const[Ne,...Ye]=pe;return Reflect.construct(H,Ye,Ne.constructor)}}})}var L;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(L||(e.TerminalOutputAnchor=L={}));var N;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let U=c=class{static from(...q){let pe=q;return new c(function(){if(pe){for(const Ne of pe)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();pe=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$hL=U,e.$hL=U=c=Ge([y],U);let T=g=class{static Min(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Ne=1;Ne<q.length;Ne++){const Ye=q[Ne];Ye.isBefore(pe)&&(pe=Ye)}return pe}static Max(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Ne=1;Ne<q.length;Ne++){const Ye=q[Ne];Ye.isAfter(pe)&&(pe=Ye)}return pe}static isPosition(q){if(!q)return!1;if(q instanceof g)return!0;const{line:pe,character:Ne}=q;return typeof pe=="number"&&typeof Ne=="number"}static of(q){if(q instanceof g)return q;if(this.isPosition(q))return new g(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,pe){if(q<0)throw(0,F.$7)("line must be non-negative");if(pe<0)throw(0,F.$7)("character must be non-negative");this.c=q,this.e=pe}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,pe=0){if(q===null||pe===null)throw(0,F.$7)();let Ne;return typeof q>"u"?Ne=0:typeof q=="number"?Ne=q:(Ne=typeof q.lineDelta=="number"?q.lineDelta:0,pe=typeof q.characterDelta=="number"?q.characterDelta:0),Ne===0&&pe===0?this:new g(this.line+Ne,this.character+pe)}with(q,pe=this.character){if(q===null||pe===null)throw(0,F.$7)();let Ne;return typeof q>"u"?Ne=this.line:typeof q=="number"?Ne=q:(Ne=typeof q.line=="number"?q.line:this.line,pe=typeof q.character=="number"?q.character:this.character),Ne===this.line&&pe===this.character?this:new g(Ne,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$iL=T,e.$iL=T=g=Ge([y],T);let O=o=class{static isRange(q){return q instanceof o?!0:q?T.isPosition(q.start)&&T.isPosition(q.end):!1}static of(q){if(q instanceof o)return q;if(this.isRange(q))return new o(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,pe,Ne,Ye){let tt,ut;if(typeof q=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(tt=new T(q,pe),ut=new T(Ne,Ye)):T.isPosition(q)&&T.isPosition(pe)&&(tt=T.of(q),ut=T.of(pe)),!tt||!ut)throw new Error("Invalid arguments");tt.isBefore(ut)?(this.c=tt,this.e=ut):(this.c=ut,this.e=tt)}contains(q){return o.isRange(q)?this.contains(q.start)&&this.contains(q.end):T.isPosition(q)?!(T.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const pe=T.Max(q.start,this.c),Ne=T.Min(q.end,this.e);if(!pe.isAfter(Ne))return new o(pe,Ne)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const pe=T.Min(q.start,this.c),Ne=T.Max(q.end,this.end);return new o(pe,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,pe=this.end){if(q===null||pe===null)throw(0,F.$7)();let Ne;return q?T.isPosition(q)?Ne=q:(Ne=q.start||this.start,pe=q.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&pe.isEqual(this.end)?this:new o(Ne,pe)}toJSON(){return[this.start,this.end]}};e.$jL=O,e.$jL=O=o=Ge([y],O);let M=i=class extends O{static isSelection(q){return q instanceof i?!0:q?O.isRange(q)&&T.isPosition(q.anchor)&&T.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,pe,Ne,Ye){let tt,ut;if(typeof q=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(tt=new T(q,pe),ut=new T(Ne,Ye)):T.isPosition(q)&&T.isPosition(pe)&&(tt=T.of(q),ut=T.of(pe)),!tt||!ut)throw new Error("Invalid arguments");super(tt,ut),this.f=tt,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$kL=M,e.$kL=M=i=Ge([y],M);const j=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,F.$7)("connectionToken")};class z{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe,Ne){if(typeof q!="string"||q.length===0)throw(0,F.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,F.$7)("port");typeof Ne<"u"&&j(Ne),this.host=q,this.port=Math.round(pe),this.connectionToken=Ne}}e.$lL=z;class J{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe){this.makeConnection=q,this.connectionToken=pe,typeof pe<"u"&&j(pe)}}e.$mL=J;class le extends Error{static NotAvailable(q,pe){return new le(q,k.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(q){return new le(q,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,pe=k.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(q),this._message=q,this._code=pe,this._detail=Ne,Object.setPrototypeOf(this,le.prototype)}}e.$nL=le;var Y;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Y||(e.EndOfLine=Y={}));var Q;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let X=r=class{static isTextEdit(q){return q instanceof r?!0:q?O.isRange(q)&&typeof q.newText=="string":!1}static replace(q,pe){return new r(q,pe)}static insert(q,pe){return r.replace(new O(q,q),pe)}static delete(q){return r.replace(q,"")}static setEndOfLine(q){const pe=new r(new O(new T(0,0),new T(0,0)),"");return pe.newEol=q,pe}get range(){return this.c}set range(q){if(q&&!O.isRange(q))throw(0,F.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,F.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,F.$7)("newEol");this.f=q}constructor(q,pe){this.c=q,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$oL=X,e.$oL=X=r=Ge([y],X);let ue=n=class{static isNotebookCellEdit(q){return q instanceof n?!0:q?ni.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,pe){return new n(q,pe)}static insertCells(q,pe){return new n(new ni(q,q),pe)}static deleteCells(q){return new n(q,[])}static updateCellMetadata(q,pe){const Ne=new n(new ni(q,q),[]);return Ne.newCellMetadata=pe,Ne}static updateNotebookMetadata(q){const pe=new n(new ni(0,0),[]);return pe.newNotebookMetadata=q,pe}constructor(q,pe){this.range=q,this.newCells=pe}};e.$pL=ue,e.$pL=ue=n=Ge([y],ue);class ne{static isSnippetTextEdit(q){return q instanceof ne?!0:q?O.isRange(q.range)&&K.isSnippetString(q.snippet):!1}static replace(q,pe){return new ne(q,pe)}static insert(q,pe){return ne.replace(new O(q,q),pe)}constructor(q,pe){this.range=q,this.snippet=pe}}e.$qL=ne;var $e;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,pe,Ne,Ye){this.c.push({_type:1,from:q,to:pe,options:Ne,metadata:Ye})}createFile(q,pe,Ne){this.c.push({_type:1,from:void 0,to:q,options:pe,metadata:Ne})}deleteFile(q,pe,Ne){this.c.push({_type:1,from:q,to:void 0,options:pe,metadata:Ne})}e(q,pe,Ne){this.c.push({_type:3,metadata:Ne,uri:q,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(q,pe,Ne,Ye){const tt=pe.start,ut=pe.end;(tt!==ut||Ne.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:ut-tt,cells:Ne,metadata:Ye})}g(q,pe,Ne,Ye){this.c.push({_type:3,metadata:Ye,uri:q,edit:{editType:3,index:pe,metadata:Ne}})}replace(q,pe,Ne,Ye){this.c.push({_type:2,uri:q,edit:new X(pe,Ne),metadata:Ye})}insert(q,pe,Ne,Ye){this.replace(q,new O(pe,pe),Ne,Ye)}delete(q,pe,Ne){this.replace(q,pe,"",Ne)}has(q){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===q.toString())}set(q,pe){if(pe)for(const Ne of pe){if(!Ne)continue;let Ye,tt;Array.isArray(Ne)?(Ye=Ne[0],tt=Ne[1]):Ye=Ne,ue.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(q,Ye.range.start,Ye.newCellMetadata,tt):Ye.newNotebookMetadata?this.e(q,Ye.newNotebookMetadata,tt):this.f(q,Ye.range,Ye.newCells,tt):ne.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:q,range:Ye.range,edit:Ye.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Ye,metadata:tt})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Ye=this.c[Ne];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===q.toString()&&(this.c[Ne]=void 0);break}}(0,C.$Ib)(this.c)}}get(q){const pe=[];for(const Ne of this.c)Ne._type===2&&Ne.uri.toString()===q.toString()&&pe.push(Ne.edit);return pe}entries(){const q=new P.$Ac;for(const pe of this.c)if(pe._type===2){let Ne=q.get(pe.uri);Ne||(Ne=[pe.uri,[]],q.set(pe.uri,Ne)),Ne[1].push(pe.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$rL=oe,e.$rL=oe=Ge([y],oe);let K=a=class{static isSnippetString(q){return q instanceof a?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=a.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,pe=this.e++){if(typeof q=="function"){const Ne=new a;Ne.e=this.e,q(Ne),this.e=Ne.e,q=Ne.value}else q=a.c(q);return this.value+="${",this.value+=pe,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,pe=this.e++){const Ne=q.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(q,pe){if(typeof pe=="function"){const Ne=new a;Ne.e=this.e,pe(Ne),this.e=Ne.e,pe=Ne.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$sL=K,e.$sL=K=a=Ge([y],K);var W;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var ie;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?O.isRange(q.range)&&E.URI.isUri(q.uri):!1}constructor(q,pe){if(this.uri=q,pe)if(O.isRange(pe))this.range=O.of(pe);else if(T.isPosition(pe))this.range=new O(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$tL=ye,e.$tL=ye=t=Ge([y],ye);let de=class{static is(q){return q?typeof q.message=="string"&&q.location&&O.isRange(q.location.range)&&E.URI.isUri(q.location.uri):!1}constructor(q,pe){this.location=q,this.message=pe}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.location.range.isEqual(pe.location.range)&&q.location.uri.toString()===pe.location.uri.toString()}};e.$uL=de,e.$uL=de=Ge([y],de);let fe=class{constructor(q,pe,Ne=ie.Error){if(!O.isRange(q))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=q,this.message=pe,this.severity=Ne}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.severity===pe.severity&&q.code===pe.code&&q.severity===pe.severity&&q.source===pe.source&&q.range.isEqual(pe.range)&&(0,C.$ub)(q.tags,pe.tags)&&(0,C.$ub)(q.relatedInformation,pe.relatedInformation,de.isEqual)}};e.$vL=fe,e.$vL=fe=Ge([y],fe);let _=class{constructor(q,pe){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=pe}};e.$wL=_,e.$wL=_=Ge([y],_);var ee;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ee||(e.DocumentHighlightKind=ee={}));let G=class{constructor(q,pe=ee.Text){this.range=q,this.kind=pe}toJSON(){return{range:this.range,kind:ee[this.kind]}}};e.$xL=G,e.$xL=G=Ge([y],G);let x=class{constructor(q,pe){this.uri=q,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$yL=x,e.$yL=x=Ge([y],x);var me;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var we;(function(H){H[H.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Ae=h=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,pe,Ne,Ye,tt){this.name=q,this.kind=pe,this.containerName=tt,typeof Ne=="string"&&(this.containerName=Ne),Ye instanceof ye?this.location=Ye:Ne instanceof O&&(this.location=new ye(Ye,Ne)),h.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$zL=Ae,e.$zL=Ae=h=Ge([y],Ae);let ve=s=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(s.validate)}constructor(q,pe,Ne,Ye,tt){this.name=q,this.detail=pe,this.kind=Ne,this.range=Ye,this.selectionRange=tt,this.children=[],s.validate(this)}};e.$AL=ve,e.$AL=ve=s=Ge([y],ve);var Ie;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(Ie||(e.CodeActionTriggerKind=Ie={}));let B=class{constructor(q,pe){this.title=q,this.kind=pe}};e.$BL=B,e.$BL=B=Ge([y],B);let Z=class{static{d=this}static{this.c="."}constructor(q){this.value=q}append(q){return new d(this.value?this.value+d.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+d.c)}};e.$CL=Z,e.$CL=Z=d=Ge([y],Z),Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorMove=Z.Refactor.append("move"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll"),Z.Notebook=Z.Empty.append("notebook");let te=class{constructor(q,pe){if(this.range=q,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$DL=te,e.$DL=te=Ge([y],te);class V{constructor(q,pe,Ne,Ye,tt,ut){this.kind=q,this.name=pe,this.detail=Ne,this.uri=Ye,this.range=tt,this.selectionRange=ut}}e.$EL=V;class ae{constructor(q,pe){this.fromRanges=pe,this.from=q}}e.$FL=ae;class he{constructor(q,pe){this.fromRanges=pe,this.to=q}}e.$GL=he;var Re;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let je=class{constructor(q,pe){this.range=q,this.command=pe}get isResolved(){return!!this.command}};e.$HL=je,e.$HL=je=Ge([y],je);let He=l=class{#e;static isMarkdownString(q){return q instanceof l?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,pe=!1){this.#e=new f.$ik(q,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,pe){return this.#e.appendCodeblock(pe??"",q),this}};e.$IL=He,e.$IL=He=l=Ge([y],He);let Qe=class{constructor(q,pe){this.label=q,this.documentation=pe}};e.$JL=Qe,e.$JL=Qe=Ge([y],Qe);let _e=class{constructor(q,pe){this.label=q,this.documentation=pe,this.parameters=[]}};e.$KL=_e,e.$KL=_e=Ge([y],_e);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$LL=at,e.$LL=at=Ge([y],at);var st;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var rt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Pe=class{constructor(q){this.value=q}};e.$ML=Pe,e.$ML=Pe=Ge([y],Pe);let Ue=class{constructor(q,pe,Ne){this.position=q,this.label=pe,this.kind=Ne}};e.$NL=Ue,e.$NL=Ue=Ge([y],Ue);var Le;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le||(e.CompletionTriggerKind=Le={}));var Ze;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Ze||(e.CompletionItemKind=Ze={}));var re;(function(H){H[H.Deprecated=1]="Deprecated"})(re||(e.CompletionItemTag=re={}));let se=class{constructor(q,pe){this.label=q,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&Ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$OL=se,e.$OL=se=Ge([y],se);let Ce=class{constructor(q=[],pe=!1){this.items=q,this.isIncomplete=pe}};e.$PL=Ce,e.$PL=Ce=Ge([y],Ce);let Ve=class{constructor(q,pe,Ne){this.insertText=q,this.range=pe,this.command=Ne}};e.$QL=Ve,e.$QL=Ve=Ge([y],Ve);let Xe=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$RL=Xe,e.$RL=Xe=Ge([y],Xe);var it;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var nt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Oe(H,q){return`${D.$mm.toKey(H)}.${q}`}e.$SL=Oe;var yt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Dt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Ft;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var Tt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var kt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(kt||(e.TextDocumentChangeReason=kt={}));var Ht;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(H){function q(pe){switch(pe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=q}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Ot;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(H){function q(pe){switch(pe){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=q}(Ot||(e.SyntaxTokenType=Ot={}));let Xt=class{constructor(q,pe){if(pe&&!E.URI.isUri(pe))throw(0,F.$7)("target");if(!O.isRange(q)||q.isEmpty)throw(0,F.$7)("range");this.range=q,this.target=pe}};e.$TL=Xt,e.$TL=Xt=Ge([y],Xt);let qt=class{constructor(q,pe,Ne,Ye){this.red=q,this.green=pe,this.blue=Ne,this.alpha=Ye}};e.$UL=qt,e.$UL=qt=Ge([y],qt);let zt=class{constructor(q,pe){if(pe&&!(pe instanceof qt))throw(0,F.$7)("color");if(!O.isRange(q)||q.isEmpty)throw(0,F.$7)("range");this.range=q,this.color=pe}};e.$VL=zt,e.$VL=zt=Ge([y],zt);let et=class{constructor(q){if(!q||typeof q!="string")throw(0,F.$7)("label");this.label=q}};e.$WL=et,e.$WL=et=Ge([y],et);var Gt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var ht;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class $t{constructor(q,pe,Ne){if(this.startIndex=q,this.length=pe,this.tooltip=Ne,typeof q!="number"||q<0)throw(0,F.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,F.$7)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,F.$7)("tooltip")}}e.$XL=$t;class Bt{constructor(q){this.uri=q}}e.$YL=Bt;class Qt{constructor(q){this.terminalCommand=q}}e.$ZL=Qt;var Et;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Et||(e.TerminalLocation=Et={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,F.$7)("options")}}e.$1L=ft;var It;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var _t;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(_t||(e.TaskPanelKind=_t={}));let Lt=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(q){switch(q){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(q,pe){if(this.label=pe,typeof q!="string"||typeof pe!="string")throw(0,F.$7)("name");this.c=q}get id(){return this.c}};e.$2L=Lt,e.$2L=Lt=u=Ge([y],Lt);function Je(H){let q="";for(let pe=0;pe<H.length;pe++)q+=H[pe].replace(/,/g,",,")+",";return q}let Mt=class{constructor(q,pe,Ne){if(typeof q!="string")throw(0,F.$7)("process");this.e=[],this.c=q,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Ne):this.f=pe)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,F.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)q.push(pe);return Je(q)}};e.$3L=Mt,e.$3L=Mt=Ge([y],Mt);let jt=class{constructor(q,pe,Ne){if(this.f=[],Array.isArray(pe)){if(!q)throw(0,F.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,F.$7)("command");this.e=q,this.f=pe,this.g=Ne}else{if(typeof q!="string")throw(0,F.$7)("commandLine");this.c=q,this.g=pe}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,F.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,F.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)q.push(typeof pe=="string"?pe:pe.value);return Je(q)}};e.$4L=jt,e.$4L=jt=Ge([y],jt);var Zt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Zt||(e.ShellQuoting=Zt={}));var gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Nt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,R.$rg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$5L=Nt;let At=class{static{w=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,pe,Ne,Ye,tt,ut){this.k=!1,this.l=this.definition=q;let mt;typeof pe=="string"?(this.n=this.name=pe,this.u=this.source=Ne,this.execution=Ye,mt=tt,this.k=!0):pe===gt.Global||pe===gt.Workspace?(this.target=pe,this.n=this.name=Ne,this.u=this.source=Ye,this.execution=tt,mt=ut):(this.target=pe,this.n=this.name=Ne,this.u=this.source=Ye,this.execution=tt,mt=ut),typeof mt=="string"?(this.q=[mt],this.r=!0):Array.isArray(mt)?(this.q=mt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:w.e,id:this.o.computeId()}:this.o instanceof jt?this.l={type:w.f,id:this.o.computeId()}:this.o instanceof Nt?this.l={type:w.c,id:this.o.computeId()}:this.l={type:w.g,id:(0,R.$rg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,F.$7)("Kind can't be undefined or null");this.A(),this.l=q}get scope(){return this.m}set target(q){this.A(),this.m=q}get name(){return this.n}set name(q){if(typeof q!="string")throw(0,F.$7)("name");this.A(),this.n=q}get execution(){return this.o}set execution(q){q===null&&(q=void 0),this.A(),this.o=q;const pe=this.l.type;(w.g===pe||w.e===pe||w.f===pe||w.c===pe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(q){if(Array.isArray(q))this.A(),this.q=q,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.A(),this.t=q}get source(){return this.u}set source(q){if(typeof q!="string"||q.length===0)throw(0,F.$7)("source must be a string of length > 0");this.A(),this.u=q}get group(){return this.w}set group(q){q===null&&(q=void 0),this.A(),this.w=q}get detail(){return this.z}set detail(q){q===null&&(q=void 0),this.z=q}get presentationOptions(){return this.x}set presentationOptions(q){q==null&&(q=Object.create(null)),this.A(),this.x=q}get runOptions(){return this.y}set runOptions(q){q==null&&(q=Object.create(null)),this.A(),this.y=q}};e.$6L=At,e.$6L=At=w=Ge([y],At);var Wt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Wt||(e.ProgressLocation=Wt={}));var Me;(function(H){function q(pe){const Ne=pe;return(0,$.$Nf)(Ne.value)?Ne.tooltip&&!(0,$.$Jf)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}H.isViewBadge=q})(Me||(e.ViewBadge=Me={}));let Te=I=class{static isTreeItem(q,pe){const Ne=q;if(Ne.checkboxState!==void 0){const Ye=(0,$.$Nf)(Ne.checkboxState)?Ne.checkboxState:(0,$.$Lf)(Ne.checkboxState)&&(0,$.$Nf)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,tt=!(0,$.$Nf)(Ne.checkboxState)&&(0,$.$Lf)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==ce.Checked&&Ye!==ce.Unchecked||tt!==void 0&&!(0,$.$Jf)(tt))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(q instanceof I)return!0;if(Ne.label!==void 0&&!(0,$.$Jf)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,$.$Jf)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,$.$Jf)(Ne.iconPath)&&!E.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,$.$Jf)(Ne.iconPath.id))){const Ye=Ne.iconPath;if(!Ye||!(0,$.$Jf)(Ye.light)&&!E.URI.isUri(Ye.light)&&!(0,$.$Jf)(Ye.dark)&&!E.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,$.$Jf)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!E.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,$.$Jf)(Ne.tooltip)&&!(Ne.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<De.None&&Ne.collapsibleState>De.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,$.$Jf)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(q,pe=De.None){this.collapsibleState=pe,E.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$7L=Te,e.$7L=Te=I=Ge([y],Te);var De;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(De||(e.TreeItemCollapsibleState=De={}));var ce;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(ce||(e.TreeItemCheckboxState=ce={}));let Fe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$8L=Fe,e.$8L=Fe=Ge([y],Fe);class Be extends Fe{}e.$9L=Be;class xe extends Be{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$0L=xe;class Ke{constructor(q,pe,Ne,Ye){this.name=q,this.uri=pe,this._itemId=Ne,this.c=Ye}data(){return this.c()}}e.$$L=Ke;let ct=class{#e=new Map;constructor(q){for(const[pe,Ne]of q??[]){const Ye=this.#e.get(this.#t(pe));Ye?Ye.push(Ne):this.#e.set(this.#t(pe),[Ne])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,pe){this.#e.set(this.#t(q),[pe])}forEach(q,pe){for(const[Ne,Ye]of this.#e)for(const tt of Ye)q.call(pe,tt,Ne,this)}*[Symbol.iterator](){for(const[q,pe]of this.#e)for(const Ne of pe)yield[q,Ne]}#t(q){return q.toLowerCase()}};e.$_L=ct,e.$_L=ct=Ge([y],ct);let wt=class{constructor(q){this.insertText=q}};e.$aM=wt,e.$aM=wt=Ge([y],wt);let Kt=class{constructor(q,pe){this.label=pe,this.insertText=q}};e.$bM=Kt,e.$bM=Kt=Ge([y],Kt);let St=class{constructor(q,pe){this.id=q,this.color=pe}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$cM=St,e.$cM=St=Ge([y],St),St.File=new St("file"),St.Folder=new St("folder");let Ct=class{constructor(q){this.id=q}};e.$dM=Ct,e.$dM=Ct=Ge([y],Ct);var vt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(vt||(e.ConfigurationTarget=vt={}));let Si=class{get base(){return this.c}set base(q){this.c=q,this.e=E.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,pe){if(typeof q!="string"&&(!q||!E.URI.isUri(q)&&!E.URI.isUri(q.uri)))throw(0,F.$7)("base");if(typeof pe!="string")throw(0,F.$7)("pattern");typeof q=="string"?this.baseUri=E.URI.file(q):E.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eM=Si,e.$eM=Si=Ge([y],Si);const Ki=new WeakMap;function Pt(H,q){Ki.set(H,q)}e.$fM=Pt;let si=class{constructor(q,pe,Ne,Ye){this.enabled=typeof q=="boolean"?q:!0,typeof pe=="string"&&(this.condition=pe),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this.c||(this.c=Ki.get(this)??(0,R.$rg)()),this.c}};e.$gM=si,e.$gM=si=Ge([y],si);let mi=class extends si{constructor(q,pe,Ne,Ye,tt){if(super(pe,Ne,Ye,tt),q===null)throw(0,F.$7)("location");this.location=q}};e.$hM=mi,e.$hM=mi=Ge([y],mi);let li=class extends si{constructor(q,pe,Ne,Ye,tt){super(pe,Ne,Ye,tt),this.functionName=q}};e.$iM=li,e.$iM=li=Ge([y],li);let Di=class extends si{constructor(q,pe,Ne,Ye,tt,ut,mt){if(super(Ye,tt,ut,mt),!pe)throw(0,F.$7)("dataId");this.label=q,this.dataId=pe,this.canPersist=Ne}};e.$jM=Di,e.$jM=Di=Ge([y],Di);let Ci=class{constructor(q,pe,Ne){this.command=q,this.args=pe||[],this.options=Ne}};e.$kM=Ci,e.$kM=Ci=Ge([y],Ci);let Ut=class{constructor(q,pe){this.port=q,this.host=pe}};e.$lM=Ut,e.$lM=Ut=Ge([y],Ut);let $i=class{constructor(q){this.path=q}};e.$mM=$i,e.$mM=$i=Ge([y],$i);let Ii=class{constructor(q){this.implementation=q}};e.$nM=Ii,e.$nM=Ii=Ge([y],Ii);let ui=class{constructor(q,pe,Ne){this.session=q,this.threadId=pe,this.frameId=Ne}};e.$oM=ui,e.$oM=ui=Ge([y],ui);let hi=class{constructor(q,pe){this.session=q,this.threadId=pe}};e.$pM=hi,e.$pM=hi=Ge([y],hi);let dt=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$qM=dt,e.$qM=dt=Ge([y],dt);var Ji;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let ei=class{constructor(q,pe){this.range=q,this.text=pe}};e.$rM=ei,e.$rM=ei=Ge([y],ei);let oi=class{constructor(q,pe,Ne=!0){this.range=q,this.variableName=pe,this.caseSensitiveLookup=Ne}};e.$sM=oi,e.$sM=oi=Ge([y],oi);let bi=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$tM=bi,e.$tM=bi=Ge([y],bi);let Pi=class{constructor(q,pe){this.frameId=q,this.stoppedLocation=pe}};e.$uM=Pi,e.$uM=Pi=Ge([y],Pi);var Qi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Li=b=class extends Error{static FileExists(q){return new b(q,p.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(q){return new b(q,p.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(q){return new b(q,p.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(q){return new b(q,p.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(q){return new b(q,p.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(q){return new b(q,p.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(q,pe=p.FileSystemProviderErrorCode.Unknown,Ne){super(E.URI.isUri(q)?q.toString(!0):q),this.code=Ne?.name??"Unknown",(0,p.$Gk)(this,pe),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$vM=Li,e.$vM=Li=b=Ge([y],Li);let pi=class{constructor(q,pe,Ne){this.start=q,this.end=pe,this.kind=Ne}};e.$wM=pi,e.$wM=pi=Ge([y],pi);var Zi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Zi||(e.FoldingRangeKind=Zi={}));var Ai;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var di;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(di||(e.CommentMode=di={}));var Xi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var vi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Ri{constructor(q,pe=[]){this.tokenTypes=q,this.tokenModifiers=pe}}e.$xM=Ri;function un(H){return typeof H>"u"||(0,$.$Kf)(H)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let pe=0,Ne=q.tokenTypes.length;pe<Ne;pe++)this.k.set(q.tokenTypes[pe],pe);for(let pe=0,Ne=q.tokenModifiers.length;pe<Ne;pe++)this.l.set(q.tokenModifiers[pe],pe)}}push(q,pe,Ne,Ye,tt){if(typeof q=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Ye=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.o(q,pe,Ne,Ye,tt);if(O.isRange(q)&&typeof pe=="string"&&un(Ne))return this.n(q,pe,Ne);throw(0,F.$7)()}n(q,pe,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ye=q.start.line,tt=q.start.character,ut=q.end.character-q.start.character,mt=this.k.get(pe);let Vt=0;if(Ne)for(const xt of Ne){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(xt);Vt|=1<<ii>>>0}this.o(Ye,tt,ut,mt,Vt)}o(q,pe,Ne,Ye,tt){if(this.f&&(q<this.c||q===this.c&&pe<this.e)){this.f=!1;const Vt=this.g.length/5|0;let xt=0,ii=0;for(let ri=0;ri<Vt;ri++){let ci=this.g[5*ri],Hi=this.g[5*ri+1];ci===0?(ci=xt,Hi+=ii):ci+=xt,this.g[5*ri]=ci,this.g[5*ri+1]=Hi,xt=ci,ii=Hi}}let ut=q,mt=pe;this.f&&this.j>0&&(ut-=this.c,ut===0&&(mt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=mt,this.g[this.j++]=Ne,this.g[this.j++]=Ye,this.g[this.j++]=tt,this.c=q,this.e=pe}static q(q){const pe=[],Ne=q.length/5|0;for(let mt=0;mt<Ne;mt++)pe[mt]=mt;pe.sort((mt,Vt)=>{const xt=q[5*mt],ii=q[5*Vt];if(xt===ii){const ri=q[5*mt+1],ci=q[5*Vt+1];return ri-ci}return xt-ii});const Ye=new Uint32Array(q.length);let tt=0,ut=0;for(let mt=0;mt<Ne;mt++){const Vt=5*pe[mt],xt=q[Vt+0],ii=q[Vt+1],ri=q[Vt+2],ci=q[Vt+3],Hi=q[Vt+4],In=xt-tt,zn=In===0?ii-ut:ii,Gi=5*mt;Ye[Gi+0]=In,Ye[Gi+1]=zn,Ye[Gi+2]=ri,Ye[Gi+3]=ci,Ye[Gi+4]=Hi,tt=xt,ut=ii}return Ye}build(q){return this.f?new ai(new Uint32Array(this.g),q):new ai(Mi.q(this.g),q)}}e.$yM=Mi;class ai{constructor(q,pe){this.resultId=pe,this.data=q}}e.$zM=ai;class hn{constructor(q,pe,Ne){this.start=q,this.deleteCount=pe,this.data=Ne}}e.$AM=hn;class dn{constructor(q,pe){this.resultId=pe,this.edits=q}}e.$BM=dn;var Yi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));class Ni{constructor(q){this.name=q}}e.$CM=Ni;let Fi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$DM=Fi,e.$DM=Fi=Ge([y],Fi);var xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var wi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(wi||(e.InputBoxValidationSeverity=wi={}));var Ti;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Ti||(e.ExtensionKind=Ti={}));class fn{static validate(q){if(typeof q.badge=="string"){let pe=(0,v.$kf)(q.badge,0);if(pe<q.badge.length&&(pe+=(0,v.$kf)(q.badge,pe)),q.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!St.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,pe,Ne){this.badge=q,this.tooltip=pe,this.color=Ne}}e.$EM=fn;let yi=class{constructor(q){this.kind=q}};e.$FM=yi,e.$FM=yi=Ge([y],yi);var Oi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Oi||(e.ColorThemeKind=Oi={}));class ni{static isNotebookRange(q){return q instanceof ni?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,pe){if(q<0)throw(0,F.$7)("start must be positive");if(pe<0)throw(0,F.$7)("end must be positive");q<=pe?(this.c=q,this.e=pe):(this.c=pe,this.e=q)}with(q){let pe=this.c,Ne=this.e;return q.start!==void 0&&(pe=q.start),q.end!==void 0&&(Ne=q.end),pe===this.c&&Ne===this.e?this:new ni(pe,Ne)}}e.$GM=ni;class ki{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(pe=>ki.isNotebookCellData(pe))}static isNotebookCellData(q){return!0}constructor(q,pe,Ne,Ye,tt,ut,mt){this.kind=q,this.value=pe,this.languageId=Ne,this.mime=Ye,this.outputs=tt??[],this.metadata=ut,this.executionSummary=mt,ki.validate(this)}}e.$HM=ki;class gn{constructor(q){this.cells=q}}e.$IM=gn;class Yt{static isNotebookCellOutputItem(q){return q instanceof Yt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const pe={name:q.name,message:q.message,stack:q.stack};return Yt.json(pe,"application/vnd.code.notebook.error")}static stdout(q){return Yt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Yt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,pe="application/octet-stream"){return new Yt(q,pe)}static#e=new TextEncoder;static text(q,pe=A.$gs.text){const Ne=Yt.#e.encode(String(q));return new Yt(Ne,pe)}static json(q,pe="text/x-json"){const Ne=JSON.stringify(q,void 0,"	");return Yt.text(Ne,pe)}constructor(q,pe){this.data=q,this.mime=pe;const Ne=(0,A.$ks)(pe,!0);if(!Ne)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$JM=Yt;class fi{static isNotebookCellOutput(q){return q instanceof fi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,pe=!1){const Ne=new Set,Ye=new Set;for(let tt=0;tt<q.length;tt++){const ut=q[tt],mt=(0,A.$ks)(ut.mime);if(!Ne.has(mt)||(0,S.$iJ)(mt)){Ne.add(mt);continue}Ye.add(tt),pe&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ye.size===0?q:q.filter((tt,ut)=>!Ye.has(ut))}constructor(q,pe,Ne){this.items=fi.ensureUniqueMimeTypes(q,!0),typeof pe=="string"?(this.id=pe,this.metadata=Ne):(this.id=(0,R.$rg)(),this.metadata=pe??Ne)}}e.$KM=fi;var ji;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ji||(e.NotebookCellKind=ji={}));var We;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(We||(e.NotebookCellExecutionState=We={}));var ti;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ti||(e.NotebookCellStatusBarAlignment=ti={}));var Ui;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ui||(e.NotebookEditorRevealType=Ui={}));class ot{constructor(q,pe){this.text=q,this.alignment=pe}}e.$LM=ot;var bt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(bt||(e.NotebookControllerAffinity=bt={}));var _i;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class mn{constructor(q,pe=[]){this.uri=q,this.provides=(0,C.$3b)(pe)}}e.$MM=mn;class en{constructor(q){this.label=q}}e.$NM=en;var tn;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(tn||(e.NotebookVariablesRequestKind=tn={}));let gi=class{constructor(q,pe){this.label=q,this.timestamp=pe}};e.$OM=gi,e.$OM=gi=Ge([y],gi);var nn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(nn||(e.ExtensionMode=nn={}));var rn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(rn||(e.ExtensionRuntime=rn={}));var sn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(sn||(e.StandardTokenType=sn={}));class on{constructor(q,pe){this.ranges=q,this.wordPattern=pe}}e.$PM=on;class $n{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$QM=$n;var an;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var cn;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let zi=class{constructor(q=void 0,pe=void 0,Ne=void 0,Ye=!1){this.include=q,this.exclude=pe,this.profile=Ne,this.continuous=Ye}};e.$RM=zi,e.$RM=zi=Ge([y],zi);let Bi=m=class{static diff(q,pe,Ne){const Ye=new m(q);return Ye.expectedOutput=pe,Ye.actualOutput=Ne,Ye}constructor(q){this.message=q}};e.$SM=Bi,e.$SM=Bi=m=Ge([y],Bi);let Wi=class{constructor(q){this.id=q}};e.$TM=Wi,e.$TM=Wi=Ge([y],Wi);class Ei{constructor(q,pe){this.covered=q,this.total=pe}}e.$UM=Ei;const qi=H=>{if(H&&H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`)};class Vi{static fromDetails(q,pe){const Ne=new Ei(0,0),Ye=new Ei(0,0),tt=new Ei(0,0);for(const mt of pe)if("branches"in mt){Ne.total+=1,Ne.covered+=mt.executionCount>0?1:0;for(const Vt of mt.branches)Ye.total+=1,Ye.covered+=Vt.executionCount>0?1:0}else tt.total+=1,tt.covered+=mt.executionCount>0?1:0;const ut=new Vi(q,Ne,Ye.total>0?Ye:void 0,tt.total>0?tt:void 0);return ut.detailedCoverage=pe,ut}constructor(q,pe,Ne,Ye){this.uri=q,this.statementCoverage=pe,this.branchCoverage=Ne,this.functionCoverage=Ye,qi(pe),qi(Ne),qi(Ye)}}e.$VM=Vi;class bn{constructor(q,pe,Ne=[]){this.executionCount=q,this.location=pe,this.branches=Ne}}e.$WM=bn;class be{constructor(q,pe,Ne){this.executionCount=q,this.location=pe,this.label=Ne}}e.$XM=be;class ke{constructor(q,pe,Ne){this.name=q,this.executionCount=pe,this.location=Ne}}e.$YM=ke;var ze;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(ze||(e.ExternalUriOpenerPriority=ze={}));var lt;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(lt||(e.WorkspaceTrustState=lt={}));var pt;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(pt||(e.PortAutoForwardAction=pt={}));class Rt{constructor(q,pe,Ne,Ye,tt,ut){this.kind=q,this.name=pe,this.detail=Ne,this.uri=Ye,this.range=tt,this.selectionRange=ut}}e.$ZM=Rt;class ln{constructor(q){this.uri=q}}e.$1M=ln;class Pn{constructor(q,pe){this.original=q,this.modified=pe}}e.$2M=Pn;class Ln{constructor(q,pe,Ne,Ye){this.base=q,this.input1=pe,this.input2=Ne,this.result=Ye}}e.$3M=Ln;class An{constructor(q,pe){this.uri=q,this.viewType=pe}}e.$4M=An;class Rn{constructor(q){this.viewType=q}}e.$5M=Rn;class Mn{constructor(q,pe){this.uri=q,this.notebookType=pe}}e.$6M=Mn;class Nn{constructor(q,pe,Ne){this.original=q,this.modified=pe,this.notebookType=Ne}}e.$7M=Nn;class Fn{constructor(){}}e.$8M=Fn;class Tn{constructor(q,pe){this.uri=q,this.inputBoxUri=pe}}e.$9M=Tn;class On{constructor(q){this.providerId=q}}e.$0M=On;var pn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(vn||(e.ChatAgentCopyKind=vn={}));var wn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class jn{constructor(q,pe){this.label=q,this.values=pe}}e.$$M=jn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var kn;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(kn||(e.ChatMessageRole=kn={}));class Un{constructor(q,pe){this.role=q,this.content=pe}}e.$_M=Un;var En;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var Sn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}));var Cn;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}))}),define(Ee[311],Se([1,0,6,7]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$fL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,v,$){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(A);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(v,$)??[]}getRelatedInformation(A,v,$){return this.c.$getAiRelatedInformation(v,$)}registerRelatedInformationProvider(A,v,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiRelatedInformationProvider(E,v),new F.$hL(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Ngc=f}),define(Ee[312],Se([1,0,4,6,7,25]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class A{constructor(E){this.b=new Map,this.c=new C.$Wd,this.onDidChangeSessions=this.c.event,this.d=new v,this.f=new v,this.a=E.getProxy(F.$fL.MainThreadAuthentication)}async getSession(E,R,D,p={}){const k=P.$mm.toKey(E.identifier),S=[...D].sort().join(" ");return await this.d.getOrCreate(`${k} ${R} ${S}`,async()=>{await this.a.$ensureProvider(R);const c=E.displayName||E.name;return this.a.$getSession(R,D,k,c,p)})}async getSessions(E,R,D){const p=P.$mm.toKey(E.identifier),k=[...D].sort().join(" ");return await this.f.getOrCreate(`${p} ${k}`,async()=>{await this.a.$ensureProvider(R);const S=E.displayName||E.name;return this.a.$getSessions(R,D,p,S)})}async removeSession(E,R){const D=this.b.get(E);return D?D.provider.removeSession(R):this.a.$removeSession(E,R)}registerAuthenticationProvider(E,R,D,p){if(this.b.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this.b.set(E,{label:R,provider:D,options:p??{supportsMultipleAccounts:!1}});const k=D.onDidChangeSessions(S=>this.a.$sendDidChangeSessions(E,S));return this.a.$registerAuthenticationProvider(E,R,p?.supportsMultipleAccounts??!1),new f.$hL(()=>{k.dispose(),this.b.delete(E),this.a.$unregisterAuthenticationProvider(E)})}$createSession(E,R,D){const p=this.b.get(E);if(p)return Promise.resolve(p.provider.createSession(R,D));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,R){const D=this.b.get(E);if(D)return Promise.resolve(D.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,R){const D=this.b.get(E);if(D)return Promise.resolve(D.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,R){return this.c.fire({provider:{id:E,label:R}}),Promise.resolve()}}e.$Ygc=A;class v{constructor(){this.a=new Map}getOrCreate(E,R){const D=this.a.get(E);if(D)return D;const p=R().finally(()=>this.a.delete(E));return this.a.set(E,p),p}}}),define(Ee[147],Se([1,0,2,6,7,5,20,13,19,12,17,26]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=void 0;let k=class{static{p=this}static{this.c=0}static{this.d=250}constructor(c,g){this.h=g,this.f=new Map,this.g=c.getProxy(F.$fL.MainThreadDecorations)}registerFileDecorationProvider(c,g){const o=p.c++;this.f.set(o,{provider:c,extensionDescription:g}),this.g.$registerDecorationProvider(o,g.identifier.value);const i=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(o,null);return}const n=(0,$.$3b)(r);if(n.length<=p.d){this.g.$onDidChange(o,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,n.length);const a=n.map(s=>({uri:s,rank:(0,E.$Qe)(s.path,"/")})),t=(0,$.$zb)(a,(s,d)=>s.rank-d.rank||(0,E.$6e)(s.uri.path,d.uri.path)),h=[];e:for(const s of t){let d;for(const l of s){const u=(0,R.$mc)(l.uri.path);if(d!==u&&(d=u,h.push(l.uri)>=p.d))break e}}this.g.$onDidChange(o,h)});return new f.$hL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(c,g,o){if(!this.f.has(c))return Object.create(null);const i=Object.create(null),{provider:r,extensionDescription:n}=this.f.get(c);return await Promise.all(g.map(async a=>{try{const{uri:t,id:h}=a,s=await Promise.resolve(r.provideFileDecoration(C.URI.revive(t),o));if(!s)return;try{f.$EM.validate(s),s.badge&&typeof s.badge!="string"&&(0,D.$KF)(n,"codiconDecoration"),i[h]=[s.propagate,s.tooltip,s.badge,s.color]}catch(d){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${d}`)}}catch(t){this.h.error(t)}})),i}};e.$Xhc=k,e.$Xhc=k=p=Ge([qe(0,A.$kN),qe(1,v.$oj)],k),e.$Yhc=(0,P.$7h)("IExtHostDecorations")}),define(Ee[313],Se([1,0,14,2,7,6,16,21,12]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class E{static{this.a=0}constructor(D,p,k){this.d=p,this.e=k,this.b=new Map,this.c=D.getProxy(P.$fL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,p){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const k=E.a++;this.b.set(k,p),this.c.$registerTextContentProvider(k,D);let S;if(typeof p.onDidChange=="function"){let c;S=p.onDidChange(async g=>{if(g.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;c&&await c;const o=this.$provideTextDocumentContent(k,g).then(async i=>{if(!i&&typeof i!="string")return;const r=this.d.getDocument(g);if(!r)return;const n=(0,$.$1e)(i);if(!r.equalLines(n))return this.c.$onVirtualDocumentChange(g,i)}).catch(C.$1).finally(()=>{c===o&&(c=void 0)});c=o})}return new f.$hL(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(D,p){const k=this.b.get(D);return k?Promise.resolve(k.provideTextDocumentContent(F.URI.revive(p),v.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$1hc=E}),define(Ee[148],Se([1,0,61,16,12,176,126,7,19]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.$nN=e.$mN=void 0;const E=new Map;function R(S,c){c?E.set(S,c):E.delete(S)}e.$mN=R;function D(S){return E.get(S)}class p extends P.$mv{constructor(c,g,o,i,r,n,a,t){super(g,o,i,r),this.c=c,this.m=n,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$ub)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===F.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(g){return g?c.s(g):c.getText()},get eol(){return c.g===`
`?v.EndOfLine.LF:v.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(g){return c.t(g)},offsetAt(g){return c.u(g)},positionAt(g){return c.v(g)},validateRange(g){return c.w(g)},validatePosition(g){return c.x(g)},getWordRangeAtPosition(g,o){return c.y(g,o)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,C.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,C.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const g=this.w(c);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const o=this.g,i=g.start.line,r=g.end.line,n=[];n.push(this.f[i].substring(g.start.character));for(let a=i+1;a<r;a++)n.push(this.f[a]);return n.push(this.f[r].substring(0,g.end.character)),n.join(o)}t(c){let g;if(c instanceof v.$iL?g=c.line:typeof c=="number"&&(g=c),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new k(g,this.f[g],g===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const g=this.j.getIndexOf(c),o=this.f[g.index].length;return new v.$iL(g.index,Math.min(g.remainder,o))}w(c){if(!(c instanceof v.$jL))throw new Error("Invalid argument");const g=this.x(c.start),o=this.x(c.end);return g===c.start&&o===c.end?c:new v.$jL(g.line,g.character,o.line,o.character)}x(c){if(!(c instanceof v.$iL))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:g,character:o}=c,i=!1;if(g<0)g=0,o=0,i=!0;else if(g>=this.f.length)g=this.f.length-1,o=this.f[g].length,i=!0;else{const r=this.f[g].length;o<0?(o=0,i=!0):o>r&&(o=r,i=!0)}return i?new v.$iL(g,o):c}y(c,g){const o=this.x(c);if(!g)g=D(this.m);else if((0,f.$Ze)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const i=(0,A.$ys)(o.character+1,(0,A.$ws)(g),this.f[o.line],0);if(i)return new v.$jL(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$nN=p;class k{constructor(c,g,o){this.a=c,this.b=g,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new v.$jL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new v.$jL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$oN=k}),define(Ee[314],Se([1,0,6,7]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$fL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,v,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(A);if(!E)throw new Error("Embedding vector provider not found");const R=await E.provideEmbeddingVector(v,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,v,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiEmbeddingVectorProvider(v,E),new F.$hL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$3hc=f}),define(Ee[69],Se([1,0,6,32,7,22,5,20,59,3,11,23,16]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=e.$dhc=void 0;let S=k=class{constructor(g,o){this.b=new Map,this.c=new R.$dh,this.a=g.getProxy(C.$fL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(r){try{let n;const a=i.b.get(r.scheme);return a?(await i.a.$ensureActivation(r.scheme),n=await a.impl.stat(r)):n=await i.a.$stat(r),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===F.FilePermission.Readonly?1:void 0}}catch(n){k.e(n)}},async readDirectory(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readDirectory(r)).slice()):await i.a.$readdir(r)}catch(n){return k.e(n)}},async createDirectory(r){try{const n=i.b.get(r.scheme);return n&&!n.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(n.impl,n.extUri,r)):await i.a.$mkdir(r)}catch(n){return k.e(n)}},async readFile(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readFile(r)).slice()):(await i.a.$readFile(r)).buffer}catch(n){return k.e(n)}},async writeFile(r,n){try{const a=i.b.get(r.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(r)),await i.c.queueFor(r,()=>Promise.resolve(a.impl.writeFile(r,n,{create:!0,overwrite:!0})))):await i.a.$writeFile(r,P.$ke.wrap(n))}catch(a){return k.e(a)}},async delete(r,n){try{const a=i.b.get(r.scheme);return a&&!a.isReadonly&&!n?.useTrash?(await i.a.$ensureActivation(r.scheme),await a.impl.delete(r,{recursive:!1,...n})):await i.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(a){return k.e(a)}},async rename(r,n,a){try{return await i.a.$rename(r,n,{overwrite:!1,...a})}catch(t){return k.e(t)}},async copy(r,n,a){try{return await i.a.$copy(r,n,{overwrite:!1,...a})}catch(t){return k.e(t)}},isWritableFileSystem(r){const n=o.getCapabilities(r);if(typeof n=="number")return!(n&2048)}})}async d(g,o,i){const r=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await g.stat(i)).type&F.FileType.Directory))throw f.$vM.FileExists(`Unable to create folder '${i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(F.$Hk(n)!==F.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(o.basename(i)),i=o.dirname(i)}for(let n=r.length-1;n>=0;n--){i=o.joinPath(i,r[n]);try{await g.createDirectory(i)}catch(a){if(F.$Hk(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static e(g){if(g instanceof f.$vM)throw g;if(g instanceof F.$Dk)switch(g.code){case F.FileSystemProviderErrorCode.FileExists:throw f.$vM.FileExists(g.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$vM.FileNotFound(g.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$vM.FileNotADirectory(g.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$vM.FileIsADirectory(g.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$vM.NoPermissions(g.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$vM.Unavailable(g.message);default:throw new f.$vM(g.message,g.name)}if(!(g instanceof Error))throw new f.$vM(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw f.$vM.Unavailable(g.message);switch(g.name){case F.FileSystemProviderErrorCode.FileExists:throw f.$vM.FileExists(g.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$vM.FileNotFound(g.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$vM.FileNotADirectory(g.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$vM.FileIsADirectory(g.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$vM.NoPermissions(g.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$vM.Unavailable(g.message);default:throw new f.$vM(g.message,g.name)}}addFileSystemProvider(g,o,i){return this.b.set(g,{impl:o,extUri:i?.isCaseSensitive?D.$yg:D.$Ag,isReadonly:!!i?.isReadonly}),(0,E.$Rc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??D.$yg}};e.$dhc=S,e.$dhc=S=k=Ge([qe(0,v.$kN),qe(1,$.$Qgc)],S),e.$ehc=(0,A.$7h)("IExtHostConsumerFileSystem")}),define(Ee[315],Se([1,0,6,7]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=void 0;class f{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(C.$fL.MainThreadIssueReporter)}async $getIssueReporterUri(A,v){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(A);if(!$)throw new Error("Issue request handler not found");const E=await $.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(A,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const E=await $.provideIssueData(v);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(A,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const E=await $.provideIssueTemplate(v);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(A,v){const $=A.identifier.value;return this.a.set($,v),this.c.$registerIssueUriRequestHandler($),new F.$hL(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(A,v){const $=A.identifier.value;return this.b.set($,v),this.c.$registerIssueDataProvider($),new F.$hL(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$hic=f}),define(Ee[94],Se([1,0,5,27,13,69,2]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=void 0,e.$fhc=(0,C.$7h)("IExtensionStoragePaths");let v=class{constructor(E,R,D){this.d=R,this.f=D,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(E){return A.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,R=await this.g(E);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(E){if(this.c)return A.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return A.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ghc=v,e.$ghc=v=Ge([qe(0,F.$AN),qe(1,f.$oj),qe(2,P.$ehc)],v)}),define(Ee[316],Se([1,0,7,20,4]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;let P=class{constructor(v){this.a=new C.$FM(C.ColorThemeKind.Dark),this.b=new f.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(v){let $;switch(v){case"light":$=C.ColorThemeKind.Light;break;case"hcDark":$=C.ColorThemeKind.HighContrast;break;case"hcLight":$=C.ColorThemeKind.HighContrastLight;break;default:$=C.ColorThemeKind.Dark}this.a=new C.$FM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Kic=P,e.$Kic=P=Ge([qe(0,F.$kN)],P)}),define(Ee[70],Se([1,0,21,4,3,220,5,13,89,6,27,20,7]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$yb=e.$0yb=e.TunnelDtoConverter=void 0;class k extends $.$Kv{}var S;(function(g){function o(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:r.protocol}}g.fromApiTunnel=o;function i(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==$.TunnelPrivacyId.ConstantPrivate&&r.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}g.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$0yb=(0,A.$7h)("IExtHostTunnelService");let c=class extends f.$Tc{constructor(o,i,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(E.$fL.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const r=await this.a.$openTunnel(i,o.displayName);if(r){const n=new k(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const r=this.u();return this.r.set(r,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,r),new p.$hL(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(o,i,r,n,a){const t=[];for(const s of o){const d=this.r.get(s);if(!d)return[];t.push(...await Promise.all(i.map(async l=>{let u;try{u=await d.provider.providePortAttributes({port:l,pid:r,commandLine:n},a)}catch{u=await d.provider.providePortAttributes(l,r,n,a)}return{providedAttributes:u,port:l}})))}const h=t.filter(s=>!!s.providedAttributes);return h.length>0?h.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,a)=>await o.provideTunnel(n,a,new C.$7d().token)??void 0;const r=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,f.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const r=o.tunnelFactory??(i?this.w(i):void 0);if(r){this.b=r;let n=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,f.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const r=this.g.get(o.host);r.has(o.port)&&(i&&r.get(o.port).disposeListener.dispose(),await r.get(o.port).tunnel.dispose(),r.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const n=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:n,disposeListener:a}),S.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(n=>this.f(n.host,n.port,n.detail??""))),r=o.filter((n,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(n=>n.port).join(", ")} to ${r.map(n=>n.port).join(", ")}`),r}};e.$$yb=c,e.$$yb=c=Ge([qe(0,D.$kN),qe(1,R.$AN),qe(2,v.$oj)],c)}),define(Ee[15],Se([1,0,19,22,165,74,80,28,160,56,101,24,18,2,29,83,135,141,139,118,67,90,290,26,7]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a,t,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$jN=e.$iN=e.MarkdownString=e.$hN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var d;(function(Me){function Te(ce){const{selectionStartLineNumber:Fe,selectionStartColumn:Be,positionLineNumber:xe,positionColumn:Ke}=ce,ct=new s.$iL(Fe-1,Be-1),wt=new s.$iL(xe-1,Ke-1);return new s.$kL(ct,wt)}Me.to=Te;function De(ce){const{anchor:Fe,active:Be}=ce;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Me.from=De})(d||(e.Selection=d={}));var l;(function(Me){function Te(ce){if(!ce)return;const{start:Fe,end:Be}=ce;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Me.from=Te;function De(ce){if(!ce)return;const{startLineNumber:Fe,startColumn:Be,endLineNumber:xe,endColumn:Ke}=ce;return new s.$jL(Fe-1,Be-1,xe-1,Ke-1)}Me.to=De})(l||(e.Range=l={}));var u;(function(Me){function Te(De){return new s.$tL(k.URI.revive(De.uri),l.to(De.range))}Me.to=Te})(u||(e.Location=u={}));var w;(function(Me){function Te(De){switch(De){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Me.to=Te})(w||(e.TokenType=w={}));var I;(function(Me){function Te(ce){return new s.$iL(ce.lineNumber-1,ce.column-1)}Me.to=Te;function De(ce){return{lineNumber:ce.line+1,column:ce.character+1}}Me.from=De})(I||(e.Position=I={}));var b;(function(Me){function Te(Fe,Be,xe){return(0,C.$Hb)((0,C.$3b)(Fe).map(Ke=>De(Ke,Be,xe)))}Me.from=Te;function De(Fe,Be,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ce(Fe.scheme,Be),pattern:se.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:xe?.isBuiltin}}function ce(Fe,Be){return Be&&typeof Fe=="string"?Be.transformOutgoingScheme(Fe):Fe}})(b||(e.DocumentSelector=b={}));var m;(function(Me){function Te(ce){switch(ce){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function De(ce){switch(ce){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Me.to=De})(m||(e.DiagnosticTag=m={}));var y;(function(Me){function Te(ce){let Fe;return ce.code&&((0,p.$Jf)(ce.code)||(0,p.$Nf)(ce.code)?Fe=String(ce.code):Fe={value:String(ce.code.value),target:ce.code.target}),{...l.from(ce.range),message:ce.message,source:ce.source,code:Fe,severity:N.from(ce.severity),relatedInformation:ce.relatedInformation&&ce.relatedInformation.map(L.from),tags:Array.isArray(ce.tags)?(0,C.$Hb)(ce.tags.map(m.from)):void 0}}Me.from=Te;function De(ce){const Fe=new s.$vL(l.to(ce),ce.message,N.to(ce.severity));return Fe.source=ce.source,Fe.code=(0,p.$Jf)(ce.code)?ce.code:ce.code?.value,Fe.relatedInformation=ce.relatedInformation&&ce.relatedInformation.map(L.to),Fe.tags=ce.tags&&(0,C.$Hb)(ce.tags.map(m.to)),Fe}Me.to=De})(y||(e.Diagnostic=y={}));var L;(function(Me){function Te(ce){return{...l.from(ce.location.range),message:ce.message,resource:ce.location.uri}}Me.from=Te;function De(ce){return new s.$uL(new s.$tL(ce.resource,l.to(ce)),ce.message)}Me.to=De})(L||(e.DiagnosticRelatedInformation=L={}));var N;(function(Me){function Te(ce){switch(ce){case s.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Me.from=Te;function De(ce){switch(ce){case g.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Me.to=De})(N||(e.DiagnosticSeverity=N={}));var U;(function(Me){function Te(ce){return typeof ce=="number"&&ce>=s.ViewColumn.One?ce-1:ce===s.ViewColumn.Beside?t.$fD:t.$eD}Me.from=Te;function De(ce){if(typeof ce=="number"&&ce>=0)return ce+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=De})(U||(e.ViewColumn=U={}));function T(Me){return typeof Me.range<"u"}function O(Me){return Me.length===0?!0:!!T(Me[0])}e.$hN=O;var M;(function(Me){function Te(Ke){return Ke.map(Me.from)}Me.fromMany=Te;function De(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function ce(Ke){let ct;if(De(Ke)){const{language:Ct,value:vt}=Ke;ct={value:"```"+Ct+`
`+vt+"\n```\n"}}else s.$IL.isMarkdownString(Ke)?ct={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ct={value:Ke}:ct={value:""};const wt=Object.create(null);ct.uris=wt;const Kt=Ct=>{try{let vt=k.URI.parse(Ct,!0);vt=vt.with({query:Fe(vt.query,wt)}),wt[Ct]=vt}catch{}return""},St=new $.marked.Renderer;return St.link=Kt,St.image=Ct=>typeof Ct=="string"?Kt(A.$qk(Ct).href):"",(0,$.marked)(ct.value,{renderer:St}),ct}Me.from=ce;function Fe(Ke,ct){if(!Ke)return Ke;let wt;try{wt=(0,E.$Ch)(Ke)}catch{}if(!wt)return Ke;let Kt=!1;return wt=(0,D.$yn)(wt,St=>{if(k.URI.isUri(St)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Ct]=St,Kt=!0,Ct}else return}),Kt?JSON.stringify(wt):Ke}function Be(Ke){const ct=new s.$IL(Ke.value,Ke.supportThemeIcons);return ct.isTrusted=Ke.isTrusted,ct.supportHtml=Ke.supportHtml,ct.baseUri=Ke.baseUri?k.URI.from(Ke.baseUri):void 0,ct}Me.to=Be;function xe(Ke){if(Ke)return typeof Ke=="string"?Ke:Me.from(Ke)}Me.fromStrict=xe})(M||(e.MarkdownString=M={}));function j(Me){return O(Me)?Me.map(Te=>({range:l.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?M.fromMany(Te.hoverMessage):Te.hoverMessage?M.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:l.from(Te)}))}e.$iN=j;function z(Me){return typeof Me>"u"?Me:typeof Me=="string"?k.URI.file(Me):Me}e.$jN=z;var J;(function(Me){function Te(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?z(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Me.from=Te})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var le;(function(Me){function Te(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?z(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?J.from(De.before):void 0,after:De.after?J.from(De.after):void 0}}Me.from=Te})(le||(e.ThemableDecorationRenderOptions=le={}));var Y;(function(Me){function Te(De){if(typeof De>"u")return De;switch(De){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(Y||(e.DecorationRangeBehavior=Y={}));var Q;(function(Me){function Te(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?Y.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?le.from(De.light):void 0,dark:De.dark?le.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?z(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?J.from(De.before):void 0,after:De.after?J.from(De.after):void 0}}Me.from=Te})(Q||(e.DecorationRenderOptions=Q={}));var X;(function(Me){function Te(ce){return{text:ce.newText,eol:ce.newEol&&Pe.from(ce.newEol),range:l.from(ce.range)}}Me.from=Te;function De(ce){const Fe=new s.$oL(l.to(ce.range),ce.text);return Fe.newEol=typeof ce.eol>"u"?void 0:Pe.to(ce.eol),Fe}Me.to=De})(X||(e.TextEdit=X={}));var ue;(function(Me){function Te(ce,Fe){const Be={edits:[]};if(ce instanceof s.$rL){const xe=new v.$Bc;for(const Ke of ce._allEntries())Ke._type===1&&k.URI.isUri(Ke.to)&&Ke.from===void 0&&xe.add(Ke.to);for(const Ke of ce._allEntries())if(Ke._type===1){let ct;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ct={type:"base64",value:(0,F.$Ee)(F.$ke.wrap(Ke.options.contents))}:ct={type:"dataTransferItem",id:Ke.options.contents._itemId}),Be.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ct},metadata:Ke.metadata})}else Ke._type===2?Be.edits.push({resource:Ke.uri,textEdit:X.from(Ke.edit),versionId:xe.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Be.edits.push({resource:Ke.uri,textEdit:{range:l.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:xe.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Be.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Dt.from)}})}return Be}Me.from=Te;function De(ce){const Fe=new s.$rL,Be=new v.$Ac;for(const xe of ce.edits)if(xe.textEdit){const Ke=xe,ct=k.URI.revive(Ke.resource),wt=l.to(Ke.textEdit.range),Kt=Ke.textEdit.text,St=Ke.textEdit.insertAsSnippet;let Ct;St?Ct=s.$qL.replace(wt,new s.$sL(Kt)):Ct=s.$oL.replace(wt,Kt);const vt=Be.get(ct);vt?vt.push(Ct):Be.set(ct,[Ct])}else Fe.renameFile(k.URI.revive(xe.oldResource),k.URI.revive(xe.newResource),xe.options);for(const[xe,Ke]of Be)Fe.set(xe,Ke);return Fe}Me.to=De})(ue||(e.WorkspaceEdit=ue={}));var ne;(function(Me){const Te=Object.create(null);Te[s.SymbolKind.File]=0,Te[s.SymbolKind.Module]=1,Te[s.SymbolKind.Namespace]=2,Te[s.SymbolKind.Package]=3,Te[s.SymbolKind.Class]=4,Te[s.SymbolKind.Method]=5,Te[s.SymbolKind.Property]=6,Te[s.SymbolKind.Field]=7,Te[s.SymbolKind.Constructor]=8,Te[s.SymbolKind.Enum]=9,Te[s.SymbolKind.Interface]=10,Te[s.SymbolKind.Function]=11,Te[s.SymbolKind.Variable]=12,Te[s.SymbolKind.Constant]=13,Te[s.SymbolKind.String]=14,Te[s.SymbolKind.Number]=15,Te[s.SymbolKind.Boolean]=16,Te[s.SymbolKind.Array]=17,Te[s.SymbolKind.Object]=18,Te[s.SymbolKind.Key]=19,Te[s.SymbolKind.Null]=20,Te[s.SymbolKind.EnumMember]=21,Te[s.SymbolKind.Struct]=22,Te[s.SymbolKind.Event]=23,Te[s.SymbolKind.Operator]=24,Te[s.SymbolKind.TypeParameter]=25;function De(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=De;function ce(Fe){for(const Be in Te)if(Te[Be]===Fe)return Number(Be);return s.SymbolKind.Property}Me.to=ce})(ne||(e.SymbolKind=ne={}));var $e;(function(Me){function Te(ce){switch(ce){case s.SymbolTag.Deprecated:return 1}}Me.from=Te;function De(ce){switch(ce){case 1:return s.SymbolTag.Deprecated}}Me.to=De})($e||(e.SymbolTag=$e={}));var oe;(function(Me){function Te(ce){return{name:ce.name,kind:ne.from(ce.kind),tags:ce.tags&&ce.tags.map($e.from),containerName:ce.containerName,location:de.from(ce.location)}}Me.from=Te;function De(ce){const Fe=new s.$zL(ce.name,ne.to(ce.kind),ce.containerName,de.to(ce.location));return Fe.tags=ce.tags&&ce.tags.map($e.to),Fe}Me.to=De})(oe||(e.WorkspaceSymbol=oe={}));var K;(function(Me){function Te(ce){const Fe={name:ce.name||"!!MISSING: name!!",detail:ce.detail,range:l.from(ce.range),selectionRange:l.from(ce.selectionRange),kind:ne.from(ce.kind),tags:ce.tags?.map($e.from)??[]};return ce.children&&(Fe.children=ce.children.map(Te)),Fe}Me.from=Te;function De(ce){const Fe=new s.$AL(ce.name,ce.detail,ne.to(ce.kind),l.to(ce.range),l.to(ce.selectionRange));return(0,C.$Lb)(ce.tags)&&(Fe.tags=ce.tags.map($e.to)),ce.children&&(Fe.children=ce.children.map(De)),Fe}Me.to=De})(K||(e.DocumentSymbol=K={}));var W;(function(Me){function Te(ce){const Fe=new s.$EL(ne.to(ce.kind),ce.name,ce.detail||"",k.URI.revive(ce.uri),l.to(ce.range),l.to(ce.selectionRange));return Fe._sessionId=ce._sessionId,Fe._itemId=ce._itemId,Fe}Me.to=Te;function De(ce,Fe,Be){if(Fe=Fe??ce._sessionId,Be=Be??ce._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,name:ce.name,detail:ce.detail,kind:ne.from(ce.kind),uri:ce.uri,range:l.from(ce.range),selectionRange:l.from(ce.selectionRange),tags:ce.tags?.map($e.from)}}Me.from=De})(W||(e.CallHierarchyItem=W={}));var ie;(function(Me){function Te(De){return new s.$FL(W.to(De.from),De.fromRanges.map(ce=>l.to(ce)))}Me.to=Te})(ie||(e.CallHierarchyIncomingCall=ie={}));var ye;(function(Me){function Te(De){return new s.$GL(W.to(De.to),De.fromRanges.map(ce=>l.to(ce)))}Me.to=Te})(ye||(e.CallHierarchyOutgoingCall=ye={}));var de;(function(Me){function Te(ce){return{range:ce.range&&l.from(ce.range),uri:ce.uri}}Me.from=Te;function De(ce){return new s.$tL(k.URI.revive(ce.uri),l.to(ce.range))}Me.to=De})(de||(e.location=de={}));var fe;(function(Me){function Te(ce){const Fe=ce,Be=ce;return{originSelectionRange:Fe.originSelectionRange?l.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Be.uri,range:l.from(Fe.targetRange?Fe.targetRange:Be.range),targetSelectionRange:Fe.targetSelectionRange?l.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function De(ce){return{targetUri:k.URI.revive(ce.uri),targetRange:l.to(ce.range),targetSelectionRange:ce.targetSelectionRange?l.to(ce.targetSelectionRange):void 0,originSelectionRange:ce.originSelectionRange?l.to(ce.originSelectionRange):void 0}}Me.to=De})(fe||(e.DefinitionLink=fe={}));var _;(function(Me){function Te(ce){return{range:l.from(ce.range),contents:M.fromMany(ce.contents)}}Me.from=Te;function De(ce){return new s.$wL(ce.contents.map(M.to),l.to(ce.range))}Me.to=De})(_||(e.Hover=_={}));var ee;(function(Me){function Te(ce){return{range:l.from(ce.range),expression:ce.expression}}Me.from=Te;function De(ce){return new s.$qM(l.to(ce.range),ce.expression)}Me.to=De})(ee||(e.EvaluatableExpression=ee={}));var G;(function(Me){function Te(ce){if(ce instanceof s.$rM)return{type:"text",range:l.from(ce.range),text:ce.text};if(ce instanceof s.$sM)return{type:"variable",range:l.from(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};if(ce instanceof s.$tM)return{type:"expression",range:l.from(ce.range),expression:ce.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function De(ce){switch(ce.type){case"text":return{range:l.to(ce.range),text:ce.text};case"variable":return{range:l.to(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};case"expression":return{range:l.to(ce.range),expression:ce.expression}}}Me.to=De})(G||(e.InlineValue=G={}));var x;(function(Me){function Te(ce){return{frameId:ce.frameId,stoppedLocation:l.from(ce.stoppedLocation)}}Me.from=Te;function De(ce){return new s.$uM(ce.frameId,l.to(ce.stoppedLocation))}Me.to=De})(x||(e.InlineValueContext=x={}));var me;(function(Me){function Te(ce){return{range:l.from(ce.range),kind:ce.kind}}Me.from=Te;function De(ce){return new s.$xL(l.to(ce.range),ce.kind)}Me.to=De})(me||(e.DocumentHighlight=me={}));var we;(function(Me){function Te(ce){return{uri:ce.uri,highlights:ce.highlights.map(me.from)}}Me.from=Te;function De(ce){return new s.$yL(k.URI.revive(ce.uri),ce.highlights.map(me.to))}Me.to=De})(we||(e.MultiDocumentHighlight=we={}));var Ae;(function(Me){function Te(De){switch(De){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Me.to=Te})(Ae||(e.CompletionTriggerKind=Ae={}));var ve;(function(Me){function Te(De){return{triggerKind:Ae.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Me.to=Te})(ve||(e.CompletionContext=ve={}));var Ie;(function(Me){function Te(ce){switch(ce){case s.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function De(ce){switch(ce){case 1:return s.CompletionItemTag.Deprecated}}Me.to=De})(Ie||(e.CompletionItemTag=Ie={}));var B;(function(Me){const Te=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function De(Be){return Te.get(Be)??9}Me.from=De;const ce=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(Be){return ce.get(Be)??s.CompletionItemKind.Property}Me.to=Fe})(B||(e.CompletionItemKind=B={}));var Z;(function(Me){function Te(De,ce){const Fe=new s.$OL(De.label);return Fe.insertText=De.insertText,Fe.kind=B.to(De.kind),Fe.tags=De.tags?.map(Ie.to),Fe.detail=De.detail,Fe.documentation=A.$kk(De.documentation)?M.to(De.documentation):De.documentation,Fe.sortText=De.sortText,Fe.filterText=De.filterText,Fe.preselect=De.preselect,Fe.commitCharacters=De.commitCharacters,S.$Vs.isIRange(De.range)?Fe.range=l.to(De.range):typeof De.range=="object"&&(Fe.range={inserting:l.to(De.range.insert),replacing:l.to(De.range.replace)}),Fe.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Fe.insertText=new s.$sL(De.insertText):(Fe.insertText=De.insertText,Fe.textEdit=Fe.range instanceof s.$jL?new s.$oL(Fe.range,Fe.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Fe.additionalTextEdits=De.additionalTextEdits.map(Be=>X.to(Be))),Fe.command=ce&&De.command?ce.fromInternal(De.command):void 0,Fe}Me.to=Te})(Z||(e.CompletionItem=Z={}));var te;(function(Me){function Te(ce){if(typeof ce.label!="string"&&!Array.isArray(ce.label))throw new TypeError("Invalid label");return{label:ce.label,documentation:M.fromStrict(ce.documentation)}}Me.from=Te;function De(ce){return{label:ce.label,documentation:A.$kk(ce.documentation)?M.to(ce.documentation):ce.documentation}}Me.to=De})(te||(e.ParameterInformation=te={}));var V;(function(Me){function Te(ce){return{label:ce.label,documentation:M.fromStrict(ce.documentation),parameters:Array.isArray(ce.parameters)?ce.parameters.map(te.from):[],activeParameter:ce.activeParameter}}Me.from=Te;function De(ce){return{label:ce.label,documentation:A.$kk(ce.documentation)?M.to(ce.documentation):ce.documentation,parameters:Array.isArray(ce.parameters)?ce.parameters.map(te.to):[],activeParameter:ce.activeParameter}}Me.to=De})(V||(e.SignatureInformation=V={}));var ae;(function(Me){function Te(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(V.from):[]}}Me.from=Te;function De(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(V.to):[]}}Me.to=De})(ae||(e.SignatureHelp=ae={}));var he;(function(Me){function Te(De,ce){const Fe=new s.$NL(I.to(ce.position),typeof ce.label=="string"?ce.label:ce.label.map(Re.to.bind(void 0,De)),ce.kind&&je.to(ce.kind));return Fe.textEdits=ce.textEdits&&ce.textEdits.map(X.to),Fe.tooltip=A.$kk(ce.tooltip)?M.to(ce.tooltip):ce.tooltip,Fe.paddingLeft=ce.paddingLeft,Fe.paddingRight=ce.paddingRight,Fe}Me.to=Te})(he||(e.InlayHint=he={}));var Re;(function(Me){function Te(De,ce){const Fe=new s.$ML(ce.label);return Fe.tooltip=A.$kk(ce.tooltip)?M.to(ce.tooltip):ce.tooltip,c.Command.is(ce.command)&&(Fe.command=De.fromInternal(ce.command)),ce.location&&(Fe.location=de.to(ce.location)),Fe}Me.to=Te})(Re||(e.InlayHintLabelPart=Re={}));var je;(function(Me){function Te(ce){return ce}Me.from=Te;function De(ce){return ce}Me.to=De})(je||(e.InlayHintKind=je={}));var He;(function(Me){function Te(ce){return{range:l.from(ce.range),url:ce.target,tooltip:ce.tooltip}}Me.from=Te;function De(ce){let Fe;if(ce.url)try{Fe=typeof ce.url=="string"?k.URI.parse(ce.url,!0):k.URI.revive(ce.url)}catch{}return new s.$TL(l.to(ce.range),Fe)}Me.to=De})(He||(e.DocumentLink=He={}));var Qe;(function(Me){function Te(ce){const Fe=new s.$WL(ce.label);return ce.textEdit&&(Fe.textEdit=X.to(ce.textEdit)),ce.additionalTextEdits&&(Fe.additionalTextEdits=ce.additionalTextEdits.map(Be=>X.to(Be))),Fe}Me.to=Te;function De(ce){return{label:ce.label,textEdit:ce.textEdit?X.from(ce.textEdit):void 0,additionalTextEdits:ce.additionalTextEdits?ce.additionalTextEdits.map(Fe=>X.from(Fe)):void 0}}Me.from=De})(Qe||(e.ColorPresentation=Qe={}));var _e;(function(Me){function Te(ce){return new s.$UL(ce[0],ce[1],ce[2],ce[3])}Me.to=Te;function De(ce){return[ce.red,ce.green,ce.blue,ce.alpha]}Me.from=De})(_e||(e.Color=_e={}));var at;(function(Me){function Te(ce){return{range:l.from(ce.range)}}Me.from=Te;function De(ce){return new s.$DL(l.to(ce.range))}Me.to=De})(at||(e.SelectionRange=at={}));var st;(function(Me){function Te(De){switch(De){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Me.to=Te})(st||(e.TextDocumentSaveReason=st={}));var rt;(function(Me){function Te(ce){switch(ce){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function De(ce){switch(ce){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Me.to=De})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Pe;(function(Me){function Te(ce){if(ce===s.EndOfLine.CRLF)return 1;if(ce===s.EndOfLine.LF)return 0}Me.from=Te;function De(ce){if(ce===1)return s.EndOfLine.CRLF;if(ce===0)return s.EndOfLine.LF}Me.to=De})(Pe||(e.EndOfLine=Pe={}));var Ue;(function(Me){function Te(De){if(typeof De=="object")return De.viewId;switch(De){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ue||(e.ProgressLocation=Ue={}));var Le;(function(Me){function Te(ce){const Fe={start:ce.start+1,end:ce.end+1};return ce.kind&&(Fe.kind=Ze.from(ce.kind)),Fe}Me.from=Te;function De(ce){const Fe={start:ce.start-1,end:ce.end-1};return ce.kind&&(Fe.kind=Ze.to(ce.kind)),Fe}Me.to=De})(Le||(e.FoldingRange=Le={}));var Ze;(function(Me){function Te(ce){if(ce)switch(ce){case s.FoldingRangeKind.Comment:return c.$Lt.Comment;case s.FoldingRangeKind.Imports:return c.$Lt.Imports;case s.FoldingRangeKind.Region:return c.$Lt.Region}}Me.from=Te;function De(ce){if(ce)switch(ce.value){case c.$Lt.Comment.value:return s.FoldingRangeKind.Comment;case c.$Lt.Imports.value:return s.FoldingRangeKind.Imports;case c.$Lt.Region.value:return s.FoldingRangeKind.Region}}Me.to=De})(Ze||(e.FoldingRangeKind=Ze={}));var re;(function(Me){function Te(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?l.from(De.selection):void 0,override:typeof De.override=="boolean"?i.$HE.id:void 0}}Me.from=Te})(re||(e.TextEditorOpenOptions=re={}));var se;(function(Me){function Te(Be){return Be instanceof s.$eM?Be.toJSON():typeof Be=="string"?Be:De(Be)||ce(Be)?new s.$eM(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Me.from=Te;function De(Be){const xe=Be;return xe?k.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ce(Be){const xe=Be;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Fe(Be){return typeof Be=="string"?Be:new s.$eM(k.URI.revive(Be.baseUri),Be.pattern)}Me.to=Fe})(se||(e.GlobPattern=se={}));var Ce;(function(Me){function Te(De){if(De){if(Array.isArray(De))return De.map(Te);if(typeof De=="string")return De;{const ce=De;return{language:ce.language,scheme:ce.scheme,pattern:se.from(ce.pattern),exclusive:ce.exclusive,notebookType:ce.notebookType}}}else return}Me.from=Te})(Ce||(e.LanguageSelector=Ce={}));var Ve;(function(Me){function Te(ce){return!!ce&&typeof ce=="object"&&"documents"in ce&&Array.isArray(ce.documents)&&ce.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&k.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(xe=>xe instanceof s.$jL)))}Me.is=Te;function De(ce){return{documents:ce.documents.map(Fe=>Fe.map(Be=>({uri:k.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>l.from(xe))})))}}Me.from=De})(Ve||(e.MappedEditsContext=Ve={}));var Xe;(function(Me){function Te(ce){return{start:ce.start,end:ce.end}}Me.from=Te;function De(ce){return new s.$GM(ce.start,ce.end)}Me.to=De})(Xe||(e.NotebookRange=Xe={}));var it;(function(Me){function Te(ce){return{timing:typeof ce.runStartTime=="number"&&typeof ce.runEndTime=="number"?{startTime:ce.runStartTime,endTime:ce.runEndTime}:void 0,executionOrder:ce.executionOrder,success:ce.lastRunSuccess}}Me.to=Te;function De(ce){return{lastRunSuccess:ce.success,runStartTime:ce.timing?.startTime,runEndTime:ce.timing?.endTime,executionOrder:ce.executionOrder}}Me.from=De})(it||(e.NotebookCellExecutionSummary=it={}));var nt;(function(Me){function Te(De){if(De===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(De===r.NotebookCellExecutionState.Pending)return;if(De===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Me.to=Te})(nt||(e.NotebookCellExecutionState=nt={}));var Oe;(function(Me){function Te(ce){switch(ce){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Me.from=Te;function De(ce){switch(ce){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Me.to=De})(Oe||(e.NotebookCellKind=Oe={}));var yt;(function(Me){function Te(ce){const Fe={metadata:ce.metadata??Object.create(null),cells:[]};for(const Be of ce.cells)s.$HM.validate(Be),Fe.cells.push(Dt.from(Be));return Fe}Me.from=Te;function De(ce){const Fe=new s.$IM(ce.cells.map(Dt.to));return(0,p.$Wf)(ce.metadata)||(Fe.metadata=ce.metadata),Fe}Me.to=De})(yt||(e.NotebookData=yt={}));var Dt;(function(Me){function Te(ce){return{cellKind:Oe.from(ce.kind),language:ce.languageId,mime:ce.mime,source:ce.value,metadata:ce.metadata,internalMetadata:it.from(ce.executionSummary??{}),outputs:ce.outputs?ce.outputs.map(Tt.from):[]}}Me.from=Te;function De(ce){return new s.$HM(Oe.to(ce.cellKind),ce.source,ce.language,ce.mime,ce.outputs?ce.outputs.map(Tt.to):void 0,ce.metadata,ce.internalMetadata?it.to(ce.internalMetadata):void 0)}Me.to=De})(Dt||(e.NotebookCellData=Dt={}));var Ft;(function(Me){function Te(ce){return{mime:ce.mime,valueBytes:F.$ke.wrap(ce.data)}}Me.from=Te;function De(ce){return new s.$JM(ce.valueBytes.buffer,ce.mime)}Me.to=De})(Ft||(e.NotebookCellOutputItem=Ft={}));var Tt;(function(Me){function Te(ce){return{outputId:ce.id,items:ce.items.map(Ft.from),metadata:ce.metadata}}Me.from=Te;function De(ce){const Fe=ce.items.map(Ft.to);return new s.$KM(Fe,ce.outputId,ce.metadata)}Me.to=De})(Tt||(e.NotebookCellOutput=Tt={}));var kt;(function(Me){function Te(Fe){return ce(Fe)?{include:se.from(Fe.include)??void 0,exclude:se.from(Fe.exclude)??void 0}:se.from(Fe)??void 0}Me.from=Te;function De(Fe){return ce(Fe)?{include:se.to(Fe.include),exclude:se.to(Fe.exclude)}:se.to(Fe)}Me.to=De;function ce(Fe){const Be=Fe;return Be?!(0,p.$Sf)(Be.include)&&!(0,p.$Sf)(Be.exclude):!1}})(kt||(e.NotebookExclusiveDocumentPattern=kt={}));var Ht;(function(Me){function Te(De,ce,Fe){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ce.toInternal(Be,Fe),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Me.from=Te})(Ht||(e.NotebookStatusBarItem=Ht={}));var Ot;(function(Me){function Te(De,ce,Fe){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:ce.toInternal(Be,Fe),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Me.from=Te})(Ot||(e.NotebookKernelSourceAction=Ot={}));var Xt;(function(Me){function Te(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Me.from=Te})(Xt||(e.NotebookDocumentContentOptions=Xt={}));var qt;(function(Me){function Te(ce){return{uri:ce.uri,provides:ce.provides}}Me.from=Te;function De(ce){return new s.$MM(k.URI.revive(ce.uri),ce.provides)}Me.to=De})(qt||(e.NotebookRendererScript=qt={}));var zt;(function(Me){function Te(ce){return{message:M.fromStrict(ce.message)||"",type:0,expected:ce.expectedOutput,actual:ce.actualOutput,contextValue:ce.contextValue,location:ce.location&&{range:l.from(ce.location.range),uri:ce.location.uri}}}Me.from=Te;function De(ce){const Fe=new s.$SM(typeof ce.message=="string"?ce.message:M.to(ce.message));return Fe.actualOutput=ce.actual,Fe.expectedOutput=ce.expected,Fe.contextValue=ce.contextValue,Fe.location=ce.location?de.to(ce.location):void 0,Fe}Me.to=De})(zt||(e.TestMessage=zt={}));var et;(function(Me){Me.namespace=a.$bK,Me.denamespace=a.$cK})(et||(e.TestTag=et={}));var Gt;(function(Me){function Te(ce){const Fe=(0,o.$gN)(ce).controllerId;return{extId:n.$0J.fromExtHostTestItem(ce,Fe).toString(),label:ce.label,uri:k.URI.revive(ce.uri),busy:ce.busy,tags:ce.tags.map(Be=>et.namespace(Fe,Be.id)),range:S.$Vs.lift(l.from(ce.range)),description:ce.description||null,sortText:ce.sortText||null,error:ce.error&&M.fromStrict(ce.error)||null}}Me.from=Te;function De(ce){return{parent:void 0,error:void 0,id:n.$0J.fromString(ce.extId).localId,label:ce.label,uri:k.URI.revive(ce.uri),tags:(ce.tags||[]).map(Fe=>{const{tagId:Be}=et.denamespace(Fe);return new s.$TM(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(ce.range||void 0),canResolveChildren:!1,busy:ce.busy,description:ce.description||void 0,sortText:ce.sortText||void 0}}Me.toPlain=De})(Gt||(e.TestItem=Gt={})),function(Me){function Te(ce){return{id:ce.id}}Me.from=Te;function De(ce){return new s.$TM(ce.id)}Me.to=De}(et||(e.TestTag=et={}));var Jt;(function(Me){const Te=(ce,Fe)=>{const Be=[];for(const[Ke,ct]of Fe)n.$0J.compare(ct.item.extId,Ke)===2&&(Fe.delete(Ke),Be.push(ct));const xe={...Gt.toPlain(ce.item),parent:void 0,taskStates:ce.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ct=>ct.type===0).map(zt.to)})),children:Be.map(Ke=>Te(Ke,Fe))};for(const Ke of xe.children)Ke.parent=xe;return xe};function De(ce){const Fe=[],Be=new Map;for(const xe of ce.items){Be.set(xe.item.extId,xe);const Ke=n.$0J.root(xe.item.extId);ce.request.targets.some(ct=>ct.controllerId===Ke&&ct.testIds.includes(xe.item.extId))&&Fe.push(xe)}return{completedAt:ce.completedAt,results:Fe.map(xe=>Te(xe,Be))}}Me.to=De})(Jt||(e.TestResults=Jt={}));var ht;(function(Me){function Te(Be){return{covered:Be.covered,total:Be.total}}function De(Be){return"line"in Be?I.from(Be):l.from(Be)}function ce(Be){return"branches"in Be?{count:Be.executionCount,location:De(Be.location),type:1,branches:Be.branches.length?Be.branches.map(xe=>({count:xe.executionCount,location:xe.location&&De(xe.location),label:xe.label})):void 0}:{type:0,name:Be.name,count:Be.executionCount,location:De(Be.location)}}Me.fromDetailed=ce;function Fe(Be){return{uri:Be.uri,statement:Te(Be.statementCoverage),branch:Be.branchCoverage&&Te(Be.branchCoverage),function:Be.functionCoverage&&Te(Be.functionCoverage),details:Be.detailedCoverage?.map(ce)}}Me.fromFile=Fe})(ht||(e.TestCoverage=ht={}));var $t;(function(Me){function Te(De){switch(De){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Me.to=Te})($t||(e.CodeActionTriggerKind=$t={}));var Bt;(function(Me){function Te(ce){const Fe=new s.$ZM(ne.to(ce.kind),ce.name,ce.detail||"",k.URI.revive(ce.uri),l.to(ce.range),l.to(ce.selectionRange));return Fe._sessionId=ce._sessionId,Fe._itemId=ce._itemId,Fe}Me.to=Te;function De(ce,Fe,Be){if(Fe=Fe??ce._sessionId,Be=Be??ce._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,kind:ne.from(ce.kind),name:ce.name,detail:ce.detail??"",uri:ce.uri,range:l.from(ce.range),selectionRange:l.from(ce.selectionRange),tags:ce.tags?.map($e.from)}}Me.from=De})(Bt||(e.TypeHierarchyItem=Bt={}));var Qt;(function(Me){function Te(De){if(De)return{value:De.value,tooltip:De.tooltip}}Me.from=Te})(Qt||(e.ViewBadge=Qt={}));var Et;(function(Me){function Te(Be,xe,Ke){const ct=xe.fileData;return ct?new s.$0L(new s.$$L(ct.name,k.URI.revive(ct.uri),ct.id,(0,P.$db)(()=>Ke(ct.id)))):Be===R.$gs.uriList&&xe.uriListData?new s.$9L(Fe(xe.uriListData)):new s.$9L(xe.asString)}Me.to=Te;async function De(Be,xe){const Ke=await xe.asString();if(Be===R.$gs.uriList)return{asString:Ke,fileData:void 0,uriListData:ce(Ke)};const ct=xe.asFile();return{asString:Ke,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Me.from=De;function ce(Be){return f.$st.split(Be).map(xe=>{if(xe.startsWith("#"))return xe;try{return k.URI.parse(xe)}catch{}return xe})}function Fe(Be){return f.$st.create(Be.map(xe=>typeof xe=="string"?xe:k.URI.revive(xe)))}})(Et||(e.DataTransferItem=Et={}));var ft;(function(Me){function Te(ce,Fe){const Be=ce.items.map(([xe,Ke])=>[xe,Et.to(xe,Ke,Fe)]);return new s.$_L(Be)}Me.toDataTransfer=Te;async function De(ce){const Fe={items:[]},Be=[];for(const[xe,Ke]of ce)Be.push((async()=>{Fe.items.push([xe,await Et.from(xe,Ke)])})());return await Promise.all(Be),Fe}Me.from=De})(ft||(e.DataTransfer=ft={}));var It;(function(Me){function Te(De){return{kind:"reply",message:De.message,title:De.title,tooltip:De.tooltip}}Me.from=Te})(It||(e.ChatReplyFollowup=It={}));var _t;(function(Me){function Te(De){return typeof De=="string"?{title:De,message:De,kind:"reply"}:"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",when:De.when??"",args:De.args}:It.from(De)}Me.from=Te})(_t||(e.ChatFollowup=_t={}));var Lt;(function(Me){function Te(ce){const Fe=new s.$_M(Je.to(ce.role),ce.content);return Fe.name=ce.name,Fe}Me.to=Te;function De(ce){return{role:Je.from(ce.role),content:ce.content,name:ce.name}}Me.from=De})(Lt||(e.ChatMessage=Lt={}));var Je;(function(Me){function Te(ce){switch(ce){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Me.to=Te;function De(ce){switch(ce){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Me.from=De})(Je||(e.ChatMessageRole=Je={}));var Mt;(function(Me){function Te(Fe){const Be={};for(const xe of Object.keys(Fe))Be[xe]=Fe[xe].map(Me.to);return Be}Me.objectTo=Te;function De(Fe){return{level:jt.to(Fe.level),kind:Fe.kind,value:(0,k.$vc)(Fe.value)?k.URI.revive(Fe.value):Fe.value,description:Fe.description}}Me.to=De;function ce(Fe){return{level:jt.from(Fe.level),kind:Fe.kind,value:Fe.value,description:Fe.description}}Me.from=ce})(Mt||(e.ChatVariable=Mt={}));var jt;(function(Me){function Te(ce){switch(ce){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Me.to=Te;function De(ce){switch(ce){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Me.from=De})(jt||(e.ChatVariableLevel=jt={}));var Zt;(function(Me){function Te(De){switch(De){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Te})(Zt||(e.InteractiveEditorResponseFeedbackKind=Zt={}));var gt;(function(Me){function Te(Fe,Be){return"markdownContent"in Be?((0,h.$KF)(Fe,"chatAgents2Additions"),{content:M.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,h.$KF)(Fe,"chatAgents2Additions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,h.$KF)(Fe,"chatAgents2Additions"),{content:M.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(xe=>({uri:xe.uri,version:xe.version,ranges:xe.ranges.map(Ke=>l.from(Ke))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:l.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:l.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"agentName"in Be?((0,h.$KF)(Fe,"chatAgents2Additions"),{agentName:Be.agentName,command:Be.command,kind:"agentDetection"}):"treeData"in Be?{treeData:Be.treeData,kind:"treeData"}:"message"in Be?{content:M.from(Be.message),kind:"progressMessage"}:void 0}Me.from=Te;function De(Fe){switch(Fe.kind){case"markdownContent":case"inlineReference":case"treeData":return Me.to(Fe);case"content":return{content:Fe.content};case"usedContext":return{documents:Fe.documents.map(Be=>({uri:k.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>l.to(xe))}))};case"reference":return{reference:(0,k.$vc)(Fe.reference)?k.URI.revive(Fe.reference):u.to(Fe.reference)};case"agentDetection":return;case"progressMessage":return{message:Fe.content.value};case"vulnerability":return{content:Fe.content,vulnerabilities:Fe.vulnerabilities};default:return}}Me.to=De;function ce(Fe){switch(Fe.kind){case"markdownContent":return{content:Fe.content.value};case"inlineReference":return{inlineReference:(0,k.$vc)(Fe.inlineReference)?k.URI.revive(Fe.inlineReference):u.to(Fe.inlineReference),title:Fe.name};case"treeData":return{treeData:(0,E.$Dh)(Fe.treeData)};default:return}}Me.toProgressContent=ce})(gt||(e.ChatResponseProgress=gt={}));var Nt;(function(Me){function Te(De,ce){return{prompt:De.message,variables:Mt.objectTo(De.variables),slashCommand:ce,subCommand:De.command,agentId:De.agentId}}Me.to=Te})(Nt||(e.ChatAgentRequest=Nt={}));var At;(function(Me){function Te(De){return{label:De.label,values:De.values.map(Mt.from),insertText:De.insertText,detail:De.detail,documentation:De.documentation}}Me.from=Te})(At||(e.ChatAgentCompletionItem=At={}));var Wt;(function(Me){function Te(De,ce,Fe){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:ce.toInternal(De,Fe)}Me.from=Te})(Wt||(e.TerminalQuickFix=Wt={}))}),define(Ee[317],Se([1,0,6,20,15]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;let P=class{constructor(v,$){this.a=v.getProxy(C.$fL.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>$.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,$,E){const R=f.WorkspaceEdit.from(v,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,E?.isRefactoring??!1)}};e.$Zgc=P,e.$Zgc=P=Ge([qe(0,F.$kN)],P)}),define(Ee[318],Se([1,0,53,3,6,15]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0;class A{static{this.a=0}constructor(E,R){this.extension=E,this.provider=R,this.handle=A.a++}}class v{static{this.a=0}constructor(E){this.b=new Map,this.c=new Map,this.d=E.getProxy(f.$fL.MainThreadChat)}registerChatProvider(E,R,D){const p=new A(E,D);return this.b.set(p.handle,p),this.d.$registerChatProvider(p.handle,R),(0,F.$Rc)(()=>{this.d.$unregisterChatProvider(p.handle),this.b.delete(p.handle)})}transferChatSession(E,R){const D=C.Iterable.find(this.c.keys(),p=>this.c.get(p)===E)??0;typeof D=="number"&&this.d.$transferChatSession(D,R)}sendInteractiveRequestToProvider(E,R){this.d.$sendRequestToProvider(E,R)}async $prepareChat(E,R){const D=this.b.get(E);if(!D)return;const p=await D.provider.prepareSession(R);if(!p)return;const k=v.a++;return this.c.set(k,p),{id:k,requesterUsername:p.requester?.name,requesterAvatarIconUri:p.requester?.icon,responderUsername:p.responder?.name,responderAvatarIconUri:p.responder?.icon,inputPlaceholder:p.inputPlaceholder}}async $provideWelcomeMessage(E,R){const D=this.b.get(E);if(!D||!D.provider.provideWelcomeMessage)return;const p=await D.provider.provideWelcomeMessage(R);if(p)return p.map(k=>typeof k=="string"?k:Array.isArray(k)?k.map(S=>P.ChatReplyFollowup.from(S)):P.MarkdownString.from(k))}async $provideSampleQuestions(E,R){const D=this.b.get(E);if(!D||!D.provider.provideSampleQuestions)return;const p=await D.provider.provideSampleQuestions(R);if(p)return p?.map(k=>P.ChatReplyFollowup.from(k))}$releaseSession(E){this.c.delete(E)}}e.$1gc=v}),define(Ee[319],Se([1,0,19,11,21,44,4,38,18,2,210,86,6,15,7,279,26]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;class o{static{this.a=0}constructor(n,a,t){this.j=a,this.k=t,this.b=new Map,this.g=new Map,this.i=new Map,this.d=n.getProxy(p.$fL.MainThreadChatAgents2)}createChatAgent(n,a,t){const h=o.a++,s=new i(n,a,this.d,h,t);return this.b.set(h,s),this.d.$registerAgent(h,a,{}),s.apiAgent}async $invokeAgent(n,a,t,h){this.g.delete(a.sessionId);const s=this.b.get(n);if(!s)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let d=!1;function l(){if(d)throw new Error("Only valid while executing the command")}const u=new F.$rh;h.onCancellationRequested(()=>u.complete()),this.j.allowListExtensionWhile(s.extension.identifier,u.p);const w=a.command?await s.validateSlashCommand(a.command):void 0,I=v.$Sd.create(!1);let b;try{const m=await this.l(s,a,t),y=s.invoke(k.ChatAgentRequest.to(a,w),{history:m},new D.$wv(L=>{l(),typeof b>"u"&&"content"in L&&(b=I.elapsed());const N=k.ChatResponseProgress.from(s.extension,L);if(!N){this.k.error("Unknown progress type: "+JSON.stringify(L));return}"placeholder"in L&&"resolvedContent"in L||this.d.$handleProgressChunk(a.requestId,N)}),h);return await(0,F.$Vg)(Promise.resolve(y).then(L=>{if(L){this.g.set(a.sessionId,L);let N=this.i.get(a.sessionId);N||(N=new Map,this.i.set(a.sessionId,N)),N.set(a.requestId,L);const U={firstProgress:b,totalElapsed:I.elapsed()};return{errorDetails:L.errorDetails,timings:U}}else this.g.delete(a.sessionId)}),h)}catch(m){return this.k.error(m,s.extension),{errorDetails:{message:(0,R.localize)(0,null,(0,P.$Ri)(m)),responseIsIncomplete:!0}}}finally{d=!0,u.complete()}}async l(n,a,t){return(0,C.$Hb)(await Promise.all(t.history.map(async h=>{const s=a.agentId===h.request.agentId&&this.i.get(a.sessionId)?.get(h.request.requestId)||h.result;return{request:k.ChatAgentRequest.to(h.request,void 0),response:(0,C.$Hb)(h.response.map(d=>k.ChatResponseProgress.toProgressContent(d))),result:s}})))}$releaseSession(n){this.g.delete(n),this.i.delete(n)}async $provideSlashCommands(n,a){const t=this.b.get(n);return t?t.provideSlashCommand(a):[]}$provideFollowups(n,a,t){const h=this.b.get(n);if(!h)return Promise.resolve([]);const s=this.g.get(a);return s?h.provideFollowups(s,t):Promise.resolve([])}$acceptFeedback(n,a,t,h,s){const d=this.b.get(n);if(!d)return;const l=this.i.get(a)?.get(t);if(!l)return;let u;switch(h){case c.InteractiveSessionVoteDirection.Down:u=S.ChatAgentResultFeedbackKind.Unhelpful;break;case c.InteractiveSessionVoteDirection.Up:u=S.ChatAgentResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(s?{result:l,kind:u,reportIssue:s}:{result:l,kind:u}))}$acceptAction(n,a,t,h){const s=this.b.get(n);if(!s)return;const d=this.i.get(a)?.get(t);d&&h.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:h.action,result:d}))}async $invokeCompletionProvider(n,a,t){const h=this.b.get(n);return h?(await h.invokeCompletionProvider(a,t)).map(k.ChatAgentCompletionItem.from):[]}}e.$3gc=o;class i{constructor(n,a,t,h,s){this.extension=n,this.id=a,this.w=t,this.x=h,this.y=s,this.q=new A.$Wd,this.s=new A.$Wd}acceptFeedback(n){this.q.fire(n)}acceptAction(n){this.s.fire(n)}async invokeCompletionProvider(n,a){return this.u?await this.u.provider.provideCompletionItems(n,a)??[]:[]}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(f.CancellationToken.None),(0,$.$Tf)(this.b));const a=this.b.find(t=>t.name===n);if(!a)throw new Error(`Unknown slashCommand: ${n}`);return a}async provideSlashCommand(n){if(!this.a)return[];const a=await this.a.provideSubCommands(n);return a?(this.b=a,a.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest}))):[]}async provideFollowups(n,a){if(!this.d)return[];const t=await this.d.provideFollowups(n,a);return t?t.map(h=>k.ChatFollowup.from(h)):[]}get apiAgent(){let n=!1,a=!1;const t=()=>{n||a||(a=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof E.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof S.$cM?this.j:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.o,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:k.MarkdownString.from(this.l),helpTextPostfix:!this.m||typeof this.m=="string"?this.m:k.MarkdownString.from(this.m),sampleRequest:this.n,supportIssueReporting:this.t}),a=!1}))},h=this;return{get name(){return h.id},get description(){return h.g??""},set description(s){h.g=s,t()},get fullName(){return h.i??h.extension.displayName??h.extension.name},set fullName(s){h.i=s,t()},get iconPath(){return h.j},set iconPath(s){h.j=s,t()},get subCommandProvider(){return h.a},set subCommandProvider(s){h.a=s,t()},get followupProvider(){return h.d},set followupProvider(s){h.d=s,t()},get isDefault(){return(0,g.$KF)(h.extension,"defaultChatAgent"),h.k},set isDefault(s){(0,g.$KF)(h.extension,"defaultChatAgent"),h.k=s,t()},get helpTextPrefix(){return(0,g.$KF)(h.extension,"defaultChatAgent"),h.l},set helpTextPrefix(s){if((0,g.$KF)(h.extension,"defaultChatAgent"),!h.k)throw new Error("helpTextPrefix is only available on the default chat agent");h.l=s,t()},get helpTextPostfix(){return(0,g.$KF)(h.extension,"defaultChatAgent"),h.m},set helpTextPostfix(s){if((0,g.$KF)(h.extension,"defaultChatAgent"),!h.k)throw new Error("helpTextPostfix is only available on the default chat agent");h.m=s,t()},get isSecondary(){return(0,g.$KF)(h.extension,"defaultChatAgent"),h.o},set isSecondary(s){(0,g.$KF)(h.extension,"defaultChatAgent"),h.o=s,t()},get sampleRequest(){return h.n},set sampleRequest(s){h.n=s,t()},get supportIssueReporting(){return(0,g.$KF)(h.extension,"chatAgents2Additions"),h.t},set supportIssueReporting(s){(0,g.$KF)(h.extension,"chatAgents2Additions"),h.t=s,t()},get onDidReceiveFeedback(){return h.q.event},set agentVariableProvider(s){if(h.u=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,s.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x)},get agentVariableProvider(){return h.u},onDidPerformAction:(0,g.$JF)(this.extension,"chatAgents2Additions")?this.s.event:void 0,dispose(){n=!0,h.a=void 0,h.d=void 0,h.q.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(n,a,t,h){return this.y(n,a,t,h)}}}),define(Ee[320],Se([1,0,21,3,6,15,86,25,11,4]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=void 0;class R{constructor(S,c){this.stream=new $.$xh,this.stream=c??new $.$xh;const g=this;this.apiObj={option:S,response:g.stream.asyncIterable}}}class D{constructor(S,c){this.a=new E.$Wd,this.b=new Map,this.c=new $.$xh,this.d=!1;const g=this;this.apiObject={result:S,response:g.c.asyncIterable,onDidStartResponseStream:g.a.event,cancel(){c.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let c=this.b.get(S.index);c||(this.b.size===0?c=new R(S.index,this.c):c=new R(S.index),this.b.set(S.index,c),this.a.fire(c.apiObj)),c.stream.emitOne(S.part)}}class p{static{this.a=1}constructor(S,c){this.d=c,this.c=new Map,this.e=new Map,this.f=new v.$om,this.b=S.getProxy(f.$fL.MainThreadChatProvider)}registerProvider(S,c,g,o){const i=p.a++;return this.c.set(i,{extension:S,provider:g}),this.b.$registerProvider(i,c,{extension:S,model:o.name??""}),(0,F.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,c,g,o,i){const r=this.c.get(S);if(!r)return;const n=new A.$wv(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${r.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(c,{index:a.index,part:a.part})});return r.provider.provideChatResponse(g.map(P.ChatMessage.to),o,n,i)}allowListExtensionWhile(S,c){this.f.set(S,c),c.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,c){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const g=await this.b.$prepareChatAccess(c);if(!g)throw new Error(`ChatAccess '${c}' NOT found`);const o=this;return{get model(){return g.model},get isRevoked(){return!o.f.has(S)},makeRequest(i,r,n){if(!o.f.has(S))throw new Error("Access to chat has been revoked");const a=new C.$7d(n),t=Math.random()*1e6|0,h=o.b.$fetchResponse(S,c,t,i.map(P.ChatMessage.from),r??{},a.token),s=new D(h,a);return o.e.set(t,{res:s}),h.finally(()=>{o.e.delete(t)}),s.apiObject}}}async $handleResponseFragment(S,c){const g=this.e.get(S);g&&g.res.handleFragment(c)}}e.$2gc=p}),define(Ee[321],Se([1,0,3,6,14,15]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;class A{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(F.$fL.MainThreadChatVariables)}async $resolveVariable($,E,R){const D=this.b.get($);if(D)try{const p=await D.resolver.resolve(D.data.name,{prompt:E},R);if(p)return p.map(P.ChatVariable.from)}catch(p){(0,f.$2)(p)}}registerVariableResolver($,E,R,D){const p=A.a++;return this.b.set(p,{extension:$.identifier,data:{name:E,description:R},resolver:D}),this.c.$registerVariable(p,{name:E,description:R}),(0,C.$Rc)(()=>{this.b.delete(p),this.c.$unregisterVariable(p)})}}e.$4gc=A}),define(Ee[322],Se([1,0,11,52,4,3,2,83,25,15,7,6,26]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;function k(S,c,g){const o=S.getProxy(D.$fL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$om,c.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const w=this.b.get(u.handle);return w?w.value:u}else if(u&&u.$mid===7){const w=this.b.get(u.commentControlHandle);if(!w)return u;const I=w.getCommentThread(u.commentThreadHandle);return I?I.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const w=this.b.get(u.thread.commentControlHandle);if(!w)return u;const I=w.getCommentThread(u.thread.commentThreadHandle);return I?u.$mid===8?I.value:{thread:I.value,text:u.text}:u}else if(u&&u.$mid===10){const w=this.b.get(u.thread.commentControlHandle);if(!w)return u;const I=w.getCommentThread(u.thread.commentThreadHandle);if(!I)return u;const b=u.commentUniqueId,m=I.getCommentByUniqueId(b);return m||u}else if(u&&u.$mid===11){const w=this.b.get(u.thread.commentControlHandle);if(!w)return u;const I=w.getCommentThread(u.thread.commentThreadHandle);if(!I)return u;const b=u.text,m=u.commentUniqueId,y=I.getCommentByUniqueId(m);return y?(typeof y.body=="string"?y.body=b:y.body=new R.$IL(b),y):u}return u}})}createCommentController(u,w,I){const b=i.a++,m=new n(u,b,w,I);this.b.set(m.handle,m);const y=this.c.get(u.identifier)||[];return y.push(m),this.c.set(u.identifier,y),m.value}async $createCommentThreadTemplate(u,w,I){const b=this.b.get(u);b&&b.$createCommentThreadTemplate(w,I)}async $updateCommentThreadTemplate(u,w,I){const b=this.b.get(u);b&&b.$updateCommentThreadTemplate(w,I)}$deleteCommentThread(u,w){this.b.get(u)?.$deleteCommentThread(w)}$provideCommentingRanges(u,w,I){const b=this.b.get(u);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const m=g.getDocument(A.URI.revive(w));return(0,C.$Zg)(async()=>{const y=await b.commentingRangeProvider.provideCommentingRanges(m,I);let L;return Array.isArray(y)?L={ranges:y,fileComments:!1}:y?L={ranges:y.ranges||[],fileComments:y.fileComments||!1}:L=y??void 0,L}).then(y=>{let L;return y&&(L={ranges:y.ranges.map(N=>E.Range.from(N)),fileComments:y.fileComments}),L})}$toggleReaction(u,w,I,b,m){const y=this.b.get(u);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,C.$Zg)(()=>{const L=y.getCommentThread(w);if(L){const N=L.getCommentByUniqueId(b.uniqueIdInThread);if(y!==void 0&&N&&y.reactionHandler)return y.reactionHandler(N,h(m))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,w,I,b,m,y,L,N){this.m=w,this.n=I,this.o=b,this.p=m,this.q=y,this.extensionDescription=L,this.r=N,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Uc,this.l.value=new P.$Sc,this.n===void 0&&(this.n=`${u}.${this.handle}`),o.$createCommentThread(w,this.handle,this.n,this.o,E.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{o.$deleteCommentThread(w,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(T){U.range=T},get comments(){return U.comments},set comments(T){U.comments=T},get collapsibleState(){return U.collapsibleState},set collapsibleState(T){U.collapsibleState=T},get canReply(){return U.canReply},set canReply(T){U.canReply=T},get contextValue(){return U.contextValue},set contextValue(T){U.contextValue=T},get label(){return U.label},set label(T){U.label=T},get state(){return U.state},set state(T){U.state=T},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Sc);const u=I=>Object.prototype.hasOwnProperty.call(this.b,I),w={};u("range")&&(w.range=E.Range.from(this.p)),u("label")&&(w.label=this.label),u("contextValue")&&(w.contextValue=this.contextValue??null),u("comments")&&(w.comments=this.q.map(I=>a(this,I,this.k,this.extensionDescription))),u("collapsibleState")&&(w.collapseState=s(this.g)),u("canReply")&&(w.canReply=this.canReply),u("state")&&(w.state=d(this.h)),u("isTemplate")&&(w.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,w)}getCommentByUniqueId(u){for(const w of this.k){const I=w[0],b=w[1];if(u===b)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}Ge([(0,F.$zh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,w,I,b){this.f=u,this.g=w,this.h=I,this.i=b,this.a=new Map,o.$registerCommentController(this.handle,I,b,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(y){m.options=y},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(y){m.commentingRangeProvider=y},get reactionHandler(){return m.reactionHandler},set reactionHandler(y){m.reactionHandler=y},createCommentThread(y,L,N){return m.createCommentThread(y,L,N).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(u,w,I){w===void 0&&(0,p.$KF)(this.f,"fileComments");const b=new r(this.id,this.handle,void 0,u,w,I,this.f,!1);return this.a.set(b.handle,b),b}$createCommentThreadTemplate(u,w){const I=new r(this.id,this.handle,void 0,A.URI.revive(u),E.Range.to(w),[],this.f,!0);return I.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(u,w){const I=this.a.get(u);I&&(I.range=E.Range.to(w))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function a(l,u,w,I){let b=w.get(u);return b||(b=++l.commentHandle,w.set(u,b)),u.state!==void 0&&(0,p.$KF)(I,"commentsDraftState"),u.reactions?.some(m=>m.reactors!==void 0)&&(0,p.$KF)(I,"commentReactor"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:b,body:typeof u.body=="string"?u.body:E.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(m=>t(m)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?E.$jN(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted,reactors:l.reactors&&l.reactors.length>0&&typeof l.reactors[0]!="string"?l.reactors.map(u=>u.name):l.reactors}}function h(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?A.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1,reactors:l.reactors?.map(u=>({name:u}))}}function s(l){if(l!==void 0)switch(l){case R.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function d(l){if(l!==void 0)switch(l){case R.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}return new i}e.$8gc=k}),define(Ee[323],Se([1,0,21,54,3,16,23,2,15,93,110,6,7]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class k{constructor(h,s){this.document=h,this.b=s,this.a=1,this.c=new R.$Mgc("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,s){await this.f(h).undo(),s||this.disposeBackup()}async redo(h,s){await this.f(h).redo(),s||this.disposeBackup()}disposeEdits(h){for(const s of h)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=a(this.document.uri)+this.a++;return(0,A.$Ig)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const s=this.c.get(h,0);if(!s)throw new Error("No edit found");return s}}class S{constructor(){this.a=new Map}get(h,s){return this.a.get(this.b(h,s))}add(h,s,d){const l=this.b(h,s.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${h} resource:${s.uri}`);const u=new k(s,d);return this.a.set(l,u),u}delete(h,s){const d=this.b(h,s.uri);this.a.delete(d)}b(h,s){return`${h}@@@${s}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class g{constructor(){this.a=new Map}addTextProvider(h,s,d){return this.b(0,h,s,d)}addCustomProvider(h,s,d){return this.b(1,h,s,d)}get(h){return this.a.get(h)}b(h,s,d,l){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:h,extension:d,provider:l}),new p.$hL(()=>this.a.delete(s))}}class o{constructor(h,s,d,l,u){this.d=s,this.f=d,this.g=l,this.h=u,this.b=new g,this.c=new S,this.a=h.getProxy(D.$fL.MainThreadCustomEditors)}registerCustomEditorProvider(h,s,d,l){const u=new f.$Sc;return r(d)?(u.add(this.b.addTextProvider(s,h,d)),this.a.$registerTextEditorProvider((0,E.$khc)(h),s,l.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,E.$ihc)(h))):(u.add(this.b.addCustomProvider(s,h,d)),i(d)&&u.add(d.onDidChangeCustomDocument(w=>{const I=this.i(s,w.document.uri);if(n(w)){const b=I.addEdit(w);this.a.$onDidEdit(w.document.uri,s,b,w.label)}else this.a.$onContentChange(w.document.uri,s)})),this.a.$registerCustomEditorProvider((0,E.$khc)(h),s,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,E.$ihc)(h))),p.$hL.from(u,new p.$hL(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(h,s,d,l,u){const w=this.b.get(s);if(!w)throw new Error(`No provider found for '${s}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${s}'`);const I=v.URI.revive(h),b=await w.provider.openCustomDocument(I,{backupId:d,untitledDocumentData:l?.buffer},u);let m;return i(w.provider)&&this.f&&(m=this.f.workspaceValue(w.extension)??this.f.globalValue(w.extension)),this.c.add(s,b,m),{editable:i(w.provider)}}async $disposeCustomDocument(h,s){const d=this.b.get(s);if(!d)throw new Error(`No provider found for '${s}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${s}'`);const l=v.URI.revive(h),{document:u}=this.i(s,l);this.c.delete(s,u),u.dispose()}async $resolveCustomEditor(h,s,d,l,u,w){const I=this.b.get(d);if(!I)throw new Error(`No provider found for '${d}'`);const b=$.ViewColumn.to(u),m=this.g.createNewWebview(s,l.contentOptions,I.extension),y=this.h.createNewWebviewPanel(s,d,l.title,b,l.options,m,l.active),L=v.URI.revive(h);switch(I.type){case 1:{const{document:N}=this.i(d,L);return I.provider.resolveCustomEditor(N,y,w)}case 0:{const N=this.d.getDocument(L);return I.provider.resolveCustomTextEditor(N,y,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,s,d){this.i(s,h).disposeEdits(d)}async $onMoveCustomEditor(h,s,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this.h.getWebviewPanel(h);if(!u)throw new Error("No webview found");const w=v.URI.revive(s),I=this.d.getDocument(w);await l.provider.moveCustomTextEditor(I,u,C.CancellationToken.None)}async $undo(h,s,d,l){return this.i(s,h).undo(d,l)}async $redo(h,s,d,l){return this.i(s,h).redo(d,l)}async $revert(h,s,d){const l=this.i(s,h);await this.j(s).revertCustomDocument(l.document,d),l.disposeBackup()}async $onSave(h,s,d){const l=this.i(s,h);await this.j(s).saveCustomDocument(l.document,d),l.disposeBackup()}async $onSaveAs(h,s,d,l){const u=this.i(s,h);return this.j(s).saveCustomDocumentAs(u.document,v.URI.revive(d),l)}async $backup(h,s,d){const l=this.i(s,h),w=await this.j(s).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},d);return l.updateBackup(w),w.id}i(h,s){const d=this.c.get(h,v.URI.revive(s));if(!d)throw new Error("No custom document found");return d}j(h){const d=this.b.get(h)?.provider;if(!d||!i(d))throw new Error("Custom document is not editable");return d}}e.$nhc=o;function i(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const h=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Ui)(h)+""}}),define(Ee[324],Se([1,0,211,135,2,6,7,15,4,13,28,59]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=void 0;class k{#e;#t;#i;constructor(g,o,i,r,n,a,t,h){this.d=g,this.e=o,this.f=i,this.g=r,this.h=n,this.c=!1,this.f=Math.max(r,i),this.#i=new R.$Ac(s=>a.getComparisonKey(s)),this.#e=t,this.#t=h}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,o){if(!g){this.clear();return}this.j();let i=[];if(f.URI.isUri(g)){if(!o){this.delete(g);return}this.#i.set(g,o.slice()),i=[g]}else if(Array.isArray(g)){i=[];let a;g=[...g].sort(k.k);for(const t of g){const[h,s]=t;if((!a||h.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=h,i.push(h),this.#i.set(h,[])),s)this.#i.get(h)?.push(...s);else{const d=this.#i.get(h);d&&(d.length=0)}}}if(this.#t.fire(i),!this.#e)return;const r=[];let n=0;for(const a of i){let t=[];const h=this.#i.get(a);if(h)if(h.length>this.g){t=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const l of h)if(l.severity===s[d]&&t.push({...v.Diagnostic.from(l),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,C.localize)(0,null,h.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=h.map(s=>({...v.Diagnostic.from(s),modelVersionId:this.h(a)}));if(r.push([a,t]),n+=t.length,n>this.f)break}this.#e.$changeMany(this.e,r)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,o){this.j();for(const[i,r]of this)g.call(o,i,r,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const o=this.#i.get(g);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,o){return g[0].toString()<o[0].toString()?-1:g[0].toString()>o[0].toString()?1:0}}e.$Rgc=k;let S=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(g){const o=new R.$Ac;for(const i of g)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(g,o,i,r){this.j=o,this.k=i,this.l=r,this.g=new Map,this.h=new $.$1d({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,p._mapper),this.f=g.getProxy(P.$fL.MainThreadDiagnostics)}createDiagnosticCollection(g,o){const{g:i,f:r,h:n,j:a,k:t,l:h}=this,s=new class{$changeMany(u,w){r.$changeMany(u,w),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,u,w.length===0?"CLEARING":w)}$clear(u){r.$clear(u),a.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,u)}dispose(){r.dispose()}};let d;if(!o)o="_generated_diagnostic_collection_name_#"+p.c++,d=o;else if(!i.has(o))d=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do d=o+p.c++;while(i.has(d))}return new class extends k{constructor(){super(o,d,p.e,p.d,u=>h.getDocument(u)?.version,t.extUri,s,n),i.set(d,this)}dispose(){super.dispose(),i.delete(d)}}}getDiagnostics(g){if(g)return this.m(g);{const o=new Map,i=[];for(const r of this.g.values())r.forEach((n,a)=>{let t=o.get(n.toString());typeof t>"u"&&(t=i.length,o.set(n.toString(),t),i.push([n,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(g){let o=[];for(const i of this.g.values())i.has(g)&&(o=o.concat(i.get(g)));return o}$acceptMarkersChange(g){if(!this.n){const o="_generated_mirror",i=new k(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of g)this.n.set(f.URI.revive(o),i.map(v.Diagnostic.to))}};e.$Sgc=S,e.$Sgc=S=p=Ge([qe(1,E.$oj),qe(2,D.$Qgc)],S)}),define(Ee[325],Se([1,0,2,14,7,15,75]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;class v{constructor(E,R,D,p={timeout:1500,errors:3}){this.c=E,this.d=R,this.f=D,this.g=p,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(R,D,p)=>{const S={dispose:this.a.push([R,D,E])};return Array.isArray(p)&&p.push(S),S}}async $participateInSave(E,R){const D=C.URI.revive(E);let p=!1;const k=setTimeout(()=>p=!0,this.g.timeout),S=[];try{for(const c of[...this.a]){if(p)break;const g=this.d.getDocument(D),o=await this.h(c,{document:g,reason:P.TextDocumentSaveReason.to(R)});S.push(o)}}finally{clearTimeout(k)}return S}h([E,R,D],p){const k=this.b.get(E);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(D,E,R,p).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const c=this.b.get(E);this.b.set(E,c?c+1:1),typeof c=="number"&&c>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,R,D,p){const k=[],S=Date.now(),{document:c,reason:g}=p,{version:o}=c,i=Object.freeze({document:c,reason:g,waitUntil(r){if(Object.isFrozen(k))throw(0,F.$8)("waitUntil can not be called async");k.push(Promise.resolve(r))}});try{R.apply(D,[i])}catch(r){return Promise.reject(r)}return Object.freeze(k),new Promise((r,n)=>{const a=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),r(t)}).catch(t=>{clearTimeout(a),n(t)})}).then(r=>{const n={edits:[]};for(const a of r)if(Array.isArray(a)&&a.every(t=>t instanceof f.$oL))for(const{newText:t,newEol:h,range:s}of a)n.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:t,eol:h&&P.EndOfLine.from(h)}});if(n.edits.length!==0)return o===c.version?this.f.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.$2hc=v}),define(Ee[326],Se([1,0,4,3,2,6,148,15,18,24,7]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;class D{constructor(k,S){this.a=new C.$Wd,this.b=new C.$Wd,this.c=new C.$Wd,this.d=new C.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Sc,this.h=new Map,this.f=k.getProxy(P.$fL.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(c=>{for(const g of c)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const g of c)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const S=this.g.getDocument(k);if(S)return S}getDocument(k){const S=this.getDocumentData(k);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return S.document}ensureDocumentData(k){const S=this.g.getDocument(k);if(S)return Promise.resolve(S);let c=this.h.get(k.toString());return c||(c=this.f.$tryOpenDocument(k).then(g=>{this.h.delete(k.toString());const o=f.URI.revive(g);return(0,$.$Uf)(this.g.getDocument(o))},g=>(this.h.delete(k.toString()),Promise.reject(g))),this.h.set(k.toString(),c)),c}createDocumentData(k){return this.f.$tryCreateDocument(k).then(S=>f.URI.revive(S))}$acceptModelLanguageChanged(k,S){const c=f.URI.revive(k),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(S),this.a.fire(g.document)}$acceptModelSaved(k){const S=f.URI.revive(k),c=this.g.getDocument(S);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(k,S){const c=f.URI.revive(k),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");g._acceptIsDirty(S),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,S,c){const g=f.URI.revive(k),o=this.g.getDocument(g);if(!o)throw new Error("unknown document");o._acceptIsDirty(c),o.onEvents(S);let i;S.isUndoing?i=R.TextDocumentChangeReason.Undo:S.isRedoing&&(i=R.TextDocumentChangeReason.Redo),this.c.fire((0,E.$xn)({document:o.document,contentChanges:S.changes.map(r=>({range:v.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:i}))}setWordDefinitionFor(k,S){(0,A.$mN)(k,S)}}e.$Ogc=D}),define(Ee[71],Se([1,0,73,4,18,2,5,6,20,15,7]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=void 0,e.$ohc=(0,A.$7h)("IExtHostEditorTabs");class D{constructor(g,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,o={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$1M(P.URI.revive(this.b.input.uri));case 2:return new R.$2M(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new R.$3M(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new R.$4M(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$5M(this.b.input.viewType);case 4:return new R.$6M(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$7M(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$8M;case 9:return new R.$9M(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$0M(this.b.input.providerId);default:return}}}class p{constructor(g,o){this.c=[],this.d="",this.b=g,this.e=o;for(const i of g.tabs)i.isActive&&(this.d=i.id),this.c.push(new D(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,o={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return E.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(i=>i.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const i=new D(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,i),g.tabDto.isActive&&(this.d=i.tabId),i}else if(g.kind===1){const i=this.c.splice(g.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(g.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,i),i}const o=this.c.find(i=>i.tabId===g.tabDto.id);if(!o)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(g.tabDto),o}activeTabId(){return this.d}}let k=class{constructor(g){this.b=new F.$Wd,this.c=new F.$Wd,this.e=[],this.a=g.getProxy(v.$fL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,o={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(i=>i.apiObject))},get activeTabGroup(){const i=g.d;return(0,f.$Uf)(g.e.find(n=>n.groupId===i)?.apiObject)},close:async(i,r)=>{const n=Array.isArray(i)?i:[i];return n.length?S(n[0])?this.j(n,r):this.i(n,r):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(g){const o=new Set(this.e.map(s=>s.groupId)),i=new Set(g.map(s=>s.groupId)),r=(0,C.$L)(o,i),n=this.e.filter(s=>r.removed.includes(s.groupId)).map(s=>s.apiObject),a=[],t=[];this.e=g.map(s=>{const d=new p(s,()=>this.d);return r.added.includes(d.groupId)?a.push(d.apiObject):t.push(d.apiObject),d});const h=(0,f.$Uf)(g.find(s=>s.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:a,closed:n,changed:t}))}$acceptTabGroupUpdate(g){const o=this.e.find(i=>i.groupId===g.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const o=this.e.find(r=>r.groupId===g.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(g){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===g)return i}h(g){return this.e.find(o=>o.apiObject===g)}async i(g,o){const i=[];for(const r of g){const n=this.g(r);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this.a.$closeTab(i,o)}async j(g,o){const i=[];for(const r of g){const n=this.h(r);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this.a.$closeGroup(i,o)}};e.$phc=k,e.$phc=k=Ge([qe(0,$.$kN)],k);function S(c){return c.tabs!==void 0}}),define(Ee[327],Se([1,0,2,6,3,7,15,173,12,22,26,80]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class p{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const g=this.a.indexOf(c);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),g=[];let o,i,r=14,n=14;for(const a of c){let t=o?(0,$.$cf)(o,a):0;for(t===0?i=1:i=n;t<a.length;t++)t+1===a.length?(r=n,n=9):n+=1,g.push([i,a.toUpperCase().charCodeAt(t),n]),g.push([i,a.toLowerCase().charCodeAt(t),n]),i=n;o=a,n=r}g.push([9,58,10]),g.push([10,47,12]),this.b=new v.$IZ(g)}}provideDocumentLinks(c){this.c();const g=[],o=v.$JZ.computeLinks({getLineContent(i){return c.lineAt(i-1).text},getLineCount(){return c.lineCount}},this.b);for(const i of o){const r=A.DocumentLink.to(i);r.target&&g.push(r)}return g}}class k{constructor(c,g){this.i=g,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(F.$fL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,g,o,i={}){if(k.j(o),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const r=this.h++;this.b.add(g),this.d.add(g),this.c.set(r,o);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof o.copy=="function"&&(n+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,R.$KF)(c,"fsChunks"),n+=4);let a;i.isReadonly&&(0,D.$kk)(i.isReadonly)&&i.isReadonly.value!==""&&(a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(r,g,n,a).catch(h=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${g}`),console.error(h)});const t=o.onDidChangeFile(h=>{const s=[];for(const d of h){const{uri:l,type:u}=d;if(l.scheme!==g)continue;let w;switch(u){case P.FileChangeType.Changed:w=0;break;case P.FileChangeType.Created:w=1;break;case P.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:l,type:w})}this.a.$onFileSystemChange(r,s)});return(0,f.$Rc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:g,ctime:o,mtime:i,size:r,permissions:n}=c;return{type:g,ctime:o,mtime:i,size:r,permissions:n}}$stat(c,g){return Promise.resolve(this.l(c).stat(C.URI.revive(g))).then(o=>k.k(o))}$readdir(c,g){return Promise.resolve(this.l(c).readDirectory(C.URI.revive(g)))}$readFile(c,g){return Promise.resolve(this.l(c).readFile(C.URI.revive(g))).then(o=>E.$ke.wrap(o))}$writeFile(c,g,o,i){return Promise.resolve(this.l(c).writeFile(C.URI.revive(g),o.buffer,i))}$delete(c,g,o){return Promise.resolve(this.l(c).delete(C.URI.revive(g),o))}$rename(c,g,o,i){return Promise.resolve(this.l(c).rename(C.URI.revive(g),C.URI.revive(o),i))}$copy(c,g,o,i){const r=this.l(c);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(C.URI.revive(g),C.URI.revive(o),i))}$mkdir(c,g){return Promise.resolve(this.l(c).createDirectory(C.URI.revive(g)))}$watch(c,g,o,i){const r=this.l(c).watch(C.URI.revive(o),i);this.f.set(g,r)}$unwatch(c,g){const o=this.f.get(g);o&&(o.dispose(),this.f.delete(g))}$open(c,g,o){const i=this.l(c);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(C.URI.revive(g),o))}$close(c,g){const o=this.l(c);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(g))}$read(c,g,o,i){const r=this.l(c);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const n=E.$ke.alloc(i);return Promise.resolve(r.read(g,o,n.buffer,0,i)).then(a=>n.slice(0,a))}$write(c,g,o,i){const r=this.l(c);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(g,o,i.buffer,0,i.byteLength))}l(c){const g=this.c.get(c);if(!g){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return g}}e.$4hc=k}),define(Ee[328],Se([1,0,4,35,2,6,15,7,43]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(k,S,c,g,o,i){this.a=Math.random(),this.b=new C.$Wd,this.c=new C.$Wd,this.d=new C.$Wd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,F.$Nj)(o),n=typeof o=="string",a=i?.correlate,t=g(h=>{if(!(typeof h.session=="number"&&h.session!==this.a)&&!(a&&typeof h.session>"u")){if(!i?.ignoreCreateEvents)for(const s of h.created){const d=f.URI.revive(s);r(d.fsPath)&&(!n||S.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const s of h.changed){const d=f.URI.revive(s);r(d.fsPath)&&(!n||S.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const s of h.deleted){const d=f.URI.revive(s);r(d.fsPath)&&(!n||S.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=v.$hL.from(this.i(k,c,o,i,i?.correlate),this.b,this.c,this.d,t)}i(k,S,c,g,o){const i=v.$hL.from();if(typeof c=="string")return i;const r=k.getProxy(P.$fL.MainThreadFileSystemEventService);let n=!1;return(c.pattern.includes(F.$Jj)||c.pattern.includes(F.$Kj))&&(n=!0),r.$watch(S.identifier.value,this.a,c.baseUri,{recursive:n,excludes:g?.excludes??[]},!!o),v.$hL.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(k){this.a=k,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(f.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(f.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(k,S,c){this.j=k,this.k=S,this.l=c,this.a=new C.$Wd,this.b=new C.$Wd,this.c=new C.$Wd,this.d=new C.$Wd,this.g=new C.$Yd,this.h=new C.$Yd,this.i=new C.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,S,c,g){return new E(this.j,k,S,this.a.event,A.GlobPattern.from(c),g)}$onFileEvent(k){this.a.fire(new R(k))}$onDidRunFileOperation(k,S){switch(k){case 2:this.b.fire(Object.freeze({files:S.map(c=>({oldUri:f.URI.revive(c.source),newUri:f.URI.revive(c.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(c=>f.URI.revive(c.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(c=>f.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,S){return(c,g,o)=>{const i=function(n){c.call(g,n)};return i.extension=k,S.event(i,void 0,o)}}async $onWillRunFileOperation(k,S,c,g){switch(k){case 2:return await this.n(this.g,{files:S.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},c,g);case 1:return await this.n(this.i,{files:S.map(o=>f.URI.revive(o.target))},c,g);case 0:case 3:return await this.n(this.h,{files:S.map(o=>f.URI.revive(o.target))},c,g)}}async n(k,S,c,g){const o=new Set,i=[];if(await k.fireAsync(S,g,async(n,a)=>{const t=Date.now(),h=await Promise.resolve(n);h instanceof v.$rL&&(i.push([a.extension,h]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>c&&this.k.warn("SLOW file-participant",a.extension.identifier)}),g.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,n]of i){const{edits:a}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(a)}return{edit:r,extensionNames:Array.from(o)}}}e.$5hc=D}),define(Ee[329],Se([1,0,2,24,15,7,83,6,12,29,19,18,169,21,25,3,131,121,110,38,14,11,26,213]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class s{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentSymbols(B,Z){const te=this.d.getDocument(B),V=await this.e.provideDocumentSymbols(te,Z);if(!(0,R.$Kb)(V))return V[0]instanceof P.$AL?V.map(f.DocumentSymbol.from):s.f(V)}static f(B){B=B.slice(0).sort((V,ae)=>{let he=V.location.range.start.compareTo(ae.location.range.start);return he===0&&(he=ae.location.range.end.compareTo(V.location.range.end)),he});const Z=[],te=[];for(const V of B){const ae={name:V.name||"!!MISSING: name!!",kind:f.SymbolKind.from(V.kind),tags:V.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:f.Range.from(V.location.range),selectionRange:f.Range.from(V.location.range),children:[]};for(;;){if(te.length===0){te.push(ae),Z.push(ae);break}const he=te[te.length-1];if(E.$Vs.containsRange(he.range,ae.range)&&!E.$Vs.equalsRange(he.range,ae.range)){he.children?.push(ae),te.push(ae);break}te.pop()}}return Z}}class d{constructor(B,Z,te,V,ae,he){this.f=B,this.g=Z,this.h=te,this.j=V,this.k=ae,this.l=he,this.d=new i.$Mgc("CodeLens"),this.e=new Map}async provideCodeLenses(B,Z){const te=this.f.getDocument(B),V=await this.h.provideCodeLenses(te,Z);if(!V||Z.isCancellationRequested)return;const ae=this.d.add(V),he=new c.$Sc;this.e.set(ae,he);const Re={cacheId:ae,lenses:[]};for(let je=0;je<V.length;je++)Re.lenses.push({cacheId:[ae,je],range:f.Range.from(V[je].range),command:this.g.toInternal(V[je].command,he)});return Re}async resolveCodeLens(B,Z){const te=B.cacheId&&this.d.get(...B.cacheId);if(!te)return;let V;if(typeof this.h.resolveCodeLens!="function"||te.isResolved?V=te:V=await this.h.resolveCodeLens(te,Z),V||(V=te),Z.isCancellationRequested)return;const ae=B.cacheId&&this.e.get(B.cacheId[0]);if(ae){if(!V.command){const he=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,he),this.l.error(he);return}return B.command=this.g.toInternal(V.command,ae),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function l(Ie){return Array.isArray(Ie)?Ie.map(f.DefinitionLink.from):Ie?[f.DefinitionLink.from(Ie)]:[]}class u{constructor(B,Z){this.d=B,this.e=Z}async provideDefinition(B,Z,te){const V=this.d.getDocument(B),ae=f.Position.to(Z),he=await this.e.provideDefinition(V,ae,te);return l(he)}}class w{constructor(B,Z){this.d=B,this.e=Z}async provideDeclaration(B,Z,te){const V=this.d.getDocument(B),ae=f.Position.to(Z),he=await this.e.provideDeclaration(V,ae,te);return l(he)}}class I{constructor(B,Z){this.d=B,this.e=Z}async provideImplementation(B,Z,te){const V=this.d.getDocument(B),ae=f.Position.to(Z),he=await this.e.provideImplementation(V,ae,te);return l(he)}}class b{constructor(B,Z){this.d=B,this.e=Z}async provideTypeDefinition(B,Z,te){const V=this.d.getDocument(B),ae=f.Position.to(Z),he=await this.e.provideTypeDefinition(V,ae,te);return l(he)}}class m{constructor(B,Z){this.d=B,this.e=Z}async provideHover(B,Z,te){const V=this.d.getDocument(B),ae=f.Position.to(Z),he=await this.e.provideHover(V,ae,te);if(!(!he||(0,R.$Kb)(he.contents)))return he.range||(he.range=V.getWordRangeAtPosition(ae)),he.range||(he.range=new P.$jL(ae,ae)),f.Hover.from(he)}}class y{constructor(B,Z){this.d=B,this.e=Z}async provideEvaluatableExpression(B,Z,te){const V=this.d.getDocument(B),ae=f.Position.to(Z),he=await this.e.provideEvaluatableExpression(V,ae,te);if(he)return f.EvaluatableExpression.from(he)}}class L{constructor(B,Z){this.d=B,this.e=Z}async provideInlineValues(B,Z,te,V){const ae=this.d.getDocument(B),he=await this.e.provideInlineValues(ae,f.Range.to(Z),f.InlineValueContext.to(te),V);if(Array.isArray(he))return he.map(Re=>f.InlineValue.from(Re))}}class N{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentHighlights(B,Z,te){const V=this.d.getDocument(B),ae=f.Position.to(Z),he=await this.e.provideDocumentHighlights(V,ae,te);if(Array.isArray(he))return he.map(f.DocumentHighlight.from)}}class U{constructor(B,Z){this.d=B,this.e=Z}async provideMultiDocumentHighlights(B,Z,te,V){const ae=this.d.getDocument(B),he=te.map(He=>this.d.getDocument(He)),Re=f.Position.to(Z),je=await this.e.provideMultiDocumentHighlights(ae,Re,he,V);if(Array.isArray(je))return je.map(f.MultiDocumentHighlight.from)}}class T{constructor(B,Z){this.d=B,this.e=Z}async provideLinkedEditingRanges(B,Z,te){const V=this.d.getDocument(B),ae=f.Position.to(Z),he=await this.e.provideLinkedEditingRanges(V,ae,te);if(he&&Array.isArray(he.ranges))return{ranges:(0,R.$Hb)(he.ranges.map(f.Range.from)),wordPattern:he.wordPattern}}}class O{constructor(B,Z){this.d=B,this.e=Z}async provideReferences(B,Z,te,V){const ae=this.d.getDocument(B),he=f.Position.to(Z),Re=await this.e.provideReferences(ae,he,te,V);if(Array.isArray(Re))return Re.map(f.location.from)}}class M{static{this.d=1e3}constructor(B,Z,te,V,ae,he,Re){this.g=B,this.h=Z,this.j=te,this.k=V,this.l=ae,this.m=he,this.n=Re,this.e=new i.$Mgc("CodeAction"),this.f=new Map}async provideCodeActions(B,Z,te,V){const ae=this.g.getDocument(B),he=p.$Xs.isISelection(Z)?f.Selection.to(Z):f.Range.to(Z),Re=[];for(const st of this.j.getDiagnostics(B))if(he.intersection(st.range)&&Re.push(st)>M.d)break;const je={diagnostics:Re,only:te.only?new P.$CL(te.only):void 0,triggerKind:f.CodeActionTriggerKind.to(te.trigger)},He=await this.k.provideCodeActions(ae,he,je,V);if(!(0,R.$Lb)(He)||V.isCancellationRequested)return;const Qe=this.e.add(He),_e=new c.$Sc;this.f.set(Qe,_e);const at=[];for(let st=0;st<He.length;st++){const rt=He[st];if(rt)if(M.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)});else{je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Pe=rt.ranges??[];at.push({cacheId:[Qe,st],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(f.Diagnostic.from),edit:rt.edit&&f.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$JF)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$JF)(this.m,"codeActionRanges")?(0,R.$Hb)(Pe.map(f.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:Qe,actions:at}}async resolveCodeAction(B,Z){const[te,V]=B,ae=this.e.get(te,V);if(!ae||M.o(ae))return{};if(!this.k.resolveCodeAction)return{};const he=await this.k.resolveCodeAction(ae,Z)??ae;let Re;he.edit&&(Re=f.WorkspaceEdit.from(he.edit,void 0));let je;if(he.command){const He=this.f.get(te);He&&(je=this.h.toInternal(he.command,He))}return{edit:Re,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class j{static toInternalProviderId(B,Z){return B+"."+Z}constructor(B,Z,te,V,ae){this.d=B,this.e=Z,this.f=te,this.g=V,this.h=ae}async prepareDocumentPaste(B,Z,te,V){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(B),he=Z.map(He=>f.Range.to(He)),Re=f.DataTransfer.toDataTransfer(te,()=>{throw new n.$$});if(await this.f.prepareDocumentPaste(ae,he,Re,V),V.isCancellationRequested)return;const je=Array.from(Re).filter(([,He])=>!(He instanceof P.$9L));return f.DataTransfer.from(je)}async providePasteEdits(B,Z,te,V,ae){if(!this.f.provideDocumentPasteEdits)return;const he=this.e.getDocument(Z),Re=te.map(Qe=>f.Range.to(Qe)),je=f.DataTransfer.toDataTransfer(V,async Qe=>(await this.d.$resolvePasteFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentPasteEdits(he,Re,je,ae);if(He)return{label:He.label??(0,h.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:j.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?f.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class z{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentFormattingEdits(B,Z,te){const V=this.d.getDocument(B),ae=await this.e.provideDocumentFormattingEdits(V,Z,te);if(Array.isArray(ae))return ae.map(f.TextEdit.from)}}class J{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentRangeFormattingEdits(B,Z,te,V){const ae=this.d.getDocument(B),he=f.Range.to(Z),Re=await this.e.provideDocumentRangeFormattingEdits(ae,he,te,V);if(Array.isArray(Re))return Re.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Z,te,V){(0,D.$Tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(B),he=Z.map(f.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ae,he,te,V);if(Array.isArray(Re))return Re.map(f.TextEdit.from)}}class le{constructor(B,Z){this.d=B,this.e=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Z,te,V,ae){const he=this.d.getDocument(B),Re=f.Position.to(Z),je=await this.e.provideOnTypeFormattingEdits(he,Re,te,V,ae);if(Array.isArray(je))return je.map(f.TextEdit.from)}}class Y{constructor(B,Z){this.e=B,this.f=Z,this.d=new i.$Mgc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Z){const te=await this.e.provideWorkspaceSymbols(B,Z);if(!(0,R.$Lb)(te))return{symbols:[]};const V=this.d.add(te),ae={cacheId:V,symbols:[]};for(let he=0;he<te.length;he++){const Re=te[he];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ae.symbols.push({...f.WorkspaceSymbol.from(Re),cacheId:[V,he]})}return ae}async resolveWorkspaceSymbol(B,Z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const te=this.d.get(...B.cacheId);if(te){const V=await this.e.resolveWorkspaceSymbol(te,Z);return V&&(0,F.$zn)(B,f.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Q{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Z,te){this.d=B,this.e=Z,this.f=te}async provideRenameEdits(B,Z,te,V){const ae=this.d.getDocument(B),he=f.Position.to(Z);try{const Re=await this.e.provideRenameEdits(ae,he,te,V);return Re?f.WorkspaceEdit.from(Re):void 0}catch(Re){const je=Q.g(Re);return je?{rejectReason:je,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(B,Z,te){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(B),ae=f.Position.to(Z);try{const he=await this.e.prepareRename(V,ae,te);let Re,je;if(P.$jL.isRange(he)?(Re=he,je=V.getText(he)):(0,D.$Lf)(he)&&(Re=he.range,je=he.placeholder),!Re||!je)return;if(Re.start.line>ae.line||Re.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(Re),text:je}}catch(he){const Re=Q.g(he);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(he)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class X{constructor(B,Z){this.resultId=B,this.tokens=Z}}class ue{constructor(B,Z){this.f=B,this.g=Z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Z,te){const V=this.f.getDocument(B),ae=Z!==0?this.d.get(Z):null;let he=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,ae.resultId,te):await this.g.provideDocumentSemanticTokens(V,te);return ae&&this.d.delete(Z),he?(he=ue.h(he),this.o(ue.n(ae,he),he)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return ue.j(B)?ue.k(B)?B:new P.$zM(new Uint32Array(B.data),B.resultId):ue.l(B)?ue.m(B)?B:new P.$BM(B.edits.map(Z=>new P.$AM(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Z of B.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static n(B,Z){if(!ue.j(Z)||!B||!B.tokens)return Z;const te=B.tokens,V=te.length,ae=Z.data,he=ae.length;let Re=0;const je=Math.min(V,he);for(;Re<je&&te[Re]===ae[Re];)Re++;if(Re===V&&Re===he)return new P.$BM([],Z.resultId);let He=0;const Qe=je-Re;for(;He<Qe&&te[V-He-1]===ae[he-He-1];)He++;return new P.$BM([{start:Re,deleteCount:V-Re-He,data:ae.subarray(Re,he-He)}],Z.resultId)}o(B,Z){if(ue.j(B)){const te=this.e++;return this.d.set(te,new X(B.resultId,B.data)),(0,g.$G$)({id:te,type:"full",data:B.data})}if(ue.l(B)){const te=this.e++;return ue.j(Z)?this.d.set(te,new X(Z.resultId,Z.data)):this.d.set(te,new X(B.resultId)),(0,g.$G$)({id:te,type:"delta",deltas:(B.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class ne{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentRangeSemanticTokens(B,Z,te){const V=this.d.getDocument(B),ae=await this.e.provideDocumentRangeSemanticTokens(V,f.Range.to(Z),te);return ae?this.f(ae):null}f(B){return(0,g.$G$)({id:0,type:"full",data:B.data})}}class $e{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Z,te,V,ae){this.f=B,this.g=Z,this.h=te,this.j=V,this.k=ae,this.d=new i.$Mgc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Z,te,V){const ae=this.f.getDocument(B),he=f.Position.to(Z),Re=ae.getWordRangeAtPosition(he)||new P.$jL(he,he),je=Re.with({end:he}),He=new r.$Sd,Qe=await this.h.provideCompletionItems(ae,he,V,f.CompletionContext.to(te));if(!Qe||V.isCancellationRequested)return;const _e=Array.isArray(Qe)?new P.$PL(Qe):Qe,at=$e.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),st=new c.$Sc;this.e.set(at,st);const rt=[],Pe={x:at,b:rt,a:{replace:f.Range.from(Re),insert:f.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let Ue=0;Ue<_e.items.length;Ue++){const Le=_e.items[Ue],Ze=this.l(Le,[at,Ue],je,Re);rt.push(Ze)}return Pe}async resolveCompletionItem(B,Z){if(typeof this.h.resolveCompletionItem!="function")return;const te=this.d.get(...B);if(!te)return;const V=this.l(te,B),ae=await this.h.resolveCompletionItem(te,Z);if(!ae)return;const he=this.l(ae,B);return(V.h!==he.h||V.i!==he.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V.n!==he.n||V.o!==he.o||!(0,F.$An)(V.p,he.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,d:he.d,c:he.c,l:he.l,h:he.h,i:he.i,n:he.n,o:he.o,p:he.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Z,te,V){const ae=this.e.get(Z[0]);if(!ae)throw Error("DisposableStore is missing...");const he=this.g.toInternal(B.command,ae),Re={x:Z,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=B.textEdit.newText):typeof B.insertText=="string"?Re.h=B.insertText:B.insertText instanceof P.$sL&&(Re.h=B.insertText.value,Re.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),P.$jL.isRange(je)?Re.j=f.Range.from(je):je&&(!te?.isEqual(je.inserting)||!V?.isEqual(je.replacing))&&(Re.j={insert:f.Range.from(je.inserting),replace:f.Range.from(je.replacing)}),Re}}class oe{async provideInlineCompletions(B,Z,te,V){}disposeCompletions(B){}handleDidShowCompletionItem(B,Z,te){}handlePartialAccept(B,Z,te){}}class K extends oe{constructor(B,Z,te,V){super(),this.f=B,this.g=Z,this.h=te,this.j=V,this.d=new W,this.e=(0,t.$JF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$JF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Z,te,V){const ae=this.g.getDocument(B),he=f.Position.to(Z),Re=await this.h.provideInlineCompletionItems(ae,he,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:f.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[te.triggerKind]},V);if(!Re||V.isCancellationRequested)return;const je=Array.isArray(Re)?Re:Re.items,He=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Qe=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((st,rt)=>{let Pe;st.command&&(_e||(_e=new c.$Sc),Pe=this.j.toInternal(st.command,_e));const Ue=st.insertText;return{insertText:typeof Ue=="string"?Ue:{snippet:Ue.value},filterText:st.filterText,range:st.range?f.Range.from(st.range):void 0,command:Pe,idx:rt,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:He.map(st=>(_e||(_e=new c.$Sc),this.j.toInternal(st,_e))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Z,te){const V=this.d.get(B)?.items[Z];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,te)}handlePartialAccept(B,Z,te){const V=this.d.get(B)?.items[Z];V&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(V,te)}}class W{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Z=this.e++;return this.d.set(Z,B),Z}disposeReferenceId(B){const Z=this.d.get(B);return this.d.delete(B),Z}get(B){return this.d.get(B)}}class ie{constructor(B,Z){this.e=B,this.f=Z,this.d=new i.$Mgc("SignatureHelp")}async provideSignatureHelp(B,Z,te,V){const ae=this.e.getDocument(B),he=f.Position.to(Z),Re=this.g(te),je=await this.f.provideSignatureHelp(ae,he,V,Re);if(je){const He=this.d.add([je]);return{...f.SignatureHelp.from(je),id:He}}}g(B){let Z;if(B.activeSignatureHelp){const te=f.SignatureHelp.to(B.activeSignatureHelp),V=this.d.get(B.activeSignatureHelp.id,0);V?(Z=V,Z.activeSignature=te.activeSignature,Z.activeParameter=te.activeParameter):Z=te}return{...B,activeSignatureHelp:Z}}releaseSignatureHelp(B){this.d.delete(B)}}class ye{constructor(B,Z,te,V,ae){this.f=B,this.g=Z,this.h=te,this.j=V,this.k=ae,this.d=new i.$Mgc("InlayHints"),this.e=new Map}async provideInlayHints(B,Z,te){const V=this.f.getDocument(B),ae=f.Range.to(Z),he=await this.h.provideInlayHints(V,ae,te);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Z)}`);return}if(te.isCancellationRequested)return;const Re=this.d.add(he);this.e.set(Re,new c.$Sc);const je={hints:[],cacheId:Re};for(let He=0;He<he.length;He++)this.l(he[He],ae)&&je.hints.push(this.m(he[He],[Re,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Z)}`),je}async resolveInlayHint(B,Z){if(typeof this.h.resolveInlayHint!="function")return;const te=this.d.get(...B);if(!te)return;const V=await this.h.resolveInlayHint(te,Z);if(V&&this.l(V))return this.m(V,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Z){return B.label.length===0||Array.isArray(B.label)&&B.label.every(te=>te.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Z&&!Z.contains(B.position))}m(B,Z){const te=this.e.get(Z[0]);if(!te)throw Error("DisposableStore is missing...");const V={label:"",cacheId:Z,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")V.label=B.label;else{const ae=[];V.label=ae;for(const he of B.label){if(!he.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:he.value,tooltip:f.MarkdownString.fromStrict(he.tooltip)};P.$tL.isLocation(he.location)&&(Re.location=f.location.from(he.location)),he.command&&(Re.command=this.g.toInternal(he.command,te)),ae.push(Re)}}return V}}class de{constructor(B,Z){this.e=B,this.f=Z,this.d=new i.$Mgc("DocumentLink")}async provideLinks(B,Z){const te=this.e.getDocument(B),V=await this.f.provideDocumentLinks(te,Z);if(!(!Array.isArray(V)||V.length===0)&&!Z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(de.g).map(f.DocumentLink.from)};{const ae=this.d.add(V),he={links:[],cacheId:ae};for(let Re=0;Re<V.length;Re++){if(!de.g(V[Re]))continue;const je=f.DocumentLink.from(V[Re]);je.cacheId=[ae,Re],he.links.push(je)}return he}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Z){if(typeof this.f.resolveDocumentLink!="function")return;const te=this.d.get(...B);if(!te)return;const V=await this.f.resolveDocumentLink(te,Z);if(!(!V||!de.g(V)))return f.DocumentLink.from(V)}releaseLinks(B){this.d.delete(B)}}class fe{constructor(B,Z){this.d=B,this.e=Z}async provideColors(B,Z){const te=this.d.getDocument(B),V=await this.e.provideDocumentColors(te,Z);return Array.isArray(V)?V.map(he=>({color:f.Color.from(he.color),range:f.Range.from(he.range)})):[]}async provideColorPresentations(B,Z,te){const V=this.d.getDocument(B),ae=f.Range.to(Z.range),he=f.Color.to(Z.color),Re=await this.e.provideColorPresentations(he,{document:V,range:ae},te);if(Array.isArray(Re))return Re.map(f.ColorPresentation.from)}}class _{constructor(B,Z){this.d=B,this.e=Z}async provideFoldingRanges(B,Z,te){const V=this.d.getDocument(B),ae=await this.e.provideFoldingRanges(V,Z,te);if(Array.isArray(ae))return ae.map(f.FoldingRange.from)}}class ee{constructor(B,Z,te){this.d=B,this.e=Z,this.f=te}async provideSelectionRanges(B,Z,te){const V=this.d.getDocument(B),ae=Z.map(f.Position.to),he=await this.e.provideSelectionRanges(V,ae,te);if(!(0,R.$Lb)(he))return[];if(he.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let je=0;je<ae.length;je++){const He=[];Re.push(He);let Qe=ae[je],_e=he[je];for(;;){if(!_e.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(He.push(f.SelectionRange.from(_e)),!_e.parent)break;Qe=_e.range,_e=_e.parent}}return Re}}class G{constructor(B,Z){this.f=B,this.g=Z,this.d=new o.$pN(""),this.e=new Map}async prepareSession(B,Z,te){const V=this.f.getDocument(B),ae=f.Position.to(Z),he=await this.g.prepareCallHierarchy(V,ae,te);if(!he)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(he)?he.map(je=>this.h(Re,je)):[this.h(Re,he)]}async provideCallsTo(B,Z,te){const V=this.j(B,Z);if(!V)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(V,te);if(ae)return ae.map(he=>({from:this.h(B,he.from),fromRanges:he.fromRanges.map(Re=>f.Range.from(Re))}))}async provideCallsFrom(B,Z,te){const V=this.j(B,Z);if(!V)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(V,te);if(ae)return ae.map(he=>({to:this.h(B,he.to),fromRanges:he.fromRanges.map(Re=>f.Range.from(Re))}))}releaseSession(B){this.e.delete(B)}h(B,Z){const te=this.e.get(B),V=f.CallHierarchyItem.from(Z,B,te.size.toString(36));return te.set(V._itemId,Z),V}j(B,Z){return this.e.get(B)?.get(Z)}}class x{constructor(B,Z){this.f=B,this.g=Z,this.d=new o.$pN(""),this.e=new Map}async prepareSession(B,Z,te){const V=this.f.getDocument(B),ae=f.Position.to(Z),he=await this.g.prepareTypeHierarchy(V,ae,te);if(!he)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(he)?he.map(je=>this.h(Re,je)):[this.h(Re,he)]}async provideSupertypes(B,Z,te){const V=this.j(B,Z);if(!V)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(V,te);if(ae)return ae.map(he=>this.h(B,he))}async provideSubtypes(B,Z,te){const V=this.j(B,Z);if(!V)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(V,te);if(ae)return ae.map(he=>this.h(B,he))}releaseSession(B){this.e.delete(B)}h(B,Z){const te=this.e.get(B),V=f.TypeHierarchyItem.from(Z,B,te.size.toString(36));return te.set(V._itemId,Z),V}j(B,Z){return this.e.get(B)?.get(Z)}}class me{static toInternalProviderId(B,Z){return B+"."+Z}constructor(B,Z,te,V,ae){this.d=B,this.e=Z,this.f=te,this.g=V,this.h=ae}async provideDocumentOnDropEdits(B,Z,te,V,ae){const he=this.e.getDocument(Z),Re=f.Position.to(te),je=f.DataTransfer.toDataTransfer(V,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentDropEdits(he,Re,je,ae);if(He)return{label:He.label??(0,h.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:me.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?f.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class we{constructor(B,Z){this.d=B,this.e=Z}async provideMappedEdits(B,Z,te,V){const ae=C.URI.revive(B),he=this.d.getDocument(ae),Re=te.documents.map(Qe=>Qe.map(_e=>({uri:C.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(at=>f.Range.to(at))}))),je={documents:Re,selections:Re[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(he,Z,je,V);return He?f.WorkspaceEdit.from(He):null}}class Ae{constructor(B,Z){this.adapter=B,this.extension=Z}}class ve{static{this.d=0}constructor(B,Z,te,V,ae,he,Re,je){this.g=Z,this.h=te,this.j=V,this.k=ae,this.l=he,this.m=Re,this.n=je,this.f=new Map,this.e=B.getProxy(v.$fL.MainThreadLanguageFeatures)}o(B,Z){return f.DocumentSelector.from(B,this.g,Z)}p(B){return new P.$hL(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return ve.d++}async s(B,Z,te,V,ae,he=!1){const Re=this.f.get(B);if(!Re||!(Re.adapter instanceof Z))return V;const je=Date.now();he||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${te.toString().replace(/[\r\n]/g,"")}'`);const He=te(Re.adapter,Re.extension);return Promise.resolve(He).catch(Qe=>{(0,n.$4)(Qe)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(Re.extension.identifier,Qe))}).finally(()=>{he||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),k.CancellationToken.isCancellationToken(ae)?(0,a.$Wg)(He,ae):He}t(B,Z){const te=this.q();return this.f.set(te,new Ae(B,Z)),te}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Z,te,V){const ae=this.t(new s(this.h,te),B),he=V&&V.label||ve.u(B);return this.e.$registerDocumentSymbolProvider(ae,this.o(Z,B),he),this.p(ae)}$provideDocumentSymbols(B,Z,te){return this.s(B,s,V=>V.provideDocumentSymbols(C.URI.revive(Z),te),void 0,te)}registerCodeLensProvider(B,Z,te){const V=this.q(),ae=typeof te.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new Ae(new d(this.h,this.j.converter,te,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(V,this.o(Z,B),ae);let he=this.p(V);if(ae!==void 0){const Re=te.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ae));he=P.$hL.from(he,Re)}return he}$provideCodeLenses(B,Z,te){return this.s(B,d,V=>V.provideCodeLenses(C.URI.revive(Z),te),void 0,te)}$resolveCodeLens(B,Z,te){return this.s(B,d,V=>V.resolveCodeLens(Z,te),void 0,void 0)}$releaseCodeLenses(B,Z){this.s(B,d,te=>Promise.resolve(te.releaseCodeLenses(Z)),void 0,void 0)}registerDefinitionProvider(B,Z,te){const V=this.t(new u(this.h,te),B);return this.e.$registerDefinitionSupport(V,this.o(Z,B)),this.p(V)}$provideDefinition(B,Z,te,V){return this.s(B,u,ae=>ae.provideDefinition(C.URI.revive(Z),te,V),[],V)}registerDeclarationProvider(B,Z,te){const V=this.t(new w(this.h,te),B);return this.e.$registerDeclarationSupport(V,this.o(Z,B)),this.p(V)}$provideDeclaration(B,Z,te,V){return this.s(B,w,ae=>ae.provideDeclaration(C.URI.revive(Z),te,V),[],V)}registerImplementationProvider(B,Z,te){const V=this.t(new I(this.h,te),B);return this.e.$registerImplementationSupport(V,this.o(Z,B)),this.p(V)}$provideImplementation(B,Z,te,V){return this.s(B,I,ae=>ae.provideImplementation(C.URI.revive(Z),te,V),[],V)}registerTypeDefinitionProvider(B,Z,te){const V=this.t(new b(this.h,te),B);return this.e.$registerTypeDefinitionSupport(V,this.o(Z,B)),this.p(V)}$provideTypeDefinition(B,Z,te,V){return this.s(B,b,ae=>ae.provideTypeDefinition(C.URI.revive(Z),te,V),[],V)}registerHoverProvider(B,Z,te,V){const ae=this.t(new m(this.h,te),B);return this.e.$registerHoverProvider(ae,this.o(Z,B)),this.p(ae)}$provideHover(B,Z,te,V){return this.s(B,m,ae=>ae.provideHover(C.URI.revive(Z),te,V),void 0,V)}registerEvaluatableExpressionProvider(B,Z,te,V){const ae=this.t(new y(this.h,te),B);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(Z,B)),this.p(ae)}$provideEvaluatableExpression(B,Z,te,V){return this.s(B,y,ae=>ae.provideEvaluatableExpression(C.URI.revive(Z),te,V),void 0,V)}registerInlineValuesProvider(B,Z,te,V){const ae=typeof te.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new L(this.h,te),B);this.e.$registerInlineValuesProvider(he,this.o(Z,B),ae);let Re=this.p(he);if(ae!==void 0){const je=te.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ae));Re=P.$hL.from(Re,je)}return Re}$provideInlineValues(B,Z,te,V,ae){return this.s(B,L,he=>he.provideInlineValues(C.URI.revive(Z),te,V,ae),void 0,ae)}registerDocumentHighlightProvider(B,Z,te){const V=this.t(new N(this.h,te),B);return this.e.$registerDocumentHighlightProvider(V,this.o(Z,B)),this.p(V)}registerMultiDocumentHighlightProvider(B,Z,te){const V=this.t(new U(this.h,te),B);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(Z,B)),this.p(V)}$provideDocumentHighlights(B,Z,te,V){return this.s(B,N,ae=>ae.provideDocumentHighlights(C.URI.revive(Z),te,V),void 0,V)}$provideMultiDocumentHighlights(B,Z,te,V,ae){return this.s(B,U,he=>he.provideMultiDocumentHighlights(C.URI.revive(Z),te,V.map(Re=>C.URI.revive(Re)),ae),void 0,ae)}registerLinkedEditingRangeProvider(B,Z,te){const V=this.t(new T(this.h,te),B);return this.e.$registerLinkedEditingRangeProvider(V,this.o(Z,B)),this.p(V)}$provideLinkedEditingRanges(B,Z,te,V){return this.s(B,T,async ae=>{const he=await ae.provideLinkedEditingRanges(C.URI.revive(Z),te,V);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?ve.w(he.wordPattern):void 0}},void 0,V)}registerReferenceProvider(B,Z,te){const V=this.t(new O(this.h,te),B);return this.e.$registerReferenceSupport(V,this.o(Z,B)),this.p(V)}$provideReferences(B,Z,te,V,ae){return this.s(B,O,he=>he.provideReferences(C.URI.revive(Z),te,V,ae),void 0,ae)}registerCodeActionProvider(B,Z,te,V){const ae=new c.$Sc,he=this.t(new M(this.h,this.j.converter,this.k,te,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(he,this.o(Z,B),{providedKinds:V?.providedCodeActionKinds?.map(Re=>Re.value),documentation:V?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ae)}))},ve.u(B),!!te.resolveCodeAction),ae.add(this.p(he)),ae}$provideCodeActions(B,Z,te,V,ae){return this.s(B,M,he=>he.provideCodeActions(C.URI.revive(Z),te,V,ae),void 0,ae)}$resolveCodeAction(B,Z,te){return this.s(B,M,V=>V.resolveCodeAction(Z,te),{},void 0)}$releaseCodeActions(B,Z){this.s(B,M,te=>Promise.resolve(te.releaseCodeActions(Z)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Z,te){const V=this.t(new z(this.h,te),B);return this.e.$registerDocumentFormattingSupport(V,this.o(Z,B),B.identifier,B.displayName||B.name),this.p(V)}$provideDocumentFormattingEdits(B,Z,te,V){return this.s(B,z,ae=>ae.provideDocumentFormattingEdits(C.URI.revive(Z),te,V),void 0,V)}registerDocumentRangeFormattingEditProvider(B,Z,te){const V=typeof te.provideDocumentRangesFormattingEdits=="function",ae=this.t(new J(this.h,te),B);return this.e.$registerRangeFormattingSupport(ae,this.o(Z,B),B.identifier,B.displayName||B.name,V),this.p(ae)}$provideDocumentRangeFormattingEdits(B,Z,te,V,ae){return this.s(B,J,he=>he.provideDocumentRangeFormattingEdits(C.URI.revive(Z),te,V,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(B,Z,te,V,ae){return this.s(B,J,he=>he.provideDocumentRangesFormattingEdits(C.URI.revive(Z),te,V,ae),void 0,ae)}registerOnTypeFormattingEditProvider(B,Z,te,V){const ae=this.t(new le(this.h,te),B);return this.e.$registerOnTypeFormattingSupport(ae,this.o(Z,B),V,B.identifier),this.p(ae)}$provideOnTypeFormattingEdits(B,Z,te,V,ae,he){return this.s(B,le,Re=>Re.provideOnTypeFormattingEdits(C.URI.revive(Z),te,V,ae,he),void 0,he)}registerWorkspaceSymbolProvider(B,Z){const te=this.t(new Y(Z,this.l),B);return this.e.$registerNavigateTypeSupport(te,typeof Z.resolveWorkspaceSymbol=="function"),this.p(te)}$provideWorkspaceSymbols(B,Z,te){return this.s(B,Y,V=>V.provideWorkspaceSymbols(Z,te),{symbols:[]},te)}$resolveWorkspaceSymbol(B,Z,te){return this.s(B,Y,V=>V.resolveWorkspaceSymbol(Z,te),void 0,void 0)}$releaseWorkspaceSymbols(B,Z){this.s(B,Y,te=>te.releaseWorkspaceSymbols(Z),void 0,void 0)}registerRenameProvider(B,Z,te){const V=this.t(new Q(this.h,te,this.l),B);return this.e.$registerRenameSupport(V,this.o(Z,B),Q.supportsResolving(te)),this.p(V)}$provideRenameEdits(B,Z,te,V,ae){return this.s(B,Q,he=>he.provideRenameEdits(C.URI.revive(Z),te,V,ae),void 0,ae)}$resolveRenameLocation(B,Z,te,V){return this.s(B,Q,ae=>ae.resolveRenameLocation(C.URI.revive(Z),te,V),void 0,V)}registerDocumentSemanticTokensProvider(B,Z,te,V){const ae=this.t(new ue(this.h,te),B),he=typeof te.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(Z,B),V,he);let Re=this.p(ae);if(he){const je=te.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(he));Re=P.$hL.from(Re,je)}return Re}$provideDocumentSemanticTokens(B,Z,te,V){return this.s(B,ue,ae=>ae.provideDocumentSemanticTokens(C.URI.revive(Z),te,V),null,V)}$releaseDocumentSemanticTokens(B,Z){this.s(B,ue,te=>te.releaseDocumentSemanticColoring(Z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Z,te,V){const ae=this.t(new ne(this.h,te),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(Z,B),V),this.p(ae)}$provideDocumentRangeSemanticTokens(B,Z,te,V){return this.s(B,ne,ae=>ae.provideDocumentRangeSemanticTokens(C.URI.revive(Z),te,V),null,V)}registerCompletionItemProvider(B,Z,te,V){const ae=this.t(new $e(this.h,this.j.converter,te,this.m,B),B);return this.e.$registerCompletionsProvider(ae,this.o(Z,B),V,$e.supportsResolving(te),B.identifier),this.p(ae)}$provideCompletionItems(B,Z,te,V,ae){return this.s(B,$e,he=>he.provideCompletionItems(C.URI.revive(Z),te,V,ae),void 0,ae)}$resolveCompletionItem(B,Z,te){return this.s(B,$e,V=>V.resolveCompletionItem(Z,te),void 0,te)}$releaseCompletionItems(B,Z){this.s(B,$e,te=>te.releaseCompletionItems(Z),void 0,void 0)}registerInlineCompletionsProvider(B,Z,te,V){const ae=new K(B,this.h,te,this.j.converter),he=this.t(ae,B);return this.e.$registerInlineCompletionsSupport(he,this.o(Z,B),ae.supportsHandleEvents,S.$mm.toKey(B.identifier.value),V?.yieldTo?.map(Re=>S.$mm.toKey(Re))||[]),this.p(he)}$provideInlineCompletions(B,Z,te,V,ae){return this.s(B,oe,he=>he.provideInlineCompletions(C.URI.revive(Z),te,V,ae),void 0,ae)}$handleInlineCompletionDidShow(B,Z,te,V){this.s(B,oe,async ae=>{ae.handleDidShowCompletionItem(Z,te,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Z,te,V){this.s(B,oe,async ae=>{ae.handlePartialAccept(Z,te,V)},void 0,void 0)}$freeInlineCompletionsList(B,Z){this.s(B,oe,async te=>{te.disposeCompletions(Z)},void 0,void 0)}registerSignatureHelpProvider(B,Z,te,V){const ae=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,he=this.t(new ie(this.h,te),B);return this.e.$registerSignatureHelpProvider(he,this.o(Z,B),ae),this.p(he)}$provideSignatureHelp(B,Z,te,V,ae){return this.s(B,ie,he=>he.provideSignatureHelp(C.URI.revive(Z),te,V,ae),void 0,ae)}$releaseSignatureHelp(B,Z){this.s(B,ie,te=>te.releaseSignatureHelp(Z),void 0,void 0)}registerInlayHintsProvider(B,Z,te){const V=typeof te.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new ye(this.h,this.j.converter,te,this.l,B),B);this.e.$registerInlayHintsProvider(ae,this.o(Z,B),typeof te.resolveInlayHint=="function",V,ve.u(B));let he=this.p(ae);if(V!==void 0){const Re=te.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(V));he=P.$hL.from(he,Re)}return he}$provideInlayHints(B,Z,te,V){return this.s(B,ye,ae=>ae.provideInlayHints(C.URI.revive(Z),te,V),void 0,V)}$resolveInlayHint(B,Z,te){return this.s(B,ye,V=>V.resolveInlayHint(Z,te),void 0,te)}$releaseInlayHints(B,Z){this.s(B,ye,te=>te.releaseHints(Z),void 0,void 0)}registerDocumentLinkProvider(B,Z,te){const V=this.t(new de(this.h,te),B);return this.e.$registerDocumentLinkProvider(V,this.o(Z,B),typeof te.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(B,Z,te){return this.s(B,de,V=>V.provideLinks(C.URI.revive(Z),te),void 0,te,Z.scheme==="output")}$resolveDocumentLink(B,Z,te){return this.s(B,de,V=>V.resolveLink(Z,te),void 0,void 0,!0)}$releaseDocumentLinks(B,Z){this.s(B,de,te=>te.releaseLinks(Z),void 0,void 0,!0)}registerColorProvider(B,Z,te){const V=this.t(new fe(this.h,te),B);return this.e.$registerDocumentColorProvider(V,this.o(Z,B)),this.p(V)}$provideDocumentColors(B,Z,te){return this.s(B,fe,V=>V.provideColors(C.URI.revive(Z),te),[],te)}$provideColorPresentations(B,Z,te,V){return this.s(B,fe,ae=>ae.provideColorPresentations(C.URI.revive(Z),te,V),void 0,V)}registerFoldingRangeProvider(B,Z,te){const V=this.q(),ae=typeof te.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new Ae(new _(this.h,te),B)),this.e.$registerFoldingRangeProvider(V,this.o(Z,B),B.identifier,ae);let he=this.p(V);if(ae!==void 0){const Re=te.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));he=P.$hL.from(he,Re)}return he}$provideFoldingRanges(B,Z,te,V){return this.s(B,_,ae=>ae.provideFoldingRanges(C.URI.revive(Z),te,V),void 0,V)}registerSelectionRangeProvider(B,Z,te){const V=this.t(new ee(this.h,te,this.l),B);return this.e.$registerSelectionRangeProvider(V,this.o(Z,B)),this.p(V)}$provideSelectionRanges(B,Z,te,V){return this.s(B,ee,ae=>ae.provideSelectionRanges(C.URI.revive(Z),te,V),[],V)}registerCallHierarchyProvider(B,Z,te){const V=this.t(new G(this.h,te),B);return this.e.$registerCallHierarchyProvider(V,this.o(Z,B)),this.p(V)}$prepareCallHierarchy(B,Z,te,V){return this.s(B,G,ae=>Promise.resolve(ae.prepareSession(C.URI.revive(Z),te,V)),void 0,V)}$provideCallHierarchyIncomingCalls(B,Z,te,V){return this.s(B,G,ae=>ae.provideCallsTo(Z,te,V),void 0,V)}$provideCallHierarchyOutgoingCalls(B,Z,te,V){return this.s(B,G,ae=>ae.provideCallsFrom(Z,te,V),void 0,V)}$releaseCallHierarchy(B,Z){this.s(B,G,te=>Promise.resolve(te.releaseSession(Z)),void 0,void 0)}registerTypeHierarchyProvider(B,Z,te){const V=this.t(new x(this.h,te),B);return this.e.$registerTypeHierarchyProvider(V,this.o(Z,B)),this.p(V)}$prepareTypeHierarchy(B,Z,te,V){return this.s(B,x,ae=>Promise.resolve(ae.prepareSession(C.URI.revive(Z),te,V)),void 0,V)}$provideTypeHierarchySupertypes(B,Z,te,V){return this.s(B,x,ae=>ae.provideSupertypes(Z,te,V),void 0,V)}$provideTypeHierarchySubtypes(B,Z,te,V){return this.s(B,x,ae=>ae.provideSubtypes(Z,te,V),void 0,V)}$releaseTypeHierarchy(B,Z){this.s(B,x,te=>Promise.resolve(te.releaseSession(Z)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Z,te,V){const ae=this.q();this.f.set(ae,new Ae(new me(this.e,this.h,te,ae,B),B));const he=(0,t.$JF)(B,"dropMetadata")&&V?me.toInternalProviderId(B.identifier.value,V.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ae,this.o(Z,B),he,(0,t.$JF)(B,"dropMetadata")?V:void 0),this.p(ae)}$provideDocumentOnDropEdits(B,Z,te,V,ae,he){return this.s(B,me,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(Z,C.URI.revive(te),V,ae,he)),void 0,void 0)}registerMappedEditsProvider(B,Z,te){const V=this.t(new we(this.h,te),B);return this.e.$registerMappedEditsProvider(V,this.o(Z,B)),this.p(V)}$provideMappedEdits(B,Z,te,V,ae){return this.s(B,we,he=>Promise.resolve(he.provideMappedEdits(Z,te,V,ae)),null,ae)}registerDocumentPasteEditProvider(B,Z,te,V){const ae=this.q();this.f.set(ae,new Ae(new j(this.e,this.h,te,ae,B),B));const he=j.toInternalProviderId(B.identifier.value,V.id);return this.e.$registerPasteEditProvider(ae,this.o(Z,B),he,{supportsCopy:!!te.prepareDocumentPaste,supportsPaste:!!te.provideDocumentPasteEdits,copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(ae)}$prepareDocumentPaste(B,Z,te,V,ae){return this.s(B,j,he=>he.prepareDocumentPaste(C.URI.revive(Z),te,V,ae),void 0,ae)}$providePasteEdits(B,Z,te,V,ae,he){return this.s(B,j,Re=>Re.providePasteEdits(Z,C.URI.revive(te),V,ae,he),void 0,he)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:ve.w(B.decreaseIndentPattern),increaseIndentPattern:ve.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ve.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ve.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:ve.w(B.beforeText),afterText:B.afterText?ve.w(B.afterText):void 0,previousLineText:B.previousLineText?ve.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(ve.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Z=>P.SyntaxTokenType.toString(Z)):void 0}}static D(B){return B.map(ve.C)}setLanguageConfiguration(B,Z,te){const{wordPattern:V}=te;if(V&&(0,$.$Ze)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(Z,V):this.h.setWordDefinitionFor(Z,void 0),te.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),te.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ae=this.q(),he={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?ve.w(te.wordPattern):void 0,indentationRules:te.indentationRules?ve.y(te.indentationRules):void 0,onEnterRules:te.onEnterRules?ve.B(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport,autoClosingPairs:te.autoClosingPairs?ve.D(te.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ae,Z,he),this.p(ae)}$setWordDefinitions(B){for(const Z of B)this.h.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.$Wgc=ve}),define(Ee[330],Se([1,0,6,15,7,39,11,3,26]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;class E{constructor(D,p,k,S){this.c=p,this.d=k,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(C.$fL.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,p){await this.a.$changeLanguage(D,p);const k=this.c.getDocumentData(D);if(!k)throw new Error(`document '${D.toString()}' NOT found`);return k.document}async tokenAtPosition(D,p){const k=D.version,S=F.Position.from(p),c=await this.a.$tokensAtPosition(D.uri,S),g={type:f.StandardTokenType.Other,range:D.getWordRangeAtPosition(p)??new f.$jL(p.line,p.character,p.line,p.character)};if(!c)return g;const o={range:F.Range.to(c.range),type:F.TokenType.to(c.type)};return!o.range.contains(p)||k!==D.version?g:o}createLanguageStatusItem(D,p,k){const S=this.f++,c=this.a,g=this.g,o=`${D.identifier.value}/${p}`;if(g.has(o))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);g.add(o);const i={selector:k,id:p,name:D.displayName??D.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const n=new v.$Sc,a=()=>{if(r?.dispose(),!g.has(o)){console.warn(`LanguageStatusItem (${p}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,A.$9g)(()=>{n.clear(),this.a.$setLanguageStatus(S,{id:o,name:i.name??D.displayName??D.name,source:D.displayName??D.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?P.default.Error:i.severity===f.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:i.command&&this.d.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),r?.dispose(),c.$removeLanguageStatus(S),g.delete(o)},get id(){return i.id},get name(){return i.name},set name(h){i.name=h,a()},get selector(){return i.selector},set selector(h){i.selector=h,a()},get text(){return i.text},set text(h){i.text=h,a()},set text2(h){(0,$.$KF)(D,"languageStatusText"),i.text=h,a()},get text2(){return(0,$.$KF)(D,"languageStatusText"),i.text},get detail(){return i.detail},set detail(h){i.detail=h,a()},get severity(){return i.severity},set severity(h){i.severity=h,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(h){i.accessibilityInformation=h,a()},get command(){return i.command},set command(h){i.command=h,a()},get busy(){return i.busy},set busy(h){i.busy=h,a()}};return a(),t}}e.$jic=E}),define(Ee[331],Se([1,0,16,2,15,7,118]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=e.$7hc=void 0;class v{constructor(D,p,k,S){this.start=D,this.deletedCount=p,this.deletedItems=k,this.items=S}asApiEvent(){return{range:new P.$GM(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(D,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,p,k){this.notebook=D,this.h=p,this.j=k,this.handle=k.handle,this.uri=F.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(f.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return D.g},set mime(S){D.g=S},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(k)}return this.f}setOutputs(D){this.a=D.map(f.NotebookCellOutput.to)}setOutputItems(D,p,k){const S=k.map(f.NotebookCellOutputItem.to),c=this.a.find(g=>g.id===D);if(c&&(p||(c.items.length=0),c.items.push(...S),c.items.length>1&&c.items.every(g=>A.$iJ(g.mime)))){const g=new Map,o=[];c.items.forEach(i=>{let r;g.has(i.mime)?r=g.get(i.mime):(r=[],g.set(i.mime,r),o.push(i.mime)),r.push(i.data)}),c.items.length=0,o.forEach(i=>{const r=A.$jJ(g.get(i));c.items.push({mime:i,data:r.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$7hc=$;class E{static{this.a=0}constructor(D,p,k,S,c){this.k=D,this.l=p,this.m=k,this.uri=S,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,p={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===C.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(k){return k=D.n(k),D.b[k].apiCell},getCells(k){return(k?D.p(k):D.b).map(c=>c.apiCell)},save(){return D.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,p,k){this.g=D.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:k});const S={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},c=[];for(const o of D.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),c.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),c.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),c.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),c.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),c.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const g=new Map;for(let o=0;o<c.length;o++){const i=c[o],r=g.get(i.cell);if(r===void 0){const n=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});g.set(i.cell,n-1)}else S.cellChanges[r]={...S.cellChanges[r],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let p=D.start|0,k=D.end|0;return p<0&&(p=0),k>this.b.length&&(k=this.b.length),D.with({start:p,end:k})}p(D){D=this.o(D);const p=[];for(let k=D.start;k<D.end;k++)p.push(this.b[k]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,p,k){if(this.j)return;const S=[],c=[],g=[];if(D.reverse().forEach(o=>{const r=o[2].map(t=>{const h=new $(this,this.l,t);return p||c.push($.asModelAddData(this.apiNotebook,t)),h}),n=new v(o[0],o[1],[],r),a=this.b.splice(o[0],o[1],...r);for(const t of a)g.push(t.uri),n.deletedItems.push(t.apiCell);S.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:g}),k)for(const o of S)k.push(o.asApiEvent())}s(D,p,k,S){const c=this.b.splice(D,p);this.b.splice(k,0,...c);const g=[new v(D,p,c.map(o=>o.apiCell),[]),new v(k,0,[],c)];for(const o of g)S.push(o.asApiEvent())}t(D,p){this.b[D].setOutputs(p)}u(D,p,k,S){this.b[D].setOutputItems(p,k,S)}v(D,p){const k=this.b[D];k.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(k.uri,p)}w(D,p){const k=this.b[D];k.apiCell.mime=p}x(D,p){this.b[D].setMetadata(p)}y(D,p){this.b[D].setInternalMetadata(p)}getCellFromApiCell(D){return this.b.find(p=>p.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(p=>p.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$8hc=E}),define(Ee[332],Se([1,0,4,2,15,7]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;class A{constructor($,E,R,D={timeout:1500,errors:3}){this.b=$,this.c=E,this.d=R,this.f=D,this.a=new C.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(E,R,D)=>{const p=function(S){E.call(R,S)};return p.extension=$,this.a.event(p,void 0,D)}}async $participateInSave($,E,R){const D=F.URI.revive($),p=this.c.getNotebookDocument(D);if(!p)throw new Error("Unable to resolve notebook document");const k=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:f.TextDocumentSaveReason.to(E)},R,async(c,g)=>{const o=Date.now(),i=await await Promise.resolve(c);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof P.$rL?k.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(k.length===0)return!0;const S={edits:[]};for(const c of k){const{edits:g}=f.WorkspaceEdit.from(c);S.edits=S.edits.concat(g)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$lic=A}),define(Ee[149],Se([1,0,14,15,7]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(v,$,E,R,D,p){this.id=v,this.f=$,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=R,this.c=p}get apiEditor(){if(!this.e){const v=this;this.e={get notebook(){return v.notebookData.apiNotebook},get selection(){return v.a[0]},set selection($){this.selections=[$]},get selections(){return v.a},set selections($){if(!Array.isArray($)||!$.every(f.$GM.isNotebookRange))throw(0,C.$7)("selections");v.a=$,v.g($)},get visibleRanges(){return v.b},revealRange($,E){v.f.$tryRevealRange(v.id,F.NotebookRange.from($),E??f.NotebookEditorRevealType.Default)},get viewColumn(){return v.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(v){this.d=v}_acceptVisibleRanges(v){this.b=v}_acceptSelections(v){this.a=v}g(v){this.f.$trySetSelections(this.id,v.map(F.NotebookRange.from))}_acceptViewColumn(v){this.c=v}}e.$9hc=P}),define(Ee[333],Se([1,0,4,13,15]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;let P=class{constructor(v,$){this.c=v,this.d=$,this.a=new C.$Wd,this.b=new C.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(v,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,$);const E=this.d.getEditorById(v);$.visibleRanges&&E._acceptVisibleRanges($.visibleRanges.ranges.map(f.NotebookRange.to)),$.selections&&E._acceptSelections($.selections.selections.map(f.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const $ in v)this.d.getEditorById($)._acceptViewColumn(f.ViewColumn.to(v[$]))}};e.$nic=P,e.$nic=P=Ge([qe(0,F.$oj)],P)}),define(Ee[334],Se([1,0,4,6,149]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;class P{constructor(v,$){this.c=$,this.a=new Map,this.b=v.getProxy(F.$fL.MainThreadNotebookRenderers)}$postRendererMessage(v,$,E){const R=this.c.getEditorById(v);this.a.get($)?.fire({editor:R.apiEditor,message:E})}createRendererMessaging(v,$){if(!v.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,D,p)=>this.d($).event(R,D,p),postMessage:(R,D)=>{f.$9hc.apiEditorsToExtHost.has(R)&&([R,D]=[D,R]);const p=D&&f.$9hc.apiEditorsToExtHost.get(D);return this.b.$postMessage(p?.id,$,R)}}}d(v){let $=this.a.get(v);return $||($=new C.$Wd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(v)}}),this.a.set(v,$),$)}}e.$qic=P}),define(Ee[335],Se([1,0,15,86,21,52,14]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;class v{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,p,k){const S=this.b++,{title:c,location:g,cancellable:o}=p,i={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(S,{location:C.ProgressLocation.from(g),title:c,source:i,cancellable:o},D.isUnderDevelopment?void 0:D.identifier.value).catch(A.$2),this.d(S,k,!!o)}d(D,p,k){let S;k&&(S=new f.$7d,this.c.set(D,S));const c=o=>{this.a.$progressEnd(o),this.c.delete(o),S?.dispose()};let g;try{g=p(new E(this.a,D),k&&S?S.token:f.CancellationToken.None)}catch(o){throw c(D),o}return g.then(o=>c(D),o=>c(D)),g}$acceptProgressCanceled(D){const p=this.c.get(D);p&&(p.cancel(),this.c.delete(D))}}e.$uic=v;function $(R,D){return R.message=D.message,typeof D.increment=="number"&&(typeof R.increment=="number"?R.increment+=D.increment:R.increment=D.increment),R}class E extends F.$wv{constructor(D,p){super(k=>this.throttledReport(k)),this.c=D,this.d=p}throttledReport(D){this.c.$progressReport(this.d,D)}}Ge([(0,P.$Ah)(100,(R,D)=>$(R,D),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Ee[336],Se([1,0,2,6,11,15]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;class A{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(F.$fL.MainThreadQuickDiff)}$provideOriginalResource($,E,R){const D=C.URI.revive(E),p=this.c.get($);return p?(0,f.$Zg)(()=>p.provideOriginalResource(D,R)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider($,E,R,D){const p=A.a++;return this.c.set(p,E),this.b.$registerQuickDiffProvider(p,P.DocumentSelector.from($,this.d),R,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$vic=A}),define(Ee[337],Se([1,0,21,4,3,6,2,7,14,19,39,55,26,15]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;function S(c,g,o){const i=c.getProxy(P.$fL.MainThreadQuickOpen);class r{constructor(w,I){this.e=new Map,this.f=0,this.a=w,this.b=I}showQuickPick(w,I,b,m=C.CancellationToken.None){this.c=void 0;const y=Promise.resolve(I),L=++this.f,N=i.$show(L,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},m),U={},T=N.then(()=>U);return Promise.race([T,y]).then(O=>{if(O===U)return;const M=(0,p.$JF)(w,"quickPickItemTooltip");return y.then(j=>{const z=[];for(let J=0;J<j.length;J++){const le=j[J];if(typeof le=="string")z.push({label:le,handle:J});else if(le.kind===v.QuickPickItemKind.Separator)z.push({type:"separator",label:le.label});else{le.tooltip&&!M&&console.warn(`Extension '${w.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`);const Y=le.iconPath?s(le.iconPath):void 0;z.push({label:le.label,iconPath:Y?.iconPath,iconClass:Y?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:M?k.MarkdownString.fromStrict(le.tooltip):void 0,handle:J})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=J=>{b.onDidSelectItem(j[J])}),i.$setItems(L,z),N.then(J=>{if(typeof J=="number")return j[J];if(Array.isArray(J))return J.map(le=>j[le])})})}).then(void 0,O=>{if(!(0,$.$4)(O))return i.$setError(L,O),Promise.reject(O)})}$onItemSelected(w){this.c?.(w)}showInput(w,I=C.CancellationToken.None){return this.d=w?.validateInput,i.$input(w,typeof this.d=="function",I).then(void 0,b=>{if(!(0,$.$4)(b))return Promise.reject(b)})}async $validateInput(w){if(!this.d)return;const I=await this.d(w);if(!I||typeof I=="string")return I;let b;switch(I.severity){case v.InputBoxValidationSeverity.Info:b=R.default.Info;break;case v.InputBoxValidationSeverity.Warning:b=R.default.Warning;break;case v.InputBoxValidationSeverity.Error:b=R.default.Error;break;default:b=I.message?R.default.Error:R.default.Ignore;break}return{content:I.message,severity:b}}async showWorkspaceFolderPick(w,I=C.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[w]);if(!b)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(y=>y.uri.toString()===b.uri.toString())}createQuickPick(w){const I=new d(w,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(w){const I=new l(w,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(w,I){this.e.get(w)?._fireDidChangeValue(I)}$onDidAccept(w){this.e.get(w)?._fireDidAccept()}$onDidChangeActive(w,I){const b=this.e.get(w);b instanceof d&&b._fireDidChangeActive(I)}$onDidChangeSelection(w,I){const b=this.e.get(w);b instanceof d&&b._fireDidChangeSelection(I)}$onDidTriggerButton(w,I){this.e.get(w)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(w,I,b){const m=this.e.get(w);m instanceof d&&m._fireDidTriggerItemButton(I,b)}$onDidHide(w){this.e.get(w)?._fireDidHide()}}class n{static{this.a=1}constructor(w,I){this.x=w,this.y=I,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Wd,this.q=new F.$Wd,this.r=new F.$Wd,this.s=new F.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(w){this.b=w,this.z({title:w})}get step(){return this.c}set step(w){this.c=w,this.z({step:w})}get totalSteps(){return this.d}set totalSteps(w){this.d=w,this.z({totalSteps:w})}get enabled(){return this.g}set enabled(w){this.g=w,this.z({enabled:w})}get busy(){return this.j}set busy(w){this.j=w,this.z({busy:w})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(w){this.k=w,this.z({ignoreFocusOut:w})}get value(){return this.l}set value(w){this.l=w,this.z({value:w})}get placeholder(){return this.m}set placeholder(w){this.m=w,this.z({placeholder:w})}get buttons(){return this.n}set buttons(w){this.n=w.slice(),this.o.clear(),w.forEach((I,b)=>{const m=I===v.$DM.Back?-1:b;this.o.set(m,I)}),this.z({buttons:w.map((I,b)=>({...s(I.iconPath),tooltip:I.tooltip,handle:I===v.$DM.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(w){this.l=w,this.q.fire(w)}_fireDidTriggerButton(w){const I=this.o.get(w);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(w){if(!this.v){for(const I of Object.keys(w)){const b=w[I];this.u[I]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(u){if(u instanceof v.$cM)return{id:u.id};const w=h(u),I=t(u);return{dark:typeof w=="string"?A.URI.file(w):w,light:typeof I=="string"?A.URI.file(I):I}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function h(u){return typeof u=="object"&&"dark"in u?u.dark:u}function s(u){const w=a(u);let I,b;return"id"in w?b=D.ThemeIcon.asClassName(w):I=w,{iconPath:I,iconClass:b}}class d extends n{constructor(w,I){super(w.identifier,I),this.O=w,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Wd,this.L=[],this.M=new F.$Wd,this.N=new F.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(w){this.B=w.slice(),this.C.clear(),this.D.clear(),w.forEach((m,y)=>{this.C.set(y,m),this.D.set(m,y)});const I=(0,p.$JF)(this.O,"quickPickItemTooltip"),b=[];for(let m=0;m<w.length;m++){const y=w[m];if(y.kind===v.QuickPickItemKind.Separator)b.push({type:"separator",label:y.label});else{y.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=y.iconPath?s(y.iconPath):void 0;b.push({handle:m,label:y.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:I?k.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((N,U)=>({...s(N.iconPath),tooltip:N.tooltip,handle:U}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(w){this.E=w,this.z({canSelectMany:w})}get matchOnDescription(){return this.F}set matchOnDescription(w){this.F=w,this.z({matchOnDescription:w})}get matchOnDetail(){return this.G}set matchOnDetail(w){this.G=w,this.z({matchOnDetail:w})}get sortByLabel(){return this.H}set sortByLabel(w){this.H=w,this.z({sortByLabel:w})}get keepScrollPosition(){return this.I}set keepScrollPosition(w){this.I=w,this.z({keepScrollPosition:w})}get activeItems(){return this.J}set activeItems(w){this.J=w.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(w){this.L=w.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(w){const I=(0,E.$Hb)(w.map(b=>this.C.get(b)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(w){const I=(0,E.$Hb)(w.map(b=>this.C.get(b)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(w,I){const b=this.C.get(w);if(!b||!b.buttons||!b.buttons.length)return;const m=b.buttons[I];m&&this.N.fire({button:m,item:b})}}class l extends n{constructor(w,I){super(w.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(w){this.B=w,this.z({password:w})}get prompt(){return this.C}set prompt(w){this.C=w,this.z({prompt:w})}get valueSelection(){return this.D}set valueSelection(w){this.D=w,this.z({valueSelection:w})}get validationMessage(){return this.E}set validationMessage(w){this.E=w,w?typeof w=="string"?this.z({validationMessage:w,severity:R.default.Error}):this.z({validationMessage:w.message,severity:w.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new r(g,o)}e.$wic=S}),define(Ee[338],Se([1,0,2,4,52,3,11,6,19,128,13,25,55,15,26,16,10]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=e.$xic=void 0;function i(L){return L instanceof C.URI}function r(L,N){return L.scheme===c.Schemas.file&&N.scheme===c.Schemas.file&&g.$k?L.toString()===N.toString():L.toString().toLowerCase()===N.toString().toLowerCase()}function n(L){if(L)return typeof L.iconPath=="string"?C.URI.file(L.iconPath):C.URI.isUri(L.iconPath)||p.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function a(L){if(L.icon){if(C.URI.isUri(L.icon))return L.icon;if(p.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const N=L.icon;return{light:N.light,dark:N.dark}}}else return}function t(L,N){if(!L.iconPath&&!N.iconPath)return 0;if(L.iconPath){if(!N.iconPath)return 1}else return-1;const U=typeof L.iconPath=="string"?L.iconPath:C.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,T=typeof N.iconPath=="string"?N.iconPath:C.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,E.$Tq)(U,T)}function h(L,N){let U=0;if(L.strikeThrough!==N.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==N.faded)return L.faded?1:-1;if(L.tooltip!==N.tooltip)return(L.tooltip||"").localeCompare(N.tooltip||"");if(U=t(L,N),U!==0)return U;if(L.light&&N.light)U=t(L.light,N.light);else{if(L.light)return 1;if(N.light)return-1}if(U!==0)return U;if(L.dark&&N.dark)U=t(L.dark,N.dark);else{if(L.dark)return 1;if(N.dark)return-1}return U}function s(L,N){if(L.command!==N.command)return L.command<N.command?-1:1;if(L.title!==N.title)return L.title<N.title?-1:1;if(L.tooltip!==N.tooltip){if(L.tooltip!==void 0&&N.tooltip!==void 0)return L.tooltip<N.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(L.arguments===N.arguments)return 0;if(L.arguments)if(N.arguments){if(L.arguments.length!==N.arguments.length)return L.arguments.length-N.arguments.length}else return 1;else return-1;for(let U=0;U<L.arguments.length;U++){const T=L.arguments[U],O=N.arguments[U];if(T!==O&&!(i(T)&&i(O)&&r(T,O)))return T<O?-1:1}return 0}function d(L,N){let U=(0,E.$Tq)(L.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(U!==0)return U;if(L.command&&N.command)U=s(L.command,N.command);else{if(L.command)return 1;if(N.command)return-1}if(U!==0)return U;if(L.decorations&&N.decorations)U=h(L.decorations,N.decorations);else{if(L.decorations)return 1;if(N.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)U=(0,E.$Tq)(L.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)U=(0,E.$Tq)(L.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return U}function l(L,N){for(let U=0;U<L.length;U++)if(L[U]!==N[U])return!1;return!0}function u(L,N){return L.command===N.command&&L.title===N.title&&L.tooltip===N.tooltip&&(L.arguments&&N.arguments?l(L.arguments,N.arguments):L.arguments===N.arguments)}function w(L,N){return(0,$.$ub)(L,N,u)}class I{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,S.$KF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,S.$KF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,S.$KF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,U,T,O,M){this.k=N,this.l=O,this.m=M,this.d="",this.e=new F.$Wd,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=T}showValidationMessage(N,U){(0,S.$KF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,U)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$xic=I;class b{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,U,T,O,M,j,z){this.q=N,this.s=U,this.t=T,this.u=O,this.v=M,this.multiDiffEditorEnableViewChanges=j,this.w=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=b.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,U){const T=this.h.get(N);return T?(0,A.$Zg)(()=>this.s.executeCommand(T.command,...T.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(d),T=(0,$.$Db)(this.o,N,d).map(j=>{const z=j.toInsert.map(J=>{const le=this.e++;this.g.set(le,J);const Y=J.resourceUri;let Q;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const ee=new P.$Sc;Q=this.s.converter.toInternal(J.command,ee),this.j.set(le,ee)}else this.h.set(le,J.command);const X=(0,S.$JF)(this.w,"scmMultiDiffEditor"),ue=X?J.multiDiffEditorOriginalUri:void 0,ne=X?J.multiFileDiffEditorModifiedUri:void 0,$e=n(J.decorations),oe=J.decorations&&n(J.decorations.light)||$e,K=J.decorations&&n(J.decorations.dark)||$e,W=[oe,K],ie=J.decorations&&J.decorations.tooltip||"",ye=J.decorations&&!!J.decorations.strikeThrough,de=J.decorations&&!!J.decorations.faded,fe=J.contextValue||"";return{rawResource:[le,Y,W,ie,ye,de,fe,Q,ue,ne],handle:le}});return{start:j.start,deleteCount:j.deleteCount,toInsert:z}}),O=T.map(({start:j,deleteCount:z,toInsert:J})=>[j,z,J.map(le=>le.rawResource)]),M=T.reverse();for(const{start:j,deleteCount:z,toInsert:J}of M){const le=J.map(Q=>Q.handle),Y=this.n.splice(j,z,...le);for(const Q of Y)this.g.delete(Q),this.h.delete(Q),this.j.get(Q)?.dispose(),this.j.delete(Q)}return this.o=N,O}dispose(){this.l=!0,this.m.fire()}}class m{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let U;(0,S.$JF)(this.x,"quickDiffProvider")&&(U=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:U})}get historyProvider(){return(0,S.$KF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,S.$KF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new P.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new P.$Sc,this.o=N;const U=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,S.$KF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,S.$KF)(this.x,"scmActionButton"),this.p.value=new P.$Sc,this.q=N;const U=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(T=>T.map(O=>this.y.converter.toInternal(O,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&w(this.t,N))return;this.s.value=new P.$Sc,this.t=N;const U=(N||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(N,U,T,O,M,j,z){this.x=N,this.y=O,this.z=M,this.A=j,this.B=z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Uc,this.m=void 0,this.n=new P.$Uc,this.o=void 0,this.p=new P.$Uc,this.s=new P.$Uc,this.t=void 0,this.u=!1,this.v=new F.$Wd,this.onDidChangeSelection=this.v.event,this.w=m.d++,this.C=new Map,this.D=new Set,this.#e=T;const J=C.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:z?`rootUri=${encodeURIComponent(z.toString())}`:void 0});this.f=new I(N,U,this.#e,this.w,J),this.#e.$registerSourceControl(this.w,M,j,z,J)}createResourceGroup(N,U,T){const O=(0,S.$JF)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,M=new b(this.#e,this.y,this.w,N,U,O,this.x),j=F.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,j),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const N=[],U=[];for(const[T,O]of this.C){O.dispose();const M=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});F.Event.once(T.onDidDispose)(()=>{this.D.delete(T),M.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),N.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const j=T._takeResourceStateSnapshot();j.length>0&&U.push([T.handle,j]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,N,U),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(U=>{const T=U._takeResourceStateSnapshot();T.length!==0&&N.push([U.handle,T])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,f.$zh)(100)],m.prototype,"eventuallyAddResourceGroups",null),Ge([(0,f.$zh)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,U,T,O){this.l=U,this.m=T,this.n=O,this.g=new Map,this.h=new D.$om,this.j=new F.$Wd,this.e=N.getProxy(v.$fL.MainThreadSCM),this.f=N.getProxy(v.$fL.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this.g.get(M.sourceControlHandle);if(!j)return M;const z=j.getResourceGroup(M.groupHandle);return z?z.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this.g.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this.g.get(M.handle);return j||M}return M}})}createSourceControl(N,U,T,O){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,U,T,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const M=o.d++,j=new m(N,this.m,this.e,this.l,U,T,O);this.g.set(M,j);const z=this.h.get(N.identifier)||[];return z.push(j),this.h.set(N.identifier,z),j}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const U=this.h.get(N.identifier),T=U&&U[U.length-1];return T&&T.inputBox}$provideOriginalResource(N,U,T){const O=C.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",N,O.toString());const M=this.g.get(N);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Zg)(()=>M.quickDiffProvider.provideOriginalResource(O,T)).then(j=>j||null)}$onInputBoxValueChange(N,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const T=this.g.get(N);return T&&T.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(N,U,T,O){this.n.trace("ExtHostSCM#$executeResourceCommand",N,U,T);const M=this.g.get(N);if(!M)return Promise.resolve(void 0);const j=M.getResourceGroup(U);return j?j.$executeResourceCommand(T,O):Promise.resolve(void 0)}$validateInput(N,U,T){this.n.trace("ExtHostSCM#$validateInput",N);const O=this.g.get(N);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Zg)(()=>O.inputBox.validateInput(U,T)).then(M=>{if(!M)return Promise.resolve(void 0);const j=k.MarkdownString.fromStrict(M.message);return j?Promise.resolve([j,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,U,T,O){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,T,O)??void 0}async $provideHistoryItems(N,U,T,O){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(U,T,O))?.map(z=>({...z,icon:a(z)}))??void 0}async $provideHistoryItemSummary(N,U,T,O){const M=this.g.get(N)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const j=await M.provideHistoryItemSummary(U,T,O);return j?{...j,icon:a(j)}:void 0}async $provideHistoryItemChanges(N,U,T,O){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(U,T,O)??void 0}};e.$yic=y,e.$yic=y=o=Ge([qe(3,R.$oj)],y)}),define(Ee[339],Se([1,0,6,15,2]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;class P{static{this.a=0}constructor(v,$){this.d=$,this.c=new Map,this.b=v.getProxy(C.$fL.MainThreadShare)}async $provideShare(v,$,E){return await this.c.get(v)?.provideShare({selection:F.Range.to($.selection),resourceUri:f.URI.revive($.resourceUri)},E)??void 0}registerShareProvider(v,$){const E=P.a++;return this.c.set(E,$),this.b.$registerShareProvider(E,F.DocumentSelector.from(v,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$zic=P}),define(Ee[340],Se([1,0,7,6,216,3,15,18]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=e.$Bic=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$dM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$dM("statusBarItem.warningForeground")]])}#e;#t;constructor(p,k,S,c,g,o=C.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new P.$Sc,this.#e=p,this.#t=k,g&&c){this.c=(0,C.$SL)(c.identifier,g);const r=S.get(this.c);r&&(o=r.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,i=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=g,this.g=o,this.h=this.u(i)}u(p){if((0,v.$Nf)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!$.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new P.$Sc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let k;this.m?k=this.m:k=(0,f.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const c=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,k,this.k,c,this.r?.internal,S,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Bic=$;class E{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const k={message:p};return this.b.unshift(k),this.c(),new C.$hL(()=>{const S=this.b.indexOf(k);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(p,k){this.e=new Map,this.a=p.getProxy(F.$fL.MainThreadStatusBar),this.b=k,this.c=new E(this)}$acceptStaticEntries(p){for(const k of p)this.e.set(k.entryId,k)}createStatusBarEntry(p,k,S,c){return new $(this.a,this.b,this.e,p,k,S,c)}setStatusBarMessage(p,k){const S=this.c.setMessage(p);let c;return typeof k=="number"?c=setTimeout(()=>S.dispose(),k):typeof k<"u"&&k.then(()=>S.dispose(),()=>S.dispose()),new C.$hL(()=>{S.dispose(),clearTimeout(c)})}}e.$Cic=R}),define(Ee[150],Se([1,0,29,141,67,111,90,15,2]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=e.$xN=e.$wN=void 0;const E=(r,n,a,t)=>{let h=n;return{enumerable:!0,configurable:!1,get(){return h},set(s){if(!a(h,s)){const d=h;h=s,r.listener?.(t(s,d))}}}},R=(r,n)=>r===n,D={range:(r,n)=>r===n?!0:!r||!n?!1:r.isEqual(n),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(r,n)=>!(r.length!==n.length||r.some(a=>!n.find(t=>a.id===t.id)))},p=r=>n=>({op:4,update:r(n)}),k=(r,n)=>({range:(()=>{let a;const t=p(h=>({range:C.$Vs.lift(v.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return a},set(h){r.listener?.({op:6}),D.range(a,h)||(a=h,r.listener?.(t(h)))}}})(),label:E(r,n,D.label,p(a=>({label:a}))),description:E(r,void 0,D.description,p(a=>({description:a}))),sortText:E(r,void 0,D.sortText,p(a=>({sortText:a}))),canResolveChildren:E(r,!1,D.canResolveChildren,a=>({op:2,state:a})),busy:E(r,!1,D.busy,p(a=>({busy:a}))),error:E(r,void 0,D.error,p(a=>({error:v.MarkdownString.fromStrict(a)||null}))),tags:E(r,[],D.tags,(a,t)=>({op:1,new:a.map(v.TestTag.from),old:t.map(v.TestTag.from)}))}),S=r=>{const n=f.$0J.fromString(r.extId),a=new g(n.controllerId,n.localId,r.label,$.URI.revive(r.uri)||void 0);return a.range=v.Range.to(r.range||void 0),a.description=r.description||void 0,a.sortText=r.sortText||void 0,a.tags=r.tags.map(t=>v.TestTag.to({id:(0,A.$cK)(t).tagId})),a},c=r=>{let n;for(const a of r.tests){const t=S(a.item);(0,F.$gN)(t).parent=n,n=t}return n};e.$wN=c;class g{constructor(n,a,t,h){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const s=(0,F.$fN)(this,n);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,P.$eN)(s,F.$gN,g),enumerable:!0,writable:!1},...k(s,t)})}}e.$xN=g;class o extends g{constructor(n,a){super(n,n,a,void 0),this._isRoot=!0}}e.$yN=o;class i extends P.$aN{constructor(n,a,t){super({controllerId:n,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:F.$gN,getChildren:h=>h.children,root:new o(n,a),toITestItem:v.TestItem.from})}}e.$zN=i}),define(Ee[33],Se([1,0,18,7,15,24,6,19,13,56,29,48,2,3,5,20,150,22,68,44,38,88,91,30]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=void 0;let s=class{#e;#t;#i;constructor(b,m,y){this.b=new Map,this.c=new Map,this.#e=b.getProxy(A.$fL.MainThreadCommands),this.d=m,this.#i=y,this.#t=b.getProxy(A.$fL.MainThreadTelemetry),this.converter=new d(this,L=>{const N=this.c.get(L);return N?.result===u.Void?N:void 0},m),this.f=[{processArgument(L){return(0,E.$Dh)(L)}},{processArgument(L){return(0,P.$yn)(L,function(N){if(R.$Vs.isIRange(N))return f.Range.to(N);if(D.$Us.isIPosition(N))return f.Position.to(N);if(R.$Vs.isIRange(N.range)&&p.URI.isUri(N.uri))return f.location.to(N);if(N instanceof o.$ke)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const m=this.registerCommand(!1,b.id,async(...y)=>{const L=b.args.map((U,T)=>{if(!U.validate(y[T]))throw new Error(`Invalid argument '${U.name}' when running '${b.id}', received: ${typeof y[T]=="object"?JSON.stringify(y[T],null,"	"):y[T]} `);return U.convert(y[T])}),N=await this.executeCommand(b.internalId,...L);return b.result.convert(N,y,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new F.$hL(()=>{m.dispose(),this.c.delete(b.id)})}registerCommand(b,m,y,L,N,U){if(this.d.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this.b.has(m))throw new Error(`command '${m}' already exists`);return this.b.set(m,{callback:y,thisArg:L,metadata:N,extension:U}),b&&this.#e.$registerCommand(m),new F.$hL(()=>{this.b.delete(m)&&b&&this.#e.$unregisterCommand(m)})}executeCommand(b,...m){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,m,!0)}async g(b,m,y){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,m,!1);{let L=!1;const N=(0,P.$yn)(m,function(U){if(U instanceof F.$iL)return f.Position.from(U);if(U instanceof F.$jL)return f.Range.from(U);if(U instanceof F.$tL)return f.location.from(U);if(F.$GM.isNotebookRange(U))return f.NotebookRange.from(U);if(U instanceof ArrayBuffer)return L=!0,o.$ke.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return L=!0,o.$ke.wrap(U);if(U instanceof o.$ke)return L=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(b,L?new i.$Uv(N):N,y);return(0,E.$Dh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(b,m,!1);throw U}}}async h(b,m,y){const L=this.b.get(b);if(!L)throw new Error("Unknown command");const{callback:N,thisArg:U,metadata:T}=L;if(T?.args)for(let M=0;M<T.args.length;M++)try{(0,C.$1f)(m[M],T.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${T.args[M].name}' - ${T.args[M].description}`)}const O=n.$Sd.create();try{return await N.apply(U,m)}catch(M){if(b===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...m);j&&(b=j.command)}if(this.d.error(M,b,L.extension?.identifier),!y)throw M;if(L.extension?.identifier){const j=this.#i.onExtensionError(L.extension.identifier,M);this.d.trace("forwarded error to extension?",j,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$Ri)(M)),this.id=b,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,b,O.elapsed())}}j(b,m,y){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new a.$Mo(m),duration:y})}$executeContributedCommand(b,...m){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const y=this.b.get(b);return y?(m=m.map(L=>this.f.reduce((N,U)=>U.processArgument(N,y.extension?.identifier),L)),this.h(b,m,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(m=>(b&&(m=m.filter(y=>y[0]!=="_")),m))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[m,y]of this.b){const{metadata:L}=y;L&&(b[m]=L)}return Promise.resolve(b)}};e.$FN=s,e.$FN=s=Ge([qe(0,c.$kN),qe(1,$.$oj),qe(2,t.$EN)],s),e.$GN=(0,S.$7h)("IExtHostCommands");class d{constructor(b,m,y){this.d=b,this.f=m,this.g=y,this.delegatingCommandId=`__vsc${(0,h.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,m){if(!b)return;const y={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return y;const L=this.f(b.command);if(L)y.id=L.internalId,y.arguments=L.args.map((N,U)=>N.convert(b.arguments&&b.arguments[U]));else if((0,v.$Lb)(b.arguments)){const N=`${b.command} /${++this.c}`;this.b.set(N,b),m.add((0,k.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),y.$ident=N,y.id=this.delegatingCommandId,y.arguments=[N],this.g.trace("CommandsConverter#CREATE",b.command,N)}return y}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const m=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],m?m.command:"MISSING"),m?this.d.executeCommand(m.command,...m.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$HN=d;class l{static{this.Uri=new l("uri","Uri of a text document",b=>p.URI.isUri(b),b=>b)}static{this.Position=new l("position","A position in a text document",b=>F.$iL.isPosition(b),f.Position.from)}static{this.Range=new l("range","A range in a text document",b=>F.$jL.isRange(b),f.Range.from)}static{this.Selection=new l("selection","A selection in a text document",b=>F.$kL.isSelection(b),f.Selection.from)}static{this.Number=new l("number","",b=>typeof b=="number",b=>b)}static{this.String=new l("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=l.Arr(l.String)}static Arr(b){return new l(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,m=>Array.isArray(m)&&m.every(y=>b.validate(y)),m=>m.map(y=>b.convert(y)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",b=>b instanceof F.$EL,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",b=>b instanceof F.$ZM,f.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VS Code TestItem",b=>b instanceof g.$xN,f.TestItem.from)}constructor(b,m,y,L){this.name=b,this.description=m,this.validate=y,this.convert=L}optional(){return new l(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,m){return new l(b??this.name,m??this.description,this.validate,this.convert)}}e.$IN=l;class u{static{this.Void=new u("no result",b=>b)}constructor(b,m){this.description=b,this.convert=m}}e.$JN=u;class w{constructor(b,m,y,L,N){this.id=b,this.internalId=m,this.description=y,this.args=L,this.result=N}}e.$KN=w}),define(Ee[341],Se([1,0,19,16,2,83,131,45,33,15,7]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;const D=[new $.$KN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to an array of DocumentHighlight-instances.",k(E.DocumentHighlight.to))),new $.$KN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$IN.Uri],new $.$JN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,g)=>{if((0,C.$Kb)(c))return;class o extends R.$zL{static to(r){const n=new o(r.name,E.SymbolKind.to(r.kind),r.containerName||"",new R.$tL(g[0],E.Range.to(r.range)));return n.detail=r.detail,n.range=n.location.range,n.selectionRange=E.Range.to(r.selectionRange),n.children=r.children?r.children.map(o.to):[],n}}return c.map(o.to)})),new $.$KN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$IN.Uri,new $.$IN("options","Formatting options",c=>!0,c=>c)],new $.$JN("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new $.$KN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$IN.Uri,$.$IN.Range,new $.$IN("options","Formatting options",c=>!0,c=>c)],new $.$JN("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new $.$KN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$IN.Uri,$.$IN.Position,new $.$IN("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$IN("options","Formatting options",c=>!0,c=>c)],new $.$JN("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new $.$KN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$KN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$KN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$KN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$KN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to an array of Location-instances.",k(E.location.to))),new $.$KN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to an array of Hover-instances.",k(E.Hover.to))),new $.$KN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$IN.Uri,new $.$IN("position","A position in a text document",c=>Array.isArray(c)&&c.every(g=>R.$iL.isPosition(g)),c=>c.map(E.Position.from))],new $.$JN("A promise that resolves to an array of ranges.",c=>c.map(g=>{let o;for(const i of g.reverse())o=new R.$DL(E.Range.to(i),o);return o}))),new $.$KN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$IN.String.with("query","Search string")],new $.$JN("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(E.WorkspaceSymbol.to))),new $.$KN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(E.CallHierarchyItem.to))),new $.$KN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$IN.CallHierarchyItem],new $.$JN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(E.CallHierarchyIncomingCall.to))),new $.$KN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$IN.CallHierarchyItem],new $.$JN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(E.CallHierarchyOutgoingCall.to))),new $.$KN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:E.Range.to(c.range),placeholder:c.text}})),new $.$KN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$IN.Uri,$.$IN.Position,$.$IN.String.with("newName","The new symbol name")],new $.$JN("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return E.WorkspaceEdit.to(c)}})),new $.$KN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$IN.Uri,$.$IN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$JN("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(E.DocumentLink.to))),new $.$KN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$IN.Uri],new $.$JN("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$xM(c.tokenTypes,c.tokenModifiers)})),new $.$KN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$IN.Uri],new $.$JN("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,A.$H$)(c);if(g.type==="full")return new R.$zM(g.data,void 0)})),new $.$KN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$IN.Uri,$.$IN.Range.optional()],new $.$JN("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$xM(c.tokenTypes,c.tokenModifiers)})),new $.$KN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$IN.Uri,$.$IN.Range],new $.$JN("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,A.$H$)(c);if(g.type==="full")return new R.$zM(g.data,void 0)})),new $.$KN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$IN.Uri,$.$IN.Position,$.$IN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$IN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$JN("A promise that resolves to a CompletionList-instance.",(c,g,o)=>{if(!c)return new R.$PL([]);const i=c.suggestions.map(r=>E.CompletionItem.to(r,o));return new R.$PL(i,c.incomplete)})),new $.$KN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$IN.Uri,$.$IN.Position,$.$IN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$JN("A promise that resolves to SignatureHelp.",c=>{if(c)return E.SignatureHelp.to(c)})),new $.$KN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$IN.Uri,$.$IN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$JN("A promise that resolves to an array of CodeLens-instances.",(c,g,o)=>k(i=>new R.$HL(E.Range.to(i.range),i.command&&o.fromInternal(i.command)))(c))),new $.$KN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$IN.Uri,new $.$IN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.$jL.isRange(c),c=>R.$kL.isSelection(c)?E.Selection.from(c):E.Range.from(c)),$.$IN.String.with("kind","Code action kind to return code actions for").optional(),$.$IN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$JN("A promise that resolves to an array of Command-instances.",(c,g,o)=>k(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const r=new R.$BL(i.title,i.kind?new R.$CL(i.kind):void 0);return i.edit&&(r.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(r.command=o.fromInternal(i.command)),r.isPreferred=i.isPreferred,r}})(c))),new $.$KN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$IN.Uri],new $.$JN("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(g=>new R.$VL(E.Range.to(g.range),E.Color.to(g.color))):[])),new $.$KN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$IN("color","The color to show and insert",c=>c instanceof R.$UL,E.Color.from),new $.$IN("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:E.Range.from(c.range)}))],new $.$JN("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(E.ColorPresentation.to):[])),new $.$KN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$IN.Uri,$.$IN.Range],new $.$JN("A promise that resolves to an array of Inlay objects",(c,g,o)=>c.map(E.InlayHint.to.bind(void 0,o)))),new $.$KN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$IN.Uri],new $.$JN("A promise that resolves to an array of FoldingRange objects",(c,g)=>{if(c)return c.map(E.FoldingRange.to)})),new $.$KN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$JN("A promise that resolves to an array of NotebookContentProvider static info objects.",k(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(g=>E.NotebookExclusiveDocumentPattern.to(g))})))),new $.$KN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$IN.Uri,$.$IN.Range,new $.$IN("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof R.$jL,c=>E.InlineValueContext.from(c))],new $.$JN("A promise that resolves to an array of InlineValue objects",c=>c.map(E.InlineValue.to))),new $.$KN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$IN("uriOrString","Uri-instance or string (only http/https)",c=>f.URI.isUri(c)||typeof c=="string"&&(0,F.$gg)(c,F.Schemas.http,F.Schemas.https),c=>c),new $.$IN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[E.ViewColumn.from(c),void 0]:[E.ViewColumn.from(c.viewColumn),E.TextEditorOpenOptions.from(c)])).optional(),$.$IN.String.with("label","").optional()],$.$JN.Void),new $.$KN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$IN.Uri.with("resource","Resource to open"),$.$IN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$IN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[E.ViewColumn.from(c),void 0]:[E.ViewColumn.from(c.viewColumn),E.TextEditorOpenOptions.from(c)])).optional()],$.$JN.Void),new $.$KN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$IN.Uri.with("left","Left-hand side resource of the diff editor"),$.$IN.Uri.with("right","Right-hand side resource of the diff editor"),$.$IN.String.with("title","Human readable title for the diff editor").optional(),new $.$IN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[E.ViewColumn.from(c.viewColumn),E.TextEditorOpenOptions.from(c)]).optional()],$.$JN.Void),new $.$KN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$IN.String.with("title","Human readable title for the changes editor"),new $.$IN("resourceList","List of resources to compare",c=>{for(const g of c){if(g.length!==3)return!1;const[o,i,r]=g;if(!f.URI.isUri(o)||!f.URI.isUri(i)&&i!==void 0&&i!==null||!f.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},c=>c)],$.$JN.Void),new $.$KN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$IN.Uri,$.$IN.Position],new $.$JN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(E.TypeHierarchyItem.to))),new $.$KN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$IN.TypeHierarchyItem],new $.$JN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(E.TypeHierarchyItem.to))),new $.$KN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$IN.TypeHierarchyItem],new $.$JN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(E.TypeHierarchyItem.to))),new $.$KN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$IN.TestItem],$.$JN.Void),new $.$KN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$IN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$JN.Void),new $.$KN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$IN.String.with("name","The context key name"),new $.$IN("value","The context key value",()=>!0,c=>c)],$.$JN.Void),new $.$KN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$IN.Uri,$.$IN.StringArray,new $.$IN("MappedEditsContext","Mapped Edits Context",c=>E.MappedEditsContext.is(c),c=>E.MappedEditsContext.from(c))],new $.$JN("A promise that resolves to a workspace edit or null",c=>c?E.WorkspaceEdit.to(c):null))];class p{static register(g){D.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",v.$6i)}}e.$Xgc=p;function k(c){return g=>{if(Array.isArray(g))return g.map(c)}}function S(c){if(!Array.isArray(c))return;const g=[];for(const o of c)P.$Ht(o)?g.push(E.DefinitionLink.to(o)):g.push(E.location.to(o));return g}}),define(Ee[342],Se([1,0,3,2,6,15,7,33,11]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class E{static{this.a=0}constructor(k,S){this.extension=k,this.provider=S,this.handle=E.a++}}class R{constructor(k){this.session=k,this.responses=[]}}class D{static{this.a=0}constructor(k,S,c,g){this.f=c,this.g=g,this.b=new Map,this.d=new Map,this.e=k.getProxy(f.$fL.MainThreadInlineChat),S.registerApiCommand(new v.$KN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.$IN("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?P.Range.from(o.initialRange):void 0,initialSelection:A.$kL.isSelection(o.initialSelection)?P.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?P.Position.from(o.position):void 0}})],v.$JN.Void))}registerProvider(k,S,c){const g=new E(k,S);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,c?.label??k.displayName??k.name,k.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",c?.supportReportIssue??!1),(0,C.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(k,S,c,g){const o=this.b.get(k);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(S)),r=P.Selection.to(c),n=await o.provider.prepareInteractiveEditorSession({document:i,selection:r},g);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=D.a++;return this.d.set(a,new R(n)),{id:a,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:P.Range.from(n.wholeRange),message:n.message}}async $provideResponse(k,S,c,g){const o=this.b.get(k);if(!o)return;const i=this.d.get(S.id);if(!i)return;const r={prompt:c.prompt,selection:P.Selection.to(c.selection),wholeRange:P.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,withIntentDetection:c.withIntentDetection};let n=!1;const a={report:async I=>{if(!c.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||g.isCancellationRequested||await this.e.$handleProgressChunk(c.requestId,{message:I.message,edits:I.edits?.map(P.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:A.$IL.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,r,a,g));let h;try{h=await(0,$.$Vg)(t,g)}finally{n=!0}if(!h)return;const s=i.responses.push(h)-1,d={wholeRange:P.Range.from(h.wholeRange),placeholder:h.placeholder};if(!D.h(h))return{...d,id:s,type:"editorEdit",message:P.MarkdownString.from(h.contents),edits:[]};const{edits:l,contents:u}=h,w=u!==void 0?P.MarkdownString.from(u):void 0;return l instanceof A.$rL?{...d,id:s,type:"bulkEdit",edits:P.WorkspaceEdit.from(l),message:w}:{...d,id:s,type:"editorEdit",edits:l.map(P.TextEdit.from),message:w}}async $provideFollowups(k,S,c,g){const o=this.b.get(k),i=this.d.get(S),r=i?.responses[c];if(o&&r&&o.provider.provideFollowups){const n=Promise.resolve(o.provider.provideFollowups(i.session,r,g));return(await(0,$.$Vg)(n,g))?.map(P.ChatFollowup.from)}}$handleFeedback(k,S,c,g){const o=this.b.get(k),i=this.d.get(S),r=i?.responses[c];if(o&&r){const n=P.InteractiveEditorResponseFeedbackKind.to(g);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,r,n)}}$releaseSession(k,S){}static h(k){return typeof k=="object"&&typeof k.edits=="object"}}e.$6hc=D}),define(Ee[343],Se([1,0,2,33]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0;class f{constructor(A,v,$,E,R){this.a=v,this.b=$,this.c=E;const D=new F.$KN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$IN("showOptions","Show Options",p=>!0,p=>p),new F.$IN("resource","Interactive resource Uri",p=>!0,p=>p),new F.$IN("controllerId","Notebook controller Id",p=>!0,p=>p),new F.$IN("title","Interactive editor title",p=>!0,p=>p)],new F.$JN("Notebook and input URI",p=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const k=this.a.getEditorById(p.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri),notebookEditor:k.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,v,$,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:v,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(E))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,v){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$gic=f}),define(Ee[344],Se([1,0,19,11,21,4,3,28,2,25,13,6,33,15,7,112,284,26,68,285]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=e.$oic=void 0;let n=class{constructor(w,I,b,m,y){this.m=I,this.n=b,this.o=m,this.q=y,this.b=new v.$Ac,this.c=new v.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=w.getProxy(D.$fL.MainThreadNotebookKernels);const L=new p.$KN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$IN("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const U=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:U}}else if(N&&"notebookEditor"in N){const U=this.n.getIdByEditor(N.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return N})],p.$JN.Void);this.o.registerApiCommand(L)}createNotebookController(w,I,b,m,y,L){for(const $e of this.j.values())if($e.controller.id===I&&E.$mm.equals(w.identifier,$e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const N=this.k++,U=this;this.q.trace(`NotebookController[${N}], CREATED by ${w.identifier.value}, ${I}`);const T=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${w.identifier}'`);let O=!1;const M=new P.$Wd,j=new P.$Wd,z={id:l(w.identifier,I),notebookType:b,extensionId:w.identifier,extensionLocation:w.extensionLocation,label:m||w.identifier.value,preloads:L?L.map(k.NotebookRendererScript.from):[]};let J=y??T,le,Y;this.a.$addKernel(N,z).catch($e=>{console.log($e),O=!0});let Q=0;const X=()=>{if(O)return;const $e=++Q;Promise.resolve().then(()=>{$e===Q&&this.a.$updateKernel(N,z)})},ue=new v.$Ac,ne={get id(){return I},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return z.label},set label($e){z.label=$e??w.displayName??w.name,X()},get detail(){return z.detail??""},set detail($e){z.detail=$e,X()},get description(){return z.description??""},set description($e){z.description=$e,X()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages($e){z.supportedLanguages=$e,X()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder($e){z.supportsExecutionOrder=$e,X()},get rendererScripts(){return z.preloads?z.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler($e){J=$e??T},get interruptHandler(){return le},set interruptHandler($e){le=$e,z.supportsInterrupt=!!$e,X()},set variableProvider($e){(0,o.$KF)(w,"notebookVariableProvider"),Y=$e,z.hasVariableProvider=!!$e,$e?.onDidChangeVariables(oe=>U.a.$variablesUpdated(oe.uri)),X()},get variableProvider(){return Y},createNotebookCellExecution($e){if(O)throw new Error("notebook controller is DISPOSED");if(!ue.has($e.notebook.uri))throw U.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return U._createNotebookCellExecution($e,l(w.identifier,this.id))},createNotebookExecution($e){if((0,o.$KF)(w,"notebookExecution"),O)throw new Error("notebook controller is DISPOSED");if(!ue.has($e.uri))throw U.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return U._createNotebookExecution($e,l(w.identifier,this.id))},dispose:()=>{O||(this.q.trace(`NotebookController[${N}], DISPOSED`),O=!0,this.j.delete(N),M.dispose(),j.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity($e,oe){oe===S.NotebookControllerAffinity2.Hidden&&(0,o.$KF)(w,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(N,$e.uri,oe)},onDidReceiveMessage:j.event,postMessage($e,oe){return(0,o.$KF)(w,"notebookMessaging"),U.a.$postMessage(N,oe&&U.n.getIdByEditor(oe),$e)},asWebviewUri($e){return(0,o.$KF)(w,"notebookMessaging"),(0,c.$fwb)($e,U.m.remote)}};return this.j.set(N,{extensionId:w.identifier,controller:ne,onDidReceiveMessage:j,onDidChangeSelection:M,associatedNotebooks:ue}),ne}getIdByController(w){for(const[I,b]of this.j)if(b.controller===w)return l(b.extensionId,w.id);return null}createNotebookControllerDetectionTask(w,I){const b=this.g++,m=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${w.identifier.value}`),this.a.$addKernelDetectionTask(b,I);const y={dispose:()=>{this.f.delete(b),m.a.$removeKernelDetectionTask(b)}};return this.f.set(b,y),y}registerKernelSourceActionProvider(w,I,b){const m=this.i++,y=typeof b.onDidChangeNotebookKernelSourceActions=="function"?m:void 0,L=this;this.h.set(m,b),this.q.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${w.identifier.value}`),this.a.$addKernelSourceActionProvider(m,m,I);let N;return y!==void 0&&(N=b.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(m),L.a.$removeKernelSourceActionProvider(m,m),N?.dispose()}}}async $provideKernelSourceActions(w,I){const b=this.h.get(w);if(b){const m=new A.$Sc;return(await b.provideNotebookKernelSourceActions(I)??[]).map(L=>k.NotebookKernelSourceAction.from(L,this.o.converter,m))}return[]}$acceptNotebookAssociation(w,I,b){const m=this.j.get(w);if(m){const y=this.n.getNotebookDocument($.URI.revive(I));b?m.associatedNotebooks.set(y.uri,!0):m.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${w}] ASSOCIATE notebook`,y.uri.toString(),b),m.onDidChangeSelection.fire({selected:b,notebook:y.apiNotebook})}}async $executeCells(w,I,b){const m=this.j.get(w);if(!m)return;const y=this.n.getNotebookDocument($.URI.revive(I)),L=[];for(const N of b){const U=y.getCell(N);U&&L.push(U.apiCell)}try{this.q.trace(`NotebookController[${w}] EXECUTE cells`,y.uri.toString(),L.length),await m.controller.executeHandler.call(m.controller,L,y.apiNotebook,m.controller)}catch(N){this.q.error(`NotebookController[${w}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(w,I,b){const m=this.j.get(w);if(!m)return;const y=this.n.getNotebookDocument($.URI.revive(I));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,y.apiNotebook);else for(const L of b){const N=y.getCell(L);N&&this.b.get(N.uri)?.cancel()}if(m.controller.interruptHandler){const L=this.c.get(y.uri);b.length&&Array.isArray(L)&&L.length&&L.forEach(N=>N.dispose())}}async $provideVariables(w,I,b,m,y,L,N){const U=this.j.get(w);if(!U)return;const T=this.n.getNotebookDocument($.URI.revive(b)),O=U.controller.variableProvider;if(!O)return;let M;if(m!==void 0){if(M=this.s[m],!M)return}else this.s={};const j=y==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,z=O.provideVariables(T.apiNotebook,M,j,L,N);let J=0;for await(const le of z){if(N.isCancellationRequested)return;const Y={id:this.r++,name:le.variable.name,value:le.variable.value,type:le.variable.type,hasNamedChildren:le.hasNamedChildren,indexedChildrenCount:le.indexedChildrenCount};if(this.s[Y.id]=le.variable,this.a.$receiveVariable(I,Y),J++>=r.$tfb)return}}$acceptKernelMessageFromRenderer(w,I,b){const m=this.j.get(w);if(!m)return;const y=this.n.getEditorById(I);m.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:b}))}$cellExecutionChanged(w,I,b){const y=this.n.getNotebookDocument($.URI.revive(w)).getCell(I);if(y){const L=b?k.NotebookCellExecutionState.to(b):S.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:y.apiCell,state:L})}}_createNotebookCellExecution(w,I){if(w.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.n.getNotebookDocument(w.notebook.uri).getCellFromApiCell(w);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const y=new t(I,m,this.a);this.b.set(m.uri,y);const L=y.onDidChangeState(()=>{y.state===a.Resolved&&(y.dispose(),L.dispose(),this.b.delete(m.uri))});return y.asApiObject()}_createNotebookExecution(w,I){const b=this.n.getNotebookDocument(w.uri),m=w.getCells().find(N=>{const U=b.getCellFromApiCell(N);return U&&this.b.has(U.uri)});if(m)throw new Error(`duplicate cell execution for ${m.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const y=new s(I,b,this.a),L=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),L.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[y,L]),y.asApiObject()}};e.$oic=n,e.$oic=n=Ge([qe(4,R.$oj)],n);var a;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(a||(a={}));class t extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(w,I,b){super(),this.m=I,this.n=b,this.b=t.a++,this.c=new P.$Wd,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new f.$7d),this.h=new d(10,m=>this.s(m)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,w,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(w){await this.h.addItem(w)}async s(w){const I=Array.isArray(w)?w:[w];return this.n.$updateExecution(this.b,new i.$Uv(I))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(w){let I=this.m;if(w&&(I=this.m.notebook.getCellFromApiCell(w)),!I)throw new Error("INVALID cell");return I.handle}y(w){return w.map(I=>{const b=S.$KM.ensureUniqueMimeTypes(I.items,!0);return b===I.items?k.NotebookCellOutput.from(I):k.NotebookCellOutput.from({items:b,id:I.id,metadata:I.metadata})})}async z(w,I,b){const m=this.w(I),y=this.y((0,C.$3b)(w));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:m,append:b,outputs:y})}async C(w,I,b){return w=S.$KM.ensureUniqueMimeTypes((0,C.$3b)(w),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:w.map(k.NotebookCellOutputItem.from),outputId:I.id,append:b})}asApiObject(){const w=this;return Object.freeze({get token(){return w.g.token},get cell(){return w.m.apiCell},get executionOrder(){return w.j},set executionOrder(b){w.j=b,w.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:w.j}])},start(b){if(w.f===a.Resolved||w.f===a.Started)throw new Error("Cannot call start again");w.f=a.Started,w.c.fire(),w.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,m){if(w.f===a.Resolved)throw new Error("Cannot call resolve twice");w.f=a.Resolved,w.c.fire(),w.h.flush(),w.n.$completeExecution(w.b,new i.$Uv({runEndTime:m,lastRunSuccess:b}))},clearOutput(b){return w.t(),w.z([],b,!1)},appendOutput(b,m){return w.t(),w.z(b,m,!0)},replaceOutput(b,m){return w.t(),w.z(b,m,!1)},appendOutputItems(b,m){return w.t(),w.C(b,m,!0)},replaceOutputItems(b,m){return w.t(),w.C(b,m,!1)}})}}var h;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(h||(h={}));class s extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(w,I,b){super(),this.h=I,this.j=b,this.b=s.a++,this.c=new P.$Wd,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new f.$7d),this.j.$createNotebookExecution(this.b,w,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===h.Resolved||this.f===h.Started)throw new Error("Cannot call start again");this.f=h.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===h.Resolved)throw new Error("Cannot call resolve twice");this.f=h.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(w,I){this.f=w,this.g=I,this.a=[],this.b=Date.now()}addItem(w){return this.a.push(w),this.c||(this.c=new F.$rh,this.b=Date.now(),(0,F.$8g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const w=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>w.complete())}}function l(u,w){return`${u.value}/${w}`}e.$pic=l}),define(Ee[46],Se([1,0,4,6,5,2,20,3,7,218,14,262,21,30,263,55,11,15,33]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=e.$Bhc=e.$Ahc=void 0,e.$Ahc=(0,f.$7h)("IExtHostTerminalService");class r{constructor(b,m,y,L){this.l=b,this._id=m,this.m=y,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(U,T=!0){N.q(),N.l.$sendText(N._id,U,T)},show(U){N.q(),N.l.$show(N._id,U)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(b,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??m?.cwd??void 0,env:b.env??void 0,icon:l(b.iconPath)??void 0,color:c.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(b.location,m?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,m,y,L,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:L,color:c.ThemeColor.isThemeColor(N)?N.id:void 0,location:m?.location||this.o(b,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,m){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in b?{viewColumn:o.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,m){this.h=Object.freeze({code:b,reason:m})}setDimensions(b,m){return b===this.d&&m===this.g||b===0||m===0?!1:(this.d=b,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(m=>{m!==b&&(this.b=Promise.resolve(b))})}}e.$Bhc=r;class n{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new C.$Wd,this.onProcessData=this.a.event,this.b=new C.$Wd,this.d=new C.$Wd,this.onDidChangeProperty=this.d.event,this.f=new C.$Wd,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,m){this.g.setDimensions?.({columns:b,rows:m})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends v.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,m,y){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new v.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new C.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new C.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Wd,this.onDidChangeShell=this.N.event,this.O=new C.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(F.$fL.MainThreadTerminalService),this.y=new S.$rsb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:L=>{const N=U=>{const T=U;return this.W(T.instanceId)?.value};switch(L?.$mid){case 15:return N(L);default:{if(Array.isArray(L))for(let U=0;U<L.length&&L[U].$mid===15;U++)L[U]=N(L[U]);return L}}}}),this.B({dispose:()=>{for(const[L,N]of this.g)N.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,m){const y=new r(this.a,(0,k.$rg)(),b,b.name),L=new n(b.pty);return y.createExtensionTerminal(b.location,m,this.R(b,m).resolvedExtHostIdentifier,l(b.iconPath),u(b.color)).then(N=>{const U=this.S(N,L);this.h[N]=U}),this.f.push(y),y.value}R(b,m){if(m=m||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const y=b.location.parentTerminal;if(y){const L=this.f.find(N=>N.value===y);L&&(m.resolvedExtHostIdentifier=L._id)}}else b.location&&typeof b.location!="object"?m.location=b.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(b,m){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const L=new n(m),N=this.S(b,L);this.h[b]=N}async $acceptActiveTerminalChanged(b){const m=this.b;if(b===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const y=this.W(b);y&&(this.b=y,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,m){const y=this.W(b);y&&this.O.fire({terminal:y.value,data:m})}async $acceptTerminalDimensions(b,m,y){const L=this.W(b);L&&L.setDimensions(m,y)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(b,m){const y=this.W(b);y&&this.P.fire({terminal:y.value,...m})}async $acceptTerminalMaximumDimensions(b,m,y){this.g.get(b)?.resize(m,y)}async $acceptTerminalTitleChange(b,m){const y=this.W(b);y&&(y.name=m)}async $acceptTerminalClosed(b,m,y){const L=this.Y(this.f,b);if(L!==null){const N=this.f.splice(L,1)[0];N.setExitStatus(m,y),this.H.fire(N.value)}}$acceptTerminalOpened(b,m,y,L){if(m){const T=this.Y(this.f,m);if(T!==null){this.f[T]._id=b,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const N={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:P.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},U=new r(this.a,b,N,y);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(b,m){this.W(b)?._setProcessId(m)}async $startExtensionTerminal(b,m){const y=this.W(b);if(!y)return{message:(0,E.localize)(0,null,b)};y.isOpen||await new Promise(N=>{const U=this.onDidOpenTerminal(async T=>{T===y.value&&(U.dispose(),N())})});const L=this.g.get(b);L?L.startSendingEvents(m):this.j[b]={initialDimensions:m}}S(b,m){const y=new v.$Sc;y.add(m.onProcessReady(N=>this.a.$sendProcessReady(b,N.pid,N.cwd,N.windowsPty))),y.add(m.onDidChangeProperty(N=>this.a.$sendProcessProperty(b,N))),this.y.startBuffering(b,m.onProcessData),y.add(m.onProcessExit(N=>this.U(b,N))),this.g.set(b,m);const L=this.j[b];return L&&m instanceof n&&(m.startSendingEvents(L.initialDimensions),delete this.j[b]),y}$acceptProcessAckDataEvent(b,m){this.g.get(b)?.acknowledgeDataEvent(m)}$acceptProcessInput(b,m){this.g.get(b)?.input(m)}$acceptTerminalInteraction(b){const m=this.W(b);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(b,m){this.W(b)?.setSelection(m)}$acceptProcessResize(b,m,y){try{this.g.get(b)?.resize(m,y)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(b,m){this.g.get(b)?.shutdown(m)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(m=>this.a.$sendProcessProperty(b,{type:"cwd",value:m}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new $.$hL(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,m,y){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,y),this.a.$registerProfileProvider(m,b.identifier.value),new $.$hL(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(b,m,y){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,y),this.a.$registerQuickFixProvider(b,m),new $.$hL(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,m){const y=new p.$7d().token;if(y.isCancellationRequested)return;const L=this.D.get(b);if(!L)return;const N=await L.provideTerminalQuickFixes(m,y);if(N===null||Array.isArray(N)&&N.length===0)return;const U=new v.$Sc;if(this.w.value=U,!Array.isArray(N))return N?o.TerminalQuickFix.from(N,this.Q.converter,U):void 0;const T=[];for(const O of N){const M=o.TerminalQuickFix.from(O,this.Q.converter,U);M&&T.push(M)}return T}async $createContributedProfileTerminal(b,m){const y=new p.$7d().token;let L=await this.C.get(b)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,m);return}this.createTerminalFromOptions(L.options,m)}}async $provideLinks(b,m){const y=this.W(b);if(!y)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const N=new p.$7d;this.G.set(b,N);const U=[],T={terminal:y.value,line:m},O=[];for(const z of this.z)O.push(g.Promises.withAsyncBody(async J=>{N.token.onCancellationRequested(()=>J({provider:z,links:[]}));const le=await z.provideTerminalLinks(T,N.token)||[];N.token.isCancellationRequested||J({provider:z,links:le})}));const M=await Promise.all(O);if(N.token.isCancellationRequested)return[];const j=new Map;for(const z of M)z&&z.links.length>0&&U.push(...z.links.map(J=>{const le={id:a++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return j.set(le.id,{provider:z.provider,link:J}),le}));return this.F.set(b,j),U}$activateLink(b,m){const y=this.F.get(b)?.get(m);y&&y.provider.handleTerminalLink(y.link)}U(b,m){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const y=this.h[b];y&&(y.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,m)}W(b){return this.X(this.f,b)}X(b,m){const y=this.Y(b,m);return y!==null?b[y]:null}Y(b,m){const y=b.findIndex(L=>L._id===m);return y===-1?null:y}getEnvironmentVariableCollection(b){let m=this.n.get(b.identifier.value);return m||(m=new h,this.$(b.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(b,m){const y=(0,D.$Nr)(m.map),L=(0,D.$Or)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(b,m.persistent,y.length===0?void 0:y,L)}$initEnvironmentVariableCollections(b){b.forEach(m=>{const y=m[0],L=new h(m[1]);this.$(y,L)})}$acceptDefaultProfile(b,m){const y=this.s;this.s=b,this.u=m,y?.path!==b.path&&this.N.fire(b.path)}$(b,m){this.n.set(b,m),m.onDidChangeCollection(()=>{this.Z(b,m)})}};e.$Chc=t,e.$Chc=t=Ge([qe(1,i.$GN),qe(2,A.$kN)],t);class h{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Wd,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const m=this.h(b);let y=this.a.get(m);return y||(y=new s(this,b),this.a.set(m,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(b,m,y,L){this.f(b,{value:m,type:$.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:L})}append(b,m,y,L){this.f(b,{value:m,type:$.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:L})}prepend(b,m,y,L){this.f(b,{value:m,type:$.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:L})}f(b,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(b,m.scope),L=this.map.get(y),N=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==m.value||L.type!==m.type||L.options?.applyAtProcessCreation!==N.applyAtProcessCreation||L.options?.applyAtShellIntegration!==N.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const U=this.g(b,m.scope),T={variable:b,...m,options:N};this.map.set(U,T),this.d.fire()}}get(b,m){const y=this.g(b,m),L=this.map.get(y);return L?w(L):void 0}g(b,m){const y=this.h(m);return y.length?`${b}:::${y}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const m=new Map;for(const[y,L]of this.map)this.h(L.scope)===this.h(b)&&m.set(L.variable,w(L));return m}delete(b,m){const y=this.g(b,m);this.map.delete(y),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[m,y]of this.map)y.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(m);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,m){const y=this.h(m),L=this.descriptionMap.get(y);if(!L||L.description!==b){let N;typeof b=="string"?N=b:N=b?.value.split(`

`)[0];const U={description:N,scope:m};this.descriptionMap.set(y,U),this.d.fire()}}getDescription(b){const m=this.h(b);return this.descriptionMap.get(m)?.description}k(b){const m=this.h(b);this.descriptionMap.delete(m)}}class s{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,m){this.b=b,this.d=m,this.a=new C.$Wd}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,m,y){this.b.replace(b,m,y,this.d)}append(b,m,y){this.b.append(b,m,y,this.d)}prepend(b,m,y){this.b.prepend(b,m,y,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,m){this.b.getVariableMap(this.d).forEach((y,L)=>b.call(m,L,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends t{constructor(b,m){super(!1,b,m)}createTerminal(b,m,y){throw new R.$_}createTerminalFromOptions(b,m){throw new R.$_}};e.$Dhc=d,e.$Dhc=d=Ge([qe(0,i.$GN),qe(1,A.$kN)],d);function l(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function u(I){return c.ThemeColor.isThemeColor(I)?I:void 0}function w(I){const b={...I};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(Ee[345],Se([1,0,11,22,21,4,74,54,3,24,18,30,13,6,20,150,15,7,67,111,90,26]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=e.$Iic=e.$Hic=e.$Gic=void 0;let t=class extends $.$Tc{constructor(O,M,j,z){super(),this.w=z,this.f=this.B(new P.$Wd),this.g=new Map,this.s=this.B(new P.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=O.getProxy(k.$fL.MainThreadTesting),this.m=new y(this.h),this.j=new l(this.h,M),j.registerArgumentProcessor({processArgument:J=>{switch(J?.$mid){case 16:{const le=J,Y=le.tests[le.tests.length-1].item.extId;return this.g.get(i.$0J.root(Y))?.collection.tree.get(Y)?.actual??(0,c.$wN)(J)}case 18:{const{extId:le,message:Y}=J;return{test:this.g.get(i.$0J.root(le))?.collection.tree.get(le)?.actual,message:g.TestMessage.to(Y)}}default:return J}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const J=await j.executeCommand("_testing.getExplorerSelection"),le=Y=>{const Q=this.g.get(i.$0J.root(Y));if(Q)return i.$0J.isRoot(Y)?Q.controller:Q.collection.tree.get(Y)?.actual};return{include:J?.include.map(le).filter(R.$Rf)||[],exclude:J?.exclude.map(le).filter(R.$Rf)||[]}})}createTestController(O,M,j,z){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const J=new $.$Sc,le=J.add(new c.$zN(M,j,this.w));le.root.label=j;const Y=new Map,Q=new Set,X=this.h,ue={items:le.root.children,get label(){return j},set label($e){j=$e,le.root.label=$e,X.$updateController(M,{label:j})},get refreshHandler(){return z},set refreshHandler($e){z=$e,X.$updateController(M,{canRefresh:!!$e})},get id(){return M},createRunProfile:($e,oe,K,W,ie,ye)=>{let de=(0,v.$Ui)($e);for(;Y.has(de);)de++;return new N(this.h,Y,Q,this.s.event,M,de,$e,oe,K,W,ie,ye)},createTestItem($e,oe,K){return new c.$xN(M,$e,oe,K)},createTestRun:($e,oe,K=!0)=>this.j.createTestRun(O,M,le,$e,oe,K),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const oe=$e instanceof Array?$e:[$e];this.h.$markTestRetired(oe.map(K=>i.$0J.fromExtHostTestItem(K,M).toString()))}},set resolveHandler($e){le.resolveHandler=$e},get resolveHandler(){return le.resolveHandler},dispose:()=>{J.dispose()}};X.$registerTestController(M,j,!!z),J.add((0,$.$Rc)(()=>X.$unregisterTestController(M)));const ne={controller:ue,collection:le,profiles:Y,extension:O,activeProfiles:Q};return this.g.set(M,ne),J.add((0,$.$Rc)(()=>this.g.delete(M))),J.add(le.onDidGenerateDiff($e=>X.$publishDiff(M,$e.map(n.TestsDiffOp.serialize)))),ue}createTestObserver(){return this.m.checkout()}async runTests(O,M=f.CancellationToken.None){const j=u(O);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(j.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(J=>i.$0J.fromExtHostTestItem(J,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:U[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:O.exclude?.map(J=>J.id)},M)}$syncTests(){for(const{collection:O}of this.g.values())O.flushDiff();return Promise.resolve()}async $provideFileCoverage(O,M,j){return await this.j.getCoverageReport(O,M)?.provideFileCoverage(j)??[]}async $resolveFileCoverage(O,M,j,z){return await this.j.getCoverageReport(O,M)?.resolveFileCoverage(j,z)??[]}$configureRunProfile(O,M){this.g.get(O)?.profiles.get(M)?.configureHandler?.()}$setDefaultRunProfiles(O){const M=new Map;for(const[j,z]of Object.entries(O)){const J=this.g.get(j);if(!J)continue;const le=new Map,Y=z.filter(X=>!J.activeProfiles.has(X)),Q=[...J.activeProfiles].filter(X=>!z.includes(X));for(const X of Y)le.set(X,!0),J.activeProfiles.add(X);for(const X of Q)le.set(X,!1),J.activeProfiles.delete(X);le.size&&M.set(j,le)}this.s.fire(M)}async $refreshTests(O,M){await this.g.get(O)?.controller.refreshHandler?.(M)}$publishTestResults(O){this.results=Object.freeze(O.map(M=>(0,E.$xn)(g.TestResults.to(M))).concat(this.results).sort((M,j)=>j.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(O,M){const j=this.g.get(i.$0J.fromString(O).controllerId)?.collection;j&&(await j.expand(O,M<0?1/0:M),j.flushDiff())}$acceptDiff(O){this.m.applyDiff(O.map(M=>n.TestsDiffOp.deserialize({asCanonicalUri:j=>j},M)))}async $runControllerTests(O,M){return Promise.all(O.map(j=>this.y(j,!1,M)))}async $startContinuousRun(O,M){const j=new f.$7d(M),z=await Promise.all(O.map(J=>this.y(J,!0,j.token)));return!M.isCancellationRequested&&!z.some(J=>J.error)&&await new Promise(J=>M.onCancellationRequested(J)),j.dispose(!0),z}async y(O,M,j){const z=this.g.get(O.controllerId);if(!z)return{};const{collection:J,profiles:le,extension:Y}=z,Q=le.get(O.profileId);if(!Q)return{};const X=O.testIds.map(oe=>J.tree.get(oe)).filter(R.$Rf),ue=O.excludeExtIds.map(oe=>z.collection.tree.get(oe)).filter(R.$Rf).filter(oe=>X.some(K=>K.fullId.compare(oe.fullId)===2));if(!X.length)return{};const ne=new o.$RM(X.some(oe=>oe.actual instanceof c.$yN)?void 0:X.map(oe=>oe.actual),ue.map(oe=>oe.actual),Q,M),$e=(0,n.$_J)(O)&&this.j.prepareForMainThreadTestRun(ne,w.fromInternal(O,z.collection),Y,j);try{return await Q.runHandler(ne,j),{}}catch(oe){return{error:String(oe)}}finally{$e&&($e.hasRunningTasks&&!j.isCancellationRequested&&await P.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.j.cancelAllRuns():this.j.cancelRunById(O)}};e.$Gic=t,e.$Gic=t=Ge([qe(0,S.$kN),qe(1,p.$oj)],t);const h=1e4;var s;(function(T){T[T.Running=0]="Running",T[T.Cancelling=1]="Cancelling",T[T.Ended=2]="Ended"})(s||(s={}));class d extends $.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(O,M,j,z,J){super(),this.s=O,this.w=M,this.y=j,this.z=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$Wd),this.m=this.B(new P.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new f.$7d(J));const le=this.B(new C.$gh(()=>this.C(),h));this.B(this.h.token.onCancellationRequested(()=>le.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(O){const M=this.s.id,j=this.s.controllerId,z=(0,D.$rg)(),J=this.y,le=this.m;let Y;const Q=$e=>(oe,...K)=>{if(ue){this.z.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.s.isIncluded(oe)&&(this.F(oe),$e(oe,...K))},X=($e,oe)=>{const K=oe instanceof Array?oe.map(g.TestMessage.from):[g.TestMessage.from(oe)];if($e.uri&&$e.range){const W={range:g.Range.from($e.range),uri:$e.uri};for(const ie of K)ie.location=ie.location||W}this.w.$appendTestMessagesInRun(M,z,i.$0J.fromExtHostTestItem($e,j).toString(),K)};let ue=!1;const ne={isPersisted:this.s.isPersisted,token:this.h.token,name:O,get coverageProvider(){return Y?.provider},set coverageProvider($e){(0,a.$KF)(J,"testCoverage"),Y=$e&&new I($e),le.fire({taskId:z,runId:M,coverage:Y})},enqueued:Q($e=>{this.w.$updateTestStateInRun(M,z,i.$0J.fromExtHostTestItem($e,j).toString(),1)}),skipped:Q($e=>{this.w.$updateTestStateInRun(M,z,i.$0J.fromExtHostTestItem($e,j).toString(),5)}),started:Q($e=>{this.w.$updateTestStateInRun(M,z,i.$0J.fromExtHostTestItem($e,j).toString(),2)}),errored:Q(($e,oe,K)=>{X($e,oe),this.w.$updateTestStateInRun(M,z,i.$0J.fromExtHostTestItem($e,j).toString(),6,K)}),failed:Q(($e,oe,K)=>{X($e,oe),this.w.$updateTestStateInRun(M,z,i.$0J.fromExtHostTestItem($e,j).toString(),4,K)}),passed:Q(($e,oe)=>{this.w.$updateTestStateInRun(M,z,i.$0J.fromExtHostTestItem($e,this.s.controllerId).toString(),3,oe)}),appendOutput:($e,oe,K)=>{ue||(K&&(this.s.isIncluded(K)?this.F(K):K=void 0),this.w.$appendOutputToRun(M,z,F.$ke.fromString($e),oe&&g.location.from(oe),K&&i.$0J.fromExtHostTestItem(K,j).toString()))},end:()=>{ue||(ue=!0,this.w.$finishedTestRunTask(M,z),this.f.delete(z),this.f.size||this.D())}};return this.f.set(z,{run:ne}),this.w.$startedTestRunTask(M,{id:z,name:O,running:!0}),ne}C(){for(const{run:O}of this.f.values())O.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(O){if(!(O instanceof c.$xN))throw new r.$cN(O.id);if(this.g.has(i.$0J.fromExtHostTestItem(O,this.s.controllerId).toString()))return;const M=[],j=this.s.colllection.root;for(;;){const z=g.TestItem.from(O);if(M.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),O===j))break;O=O.parent||j}this.w.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.D(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(O,M){this.g=O,this.h=M,this.c=new Map,this.f=[]}getCoverageReport(O,M){return this.f.find(j=>j.runId===O)?.coverage.get(M)}prepareForMainThreadTestRun(O,M,j,z){return this.j(O,M,j,z)}cancelRunById(O){for(const M of this.c.values())if(M.id===O){M.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,M,j,z,J,le){const Y=this.c.get(z);if(Y)return Y.createRun(J);const Q=w.fromPublic(M,j,z,le),X=u(z);this.g.$startedExtensionTestRun({controllerId:M,continuous:!!z.continuous,profile:X&&{group:U[X.kind],id:X.profileId},exclude:z.exclude?.map(ne=>i.$0J.fromExtHostTestItem(ne,j.root.id).toString())??[],id:Q.id,include:z.include?.map(ne=>i.$0J.fromExtHostTestItem(ne,j.root.id).toString())??[j.root.id],persist:le});const ue=this.j(z,Q,O);return P.Event.once(ue.onEnd)(()=>{this.g.$finishedExtensionTestRun(Q.id),ue.dispose()}),ue.createRun(J)}j(O,M,j,z){const J=new d(M,this.g,j,this.h,z);this.c.set(O,J);let le;const Y=J.onDidCoverage(({runId:Q,taskId:X,coverage:ue})=>{le||(le={runId:Q,coverage:new Map},this.f.unshift(le),this.f.length>n.$eK&&this.f.pop()),le.coverage.set(X,ue),this.g.$signalCoverageAvailable(Q,X,!!ue)});return P.Event.once(J.onEnd)(()=>{this.c.delete(O),Y.dispose()}),J}}e.$Hic=l;const u=T=>{if(T.profile){if(!(T.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class w{static fromPublic(O,M,j,z){return new w(O,(0,D.$rg)(),j.include?.map(J=>i.$0J.fromExtHostTestItem(J,O).toString())??[O],j.exclude?.map(J=>i.$0J.fromExtHostTestItem(J,O).toString())??[],z,M)}static fromInternal(O,M){return new w(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,M)}constructor(O,M,j,z,J,le){this.controllerId=O,this.id=M,this.isPersisted=J,this.colllection=le,this.c=j.map(Y=>Y+"\0"),this.f=z.map(Y=>Y+"\0")}isIncluded(O){const M=i.$0J.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const j of this.f)if(M===j||M.startsWith(j))return!1;for(const j of this.c)if(M===j||M.startsWith(j))return!0;return!1}}e.$Iic=w;class I{constructor(O){this.provider=O}async provideFileCoverage(O){this.c||(this.c=(async()=>this.provider.provideFileCoverage(O))());try{return(await this.c)?.map(g.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(O,M){const j=await this.c;let z=j?.[O];return!this.provider||!j||!z?[]:(z.detailedCoverage||(z=j[O]=await this.provider.resolveFileCoverage?.(z,M)??z),z.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(O){this.j=O,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,g.TestItem.toPlain(O.item)),this.c.has(O)||this.f.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.f.delete(O);const M=i.$0J.parentId(O.item.extId);if(M&&this.h.has(M.toString())){this.h.add(O.item.extId);return}this.g.add(O)}getChangeEvent(){const{c:O,f:M,g:j}=this;return{get added(){return[...O].map(z=>z.revived)},get updated(){return[...M].map(z=>z.revived)},get removed(){return[...j].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class m extends n.$fK{constructor(){super(...arguments),this.s=new P.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(O){return this.f.get(O)}getMirroredTestDataByReference(O){return this.f.get(O.id)}w(O,M){return{...O,revived:g.TestItem.toPlain(O.item),depth:M?M.depth+1:0,children:new Set}}v(){return new b(this.s)}}class y{constructor(O){this.f=O}checkout(){this.c||(this.c=this.g());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(M=>M.revived)},dispose:(0,A.$db)(()=>{--O.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}g(){const O=new m({asCanonicalUri:M=>M});return this.f.$subscribeToDiffs(),{observers:0,tests:O}}}const L=(T,O,M,j)=>{M?Object.assign(M,j):O.$updateTestRunConfig(T.controllerId,T.profileId,j)};class N{#e;#t;#i;#n;#s;get label(){return this.f}set label(O){O!==this.f&&(this.f=O,L(this,this.#e,this.#n,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,L(this,this.#e,this.#n,{supportsContinuousRun:O}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(O){O!==this.isDefault&&(O?this.#t.add(this.profileId):this.#t.delete(this.profileId),L(this,this.#e,this.#n,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,L(this,this.#e,this.#n,{tag:O?g.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,L(this,this.#e,this.#n,{hasConfigurationHandler:!!O}))}get onDidChangeDefault(){return P.Event.chain(this.#i,O=>O.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(R.$Rf))}constructor(O,M,j,z,J,le,Y,Q,X,ue=!1,ne=void 0,$e=!1){this.controllerId=J,this.profileId=le,this.f=Y,this.kind=Q,this.runHandler=X,this._tag=ne,this.g=$e,this.#e=O,this.#s=M,this.#t=j,this.#i=z,M.set(le,this);const oe=U[Q];if(typeof oe!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);ue&&j.add(le),this.#n={profileId:le,controllerId:J,tag:ne?g.TestTag.namespace(this.controllerId,ne.id):null,label:Y,group:oe,isDefault:ue,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Jic=N;const U={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ee[151],Se([1,0,61,14,121,15,7]),function(ge,e,C,F,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=e.$sN=e.$rN=void 0;class v{static{this.c=new f.$pN("TextEditorDecorationType")}constructor(p,k,S){const c=v.c.nextId();p.$registerTextEditorDecorationType(k.identifier,c,P.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:c,dispose(){p.$removeTextEditorDecorationType(c)}})}}e.$rN=v;class ${constructor(p,k){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,k){this.k();let S=null;if(p instanceof A.$iL)S=new A.$jL(p,p);else if(p instanceof A.$jL)S=p;else throw new Error("Unrecognized location");this.l(S,k,!1)}insert(p,k){this.k(),this.l(new A.$jL(p,p),k,!0)}delete(p){this.k();let k=null;if(p instanceof A.$jL)k=p;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(p,k,S){const c=this.c.validateRange(p);this.g.push({range:c,text:k,forceMoveMarkers:S})}setEndOfLine(p){if(this.k(),p!==A.EndOfLine.LF&&p!==A.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=p}}class E{constructor(p,k,S,c){this.c=p,this.d=k,this._accept(S),this.e=c;const g=this;this.value={get tabSize(){return g.f},set tabSize(o){g.n(o)},get indentSize(){return g.g},set indentSize(o){g.p(o)},get insertSpaces(){return g.j},set insertSpaces(o){g.s(o)},get cursorStyle(){return g.k},set cursorStyle(o){g.t(o)},get lineNumbers(){return g.l},set lineNumbers(o){g.u(o)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=P.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const k=Math.floor(p);return k>0?k:null}if(typeof p=="string"){const k=parseInt(p,10);return isNaN(k)?null:k>0?k:null}return null}n(p){const k=this.m(p);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const k=Math.floor(p);return k>0?k:null}if(typeof p=="string"){const k=parseInt(p,10);return isNaN(k)?null:k>0?k:null}return null}p(p){const k=this.o(p);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const k=this.q(p);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(p)})))}assign(p){const k={};let S=!1;if(typeof p.tabSize<"u"){const c=this.m(p.tabSize);c==="auto"?(S=!0,k.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,S=!0,k.tabSize=c)}if(typeof p.indentSize<"u"){const c=this.o(p.indentSize);c==="tabSize"?(S=!0,k.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,S=!0,k.indentSize=c)}if(typeof p.insertSpaces<"u"){const c=this.q(p.insertSpaces);c==="auto"?(S=!0,k.insertSpaces=c):this.j!==c&&(this.j=c,S=!0,k.insertSpaces=c)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,S=!0,k.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,S=!0,k.lineNumbers=P.TextEditorLineNumbersStyle.from(p.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(p,k){k.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(S)})}}e.$sN=E;class R{constructor(p,k,S,c,g,o,i,r){this.id=p,this.j=k,this.k=S,this.g=!1,this.h=new Set,this.c=g,this.d=new E(this.j,this.id,o,S),this.e=i,this.f=r;const n=this;this.value=Object.freeze({get document(){return c.value},set document(a){throw new F.$9("document")},get selection(){return n.c&&n.c[0]},set selection(a){if(!(a instanceof A.$kL))throw(0,F.$7)("selection");n.c=[a],n.l()},get selections(){return n.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof A.$kL)))throw(0,F.$7)("selections");n.c=a,n.l()},get visibleRanges(){return n.e},set visibleRanges(a){throw new F.$9("visibleRanges")},get options(){return n.d.value},set options(a){n.g||n.d.assign(a)},get viewColumn(){return n.f},set viewColumn(a){throw new F.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new $(c.value,t);return a(h),n.m(h)},insertSnippet(a,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=n.c.map(d=>P.Range.from(d));else if(t instanceof A.$iL){const{lineNumber:d,column:l}=P.Position.from(t);s=[{startLineNumber:d,startColumn:l,endLineNumber:d,endColumn:l}]}else if(t instanceof A.$jL)s=[P.Range.from(t)];else{s=[];for(const d of t)if(d instanceof A.$jL)s.push(P.Range.from(d));else{const{lineNumber:l,column:u}=P.Position.from(d);s.push({startLineNumber:l,startColumn:u,endLineNumber:l,endColumn:u})}}return k.$tryInsertSnippet(p,c.value.version,a.value,s,h)},setDecorations(a,t){const h=t.length===0;h&&!n.h.has(a.key)||(h?n.h.delete(a.key):n.h.add(a.key),n.n(()=>{if(P.$hN(t))return k.$trySetDecorations(p,a.key,P.$iN(t));{const s=new Array(4*t.length);for(let d=0,l=t.length;d<l;d++){const u=t[d];s[4*d]=u.start.line+1,s[4*d+1]=u.start.character+1,s[4*d+2]=u.end.line+1,s[4*d+3]=u.end.character+1}return k.$trySetDecorationsFast(p,a.key,s)}}))},revealRange(a,t){n.n(()=>k.$tryRevealRange(p,P.Range.from(a),t||A.TextEditorRevealType.Default))},show(a){k.$tryShowEditor(p,P.ViewColumn.from(a))},hide(){k.$tryHideEditor(p)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,C.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,C.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,C.ok)(!this.g),this.f=p}_acceptSelections(p){(0,C.ok)(!this.g),this.c=p}async l(){const p=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const k=p.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const S=k.edits.map(g=>g.range);S.sort((g,o)=>g.end.line===o.end.line?g.end.character===o.end.character?g.start.line===o.start.line?g.start.character-o.start.character:g.start.line-o.start.line:g.end.character-o.end.character:g.end.line-o.end.line);for(let g=0,o=S.length-1;g<o;g++){const i=S[g].end;if(S[g+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=k.edits.map(g=>({range:P.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,c,{setEndOfLine:typeof k.setEndOfLine=="number"?P.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$tN=R}),define(Ee[72],Se([1,0,61,4,3,2,5,6,148,20,151,15,13,28,16,53,43]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=void 0;class o{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(n,a){this.h=n,this.i=a,this.a=null,this.b=new Map,this.c=new k.$Ac,this.d=new F.$Wd,this.e=new F.$Wd,this.f=new F.$Wd,this.g=new F.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const a=[],t=[],h=[];if(n.removedDocuments)for(const s of n.removedDocuments){const d=P.URI.revive(s),l=this.c.get(d);l?.unref()&&(this.c.delete(d),a.push(l.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const d=P.URI.revive(s.uri);let l=this.c.get(d);if(l&&d.scheme!==S.Schemas.vscodeNotebookCell&&d.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);l||(l=new o(new $.$nN(this.h.getProxy(v.$fL.MainThreadDocuments),d,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(d,l),t.push(l.value)),l.ref()}if(n.removedEditors)for(const s of n.removedEditors){const d=this.b.get(s);this.b.delete(s),d&&h.push(d)}if(n.addedEditors)for(const s of n.addedEditors){const d=P.URI.revive(s.documentUri);C.ok(this.c.has(d),`document '${d}' does not exist`),C.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const l=this.c.get(d).value,u=new R.$tN(s.id,this.h.getProxy(v.$fL.MainThreadTextEditors),this.i,new g.$V(()=>l.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(w=>D.Range.to(w)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,u)}n.newActiveEditor!==void 0&&(C.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,f.$Oc)(a),(0,f.$Oc)(h),n.removedDocuments&&this.e.fire(a),n.addedDocuments&&this.d.fire(t),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return c.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const a=this.b.get(this.a);return n?a:a?.value}allEditors(){return[...this.b.values()]}};e.$uN=i,e.$uN=i=Ge([qe(0,E.$kN),qe(1,p.$oj)],i),e.$vN=(0,A.$7h)("IExtHostDocumentsAndEditors")}),define(Ee[346],Se([1,0,19,4,6,151,15,7]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;class ${constructor(R,D){this.i=D,this.a=new F.$Wd,this.b=new F.$Wd,this.c=new F.$Wd,this.d=new F.$Wd,this.f=new F.$Wd,this.g=new F.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(f.$fL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const D=this.i.allEditors();return R?D:D.map(p=>p.value)}async showTextDocument(R,D,p){let k;typeof D=="number"?k={position:A.ViewColumn.from(D),preserveFocus:p}:typeof D=="object"?k={position:A.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?A.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:k={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(R.uri,k),c=S&&this.i.getEditor(S);if(c)return c.value;throw S?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,D){return new P.$rN(this.h,R,D).value}$acceptEditorPropertiesChanged(R,D){const p=this.i.getEditor(R);if(!p)throw new Error("unknown text editor");if(D.options&&p._acceptOptions(D.options),D.selections){const k=D.selections.selections.map(A.Selection.to);p._acceptSelections(k)}if(D.visibleRanges){const k=C.$Hb(D.visibleRanges.map(A.Range.to));p._acceptVisibleRanges(k)}if(D.options&&this.b.fire({textEditor:p.value,options:{...D.options,lineNumbers:A.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const k=v.TextEditorSelectionChangeKind.fromValue(D.selections.source),S=D.selections.selections.map(A.Selection.to);this.a.fire({textEditor:p.value,selections:S,kind:k})}if(D.visibleRanges){const k=C.$Hb(D.visibleRanges.map(A.Range.to));this.c.fire({textEditor:p.value,visibleRanges:k})}}$acceptEditorPositionData(R){for(const D in R){const p=this.i.getEditor(D);if(!p)throw new Error("Unknown text editor");const k=A.ViewColumn.to(R[D]);p.value.viewColumn!==k&&(p._acceptViewColumn(k),this.d.fire({textEditor:p.value,viewColumn:k}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$6gc=$}),define(Ee[347],Se([1,0,2,5,6,3,7,15,25,18]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=e.$Lic=void 0,e.$Lic=(0,F.$7h)("IExtHostTimeline");class R{constructor(k,S){this.b=new Map,this.c=new Map,this.a=k.getProxy(f.$fL.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(c,g)=>{if(c&&c.$mid===12)if(this.b.get(c.source)&&$.$mm.equals(g,this.b.get(c.source)?.extension)){const o=c.uri===void 0?void 0:C.URI.revive(c.uri);return this.c.get(c.source)?.get(D(o))?.get(c.handle)}else return;return c}})}async $getTimeline(k,S,c,g){return this.b.get(k)?.provider.provideTimeline(C.URI.revive(S),c,g)}registerTimelineProvider(k,S,c,g){const o=new P.$Sc,i=this.d(S.id,g,o).bind(this);let r;S.onDidChange&&(r=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const n=this.c;return this.f({...S,scheme:k,onDidChange:void 0,async provideTimeline(a,t,h){t?.resetCache&&(o.clear(),n.get(S.id)?.clear());const s=await S.provideTimeline(a,t,h);if(s==null)return;const d=i(a,t);return{...s,source:S.id,items:s.items.map(d)}},dispose(){for(const a of n.values())a.get(S.id)?.clear();r?.dispose(),o.dispose()}},c)}d(k,S,c){return(g,o)=>{let i;if(o?.cacheResults){let r=this.c.get(k);r===void 0&&(r=new Map,this.c.set(k,r));const n=D(g);i=r.get(n),i===void 0&&(i=new Map,r.set(n,i))}return r=>{const{iconPath:n,...a}=r,t=`${k}|${r.id??r.timestamp}`;i?.set(t,r);let h,s,d;r.iconPath&&(n instanceof A.$cM?d={id:n.id,color:n.color}:C.URI.isUri(n)?(h=n,s=n):{light:h,dark:s}=n);let l;return A.$IL.isMarkdownString(a.tooltip)?l=v.MarkdownString.from(a.tooltip):(0,E.$Jf)(a.tooltip)?l=a.tooltip:A.$IL.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=v.MarkdownString.from(a.detail)):(0,E.$Jf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=a.detail),{...a,id:a.id??void 0,handle:t,source:k,command:r.command?S.toInternal(r.command,c):void 0,icon:h,iconDark:s,themeIcon:d,tooltip:l,accessibilityInformation:r.accessibilityInformation}}}}f(k,S){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:S}),(0,P.$Rc)(()=>{for(const g of this.c.values())g.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$Mic=R;function D(p){return p?.toString()}}),define(Ee[348],Se([1,0,219,23,2,4,3,278,11,7,18,19,15,80,21,177,26]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;function o(n,a){if((0,R.$Jf)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends A.$Tc{constructor(a,t,h){super(),this.f=a,this.g=t,this.h=h,this.a=new Map,this.b=new c.$x8;function s(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:d=>s(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(l=>s(l)?this.r(l):l):d})}registerTreeDataProvider(a,t,h){const s=this.createTreeView(a,{treeDataProvider:t},h);return{dispose:()=>s.dispose()}}createTreeView(a,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],d=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,u=!!t.dragAndDropController?.handleDrop,w=this.m(a,t,h),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:d,hasHandleDrag:l,hasHandleDrop:u,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(a,I),m={get onDidCollapseElement(){return w.onDidCollapseElement},get onDidExpandElement(){return w.onDidExpandElement},get selection(){return w.selectedElements},get onDidChangeSelection(){return w.onDidChangeSelection},get activeItem(){return(0,g.$KF)(h,"treeViewActiveItem"),w.focusedElement},get onDidChangeActiveItem(){return(0,g.$KF)(h,"treeViewActiveItem"),w.onDidChangeActiveItem},get visible(){return w.visible},get onDidChangeVisibility(){return w.onDidChangeVisibility},get onDidChangeCheckboxState(){return w.onDidChangeCheckboxState},get message(){return w.message},set message(y){(0,k.$kk)(y)&&(0,g.$KF)(h,"treeViewMarkdownMessage"),w.message=y},get title(){return w.title},set title(y){w.title=y},get description(){return w.description},set description(y){w.description=y},get badge(){return w.badge},set badge(y){y!==void 0&&E.ViewBadge.isViewBadge(y)?w.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(w.badge=void 0)},reveal:(y,L)=>w.reveal(y,L),dispose:async()=>{await b,this.a.delete(a),w.dispose()}};return this.B(m),m}$getChildren(a,t){const h=this.a.get(a);return h?h.getChildren(t):Promise.reject(new v.$dF(a))}async $handleDrop(a,t,h,s,d,l,u,w){const I=this.a.get(a);if(!I)return Promise.reject(new v.$dF(a));const b=p.DataTransfer.toDataTransfer(h,async m=>(await this.f.$resolveDropFileData(a,t,m)).buffer);return u===a&&w&&await this.j(b,I,w,d,l),I.onDrop(b,s,d)}async j(a,t,h,s,d){const l=this.b.removeDragOperationTransfer(d);if(l)(await l)?.forEach((u,w)=>{u&&a.set(w,u)});else if(d&&t.handleDrag){const u=t.handleDrag(h,a,s);this.b.addDragOperationTransfer(d,u),await u}return a}async $handleDrag(a,t,h,s){const d=this.a.get(a);if(!d)return Promise.reject(new v.$dF(a));const l=await this.j(new E.$_L,d,t,s,h);if(!(!l||s.isCancellationRequested))return p.DataTransfer.from(l)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new v.$dF(a);return t.hasResolve}$resolve(a,t,h){const s=this.a.get(a);if(!s)throw new v.$dF(a);return s.resolveTreeItem(t,h)}$setExpanded(a,t,h){const s=this.a.get(a);if(!s)throw new v.$dF(a);s.setExpanded(t,h)}$setSelectionAndFocus(a,t,h){const s=this.a.get(a);if(!s)throw new v.$dF(a);s.setSelectionAndFocus(t,h)}$setVisible(a,t){const h=this.a.get(a);if(!h){if(!t)return;throw new v.$dF(a)}h.setVisible(t)}$changeCheckboxState(a,t){const h=this.a.get(a);if(!h)throw new v.$dF(a);h.setCheckboxState(t)}m(a,t,h){const s=this.B(new r(a,t,this.f,this.g.converter,this.h,h));return this.a.set(a,s),s}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Nic=i;class r extends A.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.$Sf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,h,s,d,l){if(super(),this.I=a,this.J=h,this.L=s,this.M=d,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$7d,l.contributes&&l.contributes.views)for(const b in l.contributes.views)for(const m of l.contributes.views[b])m.id===a&&(this.P=m.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let u,w;const I=P.Event.debounce(this.F.event,(b,m)=>(b||(b={message:!1,elements:[]}),m.element!==!1&&(u||(u=new Promise(y=>w=y),this.G=this.G.then(()=>u)),Array.isArray(m.element)?b.elements.push(...m.element):b.elements.push(m.element)),m.message&&(b.message=!0),b),200,!0);this.B(I(({message:b,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const y=w;return u=null,this.$(m).then(()=>y())})),b&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let h=this.X(a);return h||(h=await this.Y(t)),h?h.map(s=>s.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const h=(0,R.$Sf)(t.select)?!0:t.select,s=(0,R.$Sf)(t.focus)?!1:t.focus,d=(0,R.$Sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(l=>this.W(a,l[l.length-1]).then(u=>this.J.$reveal(this.I,{item:u.item,parentChain:l.map(w=>w.item)},{select:h,focus:s,expand:d})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:h,focus:s,expand:d})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=p.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const h=this.getExtensionElement(a);h&&(t?this.u.fire(Object.freeze({element:h})):this.w.fire(Object.freeze({element:h})))}setSelectionAndFocus(a,t){const h=!(0,D.$ub)(this.s,a);this.s=a;const s=this.t!==t;this.t=t,h&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async h=>{const s=this.getExtensionElement(h.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:h.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(a,t,h){const s=[];for(const d of a){const l=this.getExtensionElement(d);l&&s.push(l)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,h),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,h){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,$.$Zg)(()=>this.g?.handleDrop?this.g.handleDrop(s,a,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const h=this.j.get(a);if(h){const s=this.m.get(h);if(s){const d=await this.f.resolveTreeItem(s.extensionItem,h,t)??s.extensionItem;return this.hb(d),s.item.tooltip=this.eb(d.tooltip),s.item.command=this.fb(s.disposableStore,d.command),s.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(h=>this.W(t,h[h.length-1]).then(s=>(h.push(s),h))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Zg)(()=>this.f.getParent(a))}W(a,t){const h=this.m.get(a);return h?Promise.resolve(h):(0,$.$Zg)(()=>this.f.getTreeItem(a)).then(s=>this.kb(a,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const d=this.getExtensionElement(s);if(d){const l=this.m.get(d);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const h=this.getExtensionElement(a);t=h?this.m.get(h):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$7d(this.Z.token);try{const h=a?this.m.get(a):void 0,s=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const d=(0,D.$Hb)(s||[]),l=await Promise.all((0,D.$Hb)(d).map(w=>this.f.getTreeItem(w)));if(t.token.isCancellationRequested)return;const u=l.map((w,I)=>w?this.db(d[I],w,h):null);return(0,D.$Hb)(u)}finally{t.dispose()}}$(a){if(a.some(h=>!h))return this.Z.dispose(!0),this.Z=new S.$7d,this.tb(),this.J.$refresh(this.I);{const h=this.ab(a);if(h.length)return this.bb(h)}return Promise.resolve(void 0)}ab(a){const t=new Set,h=a.map(d=>this.m.get(d));for(const d of h)if(d&&!t.has(d.item.handle)){let l=d;for(;l&&l.parent&&h.findIndex(u=>l&&l.parent&&u&&u.item.handle===l.parent.item.handle)===-1;){const u=this.j.get(l.parent.item.handle);l=u?this.m.get(u):void 0}l&&!l.parent&&t.add(d.item.handle)}const s=[];return t.forEach(d=>{const l=this.j.get(d);if(l){const u=this.m.get(l);u&&(!u.parent||!t.has(u.parent.item.handle))&&s.push(d)}}),s}bb(a){const t={};return Promise.all(a.map(h=>this.cb(h).then(s=>{s&&(t[h]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const h=this.m.get(t);if(h)return this.rb(t),(0,$.$Zg)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const d=this.ib(t,s,h.parent);return this.pb(t,d,h,h.parent),h.dispose(),d}return null})}return Promise.resolve(null)}db(a,t,h){const s=this.ib(a,t,h);if(t.id&&this.j.has(s.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(a,s),this.qb(s,h),s}eb(a){return E.$IL.isMarkdownString(a)?p.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,h,s;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,h=a.checkboxState.tooltip,s=a.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:h,accessibilityInformation:s}}hb(a){if(!E.$7L.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,h){this.hb(t);const s=this.B(new A.$Sc),d=this.kb(a,t,h),l=this.lb(t);return{item:{handle:d,parentHandle:h?h.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,R.$Sf)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:h,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(a){return a.iconPath instanceof E.$cM?a.iconPath:void 0}kb(a,{id:t,label:h,resourceUri:s},d,l){if(t)return`${r.b}/${t}`;const u=o(h,this.N),w=d?d.item.handle:r.a;let I=u?u.label:s?(0,F.$Fg)(s):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const b=this.m.has(a)?this.m.get(a).item.handle:void 0,m=this.X(d)||[];let y,L=0;do{if(y=`${w}/${L}:${I}`,l||!this.j.has(y)||b===y)break;L++}while(L<=m.length);return y}lb(a){if(a.iconPath&&!(a.iconPath instanceof E.$cM))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof E.$cM)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return f.URI.isUri(a)?a:f.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,h,s){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==h.item.handle&&this.j.delete(h.item.handle),this.ob(a,t);const d=this.X(s)||[],l=d.filter(u=>u.item.handle===h.item.handle)[0];l&&d.splice(d.indexOf(l),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ee[349],Se([1,0,4,3,2,30,15,93,6,7]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;class R extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(S,c,g,o){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new C.$Wd),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Wd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=c,this.#n=g,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#l=o.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,f.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(S){this.#u||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#l=S.active,this.#c=S.visible,this.#o=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:A.ViewColumn.from(S),preserveFocus:!!c})}c(){if(this.#u)throw new Error("Webview is disposed")}}class D extends F.$Tc{static c(){return(0,P.$rg)()}constructor(S,c,g){super(),this.j=c,this.m=g,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$fL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,c,g,o,i={}){const r=typeof o=="object"?o.viewColumn:o,n={viewColumn:A.ViewColumn.from(r),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,v.$ihc)(S),t=D.c();this.f.$createWebviewPanel((0,v.$khc)(S),t,c,{title:g,panelOptions:p(i),webviewOptions:(0,v.$lhc)(S,this.m,i),serializeBuffersForPostMessage:a},n);const h=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,c,g,r,i,h,!0)}$onDidChangeWebviewPanelViewStates(S){const c=Object.keys(S);c.sort((g,o)=>{const i=S[g],r=S[o];return i.active?1:r.active?-1:+i.visible-+r.visible});for(const g of c){const o=this.getWebviewPanel(g);if(!o)continue;const i=S[g];o._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,c,g){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:g,extension:S}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,v.$ihc)(S)}),new E.$hL(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(S,c,g,o){const i=this.h.get(c);if(!i)throw new Error(`No serializer found for '${c}'`);const{serializer:r,extension:n}=i,a=this.j.createNewWebview(S,g.webviewOptions,n),t=this.createNewWebviewPanel(S,c,g.title,o,g.panelOptions,a,g.active);await r.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(S,c,g,o,i,r,n){const a=new R(S,this.f,r,{viewType:c,title:g,viewColumn:o,panelOptions:i,active:n});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$mhc=D;function p(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(Ee[350],Se([1,0,4,3,93,15,6,7]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;class $ extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,p,k,S,c,g){super(),this.#s=!1,this.#l=this.B(new C.$Wd),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new C.$Wd),this.onDidDispose=this.#u.event,this.#i=k,this.#a=S,this.#e=D,this.#t=p,this.#n=c,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(D,p){this.d=p,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$fL.MainThreadWebviewViews)}registerWebviewViewProvider(D,p,k,S){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:k,extension:D}),this.a.$registerWebviewViewProvider((0,f.$khc)(D),p,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$ihc)(D)}),new v.$hL(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(D,p,k,S,c){const g=this.b.get(p);if(!g)throw new Error(`No view provider found for '${p}'`);const{provider:o,extension:i}=g,r=this.d.createNewWebview(D,{},i),n=new $(D,this.a,p,k,r,!0);this.c.set(D,n),await o.resolveWebviewView(n,{state:S},c)}async $onDidChangeWebviewViewVisibility(D,p){this.e(D)._setVisible(p)}async $disposeWebviewView(D){const p=this.e(D);this.c.delete(D),p.dispose(),this.d.deleteWebview(D)}e(D){const p=this.c.get(D);if(!p)throw new Error("No webview found");return p}}e.$Qic=E}),define(Ee[351],Se([1,0,69,16,13,249,32,10]),function(ge,e,C,F,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;let $=class{constructor(D,p){D.addFileSystemProvider(F.Schemas.file,new E(p),{isCaseSensitive:v.$k})}};e.$vjc=$,e.$vjc=$=Ge([qe(0,C.$ehc),qe(1,f.$oj)],$);class E{constructor(D){this.b=D,this.a=new P.$Cq(this.b)}async stat(D){const p=await this.a.stat(D);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(D){return this.a.readdir(D)}createDirectory(D){return this.a.mkdir(D)}readFile(D){return this.a.readFile(D)}writeFile(D,p,k){return this.a.writeFile(D,p,{...k,unlock:!1,atomic:!1})}delete(D,p){return this.a.delete(D,{...p,useTrash:!1,atomic:!1})}rename(D,p,k){return this.a.rename(D,p,k)}copy(D,p,k){return this.a.copy(D,p,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(D,p){throw new Error("Method not implemented.")}}}),define(Ee[352],Se([1,0,17,63,30,33,3,6,2,20]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;let R=class extends A.$Tc{constructor(p,k){super();const S=p.getProxy(v.$fL.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async c=>{const g=$.URI.file((0,C.$jc)((0,F.tmpdir)(),(0,f.$rg)()));return await S.$download(c,g),g})}};e.$tjc=R,e.$tjc=R=Ge([qe(0,E.$kN),qe(1,P.$GN)],R)}),define(Ee[353],Se([1,0,57,17,2,94,3,16,11,31]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=void 0;class R extends P.$ghc{constructor(){super(...arguments),this.i=null}async g(t){const h=await super.g(t);if(h.scheme!==v.Schemas.file)return h;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const s=h.fsPath;let d=0;do{let l;d===0?l=s:l=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${d}`:`${s}-${d}`,await D(l);const u=F.$jc(l,"vscode.lock"),w=await c(this.d,u,!1);if(w)return this.i=w,process.on("exit",()=>{w.dispose()}),f.URI.file(l);d++}while(d<10);return h}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Fjc=R;async function D(a){try{await E.Promises.stat(a);return}catch{}try{await E.Promises.mkdir(a,{recursive:!0})}catch{}}const p=1e3,k=10*60*1e3;class S extends A.$Tc{constructor(t,h){super(),this.b=t,this.c=h,this.a=this.B(new $.$fh),this.a.cancelAndSet(async()=>{const s=await g(t,h);(!s||s.pid!==process.pid)&&(t.info(`Lock '${h}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(h,new Date,new Date)}catch(d){t.error(d),t.info(`Lock '${h}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(h),{flag:"w"})}catch(h){this.b.error(h)}}}async function c(a,t,h){try{const d={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(d),{flag:"wx"})}catch(d){a.error(d)}const s=await g(a,t);return!s||s.pid!==process.pid?h?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),r(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function g(a,t){let h;try{h=await E.Promises.readFile(t)}catch(s){return a.error(s),null}try{return JSON.parse(String(h))}catch(s){return a.error(s),null}}async function o(a,t){let h;try{h=await E.Promises.stat(t)}catch(s){return a.error(s),0}return h.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function r(a,t){const h=await g(a,t);if(!h)return a.info(`Lock '${t}': Could not read pid of lock holder.`),n(a,t);if(h.willReleaseAt){let w=h.willReleaseAt-Date.now();if(w<5e3){for(w>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${w} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);w>0;){if(await(0,$.$8g)(Math.min(100,w)),await o(a,t)===0)return n(a,t);w=h.willReleaseAt-Date.now()}return n(a,t)}}if(!i(h.pid))return a.info(`Lock '${t}': The pid ${h.pid} appears to be gone.`),n(a,t);const s=await o(a,t),d=Date.now()-s;if(d<=k)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$8g)(2e3);const l=await o(a,t),u=Date.now()-l;return u<=k?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(a,t))}async function n(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return c(a,t,!0)}}),define(Ee[354],Se([1,0,30,20,46,33]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=void 0;let A=class extends f.$Chc{constructor($,E){super(!0,$,E)}createTerminal($,E,R){return this.createTerminalFromOptions({name:$,shellPath:E,shellArgs:R})}createTerminalFromOptions($,E){const R=new f.$Bhc(this.a,(0,C.$rg)(),$,$.name);return this.f.push(R),R.create($,this.R($,E)),R.value}};e.$1ic=A,e.$1ic=A=Ge([qe(0,P.$GN),qe(1,F.$kN)],A)}),define(Ee[355],Se([1,0,4,37,45,5]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BK=e.$AK=e.OutputChannelUpdateMode=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=void 0,e.$qK="text/x-code-output",e.$rK="output",e.$sK="Log",e.$tK="text/x-code-log-output",e.$uK="log",e.$vK="workbench.panel.output",e.$wK=new f.$lj("inOutput",!1),e.$xK=new f.$lj("activeLogOutput",!1),e.$yK=new f.$lj("outputView.scrollLock",!1),e.$zK=(0,P.$7h)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$AK={OutputChannels:"workbench.contributions.outputChannels"};class v{constructor(){this.a=new Map,this.b=new C.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new C.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(R=>E.push(R)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}F.$In.add(e.$AK.OutputChannels,new v),e.$BK=new f.$lj("activeOutputChannel","")}),define(Ee[152],Se([1,0,6,5,20,25,13,355,69,27,59,182,22,18,32,4,3]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=void 0;class o extends A.$uj{get disposed(){return this.n}constructor(a,t,h,s,d){super(),this.id=a,this.name=t,this.r=h,this.s=s,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,v.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=p.$ke.fromString(t).byteLength,(0,A.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(a){this.append(a)}}let r=class{constructor(a,t,h,s,d,l){this.i=t,this.j=h,this.k=s,this.l=d,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(C.$fL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,h]of this.g)h.visible=t===this.h}createOutputChannel(a,t,h){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,d=(0,k.$Jf)(t)?t:void 0;if((0,k.$Jf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const u=this.i.environment.extensionLogLevel?.find(([I])=>P.$mm.equals(h.identifier,I))?.[1];u&&(l=(0,A.$Ej)(u));const w=s?this.o(a,l,h):this.n(a,d,h);return w.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),s?this.r(a,l??this.m.getLevel(),w):this.q(a,w)}async n(a,t,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,d=this.k.extUri.joinPath(s,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.a.$register(a,d,t,h.identifier.value);return new o(u,a,l,this.a,h)}async o(a,t,h){const s=await this.p(h),d=a.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(s,`${d}.log`),u=`${h.identifier.value}.${d}`,w=this.l.createLogger(l,{id:u,name:a,logLevel:t,extensionId:h.identifier.value});return new i(u,a,w,this.a,h)}p(a){let t=this.d.get(a.identifier.value);if(!t){const h=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(h)}catch(s){if((0,S.$Hk)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}return h})())}return t}q(a,t){let h=!1;const s=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return a},append(d){s(),t.then(l=>l.append(d))},appendLine(d){s(),t.then(l=>l.appendLine(d))},clear(){s(),t.then(d=>d.clear())},replace(d){s(),t.then(l=>l.replace(d))},show(d,l){s(),t.then(u=>u.show(d,l))},hide(){s(),t.then(d=>d.hide())},dispose(){h=!0,t.then(d=>d.dispose())}}}r(a,t,h){const s=new g.$Sc,d=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},l=s.add(new c.$Wd);function u(w){t=w,l.fire(w)}return h.then(w=>{s.add(w),w.logLevel!==t&&u(w.logLevel),s.add(w.onDidChangeLogLevel(I=>u(I)))}),{...this.q(a,h),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(w,...I){d(),h.then(b=>b.trace(w,...I))},debug(w,...I){d(),h.then(b=>b.debug(w,...I))},info(w,...I){d(),h.then(b=>b.info(w,...I))},warn(w,...I){d(),h.then(b=>b.warn(w,...I))},error(w,...I){d(),h.then(b=>b.error(w,...I))},dispose(){s.dispose()}}}};e.$ric=r,e.$ric=r=Ge([qe(0,f.$kN),qe(1,E.$AN),qe(2,$.$ehc),qe(3,R.$Qgc),qe(4,A.$pj),qe(5,A.$oj)],r),e.$sic=(0,F.$7h)("IExtHostOutputService")}),define(Ee[153],Se([1,0,5,11]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=void 0,e.$Mm=(0,C.$7h)("remoteAgentService"),e.$Nm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let P=1/0;for(let v=0;v<this.maxSampleCount;v++){const $=await f.getRoundTripTime();if($===void 0)return;P=Math.min(P,$/2),await(0,F.$8g)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(P):A=this.initial.reduce((v,$)=>v+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:P,average:this.average.reduce((v,$)=>v+$,0)/this.average.length,high:(()=>typeof A>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ee[356],Se([1,0,223,87,37,40,51,3,4,153,10,24]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=void 0,e.$YH=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$ZH=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$1H=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$2H=Object.freeze({id:"problems",title:(0,C.localize)(3,null),type:"object",order:101}),e.$3H={ConfigurationMigration:"base.contributions.configuration.migration"};class p{constructor(){this.migrations=[],this.a=new $.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const k=new p;f.$In.add(e.$3H.ConfigurationMigration,k);let S=class extends v.$Tc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const n of r.added)await this.f(n,k.migrations)})),this.c(k.migrations),this.B(k.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(r=>this.g(r,o?.uri))])}async g(o,i){const r=this.a.inspect(o.key,{resource:i}),n=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[a,t]of n){const h=[];for(const d of r.overrideIdentifiers??[]){const l=await this.h(o,{resource:i,overrideIdentifier:d},a);for(const u of l??[]){let w=h.find(([[I,b]])=>I===u[0]&&(0,D.$An)(b.value,u[1].value));w||h.push(w=[u,[]]),w[1].push(d)}}const s=await this.h(o,{resource:i},a,r);for(const d of s??[])h.push([d,[]]);h.length&&await Promise.allSettled(h.map(async([[d,l],u])=>this.a.updateValue(d,l.value,{resource:i,overrideIdentifiers:u},t)))}}async h(o,i,r,n){const a=d=>t(this.a.inspect(d,i)),t=d=>{const l=d[r];return i.overrideIdentifier?l?.override:l?.value},h=n?t(n):a(o.key);if(h===void 0)return;const s=await o.migrateFn(h,a);return Array.isArray(s)?s:[[o.key,s]]}};e.$4H=S,e.$4H=S=Ge([qe(0,A.$Ai),qe(1,P.$di)],S);let c=class extends v.$Tc{constructor(o){super(),(async()=>{if(!R.$i&&(await o.getEnvironment())?.os!==1)return;f.$In.as(F.$Nn.Configuration).registerConfiguration({...e.$1H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(4,null)},default:[],markdownDescription:(0,C.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(6,null),scope:2}}})})()}};e.$5H=c,e.$5H=c=Ge([qe(0,E.$Mm)],c)}),define(Ee[357],Se([1,0,35,16,17,23,232,356,87,5,37]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdb=e.$wdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$vdb=e.$udb=void 0,e.$udb=(0,E.$7h)("editorResolverService"),e.$vdb="workbench.editorAssociations";const D=R.$In.as($.$Nn.Configuration),p={...v.$ZH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(p);var k;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(k||(e.RegisteredEditorPriority=k={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function c(o){switch(o){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}e.$wdb=c;function g(o,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(f.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,P.$Fg)(i);return C.$Mj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$xdb=g}),define(Ee[358],Se([1,0,34,16,17,10,23,2,5,267,40,143,153]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=e.$TK=void 0,e.$TK=(0,$.$7h)("pathService");let S=k=class{constructor(g,o,i,r){this.d=g,this.e=o,this.f=i,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??g})()}hasValidBasename(g,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(r=>this.h(g,r,o)):this.h(g,o,i)}h(g,o,i){return g.scheme===F.Schemas.file||g.scheme===F.Schemas.vscodeRemote?(0,C.$7f)(i??(0,A.$Fg)(g),o===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,o){if(g.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,E.$QK)(o.getWorkspace());if(i)return i;const r=o.getWorkspace().folders[0];if(r)return r.uri.scheme;const n=o.getWorkspace().configuration;return n?n.scheme:F.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?f.$fc:f.$gc)}async fileURI(g){let o="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const r=g.indexOf("/",2);r===-1?(o=g.substring(2),g="/"):(o=g.substring(2,r),g=g.substring(r)||"/")}return v.URI.from({scheme:F.Schemas.file,authority:o,path:g,query:"",fragment:""})}};e.$UK=S,e.$UK=S=k=Ge([qe(1,p.$Mm),qe(2,D.$CK),qe(3,R.$di)],S)}),define(Ee[359],Se([1,0,234,19,52,4,54,3,2,51,239,13,64,269,89,40,143,26,21,18,24,45]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$MK=e.$LK=e.OnPortForward=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.TunnelSource=e.TunnelCloseReason=e.$FK=e.$EK=e.$DK=void 0;const t=10*1e3,h="remote.tunnels.toRestore";e.$DK="onTunnel",e.$EK=new a.$lj("forwardedPortsViewEnabled",!1,C.localize(0,null));function s(N){const U=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(U)return{host:U[1]?.substring(0,U[1].length-1)||"localhost",port:Number(U[2])}}e.$FK=s;var d;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(d||(e.TunnelCloseReason=d={}));var l;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(l||(e.TunnelSource=l={})),e.$GK={source:l.User,description:C.localize(1,null)},e.$HK={source:l.Auto,description:C.localize(2,null)};function u(N,U,T){const O=N.get(I(U,T));if(O)return O;if((0,S.$Gv)(U))for(const M of S.$Fv){const j=I(M,T);if(N.has(j))return N.get(j)}else if((0,S.$Iv)(U))for(const M of S.$Hv){const j=I(M,T);if(N.has(j))return N.get(j)}}e.$IK=u;function w(N,U,T){const O=u(N,U,T);if(O)return O;const M=(0,S.$Iv)(U)?"localhost":(0,S.$Gv)(U)?"0.0.0.0":void 0;if(M)return u(N,M,T)}e.$JK=w;function I(N,U){return N+":"+U}e.$KK=I;var b;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(b||(e.OnPortForward=b={}));function m(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$LK=m;class y extends v.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(U){super(),this.r=U,this.j=[],this.n=new P.$Wd,this.onDidChangeAttributes=this.n.event,this.B(U.onDidChangeConfiguration(T=>{(T.affectsConfiguration(y.c)||T.affectsConfiguration(y.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(U,T,O){let M=this.w(U,T,O,this.j,0);const j={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const z=this.j[M];z.key===U?(j.onAutoForward=z.onAutoForward??j.onAutoForward,j.elevateIfNeeded=z.elevateIfNeeded!==void 0?z.elevateIfNeeded:j.elevateIfNeeded,j.label=z.label??j.label,j.requireLocalPort=z.requireLocalPort,j.protocol=z.protocol):(j.onAutoForward=j.onAutoForward??z.onAutoForward,j.elevateIfNeeded=j.elevateIfNeeded!==void 0?j.elevateIfNeeded:z.elevateIfNeeded,j.label=j.label??z.label,j.requireLocalPort=j.requireLocalPort!==void 0?j.requireLocalPort:void 0,j.protocol=j.protocol??z.protocol),M=this.w(U,T,O,this.j,M+1)}return j.onAutoForward!==void 0||j.elevateIfNeeded!==void 0||j.label!==void 0||j.requireLocalPort!==void 0||j.protocol!==void 0?j:this.C()}t(U){return U.start!==void 0&&U.end!==void 0}u(U){return U.host!==void 0&&U.port!==void 0&&(0,r.$Jf)(U.host)&&(0,r.$Nf)(U.port)}w(U,T,O,M,j){if(j>=M.length)return-1;const z=!(0,S.$Gv)(T)&&!(0,S.$Iv)(T),le=M.slice(j).findIndex(Y=>(0,r.$Nf)(Y.key)?z?!1:Y.key===U:this.t(Y.key)?z?!1:U>=Y.key.start&&U<=Y.key.end:this.u(Y.key)?U===Y.key.port&&T===Y.key.host:O?Y.key.test(O):!1);return le>=0?le+j:-1}y(){const U=this.r.getValue(y.c);if(!U||!(0,r.$Lf)(U))return[];const T=[];for(const M in U){if(M===void 0)continue;const j=U[M];let z;if(Number(M))z=Number(M);else if((0,r.$Jf)(M))if(y.g.test(M)){const J=M.match(y.g);z={start:Number(J[1]),end:Number(J[2])}}else if(y.h.test(M)){const J=M.match(y.h);z={host:J[1],port:Number(J[2])}}else{let J;try{J=RegExp(M)}catch{}J&&(z=J)}z&&T.push({key:z,elevateIfNeeded:j.elevateIfNeeded,onAutoForward:j.onAutoForward,label:j.label,requireLocalPort:j.requireLocalPort,protocol:j.protocol})}const O=this.r.getValue(y.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(T)}z(U){function T(O,M){return(0,r.$Nf)(O.key)?O.key:M.t(O.key)?O.key.start:M.u(O.key)?O.key.port:Number.MAX_VALUE}return U.sort((O,M)=>T(O,this)-T(M,this))}C(){return this.m}static providedActionToAction(U){switch(U){case S.ProvidedOnAutoForward.Notify:return b.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return b.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return b.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return b.OpenPreview;case S.ProvidedOnAutoForward.Silent:return b.Silent;case S.ProvidedOnAutoForward.Ignore:return b.Ignore;default:return}}async addAttributes(U,T,O){const j=this.r.inspect(y.c).userRemoteValue;let z;!j||!(0,r.$Lf)(j)?z={}:z=(0,n.$wn)(j),z[`${U}`]||(z[`${U}`]={});for(const J in T)z[`${U}`][J]=T[J];return this.r.updateValue(y.c,z,O)}}e.$MK=y;let L=class extends v.$Tc{constructor(U,T,O,M,j,z,J,le,Y,Q){super(),this.H=U,this.I=T,this.J=O,this.L=M,this.M=j,this.N=z,this.O=J,this.P=le,this.Q=Y,this.R=Q,this.c=new Map,this.g=new P.$Wd,this.onForwardPort=this.g.event,this.h=new P.$Wd,this.onClosePort=this.h.event,this.j=new P.$Wd,this.onPortName=this.j.event,this.n=new P.$Wd,this.onCandidatesChanged=this.n.event,this.t=new P.$Wd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$Wd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new y(O),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const ue=await this.getAttributes(X.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of X)if(ne.localAddress){const $e=I(ne.tunnelRemoteHost,ne.tunnelRemotePort),oe=w(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set($e,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ue?.get(ne.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ue?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:oe?.detail,hasRunningProcess:!!oe,pid:oe?.pid,privacy:ne.privacy,source:e.$GK}),this.f.set($e,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const ue=I(X.tunnelRemoteHost,X.tunnelRemotePort);if(!w(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!w(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!w(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const ne=w(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),$e=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:$e?.protocol??S.TunnelProtocol.Http,localUri:await this.X(X.localAddress,$e),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:X.privacy,source:e.$GK})}await this.$(),this.f.set(ue,X),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(X=>this.W(X,d.Other))),this.U()}S(){return this.Q.extensions.find(U=>U.activationEvents?.includes(e.$DK))?(this.R.createKey(e.$EK.key,!0),!0):!1}U(){if(this.S())return;const U=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&U.dispose()}))}async W(U,T){const O=I(U.host,U.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.$(),this.h.fire(U))}X(U,T){if(U.startsWith("http"))return $.URI.parse(U);const O=T?.protocol??"http";return $.URI.parse(`${O}://${U}`)}async Y(){const U=this.N.getWorkspace(),T=U.configuration?(0,A.$Ui)(U.configuration.path):U.folders.length>0?(0,A.$Ui)(U.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${h}.${this.L.remoteAuthority}.${T}`}async Z(){const U=this.I.get(h,1);if(U)return this.I.remove(h,1),await this.$(),U;const T=await this.Y();if(T)return this.I.get(T,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const U=await this.s;if(U&&U!==this.y){const T=JSON.parse(U)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${T.map(O=>O.remotePort).join(", ")}`);for(const O of T){const M=w(this.detected,O.remoteHost,O.remotePort);O.source.source!==l.Extension&&!M||O.source.source===l.Extension&&M?await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,privacy:O.privacy,elevateIfNeeded:!0,source:O.source}):O.source.source===l.Extension&&!M&&this.D.set(I(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const U=await this.Y();this.w=this.B(new v.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async T=>{T.key===U&&(this.s=Promise.resolve(this.I.get(U,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const U=JSON.stringify(Array.from(this.forwarded.values()));if(U!==this.y){this.y=U;const T=await this.Y();T&&this.I.store(T,this.y,0,0)}}}async bb(U,T,O){if(!U.tunnelLocalPort||!O?.requireLocalPort||U.tunnelLocalPort===T)return;const M=new Date;if(this.ab.getTime()+t>M.getTime())return;this.ab=M;const j=C.localize(3,null,T,U.tunnelRemotePort,U.tunnelLocalPort);return this.P.info(j)}async forward(U,T){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.cb(U,T)}async cb(U,T){await this.Q.activateByEvent(e.$DK);const O=w(this.forwarded,U.remote.host,U.remote.port);T=T??(T!==null?(await this.getAttributes([U.remote]))?.get(U.remote.port):void 0);const M=U.local!==void 0?U.local:U.remote.port;let j;if(O)return this.eb(O,U,T);{const z=this.L.remoteAuthority,J=z?{getAddress:async()=>(await this.M.resolveAuthority(z)).authority}:void 0,le=I(U.remote.host,U.remote.port);this.c.set(le,!0),U=this.db(le,U);const Y=await this.H.openTunnel(J,U.remote.host,U.remote.port,void 0,M,U.elevateIfNeeded?U.elevateIfNeeded:T?.elevateIfNeeded,U.privacy,T?.protocol);if(typeof Y=="string")j=Y;else if(Y&&Y.localAddress){const Q=w(this.m??new Map,U.remote.host,U.remote.port),X=Y.protocol?Y.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:T?.protocol??S.TunnelProtocol.Http,ue={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:T?.label??U.name,closeable:!0,localAddress:Y.localAddress,protocol:X,localUri:await this.X(Y.localAddress,T),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:U.source??e.$GK,privacy:Y.privacy};return this.forwarded.set(le,ue),this.f.set(le,Y),this.c.delete(le),await this.$(),await this.bb(Y,M,T),this.g.fire(ue),Y}this.c.delete(le)}return j}db(U,T){const O=this.D.has(U)?this.D:this.F.has(U)?this.F:void 0;if(O){const M=O.get(U);O.delete(U),M&&(T.name=M.name??T.name,T.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??T.local,T.privacy=M.privacy??T.privacy)}return T}async eb(U,T,O){const M=O?.label??T.name;let j;(function(J){J[J.None=0]="None",J[J.Fire=1]="Fire",J[J.Reopen=2]="Reopen"})(j||(j={}));let z=j.None;switch(M!==U.name&&(U.name=M,z=j.Fire),(O?.protocol||U.protocol!==S.TunnelProtocol.Http)&&O?.protocol!==U.protocol&&(T.source=U.source,z=j.Reopen),T.privacy&&U.privacy!==T.privacy&&(z=j.Reopen),z){case j.Fire:{this.g.fire();break}case j.Reopen:await this.close(U.remoteHost,U.remotePort,d.User),await this.cb(T,O)}return w(this.f,T.remote.host,T.remote.port)}async name(U,T,O){const M=w(this.forwarded,U,T),j=I(U,T);if(M){M.name=O,await this.$(),this.j.fire({host:U,port:T});return}else this.detected.has(j)&&(this.detected.get(j).name=O,this.j.fire({host:U,port:T}))}async close(U,T,O){const M=I(U,T),j=this.forwarded.get(M);return O===d.AutoForwardEnd&&j&&j.source.source===l.Auto&&this.F.set(M,{local:j.localPort,name:j.name,privacy:j.privacy}),await this.H.closeTunnel(U,T),this.W({host:U,port:T},O)}address(U,T){const O=I(U,T);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(U){if(U)for(const T of U){const O=w(this.m??new Map,T.remoteAddress.host,T.remoteAddress.port),M=typeof T.localAddress=="string"?T.localAddress:I(T.localAddress.host,T.localAddress.port);this.detected.set(I(T.remoteAddress.host,T.remoteAddress.port),{remoteHost:T.remoteAddress.host,remotePort:T.remoteAddress.port,localAddress:M,protocol:S.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:l.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(T.remoteAddress.host,T.remoteAddress.port,M,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(U){this.r=U}async setCandidates(U){let T=U;this.r&&(T=await this.r(U));const O=this.fb(T);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(M=>M.port).join(", ")}`),this.n.fire(O)}fb(U){const T=this.m??new Map,O=new Map;return this.m=O,U.forEach(M=>{const j=I(M.host,M.port);O.set(j,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),T.has(j)&&T.delete(j);const z=w(this.forwarded,M.host,M.port);z&&(z.runningProcess=M.detail,z.hasRunningProcess=!0,z.pid=M.pid)}),T.forEach((M,j)=>{const z=s(j);if(!z)return;const J=w(this.forwarded,z.host,z.port);J&&(J.runningProcess=void 0,J.hasRunningProcess=!1,J.pid=void 0);const le=w(this.detected,z.host,z.port);le&&(le.runningProcess=void 0,le.hasRunningProcess=!1,le.pid=void 0)}),T}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const U=Array.from(this.forwarded.values()),T=await this.getAttributes(U.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(T)for(const O of U){const M=T.get(O.remotePort);(M?.protocol||O.protocol!==S.TunnelProtocol.Http)&&M?.protocol!==O.protocol&&await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},M),M&&M.label&&M.label!==O.name&&await this.name(O.remoteHost,O.remotePort,M.label)}}async getAttributes(U,T=!0){const O=new Map,M=new Map;U.forEach(Y=>{const Q=w(this.m??new Map,S.$Fv[0],Y.port)??Y;if(Q){O.set(Y.port,Q);const X=m(Q)?Q.pid:void 0;M.has(X)||M.set(X,[]),M.get(X)?.push(Y.port)}});const j=new Map;if(U.forEach(Y=>{const Q=this.configPortsAttributes.getAttributes(Y.port,Y.host,O.get(Y.port)?.detail);Q&&j.set(Y.port,Q)}),this.G.length===0||!T)return j.size>0?j:void 0;const z=await Promise.all((0,F.$Rb)(this.G.map(Y=>Array.from(M.entries()).map(Q=>{const X=Q[1],ue=O.get(X[0]);return Y.providePortAttributes(X,ue?.pid,ue?.detail,new i.$7d().token)})))),J=new Map;if(z.forEach(Y=>Y.forEach(Q=>{Q&&J.set(Q.port,Q)})),!j&&!J)return;const le=new Map;return U.forEach(Y=>{const Q=j.get(Y.port),X=J.get(Y.port);le.set(Y.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??y.providedActionToAction(X?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),le}addAttributesProvider(U){this.G.push(U)}};e.$NK=L,Ge([(0,f.$zh)(1e3)],L.prototype,"$",null),e.$NK=L=Ge([qe(0,S.$Bv),qe(1,k.$vp),qe(2,E.$Ai),qe(3,g.$CK),qe(4,p.$9k),qe(5,c.$di),qe(6,D.$oj),qe(7,R.$7v),qe(8,o.$GF),qe(9,a.$mj)],L)}),define(Ee[95],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$vJ=e.$uJ=void 0;class C{constructor(A,v){this.line=A,this.character=v}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,v){return new C(0,0)}with(A){return new C(0,0)}}e.$uJ=C;class F{constructor(A,v,$,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,v),this.end=new C($,E)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$vJ=F;var f;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(Ee[36],Se([1,0,19,35,24,34,12,5,17,14,95,11]),function(ge,e,C,F,f,P,A,v,$,E,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.SearchErrorCode=e.$KJ=e.$JJ=e.SearchSortOrder=e.ViewMode=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.SearchCompletionExitCode=e.$EJ=e.$DJ=e.$CJ=e.QueryType=e.SearchProviderType=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$wJ="workbench.view.search",e.$xJ="workbench.panel.search",e.$yJ="workbench.view.search",e.$zJ="search-result",e.$AJ="search.exclude";const p="\u27EA ",k=" characters skipped \u27EB",S=(p.length+k.length+5)*2;e.$BJ=(0,v.$7h)("searchService");var c;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(c||(e.SearchProviderType=c={}));var g;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(g||(e.QueryType=g={}));function o(X){return!!X.preview}e.$CJ=o;function i(X){return!!X.resource}e.$DJ=i;function r(X){return!!X.message}e.$EJ=r;var n;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class a{constructor(ue){this.resource=ue,this.results=[]}}e.$FJ=a;class t{constructor(ue,ne,$e,oe){this.ranges=ne,this.webviewIndex=oe;const K=Array.isArray(ne)?ne:[ne];if($e&&$e.matchLines===1&&h(K)){ue=(0,A.$Cf)(ue,$e.matchLines);let W="",ie=0,ye=0;const de=Math.floor($e.charsPerLine/5),fe=[];for(const _ of K){const ee=Math.max(_.startColumn-de,0),G=_.startColumn+$e.charsPerLine;if(ee>ye+de+S){const x=p+(ee-ye)+k;W+=x+ue.slice(ee,G),ie+=ee-(ye+x.length)}else W+=ue.slice(ye,G);fe.push(new d(0,_.startColumn-ie,_.endColumn-ie)),ye=G}this.preview={text:W,matches:Array.isArray(this.ranges)?fe:fe[0]}}else{const W=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:ue,matches:(0,C.$2b)(ne,ie=>new s(ie.startLineNumber-W,ie.startColumn,ie.endLineNumber-W,ie.endColumn))}}}}e.$GJ=t;function h(X){const ue=X[0].startLineNumber;for(const ne of X)if(ne.startLineNumber!==ue||ne.endLineNumber!==ue)return!1;return!0}class s{constructor(ue,ne,$e,oe){this.startLineNumber=ue,this.startColumn=ne,this.endLineNumber=$e,this.endColumn=oe}}e.$HJ=s;class d extends s{constructor(ue,ne,$e){super(ue,ne,ue,$e)}}e.$IJ=d;var l;(function(X){X.List="list",X.Tree="tree"})(l||(e.ViewMode=l={}));var u;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function w(X,ue=!0){const ne=X&&X.files&&X.files.exclude,$e=ue&&X&&X.search&&X.search.exclude;if(!ne&&!$e)return;if(!ne||!$e)return ne||$e;let oe=Object.create(null);return oe=f.$zn(oe,f.$wn(ne)),oe=f.$zn(oe,f.$wn($e),!0),oe}e.$JJ=w;function I(X,ue){return X.excludePattern&&F.$Mj(X.excludePattern,ue)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&F.$Mj(X.includePattern,ue)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(ne=>{const $e=ne.folder.fsPath;if(P.$9f(ue,$e)){const oe=$.$lc($e,ue);return!ne.includePattern||!!F.$Mj(ne.includePattern,oe)}else return!1}):!1:!0}e.$KJ=I;var b;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class m extends Error{constructor(ue,ne){super(ue),this.code=ne}}e.$LJ=m;function y(X){const ue=X.message;if((0,E.$4)(X))return new m(ue,b.canceled);try{const ne=JSON.parse(ue);return new m(ne.message,ne.code)}catch{return new m(ue,b.other)}}e.$MJ=y;function L(X){const ue={message:X.message,code:X.code};return new Error(JSON.stringify(ue))}e.$NJ=L;function N(X){return X.type==="error"?!0:X.type==="success"}e.$OJ=N;function U(X){return X.type==="success"}e.$PJ=U;function T(X){return!!X.path}e.$QJ=T;function O(X,ue){const ne=X.searchPath?X.searchPath:X.relativePath;return(0,A.$zf)(ne,ue)}e.$RJ=O;class M{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$SJ=M;function j(X,ue){const ne={...X||{},...ue||{}};return Object.keys(ne).filter($e=>{const oe=ne[$e];return typeof oe=="boolean"&&oe})}e.$TJ=j;class z{constructor(ue,ne){this.c=null,this.a={...ue.excludePattern||{},...ne.excludePattern||{}},this.b=F.$Nj(this.a);let $e=ue.includePattern;ne.includePattern&&($e?$e={...$e,...ne.includePattern}:$e=ne.includePattern),$e&&(this.c=F.$Nj($e))}matchesExcludesSync(ue,ne,$e){return!!(this.b&&this.b(ue,ne,$e))}includedInQuerySync(ue,ne,$e){return!(this.b&&this.b(ue,ne,$e)||this.c&&!this.c(ue,ne,$e))}includedInQuery(ue,ne,$e){const oe=this.b(ue,ne,$e),K=()=>this.c?!!this.c(ue,ne,$e):!0;return(0,D.$Tg)(oe)?oe.then(W=>W?!1:K()):K()}hasSiblingExcludeClauses(){return J(this.a)}}e.$UJ=z;function J(X){for(const ue in X)if(typeof X[ue]!="boolean")return!0;return!1}function le(X){if(!X)return;let ue;return ne=>(ue||(ue=(X()||Promise.resolve([])).then($e=>$e?Q($e):{})),ue.then($e=>!!$e[ne]))}e.$VJ=le;function Y(X){if(!X)return;let ue;return ne=>{if(!ue){const $e=X();ue=$e?Q($e):{}}return!!ue[ne]}}e.$WJ=Y;function Q(X){const ue={};for(const ne of X)ue[ne]=!0;return ue}}),define(Ee[41],Se([1,0,19,11,21,4,3,77,16,122,23,12,2,221,5,13,252,40,59,27,20,15,7,66,36,6,56]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a,t,h,s,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=void 0;function u(U,T,O){return new R.$xg(M=>m(M,O)).isEqual(U,T)}function w(U,T,O){return u(U.uri,T.uri,O)?0:(0,D.$6e)(U.uri.toString(),T.uri.toString())}function I(U,T,O){return U.index!==T.index?U.index<T.index?-1:1:u(U.uri,T.uri,O)?(0,D.$6e)(U.name,T.name):(0,D.$6e)(U.uri.toString(),T.uri.toString())}function b(U,T,O,M){const j=U.slice(0).sort((J,le)=>O(J,le,M)),z=T.slice(0).sort((J,le)=>O(J,le,M));return(0,C.$Eb)(j,z,(J,le)=>O(J,le,M))}function m(U,T){const O=T.getCapabilities(U.scheme);return!(O&&O&1024)}class y extends o.$ni{static toExtHostWorkspace(T,O,M,j){if(!T)return{workspace:null,added:[],removed:[]};const{id:z,name:J,folders:le,configuration:Y,transient:Q,isUntitled:X}=T,ue=[],ne=O;O?le.forEach((W,ie)=>{const ye=p.URI.revive(W.uri),de=y.o(M||O,ye,j);de?(de.name=W.name,de.index=W.index,ue.push(de)):ue.push({uri:ye,name:W.name,index:ie})}):ue.push(...le.map(({uri:W,name:ie,index:ye})=>({uri:p.URI.revive(W),name:ie,index:ye}))),ue.sort((W,ie)=>W.index<ie.index?-1:1);const $e=new y(z,J,ue,!!Q,Y?p.URI.revive(Y):null,!!X,W=>m(W,j)),{added:oe,removed:K}=b(ne?ne.workspaceFolders:[],$e.workspaceFolders,w,j);return{workspace:$e,added:oe,removed:K}}static o(T,O,M){for(let j=0;j<T.folders.length;j++){const z=T.workspaceFolders[j];if(u(z.uri,O,M))return z}}constructor(T,O,M,j,z,J,le){super(T,M.map(Y=>new o.$oi(Y)),j,z,le),this.t=O,this.u=J,this.q=[],this.s=v.$ai.forUris(le),M.forEach(Y=>{this.q.push(Y),this.s.set(Y.uri,Y)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,O){return O&&this.s.get(T)&&(T=(0,R.$Hg)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let L=class{constructor(T,O,M,j,z){this.c=new P.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new P.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new P.$Yd,this.B=new Map,this.h=j,this.s=M,this.t=z,this.j=new E.$0l,this.k=new F.$6g,this.o=T.getProxy(d.$fL.MainThreadWorkspace),this.q=T.getProxy(d.$fL.MainThreadMessageService);const J=O.workspace;this.l=J?new y(J.id,J.name,[],!!J.transient,J.configuration?p.URI.revive(J.configuration):null,!!J.isUntitled,le=>m(le,M)):void 0}$initializeWorkspace(T,O){this.v=O,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,R.$Fg)((0,R.$Hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,O,M,...j){const z=[];if(Array.isArray(j)&&j.forEach(X=>{p.URI.isUri(X.uri)&&!z.some(ue=>u(ue.uri,X.uri,this.s))&&z.push({uri:X.uri,name:X.name||(0,R.$Eg)(X.uri)})}),this.n||[O,M].some(X=>typeof X!="number"||X<0)||M===0&&z.length===0)return!1;const J=this.x?this.x.workspaceFolders:[];if(O+M>J.length)return!1;const le=J.slice(0);le.splice(O,M,...z.map(X=>({uri:X.uri,name:X.name||(0,R.$Eg)(X.uri),index:void 0})));for(let X=0;X<le.length;X++){const ue=le[X];if(le.some((ne,$e)=>$e!==X&&u(ue.uri,ne.uri,this.s)))return!1}le.forEach((X,ue)=>X.index=ue);const{added:Y,removed:Q}=b(J,le,I,this.s);if(Y.length===0&&Q.length===0)return!1;if(this.o){const X=T.displayName||T.name;this.o.$updateWorkspaceFolders(X,O,M,z).then(void 0,ue=>{this.n=void 0;const ne={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(g.Severity.Error,(0,k.localize)(0,null,X,ue.toString()),ne,[])})}return this.y(le),!0}getWorkspaceFolder(T,O){if(this.x)return this.x.getWorkspaceFolder(T,O)}async getWorkspaceFolder2(T,O){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,O)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,O){let M,j="";if(typeof T=="string"?(M=p.URI.file(T),j=T):typeof T<"u"&&(M=T,j=T.fsPath),!M)return j;const z=this.getWorkspaceFolder(M,!0);if(!z)return j;typeof O>"u"&&this.x&&(O=this.x.folders.length>1);let J=(0,R.$Kg)(z.uri,M);return O&&z.name&&(J=`${z.name}/${J}`),J}y(T){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:O,added:M,removed:j}=y.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=O||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:j}))}findFiles(T,O,M,j,z=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let J;if(O===null?J=!1:O&&(typeof O=="string"?J=O:J=O.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:Y}=N(a.GlobPattern.from(T));return this.o.$startFileSearch(le??null,Y??null,J??null,M??null,z).then(Q=>Array.isArray(Q)?Q.map(X=>p.URI.revive(X)):[])}async findTextInFiles(T,O,M,j,z=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const J=this.j.getNext(),le=typeof O.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:Y,folder:Q}=N(a.GlobPattern.from(O.include)),X=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,ue={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:le,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:Y,excludePattern:X},ne=!1;if(this.u[J]=$e=>{if(ne)return;const oe=p.URI.revive($e.resource);$e.results.forEach(K=>{const W=(0,l.$Dh)(K);(0,s.$CJ)(W)?M({uri:oe,preview:{text:W.preview.text,matches:(0,C.$2b)(W.preview.matches,ie=>new t.$jL(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,C.$2b)(W.ranges,ie=>new t.$jL(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):M({uri:oe,text:W.text,lineNumber:W.lineNumber})})},z.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(T,Q??null,ue,J,z);return delete this.u[J],$e||{}}catch($e){throw delete this.u[J],$e}}$handleTextSearchResult(T,O){this.u[O]?.(T)}async save(T){const O=await this.o.$save(T,{saveAs:!1});return p.URI.revive(O)}async saveAs(T){const O=await this.o.$save(T,{saveAs:!0});return p.URI.revive(O)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,O){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,O);const M=this.t.transformOutgoingScheme(T),j=this.z++;return this.o.$registerEditSessionIdentityProvider(j,M),(0,A.$Rc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(T,O){this.h.info("Getting edit session identifier for workspaceFolder",T);const M=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const j=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!j),!j)return;const z=await j.provideEditSessionIdentity(M,O);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(T,O,M,j){this.h.info("Getting edit session identifier for workspaceFolder",T);const z=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const J=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!J),!J)return;const le=await J.provideEditSessionIdentityMatch?.(O,M,j);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(T){return(O,M,j)=>{const z=function(le){O.call(M,le)};return z.extension=T,this.A.event(z,void 0,j)}}async $onWillCreateEditSessionIdentity(T,O,M){const j=await this.resolveWorkspaceFolder(p.URI.revive(T));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:j},O,async(z,J)=>{const le=Date.now();await Promise.resolve(z),Date.now()-le>M&&this.h.warn("SLOW edit session create-participant",J.extension.identifier)}),O.isCancellationRequested}registerCanonicalUriProvider(T,O){if(this.B.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.B.set(T,O);const M=this.t.transformOutgoingScheme(T),j=this.z++;return this.o.$registerCanonicalUriProvider(j,M),(0,A.$Rc)(()=>{this.B.delete(T),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(T,O,M){const j=this.B.get(T.scheme);if(!j)return;const z=await j.provideCanonicalUri?.(p.URI.revive(T),O,M);if(z)return z}async $provideCanonicalUri(T,O,M){return this.provideCanonicalUri(p.URI.revive(T),{targetScheme:O},M)}};e.$$gc=L,e.$$gc=L=Ge([qe(0,n.$kN),qe(1,r.$AN),qe(2,i.$Qgc),qe(3,c.$oj),qe(4,h.$9gc)],L),e.$_gc=(0,S.$7h)("IExtHostWorkspace");function N(U){let T,O;return U&&(typeof U=="string"?T=U:(T=U.pattern,O=p.URI.revive(U.baseUri))),{includePattern:T,folder:O}}}),define(Ee[42],Se([1,0,24,4,41,6,7,254,87,18,11,5,20,13,2]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=e.$bhc=e.$ahc=void 0;function c(h,s){if(s){const d=s.split(".");let l=h;for(let u=0;l&&u<d.length;u++)l=l[d[u]];return l}}function g(h){return h instanceof S.URI}function o(h){return h&&h.uri instanceof S.URI&&h.languageId&&typeof h.languageId=="string"}function i(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function r(h){return h&&h.uri instanceof S.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function n(h){if(g(h))return{resource:h};if(o(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(i(h))return{overrideIdentifier:h.languageId};if(r(h))return{resource:h.uri};if(h===null)return{resource:null}}let a=class{constructor(s,d,l){this.a=s.getProxy(P.$fL.MainThreadConfiguration),this.c=d,this.b=l,this.d=new R.$6g,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,d){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,d))}};e.$ahc=a,e.$ahc=a=Ge([qe(0,p.$kN),qe(1,f.$_gc),qe(2,k.$oj)],a);class t{constructor(s,d,l,u){this.a=new F.$Wd,this.b=s,this.f=u,this.c=d,this.e=v.$7n.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,d){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=v.$7n.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(d,l))}getConfiguration(s,d,l){const u=n(d)||{},w=this.g(s?c(this.e.getValue(void 0,u,this.c.workspace),s):this.e.getValue(void 0,u,this.c.workspace));s&&this.h(s,u,l?.identifier);function I(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(m){return typeof c(w,m)<"u"},get:(m,y)=>{this.h(s?`${s}.${m}`:m,u,l?.identifier);let L=c(w,m);if(typeof L>"u")L=y;else{let N;const U=(T,O)=>{if((0,E.$Lf)(T)){let M;const j=()=>{N=N||(0,C.$wn)(w),M=M||c(N,O)};return new Proxy(T,{get:(z,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return j(),()=>M;if(N)return M=M||c(N,O),M[J];const le=z[J];return typeof J=="string"?U(le,`${O}.${J}`):le},set:(z,J,le)=>(j(),M&&(M[J]=le),!0),deleteProperty:(z,J)=>(j(),M&&delete M[J],!0),defineProperty:(z,J,le)=>(j(),M&&Object.defineProperty(M,J,le),!0)})}return Array.isArray(T)?(0,C.$wn)(T):T};L=U(L,m)}return L},update:(m,y,L,N)=>{m=s?`${s}.${m}`:m;const U=I(L);return y!==void 0?this.b.$updateConfigurationOption(U,m,y,u,N):this.b.$removeConfigurationOption(U,m,u,N)},inspect:m=>{m=s?`${s}.${m}`:m;const y=this.e.inspect(m,u,this.c.workspace);if(y)return{key:m,defaultValue:(0,C.$wn)(y.policy?.value??y.default?.value),globalValue:(0,C.$wn)(y.user?.value??y.application?.value),workspaceValue:(0,C.$wn)(y.workspace?.value),workspaceFolderValue:(0,C.$wn)(y.workspaceFolder?.value),defaultLanguageValue:(0,C.$wn)(y.default?.override),globalLanguageValue:(0,C.$wn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,C.$wn)(y.workspace?.override),workspaceFolderLanguageValue:(0,C.$wn)(y.workspaceFolder?.override),languageIds:(0,C.$wn)(y.overrideIdentifiers)}}};return typeof w=="object"&&(0,C.$zn)(b,w,!1),Object.freeze(b)}g(s){const d=l=>(0,E.$Lf)(l)?new Proxy(l,{get:(u,w)=>d(u[w]),set:(u,w,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(u,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(u,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return d(s)}h(s,d,l){const u=$.$Xn.test(s)?4:this.d.get(s),w=l?`[${l.value}] `:"";if(u===4){typeof d?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){d?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,d){const l=new v.$9n(s,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,w)=>l.affectsConfiguration(u,n(w))})}k(s){return s.reduce((d,l)=>(d.set(l[0],l[1]),d),new Map)}}e.$bhc=t,e.$chc=(0,D.$7h)("IExtHostConfiguration")}),define(Ee[96],Se([1,0,2,11,4,6,7,41,72,42,21,46,20,27,5,16,10,13,92,296,14]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=e.$Eic=e.$Dic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(U){function T(M){if(M!=null)return M}U.from=T;function O(M){if(M!=null)return M}U.to=O})(a||(a={}));var t;(function(U){function T(M){if(M!=null)return M}U.from=T;function O(M){if(M!=null)return M}U.to=O})(t||(t={}));var h;(function(U){function T(M){if(M!=null)return M}U.from=T;function O(M){if(M!=null)return M}U.to=O})(h||(h={}));var s;(function(U){function T(j){if(j){const z=j;return z&&!!z.process}else return!1}U.is=T;function O(j){if(j==null)return;const z={process:j.process,args:j.args};return j.options&&(z.options=h.from(j.options)),z}U.from=O;function M(j){if(j!=null)return new A.$3L(j.process,j.args,j.options)}U.to=M})(s||(s={}));var d;(function(U){function T(M){if(M!=null)return M}U.from=T;function O(M){if(M!=null)return M}U.to=O})(d||(d={}));var l;(function(U){function T(j){if(j){const z=j;return z&&(!!z.commandLine||!!z.command)}else return!1}U.is=T;function O(j){if(j==null)return;const z={};return j.commandLine!==void 0?z.commandLine=j.commandLine:(z.command=j.command,z.args=j.args),j.options&&(z.options=d.from(j.options)),z}U.from=O;function M(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new A.$4L(j.commandLine,j.options):new A.$4L(j.command,j.args?j.args:[],j.options)}U.to=M})(l||(l={}));var u;(function(U){function T(j){if(j){const z=j;return z&&z.customExecution==="customExecution"}else return!1}U.is=T;function O(j){return{customExecution:"customExecution"}}U.from=O;function M(j,z){return z.get(j)}U.to=M})(u||(e.CustomExecutionDTO=u={}));var w;(function(U){function T(O,M){let j;return O.scope!==void 0&&typeof O.scope!="number"?j=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===A.TaskScope.Workspace&&M&&M.workspaceFile?j=M.workspaceFile:j=r.$CG),{id:O._id,workspaceFolder:j}}U.from=T})(w||(e.TaskHandleDTO=w={}));var I;(function(U){function T(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}U.from=T})(I||(I={}));var b;(function(U){function T(j,z){if(j==null)return[];const J=[];for(const le of j){const Y=O(le,z);Y&&J.push(Y)}return J}U.fromMany=T;function O(j,z){if(j==null)return;let J;j.execution instanceof A.$3L?J=s.from(j.execution):j.execution instanceof A.$4L?J=l.from(j.execution):j.execution&&j.execution instanceof A.$5L&&(J=u.from(j.execution));const le=a.from(j.definition);let Y;return j.scope?typeof j.scope=="number"?Y=j.scope:Y=j.scope.uri:Y=A.TaskScope.Workspace,!le||!Y?void 0:{_id:j._id,definition:le,name:j.name,source:{extensionId:z.identifier.value,label:j.source,scope:Y},execution:J,isBackground:j.isBackground,group:I.from(j.group),presentationOptions:t.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}U.from=O;async function M(j,z,J){if(j==null)return;let le;s.is(j.execution)?le=s.to(j.execution):l.is(j.execution)?le=l.to(j.execution):u.is(j.execution)&&(le=u.to(j._id,J));const Y=a.to(j.definition);let Q;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Q=j.source.scope:Q=await z.resolveWorkspaceFolder(C.URI.revive(j.source.scope)):Q=A.TaskScope.Workspace),!Y||!Q)return;const X=new A.$6L(Y,Q,j.name,j.source.label,le,j.problemMatchers);return j.isBackground!==void 0&&(X.isBackground=j.isBackground),j.group!==void 0&&(X.group=A.$2L.from(j.group._id),X.group&&j.group.isDefault&&(X.group=new A.$2L(X.group.id,X.group.label),j.group.isDefault===!0&&(X.group.isDefault=j.group.isDefault))),j.presentationOptions&&(X.presentationOptions=t.to(j.presentationOptions)),j._id&&(X._id=j._id),j.detail&&(X.detail=j.detail),X}U.to=M})(b||(e.TaskDTO=b={}));var m;(function(U){function T(M){return M}U.from=T;function O(M){if(M)return Object.assign(Object.create(null),M)}U.to=O})(m||(m={}));class y{#e;constructor(T,O,M){this._id=O,this.a=M,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let L=class{constructor(T,O,M,j,z,J,le,Y){this.q=new f.$Wd,this.r=new f.$Wd,this.s=new f.$Wd,this.u=new f.$Wd,this.a=T.getProxy(P.$fL.MainThreadTask),this.b=M,this.c=j,this.d=z,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=le,this.g=Y,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,O,M){if(!M)return new A.$hL(()=>{});const j=this.x();return this.j.set(j,{type:O,provider:M,extension:T}),this.a.$registerTaskProvider(j,O),new A.$hL(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(T,O){this.a.$registerTaskSystem(T,O)}fetchTasks(T){return this.a.$fetchTasks(m.from(T)).then(async O=>{const M=[];for(const j of O){const z=await b.to(j,this.b,this.m);z&&M.push(z)}return M})}get taskExecutions(){const T=[];return this.k.forEach(O=>T.push(O)),T}terminateTask(T){if(!(T instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,O,M){const j=this.m.get(T.id);j&&(this.o.set(T.id,j),this.e.attachPtyToTerminal(O,await j.callback(M))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const O=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const O=await this.z(T.id);this.s.fire({execution:O,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const O=await this.z(T.id);this.u.fire({execution:O,exitCode:T.exitCode})}$provideTasks(T,O){const M=this.j.get(T);if(!M)return Promise.reject(new Error("no handler found"));const j=[],z=(0,F.$Zg)(()=>M.provider.provideTasks(R.CancellationToken.None)).then(J=>this.v(O,j,M,J));return new Promise(J=>{z.then(le=>{Promise.all(j).then(()=>{J(le)})})})}async $resolveTask(T,O){const M=this.j.get(T);if(!M)return Promise.reject(new Error("no handler found"));if(O.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${M.type}].`);const j=await b.to(O,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const z=await M.provider.resolveTask(j,R.CancellationToken.None);if(!z)return;this.A(z,M);const J=b.from(z,M.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(J.execution)&&await this.y(J,z,!0),await this.w(J)}x(){return this.h++}async y(T,O,M){const j=await this.a.$createTaskId(T);!M&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,O.execution)),this.m.set(j,O.execution)}async z(T,O){if(typeof T=="string"){const z=this.l.get(T);if(!z)throw new n.$bb("Unexpected: The specified task is missing an execution");return z}const M=this.l.get(T.id);if(M)return M;let j;return O?j=Promise.resolve(new y(this,T.id,O)):j=b.to(T.task,this.b,this.m).then(z=>{if(!z)throw new n.$bb("Unexpected: Task does not exist.");return new y(this,T.id,z)}),this.l.set(T.id,j),j.then(z=>(this.k.set(T.id,z),z))}A(T,O){T._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const M=this.n.values();let j=M.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=M.next()}};e.$Dic=L,e.$Dic=L=Ge([qe(0,p.$kN),qe(1,k.$AN),qe(2,v.$_gc),qe(3,$.$vN),qe(4,E.$chc),qe(5,D.$Ahc),qe(6,o.$oj),qe(7,i.$Tgc)],L);let N=class extends L{constructor(T,O,M,j,z,J,le,Y){super(T,O,M,j,z,J,le,Y),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:g.$h(0)})}async executeTask(T,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const M=b.from(O,T);if(M===void 0)throw new Error("Task is not valid");if(u.is(M.execution))await this.y(M,O,!1);else throw new n.$_;const j=await this.z(await this.a.$getTaskExecution(M),O);return this.a.$executeTask(M).catch(z=>{throw new Error(z)}),j}v(T,O,M,j){const z=[];if(j)for(const J of j){if(this.A(J,M),!J.definition||!T[J.definition.type]){const Y=J.source?J.source:"No task source";this.f.warn(`The task [${Y}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=b.from(J,M.extension);le&&u.is(le.execution)?(z.push(le),O.push(this.y(le,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:M.extension}}async w(T){if(u.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,O,M){}};e.$Eic=N,e.$Eic=N=Ge([qe(0,p.$kN),qe(1,k.$AN),qe(2,v.$_gc),qe(3,$.$vN),qe(4,E.$chc),qe(5,D.$Ahc),qe(6,o.$oj),qe(7,i.$Tgc)],N),e.$Fic=(0,S.$7h)("IExtHostTask")}),define(Ee[360],Se([1,0,36,29]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.$4J=e.$3J=void 0;function f(A){return"cellResults"in A}e.$3J=f,e.$4J="rawCell#";function P(A,v){let $=-1;const E=[];let R=[];return A.forEach(p=>{p.range.startLineNumber!==$&&R.length>0&&(E.push([...R]),R=[]),R.push(p),$=p.range.endLineNumber}),R.length>0&&E.push([...R]),E.map(p=>{const k=[],S=p[0].range.startLineNumber,c=p[p.length-1].range.endLineNumber;for(let g=S;g<=c;g++)k.push(v.getLineContent(g));return new C.$GJ(k.join(`
`)+`
`,p.map(g=>new F.$Vs(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}e.$5J=P}),define(Ee[361],Se([1,0,215,22,4,3,28,12,18,2,32,110,6,33,15,7,68,331,149,24,16,286,360,357]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,u,w,I,b,m){this.q=w,this.r=I,this.s=b,this.t=m,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new f.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Mgc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy(p.$fL.MainThreadNotebook),this.c=l.getProxy(p.$fL.MainThreadNotebookDocuments),this.d=l.getProxy(p.$fL.MainThreadNotebookEditors),this.i=u.converter,u.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const L=y.notebookEditor?.notebookUri,N=y.cell.handle,T=this.g.get(L)?.getCell(N);if(T)return T.apiCell}if(y&&y.$mid===14){const L=y.uri,N=this.g.get(L);if(N)return N.apiNotebook}return y}}),s.B(u)}getEditorById(l){const u=this.h.get(l);if(!u)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return u}getIdByEditor(l){for(const[u,w]of this.h)if(w.apiEditor===l)return u}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,u){const w=this.g.get(l);if(!w&&!u)throw new Error(`NO notebook document for '${l}'`);return w}static u(l,u){if(!u)return;const w=u.filenamePattern.map(I=>S.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(u.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:u.displayName,filenamePattern:w,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,u,w){const I=s.a++,b=typeof w.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(I,w),this.b.$registerNotebookCellStatusBarItemProvider(I,b,u);let m;return b!==void 0&&(m=w.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(b))),new c.$hL(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,b),m?.dispose()})}async createNotebookDocument(l){const u=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&S.NotebookData.from(l.content)});return E.URI.revive(u)}async openNotebookDocument(l){const u=this.g.get(l);if(u)return u.apiNotebook;const w=await this.c.$tryOpenNotebook(l),I=this.g.get(E.URI.revive(w));return(0,$.$Uf)(I?.apiNotebook)}async showNotebookDocument(l,u){E.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let w;typeof u=="object"?w={position:S.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(S.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:w={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,w),b=I&&this.h.get(I)?.apiEditor;if(b)return b;throw I?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,u,w,I){const b=this.f.get(l),m=E.URI.revive(u),y=this.g.get(m);if(!y||!b)return;const L=y.getCellFromIndex(w);if(!L)return;const N=await b.provideCellStatusBarItems(L.apiCell,I);if(!N)return;const U=new P.$Sc,T=this.p.add([U]),M=(Array.isArray(N)?N:[N]).map(j=>S.NotebookStatusBarItem.from(j,this.i,U));return{cacheId:T,items:M}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,u,w,I,b){if((0,v.$Ke)(u))throw new Error("viewType cannot be empty or just whitespace");const m=this.w++;return this.x.set(m,{viewType:u,serializer:w,options:I}),this.b.$registerNotebookSerializer(m,{id:l.identifier,location:l.extensionLocation},u,S.NotebookDocumentContentOptions.from(I),s.u(l,b)),(0,P.$Rc)(()=>{this.b.$unregisterNotebookSerializer(m)})}async $dataToNotebook(l,u,w){const I=this.x.get(l);if(!I)throw new Error("NO serializer found");const b=await I.serializer.deserializeNotebook(u.buffer,w);return new g.$Uv(S.NotebookData.from(b))}async $notebookToData(l,u,w){const I=this.x.get(l);if(!I)throw new Error("NO serializer found");const b=await I.serializer.serializeNotebook(S.NotebookData.to(u.value),w);return F.$ke.wrap(b)}async $saveNotebook(l,u,w,I,b){const m=E.URI.revive(u),y=this.x.get(l);if(!y)throw new Error("NO serializer found");const L=this.g.get(m);if(!L)throw new Error("Document NOT found");if(L.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(m.scheme))throw new R.$Mk((0,C.localize)(0,null,this.z(m)),6);await this.y(m,I);const N={metadata:(0,r.$En)(L.apiNotebook.metadata,j=>!(y.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of L.apiNotebook.getCells()){const z=new c.$HM(j.kind,j.document.getText(),j.document.languageId,j.mime,y.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);z.metadata=(0,r.$En)(j.metadata,J=>!(y.options?.transientCellMetadata??{})[J]),N.cells.push(z)}const U=await y.serializer.serializeNotebook(N,b);await this.s.value.writeFile(m,U);const T=this.s.getFileSystemProviderExtUri(m.scheme),O=await this.s.value.stat(m);return{name:T.basename(m),isFile:(O.type&R.FileType.File)!==0,isDirectory:(O.type&R.FileType.Directory)!==0,isSymbolicLink:(O.type&R.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(m.scheme),locked:!!((O.permissions??0)&R.FilePermission.Locked),etag:R.$Xk({mtime:O.mtime,size:O.size}),children:void 0}}async $searchInNotebooks(l,u,w,I,b){const m=this.x.get(l)?.serializer;if(!m)return{limitHit:!1,results:[]};const y=new A.$Bc;await(async(O,M,j)=>{await Promise.all(O.map(async z=>await Promise.all(z.filenamePatterns.map(J=>{const le={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:J};return this.t.doInternalFileSearchWithCustomCallback(le,M,Y=>{Y.forEach(Q=>{y.has(Q)||I.some(ue=>z.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(ne=>(0,h.$xdb)(ne,Q)))||y.add(Q)})})}))))})(w,b,u);const N=new A.$Ac;let U=!1;const T=Array.from(y).map(async O=>{const M=[];try{if(b.isCancellationRequested)return;if(u.maxResults&&[...N.values()].reduce((le,Y)=>le+Y.cellResults.length,0)>u.maxResults){U=!0;return}const j=[],z=this.g.get(O);if(z)z.apiNotebook.getCells().forEach(Y=>j.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(Q=>Q.items.map(X=>X.data.toString()))}));else{const le=await this.s.value.readFile(O),Y=F.$ke.fromString(le.toString()),Q=await m.deserializeNotebook(Y.buffer,b);if(b.isCancellationRequested)return;S.NotebookData.from(Q).cells.forEach(ue=>j.push({input:ue.source,outputs:ue.outputs.flatMap(ne=>ne.items.map($e=>$e.valueBytes.toString()))}))}if(b.isCancellationRequested)return;j.forEach((le,Y)=>{const Q=u.contentPattern.pattern,X=new a.$vRb(le.input,void 0,le.outputs),ue=X.findInInputs(Q),ne=X.findInOutputs(Q),$e=ne.flatMap(oe=>(0,t.$5J)(oe.matches,oe.textBuffer)).map((oe,K)=>(oe.webviewIndex=K,oe));if(ue.length>0||ne.length>0){const oe={index:Y,contentResults:(0,t.$5J)(ue,X.inputTextBuffer),webviewResults:$e};M.push(oe)}});const J={resource:O,cellResults:M};N.set(O,J);return}catch{return}});return await Promise.all(T),{limitHit:U,results:[...N.values()]}}async y(l,u){const w=await this.s.value.stat(l);if(typeof u?.mtime=="number"&&typeof u.etag=="string"&&u.etag!==R.$Wk&&typeof w.mtime=="number"&&typeof w.size=="number"&&u.mtime<w.mtime&&u.etag!==R.$Xk({mtime:u.mtime,size:w.size}))throw new R.$Mk((0,C.localize)(1,null),3,u)}z(l){return l.scheme===n.Schemas.file?l.fsPath:l.toString()}A(l,u,w){if(this.h.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const I=new i.$9hc(u,this.d,l,w.visibleRanges.map(S.NotebookRange.to),w.selections.map(S.NotebookRange.to),typeof w.viewColumn=="number"?S.ViewColumn.to(w.viewColumn):void 0);this.h.set(u,I)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const w of l.value.removedDocuments){const I=E.URI.revive(w),b=this.g.get(I);b&&(b.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(m=>m.document.uri)}),this.n.fire(b.apiNotebook));for(const m of this.h.values())m.notebookData.uri.toString()===I.toString()&&this.h.delete(m.id)}if(l.value.addedDocuments){const w=[];for(const I of l.value.addedDocuments){const b=E.URI.revive(I.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const m=new o.$8hc(this.c,this.q,this.r,b,I);w.push(...I.cells.map(y=>o.$7hc.asModelAddData(m.apiNotebook,y))),this.g.get(b)?.dispose(),this.g.set(b,m),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(m.apiNotebook)}}if(l.value.addedEditors)for(const w of l.value.addedEditors){if(this.h.has(w.id))return;const I=E.URI.revive(w.documentUri),b=this.g.get(I);b&&this.A(b,w.id,w)}const u=[];if(l.value.removedEditors)for(const w of l.value.removedEditors){const I=this.h.get(w);I&&(this.h.delete(w),this.k?.id===I.id&&(this.k=void 0),u.push(I))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const w=new Set;this.l.forEach(I=>w.add(I.id));for(const I of this.h.values()){const b=w.has(I.id);I._acceptVisibility(b)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const u=k.$IN.String.with("notebookType","A notebook type"),w=new k.$KN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[u,new k.$IN("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>F.$ke.wrap(b))],new k.$JN("Notebook Data",b=>S.NotebookData.to(b.value))),I=new k.$KN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[u,new k.$IN("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new g.$Uv(S.NotebookData.from(b)))],new k.$JN("Bytes",b=>b.buffer));l.registerApiCommand(w),l.registerApiCommand(I)}}e.$fic=s}),define(Ee[362],Se([1,0,17,21,44,35,23,38,36]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class E{constructor(p,k,S){this.k=p,this.l=k,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&P.$Nj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&P.$Nj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const k=this.k.folderQueries||[];return new Promise((S,c)=>{const g=o=>{this.f++,p(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),r=C.$nc(i);this.j&&this.j(i,r)||this.v(g,{base:o,basename:r})}),Promise.all(k.map(o=>this.p(o,g))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{c(new Error((0,f.$Ri)(o)))})})}async p(p,k){const S=new F.$7d,c=this.q(p),g=this.r(),o=new $.$UJ(this.k,p),i=!o.hasSiblingExcludeClauses();let r;try{this.h.add(S),r=v.$Sd.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,S.token),a=r.elapsed(),t=v.$Sd.create();return this.g&&!this.e||(n&&n.forEach(h=>{const s=C.$gc.relative(p.folder.path,h.path);if(i){const d=C.$nc(h.path);this.v(k,{base:p.folder,relativePath:s,basename:d});return}this.s(g,p.folder,s,k)}),this.g&&!this.e)?null:(this.u(g,o,k),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(p){const k=(0,$.$TJ)(this.k.includePattern,p.includePattern),S=(0,$.$TJ)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:S,includes:k,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},k,S,c){if(S===this.a){const o=C.$nc(this.a);this.v(c,{base:k,relativePath:this.a,basename:o})}function g(o){const i=C.$nc(o),r=C.$mc(o);let n=p[r];n||(n=p[r]=[],g(r)),n.push({base:k,relativePath:o,basename:i})}g(S)}u({rootEntries:p,pathToEntries:k},S,c){const g=this,o=this.a;function i(r){const n=(0,$.$WJ)(()=>r.map(a=>a.basename));for(let a=0,t=r.length;a<t;a++){const h=r[a],{relativePath:s,basename:d}=h;if(S.matchesExcludesSync(s,d,o!==d?n:void 0))continue;const l=k[s];if(l)i(l);else{if(s===o)continue;g.v(c,h)}if(g.e)break}}i(p)}v(p,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(k))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,k,S,c){const g=this.c(p.cacheKey),o=new E(p,k,g&&g.token);let i=0;const r=n=>{i+=n.length,S(n.map(a=>this.d(a)))};return this.e(o,R.a,r,c).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new F.$7d),this.b.get(p)}d(p){return p.relativePath?{resource:A.$Ig(p.base,p.relativePath)}:{resource:p.base}}e(p,k,S,c){const g=c.onCancellationRequested(()=>{p.cancel()}),o=r=>{r&&(i.push(r),k>0&&i.length>=k&&(S(i),i=[]))};let i=[];return p.search(o).then(r=>(i.length&&S(i),g.dispose(),r),r=>(i.length&&S(i),g.dispose(),Promise.reject(r)))}}e.$0hc=R}),define(Ee[363],Se([1,0,19,73,35,103,28,16,17,23,12,18,2,100,235,51,13,40,142,358,36]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=e.$VK=void 0;let a=class{constructor(m,y,L,N,U){this.a=m,this.b=y,this.c=L,this.d=N,this.e=U}text(m,y,L={}){m=this.f(m,L);const N=this.a.getValue(),U=y&&y.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(y?.map(o.$pi),L),type:2,contentPattern:m,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:N.search.usePCRE2||U||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(m,y){const L=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const N={...m,wordSeparators:L.editor.wordSeparators};return this.j(m,y)&&(N.isCaseSensitive=!0),this.k(m)&&(N.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),N}file(m,y={}){return{...this.h(m,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(m,y){return m?(m=Array.isArray(m)?m.map(l):l(m),y?this.parseSearchPaths(m):{pattern:h(...Array.isArray(m)?m:[m])}):{}}h(m=[],y={}){const L=this.g(y.includePattern,y.expandPatterns),N=this.g(y.excludePattern,y.expandPatterns),U=m.length>1,T=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(j=>this.q(j,y,N)):m.map(j=>this.r(j,y,N,U))).filter(j=>!!j),O={_reason:y._reason,folderQueries:T,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:N.pattern,includePattern:L.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const j=C.$Hb(C.$Rb(this.c.groups.map(le=>le.editors.map(Y=>Y.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const z=j.filter(le=>(0,n.$KJ)(O,le.fsPath)),J=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...O,...J}}const M=y.extraFileResources&&y.extraFileResources.filter(j=>(0,n.$KJ)(O,j.fsPath));return O.extraFileResources=M&&M.length?M:void 0,O}i(m){const y=[],L=new A.$Ac,N={};let U=!1;return m.forEach(T=>{if(T.scheme===v.Schemas.walkThrough)return;if((0,E.$Mg)(T)){const M=this.b.getWorkspaceFolder(T)?.uri??T.with({path:$.$mc(T.fsPath)});let j=L.get(M);j||(U=!0,j={folder:M,includePattern:{}},y.push(j),L.set(M,j));const z=$.$lc(M.fsPath,T.fsPath);(0,D.$Uf)(j.includePattern)[z.replace(/\\/g,"/")]=!0}else T.fsPath&&(U=!0,N[T.fsPath]=!0)}),{folderQueries:y,includePattern:N,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(m,y){if(y.isSmartCase){if(m.isRegExp){if(R.$Af(m.pattern,!0))return!0}else if(R.$Af(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,k.$5B)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const y=J=>$.$ic(J)||/^\.\.?([\/\\]|$)/.test(J),N=(Array.isArray(m)?m:s(m)).map(J=>{const le=this.e.resolvedUserHome;return le?(0,P.$Zv)(J,le.scheme===v.Schemas.file?le.fsPath:le.path):J}),U=F.$K(N,J=>y(J)?"searchPaths":"exprSegments"),T=(U.exprSegments||[]).map(J=>R.$Ve(J,"/")).map(J=>R.$Ve(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),d(J))),O={},M=this.m(U.searchPaths||[]);M&&M.length&&(O.searchPaths=M);const j=C.$Rb(T),z=h(...j);return z&&(O.pattern=z),O}l(m,y){return y.disregardExcludeSettings?void 0:(0,n.$JJ)(m,!y.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const y=m.flatMap(N=>{let{pathPortion:U,globPortion:T}=t(N);return T&&(T=u(T)),this.n(U).flatMap(M=>this.o(M,T))}),L=new Map;return y.forEach(N=>{const U=N.searchPath.toString(),T=L.get(U);T?N.pattern&&(T.pattern=T.pattern||{},T.pattern[N.pattern]=!0):L.set(U,{searchPath:N.searchPath,pattern:N.pattern?h(N.pattern):void 0})}),Array.from(L.values())}n(m){if($.$ic(m)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==v.Schemas.file?[{searchPath:y[0].uri.with({path:m})}]:[{searchPath:p.URI.file($.$hc(m))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(m=l(m),m.startsWith("../")||m===".."){const N=$.$gc.resolve(y.path,m);return[{searchPath:y.with({path:N})}]}const L=u(m);return[{searchPath:y,pattern:L}]}else{if(m==="./"||m===".\\")return[];{const y=m.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(U=>{const T=y.match(new RegExp(`^${R.$Pe(U.name)}(?:/(.*)|$)`));return T?{match:T,folder:U}:null}).filter(D.$Rf);if(N.length)return N.map(U=>{const T=U.match[1];return{searchPath:U.folder.uri,pattern:T&&u(T)}});{const U=m.match(/\.[\/\\](.+)[\/\\]?/),T=U?U[1]:m,O=S.localize(0,null,T);throw new Error(O)}}}}o(m,y){const L=m.pattern&&y?`${m.pattern}/${y}`:m.pattern||y,N=[{searchPath:m.searchPath,pattern:L}];return L&&!L.endsWith("**")&&N.push({searchPath:m.searchPath,pattern:L+"/**"}),N}q(m,y,L){const N=this.r((0,o.$pi)(m.searchPath),y,L,!1);return N?{...N,includePattern:m.pattern}:null}r(m,y,L,N){let U;const T=p.URI.isUri(m)?m:m.uri;if(L.searchPaths){const J=L.searchPaths.filter(le=>(0,E.$Bg)(le.searchPath,T))[0];if(J&&!J.pattern)return null;J&&(U=J.pattern)}const O=this.a.getValue({resource:T}),j={...this.l(O,y)||{},...U||{}},z=p.URI.isUri(m)?(0,E.$Fg)(m):m.name;return{folder:T,folderName:N?z:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!O.search.followSymlinks}}};e.$VK=a,e.$VK=a=Ge([qe(0,c.$Ai),qe(1,o.$di),qe(2,i.$_C),qe(3,g.$oj),qe(4,r.$TK)],a);function t(b){const m=b.match(/[\*\{\}\(\)\[\]\?]/);if(m){const y=m.index,L=b.substr(0,y).match(/[/|\\][^/\\]*$/);if(L){let N=b.substr(0,L.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:b.substr((L.index||0)+1)}}}return{pathPortion:b}}function h(...b){return b.length?b.reduce((m,y)=>(m[y]=!0,m),Object.create(null)):void 0}function s(b){return f.$Lj(b,",").map(m=>m.trim()).filter(m=>!!m.length)}function d(b){return[`**/${b}/**`,`**/${b}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function l(b){return b.replace(/\\/g,"/")}function u(b){return l(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(b){return b.replace(/([?*[\]])/g,"[$1]")}function I(b,m){b=C.$Mb(b,N=>N.toString());const y=[],L=m.getWorkspace();return b&&b.forEach(N=>{let U;if(m.getWorkbenchState()===2)U=(0,E.$Kg)(L.folders[0].uri,N),U&&U!=="."&&(U="./"+U);else{const T=m.getWorkspaceFolder(N);if(T){const O=T.name;if(L.folders.filter(j=>j.name===O).length===1){const j=(0,E.$Kg)(T.uri,N);j===""?U=`./${T.name}`:U=`./${T.name}/${j}`}else U=N.fsPath}}U&&y.push(w(U))}),y}e.$WK=I}),define(Ee[364],Se([1,0,23,2,21,14,5,363,36,40]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$sb=e.$0sb=void 0;const R=7e3;function D(c,g){const o=g.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],r=[];for(const d of o)if(/^workspaceContains:/.test(d)){const l=d.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||c.forceUsingSearch?r.push(l):i.push(l)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);let n;const a=new Promise((d,l)=>{n=d}),t=d=>n({activationEvent:d}),h=Promise.all(i.map(d=>p(c,d,t))).then(()=>{}),s=k(c,g.identifier,r,t);return Promise.all([h,s]).then(()=>{n(void 0)}),a}e.$0sb=D;async function p(c,g,o){for(const i of c.folders)if(await c.exists(C.$Ig(F.URI.revive(i),g))){o(`workspaceContains:${g}`);return}}async function k(c,g,o,i){if(o.length===0)return Promise.resolve(void 0);const r=new f.$7d,n=c.checkExists(c.folders,o,r.token),a=setTimeout(async()=>{r.cancel(),c.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},R);let t=!1;try{t=await n}catch(h){P.$4(h)||P.$1(h)}r.dispose(),clearTimeout(a),t&&i(`workspaceContains:${o.join(",")}`)}function S(c,g,o,i){const r=c.get(A.$6h),n=c.get($.$BJ),t=r.createInstance(v.$VK).file(g.map(h=>(0,E.$pi)(F.URI.revive(h))),{_reason:"checkExists",includePattern:o,exists:!0});return n.fileSearch(t,i).then(h=>!!h.limitHit,h=>P.$4(h)?!1:Promise.reject(h))}e.$$sb=S}),define(Ee[47],Se([1,0,212,17,58,23,11,3,77,2,13,6,42,292,117,41,26,144,14,25,22,271,7,64,5,27,94,20,107,70,46,4,364,116,273,16,114,38,10,115]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a,t,h,s,d,l,u,w,I,b,m,y,L,N,U,T,O,M,j){"use strict";var z;Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=e.$Nhc=e.$Mhc=e.$Lhc=void 0,e.$Lhc=(0,s.$7h)("IHostUtils");let J=z=class extends v.$Tc{constructor(K,W,ie,ye,de,fe,_,ee,G,x,me,we){super(),this.X=we,this.a=this.B(new m.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=ie,this.f=_,this.j=ye,this.m=de,this.s=fe,this.t=G,this.u=x,this.w=me,this.y=this.g.getProxy(D.$fL.MainThreadWorkspace),this.z=this.g.getProxy(D.$fL.MainThreadTelemetry),this.C=this.g.getProxy(D.$fL.MainThreadExtensionService),this.D=new A.$6g,this.F=new A.$6g,this.G=new A.$6g,this.H=new A.$6g,this.I=new $e(this.f.extensions.activationEvents),this.L=new o.$V8b(this.I,this.f.extensions.allExtensions);const Ae=new r.$nm(this.f.extensions.myExtensions);this.J=new o.$V8b(this.I,ue(this.L,Ae)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new S.$whc(this.g,this.s),this.N=new L.$Ehc(this.g),this.O=ee,this.h=K.createChild(new w.$5h([S.$xhc,this.M],[L.$Fhc,this.N])),this.P=this.B(new k.$vhc(this.J,this.L,{onExtensionActivationError:(ve,Ie,B)=>{this.C.$onExtensionActivationError(ve,i.$3(Ie),B)},actualActivateExtension:async(ve,Ie)=>{if(o.$V8b.isHostExtension(ve,this.J,this.L))return await this.C.$activateExtension(ve,Ie),new k.$uhc;const B=this.J.getExtensionDescription(ve);return this.db(B,Ie)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.cb(de))}catch{}await Promise.all(K)}terminate(K,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ie=this.Y();Promise.race([(0,A.$8g)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const W=await this.C.$getExtension(K);return W&&{...W,identifier:new r.$mm(W.identifier.value),extensionLocation:E.URI.revive(W.extensionLocation)}}Z(K,W){return this.P.activateByEvent(K,W)}$(K,W){return this.P.activateById(K,W)}activateByIdWithErrors(K,W){return this.$(K,W).then(()=>{const ie=this.P.getActivatedExtension(K);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===U.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(K.fsPath);return E.URI.file(W)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new ne(K))),this.Q}async bb(K){const W=$.$ai.forUris(ie=>P.$zg.ignorePathCasing(ie));return await Promise.all(K.map(async ie=>{if(this.ub(ie)){const ye=await this.ab(ie.extensionLocation);W.set(ye,ie)}})),W}cb(K){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return W;const ie=this.P.getActivatedExtension(K);if(!ie)return W;try{typeof ie.module.deactivate=="function"&&(W=Promise.resolve(ie.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ye)}try{(0,v.$Oc)(ie.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ye)}return W}async db(K,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,W).then(ie=>{const ye=ie.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,W),this.eb(K,W,"success",ye),ie},ie=>{throw this.eb(K,W,"failure"),ie})}eb(K,W,ie,ye){const de=Y(K,W);this.z.$publicLog2("extensionActivationTimes",{...de,...ye||{},outcome:ie})}fb(K,W){const ie=Y(K,W);this.z.$publicLog2("activatePlugin",ie);const ye=this.ub(K);if(!ye)return Promise.resolve(new k.$thc(k.$qhc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${K.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const de=new k.$rhc(W.startup);return Promise.all([this.vb(K,(0,P.$Ig)(K.extensionLocation,ye),de),this.gb(K)]).then(fe=>(f.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),z.hb(this.s,K.identifier,fe[0],fe[1],de))).then(fe=>(f.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),fe))}gb(K){const W=new a.$zhc(K,this.M),ie=new a.$yhc(K.identifier.value,!1,this.M),ye=new N.$Ghc(K,this.N),de=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([W.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const _=this;let ee,G;const x=(0,g.$JF)(K,"ipc")?this.f.messagePorts?.get(r.$mm.toKey(K.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:ie,secrets:ye,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(me){return F.$jc(K.extensionLocation.fsPath,me)},get storagePath(){return _.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return _.O.globalValue(K).fsPath},get logPath(){return F.$jc(_.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return E.URI.joinPath(_.f.logsLocation,K.identifier.value)},get storageUri(){return _.O.workspaceValue(K)},get globalStorageUri(){return _.O.globalValue(K)},get extensionMode(){return de},get extension(){return ee===void 0&&(ee=new X(_,K.identifier,K,fe,!1)),ee},get extensionRuntime(){return(0,g.$KF)(K,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!G){if(!x)return;const me=m.Event.buffer(m.Event.fromDOMEventEmitter(x,"message",we=>we.data));x.start(),G={onDidReceiveMessage:me,postMessage:x.postMessage.bind(x)}}return G}})})}static hb(K,W,ie,ye,de){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(K,W,ie,ye,de).then(fe=>new k.$shc(!1,null,de.build(),ie,fe,ye.subscriptions))}static ib(K,W,ie,ye,de){if(typeof ie.activate=="function")try{de.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${W.value}`);const fe=typeof global=="object"?global:self,_=ie.activate.apply(fe,[ye]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(_).then(ee=>(de.activateResolveStop(),ee))}catch(fe){return Promise.reject(fe)}else return Promise.resolve(ie)}jb(K,W){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:W}).then(void 0,ie=>{this.s.error(ie)})}kb(K,W=0){const ye=Date.now();(0,M.$B)(()=>{for(let de=W;de<K.length;de+=1){const fe=K[de];for(const _ of fe.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-ye>50){this.kb(K,de);break}else this.jb(fe,_)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(K=>{const W=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(W)this.kb(ie);else for(const ye of ie)if(ye.activationEvents)for(const de of ye.activationEvents)de==="onStartupFinished"&&this.jb(ye,de)})}mb(){const K=this.Z("*",!0).then(void 0,fe=>{this.s.error(fe)});this.B(this.j.onDidChangeWorkspace(fe=>this.nb(fe.added)));const W=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(W),ye=this.pb(),de=Promise.all([ye,K,ie]).then(()=>{});return Promise.race([de,(0,A.$8g)(1e4)]).then(()=>{this.lb()}),de}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(K,W))).then(()=>{})}async ob(K,W){if(this.isActivated(W.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:K.map(fe=>fe.uri),forceUsingSearch:ie||!this.c.fsExists,exists:fe=>this.c.fsExists(fe.fsPath),checkExists:(fe,_,ee)=>this.y.$checkExists(fe,_,ee)},de=await(0,y.$0sb)(ye,W);if(de)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:de.activationEvent}).then(void 0,fe=>this.s.error(fe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:W}=this.f.environment;if(!K||!W)throw new Error(C.localize(0,null));const ie=await this.vb(null,W,new k.$rhc(!1));if(!ie||typeof ie.run!="function")throw new Error(C.localize(1,null,W.toString()));return new Promise((ye,de)=>{const fe=(G,x)=>{G?(M.$t&&this.s.error("Test runner called back with error",G),de(G)):(M.$t&&(x?this.s.info(`Test runner called back with ${x} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof x=="number"&&x>0?1:0))},_=(0,P.$wg)(W),ee=ie.run(_,fe);ee&&ee.then&&ee.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{M.$t&&this.s.error("Test runner finished with error",G),de(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$8g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,W){return this.R[K]=W,(0,v.$Rc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:W}=await this.sb(K);return W?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const W=K.indexOf("+");if(W===-1)throw new t.$nL("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=K.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(K,W){const ie=O.$Sd.create(!1),ye=()=>`[resolveAuthority(${(0,h.$al)(K)},${W})][${ie.elapsed()}ms] `,de=te=>this.s.info(`${ye()}${te}`),fe=te=>this.s.warn(`${ye()}${te}`),_=(te,V=void 0)=>this.s.error(`${ye()}${te}`,V),ee=te=>{if(te instanceof t.$nL)return{type:"error",error:{code:te._code,message:te._message,detail:te._detail}};throw te},G=async te=>{de(`activating resolver for ${te}...`);const{resolver:V,authorityPrefix:ae}=await this.sb(te);if(!V)throw _(`no resolver for ${ae}`),new t.$nL(`No remote extension installed to resolve ${ae}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:V,authorityPrefix:ae,remoteAuthority:te}},x=K.split(/@|%40/g).reverse();de(`activating remote resolvers ${x.join(" -> ")}`);let me;try{me=await Promise.all(x.map(G)).catch(async te=>{if(!(te instanceof t.$nL)||te._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw te;return fe(`resolving nested authorities failed: ${te.message}`),[await G(K)]})}catch(te){return ee(te)}const we=new A.$fh;we.cancelAndSet(()=>de("waiting..."),1e3);let Ae,ve;for(const[te,{authorityPrefix:V,resolver:ae,remoteAuthority:he}]of me.entries())try{if(te===me.length-1)de("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${V}`),Ae=await ae.resolve(he,{resolveAttempt:W,execServer:ve}),f.mark(`code/extHost/didResolveAuthorityOK/${V}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ae,t.$mL.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(de(`invoking resolveExecServer() for ${he}`),f.mark(`code/extHost/willResolveExecServer/${V}`),ve=await ae.resolveExecServer?.(he,{resolveAttempt:W,execServer:ve}),!ve)throw new t.$nL(`Exec server was not available for ${he}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${V}`)}}catch(Re){return f.mark(`code/extHost/didResolveAuthorityError/${V}`),_("returned an error",Re),we.dispose(),ee(Re)}we.dispose();const Ie={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures?{elevation:Ae.tunnelFeatures.elevation,privacyOptions:Ae.tunnelFeatures.privacyOptions,protocol:Ae.tunnelFeatures.protocol===void 0?!0:Ae.tunnelFeatures.protocol}:void 0},B={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$mL.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let Z;if(t.$mL.isManagedResolvedAuthority(Ae)){const te=W;this.X.setFactory(te,Ae.makeConnection),Z={authority:K,connectTo:new h.$0k(te),connectionToken:Ae.connectionToken}}else Z={authority:K,connectTo:new h.$$k(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:Z,options:B,tunnelInformation:Ie}}}async $getCanonicalURI(K,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,h.$al)(K)})`);const{resolver:ie}=await this.sb(K);if(!ie)return null;const ye=E.URI.revive(W);if(typeof ie.getCanonicalURI>"u")return ye;const de=await(0,A.$Zg)(()=>ie.getCanonicalURI(ye));return de||ye}$startExtensionHost(K){K.toAdd.forEach(ye=>ye.extensionLocation=E.URI.revive(ye.extensionLocation));const{globalRegistry:W,myExtensions:ie}=le(this.I,this.L,this.J,K);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(ie),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(K,W){return W===1?this.D.wait().then(ie=>this.Z(K,!1)):this.G.wait().then(ie=>this.Z(K,!1))}async $activate(K,W){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,W),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(fe=>fe.extensionLocation=E.URI.revive(fe.extensionLocation));const{globalRegistry:W,myExtensions:ie}=le(this.I,this.L,this.J,K),ye=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ie),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const W=n.$ke.alloc(K),ie=Math.random()%256;for(let ye=0;ye<K;ye++)W.writeUInt8(ie,ye);return W}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$Mhc=J,e.$Mhc=J=z=Ge([qe(0,s.$6h),qe(1,e.$Lhc),qe(2,u.$kN),qe(3,c.$_gc),qe(4,p.$chc),qe(5,R.$oj),qe(6,d.$AN),qe(7,l.$fhc),qe(8,I.$0yb),qe(9,b.$Ahc),qe(10,T.$Ihc),qe(11,j.$Jhc)],J);function le(oe,K,W,ie){oe.addActivationEvents(ie.addActivationEvents);const ye=new o.$V8b(oe,K.getAllExtensionDescriptions());ye.deltaExtensions(ie.toAdd,ie.toRemove);const de=new r.$nm(W.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of ie.myToRemove)de.delete(_);for(const _ of ie.myToAdd)de.add(_);const fe=ue(ye,de);return{globalRegistry:ye,myExtensions:fe}}function Y(oe,K){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function Q(oe){return oe.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$Nhc=(0,s.$7h)("IExtHostExtensionService");class X{#e;#t;#i;constructor(K,W,ie,ye,de){this.#e=K,this.#t=W,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=F.$hc((0,P.$wg)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=ye,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ohc=X;function ue(oe,K){return oe.getAllExtensionDescriptions().filter(W=>K.has(W.identifier))}class ne{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$Phc=ne;class $e{constructor(K){this.a=new r.$om,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const W of Object.keys(K))this.a.set(W,K[W])}}}),define(Ee[365],Se([1,0,58,2,6,42,26,25,20,27,5,47,13,12]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;let c=class{constructor(n,a,t,h,s,d,l){this.c=n,this.d=a,this.e=t,this.f=h,this.g=s,this.h=d,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new o(this.c,a,this.d,n,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const a of n.nodeModuleName)this.a.set(a,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(a=>n.alternativeModuleName(a))}};e.$Xic=c,e.$Xic=c=Ge([qe(2,R.$6h),qe(3,P.$chc),qe(4,D.$Nhc),qe(5,E.$AN),qe(6,p.$oj)],c);let g=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&S.a.size){const a=(0,k.$Pe)(this.c(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",h=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${s}\\/)(${h})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const a=this.b.exec(this.c(n));if(!a)return;const[,t,h,s]=a,d=S.a.get(h);if(d!==void 0)return console.warn(`${h} as been renamed to ${d}, please update your imports`),t+d+s}c(n){return n.replace(/\\/g,"/")}};g=S=Ge([qe(0,E.$AN)],g);class o{constructor(n,a,t,h,s){this.c=n,this.d=a,this.e=t,this.f=h,this.g=s,this.nodeModuleName="vscode",this.a=new v.$om}load(n,a){const t=this.d.findSubstr(a);if(t){let h=this.a.get(t.identifier);return h||(h=this.c(t,this.e,this.f),this.a.set(t.identifier,h)),h}if(!this.b){let h="";this.d.forEach((s,d)=>h+=`	${d} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${h}`),this.b=this.c(A.$EF,this.e,this.f)}return this.b}}let i=class{constructor(n,a,t){this.e=n,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$fL.MainThreadTelemetry);const h=t.getProxy(f.$fL.MainThreadWindow);this.c=(s,d)=>{const l=F.URI.parse(s);return d?this.g(s,d):l.scheme==="http"||l.scheme==="https"?h.$openUri(l,s,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?h.$openUri(l,s,{}):this.g(s,d)}}load(n,a,t){const h=this.e.findSubstr(a);return h&&(this.a=h.identifier.value,this.h()),this.b=t(n),this.c}g(n,a){return this.i(),this.b(n,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([qe(2,$.$kN)],i)}),define(Ee[60],Se([1,0,43,3,17,49,5,72,71,47,7,41,289,42]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=void 0,e.$Qhc=(0,A.$7h)("IExtHostVariableResolverProvider");class S extends p.$lO{constructor(o,i,r,n,a,t,h){function s(){if(r){const d=r.activeEditor();if(d)return d.document.uri;const l=n.tabGroups.all.find(u=>u.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof R.$2M||l.input instanceof R.$7M)return l.input.modified;if(l.input instanceof R.$1M||l.input instanceof R.$6M||l.input instanceof R.$4M)return l.input.uri}}}super({getFolderUri:d=>{const l=t.folders.filter(u=>u.name===d);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(d,l)=>a.getConfiguration(void 0,d).get(l),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=s();if(d)return f.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const d=s();if(d){const l=i.getWorkspaceFolder(d);if(l)return f.$hc(l.uri.fsPath)}}},getSelectedText:()=>{if(r){const d=r.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(r){const d=r.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>o.getExtension(d)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(P.env))}}let c=class extends F.$Tc{constructor(o,i,r,n,a){super(),this.b=o,this.c=i,this.g=r,this.h=n,this.j=a,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Rhc=c,e.$Rhc=c=Ge([qe(0,E.$Nhc),qe(1,D.$_gc),qe(2,v.$vN),qe(3,k.$chc),qe(4,$.$ohc)],c)}),define(Ee[97],Se([1,0,11,4,2,25,5,6,71,47,20,7,41,140,281,42,60,3,55,33]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=e.$Vhc=e.$Uhc=e.$Thc=e.$Shc=void 0,e.$Shc=(0,A.$7h)("IExtHostDebugService");let n=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(u,w,I,b,m,y,L){this.I=w,this.J=I,this.K=b,this.L=m,this.M=y,this.N=L,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new F.$Wd,this.n=new F.$Wd,this.o=new F.$Wd,this.u=new F.$Wd,this.k=u.getProxy(v.$fL.MainThreadDebugService),this.z=new F.$Wd,this.B=new F.$Wd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(N=>{N.onDidChange(U=>{this.O(N)}),this.O(N)})}asDebugSourceUri(u,w){const I=u;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let b=`debug:${encodeURIComponent(I.path||"")}`,m="?";return w&&(b+=`${m}session=${encodeURIComponent(w.id)}`,m="&"),b+=`${m}ref=${I.sourceReference}`,f.URI.parse(b)}else{if(I.path)return f.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(u){const w=[];for(const I of u.getAllExtensionDescriptions())if(I.contributes){const b=I.contributes.debuggers;if(b&&b.length>0)for(const m of b)(0,S.$fG)(m)&&w.push(m.type)}this.k.$registerDebugTypes(w)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const u=[];return this.y.forEach(w=>u.push(w)),u}async $resolveDebugVisualizer(u,w){const I=this.G.get(u);if(!I)throw new Error(`No debug visualizer found with id '${u}'`);let{v:b,provider:m}=I;if(b.visualization||(b=await m.resolveDebugVisualization?.(b,w)||b,I.v=b),!b.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${m}'`);return this.db(b.visualization)}async $executeDebugVisualizerCommand(u){const w=this.G.get(u);if(!w)throw new Error(`No debug visualizer found with id '${u}'`);const I=w.v.visualization;I&&"command"in I&&this.N.executeCommand(I.command,...I.arguments||[])}async $provideDebugVisualizers(u,w,I,b){const m=this.l.get(I.sessionId),y=this.cb(u,w),L=this.E.get(y);if(!m||!L)return[];const N=await L.provideDebugVisualization({session:m,variable:I.variable,containerId:I.containerId,frameId:I.frameId,threadId:I.threadId},b);return N?N.map(U=>{const T=++this.H;this.G.set(T,{v:U,provider:L});const O=U.iconPath?this.eb(U.iconPath):void 0;return{id:T,name:U.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.db(U.visualization)}}):[]}$disposeDebugVisualizers(u){for(const w of u)this.G.delete(w)}registerDebugVisualizationProvider(u,w,I){if(!u.contributes?.debugVisualizers?.some(y=>y.id===w))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${w})`);const b=P.$mm.toKey(u.identifier),m=this.cb(b,w);if(this.E.has(m))throw new Error(`A debug visualization provider with id '${w}' is already registered`);return this.E.set(m,I),this.k.$registerDebugVisualizer(b,w),(0,o.$Rc)(()=>{this.k.$unregisterDebugVisualizer(b,w),this.E.delete(w)})}addBreakpoints(u){const w=u.filter(m=>{const y=m.id;return this.y.has(y)?!1:(this.y.set(y,m),!0)});this.$(w,[],[]);const I=[],b=new Map;for(const m of w)if(m instanceof D.$hM){let y=b.get(m.location.uri.toString());y||(y={type:"sourceMulti",uri:m.location.uri,lines:[]},b.set(m.location.uri.toString(),y),I.push(y)),y.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof D.$iM&&I.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(I)}removeBreakpoints(u){const w=u.filter(y=>this.y.delete(y.id));this.$([],w,[]);const I=w.filter(y=>y instanceof D.$hM).map(y=>y.id),b=w.filter(y=>y instanceof D.$iM).map(y=>y.id),m=w.filter(y=>y instanceof D.$jM).map(y=>y.id);return this.k.$unregisterBreakpoints(I,b,m)}startDebugging(u,w,I){return this.k.$startDebugging(u?u.uri:void 0,w,{parentSessionID:I.parentSession?I.parentSession.id:void 0,lifecycleManagedByParent:I.lifecycleManagedByParent,repl:I.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact,suppressSaveBeforeStart:I.suppressSaveBeforeStart,suppressDebugStatusbar:I.suppressDebugStatusbar??I.debugUI?.simple,suppressDebugToolbar:I.suppressDebugToolbar??I.debugUI?.simple,suppressDebugView:I.suppressDebugView??I.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,w,I){if(!w)return new D.$hL(()=>{});const b=this.d++;return this.f.push({type:u,handle:b,provider:w}),this.k.$registerDebugConfigurationProvider(u,I,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,b),new D.$hL(()=>{this.f=this.f.filter(m=>m.provider!==w),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(u,w,I){if(!I)return new D.$hL(()=>{});if(!this.W(u,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.S(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:w,handle:b,factory:I}),this.k.$registerDebugAdapterDescriptorFactory(w,b),new D.$hL(()=>{this.h=this.h.filter(m=>m.factory!==I),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(u,w){if(!w)return new D.$hL(()=>{});const I=this.i++;return this.j.push({type:u,handle:I,factory:w}),new D.$hL(()=>{this.j=this.j.filter(b=>b.factory!==w)})}async $runInTerminal(u,w){return Promise.resolve(void 0)}async $substituteVariables(u,w){let I;const b=await this.bb(u);return b&&(I={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(I,w)}P(u,w){if(u.type==="implementation")return new s(u.implementation)}Q(){}async $startDASession(u,w){const I=this,b=await this.ab(w);return this.Y(this.S(b.type),b).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const y=this.R(m),L=this.P(y,b);if(!L)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const N=L;return this.C.set(u,N),this.X(b).then(U=>(U&&this.D.set(u,U),N.onMessage(async T=>{if(T.type==="request"&&T.command==="handshake"){const O=T,M={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const j=await this.F.sign(O.arguments.value);M.body={signature:j},N.sendResponse(M)}else throw new Error("no signer")}catch(j){M.success=!1,M.message=j.message,N.sendResponse(M)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(T),T=(0,S.$kG)(T,!0),I.k.$acceptDAMessage(u,T)}),N.onError(T=>{U&&U.onError&&U.onError(T),this.k.$acceptDAError(u,T.name,T.message,T.stack)}),N.onExit(T=>{U&&U.onExit&&U.onExit(T??void 0,void 0),this.k.$acceptDAExit(u,T??void 0,void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),N.startSession()))})}$sendDAMessage(u,w){w=(0,S.$jG)(w,!1);const I=this.D.get(u);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(w),this.C.get(u)?.sendMessage(w)}$stopDASession(u){const w=this.D.get(u);this.D.delete(u),w&&w.onWillStopSession&&w.onWillStopSession();const I=this.C.get(u);return this.C.delete(u),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const w=[],I=[],b=[];if(u.added)for(const m of u.added){const y=m.id;if(y&&!this.y.has(y)){let L;if(m.type==="function")L=new D.$iM(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")L=new D.$jM(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const N=f.URI.revive(m.uri);L=new D.$hM(new D.$tL(N,new D.$iL(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,D.$fM)(L,y),this.y.set(y,L),w.push(L)}}if(u.removed)for(const m of u.removed){const y=this.y.get(m);y&&(this.y.delete(m),I.push(y))}if(u.changed){for(const m of u.changed)if(m.id){const y=this.y.get(m.id);if(y){if(y instanceof D.$iM&&m.type==="function"){const L=y;L.enabled=m.enabled,L.condition=m.condition,L.hitCondition=m.hitCondition,L.logMessage=m.logMessage,L.functionName=m.functionName}else if(y instanceof D.$hM&&m.type==="source"){const L=y;L.enabled=m.enabled,L.condition=m.condition,L.hitCondition=m.hitCondition,L.logMessage=m.logMessage,L.location=new D.$tL(f.URI.revive(m.uri),new D.$iL(m.line,m.character))}b.push(y)}}}this.$(w,I,b)}async $acceptStackFrameFocus(u){let w;const I=u.sessionId?await this.ab(u.sessionId):void 0;if(!I)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?w=new D.$pM(I,u.threadId):w=new D.$oM(I,u.threadId,u.frameId),this.A=w,this.B.fire(this.A)}$provideDebugConfigurations(u,w,I){return(0,C.$Zg)(async()=>{const b=this.V(u);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.bb(w);return b.provideDebugConfigurations(m,I)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(u,w,I,b){return(0,C.$Zg)(async()=>{const m=this.V(u);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.bb(w);return m.resolveDebugConfiguration(y,I,b)})}$resolveDebugConfigurationWithSubstitutedVariables(u,w,I,b){return(0,C.$Zg)(async()=>{const m=this.V(u);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.bb(w);return m.resolveDebugConfigurationWithSubstitutedVariables(y,I,b)})}async $provideDebugAdapter(u,w){const I=this.U(u);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.ab(w);return this.Y(I,b).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.R(m)})}async $acceptDebugSessionStarted(u){const w=await this.ab(u);this.m.fire(w)}async $acceptDebugSessionTerminated(u){const w=await this.ab(u);w&&(this.n.fire(w),this.l.delete(w.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.ab(u):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(u,w){(await this.ab(u))?._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(u,w){const b={session:await this.ab(u),event:w.event,body:w.body};this.u.fire(b)}R(u){if(u instanceof D.$kM)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof D.$lM)return{type:"server",port:u.port,host:u.host};if(u instanceof D.$mM)return{type:"pipeServer",path:u.path};if(u instanceof D.$nM)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}S(u){const w=this.h.filter(I=>I.type===u);if(w.length>0)return w[0].factory}U(u){const w=this.h.filter(I=>I.handle===u);if(w.length>0)return w[0].factory}V(u){const w=this.f.filter(I=>I.handle===u);if(w.length>0)return w[0].provider}W(u,w){if(u.contributes){const I=u.contributes.debuggers;if(I&&I.length>0){for(const b of I)if(b.label&&b.type&&b.type===w)return!0}}return!1}X(u){const I=u.configuration.type,b=this.j.filter(m=>m.type===I||m.type==="*").map(m=>(0,C.$Zg)(()=>m.factory.createDebugAdapterTracker(u)).then(y=>y,y=>null));return Promise.race([Promise.all(b).then(m=>{const y=m.filter(L=>!!L);if(y.length>0)return new h(y)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async Y(u,w){const I=w.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new D.$lM(I));if(u){const m=await this.J.getExtensionRegistry();return(0,C.$Zg)(()=>u.createDebugAdapterDescriptor(w,this.Z(w,m))).then(y=>{if(y)return y})}const b=await this.J.getExtensionRegistry();return Promise.resolve(this.Z(w,b))}Z(u,w){}$(u,w,I){(u.length>0||w.length>0||I.length>0)&&this.z.fire(Object.freeze({added:u,removed:w,changed:I}))}async ab(u){if(u)if(typeof u=="string"){const w=this.l.get(u);if(w)return w}else{let w=this.l.get(u.id);if(!w){const I=await this.bb(u.folderUri),b=u.parent?this.l.get(u.parent):void 0;w=new a(this.k,u.id,u.type,u.name,I,u.configuration,b),this.l.set(w.id,w),this.k.$sessionCached(w.id)}return w}throw new Error("cannot find session")}bb(u){if(u){const w=f.URI.revive(u);return this.I.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}cb(u,w){return`${u}\0${w}`}db(u){if(u){if("title"in u&&"command"in u)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(u){const w=this.fb(u);let I,b;return"id"in w?b=i.ThemeIcon.asClassName(w):I=w,{iconPath:I,iconClass:b}}fb(u){if(u instanceof D.$cM)return{id:u.id};const w=typeof u=="object"&&"dark"in u?u.dark:u,I=typeof u=="object"&&"light"in u?u.light:u;return{dark:typeof w=="string"?f.URI.file(w):w,light:typeof I=="string"?f.URI.file(I):I}}};e.$Thc=n,e.$Thc=n=Ge([qe(0,R.$kN),qe(1,p.$_gc),qe(2,E.$Nhc),qe(3,c.$chc),qe(4,$.$ohc),qe(5,g.$Qhc),qe(6,r.$GN)],n);class a{constructor(u,w,I,b,m,y,L){this.d=u,this.f=w,this.g=I,this.h=b,this.i=m,this.j=y,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(u){this.h=u,this.d.$setDebugSessionName(this.f,u)}get parentSession(){return this.k}_acceptNameChanged(u){this.h=u}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(u,w){return this.d.$customDebugAdapterRequest(this.f,u,w)}getDebugProtocolBreakpoint(u){return this.d.$getDebugProtocolBreakpoint(this.f,u.id)}}e.$Uhc=a;class t{constructor(u){this.value=Object.freeze({append(w){u.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.$Vhc=t;class h{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(w=>w.onError?w.onError(u):void 0)}onExit(u,w){this.d.forEach(I=>I.onExit?I.onExit(u,w):void 0)}}class s extends k.$5lb{constructor(u){super(),this.h=u,u.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends n{constructor(u,w,I,b,m,y,L){super(u,w,I,b,m,y,L)}};e.$Whc=d,e.$Whc=d=Ge([qe(0,R.$kN),qe(1,p.$_gc),qe(2,E.$Nhc),qe(3,c.$chc),qe(4,$.$ohc),qe(5,g.$Qhc),qe(6,r.$GN)],d)}),define(Ee[366],Se([1,0,14,58,2,6,309,13,84,107,27,247,20,66,47,91]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=e.$Yic=void 0;class g{static async installEarlyHandler(r){Error.stackTraceLimit=100;const n=r.get(v.$oj),t=r.get(p.$kN).getProxy(P.$fL.MainThreadErrors);C.setUnexpectedErrorHandler(h=>{n.error(h);const s=C.$3(h);t.$onUnexpectedError(s)})}static async installFullHandler(r){const n=r.get(v.$oj),a=r.get(p.$kN),t=r.get(S.$Nhc),h=r.get(c.$EN),s=a.getProxy(P.$fL.MainThreadExtensionService),d=a.getProxy(P.$fL.MainThreadErrors),l=await t.getExtensionPathIndex(),u=new WeakMap;function w(m,y){if(u.has(m))return u.get(m).stack;let L="",N,U;for(const O of y)L+=`
	at ${O.toString()}`,U=O.getFileName(),!N&&U&&(N=l.findSubstr(f.URI.file(U)));const T=`${m.name||"Error"}: ${m.message||""}${L}`;return u.set(m,{extensionIdentifier:N?.identifier,stack:T}),T}const I=Symbol("prepareStackTrace wrapped");let b=w;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(m){if(m===w||!m||m[I]){b=m||w;return}b=function(y,L){return w(y,L),m.call(Error,y,L)},Object.assign(b,{[I]:!0})}}),C.setUnexpectedErrorHandler(m=>{n.error(m);const y=C.$3(m),L=u.get(m);if(!L?.extensionIdentifier){d.$onUnexpectedError(y);return}s.$onExtensionRuntimeError(L.extensionIdentifier,y);const N=h.onExtensionError(L.extensionIdentifier,m);n.trace("forwarded error to extension?",N,L)})}}e.$Yic=g;class o{constructor(r,n,a,t,h){this.a=a,this.b=new A.$48b(r,null,t),n=o.e(n,this.b);const s=new E.$5h(...(0,$.$1r)());s.set(R.$AN,{_serviceBrand:void 0,...n,messagePorts:h}),s.set(p.$kN,new p.$lN(this.b)),s.set(k.$9gc,new k.$0gc(t)),s.set(S.$Lhc,a);const d=new D.$Fq(s,!0);d.invokeFunction(g.installEarlyHandler),this.d=d.invokeFunction(l=>l.get(v.$oj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=d.invokeFunction(l=>l.get(S.$Nhc)),this.c.initialize(),d.invokeFunction(g.installFullHandler)}async asBrowserUri(r){const n=this.b.getProxy(P.$fL.MainThreadExtensionService);return f.URI.revive(await n.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,n){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=f.URI.revive(n.transformIncomingURIs(r.environment.appRoot));const a=r.environment.extensionDevelopmentLocationURI;return a&&(r.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(n.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=f.URI.revive(n.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=f.URI.revive(n.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=f.URI.revive(n.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=f.URI.revive(n.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=f.URI.revive(n.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=f.URI.revive(n.transformIncomingURIs(r.logsLocation)),r.workspace=n.transformIncomingURIs(r.workspace),r}}e.$Zic=o}),define(Ee[367],Se([1,0,11,10,222,241,138,97,71,47,20,46,7,60,41,282,283,42,33]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=void 0;let r=class extends v.$Thc{constructor(s,d,l,u,w,I,b,m){super(s,d,l,u,I,b,m),this.ib=w,this.gb=new t}P(s,d){switch(s.type){case"server":return new c.$5ic(s);case"pipeServer":return new c.$6ic(s);case"executable":return new c.$7ic(s,d.type)}return super.P(s,d)}Z(s,d){const l=c.$7ic.platformAdapterExecutable(d.getAllExtensionDescriptions(),s.type);if(l)return new p.$kM(l.command,l.args,l.options)}Q(){return new A.$Q_b}async $runInTerminal(s,d){if(s.kind==="integrated"){this.hb||(this.hb=this.ib.onDidCloseTerminal(O=>{this.gb.onTerminalClosed(O)}));const l=await this.K.getConfigProvider(),u=this.ib.getDefaultShell(!0),w=this.ib.getDefaultShellArgs(!0),I=s.title||f.localize(0,null),b=JSON.stringify({shell:u,shellArgs:w});let m=await this.gb.checkout(b,I),y,L=!1;if(m)y=s.cwd;else{const O={shellPath:u,shellArgs:w,cwd:s.cwd,name:I,iconPath:new p.$cM("debug")};L=!0,m=this.ib.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.gb.insert(m,b)}m.show(!0);const N=await m.processId;L?await new Promise(O=>setTimeout(O,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?m.sendText("cls"):u.indexOf("bash")>=0?m.sendText("clear"):F.$i?m.sendText("cls"):m.sendText("clear"));const U=(0,g.$9ic)(u,s.args,!!s.argsCanBeInterpretedByShell,y,s.env);m.sendText(U);const T=this.onDidTerminateDebugSession(O=>{O.id===d&&(this.gb.free(m),T.dispose())});return N}else if(s.kind==="external")return a(s,await this.K.getConfigProvider());return super.$runInTerminal(s,d)}};e.$0ic=r,e.$0ic=r=Ge([qe(0,R.$kN),qe(1,S.$_gc),qe(2,E.$Nhc),qe(3,o.$chc),qe(4,D.$Ahc),qe(5,$.$ohc),qe(6,k.$Qhc),qe(7,i.$GN)],r);let n;function a(h,s){if(!n)if(F.$i)n=new P.$C$b;else if(F.$j)n=new P.$D$b;else if(F.$k)n=new P.$E$b;else throw new Error("external terminals not supported on this platform");const d=s.getConfiguration("terminal");return n.runInTerminal(h.title,h.cwd,h.args,h.env||{},d.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,d){const u=[...this.b.entries()].map(([w,I])=>(0,C.$Ug)(async b=>{if(w.name!==d||I.lastUsedAt!==-1&&await(0,g.$8ic)(await w.processId))return null;const m=Date.now();return I.lastUsedAt+t.a>m||b.isCancellationRequested||I.config!==s?null:(I.lastUsedAt=m,w)}));return await(0,C.$_g)(u,w=>!!w)}insert(s,d){this.b.set(s,{lastUsedAt:Date.now(),config:d})}free(s){const d=this.b.get(s);d&&(d.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(Ee[368],Se([1,0,17,2,105,41,72,42,40,46,20,27,96,16,13,92,23,63,60]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;let r=class extends p.$Dic{constructor(a,t,h,s,d,l,u,w,I){super(a,t,h,s,d,l,u,w),this.C=h,this.D=I,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const h=t;if(!t.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const s=p.TaskHandleDTO.from(h,this.C),d=await this.a.$getTaskExecution(s);if(d.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.z(d,t);return this.a.$executeTask(s).catch(()=>{}),l}else{const s=p.TaskDTO.from(t,a);if(s===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const d=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),d}}v(a,t,h,s){const d=[];if(s)for(const l of s){this.A(l,h),(!l.definition||!a[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const u=p.TaskDTO.from(l,h.extension);u&&(d.push(u),p.CustomExecutionDTO.is(u.execution)&&t.push(this.y(u,l,!0)))}return{tasks:d,extension:h.extension}}async w(a){return a}async G(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const h=F.URI.file((0,o.homedir)());t=new $.$oi({uri:h,name:g.$Fg(h),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const h=F.URI.revive(a),s={process:void 0,variables:Object.create(null)},d=await this.b.resolveWorkspaceFolder(h),l=await this.b.getWorkspaceFolders2()??[],u=await this.D.getResolver(),w=d?{uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(l);for(const I of t.variables)s.variables[I]=await u.resolveAsync(w,I);if(t.process!==void 0){let I;if(t.process.path!==void 0){I=t.process.path.split(C.$tc);for(let b=0;b<I.length;b++)I[b]=await u.resolveAsync(w,I[b])}s.process=await f.win32.findExecutable(await u.resolveAsync(w,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(w,t.process.cwd):void 0,I)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,h){return f.win32.findExecutable(a,t,h)}};e.$2ic=r,e.$2ic=r=Ge([qe(0,R.$kN),qe(1,D.$AN),qe(2,P.$_gc),qe(3,A.$vN),qe(4,v.$chc),qe(5,E.$Ahc),qe(6,S.$oj),qe(7,c.$Tgc),qe(8,i.$Qhc)],r)}),define(Ee[369],Se([1,0,63,60]),function(ge,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class f extends F.$Rhc{m(){return(0,C.homedir)()}}e.$Hjc=f}),define(Ee[154],Se([1,0,19,11,21,44,16,17,23,2,36]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=e.$aic=e.$_hc=e.$$hc=void 0;class D{constructor(i,r,n,a){this.d=i,this.e=r,this.f=n,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,r){const n=this.d.folderQueries||[],a=new f.$7d(r);return new Promise((t,h)=>{this.a=new k(i);let s=!1;const d=(l,u)=>{if(!s&&!this.b){const w=this.h(l);c(l)&&typeof this.d.maxResults=="number"&&this.c+w>this.d.maxResults&&(this.b=!0,s=!0,a.cancel(),l=this.j(l,this.d.maxResults-this.c));const I=this.h(l);this.c+=I,(I>0||!c(l))&&this.a.add(l,u)}};Promise.all(n.map((l,u)=>this.k(l,w=>d(w,u),a.token))).then(l=>{a.dispose(),this.a.flush();const u=l.some(w=>!!w&&!!w.limitHit);t({limitHit:this.b||u,messages:(0,C.$Rb)(l.map(w=>w?.message?Array.isArray(w.message)?w.message:[w.message]:[])),stats:{type:this.g}})},l=>{a.dispose();const u=(0,P.$Ri)(l);h(new Error(u))})})}h(i){return c(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,r){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,r),preview:{matches:a.slice(0,r),text:i.preview.text},uri:i.uri}}async k(i,r,n){const a=new R.$UJ(this.d,i),t=[],h={report:l=>{if(!this.l(l))return;const u=i.folder.scheme===A.Schemas.file?(0,R.$VJ)(()=>this.f.readdir($.$Hg(l.uri))):void 0,w=$.$Kg(i.folder,l.uri);if(w){const I=a.includedInQuery(w,v.$nc(w),u);(0,F.$Tg)(I)?t.push(I.then(b=>{b&&r(l)})):I&&r(l)}}},s=this.n(i),d=await this.e.provideTextSearchResults(p(this.d.contentPattern),s,h,n);return t.length&&await Promise.all(t),d}l(i){if(c(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const r=(0,R.$TJ)(this.d.includePattern,i.includePattern),n=(0,R.$TJ)(this.d.excludePattern,i.excludePattern),a={folder:E.URI.from(i.folder),excludes:n,includes:r,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$$hc=D;function p(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class k{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new g(512,r=>this.g(r))}add(i,r){this.d&&(this.b!==r||!$.$Bg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$_hc=k;function S(o){return c(o)?{preview:{matches:(0,C.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,C.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function c(o){return!!o.preview}e.$aic=c;class g{static{this.a=4e3}static{this.b=50}constructor(i,r){this.g=i,this.h=r,this.c=0,this.d=[],this.e=0}addItem(i,r){i&&this.j(i,r)}addItems(i,r){i&&this.k(i,r)}j(i,r){this.d.push(i),this.e+=r,this.l()}k(i,r){this.d=this.d.concat(i),this.e+=r,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$bic=g}),define(Ee[98],Se([1,0,3,6,5,362,20,66,13,2,154]),function(ge,e,C,F,f,P,A,v,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=e.$dic=e.$cic=void 0,e.$cic=(0,f.$7h)("IExtHostSearch");let D=class{constructor(c,g,o){this.k=c,this.l=g,this.n=o,this.c=this.k.getProxy(F.$fL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new P.$0hc}o(c){return this.l.transformOutgoingScheme(c)}registerTextSearchProvider(c,g){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const o=this.d++;return this.e.set(o,g),this.c.$registerTextSearchProvider(o,this.o(c)),(0,C.$Rc)(()=>{this.g.delete(c),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(c,g){if(this.i.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.i.add(c);const o=this.d++;return this.h.set(o,g),this.c.$registerFileSearchProvider(o,this.o(c)),(0,C.$Rc)(()=>{this.i.delete(c),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(c,g,o,i){const r=p(o),n=this.h.get(c);if(n)return this.j.fileSearch(r,n,a=>{this.c.$handleFileMatch(c,g,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,g,o){return{messages:[]}}$clearCache(c){return this.j.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,g,o,i){const r=this.e.get(c);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const n=p(o);return this.q(n,r).search(t=>this.c.$handleTextMatch(c,g,t),i)}$enableExtensionHostSearch(){}q(c,g){return new R.$$hc(c,g,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$dic=D,e.$dic=D=Ge([qe(0,A.$kN),qe(1,v.$9gc),qe(2,$.$oj)],D);function p(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(k),extraFileResources:S.extraFileResources&&S.extraFileResources.map(c=>E.URI.revive(c))}}e.$eic=p;function k(S){return{...S,folder:E.URI.revive(S.folder)}}}),define(Ee[370],Se([1,0,21,14,4,3,16,39,2,132,191,172,79,25,32,13,65,88,266,6,311,341,92,312,317,318,319,320,321,298,287,33,322,42,323,97,147,324,300,313,325,326,72,71,314,47,327,69,328,59,27,342,343,315,301,329,330,114,115,302,361,332,272,333,344,334,152,303,335,336,337,20,338,98,116,339,304,340,117,94,96,91,46,345,346,316,347,348,70,15,7,305,66,306,93,349,350,146,41,280,113,26,95]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a,t,h,s,d,l,u,w,I,b,m,y,L,N,U,T,O,M,j,z,J,le,Y,Q,X,ue,ne,$e,oe,K,W,ie,ye,de,fe,_,ee,G,x,me,we,Ae,ve,Ie,B,Z,te,V,ae,he,Re,je,He,Qe,_e,at,st,rt,Pe,Ue,Le,Ze,re,se,Ce,Ve,Xe,it,nt,Oe,yt,Dt,Ft,Tt,kt,Ht,Ot,Xt,qt,zt,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;function Jt(ht){const $t=ht.get(K.$AN),Bt=ht.get(oe.$Qgc),Qt=ht.get(ne.$ehc),Et=ht.get(X.$Nhc),ft=ht.get(Xt.$_gc),It=ht.get(Le.$EN),_t=ht.get(L.$chc),Lt=ht.get(Dt.$9gc),Je=ht.get(Re.$kN),Mt=ht.get(rt.$xhc),jt=ht.get(Pe.$fhc),Zt=ht.get(c.$pj),gt=ht.get(c.$oj),Nt=ht.get(it.$0yb),At=ht.get(t.$Tgc),Wt=ht.get(Ot.$Sic),Me=ht.get(Qe.$Fhc),Te=ht.get(Y.$ohc),De=ht.get(G.$Jhc);Je.set(r.$gL.ExtHostFileSystemInfo,Bt),Je.set(r.$gL.ExtHostLogLevelServiceShape,Zt),Je.set(r.$gL.ExtHostWorkspace,ft),Je.set(r.$gL.ExtHostConfiguration,_t),Je.set(r.$gL.ExtHostExtensionService,Et),Je.set(r.$gL.ExtHostStorage,Mt),Je.set(r.$gL.ExtHostTunnelService,Nt),Je.set(r.$gL.ExtHostWindow,Wt),Je.set(r.$gL.ExtHostSecretState,Me),Je.set(r.$gL.ExtHostTelemetry,It),Je.set(r.$gL.ExtHostEditorTabs,Te),Je.set(r.$gL.ExtHostManagedSockets,De);const ce=Je.set(r.$gL.ExtHostDecorations,ht.get(T.$Yhc)),Fe=Je.set(r.$gL.ExtHostDocumentsAndEditors,ht.get(le.$vN)),Be=Je.set(r.$gL.ExtHostCommands,ht.get(m.$GN)),xe=Je.set(r.$gL.ExtHostTerminalService,ht.get(Ze.$Ahc)),Ke=Je.set(r.$gL.ExtHostDebugService,ht.get(U.$Shc)),ct=Je.set(r.$gL.ExtHostSearch,ht.get(He.$cic)),wt=Je.set(r.$gL.ExtHostTask,ht.get(Ue.$Fic)),Kt=Je.set(r.$gL.ExtHostOutputService,ht.get(Z.$sic)),St=Je.set(r.$gL.ExtHostLocalization,ht.get(ee.$Ihc)),Ct=Je.set(r.$gL.ExtHostUrls,new Ft.$Pic(Je)),vt=Je.set(r.$gL.ExtHostDocuments,new J.$Ogc(Je,Fe)),Si=Je.set(r.$gL.ExtHostDocumentContentProviders,new j.$1hc(Je,Fe,gt)),Ki=Je.set(r.$gL.ExtHostDocumentSaveParticipant,new z.$2hc(gt,vt,Je.getProxy(r.$fL.MainThreadBulkEdits))),Pt=Je.set(r.$gL.ExtHostNotebook,new me.$fic(Je,Be,Fe,vt,Qt,ct)),si=Je.set(r.$gL.ExtHostNotebookDocuments,new Ae.$mic(Pt)),mi=Je.set(r.$gL.ExtHostNotebookEditors,new ve.$nic(gt,Pt)),li=Je.set(r.$gL.ExtHostNotebookKernels,new Ie.$oic(Je,$t,Pt,Be,gt)),Di=Je.set(r.$gL.ExtHostNotebookRenderers,new B.$qic(Je,Pt)),Ci=Je.set(r.$gL.ExtHostNotebookDocumentSaveParticipant,new we.$lic(gt,Pt,Je.getProxy(r.$fL.MainThreadBulkEdits))),Ut=Je.set(r.$gL.ExtHostEditors,new se.$6gc(Je,Fe)),$i=Je.set(r.$gL.ExtHostTreeViews,new Xe.$Nic(Je.getProxy(r.$fL.MainThreadTreeViews),Be,gt)),Ii=Je.set(r.$gL.ExtHostEditorInsets,new b.$7gc(Je.getProxy(r.$fL.MainThreadEditorInsets),Ut,$t.remote)),ui=Je.set(r.$gL.ExtHostDiagnostics,new O.$Sgc(Je,gt,Bt,Fe)),hi=Je.set(r.$gL.ExtHostLanguages,new _.$jic(Je,vt,Be.converter,Lt)),dt=Je.set(r.$gL.ExtHostLanguageFeatures,new fe.$Wgc(Je,Lt,vt,Be,ui,gt,At,It)),Ji=Je.set(r.$gL.ExtHostFileSystem,new ue.$4hc(Je,dt)),ei=Je.set(r.$gL.ExtHostFileSystemEventService,new $e.$5hc(Je,gt,Fe)),oi=Je.set(r.$gL.ExtHostQuickOpen,(0,he.$wic)(Je,ft,Be)),bi=Je.set(r.$gL.ExtHostSCM,new je.$yic(Je,Be,vt,gt)),Pi=Je.set(r.$gL.ExtHostQuickDiff,new ae.$vic(Je,Lt)),Qi=Je.set(r.$gL.ExtHostShare,new _e.$zic(Je,Lt)),Li=Je.set(r.$gL.ExtHostComments,(0,y.$8gc)(Je,Be,vt)),pi=Je.set(r.$gL.ExtHostProgress,new V.$uic(Je.getProxy(r.$fL.MainThreadProgress))),Zi=Je.set(r.$gL.ExtHostLabelService,new de.$iic(Je)),Ai=Je.set(r.$gL.ExtHostTheming,new Ce.$Kic(Je)),di=Je.set(r.$gL.ExtHostAuthentication,new h.$Ygc(Je)),Xi=Je.set(r.$gL.ExtHostTimeline,new Ve.$Mic(Je,Be)),vi=Je.set(r.$gL.ExtHostWebviews,new Tt.$jhc(Je,$t.remote,ft,gt,At)),Ri=Je.set(r.$gL.ExtHostWebviewPanels,new kt.$mhc(Je,vi,ft)),un=Je.set(r.$gL.ExtHostCustomEditors,new N.$nhc(Je,vt,jt,vi,Ri)),Mi=Je.set(r.$gL.ExtHostWebviewViews,new Ht.$Qic(Je,vi)),ai=Je.set(r.$gL.ExtHostTesting,new re.$Gic(Je,gt,Be,Fe)),hn=Je.set(r.$gL.ExtHostUriOpeners,new yt.$Oic(Je)),dn=Je.set(r.$gL.ExtHostProfileContentHandlers,new te.$tic(Je));Je.set(r.$gL.ExtHostInteractive,new ie.$gic(Je,Pt,Fe,Be,gt));const Yi=Je.set(r.$gL.ExtHostInlineChat,new W.$6hc(Je,Be,vt,gt)),Ni=Je.set(r.$gL.ExtHostChatProvider,new u.$2gc(Je,gt)),Fi=Je.set(r.$gL.ExtHostChatAgents2,new l.$3gc(Je,Ni,gt)),xi=Je.set(r.$gL.ExtHostChatVariables,new w.$4gc(Je)),wi=Je.set(r.$gL.ExtHostChat,new d.$1gc(Je)),Ti=Je.set(r.$gL.ExtHostAiRelatedInformation,new n.$Ngc(Je)),fn=Je.set(r.$gL.ExtHostAiEmbeddingVector,new Q.$3hc(Je)),yi=Je.set(r.$gL.ExtHostIssueReporter,new ye.$hic(Je)),Oi=Je.set(r.$gL.ExtHostStatusBar,new st.$Cic(Je,Be.converter)),ni=Je.set(r.$gL.ExtHostSpeech,new at.$Aic(Je)),ki=Object.values(r.$gL);Je.assertRegistered(ki);const gn=new s.$Zgc(Je,Fe),Yt=new I.$5gc(Je),fi=new x.$kic(Je,gt),ji=new M.$Zhc(Je);return a.$Xgc.register(Be),function(We,ti,Ui){function ot(be){return(ke,ze,lt)=>{const pt=be(Rt=>{try{ke.call(ze,Rt)}catch(ln){F.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event`,{cause:ln})),It.onExtensionError(We.identifier,ln)}});return lt?.push(pt),pt}}const bt=function(){let be=!We.isUnderDevelopment;function ke(){be||(gt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function ze(lt){if(Array.isArray(lt))lt.forEach(ze);else if(typeof lt=="string")ke();else{const pt=lt;typeof pt.scheme>"u"&&ke(),typeof pt.exclusive=="boolean"&&(0,et.$KF)(We,"documentFiltersExclusive")}return lt}}(),_i={getSession(be,ke,ze){return di.getSession(We,be,ke,ze)},getSessions(be,ke){return(0,et.$KF)(We,"authGetSessions"),di.getSessions(We,be,ke)},async hasSession(be,ke){return(0,et.$KF)(We,"authSession"),!!await di.getSession(We,be,ke,{silent:!0})},get onDidChangeSessions(){return ot(di.onDidChangeSessions)},registerAuthenticationProvider(be,ke,ze,lt){return di.registerAuthenticationProvider(be,ke,ze,lt)}},mn={registerCommand(be,ke,ze){return Be.registerCommand(!0,be,ke,ze,void 0,We)},registerTextEditorCommand(be,ke,ze){return Be.registerCommand(!0,be,(...lt)=>{const pt=Ut.getActiveTextEditor();if(!pt){gt.warn("Cannot execute "+be+" because there is no active text editor.");return}return pt.edit(Rt=>{ke.apply(ze,[pt,Rt,...lt])}).then(Rt=>{Rt||gt.warn("Edits from command "+be+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+be,Rt)})},void 0,void 0,We)},registerDiffInformationCommand:(be,ke,ze)=>((0,et.$KF)(We,"diffCommand"),Be.registerCommand(!0,be,async(...lt)=>{const pt=Fe.activeEditor(!0);if(!pt){gt.warn("Cannot execute "+be+" because there is no active text editor.");return}const Rt=await Ut.getDiffInformation(pt.id);ke.apply(ze,[Rt,...lt])},void 0,void 0,We)),executeCommand(be,...ke){return Be.executeCommand(be,...ke)},getCommands(be=!1){return Be.getCommands(be)}},en={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Yt.value},get shell(){return xe.getDefaultShell(!1)},get onDidChangeShell(){return ot(xe.onDidChangeShell)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(It.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$KF)(We,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$KF)(We,"telemetry"),ot(It.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Le.$DN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,ke){return Le.$CN.validateSender(be),It.instantiateLogger(We,be,ke)},openExternal(be,ke){return Wt.openUri(be,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===$t.environment.appUriScheme)return Ct.createAppUri(be);try{return await Wt.asExternalUri(be,{allowTunneling:!!$t.remote.authority})}catch(ke){if((0,A.$fg)(be,A.Schemas.http)||(0,A.$fg)(be,A.Schemas.https))return be;throw ke}},get remoteName(){return(0,g.$cl)($t.remote.authority)},get remoteAuthority(){return(0,et.$KF)(We,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return ot(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(be){return(0,et.$KF)(We,"handleIssueUri"),yi.registerIssueUriRequestHandler(We,be)},registerIssueDataProvider(be){return(0,et.$KF)(We,"handleIssueUri"),yi.registerIssueDataProvider(We,be)},get appQuality(){return(0,et.$KF)(We,"resolvers"),$t.quality},get appCommit(){return(0,et.$KF)(We,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(en);const tn={createTestController(be,ke,ze){return ai.createTestController(We,be,ke,ze)},createTestObserver(){return(0,et.$KF)(We,"testObserver"),ai.createTestObserver()},runTests(be){return(0,et.$KF)(We,"testObserver"),ai.runTests(be)},get onDidChangeTestResults(){return(0,et.$KF)(We,"testObserver"),ot(ai.onResultsChanged)},get testResults(){return(0,et.$KF)(We,"testObserver"),ai.results}},gi=$t.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,nn={getExtension(be,ke){(0,et.$JF)(We,"extensionsAny")||(ke=!1);const ze=ti.mine.getExtensionDescription(be);if(ze)return new X.$Ohc(Et,We.identifier,ze,gi,!1);if(ke){const lt=ti.all.getExtensionDescription(be);if(lt)return new X.$Ohc(Et,We.identifier,lt,gi,!0)}},get all(){const be=[];for(const ke of ti.mine.getAllExtensionDescriptions())be.push(new X.$Ohc(Et,We.identifier,ke,gi,!1));return be},get allAcrossExtensionHosts(){(0,et.$KF)(We,"extensionsAny");const be=new k.$nm(ti.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ke=[];for(const ze of ti.all.getAllExtensionDescriptions()){const lt=!be.has(ze.identifier);ke.push(new X.$Ohc(Et,We.identifier,ze,gi,lt))}return ke},get onDidChange(){return(0,et.$JF)(We,"extensionsAny")?ot(f.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):ot(ti.mine.onDidChange)}},rn={createDiagnosticCollection(be){return ui.createDiagnosticCollection(We.identifier,be)},get onDidChangeDiagnostics(){return ot(ui.onDidChangeDiagnostics)},getDiagnostics:be=>ui.getDiagnostics(be),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(be,ke){return hi.changeLanguage(be.uri,ke)},match(be,ke){const ze=vt.getDocumentData(ke.uri)?.notebook;return(0,R.$Ct)(nt.LanguageSelector.from(be),ke.uri,ke.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(be,ke,ze){return dt.registerCodeActionProvider(We,bt(be),ke,ze)},registerDocumentPasteEditProvider(be,ke,ze){return(0,et.$KF)(We,"documentPaste"),dt.registerDocumentPasteEditProvider(We,bt(be),ke,ze)},registerCodeLensProvider(be,ke){return dt.registerCodeLensProvider(We,bt(be),ke)},registerDefinitionProvider(be,ke){return dt.registerDefinitionProvider(We,bt(be),ke)},registerDeclarationProvider(be,ke){return dt.registerDeclarationProvider(We,bt(be),ke)},registerImplementationProvider(be,ke){return dt.registerImplementationProvider(We,bt(be),ke)},registerTypeDefinitionProvider(be,ke){return dt.registerTypeDefinitionProvider(We,bt(be),ke)},registerHoverProvider(be,ke){return dt.registerHoverProvider(We,bt(be),ke,We.identifier)},registerEvaluatableExpressionProvider(be,ke){return dt.registerEvaluatableExpressionProvider(We,bt(be),ke,We.identifier)},registerInlineValuesProvider(be,ke){return dt.registerInlineValuesProvider(We,bt(be),ke,We.identifier)},registerDocumentHighlightProvider(be,ke){return dt.registerDocumentHighlightProvider(We,bt(be),ke)},registerMultiDocumentHighlightProvider(be,ke){return dt.registerMultiDocumentHighlightProvider(We,bt(be),ke)},registerLinkedEditingRangeProvider(be,ke){return dt.registerLinkedEditingRangeProvider(We,bt(be),ke)},registerReferenceProvider(be,ke){return dt.registerReferenceProvider(We,bt(be),ke)},registerRenameProvider(be,ke){return dt.registerRenameProvider(We,bt(be),ke)},registerDocumentSymbolProvider(be,ke,ze){return dt.registerDocumentSymbolProvider(We,bt(be),ke,ze)},registerWorkspaceSymbolProvider(be){return dt.registerWorkspaceSymbolProvider(We,be)},registerDocumentFormattingEditProvider(be,ke){return dt.registerDocumentFormattingEditProvider(We,bt(be),ke)},registerDocumentRangeFormattingEditProvider(be,ke){return dt.registerDocumentRangeFormattingEditProvider(We,bt(be),ke)},registerOnTypeFormattingEditProvider(be,ke,ze,...lt){return dt.registerOnTypeFormattingEditProvider(We,bt(be),ke,[ze].concat(lt))},registerDocumentSemanticTokensProvider(be,ke,ze){return dt.registerDocumentSemanticTokensProvider(We,bt(be),ke,ze)},registerDocumentRangeSemanticTokensProvider(be,ke,ze){return dt.registerDocumentRangeSemanticTokensProvider(We,bt(be),ke,ze)},registerSignatureHelpProvider(be,ke,ze,...lt){return typeof ze=="object"?dt.registerSignatureHelpProvider(We,bt(be),ke,ze):dt.registerSignatureHelpProvider(We,bt(be),ke,typeof ze>"u"?[]:[ze,...lt])},registerCompletionItemProvider(be,ke,...ze){return dt.registerCompletionItemProvider(We,bt(be),ke,ze)},registerInlineCompletionItemProvider(be,ke,ze){return ke.handleDidShowCompletionItem&&(0,et.$KF)(We,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,et.$KF)(We,"inlineCompletionsAdditions"),ze&&(0,et.$KF)(We,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(We,bt(be),ke,ze)},registerDocumentLinkProvider(be,ke){return dt.registerDocumentLinkProvider(We,bt(be),ke)},registerColorProvider(be,ke){return dt.registerColorProvider(We,bt(be),ke)},registerFoldingRangeProvider(be,ke){return dt.registerFoldingRangeProvider(We,bt(be),ke)},registerSelectionRangeProvider(be,ke){return dt.registerSelectionRangeProvider(We,be,ke)},registerCallHierarchyProvider(be,ke){return dt.registerCallHierarchyProvider(We,be,ke)},registerTypeHierarchyProvider(be,ke){return dt.registerTypeHierarchyProvider(We,be,ke)},setLanguageConfiguration:(be,ke)=>dt.setLanguageConfiguration(We,be,ke),getTokenInformationAtPosition(be,ke){return(0,et.$KF)(We,"tokenInformation"),hi.tokenAtPosition(be,ke)},registerInlayHintsProvider(be,ke){return dt.registerInlayHintsProvider(We,be,ke)},createLanguageStatusItem(be,ke){return hi.createLanguageStatusItem(We,be,ke)},registerDocumentDropEditProvider(be,ke,ze){return dt.registerDocumentOnDropEditProvider(We,be,ke,(0,et.$JF)(We,"dropMetadata")?ze:void 0)}},sn={get activeTextEditor(){return Ut.getActiveTextEditor()},get visibleTextEditors(){return Ut.getVisibleTextEditors()},get activeTerminal(){return xe.activeTerminal},get terminals(){return xe.terminals},async showTextDocument(be,ke,ze){const lt=await($.URI.isUri(be)?Promise.resolve(on.openTextDocument(be)):Promise.resolve(be));return Ut.showTextDocument(lt,ke,ze)},createTextEditorDecorationType(be){return Ut.createTextEditorDecorationType(We,be)},onDidChangeActiveTextEditor(be,ke,ze){return ot(Ut.onDidChangeActiveTextEditor)(be,ke,ze)},onDidChangeVisibleTextEditors(be,ke,ze){return ot(Ut.onDidChangeVisibleTextEditors)(be,ke,ze)},onDidChangeTextEditorSelection(be,ke,ze){return ot(Ut.onDidChangeTextEditorSelection)(be,ke,ze)},onDidChangeTextEditorOptions(be,ke,ze){return ot(Ut.onDidChangeTextEditorOptions)(be,ke,ze)},onDidChangeTextEditorVisibleRanges(be,ke,ze){return ot(Ut.onDidChangeTextEditorVisibleRanges)(be,ke,ze)},onDidChangeTextEditorViewColumn(be,ke,ze){return ot(Ut.onDidChangeTextEditorViewColumn)(be,ke,ze)},onDidCloseTerminal(be,ke,ze){return ot(xe.onDidCloseTerminal)(be,ke,ze)},onDidOpenTerminal(be,ke,ze){return ot(xe.onDidOpenTerminal)(be,ke,ze)},onDidChangeActiveTerminal(be,ke,ze){return ot(xe.onDidChangeActiveTerminal)(be,ke,ze)},onDidChangeTerminalDimensions(be,ke,ze){return(0,et.$KF)(We,"terminalDimensions"),ot(xe.onDidChangeTerminalDimensions)(be,ke,ze)},onDidChangeTerminalState(be,ke,ze){return ot(xe.onDidChangeTerminalState)(be,ke,ze)},onDidWriteTerminalData(be,ke,ze){return(0,et.$KF)(We,"terminalDataWriteEvent"),ot(xe.onDidWriteTerminalData)(be,ke,ze)},onDidExecuteTerminalCommand(be,ke,ze){return(0,et.$KF)(We,"terminalExecuteCommandEvent"),ot(xe.onDidExecuteTerminalCommand)(be,ke,ze)},get state(){return Wt.getState(We)},onDidChangeWindowState(be,ke,ze){return ot(Wt.onDidChangeWindowState)(be,ke,ze)},showInformationMessage(be,...ke){return fi.showMessage(We,v.default.Info,be,ke[0],ke.slice(1))},showWarningMessage(be,...ke){return fi.showMessage(We,v.default.Warning,be,ke[0],ke.slice(1))},showErrorMessage(be,...ke){return fi.showMessage(We,v.default.Error,be,ke[0],ke.slice(1))},showQuickPick(be,ke,ze){return oi.showQuickPick(We,be,ke,ze)},showWorkspaceFolderPick(be){return oi.showWorkspaceFolderPick(be)},showInputBox(be,ke){return oi.showInput(be,ke)},showOpenDialog(be){return ji.showOpenDialog(We,be)},showSaveDialog(be){return ji.showSaveDialog(be)},createStatusBarItem(be,ke,ze){let lt,pt,Rt;return typeof be=="string"?(lt=be,pt=ke,Rt=ze):(pt=be,Rt=ke),Oi.createStatusBarEntry(We,lt,pt,Rt)},setStatusBarMessage(be,ke){return Oi.setStatusBarMessage(be,ke)},withScmProgress(be){return At.report("window.withScmProgress",We,"Use 'withProgress' instead."),pi.withProgress(We,{location:Oe.ProgressLocation.SourceControl},(ke,ze)=>be({report(lt){}}))},withProgress(be,ke){return pi.withProgress(We,be,ke)},createOutputChannel(be,ke){return Kt.createOutputChannel(be,ke,We)},createWebviewPanel(be,ke,ze,lt){return Ri.createWebviewPanel(We,be,ke,ze,lt)},createWebviewTextEditorInset(be,ke,ze,lt){return(0,et.$KF)(We,"editorInsets"),Ii.createWebviewEditorInset(be,ke,ze,lt,We)},createTerminal(be,ke,ze){return typeof be=="object"?"pty"in be?xe.createExtensionTerminal(be):xe.createTerminalFromOptions(be):xe.createTerminal(be,ke,ze)},registerTerminalLinkProvider(be){return xe.registerLinkProvider(be)},registerTerminalProfileProvider(be,ke){return xe.registerProfileProvider(We,be,ke)},registerTerminalQuickFixProvider(be,ke){return(0,et.$KF)(We,"terminalQuickFixProvider"),xe.registerTerminalQuickFixProvider(be,We.identifier.value,ke)},registerTreeDataProvider(be,ke){return $i.registerTreeDataProvider(be,ke,We)},createTreeView(be,ke){return $i.createTreeView(be,ke,We)},registerWebviewPanelSerializer:(be,ke)=>Ri.registerWebviewPanelSerializer(We,be,ke),registerCustomEditorProvider:(be,ke,ze={})=>un.registerCustomEditorProvider(We,be,ke,ze),registerFileDecorationProvider(be){return ce.registerFileDecorationProvider(be,We)},registerUriHandler(be){return Ct.registerUriHandler(We,be)},createQuickPick(){return oi.createQuickPick(We)},createInputBox(){return oi.createInputBox(We)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(be,ke,ze){return ot(Ai.onDidChangeActiveColorTheme)(be,ke,ze)},registerWebviewViewProvider(be,ke,ze){return Mi.registerWebviewViewProvider(We,be,ke,ze?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,ke,ze){return ot(Pt.onDidChangeActiveNotebookEditor)(be,ke,ze)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(be,ke,ze){return ot(mi.onDidChangeNotebookEditorSelection)(be,ke,ze)},onDidChangeNotebookEditorVisibleRanges(be,ke,ze){return ot(mi.onDidChangeNotebookEditorVisibleRanges)(be,ke,ze)},showNotebookDocument(be,ke){return Pt.showNotebookDocument(be,ke)},registerExternalUriOpener(be,ke,ze){return(0,et.$KF)(We,"externalUriOpener"),hn.registerExternalUriOpener(We.identifier,be,ke,ze)},registerProfileContentHandler(be,ke){return(0,et.$KF)(We,"profileContentHandlers"),dn.registerProfileContentHandler(We,be,ke)},registerQuickDiffProvider(be,ke,ze,lt){return(0,et.$KF)(We,"quickDiffProvider"),Pi.registerQuickDiffProvider(bt(be),ke,ze,lt)},get tabGroups(){return Te.tabGroups},registerShareProvider(be,ke){return(0,et.$KF)(We,"shareProvider"),Qi.registerShareProvider(bt(be),ke)}},on={get rootPath(){return At.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(be){throw new F.$9("rootPath")},getWorkspaceFolder(be){return ft.getWorkspaceFolder(be)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(be){throw new F.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(be){throw new F.$9("workspaceFile")},updateWorkspaceFolders:(be,ke,...ze)=>ft.updateWorkspaceFolders(We,be,ke||0,...ze),onDidChangeWorkspaceFolders:function(be,ke,ze){return ot(ft.onDidChangeWorkspace)(be,ke,ze)},asRelativePath:(be,ke)=>ft.getRelativePath(be,ke),findFiles:(be,ke,ze,lt)=>ft.findFiles(be,ke,ze,We.identifier,lt),findTextInFiles:(be,ke,ze,lt)=>{(0,et.$KF)(We,"findTextInFiles");let pt,Rt;return typeof ke=="object"?(pt=ke,Rt=ze):(pt={},Rt=ke,lt=ze),ft.findTextInFiles(be,pt||{},Rt,We.identifier,lt)},save:be=>ft.save(be),saveAs:be=>ft.saveAs(be),saveAll:be=>ft.saveAll(be),applyEdit(be,ke){return gn.applyWorkspaceEdit(be,We,ke)},createFileSystemWatcher:(be,ke,ze,lt)=>{let pt;return typeof ke=="boolean"?pt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!lt,correlate:!1}:ke&&((0,et.$KF)(We,"createFileSystemWatcher"),pt={...ke,correlate:!0}),ei.createFileSystemWatcher(ft,We,be,pt)},get textDocuments(){return vt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw new F.$9("textDocuments")},openTextDocument(be){let ke;const ze=be;if(typeof be=="string")ke=Promise.resolve($.URI.file(be));else if($.URI.isUri(be))ke=Promise.resolve(be);else if(!ze||typeof ze=="object")ke=vt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(lt=>vt.ensureDocumentData(lt).then(pt=>pt.document))},onDidOpenTextDocument:(be,ke,ze)=>ot(vt.onDidAddDocument)(be,ke,ze),onDidCloseTextDocument:(be,ke,ze)=>ot(vt.onDidRemoveDocument)(be,ke,ze),onDidChangeTextDocument:(be,ke,ze)=>ot(vt.onDidChangeDocument)(be,ke,ze),onDidSaveTextDocument:(be,ke,ze)=>ot(vt.onDidSaveDocument)(be,ke,ze),onWillSaveTextDocument:(be,ke,ze)=>ot(Ki.getOnWillSaveTextDocumentEvent(We))(be,ke,ze),get notebookDocuments(){return Pt.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,ke){let ze;if($.URI.isUri(be))ze=be,await Pt.openNotebookDocument(be);else if(typeof be=="string")ze=$.URI.revive(await Pt.createNotebookDocument({viewType:be,content:ke}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(be,ke,ze){return ot(si.onDidSaveNotebookDocument)(be,ke,ze)},onDidChangeNotebookDocument(be,ke,ze){return ot(si.onDidChangeNotebookDocument)(be,ke,ze)},onWillSaveNotebookDocument(be,ke,ze){return ot(Ci.getOnWillSaveNotebookDocumentEvent(We))(be,ke,ze)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer(be,ke,ze,lt){return Pt.registerNotebookSerializer(We,be,ke,ze,(0,et.$JF)(We,"notebookLiveShare")?lt:void 0)},onDidChangeConfiguration:(be,ke,ze)=>ot(Ui.onDidChangeConfiguration)(be,ke,ze),getConfiguration(be,ke){return ke=arguments.length===1?void 0:ke,Ui.getConfiguration(be,ke,We)},registerTextDocumentContentProvider(be,ke){return Si.registerTextDocumentContentProvider(be,ke)},registerTaskProvider:(be,ke)=>(At.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(We,be,ke)),registerFileSystemProvider(be,ke,ze){return(0,P.$Qc)(Ji.registerFileSystemProvider(We,be,ke,ze),Qt.addFileSystemProvider(be,ke,ze))},get fs(){return Qt.value},registerFileSearchProvider:(be,ke)=>((0,et.$KF)(We,"fileSearchProvider"),ct.registerFileSearchProvider(be,ke)),registerTextSearchProvider:(be,ke)=>((0,et.$KF)(We,"textSearchProvider"),ct.registerTextSearchProvider(be,ke)),registerRemoteAuthorityResolver:(be,ke)=>((0,et.$KF)(We,"resolvers"),Et.registerRemoteAuthorityResolver(be,ke)),registerResourceLabelFormatter:be=>((0,et.$KF)(We,"resolvers"),Zi.$registerResourceLabelFormatter(be)),getRemoteExecServer:be=>((0,et.$KF)(We,"resolvers"),Et.getRemoteExecServer(be)),onDidCreateFiles:(be,ke,ze)=>ot(ei.onDidCreateFile)(be,ke,ze),onDidDeleteFiles:(be,ke,ze)=>ot(ei.onDidDeleteFile)(be,ke,ze),onDidRenameFiles:(be,ke,ze)=>ot(ei.onDidRenameFile)(be,ke,ze),onWillCreateFiles:(be,ke,ze)=>ot(ei.getOnWillCreateFileEvent(We))(be,ke,ze),onWillDeleteFiles:(be,ke,ze)=>ot(ei.getOnWillDeleteFileEvent(We))(be,ke,ze),onWillRenameFiles:(be,ke,ze)=>ot(ei.getOnWillRenameFileEvent(We))(be,ke,ze),openTunnel:be=>((0,et.$KF)(We,"tunnels"),Nt.openTunnel(We,be).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,et.$KF)(We,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(be,ke,ze)=>((0,et.$KF)(We,"tunnels"),ot(Nt.onDidChangeTunnels)(be,ke,ze)),registerPortAttributesProvider:(be,ke)=>((0,et.$KF)(We,"portsAttributes"),Nt.registerPortsAttributesProvider(be,ke)),registerTunnelProvider:(be,ke)=>((0,et.$KF)(We,"tunnelFactory"),Nt.registerTunnelProvider(be,ke)),registerTimelineProvider:(be,ke)=>((0,et.$KF)(We,"timeline"),Xi.registerTimelineProvider(be,ke,We.identifier,Be.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:be=>((0,et.$KF)(We,"workspaceTrust"),ft.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,ke,ze)=>ot(ft.onDidGrantWorkspaceTrust)(be,ke,ze),registerEditSessionIdentityProvider:(be,ke)=>((0,et.$KF)(We,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(be,ke)),onWillCreateEditSessionIdentity:(be,ke,ze)=>((0,et.$KF)(We,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(We))(be,ke,ze)),registerCanonicalUriProvider:(be,ke)=>((0,et.$KF)(We,"canonicalUriProvider"),ft.registerCanonicalUriProvider(be,ke)),getCanonicalUri:(be,ke,ze)=>((0,et.$KF)(We,"canonicalUriProvider"),ft.provideCanonicalUri(be,ke,ze))},$n={get inputBox(){return At.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(We)},createSourceControl(be,ke,ze){return bi.createSourceControl(We,be,ke,ze)}},an={createCommentController(be,ke){return Li.createCommentController(We,be,ke)}},cn={get activeDebugSession(){return Ke.activeDebugSession},get activeDebugConsole(){return Ke.activeDebugConsole},get breakpoints(){return Ke.breakpoints},get stackFrameFocus(){return Ke.stackFrameFocus},registerDebugVisualizationProvider(be,ke){return(0,et.$KF)(We,"debugVisualization"),Ke.registerDebugVisualizationProvider(We,be,ke)},onDidStartDebugSession(be,ke,ze){return ot(Ke.onDidStartDebugSession)(be,ke,ze)},onDidTerminateDebugSession(be,ke,ze){return ot(Ke.onDidTerminateDebugSession)(be,ke,ze)},onDidChangeActiveDebugSession(be,ke,ze){return ot(Ke.onDidChangeActiveDebugSession)(be,ke,ze)},onDidReceiveDebugSessionCustomEvent(be,ke,ze){return ot(Ke.onDidReceiveDebugSessionCustomEvent)(be,ke,ze)},onDidChangeBreakpoints(be,ke,ze){return ot(Ke.onDidChangeBreakpoints)(be,ke,ze)},onDidChangeStackFrameFocus(be,ke,ze){return(0,et.$KF)(We,"debugFocus"),ot(Ke.onDidChangeStackFrameFocus)(be,ke,ze)},registerDebugConfigurationProvider(be,ke,ze){return Ke.registerDebugConfigurationProvider(be,ke,ze||qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,ke){return Ke.registerDebugAdapterDescriptorFactory(We,be,ke)},registerDebugAdapterTrackerFactory(be,ke){return Ke.registerDebugAdapterTrackerFactory(be,ke)},startDebugging(be,ke,ze){return!ze||typeof ze=="object"&&"configuration"in ze?Ke.startDebugging(be,ke,{parentSession:ze}):Ke.startDebugging(be,ke,ze||{})},stopDebugging(be){return Ke.stopDebugging(be)},addBreakpoints(be){return Ke.addBreakpoints(be)},removeBreakpoints(be){return Ke.removeBreakpoints(be)},asDebugSourceUri(be,ke){return Ke.asDebugSourceUri(be,ke)}},zi={registerTaskProvider:(be,ke)=>wt.registerTaskProvider(We,be,ke),fetchTasks:be=>wt.fetchTasks(be),executeTask:be=>wt.executeTask(We,be),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(be,ke,ze)=>ot(wt.onDidStartTask)(be,ke,ze),onDidEndTask:(be,ke,ze)=>ot(wt.onDidEndTask)(be,ke,ze),onDidStartTaskProcess:(be,ke,ze)=>ot(wt.onDidStartTaskProcess)(be,ke,ze),onDidEndTaskProcess:(be,ke,ze)=>ot(wt.onDidEndTaskProcess)(be,ke,ze)},Bi={createNotebookController(be,ke,ze,lt,pt){return li.createNotebookController(We,be,ke,ze,lt,(0,et.$JF)(We,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(be,ke)=>Pt.registerNotebookCellStatusBarItemProvider(We,be,ke),createRendererMessaging(be){return Di.createRendererMessaging(We,be)},createNotebookControllerDetectionTask(be){return(0,et.$KF)(We,"notebookKernelSource"),li.createNotebookControllerDetectionTask(We,be)},registerKernelSourceActionProvider(be,ke){return(0,et.$KF)(We,"notebookKernelSource"),li.registerKernelSourceActionProvider(We,be,ke)},onDidChangeNotebookCellExecutionState(be,ke,ze){return(0,et.$KF)(We,"notebookCellExecutionState"),ot(li.onDidChangeNotebookCellExecutionState)(be,ke,ze)}},Wi={t(...be){if(typeof be[0]=="string"){const ke=be.shift(),ze=!be||typeof be[0]!="object"?be:be[0];return St.getMessage(We.identifier.value,{message:ke,args:ze})}return St.getMessage(We.identifier.value,be[0])},get bundle(){return St.getBundle(We.identifier.value)},get uri(){return St.getBundleUri(We.identifier.value)}},Ei={_version:1,registerInteractiveEditorSessionProvider(be,ke){return(0,et.$KF)(We,"interactive"),Yi.registerProvider(We,be,ke)},registerInteractiveSessionProvider(be,ke){return(0,et.$KF)(We,"interactive"),wi.registerChatProvider(We,be,ke)},sendInteractiveRequestToProvider(be,ke){return(0,et.$KF)(We,"interactive"),wi.sendInteractiveRequestToProvider(be,ke)},transferChatSession(be,ke){return(0,et.$KF)(We,"interactive"),wi.transferChatSession(be,ke)}},qi={getRelatedInformation(be,ke){return(0,et.$KF)(We,"aiRelatedInformation"),Ti.getRelatedInformation(We,be,ke)},registerRelatedInformationProvider(be,ke){return(0,et.$KF)(We,"aiRelatedInformation"),Ti.registerRelatedInformationProvider(We,be,ke)},registerEmbeddingVectorProvider(be,ke){return(0,et.$KF)(We,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(We,be,ke)}},Vi={registerChatResponseProvider(be,ke,ze){return(0,et.$KF)(We,"chatProvider"),Ni.registerProvider(We.identifier,be,ke,ze)},requestChatAccess(be){return(0,et.$KF)(We,"chatRequestAccess"),Ni.requestChatResponseProvider(We.identifier,be)},registerVariable(be,ke,ze){return(0,et.$KF)(We,"chatAgents2"),xi.registerVariableResolver(We,be,ke,ze)},registerMappedEditsProvider(be,ke){return(0,et.$KF)(We,"mappedEditsProvider"),dt.registerMappedEditsProvider(We,be,ke)},createChatAgent(be,ke){return(0,et.$KF)(We,"chatAgents2"),Fi.createChatAgent(We,be,ke)}},bn={registerSpeechProvider(be,ke){return(0,et.$KF)(We,"speech"),ni.registerProvider(We.identifier,be,ke)}};return{version:$t.version,ai:qi,authentication:_i,commands:mn,comments:an,chat:Vi,debug:cn,env:en,extensions:nn,interactive:Ei,l10n:Wi,languages:rn,notebooks:Bi,scm:$n,speech:bn,tasks:zi,tests:tn,window:sn,workspace:on,Breakpoint:Oe.$gM,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$_M,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$$M,CallHierarchyIncomingCall:Oe.$FL,CallHierarchyItem:Oe.$EL,CallHierarchyOutgoingCall:Oe.$GL,CancellationError:F.$5,CancellationTokenSource:C.$7d,CandidatePortSource:r.CandidatePortSource,CodeAction:Oe.$BL,CodeActionKind:Oe.$CL,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$HL,Color:Oe.$UL,ColorInformation:Oe.$VL,ColorPresentation:Oe.$WL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$OL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$PL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$5L,DebugAdapterExecutable:Oe.$kM,DebugAdapterInlineImplementation:Oe.$nM,DebugAdapterNamedPipeServer:Oe.$mM,DebugAdapterServer:Oe.$lM,DebugConfigurationProviderTriggerKind:qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DebugVisualization:Oe.$CM,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$vL,DiagnosticRelatedInformation:Oe.$uL,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$hL,DocumentHighlight:Oe.$xL,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$yL,DocumentLink:Oe.$TL,DocumentSymbol:Oe.$AL,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$qM,InlineValueText:Oe.$rM,InlineValueVariableLookup:Oe.$sM,InlineValueEvaluatableExpression:Oe.$tM,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:f.$Wd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$EM,FileDecoration2:Oe.$EM,FileSystemError:Oe.$vM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Oe.$wM,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$iM,InlineCompletionItem:Oe.$QL,InlineCompletionList:Oe.$RL,Hover:Oe.$wL,IndentAction:D.IndentAction,Location:Oe.$tL,MarkdownString:Oe.$IL,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Oe.$JL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$iL,ProcessExecution:Oe.$3L,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$DM,Range:Oe.$jL,RelativePattern:Oe.$eM,Selection:Oe.$kL,SelectionRange:Oe.$DL,SemanticTokens:Oe.$zM,SemanticTokensBuilder:Oe.$yM,SemanticTokensEdit:Oe.$AM,SemanticTokensEdits:Oe.$BM,SemanticTokensLegend:Oe.$xM,ShellExecution:Oe.$4L,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$LL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$KL,SnippetString:Oe.$sL,SourceBreakpoint:Oe.$hM,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$zL,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$6L,TaskGroup:Oe.$2L,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$XL,TerminalQuickFixTerminalCommand:Oe.$ZL,TerminalQuickFixOpener:Oe.$YL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$1L,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$oL,SnippetTextEdit:Oe.$qL,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$dM,ThemeIcon:Oe.$cM,TreeItem:Oe.$7L,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$ZM,UIKind:zt.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$rL,DocumentDropEdit:Oe.$aM,DocumentPasteEdit:Oe.$bM,InlayHint:Oe.$NL,InlayHintLabelPart:Oe.$ML,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$nL,ResolvedAuthority:Oe.$lL,ManagedResolvedAuthority:Oe.$mL,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$OM,NotebookRange:Oe.$GM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$HM,NotebookData:Oe.$IM,NotebookRendererScript:Oe.$MM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$KM,NotebookCellOutputItem:Oe.$JM,NotebookCellStatusBarItem:Oe.$LM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$pL,NotebookKernelSourceAction:Oe.$NM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$QM,LinkedEditingRanges:Oe.$PM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$RM,TestMessage:Oe.$SM,TestMessage2:Oe.$SM,TestTag:Oe.$TM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$_L,DataTransferItem:Oe.$8L,CoveredCount:Oe.$UM,FileCoverage:Oe.$VM,StatementCoverage:Oe.$WM,BranchCoverage:Oe.$XM,FunctionCoverage:Oe.$YM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$1M,TabInputTextDiff:Oe.$2M,TabInputTextMerge:Oe.$3M,TabInputCustom:Oe.$4M,TabInputNotebook:Oe.$6M,TabInputNotebookDiff:Oe.$7M,TabInputWebview:Oe.$5M,TabInputTerminal:Oe.$8M,TabInputInteractiveWindow:Oe.$9M,TabInputChat:Oe.$0M,TelemetryTrustedValue:o.$Mo,LogLevel:c.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$oM,ThreadFocus:Oe.$pM,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus,KeywordRecognitionStatus:Oe.KeywordRecognitionStatus}}}e.$Tic=Jt}),define(Ee[371],Se([1,0,84,152,41,147,42,33,72,46,96,97,98,117,70,92,146,69,59,116,91,71,145,13,60,114,115]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a,t,h,s,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Zr)(d.$Ihc,d.$Hhc,1),(0,C.$Zr)(h.$pj,t.$Uic,1),(0,C.$Zr)(c.$Tgc,c.$Ugc,1),(0,C.$Zr)(v.$GN,v.$FN,0),(0,C.$Zr)(A.$chc,A.$ahc,0),(0,C.$Zr)(o.$ehc,o.$dhc,0),(0,C.$Zr)(D.$Shc,D.$Whc,0),(0,C.$Zr)(P.$Yhc,P.$Xhc,0),(0,C.$Zr)($.$vN,$.$uN,0),(0,C.$Zr)(l.$Jhc,l.$Khc,0),(0,C.$Zr)(i.$Qgc,i.$Pgc,0),(0,C.$Zr)(F.$sic,F.$ric,1),(0,C.$Zr)(p.$cic,p.$dic,0),(0,C.$Zr)(k.$xhc,k.$whc,0),(0,C.$Zr)(R.$Fic,R.$Eic,0),(0,C.$Zr)(E.$Ahc,E.$Dhc,0),(0,C.$Zr)(S.$0yb,S.$$yb,0),(0,C.$Zr)(g.$Sic,g.$Ric,0),(0,C.$Zr)(f.$_gc,f.$$gc,0),(0,C.$Zr)(r.$Fhc,r.$Ehc,0),(0,C.$Zr)(n.$EN,n.$BN,0),(0,C.$Zr)(a.$ohc,a.$phc,0),(0,C.$Zr)(s.$Qhc,s.$Rhc,0)}),define(Ee[119],Se([1,0,19,13,36,95]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=e.$_ic=e.$$ic=void 0;function A(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.$$ic=A;function v(D,p,k,S){const c=(0,C.$2b)(k,$),g=new f.$GJ(p,c,S),o=g.preview.matches;return{ranges:(0,C.$2b)(c,E),uri:D,preview:{text:g.preview.text,matches:(0,C.$2b)(o,E)}}}e.$_ic=v;function $(D){return new f.$HJ(D.start.line,D.start.character,D.end.line,D.end.character)}function E(D){return new P.$vJ(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let R=class{constructor(p,k){this.a=p,this.b=k}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$ajc=R,e.$ajc=R=Ge([qe(1,F.$oj)],R)}),define(Ee[372],Se([1,0,50,17,76,34,10,12,119,373]),function(ge,e,C,F,f,P,A,v,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=e.$cjc=e.$bjc=void 0;const R=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(r,n,a,t){const h=p(r,n,a,t),s=n.folder.fsPath;return{cmd:C.spawn(R,h.args,{cwd:s}),rgDiskPath:R,siblingClauses:h.siblingClauses,rgArgs:h,cwd:s}}e.$bjc=D;function p(r,n,a,t){const h=["--files","--hidden","--case-sensitive","--no-require-git"];S([n],a,!1).forEach(d=>{const l=(0,$.$$ic)(d);if(h.push("-g",l),A.$j){const u=(0,f.$Il)(l);u!==l&&h.push("-g",u)}});const s=k([n],t,void 0,!1);return s.globArgs.forEach(d=>{const l=`!${(0,$.$$ic)(d)}`;if(h.push("-g",l),A.$j){const u=(0,f.$Il)(l);u!==l&&h.push("-g",u)}}),n.disregardIgnoreFiles!==!1?h.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),n.ignoreSymlinks||h.push("--follow"),r.exists&&h.push("--quiet"),h.push("--no-config"),n.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:s.siblingClauses}}function k(r,n,a,t=!0){const h=[];let s={};return r.forEach(d=>{const l=Object.assign({},d.excludePattern||{},n||{}),u=c(l,t?d.folder.fsPath:void 0,a);h.push(...u.globArgs),u.siblingClauses&&(s=Object.assign(s,u.siblingClauses))}),{globArgs:h,siblingClauses:s}}function S(r,n,a=!0){const t=[];return r.forEach(h=>{const s=Object.assign({},n||{},h.includePattern||{}),d=c(s,a?h.folder.fsPath:void 0);t.push(...d.globArgs)}),t}function c(r,n,a){const t=[],h={};return Object.keys(r).forEach(s=>{if(a&&a.has(s)||!s)return;const d=r[s];s=o(n?g(n,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof d=="boolean"&&d?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):d&&d.when&&(h[s]=d)}),{globArgs:t,siblingClauses:h}}function g(r,n){return F.$ic(n)?n:F.$jc(r,n)}e.$cjc=g;function o(r){return r=v.$Ve(r,"\\"),v.$Ve(r,"/")}function i(r){return P.$5f(r).toLowerCase()==="c:/"?r.replace(/^c:[/\\]/i,"/"):r}e.$djc=i}),define(Ee[374],Se([1,0,50,57,17,375,19,44,35,76,34,10,38,12,18,31,36,372,129]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=e.$ejc=void 0;const r=new Set;process.on("exit",()=>{r.forEach(s=>s())});class n{constructor(d){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=d,this.b=d.filePattern||"",this.d=d.includePattern&&$.$Nj(d.includePattern),this.f=d.maxResults||null,this.g=!!d.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$1q)(this.b).normalizedLowercase),this.u=d.excludePattern&&$.$Nj(d.excludePattern),this.t=new Map,d.folderQueries.forEach(l=>{const u=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),w=l.folder.fsPath;d.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==w).forEach(I=>{(0,R.$9f)(I,w)&&(u[f.$lc(w,I)]=!0)}),this.t.set(w,new t(u,w))})}cancel(){this.l=!0,r.forEach(d=>d())}walk(d,l,u,w,I){if(this.m=p.$Sd.create(!1),this.l)return I(null,this.j);l.forEach(b=>{const m=f.$nc(b.fsPath);this.u&&this.u(b.fsPath,m)||this.J(u,{relativePath:b.fsPath,searchPath:void 0})}),this.r=p.$Sd.create(!1),this.w(d,(b,m)=>{this.x(this.y,this,b,u,w,y=>{if(y){const L=(0,v.$Ri)(y);console.error(L),this.q.push(L),m(y,void 0)}else m(null,void 0)})},(b,m)=>{this.m.stop();const y=b?A.$Hb(b)[0]:null;I(y,this.j)})}w(d,l,u){const w=new Array(d.length),I=new Array(d.length);let b=!1,m=0;if(d.length===0)return u(null,[]);d.forEach((y,L)=>{l(y,(N,U)=>{if(N?(b=!0,w[L]=null,I[L]=N):(w[L]=U,I[L]=null),++m===d.length)return u(b?I:null,w)})})}x(d,l,...u){try{d.apply(l,u)}catch(w){u[u.length-1](w)}}y(d,l,u,w){const I=d.folder.fsPath,b=D.$j,m=()=>T&&T.kill();r.add(m);let y=z=>{r.delete(m),y=()=>{},w(z)},L="";const N=this.D(),U=(0,o.$bjc)(this.a,d,this.a.includePattern,this.t.get(d.folder.fsPath).expression),T=U.cmd,O=!Object.keys(U.siblingClauses).length,M=U.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let j=`${U.rgDiskPath} ${M}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),u({message:j}),this.s=0,this.z(T,"utf8",u,(z,J,le)=>{if(z){y(z);return}if(this.j){y();return}const Q=(L+(b?E.$Hl(J||""):J)).split(`
`);if(le){const X=Q.length;Q[X-1]=Q[X-1].trim(),Q[X-1]||Q.pop()}else L=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Q.length,O){for(const X of Q)if(this.J(l,{base:I,relativePath:X,searchPath:this.N(d,X)}),this.j){m();break}(le||this.j)&&y();return}this.G(d,N,I,Q,l),le&&(this.H(N,I,l),y())})}spawnFindCmd(d){const l=this.t.get(d.folder.fsPath),u=l.getBasenameTerms(),w=l.getPathTerms(),I=["-L","."];if(u.length||w.length){I.push("-not","(","(");for(const b of u)I.push("-name",b),I.push("-o");for(const b of w)I.push("-path",b),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),C.spawn("find",I,{cwd:d.folder.fsPath})}readStdout(d,l,u){let w="";this.z(d,l,()=>{},(I,b,m)=>{if(I){u(I);return}w+=b,m&&u(null,w)})}z(d,l,u,w){let I=(y,L,N)=>{(y||N)&&(I=()=>{},this.r?.stop()),w(y,L,N)},b=!1;d.stdout?(this.A(d.stdout,l,I),d.stdout.once("data",()=>b=!0)):u({message:"stdout is null"});let m;d.stderr?m=this.B(d.stderr):u({message:"stderr is null"}),d.on("error",y=>{I(y)}),d.on("close",y=>{let L;!b&&(L=this.C(m,l))&&h(L)?I(new Error(`command failed with error code ${y}: ${this.C(m,l)}`)):(this.g&&y===0&&(this.j=!0),I(null,"",!0))})}A(d,l,u){const w=new P.StringDecoder(l);return d.on("data",I=>{u(null,w.write(I))}),w}B(d){const l=[];return d.on("data",u=>{l.push(u)}),l}C(d,l){const u=new P.StringDecoder(l);return d.map(w=>u.write(w)).join("")}D(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}G(d,{pathToEntries:l},u,w,I){w.indexOf(this.b)!==-1&&this.J(I,{base:u,relativePath:this.b,searchPath:this.N(d,this.b)});const b=m=>{const y=f.$nc(m),L=f.$mc(m);let N=l[L];N||(N=l[L]=[],b(L)),N.push({base:u,relativePath:m,basename:y,searchPath:this.N(d,m)})};w.forEach(b)}H({rootEntries:d,pathToEntries:l},u,w){const I=this,b=this.t.get(u),m=this.b;function y(L){I.o++;const N=(0,g.$WJ)(()=>L.map(U=>U.basename));for(let U=0,T=L.length;U<T;U++){const O=L[U],{relativePath:M,basename:j}=O;if(b.test(M,j,m!==j?N:void 0))continue;const z=l[M];if(z)y(z);else{if(I.p++,M===m)continue;I.J(w,O)}if(I.j)break}}y(d)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(d,l,u,w,I){const b=d.folder,m=(0,g.$WJ)(()=>u);this.w(u,(y,L)=>{if(this.l||this.j)return L(null);const N=l?[l,y].join(f.sep):y;if(this.t.get(d.folder.fsPath).test(N,y,this.a.filePattern!==y?m:void 0))return L(null);const U=[b.fsPath,N].join(f.sep);F.lstat(U,(T,O)=>{if(T||this.l||this.j)return L(null);this.L(U,O,(M,j)=>M||this.l||this.j?L(null):j.isDirectory()?(this.o++,this.M(U,O,(z,J)=>z||this.l||this.j||(J=J||"",this.v[J])?L(null):(this.v[J]=!0,c.Promises.readdir(U).then(le=>{if(this.l||this.j)return L(null);this.I(d,N,le,w,Y=>L(Y||null))},le=>{L(null)})))):(this.p++,N===this.b||this.h&&S.$Nf(j.size)&&j.size>this.h||this.J(w,{base:b.fsPath,relativePath:N,searchPath:this.N(d,N)}),L(null,void 0)))})},y=>{const L=y&&A.$Hb(y);return I(L&&L.length>0?L[0]:void 0)})}J(d,l){this.K(l)&&(!this.d||this.d(l.relativePath,f.$nc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||d(l))}K(d){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$RJ)(d,this.c)}return!0}L(d,l,u){return l.isSymbolicLink()?F.stat(d,u):u(null,l)}M(d,l,u){return l.isSymbolicLink()?F.realpath(d,(w,I)=>w?u(w):u(null,I)):u(null,d)}N(d,l){return d.folderName?f.$jc(d.folderName,l):l}}e.$ejc=n;class a{constructor(d){this.a=d.folderQueries,this.b=d.extraFileResources||[],this.c=new n(d)}search(d,l,u){this.c.walk(this.a,this.b,d,l,(w,I)=>{u(w,{limitHit:I,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$fjc=a;class t{constructor(d,l){this.expression=d,this.c=l,this.d(d)}d(d){let l,u;Object.keys(d).filter(w=>d[w]).forEach(w=>{f.$ic(w)?(l=l||$.$Ij(),l[w]=d[w]):(u=u||$.$Ij(),u[w]=d[w])}),this.a=l&&$.$Nj(l,{trimForExclusions:!0}),this.b=u&&$.$Nj(u,{trimForExclusions:!0})}test(d,l,u){return this.b&&this.b(d,l,u)||this.a&&this.a(f.$jc(this.c,d),l,u)}getBasenameTerms(){const d=[];return this.a&&d.push(...$.$Pj(this.a)),this.b&&d.push(...$.$Pj(this.b)),d}getPathTerms(){const d=[];return this.a&&d.push(...$.$Qj(this.a)),this.b&&d.push(...$.$Qj(this.b)),d}}function h(s){const d=s.trim().split(`
`),l=d[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return k.$Bf(d[d.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(Ee[376],Se([1,0,99,22,186,21]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=e.DecodeStreamErrorKind=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=void 0,e.$jD="utf8",e.$kD="utf8bom",e.$lD="utf16be",e.$mD="utf16le";function A(l){return[e.$jD,e.$kD,e.$lD,e.$mD].some(u=>u===l)}e.$nD=A,e.$oD=[254,255],e.$pD=[255,254],e.$qD=[239,187,191];const v=512,$=512,E=512*8,R=512*128;var D;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D||(e.DecodeStreamErrorKind=D={}));class p extends Error{constructor(u,w){super(u),this.decodeStreamErrorKind=w}}e.$rD=p;class k{static async create(u){let w;if(u!==e.$jD)w=(await(0,f.$iD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(u));else{const I=new TextDecoder;w={write(b){return I.decode(b,{stream:!0})},end(){return I.decode()}}}return new k(w)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function S(l,u){const w=u.minBytesRequiredForDetection??u.guessEncoding?E:$;return new Promise((I,b)=>{const m=(0,C.$$d)(O=>O.join("")),y=[];let L=0,N;const U=new P.$7d,T=async()=>{try{const O=await d({buffer:F.$ke.concat(y),bytesRead:L},u.guessEncoding);if(O.seemsBinary&&u.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);O.encoding=await u.overwriteEncoding(O.encoding),N=await k.create(O.encoding);const M=N.write(F.$ke.concat(y).buffer);m.write(M),y.length=0,L=0,I({stream:m,detected:O})}catch(O){U.cancel(),m.destroy(),b(O)}};(0,C.$ce)(l,{onData:async O=>{N?m.write(N.write(O.buffer)):(y.push(O),L+=O.byteLength,L>=w&&(l.pause(),await T(),setTimeout(()=>l.resume())))},onError:O=>m.error(O),onEnd:async()=>{N||await T(),m.end(N?.end())}},U.token)})}e.$sD=S;async function c(l,u,w){const b=(await(0,f.$iD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(u),w);let m=!1,y=!1;return{read(){if(y)return null;const L=l.read();if(typeof L!="string"){if(y=!0,!m&&w?.addBOM)switch(u){case e.$jD:case e.$kD:return F.$ke.wrap(Uint8Array.from(e.$qD));case e.$lD:return F.$ke.wrap(Uint8Array.from(e.$oD));case e.$mD:return F.$ke.wrap(Uint8Array.from(e.$pD))}const N=b.end();return N&&N.length>0?(m=!0,F.$ke.wrap(N)):null}return m=!0,F.$ke.wrap(b.write(L))}}}e.$tD=c;async function g(l){return(await(0,f.$iD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(l))}e.$uD=g;function o(l){return l===e.$kD||l===null?e.$jD:l}e.$vD=o;function i(l,u){if(!l||u<e.$oD.length)return null;const w=l.readUInt8(0),I=l.readUInt8(1);if(w===e.$oD[0]&&I===e.$oD[1])return e.$lD;if(w===e.$pD[0]&&I===e.$pD[1])return e.$mD;if(u<e.$qD.length)return null;const b=l.readUInt8(2);return w===e.$qD[0]&&I===e.$qD[1]&&b===e.$qD[2]?e.$kD:null}e.$wD=i;const r=["ascii","utf-16","utf-32"];async function n(l){const u=await(0,f.$iD)("jschardet","dist/jschardet.min.js"),w=l.slice(0,R),I=h(w.buffer),b=u.detect(I);if(!b||!b.encoding)return null;const m=b.encoding.toLowerCase();return 0<=r.indexOf(m)?null:t(b.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(l){const u=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[u]||u}function h(l){let u="";for(let w=0;w<l.length;w++)u+=String.fromCharCode(l[w]);return u}function s(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=l.match(/windows(\d+)/);return u?"windows-"+u[1]:l}}}e.$xD=s;function d({buffer:l,bytesRead:u},w){let I=i(l,u),b=!1;if(I!==e.$lD&&I!==e.$mD&&l){let m=!0,y=!0,L=!1;for(let N=0;N<u&&N<v;N++){const U=N%2===1,T=l.readUInt8(N)===0;if(T&&(L=!0),m&&(U&&!T||!U&&T)&&(m=!1),y&&(U&&T||!U&&!T)&&(y=!1),T&&!m&&!y)break}L&&(m?I=e.$mD:y?I=e.$lD:b=!0)}return w&&!b&&!I&&l?n(l.slice(0,u)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:b,encoding:I}}e.$yD=d,e.$zD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ee[155],Se([1,0,376,31,154]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;class P extends f.$$hc{constructor(v,$,E=F,R="searchProcess"){super(v,$,{readdir:D=>E.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,C.$xD)(D)},R)}}e.$njc=P}),define(Ee[156],Se([1,0,50,392,375,19,73,35,12,2,36,95,393,373,119]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=e.$ljc=e.$kjc=e.$jjc=e.$ijc=e.$hjc=e.$gjc=void 0;const c=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(m){this.a=m}provideTextSearchResults(m,y,L,N){return this.a.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((U,T)=>{N.onCancellationRequested(()=>Q());const O=t(m,y),M=y.folder.fsPath,j=O.map(oe=>oe.match(/^-/)?oe:`'${oe}'`).join(" ");this.a.appendLine(`${c} ${j}
 - cwd: ${M}`);let z=C.spawn(c,O,{cwd:M});z.on("error",oe=>{console.error(oe),this.a.appendLine("Error: "+(oe&&oe.message)),T((0,R.$NJ)(new R.$LJ(oe&&oe.message,R.SearchErrorCode.rgProcessError)))});let J=!1;const le=new r(y.maxResults,y.folder,y.previewOptions);le.on("result",oe=>{J=!0,ue="",L.report(oe)});let Y=!1;const Q=()=>{Y=!0,z?.kill(),le?.cancel()};let X=!1;le.on("hitLimit",()=>{X=!0,Q()});let ue="";z.stdout.on("data",oe=>{le.handleData(oe),J||(ue+=oe)});let ne=!1;z.stdout.once("data",()=>ne=!0);let $e="";z.stderr.on("data",oe=>{const K=oe.toString();this.a.appendLine(K),$e.length+K.length<1e6&&($e+=K)}),z.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(J?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),Y)U({limitHit:X});else{le.flush(),z=null;let oe;$e&&!ne&&(oe=o($e))?T((0,R.$NJ)(new R.$LJ(oe.message,oe.code))):U({limitHit:X})}})})}}e.$gjc=g;function o(b){const m=b.split(`
`),y=m[0].trim();if(m.some(N=>N.startsWith("regex parse error")))return new R.$LJ(i(m),R.SearchErrorCode.regexParseError);const L=y.match(/grep config error: unknown encoding: (.*)/);if(L)return new R.$LJ(`Unknown encoding: ${L[1]}`,R.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new R.$LJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new R.$LJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new R.$LJ(y,R.SearchErrorCode.regexParseError)}function i(b){const m=["Regex parse error"],y=b.filter(L=>L.startsWith("PCRE2:"));if(y.length>=1){const L=y[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const N=L.split(":")[1];m.push(":"+N)}}return m.join("")}class r extends F.EventEmitter{constructor(m,y,L){super(),this.g=m,this.h=y,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(m,y){return super.on(m,y),this}handleData(m){if(this.b)return;const y=typeof m=="string"?m:this.d.write(m);this.k(y)}k(m){let y=m.indexOf(`
`);const L=this.a+m;if(y>=0)y+=this.a.length;else{this.a=L;return}let N=0;for(;y>=0;)this.m(L.substring(N,y).trim()),N=y+1,y=L.indexOf(`
`,N);this.a=L.substring(N)}m(m){if(this.b||!m)return;let y;try{y=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(y.type==="match"){const L=n(y.data.path),N=E.URI.joinPath(this.h,L),U=this.n(y.data,N);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const L=n(y.data.path),N=E.URI.joinPath(this.h,L);this.o(y.data,N).forEach(T=>this.p(T))}}n(m,y){const L=m.line_number-1,N=n(m.lines),U=Buffer.from(N);let T=0,O=0,M=L;m.submatches.length===0&&m.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const j=(0,P.$Hb)(m.submatches.map((z,J)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const le=n(z.match),Y=U.slice(T,z.start).toString(),Q=a(Y),X=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+O,ue=a(le),ne=Q.numLines+M,$e=ue.numLines+ne,oe=ue.numLines>0?ue.lastLineLength:ue.lastLineLength+X;return T=z.end,O=oe,M=$e,new D.$vJ(ne,X,$e,oe)}));return(0,S.$_ic)(y,N,j,this.j)}o(m,y){const L=n(m.lines),N=m.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((U,T)=>({text:U,uri:y,lineNumber:N+T}))}p(m){this.emit("result",m)}}e.$hjc=r;function n(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function a(b){const m=/\n/g;let y=0,L=-1,N;for(;N=m.exec(b);)y++,L=N.index;const U=L>=0?b.length-L-1:b.length;return{numLines:y,lastLineLength:U}}function t(b,m){const y=["--hidden","--no-require-git"];y.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:N}=(0,A.$K)(m.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const T=new Set;N.forEach(O=>{T.add(O)}),y.push("-g","!*"),T.forEach(O=>{h(O).map(S.$$ic).forEach(M=>{y.push("-g",M)})})}L&&L.length&&L.forEach(T=>{y.push("-g",T)}),m.excludes.map(S.$$ic).forEach(T=>y.push("-g",`!${T}`)),m.maxFileSize&&y.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),m.followSymlinks&&y.push("--follow"),m.encoding&&m.encoding!=="utf8"&&y.push("--encoding",m.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,$.$Pe)(b.pattern),b.isRegExp=!0),m.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),b.isRegExp&&(b.pattern=s(b.pattern),y.push("--engine","auto"));let U;if(b.isWordMatch){const O=(0,$.$Ye)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",O)}else if(b.isRegExp){let T=l(b.pattern);T=u(T),y.push("--regexp",T)}else U=b.pattern,y.push("--fixed-strings");return y.push("--no-config"),m.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),b.isMultiline&&y.push("--multiline"),m.beforeContext&&y.push("--before-context",m.beforeContext+""),m.afterContext&&y.push("--after-context",m.afterContext+""),y.push("--"),U&&y.push(U),y.push("."),y}e.$ijc=t;function h(b){return I(b).flatMap(y=>{const L=(0,v.$Lj)(y,"/");return L.map((N,U)=>L.slice(0,U+1).join("/"))})}function s(b){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(m);)b=b.replace(m,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(y);)b=b.replace(y,"$1\\x{$2}");return b}e.$jjc=s;const d=b=>b.type==="Assertion"&&b.kind==="lookbehind";function l(b){let m;try{m=new p.RegExpParser().parsePattern(b)}catch{return b}let y="",L=0;const N=(O,M,j)=>{y+=b.slice(L,O)+j,L=M},U=[];return new p.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const M=U[0];if(!M)N(O.start,O.end,"\\r?\\n");else if(!U.some(d))if(M.type==="CharacterClass")if(M.negate){const j=b.slice(M.start+2,O.start)+b.slice(O.end,M.end-1);M.parent?.type==="Quantifier"?N(M.start,M.end,j?`[^${j}]`:"."):N(M.start,M.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=b.slice(M.start+1,O.start)+b.slice(O.end,M.end-1);N(M.start,M.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else M.type==="Quantifier"&&N(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){U.unshift(O)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(O){U.unshift(O)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(O){U.unshift(O)},onCharacterClassLeave(){U.shift()},onAssertionEnter(O){d(O)&&U.push(O)},onAssertionLeave(O){U[0]===O&&U.shift()}}).visit(m),y+=b.slice(L),y}e.$kjc=l;function u(b){return b.replace(/\n/g,"\\r?\\n")}e.$ljc=u;function w(b){let m=!1,y=!1,L="",N="";for(let U=0;U<b.length;U++){const T=b[U];switch(T){case"\\":y?(m?N+="\\"+T:L+="\\"+T,y=!1):y=!0;break;case"{":if(y)m?N+=T:L+=T,y=!1;else{if(m)return{strInBraces:L+"{"+N+"{"+b.substring(U+1)};m=!0}break;case"}":if(y)m?N+=T:L+=T,y=!1;else{if(m)return{fixedStart:L,strInBraces:N,fixedEnd:b.substring(U+1)};L+=T}break;default:m?N+=(y?"\\":"")+T:L+=(y?"\\":"")+T,y=!1;break}}return{strInBraces:L+(m?"{"+N:"")}}function I(b){const{fixedStart:m,strInBraces:y,fixedEnd:L}=w(b);if(m===void 0||L===void 0)return[y];let N=(0,v.$Lj)(y,",");N.length||(N=[""]);const U=I(L);return N.flatMap(T=>{const O=m+T;return U.map(M=>O+M)})}e.$mjc=I}),define(Ee[377],Se([1,0,21,156,86,16]),function(ge,e,C,F,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;class A{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,R,D,p){const k=new F.$gjc(this.b);if(R.folder.scheme===P.Schemas.vscodeUserData){const S={...R,folder:R.folder.with({scheme:P.Schemas.file})},c=new f.$wv(g=>D.report({...g,uri:g.uri.with({scheme:R.folder.scheme})}));return this.c(p,g=>k.provideTextSearchResults(E,S,c,g))}else return this.c(p,S=>k.provideTextSearchResults(E,R,D,S))}async c(E,R){const D=v(E);this.a.add(D);const p=await R(D.token);return this.a.delete(D),p}d(){this.a.forEach(E=>E.cancel())}}e.$qjc=A;function v($){const E=new C.$7d;return $.onCancellationRequested(()=>E.cancel()),E}}),define(Ee[378],Se([1,0,31,156,155]),function(ge,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=void 0;class P{constructor($){this.a=$}search($,E,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(k){R({message:k})}},p=new f.$njc(this.a,new F.$gjc(D),C);return new Promise((k,S)=>p.search(c=>{E(c.map(A))},$).then(c=>k({limitHit:c.limitHit,type:"success",stats:c.stats}),S))}}e.$ojc=P;function A(v){return{path:v.resource&&v.resource.fsPath,results:v.results,numMatches:(v.results||[]).reduce(($,E)=>{if(E.ranges){const R=E;return $+(Array.isArray(R.ranges)?R.ranges.length:1)}else return $+1},0)}}}),define(Ee[379],Se([1,0,19,11,14,4,129,17,38,2,32,36,374,378]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=void 0;class S{static{this.a=512}constructor(n="searchProcess"){this.d=n,this.b=Object.create(null)}fileSearch(n){let a;const t=o(n),h=new P.$Wd({onDidAddFirstListener:()=>{a=(0,F.$Ug)(s=>this.doFileSearchWithEngine(p.$fjc,t,d=>h.fire(d),s)),a.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return h.event}textSearch(n){let a;const t=o(n),h=new P.$Wd({onDidAddFirstListener:()=>{a=(0,F.$Ug)(s=>this.f(t,d=>h.fire(d),s)),a.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return h.event}f(n,a,t){return n.maxFileSize=this.g().maxFileSize,new k.$ojc(n).search(t,a,a)}g(){return{maxFileSize:16*R.$Zk.GB}}doFileSearch(n,a,t){return this.doFileSearchWithEngine(p.$fjc,n,a,t)}doFileSearchWithEngine(n,a,t,h,s=S.a){let d=0;const l=w=>{Array.isArray(w)?(d+=w.length,t(w.map(I=>this.h(I)))):w.relativePath?(d++,t(this.h(w))):t(w)};if(a.sortByScore){let w=this.l(a,l,h);if(!w){const I=a.maxResults?Object.assign({},a,{maxResults:null}):a,b=new n(I);w=this.j(b,a,t,l,h)}return new Promise((I,b)=>{w.then(([m,y])=>{const L=y.map(N=>this.h(N));this.o(L,t,s),I(m)},b)})}const u=new n(a);return this.r(u,l,s,h).then(w=>({limitHit:w.limitHit,type:"success",stats:{detailStats:w.stats,type:this.d,fromCache:!1,resultCount:d,sortingTime:void 0}}))}h(n){return{path:n.base?(0,v.$jc)(n.base,n.relativePath):n.relativePath}}j(n,a,t,h,s){const d=new P.$Wd;let l=(0,F.$Ug)(w=>{let I=[];const b=m=>{Array.isArray(m)?I=m:(h(m),d.fire(m))};return this.r(n,b,-1,w).then(m=>[m,I])}),u;if(a.cacheKey){u=this.k(a.cacheKey);const w={promise:l,event:d.event,resolved:!1};u.resultsToSearchCache[a.filePattern||""]=w,l.then(()=>{w.resolved=!0},I=>{delete u.resultsToSearchCache[a.filePattern||""]}),l=this.s(l)}return l.then(([w,I])=>{const b=u?u.scorerCache:Object.create(null),m=(typeof a.maxResults!="number"||a.maxResults>0)&&$.$Sd.create(!1);return this.n(a,I,b,s).then(y=>{const L=m?m.elapsed():-1;return[{type:"success",stats:{detailStats:w.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:y.length},messages:w.messages,limitHit:w.limitHit||typeof a.maxResults=="number"&&I.length>a.maxResults},y]})})}k(n){const a=this.b[n];return a||(this.b[n]=new c)}l(n,a,t){const h=n.cacheKey&&this.b[n.cacheKey];if(!h)return;const s=this.q(h,n.filePattern||"",a,t);if(s)return s.then(([d,l,u])=>{const w=$.$Sd.create(!1);return this.n(n,l,h.scorerCache,t).then(I=>{const b=w.elapsed(),m={fromCache:!0,detailStats:u,type:this.d,resultCount:l.length,sortingTime:b};return[{type:"success",limitHit:d.limitHit||typeof n.maxResults=="number"&&l.length>n.maxResults,stats:m},I]})})}n(n,a,t,h){const s=(0,A.$1q)(n.filePattern||""),d=(u,w)=>(0,A.$Zq)(u,w,s,!0,g,t),l=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return C.$Gb(a,d,l,1e4,h)}o(n,a,t){if(t&&t>0)for(let h=0;h<n.length;h+=t)a(n.slice(h,h+t));else a(n)}q(n,a,t,h){const s=$.$Sd.create(!1),d=a.indexOf(v.sep)>=0;let l;for(const b in n.resultsToSearchCache)if(a.startsWith(b)){if(d&&b.indexOf(v.sep)<0&&b!=="")continue;const m=n.resultsToSearchCache[b];l={promise:this.s(m.promise),event:m.event,resolved:m.resolved};break}if(!l)return null;const u=s.elapsed(),w=$.$Sd.create(!1),I=l.event(t);return h&&h.onCancellationRequested(()=>{I.dispose()}),l.promise.then(([b,m])=>{if(h&&h.isCancellationRequested)throw(0,f.$6)();const y=[],L=(0,A.$1q)(a).normalizedLowercase;for(const N of m)(0,D.$RJ)(N,L)&&y.push(N);return[b,y,{cacheWasResolved:l.resolved,cacheLookupTime:u,cacheFilterTime:w.elapsed(),cacheEntryCount:m.length}]})}r(n,a,t,h){return new Promise((s,d)=>{let l=[];h?.onCancellationRequested(()=>n.cancel()),n.search(u=>{u&&(t?(l.push(u),t>0&&l.length>=t&&(a(l),l=[])):a(u))},u=>{a(u)},(u,w)=>{l.length&&a(l),u?(a({message:"Search finished. Error: "+u.message}),d(u)):(a({message:"Search finished. Stats: "+JSON.stringify(w.stats)}),s(w))})})}clearCache(n){return delete this.b[n],Promise.resolve(void 0)}s(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return n.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return n.finally(a)}}}}e.$pjc=S;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(r){return(0,v.$nc)(r.relativePath)}getItemDescription(r){return(0,v.$mc)(r.relativePath)}getItemPath(r){return r.relativePath}};function o(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(i),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>E.URI.revive(n))}}function i(r){return{...r,folder:E.URI.revive(r.folder)}}}),define(Ee[380],Se([1,0,3,16,2,31,13,27,20,98,66,36,379,377,119,155]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0;let g=class extends E.$dic{constructor(i,r,n,a){super(i,n,a),this.s=P,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Sc;const t=new S.$ajc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new k.$qjc(t))),r.remote.isRemote&&r.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$ajc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new k.$qjc(i))),this.x.add(this.z(F.Schemas.file,new p.$pjc("fileSearchProvider")))}z(i,r){const n=this.d++;return this.v=r,this.t=n,this.c.$registerFileSearchProvider(n,this.o(i)),(0,C.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(n)})}$provideFileSearchResults(i,r,n,a){const t=(0,E.$eic)(n);if(i===this.t){const h=Date.now();return this.A(i,r,t,a).then(s=>{const d=Date.now()-h;return this.n.debug(`Ext host file search time: ${d}ms`),s})}return super.$provideFileSearchResults(i,r,n,a)}doInternalFileSearchWithCustomCallback(i,r,n){const a=t=>{if((0,D.$QJ)(t)&&(t=[t]),Array.isArray(t)){n(t.map(h=>f.URI.file(h.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,r)}async A(i,r,n,a){return this.doInternalFileSearchWithCustomCallback(n,a,t=>{this.c.$handleFileMatch(i,r,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,r){return new c.$njc(i,r,void 0,"textSearchProvider")}};e.$rjc=g,e.$rjc=g=Ge([qe(0,$.$kN),qe(1,v.$AN),qe(2,R.$9gc),qe(3,A.$oj)],g)}),define(Ee[120],Se([1,0,394,62,63,395,22,14,4,3,17,10,30,81,82]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0;class c{traceSocketEvent(m,y){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,m,y)}constructor(m,y=""){this.f=!0,this.debugLabel=y,this.socket=m,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,v.$1)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(m){const y=L=>{this.traceSocketEvent("read",L),m(A.$ke.wrap(L))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(m){const y=L=>{m({type:0,hadError:L,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(m){const y=()=>{m()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(m){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",m),this.socket.write(m.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((m,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),m();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),m()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Vh=c;var g;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var o;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(o||(o={}));class i extends E.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(m,y){this.socket.traceSocketEvent(m,y)}constructor(m,y,L,N){super(),this.f=this.B(new $.$Wd),this.g=this.B(new $.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=m,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:L?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new r(this,y,L,N,this.f,(U,T)=>this.m(U,T))),this.B(this.a.onError(U=>{console.error(U),(0,v.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new S.$Qh,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this.f.event(m)}onClose(m){return this.g.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){let y=0;for(;y<m.byteLength;)this.a.writeMessage(m.slice(y,Math.min(y+262144,m.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(m,{compressed:y,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",m);let N=2;m.byteLength<126?N+=0:m.byteLength<2**16?N+=2:N+=8;const U=A.$ke.alloc(N),T=y?64:0,O=L&15;if(U.writeUInt8(128|T|O,0),m.byteLength<126)U.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){U.writeUInt8(126,1);let M=1;U.writeUInt8(m.byteLength>>>8&255,++M),U.writeUInt8(m.byteLength>>>0&255,++M)}else{U.writeUInt8(127,1);let M=1;U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(m.byteLength>>>24&255,++M),U.writeUInt8(m.byteLength>>>16&255,++M),U.writeUInt8(m.byteLength>>>8&255,++M),U.writeUInt8(m.byteLength>>>0&255,++M)}this.socket.write(A.$ke.concat([U,m]))}end(){this.h=!0,this.socket.end()}n(m){if(m.byteLength!==0){for(this.b.acceptChunk(m);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),L=y.readUInt8(0),N=(L&128)>>>7,U=(L&64)>>>6,T=L&15,O=y.readUInt8(1),M=(O&128)>>>7,j=O&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),L=y.readUInt8(1),N=(L&128)>>>7;let U=L&127,T=1;U===126?U=y.readUInt8(++T)*2**8+y.readUInt8(++T):U===127&&(U=y.readUInt8(++T)*0+y.readUInt8(++T)*0+y.readUInt8(++T)*0+y.readUInt8(++T)*0+y.readUInt8(++T)*2**24+y.readUInt8(++T)*2**16+y.readUInt8(++T)*2**8+y.readUInt8(++T));let O=0;N&&(O=y.readUInt8(++T)*2**24+y.readUInt8(++T)*2**16+y.readUInt8(++T)*2**8+y.readUInt8(++T)),this.j.state=3,this.j.readLen=U,this.j.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Wh=i;class r extends E.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ke.alloc(0)}constructor(m,y,L,N,U,T){super(),this.n=m,this.r=U,this.s=T,this.a=this.B(new $.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new n(this.n,N,L,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(O=>this.a.fire(O))),this.B(this.f.onError(O=>this.a.fire(O)))):(this.b=null,this.f=null)}writeMessage(m,y){this.g.push({data:m,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:m,options:y}=this.g.shift();if(this.f&&y.compressed){const L=await this.w(this.f,m);this.s(L,y)}else this.s(m,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(m,y){return new Promise((L,N)=>{m.write(y),m.flush(U=>L(U))})}acceptFrame(m,y,L){this.h.push({data:m,isCompressed:y,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const m=this.h.shift();if(this.b&&m.isCompressed){const y=await this.C(this.b,m.data,m.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(m.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(m,y,L){return new Promise((N,U)=>{m.write(y),L&&m.write(A.$ke.fromByteArray([0,0,255,255])),m.flush(T=>N(T))})}}class n extends E.$Tc{get recordedInflateBytes(){return this.j?A.$ke.concat(this.f):A.$ke.alloc(0)}constructor(m,y,L,N){super(),this.h=m,this.j=y,this.a=this.B(new $.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(N),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(A.$ke.wrap(U))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(m){this.j&&this.f.push(m.clone()),this.h.traceSocketEvent("zlibInflateWrite",m),this.b.write(m.buffer)}flush(m){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=A.$ke.concat(this.g);this.g.length=0,m(y)})}}class a extends E.$Tc{constructor(m,y){super(),this.g=m,this.a=this.B(new $.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(A.$ke.wrap(L))})}write(m){this.g.traceSocketEvent("zlibDeflateWrite",m.buffer),this.b.write(m.buffer)}flush(m){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=A.$ke.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),m(y)})}}function t(b,m){if(m===0)return;const y=b.byteLength>>>2;for(let M=0;M<y;M++){const j=b.readUInt32BE(M*4);b.writeUInt32BE(j^m,M*4)}const L=y*4,N=b.byteLength-L,U=m>>>24&255,T=m>>>16&255,O=m>>>8&255;N>=1&&b.writeUInt8(b.readUInt8(L)^U,L),N>=2&&b.writeUInt8(b.readUInt8(L+1)^T,L+1),N>=3&&b.writeUInt8(b.readUInt8(L+2)^O,L+2)}e.$Xh=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function s(){const b=(0,p.$rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const m=process.platform!=="darwin"&&e.$Xh?e.$Xh:(0,f.tmpdir)(),y=(0,R.$jc)(m,`vscode-ipc-${b}.sock`);return l(y),y}e.$Yh=s;function d(b,m,y){const N=(0,C.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${y}-${m}-sock`;const U=y.substr(0,4),T=m.substr(0,6);let O;return process.platform!=="darwin"&&e.$Xh&&!process.env.VSCODE_PORTABLE?O=(0,R.$jc)(e.$Xh,`vscode-${N}-${U}-${T}.sock`):O=(0,R.$jc)(b,`${U}-${T}.sock`),l(O),O}e.$Zh=d;function l(b){const m=h[D.$u];typeof m=="number"&&b.length>=m&&console.warn(`WARNING: IPC handle "${b}" is longer than ${m} chars, try a shorter --user-data-dir`)}class u extends k.$Kh{static b(m){const y=$.Event.fromNodeEventEmitter(m,"connection");return $.Event.map(y,L=>({protocol:new S.$Rh(new c(L,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(L,"close"))}))}constructor(m){super(u.b(m)),this.d=m}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$1h=u;function w(b){return new Promise((m,y)=>{const L=(0,F.createServer)();L.on("error",y),L.listen(b,()=>{L.removeListener("error",y),m(new u(L))})})}e.$2h=w;function I(b,m){return new Promise((y,L)=>{const N=(0,F.createConnection)(b,()=>{N.removeListener("error",L),y(S.$Sh.fromSocket(new c(N,`ipc-client${m}`),m))});N.once("error",L)})}e.$3h=I}),define(Ee[381],Se([1,0,62,63,166,120,11,3,10,51,13,136,256,257,109,89,22]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=e.$N_b=e.$M_b=e.$L_b=void 0;async function o(t,h,s,d,l){let u;for(let w=3;w&&(u?.dispose(),u=await new i(t,h,s,d,l).waitForReady(),!(l&&f.$ug[l]||!f.$ug[u.tunnelLocalPort]));w--);return u}class i extends v.$Tc{constructor(h,s,d,l,u){super(),this.m=s,this.n=u,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=h,this.b=C.createServer(),this.c=new A.$6g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=w=>this.r(w),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=d}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const h=this.n??this.tunnelRemotePort,s=(0,c.$Iv)(this.m)?"0.0.0.0":"127.0.0.1";let d=await(0,f.$vg)(h,2,1e3,s),l=null;return this.b.listen(d,this.m),await this.c.wait(),l=this.b.address(),l||(d=0,this.b.listen(d,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(h){h.pause();const s=(0,c.$Gv)(this.tunnelRemoteHost)||(0,c.$Iv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,d=await(0,p.$ml)(this.a,s,this.tunnelRemotePort),l=d.getSocket(),u=d.readEntireBuffer();d.dispose(),u.byteLength>0&&h.write(u.buffer),h.on("end",()=>{h.localAddress&&this.j.delete(h.localAddress),l.end()}),h.on("close",()=>l.end()),h.on("error",()=>{h.localAddress&&this.j.delete(h.localAddress),l instanceof P.$Vh?l.socket.destroy():l.end()}),l instanceof P.$Vh?this.t(h,l):this.s(h,l),h.localAddress&&this.j.set(h.localAddress,()=>{h.end(),l.end()})}s(h,s){s.onClose(()=>h.destroy()),s.onEnd(()=>h.end()),s.onData(d=>h.write(d.buffer)),h.on("data",d=>s.write(g.$ke.wrap(d))),h.resume()}t(h,s){const d=s.socket;d.on("end",()=>h.end()),d.on("close",()=>h.end()),d.on("error",()=>{h.destroy()}),d.pipe(h),h.pipe(d)}}e.$L_b=i;let r=class extends c.$Lv{constructor(h,s,d,l,u){super(s,u),this.v=h,this.w=d,this.y=l}isPortPrivileged(h){return(0,c.$Jv)(h,this.m,$.OS,F.release())}t(h,s,d,l,u,w,I,b){const m=this.s(s,d);if(m)return++m.refcount,m.value;if((0,c.$Dv)(h))return this.u(h,s,d,u,w,I,b);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${d} on local port ${u}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:h,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},L=o(y,l,s,d,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,d,L),L}}};e.$M_b=r,e.$M_b=r=Ge([qe(0,k.$gl),qe(1,R.$oj),qe(2,S.$jl),qe(3,D.$Gj),qe(4,E.$Ai)],r);let n=class extends r{constructor(h,s,d,l,u){super(h,s,d,l,u)}};e.$N_b=n,e.$N_b=n=Ge([qe(0,k.$gl),qe(1,R.$oj),qe(2,S.$jl),qe(3,D.$Gj),qe(4,E.$Ai)],n);let a=class extends v.$Tc{constructor(h,s,d,l,u){super(),this.b=h,this.c=s,this.f=d,this.g=l,this.h=u,this.a=new Map}async openTunnel(h,s,d,l,u,w,I,b,m){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${d}:${l} on local port ${w}.`),!this.a.has(h)){const y=new n(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(h,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(h))})}return this.a.get(h).openTunnel(s,d,l,u,w,I,b,m)}};e.$O_b=a,e.$O_b=a=Ge([qe(0,k.$gl),qe(1,R.$oj),qe(2,D.$Gj),qe(3,S.$jl),qe(4,E.$Ai)],a)}),define(Ee[382],Se([1,0,120,276,57,33,2,13,40]),function(ge,e,C,F,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=e.$LN=void 0;class E{constructor(p,k,S){this.b=p,this.c=k,this.f=S,this.a=F.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(k.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,k){const S=(g,o)=>{k.writeHead(g,{"content-type":"application/json"}),k.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},c=[];p.setEncoding("utf8"),p.on("data",g=>c.push(g)),p.on("end",async()=>{try{const g=JSON.parse(c.join(""));let o;switch(g.type){case"open":o=await this.i(g);break;case"openExternal":o=await this.j(g);break;case"status":o=await this.l(g);break;case"extensionManagement":o=await this.k(g);break;default:S(404,`Unknown message type: ${g.type}`);break}S(200,o)}catch(g){const o=g instanceof Error?g.message:JSON.stringify(g);S(500,o),this.c.error("Error while processing pipe request",g)}})}async i(p){const{fileURIs:k,folderURIs:S,forceNewWindow:c,diffMode:g,mergeMode:o,addMode:i,forceReuseWindow:r,gotoLineMode:n,waitMarkerFilePath:a,remoteAuthority:t}=p,h=[];if(Array.isArray(S))for(const u of S)try{h.push({folderUri:A.URI.parse(u)})}catch{}if(Array.isArray(k))for(const u of k)try{(0,$.$zi)(u)?h.push({workspaceUri:A.URI.parse(u)}):h.push({fileUri:A.URI.parse(u)})}catch{}const s=a?A.URI.file(a):void 0,l={forceNewWindow:c,diffMode:g,mergeMode:o,addMode:i,gotoLineMode:n,forceReuseWindow:r,preferNewWindow:!r&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",h,l)}async j(p){for(const k of p.uris){const S=A.URI.parse(k),c=S.scheme==="file"?S:k;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(p){const k=c=>c?.map(g=>/\.vsix$/i.test(g)?A.URI.parse(g):g),S={list:p.list,install:k(p.install),uninstall:k(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$LN=E;let R=class extends E{constructor(p,k){super(p,k,(0,C.$Yh)())}};e.$MN=R,e.$MN=R=Ge([qe(0,P.$GN),qe(1,v.$oj)],R)}),define(Ee[383],Se([1,0,58,370,365,275,47,352,2,16,7,382,104,307,351]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class c extends f.$Xic{j(){const i=this,r=globalThis._VSCODE_NODE_MODULES.module,n=r._load;r._load=function(s,d,l){return s=t(s),i.a.has(s)?i.a.get(s).load(s,$.URI.file((0,p.$xq)(d.filename)),u=>n.apply(this,[u,d,l])):n.apply(this,arguments)};const a=r._resolveLookupPaths;r._resolveLookupPaths=(h,s)=>a.call(this,t(h),s);const t=h=>{for(const s of i.b){const d=s(h);if(d){h=d;break}}return h}}}class g extends A.$Mhc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(k.$ujc);const i=this.h.invokeFunction(F.$Tic);if(this.h.createInstance(v.$tjc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(D.$MN);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$vjc),await this.h.createInstance(c,i,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const n=await this.m.getConfigProvider();await(0,P.$sjc)(this.j,n,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,r,n){if(r.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${r}', must be of file-scheme`);let a=null;n.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${r.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),a=ge.__$__nodeRequire(r.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),n.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const r in i){const n=i[r];n===null?delete process.env[r]:process.env[r]=n}}}e.$wjc=g}),define(Ee[384],Se([1,0,50,22,4,3,122,10,23,2,31,13,255,64,109,89,381,27,20,70,359]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=e.$Djc=e.$Cjc=e.$Bjc=e.$Ajc=e.$zjc=e.$yjc=e.$xjc=void 0;function a(m){const y=m.trim().split(`
`),L=[];return y.forEach(U=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);T&&T.length>=3&&L.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),L.reduce((U,T)=>(U[T.socket]=T,U),{})}e.$xjc=a;function t(...m){const y=[].concat(...m.map(s));return[...new Map(y.filter(L=>L.st==="0A").map(L=>{const N=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:h(N[0]),port:parseInt(N[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}e.$yjc=t;function h(m){let y="";if(m.length===8)for(let L=m.length-2;L>=0;L-=2)y+=parseInt(m.substr(L,2),16),L!==0&&(y+=".");else for(let L=0;L<m.length;L+=8){const N=m.substring(L,L+8);let U="";for(let T=8;T>=2;T-=2)U+=N.substring(T-2,T),(T===6||T===2)&&(U=parseInt(U,16).toString(16),y+=`${U}`,U="",L+T!==m.length-6&&(y+=":"))}return y}e.$zjc=h;function s(m){const y=m.trim().split(`
`),L=y.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return y.map(U=>U.trim().split(/\s+/).reduce((T,O,M)=>(T[L[M]||M]=O,T),{}))}e.$Ajc=s;function d(m){return!!m.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||m.indexOf("out/server-main.js")!==-1||m.indexOf("_productName=VSCode")!==-1}function l(m){const y=m.trim().split(`
`),L=[];return y.forEach(N=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);U&&U.length>=4&&L.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),L}e.$Bjc=l;async function u(m,y,L){const N=L.reduce((T,O)=>(T[O.pid]=O,T),{}),U=[];return m.forEach(({socket:T,ip:O,port:M})=>{const j=y[T]?y[T].pid:void 0,z=j?N[j]?.cmd:void 0;j&&z&&!d(z)&&U.push({host:O,port:M,detail:z,pid:j})}),U}e.$Cjc=u;function w(m,y,L){const N=new Map,U=l(y);for(const T of m){const O=L.get(T.port);if(O){N.set(T.port,O);continue}const M=U.find(j=>j.cmd.includes(`${T.port}`));if(M){let j=M,z;do z=U.find(J=>J.ppid===j.pid),z&&(j=z);while(z);N.set(T.port,{host:T.ip,port:T.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else N.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return N}e.$Djc=w;let I=class extends r.$$yb{constructor(y,L,N,U){super(y,L,N),this.D=L,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,v.$k&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new A.$$l;let U=0;for(;this.C;){const T=new Date().getTime(),O=(await this.I()).filter(z=>(0,c.$Gv)(z.host)||(0,c.$Iv)(z.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(z=>z.port).join(", ")}`);const M=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),U++>3&&N.update(M),(!L||JSON.stringify(L)!==JSON.stringify(O))&&(L=O,await this.a.$onFoundNewCandidates(L));const j=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(z=>setTimeout(()=>z(),j))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",L="";try{y=await R.Promises.readFile("/proc/net/tcp","utf8"),L=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(y,L),U=await new Promise(Y=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,X,ue)=>{Y(X)})}),T=a(U),O=await R.Promises.readdir("/proc"),M=[];for(const Y of O)try{const Q=Number(Y),X=$.$Ig(E.URI.file("/proc"),Y);if((await R.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(Q)){const ne=await R.Promises.readlink($.$Ig(X,"cwd").fsPath),$e=await R.Promises.readFile($.$Ig(X,"cmdline").fsPath,"utf8");M.push({pid:Q,cwd:ne,cmd:$e})}}catch{}const j=[],z=N.filter(Y=>{const Q=T[Y.socket];return Q||j.push(Y),Q}),J=u(z,T,M);let le;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const Y=await new Promise(Q=>{(0,C.exec)("ps -F -A -l | grep root",(X,ue,ne)=>{Q(ue)})});this.z=w(j,Y,this.z),le=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${le.map(Q=>Q.port).join(", ")}`)}return J.then(Y=>le?Y.concat(le):Y)}w(y){return async L=>{const N=new g.$L_b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,O,M,j){const z=await y.makeConnection();return b.connect(z,O,M,j)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new k.$0k(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await N.waitForReady();const U=new f.$Wd;return{localAddress:(0,n.$FK)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{N.dispose(),U.fire(),U.dispose()}}}}};e.$Ejc=I,e.$Ejc=I=Ge([qe(0,i.$kN),qe(1,o.$AN),qe(2,D.$oj),qe(3,S.$jl)],I);class b extends p.$asb{static connect(y,L,N,U){const T=new P.$Sc,O={onClose:T.add(new f.$Wd),onData:T.add(new f.$Wd),onEnd:T.add(new f.$Wd)};T.add(y.onDidReceiveMessage(j=>O.onData.fire(F.$ke.wrap(j)))),T.add(y.onDidEnd(()=>O.onEnd.fire())),T.add(y.onDidClose(j=>O.onClose.fire({type:0,error:j,hadError:!!j})));const M=new b(y,U,O);return M.B(T),(0,p.$_rb)(M,L,N,U,O)}constructor(y,L,N){super(L,N),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[385],Se([1,0,84,354,368,367,380,383,384,97,47,98,96,46,70,94,353,308,13,369,60,270,106,109,138]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o,i,r,n,a,t,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Zr)(R.$Nhc,v.$wjc,0),(0,C.$Zr)(i.$pj,o.$Gjc,1),(0,C.$Zr)(i.$oj,new t.$4h(a.$Wic,[!1],!0)),(0,C.$Zr)(h.$jl,s.$Q_b,1),(0,C.$Zr)(c.$fhc,g.$Fjc,0),(0,C.$Zr)(E.$Shc,P.$0ic,0),(0,C.$Zr)(D.$cic,A.$rjc,0),(0,C.$Zr)(p.$Fic,f.$2ic,0),(0,C.$Zr)(k.$Ahc,F.$1ic,0),(0,C.$Zr)(S.$0yb,$.$Ejc,0),(0,C.$Zr)(n.$Qhc,r.$Hjc,0)}),define(Ee[396],Se([1,0,62,397,58,14,82,120,253,113,366,22,31,104,11,132,277,291,371,385]),function(ge,e,C,F,f,P,A,v,$,E,R,D,p,k,S,c,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let w=0;w<process.execArgv.length;w++)process.execArgv[w]==="--inspect-port=0"&&(process.execArgv.splice(w,1),w--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const u=globalThis._VSCODE_NODE_MODULES.module,w=u._load;u._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return w.apply(this,arguments)}})();const r=process.exit.bind(process),n=process.on.bind(process);function a(u){process.exit=function(w){if(u)r(w);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const w=new Error("An extension called process.crash() and this was prevented.");console.warn(w.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(w,I){w==="uncaughtException"&&(I=function(){try{return I.call(void 0,arguments)}catch{}}),n(w,I)}}let t=function(u){r()};function h(){const u=(0,o.$Um)(process.env);if(u.type===3)return new Promise((w,I)=>{const b=m=>{const y=m[0],L=new A.$Th;y.on("message",N=>L.fire(D.$ke.wrap(N.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),w({onMessage:L.event,send:N=>y.postMessage(N.buffer)})};process.parentPort.on("message",m=>b(m.ports))});if(u.type===2)return new Promise((w,I)=>{let b=null;const m=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,L=3e5,N=new S.$hh(()=>t("renderer disconnected for too long (1)"),y),U=new S.$hh(()=>t("renderer disconnected for too long (2)"),L);process.on("message",(O,M)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const j=D.$ke.wrap(Buffer.from(O.initialDataChunk,"base64"));let z;if(O.skipWebSocketFrames)z=new v.$Vh(M,"extHost-socket");else{const J=D.$ke.wrap(Buffer.from(O.inflateBytes,"base64"));z=new v.$Wh(new v.$Vh(M,"extHost-socket"),O.permessageDeflate,J,!1)}b?(N.cancel(),U.cancel(),b.beginAcceptReconnection(z,j),b.endAcceptReconnection(),b.sendResume()):(clearTimeout(m),b=new A.$Uh({socket:z,initialChunk:j}),b.sendResume(),b.onDidDispose(()=>t("renderer disconnected")),w(b),b.onSocketClose(()=>{N.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;N.isScheduled()&&U.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const w=u.pipeName;return new Promise((I,b)=>{const m=C.createConnection(w,()=>{m.removeListener("error",b);const y=new A.$Uh({socket:new v.$Vh(m,"extHost-renderer")});y.sendResume(),I(y)});m.once("error",b),m.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const u=await h();return new class{constructor(){this.a=new A.$Th,this.onMessage=this.a.event,this.b=!1,u.onMessage(w=>{(0,E.$vm)(w,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(w)})}send(w){this.b||u.send(w)}async drain(){if(u.drain)return u.drain()}}}function d(u){return new Promise(w=>{const I=u.onMessage(b=>{I.dispose();const m=JSON.parse(b.toString()),y=m.commit,L=$.default.commit;if(y&&L&&y!==L&&r(55),m.parentPid){let N=0;setInterval(function(){try{process.kill(m.parentPid,0),N=0}catch(T){T&&T.code==="EPERM"?(N++,N>=3&&t(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):t(`parent process ${m.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(m.parentPid)}catch(T){(0,P.$1)(T)}}u.send((0,E.$um)(0)),w({protocol:u,initData:m})});u.send((0,E.$um)(1))})}async function l(){const u=[];process.on("unhandledRejection",(N,U)=>{u.push(U),setTimeout(()=>{const T=u.indexOf(U);T>=0&&U.catch(O=>{u.splice(T,1),(0,P.$4)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),N&&(0,P.$1)(N))})},1e3)}),process.on("rejectionHandled",N=>{const U=u.indexOf(N);U>=0&&u.splice(U,1)}),process.on("uncaughtException",function(N){(0,P.$Z)(N)||(0,P.$1)(N)}),f.mark("code/extHost/willConnectToRenderer");const w=await s();f.mark("code/extHost/didConnectToRenderer");const I=await d(w);f.mark("code/extHost/didWaitForInitData");const{initData:b}=I;a(!!b.environment.extensionTestsLocationURI),b.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,b.environment.skipWorkspaceStorageLock=(0,c.boolean)(i.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(U){r(U)}fsExists(U){return p.Promises.exists(U)}fsRealpath(U){return(0,k.$wq)(U)}};let y=null;b.remote.authority&&i.transformURIs&&(y=(0,g.$4r)(b.remote.authority));const L=new R.$Zic(I.protocol,b,m,y);t=N=>L.terminate(N)}l().catch(u=>console.log(u))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/31c37ee8f63491495ac49e43b8544550fbae4533/core/vs/workbench/api/node/extensionHostProcess.js.map
